# Asterix specifications

# This file is generated, DO NOT EDIT!
# For more details, see:
#     - https://github.com/zoranbosnjak/asterix-specs

from asterix.base import *

asterix_specs_ref = "git:bd9a2d1a7af0f03c4f61e2409486c4a305b80a3c"
asterix_specs_date = "2025-01-10T13:49:47+01:00"
code_generator_version = "0.5.0"

# Asterix types

class Content_0(ContentRaw):
    cv_arg: TypeAlias = int

class RuleContent_0(RuleContentContextFree):
    cv_arg: TypeAlias = Content_0.cv_arg
    cv_content: TypeAlias = Content_0

    @property
    def content(self) -> Content_0:
        return self._get_content() # type: ignore

class Variation_165(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_165.cv_arg") -> "Variation_165":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_159(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_165.cv_arg
    cv_variation: TypeAlias = Variation_165

    @classmethod
    def create(cls, arg : "RuleVariation_159.cv_arg") -> "RuleVariation_159":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_165:
        return self.arg # type: ignore

class NonSpare_1655(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SAC"
    cv_title = "System Area Code"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1655.cv_arg") -> "NonSpare_1655":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_856(Item):
    cv_arg: TypeAlias = NonSpare_1655.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1655

    @classmethod
    def create(cls, arg : "Item_856.cv_arg") -> "Item_856":
        return cls._create(arg) # type: ignore

class NonSpare_1710(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SIC"
    cv_title = "System Identification Code"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1710.cv_arg") -> "NonSpare_1710":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_887(Item):
    cv_arg: TypeAlias = NonSpare_1710.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1710

    @classmethod
    def create(cls, arg : "Item_887.cv_arg") -> "Item_887":
        return cls._create(arg) # type: ignore

class Variation_1192(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SAC"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SIC"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1192.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_856, 8), (Item_887, 8)]
    cv_items_dict = {"SAC": RuleVariation_159, "SIC": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1192.cv_arg") -> 'Variation_1192':
        return cls._create(arg) # type: ignore

class RuleVariation_1140(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1192.cv_arg
    cv_variation: TypeAlias = Variation_1192

    @classmethod
    def create(cls, arg : "RuleVariation_1140.cv_arg") -> "RuleVariation_1140":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1192:
        return self.arg # type: ignore

class NonSpare_36(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_36.cv_arg") -> "NonSpare_36":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_36(UapItem):
    cv_non_spare: TypeAlias = NonSpare_36

class Content_428(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Plot", 1: "Track"}

class RuleContent_428(RuleContentContextFree):
    cv_arg: TypeAlias = Content_428.cv_arg
    cv_content: TypeAlias = Content_428

    @property
    def content(self) -> Content_428:
        return self._get_content() # type: ignore

class Variation_72(Element):
    cv_arg: TypeAlias = RuleContent_428.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_428

    @classmethod
    def create(cls, arg: "Variation_72.cv_arg") -> "Variation_72":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_428:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_428:
        return self.rule.content

class RuleVariation_72(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_72.cv_arg
    cv_variation: TypeAlias = Variation_72

    @classmethod
    def create(cls, arg : "RuleVariation_72.cv_arg") -> "RuleVariation_72":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_72:
        return self.arg # type: ignore

class Content_18(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Actual plot or track", 1: "Simulated plot or track"}

class RuleContent_18(RuleContentContextFree):
    cv_arg: TypeAlias = Content_18.cv_arg
    cv_content: TypeAlias = Content_18

    @property
    def content(self) -> Content_18:
        return self._get_content() # type: ignore

class Variation_403(Element):
    cv_arg: TypeAlias = RuleContent_18.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_18

    @classmethod
    def create(cls, arg: "Variation_403.cv_arg") -> "Variation_403":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_18:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_18:
        return self.rule.content

class RuleVariation_392(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_403.cv_arg
    cv_variation: TypeAlias = Variation_403

    @classmethod
    def create(cls, arg : "RuleVariation_392.cv_arg") -> "RuleVariation_392":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_403:
        return self.arg # type: ignore

class Content_348(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No detection", 1: "Sole primary detection", 2: "Sole secondary detection", 3: "Combined primary and secondary detection"}

class RuleContent_348(RuleContentContextFree):
    cv_arg: TypeAlias = Content_348.cv_arg
    cv_content: TypeAlias = Content_348

    @property
    def content(self) -> Content_348:
        return self._get_content() # type: ignore

class Variation_593(Element):
    cv_arg: TypeAlias = RuleContent_348.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_348

    @classmethod
    def create(cls, arg: "Variation_593.cv_arg") -> "Variation_593":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_348:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_348:
        return self.rule.content

class RuleVariation_582(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_593.cv_arg
    cv_variation: TypeAlias = Variation_593

    @classmethod
    def create(cls, arg : "RuleVariation_582.cv_arg") -> "RuleVariation_582":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_593:
        return self.arg # type: ignore

class Content_484(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Target report from antenna 1", 1: "Target report from antenna 2"}

class RuleContent_484(RuleContentContextFree):
    cv_arg: TypeAlias = Content_484.cv_arg
    cv_content: TypeAlias = Content_484

    @property
    def content(self) -> Content_484:
        return self._get_content() # type: ignore

class Variation_754(Element):
    cv_arg: TypeAlias = RuleContent_484.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_484

    @classmethod
    def create(cls, arg: "Variation_754.cv_arg") -> "Variation_754":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_484:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_484:
        return self.rule.content

class RuleVariation_743(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_754.cv_arg
    cv_variation: TypeAlias = Variation_754

    @classmethod
    def create(cls, arg : "RuleVariation_743.cv_arg") -> "RuleVariation_743":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_754:
        return self.arg # type: ignore

class Content_152(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Special Position Identification"}

class RuleContent_152(RuleContentContextFree):
    cv_arg: TypeAlias = Content_152.cv_arg
    cv_content: TypeAlias = Content_152

    @property
    def content(self) -> Content_152:
        return self._get_content() # type: ignore

class Variation_838(Element):
    cv_arg: TypeAlias = RuleContent_152.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_152

    @classmethod
    def create(cls, arg: "Variation_838.cv_arg") -> "Variation_838":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_152:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_152:
        return self.rule.content

class RuleVariation_808(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_838.cv_arg
    cv_variation: TypeAlias = Variation_838

    @classmethod
    def create(cls, arg : "RuleVariation_808.cv_arg") -> "RuleVariation_808":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_838:
        return self.arg # type: ignore

class Content_140(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Plot or track from a fixed transponder"}

class RuleContent_140(RuleContentContextFree):
    cv_arg: TypeAlias = Content_140.cv_arg
    cv_content: TypeAlias = Content_140

    @property
    def content(self) -> Content_140:
        return self._get_content() # type: ignore

class Variation_917(Element):
    cv_arg: TypeAlias = RuleContent_140.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_140

    @classmethod
    def create(cls, arg: "Variation_917.cv_arg") -> "Variation_917":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_140:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_140:
        return self.rule.content

class RuleVariation_887(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_917.cv_arg
    cv_variation: TypeAlias = Variation_917

    @classmethod
    def create(cls, arg : "RuleVariation_887.cv_arg") -> "RuleVariation_887":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_917:
        return self.arg # type: ignore

class Content_156(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Test target indicator"}

class RuleContent_156(RuleContentContextFree):
    cv_arg: TypeAlias = Content_156.cv_arg
    cv_content: TypeAlias = Content_156

    @property
    def content(self) -> Content_156:
        return self._get_content() # type: ignore

class Variation_36(Element):
    cv_arg: TypeAlias = RuleContent_156.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_156

    @classmethod
    def create(cls, arg: "Variation_36.cv_arg") -> "Variation_36":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_156:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_156:
        return self.rule.content

class RuleVariation_36(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_36.cv_arg
    cv_variation: TypeAlias = Variation_36

    @classmethod
    def create(cls, arg : "RuleVariation_36.cv_arg") -> "RuleVariation_36":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_36:
        return self.arg # type: ignore

class Content_159(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Unlawful interference (code 7500)", 2: "Radio-communication failure (code 7600)", 3: "Emergency (code 7700)"}

class RuleContent_159(RuleContentContextFree):
    cv_arg: TypeAlias = Content_159.cv_arg
    cv_content: TypeAlias = Content_159

    @property
    def content(self) -> Content_159:
        return self._get_content() # type: ignore

class Variation_467(Element):
    cv_arg: TypeAlias = RuleContent_159.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_159

    @classmethod
    def create(cls, arg: "Variation_467.cv_arg") -> "Variation_467":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_159:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_159:
        return self.rule.content

class RuleVariation_456(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_467.cv_arg
    cv_variation: TypeAlias = Variation_467

    @classmethod
    def create(cls, arg : "RuleVariation_456.cv_arg") -> "RuleVariation_456":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_467:
        return self.arg # type: ignore

class Content_116(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Military emergency"}

class RuleContent_116(RuleContentContextFree):
    cv_arg: TypeAlias = Content_116.cv_arg
    cv_content: TypeAlias = Content_116

    @property
    def content(self) -> Content_116:
        return self._get_content() # type: ignore

class Variation_627(Element):
    cv_arg: TypeAlias = RuleContent_116.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_116

    @classmethod
    def create(cls, arg: "Variation_627.cv_arg") -> "Variation_627":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_116:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_116:
        return self.rule.content

class RuleVariation_616(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_627.cv_arg
    cv_variation: TypeAlias = Variation_627

    @classmethod
    def create(cls, arg : "RuleVariation_616.cv_arg") -> "RuleVariation_616":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_627:
        return self.arg # type: ignore

class Content_117(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Military identification"}

class RuleContent_117(RuleContentContextFree):
    cv_arg: TypeAlias = Content_117.cv_arg
    cv_content: TypeAlias = Content_117

    @property
    def content(self) -> Content_117:
        return self._get_content() # type: ignore

class Variation_708(Element):
    cv_arg: TypeAlias = RuleContent_117.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_117

    @classmethod
    def create(cls, arg: "Variation_708.cv_arg") -> "Variation_708":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_117:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_117:
        return self.rule.content

class RuleVariation_697(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_708.cv_arg
    cv_variation: TypeAlias = Variation_708

    @classmethod
    def create(cls, arg : "RuleVariation_697.cv_arg") -> "RuleVariation_697":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_708:
        return self.arg # type: ignore

class NonSpare_1957(NonSpare):
    cv_arg: TypeAlias = RuleVariation_72.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_72

    @classmethod
    def create(cls, arg : "NonSpare_1957.cv_arg") -> "NonSpare_1957":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_72:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_72:
        return self.rule.variation

class Item_1071(Item):
    cv_arg: TypeAlias = NonSpare_1957.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1957

    @classmethod
    def create(cls, arg : "Item_1071.cv_arg") -> "Item_1071":
        return cls._create(arg) # type: ignore

class NonSpare_1725(NonSpare):
    cv_arg: TypeAlias = RuleVariation_392.cv_arg
    cv_name = "SIM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_392

    @classmethod
    def create(cls, arg : "NonSpare_1725.cv_arg") -> "NonSpare_1725":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_392:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_403:
        return self.rule.variation

class Item_900(Item):
    cv_arg: TypeAlias = NonSpare_1725.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1725

    @classmethod
    def create(cls, arg : "Item_900.cv_arg") -> "Item_900":
        return cls._create(arg) # type: ignore

class NonSpare_1767(NonSpare):
    cv_arg: TypeAlias = RuleVariation_582.cv_arg
    cv_name = "SSRPSR"
    cv_title = "Radar Detection in Last Antenna Scan"
    cv_rule: TypeAlias = RuleVariation_582

    @classmethod
    def create(cls, arg : "NonSpare_1767.cv_arg") -> "NonSpare_1767":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_582:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_593:
        return self.rule.variation

class Item_932(Item):
    cv_arg: TypeAlias = NonSpare_1767.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1767

    @classmethod
    def create(cls, arg : "Item_932.cv_arg") -> "Item_932":
        return cls._create(arg) # type: ignore

class NonSpare_611(NonSpare):
    cv_arg: TypeAlias = RuleVariation_743.cv_arg
    cv_name = "ANT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_743

    @classmethod
    def create(cls, arg : "NonSpare_611.cv_arg") -> "NonSpare_611":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_743:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_754:
        return self.rule.variation

class Item_74(Item):
    cv_arg: TypeAlias = NonSpare_611.cv_arg
    cv_non_spare: TypeAlias = NonSpare_611

    @classmethod
    def create(cls, arg : "Item_74.cv_arg") -> "Item_74":
        return cls._create(arg) # type: ignore

class NonSpare_1740(NonSpare):
    cv_arg: TypeAlias = RuleVariation_808.cv_arg
    cv_name = "SPI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_808

    @classmethod
    def create(cls, arg : "NonSpare_1740.cv_arg") -> "NonSpare_1740":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_808:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_838:
        return self.rule.variation

class Item_913(Item):
    cv_arg: TypeAlias = NonSpare_1740.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1740

    @classmethod
    def create(cls, arg : "Item_913.cv_arg") -> "Item_913":
        return cls._create(arg) # type: ignore

class NonSpare_1539(NonSpare):
    cv_arg: TypeAlias = RuleVariation_887.cv_arg
    cv_name = "RAB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_887

    @classmethod
    def create(cls, arg : "NonSpare_1539.cv_arg") -> "NonSpare_1539":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_887:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_917:
        return self.rule.variation

class Item_769(Item):
    cv_arg: TypeAlias = NonSpare_1539.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1539

    @classmethod
    def create(cls, arg : "Item_769.cv_arg") -> "Item_769":
        return cls._create(arg) # type: ignore

class NonSpare_1933(NonSpare):
    cv_arg: TypeAlias = RuleVariation_36.cv_arg
    cv_name = "TST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_36

    @classmethod
    def create(cls, arg : "NonSpare_1933.cv_arg") -> "NonSpare_1933":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_36:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_36:
        return self.rule.variation

class Item_1050(Item):
    cv_arg: TypeAlias = NonSpare_1933.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1933

    @classmethod
    def create(cls, arg : "Item_1050.cv_arg") -> "Item_1050":
        return cls._create(arg) # type: ignore

class NonSpare_902(NonSpare):
    cv_arg: TypeAlias = RuleVariation_456.cv_arg
    cv_name = "DS1DS2"
    cv_title = "Radar Detection in Last Antenna Scan"
    cv_rule: TypeAlias = RuleVariation_456

    @classmethod
    def create(cls, arg : "NonSpare_902.cv_arg") -> "NonSpare_902":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_456:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_467:
        return self.rule.variation

class Item_275(Item):
    cv_arg: TypeAlias = NonSpare_902.cv_arg
    cv_non_spare: TypeAlias = NonSpare_902

    @classmethod
    def create(cls, arg : "Item_275.cv_arg") -> "Item_275":
        return cls._create(arg) # type: ignore

class NonSpare_1265(NonSpare):
    cv_arg: TypeAlias = RuleVariation_616.cv_arg
    cv_name = "ME"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_616

    @classmethod
    def create(cls, arg : "NonSpare_1265.cv_arg") -> "NonSpare_1265":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_616:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_627:
        return self.rule.variation

class Item_543(Item):
    cv_arg: TypeAlias = NonSpare_1265.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1265

    @classmethod
    def create(cls, arg : "Item_543.cv_arg") -> "Item_543":
        return cls._create(arg) # type: ignore

class NonSpare_1283(NonSpare):
    cv_arg: TypeAlias = RuleVariation_697.cv_arg
    cv_name = "MI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_697

    @classmethod
    def create(cls, arg : "NonSpare_1283.cv_arg") -> "NonSpare_1283":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_697:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_708:
        return self.rule.variation

class Item_550(Item):
    cv_arg: TypeAlias = NonSpare_1283.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1283

    @classmethod
    def create(cls, arg : "Item_550.cv_arg") -> "Item_550":
        return cls._create(arg) # type: ignore

class Item_24(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 5
    cv_bit_size = 2

class Variation_1388(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_72.cv_arg, Tuple[Literal["TYP"], RuleVariation_72.cv_arg]], Union[RuleVariation_392.cv_arg, Tuple[Literal["SIM"], RuleVariation_392.cv_arg]], Union[RuleVariation_582.cv_arg, Tuple[Literal["SSRPSR"], RuleVariation_582.cv_arg]], Union[RuleVariation_743.cv_arg, Tuple[Literal["ANT"], RuleVariation_743.cv_arg]], Union[RuleVariation_808.cv_arg, Tuple[Literal["SPI"], RuleVariation_808.cv_arg]], Union[RuleVariation_887.cv_arg, Tuple[Literal["RAB"], RuleVariation_887.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_36.cv_arg, Tuple[Literal["TST"], RuleVariation_36.cv_arg]], Union[RuleVariation_456.cv_arg, Tuple[Literal["DS1DS2"], RuleVariation_456.cv_arg]], Union[RuleVariation_616.cv_arg, Tuple[Literal["ME"], RuleVariation_616.cv_arg]], Union[RuleVariation_697.cv_arg, Tuple[Literal["MI"], RuleVariation_697.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1388.cv_arg_group_1"],
        Tuple["Variation_1388.cv_arg_group_1", "Variation_1388.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_1071, 1), (Item_900, 1), (Item_932, 2), (Item_74, 1), (Item_913, 1), (Item_769, 1), None], [(Item_1050, 1), (Item_275, 2), (Item_543, 1), (Item_550, 1), (Item_24, 2), None]]

    @classmethod
    def create(cls, arg: "Variation_1388.cv_arg") -> 'Variation_1388':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_72:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_392:
        ...
    @overload
    def get_item(self, key : Literal["SSRPSR"]) -> RuleVariation_582:
        ...
    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_743:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_808:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_887:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_36]:
        ...
    @overload
    def get_item(self, key : Literal["DS1DS2"]) -> Optional[RuleVariation_456]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_616]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_697]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1309(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1388.cv_arg
    cv_variation: TypeAlias = Variation_1388

    @classmethod
    def create(cls, arg : "RuleVariation_1309.cv_arg") -> "RuleVariation_1309":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1388:
        return self.arg # type: ignore

class NonSpare_87(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1309.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1309

    @classmethod
    def create(cls, arg : "NonSpare_87.cv_arg") -> "NonSpare_87":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1388:
        return self.rule.variation

class UapItem_87(UapItem):
    cv_non_spare: TypeAlias = NonSpare_87

class Content_768(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_767(RuleContentContextFree):
    cv_arg: TypeAlias = Content_768.cv_arg
    cv_content: TypeAlias = Content_768

    @property
    def content(self) -> Content_768:
        return self._get_content() # type: ignore

class Variation_332(Element):
    cv_arg: TypeAlias = RuleContent_767.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_767

    @classmethod
    def create(cls, arg: "Variation_332.cv_arg") -> "Variation_332":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_767:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_768:
        return self.rule.content

class RuleVariation_325(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_332.cv_arg
    cv_variation: TypeAlias = Variation_332

    @classmethod
    def create(cls, arg : "RuleVariation_325.cv_arg") -> "RuleVariation_325":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_332:
        return self.arg # type: ignore

class NonSpare_1589(NonSpare):
    cv_arg: TypeAlias = RuleVariation_325.cv_arg
    cv_name = "RHO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_325

    @classmethod
    def create(cls, arg : "NonSpare_1589.cv_arg") -> "NonSpare_1589":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_332:
        return self.rule.variation

class Item_814(Item):
    cv_arg: TypeAlias = NonSpare_1589.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1589

    @classmethod
    def create(cls, arg : "Item_814.cv_arg") -> "Item_814":
        return cls._create(arg) # type: ignore

class Content_793(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_792(RuleContentContextFree):
    cv_arg: TypeAlias = Content_793.cv_arg
    cv_content: TypeAlias = Content_793

    @property
    def content(self) -> Content_793:
        return self._get_content() # type: ignore

class Variation_343(Element):
    cv_arg: TypeAlias = RuleContent_792.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_792

    @classmethod
    def create(cls, arg: "Variation_343.cv_arg") -> "Variation_343":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_792:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_793:
        return self.rule.content

class RuleVariation_336(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_343.cv_arg
    cv_variation: TypeAlias = Variation_343

    @classmethod
    def create(cls, arg : "RuleVariation_336.cv_arg") -> "RuleVariation_336":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_343:
        return self.arg # type: ignore

class NonSpare_1855(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "THETA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1855.cv_arg") -> "NonSpare_1855":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_993(Item):
    cv_arg: TypeAlias = NonSpare_1855.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1855

    @classmethod
    def create(cls, arg : "Item_993.cv_arg") -> "Item_993":
        return cls._create(arg) # type: ignore

class Variation_1178(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_325.cv_arg, Tuple[Literal["RHO"], RuleVariation_325.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["THETA"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1178.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_814, 16), (Item_993, 16)]
    cv_items_dict = {"RHO": RuleVariation_325, "THETA": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_325:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETA"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["THETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_325:
        ...
    @overload
    def get_item(self, key : Literal["THETA"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1178.cv_arg") -> 'Variation_1178':
        return cls._create(arg) # type: ignore

class RuleVariation_1129(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1178.cv_arg
    cv_variation: TypeAlias = Variation_1178

    @classmethod
    def create(cls, arg : "RuleVariation_1129.cv_arg") -> "RuleVariation_1129":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1178:
        return self.arg # type: ignore

class NonSpare_138(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1129.cv_arg
    cv_name = "040"
    cv_title = "Measured Position in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1129

    @classmethod
    def create(cls, arg : "NonSpare_138.cv_arg") -> "NonSpare_138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1129:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1178:
        return self.rule.variation

class UapItem_138(UapItem):
    cv_non_spare: TypeAlias = NonSpare_138

class Content_56(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Code validated", 1: "Code not validated"}

class RuleContent_56(RuleContentContextFree):
    cv_arg: TypeAlias = Content_56.cv_arg
    cv_content: TypeAlias = Content_56

    @property
    def content(self) -> Content_56:
        return self._get_content() # type: ignore

class Variation_15(Element):
    cv_arg: TypeAlias = RuleContent_56.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_56

    @classmethod
    def create(cls, arg: "Variation_15.cv_arg") -> "Variation_15":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_56:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_56:
        return self.rule.content

class RuleVariation_15(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_15.cv_arg
    cv_variation: TypeAlias = Variation_15

    @classmethod
    def create(cls, arg : "RuleVariation_15.cv_arg") -> "RuleVariation_15":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_15:
        return self.arg # type: ignore

class NonSpare_1990(NonSpare):
    cv_arg: TypeAlias = RuleVariation_15.cv_arg
    cv_name = "V"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_15

    @classmethod
    def create(cls, arg : "NonSpare_1990.cv_arg") -> "NonSpare_1990":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_15:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_15:
        return self.rule.variation

class Item_1102(Item):
    cv_arg: TypeAlias = NonSpare_1990.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1990

    @classmethod
    def create(cls, arg : "Item_1102.cv_arg") -> "Item_1102":
        return cls._create(arg) # type: ignore

class Content_97(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Garbled code"}

class RuleContent_97(RuleContentContextFree):
    cv_arg: TypeAlias = Content_97.cv_arg
    cv_content: TypeAlias = Content_97

    @property
    def content(self) -> Content_97:
        return self._get_content() # type: ignore

class Variation_407(Element):
    cv_arg: TypeAlias = RuleContent_97.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_97

    @classmethod
    def create(cls, arg: "Variation_407.cv_arg") -> "Variation_407":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_97:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_97:
        return self.rule.content

class RuleVariation_396(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_407.cv_arg
    cv_variation: TypeAlias = Variation_407

    @classmethod
    def create(cls, arg : "RuleVariation_396.cv_arg") -> "RuleVariation_396":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_407:
        return self.arg # type: ignore

class NonSpare_1009(NonSpare):
    cv_arg: TypeAlias = RuleVariation_396.cv_arg
    cv_name = "G"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_396

    @classmethod
    def create(cls, arg : "NonSpare_1009.cv_arg") -> "NonSpare_1009":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_396:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_407:
        return self.rule.variation

class Item_355(Item):
    cv_arg: TypeAlias = NonSpare_1009.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1009

    @classmethod
    def create(cls, arg : "Item_355.cv_arg") -> "Item_355":
        return cls._create(arg) # type: ignore

class Content_292(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Smoothed Mode-3/A code as provided by a local tracker"}

class RuleContent_292(RuleContentContextFree):
    cv_arg: TypeAlias = Content_292.cv_arg
    cv_content: TypeAlias = Content_292

    @property
    def content(self) -> Content_292:
        return self._get_content() # type: ignore

class Variation_555(Element):
    cv_arg: TypeAlias = RuleContent_292.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_292

    @classmethod
    def create(cls, arg: "Variation_555.cv_arg") -> "Variation_555":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_292:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_292:
        return self.rule.content

class RuleVariation_544(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_555.cv_arg
    cv_variation: TypeAlias = Variation_555

    @classmethod
    def create(cls, arg : "RuleVariation_544.cv_arg") -> "RuleVariation_544":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_555:
        return self.arg # type: ignore

class NonSpare_1143(NonSpare):
    cv_arg: TypeAlias = RuleVariation_544.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_544

    @classmethod
    def create(cls, arg : "NonSpare_1143.cv_arg") -> "NonSpare_1143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_544:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_555:
        return self.rule.variation

class Item_455(Item):
    cv_arg: TypeAlias = NonSpare_1143.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1143

    @classmethod
    def create(cls, arg : "Item_455.cv_arg") -> "Item_455":
        return cls._create(arg) # type: ignore

class Item_16(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 3
    cv_bit_size = 1

class Content_611(ContentString):
    cv_arg: TypeAlias = Union[int, str]
    cv_string_type: TypeAlias = StringOctal

class RuleContent_611(RuleContentContextFree):
    cv_arg: TypeAlias = Content_611.cv_arg
    cv_content: TypeAlias = Content_611

    @property
    def content(self) -> Content_611:
        return self._get_content() # type: ignore

class Variation_809(Element):
    cv_arg: TypeAlias = RuleContent_611.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_611

    @classmethod
    def create(cls, arg: "Variation_809.cv_arg") -> "Variation_809":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_611:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_611:
        return self.rule.content

class RuleVariation_779(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_809.cv_arg
    cv_variation: TypeAlias = Variation_809

    @classmethod
    def create(cls, arg : "RuleVariation_779.cv_arg") -> "RuleVariation_779":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_809:
        return self.arg # type: ignore

class NonSpare_1309(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE3A"
    cv_title = "Mode-3/A Reply in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1309.cv_arg") -> "NonSpare_1309":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_575(Item):
    cv_arg: TypeAlias = NonSpare_1309.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1309

    @classmethod
    def create(cls, arg : "Item_575.cv_arg") -> "Item_575":
        return cls._create(arg) # type: ignore

class Variation_1266(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_544.cv_arg, Tuple[Literal["L"], RuleVariation_544.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1266.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_455, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_544, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_544:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1266.cv_arg") -> 'Variation_1266':
        return cls._create(arg) # type: ignore

class RuleVariation_1195(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1266.cv_arg
    cv_variation: TypeAlias = Variation_1266

    @classmethod
    def create(cls, arg : "RuleVariation_1195.cv_arg") -> "RuleVariation_1195":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1266:
        return self.arg # type: ignore

class NonSpare_213(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1195.cv_arg
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1195

    @classmethod
    def create(cls, arg : "NonSpare_213.cv_arg") -> "NonSpare_213":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1266:
        return self.rule.variation

class UapItem_213(UapItem):
    cv_non_spare: TypeAlias = NonSpare_213

class Content_653(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_653(RuleContentContextFree):
    cv_arg: TypeAlias = Content_653.cv_arg
    cv_content: TypeAlias = Content_653

    @property
    def content(self) -> Content_653:
        return self._get_content() # type: ignore

class Variation_609(Element):
    cv_arg: TypeAlias = RuleContent_653.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_653

    @classmethod
    def create(cls, arg: "Variation_609.cv_arg") -> "Variation_609":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_653:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_653:
        return self.rule.content

class RuleVariation_598(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_609.cv_arg
    cv_variation: TypeAlias = Variation_609

    @classmethod
    def create(cls, arg : "RuleVariation_598.cv_arg") -> "RuleVariation_598":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_609:
        return self.arg # type: ignore

class NonSpare_1069(NonSpare):
    cv_arg: TypeAlias = RuleVariation_598.cv_arg
    cv_name = "HGT"
    cv_title = "Mode-C HEIGHT"
    cv_rule: TypeAlias = RuleVariation_598

    @classmethod
    def create(cls, arg : "NonSpare_1069.cv_arg") -> "NonSpare_1069":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_598:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_609:
        return self.rule.variation

class Item_395(Item):
    cv_arg: TypeAlias = NonSpare_1069.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1069

    @classmethod
    def create(cls, arg : "Item_395.cv_arg") -> "Item_395":
        return cls._create(arg) # type: ignore

class Variation_1258(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_598.cv_arg, Tuple[Literal["HGT"], RuleVariation_598.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1258.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_395, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "HGT": RuleVariation_598}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HGT"]) -> RuleVariation_598:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["HGT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["HGT"]) -> RuleVariation_598:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1258.cv_arg") -> 'Variation_1258':
        return cls._create(arg) # type: ignore

class RuleVariation_1187(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1258.cv_arg
    cv_variation: TypeAlias = Variation_1258

    @classmethod
    def create(cls, arg : "RuleVariation_1187.cv_arg") -> "RuleVariation_1187":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1258:
        return self.arg # type: ignore

class NonSpare_253(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1187.cv_arg
    cv_name = "090"
    cv_title = "Mode-C Code in Binary Representation"
    cv_rule: TypeAlias = RuleVariation_1187

    @classmethod
    def create(cls, arg : "NonSpare_253.cv_arg") -> "NonSpare_253":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1187:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1258:
        return self.rule.variation

class UapItem_253(UapItem):
    cv_non_spare: TypeAlias = NonSpare_253

class Variation_150(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_150.cv_arg") -> "Variation_150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class Variation_1454(Repetitive):
    cv_arg: TypeAlias = List[Variation_150.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_150

    @classmethod
    def create(cls, arg: "Variation_1454.cv_arg") -> 'Variation_1454':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_150]:
        return self._get_list() # type: ignore

class RuleVariation_1375(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1454.cv_arg
    cv_variation: TypeAlias = Variation_1454

    @classmethod
    def create(cls, arg : "RuleVariation_1375.cv_arg") -> "RuleVariation_1375":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1454:
        return self.arg # type: ignore

class NonSpare_312(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "130"
    cv_title = "Radar Plot Characteristics"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_312.cv_arg") -> "NonSpare_312":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_312(UapItem):
    cv_non_spare: TypeAlias = NonSpare_312

class Content_770(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_769(RuleContentContextFree):
    cv_arg: TypeAlias = Content_770.cv_arg
    cv_content: TypeAlias = Content_770

    @property
    def content(self) -> Content_770:
        return self._get_content() # type: ignore

class Variation_334(Element):
    cv_arg: TypeAlias = RuleContent_769.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_769

    @classmethod
    def create(cls, arg: "Variation_334.cv_arg") -> "Variation_334":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_769:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_770:
        return self.rule.content

class RuleVariation_327(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_334.cv_arg
    cv_variation: TypeAlias = Variation_334

    @classmethod
    def create(cls, arg : "RuleVariation_327.cv_arg") -> "RuleVariation_327":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_334:
        return self.arg # type: ignore

class NonSpare_337(NonSpare):
    cv_arg: TypeAlias = RuleVariation_327.cv_arg
    cv_name = "141"
    cv_title = "Truncated Time of Day"
    cv_rule: TypeAlias = RuleVariation_327

    @classmethod
    def create(cls, arg : "NonSpare_337.cv_arg") -> "NonSpare_337":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

class UapItem_337(UapItem):
    cv_non_spare: TypeAlias = NonSpare_337

class Content_286(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-2 code as derived from the reply of the transponder", 1: "Smoothed Mode-2 code as provided by a local tracker"}

class RuleContent_286(RuleContentContextFree):
    cv_arg: TypeAlias = Content_286.cv_arg
    cv_content: TypeAlias = Content_286

    @property
    def content(self) -> Content_286:
        return self._get_content() # type: ignore

class Variation_549(Element):
    cv_arg: TypeAlias = RuleContent_286.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_286

    @classmethod
    def create(cls, arg: "Variation_549.cv_arg") -> "Variation_549":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_286:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_286:
        return self.rule.content

class RuleVariation_538(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_549.cv_arg
    cv_variation: TypeAlias = Variation_549

    @classmethod
    def create(cls, arg : "RuleVariation_538.cv_arg") -> "RuleVariation_538":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_549:
        return self.arg # type: ignore

class NonSpare_1137(NonSpare):
    cv_arg: TypeAlias = RuleVariation_538.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_538

    @classmethod
    def create(cls, arg : "NonSpare_1137.cv_arg") -> "NonSpare_1137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_538:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_549:
        return self.rule.variation

class Item_449(Item):
    cv_arg: TypeAlias = NonSpare_1137.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1137

    @classmethod
    def create(cls, arg : "Item_449.cv_arg") -> "Item_449":
        return cls._create(arg) # type: ignore

class NonSpare_1303(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE2"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1303.cv_arg") -> "NonSpare_1303":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_569(Item):
    cv_arg: TypeAlias = NonSpare_1303.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1303

    @classmethod
    def create(cls, arg : "Item_569.cv_arg") -> "Item_569":
        return cls._create(arg) # type: ignore

class Variation_1261(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_538.cv_arg, Tuple[Literal["L"], RuleVariation_538.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE2"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1261.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_449, 1), (Item_16, 1), (Item_569, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_538, "MODE2": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_538:
        ...
    @overload
    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1261.cv_arg") -> 'Variation_1261':
        return cls._create(arg) # type: ignore

class RuleVariation_1190(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1261.cv_arg
    cv_variation: TypeAlias = Variation_1261

    @classmethod
    def create(cls, arg : "RuleVariation_1190.cv_arg") -> "RuleVariation_1190":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1261:
        return self.arg # type: ignore

class NonSpare_174(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1190.cv_arg
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1190

    @classmethod
    def create(cls, arg : "NonSpare_174.cv_arg") -> "NonSpare_174":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1261:
        return self.rule.variation

class UapItem_174(UapItem):
    cv_non_spare: TypeAlias = NonSpare_174

class Content_681(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 3.90625e-3
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_681(RuleContentContextFree):
    cv_arg: TypeAlias = Content_681.cv_arg
    cv_content: TypeAlias = Content_681

    @property
    def content(self) -> Content_681:
        return self._get_content() # type: ignore

class Variation_218(Element):
    cv_arg: TypeAlias = RuleContent_681.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_681

    @classmethod
    def create(cls, arg: "Variation_218.cv_arg") -> "Variation_218":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_681:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_681:
        return self.rule.content

class RuleVariation_211(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_218.cv_arg
    cv_variation: TypeAlias = Variation_218

    @classmethod
    def create(cls, arg : "RuleVariation_211.cv_arg") -> "RuleVariation_211":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_218:
        return self.arg # type: ignore

class NonSpare_300(NonSpare):
    cv_arg: TypeAlias = RuleVariation_211.cv_arg
    cv_name = "120"
    cv_title = "Measured Radial Doppler Speed"
    cv_rule: TypeAlias = RuleVariation_211

    @classmethod
    def create(cls, arg : "NonSpare_300.cv_arg") -> "NonSpare_300":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_211:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_218:
        return self.rule.variation

class UapItem_300(UapItem):
    cv_non_spare: TypeAlias = NonSpare_300

class Content_625(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["dBm"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "dBm"

    def as_quantity(self, cv_unit : Optional[Literal["dBm"]] = None) -> float:
        return self._as_quantity()

class RuleContent_625(RuleContentContextFree):
    cv_arg: TypeAlias = Content_625.cv_arg
    cv_content: TypeAlias = Content_625

    @property
    def content(self) -> Content_625:
        return self._get_content() # type: ignore

class Variation_208(Element):
    cv_arg: TypeAlias = RuleContent_625.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_625

    @classmethod
    def create(cls, arg: "Variation_208.cv_arg") -> "Variation_208":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_625:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_625:
        return self.rule.content

class RuleVariation_201(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_208.cv_arg
    cv_variation: TypeAlias = Variation_208

    @classmethod
    def create(cls, arg : "RuleVariation_201.cv_arg") -> "RuleVariation_201":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_208:
        return self.arg # type: ignore

class NonSpare_316(NonSpare):
    cv_arg: TypeAlias = RuleVariation_201.cv_arg
    cv_name = "131"
    cv_title = "Received Power"
    cv_rule: TypeAlias = RuleVariation_201

    @classmethod
    def create(cls, arg : "NonSpare_316.cv_arg") -> "NonSpare_316":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_208:
        return self.rule.variation

class UapItem_316(UapItem):
    cv_non_spare: TypeAlias = NonSpare_316

class Item_3(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 4

class Content_227(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse A4", 1: "Low quality pulse A4"}

class RuleContent_227(RuleContentContextFree):
    cv_arg: TypeAlias = Content_227.cv_arg
    cv_content: TypeAlias = Content_227

    @property
    def content(self) -> Content_227:
        return self._get_content() # type: ignore

class Variation_726(Element):
    cv_arg: TypeAlias = RuleContent_227.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_227

    @classmethod
    def create(cls, arg: "Variation_726.cv_arg") -> "Variation_726":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_227:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_227:
        return self.rule.content

class RuleVariation_715(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_726.cv_arg
    cv_variation: TypeAlias = Variation_726

    @classmethod
    def create(cls, arg : "RuleVariation_715.cv_arg") -> "RuleVariation_715":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_726:
        return self.arg # type: ignore

class NonSpare_1497(NonSpare):
    cv_arg: TypeAlias = RuleVariation_715.cv_arg
    cv_name = "QA4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_715

    @classmethod
    def create(cls, arg : "NonSpare_1497.cv_arg") -> "NonSpare_1497":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_715:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_726:
        return self.rule.variation

class Item_730(Item):
    cv_arg: TypeAlias = NonSpare_1497.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1497

    @classmethod
    def create(cls, arg : "Item_730.cv_arg") -> "Item_730":
        return cls._create(arg) # type: ignore

class Content_226(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse A2", 1: "Low quality pulse A2"}

class RuleContent_226(RuleContentContextFree):
    cv_arg: TypeAlias = Content_226.cv_arg
    cv_content: TypeAlias = Content_226

    @property
    def content(self) -> Content_226:
        return self._get_content() # type: ignore

class Variation_853(Element):
    cv_arg: TypeAlias = RuleContent_226.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_226

    @classmethod
    def create(cls, arg: "Variation_853.cv_arg") -> "Variation_853":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_226:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_226:
        return self.rule.content

class RuleVariation_823(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_853.cv_arg
    cv_variation: TypeAlias = Variation_853

    @classmethod
    def create(cls, arg : "RuleVariation_823.cv_arg") -> "RuleVariation_823":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_853:
        return self.arg # type: ignore

class NonSpare_1492(NonSpare):
    cv_arg: TypeAlias = RuleVariation_823.cv_arg
    cv_name = "QA2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_823

    @classmethod
    def create(cls, arg : "NonSpare_1492.cv_arg") -> "NonSpare_1492":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_823:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_853:
        return self.rule.variation

class Item_725(Item):
    cv_arg: TypeAlias = NonSpare_1492.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1492

    @classmethod
    def create(cls, arg : "Item_725.cv_arg") -> "Item_725":
        return cls._create(arg) # type: ignore

class Content_225(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse A1", 1: "Low quality pulse A1"}

class RuleContent_225(RuleContentContextFree):
    cv_arg: TypeAlias = Content_225.cv_arg
    cv_content: TypeAlias = Content_225

    @property
    def content(self) -> Content_225:
        return self._get_content() # type: ignore

class Variation_929(Element):
    cv_arg: TypeAlias = RuleContent_225.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_225

    @classmethod
    def create(cls, arg: "Variation_929.cv_arg") -> "Variation_929":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_225:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_225:
        return self.rule.content

class RuleVariation_899(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_929.cv_arg
    cv_variation: TypeAlias = Variation_929

    @classmethod
    def create(cls, arg : "RuleVariation_899.cv_arg") -> "RuleVariation_899":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_929:
        return self.arg # type: ignore

class NonSpare_1489(NonSpare):
    cv_arg: TypeAlias = RuleVariation_899.cv_arg
    cv_name = "QA1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_899

    @classmethod
    def create(cls, arg : "NonSpare_1489.cv_arg") -> "NonSpare_1489":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_899:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_929:
        return self.rule.variation

class Item_722(Item):
    cv_arg: TypeAlias = NonSpare_1489.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1489

    @classmethod
    def create(cls, arg : "Item_722.cv_arg") -> "Item_722":
        return cls._create(arg) # type: ignore

class Content_230(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse B4", 1: "Low quality pulse B4"}

class RuleContent_230(RuleContentContextFree):
    cv_arg: TypeAlias = Content_230.cv_arg
    cv_content: TypeAlias = Content_230

    @property
    def content(self) -> Content_230:
        return self._get_content() # type: ignore

class Variation_978(Element):
    cv_arg: TypeAlias = RuleContent_230.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_230

    @classmethod
    def create(cls, arg: "Variation_978.cv_arg") -> "Variation_978":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_230:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_230:
        return self.rule.content

class RuleVariation_948(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_978.cv_arg
    cv_variation: TypeAlias = Variation_978

    @classmethod
    def create(cls, arg : "RuleVariation_948.cv_arg") -> "RuleVariation_948":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_978:
        return self.arg # type: ignore

class NonSpare_1508(NonSpare):
    cv_arg: TypeAlias = RuleVariation_948.cv_arg
    cv_name = "QB4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_948

    @classmethod
    def create(cls, arg : "NonSpare_1508.cv_arg") -> "NonSpare_1508":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_948:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_978:
        return self.rule.variation

class Item_741(Item):
    cv_arg: TypeAlias = NonSpare_1508.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1508

    @classmethod
    def create(cls, arg : "Item_741.cv_arg") -> "Item_741":
        return cls._create(arg) # type: ignore

class Content_229(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse B2", 1: "Low quality pulse B2"}

class RuleContent_229(RuleContentContextFree):
    cv_arg: TypeAlias = Content_229.cv_arg
    cv_content: TypeAlias = Content_229

    @property
    def content(self) -> Content_229:
        return self._get_content() # type: ignore

class Variation_46(Element):
    cv_arg: TypeAlias = RuleContent_229.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_229

    @classmethod
    def create(cls, arg: "Variation_46.cv_arg") -> "Variation_46":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_229:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_229:
        return self.rule.content

class RuleVariation_46(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_46.cv_arg
    cv_variation: TypeAlias = Variation_46

    @classmethod
    def create(cls, arg : "RuleVariation_46.cv_arg") -> "RuleVariation_46":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_46:
        return self.arg # type: ignore

class NonSpare_1503(NonSpare):
    cv_arg: TypeAlias = RuleVariation_46.cv_arg
    cv_name = "QB2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_46

    @classmethod
    def create(cls, arg : "NonSpare_1503.cv_arg") -> "NonSpare_1503":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_46:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_46:
        return self.rule.variation

class Item_736(Item):
    cv_arg: TypeAlias = NonSpare_1503.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1503

    @classmethod
    def create(cls, arg : "Item_736.cv_arg") -> "Item_736":
        return cls._create(arg) # type: ignore

class Content_228(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse B1", 1: "Low quality pulse B1"}

class RuleContent_228(RuleContentContextFree):
    cv_arg: TypeAlias = Content_228.cv_arg
    cv_content: TypeAlias = Content_228

    @property
    def content(self) -> Content_228:
        return self._get_content() # type: ignore

class Variation_432(Element):
    cv_arg: TypeAlias = RuleContent_228.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg: "Variation_432.cv_arg") -> "Variation_432":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_228:
        return self.rule.content

class RuleVariation_421(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_432.cv_arg
    cv_variation: TypeAlias = Variation_432

    @classmethod
    def create(cls, arg : "RuleVariation_421.cv_arg") -> "RuleVariation_421":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_432:
        return self.arg # type: ignore

class NonSpare_1499(NonSpare):
    cv_arg: TypeAlias = RuleVariation_421.cv_arg
    cv_name = "QB1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_421

    @classmethod
    def create(cls, arg : "NonSpare_1499.cv_arg") -> "NonSpare_1499":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_421:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_432:
        return self.rule.variation

class Item_732(Item):
    cv_arg: TypeAlias = NonSpare_1499.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1499

    @classmethod
    def create(cls, arg : "Item_732.cv_arg") -> "Item_732":
        return cls._create(arg) # type: ignore

class Content_233(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse C4", 1: "Low quality pulse C4"}

class RuleContent_233(RuleContentContextFree):
    cv_arg: TypeAlias = Content_233.cv_arg
    cv_content: TypeAlias = Content_233

    @property
    def content(self) -> Content_233:
        return self._get_content() # type: ignore

class Variation_538(Element):
    cv_arg: TypeAlias = RuleContent_233.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_233

    @classmethod
    def create(cls, arg: "Variation_538.cv_arg") -> "Variation_538":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_233:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_233:
        return self.rule.content

class RuleVariation_527(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_538.cv_arg
    cv_variation: TypeAlias = Variation_538

    @classmethod
    def create(cls, arg : "RuleVariation_527.cv_arg") -> "RuleVariation_527":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_538:
        return self.arg # type: ignore

class NonSpare_1516(NonSpare):
    cv_arg: TypeAlias = RuleVariation_527.cv_arg
    cv_name = "QC4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_527

    @classmethod
    def create(cls, arg : "NonSpare_1516.cv_arg") -> "NonSpare_1516":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_527:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_538:
        return self.rule.variation

class Item_749(Item):
    cv_arg: TypeAlias = NonSpare_1516.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1516

    @classmethod
    def create(cls, arg : "Item_749.cv_arg") -> "Item_749":
        return cls._create(arg) # type: ignore

class Content_232(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse C2", 1: "Low quality pulse C2"}

class RuleContent_232(RuleContentContextFree):
    cv_arg: TypeAlias = Content_232.cv_arg
    cv_content: TypeAlias = Content_232

    @property
    def content(self) -> Content_232:
        return self._get_content() # type: ignore

class Variation_642(Element):
    cv_arg: TypeAlias = RuleContent_232.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_232

    @classmethod
    def create(cls, arg: "Variation_642.cv_arg") -> "Variation_642":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_232:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_232:
        return self.rule.content

class RuleVariation_631(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_642.cv_arg
    cv_variation: TypeAlias = Variation_642

    @classmethod
    def create(cls, arg : "RuleVariation_631.cv_arg") -> "RuleVariation_631":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_642:
        return self.arg # type: ignore

class NonSpare_1512(NonSpare):
    cv_arg: TypeAlias = RuleVariation_631.cv_arg
    cv_name = "QC2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_631

    @classmethod
    def create(cls, arg : "NonSpare_1512.cv_arg") -> "NonSpare_1512":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_631:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_642:
        return self.rule.variation

class Item_745(Item):
    cv_arg: TypeAlias = NonSpare_1512.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1512

    @classmethod
    def create(cls, arg : "Item_745.cv_arg") -> "Item_745":
        return cls._create(arg) # type: ignore

class Content_231(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse C1", 1: "Low quality pulse C1"}

class RuleContent_231(RuleContentContextFree):
    cv_arg: TypeAlias = Content_231.cv_arg
    cv_content: TypeAlias = Content_231

    @property
    def content(self) -> Content_231:
        return self._get_content() # type: ignore

class Variation_728(Element):
    cv_arg: TypeAlias = RuleContent_231.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_231

    @classmethod
    def create(cls, arg: "Variation_728.cv_arg") -> "Variation_728":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_231:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_231:
        return self.rule.content

class RuleVariation_717(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_728.cv_arg
    cv_variation: TypeAlias = Variation_728

    @classmethod
    def create(cls, arg : "RuleVariation_717.cv_arg") -> "RuleVariation_717":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_728:
        return self.arg # type: ignore

class NonSpare_1510(NonSpare):
    cv_arg: TypeAlias = RuleVariation_717.cv_arg
    cv_name = "QC1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_717

    @classmethod
    def create(cls, arg : "NonSpare_1510.cv_arg") -> "NonSpare_1510":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_717:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_728:
        return self.rule.variation

class Item_743(Item):
    cv_arg: TypeAlias = NonSpare_1510.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1510

    @classmethod
    def create(cls, arg : "Item_743.cv_arg") -> "Item_743":
        return cls._create(arg) # type: ignore

class Content_236(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse D4", 1: "Low quality pulse D4"}

class RuleContent_236(RuleContentContextFree):
    cv_arg: TypeAlias = Content_236.cv_arg
    cv_content: TypeAlias = Content_236

    @property
    def content(self) -> Content_236:
        return self._get_content() # type: ignore

class Variation_856(Element):
    cv_arg: TypeAlias = RuleContent_236.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_236

    @classmethod
    def create(cls, arg: "Variation_856.cv_arg") -> "Variation_856":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_236:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_236:
        return self.rule.content

class RuleVariation_826(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_856.cv_arg
    cv_variation: TypeAlias = Variation_856

    @classmethod
    def create(cls, arg : "RuleVariation_826.cv_arg") -> "RuleVariation_826":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_856:
        return self.arg # type: ignore

class NonSpare_1524(NonSpare):
    cv_arg: TypeAlias = RuleVariation_826.cv_arg
    cv_name = "QD4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_826

    @classmethod
    def create(cls, arg : "NonSpare_1524.cv_arg") -> "NonSpare_1524":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_826:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_856:
        return self.rule.variation

class Item_757(Item):
    cv_arg: TypeAlias = NonSpare_1524.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1524

    @classmethod
    def create(cls, arg : "Item_757.cv_arg") -> "Item_757":
        return cls._create(arg) # type: ignore

class Content_235(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse D2", 1: "Low quality pulse D2"}

class RuleContent_235(RuleContentContextFree):
    cv_arg: TypeAlias = Content_235.cv_arg
    cv_content: TypeAlias = Content_235

    @property
    def content(self) -> Content_235:
        return self._get_content() # type: ignore

class Variation_933(Element):
    cv_arg: TypeAlias = RuleContent_235.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_235

    @classmethod
    def create(cls, arg: "Variation_933.cv_arg") -> "Variation_933":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_235:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_235:
        return self.rule.content

class RuleVariation_903(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_933.cv_arg
    cv_variation: TypeAlias = Variation_933

    @classmethod
    def create(cls, arg : "RuleVariation_903.cv_arg") -> "RuleVariation_903":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_933:
        return self.arg # type: ignore

class NonSpare_1522(NonSpare):
    cv_arg: TypeAlias = RuleVariation_903.cv_arg
    cv_name = "QD2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_903

    @classmethod
    def create(cls, arg : "NonSpare_1522.cv_arg") -> "NonSpare_1522":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_903:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_933:
        return self.rule.variation

class Item_755(Item):
    cv_arg: TypeAlias = NonSpare_1522.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1522

    @classmethod
    def create(cls, arg : "Item_755.cv_arg") -> "Item_755":
        return cls._create(arg) # type: ignore

class Content_234(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "High quality pulse D1", 1: "Low quality pulse D1"}

class RuleContent_234(RuleContentContextFree):
    cv_arg: TypeAlias = Content_234.cv_arg
    cv_content: TypeAlias = Content_234

    @property
    def content(self) -> Content_234:
        return self._get_content() # type: ignore

class Variation_979(Element):
    cv_arg: TypeAlias = RuleContent_234.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_234

    @classmethod
    def create(cls, arg: "Variation_979.cv_arg") -> "Variation_979":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_234:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_234:
        return self.rule.content

class RuleVariation_949(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_979.cv_arg
    cv_variation: TypeAlias = Variation_979

    @classmethod
    def create(cls, arg : "RuleVariation_949.cv_arg") -> "RuleVariation_949":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_979:
        return self.arg # type: ignore

class NonSpare_1519(NonSpare):
    cv_arg: TypeAlias = RuleVariation_949.cv_arg
    cv_name = "QD1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_949

    @classmethod
    def create(cls, arg : "NonSpare_1519.cv_arg") -> "NonSpare_1519":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_949:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_979:
        return self.rule.variation

class Item_752(Item):
    cv_arg: TypeAlias = NonSpare_1519.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1519

    @classmethod
    def create(cls, arg : "Item_752.cv_arg") -> "Item_752":
        return cls._create(arg) # type: ignore

class Variation_1032(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_715.cv_arg, Tuple[Literal["QA4"], RuleVariation_715.cv_arg]], Union[RuleVariation_823.cv_arg, Tuple[Literal["QA2"], RuleVariation_823.cv_arg]], Union[RuleVariation_899.cv_arg, Tuple[Literal["QA1"], RuleVariation_899.cv_arg]], Union[RuleVariation_948.cv_arg, Tuple[Literal["QB4"], RuleVariation_948.cv_arg]], Union[RuleVariation_46.cv_arg, Tuple[Literal["QB2"], RuleVariation_46.cv_arg]], Union[RuleVariation_421.cv_arg, Tuple[Literal["QB1"], RuleVariation_421.cv_arg]], Union[RuleVariation_527.cv_arg, Tuple[Literal["QC4"], RuleVariation_527.cv_arg]], Union[RuleVariation_631.cv_arg, Tuple[Literal["QC2"], RuleVariation_631.cv_arg]], Union[RuleVariation_717.cv_arg, Tuple[Literal["QC1"], RuleVariation_717.cv_arg]], Union[RuleVariation_826.cv_arg, Tuple[Literal["QD4"], RuleVariation_826.cv_arg]], Union[RuleVariation_903.cv_arg, Tuple[Literal["QD2"], RuleVariation_903.cv_arg]], Union[RuleVariation_949.cv_arg, Tuple[Literal["QD1"], RuleVariation_949.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1032.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_730, 1), (Item_725, 1), (Item_722, 1), (Item_741, 1), (Item_736, 1), (Item_732, 1), (Item_749, 1), (Item_745, 1), (Item_743, 1), (Item_757, 1), (Item_755, 1), (Item_752, 1)]
    cv_items_dict = {"QA4": RuleVariation_715, "QA2": RuleVariation_823, "QA1": RuleVariation_899, "QB4": RuleVariation_948, "QB2": RuleVariation_46, "QB1": RuleVariation_421, "QC4": RuleVariation_527, "QC2": RuleVariation_631, "QC1": RuleVariation_717, "QD4": RuleVariation_826, "QD2": RuleVariation_903, "QD1": RuleVariation_949}

    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_715:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_823:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_899:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB4"]) -> RuleVariation_948:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC4"]) -> RuleVariation_527:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC2"]) -> RuleVariation_631:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC1"]) -> RuleVariation_717:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD4"]) -> RuleVariation_826:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD2"]) -> RuleVariation_903:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD1"]) -> RuleVariation_949:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QA4"], Literal["QA2"], Literal["QA1"], Literal["QB4"], Literal["QB2"], Literal["QB1"], Literal["QC4"], Literal["QC2"], Literal["QC1"], Literal["QD4"], Literal["QD2"], Literal["QD1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_715:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_823:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_899:
        ...
    @overload
    def get_item(self, key : Literal["QB4"]) -> RuleVariation_948:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_46:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_421:
        ...
    @overload
    def get_item(self, key : Literal["QC4"]) -> RuleVariation_527:
        ...
    @overload
    def get_item(self, key : Literal["QC2"]) -> RuleVariation_631:
        ...
    @overload
    def get_item(self, key : Literal["QC1"]) -> RuleVariation_717:
        ...
    @overload
    def get_item(self, key : Literal["QD4"]) -> RuleVariation_826:
        ...
    @overload
    def get_item(self, key : Literal["QD2"]) -> RuleVariation_903:
        ...
    @overload
    def get_item(self, key : Literal["QD1"]) -> RuleVariation_949:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1032.cv_arg") -> 'Variation_1032':
        return cls._create(arg) # type: ignore

class RuleVariation_1000(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1032.cv_arg
    cv_variation: TypeAlias = Variation_1032

    @classmethod
    def create(cls, arg : "RuleVariation_1000.cv_arg") -> "RuleVariation_1000":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1032:
        return self.arg # type: ignore

class NonSpare_233(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1000.cv_arg
    cv_name = "080"
    cv_title = "Mode-3/A Code Confidence Indicator"
    cv_rule: TypeAlias = RuleVariation_1000

    @classmethod
    def create(cls, arg : "NonSpare_233.cv_arg") -> "NonSpare_233":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1000:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1032:
        return self.rule.variation

class UapItem_233(UapItem):
    cv_non_spare: TypeAlias = NonSpare_233

class Item_12(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 2
    cv_bit_size = 2

class Variation_808(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_808.cv_arg") -> "Variation_808":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_778(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_808.cv_arg
    cv_variation: TypeAlias = Variation_808

    @classmethod
    def create(cls, arg : "RuleVariation_778.cv_arg") -> "RuleVariation_778":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_808:
        return self.arg # type: ignore

class NonSpare_1310(NonSpare):
    cv_arg: TypeAlias = RuleVariation_778.cv_arg
    cv_name = "MODEC"
    cv_title = "Mode-C Reply in Gray Notation"
    cv_rule: TypeAlias = RuleVariation_778

    @classmethod
    def create(cls, arg : "NonSpare_1310.cv_arg") -> "NonSpare_1310":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

class Item_576(Item):
    cv_arg: TypeAlias = NonSpare_1310.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1310

    @classmethod
    def create(cls, arg : "Item_576.cv_arg") -> "Item_576":
        return cls._create(arg) # type: ignore

class Variation_852(Element):
    cv_arg: TypeAlias = RuleContent_225.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_225

    @classmethod
    def create(cls, arg: "Variation_852.cv_arg") -> "Variation_852":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_225:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_225:
        return self.rule.content

class RuleVariation_822(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_852.cv_arg
    cv_variation: TypeAlias = Variation_852

    @classmethod
    def create(cls, arg : "RuleVariation_822.cv_arg") -> "RuleVariation_822":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_852:
        return self.arg # type: ignore

class NonSpare_1488(NonSpare):
    cv_arg: TypeAlias = RuleVariation_822.cv_arg
    cv_name = "QA1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_822

    @classmethod
    def create(cls, arg : "NonSpare_1488.cv_arg") -> "NonSpare_1488":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_822:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_852:
        return self.rule.variation

class Item_721(Item):
    cv_arg: TypeAlias = NonSpare_1488.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1488

    @classmethod
    def create(cls, arg : "Item_721.cv_arg") -> "Item_721":
        return cls._create(arg) # type: ignore

class Variation_932(Element):
    cv_arg: TypeAlias = RuleContent_232.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_232

    @classmethod
    def create(cls, arg: "Variation_932.cv_arg") -> "Variation_932":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_232:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_232:
        return self.rule.content

class RuleVariation_902(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_932.cv_arg
    cv_variation: TypeAlias = Variation_932

    @classmethod
    def create(cls, arg : "RuleVariation_902.cv_arg") -> "RuleVariation_902":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_932:
        return self.arg # type: ignore

class NonSpare_1513(NonSpare):
    cv_arg: TypeAlias = RuleVariation_902.cv_arg
    cv_name = "QC2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_902

    @classmethod
    def create(cls, arg : "NonSpare_1513.cv_arg") -> "NonSpare_1513":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_902:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_932:
        return self.rule.variation

class Item_746(Item):
    cv_arg: TypeAlias = NonSpare_1513.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1513

    @classmethod
    def create(cls, arg : "Item_746.cv_arg") -> "Item_746":
        return cls._create(arg) # type: ignore

class Variation_976(Element):
    cv_arg: TypeAlias = RuleContent_226.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_226

    @classmethod
    def create(cls, arg: "Variation_976.cv_arg") -> "Variation_976":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_226:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_226:
        return self.rule.content

class RuleVariation_946(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_976.cv_arg
    cv_variation: TypeAlias = Variation_976

    @classmethod
    def create(cls, arg : "RuleVariation_946.cv_arg") -> "RuleVariation_946":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_976:
        return self.arg # type: ignore

class NonSpare_1493(NonSpare):
    cv_arg: TypeAlias = RuleVariation_946.cv_arg
    cv_name = "QA2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_946

    @classmethod
    def create(cls, arg : "NonSpare_1493.cv_arg") -> "NonSpare_1493":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_946:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_976:
        return self.rule.variation

class Item_726(Item):
    cv_arg: TypeAlias = NonSpare_1493.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1493

    @classmethod
    def create(cls, arg : "Item_726.cv_arg") -> "Item_726":
        return cls._create(arg) # type: ignore

class Variation_47(Element):
    cv_arg: TypeAlias = RuleContent_233.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_233

    @classmethod
    def create(cls, arg: "Variation_47.cv_arg") -> "Variation_47":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_233:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_233:
        return self.rule.content

class RuleVariation_47(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_47.cv_arg
    cv_variation: TypeAlias = Variation_47

    @classmethod
    def create(cls, arg : "RuleVariation_47.cv_arg") -> "RuleVariation_47":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_47:
        return self.arg # type: ignore

class NonSpare_1515(NonSpare):
    cv_arg: TypeAlias = RuleVariation_47.cv_arg
    cv_name = "QC4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_47

    @classmethod
    def create(cls, arg : "NonSpare_1515.cv_arg") -> "NonSpare_1515":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_47:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_47:
        return self.rule.variation

class Item_748(Item):
    cv_arg: TypeAlias = NonSpare_1515.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1515

    @classmethod
    def create(cls, arg : "Item_748.cv_arg") -> "Item_748":
        return cls._create(arg) # type: ignore

class Variation_431(Element):
    cv_arg: TypeAlias = RuleContent_227.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_227

    @classmethod
    def create(cls, arg: "Variation_431.cv_arg") -> "Variation_431":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_227:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_227:
        return self.rule.content

class RuleVariation_420(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_431.cv_arg
    cv_variation: TypeAlias = Variation_431

    @classmethod
    def create(cls, arg : "RuleVariation_420.cv_arg") -> "RuleVariation_420":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_431:
        return self.arg # type: ignore

class NonSpare_1495(NonSpare):
    cv_arg: TypeAlias = RuleVariation_420.cv_arg
    cv_name = "QA4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_420

    @classmethod
    def create(cls, arg : "NonSpare_1495.cv_arg") -> "NonSpare_1495":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_420:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_431:
        return self.rule.variation

class Item_728(Item):
    cv_arg: TypeAlias = NonSpare_1495.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1495

    @classmethod
    def create(cls, arg : "Item_728.cv_arg") -> "Item_728":
        return cls._create(arg) # type: ignore

class Variation_537(Element):
    cv_arg: TypeAlias = RuleContent_228.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg: "Variation_537.cv_arg") -> "Variation_537":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_228:
        return self.rule.content

class RuleVariation_526(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_537.cv_arg
    cv_variation: TypeAlias = Variation_537

    @classmethod
    def create(cls, arg : "RuleVariation_526.cv_arg") -> "RuleVariation_526":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_537:
        return self.arg # type: ignore

class NonSpare_1500(NonSpare):
    cv_arg: TypeAlias = RuleVariation_526.cv_arg
    cv_name = "QB1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_526

    @classmethod
    def create(cls, arg : "NonSpare_1500.cv_arg") -> "NonSpare_1500":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_526:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_537:
        return self.rule.variation

class Item_733(Item):
    cv_arg: TypeAlias = NonSpare_1500.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1500

    @classmethod
    def create(cls, arg : "Item_733.cv_arg") -> "Item_733":
        return cls._create(arg) # type: ignore

class Variation_643(Element):
    cv_arg: TypeAlias = RuleContent_234.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_234

    @classmethod
    def create(cls, arg: "Variation_643.cv_arg") -> "Variation_643":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_234:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_234:
        return self.rule.content

class RuleVariation_632(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_643.cv_arg
    cv_variation: TypeAlias = Variation_643

    @classmethod
    def create(cls, arg : "RuleVariation_632.cv_arg") -> "RuleVariation_632":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_643:
        return self.arg # type: ignore

class NonSpare_1518(NonSpare):
    cv_arg: TypeAlias = RuleVariation_632.cv_arg
    cv_name = "QD1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_632

    @classmethod
    def create(cls, arg : "NonSpare_1518.cv_arg") -> "NonSpare_1518":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_632:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_643:
        return self.rule.variation

class Item_751(Item):
    cv_arg: TypeAlias = NonSpare_1518.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1518

    @classmethod
    def create(cls, arg : "Item_751.cv_arg") -> "Item_751":
        return cls._create(arg) # type: ignore

class Variation_727(Element):
    cv_arg: TypeAlias = RuleContent_229.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_229

    @classmethod
    def create(cls, arg: "Variation_727.cv_arg") -> "Variation_727":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_229:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_229:
        return self.rule.content

class RuleVariation_716(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_727.cv_arg
    cv_variation: TypeAlias = Variation_727

    @classmethod
    def create(cls, arg : "RuleVariation_716.cv_arg") -> "RuleVariation_716":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_727:
        return self.arg # type: ignore

class NonSpare_1504(NonSpare):
    cv_arg: TypeAlias = RuleVariation_716.cv_arg
    cv_name = "QB2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_716

    @classmethod
    def create(cls, arg : "NonSpare_1504.cv_arg") -> "NonSpare_1504":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_716:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_727:
        return self.rule.variation

class Item_737(Item):
    cv_arg: TypeAlias = NonSpare_1504.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1504

    @classmethod
    def create(cls, arg : "Item_737.cv_arg") -> "Item_737":
        return cls._create(arg) # type: ignore

class Variation_855(Element):
    cv_arg: TypeAlias = RuleContent_235.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_235

    @classmethod
    def create(cls, arg: "Variation_855.cv_arg") -> "Variation_855":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_235:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_235:
        return self.rule.content

class RuleVariation_825(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_855.cv_arg
    cv_variation: TypeAlias = Variation_855

    @classmethod
    def create(cls, arg : "RuleVariation_825.cv_arg") -> "RuleVariation_825":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_855:
        return self.arg # type: ignore

class NonSpare_1521(NonSpare):
    cv_arg: TypeAlias = RuleVariation_825.cv_arg
    cv_name = "QD2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_825

    @classmethod
    def create(cls, arg : "NonSpare_1521.cv_arg") -> "NonSpare_1521":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_825:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_855:
        return self.rule.variation

class Item_754(Item):
    cv_arg: TypeAlias = NonSpare_1521.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1521

    @classmethod
    def create(cls, arg : "Item_754.cv_arg") -> "Item_754":
        return cls._create(arg) # type: ignore

class Variation_931(Element):
    cv_arg: TypeAlias = RuleContent_230.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_230

    @classmethod
    def create(cls, arg: "Variation_931.cv_arg") -> "Variation_931":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_230:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_230:
        return self.rule.content

class RuleVariation_901(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_931.cv_arg
    cv_variation: TypeAlias = Variation_931

    @classmethod
    def create(cls, arg : "RuleVariation_901.cv_arg") -> "RuleVariation_901":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_931:
        return self.arg # type: ignore

class NonSpare_1507(NonSpare):
    cv_arg: TypeAlias = RuleVariation_901.cv_arg
    cv_name = "QB4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_901

    @classmethod
    def create(cls, arg : "NonSpare_1507.cv_arg") -> "NonSpare_1507":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_901:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_931:
        return self.rule.variation

class Item_740(Item):
    cv_arg: TypeAlias = NonSpare_1507.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1507

    @classmethod
    def create(cls, arg : "Item_740.cv_arg") -> "Item_740":
        return cls._create(arg) # type: ignore

class Variation_980(Element):
    cv_arg: TypeAlias = RuleContent_236.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_236

    @classmethod
    def create(cls, arg: "Variation_980.cv_arg") -> "Variation_980":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_236:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_236:
        return self.rule.content

class RuleVariation_950(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_980.cv_arg
    cv_variation: TypeAlias = Variation_980

    @classmethod
    def create(cls, arg : "RuleVariation_950.cv_arg") -> "RuleVariation_950":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_980:
        return self.arg # type: ignore

class NonSpare_1525(NonSpare):
    cv_arg: TypeAlias = RuleVariation_950.cv_arg
    cv_name = "QD4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_950

    @classmethod
    def create(cls, arg : "NonSpare_1525.cv_arg") -> "NonSpare_1525":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_950:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_980:
        return self.rule.variation

class Item_758(Item):
    cv_arg: TypeAlias = NonSpare_1525.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1525

    @classmethod
    def create(cls, arg : "Item_758.cv_arg") -> "Item_758":
        return cls._create(arg) # type: ignore

class Variation_1253(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], int, Union[RuleVariation_778.cv_arg, Tuple[Literal["MODEC"], RuleVariation_778.cv_arg]], int, Union[RuleVariation_717.cv_arg, Tuple[Literal["QC1"], RuleVariation_717.cv_arg]], Union[RuleVariation_822.cv_arg, Tuple[Literal["QA1"], RuleVariation_822.cv_arg]], Union[RuleVariation_902.cv_arg, Tuple[Literal["QC2"], RuleVariation_902.cv_arg]], Union[RuleVariation_946.cv_arg, Tuple[Literal["QA2"], RuleVariation_946.cv_arg]], Union[RuleVariation_47.cv_arg, Tuple[Literal["QC4"], RuleVariation_47.cv_arg]], Union[RuleVariation_420.cv_arg, Tuple[Literal["QA4"], RuleVariation_420.cv_arg]], Union[RuleVariation_526.cv_arg, Tuple[Literal["QB1"], RuleVariation_526.cv_arg]], Union[RuleVariation_632.cv_arg, Tuple[Literal["QD1"], RuleVariation_632.cv_arg]], Union[RuleVariation_716.cv_arg, Tuple[Literal["QB2"], RuleVariation_716.cv_arg]], Union[RuleVariation_825.cv_arg, Tuple[Literal["QD2"], RuleVariation_825.cv_arg]], Union[RuleVariation_901.cv_arg, Tuple[Literal["QB4"], RuleVariation_901.cv_arg]], Union[RuleVariation_950.cv_arg, Tuple[Literal["QD4"], RuleVariation_950.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1253.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_12, 2), (Item_576, 12), (Item_3, 4), (Item_743, 1), (Item_721, 1), (Item_746, 1), (Item_726, 1), (Item_748, 1), (Item_728, 1), (Item_733, 1), (Item_751, 1), (Item_737, 1), (Item_754, 1), (Item_740, 1), (Item_758, 1)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "MODEC": RuleVariation_778, "QC1": RuleVariation_717, "QA1": RuleVariation_822, "QC2": RuleVariation_902, "QA2": RuleVariation_946, "QC4": RuleVariation_47, "QA4": RuleVariation_420, "QB1": RuleVariation_526, "QD1": RuleVariation_632, "QB2": RuleVariation_716, "QD2": RuleVariation_825, "QB4": RuleVariation_901, "QD4": RuleVariation_950}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODEC"]) -> RuleVariation_778:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC1"]) -> RuleVariation_717:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC2"]) -> RuleVariation_902:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_946:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC4"]) -> RuleVariation_47:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_526:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD1"]) -> RuleVariation_632:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_716:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD2"]) -> RuleVariation_825:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB4"]) -> RuleVariation_901:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD4"]) -> RuleVariation_950:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["MODEC"], Literal["QC1"], Literal["QA1"], Literal["QC2"], Literal["QA2"], Literal["QC4"], Literal["QA4"], Literal["QB1"], Literal["QD1"], Literal["QB2"], Literal["QD2"], Literal["QB4"], Literal["QD4"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["MODEC"]) -> RuleVariation_778:
        ...
    @overload
    def get_item(self, key : Literal["QC1"]) -> RuleVariation_717:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_822:
        ...
    @overload
    def get_item(self, key : Literal["QC2"]) -> RuleVariation_902:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_946:
        ...
    @overload
    def get_item(self, key : Literal["QC4"]) -> RuleVariation_47:
        ...
    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_420:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_526:
        ...
    @overload
    def get_item(self, key : Literal["QD1"]) -> RuleVariation_632:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_716:
        ...
    @overload
    def get_item(self, key : Literal["QD2"]) -> RuleVariation_825:
        ...
    @overload
    def get_item(self, key : Literal["QB4"]) -> RuleVariation_901:
        ...
    @overload
    def get_item(self, key : Literal["QD4"]) -> RuleVariation_950:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1253.cv_arg") -> 'Variation_1253':
        return cls._create(arg) # type: ignore

class RuleVariation_1182(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1253.cv_arg
    cv_variation: TypeAlias = Variation_1253

    @classmethod
    def create(cls, arg : "RuleVariation_1182.cv_arg") -> "RuleVariation_1182":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1253:
        return self.arg # type: ignore

class NonSpare_274(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1182.cv_arg
    cv_name = "100"
    cv_title = "Mode-C Code and Code Confidence Indicator"
    cv_rule: TypeAlias = RuleVariation_1182

    @classmethod
    def create(cls, arg : "NonSpare_274.cv_arg") -> "NonSpare_274":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1182:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1253:
        return self.rule.variation

class UapItem_274(UapItem):
    cv_non_spare: TypeAlias = NonSpare_274

class NonSpare_189(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1000.cv_arg
    cv_name = "060"
    cv_title = "Mode-2 Code Confidence Indicator"
    cv_rule: TypeAlias = RuleVariation_1000

    @classmethod
    def create(cls, arg : "NonSpare_189.cv_arg") -> "NonSpare_189":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1000:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1032:
        return self.rule.variation

class UapItem_189(UapItem):
    cv_non_spare: TypeAlias = NonSpare_189

class Content_377(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No warning nor error condition", 1: "Garbled reply", 2: "Reflection", 3: "Sidelobe reply", 4: "Split plot", 5: "Second time around reply", 6: "Angels", 7: "Terrestrial vehicles", 64: "Possible wrong code in Mode-3/A", 65: "Possible wrong altitude information, transmitted when the Code C credibility check fails together with the Mode-C code in binary notation", 66: "Possible phantom MSSR plot", 80: "Fixed PSR plot", 81: "Slow PSR plot", 82: "Low quality PSR plot"}

class RuleContent_377(RuleContentContextFree):
    cv_arg: TypeAlias = Content_377.cv_arg
    cv_content: TypeAlias = Content_377

    @property
    def content(self) -> Content_377:
        return self._get_content() # type: ignore

class Variation_152(Element):
    cv_arg: TypeAlias = RuleContent_377.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_377

    @classmethod
    def create(cls, arg: "Variation_152.cv_arg") -> "Variation_152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_377:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_377:
        return self.rule.content

class Variation_1455(Repetitive):
    cv_arg: TypeAlias = List[Variation_152.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_152

    @classmethod
    def create(cls, arg: "Variation_1455.cv_arg") -> 'Variation_1455':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_152]:
        return self._get_list() # type: ignore

class RuleVariation_1376(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1455.cv_arg
    cv_variation: TypeAlias = Variation_1455

    @classmethod
    def create(cls, arg : "RuleVariation_1376.cv_arg") -> "RuleVariation_1376":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1455:
        return self.arg # type: ignore

class NonSpare_117(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1376.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions"
    cv_rule: TypeAlias = RuleVariation_1376

    @classmethod
    def create(cls, arg : "NonSpare_117.cv_arg") -> "NonSpare_117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1376:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1455:
        return self.rule.variation

class UapItem_117(UapItem):
    cv_non_spare: TypeAlias = NonSpare_117

class Content_167(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "X-pulse received in Mode-3/A reply"}

class RuleContent_167(RuleContentContextFree):
    cv_arg: TypeAlias = Content_167.cv_arg
    cv_content: TypeAlias = Content_167

    @property
    def content(self) -> Content_167:
        return self._get_content() # type: ignore

class Variation_37(Element):
    cv_arg: TypeAlias = RuleContent_167.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_167

    @classmethod
    def create(cls, arg: "Variation_37.cv_arg") -> "Variation_37":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_167:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_167:
        return self.rule.content

class RuleVariation_37(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_37.cv_arg
    cv_variation: TypeAlias = Variation_37

    @classmethod
    def create(cls, arg : "RuleVariation_37.cv_arg") -> "RuleVariation_37":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_37:
        return self.arg # type: ignore

class NonSpare_2113(NonSpare):
    cv_arg: TypeAlias = RuleVariation_37.cv_arg
    cv_name = "XA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_37

    @classmethod
    def create(cls, arg : "NonSpare_2113.cv_arg") -> "NonSpare_2113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_37:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_37:
        return self.rule.variation

class Item_1214(Item):
    cv_arg: TypeAlias = NonSpare_2113.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2113

    @classmethod
    def create(cls, arg : "Item_1214.cv_arg") -> "Item_1214":
        return cls._create(arg) # type: ignore

class Item_7(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 1
    cv_bit_size = 1

class Content_168(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "X-pulse received in Mode-C reply"}

class RuleContent_168(RuleContentContextFree):
    cv_arg: TypeAlias = Content_168.cv_arg
    cv_content: TypeAlias = Content_168

    @property
    def content(self) -> Content_168:
        return self._get_content() # type: ignore

class Variation_525(Element):
    cv_arg: TypeAlias = RuleContent_168.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_168

    @classmethod
    def create(cls, arg: "Variation_525.cv_arg") -> "Variation_525":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_168:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_168:
        return self.rule.content

class RuleVariation_514(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_525.cv_arg
    cv_variation: TypeAlias = Variation_525

    @classmethod
    def create(cls, arg : "RuleVariation_514.cv_arg") -> "RuleVariation_514":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_525:
        return self.arg # type: ignore

class NonSpare_2114(NonSpare):
    cv_arg: TypeAlias = RuleVariation_514.cv_arg
    cv_name = "XC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_514

    @classmethod
    def create(cls, arg : "NonSpare_2114.cv_arg") -> "NonSpare_2114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_514:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_525:
        return self.rule.variation

class Item_1215(Item):
    cv_arg: TypeAlias = NonSpare_2114.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2114

    @classmethod
    def create(cls, arg : "Item_1215.cv_arg") -> "Item_1215":
        return cls._create(arg) # type: ignore

class Item_17(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 3
    cv_bit_size = 2

class Content_166(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "X-pulse received in Mode-2 reply"}

class RuleContent_166(RuleContentContextFree):
    cv_arg: TypeAlias = Content_166.cv_arg
    cv_content: TypeAlias = Content_166

    @property
    def content(self) -> Content_166:
        return self._get_content() # type: ignore

class Variation_842(Element):
    cv_arg: TypeAlias = RuleContent_166.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_166

    @classmethod
    def create(cls, arg: "Variation_842.cv_arg") -> "Variation_842":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_166:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_166:
        return self.rule.content

class RuleVariation_812(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_842.cv_arg
    cv_variation: TypeAlias = Variation_842

    @classmethod
    def create(cls, arg : "RuleVariation_812.cv_arg") -> "RuleVariation_812":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_842:
        return self.arg # type: ignore

class NonSpare_2107(NonSpare):
    cv_arg: TypeAlias = RuleVariation_812.cv_arg
    cv_name = "X2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_812

    @classmethod
    def create(cls, arg : "NonSpare_2107.cv_arg") -> "NonSpare_2107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_812:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_842:
        return self.rule.variation

class Item_1208(Item):
    cv_arg: TypeAlias = NonSpare_2107.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2107

    @classmethod
    def create(cls, arg : "Item_1208.cv_arg") -> "Item_1208":
        return cls._create(arg) # type: ignore

class Item_27(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 6
    cv_bit_size = 2

class Variation_1320(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_37.cv_arg, Tuple[Literal["XA"], RuleVariation_37.cv_arg]], int, Union[RuleVariation_514.cv_arg, Tuple[Literal["XC"], RuleVariation_514.cv_arg]], int, Union[RuleVariation_812.cv_arg, Tuple[Literal["X2"], RuleVariation_812.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1320.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1214, 1), (Item_7, 1), (Item_1215, 1), (Item_17, 2), (Item_1208, 1), (Item_27, 2)]
    cv_items_dict = {"XA": RuleVariation_37, "XC": RuleVariation_514, "X2": RuleVariation_812}

    @overload
    @classmethod
    def spec(cls, key : Literal["XA"]) -> RuleVariation_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_514:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_812:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["XA"], Literal["XC"], Literal["X2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["XA"]) -> RuleVariation_37:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_514:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_812:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1320.cv_arg") -> 'Variation_1320':
        return cls._create(arg) # type: ignore

class RuleVariation_1244(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1320.cv_arg
    cv_variation: TypeAlias = Variation_1320

    @classmethod
    def create(cls, arg : "RuleVariation_1244.cv_arg") -> "RuleVariation_1244":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1320:
        return self.arg # type: ignore

class NonSpare_346(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1244.cv_arg
    cv_name = "150"
    cv_title = "Presence of X-Pulse"
    cv_rule: TypeAlias = RuleVariation_1244

    @classmethod
    def create(cls, arg : "NonSpare_346.cv_arg") -> "NonSpare_346":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1320:
        return self.rule.variation

class UapItem_346(UapItem):
    cv_non_spare: TypeAlias = NonSpare_346

class UapItem_549(UapItemSpare):
    pass

class Variation_1464(Explicit):
    cv_arg: TypeAlias = bytes
    cv_explicit_type: TypeAlias = SpecialPurpose

    @classmethod
    def create(cls, arg: "Variation_1464.cv_arg") -> 'Variation_1464':
        return cls._create(arg) # type: ignore

class RuleVariation_1385(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1464.cv_arg
    cv_variation: TypeAlias = Variation_1464

    @classmethod
    def create(cls, arg : "RuleVariation_1385.cv_arg") -> "RuleVariation_1385":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1464:
        return self.arg # type: ignore

class NonSpare_1732(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1385.cv_arg
    cv_name = "SP"
    cv_title = "Special Purpose Field"
    cv_rule: TypeAlias = RuleVariation_1385

    @classmethod
    def create(cls, arg : "NonSpare_1732.cv_arg") -> "NonSpare_1732":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1464:
        return self.rule.variation

class UapItem_548(UapItem):
    cv_non_spare: TypeAlias = NonSpare_1732

class UapItem_550(UapItemRFS):
    pass

class Record_18(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_36.cv_arg,
        "020": NonSpare_87.cv_arg,
        "040": NonSpare_138.cv_arg,
        "070": NonSpare_213.cv_arg,
        "090": NonSpare_253.cv_arg,
        "130": NonSpare_312.cv_arg,
        "141": NonSpare_337.cv_arg,
        "050": NonSpare_174.cv_arg,
        "120": NonSpare_300.cv_arg,
        "131": NonSpare_316.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_274.cv_arg,
        "060": NonSpare_189.cv_arg,
        "030": NonSpare_117.cv_arg,
        "150": NonSpare_346.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_36.cv_arg],
        Tuple[Literal["020"], NonSpare_87.cv_arg],
        Tuple[Literal["040"], NonSpare_138.cv_arg],
        Tuple[Literal["070"], NonSpare_213.cv_arg],
        Tuple[Literal["090"], NonSpare_253.cv_arg],
        Tuple[Literal["130"], NonSpare_312.cv_arg],
        Tuple[Literal["141"], NonSpare_337.cv_arg],
        Tuple[Literal["050"], NonSpare_174.cv_arg],
        Tuple[Literal["120"], NonSpare_300.cv_arg],
        Tuple[Literal["131"], NonSpare_316.cv_arg],
        Tuple[Literal["080"], NonSpare_233.cv_arg],
        Tuple[Literal["100"], NonSpare_274.cv_arg],
        Tuple[Literal["060"], NonSpare_189.cv_arg],
        Tuple[Literal["030"], NonSpare_117.cv_arg],
        Tuple[Literal["150"], NonSpare_346.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
    ]
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_36, UapItem_87, UapItem_138, UapItem_213, UapItem_253, UapItem_312, UapItem_337, UapItem_174, UapItem_300, UapItem_316, UapItem_233, UapItem_274, UapItem_189, UapItem_117, UapItem_346, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_548, UapItem_550]
    cv_items_dict = {"010": NonSpare_36, "020": NonSpare_87, "040": NonSpare_138, "070": NonSpare_213, "090": NonSpare_253, "130": NonSpare_312, "141": NonSpare_337, "050": NonSpare_174, "120": NonSpare_300, "131": NonSpare_316, "080": NonSpare_233, "100": NonSpare_274, "060": NonSpare_189, "030": NonSpare_117, "150": NonSpare_346, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_312:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_174:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_189:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["141"], Literal["050"], Literal["120"], Literal["131"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["150"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_138]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_253]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_312]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_174]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_316]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_274]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_189]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_117]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_346]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_138.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_253.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_312.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_337.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_174.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_316.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_274.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_189.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_117.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_346.cv_arg) -> 'Record_18':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_18':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_18':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_18':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_36]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_87]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_138]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_213]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_253]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_312]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_337]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_174]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_300]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_316]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_233]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_274]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_189]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_117]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_346]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_18.cv_arg", rfs : Optional[List["Record_18.cv_union"]] = None) -> 'Record_18':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_18", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Variation_253(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_253.cv_arg") -> "Variation_253":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_246(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_253.cv_arg
    cv_variation: TypeAlias = Variation_253

    @classmethod
    def create(cls, arg : "RuleVariation_246.cv_arg") -> "RuleVariation_246":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_253:
        return self.arg # type: ignore

class NonSpare_366(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "161"
    cv_title = "Track Plot Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_366.cv_arg") -> "NonSpare_366":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_366(UapItem):
    cv_non_spare: TypeAlias = NonSpare_366

class Content_674(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.5625e-2
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_674(RuleContentContextFree):
    cv_arg: TypeAlias = Content_674.cv_arg
    cv_content: TypeAlias = Content_674

    @property
    def content(self) -> Content_674:
        return self._get_content() # type: ignore

class Variation_284(Element):
    cv_arg: TypeAlias = RuleContent_674.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_674

    @classmethod
    def create(cls, arg: "Variation_284.cv_arg") -> "Variation_284":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_674:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_674:
        return self.rule.content

class RuleVariation_277(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_284.cv_arg
    cv_variation: TypeAlias = Variation_284

    @classmethod
    def create(cls, arg : "RuleVariation_277.cv_arg") -> "RuleVariation_277":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_284:
        return self.arg # type: ignore

class NonSpare_2099(NonSpare):
    cv_arg: TypeAlias = RuleVariation_277.cv_arg
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule: TypeAlias = RuleVariation_277

    @classmethod
    def create(cls, arg : "NonSpare_2099.cv_arg") -> "NonSpare_2099":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_284:
        return self.rule.variation

class Item_1200(Item):
    cv_arg: TypeAlias = NonSpare_2099.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2099

    @classmethod
    def create(cls, arg : "Item_1200.cv_arg") -> "Item_1200":
        return cls._create(arg) # type: ignore

class NonSpare_2153(NonSpare):
    cv_arg: TypeAlias = RuleVariation_277.cv_arg
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule: TypeAlias = RuleVariation_277

    @classmethod
    def create(cls, arg : "NonSpare_2153.cv_arg") -> "NonSpare_2153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_284:
        return self.rule.variation

class Item_1251(Item):
    cv_arg: TypeAlias = NonSpare_2153.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2153

    @classmethod
    def create(cls, arg : "Item_1251.cv_arg") -> "Item_1251":
        return cls._create(arg) # type: ignore

class Variation_1313(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_277.cv_arg, Tuple[Literal["X"], RuleVariation_277.cv_arg]], Union[RuleVariation_277.cv_arg, Tuple[Literal["Y"], RuleVariation_277.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1313.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1200, 16), (Item_1251, 16)]
    cv_items_dict = {"X": RuleVariation_277, "Y": RuleVariation_277}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_277:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_277:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_277:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_277:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1313.cv_arg") -> 'Variation_1313':
        return cls._create(arg) # type: ignore

class RuleVariation_1240(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1313.cv_arg
    cv_variation: TypeAlias = Variation_1313

    @classmethod
    def create(cls, arg : "RuleVariation_1240.cv_arg") -> "RuleVariation_1240":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1313:
        return self.arg # type: ignore

class NonSpare_159(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1240.cv_arg
    cv_name = "042"
    cv_title = "Calculated Position in Cartesian Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1240

    @classmethod
    def create(cls, arg : "NonSpare_159.cv_arg") -> "NonSpare_159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1240:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1313:
        return self.rule.variation

class UapItem_159(UapItem):
    cv_non_spare: TypeAlias = NonSpare_159

class Content_778(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_777(RuleContentContextFree):
    cv_arg: TypeAlias = Content_778.cv_arg
    cv_content: TypeAlias = Content_778

    @property
    def content(self) -> Content_778:
        return self._get_content() # type: ignore

class Variation_338(Element):
    cv_arg: TypeAlias = RuleContent_777.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_777

    @classmethod
    def create(cls, arg: "Variation_338.cv_arg") -> "Variation_338":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_777:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_778:
        return self.rule.content

class RuleVariation_331(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_338.cv_arg
    cv_variation: TypeAlias = Variation_338

    @classmethod
    def create(cls, arg : "RuleVariation_331.cv_arg") -> "RuleVariation_331":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_338:
        return self.arg # type: ignore

class NonSpare_1041(NonSpare):
    cv_arg: TypeAlias = RuleVariation_331.cv_arg
    cv_name = "GSP"
    cv_title = "Calculated Groundspeed"
    cv_rule: TypeAlias = RuleVariation_331

    @classmethod
    def create(cls, arg : "NonSpare_1041.cv_arg") -> "NonSpare_1041":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

class Item_375(Item):
    cv_arg: TypeAlias = NonSpare_1041.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1041

    @classmethod
    def create(cls, arg : "Item_375.cv_arg") -> "Item_375":
        return cls._create(arg) # type: ignore

class NonSpare_1061(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "HDG"
    cv_title = "Calculated Heading"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1061.cv_arg") -> "NonSpare_1061":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_389(Item):
    cv_arg: TypeAlias = NonSpare_1061.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1061

    @classmethod
    def create(cls, arg : "Item_389.cv_arg") -> "Item_389":
        return cls._create(arg) # type: ignore

class Variation_1114(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_331.cv_arg, Tuple[Literal["GSP"], RuleVariation_331.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["HDG"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1114.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_375, 16), (Item_389, 16)]
    cv_items_dict = {"GSP": RuleVariation_331, "HDG": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["GSP"]) -> RuleVariation_331:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HDG"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GSP"], Literal["HDG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GSP"]) -> RuleVariation_331:
        ...
    @overload
    def get_item(self, key : Literal["HDG"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1114.cv_arg") -> 'Variation_1114':
        return cls._create(arg) # type: ignore

class RuleVariation_1072(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1114.cv_arg
    cv_variation: TypeAlias = Variation_1114

    @classmethod
    def create(cls, arg : "RuleVariation_1072.cv_arg") -> "RuleVariation_1072":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1114:
        return self.arg # type: ignore

class NonSpare_389(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1072.cv_arg
    cv_name = "200"
    cv_title = "Calculated Track Velocity in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1072

    @classmethod
    def create(cls, arg : "NonSpare_389.cv_arg") -> "NonSpare_389":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1072:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1114:
        return self.rule.variation

class UapItem_389(UapItem):
    cv_non_spare: TypeAlias = NonSpare_389

class Content_61(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Confirmed Track", 1: "Track in initialisation phase"}

class RuleContent_61(RuleContentContextFree):
    cv_arg: TypeAlias = Content_61.cv_arg
    cv_content: TypeAlias = Content_61

    @property
    def content(self) -> Content_61:
        return self._get_content() # type: ignore

class Variation_17(Element):
    cv_arg: TypeAlias = RuleContent_61.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_61

    @classmethod
    def create(cls, arg: "Variation_17.cv_arg") -> "Variation_17":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_61:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_61:
        return self.rule.content

class RuleVariation_17(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_17.cv_arg
    cv_variation: TypeAlias = Variation_17

    @classmethod
    def create(cls, arg : "RuleVariation_17.cv_arg") -> "RuleVariation_17":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_17:
        return self.arg # type: ignore

class Content_431(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Primary track", 1: "SSR/Combined track"}

class RuleContent_431(RuleContentContextFree):
    cv_arg: TypeAlias = Content_431.cv_arg
    cv_content: TypeAlias = Content_431

    @property
    def content(self) -> Content_431:
        return self._get_content() # type: ignore

class Variation_449(Element):
    cv_arg: TypeAlias = RuleContent_431.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_431

    @classmethod
    def create(cls, arg: "Variation_449.cv_arg") -> "Variation_449":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_431:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_431:
        return self.rule.content

class RuleVariation_438(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_449.cv_arg
    cv_variation: TypeAlias = Variation_449

    @classmethod
    def create(cls, arg : "RuleVariation_438.cv_arg") -> "RuleVariation_438":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_449:
        return self.arg # type: ignore

class Content_84(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Aircraft manoeuvring"}

class RuleContent_84(RuleContentContextFree):
    cv_arg: TypeAlias = Content_84.cv_arg
    cv_content: TypeAlias = Content_84

    @property
    def content(self) -> Content_84:
        return self._get_content() # type: ignore

class Variation_515(Element):
    cv_arg: TypeAlias = RuleContent_84.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_84

    @classmethod
    def create(cls, arg: "Variation_515.cv_arg") -> "Variation_515":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_84:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_84:
        return self.rule.content

class RuleVariation_504(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_515.cv_arg
    cv_variation: TypeAlias = Variation_515

    @classmethod
    def create(cls, arg : "RuleVariation_504.cv_arg") -> "RuleVariation_504":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_515:
        return self.arg # type: ignore

class Content_94(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Doubtful plot to track association"}

class RuleContent_94(RuleContentContextFree):
    cv_arg: TypeAlias = Content_94.cv_arg
    cv_content: TypeAlias = Content_94

    @property
    def content(self) -> Content_94:
        return self._get_content() # type: ignore

class Variation_621(Element):
    cv_arg: TypeAlias = RuleContent_94.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_94

    @classmethod
    def create(cls, arg: "Variation_621.cv_arg") -> "Variation_621":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_94:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_94:
        return self.rule.content

class RuleVariation_610(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_621.cv_arg
    cv_variation: TypeAlias = Variation_621

    @classmethod
    def create(cls, arg : "RuleVariation_610.cv_arg") -> "RuleVariation_610":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_621:
        return self.arg # type: ignore

class Content_433(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "RDP Chain 1", 1: "RDP Chain 2"}

class RuleContent_433(RuleContentContextFree):
    cv_arg: TypeAlias = Content_433.cv_arg
    cv_content: TypeAlias = Content_433

    @property
    def content(self) -> Content_433:
        return self._get_content() # type: ignore

class Variation_746(Element):
    cv_arg: TypeAlias = RuleContent_433.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_433

    @classmethod
    def create(cls, arg: "Variation_746.cv_arg") -> "Variation_746":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_433:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_433:
        return self.rule.content

class RuleVariation_735(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_746.cv_arg
    cv_variation: TypeAlias = Variation_746

    @classmethod
    def create(cls, arg : "RuleVariation_735.cv_arg") -> "RuleVariation_735":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_746:
        return self.arg # type: ignore

class Content_99(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Ghost track"}

class RuleContent_99(RuleContentContextFree):
    cv_arg: TypeAlias = Content_99.cv_arg
    cv_content: TypeAlias = Content_99

    @property
    def content(self) -> Content_99:
        return self._get_content() # type: ignore

class Variation_912(Element):
    cv_arg: TypeAlias = RuleContent_99.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_99

    @classmethod
    def create(cls, arg: "Variation_912.cv_arg") -> "Variation_912":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_99:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_99:
        return self.rule.content

class RuleVariation_882(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_912.cv_arg
    cv_variation: TypeAlias = Variation_912

    @classmethod
    def create(cls, arg : "RuleVariation_882.cv_arg") -> "RuleVariation_882":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_912:
        return self.arg # type: ignore

class Content_112(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Last report for a track"}

class RuleContent_112(RuleContentContextFree):
    cv_arg: TypeAlias = Content_112.cv_arg
    cv_content: TypeAlias = Content_112

    @property
    def content(self) -> Content_112:
        return self._get_content() # type: ignore

class Variation_31(Element):
    cv_arg: TypeAlias = RuleContent_112.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_112

    @classmethod
    def create(cls, arg: "Variation_31.cv_arg") -> "Variation_31":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_112:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_112:
        return self.rule.content

class RuleVariation_31(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_31.cv_arg
    cv_variation: TypeAlias = Variation_31

    @classmethod
    def create(cls, arg : "RuleVariation_31.cv_arg") -> "RuleVariation_31":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_31:
        return self.arg # type: ignore

class NonSpare_791(NonSpare):
    cv_arg: TypeAlias = RuleVariation_17.cv_arg
    cv_name = "CON"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_17

    @classmethod
    def create(cls, arg : "NonSpare_791.cv_arg") -> "NonSpare_791":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_17:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_17:
        return self.rule.variation

class Item_190(Item):
    cv_arg: TypeAlias = NonSpare_791.cv_arg
    cv_non_spare: TypeAlias = NonSpare_791

    @classmethod
    def create(cls, arg : "Item_190.cv_arg") -> "Item_190":
        return cls._create(arg) # type: ignore

class NonSpare_1544(NonSpare):
    cv_arg: TypeAlias = RuleVariation_438.cv_arg
    cv_name = "RAD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_438

    @classmethod
    def create(cls, arg : "NonSpare_1544.cv_arg") -> "NonSpare_1544":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_438:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_449:
        return self.rule.variation

class Item_774(Item):
    cv_arg: TypeAlias = NonSpare_1544.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1544

    @classmethod
    def create(cls, arg : "Item_774.cv_arg") -> "Item_774":
        return cls._create(arg) # type: ignore

class NonSpare_1229(NonSpare):
    cv_arg: TypeAlias = RuleVariation_504.cv_arg
    cv_name = "MAN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_504

    @classmethod
    def create(cls, arg : "NonSpare_1229.cv_arg") -> "NonSpare_1229":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_504:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_515:
        return self.rule.variation

class Item_528(Item):
    cv_arg: TypeAlias = NonSpare_1229.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1229

    @classmethod
    def create(cls, arg : "Item_528.cv_arg") -> "Item_528":
        return cls._create(arg) # type: ignore

class NonSpare_894(NonSpare):
    cv_arg: TypeAlias = RuleVariation_610.cv_arg
    cv_name = "DOU"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_610

    @classmethod
    def create(cls, arg : "NonSpare_894.cv_arg") -> "NonSpare_894":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_610:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_621:
        return self.rule.variation

class Item_269(Item):
    cv_arg: TypeAlias = NonSpare_894.cv_arg
    cv_non_spare: TypeAlias = NonSpare_894

    @classmethod
    def create(cls, arg : "Item_269.cv_arg") -> "Item_269":
        return cls._create(arg) # type: ignore

class NonSpare_1560(NonSpare):
    cv_arg: TypeAlias = RuleVariation_735.cv_arg
    cv_name = "RDPC"
    cv_title = "Radar Data Processing Chain"
    cv_rule: TypeAlias = RuleVariation_735

    @classmethod
    def create(cls, arg : "NonSpare_1560.cv_arg") -> "NonSpare_1560":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_735:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_746:
        return self.rule.variation

class Item_788(Item):
    cv_arg: TypeAlias = NonSpare_1560.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1560

    @classmethod
    def create(cls, arg : "Item_788.cv_arg") -> "Item_788":
        return cls._create(arg) # type: ignore

class Item_23(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 5
    cv_bit_size = 1

class NonSpare_1036(NonSpare):
    cv_arg: TypeAlias = RuleVariation_882.cv_arg
    cv_name = "GHO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_882

    @classmethod
    def create(cls, arg : "NonSpare_1036.cv_arg") -> "NonSpare_1036":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_882:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_912:
        return self.rule.variation

class Item_371(Item):
    cv_arg: TypeAlias = NonSpare_1036.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1036

    @classmethod
    def create(cls, arg : "Item_371.cv_arg") -> "Item_371":
        return cls._create(arg) # type: ignore

class NonSpare_1914(NonSpare):
    cv_arg: TypeAlias = RuleVariation_31.cv_arg
    cv_name = "TRE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_31

    @classmethod
    def create(cls, arg : "NonSpare_1914.cv_arg") -> "NonSpare_1914":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_31:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_31:
        return self.rule.variation

class Item_1035(Item):
    cv_arg: TypeAlias = NonSpare_1914.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1914

    @classmethod
    def create(cls, arg : "Item_1035.cv_arg") -> "Item_1035":
        return cls._create(arg) # type: ignore

class Item_9(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 1
    cv_bit_size = 6

class Variation_1355(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_17.cv_arg, Tuple[Literal["CON"], RuleVariation_17.cv_arg]], Union[RuleVariation_438.cv_arg, Tuple[Literal["RAD"], RuleVariation_438.cv_arg]], Union[RuleVariation_504.cv_arg, Tuple[Literal["MAN"], RuleVariation_504.cv_arg]], Union[RuleVariation_610.cv_arg, Tuple[Literal["DOU"], RuleVariation_610.cv_arg]], Union[RuleVariation_735.cv_arg, Tuple[Literal["RDPC"], RuleVariation_735.cv_arg]], int, Union[RuleVariation_882.cv_arg, Tuple[Literal["GHO"], RuleVariation_882.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_31.cv_arg, Tuple[Literal["TRE"], RuleVariation_31.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1355.cv_arg_group_1"],
        Tuple["Variation_1355.cv_arg_group_1", "Variation_1355.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_190, 1), (Item_774, 1), (Item_528, 1), (Item_269, 1), (Item_788, 1), (Item_23, 1), (Item_371, 1), None], [(Item_1035, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1355.cv_arg") -> 'Variation_1355':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CON"]) -> RuleVariation_17:
        ...
    @overload
    def get_item(self, key : Literal["RAD"]) -> RuleVariation_438:
        ...
    @overload
    def get_item(self, key : Literal["MAN"]) -> RuleVariation_504:
        ...
    @overload
    def get_item(self, key : Literal["DOU"]) -> RuleVariation_610:
        ...
    @overload
    def get_item(self, key : Literal["RDPC"]) -> RuleVariation_735:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> RuleVariation_882:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> Optional[RuleVariation_31]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1276(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1355.cv_arg
    cv_variation: TypeAlias = Variation_1355

    @classmethod
    def create(cls, arg : "RuleVariation_1276.cv_arg") -> "RuleVariation_1276":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1355:
        return self.arg # type: ignore

class NonSpare_378(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1276.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1276

    @classmethod
    def create(cls, arg : "NonSpare_378.cv_arg") -> "NonSpare_378":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1276:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1355:
        return self.rule.variation

class UapItem_378(UapItem):
    cv_non_spare: TypeAlias = NonSpare_378

class NonSpare_417(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "210"
    cv_title = "Track Quality"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_417.cv_arg") -> "NonSpare_417":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_417(UapItem):
    cv_non_spare: TypeAlias = NonSpare_417

class Record_19(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_36.cv_arg,
        "020": NonSpare_87.cv_arg,
        "161": NonSpare_366.cv_arg,
        "040": NonSpare_138.cv_arg,
        "042": NonSpare_159.cv_arg,
        "200": NonSpare_389.cv_arg,
        "070": NonSpare_213.cv_arg,
        "090": NonSpare_253.cv_arg,
        "141": NonSpare_337.cv_arg,
        "130": NonSpare_312.cv_arg,
        "131": NonSpare_316.cv_arg,
        "120": NonSpare_300.cv_arg,
        "170": NonSpare_378.cv_arg,
        "210": NonSpare_417.cv_arg,
        "050": NonSpare_174.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_274.cv_arg,
        "060": NonSpare_189.cv_arg,
        "030": NonSpare_117.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "150": NonSpare_346.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_36.cv_arg],
        Tuple[Literal["020"], NonSpare_87.cv_arg],
        Tuple[Literal["161"], NonSpare_366.cv_arg],
        Tuple[Literal["040"], NonSpare_138.cv_arg],
        Tuple[Literal["042"], NonSpare_159.cv_arg],
        Tuple[Literal["200"], NonSpare_389.cv_arg],
        Tuple[Literal["070"], NonSpare_213.cv_arg],
        Tuple[Literal["090"], NonSpare_253.cv_arg],
        Tuple[Literal["141"], NonSpare_337.cv_arg],
        Tuple[Literal["130"], NonSpare_312.cv_arg],
        Tuple[Literal["131"], NonSpare_316.cv_arg],
        Tuple[Literal["120"], NonSpare_300.cv_arg],
        Tuple[Literal["170"], NonSpare_378.cv_arg],
        Tuple[Literal["210"], NonSpare_417.cv_arg],
        Tuple[Literal["050"], NonSpare_174.cv_arg],
        Tuple[Literal["080"], NonSpare_233.cv_arg],
        Tuple[Literal["100"], NonSpare_274.cv_arg],
        Tuple[Literal["060"], NonSpare_189.cv_arg],
        Tuple[Literal["030"], NonSpare_117.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
        Tuple[Literal["150"], NonSpare_346.cv_arg],
    ]
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_36, UapItem_87, UapItem_366, UapItem_138, UapItem_159, UapItem_389, UapItem_213, UapItem_253, UapItem_337, UapItem_312, UapItem_316, UapItem_300, UapItem_378, UapItem_417, UapItem_174, UapItem_233, UapItem_274, UapItem_189, UapItem_117, UapItem_548, UapItem_550, UapItem_346]
    cv_items_dict = {"010": NonSpare_36, "020": NonSpare_87, "161": NonSpare_366, "040": NonSpare_138, "042": NonSpare_159, "200": NonSpare_389, "070": NonSpare_213, "090": NonSpare_253, "141": NonSpare_337, "130": NonSpare_312, "131": NonSpare_316, "120": NonSpare_300, "170": NonSpare_378, "210": NonSpare_417, "050": NonSpare_174, "080": NonSpare_233, "100": NonSpare_274, "060": NonSpare_189, "030": NonSpare_117, "SP": NonSpare_1732, "150": NonSpare_346}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_36:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_366:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_312:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_378:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_174:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_189:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_346:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["161"], Literal["040"], Literal["042"], Literal["200"], Literal["070"], Literal["090"], Literal["141"], Literal["130"], Literal["131"], Literal["120"], Literal["170"], Literal["210"], Literal["050"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["SP"], Literal["150"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_36]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_366]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_138]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_159]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_389]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_253]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_312]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_316]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_378]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_417]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_174]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_274]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_189]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_117]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_346]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_36.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_366.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_138.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_159.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_389.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_253.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_337.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_312.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_316.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_378.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_417.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_174.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_274.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_189.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_117.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_19':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_346.cv_arg) -> 'Record_19':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_19':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_19':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_36]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_87]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["161"]) -> List[NonSpare_366]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_138]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["042"]) -> List[NonSpare_159]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["200"]) -> List[NonSpare_389]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_213]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_253]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_337]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_312]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_316]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_300]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["170"]) -> List[NonSpare_378]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["210"]) -> List[NonSpare_417]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_174]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_233]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_274]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_189]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_117]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_346]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_19.cv_arg", rfs : Optional[List["Record_19.cv_union"]] = None) -> 'Record_19':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_19", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_48(UapMultiple):
    cv_arg: TypeAlias = Union[Record_18, Record_19]
    cv_uaps = {"plot": Record_18, "track": Record_19}
    cv_selector = (["020", "TYP"], {0: "plot", 1: "track"})

    @overload
    @classmethod
    def spec(cls, key : Literal["plot"]) -> Record_18:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["track"]) -> Record_19:
        ...
    @classmethod
    def spec(cls, key : Any) -> Any:
        return cls._spec(key)

    @overload
    @classmethod
    def parse(cls, uap : Literal["plot"], bs : Bits) -> Union[ValueError, List[Record_18]]:
        ...
    @overload
    @classmethod
    def parse(cls, uap : Literal["track"], bs : Bits) -> Union[ValueError, List[Record_19]]:
        ...
    @classmethod
    def parse(cls, uap : str, bs : Bits) -> Any:
        return cls._parse(uap, bs)

    @classmethod
    def parse_any_uap(cls, bs : Bits) -> "List[List[Uap_48.cv_arg]]":
        return cls._parse_any_uap(bs)

class Asterix_0(AstCat):
    cv_category = 1
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_48

    @classmethod
    def create(cls, records : List[Uap_48.cv_arg]) -> "Asterix_0":
        return cls._create(records) # type: ignore

class NonSpare_37(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_37.cv_arg") -> "NonSpare_37":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_37(UapItem):
    cv_non_spare: TypeAlias = NonSpare_37

class Record_25(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "020": NonSpare_87.cv_arg,
        "040": NonSpare_138.cv_arg,
        "070": NonSpare_213.cv_arg,
        "090": NonSpare_253.cv_arg,
        "130": NonSpare_312.cv_arg,
        "141": NonSpare_337.cv_arg,
        "050": NonSpare_174.cv_arg,
        "120": NonSpare_300.cv_arg,
        "131": NonSpare_316.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_274.cv_arg,
        "060": NonSpare_189.cv_arg,
        "030": NonSpare_117.cv_arg,
        "150": NonSpare_346.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_37.cv_arg],
        Tuple[Literal["020"], NonSpare_87.cv_arg],
        Tuple[Literal["040"], NonSpare_138.cv_arg],
        Tuple[Literal["070"], NonSpare_213.cv_arg],
        Tuple[Literal["090"], NonSpare_253.cv_arg],
        Tuple[Literal["130"], NonSpare_312.cv_arg],
        Tuple[Literal["141"], NonSpare_337.cv_arg],
        Tuple[Literal["050"], NonSpare_174.cv_arg],
        Tuple[Literal["120"], NonSpare_300.cv_arg],
        Tuple[Literal["131"], NonSpare_316.cv_arg],
        Tuple[Literal["080"], NonSpare_233.cv_arg],
        Tuple[Literal["100"], NonSpare_274.cv_arg],
        Tuple[Literal["060"], NonSpare_189.cv_arg],
        Tuple[Literal["030"], NonSpare_117.cv_arg],
        Tuple[Literal["150"], NonSpare_346.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
    ]
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_37, UapItem_87, UapItem_138, UapItem_213, UapItem_253, UapItem_312, UapItem_337, UapItem_174, UapItem_300, UapItem_316, UapItem_233, UapItem_274, UapItem_189, UapItem_117, UapItem_346, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_548, UapItem_550]
    cv_items_dict = {"010": NonSpare_37, "020": NonSpare_87, "040": NonSpare_138, "070": NonSpare_213, "090": NonSpare_253, "130": NonSpare_312, "141": NonSpare_337, "050": NonSpare_174, "120": NonSpare_300, "131": NonSpare_316, "080": NonSpare_233, "100": NonSpare_274, "060": NonSpare_189, "030": NonSpare_117, "150": NonSpare_346, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_312:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_174:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_189:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["141"], Literal["050"], Literal["120"], Literal["131"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["150"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_138]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_253]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_312]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_174]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_316]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_274]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_189]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_117]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_346]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_138.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_253.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_312.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_337.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_174.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_316.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_274.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_189.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_117.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_346.cv_arg) -> 'Record_25':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_25':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_25':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_25':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_37]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_87]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_138]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_213]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_253]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_312]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_337]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_174]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_300]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_316]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_233]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_274]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_189]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_117]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_346]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_25.cv_arg", rfs : Optional[List["Record_25.cv_union"]] = None) -> 'Record_25':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_25", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Record_26(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "020": NonSpare_87.cv_arg,
        "161": NonSpare_366.cv_arg,
        "040": NonSpare_138.cv_arg,
        "042": NonSpare_159.cv_arg,
        "200": NonSpare_389.cv_arg,
        "070": NonSpare_213.cv_arg,
        "090": NonSpare_253.cv_arg,
        "141": NonSpare_337.cv_arg,
        "130": NonSpare_312.cv_arg,
        "131": NonSpare_316.cv_arg,
        "120": NonSpare_300.cv_arg,
        "170": NonSpare_378.cv_arg,
        "210": NonSpare_417.cv_arg,
        "050": NonSpare_174.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_274.cv_arg,
        "060": NonSpare_189.cv_arg,
        "030": NonSpare_117.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "150": NonSpare_346.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_37.cv_arg],
        Tuple[Literal["020"], NonSpare_87.cv_arg],
        Tuple[Literal["161"], NonSpare_366.cv_arg],
        Tuple[Literal["040"], NonSpare_138.cv_arg],
        Tuple[Literal["042"], NonSpare_159.cv_arg],
        Tuple[Literal["200"], NonSpare_389.cv_arg],
        Tuple[Literal["070"], NonSpare_213.cv_arg],
        Tuple[Literal["090"], NonSpare_253.cv_arg],
        Tuple[Literal["141"], NonSpare_337.cv_arg],
        Tuple[Literal["130"], NonSpare_312.cv_arg],
        Tuple[Literal["131"], NonSpare_316.cv_arg],
        Tuple[Literal["120"], NonSpare_300.cv_arg],
        Tuple[Literal["170"], NonSpare_378.cv_arg],
        Tuple[Literal["210"], NonSpare_417.cv_arg],
        Tuple[Literal["050"], NonSpare_174.cv_arg],
        Tuple[Literal["080"], NonSpare_233.cv_arg],
        Tuple[Literal["100"], NonSpare_274.cv_arg],
        Tuple[Literal["060"], NonSpare_189.cv_arg],
        Tuple[Literal["030"], NonSpare_117.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
        Tuple[Literal["150"], NonSpare_346.cv_arg],
    ]
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_37, UapItem_87, UapItem_366, UapItem_138, UapItem_159, UapItem_389, UapItem_213, UapItem_253, UapItem_337, UapItem_312, UapItem_316, UapItem_300, UapItem_378, UapItem_417, UapItem_174, UapItem_233, UapItem_274, UapItem_189, UapItem_117, UapItem_548, UapItem_550, UapItem_346]
    cv_items_dict = {"010": NonSpare_37, "020": NonSpare_87, "161": NonSpare_366, "040": NonSpare_138, "042": NonSpare_159, "200": NonSpare_389, "070": NonSpare_213, "090": NonSpare_253, "141": NonSpare_337, "130": NonSpare_312, "131": NonSpare_316, "120": NonSpare_300, "170": NonSpare_378, "210": NonSpare_417, "050": NonSpare_174, "080": NonSpare_233, "100": NonSpare_274, "060": NonSpare_189, "030": NonSpare_117, "SP": NonSpare_1732, "150": NonSpare_346}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_87:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_366:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_213:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["141"]) -> NonSpare_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_312:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_316:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_300:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_378:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_174:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_189:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_346:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["161"], Literal["040"], Literal["042"], Literal["200"], Literal["070"], Literal["090"], Literal["141"], Literal["130"], Literal["131"], Literal["120"], Literal["170"], Literal["210"], Literal["050"], Literal["080"], Literal["100"], Literal["060"], Literal["030"], Literal["SP"], Literal["150"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_87]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_366]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_138]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_159]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_389]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_213]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_253]:
        ...
    @overload
    def get_item(self, key : Literal["141"]) -> Optional[NonSpare_337]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_312]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_316]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_300]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_378]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_417]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_174]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_274]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_189]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_117]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_346]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_87.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_366.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_138.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_159.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_389.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_213.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_253.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["141"], val : NonSpare_337.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_312.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_316.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_300.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_378.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_417.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_174.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_274.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_189.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_117.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_26':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_346.cv_arg) -> 'Record_26':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["141"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_26':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_26':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_37]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_87]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["161"]) -> List[NonSpare_366]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_138]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["042"]) -> List[NonSpare_159]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["200"]) -> List[NonSpare_389]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_213]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_253]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["141"]) -> List[NonSpare_337]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["130"]) -> List[NonSpare_312]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["131"]) -> List[NonSpare_316]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_300]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["170"]) -> List[NonSpare_378]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["210"]) -> List[NonSpare_417]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_174]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_233]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_274]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_189]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_117]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["150"]) -> List[NonSpare_346]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_26.cv_arg", rfs : Optional[List["Record_26.cv_union"]] = None) -> 'Record_26':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_26", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_49(UapMultiple):
    cv_arg: TypeAlias = Union[Record_25, Record_26]
    cv_uaps = {"plot": Record_25, "track": Record_26}
    cv_selector = (["020", "TYP"], {0: "plot", 1: "track"})

    @overload
    @classmethod
    def spec(cls, key : Literal["plot"]) -> Record_25:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["track"]) -> Record_26:
        ...
    @classmethod
    def spec(cls, key : Any) -> Any:
        return cls._spec(key)

    @overload
    @classmethod
    def parse(cls, uap : Literal["plot"], bs : Bits) -> Union[ValueError, List[Record_25]]:
        ...
    @overload
    @classmethod
    def parse(cls, uap : Literal["track"], bs : Bits) -> Union[ValueError, List[Record_26]]:
        ...
    @classmethod
    def parse(cls, uap : str, bs : Bits) -> Any:
        return cls._parse(uap, bs)

    @classmethod
    def parse_any_uap(cls, bs : Bits) -> "List[List[Uap_49.cv_arg]]":
        return cls._parse_any_uap(bs)

class Asterix_1(AstCat):
    cv_category = 1
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_49

    @classmethod
    def create(cls, records : List[Uap_49.cv_arg]) -> "Asterix_1":
        return cls._create(records) # type: ignore

class Asterix_2(AstCat):
    cv_category = 1
    cv_edition = (1, 4)
    cv_uap: TypeAlias = Uap_49

    @classmethod
    def create(cls, records : List[Uap_49.cv_arg]) -> "Asterix_2":
        return cls._create(records) # type: ignore

class NonSpare_47(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_47.cv_arg") -> "NonSpare_47":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_47(UapItem):
    cv_non_spare: TypeAlias = NonSpare_47

class Content_590(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "South marker message", 8: "Activation of blind zone filtering", 9: "Stop of blind zone filtering"}

class RuleContent_590(RuleContentContextFree):
    cv_arg: TypeAlias = Content_590.cv_arg
    cv_content: TypeAlias = Content_590

    @property
    def content(self) -> Content_590:
        return self._get_content() # type: ignore

class Variation_190(Element):
    cv_arg: TypeAlias = RuleContent_590.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_590

    @classmethod
    def create(cls, arg: "Variation_190.cv_arg") -> "Variation_190":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_590:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_590:
        return self.rule.content

class RuleVariation_183(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_190.cv_arg
    cv_variation: TypeAlias = Variation_190

    @classmethod
    def create(cls, arg : "RuleVariation_183.cv_arg") -> "RuleVariation_183":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_190:
        return self.arg # type: ignore

class NonSpare_7(NonSpare):
    cv_arg: TypeAlias = RuleVariation_183.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_183

    @classmethod
    def create(cls, arg : "NonSpare_7.cv_arg") -> "NonSpare_7":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_183:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_190:
        return self.rule.variation

class UapItem_7(UapItem):
    cv_non_spare: TypeAlias = NonSpare_7

class Content_790(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.40625
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_789(RuleContentContextFree):
    cv_arg: TypeAlias = Content_790.cv_arg
    cv_content: TypeAlias = Content_790

    @property
    def content(self) -> Content_790:
        return self._get_content() # type: ignore

class Variation_243(Element):
    cv_arg: TypeAlias = RuleContent_789.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_789

    @classmethod
    def create(cls, arg: "Variation_243.cv_arg") -> "Variation_243":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_789:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_790:
        return self.rule.content

class RuleVariation_236(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_243.cv_arg
    cv_variation: TypeAlias = Variation_243

    @classmethod
    def create(cls, arg : "RuleVariation_236.cv_arg") -> "RuleVariation_236":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_243:
        return self.arg # type: ignore

class NonSpare_81(NonSpare):
    cv_arg: TypeAlias = RuleVariation_236.cv_arg
    cv_name = "020"
    cv_title = "Sector Number"
    cv_rule: TypeAlias = RuleVariation_236

    @classmethod
    def create(cls, arg : "NonSpare_81.cv_arg") -> "NonSpare_81":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_243:
        return self.rule.variation

class UapItem_81(UapItem):
    cv_non_spare: TypeAlias = NonSpare_81

class Variation_370(Element):
    cv_arg: TypeAlias = RuleContent_769.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_769

    @classmethod
    def create(cls, arg: "Variation_370.cv_arg") -> "Variation_370":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_769:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_770:
        return self.rule.content

class RuleVariation_363(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_370.cv_arg
    cv_variation: TypeAlias = Variation_370

    @classmethod
    def create(cls, arg : "RuleVariation_363.cv_arg") -> "RuleVariation_363":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_370:
        return self.arg # type: ignore

class NonSpare_109(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_109.cv_arg") -> "NonSpare_109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_109(UapItem):
    cv_non_spare: TypeAlias = NonSpare_109

class NonSpare_152(NonSpare):
    cv_arg: TypeAlias = RuleVariation_327.cv_arg
    cv_name = "041"
    cv_title = "Antenna Rotation Speed"
    cv_rule: TypeAlias = RuleVariation_327

    @classmethod
    def create(cls, arg : "NonSpare_152.cv_arg") -> "NonSpare_152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

class UapItem_152(UapItem):
    cv_non_spare: TypeAlias = NonSpare_152

class NonSpare_180(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "050"
    cv_title = "Station Configuration Status"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_180.cv_arg") -> "NonSpare_180":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_180(UapItem):
    cv_non_spare: TypeAlias = NonSpare_180

class NonSpare_198(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "060"
    cv_title = "Station Processing Mode"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_198.cv_arg") -> "NonSpare_198":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_198(UapItem):
    cv_non_spare: TypeAlias = NonSpare_198

class Content_69(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Counter for antenna 1", 1: "Counter for antenna 2"}

class RuleContent_69(RuleContentContextFree):
    cv_arg: TypeAlias = Content_69.cv_arg
    cv_content: TypeAlias = Content_69

    @property
    def content(self) -> Content_69:
        return self._get_content() # type: ignore

class Variation_21(Element):
    cv_arg: TypeAlias = RuleContent_69.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_69

    @classmethod
    def create(cls, arg: "Variation_21.cv_arg") -> "Variation_21":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_69:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_69:
        return self.rule.content

class RuleVariation_21(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_21.cv_arg
    cv_variation: TypeAlias = Variation_21

    @classmethod
    def create(cls, arg : "RuleVariation_21.cv_arg") -> "RuleVariation_21":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_21:
        return self.arg # type: ignore

class NonSpare_548(NonSpare):
    cv_arg: TypeAlias = RuleVariation_21.cv_arg
    cv_name = "A"
    cv_title = "Aerial Identification"
    cv_rule: TypeAlias = RuleVariation_21

    @classmethod
    def create(cls, arg : "NonSpare_548.cv_arg") -> "NonSpare_548":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_21:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_21:
        return self.rule.variation

class Item_33(Item):
    cv_arg: TypeAlias = NonSpare_548.cv_arg
    cv_non_spare: TypeAlias = NonSpare_548

    @classmethod
    def create(cls, arg : "Item_33.cv_arg") -> "Item_33":
        return cls._create(arg) # type: ignore

class Content_595(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Sole primary plots", 2: "Sole SSR plots", 3: "Combined plots"}

class RuleContent_595(RuleContentContextFree):
    cv_arg: TypeAlias = Content_595.cv_arg
    cv_content: TypeAlias = Content_595

    @property
    def content(self) -> Content_595:
        return self._get_content() # type: ignore

class Variation_491(Element):
    cv_arg: TypeAlias = RuleContent_595.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 5
    cv_rule = RuleContent_595

    @classmethod
    def create(cls, arg: "Variation_491.cv_arg") -> "Variation_491":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_595:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_595:
        return self.rule.content

class RuleVariation_480(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_491.cv_arg
    cv_variation: TypeAlias = Variation_491

    @classmethod
    def create(cls, arg : "RuleVariation_480.cv_arg") -> "RuleVariation_480":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_491:
        return self.arg # type: ignore

class NonSpare_1113(NonSpare):
    cv_arg: TypeAlias = RuleVariation_480.cv_arg
    cv_name = "IDENT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_480

    @classmethod
    def create(cls, arg : "NonSpare_1113.cv_arg") -> "NonSpare_1113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_480:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_491:
        return self.rule.variation

class Item_430(Item):
    cv_arg: TypeAlias = NonSpare_1113.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1113

    @classmethod
    def create(cls, arg : "Item_430.cv_arg") -> "Item_430":
        return cls._create(arg) # type: ignore

class Content_613(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_613(RuleContentContextFree):
    cv_arg: TypeAlias = Content_613.cv_arg
    cv_content: TypeAlias = Content_613

    @property
    def content(self) -> Content_613:
        return self._get_content() # type: ignore

class Variation_967(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_967.cv_arg") -> "Variation_967":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_937(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_967.cv_arg
    cv_variation: TypeAlias = Variation_967

    @classmethod
    def create(cls, arg : "RuleVariation_937.cv_arg") -> "RuleVariation_937":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_967:
        return self.arg # type: ignore

class NonSpare_801(NonSpare):
    cv_arg: TypeAlias = RuleVariation_937.cv_arg
    cv_name = "COUNTER"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_937

    @classmethod
    def create(cls, arg : "NonSpare_801.cv_arg") -> "NonSpare_801":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_937:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_967:
        return self.rule.variation

class Item_200(Item):
    cv_arg: TypeAlias = NonSpare_801.cv_arg
    cv_non_spare: TypeAlias = NonSpare_801

    @classmethod
    def create(cls, arg : "Item_200.cv_arg") -> "Item_200":
        return cls._create(arg) # type: ignore

class Variation_1044(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_21.cv_arg, Tuple[Literal["A"], RuleVariation_21.cv_arg]], Union[RuleVariation_480.cv_arg, Tuple[Literal["IDENT"], RuleVariation_480.cv_arg]], Union[RuleVariation_937.cv_arg, Tuple[Literal["COUNTER"], RuleVariation_937.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1044.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_33, 1), (Item_430, 5), (Item_200, 10)]
    cv_items_dict = {"A": RuleVariation_21, "IDENT": RuleVariation_480, "COUNTER": RuleVariation_937}

    @overload
    @classmethod
    def spec(cls, key : Literal["A"]) -> RuleVariation_21:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IDENT"]) -> RuleVariation_480:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNTER"]) -> RuleVariation_937:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["A"], Literal["IDENT"], Literal["COUNTER"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["A"]) -> RuleVariation_21:
        ...
    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_480:
        ...
    @overload
    def get_item(self, key : Literal["COUNTER"]) -> RuleVariation_937:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1044.cv_arg") -> 'Variation_1044':
        return cls._create(arg) # type: ignore

class Variation_1409(Repetitive):
    cv_arg: TypeAlias = List[Variation_1044.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1044

    @classmethod
    def create(cls, arg: "Variation_1409.cv_arg") -> 'Variation_1409':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1044]:
        return self._get_list() # type: ignore

class RuleVariation_1330(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1409.cv_arg
    cv_variation: TypeAlias = Variation_1409

    @classmethod
    def create(cls, arg : "RuleVariation_1330.cv_arg") -> "RuleVariation_1330":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1409:
        return self.arg # type: ignore

class NonSpare_216(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1330.cv_arg
    cv_name = "070"
    cv_title = "Plot Count Values"
    cv_rule: TypeAlias = RuleVariation_1330

    @classmethod
    def create(cls, arg : "NonSpare_216.cv_arg") -> "NonSpare_216":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1330:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1409:
        return self.rule.variation

class UapItem_216(UapItem):
    cv_non_spare: TypeAlias = NonSpare_216

class Content_767(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_766(RuleContentContextFree):
    cv_arg: TypeAlias = Content_767.cv_arg
    cv_content: TypeAlias = Content_767

    @property
    def content(self) -> Content_767:
        return self._get_content() # type: ignore

class Variation_331(Element):
    cv_arg: TypeAlias = RuleContent_766.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_766

    @classmethod
    def create(cls, arg: "Variation_331.cv_arg") -> "Variation_331":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_766:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_767:
        return self.rule.content

class RuleVariation_324(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_331.cv_arg
    cv_variation: TypeAlias = Variation_331

    @classmethod
    def create(cls, arg : "RuleVariation_324.cv_arg") -> "RuleVariation_324":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_331:
        return self.arg # type: ignore

class NonSpare_1614(NonSpare):
    cv_arg: TypeAlias = RuleVariation_324.cv_arg
    cv_name = "RS"
    cv_title = "Rho Start"
    cv_rule: TypeAlias = RuleVariation_324

    @classmethod
    def create(cls, arg : "NonSpare_1614.cv_arg") -> "NonSpare_1614":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_324:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_331:
        return self.rule.variation

class Item_832(Item):
    cv_arg: TypeAlias = NonSpare_1614.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1614

    @classmethod
    def create(cls, arg : "Item_832.cv_arg") -> "Item_832":
        return cls._create(arg) # type: ignore

class NonSpare_1569(NonSpare):
    cv_arg: TypeAlias = RuleVariation_324.cv_arg
    cv_name = "RE"
    cv_title = "Rho End"
    cv_rule: TypeAlias = RuleVariation_324

    @classmethod
    def create(cls, arg : "NonSpare_1569.cv_arg") -> "NonSpare_1569":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_324:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_331:
        return self.rule.variation

class Item_794(Item):
    cv_arg: TypeAlias = NonSpare_1569.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1569

    @classmethod
    def create(cls, arg : "Item_794.cv_arg") -> "Item_794":
        return cls._create(arg) # type: ignore

class NonSpare_1926(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TS"
    cv_title = "Theta Start"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1926.cv_arg") -> "NonSpare_1926":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_1043(Item):
    cv_arg: TypeAlias = NonSpare_1926.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1926

    @classmethod
    def create(cls, arg : "Item_1043.cv_arg") -> "Item_1043":
        return cls._create(arg) # type: ignore

class NonSpare_1852(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TE"
    cv_title = "Theta End"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1852.cv_arg") -> "NonSpare_1852":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_991(Item):
    cv_arg: TypeAlias = NonSpare_1852.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1852

    @classmethod
    def create(cls, arg : "Item_991.cv_arg") -> "Item_991":
        return cls._create(arg) # type: ignore

class Variation_1185(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_324.cv_arg, Tuple[Literal["RS"], RuleVariation_324.cv_arg]], Union[RuleVariation_324.cv_arg, Tuple[Literal["RE"], RuleVariation_324.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["TS"], RuleVariation_336.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["TE"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1185.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_832, 16), (Item_794, 16), (Item_1043, 16), (Item_991, 16)]
    cv_items_dict = {"RS": RuleVariation_324, "RE": RuleVariation_324, "TS": RuleVariation_336, "TE": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RS"]) -> RuleVariation_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TE"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RS"], Literal["RE"], Literal["TS"], Literal["TE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RS"]) -> RuleVariation_324:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_324:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["TE"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1185.cv_arg") -> 'Variation_1185':
        return cls._create(arg) # type: ignore

class RuleVariation_1135(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1185.cv_arg
    cv_variation: TypeAlias = Variation_1185

    @classmethod
    def create(cls, arg : "RuleVariation_1135.cv_arg") -> "RuleVariation_1135":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1185:
        return self.arg # type: ignore

class NonSpare_269(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1135.cv_arg
    cv_name = "100"
    cv_title = "Dynamic Window Type 1"
    cv_rule: TypeAlias = RuleVariation_1135

    @classmethod
    def create(cls, arg : "NonSpare_269.cv_arg") -> "NonSpare_269":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1185:
        return self.rule.variation

class UapItem_269(UapItem):
    cv_non_spare: TypeAlias = NonSpare_269

class Content_677(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_677(RuleContentContextFree):
    cv_arg: TypeAlias = Content_677.cv_arg
    cv_content: TypeAlias = Content_677

    @property
    def content(self) -> Content_677:
        return self._get_content() # type: ignore

class Variation_215(Element):
    cv_arg: TypeAlias = RuleContent_677.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_677

    @classmethod
    def create(cls, arg: "Variation_215.cv_arg") -> "Variation_215":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_677:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_677:
        return self.rule.content

class RuleVariation_208(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_215.cv_arg
    cv_variation: TypeAlias = Variation_215

    @classmethod
    def create(cls, arg : "RuleVariation_208.cv_arg") -> "RuleVariation_208":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_215:
        return self.arg # type: ignore

class NonSpare_1565(NonSpare):
    cv_arg: TypeAlias = RuleVariation_208.cv_arg
    cv_name = "RE"
    cv_title = "Range Error"
    cv_rule: TypeAlias = RuleVariation_208

    @classmethod
    def create(cls, arg : "NonSpare_1565.cv_arg") -> "NonSpare_1565":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_208:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_215:
        return self.rule.variation

class Item_791(Item):
    cv_arg: TypeAlias = NonSpare_1565.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1565

    @classmethod
    def create(cls, arg : "Item_791.cv_arg") -> "Item_791":
        return cls._create(arg) # type: ignore

class Content_708(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.197265625e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_708(RuleContentContextFree):
    cv_arg: TypeAlias = Content_708.cv_arg
    cv_content: TypeAlias = Content_708

    @property
    def content(self) -> Content_708:
        return self._get_content() # type: ignore

class Variation_220(Element):
    cv_arg: TypeAlias = RuleContent_708.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_708

    @classmethod
    def create(cls, arg: "Variation_220.cv_arg") -> "Variation_220":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_708:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_708:
        return self.rule.content

class RuleVariation_213(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_220.cv_arg
    cv_variation: TypeAlias = Variation_220

    @classmethod
    def create(cls, arg : "RuleVariation_213.cv_arg") -> "RuleVariation_213":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_220:
        return self.arg # type: ignore

class NonSpare_579(NonSpare):
    cv_arg: TypeAlias = RuleVariation_213.cv_arg
    cv_name = "AE"
    cv_title = "Azimuth Error"
    cv_rule: TypeAlias = RuleVariation_213

    @classmethod
    def create(cls, arg : "NonSpare_579.cv_arg") -> "NonSpare_579":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_213:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_220:
        return self.rule.variation

class Item_49(Item):
    cv_arg: TypeAlias = NonSpare_579.cv_arg
    cv_non_spare: TypeAlias = NonSpare_579

    @classmethod
    def create(cls, arg : "Item_49.cv_arg") -> "Item_49":
        return cls._create(arg) # type: ignore

class Variation_1171(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_208.cv_arg, Tuple[Literal["RE"], RuleVariation_208.cv_arg]], Union[RuleVariation_213.cv_arg, Tuple[Literal["AE"], RuleVariation_213.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1171.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_791, 8), (Item_49, 8)]
    cv_items_dict = {"RE": RuleVariation_208, "AE": RuleVariation_213}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AE"]) -> RuleVariation_213:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["AE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_208:
        ...
    @overload
    def get_item(self, key : Literal["AE"]) -> RuleVariation_213:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1171.cv_arg") -> 'Variation_1171':
        return cls._create(arg) # type: ignore

class RuleVariation_1122(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1171.cv_arg
    cv_variation: TypeAlias = Variation_1171

    @classmethod
    def create(cls, arg : "RuleVariation_1122.cv_arg") -> "RuleVariation_1122":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1171:
        return self.arg # type: ignore

class NonSpare_244(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1122.cv_arg
    cv_name = "090"
    cv_title = "Collimation Error"
    cv_rule: TypeAlias = RuleVariation_1122

    @classmethod
    def create(cls, arg : "NonSpare_244.cv_arg") -> "NonSpare_244":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1122:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1171:
        return self.rule.variation

class UapItem_244(UapItem):
    cv_non_spare: TypeAlias = NonSpare_244

class NonSpare_242(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "080"
    cv_title = "Warning/Error Conditions"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_242.cv_arg") -> "NonSpare_242":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_242(UapItem):
    cv_non_spare: TypeAlias = NonSpare_242

class Record_46(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_47.cv_arg,
        "000": NonSpare_7.cv_arg,
        "020": NonSpare_81.cv_arg,
        "030": NonSpare_109.cv_arg,
        "041": NonSpare_152.cv_arg,
        "050": NonSpare_180.cv_arg,
        "060": NonSpare_198.cv_arg,
        "070": NonSpare_216.cv_arg,
        "100": NonSpare_269.cv_arg,
        "090": NonSpare_244.cv_arg,
        "080": NonSpare_242.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_47.cv_arg],
        Tuple[Literal["000"], NonSpare_7.cv_arg],
        Tuple[Literal["020"], NonSpare_81.cv_arg],
        Tuple[Literal["030"], NonSpare_109.cv_arg],
        Tuple[Literal["041"], NonSpare_152.cv_arg],
        Tuple[Literal["050"], NonSpare_180.cv_arg],
        Tuple[Literal["060"], NonSpare_198.cv_arg],
        Tuple[Literal["070"], NonSpare_216.cv_arg],
        Tuple[Literal["100"], NonSpare_269.cv_arg],
        Tuple[Literal["090"], NonSpare_244.cv_arg],
        Tuple[Literal["080"], NonSpare_242.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
    ]
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_47, UapItem_7, UapItem_81, UapItem_109, UapItem_152, UapItem_180, UapItem_198, UapItem_216, UapItem_269, UapItem_244, UapItem_242, UapItem_549, UapItem_548, UapItem_550]
    cv_items_dict = {"010": NonSpare_47, "000": NonSpare_7, "020": NonSpare_81, "030": NonSpare_109, "041": NonSpare_152, "050": NonSpare_180, "060": NonSpare_198, "070": NonSpare_216, "100": NonSpare_269, "090": NonSpare_244, "080": NonSpare_242, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_47:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_7:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_81:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_152:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_180:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_216:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_242:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["090"], Literal["080"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_47]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_7]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_81]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_109]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_152]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_180]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_198]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_216]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_244]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_242]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_47.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_7.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_81.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_109.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_152.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_180.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_198.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_216.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_244.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_242.cv_arg) -> 'Record_46':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_46':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_46':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_46':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_47]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["000"]) -> List[NonSpare_7]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_81]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_109]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["041"]) -> List[NonSpare_152]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_180]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_198]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_216]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_269]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_244]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_242]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_46.cv_arg", rfs : Optional[List["Record_46.cv_union"]] = None) -> 'Record_46':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_46", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_42(UapSingle):
    cv_arg: TypeAlias = Record_46
    cv_record: TypeAlias = Record_46

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_46]]:
        return cls._parse(bs)

class Asterix_3(AstCat):
    cv_category = 2
    cv_edition = (1, 0)
    cv_uap: TypeAlias = Uap_42
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_42.cv_arg]) -> "Asterix_3":
        return cls._create(records) # type: ignore

class NonSpare_38(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_38.cv_arg") -> "NonSpare_38":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_38(UapItem):
    cv_non_spare: TypeAlias = NonSpare_38

class Record_27(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_38.cv_arg,
        "000": NonSpare_7.cv_arg,
        "020": NonSpare_81.cv_arg,
        "030": NonSpare_109.cv_arg,
        "041": NonSpare_152.cv_arg,
        "050": NonSpare_180.cv_arg,
        "060": NonSpare_198.cv_arg,
        "070": NonSpare_216.cv_arg,
        "100": NonSpare_269.cv_arg,
        "090": NonSpare_244.cv_arg,
        "080": NonSpare_242.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_38.cv_arg],
        Tuple[Literal["000"], NonSpare_7.cv_arg],
        Tuple[Literal["020"], NonSpare_81.cv_arg],
        Tuple[Literal["030"], NonSpare_109.cv_arg],
        Tuple[Literal["041"], NonSpare_152.cv_arg],
        Tuple[Literal["050"], NonSpare_180.cv_arg],
        Tuple[Literal["060"], NonSpare_198.cv_arg],
        Tuple[Literal["070"], NonSpare_216.cv_arg],
        Tuple[Literal["100"], NonSpare_269.cv_arg],
        Tuple[Literal["090"], NonSpare_244.cv_arg],
        Tuple[Literal["080"], NonSpare_242.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
    ]
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_38, UapItem_7, UapItem_81, UapItem_109, UapItem_152, UapItem_180, UapItem_198, UapItem_216, UapItem_269, UapItem_244, UapItem_242, UapItem_549, UapItem_548, UapItem_550]
    cv_items_dict = {"010": NonSpare_38, "000": NonSpare_7, "020": NonSpare_81, "030": NonSpare_109, "041": NonSpare_152, "050": NonSpare_180, "060": NonSpare_198, "070": NonSpare_216, "100": NonSpare_269, "090": NonSpare_244, "080": NonSpare_242, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_38:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_7:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_81:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_152:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_180:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_216:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_242:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["090"], Literal["080"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_38]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_7]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_81]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_109]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_152]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_180]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_198]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_216]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_269]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_244]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_242]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_38.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_7.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_81.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_109.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_152.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_180.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_198.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_216.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_269.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_244.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_242.cv_arg) -> 'Record_27':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_27':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_27':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_27':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_38]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["000"]) -> List[NonSpare_7]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_81]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["030"]) -> List[NonSpare_109]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["041"]) -> List[NonSpare_152]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_180]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["060"]) -> List[NonSpare_198]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["070"]) -> List[NonSpare_216]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_269]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_244]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["080"]) -> List[NonSpare_242]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_27.cv_arg", rfs : Optional[List["Record_27.cv_union"]] = None) -> 'Record_27':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_27", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_23(UapSingle):
    cv_arg: TypeAlias = Record_27
    cv_record: TypeAlias = Record_27

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_27]]:
        return cls._parse(bs)

class Asterix_4(AstCat):
    cv_category = 2
    cv_edition = (1, 1)
    cv_uap: TypeAlias = Uap_23
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_23.cv_arg]) -> "Asterix_4":
        return cls._create(records) # type: ignore

class Asterix_5(AstCat):
    cv_category = 2
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_23
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_23.cv_arg]) -> "Asterix_5":
        return cls._create(records) # type: ignore

class NonSpare_34(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_34.cv_arg") -> "NonSpare_34":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_34(UapItem):
    cv_non_spare: TypeAlias = NonSpare_34

class Content_576(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Alive Message (AM)", 2: "Route Adherence Monitor Longitudinal Deviation (RAMLD)", 3: "Route Adherence Monitor Heading Deviation (RAMHD)", 4: "Minimum Safe Altitude Warning (MSAW)", 5: "Area Proximity Warning (APW)", 6: "Clearance Level Adherence Monitor (CLAM)", 7: "Short Term Conflict Alert (STCA)", 8: "Approach Path Monitor (APM)", 9: "RIMCAS Arrival / Landing Monitor (ALM)", 10: "RIMCAS Arrival / Departure Wrong Runway Alert (WRA)", 11: "RIMCAS Arrival / Departure Opposite Traffic Alert (OTA)", 12: "RIMCAS Departure Monitor (RDM)", 13: "RIMCAS Runway / Taxiway Crossing Monitor (RCM)", 14: "RIMCAS Taxiway Separation Monitor (TSM)", 15: "RIMCAS Unauthorized Taxiway Movement Monitor(UTMM)", 16: "RIMCAS Stop Bar Overrun Alert (SBOA)", 17: "End Of Conflict (EOC)", 18: "ACAS Resolution Advisory (ACASRA)", 19: "Near Term Conflict Alert (NTCA)", 20: "Downlinked Barometric Pressure Setting Monitor (DBPSM)", 21: "Speed Adherence Monitor (SAM)", 22: "Outside Controlled Airspace Tool (OCAT)", 23: "Vertical Conflict Detection (VCD)", 24: "Vertical Rate Adherence Monitor (VRAM)", 25: "Cleared Heading Adherence Monitor (CHAM)", 26: "Downlinked Selected Altitude Monitor (DSAM)", 27: "Holding Adherence Monitor (HAM)", 28: "Vertical Path Monitor (VPM)", 29: "RIMCAS Taxiway Traffic Alert (TTA)", 30: "RIMCAS Arrival/Departure Close Runway Alert (CRA)", 31: "RIMCAS Arrival/Departure Aircraft Separation Monitor (ASM)", 32: "RIMCAS ILS Area Violation Monitor (IAVM)", 33: "Final Target Distance Indicator (FTD)", 34: "Initial Target Distance Indicator (ITD)", 35: "Wake Vortex Indicator Infringement Alert (IIA)", 36: "Sequence Warning (SQW)", 37: "Catch Up Warning (CUW)", 38: "Conflicting ATC Clearances (CATC)", 39: "No ATC Clearance (NOCLR)", 40: "Aircraft Not Moving despite ATC Clearance (NOMOV)", 41: "Aircraft leaving/entering the aerodrome area without proper handover (NOH)", 42: "Wrong Runway or Taxiway Type (WRTY)", 43: "Stand Occupied (STOCC)", 44: "Ongoing Alert (ONGOING)", 97: "Lost Track Warning (LTW)", 98: "Holding Volume Infringement (HVI)", 99: "Airspace Infringement Warning (AIW)"}

class RuleContent_576(RuleContentContextFree):
    cv_arg: TypeAlias = Content_576.cv_arg
    cv_content: TypeAlias = Content_576

    @property
    def content(self) -> Content_576:
        return self._get_content() # type: ignore

class Variation_180(Element):
    cv_arg: TypeAlias = RuleContent_576.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_576

    @classmethod
    def create(cls, arg: "Variation_180.cv_arg") -> "Variation_180":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_576:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_576:
        return self.rule.content

class RuleVariation_173(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_180.cv_arg
    cv_variation: TypeAlias = Variation_180

    @classmethod
    def create(cls, arg : "RuleVariation_173.cv_arg") -> "RuleVariation_173":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_180:
        return self.arg # type: ignore

class NonSpare_3(NonSpare):
    cv_arg: TypeAlias = RuleVariation_173.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_173

    @classmethod
    def create(cls, arg : "NonSpare_3.cv_arg") -> "NonSpare_3":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_173:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_180:
        return self.rule.variation

class UapItem_3(UapItem):
    cv_non_spare: TypeAlias = NonSpare_3

class Variation_1429(Repetitive):
    cv_arg: TypeAlias = List[Variation_1192.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1192

    @classmethod
    def create(cls, arg: "Variation_1429.cv_arg") -> 'Variation_1429':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1192]:
        return self._get_list() # type: ignore

class RuleVariation_1350(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1429.cv_arg
    cv_variation: TypeAlias = Variation_1429

    @classmethod
    def create(cls, arg : "RuleVariation_1350.cv_arg") -> "RuleVariation_1350":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1429:
        return self.arg # type: ignore

class NonSpare_58(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1350.cv_arg
    cv_name = "015"
    cv_title = "SDPS Identifier"
    cv_rule: TypeAlias = RuleVariation_1350

    @classmethod
    def create(cls, arg : "NonSpare_58.cv_arg") -> "NonSpare_58":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1350:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1429:
        return self.rule.variation

class UapItem_58(UapItem):
    cv_non_spare: TypeAlias = NonSpare_58

class NonSpare_94(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "020"
    cv_title = "Time of Message"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_94.cv_arg") -> "NonSpare_94":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_94(UapItem):
    cv_non_spare: TypeAlias = NonSpare_94

class NonSpare_136(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "040"
    cv_title = "Alert Identifier"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_136.cv_arg") -> "NonSpare_136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_136(UapItem):
    cv_non_spare: TypeAlias = NonSpare_136

class Variation_774(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_774.cv_arg") -> "Variation_774":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_763(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_774.cv_arg
    cv_variation: TypeAlias = Variation_774

    @classmethod
    def create(cls, arg : "RuleVariation_763.cv_arg") -> "RuleVariation_763":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_774:
        return self.arg # type: ignore

class NonSpare_1783(NonSpare):
    cv_arg: TypeAlias = RuleVariation_763.cv_arg
    cv_name = "STAT"
    cv_title = "Status of the Alert"
    cv_rule: TypeAlias = RuleVariation_763

    @classmethod
    def create(cls, arg : "NonSpare_1783.cv_arg") -> "NonSpare_1783":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_763:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_774:
        return self.rule.variation

class Item_944(Item):
    cv_arg: TypeAlias = NonSpare_1783.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1783

    @classmethod
    def create(cls, arg : "Item_944.cv_arg") -> "Item_944":
        return cls._create(arg) # type: ignore

class Item_29(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 7
    cv_bit_size = 1

class Variation_1033(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_763.cv_arg, Tuple[Literal["STAT"], RuleVariation_763.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1033.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_3, 4), (Item_944, 3), (Item_29, 1)]
    cv_items_dict = {"STAT": RuleVariation_763}

    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_763:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["STAT"]) -> RuleVariation_763:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1033.cv_arg") -> 'Variation_1033':
        return cls._create(arg) # type: ignore

class RuleVariation_1001(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1033.cv_arg
    cv_variation: TypeAlias = Variation_1033

    @classmethod
    def create(cls, arg : "RuleVariation_1001.cv_arg") -> "RuleVariation_1001":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1033:
        return self.arg # type: ignore

class NonSpare_163(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1001.cv_arg
    cv_name = "045"
    cv_title = "Alert Status"
    cv_rule: TypeAlias = RuleVariation_1001

    @classmethod
    def create(cls, arg : "NonSpare_163.cv_arg") -> "NonSpare_163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1001:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1033:
        return self.rule.variation

class UapItem_163(UapItem):
    cv_non_spare: TypeAlias = NonSpare_163

class Content_114(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "MRVA function"}

class RuleContent_114(RuleContentContextFree):
    cv_arg: TypeAlias = Content_114.cv_arg
    cv_content: TypeAlias = Content_114

    @property
    def content(self) -> Content_114:
        return self._get_content() # type: ignore

class Variation_32(Element):
    cv_arg: TypeAlias = RuleContent_114.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_114

    @classmethod
    def create(cls, arg: "Variation_32.cv_arg") -> "Variation_32":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_114:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_114:
        return self.rule.content

class RuleVariation_32(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_32.cv_arg
    cv_variation: TypeAlias = Variation_32

    @classmethod
    def create(cls, arg : "RuleVariation_32.cv_arg") -> "RuleVariation_32":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_32:
        return self.arg # type: ignore

class Content_142(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "RAMLD function"}

class RuleContent_142(RuleContentContextFree):
    cv_arg: TypeAlias = Content_142.cv_arg
    cv_content: TypeAlias = Content_142

    @property
    def content(self) -> Content_142:
        return self._get_content() # type: ignore

class Variation_416(Element):
    cv_arg: TypeAlias = RuleContent_142.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_142

    @classmethod
    def create(cls, arg: "Variation_416.cv_arg") -> "Variation_416":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_142:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_142:
        return self.rule.content

class RuleVariation_405(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_416.cv_arg
    cv_variation: TypeAlias = Variation_416

    @classmethod
    def create(cls, arg : "RuleVariation_405.cv_arg") -> "RuleVariation_405":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_416:
        return self.arg # type: ignore

class Content_141(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "RAMHD function"}

class RuleContent_141(RuleContentContextFree):
    cv_arg: TypeAlias = Content_141.cv_arg
    cv_content: TypeAlias = Content_141

    @property
    def content(self) -> Content_141:
        return self._get_content() # type: ignore

class Variation_524(Element):
    cv_arg: TypeAlias = RuleContent_141.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_141

    @classmethod
    def create(cls, arg: "Variation_524.cv_arg") -> "Variation_524":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_141:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_141:
        return self.rule.content

class RuleVariation_513(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_524.cv_arg
    cv_variation: TypeAlias = Variation_524

    @classmethod
    def create(cls, arg : "RuleVariation_513.cv_arg") -> "RuleVariation_513":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_524:
        return self.arg # type: ignore

class Content_115(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "MSAW function"}

class RuleContent_115(RuleContentContextFree):
    cv_arg: TypeAlias = Content_115.cv_arg
    cv_content: TypeAlias = Content_115

    @property
    def content(self) -> Content_115:
        return self._get_content() # type: ignore

class Variation_626(Element):
    cv_arg: TypeAlias = RuleContent_115.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_115

    @classmethod
    def create(cls, arg: "Variation_626.cv_arg") -> "Variation_626":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_115:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_115:
        return self.rule.content

class RuleVariation_615(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_626.cv_arg
    cv_variation: TypeAlias = Variation_626

    @classmethod
    def create(cls, arg : "RuleVariation_615.cv_arg") -> "RuleVariation_615":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_626:
        return self.arg # type: ignore

class Content_82(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "APW function"}

class RuleContent_82(RuleContentContextFree):
    cv_arg: TypeAlias = Content_82.cv_arg
    cv_content: TypeAlias = Content_82

    @property
    def content(self) -> Content_82:
        return self._get_content() # type: ignore

class Variation_705(Element):
    cv_arg: TypeAlias = RuleContent_82.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_82

    @classmethod
    def create(cls, arg: "Variation_705.cv_arg") -> "Variation_705":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_82:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_82:
        return self.rule.content

class RuleVariation_694(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_705.cv_arg
    cv_variation: TypeAlias = Variation_705

    @classmethod
    def create(cls, arg : "RuleVariation_694.cv_arg") -> "RuleVariation_694":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_705:
        return self.arg # type: ignore

class Content_87(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "CLAM function"}

class RuleContent_87(RuleContentContextFree):
    cv_arg: TypeAlias = Content_87.cv_arg
    cv_content: TypeAlias = Content_87

    @property
    def content(self) -> Content_87:
        return self._get_content() # type: ignore

class Variation_830(Element):
    cv_arg: TypeAlias = RuleContent_87.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_87

    @classmethod
    def create(cls, arg: "Variation_830.cv_arg") -> "Variation_830":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_87:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_87:
        return self.rule.content

class RuleVariation_800(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_830.cv_arg
    cv_variation: TypeAlias = Variation_830

    @classmethod
    def create(cls, arg : "RuleVariation_800.cv_arg") -> "RuleVariation_800":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_830:
        return self.arg # type: ignore

class Content_150(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "STCA function"}

class RuleContent_150(RuleContentContextFree):
    cv_arg: TypeAlias = Content_150.cv_arg
    cv_content: TypeAlias = Content_150

    @property
    def content(self) -> Content_150:
        return self._get_content() # type: ignore

class Variation_919(Element):
    cv_arg: TypeAlias = RuleContent_150.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_150

    @classmethod
    def create(cls, arg: "Variation_919.cv_arg") -> "Variation_919":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_150:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_150:
        return self.rule.content

class RuleVariation_889(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_919.cv_arg
    cv_variation: TypeAlias = Variation_919

    @classmethod
    def create(cls, arg : "RuleVariation_889.cv_arg") -> "RuleVariation_889":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_919:
        return self.arg # type: ignore

class Content_81(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "APM function"}

class RuleContent_81(RuleContentContextFree):
    cv_arg: TypeAlias = Content_81.cv_arg
    cv_content: TypeAlias = Content_81

    @property
    def content(self) -> Content_81:
        return self._get_content() # type: ignore

class Variation_24(Element):
    cv_arg: TypeAlias = RuleContent_81.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_81

    @classmethod
    def create(cls, arg: "Variation_24.cv_arg") -> "Variation_24":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_81:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_81:
        return self.rule.content

class RuleVariation_24(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_24.cv_arg
    cv_variation: TypeAlias = Variation_24

    @classmethod
    def create(cls, arg : "RuleVariation_24.cv_arg") -> "RuleVariation_24":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_24:
        return self.arg # type: ignore

class Content_143(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "RIMCA function"}

class RuleContent_143(RuleContentContextFree):
    cv_arg: TypeAlias = Content_143.cv_arg
    cv_content: TypeAlias = Content_143

    @property
    def content(self) -> Content_143:
        return self._get_content() # type: ignore

class Variation_417(Element):
    cv_arg: TypeAlias = RuleContent_143.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_143

    @classmethod
    def create(cls, arg: "Variation_417.cv_arg") -> "Variation_417":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_143:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_143:
        return self.rule.content

class RuleVariation_406(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_417.cv_arg
    cv_variation: TypeAlias = Variation_417

    @classmethod
    def create(cls, arg : "RuleVariation_406.cv_arg") -> "RuleVariation_406":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_417:
        return self.arg # type: ignore

class Content_79(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "ACAS RA function"}

class RuleContent_79(RuleContentContextFree):
    cv_arg: TypeAlias = Content_79.cv_arg
    cv_content: TypeAlias = Content_79

    @property
    def content(self) -> Content_79:
        return self._get_content() # type: ignore

class Variation_514(Element):
    cv_arg: TypeAlias = RuleContent_79.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_79

    @classmethod
    def create(cls, arg: "Variation_514.cv_arg") -> "Variation_514":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_79:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_79:
        return self.rule.content

class RuleVariation_503(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_514.cv_arg
    cv_variation: TypeAlias = Variation_514

    @classmethod
    def create(cls, arg : "RuleVariation_503.cv_arg") -> "RuleVariation_503":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_514:
        return self.arg # type: ignore

class Content_132(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "NTCA function"}

class RuleContent_132(RuleContentContextFree):
    cv_arg: TypeAlias = Content_132.cv_arg
    cv_content: TypeAlias = Content_132

    @property
    def content(self) -> Content_132:
        return self._get_content() # type: ignore

class Variation_631(Element):
    cv_arg: TypeAlias = RuleContent_132.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_132

    @classmethod
    def create(cls, arg: "Variation_631.cv_arg") -> "Variation_631":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_132:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_132:
        return self.rule.content

class RuleVariation_620(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_631.cv_arg
    cv_variation: TypeAlias = Variation_631

    @classmethod
    def create(cls, arg : "RuleVariation_620.cv_arg") -> "RuleVariation_620":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_631:
        return self.arg # type: ignore

class Content_153(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "System degraded"}

class RuleContent_153(RuleContentContextFree):
    cv_arg: TypeAlias = Content_153.cv_arg
    cv_content: TypeAlias = Content_153

    @property
    def content(self) -> Content_153:
        return self._get_content() # type: ignore

class Variation_711(Element):
    cv_arg: TypeAlias = RuleContent_153.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_153

    @classmethod
    def create(cls, arg: "Variation_711.cv_arg") -> "Variation_711":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_153:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_153:
        return self.rule.content

class RuleVariation_700(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_711.cv_arg
    cv_variation: TypeAlias = Variation_711

    @classmethod
    def create(cls, arg : "RuleVariation_700.cv_arg") -> "RuleVariation_700":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_711:
        return self.arg # type: ignore

class Content_136(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Overflow error"}

class RuleContent_136(RuleContentContextFree):
    cv_arg: TypeAlias = Content_136.cv_arg
    cv_content: TypeAlias = Content_136

    @property
    def content(self) -> Content_136:
        return self._get_content() # type: ignore

class Variation_834(Element):
    cv_arg: TypeAlias = RuleContent_136.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_136

    @classmethod
    def create(cls, arg: "Variation_834.cv_arg") -> "Variation_834":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_136:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_136:
        return self.rule.content

class RuleVariation_804(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_834.cv_arg
    cv_variation: TypeAlias = Variation_834

    @classmethod
    def create(cls, arg : "RuleVariation_804.cv_arg") -> "RuleVariation_804":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_834:
        return self.arg # type: ignore

class Content_138(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Overload error"}

class RuleContent_138(RuleContentContextFree):
    cv_arg: TypeAlias = Content_138.cv_arg
    cv_content: TypeAlias = Content_138

    @property
    def content(self) -> Content_138:
        return self._get_content() # type: ignore

class Variation_916(Element):
    cv_arg: TypeAlias = RuleContent_138.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_138

    @classmethod
    def create(cls, arg: "Variation_916.cv_arg") -> "Variation_916":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_138:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_138:
        return self.rule.content

class RuleVariation_886(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_916.cv_arg
    cv_variation: TypeAlias = Variation_916

    @classmethod
    def create(cls, arg : "RuleVariation_886.cv_arg") -> "RuleVariation_886":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_916:
        return self.arg # type: ignore

class Content_80(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "AIW function"}

class RuleContent_80(RuleContentContextFree):
    cv_arg: TypeAlias = Content_80.cv_arg
    cv_content: TypeAlias = Content_80

    @property
    def content(self) -> Content_80:
        return self._get_content() # type: ignore

class Variation_23(Element):
    cv_arg: TypeAlias = RuleContent_80.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_80

    @classmethod
    def create(cls, arg: "Variation_23.cv_arg") -> "Variation_23":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_80:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_80:
        return self.rule.content

class RuleVariation_23(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_23.cv_arg
    cv_variation: TypeAlias = Variation_23

    @classmethod
    def create(cls, arg : "RuleVariation_23.cv_arg") -> "RuleVariation_23":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_23:
        return self.arg # type: ignore

class Content_139(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "PAIW function"}

class RuleContent_139(RuleContentContextFree):
    cv_arg: TypeAlias = Content_139.cv_arg
    cv_content: TypeAlias = Content_139

    @property
    def content(self) -> Content_139:
        return self._get_content() # type: ignore

class Variation_415(Element):
    cv_arg: TypeAlias = RuleContent_139.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_139

    @classmethod
    def create(cls, arg: "Variation_415.cv_arg") -> "Variation_415":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_139:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_139:
        return self.rule.content

class RuleVariation_404(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_415.cv_arg
    cv_variation: TypeAlias = Variation_415

    @classmethod
    def create(cls, arg : "RuleVariation_404.cv_arg") -> "RuleVariation_404":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_415:
        return self.arg # type: ignore

class Content_134(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "OCAT function"}

class RuleContent_134(RuleContentContextFree):
    cv_arg: TypeAlias = Content_134.cv_arg
    cv_content: TypeAlias = Content_134

    @property
    def content(self) -> Content_134:
        return self._get_content() # type: ignore

class Variation_522(Element):
    cv_arg: TypeAlias = RuleContent_134.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_134

    @classmethod
    def create(cls, arg: "Variation_522.cv_arg") -> "Variation_522":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_134:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_134:
        return self.rule.content

class RuleVariation_511(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_522.cv_arg
    cv_variation: TypeAlias = Variation_522

    @classmethod
    def create(cls, arg : "RuleVariation_511.cv_arg") -> "RuleVariation_511":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_522:
        return self.arg # type: ignore

class Content_148(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "SAM function"}

class RuleContent_148(RuleContentContextFree):
    cv_arg: TypeAlias = Content_148.cv_arg
    cv_content: TypeAlias = Content_148

    @property
    def content(self) -> Content_148:
        return self._get_content() # type: ignore

class Variation_632(Element):
    cv_arg: TypeAlias = RuleContent_148.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_148

    @classmethod
    def create(cls, arg: "Variation_632.cv_arg") -> "Variation_632":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_148:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_148:
        return self.rule.content

class RuleVariation_621(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_632.cv_arg
    cv_variation: TypeAlias = Variation_632

    @classmethod
    def create(cls, arg : "RuleVariation_621.cv_arg") -> "RuleVariation_621":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_632:
        return self.arg # type: ignore

class Content_160(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "VCD function"}

class RuleContent_160(RuleContentContextFree):
    cv_arg: TypeAlias = Content_160.cv_arg
    cv_content: TypeAlias = Content_160

    @property
    def content(self) -> Content_160:
        return self._get_content() # type: ignore

class Variation_712(Element):
    cv_arg: TypeAlias = RuleContent_160.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_160

    @classmethod
    def create(cls, arg: "Variation_712.cv_arg") -> "Variation_712":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_160:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_160:
        return self.rule.content

class RuleVariation_701(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_712.cv_arg
    cv_variation: TypeAlias = Variation_712

    @classmethod
    def create(cls, arg : "RuleVariation_701.cv_arg") -> "RuleVariation_701":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_712:
        return self.arg # type: ignore

class Content_86(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "CHAM function"}

class RuleContent_86(RuleContentContextFree):
    cv_arg: TypeAlias = Content_86.cv_arg
    cv_content: TypeAlias = Content_86

    @property
    def content(self) -> Content_86:
        return self._get_content() # type: ignore

class Variation_829(Element):
    cv_arg: TypeAlias = RuleContent_86.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_86

    @classmethod
    def create(cls, arg: "Variation_829.cv_arg") -> "Variation_829":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_86:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_86:
        return self.rule.content

class RuleVariation_799(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_829.cv_arg
    cv_variation: TypeAlias = Variation_829

    @classmethod
    def create(cls, arg : "RuleVariation_799.cv_arg") -> "RuleVariation_799":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_829:
        return self.arg # type: ignore

class Content_93(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "DSAM function"}

class RuleContent_93(RuleContentContextFree):
    cv_arg: TypeAlias = Content_93.cv_arg
    cv_content: TypeAlias = Content_93

    @property
    def content(self) -> Content_93:
        return self._get_content() # type: ignore

class Variation_910(Element):
    cv_arg: TypeAlias = RuleContent_93.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_93

    @classmethod
    def create(cls, arg: "Variation_910.cv_arg") -> "Variation_910":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_93:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_93:
        return self.rule.content

class RuleVariation_880(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_910.cv_arg
    cv_variation: TypeAlias = Variation_910

    @classmethod
    def create(cls, arg : "RuleVariation_880.cv_arg") -> "RuleVariation_880":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_910:
        return self.arg # type: ignore

class Content_90(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "DBPSM ARR sub-function"}

class RuleContent_90(RuleContentContextFree):
    cv_arg: TypeAlias = Content_90.cv_arg
    cv_content: TypeAlias = Content_90

    @property
    def content(self) -> Content_90:
        return self._get_content() # type: ignore

class Variation_27(Element):
    cv_arg: TypeAlias = RuleContent_90.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_90

    @classmethod
    def create(cls, arg: "Variation_27.cv_arg") -> "Variation_27":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_90:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_90:
        return self.rule.content

class RuleVariation_27(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_27.cv_arg
    cv_variation: TypeAlias = Variation_27

    @classmethod
    def create(cls, arg : "RuleVariation_27.cv_arg") -> "RuleVariation_27":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_27:
        return self.arg # type: ignore

class Content_91(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "DBPSM DEP sub-function"}

class RuleContent_91(RuleContentContextFree):
    cv_arg: TypeAlias = Content_91.cv_arg
    cv_content: TypeAlias = Content_91

    @property
    def content(self) -> Content_91:
        return self._get_content() # type: ignore

class Variation_406(Element):
    cv_arg: TypeAlias = RuleContent_91.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_91

    @classmethod
    def create(cls, arg: "Variation_406.cv_arg") -> "Variation_406":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_91:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_91:
        return self.rule.content

class RuleVariation_395(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_406.cv_arg
    cv_variation: TypeAlias = Variation_406

    @classmethod
    def create(cls, arg : "RuleVariation_395.cv_arg") -> "RuleVariation_395":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_406:
        return self.arg # type: ignore

class Content_92(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "DBPSM TL sub-function"}

class RuleContent_92(RuleContentContextFree):
    cv_arg: TypeAlias = Content_92.cv_arg
    cv_content: TypeAlias = Content_92

    @property
    def content(self) -> Content_92:
        return self._get_content() # type: ignore

class Variation_516(Element):
    cv_arg: TypeAlias = RuleContent_92.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_92

    @classmethod
    def create(cls, arg: "Variation_516.cv_arg") -> "Variation_516":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_92:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_92:
        return self.rule.content

class RuleVariation_505(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_516.cv_arg
    cv_variation: TypeAlias = Variation_516

    @classmethod
    def create(cls, arg : "RuleVariation_505.cv_arg") -> "RuleVariation_505":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_516:
        return self.arg # type: ignore

class Content_162(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "VRAM CRM sub-function"}

class RuleContent_162(RuleContentContextFree):
    cv_arg: TypeAlias = Content_162.cv_arg
    cv_content: TypeAlias = Content_162

    @property
    def content(self) -> Content_162:
        return self._get_content() # type: ignore

class Variation_634(Element):
    cv_arg: TypeAlias = RuleContent_162.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_162

    @classmethod
    def create(cls, arg: "Variation_634.cv_arg") -> "Variation_634":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_162:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_162:
        return self.rule.content

class RuleVariation_623(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_634.cv_arg
    cv_variation: TypeAlias = Variation_634

    @classmethod
    def create(cls, arg : "RuleVariation_623.cv_arg") -> "RuleVariation_623":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_634:
        return self.arg # type: ignore

class Content_164(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "VRAM VTM sub-function"}

class RuleContent_164(RuleContentContextFree):
    cv_arg: TypeAlias = Content_164.cv_arg
    cv_content: TypeAlias = Content_164

    @property
    def content(self) -> Content_164:
        return self._get_content() # type: ignore

class Variation_714(Element):
    cv_arg: TypeAlias = RuleContent_164.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_164

    @classmethod
    def create(cls, arg: "Variation_714.cv_arg") -> "Variation_714":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_164:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_164:
        return self.rule.content

class RuleVariation_703(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_714.cv_arg
    cv_variation: TypeAlias = Variation_714

    @classmethod
    def create(cls, arg : "RuleVariation_703.cv_arg") -> "RuleVariation_703":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_714:
        return self.arg # type: ignore

class Content_163(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "VRAM VRM sub-function"}

class RuleContent_163(RuleContentContextFree):
    cv_arg: TypeAlias = Content_163.cv_arg
    cv_content: TypeAlias = Content_163

    @property
    def content(self) -> Content_163:
        return self._get_content() # type: ignore

class Variation_841(Element):
    cv_arg: TypeAlias = RuleContent_163.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_163

    @classmethod
    def create(cls, arg: "Variation_841.cv_arg") -> "Variation_841":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_163:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_163:
        return self.rule.content

class RuleVariation_811(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_841.cv_arg
    cv_variation: TypeAlias = Variation_841

    @classmethod
    def create(cls, arg : "RuleVariation_811.cv_arg") -> "RuleVariation_811":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_841:
        return self.arg # type: ignore

class Content_101(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "HAM HD sub-function"}

class RuleContent_101(RuleContentContextFree):
    cv_arg: TypeAlias = Content_101.cv_arg
    cv_content: TypeAlias = Content_101

    @property
    def content(self) -> Content_101:
        return self._get_content() # type: ignore

class Variation_913(Element):
    cv_arg: TypeAlias = RuleContent_101.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_101

    @classmethod
    def create(cls, arg: "Variation_913.cv_arg") -> "Variation_913":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_101:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_101:
        return self.rule.content

class RuleVariation_883(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_913.cv_arg
    cv_variation: TypeAlias = Variation_913

    @classmethod
    def create(cls, arg : "RuleVariation_883.cv_arg") -> "RuleVariation_883":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_913:
        return self.arg # type: ignore

class Content_102(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "HAM RD sub-function"}

class RuleContent_102(RuleContentContextFree):
    cv_arg: TypeAlias = Content_102.cv_arg
    cv_content: TypeAlias = Content_102

    @property
    def content(self) -> Content_102:
        return self._get_content() # type: ignore

class Variation_29(Element):
    cv_arg: TypeAlias = RuleContent_102.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_102

    @classmethod
    def create(cls, arg: "Variation_29.cv_arg") -> "Variation_29":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_102:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_102:
        return self.rule.content

class RuleVariation_29(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_29.cv_arg
    cv_variation: TypeAlias = Variation_29

    @classmethod
    def create(cls, arg : "RuleVariation_29.cv_arg") -> "RuleVariation_29":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_29:
        return self.arg # type: ignore

class Content_103(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "HAM VD sub-function"}

class RuleContent_103(RuleContentContextFree):
    cv_arg: TypeAlias = Content_103.cv_arg
    cv_content: TypeAlias = Content_103

    @property
    def content(self) -> Content_103:
        return self._get_content() # type: ignore

class Variation_409(Element):
    cv_arg: TypeAlias = RuleContent_103.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_103

    @classmethod
    def create(cls, arg: "Variation_409.cv_arg") -> "Variation_409":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_103:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_103:
        return self.rule.content

class RuleVariation_398(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_409.cv_arg
    cv_variation: TypeAlias = Variation_409

    @classmethod
    def create(cls, arg : "RuleVariation_398.cv_arg") -> "RuleVariation_398":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_409:
        return self.arg # type: ignore

class Content_104(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "HVI function"}

class RuleContent_104(RuleContentContextFree):
    cv_arg: TypeAlias = Content_104.cv_arg
    cv_content: TypeAlias = Content_104

    @property
    def content(self) -> Content_104:
        return self._get_content() # type: ignore

class Variation_518(Element):
    cv_arg: TypeAlias = RuleContent_104.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_104

    @classmethod
    def create(cls, arg: "Variation_518.cv_arg") -> "Variation_518":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_104:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_104:
        return self.rule.content

class RuleVariation_507(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_518.cv_arg
    cv_variation: TypeAlias = Variation_518

    @classmethod
    def create(cls, arg : "RuleVariation_507.cv_arg") -> "RuleVariation_507":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_518:
        return self.arg # type: ignore

class Content_111(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "LTW function"}

class RuleContent_111(RuleContentContextFree):
    cv_arg: TypeAlias = Content_111.cv_arg
    cv_content: TypeAlias = Content_111

    @property
    def content(self) -> Content_111:
        return self._get_content() # type: ignore

class Variation_625(Element):
    cv_arg: TypeAlias = RuleContent_111.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_111

    @classmethod
    def create(cls, arg: "Variation_625.cv_arg") -> "Variation_625":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_111:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_111:
        return self.rule.content

class RuleVariation_614(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_625.cv_arg
    cv_variation: TypeAlias = Variation_625

    @classmethod
    def create(cls, arg : "RuleVariation_614.cv_arg") -> "RuleVariation_614":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_625:
        return self.arg # type: ignore

class Content_161(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "VPM function"}

class RuleContent_161(RuleContentContextFree):
    cv_arg: TypeAlias = Content_161.cv_arg
    cv_content: TypeAlias = Content_161

    @property
    def content(self) -> Content_161:
        return self._get_content() # type: ignore

class Variation_713(Element):
    cv_arg: TypeAlias = RuleContent_161.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_161

    @classmethod
    def create(cls, arg: "Variation_713.cv_arg") -> "Variation_713":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_161:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_161:
        return self.rule.content

class RuleVariation_702(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_713.cv_arg
    cv_variation: TypeAlias = Variation_713

    @classmethod
    def create(cls, arg : "RuleVariation_702.cv_arg") -> "RuleVariation_702":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_713:
        return self.arg # type: ignore

class Content_154(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "TTA function"}

class RuleContent_154(RuleContentContextFree):
    cv_arg: TypeAlias = Content_154.cv_arg
    cv_content: TypeAlias = Content_154

    @property
    def content(self) -> Content_154:
        return self._get_content() # type: ignore

class Variation_839(Element):
    cv_arg: TypeAlias = RuleContent_154.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_154

    @classmethod
    def create(cls, arg: "Variation_839.cv_arg") -> "Variation_839":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_154:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_154:
        return self.rule.content

class RuleVariation_809(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_839.cv_arg
    cv_variation: TypeAlias = Variation_839

    @classmethod
    def create(cls, arg : "RuleVariation_809.cv_arg") -> "RuleVariation_809":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_839:
        return self.arg # type: ignore

class Content_88(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "CRA function"}

class RuleContent_88(RuleContentContextFree):
    cv_arg: TypeAlias = Content_88.cv_arg
    cv_content: TypeAlias = Content_88

    @property
    def content(self) -> Content_88:
        return self._get_content() # type: ignore

class Variation_908(Element):
    cv_arg: TypeAlias = RuleContent_88.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_88

    @classmethod
    def create(cls, arg: "Variation_908.cv_arg") -> "Variation_908":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_88:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_88:
        return self.rule.content

class RuleVariation_878(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_908.cv_arg
    cv_variation: TypeAlias = Variation_908

    @classmethod
    def create(cls, arg : "RuleVariation_878.cv_arg") -> "RuleVariation_878":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_908:
        return self.arg # type: ignore

class Content_83(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "ASM sub-function"}

class RuleContent_83(RuleContentContextFree):
    cv_arg: TypeAlias = Content_83.cv_arg
    cv_content: TypeAlias = Content_83

    @property
    def content(self) -> Content_83:
        return self._get_content() # type: ignore

class Variation_25(Element):
    cv_arg: TypeAlias = RuleContent_83.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_83

    @classmethod
    def create(cls, arg: "Variation_25.cv_arg") -> "Variation_25":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_83:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_83:
        return self.rule.content

class RuleVariation_25(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_25.cv_arg
    cv_variation: TypeAlias = Variation_25

    @classmethod
    def create(cls, arg : "RuleVariation_25.cv_arg") -> "RuleVariation_25":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_25:
        return self.arg # type: ignore

class Content_106(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "IAVM sub-function"}

class RuleContent_106(RuleContentContextFree):
    cv_arg: TypeAlias = Content_106.cv_arg
    cv_content: TypeAlias = Content_106

    @property
    def content(self) -> Content_106:
        return self._get_content() # type: ignore

class Variation_410(Element):
    cv_arg: TypeAlias = RuleContent_106.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_106

    @classmethod
    def create(cls, arg: "Variation_410.cv_arg") -> "Variation_410":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_106:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_106:
        return self.rule.content

class RuleVariation_399(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_410.cv_arg
    cv_variation: TypeAlias = Variation_410

    @classmethod
    def create(cls, arg : "RuleVariation_399.cv_arg") -> "RuleVariation_399":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_410:
        return self.arg # type: ignore

class Content_96(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "FTD Function"}

class RuleContent_96(RuleContentContextFree):
    cv_arg: TypeAlias = Content_96.cv_arg
    cv_content: TypeAlias = Content_96

    @property
    def content(self) -> Content_96:
        return self._get_content() # type: ignore

class Variation_517(Element):
    cv_arg: TypeAlias = RuleContent_96.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_96

    @classmethod
    def create(cls, arg: "Variation_517.cv_arg") -> "Variation_517":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_96:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_96:
        return self.rule.content

class RuleVariation_506(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_517.cv_arg
    cv_variation: TypeAlias = Variation_517

    @classmethod
    def create(cls, arg : "RuleVariation_506.cv_arg") -> "RuleVariation_506":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_517:
        return self.arg # type: ignore

class Content_108(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "ITD function"}

class RuleContent_108(RuleContentContextFree):
    cv_arg: TypeAlias = Content_108.cv_arg
    cv_content: TypeAlias = Content_108

    @property
    def content(self) -> Content_108:
        return self._get_content() # type: ignore

class Variation_623(Element):
    cv_arg: TypeAlias = RuleContent_108.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_108

    @classmethod
    def create(cls, arg: "Variation_623.cv_arg") -> "Variation_623":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_108:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_108:
        return self.rule.content

class RuleVariation_612(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_623.cv_arg
    cv_variation: TypeAlias = Variation_623

    @classmethod
    def create(cls, arg : "RuleVariation_612.cv_arg") -> "RuleVariation_612":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_623:
        return self.arg # type: ignore

class Content_107(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "IIA function"}

class RuleContent_107(RuleContentContextFree):
    cv_arg: TypeAlias = Content_107.cv_arg
    cv_content: TypeAlias = Content_107

    @property
    def content(self) -> Content_107:
        return self._get_content() # type: ignore

class Variation_707(Element):
    cv_arg: TypeAlias = RuleContent_107.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_107

    @classmethod
    def create(cls, arg: "Variation_707.cv_arg") -> "Variation_707":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_107:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_107:
        return self.rule.content

class RuleVariation_696(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_707.cv_arg
    cv_variation: TypeAlias = Variation_707

    @classmethod
    def create(cls, arg : "RuleVariation_696.cv_arg") -> "RuleVariation_696":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_707:
        return self.arg # type: ignore

class Content_149(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "SQW function"}

class RuleContent_149(RuleContentContextFree):
    cv_arg: TypeAlias = Content_149.cv_arg
    cv_content: TypeAlias = Content_149

    @property
    def content(self) -> Content_149:
        return self._get_content() # type: ignore

class Variation_836(Element):
    cv_arg: TypeAlias = RuleContent_149.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_149

    @classmethod
    def create(cls, arg: "Variation_836.cv_arg") -> "Variation_836":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_149:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_149:
        return self.rule.content

class RuleVariation_806(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_836.cv_arg
    cv_variation: TypeAlias = Variation_836

    @classmethod
    def create(cls, arg : "RuleVariation_806.cv_arg") -> "RuleVariation_806":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_836:
        return self.arg # type: ignore

class Content_89(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "CUW function"}

class RuleContent_89(RuleContentContextFree):
    cv_arg: TypeAlias = Content_89.cv_arg
    cv_content: TypeAlias = Content_89

    @property
    def content(self) -> Content_89:
        return self._get_content() # type: ignore

class Variation_909(Element):
    cv_arg: TypeAlias = RuleContent_89.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_89

    @classmethod
    def create(cls, arg: "Variation_909.cv_arg") -> "Variation_909":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_89:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_89:
        return self.rule.content

class RuleVariation_879(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_909.cv_arg
    cv_variation: TypeAlias = Variation_909

    @classmethod
    def create(cls, arg : "RuleVariation_879.cv_arg") -> "RuleVariation_879":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_909:
        return self.arg # type: ignore

class Content_85(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "CATC function"}

class RuleContent_85(RuleContentContextFree):
    cv_arg: TypeAlias = Content_85.cv_arg
    cv_content: TypeAlias = Content_85

    @property
    def content(self) -> Content_85:
        return self._get_content() # type: ignore

class Variation_26(Element):
    cv_arg: TypeAlias = RuleContent_85.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_85

    @classmethod
    def create(cls, arg: "Variation_26.cv_arg") -> "Variation_26":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_85:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_85:
        return self.rule.content

class RuleVariation_26(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_26.cv_arg
    cv_variation: TypeAlias = Variation_26

    @classmethod
    def create(cls, arg : "RuleVariation_26.cv_arg") -> "RuleVariation_26":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_26:
        return self.arg # type: ignore

class Content_129(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "NOCLR sub-function"}

class RuleContent_129(RuleContentContextFree):
    cv_arg: TypeAlias = Content_129.cv_arg
    cv_content: TypeAlias = Content_129

    @property
    def content(self) -> Content_129:
        return self._get_content() # type: ignore

class Variation_414(Element):
    cv_arg: TypeAlias = RuleContent_129.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_129

    @classmethod
    def create(cls, arg: "Variation_414.cv_arg") -> "Variation_414":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_129:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_129:
        return self.rule.content

class RuleVariation_403(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_414.cv_arg
    cv_variation: TypeAlias = Variation_414

    @classmethod
    def create(cls, arg : "RuleVariation_403.cv_arg") -> "RuleVariation_403":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_414:
        return self.arg # type: ignore

class Content_131(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "NOMOV Function"}

class RuleContent_131(RuleContentContextFree):
    cv_arg: TypeAlias = Content_131.cv_arg
    cv_content: TypeAlias = Content_131

    @property
    def content(self) -> Content_131:
        return self._get_content() # type: ignore

class Variation_521(Element):
    cv_arg: TypeAlias = RuleContent_131.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_131

    @classmethod
    def create(cls, arg: "Variation_521.cv_arg") -> "Variation_521":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_131:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_131:
        return self.rule.content

class RuleVariation_510(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_521.cv_arg
    cv_variation: TypeAlias = Variation_521

    @classmethod
    def create(cls, arg : "RuleVariation_510.cv_arg") -> "RuleVariation_510":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_521:
        return self.arg # type: ignore

class Content_130(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "NOH function"}

class RuleContent_130(RuleContentContextFree):
    cv_arg: TypeAlias = Content_130.cv_arg
    cv_content: TypeAlias = Content_130

    @property
    def content(self) -> Content_130:
        return self._get_content() # type: ignore

class Variation_630(Element):
    cv_arg: TypeAlias = RuleContent_130.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_130

    @classmethod
    def create(cls, arg: "Variation_630.cv_arg") -> "Variation_630":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_130:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_130:
        return self.rule.content

class RuleVariation_619(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_630.cv_arg
    cv_variation: TypeAlias = Variation_630

    @classmethod
    def create(cls, arg : "RuleVariation_619.cv_arg") -> "RuleVariation_619":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_630:
        return self.arg # type: ignore

class Content_165(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "WRTY function"}

class RuleContent_165(RuleContentContextFree):
    cv_arg: TypeAlias = Content_165.cv_arg
    cv_content: TypeAlias = Content_165

    @property
    def content(self) -> Content_165:
        return self._get_content() # type: ignore

class Variation_715(Element):
    cv_arg: TypeAlias = RuleContent_165.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_165

    @classmethod
    def create(cls, arg: "Variation_715.cv_arg") -> "Variation_715":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_165:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_165:
        return self.rule.content

class RuleVariation_704(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_715.cv_arg
    cv_variation: TypeAlias = Variation_715

    @classmethod
    def create(cls, arg : "RuleVariation_704.cv_arg") -> "RuleVariation_704":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_715:
        return self.arg # type: ignore

class Content_151(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "STOCC function"}

class RuleContent_151(RuleContentContextFree):
    cv_arg: TypeAlias = Content_151.cv_arg
    cv_content: TypeAlias = Content_151

    @property
    def content(self) -> Content_151:
        return self._get_content() # type: ignore

class Variation_837(Element):
    cv_arg: TypeAlias = RuleContent_151.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_151

    @classmethod
    def create(cls, arg: "Variation_837.cv_arg") -> "Variation_837":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_151:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_151:
        return self.rule.content

class RuleVariation_807(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_837.cv_arg
    cv_variation: TypeAlias = Variation_837

    @classmethod
    def create(cls, arg : "RuleVariation_807.cv_arg") -> "RuleVariation_807":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_837:
        return self.arg # type: ignore

class Content_135(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "ONGOING function"}

class RuleContent_135(RuleContentContextFree):
    cv_arg: TypeAlias = Content_135.cv_arg
    cv_content: TypeAlias = Content_135

    @property
    def content(self) -> Content_135:
        return self._get_content() # type: ignore

class Variation_915(Element):
    cv_arg: TypeAlias = RuleContent_135.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_135

    @classmethod
    def create(cls, arg: "Variation_915.cv_arg") -> "Variation_915":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_135:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_135:
        return self.rule.content

class RuleVariation_885(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_915.cv_arg
    cv_variation: TypeAlias = Variation_915

    @classmethod
    def create(cls, arg : "RuleVariation_885.cv_arg") -> "RuleVariation_885":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_915:
        return self.arg # type: ignore

class NonSpare_1318(NonSpare):
    cv_arg: TypeAlias = RuleVariation_32.cv_arg
    cv_name = "MRVA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_32

    @classmethod
    def create(cls, arg : "NonSpare_1318.cv_arg") -> "NonSpare_1318":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_32:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_32:
        return self.rule.variation

class Item_584(Item):
    cv_arg: TypeAlias = NonSpare_1318.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1318

    @classmethod
    def create(cls, arg : "Item_584.cv_arg") -> "Item_584":
        return cls._create(arg) # type: ignore

class NonSpare_1547(NonSpare):
    cv_arg: TypeAlias = RuleVariation_405.cv_arg
    cv_name = "RAMLD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_405

    @classmethod
    def create(cls, arg : "NonSpare_1547.cv_arg") -> "NonSpare_1547":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_405:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_416:
        return self.rule.variation

class Item_777(Item):
    cv_arg: TypeAlias = NonSpare_1547.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1547

    @classmethod
    def create(cls, arg : "Item_777.cv_arg") -> "Item_777":
        return cls._create(arg) # type: ignore

class NonSpare_1546(NonSpare):
    cv_arg: TypeAlias = RuleVariation_513.cv_arg
    cv_name = "RAMHD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_513

    @classmethod
    def create(cls, arg : "NonSpare_1546.cv_arg") -> "NonSpare_1546":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_513:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_524:
        return self.rule.variation

class Item_776(Item):
    cv_arg: TypeAlias = NonSpare_1546.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1546

    @classmethod
    def create(cls, arg : "Item_776.cv_arg") -> "Item_776":
        return cls._create(arg) # type: ignore

class NonSpare_1323(NonSpare):
    cv_arg: TypeAlias = RuleVariation_615.cv_arg
    cv_name = "MSAW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_615

    @classmethod
    def create(cls, arg : "NonSpare_1323.cv_arg") -> "NonSpare_1323":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_615:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_626:
        return self.rule.variation

class Item_587(Item):
    cv_arg: TypeAlias = NonSpare_1323.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1323

    @classmethod
    def create(cls, arg : "Item_587.cv_arg") -> "Item_587":
        return cls._create(arg) # type: ignore

class NonSpare_619(NonSpare):
    cv_arg: TypeAlias = RuleVariation_694.cv_arg
    cv_name = "APW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_694

    @classmethod
    def create(cls, arg : "NonSpare_619.cv_arg") -> "NonSpare_619":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_694:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_705:
        return self.rule.variation

class Item_78(Item):
    cv_arg: TypeAlias = NonSpare_619.cv_arg
    cv_non_spare: TypeAlias = NonSpare_619

    @classmethod
    def create(cls, arg : "Item_78.cv_arg") -> "Item_78":
        return cls._create(arg) # type: ignore

class NonSpare_743(NonSpare):
    cv_arg: TypeAlias = RuleVariation_800.cv_arg
    cv_name = "CLAM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_800

    @classmethod
    def create(cls, arg : "NonSpare_743.cv_arg") -> "NonSpare_743":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_800:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_830:
        return self.rule.variation

class Item_162(Item):
    cv_arg: TypeAlias = NonSpare_743.cv_arg
    cv_non_spare: TypeAlias = NonSpare_743

    @classmethod
    def create(cls, arg : "Item_162.cv_arg") -> "Item_162":
        return cls._create(arg) # type: ignore

class NonSpare_1787(NonSpare):
    cv_arg: TypeAlias = RuleVariation_889.cv_arg
    cv_name = "STCA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_889

    @classmethod
    def create(cls, arg : "NonSpare_1787.cv_arg") -> "NonSpare_1787":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_889:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_919:
        return self.rule.variation

class Item_948(Item):
    cv_arg: TypeAlias = NonSpare_1787.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1787

    @classmethod
    def create(cls, arg : "Item_948.cv_arg") -> "Item_948":
        return cls._create(arg) # type: ignore

class NonSpare_618(NonSpare):
    cv_arg: TypeAlias = RuleVariation_24.cv_arg
    cv_name = "APM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_24

    @classmethod
    def create(cls, arg : "NonSpare_618.cv_arg") -> "NonSpare_618":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_24:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_24:
        return self.rule.variation

class Item_77(Item):
    cv_arg: TypeAlias = NonSpare_618.cv_arg
    cv_non_spare: TypeAlias = NonSpare_618

    @classmethod
    def create(cls, arg : "Item_77.cv_arg") -> "Item_77":
        return cls._create(arg) # type: ignore

class NonSpare_1597(NonSpare):
    cv_arg: TypeAlias = RuleVariation_406.cv_arg
    cv_name = "RIMCA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_406

    @classmethod
    def create(cls, arg : "NonSpare_1597.cv_arg") -> "NonSpare_1597":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_406:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_417:
        return self.rule.variation

class Item_822(Item):
    cv_arg: TypeAlias = NonSpare_1597.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1597

    @classmethod
    def create(cls, arg : "Item_822.cv_arg") -> "Item_822":
        return cls._create(arg) # type: ignore

class NonSpare_560(NonSpare):
    cv_arg: TypeAlias = RuleVariation_503.cv_arg
    cv_name = "ACASRA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_503

    @classmethod
    def create(cls, arg : "NonSpare_560.cv_arg") -> "NonSpare_560":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_503:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_514:
        return self.rule.variation

class Item_40(Item):
    cv_arg: TypeAlias = NonSpare_560.cv_arg
    cv_non_spare: TypeAlias = NonSpare_560

    @classmethod
    def create(cls, arg : "Item_40.cv_arg") -> "Item_40":
        return cls._create(arg) # type: ignore

class NonSpare_1381(NonSpare):
    cv_arg: TypeAlias = RuleVariation_620.cv_arg
    cv_name = "NTCA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_620

    @classmethod
    def create(cls, arg : "NonSpare_1381.cv_arg") -> "NonSpare_1381":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_620:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_631:
        return self.rule.variation

class Item_640(Item):
    cv_arg: TypeAlias = NonSpare_1381.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1381

    @classmethod
    def create(cls, arg : "Item_640.cv_arg") -> "Item_640":
        return cls._create(arg) # type: ignore

class NonSpare_883(NonSpare):
    cv_arg: TypeAlias = RuleVariation_700.cv_arg
    cv_name = "DG"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_700

    @classmethod
    def create(cls, arg : "NonSpare_883.cv_arg") -> "NonSpare_883":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_700:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_711:
        return self.rule.variation

class Item_260(Item):
    cv_arg: TypeAlias = NonSpare_883.cv_arg
    cv_non_spare: TypeAlias = NonSpare_883

    @classmethod
    def create(cls, arg : "Item_260.cv_arg") -> "Item_260":
        return cls._create(arg) # type: ignore

class NonSpare_1396(NonSpare):
    cv_arg: TypeAlias = RuleVariation_804.cv_arg
    cv_name = "OF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_804

    @classmethod
    def create(cls, arg : "NonSpare_1396.cv_arg") -> "NonSpare_1396":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_804:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_834:
        return self.rule.variation

class Item_655(Item):
    cv_arg: TypeAlias = NonSpare_1396.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1396

    @classmethod
    def create(cls, arg : "Item_655.cv_arg") -> "Item_655":
        return cls._create(arg) # type: ignore

class NonSpare_1397(NonSpare):
    cv_arg: TypeAlias = RuleVariation_886.cv_arg
    cv_name = "OL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_886

    @classmethod
    def create(cls, arg : "NonSpare_1397.cv_arg") -> "NonSpare_1397":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_886:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_916:
        return self.rule.variation

class Item_656(Item):
    cv_arg: TypeAlias = NonSpare_1397.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1397

    @classmethod
    def create(cls, arg : "Item_656.cv_arg") -> "Item_656":
        return cls._create(arg) # type: ignore

class NonSpare_589(NonSpare):
    cv_arg: TypeAlias = RuleVariation_23.cv_arg
    cv_name = "AIW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_23

    @classmethod
    def create(cls, arg : "NonSpare_589.cv_arg") -> "NonSpare_589":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_23:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_23:
        return self.rule.variation

class Item_56(Item):
    cv_arg: TypeAlias = NonSpare_589.cv_arg
    cv_non_spare: TypeAlias = NonSpare_589

    @classmethod
    def create(cls, arg : "Item_56.cv_arg") -> "Item_56":
        return cls._create(arg) # type: ignore

class NonSpare_1421(NonSpare):
    cv_arg: TypeAlias = RuleVariation_404.cv_arg
    cv_name = "PAIW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_404

    @classmethod
    def create(cls, arg : "NonSpare_1421.cv_arg") -> "NonSpare_1421":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_404:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_415:
        return self.rule.variation

class Item_678(Item):
    cv_arg: TypeAlias = NonSpare_1421.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1421

    @classmethod
    def create(cls, arg : "Item_678.cv_arg") -> "Item_678":
        return cls._create(arg) # type: ignore

class NonSpare_1390(NonSpare):
    cv_arg: TypeAlias = RuleVariation_511.cv_arg
    cv_name = "OCAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_511

    @classmethod
    def create(cls, arg : "NonSpare_1390.cv_arg") -> "NonSpare_1390":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_511:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_522:
        return self.rule.variation

class Item_649(Item):
    cv_arg: TypeAlias = NonSpare_1390.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1390

    @classmethod
    def create(cls, arg : "Item_649.cv_arg") -> "Item_649":
        return cls._create(arg) # type: ignore

class NonSpare_1661(NonSpare):
    cv_arg: TypeAlias = RuleVariation_621.cv_arg
    cv_name = "SAM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_621

    @classmethod
    def create(cls, arg : "NonSpare_1661.cv_arg") -> "NonSpare_1661":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_621:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_632:
        return self.rule.variation

class Item_859(Item):
    cv_arg: TypeAlias = NonSpare_1661.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1661

    @classmethod
    def create(cls, arg : "Item_859.cv_arg") -> "Item_859":
        return cls._create(arg) # type: ignore

class NonSpare_2028(NonSpare):
    cv_arg: TypeAlias = RuleVariation_701.cv_arg
    cv_name = "VCD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_701

    @classmethod
    def create(cls, arg : "NonSpare_2028.cv_arg") -> "NonSpare_2028":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_701:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_712:
        return self.rule.variation

class Item_1138(Item):
    cv_arg: TypeAlias = NonSpare_2028.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2028

    @classmethod
    def create(cls, arg : "Item_1138.cv_arg") -> "Item_1138":
        return cls._create(arg) # type: ignore

class NonSpare_733(NonSpare):
    cv_arg: TypeAlias = RuleVariation_799.cv_arg
    cv_name = "CHAM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_799

    @classmethod
    def create(cls, arg : "NonSpare_733.cv_arg") -> "NonSpare_733":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_799:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_829:
        return self.rule.variation

class Item_155(Item):
    cv_arg: TypeAlias = NonSpare_733.cv_arg
    cv_non_spare: TypeAlias = NonSpare_733

    @classmethod
    def create(cls, arg : "Item_155.cv_arg") -> "Item_155":
        return cls._create(arg) # type: ignore

class NonSpare_903(NonSpare):
    cv_arg: TypeAlias = RuleVariation_880.cv_arg
    cv_name = "DSAM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_880

    @classmethod
    def create(cls, arg : "NonSpare_903.cv_arg") -> "NonSpare_903":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_880:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_910:
        return self.rule.variation

class Item_276(Item):
    cv_arg: TypeAlias = NonSpare_903.cv_arg
    cv_non_spare: TypeAlias = NonSpare_903

    @classmethod
    def create(cls, arg : "Item_276.cv_arg") -> "Item_276":
        return cls._create(arg) # type: ignore

class NonSpare_865(NonSpare):
    cv_arg: TypeAlias = RuleVariation_27.cv_arg
    cv_name = "DBPSMARR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_27

    @classmethod
    def create(cls, arg : "NonSpare_865.cv_arg") -> "NonSpare_865":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_27:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_27:
        return self.rule.variation

class Item_243(Item):
    cv_arg: TypeAlias = NonSpare_865.cv_arg
    cv_non_spare: TypeAlias = NonSpare_865

    @classmethod
    def create(cls, arg : "Item_243.cv_arg") -> "Item_243":
        return cls._create(arg) # type: ignore

class NonSpare_867(NonSpare):
    cv_arg: TypeAlias = RuleVariation_395.cv_arg
    cv_name = "DBPSMDEP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_395

    @classmethod
    def create(cls, arg : "NonSpare_867.cv_arg") -> "NonSpare_867":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_395:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_406:
        return self.rule.variation

class Item_245(Item):
    cv_arg: TypeAlias = NonSpare_867.cv_arg
    cv_non_spare: TypeAlias = NonSpare_867

    @classmethod
    def create(cls, arg : "Item_245.cv_arg") -> "Item_245":
        return cls._create(arg) # type: ignore

class NonSpare_869(NonSpare):
    cv_arg: TypeAlias = RuleVariation_505.cv_arg
    cv_name = "DBPSMTL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_505

    @classmethod
    def create(cls, arg : "NonSpare_869.cv_arg") -> "NonSpare_869":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_505:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_516:
        return self.rule.variation

class Item_247(Item):
    cv_arg: TypeAlias = NonSpare_869.cv_arg
    cv_non_spare: TypeAlias = NonSpare_869

    @classmethod
    def create(cls, arg : "Item_247.cv_arg") -> "Item_247":
        return cls._create(arg) # type: ignore

class NonSpare_2040(NonSpare):
    cv_arg: TypeAlias = RuleVariation_623.cv_arg
    cv_name = "VRAMCRM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_623

    @classmethod
    def create(cls, arg : "NonSpare_2040.cv_arg") -> "NonSpare_2040":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_623:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_634:
        return self.rule.variation

class Item_1149(Item):
    cv_arg: TypeAlias = NonSpare_2040.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2040

    @classmethod
    def create(cls, arg : "Item_1149.cv_arg") -> "Item_1149":
        return cls._create(arg) # type: ignore

class NonSpare_2043(NonSpare):
    cv_arg: TypeAlias = RuleVariation_703.cv_arg
    cv_name = "VRAMVTM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_703

    @classmethod
    def create(cls, arg : "NonSpare_2043.cv_arg") -> "NonSpare_2043":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_703:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_714:
        return self.rule.variation

class Item_1152(Item):
    cv_arg: TypeAlias = NonSpare_2043.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2043

    @classmethod
    def create(cls, arg : "Item_1152.cv_arg") -> "Item_1152":
        return cls._create(arg) # type: ignore

class NonSpare_2042(NonSpare):
    cv_arg: TypeAlias = RuleVariation_811.cv_arg
    cv_name = "VRAMVRM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_811

    @classmethod
    def create(cls, arg : "NonSpare_2042.cv_arg") -> "NonSpare_2042":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_811:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_841:
        return self.rule.variation

class Item_1151(Item):
    cv_arg: TypeAlias = NonSpare_2042.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2042

    @classmethod
    def create(cls, arg : "Item_1151.cv_arg") -> "Item_1151":
        return cls._create(arg) # type: ignore

class NonSpare_1054(NonSpare):
    cv_arg: TypeAlias = RuleVariation_883.cv_arg
    cv_name = "HAMHD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_883

    @classmethod
    def create(cls, arg : "NonSpare_1054.cv_arg") -> "NonSpare_1054":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_883:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_913:
        return self.rule.variation

class Item_382(Item):
    cv_arg: TypeAlias = NonSpare_1054.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1054

    @classmethod
    def create(cls, arg : "Item_382.cv_arg") -> "Item_382":
        return cls._create(arg) # type: ignore

class NonSpare_1056(NonSpare):
    cv_arg: TypeAlias = RuleVariation_29.cv_arg
    cv_name = "HAMRD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_29

    @classmethod
    def create(cls, arg : "NonSpare_1056.cv_arg") -> "NonSpare_1056":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_29:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_29:
        return self.rule.variation

class Item_384(Item):
    cv_arg: TypeAlias = NonSpare_1056.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1056

    @classmethod
    def create(cls, arg : "Item_384.cv_arg") -> "Item_384":
        return cls._create(arg) # type: ignore

class NonSpare_1058(NonSpare):
    cv_arg: TypeAlias = RuleVariation_398.cv_arg
    cv_name = "HAMVD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_398

    @classmethod
    def create(cls, arg : "NonSpare_1058.cv_arg") -> "NonSpare_1058":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_398:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_409:
        return self.rule.variation

class Item_386(Item):
    cv_arg: TypeAlias = NonSpare_1058.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1058

    @classmethod
    def create(cls, arg : "Item_386.cv_arg") -> "Item_386":
        return cls._create(arg) # type: ignore

class NonSpare_1085(NonSpare):
    cv_arg: TypeAlias = RuleVariation_507.cv_arg
    cv_name = "HVI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_507

    @classmethod
    def create(cls, arg : "NonSpare_1085.cv_arg") -> "NonSpare_1085":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_507:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_518:
        return self.rule.variation

class Item_407(Item):
    cv_arg: TypeAlias = NonSpare_1085.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1085

    @classmethod
    def create(cls, arg : "Item_407.cv_arg") -> "Item_407":
        return cls._create(arg) # type: ignore

class NonSpare_1202(NonSpare):
    cv_arg: TypeAlias = RuleVariation_614.cv_arg
    cv_name = "LTW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_614

    @classmethod
    def create(cls, arg : "NonSpare_1202.cv_arg") -> "NonSpare_1202":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_614:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_625:
        return self.rule.variation

class Item_510(Item):
    cv_arg: TypeAlias = NonSpare_1202.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1202

    @classmethod
    def create(cls, arg : "Item_510.cv_arg") -> "Item_510":
        return cls._create(arg) # type: ignore

class NonSpare_2038(NonSpare):
    cv_arg: TypeAlias = RuleVariation_702.cv_arg
    cv_name = "VPM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_702

    @classmethod
    def create(cls, arg : "NonSpare_2038.cv_arg") -> "NonSpare_2038":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_702:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_713:
        return self.rule.variation

class Item_1147(Item):
    cv_arg: TypeAlias = NonSpare_2038.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2038

    @classmethod
    def create(cls, arg : "Item_1147.cv_arg") -> "Item_1147":
        return cls._create(arg) # type: ignore

class NonSpare_1946(NonSpare):
    cv_arg: TypeAlias = RuleVariation_809.cv_arg
    cv_name = "TTA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_809

    @classmethod
    def create(cls, arg : "NonSpare_1946.cv_arg") -> "NonSpare_1946":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_809:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_839:
        return self.rule.variation

class Item_1061(Item):
    cv_arg: TypeAlias = NonSpare_1946.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1946

    @classmethod
    def create(cls, arg : "Item_1061.cv_arg") -> "Item_1061":
        return cls._create(arg) # type: ignore

class NonSpare_828(NonSpare):
    cv_arg: TypeAlias = RuleVariation_878.cv_arg
    cv_name = "CRA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_878

    @classmethod
    def create(cls, arg : "NonSpare_828.cv_arg") -> "NonSpare_828":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_878:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_908:
        return self.rule.variation

class Item_214(Item):
    cv_arg: TypeAlias = NonSpare_828.cv_arg
    cv_non_spare: TypeAlias = NonSpare_828

    @classmethod
    def create(cls, arg : "Item_214.cv_arg") -> "Item_214":
        return cls._create(arg) # type: ignore

class NonSpare_638(NonSpare):
    cv_arg: TypeAlias = RuleVariation_25.cv_arg
    cv_name = "ASM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_25

    @classmethod
    def create(cls, arg : "NonSpare_638.cv_arg") -> "NonSpare_638":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_25:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_25:
        return self.rule.variation

class Item_87(Item):
    cv_arg: TypeAlias = NonSpare_638.cv_arg
    cv_non_spare: TypeAlias = NonSpare_638

    @classmethod
    def create(cls, arg : "Item_87.cv_arg") -> "Item_87":
        return cls._create(arg) # type: ignore

class NonSpare_1105(NonSpare):
    cv_arg: TypeAlias = RuleVariation_399.cv_arg
    cv_name = "IAVM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_399

    @classmethod
    def create(cls, arg : "NonSpare_1105.cv_arg") -> "NonSpare_1105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_399:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_410:
        return self.rule.variation

class Item_423(Item):
    cv_arg: TypeAlias = NonSpare_1105.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1105

    @classmethod
    def create(cls, arg : "Item_423.cv_arg") -> "Item_423":
        return cls._create(arg) # type: ignore

class NonSpare_1005(NonSpare):
    cv_arg: TypeAlias = RuleVariation_506.cv_arg
    cv_name = "FTD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_506

    @classmethod
    def create(cls, arg : "NonSpare_1005.cv_arg") -> "NonSpare_1005":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_506:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_517:
        return self.rule.variation

class Item_351(Item):
    cv_arg: TypeAlias = NonSpare_1005.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1005

    @classmethod
    def create(cls, arg : "Item_351.cv_arg") -> "Item_351":
        return cls._create(arg) # type: ignore

class NonSpare_1129(NonSpare):
    cv_arg: TypeAlias = RuleVariation_612.cv_arg
    cv_name = "ITD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_612

    @classmethod
    def create(cls, arg : "NonSpare_1129.cv_arg") -> "NonSpare_1129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_612:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_623:
        return self.rule.variation

class Item_441(Item):
    cv_arg: TypeAlias = NonSpare_1129.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1129

    @classmethod
    def create(cls, arg : "Item_441.cv_arg") -> "Item_441":
        return cls._create(arg) # type: ignore

class NonSpare_1120(NonSpare):
    cv_arg: TypeAlias = RuleVariation_696.cv_arg
    cv_name = "IIA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_696

    @classmethod
    def create(cls, arg : "NonSpare_1120.cv_arg") -> "NonSpare_1120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_696:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_707:
        return self.rule.variation

class Item_434(Item):
    cv_arg: TypeAlias = NonSpare_1120.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1120

    @classmethod
    def create(cls, arg : "Item_434.cv_arg") -> "Item_434":
        return cls._create(arg) # type: ignore

class NonSpare_1744(NonSpare):
    cv_arg: TypeAlias = RuleVariation_806.cv_arg
    cv_name = "SQW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_806

    @classmethod
    def create(cls, arg : "NonSpare_1744.cv_arg") -> "NonSpare_1744":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_806:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_836:
        return self.rule.variation

class Item_917(Item):
    cv_arg: TypeAlias = NonSpare_1744.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1744

    @classmethod
    def create(cls, arg : "Item_917.cv_arg") -> "Item_917":
        return cls._create(arg) # type: ignore

class NonSpare_851(NonSpare):
    cv_arg: TypeAlias = RuleVariation_879.cv_arg
    cv_name = "CUW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_879

    @classmethod
    def create(cls, arg : "NonSpare_851.cv_arg") -> "NonSpare_851":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_879:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_909:
        return self.rule.variation

class Item_232(Item):
    cv_arg: TypeAlias = NonSpare_851.cv_arg
    cv_non_spare: TypeAlias = NonSpare_851

    @classmethod
    def create(cls, arg : "Item_232.cv_arg") -> "Item_232":
        return cls._create(arg) # type: ignore

class NonSpare_707(NonSpare):
    cv_arg: TypeAlias = RuleVariation_26.cv_arg
    cv_name = "CATC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_26

    @classmethod
    def create(cls, arg : "NonSpare_707.cv_arg") -> "NonSpare_707":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_26:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_26:
        return self.rule.variation

class Item_137(Item):
    cv_arg: TypeAlias = NonSpare_707.cv_arg
    cv_non_spare: TypeAlias = NonSpare_707

    @classmethod
    def create(cls, arg : "Item_137.cv_arg") -> "Item_137":
        return cls._create(arg) # type: ignore

class NonSpare_1363(NonSpare):
    cv_arg: TypeAlias = RuleVariation_403.cv_arg
    cv_name = "NOCLR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_403

    @classmethod
    def create(cls, arg : "NonSpare_1363.cv_arg") -> "NonSpare_1363":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_403:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_414:
        return self.rule.variation

class Item_623(Item):
    cv_arg: TypeAlias = NonSpare_1363.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1363

    @classmethod
    def create(cls, arg : "Item_623.cv_arg") -> "Item_623":
        return cls._create(arg) # type: ignore

class NonSpare_1376(NonSpare):
    cv_arg: TypeAlias = RuleVariation_510.cv_arg
    cv_name = "NOMOV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_510

    @classmethod
    def create(cls, arg : "NonSpare_1376.cv_arg") -> "NonSpare_1376":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_510:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_521:
        return self.rule.variation

class Item_636(Item):
    cv_arg: TypeAlias = NonSpare_1376.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1376

    @classmethod
    def create(cls, arg : "Item_636.cv_arg") -> "Item_636":
        return cls._create(arg) # type: ignore

class NonSpare_1371(NonSpare):
    cv_arg: TypeAlias = RuleVariation_619.cv_arg
    cv_name = "NOH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_619

    @classmethod
    def create(cls, arg : "NonSpare_1371.cv_arg") -> "NonSpare_1371":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_619:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_630:
        return self.rule.variation

class Item_631(Item):
    cv_arg: TypeAlias = NonSpare_1371.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1371

    @classmethod
    def create(cls, arg : "Item_631.cv_arg") -> "Item_631":
        return cls._create(arg) # type: ignore

class NonSpare_2064(NonSpare):
    cv_arg: TypeAlias = RuleVariation_704.cv_arg
    cv_name = "WRTY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_704

    @classmethod
    def create(cls, arg : "NonSpare_2064.cv_arg") -> "NonSpare_2064":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_704:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_715:
        return self.rule.variation

class Item_1168(Item):
    cv_arg: TypeAlias = NonSpare_2064.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2064

    @classmethod
    def create(cls, arg : "Item_1168.cv_arg") -> "Item_1168":
        return cls._create(arg) # type: ignore

class NonSpare_1794(NonSpare):
    cv_arg: TypeAlias = RuleVariation_807.cv_arg
    cv_name = "STOCC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_807

    @classmethod
    def create(cls, arg : "NonSpare_1794.cv_arg") -> "NonSpare_1794":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_807:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_837:
        return self.rule.variation

class Item_954(Item):
    cv_arg: TypeAlias = NonSpare_1794.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1794

    @classmethod
    def create(cls, arg : "Item_954.cv_arg") -> "Item_954":
        return cls._create(arg) # type: ignore

class NonSpare_1399(NonSpare):
    cv_arg: TypeAlias = RuleVariation_885.cv_arg
    cv_name = "ONGOING"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_885

    @classmethod
    def create(cls, arg : "NonSpare_1399.cv_arg") -> "NonSpare_1399":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_885:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_915:
        return self.rule.variation

class Item_658(Item):
    cv_arg: TypeAlias = NonSpare_1399.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1399

    @classmethod
    def create(cls, arg : "Item_658.cv_arg") -> "Item_658":
        return cls._create(arg) # type: ignore

class Variation_1371(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_32.cv_arg, Tuple[Literal["MRVA"], RuleVariation_32.cv_arg]], Union[RuleVariation_405.cv_arg, Tuple[Literal["RAMLD"], RuleVariation_405.cv_arg]], Union[RuleVariation_513.cv_arg, Tuple[Literal["RAMHD"], RuleVariation_513.cv_arg]], Union[RuleVariation_615.cv_arg, Tuple[Literal["MSAW"], RuleVariation_615.cv_arg]], Union[RuleVariation_694.cv_arg, Tuple[Literal["APW"], RuleVariation_694.cv_arg]], Union[RuleVariation_800.cv_arg, Tuple[Literal["CLAM"], RuleVariation_800.cv_arg]], Union[RuleVariation_889.cv_arg, Tuple[Literal["STCA"], RuleVariation_889.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_24.cv_arg, Tuple[Literal["APM"], RuleVariation_24.cv_arg]], Union[RuleVariation_406.cv_arg, Tuple[Literal["RIMCA"], RuleVariation_406.cv_arg]], Union[RuleVariation_503.cv_arg, Tuple[Literal["ACASRA"], RuleVariation_503.cv_arg]], Union[RuleVariation_620.cv_arg, Tuple[Literal["NTCA"], RuleVariation_620.cv_arg]], Union[RuleVariation_700.cv_arg, Tuple[Literal["DG"], RuleVariation_700.cv_arg]], Union[RuleVariation_804.cv_arg, Tuple[Literal["OF"], RuleVariation_804.cv_arg]], Union[RuleVariation_886.cv_arg, Tuple[Literal["OL"], RuleVariation_886.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_23.cv_arg, Tuple[Literal["AIW"], RuleVariation_23.cv_arg]], Union[RuleVariation_404.cv_arg, Tuple[Literal["PAIW"], RuleVariation_404.cv_arg]], Union[RuleVariation_511.cv_arg, Tuple[Literal["OCAT"], RuleVariation_511.cv_arg]], Union[RuleVariation_621.cv_arg, Tuple[Literal["SAM"], RuleVariation_621.cv_arg]], Union[RuleVariation_701.cv_arg, Tuple[Literal["VCD"], RuleVariation_701.cv_arg]], Union[RuleVariation_799.cv_arg, Tuple[Literal["CHAM"], RuleVariation_799.cv_arg]], Union[RuleVariation_880.cv_arg, Tuple[Literal["DSAM"], RuleVariation_880.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_27.cv_arg, Tuple[Literal["DBPSMARR"], RuleVariation_27.cv_arg]], Union[RuleVariation_395.cv_arg, Tuple[Literal["DBPSMDEP"], RuleVariation_395.cv_arg]], Union[RuleVariation_505.cv_arg, Tuple[Literal["DBPSMTL"], RuleVariation_505.cv_arg]], Union[RuleVariation_623.cv_arg, Tuple[Literal["VRAMCRM"], RuleVariation_623.cv_arg]], Union[RuleVariation_703.cv_arg, Tuple[Literal["VRAMVTM"], RuleVariation_703.cv_arg]], Union[RuleVariation_811.cv_arg, Tuple[Literal["VRAMVRM"], RuleVariation_811.cv_arg]], Union[RuleVariation_883.cv_arg, Tuple[Literal["HAMHD"], RuleVariation_883.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_29.cv_arg, Tuple[Literal["HAMRD"], RuleVariation_29.cv_arg]], Union[RuleVariation_398.cv_arg, Tuple[Literal["HAMVD"], RuleVariation_398.cv_arg]], Union[RuleVariation_507.cv_arg, Tuple[Literal["HVI"], RuleVariation_507.cv_arg]], Union[RuleVariation_614.cv_arg, Tuple[Literal["LTW"], RuleVariation_614.cv_arg]], Union[RuleVariation_702.cv_arg, Tuple[Literal["VPM"], RuleVariation_702.cv_arg]], Union[RuleVariation_809.cv_arg, Tuple[Literal["TTA"], RuleVariation_809.cv_arg]], Union[RuleVariation_878.cv_arg, Tuple[Literal["CRA"], RuleVariation_878.cv_arg]], None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_25.cv_arg, Tuple[Literal["ASM"], RuleVariation_25.cv_arg]], Union[RuleVariation_399.cv_arg, Tuple[Literal["IAVM"], RuleVariation_399.cv_arg]], Union[RuleVariation_506.cv_arg, Tuple[Literal["FTD"], RuleVariation_506.cv_arg]], Union[RuleVariation_612.cv_arg, Tuple[Literal["ITD"], RuleVariation_612.cv_arg]], Union[RuleVariation_696.cv_arg, Tuple[Literal["IIA"], RuleVariation_696.cv_arg]], Union[RuleVariation_806.cv_arg, Tuple[Literal["SQW"], RuleVariation_806.cv_arg]], Union[RuleVariation_879.cv_arg, Tuple[Literal["CUW"], RuleVariation_879.cv_arg]], None]]
    cv_arg_group_7: TypeAlias = Union[int, Tuple[Union[RuleVariation_26.cv_arg, Tuple[Literal["CATC"], RuleVariation_26.cv_arg]], Union[RuleVariation_403.cv_arg, Tuple[Literal["NOCLR"], RuleVariation_403.cv_arg]], Union[RuleVariation_510.cv_arg, Tuple[Literal["NOMOV"], RuleVariation_510.cv_arg]], Union[RuleVariation_619.cv_arg, Tuple[Literal["NOH"], RuleVariation_619.cv_arg]], Union[RuleVariation_704.cv_arg, Tuple[Literal["WRTY"], RuleVariation_704.cv_arg]], Union[RuleVariation_807.cv_arg, Tuple[Literal["STOCC"], RuleVariation_807.cv_arg]], Union[RuleVariation_885.cv_arg, Tuple[Literal["ONGOING"], RuleVariation_885.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1371.cv_arg_group_1"],
        Tuple["Variation_1371.cv_arg_group_1", "Variation_1371.cv_arg_group_2"],
        Tuple["Variation_1371.cv_arg_group_1", "Variation_1371.cv_arg_group_2", "Variation_1371.cv_arg_group_3"],
        Tuple["Variation_1371.cv_arg_group_1", "Variation_1371.cv_arg_group_2", "Variation_1371.cv_arg_group_3", "Variation_1371.cv_arg_group_4"],
        Tuple["Variation_1371.cv_arg_group_1", "Variation_1371.cv_arg_group_2", "Variation_1371.cv_arg_group_3", "Variation_1371.cv_arg_group_4", "Variation_1371.cv_arg_group_5"],
        Tuple["Variation_1371.cv_arg_group_1", "Variation_1371.cv_arg_group_2", "Variation_1371.cv_arg_group_3", "Variation_1371.cv_arg_group_4", "Variation_1371.cv_arg_group_5", "Variation_1371.cv_arg_group_6"],
        Tuple["Variation_1371.cv_arg_group_1", "Variation_1371.cv_arg_group_2", "Variation_1371.cv_arg_group_3", "Variation_1371.cv_arg_group_4", "Variation_1371.cv_arg_group_5", "Variation_1371.cv_arg_group_6", "Variation_1371.cv_arg_group_7"],
    ]
    cv_items_list = [[(Item_584, 1), (Item_777, 1), (Item_776, 1), (Item_587, 1), (Item_78, 1), (Item_162, 1), (Item_948, 1), None], [(Item_77, 1), (Item_822, 1), (Item_40, 1), (Item_640, 1), (Item_260, 1), (Item_655, 1), (Item_656, 1), None], [(Item_56, 1), (Item_678, 1), (Item_649, 1), (Item_859, 1), (Item_1138, 1), (Item_155, 1), (Item_276, 1), None], [(Item_243, 1), (Item_245, 1), (Item_247, 1), (Item_1149, 1), (Item_1152, 1), (Item_1151, 1), (Item_382, 1), None], [(Item_384, 1), (Item_386, 1), (Item_407, 1), (Item_510, 1), (Item_1147, 1), (Item_1061, 1), (Item_214, 1), None], [(Item_87, 1), (Item_423, 1), (Item_351, 1), (Item_441, 1), (Item_434, 1), (Item_917, 1), (Item_232, 1), None], [(Item_137, 1), (Item_623, 1), (Item_636, 1), (Item_631, 1), (Item_1168, 1), (Item_954, 1), (Item_658, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1371.cv_arg") -> 'Variation_1371':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MRVA"]) -> RuleVariation_32:
        ...
    @overload
    def get_item(self, key : Literal["RAMLD"]) -> RuleVariation_405:
        ...
    @overload
    def get_item(self, key : Literal["RAMHD"]) -> RuleVariation_513:
        ...
    @overload
    def get_item(self, key : Literal["MSAW"]) -> RuleVariation_615:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> RuleVariation_694:
        ...
    @overload
    def get_item(self, key : Literal["CLAM"]) -> RuleVariation_800:
        ...
    @overload
    def get_item(self, key : Literal["STCA"]) -> RuleVariation_889:
        ...
    @overload
    def get_item(self, key : Literal["APM"]) -> Optional[RuleVariation_24]:
        ...
    @overload
    def get_item(self, key : Literal["RIMCA"]) -> Optional[RuleVariation_406]:
        ...
    @overload
    def get_item(self, key : Literal["ACASRA"]) -> Optional[RuleVariation_503]:
        ...
    @overload
    def get_item(self, key : Literal["NTCA"]) -> Optional[RuleVariation_620]:
        ...
    @overload
    def get_item(self, key : Literal["DG"]) -> Optional[RuleVariation_700]:
        ...
    @overload
    def get_item(self, key : Literal["OF"]) -> Optional[RuleVariation_804]:
        ...
    @overload
    def get_item(self, key : Literal["OL"]) -> Optional[RuleVariation_886]:
        ...
    @overload
    def get_item(self, key : Literal["AIW"]) -> Optional[RuleVariation_23]:
        ...
    @overload
    def get_item(self, key : Literal["PAIW"]) -> Optional[RuleVariation_404]:
        ...
    @overload
    def get_item(self, key : Literal["OCAT"]) -> Optional[RuleVariation_511]:
        ...
    @overload
    def get_item(self, key : Literal["SAM"]) -> Optional[RuleVariation_621]:
        ...
    @overload
    def get_item(self, key : Literal["VCD"]) -> Optional[RuleVariation_701]:
        ...
    @overload
    def get_item(self, key : Literal["CHAM"]) -> Optional[RuleVariation_799]:
        ...
    @overload
    def get_item(self, key : Literal["DSAM"]) -> Optional[RuleVariation_880]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMARR"]) -> Optional[RuleVariation_27]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMDEP"]) -> Optional[RuleVariation_395]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMTL"]) -> Optional[RuleVariation_505]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMCRM"]) -> Optional[RuleVariation_623]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVTM"]) -> Optional[RuleVariation_703]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVRM"]) -> Optional[RuleVariation_811]:
        ...
    @overload
    def get_item(self, key : Literal["HAMHD"]) -> Optional[RuleVariation_883]:
        ...
    @overload
    def get_item(self, key : Literal["HAMRD"]) -> Optional[RuleVariation_29]:
        ...
    @overload
    def get_item(self, key : Literal["HAMVD"]) -> Optional[RuleVariation_398]:
        ...
    @overload
    def get_item(self, key : Literal["HVI"]) -> Optional[RuleVariation_507]:
        ...
    @overload
    def get_item(self, key : Literal["LTW"]) -> Optional[RuleVariation_614]:
        ...
    @overload
    def get_item(self, key : Literal["VPM"]) -> Optional[RuleVariation_702]:
        ...
    @overload
    def get_item(self, key : Literal["TTA"]) -> Optional[RuleVariation_809]:
        ...
    @overload
    def get_item(self, key : Literal["CRA"]) -> Optional[RuleVariation_878]:
        ...
    @overload
    def get_item(self, key : Literal["ASM"]) -> Optional[RuleVariation_25]:
        ...
    @overload
    def get_item(self, key : Literal["IAVM"]) -> Optional[RuleVariation_399]:
        ...
    @overload
    def get_item(self, key : Literal["FTD"]) -> Optional[RuleVariation_506]:
        ...
    @overload
    def get_item(self, key : Literal["ITD"]) -> Optional[RuleVariation_612]:
        ...
    @overload
    def get_item(self, key : Literal["IIA"]) -> Optional[RuleVariation_696]:
        ...
    @overload
    def get_item(self, key : Literal["SQW"]) -> Optional[RuleVariation_806]:
        ...
    @overload
    def get_item(self, key : Literal["CUW"]) -> Optional[RuleVariation_879]:
        ...
    @overload
    def get_item(self, key : Literal["CATC"]) -> Optional[RuleVariation_26]:
        ...
    @overload
    def get_item(self, key : Literal["NOCLR"]) -> Optional[RuleVariation_403]:
        ...
    @overload
    def get_item(self, key : Literal["NOMOV"]) -> Optional[RuleVariation_510]:
        ...
    @overload
    def get_item(self, key : Literal["NOH"]) -> Optional[RuleVariation_619]:
        ...
    @overload
    def get_item(self, key : Literal["WRTY"]) -> Optional[RuleVariation_704]:
        ...
    @overload
    def get_item(self, key : Literal["STOCC"]) -> Optional[RuleVariation_807]:
        ...
    @overload
    def get_item(self, key : Literal["ONGOING"]) -> Optional[RuleVariation_885]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1292(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1371.cv_arg
    cv_variation: TypeAlias = Variation_1371

    @classmethod
    def create(cls, arg : "RuleVariation_1292.cv_arg") -> "RuleVariation_1292":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1371:
        return self.arg # type: ignore

class NonSpare_195(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1292.cv_arg
    cv_name = "060"
    cv_title = "Safety Net Function and System Status"
    cv_rule: TypeAlias = RuleVariation_1292

    @classmethod
    def create(cls, arg : "NonSpare_195.cv_arg") -> "NonSpare_195":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1371:
        return self.rule.variation

class UapItem_195(UapItem):
    cv_non_spare: TypeAlias = NonSpare_195

class NonSpare_114(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "030"
    cv_title = "Track Number 1"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_114.cv_arg") -> "NonSpare_114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_114(UapItem):
    cv_non_spare: TypeAlias = NonSpare_114

class Content_609(ContentString):
    cv_arg: TypeAlias = Union[int, str]
    cv_string_type: TypeAlias = StringAscii

class RuleContent_609(RuleContentContextFree):
    cv_arg: TypeAlias = Content_609.cv_arg
    cv_content: TypeAlias = Content_609

    @property
    def content(self) -> Content_609:
        return self._get_content() # type: ignore

class Variation_393(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_393.cv_arg") -> "Variation_393":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_385(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_393.cv_arg
    cv_variation: TypeAlias = Variation_393

    @classmethod
    def create(cls, arg : "RuleVariation_385.cv_arg") -> "RuleVariation_385":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_393:
        return self.arg # type: ignore

class NonSpare_586(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "AI1"
    cv_title = "Aircraft Identifier (in 7 Characters) of Aircraft 1 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_586.cv_arg") -> "NonSpare_586":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1307(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE3A"
    cv_title = "Mode-3/A Code (Converted Into Octal Representation) of Aircraft 1 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1307.cv_arg") -> "NonSpare_1307":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_573(Item):
    cv_arg: TypeAlias = NonSpare_1307.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1307

    @classmethod
    def create(cls, arg : "Item_573.cv_arg") -> "Item_573":
        return cls._create(arg) # type: ignore

class Variation_1027(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1027.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_573, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1027.cv_arg") -> 'Variation_1027':
        return cls._create(arg) # type: ignore

class RuleVariation_996(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1027.cv_arg
    cv_variation: TypeAlias = Variation_1027

    @classmethod
    def create(cls, arg : "RuleVariation_996.cv_arg") -> "RuleVariation_996":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1027:
        return self.arg # type: ignore

class NonSpare_1214(NonSpare):
    cv_arg: TypeAlias = RuleVariation_996.cv_arg
    cv_name = "M31"
    cv_title = "Mode 3/A Code Aircraft 1"
    cv_rule: TypeAlias = RuleVariation_996

    @classmethod
    def create(cls, arg : "NonSpare_1214.cv_arg") -> "NonSpare_1214":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_996:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1027:
        return self.rule.variation

class Content_699(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 5.364418029785156e-6
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_699(RuleContentContextFree):
    cv_arg: TypeAlias = Content_699.cv_arg
    cv_content: TypeAlias = Content_699

    @property
    def content(self) -> Content_699:
        return self._get_content() # type: ignore

class Variation_378(Element):
    cv_arg: TypeAlias = RuleContent_699.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_699

    @classmethod
    def create(cls, arg: "Variation_378.cv_arg") -> "Variation_378":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_699:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_699:
        return self.rule.content

class RuleVariation_371(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_378.cv_arg
    cv_variation: TypeAlias = Variation_378

    @classmethod
    def create(cls, arg : "RuleVariation_371.cv_arg") -> "RuleVariation_371":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_378:
        return self.arg # type: ignore

class NonSpare_1159(NonSpare):
    cv_arg: TypeAlias = RuleVariation_371.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude in WGS-84 in Two’s Complement"
    cv_rule: TypeAlias = RuleVariation_371

    @classmethod
    def create(cls, arg : "NonSpare_1159.cv_arg") -> "NonSpare_1159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_371:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_378:
        return self.rule.variation

class Item_471(Item):
    cv_arg: TypeAlias = NonSpare_1159.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1159

    @classmethod
    def create(cls, arg : "Item_471.cv_arg") -> "Item_471":
        return cls._create(arg) # type: ignore

class Content_698(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 5.364418029785156e-6
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_698(RuleContentContextFree):
    cv_arg: TypeAlias = Content_698.cv_arg
    cv_content: TypeAlias = Content_698

    @property
    def content(self) -> Content_698:
        return self._get_content() # type: ignore

class Variation_377(Element):
    cv_arg: TypeAlias = RuleContent_698.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_698

    @classmethod
    def create(cls, arg: "Variation_377.cv_arg") -> "Variation_377":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_698:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_698:
        return self.rule.content

class RuleVariation_370(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_377.cv_arg
    cv_variation: TypeAlias = Variation_377

    @classmethod
    def create(cls, arg : "RuleVariation_370.cv_arg") -> "RuleVariation_370":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_377:
        return self.arg # type: ignore

class NonSpare_1189(NonSpare):
    cv_arg: TypeAlias = RuleVariation_370.cv_arg
    cv_name = "LON"
    cv_title = "Longitude in WGS-84 in Two’s Complement"
    cv_rule: TypeAlias = RuleVariation_370

    @classmethod
    def create(cls, arg : "NonSpare_1189.cv_arg") -> "NonSpare_1189":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_370:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_377:
        return self.rule.variation

class Item_499(Item):
    cv_arg: TypeAlias = NonSpare_1189.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1189

    @classmethod
    def create(cls, arg : "Item_499.cv_arg") -> "Item_499":
        return cls._create(arg) # type: ignore

class Content_634(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_634(RuleContentContextFree):
    cv_arg: TypeAlias = Content_634.cv_arg
    cv_content: TypeAlias = Content_634

    @property
    def content(self) -> Content_634:
        return self._get_content() # type: ignore

class Variation_263(Element):
    cv_arg: TypeAlias = RuleContent_634.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_634

    @classmethod
    def create(cls, arg: "Variation_263.cv_arg") -> "Variation_263":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_634:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_634:
        return self.rule.content

class RuleVariation_256(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_263.cv_arg
    cv_variation: TypeAlias = Variation_263

    @classmethod
    def create(cls, arg : "RuleVariation_256.cv_arg") -> "RuleVariation_256":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_263:
        return self.arg # type: ignore

class NonSpare_596(NonSpare):
    cv_arg: TypeAlias = RuleVariation_256.cv_arg
    cv_name = "ALT"
    cv_title = "Altitude of Predicted Conflict"
    cv_rule: TypeAlias = RuleVariation_256

    @classmethod
    def create(cls, arg : "NonSpare_596.cv_arg") -> "NonSpare_596":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_256:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_263:
        return self.rule.variation

class Item_63(Item):
    cv_arg: TypeAlias = NonSpare_596.cv_arg
    cv_non_spare: TypeAlias = NonSpare_596

    @classmethod
    def create(cls, arg : "Item_63.cv_arg") -> "Item_63":
        return cls._create(arg) # type: ignore

class Variation_1135(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_371.cv_arg, Tuple[Literal["LAT"], RuleVariation_371.cv_arg]], Union[RuleVariation_370.cv_arg, Tuple[Literal["LON"], RuleVariation_370.cv_arg]], Union[RuleVariation_256.cv_arg, Tuple[Literal["ALT"], RuleVariation_256.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1135.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 80
    cv_items_list = [(Item_471, 32), (Item_499, 32), (Item_63, 16)]
    cv_items_dict = {"LAT": RuleVariation_371, "LON": RuleVariation_370, "ALT": RuleVariation_256}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_370:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_256:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_370:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_256:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1135.cv_arg") -> 'Variation_1135':
        return cls._create(arg) # type: ignore

class RuleVariation_1091(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1135.cv_arg
    cv_variation: TypeAlias = Variation_1135

    @classmethod
    def create(cls, arg : "RuleVariation_1091.cv_arg") -> "RuleVariation_1091":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1135:
        return self.arg # type: ignore

class NonSpare_824(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1091.cv_arg
    cv_name = "CPW"
    cv_title = "Predicted Conflict Position Target 1 in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1091

    @classmethod
    def create(cls, arg : "NonSpare_824.cv_arg") -> "NonSpare_824":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1091:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1135:
        return self.rule.variation

class Content_639(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_639(RuleContentContextFree):
    cv_arg: TypeAlias = Content_639.cv_arg
    cv_content: TypeAlias = Content_639

    @property
    def content(self) -> Content_639:
        return self._get_content() # type: ignore

class Variation_352(Element):
    cv_arg: TypeAlias = RuleContent_639.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_639

    @classmethod
    def create(cls, arg: "Variation_352.cv_arg") -> "Variation_352":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_639:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_639:
        return self.rule.content

class RuleVariation_345(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_352.cv_arg
    cv_variation: TypeAlias = Variation_352

    @classmethod
    def create(cls, arg : "RuleVariation_345.cv_arg") -> "RuleVariation_345":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_352:
        return self.arg # type: ignore

class NonSpare_2093(NonSpare):
    cv_arg: TypeAlias = RuleVariation_345.cv_arg
    cv_name = "X"
    cv_title = "Starting X-position of the Conflict"
    cv_rule: TypeAlias = RuleVariation_345

    @classmethod
    def create(cls, arg : "NonSpare_2093.cv_arg") -> "NonSpare_2093":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_352:
        return self.rule.variation

class Item_1194(Item):
    cv_arg: TypeAlias = NonSpare_2093.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2093

    @classmethod
    def create(cls, arg : "Item_1194.cv_arg") -> "Item_1194":
        return cls._create(arg) # type: ignore

class NonSpare_2146(NonSpare):
    cv_arg: TypeAlias = RuleVariation_345.cv_arg
    cv_name = "Y"
    cv_title = "Starting Y-position of the Conflict"
    cv_rule: TypeAlias = RuleVariation_345

    @classmethod
    def create(cls, arg : "NonSpare_2146.cv_arg") -> "NonSpare_2146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_352:
        return self.rule.variation

class Item_1244(Item):
    cv_arg: TypeAlias = NonSpare_2146.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2146

    @classmethod
    def create(cls, arg : "Item_1244.cv_arg") -> "Item_1244":
        return cls._create(arg) # type: ignore

class NonSpare_2164(NonSpare):
    cv_arg: TypeAlias = RuleVariation_256.cv_arg
    cv_name = "Z"
    cv_title = "Starting Z-position of the Conflict"
    cv_rule: TypeAlias = RuleVariation_256

    @classmethod
    def create(cls, arg : "NonSpare_2164.cv_arg") -> "NonSpare_2164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_256:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_263:
        return self.rule.variation

class Item_1262(Item):
    cv_arg: TypeAlias = NonSpare_2164.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2164

    @classmethod
    def create(cls, arg : "Item_1262.cv_arg") -> "Item_1262":
        return cls._create(arg) # type: ignore

class Variation_1307(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_345.cv_arg, Tuple[Literal["X"], RuleVariation_345.cv_arg]], Union[RuleVariation_345.cv_arg, Tuple[Literal["Y"], RuleVariation_345.cv_arg]], Union[RuleVariation_256.cv_arg, Tuple[Literal["Z"], RuleVariation_256.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1307.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_1194, 24), (Item_1244, 24), (Item_1262, 16)]
    cv_items_dict = {"X": RuleVariation_345, "Y": RuleVariation_345, "Z": RuleVariation_256}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Z"]) -> RuleVariation_256:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["Z"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_345:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_345:
        ...
    @overload
    def get_item(self, key : Literal["Z"]) -> RuleVariation_256:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1307.cv_arg") -> 'Variation_1307':
        return cls._create(arg) # type: ignore

class RuleVariation_1236(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1307.cv_arg
    cv_variation: TypeAlias = Variation_1307

    @classmethod
    def create(cls, arg : "RuleVariation_1236.cv_arg") -> "RuleVariation_1236":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1307:
        return self.arg # type: ignore

class NonSpare_819(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1236.cv_arg
    cv_name = "CPC"
    cv_title = "Predicted Conflict Position for the Aircraft 1 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_1236

    @classmethod
    def create(cls, arg : "NonSpare_819.cv_arg") -> "NonSpare_819":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1307:
        return self.rule.variation

class NonSpare_1944(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "TT1"
    cv_title = "Time to Runway Threshold for First Approaching Aircraft in a RIMCA"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_1944.cv_arg") -> "NonSpare_1944":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class Content_732(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_732(RuleContentContextFree):
    cv_arg: TypeAlias = Content_732.cv_arg
    cv_content: TypeAlias = Content_732

    @property
    def content(self) -> Content_732:
        return self._get_content() # type: ignore

class Variation_311(Element):
    cv_arg: TypeAlias = RuleContent_732.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_732

    @classmethod
    def create(cls, arg: "Variation_311.cv_arg") -> "Variation_311":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_732:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_732:
        return self.rule.content

class RuleVariation_304(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_311.cv_arg
    cv_variation: TypeAlias = Variation_311

    @classmethod
    def create(cls, arg : "RuleVariation_304.cv_arg") -> "RuleVariation_304":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_311:
        return self.arg # type: ignore

class NonSpare_905(NonSpare):
    cv_arg: TypeAlias = RuleVariation_304.cv_arg
    cv_name = "DT1"
    cv_title = "Distance to Runway Threshold for Aircraft 1 Involved in a RIMCA"
    cv_rule: TypeAlias = RuleVariation_304

    @classmethod
    def create(cls, arg : "NonSpare_905.cv_arg") -> "NonSpare_905":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

class Content_548(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "General Air Traffic", 2: "Operational Air Traffic", 3: "Not applicable"}

class RuleContent_548(RuleContentContextFree):
    cv_arg: TypeAlias = Content_548.cv_arg
    cv_content: TypeAlias = Content_548

    @property
    def content(self) -> Content_548:
        return self._get_content() # type: ignore

class Variation_116(Element):
    cv_arg: TypeAlias = RuleContent_548.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_548

    @classmethod
    def create(cls, arg: "Variation_116.cv_arg") -> "Variation_116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_548:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_548:
        return self.rule.content

class RuleVariation_116(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_116.cv_arg
    cv_variation: TypeAlias = Variation_116

    @classmethod
    def create(cls, arg : "RuleVariation_116.cv_arg") -> "RuleVariation_116":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_116:
        return self.arg # type: ignore

class Content_246(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Instrument Flight Rules", 1: "Visual Flight rules", 2: "Not applicable", 3: "Controlled Visual Flight Rules"}

class RuleContent_246(RuleContentContextFree):
    cv_arg: TypeAlias = Content_246.cv_arg
    cv_content: TypeAlias = Content_246

    @property
    def content(self) -> Content_246:
        return self._get_content() # type: ignore

class Variation_592(Element):
    cv_arg: TypeAlias = RuleContent_246.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_246

    @classmethod
    def create(cls, arg: "Variation_592.cv_arg") -> "Variation_592":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_246:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_246:
        return self.rule.content

class RuleVariation_581(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_592.cv_arg
    cv_variation: TypeAlias = Variation_592

    @classmethod
    def create(cls, arg : "RuleVariation_581.cv_arg") -> "RuleVariation_581":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_592:
        return self.arg # type: ignore

class Content_541(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Approved", 2: "Exempt", 3: "Not Approved"}

class RuleContent_541(RuleContentContextFree):
    cv_arg: TypeAlias = Content_541.cv_arg
    cv_content: TypeAlias = Content_541

    @property
    def content(self) -> Content_541:
        return self._get_content() # type: ignore

class Variation_769(Element):
    cv_arg: TypeAlias = RuleContent_541.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_541

    @classmethod
    def create(cls, arg: "Variation_769.cv_arg") -> "Variation_769":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_541:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_541:
        return self.rule.content

class RuleVariation_758(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_769.cv_arg
    cv_variation: TypeAlias = Variation_769

    @classmethod
    def create(cls, arg : "RuleVariation_758.cv_arg") -> "RuleVariation_758":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_769:
        return self.arg # type: ignore

class Content_383(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Normal Priority Flight", 1: "High Priority Flight"}

class RuleContent_383(RuleContentContextFree):
    cv_arg: TypeAlias = Content_383.cv_arg
    cv_content: TypeAlias = Content_383

    @property
    def content(self) -> Content_383:
        return self._get_content() # type: ignore

class Variation_942(Element):
    cv_arg: TypeAlias = RuleContent_383.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_383

    @classmethod
    def create(cls, arg: "Variation_942.cv_arg") -> "Variation_942":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_383:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_383:
        return self.rule.content

class RuleVariation_912(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_942.cv_arg
    cv_variation: TypeAlias = Variation_942

    @classmethod
    def create(cls, arg : "RuleVariation_912.cv_arg") -> "RuleVariation_912":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_942:
        return self.arg # type: ignore

class Content_263(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Maintaining", 1: "Climbing", 2: "Descending", 3: "Invalid"}

class RuleContent_263(RuleContentContextFree):
    cv_arg: TypeAlias = Content_263.cv_arg
    cv_content: TypeAlias = Content_263

    @property
    def content(self) -> Content_263:
        return self._get_content() # type: ignore

class Variation_104(Element):
    cv_arg: TypeAlias = RuleContent_263.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_263

    @classmethod
    def create(cls, arg: "Variation_104.cv_arg") -> "Variation_104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_263:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_263:
        return self.rule.content

class RuleVariation_104(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_104.cv_arg
    cv_variation: TypeAlias = Variation_104

    @classmethod
    def create(cls, arg : "RuleVariation_104.cv_arg") -> "RuleVariation_104":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_104:
        return self.arg # type: ignore

class Content_378(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Non primary target", 1: "Primary target"}

class RuleContent_378(RuleContentContextFree):
    cv_arg: TypeAlias = Content_378.cv_arg
    cv_content: TypeAlias = Content_378

    @property
    def content(self) -> Content_378:
        return self._get_content() # type: ignore

class Variation_565(Element):
    cv_arg: TypeAlias = RuleContent_378.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_378

    @classmethod
    def create(cls, arg: "Variation_565.cv_arg") -> "Variation_565":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_378:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_378:
        return self.rule.content

class RuleVariation_554(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_565.cv_arg
    cv_variation: TypeAlias = Variation_565

    @classmethod
    def create(cls, arg : "RuleVariation_554.cv_arg") -> "RuleVariation_554":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_565:
        return self.arg # type: ignore

class Content_100(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Ground Vehicle"}

class RuleContent_100(RuleContentContextFree):
    cv_arg: TypeAlias = Content_100.cv_arg
    cv_content: TypeAlias = Content_100

    @property
    def content(self) -> Content_100:
        return self._get_content() # type: ignore

class Variation_622(Element):
    cv_arg: TypeAlias = RuleContent_100.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_100

    @classmethod
    def create(cls, arg: "Variation_622.cv_arg") -> "Variation_622":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_100:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_100:
        return self.rule.content

class RuleVariation_611(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_622.cv_arg
    cv_variation: TypeAlias = Variation_622

    @classmethod
    def create(cls, arg : "RuleVariation_611.cv_arg") -> "RuleVariation_611":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_622:
        return self.arg # type: ignore

class NonSpare_1026(NonSpare):
    cv_arg: TypeAlias = RuleVariation_116.cv_arg
    cv_name = "GATOAT"
    cv_title = "Identification of Conflict Categories Definition Table"
    cv_rule: TypeAlias = RuleVariation_116

    @classmethod
    def create(cls, arg : "NonSpare_1026.cv_arg") -> "NonSpare_1026":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_116:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_116:
        return self.rule.variation

class Item_364(Item):
    cv_arg: TypeAlias = NonSpare_1026.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1026

    @classmethod
    def create(cls, arg : "Item_364.cv_arg") -> "Item_364":
        return cls._create(arg) # type: ignore

class NonSpare_995(NonSpare):
    cv_arg: TypeAlias = RuleVariation_581.cv_arg
    cv_name = "FR1FR2"
    cv_title = "Flight Rules"
    cv_rule: TypeAlias = RuleVariation_581

    @classmethod
    def create(cls, arg : "NonSpare_995.cv_arg") -> "NonSpare_995":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_581:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_592:
        return self.rule.variation

class Item_344(Item):
    cv_arg: TypeAlias = NonSpare_995.cv_arg
    cv_non_spare: TypeAlias = NonSpare_995

    @classmethod
    def create(cls, arg : "Item_344.cv_arg") -> "Item_344":
        return cls._create(arg) # type: ignore

class NonSpare_1638(NonSpare):
    cv_arg: TypeAlias = RuleVariation_758.cv_arg
    cv_name = "RVSM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_758

    @classmethod
    def create(cls, arg : "NonSpare_1638.cv_arg") -> "NonSpare_1638":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_758:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_769:
        return self.rule.variation

class Item_843(Item):
    cv_arg: TypeAlias = NonSpare_1638.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1638

    @classmethod
    def create(cls, arg : "Item_843.cv_arg") -> "Item_843":
        return cls._create(arg) # type: ignore

class NonSpare_1077(NonSpare):
    cv_arg: TypeAlias = RuleVariation_912.cv_arg
    cv_name = "HPR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_912

    @classmethod
    def create(cls, arg : "NonSpare_1077.cv_arg") -> "NonSpare_1077":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_912:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_942:
        return self.rule.variation

class Item_401(Item):
    cv_arg: TypeAlias = NonSpare_1077.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1077

    @classmethod
    def create(cls, arg : "Item_401.cv_arg") -> "Item_401":
        return cls._create(arg) # type: ignore

class NonSpare_716(NonSpare):
    cv_arg: TypeAlias = RuleVariation_104.cv_arg
    cv_name = "CDM"
    cv_title = "Climbing/Descending Mode"
    cv_rule: TypeAlias = RuleVariation_104

    @classmethod
    def create(cls, arg : "NonSpare_716.cv_arg") -> "NonSpare_716":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_104:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_104:
        return self.rule.variation

class Item_142(Item):
    cv_arg: TypeAlias = NonSpare_716.cv_arg
    cv_non_spare: TypeAlias = NonSpare_716

    @classmethod
    def create(cls, arg : "Item_142.cv_arg") -> "Item_142":
        return cls._create(arg) # type: ignore

class NonSpare_1465(NonSpare):
    cv_arg: TypeAlias = RuleVariation_554.cv_arg
    cv_name = "PRI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_554

    @classmethod
    def create(cls, arg : "NonSpare_1465.cv_arg") -> "NonSpare_1465":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_554:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_565:
        return self.rule.variation

class Item_708(Item):
    cv_arg: TypeAlias = NonSpare_1465.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1465

    @classmethod
    def create(cls, arg : "Item_708.cv_arg") -> "Item_708":
        return cls._create(arg) # type: ignore

class NonSpare_1046(NonSpare):
    cv_arg: TypeAlias = RuleVariation_611.cv_arg
    cv_name = "GV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_611

    @classmethod
    def create(cls, arg : "NonSpare_1046.cv_arg") -> "NonSpare_1046":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_611:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_622:
        return self.rule.variation

class Item_379(Item):
    cv_arg: TypeAlias = NonSpare_1046.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1046

    @classmethod
    def create(cls, arg : "Item_379.cv_arg") -> "Item_379":
        return cls._create(arg) # type: ignore

class Item_21(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 4
    cv_bit_size = 3

class Variation_1362(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_116.cv_arg, Tuple[Literal["GATOAT"], RuleVariation_116.cv_arg]], Union[RuleVariation_581.cv_arg, Tuple[Literal["FR1FR2"], RuleVariation_581.cv_arg]], Union[RuleVariation_758.cv_arg, Tuple[Literal["RVSM"], RuleVariation_758.cv_arg]], Union[RuleVariation_912.cv_arg, Tuple[Literal["HPR"], RuleVariation_912.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_104.cv_arg, Tuple[Literal["CDM"], RuleVariation_104.cv_arg]], Union[RuleVariation_554.cv_arg, Tuple[Literal["PRI"], RuleVariation_554.cv_arg]], Union[RuleVariation_611.cv_arg, Tuple[Literal["GV"], RuleVariation_611.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1362.cv_arg_group_1"],
        Tuple["Variation_1362.cv_arg_group_1", "Variation_1362.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_364, 2), (Item_344, 2), (Item_843, 2), (Item_401, 1), None], [(Item_142, 2), (Item_708, 1), (Item_379, 1), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1362.cv_arg") -> 'Variation_1362':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_581:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> Optional[RuleVariation_104]:
        ...
    @overload
    def get_item(self, key : Literal["PRI"]) -> Optional[RuleVariation_554]:
        ...
    @overload
    def get_item(self, key : Literal["GV"]) -> Optional[RuleVariation_611]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1283(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1362.cv_arg
    cv_variation: TypeAlias = Variation_1362

    @classmethod
    def create(cls, arg : "RuleVariation_1283.cv_arg") -> "RuleVariation_1283":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1362:
        return self.arg # type: ignore

class NonSpare_558(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1283.cv_arg
    cv_name = "AC1"
    cv_title = "Characteristics of Aircraft 1 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_1283

    @classmethod
    def create(cls, arg : "NonSpare_558.cv_arg") -> "NonSpare_558":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1362:
        return self.rule.variation

class Content_610(ContentString):
    cv_arg: TypeAlias = Union[int, str]
    cv_string_type: TypeAlias = StringICAO

class RuleContent_610(RuleContentContextFree):
    cv_arg: TypeAlias = Content_610.cv_arg
    cv_content: TypeAlias = Content_610

    @property
    def content(self) -> Content_610:
        return self._get_content() # type: ignore

class Variation_391(Element):
    cv_arg: TypeAlias = RuleContent_610.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_rule = RuleContent_610

    @classmethod
    def create(cls, arg: "Variation_391.cv_arg") -> "Variation_391":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_610:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_610:
        return self.rule.content

class RuleVariation_383(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_391.cv_arg
    cv_variation: TypeAlias = Variation_391

    @classmethod
    def create(cls, arg : "RuleVariation_383.cv_arg") -> "RuleVariation_383":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_391:
        return self.arg # type: ignore

class NonSpare_1321(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "MS1"
    cv_title = "Aircraft Identification Downloaded from Aircraft 1 Involved in the Conflict If Equipped with a Mode-S Transponder"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_1321.cv_arg") -> "NonSpare_1321":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class Item_4(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 5

class Content_710(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

class RuleContent_710(RuleContentContextFree):
    cv_arg: TypeAlias = Content_710.cv_arg
    cv_content: TypeAlias = Content_710

    @property
    def content(self) -> Content_710:
        return self._get_content() # type: ignore

class Variation_898(Element):
    cv_arg: TypeAlias = RuleContent_710.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 27
    cv_rule = RuleContent_710

    @classmethod
    def create(cls, arg: "Variation_898.cv_arg") -> "Variation_898":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_710:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_710:
        return self.rule.content

class RuleVariation_868(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_898.cv_arg
    cv_variation: TypeAlias = Variation_898

    @classmethod
    def create(cls, arg : "RuleVariation_868.cv_arg") -> "RuleVariation_868":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_898:
        return self.arg # type: ignore

class NonSpare_1352(NonSpare):
    cv_arg: TypeAlias = RuleVariation_868.cv_arg
    cv_name = "NBR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_868

    @classmethod
    def create(cls, arg : "NonSpare_1352.cv_arg") -> "NonSpare_1352":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_868:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_898:
        return self.rule.variation

class Item_612(Item):
    cv_arg: TypeAlias = NonSpare_1352.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1352

    @classmethod
    def create(cls, arg : "Item_612.cv_arg") -> "Item_612":
        return cls._create(arg) # type: ignore

class Variation_1038(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_868.cv_arg, Tuple[Literal["NBR"], RuleVariation_868.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1038.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_4, 5), (Item_612, 27)]
    cv_items_dict = {"NBR": RuleVariation_868}

    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_868:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["NBR"]) -> RuleVariation_868:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1038.cv_arg") -> 'Variation_1038':
        return cls._create(arg) # type: ignore

class RuleVariation_1006(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1038.cv_arg
    cv_variation: TypeAlias = Variation_1038

    @classmethod
    def create(cls, arg : "RuleVariation_1006.cv_arg") -> "RuleVariation_1006":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1038:
        return self.arg # type: ignore

class NonSpare_986(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1006.cv_arg
    cv_name = "FP1"
    cv_title = "Number of the Flight Plan Correlated to Aircraft 1 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_1006

    @classmethod
    def create(cls, arg : "NonSpare_986.cv_arg") -> "NonSpare_986":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1006:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1038:
        return self.rule.variation

class Content_752(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_751(RuleContentContextFree):
    cv_arg: TypeAlias = Content_752.cv_arg
    cv_content: TypeAlias = Content_752

    @property
    def content(self) -> Content_752:
        return self._get_content() # type: ignore

class Variation_321(Element):
    cv_arg: TypeAlias = RuleContent_751.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_751

    @classmethod
    def create(cls, arg: "Variation_321.cv_arg") -> "Variation_321":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_751:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_752:
        return self.rule.content

class RuleVariation_314(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_321.cv_arg
    cv_variation: TypeAlias = Variation_321

    @classmethod
    def create(cls, arg : "RuleVariation_314.cv_arg") -> "RuleVariation_314":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_321:
        return self.arg # type: ignore

class NonSpare_725(NonSpare):
    cv_arg: TypeAlias = RuleVariation_314.cv_arg
    cv_name = "CF1"
    cv_title = "Cleared Flight Level for Aircraft 1 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_314

    @classmethod
    def create(cls, arg : "NonSpare_725.cv_arg") -> "NonSpare_725":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_321:
        return self.rule.variation

class Variation_1469(Compound):
    cv_arg = TypedDict('cv_arg', {
        "AI1": NonSpare_586.cv_arg,
        "M31": NonSpare_1214.cv_arg,
        "CPW": NonSpare_824.cv_arg,
        "CPC": NonSpare_819.cv_arg,
        "TT1": NonSpare_1944.cv_arg,
        "DT1": NonSpare_905.cv_arg,
        "AC1": NonSpare_558.cv_arg,
        "MS1": NonSpare_1321.cv_arg,
        "FP1": NonSpare_986.cv_arg,
        "CF1": NonSpare_725.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_586, NonSpare_1214, NonSpare_824, NonSpare_819, NonSpare_1944, NonSpare_905, NonSpare_558, NonSpare_1321, NonSpare_986, NonSpare_725]
    cv_items_dict = {"AI1": NonSpare_586, "M31": NonSpare_1214, "CPW": NonSpare_824, "CPC": NonSpare_819, "TT1": NonSpare_1944, "DT1": NonSpare_905, "AC1": NonSpare_558, "MS1": NonSpare_1321, "FP1": NonSpare_986, "CF1": NonSpare_725}

    @overload
    @classmethod
    def spec(cls, key : Literal["AI1"]) -> NonSpare_586:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M31"]) -> NonSpare_1214:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPW"]) -> NonSpare_824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> NonSpare_819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TT1"]) -> NonSpare_1944:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DT1"]) -> NonSpare_905:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC1"]) -> NonSpare_558:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MS1"]) -> NonSpare_1321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FP1"]) -> NonSpare_986:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CF1"]) -> NonSpare_725:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AI1"], Literal["M31"], Literal["CPW"], Literal["CPC"], Literal["TT1"], Literal["DT1"], Literal["AC1"], Literal["MS1"], Literal["FP1"], Literal["CF1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AI1"]) -> Optional[NonSpare_586]:
        ...
    @overload
    def get_item(self, key : Literal["M31"]) -> Optional[NonSpare_1214]:
        ...
    @overload
    def get_item(self, key : Literal["CPW"]) -> Optional[NonSpare_824]:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> Optional[NonSpare_819]:
        ...
    @overload
    def get_item(self, key : Literal["TT1"]) -> Optional[NonSpare_1944]:
        ...
    @overload
    def get_item(self, key : Literal["DT1"]) -> Optional[NonSpare_905]:
        ...
    @overload
    def get_item(self, key : Literal["AC1"]) -> Optional[NonSpare_558]:
        ...
    @overload
    def get_item(self, key : Literal["MS1"]) -> Optional[NonSpare_1321]:
        ...
    @overload
    def get_item(self, key : Literal["FP1"]) -> Optional[NonSpare_986]:
        ...
    @overload
    def get_item(self, key : Literal["CF1"]) -> Optional[NonSpare_725]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AI1"], val : NonSpare_586.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["M31"], val : NonSpare_1214.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["CPW"], val : NonSpare_824.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["CPC"], val : NonSpare_819.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["TT1"], val : NonSpare_1944.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["DT1"], val : NonSpare_905.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["AC1"], val : NonSpare_558.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["MS1"], val : NonSpare_1321.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["FP1"], val : NonSpare_986.cv_arg) -> "Variation_1469":
        ...
    @overload
    def set_item(self, key : Literal["CF1"], val : NonSpare_725.cv_arg) -> "Variation_1469":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AI1"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["M31"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["CPW"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["CPC"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["TT1"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["DT1"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["AC1"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["MS1"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["FP1"]) -> "Variation_1469":
        ...
    @overload
    def del_item(self, key : Literal["CF1"]) -> "Variation_1469":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1469.cv_arg") -> 'Variation_1469':
        return cls._create(arg) # type: ignore

class RuleVariation_1390(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1469.cv_arg
    cv_variation: TypeAlias = Variation_1469

    @classmethod
    def create(cls, arg : "RuleVariation_1390.cv_arg") -> "RuleVariation_1390":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1469:
        return self.arg # type: ignore

class NonSpare_370(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1390.cv_arg
    cv_name = "170"
    cv_title = "Aircraft Identification and Characteristics 1"
    cv_rule: TypeAlias = RuleVariation_1390

    @classmethod
    def create(cls, arg : "NonSpare_370.cv_arg") -> "NonSpare_370":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1390:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1469:
        return self.rule.variation

class UapItem_370(UapItem):
    cv_non_spare: TypeAlias = NonSpare_370

class Content_66(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Conflict not predicted to occur in military airspace", 1: "Conflict predicted to occur in military airspace"}

class RuleContent_66(RuleContentContextFree):
    cv_arg: TypeAlias = Content_66.cv_arg
    cv_content: TypeAlias = Content_66

    @property
    def content(self) -> Content_66:
        return self._get_content() # type: ignore

class Variation_20(Element):
    cv_arg: TypeAlias = RuleContent_66.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_66

    @classmethod
    def create(cls, arg: "Variation_20.cv_arg") -> "Variation_20":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_66:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_66:
        return self.rule.content

class RuleVariation_20(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_20.cv_arg
    cv_variation: TypeAlias = Variation_20

    @classmethod
    def create(cls, arg : "RuleVariation_20.cv_arg") -> "RuleVariation_20":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_20:
        return self.arg # type: ignore

class Content_65(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Conflict not predicted to occur in civil airspace", 1: "Conflict predicted to occur in civil airspace"}

class RuleContent_65(RuleContentContextFree):
    cv_arg: TypeAlias = Content_65.cv_arg
    cv_content: TypeAlias = Content_65

    @property
    def content(self) -> Content_65:
        return self._get_content() # type: ignore

class Variation_404(Element):
    cv_arg: TypeAlias = RuleContent_65.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_65

    @classmethod
    def create(cls, arg: "Variation_404.cv_arg") -> "Variation_404":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_65:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_65:
        return self.rule.content

class RuleVariation_393(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_404.cv_arg
    cv_variation: TypeAlias = Variation_404

    @classmethod
    def create(cls, arg : "RuleVariation_393.cv_arg") -> "RuleVariation_393":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_404:
        return self.arg # type: ignore

class Content_25(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft are not fast diverging laterally at current time", 1: "Aircraft are fast diverging laterally at current time"}

class RuleContent_25(RuleContentContextFree):
    cv_arg: TypeAlias = Content_25.cv_arg
    cv_content: TypeAlias = Content_25

    @property
    def content(self) -> Content_25:
        return self._get_content() # type: ignore

class Variation_509(Element):
    cv_arg: TypeAlias = RuleContent_25.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_25

    @classmethod
    def create(cls, arg: "Variation_509.cv_arg") -> "Variation_509":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_25:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_25:
        return self.rule.content

class RuleVariation_498(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_509.cv_arg
    cv_variation: TypeAlias = Variation_509

    @classmethod
    def create(cls, arg : "RuleVariation_498.cv_arg") -> "RuleVariation_498":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_509:
        return self.arg # type: ignore

class Content_26(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft are not fast diverging vertically at current time", 1: "Aircraft are fast diverging vertically at current time"}

class RuleContent_26(RuleContentContextFree):
    cv_arg: TypeAlias = Content_26.cv_arg
    cv_content: TypeAlias = Content_26

    @property
    def content(self) -> Content_26:
        return self._get_content() # type: ignore

class Variation_616(Element):
    cv_arg: TypeAlias = RuleContent_26.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_26

    @classmethod
    def create(cls, arg: "Variation_616.cv_arg") -> "Variation_616":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_26:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_26:
        return self.rule.content

class RuleVariation_605(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_616.cv_arg
    cv_variation: TypeAlias = Variation_616

    @classmethod
    def create(cls, arg : "RuleVariation_605.cv_arg") -> "RuleVariation_605":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_616:
        return self.arg # type: ignore

class Content_270(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Minor separation infringement", 1: "Major separation infringement"}

class RuleContent_270(RuleContentContextFree):
    cv_arg: TypeAlias = Content_270.cv_arg
    cv_content: TypeAlias = Content_270

    @property
    def content(self) -> Content_270:
        return self._get_content() # type: ignore

class Variation_732(Element):
    cv_arg: TypeAlias = RuleContent_270.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_270

    @classmethod
    def create(cls, arg: "Variation_732.cv_arg") -> "Variation_732":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_270:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_270:
        return self.rule.content

class RuleVariation_721(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_732.cv_arg
    cv_variation: TypeAlias = Variation_732

    @classmethod
    def create(cls, arg : "RuleVariation_721.cv_arg") -> "RuleVariation_721":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_732:
        return self.arg # type: ignore

class Content_28(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft have not crossed at starting time of conflict", 1: "Aircraft have crossed at starting time of conflict"}

class RuleContent_28(RuleContentContextFree):
    cv_arg: TypeAlias = Content_28.cv_arg
    cv_content: TypeAlias = Content_28

    @property
    def content(self) -> Content_28:
        return self._get_content() # type: ignore

class Variation_821(Element):
    cv_arg: TypeAlias = RuleContent_28.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_28

    @classmethod
    def create(cls, arg: "Variation_821.cv_arg") -> "Variation_821":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_28:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_28:
        return self.rule.content

class RuleVariation_791(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_821.cv_arg
    cv_variation: TypeAlias = Variation_821

    @classmethod
    def create(cls, arg : "RuleVariation_791.cv_arg") -> "RuleVariation_791":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_821:
        return self.arg # type: ignore

class Content_24(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft are not diverging at starting time of conflict", 1: "Aircraft are diverging at starting time of conflict"}

class RuleContent_24(RuleContentContextFree):
    cv_arg: TypeAlias = Content_24.cv_arg
    cv_content: TypeAlias = Content_24

    @property
    def content(self) -> Content_24:
        return self._get_content() # type: ignore

class Variation_902(Element):
    cv_arg: TypeAlias = RuleContent_24.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_24

    @classmethod
    def create(cls, arg: "Variation_902.cv_arg") -> "Variation_902":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_24:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_24:
        return self.rule.content

class RuleVariation_872(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_902.cv_arg
    cv_variation: TypeAlias = Variation_902

    @classmethod
    def create(cls, arg : "RuleVariation_872.cv_arg") -> "RuleVariation_872":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_902:
        return self.arg # type: ignore

class Content_146(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Runway/Runway Crossing"}

class RuleContent_146(RuleContentContextFree):
    cv_arg: TypeAlias = Content_146.cv_arg
    cv_content: TypeAlias = Content_146

    @property
    def content(self) -> Content_146:
        return self._get_content() # type: ignore

class Variation_35(Element):
    cv_arg: TypeAlias = RuleContent_146.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_146

    @classmethod
    def create(cls, arg: "Variation_35.cv_arg") -> "Variation_35":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_146:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_146:
        return self.rule.content

class RuleVariation_35(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_35.cv_arg
    cv_variation: TypeAlias = Variation_35

    @classmethod
    def create(cls, arg : "RuleVariation_35.cv_arg") -> "RuleVariation_35":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_35:
        return self.arg # type: ignore

class Content_147(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Runway/Taxiway Crossing"}

class RuleContent_147(RuleContentContextFree):
    cv_arg: TypeAlias = Content_147.cv_arg
    cv_content: TypeAlias = Content_147

    @property
    def content(self) -> Content_147:
        return self._get_content() # type: ignore

class Variation_418(Element):
    cv_arg: TypeAlias = RuleContent_147.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_147

    @classmethod
    def create(cls, arg: "Variation_418.cv_arg") -> "Variation_418":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_147:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_147:
        return self.rule.content

class RuleVariation_407(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_418.cv_arg
    cv_variation: TypeAlias = Variation_418

    @classmethod
    def create(cls, arg : "RuleVariation_407.cv_arg") -> "RuleVariation_407":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_418:
        return self.arg # type: ignore

class Content_127(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 4 (MSAW) indicates MRVA"}

class RuleContent_127(RuleContentContextFree):
    cv_arg: TypeAlias = Content_127.cv_arg
    cv_content: TypeAlias = Content_127

    @property
    def content(self) -> Content_127:
        return self._get_content() # type: ignore

class Variation_520(Element):
    cv_arg: TypeAlias = RuleContent_127.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_127

    @classmethod
    def create(cls, arg: "Variation_520.cv_arg") -> "Variation_520":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_127:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_127:
        return self.rule.content

class RuleVariation_509(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_520.cv_arg
    cv_variation: TypeAlias = Variation_520

    @classmethod
    def create(cls, arg : "RuleVariation_509.cv_arg") -> "RuleVariation_509":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_520:
        return self.arg # type: ignore

class Content_121(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 25 (VRAM) indicates CRM"}

class RuleContent_121(RuleContentContextFree):
    cv_arg: TypeAlias = Content_121.cv_arg
    cv_content: TypeAlias = Content_121

    @property
    def content(self) -> Content_121:
        return self._get_content() # type: ignore

class Variation_629(Element):
    cv_arg: TypeAlias = RuleContent_121.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_121

    @classmethod
    def create(cls, arg: "Variation_629.cv_arg") -> "Variation_629":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_121:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_121:
        return self.rule.content

class RuleVariation_618(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_629.cv_arg
    cv_variation: TypeAlias = Variation_629

    @classmethod
    def create(cls, arg : "RuleVariation_618.cv_arg") -> "RuleVariation_618":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_629:
        return self.arg # type: ignore

class Content_122(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 25 (VRAM) indicates VRM"}

class RuleContent_122(RuleContentContextFree):
    cv_arg: TypeAlias = Content_122.cv_arg
    cv_content: TypeAlias = Content_122

    @property
    def content(self) -> Content_122:
        return self._get_content() # type: ignore

class Variation_710(Element):
    cv_arg: TypeAlias = RuleContent_122.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_122

    @classmethod
    def create(cls, arg: "Variation_710.cv_arg") -> "Variation_710":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_122:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_122:
        return self.rule.content

class RuleVariation_699(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_710.cv_arg
    cv_variation: TypeAlias = Variation_710

    @classmethod
    def create(cls, arg : "RuleVariation_699.cv_arg") -> "RuleVariation_699":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_710:
        return self.arg # type: ignore

class Content_123(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 25 (VRAM) indicates VTM"}

class RuleContent_123(RuleContentContextFree):
    cv_arg: TypeAlias = Content_123.cv_arg
    cv_content: TypeAlias = Content_123

    @property
    def content(self) -> Content_123:
        return self._get_content() # type: ignore

class Variation_832(Element):
    cv_arg: TypeAlias = RuleContent_123.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_123

    @classmethod
    def create(cls, arg: "Variation_832.cv_arg") -> "Variation_832":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_123:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_123:
        return self.rule.content

class RuleVariation_802(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_832.cv_arg
    cv_variation: TypeAlias = Variation_832

    @classmethod
    def create(cls, arg : "RuleVariation_802.cv_arg") -> "RuleVariation_802":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_832:
        return self.arg # type: ignore

class Content_124(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 29 (HAM) indicates HD"}

class RuleContent_124(RuleContentContextFree):
    cv_arg: TypeAlias = Content_124.cv_arg
    cv_content: TypeAlias = Content_124

    @property
    def content(self) -> Content_124:
        return self._get_content() # type: ignore

class Variation_914(Element):
    cv_arg: TypeAlias = RuleContent_124.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_124

    @classmethod
    def create(cls, arg: "Variation_914.cv_arg") -> "Variation_914":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_124:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_124:
        return self.rule.content

class RuleVariation_884(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_914.cv_arg
    cv_variation: TypeAlias = Variation_914

    @classmethod
    def create(cls, arg : "RuleVariation_884.cv_arg") -> "RuleVariation_884":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_914:
        return self.arg # type: ignore

class Content_125(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 29 (HAM) indicates RD"}

class RuleContent_125(RuleContentContextFree):
    cv_arg: TypeAlias = Content_125.cv_arg
    cv_content: TypeAlias = Content_125

    @property
    def content(self) -> Content_125:
        return self._get_content() # type: ignore

class Variation_33(Element):
    cv_arg: TypeAlias = RuleContent_125.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_125

    @classmethod
    def create(cls, arg: "Variation_33.cv_arg") -> "Variation_33":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_125:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_125:
        return self.rule.content

class RuleVariation_33(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_33.cv_arg
    cv_variation: TypeAlias = Variation_33

    @classmethod
    def create(cls, arg : "RuleVariation_33.cv_arg") -> "RuleVariation_33":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_33:
        return self.arg # type: ignore

class Content_126(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 29 (HAM) indicates VD"}

class RuleContent_126(RuleContentContextFree):
    cv_arg: TypeAlias = Content_126.cv_arg
    cv_content: TypeAlias = Content_126

    @property
    def content(self) -> Content_126:
        return self._get_content() # type: ignore

class Variation_413(Element):
    cv_arg: TypeAlias = RuleContent_126.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_126

    @classmethod
    def create(cls, arg: "Variation_413.cv_arg") -> "Variation_413":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_126:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_126:
        return self.rule.content

class RuleVariation_402(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_413.cv_arg
    cv_variation: TypeAlias = Variation_413

    @classmethod
    def create(cls, arg : "RuleVariation_402.cv_arg") -> "RuleVariation_402":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_413:
        return self.arg # type: ignore

class Content_118(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 20 (DBPSM) indicates ARR"}

class RuleContent_118(RuleContentContextFree):
    cv_arg: TypeAlias = Content_118.cv_arg
    cv_content: TypeAlias = Content_118

    @property
    def content(self) -> Content_118:
        return self._get_content() # type: ignore

class Variation_519(Element):
    cv_arg: TypeAlias = RuleContent_118.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_118

    @classmethod
    def create(cls, arg: "Variation_519.cv_arg") -> "Variation_519":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_118:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_118:
        return self.rule.content

class RuleVariation_508(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_519.cv_arg
    cv_variation: TypeAlias = Variation_519

    @classmethod
    def create(cls, arg : "RuleVariation_508.cv_arg") -> "RuleVariation_508":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_519:
        return self.arg # type: ignore

class Content_119(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 20 (DBPSM) indicates DEP"}

class RuleContent_119(RuleContentContextFree):
    cv_arg: TypeAlias = Content_119.cv_arg
    cv_content: TypeAlias = Content_119

    @property
    def content(self) -> Content_119:
        return self._get_content() # type: ignore

class Variation_628(Element):
    cv_arg: TypeAlias = RuleContent_119.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_119

    @classmethod
    def create(cls, arg: "Variation_628.cv_arg") -> "Variation_628":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_119:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_119:
        return self.rule.content

class RuleVariation_617(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_628.cv_arg
    cv_variation: TypeAlias = Variation_628

    @classmethod
    def create(cls, arg : "RuleVariation_617.cv_arg") -> "RuleVariation_617":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_628:
        return self.arg # type: ignore

class Content_120(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 20 (DBPSM) indicates above TL"}

class RuleContent_120(RuleContentContextFree):
    cv_arg: TypeAlias = Content_120.cv_arg
    cv_content: TypeAlias = Content_120

    @property
    def content(self) -> Content_120:
        return self._get_content() # type: ignore

class Variation_709(Element):
    cv_arg: TypeAlias = RuleContent_120.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_120

    @classmethod
    def create(cls, arg: "Variation_709.cv_arg") -> "Variation_709":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_120:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_120:
        return self.rule.content

class RuleVariation_698(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_709.cv_arg
    cv_variation: TypeAlias = Variation_709

    @classmethod
    def create(cls, arg : "RuleVariation_698.cv_arg") -> "RuleVariation_698":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_709:
        return self.arg # type: ignore

class Content_128(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Msg Type 99 (AIW) indicates pAIW Alert"}

class RuleContent_128(RuleContentContextFree):
    cv_arg: TypeAlias = Content_128.cv_arg
    cv_content: TypeAlias = Content_128

    @property
    def content(self) -> Content_128:
        return self._get_content() # type: ignore

class Variation_833(Element):
    cv_arg: TypeAlias = RuleContent_128.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_128

    @classmethod
    def create(cls, arg: "Variation_833.cv_arg") -> "Variation_833":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_128:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_128:
        return self.rule.content

class RuleVariation_803(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_833.cv_arg
    cv_variation: TypeAlias = Variation_833

    @classmethod
    def create(cls, arg : "RuleVariation_803.cv_arg") -> "RuleVariation_803":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_833:
        return self.arg # type: ignore

class NonSpare_1230(NonSpare):
    cv_arg: TypeAlias = RuleVariation_20.cv_arg
    cv_name = "MAS"
    cv_title = "Conflict Location in Military Airspace"
    cv_rule: TypeAlias = RuleVariation_20

    @classmethod
    def create(cls, arg : "NonSpare_1230.cv_arg") -> "NonSpare_1230":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_20:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_20:
        return self.rule.variation

class Item_529(Item):
    cv_arg: TypeAlias = NonSpare_1230.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1230

    @classmethod
    def create(cls, arg : "Item_529.cv_arg") -> "Item_529":
        return cls._create(arg) # type: ignore

class NonSpare_705(NonSpare):
    cv_arg: TypeAlias = RuleVariation_393.cv_arg
    cv_name = "CAS"
    cv_title = "Conflict Location in Civil Airspace"
    cv_rule: TypeAlias = RuleVariation_393

    @classmethod
    def create(cls, arg : "NonSpare_705.cv_arg") -> "NonSpare_705":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_393:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_404:
        return self.rule.variation

class Item_135(Item):
    cv_arg: TypeAlias = NonSpare_705.cv_arg
    cv_non_spare: TypeAlias = NonSpare_705

    @classmethod
    def create(cls, arg : "Item_135.cv_arg") -> "Item_135":
        return cls._create(arg) # type: ignore

class NonSpare_976(NonSpare):
    cv_arg: TypeAlias = RuleVariation_498.cv_arg
    cv_name = "FLD"
    cv_title = "Fast Lateral Divergence"
    cv_rule: TypeAlias = RuleVariation_498

    @classmethod
    def create(cls, arg : "NonSpare_976.cv_arg") -> "NonSpare_976":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_498:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_509:
        return self.rule.variation

class Item_332(Item):
    cv_arg: TypeAlias = NonSpare_976.cv_arg
    cv_non_spare: TypeAlias = NonSpare_976

    @classmethod
    def create(cls, arg : "Item_332.cv_arg") -> "Item_332":
        return cls._create(arg) # type: ignore

class NonSpare_1008(NonSpare):
    cv_arg: TypeAlias = RuleVariation_605.cv_arg
    cv_name = "FVD"
    cv_title = "Fast Vertical Divergence"
    cv_rule: TypeAlias = RuleVariation_605

    @classmethod
    def create(cls, arg : "NonSpare_1008.cv_arg") -> "NonSpare_1008":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_605:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_616:
        return self.rule.variation

class Item_354(Item):
    cv_arg: TypeAlias = NonSpare_1008.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1008

    @classmethod
    def create(cls, arg : "Item_354.cv_arg") -> "Item_354":
        return cls._create(arg) # type: ignore

class NonSpare_1975(NonSpare):
    cv_arg: TypeAlias = RuleVariation_721.cv_arg
    cv_name = "TYPE"
    cv_title = "Type of Separation Infringement"
    cv_rule: TypeAlias = RuleVariation_721

    @classmethod
    def create(cls, arg : "NonSpare_1975.cv_arg") -> "NonSpare_1975":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_721:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_732:
        return self.rule.variation

class Item_1088(Item):
    cv_arg: TypeAlias = NonSpare_1975.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1975

    @classmethod
    def create(cls, arg : "Item_1088.cv_arg") -> "Item_1088":
        return cls._create(arg) # type: ignore

class NonSpare_829(NonSpare):
    cv_arg: TypeAlias = RuleVariation_791.cv_arg
    cv_name = "CROSS"
    cv_title = "Crossing Test"
    cv_rule: TypeAlias = RuleVariation_791

    @classmethod
    def create(cls, arg : "NonSpare_829.cv_arg") -> "NonSpare_829":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_791:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_821:
        return self.rule.variation

class Item_215(Item):
    cv_arg: TypeAlias = NonSpare_829.cv_arg
    cv_non_spare: TypeAlias = NonSpare_829

    @classmethod
    def create(cls, arg : "Item_215.cv_arg") -> "Item_215":
        return cls._create(arg) # type: ignore

class NonSpare_886(NonSpare):
    cv_arg: TypeAlias = RuleVariation_872.cv_arg
    cv_name = "DIV"
    cv_title = "Divergence Test"
    cv_rule: TypeAlias = RuleVariation_872

    @classmethod
    def create(cls, arg : "NonSpare_886.cv_arg") -> "NonSpare_886":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_872:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_902:
        return self.rule.variation

class Item_263(Item):
    cv_arg: TypeAlias = NonSpare_886.cv_arg
    cv_non_spare: TypeAlias = NonSpare_886

    @classmethod
    def create(cls, arg : "Item_263.cv_arg") -> "Item_263":
        return cls._create(arg) # type: ignore

class NonSpare_1611(NonSpare):
    cv_arg: TypeAlias = RuleVariation_35.cv_arg
    cv_name = "RRC"
    cv_title = "Runway/Runway Crossing in RIMCAS"
    cv_rule: TypeAlias = RuleVariation_35

    @classmethod
    def create(cls, arg : "NonSpare_1611.cv_arg") -> "NonSpare_1611":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_35:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_35:
        return self.rule.variation

class Item_829(Item):
    cv_arg: TypeAlias = NonSpare_1611.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1611

    @classmethod
    def create(cls, arg : "Item_829.cv_arg") -> "Item_829":
        return cls._create(arg) # type: ignore

class NonSpare_1633(NonSpare):
    cv_arg: TypeAlias = RuleVariation_407.cv_arg
    cv_name = "RTC"
    cv_title = "Runway/Taxiway Crossing in RIMCAS"
    cv_rule: TypeAlias = RuleVariation_407

    @classmethod
    def create(cls, arg : "NonSpare_1633.cv_arg") -> "NonSpare_1633":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_407:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_418:
        return self.rule.variation

class Item_839(Item):
    cv_arg: TypeAlias = NonSpare_1633.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1633

    @classmethod
    def create(cls, arg : "Item_839.cv_arg") -> "Item_839":
        return cls._create(arg) # type: ignore

class NonSpare_1319(NonSpare):
    cv_arg: TypeAlias = RuleVariation_509.cv_arg
    cv_name = "MRVA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_509

    @classmethod
    def create(cls, arg : "NonSpare_1319.cv_arg") -> "NonSpare_1319":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_509:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_520:
        return self.rule.variation

class Item_585(Item):
    cv_arg: TypeAlias = NonSpare_1319.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1319

    @classmethod
    def create(cls, arg : "Item_585.cv_arg") -> "Item_585":
        return cls._create(arg) # type: ignore

class NonSpare_2039(NonSpare):
    cv_arg: TypeAlias = RuleVariation_618.cv_arg
    cv_name = "VRAMCRM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_618

    @classmethod
    def create(cls, arg : "NonSpare_2039.cv_arg") -> "NonSpare_2039":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_618:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_629:
        return self.rule.variation

class Item_1148(Item):
    cv_arg: TypeAlias = NonSpare_2039.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2039

    @classmethod
    def create(cls, arg : "Item_1148.cv_arg") -> "Item_1148":
        return cls._create(arg) # type: ignore

class NonSpare_2041(NonSpare):
    cv_arg: TypeAlias = RuleVariation_699.cv_arg
    cv_name = "VRAMVRM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_699

    @classmethod
    def create(cls, arg : "NonSpare_2041.cv_arg") -> "NonSpare_2041":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_699:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_710:
        return self.rule.variation

class Item_1150(Item):
    cv_arg: TypeAlias = NonSpare_2041.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2041

    @classmethod
    def create(cls, arg : "Item_1150.cv_arg") -> "Item_1150":
        return cls._create(arg) # type: ignore

class NonSpare_2044(NonSpare):
    cv_arg: TypeAlias = RuleVariation_802.cv_arg
    cv_name = "VRAMVTM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_802

    @classmethod
    def create(cls, arg : "NonSpare_2044.cv_arg") -> "NonSpare_2044":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_802:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_832:
        return self.rule.variation

class Item_1153(Item):
    cv_arg: TypeAlias = NonSpare_2044.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2044

    @classmethod
    def create(cls, arg : "Item_1153.cv_arg") -> "Item_1153":
        return cls._create(arg) # type: ignore

class NonSpare_1055(NonSpare):
    cv_arg: TypeAlias = RuleVariation_884.cv_arg
    cv_name = "HAMHD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_884

    @classmethod
    def create(cls, arg : "NonSpare_1055.cv_arg") -> "NonSpare_1055":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_884:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_914:
        return self.rule.variation

class Item_383(Item):
    cv_arg: TypeAlias = NonSpare_1055.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1055

    @classmethod
    def create(cls, arg : "Item_383.cv_arg") -> "Item_383":
        return cls._create(arg) # type: ignore

class NonSpare_1057(NonSpare):
    cv_arg: TypeAlias = RuleVariation_33.cv_arg
    cv_name = "HAMRD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_33

    @classmethod
    def create(cls, arg : "NonSpare_1057.cv_arg") -> "NonSpare_1057":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_33:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_33:
        return self.rule.variation

class Item_385(Item):
    cv_arg: TypeAlias = NonSpare_1057.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1057

    @classmethod
    def create(cls, arg : "Item_385.cv_arg") -> "Item_385":
        return cls._create(arg) # type: ignore

class NonSpare_1059(NonSpare):
    cv_arg: TypeAlias = RuleVariation_402.cv_arg
    cv_name = "HAMVD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_402

    @classmethod
    def create(cls, arg : "NonSpare_1059.cv_arg") -> "NonSpare_1059":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_402:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_413:
        return self.rule.variation

class Item_387(Item):
    cv_arg: TypeAlias = NonSpare_1059.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1059

    @classmethod
    def create(cls, arg : "Item_387.cv_arg") -> "Item_387":
        return cls._create(arg) # type: ignore

class NonSpare_866(NonSpare):
    cv_arg: TypeAlias = RuleVariation_508.cv_arg
    cv_name = "DBPSMARR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_508

    @classmethod
    def create(cls, arg : "NonSpare_866.cv_arg") -> "NonSpare_866":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_508:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_519:
        return self.rule.variation

class Item_244(Item):
    cv_arg: TypeAlias = NonSpare_866.cv_arg
    cv_non_spare: TypeAlias = NonSpare_866

    @classmethod
    def create(cls, arg : "Item_244.cv_arg") -> "Item_244":
        return cls._create(arg) # type: ignore

class NonSpare_868(NonSpare):
    cv_arg: TypeAlias = RuleVariation_617.cv_arg
    cv_name = "DBPSMDEP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_617

    @classmethod
    def create(cls, arg : "NonSpare_868.cv_arg") -> "NonSpare_868":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_617:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_628:
        return self.rule.variation

class Item_246(Item):
    cv_arg: TypeAlias = NonSpare_868.cv_arg
    cv_non_spare: TypeAlias = NonSpare_868

    @classmethod
    def create(cls, arg : "Item_246.cv_arg") -> "Item_246":
        return cls._create(arg) # type: ignore

class NonSpare_870(NonSpare):
    cv_arg: TypeAlias = RuleVariation_698.cv_arg
    cv_name = "DBPSMTL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_698

    @classmethod
    def create(cls, arg : "NonSpare_870.cv_arg") -> "NonSpare_870":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_698:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_709:
        return self.rule.variation

class Item_248(Item):
    cv_arg: TypeAlias = NonSpare_870.cv_arg
    cv_non_spare: TypeAlias = NonSpare_870

    @classmethod
    def create(cls, arg : "Item_248.cv_arg") -> "Item_248":
        return cls._create(arg) # type: ignore

class NonSpare_590(NonSpare):
    cv_arg: TypeAlias = RuleVariation_803.cv_arg
    cv_name = "AIW"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_803

    @classmethod
    def create(cls, arg : "NonSpare_590.cv_arg") -> "NonSpare_590":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_803:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_833:
        return self.rule.variation

class Item_57(Item):
    cv_arg: TypeAlias = NonSpare_590.cv_arg
    cv_non_spare: TypeAlias = NonSpare_590

    @classmethod
    def create(cls, arg : "Item_57.cv_arg") -> "Item_57":
        return cls._create(arg) # type: ignore

class Item_26(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 6
    cv_bit_size = 1

class Variation_1364(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_20.cv_arg, Tuple[Literal["MAS"], RuleVariation_20.cv_arg]], Union[RuleVariation_393.cv_arg, Tuple[Literal["CAS"], RuleVariation_393.cv_arg]], Union[RuleVariation_498.cv_arg, Tuple[Literal["FLD"], RuleVariation_498.cv_arg]], Union[RuleVariation_605.cv_arg, Tuple[Literal["FVD"], RuleVariation_605.cv_arg]], Union[RuleVariation_721.cv_arg, Tuple[Literal["TYPE"], RuleVariation_721.cv_arg]], Union[RuleVariation_791.cv_arg, Tuple[Literal["CROSS"], RuleVariation_791.cv_arg]], Union[RuleVariation_872.cv_arg, Tuple[Literal["DIV"], RuleVariation_872.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_35.cv_arg, Tuple[Literal["RRC"], RuleVariation_35.cv_arg]], Union[RuleVariation_407.cv_arg, Tuple[Literal["RTC"], RuleVariation_407.cv_arg]], Union[RuleVariation_509.cv_arg, Tuple[Literal["MRVA"], RuleVariation_509.cv_arg]], Union[RuleVariation_618.cv_arg, Tuple[Literal["VRAMCRM"], RuleVariation_618.cv_arg]], Union[RuleVariation_699.cv_arg, Tuple[Literal["VRAMVRM"], RuleVariation_699.cv_arg]], Union[RuleVariation_802.cv_arg, Tuple[Literal["VRAMVTM"], RuleVariation_802.cv_arg]], Union[RuleVariation_884.cv_arg, Tuple[Literal["HAMHD"], RuleVariation_884.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_33.cv_arg, Tuple[Literal["HAMRD"], RuleVariation_33.cv_arg]], Union[RuleVariation_402.cv_arg, Tuple[Literal["HAMVD"], RuleVariation_402.cv_arg]], Union[RuleVariation_508.cv_arg, Tuple[Literal["DBPSMARR"], RuleVariation_508.cv_arg]], Union[RuleVariation_617.cv_arg, Tuple[Literal["DBPSMDEP"], RuleVariation_617.cv_arg]], Union[RuleVariation_698.cv_arg, Tuple[Literal["DBPSMTL"], RuleVariation_698.cv_arg]], Union[RuleVariation_803.cv_arg, Tuple[Literal["AIW"], RuleVariation_803.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1364.cv_arg_group_1"],
        Tuple["Variation_1364.cv_arg_group_1", "Variation_1364.cv_arg_group_2"],
        Tuple["Variation_1364.cv_arg_group_1", "Variation_1364.cv_arg_group_2", "Variation_1364.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_529, 1), (Item_135, 1), (Item_332, 1), (Item_354, 1), (Item_1088, 1), (Item_215, 1), (Item_263, 1), None], [(Item_829, 1), (Item_839, 1), (Item_585, 1), (Item_1148, 1), (Item_1150, 1), (Item_1153, 1), (Item_383, 1), None], [(Item_385, 1), (Item_387, 1), (Item_244, 1), (Item_246, 1), (Item_248, 1), (Item_57, 1), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1364.cv_arg") -> 'Variation_1364':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MAS"]) -> RuleVariation_20:
        ...
    @overload
    def get_item(self, key : Literal["CAS"]) -> RuleVariation_393:
        ...
    @overload
    def get_item(self, key : Literal["FLD"]) -> RuleVariation_498:
        ...
    @overload
    def get_item(self, key : Literal["FVD"]) -> RuleVariation_605:
        ...
    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_721:
        ...
    @overload
    def get_item(self, key : Literal["CROSS"]) -> RuleVariation_791:
        ...
    @overload
    def get_item(self, key : Literal["DIV"]) -> RuleVariation_872:
        ...
    @overload
    def get_item(self, key : Literal["RRC"]) -> Optional[RuleVariation_35]:
        ...
    @overload
    def get_item(self, key : Literal["RTC"]) -> Optional[RuleVariation_407]:
        ...
    @overload
    def get_item(self, key : Literal["MRVA"]) -> Optional[RuleVariation_509]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMCRM"]) -> Optional[RuleVariation_618]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVRM"]) -> Optional[RuleVariation_699]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVTM"]) -> Optional[RuleVariation_802]:
        ...
    @overload
    def get_item(self, key : Literal["HAMHD"]) -> Optional[RuleVariation_884]:
        ...
    @overload
    def get_item(self, key : Literal["HAMRD"]) -> Optional[RuleVariation_33]:
        ...
    @overload
    def get_item(self, key : Literal["HAMVD"]) -> Optional[RuleVariation_402]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMARR"]) -> Optional[RuleVariation_508]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMDEP"]) -> Optional[RuleVariation_617]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMTL"]) -> Optional[RuleVariation_698]:
        ...
    @overload
    def get_item(self, key : Literal["AIW"]) -> Optional[RuleVariation_803]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1285(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1364.cv_arg
    cv_variation: TypeAlias = Variation_1364

    @classmethod
    def create(cls, arg : "RuleVariation_1285.cv_arg") -> "RuleVariation_1285":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1364:
        return self.arg # type: ignore

class NonSpare_746(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1285.cv_arg
    cv_name = "CN"
    cv_title = "Conflict Nature"
    cv_rule: TypeAlias = RuleVariation_1285

    @classmethod
    def create(cls, arg : "NonSpare_746.cv_arg") -> "NonSpare_746":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1285:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1364:
        return self.rule.variation

class Variation_132(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_132.cv_arg") -> "Variation_132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_132(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_132.cv_arg
    cv_variation: TypeAlias = Variation_132

    @classmethod
    def create(cls, arg : "RuleVariation_132.cv_arg") -> "RuleVariation_132":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_132:
        return self.arg # type: ignore

class NonSpare_1862(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "TID"
    cv_title = "Identification of Conflict Categories Definition Table"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_1862.cv_arg") -> "NonSpare_1862":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_998(Item):
    cv_arg: TypeAlias = NonSpare_1862.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1862

    @classmethod
    def create(cls, arg : "Item_998.cv_arg") -> "Item_998":
        return cls._create(arg) # type: ignore

class Content_11(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "APW Low Severity", 1: "APW Medium Severity", 2: "APW High Severity"}

class RuleContent_11(RuleContentContextFree):
    cv_arg: TypeAlias = Content_11.cv_arg
    cv_content: TypeAlias = Content_11

    @property
    def content(self) -> Content_11:
        return self._get_content() # type: ignore

class Variation_777(Element):
    cv_arg: TypeAlias = RuleContent_11.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_11

    @classmethod
    def create(cls, arg: "Variation_777.cv_arg") -> "Variation_777":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_11:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_11:
        return self.rule.content

class Content_584(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Major seperation infringement and not (crossed and diverging)", 2: "Minor seperation infringement and not (crossed and diverging)", 3: "Major seperation infringement and (crossed and diverging)", 4: "Minor seperation infringement and (crossed and diverging)"}

class RuleContent_584(RuleContentContextFree):
    cv_arg: TypeAlias = Content_584.cv_arg
    cv_content: TypeAlias = Content_584

    @property
    def content(self) -> Content_584:
        return self._get_content() # type: ignore

class Variation_798(Element):
    cv_arg: TypeAlias = RuleContent_584.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_584

    @classmethod
    def create(cls, arg: "Variation_798.cv_arg") -> "Variation_798":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_584:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_584:
        return self.rule.content

class Content_212(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Filter not set", 1: "Filter set"}

class RuleContent_212(RuleContentContextFree):
    cv_arg: TypeAlias = Content_212.cv_arg
    cv_content: TypeAlias = Content_212

    @property
    def content(self) -> Content_212:
        return self._get_content() # type: ignore

class Variation_724(Element):
    cv_arg: TypeAlias = RuleContent_212.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_212

    @classmethod
    def create(cls, arg: "Variation_724.cv_arg") -> "Variation_724":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_212:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_212:
        return self.rule.content

class RuleVariation_713(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_724.cv_arg
    cv_variation: TypeAlias = Variation_724

    @classmethod
    def create(cls, arg : "RuleVariation_713.cv_arg") -> "RuleVariation_713":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_724:
        return self.arg # type: ignore

class NonSpare_1197(NonSpare):
    cv_arg: TypeAlias = RuleVariation_713.cv_arg
    cv_name = "LPF"
    cv_title = "Linear Prediction Filter"
    cv_rule: TypeAlias = RuleVariation_713

    @classmethod
    def create(cls, arg : "NonSpare_1197.cv_arg") -> "NonSpare_1197":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_713:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_724:
        return self.rule.variation

class Item_505(Item):
    cv_arg: TypeAlias = NonSpare_1197.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1197

    @classmethod
    def create(cls, arg : "Item_505.cv_arg") -> "Item_505":
        return cls._create(arg) # type: ignore

class Variation_851(Element):
    cv_arg: TypeAlias = RuleContent_212.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_212

    @classmethod
    def create(cls, arg: "Variation_851.cv_arg") -> "Variation_851":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_212:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_212:
        return self.rule.content

class RuleVariation_821(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_851.cv_arg
    cv_variation: TypeAlias = Variation_851

    @classmethod
    def create(cls, arg : "RuleVariation_821.cv_arg") -> "RuleVariation_821":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_851:
        return self.arg # type: ignore

class NonSpare_820(NonSpare):
    cv_arg: TypeAlias = RuleVariation_821.cv_arg
    cv_name = "CPF"
    cv_title = "Current Proximity Filter"
    cv_rule: TypeAlias = RuleVariation_821

    @classmethod
    def create(cls, arg : "NonSpare_820.cv_arg") -> "NonSpare_820":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_821:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_851:
        return self.rule.variation

class Item_209(Item):
    cv_arg: TypeAlias = NonSpare_820.cv_arg
    cv_non_spare: TypeAlias = NonSpare_820

    @classmethod
    def create(cls, arg : "Item_209.cv_arg") -> "Item_209":
        return cls._create(arg) # type: ignore

class Variation_927(Element):
    cv_arg: TypeAlias = RuleContent_212.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_212

    @classmethod
    def create(cls, arg: "Variation_927.cv_arg") -> "Variation_927":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_212:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_212:
        return self.rule.content

class RuleVariation_897(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_927.cv_arg
    cv_variation: TypeAlias = Variation_927

    @classmethod
    def create(cls, arg : "RuleVariation_897.cv_arg") -> "RuleVariation_897":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_927:
        return self.arg # type: ignore

class NonSpare_1279(NonSpare):
    cv_arg: TypeAlias = RuleVariation_897.cv_arg
    cv_name = "MHF"
    cv_title = "Manoeuvre Hazard Filter"
    cv_rule: TypeAlias = RuleVariation_897

    @classmethod
    def create(cls, arg : "NonSpare_1279.cv_arg") -> "NonSpare_1279":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_897:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_927:
        return self.rule.variation

class Item_549(Item):
    cv_arg: TypeAlias = NonSpare_1279.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1279

    @classmethod
    def create(cls, arg : "Item_549.cv_arg") -> "Item_549":
        return cls._create(arg) # type: ignore

class Variation_1337(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_713.cv_arg, Tuple[Literal["LPF"], RuleVariation_713.cv_arg]], Union[RuleVariation_821.cv_arg, Tuple[Literal["CPF"], RuleVariation_821.cv_arg]], Union[RuleVariation_897.cv_arg, Tuple[Literal["MHF"], RuleVariation_897.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1337.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_505, 1), (Item_209, 1), (Item_549, 1)]
    cv_items_dict = {"LPF": RuleVariation_713, "CPF": RuleVariation_821, "MHF": RuleVariation_897}

    @overload
    @classmethod
    def spec(cls, key : Literal["LPF"]) -> RuleVariation_713:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPF"]) -> RuleVariation_821:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHF"]) -> RuleVariation_897:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LPF"], Literal["CPF"], Literal["MHF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LPF"]) -> RuleVariation_713:
        ...
    @overload
    def get_item(self, key : Literal["CPF"]) -> RuleVariation_821:
        ...
    @overload
    def get_item(self, key : Literal["MHF"]) -> RuleVariation_897:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1337.cv_arg") -> 'Variation_1337':
        return cls._create(arg) # type: ignore

class Content_458(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Stage One Alert", 1: "Stage Two Alert"}

class RuleContent_458(RuleContentContextFree):
    cv_arg: TypeAlias = Content_458.cv_arg
    cv_content: TypeAlias = Content_458

    @property
    def content(self) -> Content_458:
        return self._get_content() # type: ignore

class Variation_751(Element):
    cv_arg: TypeAlias = RuleContent_458.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_458

    @classmethod
    def create(cls, arg: "Variation_751.cv_arg") -> "Variation_751":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_458:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_458:
        return self.rule.content

class RuleVariation_740(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_751.cv_arg
    cv_variation: TypeAlias = Variation_751

    @classmethod
    def create(cls, arg : "RuleVariation_740.cv_arg") -> "RuleVariation_740":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_751:
        return self.arg # type: ignore

class NonSpare_1550(NonSpare):
    cv_arg: TypeAlias = RuleVariation_740.cv_arg
    cv_name = "RAS"
    cv_title = "RIMCAS Alert Stage"
    cv_rule: TypeAlias = RuleVariation_740

    @classmethod
    def create(cls, arg : "NonSpare_1550.cv_arg") -> "NonSpare_1550":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_740:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_751:
        return self.rule.variation

class Item_778(Item):
    cv_arg: TypeAlias = NonSpare_1550.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1550

    @classmethod
    def create(cls, arg : "Item_778.cv_arg") -> "Item_778":
        return cls._create(arg) # type: ignore

class Variation_1338(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_740.cv_arg, Tuple[Literal["RAS"], RuleVariation_740.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1338.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_778, 1), (Item_24, 2)]
    cv_items_dict = {"RAS": RuleVariation_740}

    @classmethod
    def spec(cls, key : Literal["RAS"]) -> RuleVariation_740:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["RAS"]) -> RuleVariation_740:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1338.cv_arg") -> 'Variation_1338':
        return cls._create(arg) # type: ignore

class Content_4(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "2 aircraft, same taxiway, opposite direction", 1: "Aircraft entering wrong direction", 2: "Aircraft entering wrong taxiway", 3: "Speed violation"}

class RuleContent_4(RuleContentContextFree):
    cv_arg: TypeAlias = Content_4.cv_arg
    cv_content: TypeAlias = Content_4

    @property
    def content(self) -> Content_4:
        return self._get_content() # type: ignore

class Variation_776(Element):
    cv_arg: TypeAlias = RuleContent_4.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_4

    @classmethod
    def create(cls, arg: "Variation_776.cv_arg") -> "Variation_776":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_4:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_4:
        return self.rule.content

class Content_557(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "VRM Slow Climb", 1: "VRM Slow Descent"}

class RuleContent_557(RuleContentContextFree):
    cv_arg: TypeAlias = Content_557.cv_arg
    cv_content: TypeAlias = Content_557

    @property
    def content(self) -> Content_557:
        return self._get_content() # type: ignore

class Variation_795(Element):
    cv_arg: TypeAlias = RuleContent_557.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_557

    @classmethod
    def create(cls, arg: "Variation_795.cv_arg") -> "Variation_795":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_557:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_557:
        return self.rule.content

class Content_558(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "VTM Fast Climb", 1: "VTM Fast Descent"}

class RuleContent_558(RuleContentContextFree):
    cv_arg: TypeAlias = Content_558.cv_arg
    cv_content: TypeAlias = Content_558

    @property
    def content(self) -> Content_558:
        return self._get_content() # type: ignore

class Variation_796(Element):
    cv_arg: TypeAlias = RuleContent_558.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_558

    @classmethod
    def create(cls, arg: "Variation_796.cv_arg") -> "Variation_796":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_558:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_558:
        return self.rule.content

class Content_563(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Vertical manoeuvre deviation prior to reaching its expected level", 1: "Vertical manoeuvre deviation past its expected level"}

class RuleContent_563(RuleContentContextFree):
    cv_arg: TypeAlias = Content_563.cv_arg
    cv_content: TypeAlias = Content_563

    @property
    def content(self) -> Content_563:
        return self._get_content() # type: ignore

class Variation_797(Element):
    cv_arg: TypeAlias = RuleContent_563.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_563

    @classmethod
    def create(cls, arg: "Variation_797.cv_arg") -> "Variation_797":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_563:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_563:
        return self.rule.content

class Content_457(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Slow Descent", 1: "Fast Descent", 2: "Slow Climb", 3: "Fast Climb"}

class RuleContent_457(RuleContentContextFree):
    cv_arg: TypeAlias = Content_457.cv_arg
    cv_content: TypeAlias = Content_457

    @property
    def content(self) -> Content_457:
        return self._get_content() # type: ignore

class Variation_790(Element):
    cv_arg: TypeAlias = RuleContent_457.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_457

    @classmethod
    def create(cls, arg: "Variation_790.cv_arg") -> "Variation_790":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_457:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_457:
        return self.rule.content

class Content_12(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Above", 1: "Below"}

class RuleContent_12(RuleContentContextFree):
    cv_arg: TypeAlias = Content_12.cv_arg
    cv_content: TypeAlias = Content_12

    @property
    def content(self) -> Content_12:
        return self._get_content() # type: ignore

class Variation_778(Element):
    cv_arg: TypeAlias = RuleContent_12.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_12

    @classmethod
    def create(cls, arg: "Variation_778.cv_arg") -> "Variation_778":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_12:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_12:
        return self.rule.content

class Content_477(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Table - Single RWY Operation", 1: "MRS - Single RWY Operation", 2: "ROT - Single RWY Operation", 3: "GAP - Single RWY Operation", 4: "Table - Parallel RWY Operation", 5: "MRS - Parallel RWY Operation", 6: "ROT - Parallel RWY Operation", 7: "GAP - Parallel RWY Operation"}

class RuleContent_477(RuleContentContextFree):
    cv_arg: TypeAlias = Content_477.cv_arg
    cv_content: TypeAlias = Content_477

    @property
    def content(self) -> Content_477:
        return self._get_content() # type: ignore

class Variation_791(Element):
    cv_arg: TypeAlias = RuleContent_477.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_477

    @classmethod
    def create(cls, arg: "Variation_791.cv_arg") -> "Variation_791":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_477:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_477:
        return self.rule.content

class Content_208(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "End of Alert", 1: "Planned Alert", 2: "Alert on TABLE Indicator", 3: "Alert on MRS Indicator", 4: "Alert on ROT Indicator", 5: "Alert on GAP Indicator"}

class RuleContent_208(RuleContentContextFree):
    cv_arg: TypeAlias = Content_208.cv_arg
    cv_content: TypeAlias = Content_208

    @property
    def content(self) -> Content_208:
        return self._get_content() # type: ignore

class Variation_782(Element):
    cv_arg: TypeAlias = RuleContent_208.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_208

    @classmethod
    def create(cls, arg: "Variation_782.cv_arg") -> "Variation_782":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_208:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_208:
        return self.rule.content

class Content_257(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Line-Up vs. Line-Up", 1: "Line-Up vs. Cross or Enter", 2: "Line-Up vs. Take-Off", 3: "Line-Up vs. Landing"}

class RuleContent_257(RuleContentContextFree):
    cv_arg: TypeAlias = Content_257.cv_arg
    cv_content: TypeAlias = Content_257

    @property
    def content(self) -> Content_257:
        return self._get_content() # type: ignore

class Variation_784(Element):
    cv_arg: TypeAlias = RuleContent_257.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_257

    @classmethod
    def create(cls, arg: "Variation_784.cv_arg") -> "Variation_784":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_257:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_257:
        return self.rule.content

class Content_70(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Cross or Enter  vs. Line-Up", 1: "Cross or Enter  vs. Cross or Enter", 2: "Cross or Enter  vs. Take-Off", 3: "Cross or Enter  vs. Landing"}

class RuleContent_70(RuleContentContextFree):
    cv_arg: TypeAlias = Content_70.cv_arg
    cv_content: TypeAlias = Content_70

    @property
    def content(self) -> Content_70:
        return self._get_content() # type: ignore

class Variation_781(Element):
    cv_arg: TypeAlias = RuleContent_70.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_70

    @classmethod
    def create(cls, arg: "Variation_781.cv_arg") -> "Variation_781":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_70:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_70:
        return self.rule.content

class Content_478(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Take-Off vs. Line-Up", 1: "Take-Off vs. Cross or Enter", 2: "Take-Off vs. Take-Off", 3: "Take-Off vs. Landing"}

class RuleContent_478(RuleContentContextFree):
    cv_arg: TypeAlias = Content_478.cv_arg
    cv_content: TypeAlias = Content_478

    @property
    def content(self) -> Content_478:
        return self._get_content() # type: ignore

class Variation_792(Element):
    cv_arg: TypeAlias = RuleContent_478.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_478

    @classmethod
    def create(cls, arg: "Variation_792.cv_arg") -> "Variation_792":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_478:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_478:
        return self.rule.content

class Content_254(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Landing vs. Line-Up", 1: "Landing vs. Cross or Enter", 2: "Landing vs. Take-Off", 3: "Landing vs. Landing"}

class RuleContent_254(RuleContentContextFree):
    cv_arg: TypeAlias = Content_254.cv_arg
    cv_content: TypeAlias = Content_254

    @property
    def content(self) -> Content_254:
        return self._get_content() # type: ignore

class Variation_783(Element):
    cv_arg: TypeAlias = RuleContent_254.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_254

    @classmethod
    def create(cls, arg: "Variation_783.cv_arg") -> "Variation_783":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_254:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_254:
        return self.rule.content

class Content_432(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Push-Back vs. Push-Back", 1: "Push-Back vs. Taxi"}

class RuleContent_432(RuleContentContextFree):
    cv_arg: TypeAlias = Content_432.cv_arg
    cv_content: TypeAlias = Content_432

    @property
    def content(self) -> Content_432:
        return self._get_content() # type: ignore

class Variation_789(Element):
    cv_arg: TypeAlias = RuleContent_432.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_432

    @classmethod
    def create(cls, arg: "Variation_789.cv_arg") -> "Variation_789":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_432:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_432:
        return self.rule.content

class Content_485(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Taxi vs. Push-Back", 1: "TAxi vs. Taxi"}

class RuleContent_485(RuleContentContextFree):
    cv_arg: TypeAlias = Content_485.cv_arg
    cv_content: TypeAlias = Content_485

    @property
    def content(self) -> Content_485:
        return self._get_content() # type: ignore

class Variation_793(Element):
    cv_arg: TypeAlias = RuleContent_485.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_485

    @classmethod
    def create(cls, arg: "Variation_793.cv_arg") -> "Variation_793":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_485:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_485:
        return self.rule.content

class Content_314(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Push-Back Clearance", 1: "No Taxi Clearance", 2: "No Line-Up Clearance", 3: "No Crossing Clearance", 4: "No Enter Clearance", 5: "No Take-Off Clearance", 6: "Landing Clearance"}

class RuleContent_314(RuleContentContextFree):
    cv_arg: TypeAlias = Content_314.cv_arg
    cv_content: TypeAlias = Content_314

    @property
    def content(self) -> Content_314:
        return self._get_content() # type: ignore

class Variation_785(Element):
    cv_arg: TypeAlias = RuleContent_314.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_314

    @classmethod
    def create(cls, arg: "Variation_785.cv_arg") -> "Variation_785":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_314:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_314:
        return self.rule.content

class Content_21(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "After Push-Back Clearance", 1: "After Taxi Clearance", 2: "After Line-Up Clearance", 3: "After Crossing Clearance", 4: "After Enter Clearance", 5: "After Take-Off Clearance", 6: "Stationary on Runway", 7: "Stationary on Taxiway"}

class RuleContent_21(RuleContentContextFree):
    cv_arg: TypeAlias = Content_21.cv_arg
    cv_content: TypeAlias = Content_21

    @property
    def content(self) -> Content_21:
        return self._get_content() # type: ignore

class Variation_780(Element):
    cv_arg: TypeAlias = RuleContent_21.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_21

    @classmethod
    def create(cls, arg: "Variation_780.cv_arg") -> "Variation_780":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_21:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_21:
        return self.rule.content

class Content_343(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No contact (receiving ATSU)", 1: "No transfer (leaving ATSU)"}

class RuleContent_343(RuleContentContextFree):
    cv_arg: TypeAlias = Content_343.cv_arg
    cv_content: TypeAlias = Content_343

    @property
    def content(self) -> Content_343:
        return self._get_content() # type: ignore

class Variation_786(Element):
    cv_arg: TypeAlias = RuleContent_343.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_343

    @classmethod
    def create(cls, arg: "Variation_786.cv_arg") -> "Variation_786":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_343:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_343:
        return self.rule.content

class RuleVariation_1442(RuleVariationDependent):
    cv_arg: TypeAlias = Union[
        Variation_774.cv_arg,
        Variation_777.cv_arg,
        Variation_798.cv_arg,
        Variation_1337.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_776.cv_arg,
        Variation_795.cv_arg,
        Variation_796.cv_arg,
        Variation_797.cv_arg,
        Variation_790.cv_arg,
        Variation_778.cv_arg,
        Variation_791.cv_arg,
        Variation_791.cv_arg,
        Variation_782.cv_arg,
        Variation_784.cv_arg,
        Variation_781.cv_arg,
        Variation_792.cv_arg,
        Variation_783.cv_arg,
        Variation_789.cv_arg,
        Variation_793.cv_arg,
        Variation_785.cv_arg,
        Variation_780.cv_arg,
        Variation_786.cv_arg,
    ]
    cv_depends_on = [["000"], ["120", "CC", "TID"]]
    cv_default_variation: TypeAlias = Variation_774
    cv_cases = [
        ([5, 1], Variation_777),
        ([7, 0], Variation_798),
        ([7, 1], Variation_1337),
        ([9, 2], Variation_1338),
        ([10, 2], Variation_1338),
        ([11, 2], Variation_1338),
        ([12, 2], Variation_1338),
        ([13, 2], Variation_1338),
        ([14, 2], Variation_1338),
        ([15, 2], Variation_1338),
        ([16, 2], Variation_1338),
        ([15, 1], Variation_776),
        ([24, 1], Variation_795),
        ([24, 2], Variation_796),
        ([26, 1], Variation_797),
        ([27, 1], Variation_790),
        ([27, 2], Variation_778),
        ([33, 1], Variation_791),
        ([34, 1], Variation_791),
        ([35, 1], Variation_782),
        ([38, 0], Variation_784),
        ([38, 1], Variation_781),
        ([38, 2], Variation_792),
        ([38, 3], Variation_783),
        ([38, 4], Variation_789),
        ([38, 5], Variation_793),
        ([39, 1], Variation_785),
        ([40, 1], Variation_780),
        ([41, 1], Variation_786),
    ]

    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[5], Literal[1]]) -> Variation_777:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[7], Literal[0]]) -> Variation_798:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[7], Literal[1]]) -> Variation_1337:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[9], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[10], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[11], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[12], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[13], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[14], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[15], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[16], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[15], Literal[1]]) -> Variation_776:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[24], Literal[1]]) -> Variation_795:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[24], Literal[2]]) -> Variation_796:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[26], Literal[1]]) -> Variation_797:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[27], Literal[1]]) -> Variation_790:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[27], Literal[2]]) -> Variation_778:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[33], Literal[1]]) -> Variation_791:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[34], Literal[1]]) -> Variation_791:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[35], Literal[1]]) -> Variation_782:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[0]]) -> Variation_784:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[1]]) -> Variation_781:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[2]]) -> Variation_792:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[3]]) -> Variation_783:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[4]]) -> Variation_789:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[5]]) -> Variation_793:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[39], Literal[1]]) -> Variation_785:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[40], Literal[1]]) -> Variation_780:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[41], Literal[1]]) -> Variation_786:
        ...

    @classmethod
    def variation(cls, key : Any) -> Any:
        return cls._variation(key)

    @classmethod
    def create(cls, arg : "RuleVariation_1442.cv_arg") -> "RuleVariation_1442":
        return cls._create(arg) # type: ignore

class NonSpare_817(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1442.cv_arg
    cv_name = "CPC"
    cv_title = "Conflict Properties Class"
    cv_rule: TypeAlias = RuleVariation_1442

    @classmethod
    def create(cls, arg : "NonSpare_817.cv_arg") -> "NonSpare_817":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1442:
        return self.arg # type: ignore

class Item_207(Item):
    cv_arg: TypeAlias = NonSpare_817.cv_arg
    cv_non_spare: TypeAlias = NonSpare_817

    @classmethod
    def create(cls, arg : "Item_207.cv_arg") -> "Item_207":
        return cls._create(arg) # type: ignore

class Content_253(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "LOW", 1: "HIGH"}

class RuleContent_253(RuleContentContextFree):
    cv_arg: TypeAlias = Content_253.cv_arg
    cv_content: TypeAlias = Content_253

    @property
    def content(self) -> Content_253:
        return self._get_content() # type: ignore

class Variation_982(Element):
    cv_arg: TypeAlias = RuleContent_253.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_253

    @classmethod
    def create(cls, arg: "Variation_982.cv_arg") -> "Variation_982":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_253:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_253:
        return self.rule.content

class RuleVariation_952(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_982.cv_arg
    cv_variation: TypeAlias = Variation_982

    @classmethod
    def create(cls, arg : "RuleVariation_952.cv_arg") -> "RuleVariation_952":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_982:
        return self.arg # type: ignore

class NonSpare_834(NonSpare):
    cv_arg: TypeAlias = RuleVariation_952.cv_arg
    cv_name = "CS"
    cv_title = "Conflict Severity"
    cv_rule: TypeAlias = RuleVariation_952

    @classmethod
    def create(cls, arg : "NonSpare_834.cv_arg") -> "NonSpare_834":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_952:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_982:
        return self.rule.variation

class Item_219(Item):
    cv_arg: TypeAlias = NonSpare_834.cv_arg
    cv_non_spare: TypeAlias = NonSpare_834

    @classmethod
    def create(cls, arg : "Item_219.cv_arg") -> "Item_219":
        return cls._create(arg) # type: ignore

class Variation_1224(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["TID"], RuleVariation_132.cv_arg]], Union[RuleVariation_1442.cv_arg, Tuple[Literal["CPC"], RuleVariation_1442.cv_arg]], Union[RuleVariation_952.cv_arg, Tuple[Literal["CS"], RuleVariation_952.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1224.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_998, 4), (Item_207, 3), (Item_219, 1)]
    cv_items_dict = {"TID": RuleVariation_132, "CPC": RuleVariation_1442, "CS": RuleVariation_952}

    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> RuleVariation_1442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> RuleVariation_952:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TID"], Literal["CPC"], Literal["CS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> RuleVariation_1442:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> RuleVariation_952:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1224.cv_arg") -> 'Variation_1224':
        return cls._create(arg) # type: ignore

class RuleVariation_1164(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1224.cv_arg
    cv_variation: TypeAlias = Variation_1224

    @classmethod
    def create(cls, arg : "RuleVariation_1164.cv_arg") -> "RuleVariation_1164":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1224:
        return self.arg # type: ignore

class NonSpare_710(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1164.cv_arg
    cv_name = "CC"
    cv_title = "Conflict Classification"
    cv_rule: TypeAlias = RuleVariation_1164

    @classmethod
    def create(cls, arg : "NonSpare_710.cv_arg") -> "NonSpare_710":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1164:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1224:
        return self.rule.variation

class Content_731(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["%"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.5
    cv_unit = "%"

    def as_quantity(self, cv_unit : Optional[Literal["%"]] = None) -> float:
        return self._as_quantity()

class RuleContent_731(RuleContentContextFree):
    cv_arg: TypeAlias = Content_731.cv_arg
    cv_content: TypeAlias = Content_731

    @property
    def content(self) -> Content_731:
        return self._get_content() # type: ignore

class Variation_226(Element):
    cv_arg: TypeAlias = RuleContent_731.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_731

    @classmethod
    def create(cls, arg: "Variation_226.cv_arg") -> "Variation_226":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_731:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_731:
        return self.rule.content

class RuleVariation_219(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_226.cv_arg
    cv_variation: TypeAlias = Variation_226

    @classmethod
    def create(cls, arg : "RuleVariation_219.cv_arg") -> "RuleVariation_219":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_226:
        return self.arg # type: ignore

class NonSpare_815(NonSpare):
    cv_arg: TypeAlias = RuleVariation_219.cv_arg
    cv_name = "CP"
    cv_title = "Conflict Probability"
    cv_rule: TypeAlias = RuleVariation_219

    @classmethod
    def create(cls, arg : "NonSpare_815.cv_arg") -> "NonSpare_815":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_219:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_226:
        return self.rule.variation

class NonSpare_713(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "CD"
    cv_title = "Conflict Duration"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_713.cv_arg") -> "NonSpare_713":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class Variation_1479(Compound):
    cv_arg = TypedDict('cv_arg', {
        "CN": NonSpare_746.cv_arg,
        "CC": NonSpare_710.cv_arg,
        "CP": NonSpare_815.cv_arg,
        "CD": NonSpare_713.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_746, NonSpare_710, NonSpare_815, NonSpare_713]
    cv_items_dict = {"CN": NonSpare_746, "CC": NonSpare_710, "CP": NonSpare_815, "CD": NonSpare_713}

    @overload
    @classmethod
    def spec(cls, key : Literal["CN"]) -> NonSpare_746:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CC"]) -> NonSpare_710:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CP"]) -> NonSpare_815:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CD"]) -> NonSpare_713:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CN"], Literal["CC"], Literal["CP"], Literal["CD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CN"]) -> Optional[NonSpare_746]:
        ...
    @overload
    def get_item(self, key : Literal["CC"]) -> Optional[NonSpare_710]:
        ...
    @overload
    def get_item(self, key : Literal["CP"]) -> Optional[NonSpare_815]:
        ...
    @overload
    def get_item(self, key : Literal["CD"]) -> Optional[NonSpare_713]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CN"], val : NonSpare_746.cv_arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["CC"], val : NonSpare_710.cv_arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["CP"], val : NonSpare_815.cv_arg) -> "Variation_1479":
        ...
    @overload
    def set_item(self, key : Literal["CD"], val : NonSpare_713.cv_arg) -> "Variation_1479":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CN"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["CC"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["CP"]) -> "Variation_1479":
        ...
    @overload
    def del_item(self, key : Literal["CD"]) -> "Variation_1479":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1479.cv_arg") -> 'Variation_1479':
        return cls._create(arg) # type: ignore

class RuleVariation_1400(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1479.cv_arg
    cv_variation: TypeAlias = Variation_1479

    @classmethod
    def create(cls, arg : "RuleVariation_1400.cv_arg") -> "RuleVariation_1400":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1479:
        return self.arg # type: ignore

class NonSpare_297(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1400.cv_arg
    cv_name = "120"
    cv_title = "Conflict Characteristics"
    cv_rule: TypeAlias = RuleVariation_1400

    @classmethod
    def create(cls, arg : "NonSpare_297.cv_arg") -> "NonSpare_297":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1400:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1479:
        return self.rule.variation

class UapItem_297(UapItem):
    cv_non_spare: TypeAlias = NonSpare_297

class NonSpare_1835(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "TC"
    cv_title = "Time to Conflict"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_1835.cv_arg") -> "NonSpare_1835":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class NonSpare_1839(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "TCA"
    cv_title = "Time to Closest Approach"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_1839.cv_arg") -> "NonSpare_1839":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class Variation_366(Element):
    cv_arg: TypeAlias = RuleContent_732.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_732

    @classmethod
    def create(cls, arg: "Variation_366.cv_arg") -> "Variation_366":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_732:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_732:
        return self.rule.content

class RuleVariation_359(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_366.cv_arg
    cv_variation: TypeAlias = Variation_366

    @classmethod
    def create(cls, arg : "RuleVariation_359.cv_arg") -> "RuleVariation_359":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_366:
        return self.arg # type: ignore

class NonSpare_738(NonSpare):
    cv_arg: TypeAlias = RuleVariation_359.cv_arg
    cv_name = "CHS"
    cv_title = "Current Horizontal Separation"
    cv_rule: TypeAlias = RuleVariation_359

    @classmethod
    def create(cls, arg : "NonSpare_738.cv_arg") -> "NonSpare_738":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_359:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_366:
        return self.rule.variation

class NonSpare_1282(NonSpare):
    cv_arg: TypeAlias = RuleVariation_304.cv_arg
    cv_name = "MHS"
    cv_title = "Estimated Minimum Horizontal Separation"
    cv_rule: TypeAlias = RuleVariation_304

    @classmethod
    def create(cls, arg : "NonSpare_1282.cv_arg") -> "NonSpare_1282":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

class Content_729(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_729(RuleContentContextFree):
    cv_arg: TypeAlias = Content_729.cv_arg
    cv_content: TypeAlias = Content_729

    @property
    def content(self) -> Content_729:
        return self._get_content() # type: ignore

class Variation_310(Element):
    cv_arg: TypeAlias = RuleContent_729.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_729

    @classmethod
    def create(cls, arg: "Variation_310.cv_arg") -> "Variation_310":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_729:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_729:
        return self.rule.content

class RuleVariation_303(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_310.cv_arg
    cv_variation: TypeAlias = Variation_310

    @classmethod
    def create(cls, arg : "RuleVariation_303.cv_arg") -> "RuleVariation_303":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_310:
        return self.arg # type: ignore

class NonSpare_853(NonSpare):
    cv_arg: TypeAlias = RuleVariation_303.cv_arg
    cv_name = "CVS"
    cv_title = "Current Vertical Separation"
    cv_rule: TypeAlias = RuleVariation_303

    @classmethod
    def create(cls, arg : "NonSpare_853.cv_arg") -> "NonSpare_853":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_310:
        return self.rule.variation

class NonSpare_1341(NonSpare):
    cv_arg: TypeAlias = RuleVariation_303.cv_arg
    cv_name = "MVS"
    cv_title = "Estimated Minimum Vertical Separation"
    cv_rule: TypeAlias = RuleVariation_303

    @classmethod
    def create(cls, arg : "NonSpare_1341.cv_arg") -> "NonSpare_1341":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_310:
        return self.rule.variation

class Variation_1515(Compound):
    cv_arg = TypedDict('cv_arg', {
        "TC": NonSpare_1835.cv_arg,
        "TCA": NonSpare_1839.cv_arg,
        "CHS": NonSpare_738.cv_arg,
        "MHS": NonSpare_1282.cv_arg,
        "CVS": NonSpare_853.cv_arg,
        "MVS": NonSpare_1341.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1835, NonSpare_1839, NonSpare_738, NonSpare_1282, NonSpare_853, NonSpare_1341]
    cv_items_dict = {"TC": NonSpare_1835, "TCA": NonSpare_1839, "CHS": NonSpare_738, "MHS": NonSpare_1282, "CVS": NonSpare_853, "MVS": NonSpare_1341}

    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> NonSpare_1835:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCA"]) -> NonSpare_1839:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHS"]) -> NonSpare_738:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHS"]) -> NonSpare_1282:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CVS"]) -> NonSpare_853:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MVS"]) -> NonSpare_1341:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TC"], Literal["TCA"], Literal["CHS"], Literal["MHS"], Literal["CVS"], Literal["MVS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TC"]) -> Optional[NonSpare_1835]:
        ...
    @overload
    def get_item(self, key : Literal["TCA"]) -> Optional[NonSpare_1839]:
        ...
    @overload
    def get_item(self, key : Literal["CHS"]) -> Optional[NonSpare_738]:
        ...
    @overload
    def get_item(self, key : Literal["MHS"]) -> Optional[NonSpare_1282]:
        ...
    @overload
    def get_item(self, key : Literal["CVS"]) -> Optional[NonSpare_853]:
        ...
    @overload
    def get_item(self, key : Literal["MVS"]) -> Optional[NonSpare_1341]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TC"], val : NonSpare_1835.cv_arg) -> "Variation_1515":
        ...
    @overload
    def set_item(self, key : Literal["TCA"], val : NonSpare_1839.cv_arg) -> "Variation_1515":
        ...
    @overload
    def set_item(self, key : Literal["CHS"], val : NonSpare_738.cv_arg) -> "Variation_1515":
        ...
    @overload
    def set_item(self, key : Literal["MHS"], val : NonSpare_1282.cv_arg) -> "Variation_1515":
        ...
    @overload
    def set_item(self, key : Literal["CVS"], val : NonSpare_853.cv_arg) -> "Variation_1515":
        ...
    @overload
    def set_item(self, key : Literal["MVS"], val : NonSpare_1341.cv_arg) -> "Variation_1515":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TC"]) -> "Variation_1515":
        ...
    @overload
    def del_item(self, key : Literal["TCA"]) -> "Variation_1515":
        ...
    @overload
    def del_item(self, key : Literal["CHS"]) -> "Variation_1515":
        ...
    @overload
    def del_item(self, key : Literal["MHS"]) -> "Variation_1515":
        ...
    @overload
    def del_item(self, key : Literal["CVS"]) -> "Variation_1515":
        ...
    @overload
    def del_item(self, key : Literal["MVS"]) -> "Variation_1515":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1515.cv_arg") -> 'Variation_1515':
        return cls._create(arg) # type: ignore

class RuleVariation_1436(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1515.cv_arg
    cv_variation: TypeAlias = Variation_1515

    @classmethod
    def create(cls, arg : "RuleVariation_1436.cv_arg") -> "RuleVariation_1436":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1515:
        return self.arg # type: ignore

class NonSpare_204(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1436.cv_arg
    cv_name = "070"
    cv_title = "Conflict Timing and Separation"
    cv_rule: TypeAlias = RuleVariation_1436

    @classmethod
    def create(cls, arg : "NonSpare_204.cv_arg") -> "NonSpare_204":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1436:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1515:
        return self.rule.variation

class UapItem_204(UapItem):
    cv_non_spare: TypeAlias = NonSpare_204

class Content_633(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_633(RuleContentContextFree):
    cv_arg: TypeAlias = Content_633.cv_arg
    cv_content: TypeAlias = Content_633

    @property
    def content(self) -> Content_633:
        return self._get_content() # type: ignore

class Variation_262(Element):
    cv_arg: TypeAlias = RuleContent_633.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_633

    @classmethod
    def create(cls, arg: "Variation_262.cv_arg") -> "Variation_262":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_633:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_633:
        return self.rule.content

class RuleVariation_255(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_262.cv_arg
    cv_variation: TypeAlias = Variation_262

    @classmethod
    def create(cls, arg : "RuleVariation_255.cv_arg") -> "RuleVariation_255":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_262:
        return self.arg # type: ignore

class NonSpare_230(NonSpare):
    cv_arg: TypeAlias = RuleVariation_255.cv_arg
    cv_name = "076"
    cv_title = "Vertical Deviation"
    cv_rule: TypeAlias = RuleVariation_255

    @classmethod
    def create(cls, arg : "NonSpare_230.cv_arg") -> "NonSpare_230":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_255:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_262:
        return self.rule.variation

class UapItem_230(UapItem):
    cv_non_spare: TypeAlias = NonSpare_230

class Content_638(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 32.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_638(RuleContentContextFree):
    cv_arg: TypeAlias = Content_638.cv_arg
    cv_content: TypeAlias = Content_638

    @property
    def content(self) -> Content_638:
        return self._get_content() # type: ignore

class Variation_264(Element):
    cv_arg: TypeAlias = RuleContent_638.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_638

    @classmethod
    def create(cls, arg: "Variation_264.cv_arg") -> "Variation_264":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_638:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_638:
        return self.rule.content

class RuleVariation_257(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_264.cv_arg
    cv_variation: TypeAlias = Variation_264

    @classmethod
    def create(cls, arg : "RuleVariation_257.cv_arg") -> "RuleVariation_257":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_264:
        return self.arg # type: ignore

class NonSpare_225(NonSpare):
    cv_arg: TypeAlias = RuleVariation_257.cv_arg
    cv_name = "074"
    cv_title = "Longitudinal Deviation"
    cv_rule: TypeAlias = RuleVariation_257

    @classmethod
    def create(cls, arg : "NonSpare_225.cv_arg") -> "NonSpare_225":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_257:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_264:
        return self.rule.variation

class UapItem_225(UapItem):
    cv_non_spare: TypeAlias = NonSpare_225

class NonSpare_228(NonSpare):
    cv_arg: TypeAlias = RuleVariation_345.cv_arg
    cv_name = "075"
    cv_title = "Transversal Distance Deviation"
    cv_rule: TypeAlias = RuleVariation_345

    @classmethod
    def create(cls, arg : "NonSpare_228.cv_arg") -> "NonSpare_228":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_352:
        return self.rule.variation

class UapItem_228(UapItem):
    cv_non_spare: TypeAlias = NonSpare_228

class NonSpare_610(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "AN"
    cv_title = "Area Name"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_610.cv_arg") -> "NonSpare_610":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class NonSpare_704(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "CAN"
    cv_title = "Crossing Area Name"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_704.cv_arg") -> "NonSpare_704":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1629(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "RT1"
    cv_title = "Runway/Taxiway Designator 1"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1629.cv_arg") -> "NonSpare_1629":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1630(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "RT2"
    cv_title = "Runway/Taxiway Designator 2"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1630.cv_arg") -> "NonSpare_1630":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1665(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "SB"
    cv_title = "Stop Bar Designator"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1665.cv_arg") -> "NonSpare_1665":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1012(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "G"
    cv_title = "Gate Designator"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1012.cv_arg") -> "NonSpare_1012":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class Variation_1472(Compound):
    cv_arg = TypedDict('cv_arg', {
        "AN": NonSpare_610.cv_arg,
        "CAN": NonSpare_704.cv_arg,
        "RT1": NonSpare_1629.cv_arg,
        "RT2": NonSpare_1630.cv_arg,
        "SB": NonSpare_1665.cv_arg,
        "G": NonSpare_1012.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_610, NonSpare_704, NonSpare_1629, NonSpare_1630, NonSpare_1665, NonSpare_1012]
    cv_items_dict = {"AN": NonSpare_610, "CAN": NonSpare_704, "RT1": NonSpare_1629, "RT2": NonSpare_1630, "SB": NonSpare_1665, "G": NonSpare_1012}

    @overload
    @classmethod
    def spec(cls, key : Literal["AN"]) -> NonSpare_610:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CAN"]) -> NonSpare_704:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RT1"]) -> NonSpare_1629:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RT2"]) -> NonSpare_1630:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SB"]) -> NonSpare_1665:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> NonSpare_1012:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AN"], Literal["CAN"], Literal["RT1"], Literal["RT2"], Literal["SB"], Literal["G"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AN"]) -> Optional[NonSpare_610]:
        ...
    @overload
    def get_item(self, key : Literal["CAN"]) -> Optional[NonSpare_704]:
        ...
    @overload
    def get_item(self, key : Literal["RT1"]) -> Optional[NonSpare_1629]:
        ...
    @overload
    def get_item(self, key : Literal["RT2"]) -> Optional[NonSpare_1630]:
        ...
    @overload
    def get_item(self, key : Literal["SB"]) -> Optional[NonSpare_1665]:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> Optional[NonSpare_1012]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AN"], val : NonSpare_610.cv_arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["CAN"], val : NonSpare_704.cv_arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["RT1"], val : NonSpare_1629.cv_arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["RT2"], val : NonSpare_1630.cv_arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["SB"], val : NonSpare_1665.cv_arg) -> "Variation_1472":
        ...
    @overload
    def set_item(self, key : Literal["G"], val : NonSpare_1012.cv_arg) -> "Variation_1472":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AN"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["CAN"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["RT1"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["RT2"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["SB"]) -> "Variation_1472":
        ...
    @overload
    def del_item(self, key : Literal["G"]) -> "Variation_1472":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1472.cv_arg") -> 'Variation_1472':
        return cls._create(arg) # type: ignore

class RuleVariation_1393(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1472.cv_arg
    cv_variation: TypeAlias = Variation_1472

    @classmethod
    def create(cls, arg : "RuleVariation_1393.cv_arg") -> "RuleVariation_1393":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1472:
        return self.arg # type: ignore

class NonSpare_267(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1393.cv_arg
    cv_name = "100"
    cv_title = "Area Definition"
    cv_rule: TypeAlias = RuleVariation_1393

    @classmethod
    def create(cls, arg : "NonSpare_267.cv_arg") -> "NonSpare_267":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1393:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1472:
        return self.rule.variation

class UapItem_267(UapItem):
    cv_non_spare: TypeAlias = NonSpare_267

class NonSpare_130(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "035"
    cv_title = "Track Number 2"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_130.cv_arg") -> "NonSpare_130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_130(UapItem):
    cv_non_spare: TypeAlias = NonSpare_130

class NonSpare_587(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "AI2"
    cv_title = "Aircraft Identifier (in 7 Characters) of Aircraft 2 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_587.cv_arg") -> "NonSpare_587":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1308(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE3A"
    cv_title = "Mode-3/A Code (Converted Into Octal Representation) of Aircraft 2 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1308.cv_arg") -> "NonSpare_1308":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_574(Item):
    cv_arg: TypeAlias = NonSpare_1308.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1308

    @classmethod
    def create(cls, arg : "Item_574.cv_arg") -> "Item_574":
        return cls._create(arg) # type: ignore

class Variation_1028(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1028.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_574, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1028.cv_arg") -> 'Variation_1028':
        return cls._create(arg) # type: ignore

class RuleVariation_997(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1028.cv_arg
    cv_variation: TypeAlias = Variation_1028

    @classmethod
    def create(cls, arg : "RuleVariation_997.cv_arg") -> "RuleVariation_997":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1028:
        return self.arg # type: ignore

class NonSpare_1215(NonSpare):
    cv_arg: TypeAlias = RuleVariation_997.cv_arg
    cv_name = "M32"
    cv_title = "Mode 3/A Code Aircraft 2"
    cv_rule: TypeAlias = RuleVariation_997

    @classmethod
    def create(cls, arg : "NonSpare_1215.cv_arg") -> "NonSpare_1215":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_997:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1028:
        return self.rule.variation

class NonSpare_825(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1091.cv_arg
    cv_name = "CPW"
    cv_title = "Predicted Conflict Position Target 2 in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1091

    @classmethod
    def create(cls, arg : "NonSpare_825.cv_arg") -> "NonSpare_825":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1091:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1135:
        return self.rule.variation

class NonSpare_822(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1236.cv_arg
    cv_name = "CPL"
    cv_title = "Predicted Conflict Position for the Aircraft 2 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_1236

    @classmethod
    def create(cls, arg : "NonSpare_822.cv_arg") -> "NonSpare_822":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1307:
        return self.rule.variation

class NonSpare_1945(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "TT2"
    cv_title = "Time to Runway Threshold for Second Approaching Aircraft in a RIMCA"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_1945.cv_arg") -> "NonSpare_1945":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class NonSpare_906(NonSpare):
    cv_arg: TypeAlias = RuleVariation_304.cv_arg
    cv_name = "DT2"
    cv_title = "Distance to Runway Threshold for Aircraft 2 Involved in a RIMCA"
    cv_rule: TypeAlias = RuleVariation_304

    @classmethod
    def create(cls, arg : "NonSpare_906.cv_arg") -> "NonSpare_906":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

class NonSpare_559(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1283.cv_arg
    cv_name = "AC2"
    cv_title = "Characteristics of Aircraft 2 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_1283

    @classmethod
    def create(cls, arg : "NonSpare_559.cv_arg") -> "NonSpare_559":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1362:
        return self.rule.variation

class NonSpare_1322(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "MS2"
    cv_title = "Aircraft Identification Downloaded From Aircraft 2 Involved in the Conflict If Eequipped With a Mode-S Transponder"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_1322.cv_arg") -> "NonSpare_1322":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class NonSpare_987(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1006.cv_arg
    cv_name = "FP2"
    cv_title = "Number of the Flight Plan Correlated to Aircraft 2 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_1006

    @classmethod
    def create(cls, arg : "NonSpare_987.cv_arg") -> "NonSpare_987":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1006:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1038:
        return self.rule.variation

class NonSpare_726(NonSpare):
    cv_arg: TypeAlias = RuleVariation_314.cv_arg
    cv_name = "CF2"
    cv_title = "Cleared Flight Level for Aircraft 2 Involved in the Conflict"
    cv_rule: TypeAlias = RuleVariation_314

    @classmethod
    def create(cls, arg : "NonSpare_726.cv_arg") -> "NonSpare_726":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_321:
        return self.rule.variation

class Variation_1470(Compound):
    cv_arg = TypedDict('cv_arg', {
        "AI2": NonSpare_587.cv_arg,
        "M32": NonSpare_1215.cv_arg,
        "CPW": NonSpare_825.cv_arg,
        "CPL": NonSpare_822.cv_arg,
        "TT2": NonSpare_1945.cv_arg,
        "DT2": NonSpare_906.cv_arg,
        "AC2": NonSpare_559.cv_arg,
        "MS2": NonSpare_1322.cv_arg,
        "FP2": NonSpare_987.cv_arg,
        "CF2": NonSpare_726.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_587, NonSpare_1215, NonSpare_825, NonSpare_822, NonSpare_1945, NonSpare_906, NonSpare_559, NonSpare_1322, NonSpare_987, NonSpare_726]
    cv_items_dict = {"AI2": NonSpare_587, "M32": NonSpare_1215, "CPW": NonSpare_825, "CPL": NonSpare_822, "TT2": NonSpare_1945, "DT2": NonSpare_906, "AC2": NonSpare_559, "MS2": NonSpare_1322, "FP2": NonSpare_987, "CF2": NonSpare_726}

    @overload
    @classmethod
    def spec(cls, key : Literal["AI2"]) -> NonSpare_587:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M32"]) -> NonSpare_1215:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPW"]) -> NonSpare_825:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPL"]) -> NonSpare_822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TT2"]) -> NonSpare_1945:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DT2"]) -> NonSpare_906:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC2"]) -> NonSpare_559:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MS2"]) -> NonSpare_1322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FP2"]) -> NonSpare_987:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CF2"]) -> NonSpare_726:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AI2"], Literal["M32"], Literal["CPW"], Literal["CPL"], Literal["TT2"], Literal["DT2"], Literal["AC2"], Literal["MS2"], Literal["FP2"], Literal["CF2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AI2"]) -> Optional[NonSpare_587]:
        ...
    @overload
    def get_item(self, key : Literal["M32"]) -> Optional[NonSpare_1215]:
        ...
    @overload
    def get_item(self, key : Literal["CPW"]) -> Optional[NonSpare_825]:
        ...
    @overload
    def get_item(self, key : Literal["CPL"]) -> Optional[NonSpare_822]:
        ...
    @overload
    def get_item(self, key : Literal["TT2"]) -> Optional[NonSpare_1945]:
        ...
    @overload
    def get_item(self, key : Literal["DT2"]) -> Optional[NonSpare_906]:
        ...
    @overload
    def get_item(self, key : Literal["AC2"]) -> Optional[NonSpare_559]:
        ...
    @overload
    def get_item(self, key : Literal["MS2"]) -> Optional[NonSpare_1322]:
        ...
    @overload
    def get_item(self, key : Literal["FP2"]) -> Optional[NonSpare_987]:
        ...
    @overload
    def get_item(self, key : Literal["CF2"]) -> Optional[NonSpare_726]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AI2"], val : NonSpare_587.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["M32"], val : NonSpare_1215.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["CPW"], val : NonSpare_825.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["CPL"], val : NonSpare_822.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["TT2"], val : NonSpare_1945.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["DT2"], val : NonSpare_906.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["AC2"], val : NonSpare_559.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["MS2"], val : NonSpare_1322.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["FP2"], val : NonSpare_987.cv_arg) -> "Variation_1470":
        ...
    @overload
    def set_item(self, key : Literal["CF2"], val : NonSpare_726.cv_arg) -> "Variation_1470":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AI2"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["M32"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["CPW"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["CPL"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["TT2"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["DT2"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["AC2"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["MS2"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["FP2"]) -> "Variation_1470":
        ...
    @overload
    def del_item(self, key : Literal["CF2"]) -> "Variation_1470":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1470.cv_arg") -> 'Variation_1470':
        return cls._create(arg) # type: ignore

class RuleVariation_1391(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1470.cv_arg
    cv_variation: TypeAlias = Variation_1470

    @classmethod
    def create(cls, arg : "RuleVariation_1391.cv_arg") -> "RuleVariation_1391":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1470:
        return self.arg # type: ignore

class NonSpare_382(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1391.cv_arg
    cv_name = "171"
    cv_title = "Aircraft Identification and Characteristics 2"
    cv_rule: TypeAlias = RuleVariation_1391

    @classmethod
    def create(cls, arg : "NonSpare_382.cv_arg") -> "NonSpare_382":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1391:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1470:
        return self.rule.variation

class UapItem_382(UapItem):
    cv_non_spare: TypeAlias = NonSpare_382

class NonSpare_721(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "CEN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_721.cv_arg") -> "NonSpare_721":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_147(Item):
    cv_arg: TypeAlias = NonSpare_721.cv_arg
    cv_non_spare: TypeAlias = NonSpare_721

    @classmethod
    def create(cls, arg : "Item_147.cv_arg") -> "Item_147":
        return cls._create(arg) # type: ignore

class NonSpare_1443(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "POS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1443.cv_arg") -> "NonSpare_1443":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_692(Item):
    cv_arg: TypeAlias = NonSpare_1443.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1443

    @classmethod
    def create(cls, arg : "Item_692.cv_arg") -> "Item_692":
        return cls._create(arg) # type: ignore

class Variation_1066(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["CEN"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["POS"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1066.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_147, 8), (Item_692, 8)]
    cv_items_dict = {"CEN": RuleVariation_159, "POS": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["CEN"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CEN"], Literal["POS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CEN"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1066.cv_arg") -> 'Variation_1066':
        return cls._create(arg) # type: ignore

class Variation_1414(Repetitive):
    cv_arg: TypeAlias = List[Variation_1066.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1066

    @classmethod
    def create(cls, arg: "Variation_1414.cv_arg") -> 'Variation_1414':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1066]:
        return self._get_list() # type: ignore

class RuleVariation_1335(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1414.cv_arg
    cv_variation: TypeAlias = Variation_1414

    @classmethod
    def create(cls, arg : "RuleVariation_1335.cv_arg") -> "RuleVariation_1335":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1414:
        return self.arg # type: ignore

class NonSpare_286(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1335.cv_arg
    cv_name = "110"
    cv_title = "FDPS Sector Control Identification"
    cv_rule: TypeAlias = RuleVariation_1335

    @classmethod
    def create(cls, arg : "NonSpare_286.cv_arg") -> "NonSpare_286":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1335:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1414:
        return self.rule.variation

class UapItem_286(UapItem):
    cv_non_spare: TypeAlias = NonSpare_286

class Variation_1463(Explicit):
    cv_arg: TypeAlias = bytes
    cv_explicit_type: TypeAlias = ReservedExpansion

    @classmethod
    def create(cls, arg: "Variation_1463.cv_arg") -> 'Variation_1463':
        return cls._create(arg) # type: ignore

class RuleVariation_1384(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1463.cv_arg
    cv_variation: TypeAlias = Variation_1463

    @classmethod
    def create(cls, arg : "RuleVariation_1384.cv_arg") -> "RuleVariation_1384":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1463:
        return self.arg # type: ignore

class NonSpare_1568(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1384.cv_arg
    cv_name = "RE"
    cv_title = "Reserved Expansion Field"
    cv_rule: TypeAlias = RuleVariation_1384

    @classmethod
    def create(cls, arg : "NonSpare_1568.cv_arg") -> "NonSpare_1568":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1463:
        return self.rule.variation

class UapItem_547(UapItem):
    cv_non_spare: TypeAlias = NonSpare_1568

class Record_14(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_34.cv_arg,
        "000": NonSpare_3.cv_arg,
        "015": NonSpare_58.cv_arg,
        "020": NonSpare_94.cv_arg,
        "040": NonSpare_136.cv_arg,
        "045": NonSpare_163.cv_arg,
        "060": NonSpare_195.cv_arg,
        "030": NonSpare_114.cv_arg,
        "170": NonSpare_370.cv_arg,
        "120": NonSpare_297.cv_arg,
        "070": NonSpare_204.cv_arg,
        "076": NonSpare_230.cv_arg,
        "074": NonSpare_225.cv_arg,
        "075": NonSpare_228.cv_arg,
        "100": NonSpare_267.cv_arg,
        "035": NonSpare_130.cv_arg,
        "171": NonSpare_382.cv_arg,
        "110": NonSpare_286.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_34, UapItem_3, UapItem_58, UapItem_94, UapItem_136, UapItem_163, UapItem_195, UapItem_114, UapItem_370, UapItem_297, UapItem_204, UapItem_230, UapItem_225, UapItem_228, UapItem_267, UapItem_130, UapItem_382, UapItem_286, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_34, "000": NonSpare_3, "015": NonSpare_58, "020": NonSpare_94, "040": NonSpare_136, "045": NonSpare_163, "060": NonSpare_195, "030": NonSpare_114, "170": NonSpare_370, "120": NonSpare_297, "070": NonSpare_204, "076": NonSpare_230, "074": NonSpare_225, "075": NonSpare_228, "100": NonSpare_267, "035": NonSpare_130, "171": NonSpare_382, "110": NonSpare_286, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_34:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_3:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_94:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["045"]) -> NonSpare_163:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_114:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_370:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_297:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_230:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_267:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_130:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["171"]) -> NonSpare_382:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_286:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["020"], Literal["040"], Literal["045"], Literal["060"], Literal["030"], Literal["170"], Literal["120"], Literal["070"], Literal["076"], Literal["074"], Literal["075"], Literal["100"], Literal["035"], Literal["171"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_34]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_3]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_58]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_94]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_136]:
        ...
    @overload
    def get_item(self, key : Literal["045"]) -> Optional[NonSpare_163]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_195]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_114]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_370]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_297]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_230]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_228]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_267]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_130]:
        ...
    @overload
    def get_item(self, key : Literal["171"]) -> Optional[NonSpare_382]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_286]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_34.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_3.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_58.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_94.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_136.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["045"], val : NonSpare_163.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_195.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_114.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_370.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_297.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_230.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_225.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_228.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_267.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_130.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["171"], val : NonSpare_382.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_286.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_14':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_14':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["045"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["171"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_14':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_14':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_14.cv_arg") -> 'Record_14':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_14", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_14(UapSingle):
    cv_arg: TypeAlias = Record_14
    cv_record: TypeAlias = Record_14

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_14]]:
        return cls._parse(bs)

class Asterix_6(AstCat):
    cv_category = 4
    cv_edition = (1, 12)
    cv_uap: TypeAlias = Uap_14
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_14.cv_arg]) -> "Asterix_6":
        return cls._create(records) # type: ignore

class Content_575(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Alive Message (AM)", 2: "Route Adherence Monitor Longitudinal Deviation (RAMLD)", 3: "Route Adherence Monitor Heading Deviation (RAMHD)", 4: "Minimum Safe Altitude Warning (MSAW)", 5: "Area Proximity Warning (APW)", 6: "Clearance Level Adherence Monitor (CLAM)", 7: "Short Term Conflict Alert (STCA)", 8: "Approach Path Monitor (APM)", 9: "RIMCAS Arrival / Landing Monitor (ALM)", 10: "RIMCAS Arrival / Departure Wrong Runway Alert (WRA)", 11: "RIMCAS Arrival / Departure Opposite Traffic Alert (OTA)", 12: "RIMCAS Departure Monitor (RDM)", 13: "RIMCAS Runway / Taxiway Crossing Monitor (RCM)", 14: "RIMCAS Taxiway Separation Monitor (TSM)", 15: "RIMCAS Unauthorized Taxiway Movement Monitor(UTMM)", 16: "RIMCAS Stop Bar Overrun Alert (SBOA)", 17: "End Of Conflict (EOC)", 18: "ACAS Resolution Advisory (ACASRA)", 19: "Near Term Conflict Alert (NTCA)", 20: "Downlinked Barometric Pressure Setting Monitor (DBPSM)", 21: "Speed Adherence Monitor (SAM)", 22: "Outside Controlled Airspace Tool (OCAT)", 23: "Vertical Conflict Detection (VCD)", 24: "Vertical Rate Adherence Monitor (VRAM)", 25: "Cleared Heading Adherence Monitor (CHAM)", 26: "Downlinked Selected Altitude Monitor (DSAM)", 27: "Holding Adherence Monitor (HAM)", 28: "Vertical Path Monitor (VPM)", 29: "RIMCAS Taxiway Traffic Alert (TTA)", 30: "RIMCAS Arrival/Departure Close Runway Alert (CRA)", 31: "RIMCAS Arrival/Departure Aircraft Separation Monitor (ASM)", 32: "RIMCAS ILS Area Violation Monitor (IAVM)", 33: "Final Target Distance Indicator (FTD)", 34: "Initial Target Distance Indicator (ITD)", 35: "Wake Vortex Indicator Infringement Alert (IIA)", 36: "Sequence Warning (SQW)", 37: "Catch Up Warning (CUW)", 38: "Conflicting ATC Clearances (CATC)", 39: "No ATC Clearance (NOCLR)", 40: "Aircraft Not Moving despite ATC Clearance (NOMOV)", 41: "Aircraft leaving/entering the aerodrome area without proper handover (NOH)", 42: "Wrong Runway or Taxiway Type (WRTY)", 43: "Stand Occupied (STOCC)", 44: "Ongoing Alert (ONGOING)", 45: "Non-Transgression Zone Violation (NTZ)", 97: "Lost Track Warning (LTW)", 98: "Holding Volume Infringement (HVI)", 99: "Airspace Infringement Warning (AIW)"}

class RuleContent_575(RuleContentContextFree):
    cv_arg: TypeAlias = Content_575.cv_arg
    cv_content: TypeAlias = Content_575

    @property
    def content(self) -> Content_575:
        return self._get_content() # type: ignore

class Variation_179(Element):
    cv_arg: TypeAlias = RuleContent_575.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_575

    @classmethod
    def create(cls, arg: "Variation_179.cv_arg") -> "Variation_179":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_575:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_575:
        return self.rule.content

class RuleVariation_172(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_179.cv_arg
    cv_variation: TypeAlias = Variation_179

    @classmethod
    def create(cls, arg : "RuleVariation_172.cv_arg") -> "RuleVariation_172":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_179:
        return self.arg # type: ignore

class NonSpare_2(NonSpare):
    cv_arg: TypeAlias = RuleVariation_172.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_172

    @classmethod
    def create(cls, arg : "NonSpare_2.cv_arg") -> "NonSpare_2":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_172:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_179:
        return self.rule.variation

class UapItem_2(UapItem):
    cv_non_spare: TypeAlias = NonSpare_2

class NonSpare_93(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "020"
    cv_title = "Time of Message"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_93.cv_arg") -> "NonSpare_93":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_93(UapItem):
    cv_non_spare: TypeAlias = NonSpare_93

class Content_204(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Element not populated", 1: "Element populated"}

class RuleContent_204(RuleContentContextFree):
    cv_arg: TypeAlias = Content_204.cv_arg
    cv_content: TypeAlias = Content_204

    @property
    def content(self) -> Content_204:
        return self._get_content() # type: ignore

class Variation_42(Element):
    cv_arg: TypeAlias = RuleContent_204.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_204

    @classmethod
    def create(cls, arg: "Variation_42.cv_arg") -> "Variation_42":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_204:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_204:
        return self.rule.content

class RuleVariation_42(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_42.cv_arg
    cv_variation: TypeAlias = Variation_42

    @classmethod
    def create(cls, arg : "RuleVariation_42.cv_arg") -> "RuleVariation_42":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_42:
        return self.arg # type: ignore

class NonSpare_941(NonSpare):
    cv_arg: TypeAlias = RuleVariation_42.cv_arg
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_42

    @classmethod
    def create(cls, arg : "NonSpare_941.cv_arg") -> "NonSpare_941":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_42:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_42:
        return self.rule.variation

class Item_302(Item):
    cv_arg: TypeAlias = NonSpare_941.cv_arg
    cv_non_spare: TypeAlias = NonSpare_941

    @classmethod
    def create(cls, arg : "Item_302.cv_arg") -> "Item_302":
        return cls._create(arg) # type: ignore

class Content_243(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Inactive", 1: "Active", 2: "Pre-active", 3: "Reserved for Future Use", 4: "Reserved for Future Use", 5: "Reserved for Future Use", 6: "Reserved for Future Use", 7: "Reserved for Future Use"}

class RuleContent_243(RuleContentContextFree):
    cv_arg: TypeAlias = Content_243.cv_arg
    cv_content: TypeAlias = Content_243

    @property
    def content(self) -> Content_243:
        return self._get_content() # type: ignore

class Variation_483(Element):
    cv_arg: TypeAlias = RuleContent_243.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_243

    @classmethod
    def create(cls, arg: "Variation_483.cv_arg") -> "Variation_483":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_243:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_243:
        return self.rule.content

class RuleVariation_472(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_483.cv_arg
    cv_variation: TypeAlias = Variation_483

    @classmethod
    def create(cls, arg : "RuleVariation_472.cv_arg") -> "RuleVariation_472":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_483:
        return self.arg # type: ignore

class NonSpare_1996(NonSpare):
    cv_arg: TypeAlias = RuleVariation_472.cv_arg
    cv_name = "VAL"
    cv_title = "Area Status Value"
    cv_rule: TypeAlias = RuleVariation_472

    @classmethod
    def create(cls, arg : "NonSpare_1996.cv_arg") -> "NonSpare_1996":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_472:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_483:
        return self.rule.variation

class Item_1106(Item):
    cv_arg: TypeAlias = NonSpare_1996.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1996

    @classmethod
    def create(cls, arg : "Item_1106.cv_arg") -> "Item_1106":
        return cls._create(arg) # type: ignore

class Variation_1092(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_472.cv_arg, Tuple[Literal["VAL"], RuleVariation_472.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1092.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_items_list = [(Item_302, 1), (Item_1106, 3)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_472}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_472:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_472:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1092.cv_arg") -> 'Variation_1092':
        return cls._create(arg) # type: ignore

class RuleVariation_1050(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1092.cv_arg
    cv_variation: TypeAlias = Variation_1092

    @classmethod
    def create(cls, arg : "RuleVariation_1050.cv_arg") -> "RuleVariation_1050":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1092:
        return self.arg # type: ignore

class NonSpare_631(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1050.cv_arg
    cv_name = "AREA"
    cv_title = "Area Status"
    cv_rule: TypeAlias = RuleVariation_1050

    @classmethod
    def create(cls, arg : "NonSpare_631.cv_arg") -> "NonSpare_631":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1050:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1092:
        return self.rule.variation

class Item_84(Item):
    cv_arg: TypeAlias = NonSpare_631.cv_arg
    cv_non_spare: TypeAlias = NonSpare_631

    @classmethod
    def create(cls, arg : "Item_84.cv_arg") -> "Item_84":
        return cls._create(arg) # type: ignore

class Variation_1054(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_1050.cv_arg, Tuple[Literal["AREA"], RuleVariation_1050.cv_arg]], Union[RuleVariation_763.cv_arg, Tuple[Literal["STAT"], RuleVariation_763.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1054.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_84, 4), (Item_944, 3), (Item_29, 1)]
    cv_items_dict = {"AREA": RuleVariation_1050, "STAT": RuleVariation_763}

    @overload
    @classmethod
    def spec(cls, key : Literal["AREA"]) -> RuleVariation_1050:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_763:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AREA"], Literal["STAT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AREA"]) -> RuleVariation_1050:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_763:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1054.cv_arg") -> 'Variation_1054':
        return cls._create(arg) # type: ignore

class RuleVariation_1021(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1054.cv_arg
    cv_variation: TypeAlias = Variation_1054

    @classmethod
    def create(cls, arg : "RuleVariation_1021.cv_arg") -> "RuleVariation_1021":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1054:
        return self.arg # type: ignore

class NonSpare_164(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1021.cv_arg
    cv_name = "045"
    cv_title = "Area and Alert Status"
    cv_rule: TypeAlias = RuleVariation_1021

    @classmethod
    def create(cls, arg : "NonSpare_164.cv_arg") -> "NonSpare_164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1021:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1054:
        return self.rule.variation

class UapItem_164(UapItem):
    cv_non_spare: TypeAlias = NonSpare_164

class Content_133(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Non-Transgression Zone Function"}

class RuleContent_133(RuleContentContextFree):
    cv_arg: TypeAlias = Content_133.cv_arg
    cv_content: TypeAlias = Content_133

    @property
    def content(self) -> Content_133:
        return self._get_content() # type: ignore

class Variation_34(Element):
    cv_arg: TypeAlias = RuleContent_133.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_133

    @classmethod
    def create(cls, arg: "Variation_34.cv_arg") -> "Variation_34":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_133:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_133:
        return self.rule.content

class RuleVariation_34(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_34.cv_arg
    cv_variation: TypeAlias = Variation_34

    @classmethod
    def create(cls, arg : "RuleVariation_34.cv_arg") -> "RuleVariation_34":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_34:
        return self.arg # type: ignore

class NonSpare_1382(NonSpare):
    cv_arg: TypeAlias = RuleVariation_34.cv_arg
    cv_name = "NTZ"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_34

    @classmethod
    def create(cls, arg : "NonSpare_1382.cv_arg") -> "NonSpare_1382":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_34:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_34:
        return self.rule.variation

class Item_641(Item):
    cv_arg: TypeAlias = NonSpare_1382.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1382

    @classmethod
    def create(cls, arg : "Item_641.cv_arg") -> "Item_641":
        return cls._create(arg) # type: ignore

class Variation_1372(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_32.cv_arg, Tuple[Literal["MRVA"], RuleVariation_32.cv_arg]], Union[RuleVariation_405.cv_arg, Tuple[Literal["RAMLD"], RuleVariation_405.cv_arg]], Union[RuleVariation_513.cv_arg, Tuple[Literal["RAMHD"], RuleVariation_513.cv_arg]], Union[RuleVariation_615.cv_arg, Tuple[Literal["MSAW"], RuleVariation_615.cv_arg]], Union[RuleVariation_694.cv_arg, Tuple[Literal["APW"], RuleVariation_694.cv_arg]], Union[RuleVariation_800.cv_arg, Tuple[Literal["CLAM"], RuleVariation_800.cv_arg]], Union[RuleVariation_889.cv_arg, Tuple[Literal["STCA"], RuleVariation_889.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_24.cv_arg, Tuple[Literal["APM"], RuleVariation_24.cv_arg]], Union[RuleVariation_406.cv_arg, Tuple[Literal["RIMCA"], RuleVariation_406.cv_arg]], Union[RuleVariation_503.cv_arg, Tuple[Literal["ACASRA"], RuleVariation_503.cv_arg]], Union[RuleVariation_620.cv_arg, Tuple[Literal["NTCA"], RuleVariation_620.cv_arg]], Union[RuleVariation_700.cv_arg, Tuple[Literal["DG"], RuleVariation_700.cv_arg]], Union[RuleVariation_804.cv_arg, Tuple[Literal["OF"], RuleVariation_804.cv_arg]], Union[RuleVariation_886.cv_arg, Tuple[Literal["OL"], RuleVariation_886.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_23.cv_arg, Tuple[Literal["AIW"], RuleVariation_23.cv_arg]], Union[RuleVariation_404.cv_arg, Tuple[Literal["PAIW"], RuleVariation_404.cv_arg]], Union[RuleVariation_511.cv_arg, Tuple[Literal["OCAT"], RuleVariation_511.cv_arg]], Union[RuleVariation_621.cv_arg, Tuple[Literal["SAM"], RuleVariation_621.cv_arg]], Union[RuleVariation_701.cv_arg, Tuple[Literal["VCD"], RuleVariation_701.cv_arg]], Union[RuleVariation_799.cv_arg, Tuple[Literal["CHAM"], RuleVariation_799.cv_arg]], Union[RuleVariation_880.cv_arg, Tuple[Literal["DSAM"], RuleVariation_880.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_27.cv_arg, Tuple[Literal["DBPSMARR"], RuleVariation_27.cv_arg]], Union[RuleVariation_395.cv_arg, Tuple[Literal["DBPSMDEP"], RuleVariation_395.cv_arg]], Union[RuleVariation_505.cv_arg, Tuple[Literal["DBPSMTL"], RuleVariation_505.cv_arg]], Union[RuleVariation_623.cv_arg, Tuple[Literal["VRAMCRM"], RuleVariation_623.cv_arg]], Union[RuleVariation_703.cv_arg, Tuple[Literal["VRAMVTM"], RuleVariation_703.cv_arg]], Union[RuleVariation_811.cv_arg, Tuple[Literal["VRAMVRM"], RuleVariation_811.cv_arg]], Union[RuleVariation_883.cv_arg, Tuple[Literal["HAMHD"], RuleVariation_883.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_29.cv_arg, Tuple[Literal["HAMRD"], RuleVariation_29.cv_arg]], Union[RuleVariation_398.cv_arg, Tuple[Literal["HAMVD"], RuleVariation_398.cv_arg]], Union[RuleVariation_507.cv_arg, Tuple[Literal["HVI"], RuleVariation_507.cv_arg]], Union[RuleVariation_614.cv_arg, Tuple[Literal["LTW"], RuleVariation_614.cv_arg]], Union[RuleVariation_702.cv_arg, Tuple[Literal["VPM"], RuleVariation_702.cv_arg]], Union[RuleVariation_809.cv_arg, Tuple[Literal["TTA"], RuleVariation_809.cv_arg]], Union[RuleVariation_878.cv_arg, Tuple[Literal["CRA"], RuleVariation_878.cv_arg]], None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_25.cv_arg, Tuple[Literal["ASM"], RuleVariation_25.cv_arg]], Union[RuleVariation_399.cv_arg, Tuple[Literal["IAVM"], RuleVariation_399.cv_arg]], Union[RuleVariation_506.cv_arg, Tuple[Literal["FTD"], RuleVariation_506.cv_arg]], Union[RuleVariation_612.cv_arg, Tuple[Literal["ITD"], RuleVariation_612.cv_arg]], Union[RuleVariation_696.cv_arg, Tuple[Literal["IIA"], RuleVariation_696.cv_arg]], Union[RuleVariation_806.cv_arg, Tuple[Literal["SQW"], RuleVariation_806.cv_arg]], Union[RuleVariation_879.cv_arg, Tuple[Literal["CUW"], RuleVariation_879.cv_arg]], None]]
    cv_arg_group_7: TypeAlias = Union[int, Tuple[Union[RuleVariation_26.cv_arg, Tuple[Literal["CATC"], RuleVariation_26.cv_arg]], Union[RuleVariation_403.cv_arg, Tuple[Literal["NOCLR"], RuleVariation_403.cv_arg]], Union[RuleVariation_510.cv_arg, Tuple[Literal["NOMOV"], RuleVariation_510.cv_arg]], Union[RuleVariation_619.cv_arg, Tuple[Literal["NOH"], RuleVariation_619.cv_arg]], Union[RuleVariation_704.cv_arg, Tuple[Literal["WRTY"], RuleVariation_704.cv_arg]], Union[RuleVariation_807.cv_arg, Tuple[Literal["STOCC"], RuleVariation_807.cv_arg]], Union[RuleVariation_885.cv_arg, Tuple[Literal["ONGOING"], RuleVariation_885.cv_arg]], None]]
    cv_arg_group_8: TypeAlias = Union[int, Tuple[Union[RuleVariation_34.cv_arg, Tuple[Literal["NTZ"], RuleVariation_34.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1372.cv_arg_group_1"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2", "Variation_1372.cv_arg_group_3"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2", "Variation_1372.cv_arg_group_3", "Variation_1372.cv_arg_group_4"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2", "Variation_1372.cv_arg_group_3", "Variation_1372.cv_arg_group_4", "Variation_1372.cv_arg_group_5"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2", "Variation_1372.cv_arg_group_3", "Variation_1372.cv_arg_group_4", "Variation_1372.cv_arg_group_5", "Variation_1372.cv_arg_group_6"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2", "Variation_1372.cv_arg_group_3", "Variation_1372.cv_arg_group_4", "Variation_1372.cv_arg_group_5", "Variation_1372.cv_arg_group_6", "Variation_1372.cv_arg_group_7"],
        Tuple["Variation_1372.cv_arg_group_1", "Variation_1372.cv_arg_group_2", "Variation_1372.cv_arg_group_3", "Variation_1372.cv_arg_group_4", "Variation_1372.cv_arg_group_5", "Variation_1372.cv_arg_group_6", "Variation_1372.cv_arg_group_7", "Variation_1372.cv_arg_group_8"],
    ]
    cv_items_list = [[(Item_584, 1), (Item_777, 1), (Item_776, 1), (Item_587, 1), (Item_78, 1), (Item_162, 1), (Item_948, 1), None], [(Item_77, 1), (Item_822, 1), (Item_40, 1), (Item_640, 1), (Item_260, 1), (Item_655, 1), (Item_656, 1), None], [(Item_56, 1), (Item_678, 1), (Item_649, 1), (Item_859, 1), (Item_1138, 1), (Item_155, 1), (Item_276, 1), None], [(Item_243, 1), (Item_245, 1), (Item_247, 1), (Item_1149, 1), (Item_1152, 1), (Item_1151, 1), (Item_382, 1), None], [(Item_384, 1), (Item_386, 1), (Item_407, 1), (Item_510, 1), (Item_1147, 1), (Item_1061, 1), (Item_214, 1), None], [(Item_87, 1), (Item_423, 1), (Item_351, 1), (Item_441, 1), (Item_434, 1), (Item_917, 1), (Item_232, 1), None], [(Item_137, 1), (Item_623, 1), (Item_636, 1), (Item_631, 1), (Item_1168, 1), (Item_954, 1), (Item_658, 1), None], [(Item_641, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1372.cv_arg") -> 'Variation_1372':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MRVA"]) -> RuleVariation_32:
        ...
    @overload
    def get_item(self, key : Literal["RAMLD"]) -> RuleVariation_405:
        ...
    @overload
    def get_item(self, key : Literal["RAMHD"]) -> RuleVariation_513:
        ...
    @overload
    def get_item(self, key : Literal["MSAW"]) -> RuleVariation_615:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> RuleVariation_694:
        ...
    @overload
    def get_item(self, key : Literal["CLAM"]) -> RuleVariation_800:
        ...
    @overload
    def get_item(self, key : Literal["STCA"]) -> RuleVariation_889:
        ...
    @overload
    def get_item(self, key : Literal["APM"]) -> Optional[RuleVariation_24]:
        ...
    @overload
    def get_item(self, key : Literal["RIMCA"]) -> Optional[RuleVariation_406]:
        ...
    @overload
    def get_item(self, key : Literal["ACASRA"]) -> Optional[RuleVariation_503]:
        ...
    @overload
    def get_item(self, key : Literal["NTCA"]) -> Optional[RuleVariation_620]:
        ...
    @overload
    def get_item(self, key : Literal["DG"]) -> Optional[RuleVariation_700]:
        ...
    @overload
    def get_item(self, key : Literal["OF"]) -> Optional[RuleVariation_804]:
        ...
    @overload
    def get_item(self, key : Literal["OL"]) -> Optional[RuleVariation_886]:
        ...
    @overload
    def get_item(self, key : Literal["AIW"]) -> Optional[RuleVariation_23]:
        ...
    @overload
    def get_item(self, key : Literal["PAIW"]) -> Optional[RuleVariation_404]:
        ...
    @overload
    def get_item(self, key : Literal["OCAT"]) -> Optional[RuleVariation_511]:
        ...
    @overload
    def get_item(self, key : Literal["SAM"]) -> Optional[RuleVariation_621]:
        ...
    @overload
    def get_item(self, key : Literal["VCD"]) -> Optional[RuleVariation_701]:
        ...
    @overload
    def get_item(self, key : Literal["CHAM"]) -> Optional[RuleVariation_799]:
        ...
    @overload
    def get_item(self, key : Literal["DSAM"]) -> Optional[RuleVariation_880]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMARR"]) -> Optional[RuleVariation_27]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMDEP"]) -> Optional[RuleVariation_395]:
        ...
    @overload
    def get_item(self, key : Literal["DBPSMTL"]) -> Optional[RuleVariation_505]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMCRM"]) -> Optional[RuleVariation_623]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVTM"]) -> Optional[RuleVariation_703]:
        ...
    @overload
    def get_item(self, key : Literal["VRAMVRM"]) -> Optional[RuleVariation_811]:
        ...
    @overload
    def get_item(self, key : Literal["HAMHD"]) -> Optional[RuleVariation_883]:
        ...
    @overload
    def get_item(self, key : Literal["HAMRD"]) -> Optional[RuleVariation_29]:
        ...
    @overload
    def get_item(self, key : Literal["HAMVD"]) -> Optional[RuleVariation_398]:
        ...
    @overload
    def get_item(self, key : Literal["HVI"]) -> Optional[RuleVariation_507]:
        ...
    @overload
    def get_item(self, key : Literal["LTW"]) -> Optional[RuleVariation_614]:
        ...
    @overload
    def get_item(self, key : Literal["VPM"]) -> Optional[RuleVariation_702]:
        ...
    @overload
    def get_item(self, key : Literal["TTA"]) -> Optional[RuleVariation_809]:
        ...
    @overload
    def get_item(self, key : Literal["CRA"]) -> Optional[RuleVariation_878]:
        ...
    @overload
    def get_item(self, key : Literal["ASM"]) -> Optional[RuleVariation_25]:
        ...
    @overload
    def get_item(self, key : Literal["IAVM"]) -> Optional[RuleVariation_399]:
        ...
    @overload
    def get_item(self, key : Literal["FTD"]) -> Optional[RuleVariation_506]:
        ...
    @overload
    def get_item(self, key : Literal["ITD"]) -> Optional[RuleVariation_612]:
        ...
    @overload
    def get_item(self, key : Literal["IIA"]) -> Optional[RuleVariation_696]:
        ...
    @overload
    def get_item(self, key : Literal["SQW"]) -> Optional[RuleVariation_806]:
        ...
    @overload
    def get_item(self, key : Literal["CUW"]) -> Optional[RuleVariation_879]:
        ...
    @overload
    def get_item(self, key : Literal["CATC"]) -> Optional[RuleVariation_26]:
        ...
    @overload
    def get_item(self, key : Literal["NOCLR"]) -> Optional[RuleVariation_403]:
        ...
    @overload
    def get_item(self, key : Literal["NOMOV"]) -> Optional[RuleVariation_510]:
        ...
    @overload
    def get_item(self, key : Literal["NOH"]) -> Optional[RuleVariation_619]:
        ...
    @overload
    def get_item(self, key : Literal["WRTY"]) -> Optional[RuleVariation_704]:
        ...
    @overload
    def get_item(self, key : Literal["STOCC"]) -> Optional[RuleVariation_807]:
        ...
    @overload
    def get_item(self, key : Literal["ONGOING"]) -> Optional[RuleVariation_885]:
        ...
    @overload
    def get_item(self, key : Literal["NTZ"]) -> Optional[RuleVariation_34]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1293(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1372.cv_arg
    cv_variation: TypeAlias = Variation_1372

    @classmethod
    def create(cls, arg : "RuleVariation_1293.cv_arg") -> "RuleVariation_1293":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1372:
        return self.arg # type: ignore

class NonSpare_196(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1293.cv_arg
    cv_name = "060"
    cv_title = "Safety Net Function and System Status"
    cv_rule: TypeAlias = RuleVariation_1293

    @classmethod
    def create(cls, arg : "NonSpare_196.cv_arg") -> "NonSpare_196":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1293:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1372:
        return self.rule.variation

class UapItem_196(UapItem):
    cv_non_spare: TypeAlias = NonSpare_196

class NonSpare_1170(NonSpare):
    cv_arg: TypeAlias = RuleVariation_713.cv_arg
    cv_name = "LFP"
    cv_title = "Linear Prediction Filter"
    cv_rule: TypeAlias = RuleVariation_713

    @classmethod
    def create(cls, arg : "NonSpare_1170.cv_arg") -> "NonSpare_1170":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_713:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_724:
        return self.rule.variation

class Item_480(Item):
    cv_arg: TypeAlias = NonSpare_1170.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1170

    @classmethod
    def create(cls, arg : "Item_480.cv_arg") -> "Item_480":
        return cls._create(arg) # type: ignore

class NonSpare_1332(NonSpare):
    cv_arg: TypeAlias = RuleVariation_897.cv_arg
    cv_name = "MSM"
    cv_title = "Mode S Manoeuvre/Prediction Filter"
    cv_rule: TypeAlias = RuleVariation_897

    @classmethod
    def create(cls, arg : "NonSpare_1332.cv_arg") -> "NonSpare_1332":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_897:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_927:
        return self.rule.variation

class Item_596(Item):
    cv_arg: TypeAlias = NonSpare_1332.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1332

    @classmethod
    def create(cls, arg : "Item_596.cv_arg") -> "Item_596":
        return cls._create(arg) # type: ignore

class Variation_1336(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_713.cv_arg, Tuple[Literal["LFP"], RuleVariation_713.cv_arg]], int, Union[RuleVariation_897.cv_arg, Tuple[Literal["MSM"], RuleVariation_897.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1336.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_480, 1), (Item_23, 1), (Item_596, 1)]
    cv_items_dict = {"LFP": RuleVariation_713, "MSM": RuleVariation_897}

    @overload
    @classmethod
    def spec(cls, key : Literal["LFP"]) -> RuleVariation_713:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSM"]) -> RuleVariation_897:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LFP"], Literal["MSM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LFP"]) -> RuleVariation_713:
        ...
    @overload
    def get_item(self, key : Literal["MSM"]) -> RuleVariation_897:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1336.cv_arg") -> 'Variation_1336':
        return cls._create(arg) # type: ignore

class RuleVariation_1443(RuleVariationDependent):
    cv_arg: TypeAlias = Union[
        Variation_774.cv_arg,
        Variation_777.cv_arg,
        Variation_798.cv_arg,
        Variation_1337.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_1338.cv_arg,
        Variation_776.cv_arg,
        Variation_795.cv_arg,
        Variation_796.cv_arg,
        Variation_797.cv_arg,
        Variation_790.cv_arg,
        Variation_778.cv_arg,
        Variation_791.cv_arg,
        Variation_791.cv_arg,
        Variation_782.cv_arg,
        Variation_784.cv_arg,
        Variation_781.cv_arg,
        Variation_792.cv_arg,
        Variation_783.cv_arg,
        Variation_789.cv_arg,
        Variation_793.cv_arg,
        Variation_785.cv_arg,
        Variation_780.cv_arg,
        Variation_786.cv_arg,
        Variation_1336.cv_arg,
    ]
    cv_depends_on = [["000"], ["120", "CC", "TID"]]
    cv_default_variation: TypeAlias = Variation_774
    cv_cases = [
        ([5, 1], Variation_777),
        ([7, 0], Variation_798),
        ([7, 1], Variation_1337),
        ([9, 2], Variation_1338),
        ([10, 2], Variation_1338),
        ([11, 2], Variation_1338),
        ([12, 2], Variation_1338),
        ([13, 2], Variation_1338),
        ([14, 2], Variation_1338),
        ([15, 2], Variation_1338),
        ([16, 2], Variation_1338),
        ([15, 1], Variation_776),
        ([24, 1], Variation_795),
        ([24, 2], Variation_796),
        ([26, 1], Variation_797),
        ([27, 1], Variation_790),
        ([27, 2], Variation_778),
        ([33, 1], Variation_791),
        ([34, 1], Variation_791),
        ([35, 1], Variation_782),
        ([38, 0], Variation_784),
        ([38, 1], Variation_781),
        ([38, 2], Variation_792),
        ([38, 3], Variation_783),
        ([38, 4], Variation_789),
        ([38, 5], Variation_793),
        ([39, 1], Variation_785),
        ([40, 1], Variation_780),
        ([41, 1], Variation_786),
        ([45, 1], Variation_1336),
    ]

    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[5], Literal[1]]) -> Variation_777:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[7], Literal[0]]) -> Variation_798:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[7], Literal[1]]) -> Variation_1337:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[9], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[10], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[11], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[12], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[13], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[14], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[15], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[16], Literal[2]]) -> Variation_1338:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[15], Literal[1]]) -> Variation_776:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[24], Literal[1]]) -> Variation_795:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[24], Literal[2]]) -> Variation_796:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[26], Literal[1]]) -> Variation_797:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[27], Literal[1]]) -> Variation_790:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[27], Literal[2]]) -> Variation_778:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[33], Literal[1]]) -> Variation_791:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[34], Literal[1]]) -> Variation_791:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[35], Literal[1]]) -> Variation_782:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[0]]) -> Variation_784:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[1]]) -> Variation_781:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[2]]) -> Variation_792:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[3]]) -> Variation_783:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[4]]) -> Variation_789:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[38], Literal[5]]) -> Variation_793:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[39], Literal[1]]) -> Variation_785:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[40], Literal[1]]) -> Variation_780:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[41], Literal[1]]) -> Variation_786:
        ...
    @overload
    @classmethod
    def variation(cls, key : Tuple[Literal[45], Literal[1]]) -> Variation_1336:
        ...

    @classmethod
    def variation(cls, key : Any) -> Any:
        return cls._variation(key)

    @classmethod
    def create(cls, arg : "RuleVariation_1443.cv_arg") -> "RuleVariation_1443":
        return cls._create(arg) # type: ignore

class NonSpare_818(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1443.cv_arg
    cv_name = "CPC"
    cv_title = "Conflict Properties Class"
    cv_rule: TypeAlias = RuleVariation_1443

    @classmethod
    def create(cls, arg : "NonSpare_818.cv_arg") -> "NonSpare_818":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1443:
        return self.arg # type: ignore

class Item_208(Item):
    cv_arg: TypeAlias = NonSpare_818.cv_arg
    cv_non_spare: TypeAlias = NonSpare_818

    @classmethod
    def create(cls, arg : "Item_208.cv_arg") -> "Item_208":
        return cls._create(arg) # type: ignore

class Variation_1225(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["TID"], RuleVariation_132.cv_arg]], Union[RuleVariation_1443.cv_arg, Tuple[Literal["CPC"], RuleVariation_1443.cv_arg]], Union[RuleVariation_952.cv_arg, Tuple[Literal["CS"], RuleVariation_952.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1225.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_998, 4), (Item_208, 3), (Item_219, 1)]
    cv_items_dict = {"TID": RuleVariation_132, "CPC": RuleVariation_1443, "CS": RuleVariation_952}

    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> RuleVariation_1443:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> RuleVariation_952:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TID"], Literal["CPC"], Literal["CS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> RuleVariation_1443:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> RuleVariation_952:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1225.cv_arg") -> 'Variation_1225':
        return cls._create(arg) # type: ignore

class RuleVariation_1165(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1225.cv_arg
    cv_variation: TypeAlias = Variation_1225

    @classmethod
    def create(cls, arg : "RuleVariation_1165.cv_arg") -> "RuleVariation_1165":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1225:
        return self.arg # type: ignore

class NonSpare_711(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1165.cv_arg
    cv_name = "CC"
    cv_title = "Conflict Classification"
    cv_rule: TypeAlias = RuleVariation_1165

    @classmethod
    def create(cls, arg : "NonSpare_711.cv_arg") -> "NonSpare_711":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1165:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1225:
        return self.rule.variation

class Variation_1480(Compound):
    cv_arg = TypedDict('cv_arg', {
        "CN": NonSpare_746.cv_arg,
        "CC": NonSpare_711.cv_arg,
        "CP": NonSpare_815.cv_arg,
        "CD": NonSpare_713.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_746, NonSpare_711, NonSpare_815, NonSpare_713]
    cv_items_dict = {"CN": NonSpare_746, "CC": NonSpare_711, "CP": NonSpare_815, "CD": NonSpare_713}

    @overload
    @classmethod
    def spec(cls, key : Literal["CN"]) -> NonSpare_746:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CC"]) -> NonSpare_711:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CP"]) -> NonSpare_815:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CD"]) -> NonSpare_713:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CN"], Literal["CC"], Literal["CP"], Literal["CD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CN"]) -> Optional[NonSpare_746]:
        ...
    @overload
    def get_item(self, key : Literal["CC"]) -> Optional[NonSpare_711]:
        ...
    @overload
    def get_item(self, key : Literal["CP"]) -> Optional[NonSpare_815]:
        ...
    @overload
    def get_item(self, key : Literal["CD"]) -> Optional[NonSpare_713]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CN"], val : NonSpare_746.cv_arg) -> "Variation_1480":
        ...
    @overload
    def set_item(self, key : Literal["CC"], val : NonSpare_711.cv_arg) -> "Variation_1480":
        ...
    @overload
    def set_item(self, key : Literal["CP"], val : NonSpare_815.cv_arg) -> "Variation_1480":
        ...
    @overload
    def set_item(self, key : Literal["CD"], val : NonSpare_713.cv_arg) -> "Variation_1480":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CN"]) -> "Variation_1480":
        ...
    @overload
    def del_item(self, key : Literal["CC"]) -> "Variation_1480":
        ...
    @overload
    def del_item(self, key : Literal["CP"]) -> "Variation_1480":
        ...
    @overload
    def del_item(self, key : Literal["CD"]) -> "Variation_1480":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1480.cv_arg") -> 'Variation_1480':
        return cls._create(arg) # type: ignore

class RuleVariation_1401(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1480.cv_arg
    cv_variation: TypeAlias = Variation_1480

    @classmethod
    def create(cls, arg : "RuleVariation_1401.cv_arg") -> "RuleVariation_1401":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1480:
        return self.arg # type: ignore

class NonSpare_298(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1401.cv_arg
    cv_name = "120"
    cv_title = "Conflict Characteristics"
    cv_rule: TypeAlias = RuleVariation_1401

    @classmethod
    def create(cls, arg : "NonSpare_298.cv_arg") -> "NonSpare_298":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1401:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1480:
        return self.rule.variation

class UapItem_298(UapItem):
    cv_non_spare: TypeAlias = NonSpare_298

class Record_13(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_34.cv_arg,
        "000": NonSpare_2.cv_arg,
        "015": NonSpare_58.cv_arg,
        "020": NonSpare_93.cv_arg,
        "040": NonSpare_136.cv_arg,
        "045": NonSpare_164.cv_arg,
        "060": NonSpare_196.cv_arg,
        "030": NonSpare_114.cv_arg,
        "170": NonSpare_370.cv_arg,
        "120": NonSpare_298.cv_arg,
        "070": NonSpare_204.cv_arg,
        "076": NonSpare_230.cv_arg,
        "074": NonSpare_225.cv_arg,
        "075": NonSpare_228.cv_arg,
        "100": NonSpare_267.cv_arg,
        "035": NonSpare_130.cv_arg,
        "171": NonSpare_382.cv_arg,
        "110": NonSpare_286.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_34, UapItem_2, UapItem_58, UapItem_93, UapItem_136, UapItem_164, UapItem_196, UapItem_114, UapItem_370, UapItem_298, UapItem_204, UapItem_230, UapItem_225, UapItem_228, UapItem_267, UapItem_130, UapItem_382, UapItem_286, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_34, "000": NonSpare_2, "015": NonSpare_58, "020": NonSpare_93, "040": NonSpare_136, "045": NonSpare_164, "060": NonSpare_196, "030": NonSpare_114, "170": NonSpare_370, "120": NonSpare_298, "070": NonSpare_204, "076": NonSpare_230, "074": NonSpare_225, "075": NonSpare_228, "100": NonSpare_267, "035": NonSpare_130, "171": NonSpare_382, "110": NonSpare_286, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_34:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_2:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_93:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["045"]) -> NonSpare_164:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_114:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_370:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_298:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_230:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_267:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_130:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["171"]) -> NonSpare_382:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_286:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["020"], Literal["040"], Literal["045"], Literal["060"], Literal["030"], Literal["170"], Literal["120"], Literal["070"], Literal["076"], Literal["074"], Literal["075"], Literal["100"], Literal["035"], Literal["171"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_34]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_2]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_58]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_93]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_136]:
        ...
    @overload
    def get_item(self, key : Literal["045"]) -> Optional[NonSpare_164]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_196]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_114]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_370]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_298]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_204]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_230]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_225]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_228]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_267]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_130]:
        ...
    @overload
    def get_item(self, key : Literal["171"]) -> Optional[NonSpare_382]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_286]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_34.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_2.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_58.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_93.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_136.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["045"], val : NonSpare_164.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_196.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_114.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_370.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_298.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_204.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_230.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_225.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_228.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_267.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_130.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["171"], val : NonSpare_382.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_286.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_13':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_13':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["045"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["171"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_13':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_13':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_13.cv_arg") -> 'Record_13':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_13", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_13(UapSingle):
    cv_arg: TypeAlias = Record_13
    cv_record: TypeAlias = Record_13

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_13]]:
        return cls._parse(bs)

class Asterix_7(AstCat):
    cv_category = 4
    cv_edition = (1, 13)
    cv_uap: TypeAlias = Uap_13
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_13.cv_arg]) -> "Asterix_7":
        return cls._create(records) # type: ignore

class Content_592(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Polar vector", 2: "Cartesian vector of start point/length", 3: "Contour record", 4: "Cartesian start point and end point vector", 254: "SOP message", 255: "EOP message"}

class RuleContent_592(RuleContentContextFree):
    cv_arg: TypeAlias = Content_592.cv_arg
    cv_content: TypeAlias = Content_592

    @property
    def content(self) -> Content_592:
        return self._get_content() # type: ignore

class Variation_192(Element):
    cv_arg: TypeAlias = RuleContent_592.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_592

    @classmethod
    def create(cls, arg: "Variation_192.cv_arg") -> "Variation_192":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_592:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_592:
        return self.rule.content

class RuleVariation_185(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_192.cv_arg
    cv_variation: TypeAlias = Variation_192

    @classmethod
    def create(cls, arg : "RuleVariation_185.cv_arg") -> "RuleVariation_185":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_192:
        return self.arg # type: ignore

class NonSpare_8(NonSpare):
    cv_arg: TypeAlias = RuleVariation_185.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_185

    @classmethod
    def create(cls, arg : "NonSpare_8.cv_arg") -> "NonSpare_8":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_185:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_192:
        return self.rule.variation

class UapItem_8(UapItem):
    cv_non_spare: TypeAlias = NonSpare_8

class Content_259(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Local Coordinates", 1: "System Coordinates"}

class RuleContent_259(RuleContentContextFree):
    cv_arg: TypeAlias = Content_259.cv_arg
    cv_content: TypeAlias = Content_259

    @property
    def content(self) -> Content_259:
        return self._get_content() # type: ignore

class Variation_52(Element):
    cv_arg: TypeAlias = RuleContent_259.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_259

    @classmethod
    def create(cls, arg: "Variation_52.cv_arg") -> "Variation_52":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_259:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_259:
        return self.rule.content

class RuleVariation_52(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_52.cv_arg
    cv_variation: TypeAlias = Variation_52

    @classmethod
    def create(cls, arg : "RuleVariation_52.cv_arg") -> "RuleVariation_52":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_52:
        return self.arg # type: ignore

class Variation_488(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_488.cv_arg") -> "Variation_488":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_477(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_488.cv_arg
    cv_variation: TypeAlias = Variation_488

    @classmethod
    def create(cls, arg : "RuleVariation_477.cv_arg") -> "RuleVariation_477":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_488:
        return self.arg # type: ignore

class Content_2(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "0°", 1: "22.5°", 2: "45°", 3: "67.5°", 4: "90°", 5: "112.5°", 6: "135°", 7: "157.5°"}

class RuleContent_2(RuleContentContextFree):
    cv_arg: TypeAlias = Content_2.cv_arg
    cv_content: TypeAlias = Content_2

    @property
    def content(self) -> Content_2:
        return self._get_content() # type: ignore

class Variation_775(Element):
    cv_arg: TypeAlias = RuleContent_2.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_2

    @classmethod
    def create(cls, arg: "Variation_775.cv_arg") -> "Variation_775":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_2:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_2:
        return self.rule.content

class RuleVariation_764(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_775.cv_arg
    cv_variation: TypeAlias = Variation_775

    @classmethod
    def create(cls, arg : "RuleVariation_764.cv_arg") -> "RuleVariation_764":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_775:
        return self.arg # type: ignore

class Content_157(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Test vector"}

class RuleContent_157(RuleContentContextFree):
    cv_arg: TypeAlias = Content_157.cv_arg
    cv_content: TypeAlias = Content_157

    @property
    def content(self) -> Content_157:
        return self._get_content() # type: ignore

class Variation_840(Element):
    cv_arg: TypeAlias = RuleContent_157.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_157

    @classmethod
    def create(cls, arg: "Variation_840.cv_arg") -> "Variation_840":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_157:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_157:
        return self.rule.content

class RuleVariation_810(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_840.cv_arg
    cv_variation: TypeAlias = Variation_840

    @classmethod
    def create(cls, arg : "RuleVariation_810.cv_arg") -> "RuleVariation_810":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_840:
        return self.arg # type: ignore

class Content_95(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Error condition encountered"}

class RuleContent_95(RuleContentContextFree):
    cv_arg: TypeAlias = Content_95.cv_arg
    cv_content: TypeAlias = Content_95

    @property
    def content(self) -> Content_95:
        return self._get_content() # type: ignore

class Variation_911(Element):
    cv_arg: TypeAlias = RuleContent_95.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_95

    @classmethod
    def create(cls, arg: "Variation_911.cv_arg") -> "Variation_911":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_95:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_95:
        return self.rule.content

class RuleVariation_881(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_911.cv_arg
    cv_variation: TypeAlias = Variation_911

    @classmethod
    def create(cls, arg : "RuleVariation_881.cv_arg") -> "RuleVariation_881":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_911:
        return self.arg # type: ignore

class NonSpare_1402(NonSpare):
    cv_arg: TypeAlias = RuleVariation_52.cv_arg
    cv_name = "ORG"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_52

    @classmethod
    def create(cls, arg : "NonSpare_1402.cv_arg") -> "NonSpare_1402":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_52:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_52:
        return self.rule.variation

class Item_661(Item):
    cv_arg: TypeAlias = NonSpare_1402.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1402

    @classmethod
    def create(cls, arg : "Item_661.cv_arg") -> "Item_661":
        return cls._create(arg) # type: ignore

class NonSpare_1087(NonSpare):
    cv_arg: TypeAlias = RuleVariation_477.cv_arg
    cv_name = "I"
    cv_title = "Intensity Level"
    cv_rule: TypeAlias = RuleVariation_477

    @classmethod
    def create(cls, arg : "NonSpare_1087.cv_arg") -> "NonSpare_1087":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_477:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_488:
        return self.rule.variation

class Item_409(Item):
    cv_arg: TypeAlias = NonSpare_1087.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1087

    @classmethod
    def create(cls, arg : "Item_409.cv_arg") -> "Item_409":
        return cls._create(arg) # type: ignore

class NonSpare_1647(NonSpare):
    cv_arg: TypeAlias = RuleVariation_764.cv_arg
    cv_name = "S"
    cv_title = "Shading Orientation with Respect to North"
    cv_rule: TypeAlias = RuleVariation_764

    @classmethod
    def create(cls, arg : "NonSpare_1647.cv_arg") -> "NonSpare_1647":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_764:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_775:
        return self.rule.variation

class Item_850(Item):
    cv_arg: TypeAlias = NonSpare_1647.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1647

    @classmethod
    def create(cls, arg : "Item_850.cv_arg") -> "Item_850":
        return cls._create(arg) # type: ignore

class NonSpare_1936(NonSpare):
    cv_arg: TypeAlias = RuleVariation_810.cv_arg
    cv_name = "TST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_810

    @classmethod
    def create(cls, arg : "NonSpare_1936.cv_arg") -> "NonSpare_1936":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_810:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_840:
        return self.rule.variation

class Item_1053(Item):
    cv_arg: TypeAlias = NonSpare_1936.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1936

    @classmethod
    def create(cls, arg : "Item_1053.cv_arg") -> "Item_1053":
        return cls._create(arg) # type: ignore

class NonSpare_956(NonSpare):
    cv_arg: TypeAlias = RuleVariation_881.cv_arg
    cv_name = "ER"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_881

    @classmethod
    def create(cls, arg : "NonSpare_956.cv_arg") -> "NonSpare_956":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_881:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_911:
        return self.rule.variation

class Item_317(Item):
    cv_arg: TypeAlias = NonSpare_956.cv_arg
    cv_non_spare: TypeAlias = NonSpare_956

    @classmethod
    def create(cls, arg : "Item_317.cv_arg") -> "Item_317":
        return cls._create(arg) # type: ignore

class Variation_1379(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_52.cv_arg, Tuple[Literal["ORG"], RuleVariation_52.cv_arg]], Union[RuleVariation_477.cv_arg, Tuple[Literal["I"], RuleVariation_477.cv_arg]], Union[RuleVariation_764.cv_arg, Tuple[Literal["S"], RuleVariation_764.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_810.cv_arg, Tuple[Literal["TST"], RuleVariation_810.cv_arg]], Union[RuleVariation_881.cv_arg, Tuple[Literal["ER"], RuleVariation_881.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1379.cv_arg_group_1"],
        Tuple["Variation_1379.cv_arg_group_1", "Variation_1379.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_661, 1), (Item_409, 3), (Item_850, 3), None], [(Item_4, 5), (Item_1053, 1), (Item_317, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1379.cv_arg") -> 'Variation_1379':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ORG"]) -> RuleVariation_52:
        ...
    @overload
    def get_item(self, key : Literal["I"]) -> RuleVariation_477:
        ...
    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_764:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_810]:
        ...
    @overload
    def get_item(self, key : Literal["ER"]) -> Optional[RuleVariation_881]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1300(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1379.cv_arg
    cv_variation: TypeAlias = Variation_1379

    @classmethod
    def create(cls, arg : "RuleVariation_1300.cv_arg") -> "RuleVariation_1300":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1379:
        return self.arg # type: ignore

class NonSpare_96(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1300.cv_arg
    cv_name = "020"
    cv_title = "Vector Qualifier"
    cv_rule: TypeAlias = RuleVariation_1300

    @classmethod
    def create(cls, arg : "NonSpare_96.cv_arg") -> "NonSpare_96":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1300:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1379:
        return self.rule.variation

class UapItem_96(UapItem):
    cv_non_spare: TypeAlias = NonSpare_96

class Content_612(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Signed

class RuleContent_612(RuleContentContextFree):
    cv_arg: TypeAlias = Content_612.cv_arg
    cv_content: TypeAlias = Content_612

    @property
    def content(self) -> Content_612:
        return self._get_content() # type: ignore

class Variation_204(Element):
    cv_arg: TypeAlias = RuleContent_612.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_612

    @classmethod
    def create(cls, arg: "Variation_204.cv_arg") -> "Variation_204":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_612:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_612:
        return self.rule.content

class RuleVariation_197(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_204.cv_arg
    cv_variation: TypeAlias = Variation_204

    @classmethod
    def create(cls, arg : "RuleVariation_197.cv_arg") -> "RuleVariation_197":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_204:
        return self.arg # type: ignore

class NonSpare_2097(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2097.cv_arg") -> "NonSpare_2097":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1198(Item):
    cv_arg: TypeAlias = NonSpare_2097.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2097

    @classmethod
    def create(cls, arg : "Item_1198.cv_arg") -> "Item_1198":
        return cls._create(arg) # type: ignore

class NonSpare_2151(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2151.cv_arg") -> "NonSpare_2151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1249(Item):
    cv_arg: TypeAlias = NonSpare_2151.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2151

    @classmethod
    def create(cls, arg : "Item_1249.cv_arg") -> "Item_1249":
        return cls._create(arg) # type: ignore

class Variation_205(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_205.cv_arg") -> "Variation_205":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_198(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_205.cv_arg
    cv_variation: TypeAlias = Variation_205

    @classmethod
    def create(cls, arg : "RuleVariation_198.cv_arg") -> "RuleVariation_198":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_205:
        return self.arg # type: ignore

class NonSpare_1169(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "LENGTH"
    cv_title = "Length"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1169.cv_arg") -> "NonSpare_1169":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_479(Item):
    cv_arg: TypeAlias = NonSpare_1169.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1169

    @classmethod
    def create(cls, arg : "Item_479.cv_arg") -> "Item_479":
        return cls._create(arg) # type: ignore

class Variation_1311(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_197.cv_arg, Tuple[Literal["X"], RuleVariation_197.cv_arg]], Union[RuleVariation_197.cv_arg, Tuple[Literal["Y"], RuleVariation_197.cv_arg]], Union[RuleVariation_198.cv_arg, Tuple[Literal["LENGTH"], RuleVariation_198.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1311.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1198, 8), (Item_1249, 8), (Item_479, 8)]
    cv_items_dict = {"X": RuleVariation_197, "Y": RuleVariation_197, "LENGTH": RuleVariation_198}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LENGTH"]) -> RuleVariation_198:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["LENGTH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_197:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_197:
        ...
    @overload
    def get_item(self, key : Literal["LENGTH"]) -> RuleVariation_198:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1311.cv_arg") -> 'Variation_1311':
        return cls._create(arg) # type: ignore

class Variation_1450(Repetitive):
    cv_arg: TypeAlias = List[Variation_1311.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1311

    @classmethod
    def create(cls, arg: "Variation_1450.cv_arg") -> 'Variation_1450':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1311]:
        return self._get_list() # type: ignore

class RuleVariation_1371(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1450.cv_arg
    cv_variation: TypeAlias = Variation_1450

    @classmethod
    def create(cls, arg : "RuleVariation_1371.cv_arg") -> "RuleVariation_1371":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1450:
        return self.arg # type: ignore

class NonSpare_133(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1371.cv_arg
    cv_name = "036"
    cv_title = "Sequence of Cartesian Vectors in SPF Notation"
    cv_rule: TypeAlias = RuleVariation_1371

    @classmethod
    def create(cls, arg : "NonSpare_133.cv_arg") -> "NonSpare_133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1371:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1450:
        return self.rule.variation

class UapItem_133(UapItem):
    cv_non_spare: TypeAlias = NonSpare_133

class NonSpare_1797(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "STR"
    cv_title = "Start Range"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1797.cv_arg") -> "NonSpare_1797":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_957(Item):
    cv_arg: TypeAlias = NonSpare_1797.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1797

    @classmethod
    def create(cls, arg : "Item_957.cv_arg") -> "Item_957":
        return cls._create(arg) # type: ignore

class NonSpare_935(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "ENDR"
    cv_title = "End Range"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_935.cv_arg") -> "NonSpare_935":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_296(Item):
    cv_arg: TypeAlias = NonSpare_935.cv_arg
    cv_non_spare: TypeAlias = NonSpare_935

    @classmethod
    def create(cls, arg : "Item_296.cv_arg") -> "Item_296":
        return cls._create(arg) # type: ignore

class NonSpare_663(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "AZ"
    cv_title = "Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_663.cv_arg") -> "NonSpare_663":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_106(Item):
    cv_arg: TypeAlias = NonSpare_663.cv_arg
    cv_non_spare: TypeAlias = NonSpare_663

    @classmethod
    def create(cls, arg : "Item_106.cv_arg") -> "Item_106":
        return cls._create(arg) # type: ignore

class Variation_1219(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_198.cv_arg, Tuple[Literal["STR"], RuleVariation_198.cv_arg]], Union[RuleVariation_198.cv_arg, Tuple[Literal["ENDR"], RuleVariation_198.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["AZ"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1219.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_957, 8), (Item_296, 8), (Item_106, 16)]
    cv_items_dict = {"STR": RuleVariation_198, "ENDR": RuleVariation_198, "AZ": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["STR"]) -> RuleVariation_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ENDR"]) -> RuleVariation_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZ"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STR"], Literal["ENDR"], Literal["AZ"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STR"]) -> RuleVariation_198:
        ...
    @overload
    def get_item(self, key : Literal["ENDR"]) -> RuleVariation_198:
        ...
    @overload
    def get_item(self, key : Literal["AZ"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1219.cv_arg") -> 'Variation_1219':
        return cls._create(arg) # type: ignore

class Variation_1434(Repetitive):
    cv_arg: TypeAlias = List[Variation_1219.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1219

    @classmethod
    def create(cls, arg: "Variation_1434.cv_arg") -> 'Variation_1434':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1219]:
        return self._get_list() # type: ignore

class RuleVariation_1355(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1434.cv_arg
    cv_variation: TypeAlias = Variation_1434

    @classmethod
    def create(cls, arg : "RuleVariation_1355.cv_arg") -> "RuleVariation_1355":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1434:
        return self.arg # type: ignore

class NonSpare_128(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1355.cv_arg
    cv_name = "034"
    cv_title = "Sequence of Polar Vectors in SPF Notation"
    cv_rule: TypeAlias = RuleVariation_1355

    @classmethod
    def create(cls, arg : "NonSpare_128.cv_arg") -> "NonSpare_128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1355:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1434:
        return self.rule.variation

class UapItem_128(UapItem):
    cv_non_spare: TypeAlias = NonSpare_128

class Variation_482(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_482.cv_arg") -> "Variation_482":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_471(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_482.cv_arg
    cv_variation: TypeAlias = Variation_482

    @classmethod
    def create(cls, arg : "RuleVariation_471.cv_arg") -> "RuleVariation_471":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_482:
        return self.arg # type: ignore

class NonSpare_1086(NonSpare):
    cv_arg: TypeAlias = RuleVariation_471.cv_arg
    cv_name = "I"
    cv_title = "Intensity Level"
    cv_rule: TypeAlias = RuleVariation_471

    @classmethod
    def create(cls, arg : "NonSpare_1086.cv_arg") -> "NonSpare_1086":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_471:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_482:
        return self.rule.variation

class Item_408(Item):
    cv_arg: TypeAlias = NonSpare_1086.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1086

    @classmethod
    def create(cls, arg : "Item_408.cv_arg") -> "Item_408":
        return cls._create(arg) # type: ignore

class Item_20(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 4
    cv_bit_size = 2

class Content_247(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Intermediate record of a contour", 1: "Last record of a contour of at least two records", 2: "First record of a contour of at least two records", 3: "First and only record, fully defining a contour"}

class RuleContent_247(RuleContentContextFree):
    cv_arg: TypeAlias = Content_247.cv_arg
    cv_content: TypeAlias = Content_247

    @property
    def content(self) -> Content_247:
        return self._get_content() # type: ignore

class Variation_961(Element):
    cv_arg: TypeAlias = RuleContent_247.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_247

    @classmethod
    def create(cls, arg: "Variation_961.cv_arg") -> "Variation_961":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_247:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_247:
        return self.rule.content

class RuleVariation_931(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_961.cv_arg
    cv_variation: TypeAlias = Variation_961

    @classmethod
    def create(cls, arg : "RuleVariation_931.cv_arg") -> "RuleVariation_931":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_961:
        return self.arg # type: ignore

class NonSpare_1004(NonSpare):
    cv_arg: TypeAlias = RuleVariation_931.cv_arg
    cv_name = "FSTLST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_931

    @classmethod
    def create(cls, arg : "NonSpare_1004.cv_arg") -> "NonSpare_1004":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_931:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_961:
        return self.rule.variation

class Item_350(Item):
    cv_arg: TypeAlias = NonSpare_1004.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1004

    @classmethod
    def create(cls, arg : "Item_350.cv_arg") -> "Item_350":
        return cls._create(arg) # type: ignore

class NonSpare_836(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "CSN"
    cv_title = "Contour Serial Number"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_836.cv_arg") -> "NonSpare_836":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_220(Item):
    cv_arg: TypeAlias = NonSpare_836.cv_arg
    cv_non_spare: TypeAlias = NonSpare_836

    @classmethod
    def create(cls, arg : "Item_220.cv_arg") -> "Item_220":
        return cls._create(arg) # type: ignore

class Variation_1156(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_52.cv_arg, Tuple[Literal["ORG"], RuleVariation_52.cv_arg]], Union[RuleVariation_471.cv_arg, Tuple[Literal["I"], RuleVariation_471.cv_arg]], int, Union[RuleVariation_931.cv_arg, Tuple[Literal["FSTLST"], RuleVariation_931.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["CSN"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1156.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_661, 1), (Item_408, 3), (Item_20, 2), (Item_350, 2), (Item_220, 8)]
    cv_items_dict = {"ORG": RuleVariation_52, "I": RuleVariation_471, "FSTLST": RuleVariation_931, "CSN": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["ORG"]) -> RuleVariation_52:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I"]) -> RuleVariation_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSTLST"]) -> RuleVariation_931:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ORG"], Literal["I"], Literal["FSTLST"], Literal["CSN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ORG"]) -> RuleVariation_52:
        ...
    @overload
    def get_item(self, key : Literal["I"]) -> RuleVariation_471:
        ...
    @overload
    def get_item(self, key : Literal["FSTLST"]) -> RuleVariation_931:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1156.cv_arg") -> 'Variation_1156':
        return cls._create(arg) # type: ignore

class RuleVariation_1109(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1156.cv_arg
    cv_variation: TypeAlias = Variation_1156

    @classmethod
    def create(cls, arg : "RuleVariation_1109.cv_arg") -> "RuleVariation_1109":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1156:
        return self.arg # type: ignore

class NonSpare_137(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1109.cv_arg
    cv_name = "040"
    cv_title = "Contour Identifier"
    cv_rule: TypeAlias = RuleVariation_1109

    @classmethod
    def create(cls, arg : "NonSpare_137.cv_arg") -> "NonSpare_137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1109:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1156:
        return self.rule.variation

class UapItem_137(UapItem):
    cv_non_spare: TypeAlias = NonSpare_137

class NonSpare_2104(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "X1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2104.cv_arg") -> "NonSpare_2104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1205(Item):
    cv_arg: TypeAlias = NonSpare_2104.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2104

    @classmethod
    def create(cls, arg : "Item_1205.cv_arg") -> "Item_1205":
        return cls._create(arg) # type: ignore

class NonSpare_2158(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "Y1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2158.cv_arg") -> "NonSpare_2158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1256(Item):
    cv_arg: TypeAlias = NonSpare_2158.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2158

    @classmethod
    def create(cls, arg : "Item_1256.cv_arg") -> "Item_1256":
        return cls._create(arg) # type: ignore

class Variation_1318(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_197.cv_arg, Tuple[Literal["X1"], RuleVariation_197.cv_arg]], Union[RuleVariation_197.cv_arg, Tuple[Literal["Y1"], RuleVariation_197.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1318.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1205, 8), (Item_1256, 8)]
    cv_items_dict = {"X1": RuleVariation_197, "Y1": RuleVariation_197}

    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y1"]) -> RuleVariation_197:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X1"], Literal["Y1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_197:
        ...
    @overload
    def get_item(self, key : Literal["Y1"]) -> RuleVariation_197:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1318.cv_arg") -> 'Variation_1318':
        return cls._create(arg) # type: ignore

class Variation_1452(Repetitive):
    cv_arg: TypeAlias = List[Variation_1318.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1318

    @classmethod
    def create(cls, arg: "Variation_1452.cv_arg") -> 'Variation_1452':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1318]:
        return self._get_list() # type: ignore

class RuleVariation_1373(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1452.cv_arg
    cv_variation: TypeAlias = Variation_1452

    @classmethod
    def create(cls, arg : "RuleVariation_1373.cv_arg") -> "RuleVariation_1373":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1452:
        return self.arg # type: ignore

class NonSpare_178(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1373.cv_arg
    cv_name = "050"
    cv_title = "Sequence of Contour Points in SPF Notation"
    cv_rule: TypeAlias = RuleVariation_1373

    @classmethod
    def create(cls, arg : "NonSpare_178.cv_arg") -> "NonSpare_178":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1373:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1452:
        return self.rule.variation

class UapItem_178(UapItem):
    cv_non_spare: TypeAlias = NonSpare_178

class NonSpare_259(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "090"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_259.cv_arg") -> "NonSpare_259":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_259(UapItem):
    cv_non_spare: TypeAlias = NonSpare_259

class Variation_146(Element):
    cv_arg: TypeAlias = RuleContent_612.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_612

    @classmethod
    def create(cls, arg: "Variation_146.cv_arg") -> "Variation_146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_612:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_612:
        return self.rule.content

class RuleVariation_146(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_146.cv_arg
    cv_variation: TypeAlias = Variation_146

    @classmethod
    def create(cls, arg : "RuleVariation_146.cv_arg") -> "RuleVariation_146":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_146:
        return self.arg # type: ignore

class Variation_889(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_889.cv_arg") -> "Variation_889":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_859(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_889.cv_arg
    cv_variation: TypeAlias = Variation_889

    @classmethod
    def create(cls, arg : "RuleVariation_859.cv_arg") -> "RuleVariation_859":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_889:
        return self.arg # type: ignore

class Variation_251(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 15
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_251.cv_arg") -> "Variation_251":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_244(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_251.cv_arg
    cv_variation: TypeAlias = Variation_251

    @classmethod
    def create(cls, arg : "RuleVariation_244.cv_arg") -> "RuleVariation_244":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_251:
        return self.arg # type: ignore

class NonSpare_968(NonSpare):
    cv_arg: TypeAlias = RuleVariation_146.cv_arg
    cv_name = "F"
    cv_title = "Scaling Factor"
    cv_rule: TypeAlias = RuleVariation_146

    @classmethod
    def create(cls, arg : "NonSpare_968.cv_arg") -> "NonSpare_968":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_146:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_146:
        return self.rule.variation

class Item_326(Item):
    cv_arg: TypeAlias = NonSpare_968.cv_arg
    cv_non_spare: TypeAlias = NonSpare_968

    @classmethod
    def create(cls, arg : "Item_326.cv_arg") -> "Item_326":
        return cls._create(arg) # type: ignore

class NonSpare_1531(NonSpare):
    cv_arg: TypeAlias = RuleVariation_859.cv_arg
    cv_name = "R"
    cv_title = "Current Reduction Stage in Use"
    cv_rule: TypeAlias = RuleVariation_859

    @classmethod
    def create(cls, arg : "NonSpare_1531.cv_arg") -> "NonSpare_1531":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_859:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_889:
        return self.rule.variation

class Item_763(Item):
    cv_arg: TypeAlias = NonSpare_1531.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1531

    @classmethod
    def create(cls, arg : "Item_763.cv_arg") -> "Item_763":
        return cls._create(arg) # type: ignore

class NonSpare_1487(NonSpare):
    cv_arg: TypeAlias = RuleVariation_244.cv_arg
    cv_name = "Q"
    cv_title = "Processing Parameters"
    cv_rule: TypeAlias = RuleVariation_244

    @classmethod
    def create(cls, arg : "NonSpare_1487.cv_arg") -> "NonSpare_1487":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class Item_720(Item):
    cv_arg: TypeAlias = NonSpare_1487.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1487

    @classmethod
    def create(cls, arg : "Item_720.cv_arg") -> "Item_720":
        return cls._create(arg) # type: ignore

class Variation_1359(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_146.cv_arg, Tuple[Literal["F"], RuleVariation_146.cv_arg]], Union[RuleVariation_859.cv_arg, Tuple[Literal["R"], RuleVariation_859.cv_arg]], Union[RuleVariation_244.cv_arg, Tuple[Literal["Q"], RuleVariation_244.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1359.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_326, 5), (Item_763, 3), (Item_720, 15), None]]

    @classmethod
    def create(cls, arg: "Variation_1359.cv_arg") -> 'Variation_1359':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["F"]) -> RuleVariation_146:
        ...
    @overload
    def get_item(self, key : Literal["R"]) -> RuleVariation_859:
        ...
    @overload
    def get_item(self, key : Literal["Q"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1280(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1359.cv_arg
    cv_variation: TypeAlias = Variation_1359

    @classmethod
    def create(cls, arg : "RuleVariation_1280.cv_arg") -> "RuleVariation_1280":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1359:
        return self.arg # type: ignore

class NonSpare_275(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1280.cv_arg
    cv_name = "100"
    cv_title = "Processing Status"
    cv_rule: TypeAlias = RuleVariation_1280

    @classmethod
    def create(cls, arg : "NonSpare_275.cv_arg") -> "NonSpare_275":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1359:
        return self.rule.variation

class UapItem_275(UapItem):
    cv_non_spare: TypeAlias = NonSpare_275

class NonSpare_291(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "110"
    cv_title = "Station Configuration Status"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_291.cv_arg") -> "NonSpare_291":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_291(UapItem):
    cv_non_spare: TypeAlias = NonSpare_291

class Variation_256(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_256.cv_arg") -> "Variation_256":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_249(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_256.cv_arg
    cv_variation: TypeAlias = Variation_256

    @classmethod
    def create(cls, arg : "RuleVariation_249.cv_arg") -> "RuleVariation_249":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_256:
        return self.arg # type: ignore

class NonSpare_304(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "120"
    cv_title = "Total Number of Items Constituting One Weather Picture"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_304.cv_arg") -> "NonSpare_304":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_304(UapItem):
    cv_non_spare: TypeAlias = NonSpare_304

class NonSpare_2106(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "X1"
    cv_title = "X1-Component"
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2106.cv_arg") -> "NonSpare_2106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1207(Item):
    cv_arg: TypeAlias = NonSpare_2106.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2106

    @classmethod
    def create(cls, arg : "Item_1207.cv_arg") -> "Item_1207":
        return cls._create(arg) # type: ignore

class NonSpare_2159(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "Y1"
    cv_title = "Y1-Component"
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2159.cv_arg") -> "NonSpare_2159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1257(Item):
    cv_arg: TypeAlias = NonSpare_2159.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2159

    @classmethod
    def create(cls, arg : "Item_1257.cv_arg") -> "Item_1257":
        return cls._create(arg) # type: ignore

class NonSpare_2110(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "X2"
    cv_title = "X2-Component"
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2110.cv_arg") -> "NonSpare_2110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1211(Item):
    cv_arg: TypeAlias = NonSpare_2110.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2110

    @classmethod
    def create(cls, arg : "Item_1211.cv_arg") -> "Item_1211":
        return cls._create(arg) # type: ignore

class NonSpare_2161(NonSpare):
    cv_arg: TypeAlias = RuleVariation_197.cv_arg
    cv_name = "Y2"
    cv_title = "Y2-Component"
    cv_rule: TypeAlias = RuleVariation_197

    @classmethod
    def create(cls, arg : "NonSpare_2161.cv_arg") -> "NonSpare_2161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_204:
        return self.rule.variation

class Item_1259(Item):
    cv_arg: TypeAlias = NonSpare_2161.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2161

    @classmethod
    def create(cls, arg : "Item_1259.cv_arg") -> "Item_1259":
        return cls._create(arg) # type: ignore

class Variation_1319(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_197.cv_arg, Tuple[Literal["X1"], RuleVariation_197.cv_arg]], Union[RuleVariation_197.cv_arg, Tuple[Literal["Y1"], RuleVariation_197.cv_arg]], Union[RuleVariation_197.cv_arg, Tuple[Literal["X2"], RuleVariation_197.cv_arg]], Union[RuleVariation_197.cv_arg, Tuple[Literal["Y2"], RuleVariation_197.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1319.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1207, 8), (Item_1257, 8), (Item_1211, 8), (Item_1259, 8)]
    cv_items_dict = {"X1": RuleVariation_197, "Y1": RuleVariation_197, "X2": RuleVariation_197, "Y2": RuleVariation_197}

    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y1"]) -> RuleVariation_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y2"]) -> RuleVariation_197:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X1"], Literal["Y1"], Literal["X2"], Literal["Y2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_197:
        ...
    @overload
    def get_item(self, key : Literal["Y1"]) -> RuleVariation_197:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_197:
        ...
    @overload
    def get_item(self, key : Literal["Y2"]) -> RuleVariation_197:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1319.cv_arg") -> 'Variation_1319':
        return cls._create(arg) # type: ignore

class Variation_1453(Repetitive):
    cv_arg: TypeAlias = List[Variation_1319.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1319

    @classmethod
    def create(cls, arg: "Variation_1453.cv_arg") -> 'Variation_1453':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1319]:
        return self._get_list() # type: ignore

class RuleVariation_1374(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1453.cv_arg
    cv_variation: TypeAlias = Variation_1453

    @classmethod
    def create(cls, arg : "RuleVariation_1374.cv_arg") -> "RuleVariation_1374":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1453:
        return self.arg # type: ignore

class NonSpare_135(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1374.cv_arg
    cv_name = "038"
    cv_title = "Sequence of Weather Vectors in SPF Notation"
    cv_rule: TypeAlias = RuleVariation_1374

    @classmethod
    def create(cls, arg : "NonSpare_135.cv_arg") -> "NonSpare_135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1453:
        return self.rule.variation

class UapItem_135(UapItem):
    cv_non_spare: TypeAlias = NonSpare_135

class Record_20(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "000": NonSpare_8.cv_arg,
        "020": NonSpare_96.cv_arg,
        "036": NonSpare_133.cv_arg,
        "034": NonSpare_128.cv_arg,
        "040": NonSpare_137.cv_arg,
        "050": NonSpare_178.cv_arg,
        "090": NonSpare_259.cv_arg,
        "100": NonSpare_275.cv_arg,
        "110": NonSpare_291.cv_arg,
        "120": NonSpare_304.cv_arg,
        "038": NonSpare_135.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_union: TypeAlias = Union[
        Tuple[Literal["010"], NonSpare_37.cv_arg],
        Tuple[Literal["000"], NonSpare_8.cv_arg],
        Tuple[Literal["020"], NonSpare_96.cv_arg],
        Tuple[Literal["036"], NonSpare_133.cv_arg],
        Tuple[Literal["034"], NonSpare_128.cv_arg],
        Tuple[Literal["040"], NonSpare_137.cv_arg],
        Tuple[Literal["050"], NonSpare_178.cv_arg],
        Tuple[Literal["090"], NonSpare_259.cv_arg],
        Tuple[Literal["100"], NonSpare_275.cv_arg],
        Tuple[Literal["110"], NonSpare_291.cv_arg],
        Tuple[Literal["120"], NonSpare_304.cv_arg],
        Tuple[Literal["038"], NonSpare_135.cv_arg],
        Tuple[Literal["SP"], NonSpare_1732.cv_arg],
    ]
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_37, UapItem_8, UapItem_96, UapItem_133, UapItem_128, UapItem_137, UapItem_178, UapItem_259, UapItem_275, UapItem_291, UapItem_304, UapItem_135, UapItem_548, UapItem_550]
    cv_items_dict = {"010": NonSpare_37, "000": NonSpare_8, "020": NonSpare_96, "036": NonSpare_133, "034": NonSpare_128, "040": NonSpare_137, "050": NonSpare_178, "090": NonSpare_259, "100": NonSpare_275, "110": NonSpare_291, "120": NonSpare_304, "038": NonSpare_135, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_8:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["036"]) -> NonSpare_133:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["034"]) -> NonSpare_128:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_178:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_259:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_275:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_291:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_304:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["038"]) -> NonSpare_135:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["036"], Literal["034"], Literal["040"], Literal["050"], Literal["090"], Literal["100"], Literal["110"], Literal["120"], Literal["038"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_8]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_96]:
        ...
    @overload
    def get_item(self, key : Literal["036"]) -> Optional[NonSpare_133]:
        ...
    @overload
    def get_item(self, key : Literal["034"]) -> Optional[NonSpare_128]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_137]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_178]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_259]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_275]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_291]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_304]:
        ...
    @overload
    def get_item(self, key : Literal["038"]) -> Optional[NonSpare_135]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_8.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_96.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["036"], val : NonSpare_133.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["034"], val : NonSpare_128.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_137.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_178.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_259.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_275.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_291.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_304.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["038"], val : NonSpare_135.cv_arg) -> 'Record_20':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_20':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["036"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["034"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["038"]) -> 'Record_20':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_20':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @overload
    def get_rfs_item(self, arg : Literal["010"]) -> List[NonSpare_37]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["000"]) -> List[NonSpare_8]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["020"]) -> List[NonSpare_96]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["036"]) -> List[NonSpare_133]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["034"]) -> List[NonSpare_128]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["040"]) -> List[NonSpare_137]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["050"]) -> List[NonSpare_178]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["090"]) -> List[NonSpare_259]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["100"]) -> List[NonSpare_275]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["110"]) -> List[NonSpare_291]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["120"]) -> List[NonSpare_304]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["038"]) -> List[NonSpare_135]:
        ...
    @overload
    def get_rfs_item(self, arg : Literal["SP"]) -> List[NonSpare_1732]:
        ...
    def get_rfs_item(self, arg : Any) -> Any:
        return self._get_rfs_item(arg)

    @classmethod
    def create(cls, arg: "Record_20.cv_arg", rfs : Optional[List["Record_20.cv_union"]] = None) -> 'Record_20':
        return cls._create(arg, rfs) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_20", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_18(UapSingle):
    cv_arg: TypeAlias = Record_20
    cv_record: TypeAlias = Record_20

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_20]]:
        return cls._parse(bs)

class Asterix_8(AstCat):
    cv_category = 8
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_18
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_18.cv_arg]) -> "Asterix_8":
        return cls._create(records) # type: ignore

class Asterix_9(AstCat):
    cv_category = 8
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_18
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_18.cv_arg]) -> "Asterix_9":
        return cls._create(records) # type: ignore

class Content_605(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {2: "Cartesian vector", 253: "Intermediate-update-step message", 254: "Start-of-picture message", 255: "End-of-picture message"}

class RuleContent_605(RuleContentContextFree):
    cv_arg: TypeAlias = Content_605.cv_arg
    cv_content: TypeAlias = Content_605

    @property
    def content(self) -> Content_605:
        return self._get_content() # type: ignore

class Variation_201(Element):
    cv_arg: TypeAlias = RuleContent_605.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_605

    @classmethod
    def create(cls, arg: "Variation_201.cv_arg") -> "Variation_201":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_605:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_605:
        return self.rule.content

class RuleVariation_194(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_201.cv_arg
    cv_variation: TypeAlias = Variation_201

    @classmethod
    def create(cls, arg : "RuleVariation_194.cv_arg") -> "RuleVariation_194":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_201:
        return self.arg # type: ignore

class NonSpare_16(NonSpare):
    cv_arg: TypeAlias = RuleVariation_194.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_194

    @classmethod
    def create(cls, arg : "NonSpare_16.cv_arg") -> "NonSpare_16":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_201:
        return self.rule.variation

class UapItem_16(UapItem):
    cv_non_spare: TypeAlias = NonSpare_16

class Variation_1378(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_52.cv_arg, Tuple[Literal["ORG"], RuleVariation_52.cv_arg]], Union[RuleVariation_477.cv_arg, Tuple[Literal["I"], RuleVariation_477.cv_arg]], Union[RuleVariation_764.cv_arg, Tuple[Literal["S"], RuleVariation_764.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1378.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_661, 1), (Item_409, 3), (Item_850, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1378.cv_arg") -> 'Variation_1378':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ORG"]) -> RuleVariation_52:
        ...
    @overload
    def get_item(self, key : Literal["I"]) -> RuleVariation_477:
        ...
    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_764:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1299(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1378.cv_arg
    cv_variation: TypeAlias = Variation_1378

    @classmethod
    def create(cls, arg : "RuleVariation_1299.cv_arg") -> "RuleVariation_1299":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1378:
        return self.arg # type: ignore

class NonSpare_95(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1299.cv_arg
    cv_name = "020"
    cv_title = "Vector Qualifier"
    cv_rule: TypeAlias = RuleVariation_1299

    @classmethod
    def create(cls, arg : "NonSpare_95.cv_arg") -> "NonSpare_95":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1299:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1378:
        return self.rule.variation

class UapItem_95(UapItem):
    cv_non_spare: TypeAlias = NonSpare_95

class Variation_255(Element):
    cv_arg: TypeAlias = RuleContent_612.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_612

    @classmethod
    def create(cls, arg: "Variation_255.cv_arg") -> "Variation_255":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_612:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_612:
        return self.rule.content

class RuleVariation_248(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_255.cv_arg
    cv_variation: TypeAlias = Variation_255

    @classmethod
    def create(cls, arg : "RuleVariation_248.cv_arg") -> "RuleVariation_248":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_255:
        return self.arg # type: ignore

class NonSpare_2101(NonSpare):
    cv_arg: TypeAlias = RuleVariation_248.cv_arg
    cv_name = "X"
    cv_title = "X-coordinate"
    cv_rule: TypeAlias = RuleVariation_248

    @classmethod
    def create(cls, arg : "NonSpare_2101.cv_arg") -> "NonSpare_2101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_248:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_255:
        return self.rule.variation

class Item_1202(Item):
    cv_arg: TypeAlias = NonSpare_2101.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2101

    @classmethod
    def create(cls, arg : "Item_1202.cv_arg") -> "Item_1202":
        return cls._create(arg) # type: ignore

class NonSpare_2155(NonSpare):
    cv_arg: TypeAlias = RuleVariation_248.cv_arg
    cv_name = "Y"
    cv_title = "Y-coordinate"
    cv_rule: TypeAlias = RuleVariation_248

    @classmethod
    def create(cls, arg : "NonSpare_2155.cv_arg") -> "NonSpare_2155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_248:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_255:
        return self.rule.variation

class Item_1253(Item):
    cv_arg: TypeAlias = NonSpare_2155.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2155

    @classmethod
    def create(cls, arg : "Item_1253.cv_arg") -> "Item_1253":
        return cls._create(arg) # type: ignore

class NonSpare_1145(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "L"
    cv_title = "Vector Length"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_1145.cv_arg") -> "NonSpare_1145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class Item_457(Item):
    cv_arg: TypeAlias = NonSpare_1145.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1145

    @classmethod
    def create(cls, arg : "Item_457.cv_arg") -> "Item_457":
        return cls._create(arg) # type: ignore

class Variation_1316(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_248.cv_arg, Tuple[Literal["X"], RuleVariation_248.cv_arg]], Union[RuleVariation_248.cv_arg, Tuple[Literal["Y"], RuleVariation_248.cv_arg]], Union[RuleVariation_249.cv_arg, Tuple[Literal["L"], RuleVariation_249.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1316.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1202, 16), (Item_1253, 16), (Item_457, 16)]
    cv_items_dict = {"X": RuleVariation_248, "Y": RuleVariation_248, "L": RuleVariation_249}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_248:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_248:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_249:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["L"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_248:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_248:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_249:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1316.cv_arg") -> 'Variation_1316':
        return cls._create(arg) # type: ignore

class Variation_1451(Repetitive):
    cv_arg: TypeAlias = List[Variation_1316.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1316

    @classmethod
    def create(cls, arg: "Variation_1451.cv_arg") -> 'Variation_1451':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1316]:
        return self._get_list() # type: ignore

class RuleVariation_1372(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1451.cv_arg
    cv_variation: TypeAlias = Variation_1451

    @classmethod
    def create(cls, arg : "RuleVariation_1372.cv_arg") -> "RuleVariation_1372":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1451:
        return self.arg # type: ignore

class NonSpare_107(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1372.cv_arg
    cv_name = "030"
    cv_title = "Sequence of Cartesian Vectors"
    cv_rule: TypeAlias = RuleVariation_1372

    @classmethod
    def create(cls, arg : "NonSpare_107.cv_arg") -> "NonSpare_107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1372:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1451:
        return self.rule.variation

class UapItem_107(UapItem):
    cv_non_spare: TypeAlias = NonSpare_107

class Variation_149(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 6
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_149.cv_arg") -> "Variation_149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_149(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_149.cv_arg
    cv_variation: TypeAlias = Variation_149

    @classmethod
    def create(cls, arg : "RuleVariation_149.cv_arg") -> "RuleVariation_149":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_149:
        return self.arg # type: ignore

class NonSpare_1729(NonSpare):
    cv_arg: TypeAlias = RuleVariation_149.cv_arg
    cv_name = "SN"
    cv_title = "Step Number"
    cv_rule: TypeAlias = RuleVariation_149

    @classmethod
    def create(cls, arg : "NonSpare_1729.cv_arg") -> "NonSpare_1729":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_149:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_149:
        return self.rule.variation

class Item_904(Item):
    cv_arg: TypeAlias = NonSpare_1729.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1729

    @classmethod
    def create(cls, arg : "Item_904.cv_arg") -> "Item_904":
        return cls._create(arg) # type: ignore

class Variation_1382(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_149.cv_arg, Tuple[Literal["SN"], RuleVariation_149.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1382.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_904, 6), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1382.cv_arg") -> 'Variation_1382':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["SN"]) -> RuleVariation_149:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1303(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1382.cv_arg
    cv_variation: TypeAlias = Variation_1382

    @classmethod
    def create(cls, arg : "RuleVariation_1303.cv_arg") -> "RuleVariation_1303":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1382:
        return self.arg # type: ignore

class NonSpare_199(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1303.cv_arg
    cv_name = "060"
    cv_title = "Synchronisation/Control Signal"
    cv_rule: TypeAlias = RuleVariation_1303

    @classmethod
    def create(cls, arg : "NonSpare_199.cv_arg") -> "NonSpare_199":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1382:
        return self.rule.variation

class UapItem_199(UapItem):
    cv_non_spare: TypeAlias = NonSpare_199

class NonSpare_221(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "070"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_221.cv_arg") -> "NonSpare_221":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_221(UapItem):
    cv_non_spare: TypeAlias = NonSpare_221

class NonSpare_234(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1280.cv_arg
    cv_name = "080"
    cv_title = "Processing Status"
    cv_rule: TypeAlias = RuleVariation_1280

    @classmethod
    def create(cls, arg : "NonSpare_234.cv_arg") -> "NonSpare_234":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1359:
        return self.rule.variation

class UapItem_234(UapItem):
    cv_non_spare: TypeAlias = NonSpare_234

class NonSpare_1654(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SAC"
    cv_title = "SAC of Radar Concerned"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1654.cv_arg") -> "NonSpare_1654":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_855(Item):
    cv_arg: TypeAlias = NonSpare_1654.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1654

    @classmethod
    def create(cls, arg : "Item_855.cv_arg") -> "Item_855":
        return cls._create(arg) # type: ignore

class NonSpare_1709(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SIC"
    cv_title = "SIC of Radar Concerned"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1709.cv_arg") -> "NonSpare_1709":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_886(Item):
    cv_arg: TypeAlias = NonSpare_1709.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1709

    @classmethod
    def create(cls, arg : "Item_886.cv_arg") -> "Item_886":
        return cls._create(arg) # type: ignore

class Item_2(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 3

class Variation_614(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_614.cv_arg") -> "Variation_614":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_603(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_614.cv_arg
    cv_variation: TypeAlias = Variation_614

    @classmethod
    def create(cls, arg : "RuleVariation_603.cv_arg") -> "RuleVariation_603":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_614:
        return self.arg # type: ignore

class NonSpare_814(NonSpare):
    cv_arg: TypeAlias = RuleVariation_603.cv_arg
    cv_name = "CP"
    cv_title = "Circular Polarisation"
    cv_rule: TypeAlias = RuleVariation_603

    @classmethod
    def create(cls, arg : "NonSpare_814.cv_arg") -> "NonSpare_814":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_603:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_614:
        return self.rule.variation

class Item_206(Item):
    cv_arg: TypeAlias = NonSpare_814.cv_arg
    cv_non_spare: TypeAlias = NonSpare_814

    @classmethod
    def create(cls, arg : "Item_206.cv_arg") -> "Item_206":
        return cls._create(arg) # type: ignore

class Variation_699(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_699.cv_arg") -> "Variation_699":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_688(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_699.cv_arg
    cv_variation: TypeAlias = Variation_699

    @classmethod
    def create(cls, arg : "RuleVariation_688.cv_arg") -> "RuleVariation_688":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_699:
        return self.arg # type: ignore

class NonSpare_2063(NonSpare):
    cv_arg: TypeAlias = RuleVariation_688.cv_arg
    cv_name = "WO"
    cv_title = "Weather Channel Overload"
    cv_rule: TypeAlias = RuleVariation_688

    @classmethod
    def create(cls, arg : "NonSpare_2063.cv_arg") -> "NonSpare_2063":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_688:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_699:
        return self.rule.variation

class Item_1167(Item):
    cv_arg: TypeAlias = NonSpare_2063.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2063

    @classmethod
    def create(cls, arg : "Item_1167.cv_arg") -> "Item_1167":
        return cls._create(arg) # type: ignore

class NonSpare_1533(NonSpare):
    cv_arg: TypeAlias = RuleVariation_859.cv_arg
    cv_name = "R"
    cv_title = "Reduction Step in Use By Radar  Concerned"
    cv_rule: TypeAlias = RuleVariation_859

    @classmethod
    def create(cls, arg : "NonSpare_1533.cv_arg") -> "NonSpare_1533":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_859:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_889:
        return self.rule.variation

class Item_764(Item):
    cv_arg: TypeAlias = NonSpare_1533.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1533

    @classmethod
    def create(cls, arg : "Item_764.cv_arg") -> "Item_764":
        return cls._create(arg) # type: ignore

class Variation_1191(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SAC"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SIC"], RuleVariation_159.cv_arg]], int, Union[RuleVariation_603.cv_arg, Tuple[Literal["CP"], RuleVariation_603.cv_arg]], Union[RuleVariation_688.cv_arg, Tuple[Literal["WO"], RuleVariation_688.cv_arg]], Union[RuleVariation_859.cv_arg, Tuple[Literal["R"], RuleVariation_859.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1191.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_855, 8), (Item_886, 8), (Item_2, 3), (Item_206, 1), (Item_1167, 1), (Item_764, 3)]
    cv_items_dict = {"SAC": RuleVariation_159, "SIC": RuleVariation_159, "CP": RuleVariation_603, "WO": RuleVariation_688, "R": RuleVariation_859}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CP"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WO"]) -> RuleVariation_688:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["R"]) -> RuleVariation_859:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"], Literal["CP"], Literal["WO"], Literal["R"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["CP"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["WO"]) -> RuleVariation_688:
        ...
    @overload
    def get_item(self, key : Literal["R"]) -> RuleVariation_859:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1191.cv_arg") -> 'Variation_1191':
        return cls._create(arg) # type: ignore

class Variation_1428(Repetitive):
    cv_arg: TypeAlias = List[Variation_1191.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1191

    @classmethod
    def create(cls, arg: "Variation_1428.cv_arg") -> 'Variation_1428':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1191]:
        return self._get_list() # type: ignore

class RuleVariation_1349(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1428.cv_arg
    cv_variation: TypeAlias = Variation_1428

    @classmethod
    def create(cls, arg : "RuleVariation_1349.cv_arg") -> "RuleVariation_1349":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1428:
        return self.arg # type: ignore

class NonSpare_257(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1349.cv_arg
    cv_name = "090"
    cv_title = "Radar Configuration and Status"
    cv_rule: TypeAlias = RuleVariation_1349

    @classmethod
    def create(cls, arg : "NonSpare_257.cv_arg") -> "NonSpare_257":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1428:
        return self.rule.variation

class UapItem_257(UapItem):
    cv_non_spare: TypeAlias = NonSpare_257

class NonSpare_279(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "100"
    cv_title = "Vector Count"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_279.cv_arg") -> "NonSpare_279":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_279(UapItem):
    cv_non_spare: TypeAlias = NonSpare_279

class Record_21(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "000": NonSpare_16.cv_arg,
        "020": NonSpare_95.cv_arg,
        "030": NonSpare_107.cv_arg,
        "060": NonSpare_199.cv_arg,
        "070": NonSpare_221.cv_arg,
        "080": NonSpare_234.cv_arg,
        "090": NonSpare_257.cv_arg,
        "100": NonSpare_279.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_37, UapItem_16, UapItem_95, UapItem_107, UapItem_199, UapItem_221, UapItem_234, UapItem_257, UapItem_279]
    cv_items_dict = {"010": NonSpare_37, "000": NonSpare_16, "020": NonSpare_95, "030": NonSpare_107, "060": NonSpare_199, "070": NonSpare_221, "080": NonSpare_234, "090": NonSpare_257, "100": NonSpare_279}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_16:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_107:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_199:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_221:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_234:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_257:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_279:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["060"], Literal["070"], Literal["080"], Literal["090"], Literal["100"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_16]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_95]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_107]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_199]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_221]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_234]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_257]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_279]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_16.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_95.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_107.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_199.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_221.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_234.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_257.cv_arg) -> 'Record_21':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_279.cv_arg) -> 'Record_21':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_21':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_21':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_21.cv_arg") -> 'Record_21':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_21", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_19(UapSingle):
    cv_arg: TypeAlias = Record_21
    cv_record: TypeAlias = Record_21

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_21]]:
        return cls._parse(bs)

class Asterix_10(AstCat):
    cv_category = 9
    cv_edition = (2, 1)
    cv_uap: TypeAlias = Uap_19
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_19.cv_arg]) -> "Asterix_10":
        return cls._create(records) # type: ignore

class NonSpare_43(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_43.cv_arg") -> "NonSpare_43":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_43(UapItem):
    cv_non_spare: TypeAlias = NonSpare_43

class Content_599(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Target Report", 2: "Start of Update Cycle", 3: "Periodic Status Message", 4: "Event-triggered Status Message"}

class RuleContent_599(RuleContentContextFree):
    cv_arg: TypeAlias = Content_599.cv_arg
    cv_content: TypeAlias = Content_599

    @property
    def content(self) -> Content_599:
        return self._get_content() # type: ignore

class Variation_198(Element):
    cv_arg: TypeAlias = RuleContent_599.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_599

    @classmethod
    def create(cls, arg: "Variation_198.cv_arg") -> "Variation_198":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_599:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_599:
        return self.rule.content

class RuleVariation_191(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_198.cv_arg
    cv_variation: TypeAlias = Variation_198

    @classmethod
    def create(cls, arg : "RuleVariation_191.cv_arg") -> "RuleVariation_191":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_198:
        return self.arg # type: ignore

class NonSpare_13(NonSpare):
    cv_arg: TypeAlias = RuleVariation_191.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_191

    @classmethod
    def create(cls, arg : "NonSpare_13.cv_arg") -> "NonSpare_13":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_191:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_198:
        return self.rule.variation

class UapItem_13(UapItem):
    cv_non_spare: TypeAlias = NonSpare_13

class Content_451(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "SSR multilateration", 1: "Mode S multilateration", 2: "ADS-B", 3: "PSR", 4: "Magnetic Loop System", 5: "HF multilateration", 6: "Not defined", 7: "Other types"}

class RuleContent_451(RuleContentContextFree):
    cv_arg: TypeAlias = Content_451.cv_arg
    cv_content: TypeAlias = Content_451

    @property
    def content(self) -> Content_451:
        return self._get_content() # type: ignore

class Variation_131(Element):
    cv_arg: TypeAlias = RuleContent_451.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_451

    @classmethod
    def create(cls, arg: "Variation_131.cv_arg") -> "Variation_131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_451:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_451:
        return self.rule.content

class RuleVariation_131(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_131.cv_arg
    cv_variation: TypeAlias = Variation_131

    @classmethod
    def create(cls, arg : "RuleVariation_131.cv_arg") -> "RuleVariation_131":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_131:
        return self.arg # type: ignore

class Content_352(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No differential correction (ADS-B)", 1: "Differential correction (ADS-B)"}

class RuleContent_352(RuleContentContextFree):
    cv_arg: TypeAlias = Content_352.cv_arg
    cv_content: TypeAlias = Content_352

    @property
    def content(self) -> Content_352:
        return self._get_content() # type: ignore

class Variation_652(Element):
    cv_arg: TypeAlias = RuleContent_352.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_352

    @classmethod
    def create(cls, arg: "Variation_652.cv_arg") -> "Variation_652":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_352:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_352:
        return self.rule.content

class RuleVariation_641(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_652.cv_arg
    cv_variation: TypeAlias = Variation_652

    @classmethod
    def create(cls, arg : "RuleVariation_641.cv_arg") -> "RuleVariation_641":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_652:
        return self.arg # type: ignore

class Content_53(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Chain 1", 1: "Chain 2"}

class RuleContent_53(RuleContentContextFree):
    cv_arg: TypeAlias = Content_53.cv_arg
    cv_content: TypeAlias = Content_53

    @property
    def content(self) -> Content_53:
        return self._get_content() # type: ignore

class Variation_703(Element):
    cv_arg: TypeAlias = RuleContent_53.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_53

    @classmethod
    def create(cls, arg: "Variation_703.cv_arg") -> "Variation_703":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_53:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_53:
        return self.rule.content

class RuleVariation_692(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_703.cv_arg
    cv_variation: TypeAlias = Variation_703

    @classmethod
    def create(cls, arg : "RuleVariation_692.cv_arg") -> "RuleVariation_692":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_703:
        return self.arg # type: ignore

class Content_521(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Transponder Ground bit not set", 1: "Transponder Ground bit set"}

class RuleContent_521(RuleContentContextFree):
    cv_arg: TypeAlias = Content_521.cv_arg
    cv_content: TypeAlias = Content_521

    @property
    def content(self) -> Content_521:
        return self._get_content() # type: ignore

class Variation_875(Element):
    cv_arg: TypeAlias = RuleContent_521.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_521

    @classmethod
    def create(cls, arg: "Variation_875.cv_arg") -> "Variation_875":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_521:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_521:
        return self.rule.content

class RuleVariation_845(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_875.cv_arg
    cv_variation: TypeAlias = Variation_875

    @classmethod
    def create(cls, arg : "RuleVariation_845.cv_arg") -> "RuleVariation_845":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_875:
        return self.arg # type: ignore

class Content_306(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Corrupted reply in multilateration", 1: "Corrupted replies in multilateration"}

class RuleContent_306(RuleContentContextFree):
    cv_arg: TypeAlias = Content_306.cv_arg
    cv_content: TypeAlias = Content_306

    @property
    def content(self) -> Content_306:
        return self._get_content() # type: ignore

class Variation_940(Element):
    cv_arg: TypeAlias = RuleContent_306.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_306

    @classmethod
    def create(cls, arg: "Variation_940.cv_arg") -> "Variation_940":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_306:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_306:
        return self.rule.content

class RuleVariation_910(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_940.cv_arg
    cv_variation: TypeAlias = Variation_940

    @classmethod
    def create(cls, arg : "RuleVariation_910.cv_arg") -> "RuleVariation_910":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_940:
        return self.arg # type: ignore

class Content_19(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Actual target report", 1: "Simulated target report"}

class RuleContent_19(RuleContentContextFree):
    cv_arg: TypeAlias = Content_19.cv_arg
    cv_content: TypeAlias = Content_19

    @property
    def content(self) -> Content_19:
        return self._get_content() # type: ignore

class Variation_5(Element):
    cv_arg: TypeAlias = RuleContent_19.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg: "Variation_5.cv_arg") -> "Variation_5":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_19:
        return self.rule.content

class RuleVariation_5(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_5.cv_arg
    cv_variation: TypeAlias = Variation_5

    @classmethod
    def create(cls, arg : "RuleVariation_5.cv_arg") -> "RuleVariation_5":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_5:
        return self.arg # type: ignore

class Content_155(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Test Target"}

class RuleContent_155(RuleContentContextFree):
    cv_arg: TypeAlias = Content_155.cv_arg
    cv_content: TypeAlias = Content_155

    @property
    def content(self) -> Content_155:
        return self._get_content() # type: ignore

class Variation_419(Element):
    cv_arg: TypeAlias = RuleContent_155.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_155

    @classmethod
    def create(cls, arg: "Variation_419.cv_arg") -> "Variation_419":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_155:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_155:
        return self.rule.content

class RuleVariation_408(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_419.cv_arg
    cv_variation: TypeAlias = Variation_419

    @classmethod
    def create(cls, arg : "RuleVariation_408.cv_arg") -> "RuleVariation_408":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_419:
        return self.arg # type: ignore

class Content_442(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Report from target transponder", 1: "Report from field monitor (fixed transponder)"}

class RuleContent_442(RuleContentContextFree):
    cv_arg: TypeAlias = Content_442.cv_arg
    cv_content: TypeAlias = Content_442

    @property
    def content(self) -> Content_442:
        return self._get_content() # type: ignore

class Variation_574(Element):
    cv_arg: TypeAlias = RuleContent_442.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_442

    @classmethod
    def create(cls, arg: "Variation_574.cv_arg") -> "Variation_574":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_442:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_442:
        return self.rule.content

class RuleVariation_563(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_574.cv_arg
    cv_variation: TypeAlias = Variation_574

    @classmethod
    def create(cls, arg : "RuleVariation_563.cv_arg") -> "RuleVariation_563":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_574:
        return self.arg # type: ignore

class Content_533(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Undetermined", 1: "Loop start", 2: "Loop finish"}

class RuleContent_533(RuleContentContextFree):
    cv_arg: TypeAlias = Content_533.cv_arg
    cv_content: TypeAlias = Content_533

    @property
    def content(self) -> Content_533:
        return self._get_content() # type: ignore

class Variation_682(Element):
    cv_arg: TypeAlias = RuleContent_533.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_533

    @classmethod
    def create(cls, arg: "Variation_682.cv_arg") -> "Variation_682":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_533:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_533:
        return self.rule.content

class RuleVariation_671(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_682.cv_arg
    cv_variation: TypeAlias = Variation_682

    @classmethod
    def create(cls, arg : "RuleVariation_671.cv_arg") -> "RuleVariation_671":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_682:
        return self.arg # type: ignore

class Content_532(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Undetermined", 1: "Aircraft", 2: "Ground vehicle", 3: "Helicopter"}

class RuleContent_532(RuleContentContextFree):
    cv_arg: TypeAlias = Content_532.cv_arg
    cv_content: TypeAlias = Content_532

    @property
    def content(self) -> Content_532:
        return self._get_content() # type: ignore

class Variation_887(Element):
    cv_arg: TypeAlias = RuleContent_532.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_532

    @classmethod
    def create(cls, arg: "Variation_887.cv_arg") -> "Variation_887":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_532:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_532:
        return self.rule.content

class RuleVariation_857(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_887.cv_arg
    cv_variation: TypeAlias = Variation_887

    @classmethod
    def create(cls, arg : "RuleVariation_857.cv_arg") -> "RuleVariation_857":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_887:
        return self.arg # type: ignore

class Content_13(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Absence of SPI", 1: "Special Position Identification"}

class RuleContent_13(RuleContentContextFree):
    cv_arg: TypeAlias = Content_13.cv_arg
    cv_content: TypeAlias = Content_13

    @property
    def content(self) -> Content_13:
        return self._get_content() # type: ignore

class Variation_3(Element):
    cv_arg: TypeAlias = RuleContent_13.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg: "Variation_3.cv_arg") -> "Variation_3":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_13:
        return self.rule.content

class RuleVariation_3(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_3.cv_arg
    cv_variation: TypeAlias = Variation_3

    @classmethod
    def create(cls, arg : "RuleVariation_3.cv_arg") -> "RuleVariation_3":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_3:
        return self.arg # type: ignore

class NonSpare_1960(NonSpare):
    cv_arg: TypeAlias = RuleVariation_131.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_131

    @classmethod
    def create(cls, arg : "NonSpare_1960.cv_arg") -> "NonSpare_1960":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_131:
        return self.rule.variation

class Item_1074(Item):
    cv_arg: TypeAlias = NonSpare_1960.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1960

    @classmethod
    def create(cls, arg : "Item_1074.cv_arg") -> "Item_1074":
        return cls._create(arg) # type: ignore

class NonSpare_875(NonSpare):
    cv_arg: TypeAlias = RuleVariation_641.cv_arg
    cv_name = "DCR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_641

    @classmethod
    def create(cls, arg : "NonSpare_875.cv_arg") -> "NonSpare_875":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_641:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_652:
        return self.rule.variation

class Item_253(Item):
    cv_arg: TypeAlias = NonSpare_875.cv_arg
    cv_non_spare: TypeAlias = NonSpare_875

    @classmethod
    def create(cls, arg : "Item_253.cv_arg") -> "Item_253":
        return cls._create(arg) # type: ignore

class NonSpare_735(NonSpare):
    cv_arg: TypeAlias = RuleVariation_692.cv_arg
    cv_name = "CHN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_692

    @classmethod
    def create(cls, arg : "NonSpare_735.cv_arg") -> "NonSpare_735":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_692:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_703:
        return self.rule.variation

class Item_157(Item):
    cv_arg: TypeAlias = NonSpare_735.cv_arg
    cv_non_spare: TypeAlias = NonSpare_735

    @classmethod
    def create(cls, arg : "Item_157.cv_arg") -> "Item_157":
        return cls._create(arg) # type: ignore

class NonSpare_1029(NonSpare):
    cv_arg: TypeAlias = RuleVariation_845.cv_arg
    cv_name = "GBS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_845

    @classmethod
    def create(cls, arg : "NonSpare_1029.cv_arg") -> "NonSpare_1029":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_845:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_875:
        return self.rule.variation

class Item_367(Item):
    cv_arg: TypeAlias = NonSpare_1029.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1029

    @classmethod
    def create(cls, arg : "Item_367.cv_arg") -> "Item_367":
        return cls._create(arg) # type: ignore

class NonSpare_831(NonSpare):
    cv_arg: TypeAlias = RuleVariation_910.cv_arg
    cv_name = "CRT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_910

    @classmethod
    def create(cls, arg : "NonSpare_831.cv_arg") -> "NonSpare_831":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_910:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_940:
        return self.rule.variation

class Item_217(Item):
    cv_arg: TypeAlias = NonSpare_831.cv_arg
    cv_non_spare: TypeAlias = NonSpare_831

    @classmethod
    def create(cls, arg : "Item_217.cv_arg") -> "Item_217":
        return cls._create(arg) # type: ignore

class NonSpare_1723(NonSpare):
    cv_arg: TypeAlias = RuleVariation_5.cv_arg
    cv_name = "SIM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_5

    @classmethod
    def create(cls, arg : "NonSpare_1723.cv_arg") -> "NonSpare_1723":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_5:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_5:
        return self.rule.variation

class Item_898(Item):
    cv_arg: TypeAlias = NonSpare_1723.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1723

    @classmethod
    def create(cls, arg : "Item_898.cv_arg") -> "Item_898":
        return cls._create(arg) # type: ignore

class NonSpare_1935(NonSpare):
    cv_arg: TypeAlias = RuleVariation_408.cv_arg
    cv_name = "TST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_408

    @classmethod
    def create(cls, arg : "NonSpare_1935.cv_arg") -> "NonSpare_1935":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_408:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_419:
        return self.rule.variation

class Item_1052(Item):
    cv_arg: TypeAlias = NonSpare_1935.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1935

    @classmethod
    def create(cls, arg : "Item_1052.cv_arg") -> "Item_1052":
        return cls._create(arg) # type: ignore

class NonSpare_1537(NonSpare):
    cv_arg: TypeAlias = RuleVariation_563.cv_arg
    cv_name = "RAB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_563

    @classmethod
    def create(cls, arg : "NonSpare_1537.cv_arg") -> "NonSpare_1537":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_563:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_574:
        return self.rule.variation

class Item_767(Item):
    cv_arg: TypeAlias = NonSpare_1537.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1537

    @classmethod
    def create(cls, arg : "Item_767.cv_arg") -> "Item_767":
        return cls._create(arg) # type: ignore

class NonSpare_1194(NonSpare):
    cv_arg: TypeAlias = RuleVariation_671.cv_arg
    cv_name = "LOP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_671

    @classmethod
    def create(cls, arg : "NonSpare_1194.cv_arg") -> "NonSpare_1194":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_671:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_682:
        return self.rule.variation

class Item_504(Item):
    cv_arg: TypeAlias = NonSpare_1194.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1194

    @classmethod
    def create(cls, arg : "Item_504.cv_arg") -> "Item_504":
        return cls._create(arg) # type: ignore

class NonSpare_1888(NonSpare):
    cv_arg: TypeAlias = RuleVariation_857.cv_arg
    cv_name = "TOT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_857

    @classmethod
    def create(cls, arg : "NonSpare_1888.cv_arg") -> "NonSpare_1888":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_857:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_887:
        return self.rule.variation

class Item_1011(Item):
    cv_arg: TypeAlias = NonSpare_1888.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1888

    @classmethod
    def create(cls, arg : "Item_1011.cv_arg") -> "Item_1011":
        return cls._create(arg) # type: ignore

class NonSpare_1736(NonSpare):
    cv_arg: TypeAlias = RuleVariation_3.cv_arg
    cv_name = "SPI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_3

    @classmethod
    def create(cls, arg : "NonSpare_1736.cv_arg") -> "NonSpare_1736":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_3:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_3:
        return self.rule.variation

class Item_909(Item):
    cv_arg: TypeAlias = NonSpare_1736.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1736

    @classmethod
    def create(cls, arg : "Item_909.cv_arg") -> "Item_909":
        return cls._create(arg) # type: ignore

class Variation_1392(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_131.cv_arg, Tuple[Literal["TYP"], RuleVariation_131.cv_arg]], Union[RuleVariation_641.cv_arg, Tuple[Literal["DCR"], RuleVariation_641.cv_arg]], Union[RuleVariation_692.cv_arg, Tuple[Literal["CHN"], RuleVariation_692.cv_arg]], Union[RuleVariation_845.cv_arg, Tuple[Literal["GBS"], RuleVariation_845.cv_arg]], Union[RuleVariation_910.cv_arg, Tuple[Literal["CRT"], RuleVariation_910.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_5.cv_arg, Tuple[Literal["SIM"], RuleVariation_5.cv_arg]], Union[RuleVariation_408.cv_arg, Tuple[Literal["TST"], RuleVariation_408.cv_arg]], Union[RuleVariation_563.cv_arg, Tuple[Literal["RAB"], RuleVariation_563.cv_arg]], Union[RuleVariation_671.cv_arg, Tuple[Literal["LOP"], RuleVariation_671.cv_arg]], Union[RuleVariation_857.cv_arg, Tuple[Literal["TOT"], RuleVariation_857.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_3.cv_arg, Tuple[Literal["SPI"], RuleVariation_3.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1392.cv_arg_group_1"],
        Tuple["Variation_1392.cv_arg_group_1", "Variation_1392.cv_arg_group_2"],
        Tuple["Variation_1392.cv_arg_group_1", "Variation_1392.cv_arg_group_2", "Variation_1392.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_1074, 3), (Item_253, 1), (Item_157, 1), (Item_367, 1), (Item_217, 1), None], [(Item_898, 1), (Item_1052, 1), (Item_767, 1), (Item_504, 2), (Item_1011, 2), None], [(Item_909, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1392.cv_arg") -> 'Variation_1392':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_131:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> RuleVariation_641:
        ...
    @overload
    def get_item(self, key : Literal["CHN"]) -> RuleVariation_692:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_845:
        ...
    @overload
    def get_item(self, key : Literal["CRT"]) -> RuleVariation_910:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_5]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_408]:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> Optional[RuleVariation_563]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[RuleVariation_671]:
        ...
    @overload
    def get_item(self, key : Literal["TOT"]) -> Optional[RuleVariation_857]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_3]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1313(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1392.cv_arg
    cv_variation: TypeAlias = Variation_1392

    @classmethod
    def create(cls, arg : "RuleVariation_1313.cv_arg") -> "RuleVariation_1313":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1392:
        return self.arg # type: ignore

class NonSpare_91(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1313.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1313

    @classmethod
    def create(cls, arg : "NonSpare_91.cv_arg") -> "NonSpare_91":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1392:
        return self.rule.variation

class UapItem_91(UapItem):
    cv_non_spare: TypeAlias = NonSpare_91

class NonSpare_331(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_331.cv_arg") -> "NonSpare_331":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_331(UapItem):
    cv_non_spare: TypeAlias = NonSpare_331

class Content_705(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_705(RuleContentContextFree):
    cv_arg: TypeAlias = Content_705.cv_arg
    cv_content: TypeAlias = Content_705

    @property
    def content(self) -> Content_705:
        return self._get_content() # type: ignore

class Variation_383(Element):
    cv_arg: TypeAlias = RuleContent_705.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_705

    @classmethod
    def create(cls, arg: "Variation_383.cv_arg") -> "Variation_383":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_705:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_705:
        return self.rule.content

class RuleVariation_376(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_383.cv_arg
    cv_variation: TypeAlias = Variation_383

    @classmethod
    def create(cls, arg : "RuleVariation_376.cv_arg") -> "RuleVariation_376":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_383:
        return self.arg # type: ignore

class NonSpare_1154(NonSpare):
    cv_arg: TypeAlias = RuleVariation_376.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule: TypeAlias = RuleVariation_376

    @classmethod
    def create(cls, arg : "NonSpare_1154.cv_arg") -> "NonSpare_1154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_376:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_383:
        return self.rule.variation

class Item_466(Item):
    cv_arg: TypeAlias = NonSpare_1154.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1154

    @classmethod
    def create(cls, arg : "Item_466.cv_arg") -> "Item_466":
        return cls._create(arg) # type: ignore

class Content_703(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_703(RuleContentContextFree):
    cv_arg: TypeAlias = Content_703.cv_arg
    cv_content: TypeAlias = Content_703

    @property
    def content(self) -> Content_703:
        return self._get_content() # type: ignore

class Variation_381(Element):
    cv_arg: TypeAlias = RuleContent_703.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_703

    @classmethod
    def create(cls, arg: "Variation_381.cv_arg") -> "Variation_381":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_703:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_703:
        return self.rule.content

class RuleVariation_374(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_381.cv_arg
    cv_variation: TypeAlias = Variation_381

    @classmethod
    def create(cls, arg : "RuleVariation_374.cv_arg") -> "RuleVariation_374":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_381:
        return self.arg # type: ignore

class NonSpare_1184(NonSpare):
    cv_arg: TypeAlias = RuleVariation_374.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_374

    @classmethod
    def create(cls, arg : "NonSpare_1184.cv_arg") -> "NonSpare_1184":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_381:
        return self.rule.variation

class Item_494(Item):
    cv_arg: TypeAlias = NonSpare_1184.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1184

    @classmethod
    def create(cls, arg : "Item_494.cv_arg") -> "Item_494":
        return cls._create(arg) # type: ignore

class Variation_1130(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_376.cv_arg, Tuple[Literal["LAT"], RuleVariation_376.cv_arg]], Union[RuleVariation_374.cv_arg, Tuple[Literal["LON"], RuleVariation_374.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1130.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_466, 32), (Item_494, 32)]
    cv_items_dict = {"LAT": RuleVariation_376, "LON": RuleVariation_374}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_374:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_374:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1130.cv_arg") -> 'Variation_1130':
        return cls._create(arg) # type: ignore

class RuleVariation_1086(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1130.cv_arg
    cv_variation: TypeAlias = Variation_1130

    @classmethod
    def create(cls, arg : "RuleVariation_1086.cv_arg") -> "RuleVariation_1086":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1130:
        return self.arg # type: ignore

class NonSpare_155(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1086.cv_arg
    cv_name = "041"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1086

    @classmethod
    def create(cls, arg : "NonSpare_155.cv_arg") -> "NonSpare_155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1086:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1130:
        return self.rule.variation

class UapItem_155(UapItem):
    cv_non_spare: TypeAlias = NonSpare_155

class Content_720(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_720(RuleContentContextFree):
    cv_arg: TypeAlias = Content_720.cv_arg
    cv_content: TypeAlias = Content_720

    @property
    def content(self) -> Content_720:
        return self._get_content() # type: ignore

class Variation_305(Element):
    cv_arg: TypeAlias = RuleContent_720.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_720

    @classmethod
    def create(cls, arg: "Variation_305.cv_arg") -> "Variation_305":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_720:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_720:
        return self.rule.content

class RuleVariation_298(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_305.cv_arg
    cv_variation: TypeAlias = Variation_305

    @classmethod
    def create(cls, arg : "RuleVariation_298.cv_arg") -> "RuleVariation_298":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_305:
        return self.arg # type: ignore

class NonSpare_1592(NonSpare):
    cv_arg: TypeAlias = RuleVariation_298.cv_arg
    cv_name = "RHO"
    cv_title = "RHO"
    cv_rule: TypeAlias = RuleVariation_298

    @classmethod
    def create(cls, arg : "NonSpare_1592.cv_arg") -> "NonSpare_1592":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_298:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_305:
        return self.rule.variation

class Item_817(Item):
    cv_arg: TypeAlias = NonSpare_1592.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1592

    @classmethod
    def create(cls, arg : "Item_817.cv_arg") -> "Item_817":
        return cls._create(arg) # type: ignore

class NonSpare_1854(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TH"
    cv_title = "Theta"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1854.cv_arg") -> "NonSpare_1854":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_992(Item):
    cv_arg: TypeAlias = NonSpare_1854.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1854

    @classmethod
    def create(cls, arg : "Item_992.cv_arg") -> "Item_992":
        return cls._create(arg) # type: ignore

class Variation_1181(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_298.cv_arg, Tuple[Literal["RHO"], RuleVariation_298.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["TH"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1181.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_817, 16), (Item_992, 16)]
    cv_items_dict = {"RHO": RuleVariation_298, "TH": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_298:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TH"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["TH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_298:
        ...
    @overload
    def get_item(self, key : Literal["TH"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1181.cv_arg") -> 'Variation_1181':
        return cls._create(arg) # type: ignore

class RuleVariation_1132(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1181.cv_arg
    cv_variation: TypeAlias = Variation_1181

    @classmethod
    def create(cls, arg : "RuleVariation_1132.cv_arg") -> "RuleVariation_1132":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1181:
        return self.arg # type: ignore

class NonSpare_140(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1132.cv_arg
    cv_name = "040"
    cv_title = "Measured Position in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1132

    @classmethod
    def create(cls, arg : "NonSpare_140.cv_arg") -> "NonSpare_140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1181:
        return self.rule.variation

class UapItem_140(UapItem):
    cv_non_spare: TypeAlias = NonSpare_140

class Content_627(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_627(RuleContentContextFree):
    cv_arg: TypeAlias = Content_627.cv_arg
    cv_content: TypeAlias = Content_627

    @property
    def content(self) -> Content_627:
        return self._get_content() # type: ignore

class Variation_259(Element):
    cv_arg: TypeAlias = RuleContent_627.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_627

    @classmethod
    def create(cls, arg: "Variation_259.cv_arg") -> "Variation_259":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_627:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_627:
        return self.rule.content

class RuleVariation_252(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_259.cv_arg
    cv_variation: TypeAlias = Variation_259

    @classmethod
    def create(cls, arg : "RuleVariation_252.cv_arg") -> "RuleVariation_252":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_259:
        return self.arg # type: ignore

class NonSpare_2095(NonSpare):
    cv_arg: TypeAlias = RuleVariation_252.cv_arg
    cv_name = "X"
    cv_title = "X Coordinate"
    cv_rule: TypeAlias = RuleVariation_252

    @classmethod
    def create(cls, arg : "NonSpare_2095.cv_arg") -> "NonSpare_2095":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_259:
        return self.rule.variation

class Item_1196(Item):
    cv_arg: TypeAlias = NonSpare_2095.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2095

    @classmethod
    def create(cls, arg : "Item_1196.cv_arg") -> "Item_1196":
        return cls._create(arg) # type: ignore

class NonSpare_2149(NonSpare):
    cv_arg: TypeAlias = RuleVariation_252.cv_arg
    cv_name = "Y"
    cv_title = "Y Coordinate"
    cv_rule: TypeAlias = RuleVariation_252

    @classmethod
    def create(cls, arg : "NonSpare_2149.cv_arg") -> "NonSpare_2149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_259:
        return self.rule.variation

class Item_1247(Item):
    cv_arg: TypeAlias = NonSpare_2149.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2149

    @classmethod
    def create(cls, arg : "Item_1247.cv_arg") -> "Item_1247":
        return cls._create(arg) # type: ignore

class Variation_1309(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_252.cv_arg, Tuple[Literal["X"], RuleVariation_252.cv_arg]], Union[RuleVariation_252.cv_arg, Tuple[Literal["Y"], RuleVariation_252.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1309.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1196, 16), (Item_1247, 16)]
    cv_items_dict = {"X": RuleVariation_252, "Y": RuleVariation_252}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_252:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_252:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_252:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1309.cv_arg") -> 'Variation_1309':
        return cls._create(arg) # type: ignore

class RuleVariation_1237(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1309.cv_arg
    cv_variation: TypeAlias = Variation_1309

    @classmethod
    def create(cls, arg : "RuleVariation_1237.cv_arg") -> "RuleVariation_1237":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1309:
        return self.arg # type: ignore

class NonSpare_161(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1237.cv_arg
    cv_name = "042"
    cv_title = "Position in Cartesian Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1237

    @classmethod
    def create(cls, arg : "NonSpare_161.cv_arg") -> "NonSpare_161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1237:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1309:
        return self.rule.variation

class UapItem_161(UapItem):
    cv_non_spare: TypeAlias = NonSpare_161

class Content_780(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_779(RuleContentContextFree):
    cv_arg: TypeAlias = Content_780.cv_arg
    cv_content: TypeAlias = Content_780

    @property
    def content(self) -> Content_780:
        return self._get_content() # type: ignore

class Variation_339(Element):
    cv_arg: TypeAlias = RuleContent_779.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_779

    @classmethod
    def create(cls, arg: "Variation_339.cv_arg") -> "Variation_339":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_779:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_780:
        return self.rule.content

class RuleVariation_332(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_339.cv_arg
    cv_variation: TypeAlias = Variation_339

    @classmethod
    def create(cls, arg : "RuleVariation_332.cv_arg") -> "RuleVariation_332":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_339:
        return self.arg # type: ignore

class NonSpare_1042(NonSpare):
    cv_arg: TypeAlias = RuleVariation_332.cv_arg
    cv_name = "GSP"
    cv_title = "Ground Speed"
    cv_rule: TypeAlias = RuleVariation_332

    @classmethod
    def create(cls, arg : "NonSpare_1042.cv_arg") -> "NonSpare_1042":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_332:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_339:
        return self.rule.variation

class Item_376(Item):
    cv_arg: TypeAlias = NonSpare_1042.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1042

    @classmethod
    def create(cls, arg : "Item_376.cv_arg") -> "Item_376":
        return cls._create(arg) # type: ignore

class NonSpare_1901(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TRA"
    cv_title = "Track Angle"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1901.cv_arg") -> "NonSpare_1901":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_1024(Item):
    cv_arg: TypeAlias = NonSpare_1901.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1901

    @classmethod
    def create(cls, arg : "Item_1024.cv_arg") -> "Item_1024":
        return cls._create(arg) # type: ignore

class Variation_1115(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_332.cv_arg, Tuple[Literal["GSP"], RuleVariation_332.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["TRA"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1115.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_376, 16), (Item_1024, 16)]
    cv_items_dict = {"GSP": RuleVariation_332, "TRA": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["GSP"]) -> RuleVariation_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRA"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GSP"], Literal["TRA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GSP"]) -> RuleVariation_332:
        ...
    @overload
    def get_item(self, key : Literal["TRA"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1115.cv_arg") -> 'Variation_1115':
        return cls._create(arg) # type: ignore

class RuleVariation_1073(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1115.cv_arg
    cv_variation: TypeAlias = Variation_1115

    @classmethod
    def create(cls, arg : "RuleVariation_1073.cv_arg") -> "RuleVariation_1073":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1115:
        return self.arg # type: ignore

class NonSpare_391(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1073.cv_arg
    cv_name = "200"
    cv_title = "Calculated Track Velocity in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1073

    @classmethod
    def create(cls, arg : "NonSpare_391.cv_arg") -> "NonSpare_391":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1073:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1115:
        return self.rule.variation

class UapItem_391(UapItem):
    cv_non_spare: TypeAlias = NonSpare_391

class Content_669(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_669(RuleContentContextFree):
    cv_arg: TypeAlias = Content_669.cv_arg
    cv_content: TypeAlias = Content_669

    @property
    def content(self) -> Content_669:
        return self._get_content() # type: ignore

class Variation_282(Element):
    cv_arg: TypeAlias = RuleContent_669.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_669

    @classmethod
    def create(cls, arg: "Variation_282.cv_arg") -> "Variation_282":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_669:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_669:
        return self.rule.content

class RuleVariation_275(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_282.cv_arg
    cv_variation: TypeAlias = Variation_282

    @classmethod
    def create(cls, arg : "RuleVariation_275.cv_arg") -> "RuleVariation_275":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_282:
        return self.arg # type: ignore

class NonSpare_2052(NonSpare):
    cv_arg: TypeAlias = RuleVariation_275.cv_arg
    cv_name = "VX"
    cv_title = "X Velocity"
    cv_rule: TypeAlias = RuleVariation_275

    @classmethod
    def create(cls, arg : "NonSpare_2052.cv_arg") -> "NonSpare_2052":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_275:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_282:
        return self.rule.variation

class Item_1158(Item):
    cv_arg: TypeAlias = NonSpare_2052.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2052

    @classmethod
    def create(cls, arg : "Item_1158.cv_arg") -> "Item_1158":
        return cls._create(arg) # type: ignore

class NonSpare_2057(NonSpare):
    cv_arg: TypeAlias = RuleVariation_275.cv_arg
    cv_name = "VY"
    cv_title = "Y Velocity"
    cv_rule: TypeAlias = RuleVariation_275

    @classmethod
    def create(cls, arg : "NonSpare_2057.cv_arg") -> "NonSpare_2057":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_275:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_282:
        return self.rule.variation

class Item_1163(Item):
    cv_arg: TypeAlias = NonSpare_2057.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2057

    @classmethod
    def create(cls, arg : "Item_1163.cv_arg") -> "Item_1163":
        return cls._create(arg) # type: ignore

class Variation_1283(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_275.cv_arg, Tuple[Literal["VX"], RuleVariation_275.cv_arg]], Union[RuleVariation_275.cv_arg, Tuple[Literal["VY"], RuleVariation_275.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1283.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1158, 16), (Item_1163, 16)]
    cv_items_dict = {"VX": RuleVariation_275, "VY": RuleVariation_275}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_275:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_275:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_275:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_275:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1283.cv_arg") -> 'Variation_1283':
        return cls._create(arg) # type: ignore

class RuleVariation_1212(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1283.cv_arg
    cv_variation: TypeAlias = Variation_1283

    @classmethod
    def create(cls, arg : "RuleVariation_1212.cv_arg") -> "RuleVariation_1212":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1283:
        return self.arg # type: ignore

class NonSpare_404(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1212.cv_arg
    cv_name = "202"
    cv_title = "Calculated Track Velocity in Cartesian Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1212

    @classmethod
    def create(cls, arg : "NonSpare_404.cv_arg") -> "NonSpare_404":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1212:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1283:
        return self.rule.variation

class UapItem_404(UapItem):
    cv_non_spare: TypeAlias = NonSpare_404

class NonSpare_1919(NonSpare):
    cv_arg: TypeAlias = RuleVariation_778.cv_arg
    cv_name = "TRK"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_778

    @classmethod
    def create(cls, arg : "NonSpare_1919.cv_arg") -> "NonSpare_1919":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

class Item_1038(Item):
    cv_arg: TypeAlias = NonSpare_1919.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1919

    @classmethod
    def create(cls, arg : "Item_1038.cv_arg") -> "Item_1038":
        return cls._create(arg) # type: ignore

class Variation_1034(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_778.cv_arg, Tuple[Literal["TRK"], RuleVariation_778.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1034.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_1038, 12)]
    cv_items_dict = {"TRK": RuleVariation_778}

    @classmethod
    def spec(cls, key : Literal["TRK"]) -> RuleVariation_778:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TRK"]) -> RuleVariation_778:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1034.cv_arg") -> 'Variation_1034':
        return cls._create(arg) # type: ignore

class RuleVariation_1002(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1034.cv_arg
    cv_variation: TypeAlias = Variation_1034

    @classmethod
    def create(cls, arg : "RuleVariation_1002.cv_arg") -> "RuleVariation_1002":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1034:
        return self.arg # type: ignore

class NonSpare_362(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1002.cv_arg
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_1002

    @classmethod
    def create(cls, arg : "NonSpare_362.cv_arg") -> "NonSpare_362":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1002:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1034:
        return self.rule.variation

class UapItem_362(UapItem):
    cv_non_spare: TypeAlias = NonSpare_362

class Content_63(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Confirmed track", 1: "Track in initialisation phase"}

class RuleContent_63(RuleContentContextFree):
    cv_arg: TypeAlias = Content_63.cv_arg
    cv_content: TypeAlias = Content_63

    @property
    def content(self) -> Content_63:
        return self._get_content() # type: ignore

class Variation_18(Element):
    cv_arg: TypeAlias = RuleContent_63.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_63

    @classmethod
    def create(cls, arg: "Variation_18.cv_arg") -> "Variation_18":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_63:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_63:
        return self.rule.content

class RuleVariation_18(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_18.cv_arg
    cv_variation: TypeAlias = Variation_18

    @classmethod
    def create(cls, arg : "RuleVariation_18.cv_arg") -> "RuleVariation_18":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_18:
        return self.arg # type: ignore

class Variation_411(Element):
    cv_arg: TypeAlias = RuleContent_112.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_112

    @classmethod
    def create(cls, arg: "Variation_411.cv_arg") -> "Variation_411":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_112:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_112:
        return self.rule.content

class RuleVariation_400(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_411.cv_arg
    cv_variation: TypeAlias = Variation_411

    @classmethod
    def create(cls, arg : "RuleVariation_400.cv_arg") -> "RuleVariation_400":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_411:
        return self.arg # type: ignore

class Content_361(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No extrapolation", 1: "Predictable extrapolation due to sensor refresh period (see NOTE)", 2: "Predictable extrapolation in masked area", 3: "Extrapolation due to unpredictable absence of detection"}

class RuleContent_361(RuleContentContextFree):
    cv_arg: TypeAlias = Content_361.cv_arg
    cv_content: TypeAlias = Content_361

    @property
    def content(self) -> Content_361:
        return self._get_content() # type: ignore

class Variation_594(Element):
    cv_arg: TypeAlias = RuleContent_361.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_361

    @classmethod
    def create(cls, arg: "Variation_594.cv_arg") -> "Variation_594":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_361:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_361:
        return self.rule.content

class RuleVariation_583(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_594.cv_arg
    cv_variation: TypeAlias = Variation_594

    @classmethod
    def create(cls, arg : "RuleVariation_583.cv_arg") -> "RuleVariation_583":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_594:
        return self.arg # type: ignore

class Content_105(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Horizontal manoeuvre"}

class RuleContent_105(RuleContentContextFree):
    cv_arg: TypeAlias = Content_105.cv_arg
    cv_content: TypeAlias = Content_105

    @property
    def content(self) -> Content_105:
        return self._get_content() # type: ignore

class Variation_706(Element):
    cv_arg: TypeAlias = RuleContent_105.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_105

    @classmethod
    def create(cls, arg: "Variation_706.cv_arg") -> "Variation_706":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_105:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_105:
        return self.rule.content

class RuleVariation_695(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_706.cv_arg
    cv_variation: TypeAlias = Variation_706

    @classmethod
    def create(cls, arg : "RuleVariation_695.cv_arg") -> "RuleVariation_695":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_706:
        return self.arg # type: ignore

class Content_515(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Tracking performed in 'Sensor Plane', i.e. neither slant range correction nor projection was applied", 1: "Slant range correction and a suitable projection technique are used to track in a 2D.reference plane, tangential to the earth model at the Sensor Site co-ordinates"}

class RuleContent_515(RuleContentContextFree):
    cv_arg: TypeAlias = Content_515.cv_arg
    cv_content: TypeAlias = Content_515

    @property
    def content(self) -> Content_515:
        return self._get_content() # type: ignore

class Variation_874(Element):
    cv_arg: TypeAlias = RuleContent_515.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_515

    @classmethod
    def create(cls, arg: "Variation_874.cv_arg") -> "Variation_874":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_515:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_515:
        return self.rule.content

class RuleVariation_844(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_874.cv_arg
    cv_variation: TypeAlias = Variation_874

    @classmethod
    def create(cls, arg : "RuleVariation_844.cv_arg") -> "RuleVariation_844":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_874:
        return self.arg # type: ignore

class Content_268(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Measured position", 1: "Smoothed position"}

class RuleContent_268(RuleContentContextFree):
    cv_arg: TypeAlias = Content_268.cv_arg
    cv_content: TypeAlias = Content_268

    @property
    def content(self) -> Content_268:
        return self._get_content() # type: ignore

class Variation_937(Element):
    cv_arg: TypeAlias = RuleContent_268.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_268

    @classmethod
    def create(cls, arg: "Variation_937.cv_arg") -> "Variation_937":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_268:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_268:
        return self.rule.content

class RuleVariation_907(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_937.cv_arg
    cv_variation: TypeAlias = Variation_937

    @classmethod
    def create(cls, arg : "RuleVariation_907.cv_arg") -> "RuleVariation_907":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_937:
        return self.arg # type: ignore

class Content_554(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown type of movement", 1: "Taking-off", 2: "Landing", 3: "Other types of movement"}

class RuleContent_554(RuleContentContextFree):
    cv_arg: TypeAlias = Content_554.cv_arg
    cv_content: TypeAlias = Content_554

    @property
    def content(self) -> Content_554:
        return self._get_content() # type: ignore

class Variation_117(Element):
    cv_arg: TypeAlias = RuleContent_554.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_554

    @classmethod
    def create(cls, arg: "Variation_117.cv_arg") -> "Variation_117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_554:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_554:
        return self.rule.content

class RuleVariation_117(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_117.cv_arg
    cv_variation: TypeAlias = Variation_117

    @classmethod
    def create(cls, arg : "RuleVariation_117.cv_arg") -> "RuleVariation_117":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_117:
        return self.arg # type: ignore

class Content_353(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No doubt", 1: "Doubtful correlation (undetermined reason)", 2: "Doubtful correlation in clutter", 3: "Loss of accuracy", 4: "Loss of accuracy in clutter", 5: "Unstable track", 6: "Previously coasted"}

class RuleContent_353(RuleContentContextFree):
    cv_arg: TypeAlias = Content_353.cv_arg
    cv_content: TypeAlias = Content_353

    @property
    def content(self) -> Content_353:
        return self._get_content() # type: ignore

class Variation_600(Element):
    cv_arg: TypeAlias = RuleContent_353.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_353

    @classmethod
    def create(cls, arg: "Variation_600.cv_arg") -> "Variation_600":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_353:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_353:
        return self.rule.content

class RuleVariation_589(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_600.cv_arg
    cv_variation: TypeAlias = Variation_600

    @classmethod
    def create(cls, arg : "RuleVariation_589.cv_arg") -> "RuleVariation_589":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_600:
        return self.arg # type: ignore

class Content_269(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Merge or split indication undetermined", 1: "Track merged by association to plot", 2: "Track merged by non-association to plot", 3: "Split track"}

class RuleContent_269(RuleContentContextFree):
    cv_arg: TypeAlias = Content_269.cv_arg
    cv_content: TypeAlias = Content_269

    @property
    def content(self) -> Content_269:
        return self._get_content() # type: ignore

class Variation_879(Element):
    cv_arg: TypeAlias = RuleContent_269.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_269

    @classmethod
    def create(cls, arg: "Variation_879.cv_arg") -> "Variation_879":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_269:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_269:
        return self.rule.content

class RuleVariation_849(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_879.cv_arg
    cv_variation: TypeAlias = Variation_879

    @classmethod
    def create(cls, arg : "RuleVariation_849.cv_arg") -> "RuleVariation_849":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_879:
        return self.arg # type: ignore

class Variation_28(Element):
    cv_arg: TypeAlias = RuleContent_99.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_99

    @classmethod
    def create(cls, arg: "Variation_28.cv_arg") -> "Variation_28":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_99:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_99:
        return self.rule.content

class RuleVariation_28(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_28.cv_arg
    cv_variation: TypeAlias = Variation_28

    @classmethod
    def create(cls, arg : "RuleVariation_28.cv_arg") -> "RuleVariation_28":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_28:
        return self.arg # type: ignore

class NonSpare_747(NonSpare):
    cv_arg: TypeAlias = RuleVariation_18.cv_arg
    cv_name = "CNF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_18

    @classmethod
    def create(cls, arg : "NonSpare_747.cv_arg") -> "NonSpare_747":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_18:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_18:
        return self.rule.variation

class Item_165(Item):
    cv_arg: TypeAlias = NonSpare_747.cv_arg
    cv_non_spare: TypeAlias = NonSpare_747

    @classmethod
    def create(cls, arg : "Item_165.cv_arg") -> "Item_165":
        return cls._create(arg) # type: ignore

class NonSpare_1915(NonSpare):
    cv_arg: TypeAlias = RuleVariation_400.cv_arg
    cv_name = "TRE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_400

    @classmethod
    def create(cls, arg : "NonSpare_1915.cv_arg") -> "NonSpare_1915":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_400:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_411:
        return self.rule.variation

class Item_1036(Item):
    cv_arg: TypeAlias = NonSpare_1915.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1915

    @classmethod
    def create(cls, arg : "Item_1036.cv_arg") -> "Item_1036":
        return cls._create(arg) # type: ignore

class NonSpare_842(NonSpare):
    cv_arg: TypeAlias = RuleVariation_583.cv_arg
    cv_name = "CST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_583

    @classmethod
    def create(cls, arg : "NonSpare_842.cv_arg") -> "NonSpare_842":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_583:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_594:
        return self.rule.variation

class Item_225(Item):
    cv_arg: TypeAlias = NonSpare_842.cv_arg
    cv_non_spare: TypeAlias = NonSpare_842

    @classmethod
    def create(cls, arg : "Item_225.cv_arg") -> "Item_225":
        return cls._create(arg) # type: ignore

class NonSpare_1224(NonSpare):
    cv_arg: TypeAlias = RuleVariation_695.cv_arg
    cv_name = "MAH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_695

    @classmethod
    def create(cls, arg : "NonSpare_1224.cv_arg") -> "NonSpare_1224":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_695:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_706:
        return self.rule.variation

class Item_524(Item):
    cv_arg: TypeAlias = NonSpare_1224.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1224

    @classmethod
    def create(cls, arg : "Item_524.cv_arg") -> "Item_524":
        return cls._create(arg) # type: ignore

class NonSpare_1840(NonSpare):
    cv_arg: TypeAlias = RuleVariation_844.cv_arg
    cv_name = "TCC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_844

    @classmethod
    def create(cls, arg : "NonSpare_1840.cv_arg") -> "NonSpare_1840":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_844:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_874:
        return self.rule.variation

class Item_979(Item):
    cv_arg: TypeAlias = NonSpare_1840.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1840

    @classmethod
    def create(cls, arg : "Item_979.cv_arg") -> "Item_979":
        return cls._create(arg) # type: ignore

class NonSpare_1789(NonSpare):
    cv_arg: TypeAlias = RuleVariation_907.cv_arg
    cv_name = "STH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_907

    @classmethod
    def create(cls, arg : "NonSpare_1789.cv_arg") -> "NonSpare_1789":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_907:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_937:
        return self.rule.variation

class Item_949(Item):
    cv_arg: TypeAlias = NonSpare_1789.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1789

    @classmethod
    def create(cls, arg : "Item_949.cv_arg") -> "Item_949":
        return cls._create(arg) # type: ignore

class NonSpare_1884(NonSpare):
    cv_arg: TypeAlias = RuleVariation_117.cv_arg
    cv_name = "TOM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_117

    @classmethod
    def create(cls, arg : "NonSpare_1884.cv_arg") -> "NonSpare_1884":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_117:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_117:
        return self.rule.variation

class Item_1009(Item):
    cv_arg: TypeAlias = NonSpare_1884.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1884

    @classmethod
    def create(cls, arg : "Item_1009.cv_arg") -> "Item_1009":
        return cls._create(arg) # type: ignore

class NonSpare_893(NonSpare):
    cv_arg: TypeAlias = RuleVariation_589.cv_arg
    cv_name = "DOU"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_589

    @classmethod
    def create(cls, arg : "NonSpare_893.cv_arg") -> "NonSpare_893":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_589:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_600:
        return self.rule.variation

class Item_268(Item):
    cv_arg: TypeAlias = NonSpare_893.cv_arg
    cv_non_spare: TypeAlias = NonSpare_893

    @classmethod
    def create(cls, arg : "Item_268.cv_arg") -> "Item_268":
        return cls._create(arg) # type: ignore

class NonSpare_1317(NonSpare):
    cv_arg: TypeAlias = RuleVariation_849.cv_arg
    cv_name = "MRS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_849

    @classmethod
    def create(cls, arg : "NonSpare_1317.cv_arg") -> "NonSpare_1317":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_849:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_879:
        return self.rule.variation

class Item_583(Item):
    cv_arg: TypeAlias = NonSpare_1317.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1317

    @classmethod
    def create(cls, arg : "Item_583.cv_arg") -> "Item_583":
        return cls._create(arg) # type: ignore

class NonSpare_1035(NonSpare):
    cv_arg: TypeAlias = RuleVariation_28.cv_arg
    cv_name = "GHO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_28

    @classmethod
    def create(cls, arg : "NonSpare_1035.cv_arg") -> "NonSpare_1035":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_28:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_28:
        return self.rule.variation

class Item_370(Item):
    cv_arg: TypeAlias = NonSpare_1035.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1035

    @classmethod
    def create(cls, arg : "Item_370.cv_arg") -> "Item_370":
        return cls._create(arg) # type: ignore

class Variation_1351(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_18.cv_arg, Tuple[Literal["CNF"], RuleVariation_18.cv_arg]], Union[RuleVariation_400.cv_arg, Tuple[Literal["TRE"], RuleVariation_400.cv_arg]], Union[RuleVariation_583.cv_arg, Tuple[Literal["CST"], RuleVariation_583.cv_arg]], Union[RuleVariation_695.cv_arg, Tuple[Literal["MAH"], RuleVariation_695.cv_arg]], Union[RuleVariation_844.cv_arg, Tuple[Literal["TCC"], RuleVariation_844.cv_arg]], Union[RuleVariation_907.cv_arg, Tuple[Literal["STH"], RuleVariation_907.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_117.cv_arg, Tuple[Literal["TOM"], RuleVariation_117.cv_arg]], Union[RuleVariation_589.cv_arg, Tuple[Literal["DOU"], RuleVariation_589.cv_arg]], Union[RuleVariation_849.cv_arg, Tuple[Literal["MRS"], RuleVariation_849.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_28.cv_arg, Tuple[Literal["GHO"], RuleVariation_28.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1351.cv_arg_group_1"],
        Tuple["Variation_1351.cv_arg_group_1", "Variation_1351.cv_arg_group_2"],
        Tuple["Variation_1351.cv_arg_group_1", "Variation_1351.cv_arg_group_2", "Variation_1351.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_165, 1), (Item_1036, 1), (Item_225, 2), (Item_524, 1), (Item_979, 1), (Item_949, 1), None], [(Item_1009, 2), (Item_268, 3), (Item_583, 2), None], [(Item_370, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1351.cv_arg") -> 'Variation_1351':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_18:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> RuleVariation_400:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_583:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_695:
        ...
    @overload
    def get_item(self, key : Literal["TCC"]) -> RuleVariation_844:
        ...
    @overload
    def get_item(self, key : Literal["STH"]) -> RuleVariation_907:
        ...
    @overload
    def get_item(self, key : Literal["TOM"]) -> Optional[RuleVariation_117]:
        ...
    @overload
    def get_item(self, key : Literal["DOU"]) -> Optional[RuleVariation_589]:
        ...
    @overload
    def get_item(self, key : Literal["MRS"]) -> Optional[RuleVariation_849]:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_28]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1272(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1351.cv_arg
    cv_variation: TypeAlias = Variation_1351

    @classmethod
    def create(cls, arg : "RuleVariation_1272.cv_arg") -> "RuleVariation_1272":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1351:
        return self.arg # type: ignore

class NonSpare_374(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1272.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1272

    @classmethod
    def create(cls, arg : "NonSpare_374.cv_arg") -> "NonSpare_374":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1351:
        return self.rule.variation

class UapItem_374(UapItem):
    cv_non_spare: TypeAlias = NonSpare_374

class NonSpare_1991(NonSpare):
    cv_arg: TypeAlias = RuleVariation_15.cv_arg
    cv_name = "V"
    cv_title = "Validated"
    cv_rule: TypeAlias = RuleVariation_15

    @classmethod
    def create(cls, arg : "NonSpare_1991.cv_arg") -> "NonSpare_1991":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_15:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_15:
        return self.rule.variation

class Item_1103(Item):
    cv_arg: TypeAlias = NonSpare_1991.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1991

    @classmethod
    def create(cls, arg : "Item_1103.cv_arg") -> "Item_1103":
        return cls._create(arg) # type: ignore

class NonSpare_1011(NonSpare):
    cv_arg: TypeAlias = RuleVariation_396.cv_arg
    cv_name = "G"
    cv_title = "Garbled"
    cv_rule: TypeAlias = RuleVariation_396

    @classmethod
    def create(cls, arg : "NonSpare_1011.cv_arg") -> "NonSpare_1011":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_396:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_407:
        return self.rule.variation

class Item_357(Item):
    cv_arg: TypeAlias = NonSpare_1011.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1011

    @classmethod
    def create(cls, arg : "Item_357.cv_arg") -> "Item_357":
        return cls._create(arg) # type: ignore

class Content_290(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Mode-3/A code not extracted during the last scan"}

class RuleContent_290(RuleContentContextFree):
    cv_arg: TypeAlias = Content_290.cv_arg
    cv_content: TypeAlias = Content_290

    @property
    def content(self) -> Content_290:
        return self._get_content() # type: ignore

class Variation_553(Element):
    cv_arg: TypeAlias = RuleContent_290.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_290

    @classmethod
    def create(cls, arg: "Variation_553.cv_arg") -> "Variation_553":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_290:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_290:
        return self.rule.content

class RuleVariation_542(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_553.cv_arg
    cv_variation: TypeAlias = Variation_553

    @classmethod
    def create(cls, arg : "RuleVariation_542.cv_arg") -> "RuleVariation_542":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_553:
        return self.arg # type: ignore

class NonSpare_1141(NonSpare):
    cv_arg: TypeAlias = RuleVariation_542.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_542

    @classmethod
    def create(cls, arg : "NonSpare_1141.cv_arg") -> "NonSpare_1141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_542:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_553:
        return self.rule.variation

class Item_453(Item):
    cv_arg: TypeAlias = NonSpare_1141.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1141

    @classmethod
    def create(cls, arg : "Item_453.cv_arg") -> "Item_453":
        return cls._create(arg) # type: ignore

class Variation_1275(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_542.cv_arg, Tuple[Literal["L"], RuleVariation_542.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1275.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_453, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_542, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1275.cv_arg") -> 'Variation_1275':
        return cls._create(arg) # type: ignore

class RuleVariation_1204(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1275.cv_arg
    cv_variation: TypeAlias = Variation_1275

    @classmethod
    def create(cls, arg : "RuleVariation_1204.cv_arg") -> "RuleVariation_1204":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1275:
        return self.arg # type: ignore

class NonSpare_192(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1204.cv_arg
    cv_name = "060"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1204

    @classmethod
    def create(cls, arg : "NonSpare_192.cv_arg") -> "NonSpare_192":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1204:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1275:
        return self.rule.variation

class UapItem_192(UapItem):
    cv_non_spare: TypeAlias = NonSpare_192

class Variation_349(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_349.cv_arg") -> "Variation_349":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_342(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_349.cv_arg
    cv_variation: TypeAlias = Variation_349

    @classmethod
    def create(cls, arg : "RuleVariation_342.cv_arg") -> "RuleVariation_342":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_349:
        return self.arg # type: ignore

class NonSpare_426(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "220"
    cv_title = "Target Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_426.cv_arg") -> "NonSpare_426":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_426(UapItem):
    cv_non_spare: TypeAlias = NonSpare_426

class Content_51(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Callsign or registration downlinked from transponder", 1: "Callsign not downlinked from transponder", 2: "Registration not downlinked from transponder"}

class RuleContent_51(RuleContentContextFree):
    cv_arg: TypeAlias = Content_51.cv_arg
    cv_content: TypeAlias = Content_51

    @property
    def content(self) -> Content_51:
        return self._get_content() # type: ignore

class Variation_98(Element):
    cv_arg: TypeAlias = RuleContent_51.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_51

    @classmethod
    def create(cls, arg: "Variation_98.cv_arg") -> "Variation_98":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_51:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_51:
        return self.rule.content

class RuleVariation_98(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_98.cv_arg
    cv_variation: TypeAlias = Variation_98

    @classmethod
    def create(cls, arg : "RuleVariation_98.cv_arg") -> "RuleVariation_98":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_98:
        return self.arg # type: ignore

class NonSpare_1791(NonSpare):
    cv_arg: TypeAlias = RuleVariation_98.cv_arg
    cv_name = "STI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_98

    @classmethod
    def create(cls, arg : "NonSpare_1791.cv_arg") -> "NonSpare_1791":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_98:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_98:
        return self.rule.variation

class Item_951(Item):
    cv_arg: TypeAlias = NonSpare_1791.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1791

    @classmethod
    def create(cls, arg : "Item_951.cv_arg") -> "Item_951":
        return cls._create(arg) # type: ignore

class Item_15(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 2
    cv_bit_size = 6

class NonSpare_736(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "CHR"
    cv_title = "Characters 1-8 (Coded on 6 Bits Each) Defining Target Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_736.cv_arg") -> "NonSpare_736":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class Item_158(Item):
    cv_arg: TypeAlias = NonSpare_736.cv_arg
    cv_non_spare: TypeAlias = NonSpare_736

    @classmethod
    def create(cls, arg : "Item_158.cv_arg") -> "Item_158":
        return cls._create(arg) # type: ignore

class Variation_1216(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_98.cv_arg, Tuple[Literal["STI"], RuleVariation_98.cv_arg]], int, Union[RuleVariation_383.cv_arg, Tuple[Literal["CHR"], RuleVariation_383.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1216.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_951, 2), (Item_15, 6), (Item_158, 48)]
    cv_items_dict = {"STI": RuleVariation_98, "CHR": RuleVariation_383}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_98:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHR"]) -> RuleVariation_383:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["CHR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_98:
        ...
    @overload
    def get_item(self, key : Literal["CHR"]) -> RuleVariation_383:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1216.cv_arg") -> 'Variation_1216':
        return cls._create(arg) # type: ignore

class RuleVariation_1160(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1216.cv_arg
    cv_variation: TypeAlias = Variation_1216

    @classmethod
    def create(cls, arg : "RuleVariation_1160.cv_arg") -> "RuleVariation_1160":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1216:
        return self.arg # type: ignore

class NonSpare_441(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1160.cv_arg
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_1160

    @classmethod
    def create(cls, arg : "NonSpare_441.cv_arg") -> "NonSpare_441":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1160:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1216:
        return self.rule.variation

class UapItem_441(UapItem):
    cv_non_spare: TypeAlias = NonSpare_441

class Variation_392(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_392.cv_arg") -> "Variation_392":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_384(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_392.cv_arg
    cv_variation: TypeAlias = Variation_392

    @classmethod
    def create(cls, arg : "RuleVariation_384.cv_arg") -> "RuleVariation_384":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_392:
        return self.arg # type: ignore

class NonSpare_1235(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "MBDATA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_1235.cv_arg") -> "NonSpare_1235":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class Item_531(Item):
    cv_arg: TypeAlias = NonSpare_1235.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1235

    @classmethod
    def create(cls, arg : "Item_531.cv_arg") -> "Item_531":
        return cls._create(arg) # type: ignore

class NonSpare_675(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "BDS1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_675.cv_arg") -> "NonSpare_675":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_115(Item):
    cv_arg: TypeAlias = NonSpare_675.cv_arg
    cv_non_spare: TypeAlias = NonSpare_675

    @classmethod
    def create(cls, arg : "Item_115.cv_arg") -> "Item_115":
        return cls._create(arg) # type: ignore

class Variation_799(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_799.cv_arg") -> "Variation_799":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_769(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_799.cv_arg
    cv_variation: TypeAlias = Variation_799

    @classmethod
    def create(cls, arg : "RuleVariation_769.cv_arg") -> "RuleVariation_769":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_799:
        return self.arg # type: ignore

class NonSpare_677(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "BDS2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_677.cv_arg") -> "NonSpare_677":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_117(Item):
    cv_arg: TypeAlias = NonSpare_677.cv_arg
    cv_non_spare: TypeAlias = NonSpare_677

    @classmethod
    def create(cls, arg : "Item_117.cv_arg") -> "Item_117":
        return cls._create(arg) # type: ignore

class Variation_1142(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_384.cv_arg, Tuple[Literal["MBDATA"], RuleVariation_384.cv_arg]], Union[RuleVariation_132.cv_arg, Tuple[Literal["BDS1"], RuleVariation_132.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["BDS2"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1142.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_531, 56), (Item_115, 4), (Item_117, 4)]
    cv_items_dict = {"MBDATA": RuleVariation_384, "BDS1": RuleVariation_132, "BDS2": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["MBDATA"]) -> RuleVariation_384:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS1"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS2"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MBDATA"], Literal["BDS1"], Literal["BDS2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MBDATA"]) -> RuleVariation_384:
        ...
    @overload
    def get_item(self, key : Literal["BDS1"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["BDS2"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1142.cv_arg") -> 'Variation_1142':
        return cls._create(arg) # type: ignore

class Variation_1421(Repetitive):
    cv_arg: TypeAlias = List[Variation_1142.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1142

    @classmethod
    def create(cls, arg: "Variation_1421.cv_arg") -> 'Variation_1421':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1142]:
        return self._get_list() # type: ignore

class RuleVariation_1342(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1421.cv_arg
    cv_variation: TypeAlias = Variation_1421

    @classmethod
    def create(cls, arg : "RuleVariation_1342.cv_arg") -> "RuleVariation_1342":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1421:
        return self.arg # type: ignore

class NonSpare_448(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1342.cv_arg
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule: TypeAlias = RuleVariation_1342

    @classmethod
    def create(cls, arg : "NonSpare_448.cv_arg") -> "NonSpare_448":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1421:
        return self.rule.variation

class UapItem_448(UapItem):
    cv_non_spare: TypeAlias = NonSpare_448

class Content_537(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "ATC equipment maintenance", 2: "Airport maintenance", 3: "Fire", 4: "Bird scarer", 5: "Snow plough", 6: "Runway sweeper", 7: "Emergency", 8: "Police", 9: "Bus", 10: "Tug (push/tow)", 11: "Grass cutter", 12: "Fuel", 13: "Baggage", 14: "Catering", 15: "Aircraft maintenance", 16: "Flyco (follow me)"}

class RuleContent_537(RuleContentContextFree):
    cv_arg: TypeAlias = Content_537.cv_arg
    cv_content: TypeAlias = Content_537

    @property
    def content(self) -> Content_537:
        return self._get_content() # type: ignore

class Variation_177(Element):
    cv_arg: TypeAlias = RuleContent_537.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_537

    @classmethod
    def create(cls, arg: "Variation_177.cv_arg") -> "Variation_177":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_537:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_537:
        return self.rule.content

class RuleVariation_170(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_177.cv_arg
    cv_variation: TypeAlias = Variation_177

    @classmethod
    def create(cls, arg : "RuleVariation_170.cv_arg") -> "RuleVariation_170":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_177:
        return self.arg # type: ignore

class NonSpare_477(NonSpare):
    cv_arg: TypeAlias = RuleVariation_170.cv_arg
    cv_name = "300"
    cv_title = "Vehicle Fleet Identification"
    cv_rule: TypeAlias = RuleVariation_170

    @classmethod
    def create(cls, arg : "NonSpare_477.cv_arg") -> "NonSpare_477":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_170:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_177:
        return self.rule.variation

class UapItem_477(UapItem):
    cv_non_spare: TypeAlias = NonSpare_477

class NonSpare_974(NonSpare):
    cv_arg: TypeAlias = RuleVariation_598.cv_arg
    cv_name = "FL"
    cv_title = "Flight Level"
    cv_rule: TypeAlias = RuleVariation_598

    @classmethod
    def create(cls, arg : "NonSpare_974.cv_arg") -> "NonSpare_974":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_598:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_609:
        return self.rule.variation

class Item_331(Item):
    cv_arg: TypeAlias = NonSpare_974.cv_arg
    cv_non_spare: TypeAlias = NonSpare_974

    @classmethod
    def create(cls, arg : "Item_331.cv_arg") -> "Item_331":
        return cls._create(arg) # type: ignore

class Variation_1271(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_598.cv_arg, Tuple[Literal["FL"], RuleVariation_598.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1271.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_331, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "FL": RuleVariation_598}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_598:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_598:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1271.cv_arg") -> 'Variation_1271':
        return cls._create(arg) # type: ignore

class RuleVariation_1200(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1271.cv_arg
    cv_variation: TypeAlias = Variation_1271

    @classmethod
    def create(cls, arg : "RuleVariation_1200.cv_arg") -> "RuleVariation_1200":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1271:
        return self.arg # type: ignore

class NonSpare_250(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1200.cv_arg
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule: TypeAlias = RuleVariation_1200

    @classmethod
    def create(cls, arg : "NonSpare_250.cv_arg") -> "NonSpare_250":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1271:
        return self.rule.variation

class UapItem_250(UapItem):
    cv_non_spare: TypeAlias = NonSpare_250

class Content_685(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_685(RuleContentContextFree):
    cv_arg: TypeAlias = Content_685.cv_arg
    cv_content: TypeAlias = Content_685

    @property
    def content(self) -> Content_685:
        return self._get_content() # type: ignore

class Variation_290(Element):
    cv_arg: TypeAlias = RuleContent_685.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_685

    @classmethod
    def create(cls, arg: "Variation_290.cv_arg") -> "Variation_290":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_685:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_685:
        return self.rule.content

class RuleVariation_283(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_290.cv_arg
    cv_variation: TypeAlias = Variation_290

    @classmethod
    def create(cls, arg : "RuleVariation_283.cv_arg") -> "RuleVariation_283":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_290:
        return self.arg # type: ignore

class NonSpare_260(NonSpare):
    cv_arg: TypeAlias = RuleVariation_283.cv_arg
    cv_name = "091"
    cv_title = "Measured Height"
    cv_rule: TypeAlias = RuleVariation_283

    @classmethod
    def create(cls, arg : "NonSpare_260.cv_arg") -> "NonSpare_260":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_290:
        return self.rule.variation

class UapItem_260(UapItem):
    cv_non_spare: TypeAlias = NonSpare_260

class Content_719(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_719(RuleContentContextFree):
    cv_arg: TypeAlias = Content_719.cv_arg
    cv_content: TypeAlias = Content_719

    @property
    def content(self) -> Content_719:
        return self._get_content() # type: ignore

class Variation_161(Element):
    cv_arg: TypeAlias = RuleContent_719.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_719

    @classmethod
    def create(cls, arg: "Variation_161.cv_arg") -> "Variation_161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_719:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_719:
        return self.rule.content

class RuleVariation_155(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_161.cv_arg
    cv_variation: TypeAlias = Variation_161

    @classmethod
    def create(cls, arg : "RuleVariation_155.cv_arg") -> "RuleVariation_155":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_161:
        return self.arg # type: ignore

class Content_789(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 2.8125
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_788(RuleContentContextFree):
    cv_arg: TypeAlias = Content_789.cv_arg
    cv_content: TypeAlias = Content_789

    @property
    def content(self) -> Content_789:
        return self._get_content() # type: ignore

class Variation_164(Element):
    cv_arg: TypeAlias = RuleContent_788.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_788

    @classmethod
    def create(cls, arg: "Variation_164.cv_arg") -> "Variation_164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_788:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_789:
        return self.rule.content

class RuleVariation_158(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_164.cv_arg
    cv_variation: TypeAlias = Variation_164

    @classmethod
    def create(cls, arg : "RuleVariation_158.cv_arg") -> "RuleVariation_158":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_164:
        return self.arg # type: ignore

class NonSpare_1168(NonSpare):
    cv_arg: TypeAlias = RuleVariation_155.cv_arg
    cv_name = "LENGTH"
    cv_title = "Length"
    cv_rule: TypeAlias = RuleVariation_155

    @classmethod
    def create(cls, arg : "NonSpare_1168.cv_arg") -> "NonSpare_1168":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_155:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_161:
        return self.rule.variation

class Item_478(Item):
    cv_arg: TypeAlias = NonSpare_1168.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1168

    @classmethod
    def create(cls, arg : "Item_478.cv_arg") -> "Item_478":
        return cls._create(arg) # type: ignore

class NonSpare_1403(NonSpare):
    cv_arg: TypeAlias = RuleVariation_158.cv_arg
    cv_name = "ORIENTATION"
    cv_title = "Orientation"
    cv_rule: TypeAlias = RuleVariation_158

    @classmethod
    def create(cls, arg : "NonSpare_1403.cv_arg") -> "NonSpare_1403":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_164:
        return self.rule.variation

class Item_662(Item):
    cv_arg: TypeAlias = NonSpare_1403.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1403

    @classmethod
    def create(cls, arg : "Item_662.cv_arg") -> "Item_662":
        return cls._create(arg) # type: ignore

class NonSpare_2062(NonSpare):
    cv_arg: TypeAlias = RuleVariation_155.cv_arg
    cv_name = "WIDTH"
    cv_title = "Width"
    cv_rule: TypeAlias = RuleVariation_155

    @classmethod
    def create(cls, arg : "NonSpare_2062.cv_arg") -> "NonSpare_2062":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_155:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_161:
        return self.rule.variation

class Item_1166(Item):
    cv_arg: TypeAlias = NonSpare_2062.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2062

    @classmethod
    def create(cls, arg : "Item_1166.cv_arg") -> "Item_1166":
        return cls._create(arg) # type: ignore

class Variation_1363(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_155.cv_arg, Tuple[Literal["LENGTH"], RuleVariation_155.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_158.cv_arg, Tuple[Literal["ORIENTATION"], RuleVariation_158.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_155.cv_arg, Tuple[Literal["WIDTH"], RuleVariation_155.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1363.cv_arg_group_1"],
        Tuple["Variation_1363.cv_arg_group_1", "Variation_1363.cv_arg_group_2"],
        Tuple["Variation_1363.cv_arg_group_1", "Variation_1363.cv_arg_group_2", "Variation_1363.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_478, 7), None], [(Item_662, 7), None], [(Item_1166, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1363.cv_arg") -> 'Variation_1363':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["LENGTH"]) -> RuleVariation_155:
        ...
    @overload
    def get_item(self, key : Literal["ORIENTATION"]) -> Optional[RuleVariation_158]:
        ...
    @overload
    def get_item(self, key : Literal["WIDTH"]) -> Optional[RuleVariation_155]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1284(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1363.cv_arg
    cv_variation: TypeAlias = Variation_1363

    @classmethod
    def create(cls, arg : "RuleVariation_1284.cv_arg") -> "RuleVariation_1284":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1363:
        return self.arg # type: ignore

class NonSpare_461(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1284.cv_arg
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule: TypeAlias = RuleVariation_1284

    @classmethod
    def create(cls, arg : "NonSpare_461.cv_arg") -> "NonSpare_461":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1363:
        return self.rule.variation

class UapItem_461(UapItem):
    cv_non_spare: TypeAlias = NonSpare_461

class Content_411(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Operational", 1: "Degraded", 2: "NOGO"}

class RuleContent_411(RuleContentContextFree):
    cv_arg: TypeAlias = Content_411.cv_arg
    cv_content: TypeAlias = Content_411

    @property
    def content(self) -> Content_411:
        return self._get_content() # type: ignore

class Variation_108(Element):
    cv_arg: TypeAlias = RuleContent_411.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_411

    @classmethod
    def create(cls, arg: "Variation_108.cv_arg") -> "Variation_108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_411:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_411:
        return self.rule.content

class RuleVariation_108(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_108.cv_arg
    cv_variation: TypeAlias = Variation_108

    @classmethod
    def create(cls, arg : "RuleVariation_108.cv_arg") -> "RuleVariation_108":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_108:
        return self.arg # type: ignore

class NonSpare_1369(NonSpare):
    cv_arg: TypeAlias = RuleVariation_108.cv_arg
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the System"
    cv_rule: TypeAlias = RuleVariation_108

    @classmethod
    def create(cls, arg : "NonSpare_1369.cv_arg") -> "NonSpare_1369":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_108:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_108:
        return self.rule.variation

class Item_629(Item):
    cv_arg: TypeAlias = NonSpare_1369.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1369

    @classmethod
    def create(cls, arg : "Item_629.cv_arg") -> "Item_629":
        return cls._create(arg) # type: ignore

class Content_369(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No overload", 1: "Overload"}

class RuleContent_369(RuleContentContextFree):
    cv_arg: TypeAlias = Content_369.cv_arg
    cv_content: TypeAlias = Content_369

    @property
    def content(self) -> Content_369:
        return self._get_content() # type: ignore

class Variation_564(Element):
    cv_arg: TypeAlias = RuleContent_369.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_369

    @classmethod
    def create(cls, arg: "Variation_564.cv_arg") -> "Variation_564":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_369:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_369:
        return self.rule.content

class RuleVariation_553(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_564.cv_arg
    cv_variation: TypeAlias = Variation_564

    @classmethod
    def create(cls, arg : "RuleVariation_553.cv_arg") -> "RuleVariation_553":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_564:
        return self.arg # type: ignore

class NonSpare_1410(NonSpare):
    cv_arg: TypeAlias = RuleVariation_553.cv_arg
    cv_name = "OVL"
    cv_title = "Overload Indicator"
    cv_rule: TypeAlias = RuleVariation_553

    @classmethod
    def create(cls, arg : "NonSpare_1410.cv_arg") -> "NonSpare_1410":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_553:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_564:
        return self.rule.variation

class Item_668(Item):
    cv_arg: TypeAlias = NonSpare_1410.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1410

    @classmethod
    def create(cls, arg : "Item_668.cv_arg") -> "Item_668":
        return cls._create(arg) # type: ignore

class Content_559(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Valid", 1: "Invalid"}

class RuleContent_559(RuleContentContextFree):
    cv_arg: TypeAlias = Content_559.cv_arg
    cv_content: TypeAlias = Content_559

    @property
    def content(self) -> Content_559:
        return self._get_content() # type: ignore

class Variation_673(Element):
    cv_arg: TypeAlias = RuleContent_559.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_559

    @classmethod
    def create(cls, arg: "Variation_673.cv_arg") -> "Variation_673":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_559:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_559:
        return self.rule.content

class RuleVariation_662(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_673.cv_arg
    cv_variation: TypeAlias = Variation_673

    @classmethod
    def create(cls, arg : "RuleVariation_662.cv_arg") -> "RuleVariation_662":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_673:
        return self.arg # type: ignore

class NonSpare_1941(NonSpare):
    cv_arg: TypeAlias = RuleVariation_662.cv_arg
    cv_name = "TSV"
    cv_title = "Time Source Validity"
    cv_rule: TypeAlias = RuleVariation_662

    @classmethod
    def create(cls, arg : "NonSpare_1941.cv_arg") -> "NonSpare_1941":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_662:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_673:
        return self.rule.variation

class Item_1058(Item):
    cv_arg: TypeAlias = NonSpare_1941.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1941

    @classmethod
    def create(cls, arg : "Item_1058.cv_arg") -> "Item_1058":
        return cls._create(arg) # type: ignore

class Content_382(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Normal Operation", 1: "Diversity degraded"}

class RuleContent_382(RuleContentContextFree):
    cv_arg: TypeAlias = Content_382.cv_arg
    cv_content: TypeAlias = Content_382

    @property
    def content(self) -> Content_382:
        return self._get_content() # type: ignore

class Variation_742(Element):
    cv_arg: TypeAlias = RuleContent_382.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_382

    @classmethod
    def create(cls, arg: "Variation_742.cv_arg") -> "Variation_742":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_382:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_382:
        return self.rule.content

class RuleVariation_731(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_742.cv_arg
    cv_variation: TypeAlias = Variation_742

    @classmethod
    def create(cls, arg : "RuleVariation_731.cv_arg") -> "RuleVariation_731":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_742:
        return self.arg # type: ignore

class NonSpare_885(NonSpare):
    cv_arg: TypeAlias = RuleVariation_731.cv_arg
    cv_name = "DIV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_731

    @classmethod
    def create(cls, arg : "NonSpare_885.cv_arg") -> "NonSpare_885":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_731:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_742:
        return self.rule.variation

class Item_262(Item):
    cv_arg: TypeAlias = NonSpare_885.cv_arg
    cv_non_spare: TypeAlias = NonSpare_885

    @classmethod
    def create(cls, arg : "Item_262.cv_arg") -> "Item_262":
        return cls._create(arg) # type: ignore

class Content_487(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Test Target Operative", 1: "Test Target Failure"}

class RuleContent_487(RuleContentContextFree):
    cv_arg: TypeAlias = Content_487.cv_arg
    cv_content: TypeAlias = Content_487

    @property
    def content(self) -> Content_487:
        return self._get_content() # type: ignore

class Variation_872(Element):
    cv_arg: TypeAlias = RuleContent_487.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_487

    @classmethod
    def create(cls, arg: "Variation_872.cv_arg") -> "Variation_872":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_487:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_487:
        return self.rule.content

class RuleVariation_842(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_872.cv_arg
    cv_variation: TypeAlias = Variation_872

    @classmethod
    def create(cls, arg : "RuleVariation_842.cv_arg") -> "RuleVariation_842":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_872:
        return self.arg # type: ignore

class NonSpare_1948(NonSpare):
    cv_arg: TypeAlias = RuleVariation_842.cv_arg
    cv_name = "TTF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_842

    @classmethod
    def create(cls, arg : "NonSpare_1948.cv_arg") -> "NonSpare_1948":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_842:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_872:
        return self.rule.variation

class Item_1063(Item):
    cv_arg: TypeAlias = NonSpare_1948.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1948

    @classmethod
    def create(cls, arg : "Item_1063.cv_arg") -> "Item_1063":
        return cls._create(arg) # type: ignore

class Variation_1153(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_108.cv_arg, Tuple[Literal["NOGO"], RuleVariation_108.cv_arg]], Union[RuleVariation_553.cv_arg, Tuple[Literal["OVL"], RuleVariation_553.cv_arg]], Union[RuleVariation_662.cv_arg, Tuple[Literal["TSV"], RuleVariation_662.cv_arg]], Union[RuleVariation_731.cv_arg, Tuple[Literal["DIV"], RuleVariation_731.cv_arg]], Union[RuleVariation_842.cv_arg, Tuple[Literal["TTF"], RuleVariation_842.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1153.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_629, 2), (Item_668, 1), (Item_1058, 1), (Item_262, 1), (Item_1063, 1), (Item_27, 2)]
    cv_items_dict = {"NOGO": RuleVariation_108, "OVL": RuleVariation_553, "TSV": RuleVariation_662, "DIV": RuleVariation_731, "TTF": RuleVariation_842}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_553:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_662:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DIV"]) -> RuleVariation_731:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTF"]) -> RuleVariation_842:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["OVL"], Literal["TSV"], Literal["DIV"], Literal["TTF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_108:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_553:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_662:
        ...
    @overload
    def get_item(self, key : Literal["DIV"]) -> RuleVariation_731:
        ...
    @overload
    def get_item(self, key : Literal["TTF"]) -> RuleVariation_842:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1153.cv_arg") -> 'Variation_1153':
        return cls._create(arg) # type: ignore

class RuleVariation_1106(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1153.cv_arg
    cv_variation: TypeAlias = Variation_1153

    @classmethod
    def create(cls, arg : "RuleVariation_1106.cv_arg") -> "RuleVariation_1106":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1153:
        return self.arg # type: ignore

class NonSpare_523(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1106.cv_arg
    cv_name = "550"
    cv_title = "System Status"
    cv_rule: TypeAlias = RuleVariation_1106

    @classmethod
    def create(cls, arg : "NonSpare_523.cv_arg") -> "NonSpare_523":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1106:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1153:
        return self.rule.variation

class UapItem_522(UapItem):
    cv_non_spare: TypeAlias = NonSpare_523

class Content_109(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "In Trouble"}

class RuleContent_109(RuleContentContextFree):
    cv_arg: TypeAlias = Content_109.cv_arg
    cv_content: TypeAlias = Content_109

    @property
    def content(self) -> Content_109:
        return self._get_content() # type: ignore

class Variation_30(Element):
    cv_arg: TypeAlias = RuleContent_109.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_109

    @classmethod
    def create(cls, arg: "Variation_30.cv_arg") -> "Variation_30":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_109:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_109:
        return self.rule.content

class RuleVariation_30(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_30.cv_arg
    cv_variation: TypeAlias = Variation_30

    @classmethod
    def create(cls, arg : "RuleVariation_30.cv_arg") -> "RuleVariation_30":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_30:
        return self.arg # type: ignore

class NonSpare_1908(NonSpare):
    cv_arg: TypeAlias = RuleVariation_30.cv_arg
    cv_name = "TRB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_30

    @classmethod
    def create(cls, arg : "NonSpare_1908.cv_arg") -> "NonSpare_1908":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_30:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_30:
        return self.rule.variation

class Item_1031(Item):
    cv_arg: TypeAlias = NonSpare_1908.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1908

    @classmethod
    def create(cls, arg : "Item_1031.cv_arg") -> "Item_1031":
        return cls._create(arg) # type: ignore

class Content_602(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Towing aircraft", 2: "“Follow me” operation", 3: "Runway check", 4: "Emergency operation (fire, medical...)", 5: "Work in progress (maintenance, birds scarer, sweepers...)"}

class RuleContent_602(RuleContentContextFree):
    cv_arg: TypeAlias = Content_602.cv_arg
    cv_content: TypeAlias = Content_602

    @property
    def content(self) -> Content_602:
        return self._get_content() # type: ignore

class Variation_496(Element):
    cv_arg: TypeAlias = RuleContent_602.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_602

    @classmethod
    def create(cls, arg: "Variation_496.cv_arg") -> "Variation_496":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_602:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_602:
        return self.rule.content

class RuleVariation_485(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_496.cv_arg
    cv_variation: TypeAlias = Variation_496

    @classmethod
    def create(cls, arg : "RuleVariation_485.cv_arg") -> "RuleVariation_485":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_496:
        return self.arg # type: ignore

class NonSpare_1330(NonSpare):
    cv_arg: TypeAlias = RuleVariation_485.cv_arg
    cv_name = "MSG"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_485

    @classmethod
    def create(cls, arg : "NonSpare_1330.cv_arg") -> "NonSpare_1330":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_485:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_496:
        return self.rule.variation

class Item_594(Item):
    cv_arg: TypeAlias = NonSpare_1330.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1330

    @classmethod
    def create(cls, arg : "Item_594.cv_arg") -> "Item_594":
        return cls._create(arg) # type: ignore

class Variation_1231(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_30.cv_arg, Tuple[Literal["TRB"], RuleVariation_30.cv_arg]], Union[RuleVariation_485.cv_arg, Tuple[Literal["MSG"], RuleVariation_485.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1231.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1031, 1), (Item_594, 7)]
    cv_items_dict = {"TRB": RuleVariation_30, "MSG": RuleVariation_485}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSG"]) -> RuleVariation_485:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRB"], Literal["MSG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    def get_item(self, key : Literal["MSG"]) -> RuleVariation_485:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1231.cv_arg") -> 'Variation_1231':
        return cls._create(arg) # type: ignore

class RuleVariation_1169(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1231.cv_arg
    cv_variation: TypeAlias = Variation_1231

    @classmethod
    def create(cls, arg : "RuleVariation_1169.cv_arg") -> "RuleVariation_1169":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1231:
        return self.arg # type: ignore

class NonSpare_479(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1169.cv_arg
    cv_name = "310"
    cv_title = "Pre-programmed Message"
    cv_rule: TypeAlias = RuleVariation_1169

    @classmethod
    def create(cls, arg : "NonSpare_479.cv_arg") -> "NonSpare_479":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1169:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1231:
        return self.rule.variation

class UapItem_479(UapItem):
    cv_non_spare: TypeAlias = NonSpare_479

class Content_755(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_754(RuleContentContextFree):
    cv_arg: TypeAlias = Content_755.cv_arg
    cv_content: TypeAlias = Content_755

    @property
    def content(self) -> Content_755:
        return self._get_content() # type: ignore

class Variation_232(Element):
    cv_arg: TypeAlias = RuleContent_754.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_754

    @classmethod
    def create(cls, arg: "Variation_232.cv_arg") -> "Variation_232":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_754:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_755:
        return self.rule.content

class RuleVariation_225(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_232.cv_arg
    cv_variation: TypeAlias = Variation_232

    @classmethod
    def create(cls, arg : "RuleVariation_225.cv_arg") -> "RuleVariation_225":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_232:
        return self.arg # type: ignore

class NonSpare_880(NonSpare):
    cv_arg: TypeAlias = RuleVariation_225.cv_arg
    cv_name = "DEVX"
    cv_title = "Standard Deviation of X Component"
    cv_rule: TypeAlias = RuleVariation_225

    @classmethod
    def create(cls, arg : "NonSpare_880.cv_arg") -> "NonSpare_880":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_232:
        return self.rule.variation

class Item_257(Item):
    cv_arg: TypeAlias = NonSpare_880.cv_arg
    cv_non_spare: TypeAlias = NonSpare_880

    @classmethod
    def create(cls, arg : "Item_257.cv_arg") -> "Item_257":
        return cls._create(arg) # type: ignore

class NonSpare_881(NonSpare):
    cv_arg: TypeAlias = RuleVariation_225.cv_arg
    cv_name = "DEVY"
    cv_title = "Standard Deviation of Y Component"
    cv_rule: TypeAlias = RuleVariation_225

    @classmethod
    def create(cls, arg : "NonSpare_881.cv_arg") -> "NonSpare_881":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_232:
        return self.rule.variation

class Item_258(Item):
    cv_arg: TypeAlias = NonSpare_881.cv_arg
    cv_non_spare: TypeAlias = NonSpare_881

    @classmethod
    def create(cls, arg : "Item_258.cv_arg") -> "Item_258":
        return cls._create(arg) # type: ignore

class Content_658(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_658(RuleContentContextFree):
    cv_arg: TypeAlias = Content_658.cv_arg
    cv_content: TypeAlias = Content_658

    @property
    def content(self) -> Content_658:
        return self._get_content() # type: ignore

class Variation_275(Element):
    cv_arg: TypeAlias = RuleContent_658.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_658

    @classmethod
    def create(cls, arg: "Variation_275.cv_arg") -> "Variation_275":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_658:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_658:
        return self.rule.content

class RuleVariation_268(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_275.cv_arg
    cv_variation: TypeAlias = Variation_275

    @classmethod
    def create(cls, arg : "RuleVariation_268.cv_arg") -> "RuleVariation_268":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_275:
        return self.arg # type: ignore

class NonSpare_813(NonSpare):
    cv_arg: TypeAlias = RuleVariation_268.cv_arg
    cv_name = "COVXY"
    cv_title = "Covariance in Two’s Complement Form"
    cv_rule: TypeAlias = RuleVariation_268

    @classmethod
    def create(cls, arg : "NonSpare_813.cv_arg") -> "NonSpare_813":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_268:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_275:
        return self.rule.variation

class Item_205(Item):
    cv_arg: TypeAlias = NonSpare_813.cv_arg
    cv_non_spare: TypeAlias = NonSpare_813

    @classmethod
    def create(cls, arg : "Item_205.cv_arg") -> "Item_205":
        return cls._create(arg) # type: ignore

class Variation_1084(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_225.cv_arg, Tuple[Literal["DEVX"], RuleVariation_225.cv_arg]], Union[RuleVariation_225.cv_arg, Tuple[Literal["DEVY"], RuleVariation_225.cv_arg]], Union[RuleVariation_268.cv_arg, Tuple[Literal["COVXY"], RuleVariation_268.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1084.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_257, 8), (Item_258, 8), (Item_205, 16)]
    cv_items_dict = {"DEVX": RuleVariation_225, "DEVY": RuleVariation_225, "COVXY": RuleVariation_268}

    @overload
    @classmethod
    def spec(cls, key : Literal["DEVX"]) -> RuleVariation_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DEVY"]) -> RuleVariation_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVXY"]) -> RuleVariation_268:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DEVX"], Literal["DEVY"], Literal["COVXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DEVX"]) -> RuleVariation_225:
        ...
    @overload
    def get_item(self, key : Literal["DEVY"]) -> RuleVariation_225:
        ...
    @overload
    def get_item(self, key : Literal["COVXY"]) -> RuleVariation_268:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1084.cv_arg") -> 'Variation_1084':
        return cls._create(arg) # type: ignore

class RuleVariation_1044(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1084.cv_arg
    cv_variation: TypeAlias = Variation_1084

    @classmethod
    def create(cls, arg : "RuleVariation_1044.cv_arg") -> "RuleVariation_1044":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1084:
        return self.arg # type: ignore

class NonSpare_518(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1044.cv_arg
    cv_name = "500"
    cv_title = "Standard Deviation of Position"
    cv_rule: TypeAlias = RuleVariation_1044

    @classmethod
    def create(cls, arg : "NonSpare_518.cv_arg") -> "NonSpare_518":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1044:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1084:
        return self.rule.variation

class UapItem_517(UapItem):
    cv_non_spare: TypeAlias = NonSpare_518

class Content_628(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_628(RuleContentContextFree):
    cv_arg: TypeAlias = Content_628.cv_arg
    cv_content: TypeAlias = Content_628

    @property
    def content(self) -> Content_628:
        return self._get_content() # type: ignore

class Variation_210(Element):
    cv_arg: TypeAlias = RuleContent_628.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_628

    @classmethod
    def create(cls, arg: "Variation_210.cv_arg") -> "Variation_210":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_628:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_628:
        return self.rule.content

class RuleVariation_203(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_210.cv_arg
    cv_variation: TypeAlias = Variation_210

    @classmethod
    def create(cls, arg : "RuleVariation_203.cv_arg") -> "RuleVariation_203":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_210:
        return self.arg # type: ignore

class NonSpare_898(NonSpare):
    cv_arg: TypeAlias = RuleVariation_203.cv_arg
    cv_name = "DRHO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_203

    @classmethod
    def create(cls, arg : "NonSpare_898.cv_arg") -> "NonSpare_898":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_210:
        return self.rule.variation

class Item_271(Item):
    cv_arg: TypeAlias = NonSpare_898.cv_arg
    cv_non_spare: TypeAlias = NonSpare_898

    @classmethod
    def create(cls, arg : "Item_271.cv_arg") -> "Item_271":
        return cls._create(arg) # type: ignore

class Content_684(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.15
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_684(RuleContentContextFree):
    cv_arg: TypeAlias = Content_684.cv_arg
    cv_content: TypeAlias = Content_684

    @property
    def content(self) -> Content_684:
        return self._get_content() # type: ignore

class Variation_219(Element):
    cv_arg: TypeAlias = RuleContent_684.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_684

    @classmethod
    def create(cls, arg: "Variation_219.cv_arg") -> "Variation_219":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_684:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_684:
        return self.rule.content

class RuleVariation_212(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_219.cv_arg
    cv_variation: TypeAlias = Variation_219

    @classmethod
    def create(cls, arg : "RuleVariation_212.cv_arg") -> "RuleVariation_212":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_219:
        return self.arg # type: ignore

class NonSpare_909(NonSpare):
    cv_arg: TypeAlias = RuleVariation_212.cv_arg
    cv_name = "DTHETA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_212

    @classmethod
    def create(cls, arg : "NonSpare_909.cv_arg") -> "NonSpare_909":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_212:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_219:
        return self.rule.variation

class Item_279(Item):
    cv_arg: TypeAlias = NonSpare_909.cv_arg
    cv_non_spare: TypeAlias = NonSpare_909

    @classmethod
    def create(cls, arg : "Item_279.cv_arg") -> "Item_279":
        return cls._create(arg) # type: ignore

class Variation_1086(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_203.cv_arg, Tuple[Literal["DRHO"], RuleVariation_203.cv_arg]], Union[RuleVariation_212.cv_arg, Tuple[Literal["DTHETA"], RuleVariation_212.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1086.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_271, 8), (Item_279, 8)]
    cv_items_dict = {"DRHO": RuleVariation_203, "DTHETA": RuleVariation_212}

    @overload
    @classmethod
    def spec(cls, key : Literal["DRHO"]) -> RuleVariation_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DTHETA"]) -> RuleVariation_212:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DRHO"], Literal["DTHETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DRHO"]) -> RuleVariation_203:
        ...
    @overload
    def get_item(self, key : Literal["DTHETA"]) -> RuleVariation_212:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1086.cv_arg") -> 'Variation_1086':
        return cls._create(arg) # type: ignore

class Variation_1418(Repetitive):
    cv_arg: TypeAlias = List[Variation_1086.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1086

    @classmethod
    def create(cls, arg: "Variation_1418.cv_arg") -> 'Variation_1418':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1086]:
        return self._get_list() # type: ignore

class RuleVariation_1339(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1418.cv_arg
    cv_variation: TypeAlias = Variation_1418

    @classmethod
    def create(cls, arg : "RuleVariation_1339.cv_arg") -> "RuleVariation_1339":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1418:
        return self.arg # type: ignore

class NonSpare_467(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1339.cv_arg
    cv_name = "280"
    cv_title = "Presence"
    cv_rule: TypeAlias = RuleVariation_1339

    @classmethod
    def create(cls, arg : "NonSpare_467.cv_arg") -> "NonSpare_467":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1339:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1418:
        return self.rule.variation

class UapItem_467(UapItem):
    cv_non_spare: TypeAlias = NonSpare_467

class NonSpare_314(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "131"
    cv_title = "Amplitude of Primary Plot"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_314.cv_arg") -> "NonSpare_314":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_314(UapItem):
    cv_non_spare: TypeAlias = NonSpare_314

class Content_671(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_671(RuleContentContextFree):
    cv_arg: TypeAlias = Content_671.cv_arg
    cv_content: TypeAlias = Content_671

    @property
    def content(self) -> Content_671:
        return self._get_content() # type: ignore

class Variation_213(Element):
    cv_arg: TypeAlias = RuleContent_671.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_671

    @classmethod
    def create(cls, arg: "Variation_213.cv_arg") -> "Variation_213":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_671:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_671:
        return self.rule.content

class RuleVariation_206(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_213.cv_arg
    cv_variation: TypeAlias = Variation_213

    @classmethod
    def create(cls, arg : "RuleVariation_206.cv_arg") -> "RuleVariation_206":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_213:
        return self.arg # type: ignore

class NonSpare_658(NonSpare):
    cv_arg: TypeAlias = RuleVariation_206.cv_arg
    cv_name = "AX"
    cv_title = "X Acceleration"
    cv_rule: TypeAlias = RuleVariation_206

    @classmethod
    def create(cls, arg : "NonSpare_658.cv_arg") -> "NonSpare_658":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_206:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_213:
        return self.rule.variation

class Item_101(Item):
    cv_arg: TypeAlias = NonSpare_658.cv_arg
    cv_non_spare: TypeAlias = NonSpare_658

    @classmethod
    def create(cls, arg : "Item_101.cv_arg") -> "Item_101":
        return cls._create(arg) # type: ignore

class NonSpare_662(NonSpare):
    cv_arg: TypeAlias = RuleVariation_206.cv_arg
    cv_name = "AY"
    cv_title = "Y Acceleration"
    cv_rule: TypeAlias = RuleVariation_206

    @classmethod
    def create(cls, arg : "NonSpare_662.cv_arg") -> "NonSpare_662":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_206:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_213:
        return self.rule.variation

class Item_105(Item):
    cv_arg: TypeAlias = NonSpare_662.cv_arg
    cv_non_spare: TypeAlias = NonSpare_662

    @classmethod
    def create(cls, arg : "Item_105.cv_arg") -> "Item_105":
        return cls._create(arg) # type: ignore

class Variation_1058(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_206.cv_arg, Tuple[Literal["AX"], RuleVariation_206.cv_arg]], Union[RuleVariation_206.cv_arg, Tuple[Literal["AY"], RuleVariation_206.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1058.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_101, 8), (Item_105, 8)]
    cv_items_dict = {"AX": RuleVariation_206, "AY": RuleVariation_206}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_206:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_206:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_206:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_206:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1058.cv_arg") -> 'Variation_1058':
        return cls._create(arg) # type: ignore

class RuleVariation_1025(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1058.cv_arg
    cv_variation: TypeAlias = Variation_1058

    @classmethod
    def create(cls, arg : "RuleVariation_1025.cv_arg") -> "RuleVariation_1025":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1058:
        return self.arg # type: ignore

class NonSpare_409(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1025.cv_arg
    cv_name = "210"
    cv_title = "Calculated Acceleration"
    cv_rule: TypeAlias = RuleVariation_1025

    @classmethod
    def create(cls, arg : "NonSpare_409.cv_arg") -> "NonSpare_409":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1025:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1058:
        return self.rule.variation

class UapItem_409(UapItem):
    cv_non_spare: TypeAlias = NonSpare_409

class Record_38(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_43.cv_arg,
        "000": NonSpare_13.cv_arg,
        "020": NonSpare_91.cv_arg,
        "140": NonSpare_331.cv_arg,
        "041": NonSpare_155.cv_arg,
        "040": NonSpare_140.cv_arg,
        "042": NonSpare_161.cv_arg,
        "200": NonSpare_391.cv_arg,
        "202": NonSpare_404.cv_arg,
        "161": NonSpare_362.cv_arg,
        "170": NonSpare_374.cv_arg,
        "060": NonSpare_192.cv_arg,
        "220": NonSpare_426.cv_arg,
        "245": NonSpare_441.cv_arg,
        "250": NonSpare_448.cv_arg,
        "300": NonSpare_477.cv_arg,
        "090": NonSpare_250.cv_arg,
        "091": NonSpare_260.cv_arg,
        "270": NonSpare_461.cv_arg,
        "550": NonSpare_523.cv_arg,
        "310": NonSpare_479.cv_arg,
        "500": NonSpare_518.cv_arg,
        "280": NonSpare_467.cv_arg,
        "131": NonSpare_314.cv_arg,
        "210": NonSpare_409.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_43, UapItem_13, UapItem_91, UapItem_331, UapItem_155, UapItem_140, UapItem_161, UapItem_391, UapItem_404, UapItem_362, UapItem_374, UapItem_192, UapItem_426, UapItem_441, UapItem_448, UapItem_477, UapItem_250, UapItem_260, UapItem_461, UapItem_522, UapItem_479, UapItem_517, UapItem_467, UapItem_314, UapItem_409, UapItem_549, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_43, "000": NonSpare_13, "020": NonSpare_91, "140": NonSpare_331, "041": NonSpare_155, "040": NonSpare_140, "042": NonSpare_161, "200": NonSpare_391, "202": NonSpare_404, "161": NonSpare_362, "170": NonSpare_374, "060": NonSpare_192, "220": NonSpare_426, "245": NonSpare_441, "250": NonSpare_448, "300": NonSpare_477, "090": NonSpare_250, "091": NonSpare_260, "270": NonSpare_461, "550": NonSpare_523, "310": NonSpare_479, "500": NonSpare_518, "280": NonSpare_467, "131": NonSpare_314, "210": NonSpare_409, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_43:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_91:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_331:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_155:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_140:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_161:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_391:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_404:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_362:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_192:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_441:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_448:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_250:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["091"]) -> NonSpare_260:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_523:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_479:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_518:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["280"]) -> NonSpare_467:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_314:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_409:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["140"], Literal["041"], Literal["040"], Literal["042"], Literal["200"], Literal["202"], Literal["161"], Literal["170"], Literal["060"], Literal["220"], Literal["245"], Literal["250"], Literal["300"], Literal["090"], Literal["091"], Literal["270"], Literal["550"], Literal["310"], Literal["500"], Literal["280"], Literal["131"], Literal["210"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_43]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_13]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_91]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_331]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_155]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_140]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_161]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_391]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_404]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_362]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_374]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_192]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_426]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_441]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_448]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_250]:
        ...
    @overload
    def get_item(self, key : Literal["091"]) -> Optional[NonSpare_260]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_461]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_523]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_479]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_518]:
        ...
    @overload
    def get_item(self, key : Literal["280"]) -> Optional[NonSpare_467]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_314]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_409]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_43.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_13.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_91.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_331.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_155.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_140.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_161.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_391.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_404.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_362.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_374.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_192.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_426.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_441.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_448.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_250.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["091"], val : NonSpare_260.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_461.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_523.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_479.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_518.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["280"], val : NonSpare_467.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_314.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_409.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_38':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_38':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["091"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["280"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_38':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_38':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_38.cv_arg") -> 'Record_38':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_38", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_34(UapSingle):
    cv_arg: TypeAlias = Record_38
    cv_record: TypeAlias = Record_38

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_38]]:
        return cls._parse(bs)

class Asterix_11(AstCat):
    cv_category = 10
    cv_edition = (1, 1)
    cv_uap: TypeAlias = Uap_34
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_34.cv_arg]) -> "Asterix_11":
        return cls._create(records) # type: ignore

class NonSpare_1656(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SAC"
    cv_title = "System Area Code Fixed to Zero"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1656.cv_arg") -> "NonSpare_1656":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_857(Item):
    cv_arg: TypeAlias = NonSpare_1656.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1656

    @classmethod
    def create(cls, arg : "Item_857.cv_arg") -> "Item_857":
        return cls._create(arg) # type: ignore

class Variation_1196(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SAC"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SIC"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1196.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_857, 8), (Item_887, 8)]
    cv_items_dict = {"SAC": RuleVariation_159, "SIC": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1196.cv_arg") -> 'Variation_1196':
        return cls._create(arg) # type: ignore

class RuleVariation_1142(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1196.cv_arg
    cv_variation: TypeAlias = Variation_1196

    @classmethod
    def create(cls, arg : "RuleVariation_1142.cv_arg") -> "RuleVariation_1142":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1196:
        return self.arg # type: ignore

class NonSpare_48(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1142.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1142

    @classmethod
    def create(cls, arg : "NonSpare_48.cv_arg") -> "NonSpare_48":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1142:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1196:
        return self.rule.variation

class UapItem_48(UapItem):
    cv_non_spare: TypeAlias = NonSpare_48

class Content_600(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Target reports, flight plan data and basic alerts", 2: "Manual attachment of flight plan to track", 3: "Manual detachment of flight plan to track", 4: "Insertion of flight plan data", 5: "Suppression of flight plan data", 6: "Modification of flight plan data", 7: "Holdbar status"}

class RuleContent_600(RuleContentContextFree):
    cv_arg: TypeAlias = Content_600.cv_arg
    cv_content: TypeAlias = Content_600

    @property
    def content(self) -> Content_600:
        return self._get_content() # type: ignore

class Variation_199(Element):
    cv_arg: TypeAlias = RuleContent_600.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_600

    @classmethod
    def create(cls, arg: "Variation_199.cv_arg") -> "Variation_199":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_600:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_600:
        return self.rule.content

class RuleVariation_192(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_199.cv_arg
    cv_variation: TypeAlias = Variation_199

    @classmethod
    def create(cls, arg : "RuleVariation_192.cv_arg") -> "RuleVariation_192":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_199:
        return self.arg # type: ignore

class NonSpare_14(NonSpare):
    cv_arg: TypeAlias = RuleVariation_192.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_192

    @classmethod
    def create(cls, arg : "NonSpare_14.cv_arg") -> "NonSpare_14":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_192:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_199:
        return self.rule.variation

class UapItem_14(UapItem):
    cv_non_spare: TypeAlias = NonSpare_14

class NonSpare_62(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_62.cv_arg") -> "NonSpare_62":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_62(UapItem):
    cv_non_spare: TypeAlias = NonSpare_62

class NonSpare_336(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Track Information"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_336.cv_arg") -> "NonSpare_336":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_336(UapItem):
    cv_non_spare: TypeAlias = NonSpare_336

class NonSpare_1158(NonSpare):
    cv_arg: TypeAlias = RuleVariation_376.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude in WGS-84 in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_376

    @classmethod
    def create(cls, arg : "NonSpare_1158.cv_arg") -> "NonSpare_1158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_376:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_383:
        return self.rule.variation

class Item_470(Item):
    cv_arg: TypeAlias = NonSpare_1158.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1158

    @classmethod
    def create(cls, arg : "Item_470.cv_arg") -> "Item_470":
        return cls._create(arg) # type: ignore

class NonSpare_1188(NonSpare):
    cv_arg: TypeAlias = RuleVariation_374.cv_arg
    cv_name = "LON"
    cv_title = "Longitude in WGS-84 in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_374

    @classmethod
    def create(cls, arg : "NonSpare_1188.cv_arg") -> "NonSpare_1188":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_381:
        return self.rule.variation

class Item_498(Item):
    cv_arg: TypeAlias = NonSpare_1188.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1188

    @classmethod
    def create(cls, arg : "Item_498.cv_arg") -> "Item_498":
        return cls._create(arg) # type: ignore

class Variation_1134(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_376.cv_arg, Tuple[Literal["LAT"], RuleVariation_376.cv_arg]], Union[RuleVariation_374.cv_arg, Tuple[Literal["LON"], RuleVariation_374.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1134.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_470, 32), (Item_498, 32)]
    cv_items_dict = {"LAT": RuleVariation_376, "LON": RuleVariation_374}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_374:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_374:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1134.cv_arg") -> 'Variation_1134':
        return cls._create(arg) # type: ignore

class RuleVariation_1090(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1134.cv_arg
    cv_variation: TypeAlias = Variation_1134

    @classmethod
    def create(cls, arg : "RuleVariation_1090.cv_arg") -> "RuleVariation_1090":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1134:
        return self.arg # type: ignore

class NonSpare_156(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1090.cv_arg
    cv_name = "041"
    cv_title = "Position in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1090

    @classmethod
    def create(cls, arg : "NonSpare_156.cv_arg") -> "NonSpare_156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1090:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1134:
        return self.rule.variation

class UapItem_156(UapItem):
    cv_non_spare: TypeAlias = NonSpare_156

class NonSpare_2098(NonSpare):
    cv_arg: TypeAlias = RuleVariation_252.cv_arg
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule: TypeAlias = RuleVariation_252

    @classmethod
    def create(cls, arg : "NonSpare_2098.cv_arg") -> "NonSpare_2098":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_259:
        return self.rule.variation

class Item_1199(Item):
    cv_arg: TypeAlias = NonSpare_2098.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2098

    @classmethod
    def create(cls, arg : "Item_1199.cv_arg") -> "Item_1199":
        return cls._create(arg) # type: ignore

class NonSpare_2152(NonSpare):
    cv_arg: TypeAlias = RuleVariation_252.cv_arg
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule: TypeAlias = RuleVariation_252

    @classmethod
    def create(cls, arg : "NonSpare_2152.cv_arg") -> "NonSpare_2152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_259:
        return self.rule.variation

class Item_1250(Item):
    cv_arg: TypeAlias = NonSpare_2152.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2152

    @classmethod
    def create(cls, arg : "Item_1250.cv_arg") -> "Item_1250":
        return cls._create(arg) # type: ignore

class Variation_1312(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_252.cv_arg, Tuple[Literal["X"], RuleVariation_252.cv_arg]], Union[RuleVariation_252.cv_arg, Tuple[Literal["Y"], RuleVariation_252.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1312.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1199, 16), (Item_1250, 16)]
    cv_items_dict = {"X": RuleVariation_252, "Y": RuleVariation_252}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_252:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_252:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_252:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1312.cv_arg") -> 'Variation_1312':
        return cls._create(arg) # type: ignore

class RuleVariation_1239(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1312.cv_arg
    cv_variation: TypeAlias = Variation_1312

    @classmethod
    def create(cls, arg : "RuleVariation_1239.cv_arg") -> "RuleVariation_1239":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1312:
        return self.arg # type: ignore

class NonSpare_158(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1239.cv_arg
    cv_name = "042"
    cv_title = "Calculated Position in Cartesian Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1239

    @classmethod
    def create(cls, arg : "NonSpare_158.cv_arg") -> "NonSpare_158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1239:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1312:
        return self.rule.variation

class UapItem_158(UapItem):
    cv_non_spare: TypeAlias = NonSpare_158

class Content_662(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_662(RuleContentContextFree):
    cv_arg: TypeAlias = Content_662.cv_arg
    cv_content: TypeAlias = Content_662

    @property
    def content(self) -> Content_662:
        return self._get_content() # type: ignore

class Variation_279(Element):
    cv_arg: TypeAlias = RuleContent_662.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_662

    @classmethod
    def create(cls, arg: "Variation_279.cv_arg") -> "Variation_279":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_662:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_662:
        return self.rule.content

class RuleVariation_272(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_279.cv_arg
    cv_variation: TypeAlias = Variation_279

    @classmethod
    def create(cls, arg : "RuleVariation_272.cv_arg") -> "RuleVariation_272":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_279:
        return self.arg # type: ignore

class NonSpare_2051(NonSpare):
    cv_arg: TypeAlias = RuleVariation_272.cv_arg
    cv_name = "VX"
    cv_title = "Vx"
    cv_rule: TypeAlias = RuleVariation_272

    @classmethod
    def create(cls, arg : "NonSpare_2051.cv_arg") -> "NonSpare_2051":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_279:
        return self.rule.variation

class Item_1157(Item):
    cv_arg: TypeAlias = NonSpare_2051.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2051

    @classmethod
    def create(cls, arg : "Item_1157.cv_arg") -> "Item_1157":
        return cls._create(arg) # type: ignore

class NonSpare_2056(NonSpare):
    cv_arg: TypeAlias = RuleVariation_272.cv_arg
    cv_name = "VY"
    cv_title = "Vy"
    cv_rule: TypeAlias = RuleVariation_272

    @classmethod
    def create(cls, arg : "NonSpare_2056.cv_arg") -> "NonSpare_2056":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_279:
        return self.rule.variation

class Item_1162(Item):
    cv_arg: TypeAlias = NonSpare_2056.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2056

    @classmethod
    def create(cls, arg : "Item_1162.cv_arg") -> "Item_1162":
        return cls._create(arg) # type: ignore

class Variation_1282(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_272.cv_arg, Tuple[Literal["VX"], RuleVariation_272.cv_arg]], Union[RuleVariation_272.cv_arg, Tuple[Literal["VY"], RuleVariation_272.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1282.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1157, 16), (Item_1162, 16)]
    cv_items_dict = {"VX": RuleVariation_272, "VY": RuleVariation_272}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_272:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_272:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_272:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1282.cv_arg") -> 'Variation_1282':
        return cls._create(arg) # type: ignore

class RuleVariation_1211(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1282.cv_arg
    cv_variation: TypeAlias = Variation_1282

    @classmethod
    def create(cls, arg : "RuleVariation_1211.cv_arg") -> "RuleVariation_1211":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1282:
        return self.arg # type: ignore

class NonSpare_406(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1211.cv_arg
    cv_name = "202"
    cv_title = "Calculated Track Velocity in Cartesian Coordinates"
    cv_rule: TypeAlias = RuleVariation_1211

    @classmethod
    def create(cls, arg : "NonSpare_406.cv_arg") -> "NonSpare_406":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1211:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1282:
        return self.rule.variation

class UapItem_406(UapItem):
    cv_non_spare: TypeAlias = NonSpare_406

class Content_665(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_665(RuleContentContextFree):
    cv_arg: TypeAlias = Content_665.cv_arg
    cv_content: TypeAlias = Content_665

    @property
    def content(self) -> Content_665:
        return self._get_content() # type: ignore

class Variation_212(Element):
    cv_arg: TypeAlias = RuleContent_665.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_665

    @classmethod
    def create(cls, arg: "Variation_212.cv_arg") -> "Variation_212":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_665:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_665:
        return self.rule.content

class RuleVariation_205(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_212.cv_arg
    cv_variation: TypeAlias = Variation_212

    @classmethod
    def create(cls, arg : "RuleVariation_205.cv_arg") -> "RuleVariation_205":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_212:
        return self.arg # type: ignore

class NonSpare_657(NonSpare):
    cv_arg: TypeAlias = RuleVariation_205.cv_arg
    cv_name = "AX"
    cv_title = "Ax"
    cv_rule: TypeAlias = RuleVariation_205

    @classmethod
    def create(cls, arg : "NonSpare_657.cv_arg") -> "NonSpare_657":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

class Item_100(Item):
    cv_arg: TypeAlias = NonSpare_657.cv_arg
    cv_non_spare: TypeAlias = NonSpare_657

    @classmethod
    def create(cls, arg : "Item_100.cv_arg") -> "Item_100":
        return cls._create(arg) # type: ignore

class NonSpare_661(NonSpare):
    cv_arg: TypeAlias = RuleVariation_205.cv_arg
    cv_name = "AY"
    cv_title = "Ay"
    cv_rule: TypeAlias = RuleVariation_205

    @classmethod
    def create(cls, arg : "NonSpare_661.cv_arg") -> "NonSpare_661":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

class Item_104(Item):
    cv_arg: TypeAlias = NonSpare_661.cv_arg
    cv_non_spare: TypeAlias = NonSpare_661

    @classmethod
    def create(cls, arg : "Item_104.cv_arg") -> "Item_104":
        return cls._create(arg) # type: ignore

class Variation_1057(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_205.cv_arg, Tuple[Literal["AX"], RuleVariation_205.cv_arg]], Union[RuleVariation_205.cv_arg, Tuple[Literal["AY"], RuleVariation_205.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1057.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_100, 8), (Item_104, 8)]
    cv_items_dict = {"AX": RuleVariation_205, "AY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1057.cv_arg") -> 'Variation_1057':
        return cls._create(arg) # type: ignore

class RuleVariation_1024(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1057.cv_arg
    cv_variation: TypeAlias = Variation_1057

    @classmethod
    def create(cls, arg : "RuleVariation_1024.cv_arg") -> "RuleVariation_1024":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1057:
        return self.arg # type: ignore

class NonSpare_408(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1024.cv_arg
    cv_name = "210"
    cv_title = "Calculated Acceleration"
    cv_rule: TypeAlias = RuleVariation_1024

    @classmethod
    def create(cls, arg : "NonSpare_408.cv_arg") -> "NonSpare_408":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1024:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1057:
        return self.rule.variation

class UapItem_408(UapItem):
    cv_non_spare: TypeAlias = NonSpare_408

class NonSpare_1299(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MOD3A"
    cv_title = "Mode-3/A Reply in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1299.cv_arg") -> "NonSpare_1299":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_565(Item):
    cv_arg: TypeAlias = NonSpare_1299.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1299

    @classmethod
    def create(cls, arg : "Item_565.cv_arg") -> "Item_565":
        return cls._create(arg) # type: ignore

class Variation_1024(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MOD3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1024.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_565, 12)]
    cv_items_dict = {"MOD3A": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["MOD3A"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MOD3A"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1024.cv_arg") -> 'Variation_1024':
        return cls._create(arg) # type: ignore

class RuleVariation_993(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1024.cv_arg
    cv_variation: TypeAlias = Variation_1024

    @classmethod
    def create(cls, arg : "RuleVariation_993.cv_arg") -> "RuleVariation_993":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1024:
        return self.arg # type: ignore

class NonSpare_191(NonSpare):
    cv_arg: TypeAlias = RuleVariation_993.cv_arg
    cv_name = "060"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_993

    @classmethod
    def create(cls, arg : "NonSpare_191.cv_arg") -> "NonSpare_191":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_993:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1024:
        return self.rule.variation

class UapItem_191(UapItem):
    cv_non_spare: TypeAlias = NonSpare_191

class NonSpare_1863(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "TID"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_1863.cv_arg") -> "NonSpare_1863":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class Item_999(Item):
    cv_arg: TypeAlias = NonSpare_1863.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1863

    @classmethod
    def create(cls, arg : "Item_999.cv_arg") -> "Item_999":
        return cls._create(arg) # type: ignore

class Variation_1217(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_98.cv_arg, Tuple[Literal["STI"], RuleVariation_98.cv_arg]], int, Union[RuleVariation_383.cv_arg, Tuple[Literal["TID"], RuleVariation_383.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1217.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_951, 2), (Item_15, 6), (Item_999, 48)]
    cv_items_dict = {"STI": RuleVariation_98, "TID": RuleVariation_383}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_98:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_383:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["TID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_98:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_383:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1217.cv_arg") -> 'Variation_1217':
        return cls._create(arg) # type: ignore

class RuleVariation_1161(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1217.cv_arg
    cv_variation: TypeAlias = Variation_1217

    @classmethod
    def create(cls, arg : "RuleVariation_1161.cv_arg") -> "RuleVariation_1161":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1217:
        return self.arg # type: ignore

class NonSpare_442(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1161.cv_arg
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_1161

    @classmethod
    def create(cls, arg : "NonSpare_442.cv_arg") -> "NonSpare_442":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1161:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1217:
        return self.rule.variation

class UapItem_442(UapItem):
    cv_non_spare: TypeAlias = NonSpare_442

class Content_798(ContentBds):
    cv_arg: TypeAlias = int
    cv_bds_type = BdsWithAddress

class RuleContent_797(RuleContentContextFree):
    cv_arg: TypeAlias = Content_798.cv_arg
    cv_content: TypeAlias = Content_798

    @property
    def content(self) -> Content_798:
        return self._get_content() # type: ignore

class Variation_396(Element):
    cv_arg: TypeAlias = RuleContent_797.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_rule = RuleContent_797

    @classmethod
    def create(cls, arg: "Variation_396.cv_arg") -> "Variation_396":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_797:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_798:
        return self.rule.content

class Variation_1404(Repetitive):
    cv_arg: TypeAlias = List[Variation_396.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_396

    @classmethod
    def create(cls, arg: "Variation_1404.cv_arg") -> 'Variation_1404':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_396]:
        return self._get_list() # type: ignore

class RuleVariation_1325(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1404.cv_arg
    cv_variation: TypeAlias = Variation_1404

    @classmethod
    def create(cls, arg : "RuleVariation_1325.cv_arg") -> "RuleVariation_1325":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1404:
        return self.arg # type: ignore

class NonSpare_1231(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1325.cv_arg
    cv_name = "MB"
    cv_title = "BDS"
    cv_rule: TypeAlias = RuleVariation_1325

    @classmethod
    def create(cls, arg : "NonSpare_1231.cv_arg") -> "NonSpare_1231":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1404:
        return self.rule.variation

class NonSpare_571(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "ADR"
    cv_title = "24 Bits Aircraft Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_571.cv_arg") -> "NonSpare_571":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class Content_339(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No communications capability (surveillance only)", 1: "Comm. A and Comm. B capability", 2: "Comm. A, Comm. B and Uplink ELM", 3: "Comm. A, Comm. B, Uplink ELM and Downlink ELM", 4: "Level 5 Transponder capability", 5: "Not assigned", 6: "Not assigned", 7: "Not assigned"}

class RuleContent_339(RuleContentContextFree):
    cv_arg: TypeAlias = Content_339.cv_arg
    cv_content: TypeAlias = Content_339

    @property
    def content(self) -> Content_339:
        return self._get_content() # type: ignore

class Variation_124(Element):
    cv_arg: TypeAlias = RuleContent_339.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_339

    @classmethod
    def create(cls, arg: "Variation_124.cv_arg") -> "Variation_124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_339:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_339:
        return self.rule.content

class RuleVariation_124(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_124.cv_arg
    cv_variation: TypeAlias = Variation_124

    @classmethod
    def create(cls, arg : "RuleVariation_124.cv_arg") -> "RuleVariation_124":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_124:
        return self.arg # type: ignore

class NonSpare_785(NonSpare):
    cv_arg: TypeAlias = RuleVariation_124.cv_arg
    cv_name = "COM"
    cv_title = "Communications Capability of the Transponder"
    cv_rule: TypeAlias = RuleVariation_124

    @classmethod
    def create(cls, arg : "NonSpare_785.cv_arg") -> "NonSpare_785":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_124:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_124:
        return self.rule.variation

class Item_188(Item):
    cv_arg: TypeAlias = NonSpare_785.cv_arg
    cv_non_spare: TypeAlias = NonSpare_785

    @classmethod
    def create(cls, arg : "Item_188.cv_arg") -> "Item_188":
        return cls._create(arg) # type: ignore

class Content_320(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "General Emergency", 7: "Lifeguard / medical", 8: "Minimum fuel", 9: "No communications", 10: "Unlawful"}

class RuleContent_320(RuleContentContextFree):
    cv_arg: TypeAlias = Content_320.cv_arg
    cv_content: TypeAlias = Content_320

    @property
    def content(self) -> Content_320:
        return self._get_content() # type: ignore

class Variation_692(Element):
    cv_arg: TypeAlias = RuleContent_320.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_320

    @classmethod
    def create(cls, arg: "Variation_692.cv_arg") -> "Variation_692":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_320:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_320:
        return self.rule.content

class RuleVariation_681(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_692.cv_arg
    cv_variation: TypeAlias = Variation_692

    @classmethod
    def create(cls, arg : "RuleVariation_681.cv_arg") -> "RuleVariation_681":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_692:
        return self.arg # type: ignore

class NonSpare_1779(NonSpare):
    cv_arg: TypeAlias = RuleVariation_681.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_681

    @classmethod
    def create(cls, arg : "NonSpare_1779.cv_arg") -> "NonSpare_1779":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_681:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_692:
        return self.rule.variation

class Item_940(Item):
    cv_arg: TypeAlias = NonSpare_1779.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1779

    @classmethod
    def create(cls, arg : "Item_940.cv_arg") -> "Item_940":
        return cls._create(arg) # type: ignore

class Content_304(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No", 1: "Yes"}

class RuleContent_304(RuleContentContextFree):
    cv_arg: TypeAlias = Content_304.cv_arg
    cv_content: TypeAlias = Content_304

    @property
    def content(self) -> Content_304:
        return self._get_content() # type: ignore

class Variation_56(Element):
    cv_arg: TypeAlias = RuleContent_304.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_304

    @classmethod
    def create(cls, arg: "Variation_56.cv_arg") -> "Variation_56":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_304:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_304:
        return self.rule.content

class RuleVariation_56(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_56.cv_arg
    cv_variation: TypeAlias = Variation_56

    @classmethod
    def create(cls, arg : "RuleVariation_56.cv_arg") -> "RuleVariation_56":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_56:
        return self.arg # type: ignore

class NonSpare_1756(NonSpare):
    cv_arg: TypeAlias = RuleVariation_56.cv_arg
    cv_name = "SSC"
    cv_title = "Specific Service Capability"
    cv_rule: TypeAlias = RuleVariation_56

    @classmethod
    def create(cls, arg : "NonSpare_1756.cv_arg") -> "NonSpare_1756":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_56:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_56:
        return self.rule.variation

class Item_926(Item):
    cv_arg: TypeAlias = NonSpare_1756.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1756

    @classmethod
    def create(cls, arg : "Item_926.cv_arg") -> "Item_926":
        return cls._create(arg) # type: ignore

class Content_3(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "100 ft resolution", 1: "25 ft resolution"}

class RuleContent_3(RuleContentContextFree):
    cv_arg: TypeAlias = Content_3.cv_arg
    cv_content: TypeAlias = Content_3

    @property
    def content(self) -> Content_3:
        return self._get_content() # type: ignore

class Variation_401(Element):
    cv_arg: TypeAlias = RuleContent_3.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_3

    @classmethod
    def create(cls, arg: "Variation_401.cv_arg") -> "Variation_401":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_3:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_3:
        return self.rule.content

class RuleVariation_390(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_401.cv_arg
    cv_variation: TypeAlias = Variation_401

    @classmethod
    def create(cls, arg : "RuleVariation_390.cv_arg") -> "RuleVariation_390":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_401:
        return self.arg # type: ignore

class NonSpare_626(NonSpare):
    cv_arg: TypeAlias = RuleVariation_390.cv_arg
    cv_name = "ARC"
    cv_title = "Altitude Reporting Capability"
    cv_rule: TypeAlias = RuleVariation_390

    @classmethod
    def create(cls, arg : "NonSpare_626.cv_arg") -> "NonSpare_626":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_390:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_401:
        return self.rule.variation

class Item_81(Item):
    cv_arg: TypeAlias = NonSpare_626.cv_arg
    cv_non_spare: TypeAlias = NonSpare_626

    @classmethod
    def create(cls, arg : "Item_81.cv_arg") -> "Item_81":
        return cls._create(arg) # type: ignore

class Variation_558(Element):
    cv_arg: TypeAlias = RuleContent_304.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_304

    @classmethod
    def create(cls, arg: "Variation_558.cv_arg") -> "Variation_558":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_304:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_304:
        return self.rule.content

class RuleVariation_547(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_558.cv_arg
    cv_variation: TypeAlias = Variation_558

    @classmethod
    def create(cls, arg : "RuleVariation_547.cv_arg") -> "RuleVariation_547":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_558:
        return self.arg # type: ignore

class NonSpare_588(NonSpare):
    cv_arg: TypeAlias = RuleVariation_547.cv_arg
    cv_name = "AIC"
    cv_title = "Aircraft Identification Capability"
    cv_rule: TypeAlias = RuleVariation_547

    @classmethod
    def create(cls, arg : "NonSpare_588.cv_arg") -> "NonSpare_588":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_547:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_558:
        return self.rule.variation

class Item_55(Item):
    cv_arg: TypeAlias = NonSpare_588.cv_arg
    cv_non_spare: TypeAlias = NonSpare_588

    @classmethod
    def create(cls, arg : "Item_55.cv_arg") -> "Item_55":
        return cls._create(arg) # type: ignore

class NonSpare_669(NonSpare):
    cv_arg: TypeAlias = RuleVariation_603.cv_arg
    cv_name = "B1A"
    cv_title = "BDS 1,0 Bit 16"
    cv_rule: TypeAlias = RuleVariation_603

    @classmethod
    def create(cls, arg : "NonSpare_669.cv_arg") -> "NonSpare_669":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_603:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_614:
        return self.rule.variation

class Item_109(Item):
    cv_arg: TypeAlias = NonSpare_669.cv_arg
    cv_non_spare: TypeAlias = NonSpare_669

    @classmethod
    def create(cls, arg : "Item_109.cv_arg") -> "Item_109":
        return cls._create(arg) # type: ignore

class NonSpare_670(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "B1B"
    cv_title = "BDS 1,0 Bit 37/40"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_670.cv_arg") -> "NonSpare_670":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_110(Item):
    cv_arg: TypeAlias = NonSpare_670.cv_arg
    cv_non_spare: TypeAlias = NonSpare_670

    @classmethod
    def create(cls, arg : "Item_110.cv_arg") -> "Item_110":
        return cls._create(arg) # type: ignore

class NonSpare_555(NonSpare):
    cv_arg: TypeAlias = RuleVariation_56.cv_arg
    cv_name = "AC"
    cv_title = "ACAS Operational"
    cv_rule: TypeAlias = RuleVariation_56

    @classmethod
    def create(cls, arg : "NonSpare_555.cv_arg") -> "NonSpare_555":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_56:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_56:
        return self.rule.variation

class Item_37(Item):
    cv_arg: TypeAlias = NonSpare_555.cv_arg
    cv_non_spare: TypeAlias = NonSpare_555

    @classmethod
    def create(cls, arg : "Item_37.cv_arg") -> "Item_37":
        return cls._create(arg) # type: ignore

class Variation_439(Element):
    cv_arg: TypeAlias = RuleContent_304.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_304

    @classmethod
    def create(cls, arg: "Variation_439.cv_arg") -> "Variation_439":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_304:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_304:
        return self.rule.content

class RuleVariation_428(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_439.cv_arg
    cv_variation: TypeAlias = Variation_439

    @classmethod
    def create(cls, arg : "RuleVariation_428.cv_arg") -> "RuleVariation_428":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_439:
        return self.arg # type: ignore

class NonSpare_1296(NonSpare):
    cv_arg: TypeAlias = RuleVariation_428.cv_arg
    cv_name = "MN"
    cv_title = "Multiple Navigational Aids Operating"
    cv_rule: TypeAlias = RuleVariation_428

    @classmethod
    def create(cls, arg : "NonSpare_1296.cv_arg") -> "NonSpare_1296":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_428:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_439:
        return self.rule.variation

class Item_562(Item):
    cv_arg: TypeAlias = NonSpare_1296.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1296

    @classmethod
    def create(cls, arg : "Item_562.cv_arg") -> "Item_562":
        return cls._create(arg) # type: ignore

class Content_571(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Yes", 1: "No"}

class RuleContent_571(RuleContentContextFree):
    cv_arg: TypeAlias = Content_571.cv_arg
    cv_content: TypeAlias = Content_571

    @property
    def content(self) -> Content_571:
        return self._get_content() # type: ignore

class Variation_585(Element):
    cv_arg: TypeAlias = RuleContent_571.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_571

    @classmethod
    def create(cls, arg: "Variation_585.cv_arg") -> "Variation_585":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_571:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_571:
        return self.rule.content

class RuleVariation_574(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_585.cv_arg
    cv_variation: TypeAlias = Variation_585

    @classmethod
    def create(cls, arg : "RuleVariation_574.cv_arg") -> "RuleVariation_574":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_585:
        return self.arg # type: ignore

class NonSpare_872(NonSpare):
    cv_arg: TypeAlias = RuleVariation_574.cv_arg
    cv_name = "DC"
    cv_title = "Differential Correction"
    cv_rule: TypeAlias = RuleVariation_574

    @classmethod
    def create(cls, arg : "NonSpare_872.cv_arg") -> "NonSpare_872":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_574:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_585:
        return self.rule.variation

class Item_250(Item):
    cv_arg: TypeAlias = NonSpare_872.cv_arg
    cv_non_spare: TypeAlias = NonSpare_872

    @classmethod
    def create(cls, arg : "Item_250.cv_arg") -> "Item_250":
        return cls._create(arg) # type: ignore

class Item_19(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 3
    cv_bit_size = 5

class Variation_1079(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_124.cv_arg, Tuple[Literal["COM"], RuleVariation_124.cv_arg]], Union[RuleVariation_681.cv_arg, Tuple[Literal["STAT"], RuleVariation_681.cv_arg]], int, Union[RuleVariation_56.cv_arg, Tuple[Literal["SSC"], RuleVariation_56.cv_arg]], Union[RuleVariation_390.cv_arg, Tuple[Literal["ARC"], RuleVariation_390.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["AIC"], RuleVariation_547.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["B1A"], RuleVariation_603.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["B1B"], RuleVariation_769.cv_arg]], Union[RuleVariation_56.cv_arg, Tuple[Literal["AC"], RuleVariation_56.cv_arg]], Union[RuleVariation_428.cv_arg, Tuple[Literal["MN"], RuleVariation_428.cv_arg]], Union[RuleVariation_574.cv_arg, Tuple[Literal["DC"], RuleVariation_574.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1079.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_188, 3), (Item_940, 4), (Item_29, 1), (Item_926, 1), (Item_81, 1), (Item_55, 1), (Item_109, 1), (Item_110, 4), (Item_37, 1), (Item_562, 1), (Item_250, 1), (Item_19, 5)]
    cv_items_dict = {"COM": RuleVariation_124, "STAT": RuleVariation_681, "SSC": RuleVariation_56, "ARC": RuleVariation_390, "AIC": RuleVariation_547, "B1A": RuleVariation_603, "B1B": RuleVariation_769, "AC": RuleVariation_56, "MN": RuleVariation_428, "DC": RuleVariation_574}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_681:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_574:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"], Literal["AC"], Literal["MN"], Literal["DC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_681:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_428:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_574:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1079.cv_arg") -> 'Variation_1079':
        return cls._create(arg) # type: ignore

class RuleVariation_1039(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1079.cv_arg
    cv_variation: TypeAlias = Variation_1079

    @classmethod
    def create(cls, arg : "RuleVariation_1039.cv_arg") -> "RuleVariation_1039":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1079:
        return self.arg # type: ignore

class NonSpare_789(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1039.cv_arg
    cv_name = "COMACAS"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1039

    @classmethod
    def create(cls, arg : "NonSpare_789.cv_arg") -> "NonSpare_789":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1039:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1079:
        return self.rule.variation

class Variation_374(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_374.cv_arg") -> "Variation_374":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_367(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_374.cv_arg
    cv_variation: TypeAlias = Variation_374

    @classmethod
    def create(cls, arg : "RuleVariation_367.cv_arg") -> "RuleVariation_367":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_374:
        return self.arg # type: ignore

class NonSpare_566(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "ACT"
    cv_title = "Aircraft Derived Aircraft Type"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_566.cv_arg") -> "NonSpare_566":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class Content_581(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Light aircraft <= 7000 kg", 2: "Reserved", 3: "7000 kg &lt; medium aircraft &lt; 136000 kg", 4: "Reserved", 5: "136000 kg <= heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (&gt;400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Reserved", 24: "Reserved"}

class RuleContent_581(RuleContentContextFree):
    cv_arg: TypeAlias = Content_581.cv_arg
    cv_content: TypeAlias = Content_581

    @property
    def content(self) -> Content_581:
        return self._get_content() # type: ignore

class Variation_183(Element):
    cv_arg: TypeAlias = RuleContent_581.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_581

    @classmethod
    def create(cls, arg: "Variation_183.cv_arg") -> "Variation_183":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_581:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_581:
        return self.rule.content

class RuleVariation_176(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_183.cv_arg
    cv_variation: TypeAlias = Variation_183

    @classmethod
    def create(cls, arg : "RuleVariation_176.cv_arg") -> "RuleVariation_176":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_183:
        return self.arg # type: ignore

class NonSpare_919(NonSpare):
    cv_arg: TypeAlias = RuleVariation_176.cv_arg
    cv_name = "ECAT"
    cv_title = "Emitter Category"
    cv_rule: TypeAlias = RuleVariation_176

    @classmethod
    def create(cls, arg : "NonSpare_919.cv_arg") -> "NonSpare_919":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_176:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_183:
        return self.rule.variation

class Content_555(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "VDL Mode 4 available", 1: "VDL Mode 4 not available"}

class RuleContent_555(RuleContentContextFree):
    cv_arg: TypeAlias = Content_555.cv_arg
    cv_content: TypeAlias = Content_555

    @property
    def content(self) -> Content_555:
        return self._get_content() # type: ignore

class Variation_95(Element):
    cv_arg: TypeAlias = RuleContent_555.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_555

    @classmethod
    def create(cls, arg: "Variation_95.cv_arg") -> "Variation_95":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_555:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_555:
        return self.rule.content

class RuleVariation_95(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_95.cv_arg
    cv_variation: TypeAlias = Variation_95

    @classmethod
    def create(cls, arg : "RuleVariation_95.cv_arg") -> "RuleVariation_95":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_95:
        return self.arg # type: ignore

class NonSpare_2030(NonSpare):
    cv_arg: TypeAlias = RuleVariation_95.cv_arg
    cv_name = "VDL"
    cv_title = "VDL Mode 4"
    cv_rule: TypeAlias = RuleVariation_95

    @classmethod
    def create(cls, arg : "NonSpare_2030.cv_arg") -> "NonSpare_2030":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_95:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_95:
        return self.rule.variation

class Item_1139(Item):
    cv_arg: TypeAlias = NonSpare_2030.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2030

    @classmethod
    def create(cls, arg : "Item_1139.cv_arg") -> "Item_1139":
        return cls._create(arg) # type: ignore

class Content_282(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode S available", 1: "Mode S not available"}

class RuleContent_282(RuleContentContextFree):
    cv_arg: TypeAlias = Content_282.cv_arg
    cv_content: TypeAlias = Content_282

    @property
    def content(self) -> Content_282:
        return self._get_content() # type: ignore

class Variation_437(Element):
    cv_arg: TypeAlias = RuleContent_282.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_282

    @classmethod
    def create(cls, arg: "Variation_437.cv_arg") -> "Variation_437":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_282:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_282:
        return self.rule.content

class RuleVariation_426(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_437.cv_arg
    cv_variation: TypeAlias = Variation_437

    @classmethod
    def create(cls, arg : "RuleVariation_426.cv_arg") -> "RuleVariation_426":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_437:
        return self.arg # type: ignore

class NonSpare_1260(NonSpare):
    cv_arg: TypeAlias = RuleVariation_426.cv_arg
    cv_name = "MDS"
    cv_title = "Mode S"
    cv_rule: TypeAlias = RuleVariation_426

    @classmethod
    def create(cls, arg : "NonSpare_1260.cv_arg") -> "NonSpare_1260":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_426:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_437:
        return self.rule.variation

class Item_541(Item):
    cv_arg: TypeAlias = NonSpare_1260.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1260

    @classmethod
    def create(cls, arg : "Item_541.cv_arg") -> "Item_541":
        return cls._create(arg) # type: ignore

class Content_528(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "UAT available", 1: "UAT not available"}

class RuleContent_528(RuleContentContextFree):
    cv_arg: TypeAlias = Content_528.cv_arg
    cv_content: TypeAlias = Content_528

    @property
    def content(self) -> Content_528:
        return self._get_content() # type: ignore

class Variation_583(Element):
    cv_arg: TypeAlias = RuleContent_528.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_528

    @classmethod
    def create(cls, arg: "Variation_583.cv_arg") -> "Variation_583":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_528:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_528:
        return self.rule.content

class RuleVariation_572(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_583.cv_arg
    cv_variation: TypeAlias = Variation_583

    @classmethod
    def create(cls, arg : "RuleVariation_572.cv_arg") -> "RuleVariation_572":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_583:
        return self.arg # type: ignore

class NonSpare_1979(NonSpare):
    cv_arg: TypeAlias = RuleVariation_572.cv_arg
    cv_name = "UAT"
    cv_title = "UAT"
    cv_rule: TypeAlias = RuleVariation_572

    @classmethod
    def create(cls, arg : "NonSpare_1979.cv_arg") -> "NonSpare_1979":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_572:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_583:
        return self.rule.variation

class Item_1091(Item):
    cv_arg: TypeAlias = NonSpare_1979.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1979

    @classmethod
    def create(cls, arg : "Item_1091.cv_arg") -> "Item_1091":
        return cls._create(arg) # type: ignore

class Variation_1278(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_95.cv_arg, Tuple[Literal["VDL"], RuleVariation_95.cv_arg]], Union[RuleVariation_426.cv_arg, Tuple[Literal["MDS"], RuleVariation_426.cv_arg]], Union[RuleVariation_572.cv_arg, Tuple[Literal["UAT"], RuleVariation_572.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1278.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1139, 1), (Item_541, 1), (Item_1091, 1), (Item_19, 5)]
    cv_items_dict = {"VDL": RuleVariation_95, "MDS": RuleVariation_426, "UAT": RuleVariation_572}

    @overload
    @classmethod
    def spec(cls, key : Literal["VDL"]) -> RuleVariation_95:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> RuleVariation_426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UAT"]) -> RuleVariation_572:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VDL"], Literal["MDS"], Literal["UAT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VDL"]) -> RuleVariation_95:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> RuleVariation_426:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_572:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1278.cv_arg") -> 'Variation_1278':
        return cls._create(arg) # type: ignore

class RuleVariation_1207(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1278.cv_arg
    cv_variation: TypeAlias = Variation_1278

    @classmethod
    def create(cls, arg : "RuleVariation_1207.cv_arg") -> "RuleVariation_1207":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1278:
        return self.arg # type: ignore

class NonSpare_654(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1207.cv_arg
    cv_name = "AVTECH"
    cv_title = "Available Technologies"
    cv_rule: TypeAlias = RuleVariation_1207

    @classmethod
    def create(cls, arg : "NonSpare_654.cv_arg") -> "NonSpare_654":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1278:
        return self.rule.variation

class Variation_1494(Compound):
    cv_arg = TypedDict('cv_arg', {
        "MB": NonSpare_1231.cv_arg,
        "ADR": NonSpare_571.cv_arg,
        "COMACAS": NonSpare_789.cv_arg,
        "ACT": NonSpare_566.cv_arg,
        "ECAT": NonSpare_919.cv_arg,
        "AVTECH": NonSpare_654.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1231, NonSpare_571, None, NonSpare_789, None, None, None, NonSpare_566, NonSpare_919, None, NonSpare_654]
    cv_items_dict = {"MB": NonSpare_1231, "ADR": NonSpare_571, "COMACAS": NonSpare_789, "ACT": NonSpare_566, "ECAT": NonSpare_919, "AVTECH": NonSpare_654}

    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_571:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COMACAS"]) -> NonSpare_789:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACT"]) -> NonSpare_566:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ECAT"]) -> NonSpare_919:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVTECH"]) -> NonSpare_654:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MB"], Literal["ADR"], Literal["COMACAS"], Literal["ACT"], Literal["ECAT"], Literal["AVTECH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1231]:
        ...
    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_571]:
        ...
    @overload
    def get_item(self, key : Literal["COMACAS"]) -> Optional[NonSpare_789]:
        ...
    @overload
    def get_item(self, key : Literal["ACT"]) -> Optional[NonSpare_566]:
        ...
    @overload
    def get_item(self, key : Literal["ECAT"]) -> Optional[NonSpare_919]:
        ...
    @overload
    def get_item(self, key : Literal["AVTECH"]) -> Optional[NonSpare_654]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1231.cv_arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_571.cv_arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["COMACAS"], val : NonSpare_789.cv_arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["ACT"], val : NonSpare_566.cv_arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["ECAT"], val : NonSpare_919.cv_arg) -> "Variation_1494":
        ...
    @overload
    def set_item(self, key : Literal["AVTECH"], val : NonSpare_654.cv_arg) -> "Variation_1494":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["COMACAS"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["ACT"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["ECAT"]) -> "Variation_1494":
        ...
    @overload
    def del_item(self, key : Literal["AVTECH"]) -> "Variation_1494":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1494.cv_arg") -> 'Variation_1494':
        return cls._create(arg) # type: ignore

class RuleVariation_1415(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1494.cv_arg
    cv_variation: TypeAlias = Variation_1494

    @classmethod
    def create(cls, arg : "RuleVariation_1415.cv_arg") -> "RuleVariation_1415":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1494:
        return self.arg # type: ignore

class NonSpare_489(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1415.cv_arg
    cv_name = "380"
    cv_title = "Mode-S / ADS-B Related Data"
    cv_rule: TypeAlias = RuleVariation_1415

    @classmethod
    def create(cls, arg : "NonSpare_489.cv_arg") -> "NonSpare_489":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1415:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1494:
        return self.rule.variation

class UapItem_489(UapItem):
    cv_non_spare: TypeAlias = NonSpare_489

class Item_0(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 1

class Variation_499(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_499.cv_arg") -> "Variation_499":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_488(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_499.cv_arg
    cv_variation: TypeAlias = Variation_499

    @classmethod
    def create(cls, arg : "RuleVariation_488.cv_arg") -> "RuleVariation_488":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_499:
        return self.arg # type: ignore

class NonSpare_1006(NonSpare):
    cv_arg: TypeAlias = RuleVariation_488.cv_arg
    cv_name = "FTN"
    cv_title = "Fusion Track Number"
    cv_rule: TypeAlias = RuleVariation_488

    @classmethod
    def create(cls, arg : "NonSpare_1006.cv_arg") -> "NonSpare_1006":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_488:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_499:
        return self.rule.variation

class Item_352(Item):
    cv_arg: TypeAlias = NonSpare_1006.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1006

    @classmethod
    def create(cls, arg : "Item_352.cv_arg") -> "Item_352":
        return cls._create(arg) # type: ignore

class Variation_995(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_488.cv_arg, Tuple[Literal["FTN"], RuleVariation_488.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_995.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_352, 15)]
    cv_items_dict = {"FTN": RuleVariation_488}

    @classmethod
    def spec(cls, key : Literal["FTN"]) -> RuleVariation_488:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FTN"]) -> RuleVariation_488:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_995.cv_arg") -> 'Variation_995':
        return cls._create(arg) # type: ignore

class RuleVariation_965(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_995.cv_arg
    cv_variation: TypeAlias = Variation_995

    @classmethod
    def create(cls, arg : "RuleVariation_965.cv_arg") -> "RuleVariation_965":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_995:
        return self.arg # type: ignore

class NonSpare_361(NonSpare):
    cv_arg: TypeAlias = RuleVariation_965.cv_arg
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_965

    @classmethod
    def create(cls, arg : "NonSpare_361.cv_arg") -> "NonSpare_361":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_965:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_995:
        return self.rule.variation

class UapItem_361(UapItem):
    cv_non_spare: TypeAlias = NonSpare_361

class Content_298(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Multisensor Track", 1: "Monosensor Track"}

class RuleContent_298(RuleContentContextFree):
    cv_arg: TypeAlias = Content_298.cv_arg
    cv_content: TypeAlias = Content_298

    @property
    def content(self) -> Content_298:
        return self._get_content() # type: ignore

class Variation_54(Element):
    cv_arg: TypeAlias = RuleContent_298.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_298

    @classmethod
    def create(cls, arg: "Variation_54.cv_arg") -> "Variation_54":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_298:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_298:
        return self.rule.content

class RuleVariation_54(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_54.cv_arg
    cv_variation: TypeAlias = Variation_54

    @classmethod
    def create(cls, arg : "RuleVariation_54.cv_arg") -> "RuleVariation_54":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_54:
        return self.arg # type: ignore

class Content_522(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Transponder Ground bit not set or unknown", 1: "Transponder Ground bit set"}

class RuleContent_522(RuleContentContextFree):
    cv_arg: TypeAlias = Content_522.cv_arg
    cv_content: TypeAlias = Content_522

    @property
    def content(self) -> Content_522:
        return self._get_content() # type: ignore

class Variation_461(Element):
    cv_arg: TypeAlias = RuleContent_522.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_522

    @classmethod
    def create(cls, arg: "Variation_461.cv_arg") -> "Variation_461":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_522:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_522:
        return self.rule.content

class RuleVariation_450(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_461.cv_arg
    cv_variation: TypeAlias = Variation_461

    @classmethod
    def create(cls, arg : "RuleVariation_450.cv_arg") -> "RuleVariation_450":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_461:
        return self.arg # type: ignore

class Content_45(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Barometric altitude (Mode C) more reliable", 1: "Geometric altitude more reliable"}

class RuleContent_45(RuleContentContextFree):
    cv_arg: TypeAlias = Content_45.cv_arg
    cv_content: TypeAlias = Content_45

    @property
    def content(self) -> Content_45:
        return self._get_content() # type: ignore

class Variation_511(Element):
    cv_arg: TypeAlias = RuleContent_45.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_45

    @classmethod
    def create(cls, arg: "Variation_511.cv_arg") -> "Variation_511":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_45:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_45:
        return self.rule.content

class RuleVariation_500(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_511.cv_arg
    cv_variation: TypeAlias = Variation_511

    @classmethod
    def create(cls, arg : "RuleVariation_500.cv_arg") -> "RuleVariation_500":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_511:
        return self.arg # type: ignore

class Content_372(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No source", 1: "GPS", 2: "3d radar", 3: "Triangulation", 4: "Height from coverage", 5: "Speed look-up table", 6: "Default height", 7: "Multilateration"}

class RuleContent_372(RuleContentContextFree):
    cv_arg: TypeAlias = Content_372.cv_arg
    cv_content: TypeAlias = Content_372

    @property
    def content(self) -> Content_372:
        return self._get_content() # type: ignore

class Variation_690(Element):
    cv_arg: TypeAlias = RuleContent_372.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_372

    @classmethod
    def create(cls, arg: "Variation_690.cv_arg") -> "Variation_690":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_372:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_372:
        return self.rule.content

class RuleVariation_679(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_690.cv_arg
    cv_variation: TypeAlias = Variation_690

    @classmethod
    def create(cls, arg : "RuleVariation_679.cv_arg") -> "RuleVariation_679":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_690:
        return self.arg # type: ignore

class Content_62(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Confirmed track", 1: "Tentative track"}

class RuleContent_62(RuleContentContextFree):
    cv_arg: TypeAlias = Content_62.cv_arg
    cv_content: TypeAlias = Content_62

    @property
    def content(self) -> Content_62:
        return self._get_content() # type: ignore

class Variation_907(Element):
    cv_arg: TypeAlias = RuleContent_62.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_62

    @classmethod
    def create(cls, arg: "Variation_907.cv_arg") -> "Variation_907":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_62:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_62:
        return self.rule.content

class RuleVariation_877(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_907.cv_arg
    cv_variation: TypeAlias = Variation_907

    @classmethod
    def create(cls, arg : "RuleVariation_877.cv_arg") -> "RuleVariation_877":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_907:
        return self.arg # type: ignore

class Content_17(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Actual Track", 1: "Simulated track"}

class RuleContent_17(RuleContentContextFree):
    cv_arg: TypeAlias = Content_17.cv_arg
    cv_content: TypeAlias = Content_17

    @property
    def content(self) -> Content_17:
        return self._get_content() # type: ignore

class Variation_4(Element):
    cv_arg: TypeAlias = RuleContent_17.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_17

    @classmethod
    def create(cls, arg: "Variation_4.cv_arg") -> "Variation_4":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_17:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_17:
        return self.rule.content

class RuleVariation_4(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_4.cv_arg
    cv_variation: TypeAlias = Variation_4

    @classmethod
    def create(cls, arg : "RuleVariation_4.cv_arg") -> "RuleVariation_4":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_4:
        return self.arg # type: ignore

class Content_196(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Track service end (i.e. last message transmitted to the user for the track)"}

class RuleContent_196(RuleContentContextFree):
    cv_arg: TypeAlias = Content_196.cv_arg
    cv_content: TypeAlias = Content_196

    @property
    def content(self) -> Content_196:
        return self._get_content() # type: ignore

class Variation_424(Element):
    cv_arg: TypeAlias = RuleContent_196.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_196

    @classmethod
    def create(cls, arg: "Variation_424.cv_arg") -> "Variation_424":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_196:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_196:
        return self.rule.content

class RuleVariation_413(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_424.cv_arg
    cv_variation: TypeAlias = Variation_424

    @classmethod
    def create(cls, arg : "RuleVariation_413.cv_arg") -> "RuleVariation_413":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_424:
        return self.arg # type: ignore

class Content_195(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Track service begin (i.e. first message transmitted to the user for the track)"}

class RuleContent_195(RuleContentContextFree):
    cv_arg: TypeAlias = Content_195.cv_arg
    cv_content: TypeAlias = Content_195

    @property
    def content(self) -> Content_195:
        return self._get_content() # type: ignore

class Variation_532(Element):
    cv_arg: TypeAlias = RuleContent_195.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_195

    @classmethod
    def create(cls, arg: "Variation_532.cv_arg") -> "Variation_532":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_195:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_195:
        return self.rule.content

class RuleVariation_521(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_532.cv_arg
    cv_variation: TypeAlias = Variation_532

    @classmethod
    def create(cls, arg : "RuleVariation_521.cv_arg") -> "RuleVariation_521":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_532:
        return self.arg # type: ignore

class Content_311(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Mode 4 interrogationt", 1: "Friendly target", 2: "Unknown target", 3: "No reply"}

class RuleContent_311(RuleContentContextFree):
    cv_arg: TypeAlias = Content_311.cv_arg
    cv_content: TypeAlias = Content_311

    @property
    def content(self) -> Content_311:
        return self._get_content() # type: ignore

class Variation_679(Element):
    cv_arg: TypeAlias = RuleContent_311.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_311

    @classmethod
    def create(cls, arg: "Variation_679.cv_arg") -> "Variation_679":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_311:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_311:
        return self.rule.content

class RuleVariation_668(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_679.cv_arg
    cv_variation: TypeAlias = Variation_679

    @classmethod
    def create(cls, arg : "RuleVariation_668.cv_arg") -> "RuleVariation_668":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_679:
        return self.arg # type: ignore

class Content_188(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Military Emergency present in the last report received from a sensor capable of decoding this data"}

class RuleContent_188(RuleContentContextFree):
    cv_arg: TypeAlias = Content_188.cv_arg
    cv_content: TypeAlias = Content_188

    @property
    def content(self) -> Content_188:
        return self._get_content() # type: ignore

class Variation_845(Element):
    cv_arg: TypeAlias = RuleContent_188.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_188

    @classmethod
    def create(cls, arg: "Variation_845.cv_arg") -> "Variation_845":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_188:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_188:
        return self.rule.content

class RuleVariation_815(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_845.cv_arg
    cv_variation: TypeAlias = Variation_845

    @classmethod
    def create(cls, arg : "RuleVariation_815.cv_arg") -> "RuleVariation_815":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_845:
        return self.arg # type: ignore

class Content_209(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "End of Data Item", 1: "Military Identification present in the last report received from a sensor capable of decoding this data"}

class RuleContent_209(RuleContentContextFree):
    cv_arg: TypeAlias = Content_209.cv_arg
    cv_content: TypeAlias = Content_209

    @property
    def content(self) -> Content_209:
        return self._get_content() # type: ignore

class Variation_926(Element):
    cv_arg: TypeAlias = RuleContent_209.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_209

    @classmethod
    def create(cls, arg: "Variation_926.cv_arg") -> "Variation_926":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_209:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_209:
        return self.rule.content

class RuleVariation_896(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_926.cv_arg
    cv_variation: TypeAlias = Variation_926

    @classmethod
    def create(cls, arg : "RuleVariation_896.cv_arg") -> "RuleVariation_896":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_926:
        return self.arg # type: ignore

class Content_513(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Track not resulting from amalgamation process", 1: "Track resulting from amalgamation process"}

class RuleContent_513(RuleContentContextFree):
    cv_arg: TypeAlias = Content_513.cv_arg
    cv_content: TypeAlias = Content_513

    @property
    def content(self) -> Content_513:
        return self._get_content() # type: ignore

class Variation_90(Element):
    cv_arg: TypeAlias = RuleContent_513.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_513

    @classmethod
    def create(cls, arg: "Variation_90.cv_arg") -> "Variation_90":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_513:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_513:
        return self.rule.content

class RuleVariation_90(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_90.cv_arg
    cv_variation: TypeAlias = Variation_90

    @classmethod
    def create(cls, arg : "RuleVariation_90.cv_arg") -> "RuleVariation_90":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_90:
        return self.arg # type: ignore

class Content_190(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "SPI present in the last report received from a sensor capable of decoding this data"}

class RuleContent_190(RuleContentContextFree):
    cv_arg: TypeAlias = Content_190.cv_arg
    cv_content: TypeAlias = Content_190

    @property
    def content(self) -> Content_190:
        return self._get_content() # type: ignore

class Variation_423(Element):
    cv_arg: TypeAlias = RuleContent_190.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_190

    @classmethod
    def create(cls, arg: "Variation_423.cv_arg") -> "Variation_423":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_190:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_190:
        return self.rule.content

class RuleVariation_412(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_423.cv_arg
    cv_variation: TypeAlias = Variation_423

    @classmethod
    def create(cls, arg : "RuleVariation_412.cv_arg") -> "RuleVariation_412":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_423:
        return self.arg # type: ignore

class Content_179(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received track update is higher than system dependent threshold (coasting)"}

class RuleContent_179(RuleContentContextFree):
    cv_arg: TypeAlias = Content_179.cv_arg
    cv_content: TypeAlias = Content_179

    @property
    def content(self) -> Content_179:
        return self._get_content() # type: ignore

class Variation_529(Element):
    cv_arg: TypeAlias = RuleContent_179.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_179

    @classmethod
    def create(cls, arg: "Variation_529.cv_arg") -> "Variation_529":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_179:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_179:
        return self.rule.content

class RuleVariation_518(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_529.cv_arg
    cv_variation: TypeAlias = Variation_529

    @classmethod
    def create(cls, arg : "RuleVariation_518.cv_arg") -> "RuleVariation_518":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_529:
        return self.arg # type: ignore

class Content_399(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not flight-plan correlated", 1: "Flight plan correlated"}

class RuleContent_399(RuleContentContextFree):
    cv_arg: TypeAlias = Content_399.cv_arg
    cv_content: TypeAlias = Content_399

    @property
    def content(self) -> Content_399:
        return self._get_content() # type: ignore

class Variation_658(Element):
    cv_arg: TypeAlias = RuleContent_399.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_399

    @classmethod
    def create(cls, arg: "Variation_658.cv_arg") -> "Variation_658":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_399:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_399:
        return self.rule.content

class RuleVariation_647(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_658.cv_arg
    cv_variation: TypeAlias = Variation_658

    @classmethod
    def create(cls, arg : "RuleVariation_647.cv_arg") -> "RuleVariation_647":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_658:
        return self.arg # type: ignore

class Content_172(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "ADS-B data inconsistent with other surveillance information"}

class RuleContent_172(RuleContentContextFree):
    cv_arg: TypeAlias = Content_172.cv_arg
    cv_content: TypeAlias = Content_172

    @property
    def content(self) -> Content_172:
        return self._get_content() # type: ignore

class Variation_716(Element):
    cv_arg: TypeAlias = RuleContent_172.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_172

    @classmethod
    def create(cls, arg: "Variation_716.cv_arg") -> "Variation_716":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_172:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_172:
        return self.rule.content

class RuleVariation_705(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_716.cv_arg
    cv_variation: TypeAlias = Variation_716

    @classmethod
    def create(cls, arg : "RuleVariation_705.cv_arg") -> "RuleVariation_705":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_716:
        return self.arg # type: ignore

class NonSpare_1312(NonSpare):
    cv_arg: TypeAlias = RuleVariation_54.cv_arg
    cv_name = "MON"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_54

    @classmethod
    def create(cls, arg : "NonSpare_1312.cv_arg") -> "NonSpare_1312":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_54:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_54:
        return self.rule.variation

class Item_578(Item):
    cv_arg: TypeAlias = NonSpare_1312.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1312

    @classmethod
    def create(cls, arg : "Item_578.cv_arg") -> "Item_578":
        return cls._create(arg) # type: ignore

class NonSpare_1027(NonSpare):
    cv_arg: TypeAlias = RuleVariation_450.cv_arg
    cv_name = "GBS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_450

    @classmethod
    def create(cls, arg : "NonSpare_1027.cv_arg") -> "NonSpare_1027":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_450:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_461:
        return self.rule.variation

class Item_365(Item):
    cv_arg: TypeAlias = NonSpare_1027.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1027

    @classmethod
    def create(cls, arg : "Item_365.cv_arg") -> "Item_365":
        return cls._create(arg) # type: ignore

class NonSpare_1315(NonSpare):
    cv_arg: TypeAlias = RuleVariation_500.cv_arg
    cv_name = "MRH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_500

    @classmethod
    def create(cls, arg : "NonSpare_1315.cv_arg") -> "NonSpare_1315":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_500:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_511:
        return self.rule.variation

class Item_581(Item):
    cv_arg: TypeAlias = NonSpare_1315.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1315

    @classmethod
    def create(cls, arg : "Item_581.cv_arg") -> "Item_581":
        return cls._create(arg) # type: ignore

class NonSpare_1748(NonSpare):
    cv_arg: TypeAlias = RuleVariation_679.cv_arg
    cv_name = "SRC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_679

    @classmethod
    def create(cls, arg : "NonSpare_1748.cv_arg") -> "NonSpare_1748":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_679:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_690:
        return self.rule.variation

class Item_921(Item):
    cv_arg: TypeAlias = NonSpare_1748.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1748

    @classmethod
    def create(cls, arg : "Item_921.cv_arg") -> "Item_921":
        return cls._create(arg) # type: ignore

class NonSpare_749(NonSpare):
    cv_arg: TypeAlias = RuleVariation_877.cv_arg
    cv_name = "CNF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_877

    @classmethod
    def create(cls, arg : "NonSpare_749.cv_arg") -> "NonSpare_749":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_877:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_907:
        return self.rule.variation

class Item_167(Item):
    cv_arg: TypeAlias = NonSpare_749.cv_arg
    cv_non_spare: TypeAlias = NonSpare_749

    @classmethod
    def create(cls, arg : "Item_167.cv_arg") -> "Item_167":
        return cls._create(arg) # type: ignore

class NonSpare_1722(NonSpare):
    cv_arg: TypeAlias = RuleVariation_4.cv_arg
    cv_name = "SIM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_4

    @classmethod
    def create(cls, arg : "NonSpare_1722.cv_arg") -> "NonSpare_1722":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_4:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_4:
        return self.rule.variation

class Item_897(Item):
    cv_arg: TypeAlias = NonSpare_1722.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1722

    @classmethod
    def create(cls, arg : "Item_897.cv_arg") -> "Item_897":
        return cls._create(arg) # type: ignore

class NonSpare_1930(NonSpare):
    cv_arg: TypeAlias = RuleVariation_413.cv_arg
    cv_name = "TSE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_413

    @classmethod
    def create(cls, arg : "NonSpare_1930.cv_arg") -> "NonSpare_1930":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_413:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_424:
        return self.rule.variation

class Item_1047(Item):
    cv_arg: TypeAlias = NonSpare_1930.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1930

    @classmethod
    def create(cls, arg : "Item_1047.cv_arg") -> "Item_1047":
        return cls._create(arg) # type: ignore

class NonSpare_1928(NonSpare):
    cv_arg: TypeAlias = RuleVariation_521.cv_arg
    cv_name = "TSB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_521

    @classmethod
    def create(cls, arg : "NonSpare_1928.cv_arg") -> "NonSpare_1928":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_521:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_532:
        return self.rule.variation

class Item_1045(Item):
    cv_arg: TypeAlias = NonSpare_1928.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1928

    @classmethod
    def create(cls, arg : "Item_1045.cv_arg") -> "Item_1045":
        return cls._create(arg) # type: ignore

class NonSpare_996(NonSpare):
    cv_arg: TypeAlias = RuleVariation_668.cv_arg
    cv_name = "FRIFOE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_668

    @classmethod
    def create(cls, arg : "NonSpare_996.cv_arg") -> "NonSpare_996":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_668:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_679:
        return self.rule.variation

class Item_345(Item):
    cv_arg: TypeAlias = NonSpare_996.cv_arg
    cv_non_spare: TypeAlias = NonSpare_996

    @classmethod
    def create(cls, arg : "Item_345.cv_arg") -> "Item_345":
        return cls._create(arg) # type: ignore

class NonSpare_1268(NonSpare):
    cv_arg: TypeAlias = RuleVariation_815.cv_arg
    cv_name = "ME"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_815

    @classmethod
    def create(cls, arg : "NonSpare_1268.cv_arg") -> "NonSpare_1268":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_815:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_845:
        return self.rule.variation

class Item_546(Item):
    cv_arg: TypeAlias = NonSpare_1268.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1268

    @classmethod
    def create(cls, arg : "Item_546.cv_arg") -> "Item_546":
        return cls._create(arg) # type: ignore

class NonSpare_1286(NonSpare):
    cv_arg: TypeAlias = RuleVariation_896.cv_arg
    cv_name = "MI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_896

    @classmethod
    def create(cls, arg : "NonSpare_1286.cv_arg") -> "NonSpare_1286":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_896:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_926:
        return self.rule.variation

class Item_553(Item):
    cv_arg: TypeAlias = NonSpare_1286.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1286

    @classmethod
    def create(cls, arg : "Item_553.cv_arg") -> "Item_553":
        return cls._create(arg) # type: ignore

class NonSpare_607(NonSpare):
    cv_arg: TypeAlias = RuleVariation_90.cv_arg
    cv_name = "AMA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_90

    @classmethod
    def create(cls, arg : "NonSpare_607.cv_arg") -> "NonSpare_607":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_90:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_90:
        return self.rule.variation

class Item_71(Item):
    cv_arg: TypeAlias = NonSpare_607.cv_arg
    cv_non_spare: TypeAlias = NonSpare_607

    @classmethod
    def create(cls, arg : "Item_71.cv_arg") -> "Item_71":
        return cls._create(arg) # type: ignore

class NonSpare_1738(NonSpare):
    cv_arg: TypeAlias = RuleVariation_412.cv_arg
    cv_name = "SPI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_412

    @classmethod
    def create(cls, arg : "NonSpare_1738.cv_arg") -> "NonSpare_1738":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_412:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_423:
        return self.rule.variation

class Item_911(Item):
    cv_arg: TypeAlias = NonSpare_1738.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1738

    @classmethod
    def create(cls, arg : "Item_911.cv_arg") -> "Item_911":
        return cls._create(arg) # type: ignore

class NonSpare_839(NonSpare):
    cv_arg: TypeAlias = RuleVariation_518.cv_arg
    cv_name = "CST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_518

    @classmethod
    def create(cls, arg : "NonSpare_839.cv_arg") -> "NonSpare_839":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_518:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_529:
        return self.rule.variation

class Item_222(Item):
    cv_arg: TypeAlias = NonSpare_839.cv_arg
    cv_non_spare: TypeAlias = NonSpare_839

    @classmethod
    def create(cls, arg : "Item_222.cv_arg") -> "Item_222":
        return cls._create(arg) # type: ignore

class NonSpare_988(NonSpare):
    cv_arg: TypeAlias = RuleVariation_647.cv_arg
    cv_name = "FPC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_647

    @classmethod
    def create(cls, arg : "NonSpare_988.cv_arg") -> "NonSpare_988":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_647:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_658:
        return self.rule.variation

class Item_338(Item):
    cv_arg: TypeAlias = NonSpare_988.cv_arg
    cv_non_spare: TypeAlias = NonSpare_988

    @classmethod
    def create(cls, arg : "Item_338.cv_arg") -> "Item_338":
        return cls._create(arg) # type: ignore

class NonSpare_580(NonSpare):
    cv_arg: TypeAlias = RuleVariation_705.cv_arg
    cv_name = "AFF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_705

    @classmethod
    def create(cls, arg : "NonSpare_580.cv_arg") -> "NonSpare_580":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_705:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_716:
        return self.rule.variation

class Item_50(Item):
    cv_arg: TypeAlias = NonSpare_580.cv_arg
    cv_non_spare: TypeAlias = NonSpare_580

    @classmethod
    def create(cls, arg : "Item_50.cv_arg") -> "Item_50":
        return cls._create(arg) # type: ignore

class Variation_1366(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_54.cv_arg, Tuple[Literal["MON"], RuleVariation_54.cv_arg]], Union[RuleVariation_450.cv_arg, Tuple[Literal["GBS"], RuleVariation_450.cv_arg]], Union[RuleVariation_500.cv_arg, Tuple[Literal["MRH"], RuleVariation_500.cv_arg]], Union[RuleVariation_679.cv_arg, Tuple[Literal["SRC"], RuleVariation_679.cv_arg]], Union[RuleVariation_877.cv_arg, Tuple[Literal["CNF"], RuleVariation_877.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_4.cv_arg, Tuple[Literal["SIM"], RuleVariation_4.cv_arg]], Union[RuleVariation_413.cv_arg, Tuple[Literal["TSE"], RuleVariation_413.cv_arg]], Union[RuleVariation_521.cv_arg, Tuple[Literal["TSB"], RuleVariation_521.cv_arg]], Union[RuleVariation_668.cv_arg, Tuple[Literal["FRIFOE"], RuleVariation_668.cv_arg]], Union[RuleVariation_815.cv_arg, Tuple[Literal["ME"], RuleVariation_815.cv_arg]], Union[RuleVariation_896.cv_arg, Tuple[Literal["MI"], RuleVariation_896.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_90.cv_arg, Tuple[Literal["AMA"], RuleVariation_90.cv_arg]], Union[RuleVariation_412.cv_arg, Tuple[Literal["SPI"], RuleVariation_412.cv_arg]], Union[RuleVariation_518.cv_arg, Tuple[Literal["CST"], RuleVariation_518.cv_arg]], Union[RuleVariation_647.cv_arg, Tuple[Literal["FPC"], RuleVariation_647.cv_arg]], Union[RuleVariation_705.cv_arg, Tuple[Literal["AFF"], RuleVariation_705.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1366.cv_arg_group_1"],
        Tuple["Variation_1366.cv_arg_group_1", "Variation_1366.cv_arg_group_2"],
        Tuple["Variation_1366.cv_arg_group_1", "Variation_1366.cv_arg_group_2", "Variation_1366.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_578, 1), (Item_365, 1), (Item_581, 1), (Item_921, 3), (Item_167, 1), None], [(Item_897, 1), (Item_1047, 1), (Item_1045, 1), (Item_345, 2), (Item_546, 1), (Item_553, 1), None], [(Item_71, 1), (Item_911, 1), (Item_222, 1), (Item_338, 1), (Item_50, 1), (Item_24, 2), None]]

    @classmethod
    def create(cls, arg: "Variation_1366.cv_arg") -> 'Variation_1366':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_54:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_450:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_500:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_679:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_877:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_4]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_413]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_521]:
        ...
    @overload
    def get_item(self, key : Literal["FRIFOE"]) -> Optional[RuleVariation_668]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_815]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_896]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_90]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_412]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_518]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_647]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_705]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1287(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1366.cv_arg
    cv_variation: TypeAlias = Variation_1366

    @classmethod
    def create(cls, arg : "RuleVariation_1287.cv_arg") -> "RuleVariation_1287":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1366:
        return self.arg # type: ignore

class NonSpare_379(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1287.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1287

    @classmethod
    def create(cls, arg : "NonSpare_379.cv_arg") -> "NonSpare_379":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1287:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1366:
        return self.rule.variation

class UapItem_379(UapItem):
    cv_non_spare: TypeAlias = NonSpare_379

class Content_759(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_758(RuleContentContextFree):
    cv_arg: TypeAlias = Content_759.cv_arg
    cv_content: TypeAlias = Content_759

    @property
    def content(self) -> Content_759:
        return self._get_content() # type: ignore

class Variation_235(Element):
    cv_arg: TypeAlias = RuleContent_758.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_758

    @classmethod
    def create(cls, arg: "Variation_235.cv_arg") -> "Variation_235":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_758:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_759:
        return self.rule.content

class RuleVariation_228(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_235.cv_arg
    cv_variation: TypeAlias = Variation_235

    @classmethod
    def create(cls, arg : "RuleVariation_228.cv_arg") -> "RuleVariation_228":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_235:
        return self.arg # type: ignore

class NonSpare_1474(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "PSR"
    cv_title = "Age of The Last Primary Detection Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1474.cv_arg") -> "NonSpare_1474":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1760(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "SSR"
    cv_title = "Age of the Last Secondary Detection Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1760.cv_arg") -> "NonSpare_1760":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1252(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MDA"
    cv_title = "Age of the Last Mode A Detection Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1252.cv_arg") -> "NonSpare_1252":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1274(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MFL"
    cv_title = "Age of the Last Mode C Detection Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1274.cv_arg") -> "NonSpare_1274":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1258(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MDS"
    cv_title = "Age of the Last Mode S Detection Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1258.cv_arg") -> "NonSpare_1258":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class Variation_326(Element):
    cv_arg: TypeAlias = RuleContent_758.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_758

    @classmethod
    def create(cls, arg: "Variation_326.cv_arg") -> "Variation_326":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_758:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_759:
        return self.rule.content

class RuleVariation_319(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_326.cv_arg
    cv_variation: TypeAlias = Variation_326

    @classmethod
    def create(cls, arg : "RuleVariation_319.cv_arg") -> "RuleVariation_319":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_326:
        return self.arg # type: ignore

class NonSpare_577(NonSpare):
    cv_arg: TypeAlias = RuleVariation_319.cv_arg
    cv_name = "ADS"
    cv_title = "Age of the Last ADS Report Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_319

    @classmethod
    def create(cls, arg : "NonSpare_577.cv_arg") -> "NonSpare_577":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_326:
        return self.rule.variation

class NonSpare_567(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "ADB"
    cv_title = "Age of the Last ADS-B Report Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_567.cv_arg") -> "NonSpare_567":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1241(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MD1"
    cv_title = "Age of the Last Valid Mode 1 Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1241.cv_arg") -> "NonSpare_1241":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1243(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MD2"
    cv_title = "Age of the Last Mode 2 Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1243.cv_arg") -> "NonSpare_1243":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1195(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "LOP"
    cv_title = "Age of the Last Magentic Loop Detection"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1195.cv_arg") -> "NonSpare_1195":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1917(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "TRK"
    cv_title = "Actual Track Age Since First Occurrence"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1917.cv_arg") -> "NonSpare_1917":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1336(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MUL"
    cv_title = "Age of the Last Multilateration Detection"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1336.cv_arg") -> "NonSpare_1336":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class Variation_1500(Compound):
    cv_arg = TypedDict('cv_arg', {
        "PSR": NonSpare_1474.cv_arg,
        "SSR": NonSpare_1760.cv_arg,
        "MDA": NonSpare_1252.cv_arg,
        "MFL": NonSpare_1274.cv_arg,
        "MDS": NonSpare_1258.cv_arg,
        "ADS": NonSpare_577.cv_arg,
        "ADB": NonSpare_567.cv_arg,
        "MD1": NonSpare_1241.cv_arg,
        "MD2": NonSpare_1243.cv_arg,
        "LOP": NonSpare_1195.cv_arg,
        "TRK": NonSpare_1917.cv_arg,
        "MUL": NonSpare_1336.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1474, NonSpare_1760, NonSpare_1252, NonSpare_1274, NonSpare_1258, NonSpare_577, NonSpare_567, NonSpare_1241, NonSpare_1243, NonSpare_1195, NonSpare_1917, NonSpare_1336]
    cv_items_dict = {"PSR": NonSpare_1474, "SSR": NonSpare_1760, "MDA": NonSpare_1252, "MFL": NonSpare_1274, "MDS": NonSpare_1258, "ADS": NonSpare_577, "ADB": NonSpare_567, "MD1": NonSpare_1241, "MD2": NonSpare_1243, "LOP": NonSpare_1195, "TRK": NonSpare_1917, "MUL": NonSpare_1336}

    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1474:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1760:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MFL"]) -> NonSpare_1274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1258:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADS"]) -> NonSpare_577:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADB"]) -> NonSpare_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD1"]) -> NonSpare_1241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD2"]) -> NonSpare_1243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOP"]) -> NonSpare_1195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRK"]) -> NonSpare_1917:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MUL"]) -> NonSpare_1336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PSR"], Literal["SSR"], Literal["MDA"], Literal["MFL"], Literal["MDS"], Literal["ADS"], Literal["ADB"], Literal["MD1"], Literal["MD2"], Literal["LOP"], Literal["TRK"], Literal["MUL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1474]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1760]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1252]:
        ...
    @overload
    def get_item(self, key : Literal["MFL"]) -> Optional[NonSpare_1274]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1258]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[NonSpare_577]:
        ...
    @overload
    def get_item(self, key : Literal["ADB"]) -> Optional[NonSpare_567]:
        ...
    @overload
    def get_item(self, key : Literal["MD1"]) -> Optional[NonSpare_1241]:
        ...
    @overload
    def get_item(self, key : Literal["MD2"]) -> Optional[NonSpare_1243]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[NonSpare_1195]:
        ...
    @overload
    def get_item(self, key : Literal["TRK"]) -> Optional[NonSpare_1917]:
        ...
    @overload
    def get_item(self, key : Literal["MUL"]) -> Optional[NonSpare_1336]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1474.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1760.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1252.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["MFL"], val : NonSpare_1274.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1258.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["ADS"], val : NonSpare_577.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["ADB"], val : NonSpare_567.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["MD1"], val : NonSpare_1241.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["MD2"], val : NonSpare_1243.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["LOP"], val : NonSpare_1195.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["TRK"], val : NonSpare_1917.cv_arg) -> "Variation_1500":
        ...
    @overload
    def set_item(self, key : Literal["MUL"], val : NonSpare_1336.cv_arg) -> "Variation_1500":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["MFL"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["ADS"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["ADB"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["MD1"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["MD2"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["LOP"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["TRK"]) -> "Variation_1500":
        ...
    @overload
    def del_item(self, key : Literal["MUL"]) -> "Variation_1500":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1500.cv_arg") -> 'Variation_1500':
        return cls._create(arg) # type: ignore

class RuleVariation_1421(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1500.cv_arg
    cv_variation: TypeAlias = Variation_1500

    @classmethod
    def create(cls, arg : "RuleVariation_1421.cv_arg") -> "RuleVariation_1421":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1500:
        return self.arg # type: ignore

class NonSpare_468(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1421.cv_arg
    cv_name = "290"
    cv_title = "System Track Update Ages"
    cv_rule: TypeAlias = RuleVariation_1421

    @classmethod
    def create(cls, arg : "NonSpare_468.cv_arg") -> "NonSpare_468":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1421:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1500:
        return self.rule.variation

class UapItem_468(UapItem):
    cv_non_spare: TypeAlias = NonSpare_468

class Content_551(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "On stand", 2: "Taxiing for departure", 3: "Taxiing for arrival", 4: "Runway for departure", 5: "Runway for arrival", 6: "Hold for departure", 7: "Hold for arrival", 8: "Push back", 9: "On finals"}

class RuleContent_551(RuleContentContextFree):
    cv_arg: TypeAlias = Content_551.cv_arg
    cv_content: TypeAlias = Content_551

    @property
    def content(self) -> Content_551:
        return self._get_content() # type: ignore

class Variation_178(Element):
    cv_arg: TypeAlias = RuleContent_551.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_551

    @classmethod
    def create(cls, arg: "Variation_178.cv_arg") -> "Variation_178":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_551:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_551:
        return self.rule.content

class RuleVariation_171(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_178.cv_arg
    cv_variation: TypeAlias = Variation_178

    @classmethod
    def create(cls, arg : "RuleVariation_171.cv_arg") -> "RuleVariation_171":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_178:
        return self.arg # type: ignore

class NonSpare_506(NonSpare):
    cv_arg: TypeAlias = RuleVariation_171.cv_arg
    cv_name = "430"
    cv_title = "Phase of Flight"
    cv_rule: TypeAlias = RuleVariation_171

    @classmethod
    def create(cls, arg : "NonSpare_506.cv_arg") -> "NonSpare_506":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_171:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_178:
        return self.rule.variation

class UapItem_505(UapItem):
    cv_non_spare: TypeAlias = NonSpare_506

class Content_657(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_657(RuleContentContextFree):
    cv_arg: TypeAlias = Content_657.cv_arg
    cv_content: TypeAlias = Content_657

    @property
    def content(self) -> Content_657:
        return self._get_content() # type: ignore

class Variation_274(Element):
    cv_arg: TypeAlias = RuleContent_657.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_657

    @classmethod
    def create(cls, arg: "Variation_274.cv_arg") -> "Variation_274":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_657:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_657:
        return self.rule.content

class RuleVariation_267(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_274.cv_arg
    cv_variation: TypeAlias = Variation_274

    @classmethod
    def create(cls, arg : "RuleVariation_267.cv_arg") -> "RuleVariation_267":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_274:
        return self.arg # type: ignore

class NonSpare_252(NonSpare):
    cv_arg: TypeAlias = RuleVariation_267.cv_arg
    cv_name = "090"
    cv_title = "Measured Flight Level"
    cv_rule: TypeAlias = RuleVariation_267

    @classmethod
    def create(cls, arg : "NonSpare_252.cv_arg") -> "NonSpare_252":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_267:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_274:
        return self.rule.variation

class UapItem_252(UapItem):
    cv_non_spare: TypeAlias = NonSpare_252

class Content_316(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No QNH correction applied", 1: "QNH correction applied"}

class RuleContent_316(RuleContentContextFree):
    cv_arg: TypeAlias = Content_316.cv_arg
    cv_content: TypeAlias = Content_316

    @property
    def content(self) -> Content_316:
        return self._get_content() # type: ignore

class Variation_59(Element):
    cv_arg: TypeAlias = RuleContent_316.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_316

    @classmethod
    def create(cls, arg: "Variation_59.cv_arg") -> "Variation_59":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_316:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_316:
        return self.rule.content

class RuleVariation_59(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_59.cv_arg
    cv_variation: TypeAlias = Variation_59

    @classmethod
    def create(cls, arg : "RuleVariation_59.cv_arg") -> "RuleVariation_59":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_59:
        return self.arg # type: ignore

class NonSpare_1530(NonSpare):
    cv_arg: TypeAlias = RuleVariation_59.cv_arg
    cv_name = "QNH"
    cv_title = "QNH Correction Applied"
    cv_rule: TypeAlias = RuleVariation_59

    @classmethod
    def create(cls, arg : "NonSpare_1530.cv_arg") -> "NonSpare_1530":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_59:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_59:
        return self.rule.variation

class Item_762(Item):
    cv_arg: TypeAlias = NonSpare_1530.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1530

    @classmethod
    def create(cls, arg : "Item_762.cv_arg") -> "Item_762":
        return cls._create(arg) # type: ignore

class Content_655(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_655(RuleContentContextFree):
    cv_arg: TypeAlias = Content_655.cv_arg
    cv_content: TypeAlias = Content_655

    @property
    def content(self) -> Content_655:
        return self._get_content() # type: ignore

class Variation_500(Element):
    cv_arg: TypeAlias = RuleContent_655.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_655

    @classmethod
    def create(cls, arg: "Variation_500.cv_arg") -> "Variation_500":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_655:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_655:
        return self.rule.content

class RuleVariation_489(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_500.cv_arg
    cv_variation: TypeAlias = Variation_500

    @classmethod
    def create(cls, arg : "RuleVariation_489.cv_arg") -> "RuleVariation_489":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_500:
        return self.arg # type: ignore

class NonSpare_848(NonSpare):
    cv_arg: TypeAlias = RuleVariation_489.cv_arg
    cv_name = "CTBA"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_489

    @classmethod
    def create(cls, arg : "NonSpare_848.cv_arg") -> "NonSpare_848":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_489:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_500:
        return self.rule.variation

class Item_230(Item):
    cv_arg: TypeAlias = NonSpare_848.cv_arg
    cv_non_spare: TypeAlias = NonSpare_848

    @classmethod
    def create(cls, arg : "Item_230.cv_arg") -> "Item_230":
        return cls._create(arg) # type: ignore

class Variation_1168(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_59.cv_arg, Tuple[Literal["QNH"], RuleVariation_59.cv_arg]], Union[RuleVariation_489.cv_arg, Tuple[Literal["CTBA"], RuleVariation_489.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1168.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_762, 1), (Item_230, 15)]
    cv_items_dict = {"QNH": RuleVariation_59, "CTBA": RuleVariation_489}

    @overload
    @classmethod
    def spec(cls, key : Literal["QNH"]) -> RuleVariation_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTBA"]) -> RuleVariation_489:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QNH"], Literal["CTBA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QNH"]) -> RuleVariation_59:
        ...
    @overload
    def get_item(self, key : Literal["CTBA"]) -> RuleVariation_489:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1168.cv_arg") -> 'Variation_1168':
        return cls._create(arg) # type: ignore

class RuleVariation_1119(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1168.cv_arg
    cv_variation: TypeAlias = Variation_1168

    @classmethod
    def create(cls, arg : "RuleVariation_1119.cv_arg") -> "RuleVariation_1119":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1168:
        return self.arg # type: ignore

class NonSpare_265(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1119.cv_arg
    cv_name = "093"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_1119

    @classmethod
    def create(cls, arg : "NonSpare_265.cv_arg") -> "NonSpare_265":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1119:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1168:
        return self.rule.variation

class UapItem_265(UapItem):
    cv_non_spare: TypeAlias = NonSpare_265

class Content_687(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_687(RuleContentContextFree):
    cv_arg: TypeAlias = Content_687.cv_arg
    cv_content: TypeAlias = Content_687

    @property
    def content(self) -> Content_687:
        return self._get_content() # type: ignore

class Variation_292(Element):
    cv_arg: TypeAlias = RuleContent_687.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_687

    @classmethod
    def create(cls, arg: "Variation_292.cv_arg") -> "Variation_292":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_687:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_687:
        return self.rule.content

class RuleVariation_285(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_292.cv_arg
    cv_variation: TypeAlias = Variation_292

    @classmethod
    def create(cls, arg : "RuleVariation_285.cv_arg") -> "RuleVariation_285":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_292:
        return self.arg # type: ignore

class NonSpare_262(NonSpare):
    cv_arg: TypeAlias = RuleVariation_285.cv_arg
    cv_name = "092"
    cv_title = "Calculated Track Geometric Altitude"
    cv_rule: TypeAlias = RuleVariation_285

    @classmethod
    def create(cls, arg : "NonSpare_262.cv_arg") -> "NonSpare_262":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_285:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_292:
        return self.rule.variation

class UapItem_262(UapItem):
    cv_non_spare: TypeAlias = NonSpare_262

class Content_689(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft/min"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25
    cv_unit = "ft/min"

    def as_quantity(self, cv_unit : Optional[Literal["ft/min"]] = None) -> float:
        return self._as_quantity()

class RuleContent_689(RuleContentContextFree):
    cv_arg: TypeAlias = Content_689.cv_arg
    cv_content: TypeAlias = Content_689

    @property
    def content(self) -> Content_689:
        return self._get_content() # type: ignore

class Variation_294(Element):
    cv_arg: TypeAlias = RuleContent_689.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_689

    @classmethod
    def create(cls, arg: "Variation_294.cv_arg") -> "Variation_294":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_689:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_689:
        return self.rule.content

class RuleVariation_287(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_294.cv_arg
    cv_variation: TypeAlias = Variation_294

    @classmethod
    def create(cls, arg : "RuleVariation_287.cv_arg") -> "RuleVariation_287":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_294:
        return self.arg # type: ignore

class NonSpare_418(NonSpare):
    cv_arg: TypeAlias = RuleVariation_287.cv_arg
    cv_name = "215"
    cv_title = "Calculated Rate Of Climb/Descent"
    cv_rule: TypeAlias = RuleVariation_287

    @classmethod
    def create(cls, arg : "NonSpare_418.cv_arg") -> "NonSpare_418":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_287:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_294:
        return self.rule.variation

class UapItem_418(UapItem):
    cv_non_spare: TypeAlias = NonSpare_418

class NonSpare_464(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1284.cv_arg
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule: TypeAlias = RuleVariation_1284

    @classmethod
    def create(cls, arg : "NonSpare_464.cv_arg") -> "NonSpare_464":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1363:
        return self.rule.variation

class UapItem_464(UapItem):
    cv_non_spare: TypeAlias = NonSpare_464

class NonSpare_1711(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SIC"
    cv_title = "System Identity Code"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1711.cv_arg") -> "NonSpare_1711":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_888(Item):
    cv_arg: TypeAlias = NonSpare_1711.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1711

    @classmethod
    def create(cls, arg : "Item_888.cv_arg") -> "Item_888":
        return cls._create(arg) # type: ignore

class Variation_1195(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SAC"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SIC"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1195.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_856, 8), (Item_888, 8)]
    cv_items_dict = {"SAC": RuleVariation_159, "SIC": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1195.cv_arg") -> 'Variation_1195':
        return cls._create(arg) # type: ignore

class RuleVariation_1141(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1195.cv_arg
    cv_variation: TypeAlias = Variation_1195

    @classmethod
    def create(cls, arg : "RuleVariation_1141.cv_arg") -> "RuleVariation_1141":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1195:
        return self.arg # type: ignore

class NonSpare_990(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1141.cv_arg
    cv_name = "FPPSID"
    cv_title = "FPPS Identification Tag"
    cv_rule: TypeAlias = RuleVariation_1141

    @classmethod
    def create(cls, arg : "NonSpare_990.cv_arg") -> "NonSpare_990":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1141:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1195:
        return self.rule.variation

class NonSpare_835(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "CSN"
    cv_title = "Callsign"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_835.cv_arg") -> "NonSpare_835":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class Content_427(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Plan number", 1: "Unit 1 internal flight number", 2: "Unit 2 internal flight number", 3: "Unit 3 internal flight number"}

class RuleContent_427(RuleContentContextFree):
    cv_arg: TypeAlias = Content_427.cv_arg
    cv_content: TypeAlias = Content_427

    @property
    def content(self) -> Content_427:
        return self._get_content() # type: ignore

class Variation_112(Element):
    cv_arg: TypeAlias = RuleContent_427.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_427

    @classmethod
    def create(cls, arg: "Variation_112.cv_arg") -> "Variation_112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_427:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_427:
        return self.rule.content

class RuleVariation_112(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_112.cv_arg
    cv_variation: TypeAlias = Variation_112

    @classmethod
    def create(cls, arg : "RuleVariation_112.cv_arg") -> "RuleVariation_112":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_112:
        return self.arg # type: ignore

class NonSpare_1965(NonSpare):
    cv_arg: TypeAlias = RuleVariation_112.cv_arg
    cv_name = "TYP"
    cv_title = "IFPS Flight ID Type"
    cv_rule: TypeAlias = RuleVariation_112

    @classmethod
    def create(cls, arg : "NonSpare_1965.cv_arg") -> "NonSpare_1965":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_112:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_112:
        return self.rule.variation

class Item_1078(Item):
    cv_arg: TypeAlias = NonSpare_1965.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1965

    @classmethod
    def create(cls, arg : "Item_1078.cv_arg") -> "Item_1078":
        return cls._create(arg) # type: ignore

class Item_13(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 2
    cv_bit_size = 3

class Variation_896(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 27
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_896.cv_arg") -> "Variation_896":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_866(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_896.cv_arg
    cv_variation: TypeAlias = Variation_896

    @classmethod
    def create(cls, arg : "RuleVariation_866.cv_arg") -> "RuleVariation_866":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_896:
        return self.arg # type: ignore

class NonSpare_1353(NonSpare):
    cv_arg: TypeAlias = RuleVariation_866.cv_arg
    cv_name = "NBR"
    cv_title = "IFPS Flight ID Number"
    cv_rule: TypeAlias = RuleVariation_866

    @classmethod
    def create(cls, arg : "NonSpare_1353.cv_arg") -> "NonSpare_1353":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_866:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_896:
        return self.rule.variation

class Item_613(Item):
    cv_arg: TypeAlias = NonSpare_1353.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1353

    @classmethod
    def create(cls, arg : "Item_613.cv_arg") -> "Item_613":
        return cls._create(arg) # type: ignore

class Variation_1237(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_112.cv_arg, Tuple[Literal["TYP"], RuleVariation_112.cv_arg]], int, Union[RuleVariation_866.cv_arg, Tuple[Literal["NBR"], RuleVariation_866.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1237.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1078, 2), (Item_13, 3), (Item_613, 27)]
    cv_items_dict = {"TYP": RuleVariation_112, "NBR": RuleVariation_866}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_112:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_866:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["NBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_112:
        ...
    @overload
    def get_item(self, key : Literal["NBR"]) -> RuleVariation_866:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1237.cv_arg") -> 'Variation_1237':
        return cls._create(arg) # type: ignore

class RuleVariation_1173(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1237.cv_arg
    cv_variation: TypeAlias = Variation_1237

    @classmethod
    def create(cls, arg : "RuleVariation_1173.cv_arg") -> "RuleVariation_1173":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1237:
        return self.arg # type: ignore

class NonSpare_1119(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1173.cv_arg
    cv_name = "IFPSFLIGHTID"
    cv_title = "IFPS_FLIGHT_ID"
    cv_rule: TypeAlias = RuleVariation_1173

    @classmethod
    def create(cls, arg : "NonSpare_1119.cv_arg") -> "NonSpare_1119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1173:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1237:
        return self.rule.variation

class NonSpare_1025(NonSpare):
    cv_arg: TypeAlias = RuleVariation_116.cv_arg
    cv_name = "GATOAT"
    cv_title = "Flight Type"
    cv_rule: TypeAlias = RuleVariation_116

    @classmethod
    def create(cls, arg : "NonSpare_1025.cv_arg") -> "NonSpare_1025":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_116:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_116:
        return self.rule.variation

class Item_363(Item):
    cv_arg: TypeAlias = NonSpare_1025.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1025

    @classmethod
    def create(cls, arg : "Item_363.cv_arg") -> "Item_363":
        return cls._create(arg) # type: ignore

class NonSpare_1640(NonSpare):
    cv_arg: TypeAlias = RuleVariation_758.cv_arg
    cv_name = "RVSM"
    cv_title = "RVSM"
    cv_rule: TypeAlias = RuleVariation_758

    @classmethod
    def create(cls, arg : "NonSpare_1640.cv_arg") -> "NonSpare_1640":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_758:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_769:
        return self.rule.variation

class Item_845(Item):
    cv_arg: TypeAlias = NonSpare_1640.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1640

    @classmethod
    def create(cls, arg : "Item_845.cv_arg") -> "Item_845":
        return cls._create(arg) # type: ignore

class NonSpare_1079(NonSpare):
    cv_arg: TypeAlias = RuleVariation_912.cv_arg
    cv_name = "HPR"
    cv_title = "Flight Priority"
    cv_rule: TypeAlias = RuleVariation_912

    @classmethod
    def create(cls, arg : "NonSpare_1079.cv_arg") -> "NonSpare_1079":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_912:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_942:
        return self.rule.variation

class Item_403(Item):
    cv_arg: TypeAlias = NonSpare_1079.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1079

    @classmethod
    def create(cls, arg : "Item_403.cv_arg") -> "Item_403":
        return cls._create(arg) # type: ignore

class Variation_1112(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_116.cv_arg, Tuple[Literal["GATOAT"], RuleVariation_116.cv_arg]], Union[RuleVariation_581.cv_arg, Tuple[Literal["FR1FR2"], RuleVariation_581.cv_arg]], Union[RuleVariation_758.cv_arg, Tuple[Literal["RVSM"], RuleVariation_758.cv_arg]], Union[RuleVariation_912.cv_arg, Tuple[Literal["HPR"], RuleVariation_912.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1112.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_363, 2), (Item_344, 2), (Item_845, 2), (Item_403, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_116, "FR1FR2": RuleVariation_581, "RVSM": RuleVariation_758, "HPR": RuleVariation_912}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_581:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_581:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1112.cv_arg") -> 'Variation_1112':
        return cls._create(arg) # type: ignore

class RuleVariation_1070(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1112.cv_arg
    cv_variation: TypeAlias = Variation_1112

    @classmethod
    def create(cls, arg : "RuleVariation_1070.cv_arg") -> "RuleVariation_1070":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1112:
        return self.arg # type: ignore

class NonSpare_978(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1070.cv_arg
    cv_name = "FLIGHTCAT"
    cv_title = "Flight Category"
    cv_rule: TypeAlias = RuleVariation_1070

    @classmethod
    def create(cls, arg : "NonSpare_978.cv_arg") -> "NonSpare_978":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1070:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1112:
        return self.rule.variation

class NonSpare_1880(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "TOA"
    cv_title = "Type of Aircraft"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_1880.cv_arg") -> "NonSpare_1880":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class Content_608(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {76: "Light", 77: "Medium", 72: "Heavy", 74: "Super"}

class RuleContent_608(RuleContentContextFree):
    cv_arg: TypeAlias = Content_608.cv_arg
    cv_content: TypeAlias = Content_608

    @property
    def content(self) -> Content_608:
        return self._get_content() # type: ignore

class Variation_202(Element):
    cv_arg: TypeAlias = RuleContent_608.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_608

    @classmethod
    def create(cls, arg: "Variation_202.cv_arg") -> "Variation_202":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_608:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_608:
        return self.rule.content

class RuleVariation_195(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_202.cv_arg
    cv_variation: TypeAlias = Variation_202

    @classmethod
    def create(cls, arg : "RuleVariation_195.cv_arg") -> "RuleVariation_195":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_202:
        return self.arg # type: ignore

class NonSpare_2069(NonSpare):
    cv_arg: TypeAlias = RuleVariation_195.cv_arg
    cv_name = "WTC"
    cv_title = "Wake Turbulence Category"
    cv_rule: TypeAlias = RuleVariation_195

    @classmethod
    def create(cls, arg : "NonSpare_2069.cv_arg") -> "NonSpare_2069":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

class NonSpare_568(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "ADEP"
    cv_title = "Departure Airport"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_568.cv_arg") -> "NonSpare_568":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class NonSpare_569(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "ADES"
    cv_title = "Destination Airport"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_569.cv_arg") -> "NonSpare_569":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class Variation_350(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_350.cv_arg") -> "Variation_350":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_343(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_350.cv_arg
    cv_variation: TypeAlias = Variation_350

    @classmethod
    def create(cls, arg : "RuleVariation_343.cv_arg") -> "RuleVariation_343":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_350:
        return self.arg # type: ignore

class NonSpare_1644(NonSpare):
    cv_arg: TypeAlias = RuleVariation_343.cv_arg
    cv_name = "RWY"
    cv_title = "Runway Designation"
    cv_rule: TypeAlias = RuleVariation_343

    @classmethod
    def create(cls, arg : "NonSpare_1644.cv_arg") -> "NonSpare_1644":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

class NonSpare_727(NonSpare):
    cv_arg: TypeAlias = RuleVariation_314.cv_arg
    cv_name = "CFL"
    cv_title = "Current Cleared Flight Level"
    cv_rule: TypeAlias = RuleVariation_314

    @classmethod
    def create(cls, arg : "NonSpare_727.cv_arg") -> "NonSpare_727":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_321:
        return self.rule.variation

class NonSpare_724(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "CENTRE"
    cv_title = "8-bit Group Identification Code"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_724.cv_arg") -> "NonSpare_724":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_150(Item):
    cv_arg: TypeAlias = NonSpare_724.cv_arg
    cv_non_spare: TypeAlias = NonSpare_724

    @classmethod
    def create(cls, arg : "Item_150.cv_arg") -> "Item_150":
        return cls._create(arg) # type: ignore

class NonSpare_1452(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "POSITION"
    cv_title = "8-bit Control Position Identification Code"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1452.cv_arg") -> "NonSpare_1452":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_695(Item):
    cv_arg: TypeAlias = NonSpare_1452.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1452

    @classmethod
    def create(cls, arg : "Item_695.cv_arg") -> "Item_695":
        return cls._create(arg) # type: ignore

class Variation_1069(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["CENTRE"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["POSITION"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1069.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_150, 8), (Item_695, 8)]
    cv_items_dict = {"CENTRE": RuleVariation_159, "POSITION": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["CENTRE"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POSITION"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CENTRE"], Literal["POSITION"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CENTRE"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["POSITION"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1069.cv_arg") -> 'Variation_1069':
        return cls._create(arg) # type: ignore

class RuleVariation_1031(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1069.cv_arg
    cv_variation: TypeAlias = Variation_1069

    @classmethod
    def create(cls, arg : "RuleVariation_1031.cv_arg") -> "RuleVariation_1031":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1069:
        return self.arg # type: ignore

class NonSpare_712(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1031.cv_arg
    cv_name = "CCP"
    cv_title = "Current Control Position"
    cv_rule: TypeAlias = RuleVariation_1031

    @classmethod
    def create(cls, arg : "NonSpare_712.cv_arg") -> "NonSpare_712":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1031:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1069:
        return self.rule.variation

class Content_455(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Scheduled off-block time", 1: "Estimated off-block time", 2: "Estimated take-off time", 3: "Actual off-block time", 4: "Predicted time at runway hold", 5: "Actual time at runway hold", 6: "Actual line-up time", 7: "Actual take-off time", 8: "Estimated time of arrival", 9: "Predicted landing time", 10: "Actual landing time", 11: "Actual time off runway", 12: "Predicted time to gate", 13: "Actual on-block time"}

class RuleContent_455(RuleContentContextFree):
    cv_arg: TypeAlias = Content_455.cv_arg
    cv_content: TypeAlias = Content_455

    @property
    def content(self) -> Content_455:
        return self._get_content() # type: ignore

class Variation_145(Element):
    cv_arg: TypeAlias = RuleContent_455.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_455

    @classmethod
    def create(cls, arg: "Variation_145.cv_arg") -> "Variation_145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_455:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_455:
        return self.rule.content

class RuleVariation_145(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_145.cv_arg
    cv_variation: TypeAlias = Variation_145

    @classmethod
    def create(cls, arg : "RuleVariation_145.cv_arg") -> "RuleVariation_145":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_145:
        return self.arg # type: ignore

class NonSpare_1968(NonSpare):
    cv_arg: TypeAlias = RuleVariation_145.cv_arg
    cv_name = "TYP"
    cv_title = "Time Type"
    cv_rule: TypeAlias = RuleVariation_145

    @classmethod
    def create(cls, arg : "NonSpare_1968.cv_arg") -> "NonSpare_1968":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_145:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_145:
        return self.rule.variation

class Item_1081(Item):
    cv_arg: TypeAlias = NonSpare_1968.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1968

    @classmethod
    def create(cls, arg : "Item_1081.cv_arg") -> "Item_1081":
        return cls._create(arg) # type: ignore

class Content_509(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Today", 1: "Yesterday", 2: "Tomorrow"}

class RuleContent_509(RuleContentContextFree):
    cv_arg: TypeAlias = Content_509.cv_arg
    cv_content: TypeAlias = Content_509

    @property
    def content(self) -> Content_509:
        return self._get_content() # type: ignore

class Variation_884(Element):
    cv_arg: TypeAlias = RuleContent_509.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_509

    @classmethod
    def create(cls, arg: "Variation_884.cv_arg") -> "Variation_884":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_509:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_509:
        return self.rule.content

class RuleVariation_854(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_884.cv_arg
    cv_variation: TypeAlias = Variation_884

    @classmethod
    def create(cls, arg : "RuleVariation_854.cv_arg") -> "RuleVariation_854":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_884:
        return self.arg # type: ignore

class NonSpare_864(NonSpare):
    cv_arg: TypeAlias = RuleVariation_854.cv_arg
    cv_name = "DAY"
    cv_title = "Day"
    cv_rule: TypeAlias = RuleVariation_854

    @classmethod
    def create(cls, arg : "NonSpare_864.cv_arg") -> "NonSpare_864":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_854:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_884:
        return self.rule.variation

class Item_242(Item):
    cv_arg: TypeAlias = NonSpare_864.cv_arg
    cv_non_spare: TypeAlias = NonSpare_864

    @classmethod
    def create(cls, arg : "Item_242.cv_arg") -> "Item_242":
        return cls._create(arg) # type: ignore

class Item_30(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 7
    cv_bit_size = 4

class Content_618(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_618(RuleContentContextFree):
    cv_arg: TypeAlias = Content_618.cv_arg
    cv_content: TypeAlias = Content_618

    @property
    def content(self) -> Content_618:
        return self._get_content() # type: ignore

class Variation_696(Element):
    cv_arg: TypeAlias = RuleContent_618.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 5
    cv_rule = RuleContent_618

    @classmethod
    def create(cls, arg: "Variation_696.cv_arg") -> "Variation_696":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_618:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_618:
        return self.rule.content

class RuleVariation_685(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_696.cv_arg
    cv_variation: TypeAlias = Variation_696

    @classmethod
    def create(cls, arg : "RuleVariation_685.cv_arg") -> "RuleVariation_685":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_696:
        return self.arg # type: ignore

class NonSpare_1075(NonSpare):
    cv_arg: TypeAlias = RuleVariation_685.cv_arg
    cv_name = "HOR"
    cv_title = "Hours, from 0 to 23"
    cv_rule: TypeAlias = RuleVariation_685

    @classmethod
    def create(cls, arg : "NonSpare_1075.cv_arg") -> "NonSpare_1075":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_685:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_696:
        return self.rule.variation

class Item_400(Item):
    cv_arg: TypeAlias = NonSpare_1075.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1075

    @classmethod
    def create(cls, arg : "Item_400.cv_arg") -> "Item_400":
        return cls._create(arg) # type: ignore

class Item_1(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 2

class Content_619(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_619(RuleContentContextFree):
    cv_arg: TypeAlias = Content_619.cv_arg
    cv_content: TypeAlias = Content_619

    @property
    def content(self) -> Content_619:
        return self._get_content() # type: ignore

class Variation_603(Element):
    cv_arg: TypeAlias = RuleContent_619.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 6
    cv_rule = RuleContent_619

    @classmethod
    def create(cls, arg: "Variation_603.cv_arg") -> "Variation_603":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_619:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_619:
        return self.rule.content

class RuleVariation_592(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_603.cv_arg
    cv_variation: TypeAlias = Variation_603

    @classmethod
    def create(cls, arg : "RuleVariation_592.cv_arg") -> "RuleVariation_592":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_603:
        return self.arg # type: ignore

class NonSpare_1289(NonSpare):
    cv_arg: TypeAlias = RuleVariation_592.cv_arg
    cv_name = "MIN"
    cv_title = "Minutes, from 0 to 59"
    cv_rule: TypeAlias = RuleVariation_592

    @classmethod
    def create(cls, arg : "NonSpare_1289.cv_arg") -> "NonSpare_1289":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

class Item_556(Item):
    cv_arg: TypeAlias = NonSpare_1289.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1289

    @classmethod
    def create(cls, arg : "Item_556.cv_arg") -> "Item_556":
        return cls._create(arg) # type: ignore

class Content_456(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Seconds available", 1: "Seconds not available"}

class RuleContent_456(RuleContentContextFree):
    cv_arg: TypeAlias = Content_456.cv_arg
    cv_content: TypeAlias = Content_456

    @property
    def content(self) -> Content_456:
        return self._get_content() # type: ignore

class Variation_75(Element):
    cv_arg: TypeAlias = RuleContent_456.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_456

    @classmethod
    def create(cls, arg: "Variation_75.cv_arg") -> "Variation_75":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_456:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_456:
        return self.rule.content

class RuleVariation_75(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_75.cv_arg
    cv_variation: TypeAlias = Variation_75

    @classmethod
    def create(cls, arg : "RuleVariation_75.cv_arg") -> "RuleVariation_75":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_75:
        return self.arg # type: ignore

class NonSpare_652(NonSpare):
    cv_arg: TypeAlias = RuleVariation_75.cv_arg
    cv_name = "AVS"
    cv_title = "Seconds Available"
    cv_rule: TypeAlias = RuleVariation_75

    @classmethod
    def create(cls, arg : "NonSpare_652.cv_arg") -> "NonSpare_652":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_75:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_75:
        return self.rule.variation

class Item_96(Item):
    cv_arg: TypeAlias = NonSpare_652.cv_arg
    cv_non_spare: TypeAlias = NonSpare_652

    @classmethod
    def create(cls, arg : "Item_96.cv_arg") -> "Item_96":
        return cls._create(arg) # type: ignore

class NonSpare_1701(NonSpare):
    cv_arg: TypeAlias = RuleVariation_592.cv_arg
    cv_name = "SEC"
    cv_title = "Seconds, from 0 to 59"
    cv_rule: TypeAlias = RuleVariation_592

    @classmethod
    def create(cls, arg : "NonSpare_1701.cv_arg") -> "NonSpare_1701":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

class Item_880(Item):
    cv_arg: TypeAlias = NonSpare_1701.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1701

    @classmethod
    def create(cls, arg : "Item_880.cv_arg") -> "Item_880":
        return cls._create(arg) # type: ignore

class Variation_1240(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_145.cv_arg, Tuple[Literal["TYP"], RuleVariation_145.cv_arg]], Union[RuleVariation_854.cv_arg, Tuple[Literal["DAY"], RuleVariation_854.cv_arg]], int, Union[RuleVariation_685.cv_arg, Tuple[Literal["HOR"], RuleVariation_685.cv_arg]], int, Union[RuleVariation_592.cv_arg, Tuple[Literal["MIN"], RuleVariation_592.cv_arg]], Union[RuleVariation_75.cv_arg, Tuple[Literal["AVS"], RuleVariation_75.cv_arg]], int, Union[RuleVariation_592.cv_arg, Tuple[Literal["SEC"], RuleVariation_592.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1240.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1081, 5), (Item_242, 2), (Item_30, 4), (Item_400, 5), (Item_1, 2), (Item_556, 6), (Item_96, 1), (Item_7, 1), (Item_880, 6)]
    cv_items_dict = {"TYP": RuleVariation_145, "DAY": RuleVariation_854, "HOR": RuleVariation_685, "MIN": RuleVariation_592, "AVS": RuleVariation_75, "SEC": RuleVariation_592}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_145:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DAY"]) -> RuleVariation_854:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HOR"]) -> RuleVariation_685:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIN"]) -> RuleVariation_592:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVS"]) -> RuleVariation_75:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SEC"]) -> RuleVariation_592:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["DAY"], Literal["HOR"], Literal["MIN"], Literal["AVS"], Literal["SEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_145:
        ...
    @overload
    def get_item(self, key : Literal["DAY"]) -> RuleVariation_854:
        ...
    @overload
    def get_item(self, key : Literal["HOR"]) -> RuleVariation_685:
        ...
    @overload
    def get_item(self, key : Literal["MIN"]) -> RuleVariation_592:
        ...
    @overload
    def get_item(self, key : Literal["AVS"]) -> RuleVariation_75:
        ...
    @overload
    def get_item(self, key : Literal["SEC"]) -> RuleVariation_592:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1240.cv_arg") -> 'Variation_1240':
        return cls._create(arg) # type: ignore

class Variation_1442(Repetitive):
    cv_arg: TypeAlias = List[Variation_1240.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1240

    @classmethod
    def create(cls, arg: "Variation_1442.cv_arg") -> 'Variation_1442':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1240]:
        return self._get_list() # type: ignore

class RuleVariation_1363(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1442.cv_arg
    cv_variation: TypeAlias = Variation_1442

    @classmethod
    def create(cls, arg : "RuleVariation_1363.cv_arg") -> "RuleVariation_1363":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1442:
        return self.arg # type: ignore

class NonSpare_1881(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1363.cv_arg
    cv_name = "TOD"
    cv_title = "Time of Departure"
    cv_rule: TypeAlias = RuleVariation_1363

    @classmethod
    def create(cls, arg : "NonSpare_1881.cv_arg") -> "NonSpare_1881":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1442:
        return self.rule.variation

class Variation_390(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_390.cv_arg") -> "Variation_390":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_382(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_390.cv_arg
    cv_variation: TypeAlias = Variation_390

    @classmethod
    def create(cls, arg : "RuleVariation_382.cv_arg") -> "RuleVariation_382":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_390:
        return self.arg # type: ignore

class NonSpare_639(NonSpare):
    cv_arg: TypeAlias = RuleVariation_382.cv_arg
    cv_name = "AST"
    cv_title = "Aircraft Stand"
    cv_rule: TypeAlias = RuleVariation_382

    @classmethod
    def create(cls, arg : "NonSpare_639.cv_arg") -> "NonSpare_639":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_390:
        return self.rule.variation

class Content_205(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Empty", 1: "Occupied", 2: "Unknown"}

class RuleContent_205(RuleContentContextFree):
    cv_arg: TypeAlias = Content_205.cv_arg
    cv_content: TypeAlias = Content_205

    @property
    def content(self) -> Content_205:
        return self._get_content() # type: ignore

class Variation_102(Element):
    cv_arg: TypeAlias = RuleContent_205.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_205

    @classmethod
    def create(cls, arg: "Variation_102.cv_arg") -> "Variation_102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_205:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_205:
        return self.rule.content

class RuleVariation_102(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_102.cv_arg
    cv_variation: TypeAlias = Variation_102

    @classmethod
    def create(cls, arg : "RuleVariation_102.cv_arg") -> "RuleVariation_102":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_102:
        return self.arg # type: ignore

class NonSpare_932(NonSpare):
    cv_arg: TypeAlias = RuleVariation_102.cv_arg
    cv_name = "EMP"
    cv_title = "Stand Empty"
    cv_rule: TypeAlias = RuleVariation_102

    @classmethod
    def create(cls, arg : "NonSpare_932.cv_arg") -> "NonSpare_932":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_102:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_102:
        return self.rule.variation

class Item_293(Item):
    cv_arg: TypeAlias = NonSpare_932.cv_arg
    cv_non_spare: TypeAlias = NonSpare_932

    @classmethod
    def create(cls, arg : "Item_293.cv_arg") -> "Item_293":
        return cls._create(arg) # type: ignore

class Content_43(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Available", 1: "Not available", 2: "Unknown"}

class RuleContent_43(RuleContentContextFree):
    cv_arg: TypeAlias = Content_43.cv_arg
    cv_content: TypeAlias = Content_43

    @property
    def content(self) -> Content_43:
        return self._get_content() # type: ignore

class Variation_588(Element):
    cv_arg: TypeAlias = RuleContent_43.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_43

    @classmethod
    def create(cls, arg: "Variation_588.cv_arg") -> "Variation_588":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_43:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_43:
        return self.rule.content

class RuleVariation_577(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_588.cv_arg
    cv_variation: TypeAlias = Variation_588

    @classmethod
    def create(cls, arg : "RuleVariation_577.cv_arg") -> "RuleVariation_577":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_588:
        return self.arg # type: ignore

class NonSpare_650(NonSpare):
    cv_arg: TypeAlias = RuleVariation_577.cv_arg
    cv_name = "AVL"
    cv_title = "Stand Available"
    cv_rule: TypeAlias = RuleVariation_577

    @classmethod
    def create(cls, arg : "NonSpare_650.cv_arg") -> "NonSpare_650":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_577:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_588:
        return self.rule.variation

class Item_94(Item):
    cv_arg: TypeAlias = NonSpare_650.cv_arg
    cv_non_spare: TypeAlias = NonSpare_650

    @classmethod
    def create(cls, arg : "Item_94.cv_arg") -> "Item_94":
        return cls._create(arg) # type: ignore

class Item_22(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 4
    cv_bit_size = 4

class Variation_1088(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_102.cv_arg, Tuple[Literal["EMP"], RuleVariation_102.cv_arg]], Union[RuleVariation_577.cv_arg, Tuple[Literal["AVL"], RuleVariation_577.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1088.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_293, 2), (Item_94, 2), (Item_22, 4)]
    cv_items_dict = {"EMP": RuleVariation_102, "AVL": RuleVariation_577}

    @overload
    @classmethod
    def spec(cls, key : Literal["EMP"]) -> RuleVariation_102:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVL"]) -> RuleVariation_577:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EMP"], Literal["AVL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EMP"]) -> RuleVariation_102:
        ...
    @overload
    def get_item(self, key : Literal["AVL"]) -> RuleVariation_577:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1088.cv_arg") -> 'Variation_1088':
        return cls._create(arg) # type: ignore

class RuleVariation_1046(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1088.cv_arg
    cv_variation: TypeAlias = Variation_1088

    @classmethod
    def create(cls, arg : "RuleVariation_1046.cv_arg") -> "RuleVariation_1046":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1088:
        return self.arg # type: ignore

class NonSpare_1799(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1046.cv_arg
    cv_name = "STS"
    cv_title = "Stand Status"
    cv_rule: TypeAlias = RuleVariation_1046

    @classmethod
    def create(cls, arg : "NonSpare_1799.cv_arg") -> "NonSpare_1799":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1046:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1088:
        return self.rule.variation

class Variation_1488(Compound):
    cv_arg = TypedDict('cv_arg', {
        "FPPSID": NonSpare_990.cv_arg,
        "CSN": NonSpare_835.cv_arg,
        "IFPSFLIGHTID": NonSpare_1119.cv_arg,
        "FLIGHTCAT": NonSpare_978.cv_arg,
        "TOA": NonSpare_1880.cv_arg,
        "WTC": NonSpare_2069.cv_arg,
        "ADEP": NonSpare_568.cv_arg,
        "ADES": NonSpare_569.cv_arg,
        "RWY": NonSpare_1644.cv_arg,
        "CFL": NonSpare_727.cv_arg,
        "CCP": NonSpare_712.cv_arg,
        "TOD": NonSpare_1881.cv_arg,
        "AST": NonSpare_639.cv_arg,
        "STS": NonSpare_1799.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_990, NonSpare_835, NonSpare_1119, NonSpare_978, NonSpare_1880, NonSpare_2069, NonSpare_568, NonSpare_569, NonSpare_1644, NonSpare_727, NonSpare_712, NonSpare_1881, NonSpare_639, NonSpare_1799]
    cv_items_dict = {"FPPSID": NonSpare_990, "CSN": NonSpare_835, "IFPSFLIGHTID": NonSpare_1119, "FLIGHTCAT": NonSpare_978, "TOA": NonSpare_1880, "WTC": NonSpare_2069, "ADEP": NonSpare_568, "ADES": NonSpare_569, "RWY": NonSpare_1644, "CFL": NonSpare_727, "CCP": NonSpare_712, "TOD": NonSpare_1881, "AST": NonSpare_639, "STS": NonSpare_1799}

    @overload
    @classmethod
    def spec(cls, key : Literal["FPPSID"]) -> NonSpare_990:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_835:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFPSFLIGHTID"]) -> NonSpare_1119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FLIGHTCAT"]) -> NonSpare_978:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> NonSpare_1880:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2069:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADEP"]) -> NonSpare_568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADES"]) -> NonSpare_569:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RWY"]) -> NonSpare_1644:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_727:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CCP"]) -> NonSpare_712:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1881:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_639:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1799:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FPPSID"], Literal["CSN"], Literal["IFPSFLIGHTID"], Literal["FLIGHTCAT"], Literal["TOA"], Literal["WTC"], Literal["ADEP"], Literal["ADES"], Literal["RWY"], Literal["CFL"], Literal["CCP"], Literal["TOD"], Literal["AST"], Literal["STS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FPPSID"]) -> Optional[NonSpare_990]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_835]:
        ...
    @overload
    def get_item(self, key : Literal["IFPSFLIGHTID"]) -> Optional[NonSpare_1119]:
        ...
    @overload
    def get_item(self, key : Literal["FLIGHTCAT"]) -> Optional[NonSpare_978]:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> Optional[NonSpare_1880]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2069]:
        ...
    @overload
    def get_item(self, key : Literal["ADEP"]) -> Optional[NonSpare_568]:
        ...
    @overload
    def get_item(self, key : Literal["ADES"]) -> Optional[NonSpare_569]:
        ...
    @overload
    def get_item(self, key : Literal["RWY"]) -> Optional[NonSpare_1644]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_727]:
        ...
    @overload
    def get_item(self, key : Literal["CCP"]) -> Optional[NonSpare_712]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1881]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_639]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1799]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["FPPSID"], val : NonSpare_990.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_835.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["IFPSFLIGHTID"], val : NonSpare_1119.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["FLIGHTCAT"], val : NonSpare_978.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["TOA"], val : NonSpare_1880.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2069.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["ADEP"], val : NonSpare_568.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["ADES"], val : NonSpare_569.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["RWY"], val : NonSpare_1644.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_727.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["CCP"], val : NonSpare_712.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1881.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_639.cv_arg) -> "Variation_1488":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1799.cv_arg) -> "Variation_1488":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["FPPSID"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["IFPSFLIGHTID"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["FLIGHTCAT"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["TOA"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["ADEP"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["ADES"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["RWY"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["CCP"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1488":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1488":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1488.cv_arg") -> 'Variation_1488':
        return cls._create(arg) # type: ignore

class RuleVariation_1409(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1488.cv_arg
    cv_variation: TypeAlias = Variation_1488

    @classmethod
    def create(cls, arg : "RuleVariation_1409.cv_arg") -> "RuleVariation_1409":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1488:
        return self.arg # type: ignore

class NonSpare_492(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1409.cv_arg
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule: TypeAlias = RuleVariation_1409

    @classmethod
    def create(cls, arg : "NonSpare_492.cv_arg") -> "NonSpare_492":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1409:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1488:
        return self.rule.variation

class UapItem_492(UapItem):
    cv_non_spare: TypeAlias = NonSpare_492

class Content_215(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Flyco (follow me)", 1: "ATC equipment maintenance", 2: "Airport maintenance", 3: "Fire", 4: "Bird scarer", 5: "Snow plough", 6: "Runway sweeper", 7: "Emergency", 8: "Police", 9: "Bus", 10: "Tug (push/tow)", 11: "Grass cutter", 12: "Fuel", 13: "Baggage", 14: "Catering", 15: "Aircraft maintenance", 16: "Unknown"}

class RuleContent_215(RuleContentContextFree):
    cv_arg: TypeAlias = Content_215.cv_arg
    cv_content: TypeAlias = Content_215

    @property
    def content(self) -> Content_215:
        return self._get_content() # type: ignore

class Variation_167(Element):
    cv_arg: TypeAlias = RuleContent_215.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_215

    @classmethod
    def create(cls, arg: "Variation_167.cv_arg") -> "Variation_167":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_215:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_215:
        return self.rule.content

class RuleVariation_161(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_167.cv_arg
    cv_variation: TypeAlias = Variation_167

    @classmethod
    def create(cls, arg : "RuleVariation_161.cv_arg") -> "RuleVariation_161":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_167:
        return self.arg # type: ignore

class NonSpare_476(NonSpare):
    cv_arg: TypeAlias = RuleVariation_161.cv_arg
    cv_name = "300"
    cv_title = "Vehicle Fleet Identification"
    cv_rule: TypeAlias = RuleVariation_161

    @classmethod
    def create(cls, arg : "NonSpare_476.cv_arg") -> "NonSpare_476":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_161:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_167:
        return self.rule.variation

class UapItem_476(UapItem):
    cv_non_spare: TypeAlias = NonSpare_476

class NonSpare_1909(NonSpare):
    cv_arg: TypeAlias = RuleVariation_30.cv_arg
    cv_name = "TRB"
    cv_title = "In Trouble"
    cv_rule: TypeAlias = RuleVariation_30

    @classmethod
    def create(cls, arg : "NonSpare_1909.cv_arg") -> "NonSpare_1909":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_30:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_30:
        return self.rule.variation

class Item_1032(Item):
    cv_arg: TypeAlias = NonSpare_1909.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1909

    @classmethod
    def create(cls, arg : "Item_1032.cv_arg") -> "Item_1032":
        return cls._create(arg) # type: ignore

class Content_601(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Towing aircraft", 2: "FOLLOW-ME operation", 3: "Runway check", 4: "Emergency operation (fire, medical...)", 5: "Work in progress (maintenance, birds scarer, sweepers...)"}

class RuleContent_601(RuleContentContextFree):
    cv_arg: TypeAlias = Content_601.cv_arg
    cv_content: TypeAlias = Content_601

    @property
    def content(self) -> Content_601:
        return self._get_content() # type: ignore

class Variation_495(Element):
    cv_arg: TypeAlias = RuleContent_601.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_601

    @classmethod
    def create(cls, arg: "Variation_495.cv_arg") -> "Variation_495":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_601:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_601:
        return self.rule.content

class RuleVariation_484(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_495.cv_arg
    cv_variation: TypeAlias = Variation_495

    @classmethod
    def create(cls, arg : "RuleVariation_484.cv_arg") -> "RuleVariation_484":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_495:
        return self.arg # type: ignore

class NonSpare_1331(NonSpare):
    cv_arg: TypeAlias = RuleVariation_484.cv_arg
    cv_name = "MSG"
    cv_title = "Message"
    cv_rule: TypeAlias = RuleVariation_484

    @classmethod
    def create(cls, arg : "NonSpare_1331.cv_arg") -> "NonSpare_1331":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_484:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_495:
        return self.rule.variation

class Item_595(Item):
    cv_arg: TypeAlias = NonSpare_1331.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1331

    @classmethod
    def create(cls, arg : "Item_595.cv_arg") -> "Item_595":
        return cls._create(arg) # type: ignore

class Variation_1232(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_30.cv_arg, Tuple[Literal["TRB"], RuleVariation_30.cv_arg]], Union[RuleVariation_484.cv_arg, Tuple[Literal["MSG"], RuleVariation_484.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1232.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1032, 1), (Item_595, 7)]
    cv_items_dict = {"TRB": RuleVariation_30, "MSG": RuleVariation_484}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSG"]) -> RuleVariation_484:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRB"], Literal["MSG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    def get_item(self, key : Literal["MSG"]) -> RuleVariation_484:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1232.cv_arg") -> 'Variation_1232':
        return cls._create(arg) # type: ignore

class RuleVariation_1170(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1232.cv_arg
    cv_variation: TypeAlias = Variation_1232

    @classmethod
    def create(cls, arg : "RuleVariation_1170.cv_arg") -> "RuleVariation_1170":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1232:
        return self.arg # type: ignore

class NonSpare_480(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1170.cv_arg
    cv_name = "310"
    cv_title = "Pre-programmed Message"
    cv_rule: TypeAlias = RuleVariation_1170

    @classmethod
    def create(cls, arg : "NonSpare_480.cv_arg") -> "NonSpare_480":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1170:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1232:
        return self.rule.variation

class UapItem_480(UapItem):
    cv_non_spare: TypeAlias = NonSpare_480

class NonSpare_2090(NonSpare):
    cv_arg: TypeAlias = RuleVariation_225.cv_arg
    cv_name = "X"
    cv_title = "Estimated Accuracy of the Calculated Position of X Component"
    cv_rule: TypeAlias = RuleVariation_225

    @classmethod
    def create(cls, arg : "NonSpare_2090.cv_arg") -> "NonSpare_2090":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_232:
        return self.rule.variation

class Item_1191(Item):
    cv_arg: TypeAlias = NonSpare_2090.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2090

    @classmethod
    def create(cls, arg : "Item_1191.cv_arg") -> "Item_1191":
        return cls._create(arg) # type: ignore

class NonSpare_2143(NonSpare):
    cv_arg: TypeAlias = RuleVariation_225.cv_arg
    cv_name = "Y"
    cv_title = "Estimated Accuracy of the Calculated Position of Y Component"
    cv_rule: TypeAlias = RuleVariation_225

    @classmethod
    def create(cls, arg : "NonSpare_2143.cv_arg") -> "NonSpare_2143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_232:
        return self.rule.variation

class Item_1241(Item):
    cv_arg: TypeAlias = NonSpare_2143.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2143

    @classmethod
    def create(cls, arg : "Item_1241.cv_arg") -> "Item_1241":
        return cls._create(arg) # type: ignore

class Variation_1304(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_225.cv_arg, Tuple[Literal["X"], RuleVariation_225.cv_arg]], Union[RuleVariation_225.cv_arg, Tuple[Literal["Y"], RuleVariation_225.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1304.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1191, 8), (Item_1241, 8)]
    cv_items_dict = {"X": RuleVariation_225, "Y": RuleVariation_225}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_225:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_225:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_225:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_225:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1304.cv_arg") -> 'Variation_1304':
        return cls._create(arg) # type: ignore

class RuleVariation_1233(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1304.cv_arg
    cv_variation: TypeAlias = Variation_1304

    @classmethod
    def create(cls, arg : "RuleVariation_1233.cv_arg") -> "RuleVariation_1233":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1304:
        return self.arg # type: ignore

class NonSpare_616(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1233.cv_arg
    cv_name = "APC"
    cv_title = "Estimated Accuracy Of Track Position (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1233

    @classmethod
    def create(cls, arg : "NonSpare_616.cv_arg") -> "NonSpare_616":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1233:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1304:
        return self.rule.variation

class Content_702(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_702(RuleContentContextFree):
    cv_arg: TypeAlias = Content_702.cv_arg
    cv_content: TypeAlias = Content_702

    @property
    def content(self) -> Content_702:
        return self._get_content() # type: ignore

class Variation_298(Element):
    cv_arg: TypeAlias = RuleContent_702.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_702

    @classmethod
    def create(cls, arg: "Variation_298.cv_arg") -> "Variation_298":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_702:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_702:
        return self.rule.content

class RuleVariation_291(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_298.cv_arg
    cv_variation: TypeAlias = Variation_298

    @classmethod
    def create(cls, arg : "RuleVariation_291.cv_arg") -> "RuleVariation_291":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_298:
        return self.arg # type: ignore

class NonSpare_1148(NonSpare):
    cv_arg: TypeAlias = RuleVariation_291.cv_arg
    cv_name = "LAT"
    cv_title = "APW Latitude Component Accuracy"
    cv_rule: TypeAlias = RuleVariation_291

    @classmethod
    def create(cls, arg : "NonSpare_1148.cv_arg") -> "NonSpare_1148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_291:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_298:
        return self.rule.variation

class Item_460(Item):
    cv_arg: TypeAlias = NonSpare_1148.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1148

    @classmethod
    def create(cls, arg : "Item_460.cv_arg") -> "Item_460":
        return cls._create(arg) # type: ignore

class NonSpare_1177(NonSpare):
    cv_arg: TypeAlias = RuleVariation_291.cv_arg
    cv_name = "LON"
    cv_title = "APW Longitude Component Accuracy"
    cv_rule: TypeAlias = RuleVariation_291

    @classmethod
    def create(cls, arg : "NonSpare_1177.cv_arg") -> "NonSpare_1177":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_291:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_298:
        return self.rule.variation

class Item_487(Item):
    cv_arg: TypeAlias = NonSpare_1177.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1177

    @classmethod
    def create(cls, arg : "Item_487.cv_arg") -> "Item_487":
        return cls._create(arg) # type: ignore

class Variation_1125(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_291.cv_arg, Tuple[Literal["LAT"], RuleVariation_291.cv_arg]], Union[RuleVariation_291.cv_arg, Tuple[Literal["LON"], RuleVariation_291.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1125.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_460, 16), (Item_487, 16)]
    cv_items_dict = {"LAT": RuleVariation_291, "LON": RuleVariation_291}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_291:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_291:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_291:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_291:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1125.cv_arg") -> 'Variation_1125':
        return cls._create(arg) # type: ignore

class RuleVariation_1081(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1125.cv_arg
    cv_variation: TypeAlias = Variation_1125

    @classmethod
    def create(cls, arg : "RuleVariation_1081.cv_arg") -> "RuleVariation_1081":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1125:
        return self.arg # type: ignore

class NonSpare_621(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1081.cv_arg
    cv_name = "APW"
    cv_title = "Estimated Accuracy Of Track Position (WGS84)"
    cv_rule: TypeAlias = RuleVariation_1081

    @classmethod
    def create(cls, arg : "NonSpare_621.cv_arg") -> "NonSpare_621":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1081:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1125:
        return self.rule.variation

class Variation_265(Element):
    cv_arg: TypeAlias = RuleContent_639.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_639

    @classmethod
    def create(cls, arg: "Variation_265.cv_arg") -> "Variation_265":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_639:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_639:
        return self.rule.content

class RuleVariation_258(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_265.cv_arg
    cv_variation: TypeAlias = Variation_265

    @classmethod
    def create(cls, arg : "RuleVariation_258.cv_arg") -> "RuleVariation_258":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_265:
        return self.arg # type: ignore

class NonSpare_641(NonSpare):
    cv_arg: TypeAlias = RuleVariation_258.cv_arg
    cv_name = "ATH"
    cv_title = "Estimated Accuracy Of Track Height"
    cv_rule: TypeAlias = RuleVariation_258

    @classmethod
    def create(cls, arg : "NonSpare_641.cv_arg") -> "NonSpare_641":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_258:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_265:
        return self.rule.variation

class Content_738(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_738(RuleContentContextFree):
    cv_arg: TypeAlias = Content_738.cv_arg
    cv_content: TypeAlias = Content_738

    @property
    def content(self) -> Content_738:
        return self._get_content() # type: ignore

class Variation_228(Element):
    cv_arg: TypeAlias = RuleContent_738.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_738

    @classmethod
    def create(cls, arg: "Variation_228.cv_arg") -> "Variation_228":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_738:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_738:
        return self.rule.content

class RuleVariation_221(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_228.cv_arg
    cv_variation: TypeAlias = Variation_228

    @classmethod
    def create(cls, arg : "RuleVariation_221.cv_arg") -> "RuleVariation_221":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_228:
        return self.arg # type: ignore

class NonSpare_2091(NonSpare):
    cv_arg: TypeAlias = RuleVariation_221.cv_arg
    cv_name = "X"
    cv_title = "Estimated Accuracy of the Calculated Velocity of X Component"
    cv_rule: TypeAlias = RuleVariation_221

    @classmethod
    def create(cls, arg : "NonSpare_2091.cv_arg") -> "NonSpare_2091":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_221:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_228:
        return self.rule.variation

class Item_1192(Item):
    cv_arg: TypeAlias = NonSpare_2091.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2091

    @classmethod
    def create(cls, arg : "Item_1192.cv_arg") -> "Item_1192":
        return cls._create(arg) # type: ignore

class NonSpare_2144(NonSpare):
    cv_arg: TypeAlias = RuleVariation_221.cv_arg
    cv_name = "Y"
    cv_title = "Estimated Accuracy of the Calculated Velocity of Y Component"
    cv_rule: TypeAlias = RuleVariation_221

    @classmethod
    def create(cls, arg : "NonSpare_2144.cv_arg") -> "NonSpare_2144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_221:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_228:
        return self.rule.variation

class Item_1242(Item):
    cv_arg: TypeAlias = NonSpare_2144.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2144

    @classmethod
    def create(cls, arg : "Item_1242.cv_arg") -> "Item_1242":
        return cls._create(arg) # type: ignore

class Variation_1305(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_221.cv_arg, Tuple[Literal["X"], RuleVariation_221.cv_arg]], Union[RuleVariation_221.cv_arg, Tuple[Literal["Y"], RuleVariation_221.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1305.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1192, 8), (Item_1242, 8)]
    cv_items_dict = {"X": RuleVariation_221, "Y": RuleVariation_221}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_221:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_221:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_221:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_221:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1305.cv_arg") -> 'Variation_1305':
        return cls._create(arg) # type: ignore

class RuleVariation_1234(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1305.cv_arg
    cv_variation: TypeAlias = Variation_1305

    @classmethod
    def create(cls, arg : "RuleVariation_1234.cv_arg") -> "RuleVariation_1234":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1305:
        return self.arg # type: ignore

class NonSpare_648(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1234.cv_arg
    cv_name = "AVC"
    cv_title = "Estimated Accuracy Of Track Velocity (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1234

    @classmethod
    def create(cls, arg : "NonSpare_648.cv_arg") -> "NonSpare_648":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1234:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1305:
        return self.rule.variation

class Content_642(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_642(RuleContentContextFree):
    cv_arg: TypeAlias = Content_642.cv_arg
    cv_content: TypeAlias = Content_642

    @property
    def content(self) -> Content_642:
        return self._get_content() # type: ignore

class Variation_266(Element):
    cv_arg: TypeAlias = RuleContent_642.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_642

    @classmethod
    def create(cls, arg: "Variation_266.cv_arg") -> "Variation_266":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_642:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_642:
        return self.rule.content

class RuleVariation_259(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_266.cv_arg
    cv_variation: TypeAlias = Variation_266

    @classmethod
    def create(cls, arg : "RuleVariation_259.cv_arg") -> "RuleVariation_259":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_266:
        return self.arg # type: ignore

class NonSpare_629(NonSpare):
    cv_arg: TypeAlias = RuleVariation_259.cv_arg
    cv_name = "ARC"
    cv_title = "Estimated Accuracy Of Rate Of Climb / Descent"
    cv_rule: TypeAlias = RuleVariation_259

    @classmethod
    def create(cls, arg : "NonSpare_629.cv_arg") -> "NonSpare_629":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_259:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_266:
        return self.rule.variation

class Content_746(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_746(RuleContentContextFree):
    cv_arg: TypeAlias = Content_746.cv_arg
    cv_content: TypeAlias = Content_746

    @property
    def content(self) -> Content_746:
        return self._get_content() # type: ignore

class Variation_230(Element):
    cv_arg: TypeAlias = RuleContent_746.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_746

    @classmethod
    def create(cls, arg: "Variation_230.cv_arg") -> "Variation_230":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_746:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_746:
        return self.rule.content

class RuleVariation_223(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_230.cv_arg
    cv_variation: TypeAlias = Variation_230

    @classmethod
    def create(cls, arg : "RuleVariation_223.cv_arg") -> "RuleVariation_223":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_230:
        return self.arg # type: ignore

class NonSpare_2089(NonSpare):
    cv_arg: TypeAlias = RuleVariation_223.cv_arg
    cv_name = "X"
    cv_title = "Estimated Accuracy Of Acceleration of X Component"
    cv_rule: TypeAlias = RuleVariation_223

    @classmethod
    def create(cls, arg : "NonSpare_2089.cv_arg") -> "NonSpare_2089":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_230:
        return self.rule.variation

class Item_1190(Item):
    cv_arg: TypeAlias = NonSpare_2089.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2089

    @classmethod
    def create(cls, arg : "Item_1190.cv_arg") -> "Item_1190":
        return cls._create(arg) # type: ignore

class NonSpare_2142(NonSpare):
    cv_arg: TypeAlias = RuleVariation_223.cv_arg
    cv_name = "Y"
    cv_title = "Estimated Accuracy Of Acceleration of Y Component"
    cv_rule: TypeAlias = RuleVariation_223

    @classmethod
    def create(cls, arg : "NonSpare_2142.cv_arg") -> "NonSpare_2142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_230:
        return self.rule.variation

class Item_1240(Item):
    cv_arg: TypeAlias = NonSpare_2142.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2142

    @classmethod
    def create(cls, arg : "Item_1240.cv_arg") -> "Item_1240":
        return cls._create(arg) # type: ignore

class Variation_1303(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_223.cv_arg, Tuple[Literal["X"], RuleVariation_223.cv_arg]], Union[RuleVariation_223.cv_arg, Tuple[Literal["Y"], RuleVariation_223.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1303.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1190, 8), (Item_1240, 8)]
    cv_items_dict = {"X": RuleVariation_223, "Y": RuleVariation_223}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_223:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_223:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_223:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1303.cv_arg") -> 'Variation_1303':
        return cls._create(arg) # type: ignore

class RuleVariation_1232(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1303.cv_arg
    cv_variation: TypeAlias = Variation_1303

    @classmethod
    def create(cls, arg : "RuleVariation_1232.cv_arg") -> "RuleVariation_1232":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1303:
        return self.arg # type: ignore

class NonSpare_552(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1232.cv_arg
    cv_name = "AAC"
    cv_title = "Estimated Accuracy Of Acceleration (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1232

    @classmethod
    def create(cls, arg : "NonSpare_552.cv_arg") -> "NonSpare_552":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1232:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1303:
        return self.rule.variation

class Variation_1476(Compound):
    cv_arg = TypedDict('cv_arg', {
        "APC": NonSpare_616.cv_arg,
        "APW": NonSpare_621.cv_arg,
        "ATH": NonSpare_641.cv_arg,
        "AVC": NonSpare_648.cv_arg,
        "ARC": NonSpare_629.cv_arg,
        "AAC": NonSpare_552.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_616, NonSpare_621, NonSpare_641, NonSpare_648, NonSpare_629, NonSpare_552]
    cv_items_dict = {"APC": NonSpare_616, "APW": NonSpare_621, "ATH": NonSpare_641, "AVC": NonSpare_648, "ARC": NonSpare_629, "AAC": NonSpare_552}

    @overload
    @classmethod
    def spec(cls, key : Literal["APC"]) -> NonSpare_616:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["APW"]) -> NonSpare_621:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATH"]) -> NonSpare_641:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVC"]) -> NonSpare_648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> NonSpare_629:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AAC"]) -> NonSpare_552:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["APC"], Literal["APW"], Literal["ATH"], Literal["AVC"], Literal["ARC"], Literal["AAC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["APC"]) -> Optional[NonSpare_616]:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> Optional[NonSpare_621]:
        ...
    @overload
    def get_item(self, key : Literal["ATH"]) -> Optional[NonSpare_641]:
        ...
    @overload
    def get_item(self, key : Literal["AVC"]) -> Optional[NonSpare_648]:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> Optional[NonSpare_629]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[NonSpare_552]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["APC"], val : NonSpare_616.cv_arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["APW"], val : NonSpare_621.cv_arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["ATH"], val : NonSpare_641.cv_arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["AVC"], val : NonSpare_648.cv_arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["ARC"], val : NonSpare_629.cv_arg) -> "Variation_1476":
        ...
    @overload
    def set_item(self, key : Literal["AAC"], val : NonSpare_552.cv_arg) -> "Variation_1476":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["APC"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["APW"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["ATH"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["AVC"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["ARC"]) -> "Variation_1476":
        ...
    @overload
    def del_item(self, key : Literal["AAC"]) -> "Variation_1476":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1476.cv_arg") -> 'Variation_1476':
        return cls._create(arg) # type: ignore

class RuleVariation_1397(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1476.cv_arg
    cv_variation: TypeAlias = Variation_1476

    @classmethod
    def create(cls, arg : "RuleVariation_1397.cv_arg") -> "RuleVariation_1397":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1476:
        return self.arg # type: ignore

class NonSpare_516(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1397.cv_arg
    cv_name = "500"
    cv_title = "Estimated Accuracies"
    cv_rule: TypeAlias = RuleVariation_1397

    @classmethod
    def create(cls, arg : "NonSpare_516.cv_arg") -> "NonSpare_516":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1397:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1476:
        return self.rule.variation

class UapItem_515(UapItem):
    cv_non_spare: TypeAlias = NonSpare_516

class Content_31(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Alert acknowledged", 1: "Alert not acknowledged"}

class RuleContent_31(RuleContentContextFree):
    cv_arg: TypeAlias = Content_31.cv_arg
    cv_content: TypeAlias = Content_31

    @property
    def content(self) -> Content_31:
        return self._get_content() # type: ignore

class Variation_11(Element):
    cv_arg: TypeAlias = RuleContent_31.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_31

    @classmethod
    def create(cls, arg: "Variation_11.cv_arg") -> "Variation_11":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_31:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_31:
        return self.rule.content

class RuleVariation_11(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_11.cv_arg
    cv_variation: TypeAlias = Variation_11

    @classmethod
    def create(cls, arg : "RuleVariation_11.cv_arg") -> "RuleVariation_11":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_11:
        return self.arg # type: ignore

class NonSpare_562(NonSpare):
    cv_arg: TypeAlias = RuleVariation_11.cv_arg
    cv_name = "ACK"
    cv_title = "Alert Acknowleged"
    cv_rule: TypeAlias = RuleVariation_11

    @classmethod
    def create(cls, arg : "NonSpare_562.cv_arg") -> "NonSpare_562":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_11:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_11:
        return self.rule.variation

class Item_42(Item):
    cv_arg: TypeAlias = NonSpare_562.cv_arg
    cv_non_spare: TypeAlias = NonSpare_562

    @classmethod
    def create(cls, arg : "Item_42.cv_arg") -> "Item_42":
        return cls._create(arg) # type: ignore

class Content_207(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "End fo alert", 1: "Pre-alarm", 2: "Severe alert"}

class RuleContent_207(RuleContentContextFree):
    cv_arg: TypeAlias = Content_207.cv_arg
    cv_content: TypeAlias = Content_207

    @property
    def content(self) -> Content_207:
        return self._get_content() # type: ignore

class Variation_468(Element):
    cv_arg: TypeAlias = RuleContent_207.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_207

    @classmethod
    def create(cls, arg: "Variation_468.cv_arg") -> "Variation_468":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_207:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_207:
        return self.rule.content

class RuleVariation_457(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_468.cv_arg
    cv_variation: TypeAlias = Variation_468

    @classmethod
    def create(cls, arg : "RuleVariation_457.cv_arg") -> "RuleVariation_457":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_468:
        return self.arg # type: ignore

class NonSpare_1814(NonSpare):
    cv_arg: TypeAlias = RuleVariation_457.cv_arg
    cv_name = "SVR"
    cv_title = "Alert Severity"
    cv_rule: TypeAlias = RuleVariation_457

    @classmethod
    def create(cls, arg : "NonSpare_1814.cv_arg") -> "NonSpare_1814":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_457:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_468:
        return self.rule.variation

class Item_966(Item):
    cv_arg: TypeAlias = NonSpare_1814.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1814

    @classmethod
    def create(cls, arg : "Item_966.cv_arg") -> "Item_966":
        return cls._create(arg) # type: ignore

class NonSpare_640(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "AT"
    cv_title = "Alert Type"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_640.cv_arg") -> "NonSpare_640":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_88(Item):
    cv_arg: TypeAlias = NonSpare_640.cv_arg
    cv_non_spare: TypeAlias = NonSpare_640

    @classmethod
    def create(cls, arg : "Item_88.cv_arg") -> "Item_88":
        return cls._create(arg) # type: ignore

class NonSpare_609(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "AN"
    cv_title = "Alert Number"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_609.cv_arg") -> "NonSpare_609":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_73(Item):
    cv_arg: TypeAlias = NonSpare_609.cv_arg
    cv_non_spare: TypeAlias = NonSpare_609

    @classmethod
    def create(cls, arg : "Item_73.cv_arg") -> "Item_73":
        return cls._create(arg) # type: ignore

class Variation_1047(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_11.cv_arg, Tuple[Literal["ACK"], RuleVariation_11.cv_arg]], Union[RuleVariation_457.cv_arg, Tuple[Literal["SVR"], RuleVariation_457.cv_arg]], int, Union[RuleVariation_159.cv_arg, Tuple[Literal["AT"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["AN"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1047.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_42, 1), (Item_966, 2), (Item_19, 5), (Item_88, 8), (Item_73, 8)]
    cv_items_dict = {"ACK": RuleVariation_11, "SVR": RuleVariation_457, "AT": RuleVariation_159, "AN": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["ACK"]) -> RuleVariation_11:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SVR"]) -> RuleVariation_457:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AT"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AN"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ACK"], Literal["SVR"], Literal["AT"], Literal["AN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ACK"]) -> RuleVariation_11:
        ...
    @overload
    def get_item(self, key : Literal["SVR"]) -> RuleVariation_457:
        ...
    @overload
    def get_item(self, key : Literal["AT"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["AN"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1047.cv_arg") -> 'Variation_1047':
        return cls._create(arg) # type: ignore

class RuleVariation_1014(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1047.cv_arg
    cv_variation: TypeAlias = Variation_1047

    @classmethod
    def create(cls, arg : "RuleVariation_1014.cv_arg") -> "RuleVariation_1014":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1047:
        return self.arg # type: ignore

class NonSpare_528(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1014.cv_arg
    cv_name = "600"
    cv_title = "Alert Messages"
    cv_rule: TypeAlias = RuleVariation_1014

    @classmethod
    def create(cls, arg : "NonSpare_528.cv_arg") -> "NonSpare_528":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1014:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1047:
        return self.rule.variation

class UapItem_527(UapItem):
    cv_non_spare: TypeAlias = NonSpare_528

class NonSpare_1007(NonSpare):
    cv_arg: TypeAlias = RuleVariation_778.cv_arg
    cv_name = "FTN"
    cv_title = "Fusion Track Number"
    cv_rule: TypeAlias = RuleVariation_778

    @classmethod
    def create(cls, arg : "NonSpare_1007.cv_arg") -> "NonSpare_1007":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

class Item_353(Item):
    cv_arg: TypeAlias = NonSpare_1007.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1007

    @classmethod
    def create(cls, arg : "Item_353.cv_arg") -> "Item_353":
        return cls._create(arg) # type: ignore

class Variation_1022(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_778.cv_arg, Tuple[Literal["FTN"], RuleVariation_778.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1022.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_353, 12)]
    cv_items_dict = {"FTN": RuleVariation_778}

    @classmethod
    def spec(cls, key : Literal["FTN"]) -> RuleVariation_778:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FTN"]) -> RuleVariation_778:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1022.cv_arg") -> 'Variation_1022':
        return cls._create(arg) # type: ignore

class Variation_1407(Repetitive):
    cv_arg: TypeAlias = List[Variation_1022.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1022

    @classmethod
    def create(cls, arg: "Variation_1407.cv_arg") -> 'Variation_1407':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1022]:
        return self._get_list() # type: ignore

class RuleVariation_1328(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1407.cv_arg
    cv_variation: TypeAlias = Variation_1407

    @classmethod
    def create(cls, arg : "RuleVariation_1328.cv_arg") -> "RuleVariation_1328":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1407:
        return self.arg # type: ignore

class NonSpare_536(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1328.cv_arg
    cv_name = "605"
    cv_title = "Tracks in Alert"
    cv_rule: TypeAlias = RuleVariation_1328

    @classmethod
    def create(cls, arg : "NonSpare_536.cv_arg") -> "NonSpare_536":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1328:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1407:
        return self.rule.variation

class UapItem_535(UapItem):
    cv_non_spare: TypeAlias = NonSpare_536

class NonSpare_689(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "BKN"
    cv_title = "Bank Number"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_689.cv_arg") -> "NonSpare_689":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_128(Item):
    cv_arg: TypeAlias = NonSpare_689.cv_arg
    cv_non_spare: TypeAlias = NonSpare_689

    @classmethod
    def create(cls, arg : "Item_128.cv_arg") -> "Item_128":
        return cls._create(arg) # type: ignore

class Content_244(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Indicator on", 1: "Indicator off"}

class RuleContent_244(RuleContentContextFree):
    cv_arg: TypeAlias = Content_244.cv_arg
    cv_content: TypeAlias = Content_244

    @property
    def content(self) -> Content_244:
        return self._get_content() # type: ignore

class Variation_729(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_729.cv_arg") -> "Variation_729":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_718(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_729.cv_arg
    cv_variation: TypeAlias = Variation_729

    @classmethod
    def create(cls, arg : "RuleVariation_718.cv_arg") -> "RuleVariation_718":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_729:
        return self.arg # type: ignore

class NonSpare_1088(NonSpare):
    cv_arg: TypeAlias = RuleVariation_718.cv_arg
    cv_name = "I1"
    cv_title = "Indicator 1"
    cv_rule: TypeAlias = RuleVariation_718

    @classmethod
    def create(cls, arg : "NonSpare_1088.cv_arg") -> "NonSpare_1088":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_718:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_729:
        return self.rule.variation

class Item_410(Item):
    cv_arg: TypeAlias = NonSpare_1088.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1088

    @classmethod
    def create(cls, arg : "Item_410.cv_arg") -> "Item_410":
        return cls._create(arg) # type: ignore

class Variation_857(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_857.cv_arg") -> "Variation_857":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_827(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_857.cv_arg
    cv_variation: TypeAlias = Variation_857

    @classmethod
    def create(cls, arg : "RuleVariation_827.cv_arg") -> "RuleVariation_827":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_857:
        return self.arg # type: ignore

class NonSpare_1092(NonSpare):
    cv_arg: TypeAlias = RuleVariation_827.cv_arg
    cv_name = "I2"
    cv_title = "Indicator 2"
    cv_rule: TypeAlias = RuleVariation_827

    @classmethod
    def create(cls, arg : "NonSpare_1092.cv_arg") -> "NonSpare_1092":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_827:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_857:
        return self.rule.variation

class Item_414(Item):
    cv_arg: TypeAlias = NonSpare_1092.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1092

    @classmethod
    def create(cls, arg : "Item_414.cv_arg") -> "Item_414":
        return cls._create(arg) # type: ignore

class Variation_935(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_935.cv_arg") -> "Variation_935":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_905(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_935.cv_arg
    cv_variation: TypeAlias = Variation_935

    @classmethod
    def create(cls, arg : "RuleVariation_905.cv_arg") -> "RuleVariation_905":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_935:
        return self.arg # type: ignore

class NonSpare_1093(NonSpare):
    cv_arg: TypeAlias = RuleVariation_905.cv_arg
    cv_name = "I3"
    cv_title = "Indicator 3"
    cv_rule: TypeAlias = RuleVariation_905

    @classmethod
    def create(cls, arg : "NonSpare_1093.cv_arg") -> "NonSpare_1093":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_905:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_935:
        return self.rule.variation

class Item_415(Item):
    cv_arg: TypeAlias = NonSpare_1093.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1093

    @classmethod
    def create(cls, arg : "Item_415.cv_arg") -> "Item_415":
        return cls._create(arg) # type: ignore

class Variation_981(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_981.cv_arg") -> "Variation_981":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_951(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_981.cv_arg
    cv_variation: TypeAlias = Variation_981

    @classmethod
    def create(cls, arg : "RuleVariation_951.cv_arg") -> "RuleVariation_951":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_981:
        return self.arg # type: ignore

class NonSpare_1094(NonSpare):
    cv_arg: TypeAlias = RuleVariation_951.cv_arg
    cv_name = "I4"
    cv_title = "Indicator 4"
    cv_rule: TypeAlias = RuleVariation_951

    @classmethod
    def create(cls, arg : "NonSpare_1094.cv_arg") -> "NonSpare_1094":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_951:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_981:
        return self.rule.variation

class Item_416(Item):
    cv_arg: TypeAlias = NonSpare_1094.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1094

    @classmethod
    def create(cls, arg : "Item_416.cv_arg") -> "Item_416":
        return cls._create(arg) # type: ignore

class Variation_50(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_50.cv_arg") -> "Variation_50":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_50(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_50.cv_arg
    cv_variation: TypeAlias = Variation_50

    @classmethod
    def create(cls, arg : "RuleVariation_50.cv_arg") -> "RuleVariation_50":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_50:
        return self.arg # type: ignore

class NonSpare_1095(NonSpare):
    cv_arg: TypeAlias = RuleVariation_50.cv_arg
    cv_name = "I5"
    cv_title = "Indicator 5"
    cv_rule: TypeAlias = RuleVariation_50

    @classmethod
    def create(cls, arg : "NonSpare_1095.cv_arg") -> "NonSpare_1095":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_50:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_50:
        return self.rule.variation

class Item_417(Item):
    cv_arg: TypeAlias = NonSpare_1095.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1095

    @classmethod
    def create(cls, arg : "Item_417.cv_arg") -> "Item_417":
        return cls._create(arg) # type: ignore

class Variation_433(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_433.cv_arg") -> "Variation_433":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_422(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_433.cv_arg
    cv_variation: TypeAlias = Variation_433

    @classmethod
    def create(cls, arg : "RuleVariation_422.cv_arg") -> "RuleVariation_422":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_433:
        return self.arg # type: ignore

class NonSpare_1096(NonSpare):
    cv_arg: TypeAlias = RuleVariation_422.cv_arg
    cv_name = "I6"
    cv_title = "Indicator 6"
    cv_rule: TypeAlias = RuleVariation_422

    @classmethod
    def create(cls, arg : "NonSpare_1096.cv_arg") -> "NonSpare_1096":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_422:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_433:
        return self.rule.variation

class Item_418(Item):
    cv_arg: TypeAlias = NonSpare_1096.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1096

    @classmethod
    def create(cls, arg : "Item_418.cv_arg") -> "Item_418":
        return cls._create(arg) # type: ignore

class Variation_540(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_540.cv_arg") -> "Variation_540":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_529(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_540.cv_arg
    cv_variation: TypeAlias = Variation_540

    @classmethod
    def create(cls, arg : "RuleVariation_529.cv_arg") -> "RuleVariation_529":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_540:
        return self.arg # type: ignore

class NonSpare_1097(NonSpare):
    cv_arg: TypeAlias = RuleVariation_529.cv_arg
    cv_name = "I7"
    cv_title = "Indicator 7"
    cv_rule: TypeAlias = RuleVariation_529

    @classmethod
    def create(cls, arg : "NonSpare_1097.cv_arg") -> "NonSpare_1097":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_529:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_540:
        return self.rule.variation

class Item_419(Item):
    cv_arg: TypeAlias = NonSpare_1097.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1097

    @classmethod
    def create(cls, arg : "Item_419.cv_arg") -> "Item_419":
        return cls._create(arg) # type: ignore

class Variation_645(Element):
    cv_arg: TypeAlias = RuleContent_244.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_244

    @classmethod
    def create(cls, arg: "Variation_645.cv_arg") -> "Variation_645":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_244:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_244:
        return self.rule.content

class RuleVariation_634(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_645.cv_arg
    cv_variation: TypeAlias = Variation_645

    @classmethod
    def create(cls, arg : "RuleVariation_634.cv_arg") -> "RuleVariation_634":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_645:
        return self.arg # type: ignore

class NonSpare_1098(NonSpare):
    cv_arg: TypeAlias = RuleVariation_634.cv_arg
    cv_name = "I8"
    cv_title = "Indicator 8"
    cv_rule: TypeAlias = RuleVariation_634

    @classmethod
    def create(cls, arg : "NonSpare_1098.cv_arg") -> "NonSpare_1098":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_634:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_645:
        return self.rule.variation

class Item_420(Item):
    cv_arg: TypeAlias = NonSpare_1098.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1098

    @classmethod
    def create(cls, arg : "Item_420.cv_arg") -> "Item_420":
        return cls._create(arg) # type: ignore

class NonSpare_1099(NonSpare):
    cv_arg: TypeAlias = RuleVariation_718.cv_arg
    cv_name = "I9"
    cv_title = "Indicator 9"
    cv_rule: TypeAlias = RuleVariation_718

    @classmethod
    def create(cls, arg : "NonSpare_1099.cv_arg") -> "NonSpare_1099":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_718:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_729:
        return self.rule.variation

class Item_421(Item):
    cv_arg: TypeAlias = NonSpare_1099.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1099

    @classmethod
    def create(cls, arg : "Item_421.cv_arg") -> "Item_421":
        return cls._create(arg) # type: ignore

class NonSpare_1089(NonSpare):
    cv_arg: TypeAlias = RuleVariation_827.cv_arg
    cv_name = "I10"
    cv_title = "Indicator 10"
    cv_rule: TypeAlias = RuleVariation_827

    @classmethod
    def create(cls, arg : "NonSpare_1089.cv_arg") -> "NonSpare_1089":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_827:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_857:
        return self.rule.variation

class Item_411(Item):
    cv_arg: TypeAlias = NonSpare_1089.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1089

    @classmethod
    def create(cls, arg : "Item_411.cv_arg") -> "Item_411":
        return cls._create(arg) # type: ignore

class NonSpare_1090(NonSpare):
    cv_arg: TypeAlias = RuleVariation_905.cv_arg
    cv_name = "I11"
    cv_title = "Indicator 11"
    cv_rule: TypeAlias = RuleVariation_905

    @classmethod
    def create(cls, arg : "NonSpare_1090.cv_arg") -> "NonSpare_1090":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_905:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_935:
        return self.rule.variation

class Item_412(Item):
    cv_arg: TypeAlias = NonSpare_1090.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1090

    @classmethod
    def create(cls, arg : "Item_412.cv_arg") -> "Item_412":
        return cls._create(arg) # type: ignore

class NonSpare_1091(NonSpare):
    cv_arg: TypeAlias = RuleVariation_951.cv_arg
    cv_name = "I12"
    cv_title = "Indicator 12"
    cv_rule: TypeAlias = RuleVariation_951

    @classmethod
    def create(cls, arg : "NonSpare_1091.cv_arg") -> "NonSpare_1091":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_951:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_981:
        return self.rule.variation

class Item_413(Item):
    cv_arg: TypeAlias = NonSpare_1091.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1091

    @classmethod
    def create(cls, arg : "Item_413.cv_arg") -> "Item_413":
        return cls._create(arg) # type: ignore

class Variation_1061(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["BKN"], RuleVariation_132.cv_arg]], Union[RuleVariation_718.cv_arg, Tuple[Literal["I1"], RuleVariation_718.cv_arg]], Union[RuleVariation_827.cv_arg, Tuple[Literal["I2"], RuleVariation_827.cv_arg]], Union[RuleVariation_905.cv_arg, Tuple[Literal["I3"], RuleVariation_905.cv_arg]], Union[RuleVariation_951.cv_arg, Tuple[Literal["I4"], RuleVariation_951.cv_arg]], Union[RuleVariation_50.cv_arg, Tuple[Literal["I5"], RuleVariation_50.cv_arg]], Union[RuleVariation_422.cv_arg, Tuple[Literal["I6"], RuleVariation_422.cv_arg]], Union[RuleVariation_529.cv_arg, Tuple[Literal["I7"], RuleVariation_529.cv_arg]], Union[RuleVariation_634.cv_arg, Tuple[Literal["I8"], RuleVariation_634.cv_arg]], Union[RuleVariation_718.cv_arg, Tuple[Literal["I9"], RuleVariation_718.cv_arg]], Union[RuleVariation_827.cv_arg, Tuple[Literal["I10"], RuleVariation_827.cv_arg]], Union[RuleVariation_905.cv_arg, Tuple[Literal["I11"], RuleVariation_905.cv_arg]], Union[RuleVariation_951.cv_arg, Tuple[Literal["I12"], RuleVariation_951.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1061.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_128, 4), (Item_410, 1), (Item_414, 1), (Item_415, 1), (Item_416, 1), (Item_417, 1), (Item_418, 1), (Item_419, 1), (Item_420, 1), (Item_421, 1), (Item_411, 1), (Item_412, 1), (Item_413, 1)]
    cv_items_dict = {"BKN": RuleVariation_132, "I1": RuleVariation_718, "I2": RuleVariation_827, "I3": RuleVariation_905, "I4": RuleVariation_951, "I5": RuleVariation_50, "I6": RuleVariation_422, "I7": RuleVariation_529, "I8": RuleVariation_634, "I9": RuleVariation_718, "I10": RuleVariation_827, "I11": RuleVariation_905, "I12": RuleVariation_951}

    @overload
    @classmethod
    def spec(cls, key : Literal["BKN"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I1"]) -> RuleVariation_718:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I2"]) -> RuleVariation_827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I3"]) -> RuleVariation_905:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I4"]) -> RuleVariation_951:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I5"]) -> RuleVariation_50:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I6"]) -> RuleVariation_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I7"]) -> RuleVariation_529:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I8"]) -> RuleVariation_634:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I9"]) -> RuleVariation_718:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I10"]) -> RuleVariation_827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I11"]) -> RuleVariation_905:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["I12"]) -> RuleVariation_951:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BKN"], Literal["I1"], Literal["I2"], Literal["I3"], Literal["I4"], Literal["I5"], Literal["I6"], Literal["I7"], Literal["I8"], Literal["I9"], Literal["I10"], Literal["I11"], Literal["I12"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BKN"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["I1"]) -> RuleVariation_718:
        ...
    @overload
    def get_item(self, key : Literal["I2"]) -> RuleVariation_827:
        ...
    @overload
    def get_item(self, key : Literal["I3"]) -> RuleVariation_905:
        ...
    @overload
    def get_item(self, key : Literal["I4"]) -> RuleVariation_951:
        ...
    @overload
    def get_item(self, key : Literal["I5"]) -> RuleVariation_50:
        ...
    @overload
    def get_item(self, key : Literal["I6"]) -> RuleVariation_422:
        ...
    @overload
    def get_item(self, key : Literal["I7"]) -> RuleVariation_529:
        ...
    @overload
    def get_item(self, key : Literal["I8"]) -> RuleVariation_634:
        ...
    @overload
    def get_item(self, key : Literal["I9"]) -> RuleVariation_718:
        ...
    @overload
    def get_item(self, key : Literal["I10"]) -> RuleVariation_827:
        ...
    @overload
    def get_item(self, key : Literal["I11"]) -> RuleVariation_905:
        ...
    @overload
    def get_item(self, key : Literal["I12"]) -> RuleVariation_951:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1061.cv_arg") -> 'Variation_1061':
        return cls._create(arg) # type: ignore

class Variation_1412(Repetitive):
    cv_arg: TypeAlias = List[Variation_1061.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1061

    @classmethod
    def create(cls, arg: "Variation_1412.cv_arg") -> 'Variation_1412':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1061]:
        return self._get_list() # type: ignore

class RuleVariation_1333(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1412.cv_arg
    cv_variation: TypeAlias = Variation_1412

    @classmethod
    def create(cls, arg : "RuleVariation_1333.cv_arg") -> "RuleVariation_1333":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1412:
        return self.arg # type: ignore

class NonSpare_540(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1333.cv_arg
    cv_name = "610"
    cv_title = "Holdbar Status"
    cv_rule: TypeAlias = RuleVariation_1333

    @classmethod
    def create(cls, arg : "NonSpare_540.cv_arg") -> "NonSpare_540":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1412:
        return self.rule.variation

class UapItem_539(UapItem):
    cv_non_spare: TypeAlias = NonSpare_540

class Record_48(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_48.cv_arg,
        "000": NonSpare_14.cv_arg,
        "015": NonSpare_62.cv_arg,
        "140": NonSpare_336.cv_arg,
        "041": NonSpare_156.cv_arg,
        "042": NonSpare_158.cv_arg,
        "202": NonSpare_406.cv_arg,
        "210": NonSpare_408.cv_arg,
        "060": NonSpare_191.cv_arg,
        "245": NonSpare_442.cv_arg,
        "380": NonSpare_489.cv_arg,
        "161": NonSpare_361.cv_arg,
        "170": NonSpare_379.cv_arg,
        "290": NonSpare_468.cv_arg,
        "430": NonSpare_506.cv_arg,
        "090": NonSpare_252.cv_arg,
        "093": NonSpare_265.cv_arg,
        "092": NonSpare_262.cv_arg,
        "215": NonSpare_418.cv_arg,
        "270": NonSpare_464.cv_arg,
        "390": NonSpare_492.cv_arg,
        "300": NonSpare_476.cv_arg,
        "310": NonSpare_480.cv_arg,
        "500": NonSpare_516.cv_arg,
        "600": NonSpare_528.cv_arg,
        "605": NonSpare_536.cv_arg,
        "610": NonSpare_540.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_48, UapItem_14, UapItem_62, UapItem_336, UapItem_156, UapItem_158, UapItem_406, UapItem_408, UapItem_191, UapItem_442, UapItem_489, UapItem_361, UapItem_379, UapItem_468, UapItem_505, UapItem_252, UapItem_265, UapItem_262, UapItem_418, UapItem_464, UapItem_492, UapItem_476, UapItem_480, UapItem_515, UapItem_527, UapItem_535, UapItem_539, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_48, "000": NonSpare_14, "015": NonSpare_62, "140": NonSpare_336, "041": NonSpare_156, "042": NonSpare_158, "202": NonSpare_406, "210": NonSpare_408, "060": NonSpare_191, "245": NonSpare_442, "380": NonSpare_489, "161": NonSpare_361, "170": NonSpare_379, "290": NonSpare_468, "430": NonSpare_506, "090": NonSpare_252, "093": NonSpare_265, "092": NonSpare_262, "215": NonSpare_418, "270": NonSpare_464, "390": NonSpare_492, "300": NonSpare_476, "310": NonSpare_480, "500": NonSpare_516, "600": NonSpare_528, "605": NonSpare_536, "610": NonSpare_540, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_48:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_14:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_62:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_156:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_406:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_408:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_191:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_489:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_361:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_379:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["430"]) -> NonSpare_506:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["093"]) -> NonSpare_265:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["092"]) -> NonSpare_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["215"]) -> NonSpare_418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_464:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_492:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_476:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_480:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_516:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_528:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["605"]) -> NonSpare_536:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_540:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["140"], Literal["041"], Literal["042"], Literal["202"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["161"], Literal["170"], Literal["290"], Literal["430"], Literal["090"], Literal["093"], Literal["092"], Literal["215"], Literal["270"], Literal["390"], Literal["300"], Literal["310"], Literal["500"], Literal["600"], Literal["605"], Literal["610"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_48]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_14]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_62]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_336]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_156]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_406]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_408]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_191]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_489]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_361]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_379]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_468]:
        ...
    @overload
    def get_item(self, key : Literal["430"]) -> Optional[NonSpare_506]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_252]:
        ...
    @overload
    def get_item(self, key : Literal["093"]) -> Optional[NonSpare_265]:
        ...
    @overload
    def get_item(self, key : Literal["092"]) -> Optional[NonSpare_262]:
        ...
    @overload
    def get_item(self, key : Literal["215"]) -> Optional[NonSpare_418]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_464]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_492]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_476]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_480]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_516]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_528]:
        ...
    @overload
    def get_item(self, key : Literal["605"]) -> Optional[NonSpare_536]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_540]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_48.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_14.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_62.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_336.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_156.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_406.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_408.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_191.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_442.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_489.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_361.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_379.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_468.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["430"], val : NonSpare_506.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_252.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["093"], val : NonSpare_265.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["092"], val : NonSpare_262.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["215"], val : NonSpare_418.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_464.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_492.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_476.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_480.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_516.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_528.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["605"], val : NonSpare_536.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_540.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_48':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_48':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["430"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["093"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["092"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["215"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["605"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_48':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_48':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_48.cv_arg") -> 'Record_48':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_48", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_44(UapSingle):
    cv_arg: TypeAlias = Record_48
    cv_record: TypeAlias = Record_48

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_48]]:
        return cls._parse(bs)

class Asterix_12(AstCat):
    cv_category = 11
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_44
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_44.cv_arg]) -> "Asterix_12":
        return cls._create(records) # type: ignore

class NonSpare_335(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Track Information"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_335.cv_arg") -> "NonSpare_335":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_335(UapItem):
    cv_non_spare: TypeAlias = NonSpare_335

class NonSpare_190(NonSpare):
    cv_arg: TypeAlias = RuleVariation_993.cv_arg
    cv_name = "060"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_993

    @classmethod
    def create(cls, arg : "NonSpare_190.cv_arg") -> "NonSpare_190":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_993:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1024:
        return self.rule.variation

class UapItem_190(UapItem):
    cv_non_spare: TypeAlias = NonSpare_190

class Content_321(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "General Emergency", 7: "Lifeguard / medical", 8: "Minimum fuel", 9: "No communications", 10: "Unlawful interference"}

class RuleContent_321(RuleContentContextFree):
    cv_arg: TypeAlias = Content_321.cv_arg
    cv_content: TypeAlias = Content_321

    @property
    def content(self) -> Content_321:
        return self._get_content() # type: ignore

class Variation_693(Element):
    cv_arg: TypeAlias = RuleContent_321.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_321

    @classmethod
    def create(cls, arg: "Variation_693.cv_arg") -> "Variation_693":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_321:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_321:
        return self.rule.content

class RuleVariation_682(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_693.cv_arg
    cv_variation: TypeAlias = Variation_693

    @classmethod
    def create(cls, arg : "RuleVariation_682.cv_arg") -> "RuleVariation_682":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_693:
        return self.arg # type: ignore

class NonSpare_1780(NonSpare):
    cv_arg: TypeAlias = RuleVariation_682.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_682

    @classmethod
    def create(cls, arg : "NonSpare_1780.cv_arg") -> "NonSpare_1780":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_682:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_693:
        return self.rule.variation

class Item_941(Item):
    cv_arg: TypeAlias = NonSpare_1780.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1780

    @classmethod
    def create(cls, arg : "Item_941.cv_arg") -> "Item_941":
        return cls._create(arg) # type: ignore

class Variation_1080(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_124.cv_arg, Tuple[Literal["COM"], RuleVariation_124.cv_arg]], Union[RuleVariation_682.cv_arg, Tuple[Literal["STAT"], RuleVariation_682.cv_arg]], int, Union[RuleVariation_56.cv_arg, Tuple[Literal["SSC"], RuleVariation_56.cv_arg]], Union[RuleVariation_390.cv_arg, Tuple[Literal["ARC"], RuleVariation_390.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["AIC"], RuleVariation_547.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["B1A"], RuleVariation_603.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["B1B"], RuleVariation_769.cv_arg]], Union[RuleVariation_56.cv_arg, Tuple[Literal["AC"], RuleVariation_56.cv_arg]], Union[RuleVariation_428.cv_arg, Tuple[Literal["MN"], RuleVariation_428.cv_arg]], Union[RuleVariation_574.cv_arg, Tuple[Literal["DC"], RuleVariation_574.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1080.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_188, 3), (Item_941, 4), (Item_29, 1), (Item_926, 1), (Item_81, 1), (Item_55, 1), (Item_109, 1), (Item_110, 4), (Item_37, 1), (Item_562, 1), (Item_250, 1), (Item_19, 5)]
    cv_items_dict = {"COM": RuleVariation_124, "STAT": RuleVariation_682, "SSC": RuleVariation_56, "ARC": RuleVariation_390, "AIC": RuleVariation_547, "B1A": RuleVariation_603, "B1B": RuleVariation_769, "AC": RuleVariation_56, "MN": RuleVariation_428, "DC": RuleVariation_574}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_682:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_574:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"], Literal["AC"], Literal["MN"], Literal["DC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_682:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_428:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_574:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1080.cv_arg") -> 'Variation_1080':
        return cls._create(arg) # type: ignore

class RuleVariation_1040(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1080.cv_arg
    cv_variation: TypeAlias = Variation_1080

    @classmethod
    def create(cls, arg : "RuleVariation_1040.cv_arg") -> "RuleVariation_1040":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1080:
        return self.arg # type: ignore

class NonSpare_790(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1040.cv_arg
    cv_name = "COMACAS"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1040

    @classmethod
    def create(cls, arg : "NonSpare_790.cv_arg") -> "NonSpare_790":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1040:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1080:
        return self.rule.variation

class Variation_1495(Compound):
    cv_arg = TypedDict('cv_arg', {
        "MB": NonSpare_1231.cv_arg,
        "ADR": NonSpare_571.cv_arg,
        "COMACAS": NonSpare_790.cv_arg,
        "ACT": NonSpare_566.cv_arg,
        "ECAT": NonSpare_919.cv_arg,
        "AVTECH": NonSpare_654.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1231, NonSpare_571, None, NonSpare_790, None, None, None, NonSpare_566, NonSpare_919, None, NonSpare_654]
    cv_items_dict = {"MB": NonSpare_1231, "ADR": NonSpare_571, "COMACAS": NonSpare_790, "ACT": NonSpare_566, "ECAT": NonSpare_919, "AVTECH": NonSpare_654}

    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_571:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COMACAS"]) -> NonSpare_790:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACT"]) -> NonSpare_566:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ECAT"]) -> NonSpare_919:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVTECH"]) -> NonSpare_654:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MB"], Literal["ADR"], Literal["COMACAS"], Literal["ACT"], Literal["ECAT"], Literal["AVTECH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1231]:
        ...
    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_571]:
        ...
    @overload
    def get_item(self, key : Literal["COMACAS"]) -> Optional[NonSpare_790]:
        ...
    @overload
    def get_item(self, key : Literal["ACT"]) -> Optional[NonSpare_566]:
        ...
    @overload
    def get_item(self, key : Literal["ECAT"]) -> Optional[NonSpare_919]:
        ...
    @overload
    def get_item(self, key : Literal["AVTECH"]) -> Optional[NonSpare_654]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1231.cv_arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_571.cv_arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["COMACAS"], val : NonSpare_790.cv_arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["ACT"], val : NonSpare_566.cv_arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["ECAT"], val : NonSpare_919.cv_arg) -> "Variation_1495":
        ...
    @overload
    def set_item(self, key : Literal["AVTECH"], val : NonSpare_654.cv_arg) -> "Variation_1495":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["COMACAS"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["ACT"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["ECAT"]) -> "Variation_1495":
        ...
    @overload
    def del_item(self, key : Literal["AVTECH"]) -> "Variation_1495":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1495.cv_arg") -> 'Variation_1495':
        return cls._create(arg) # type: ignore

class RuleVariation_1416(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1495.cv_arg
    cv_variation: TypeAlias = Variation_1495

    @classmethod
    def create(cls, arg : "RuleVariation_1416.cv_arg") -> "RuleVariation_1416":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1495:
        return self.arg # type: ignore

class NonSpare_490(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1416.cv_arg
    cv_name = "380"
    cv_title = "Mode-S / ADS-B Related Data"
    cv_rule: TypeAlias = RuleVariation_1416

    @classmethod
    def create(cls, arg : "NonSpare_490.cv_arg") -> "NonSpare_490":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1416:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1495:
        return self.rule.variation

class UapItem_490(UapItem):
    cv_non_spare: TypeAlias = NonSpare_490

class Content_177(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received PSR track update is higher than system dependent threshold"}

class RuleContent_177(RuleContentContextFree):
    cv_arg: TypeAlias = Content_177.cv_arg
    cv_content: TypeAlias = Content_177

    @property
    def content(self) -> Content_177:
        return self._get_content() # type: ignore

class Variation_420(Element):
    cv_arg: TypeAlias = RuleContent_177.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_177

    @classmethod
    def create(cls, arg: "Variation_420.cv_arg") -> "Variation_420":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_177:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_177:
        return self.rule.content

class RuleVariation_409(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_420.cv_arg
    cv_variation: TypeAlias = Variation_420

    @classmethod
    def create(cls, arg : "RuleVariation_409.cv_arg") -> "RuleVariation_409":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_420:
        return self.arg # type: ignore

class Content_178(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received SSR track update is higher than system dependent threshold"}

class RuleContent_178(RuleContentContextFree):
    cv_arg: TypeAlias = Content_178.cv_arg
    cv_content: TypeAlias = Content_178

    @property
    def content(self) -> Content_178:
        return self._get_content() # type: ignore

class Variation_528(Element):
    cv_arg: TypeAlias = RuleContent_178.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_178

    @classmethod
    def create(cls, arg: "Variation_528.cv_arg") -> "Variation_528":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_178:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_178:
        return self.rule.content

class RuleVariation_517(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_528.cv_arg
    cv_variation: TypeAlias = Variation_528

    @classmethod
    def create(cls, arg : "RuleVariation_517.cv_arg") -> "RuleVariation_517":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_528:
        return self.arg # type: ignore

class Content_176(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received Mode S track update is higher than system dependent threshold"}

class RuleContent_176(RuleContentContextFree):
    cv_arg: TypeAlias = Content_176.cv_arg
    cv_content: TypeAlias = Content_176

    @property
    def content(self) -> Content_176:
        return self._get_content() # type: ignore

class Variation_635(Element):
    cv_arg: TypeAlias = RuleContent_176.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_176

    @classmethod
    def create(cls, arg: "Variation_635.cv_arg") -> "Variation_635":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_176:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_176:
        return self.rule.content

class RuleVariation_624(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_635.cv_arg
    cv_variation: TypeAlias = Variation_635

    @classmethod
    def create(cls, arg : "RuleVariation_624.cv_arg") -> "RuleVariation_624":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_635:
        return self.arg # type: ignore

class Content_173(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received ADS track update is higher than system dependent threshold"}

class RuleContent_173(RuleContentContextFree):
    cv_arg: TypeAlias = Content_173.cv_arg
    cv_content: TypeAlias = Content_173

    @property
    def content(self) -> Content_173:
        return self._get_content() # type: ignore

class Variation_717(Element):
    cv_arg: TypeAlias = RuleContent_173.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_173

    @classmethod
    def create(cls, arg: "Variation_717.cv_arg") -> "Variation_717":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_173:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_173:
        return self.rule.content

class RuleVariation_706(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_717.cv_arg
    cv_variation: TypeAlias = Variation_717

    @classmethod
    def create(cls, arg : "RuleVariation_706.cv_arg") -> "RuleVariation_706":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_717:
        return self.arg # type: ignore

class Content_192(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Special Used Code (Mode A codes to be defined in the system to mark a track with special interest)"}

class RuleContent_192(RuleContentContextFree):
    cv_arg: TypeAlias = Content_192.cv_arg
    cv_content: TypeAlias = Content_192

    @property
    def content(self) -> Content_192:
        return self._get_content() # type: ignore

class Variation_847(Element):
    cv_arg: TypeAlias = RuleContent_192.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_192

    @classmethod
    def create(cls, arg: "Variation_847.cv_arg") -> "Variation_847":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_192:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_192:
        return self.rule.content

class RuleVariation_817(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_847.cv_arg
    cv_variation: TypeAlias = Variation_847

    @classmethod
    def create(cls, arg : "RuleVariation_817.cv_arg") -> "RuleVariation_817":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_847:
        return self.arg # type: ignore

class Content_181(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Assigned Mode A Code Conflict (same individual Mode A Code assigned to another track)"}

class RuleContent_181(RuleContentContextFree):
    cv_arg: TypeAlias = Content_181.cv_arg
    cv_content: TypeAlias = Content_181

    @property
    def content(self) -> Content_181:
        return self._get_content() # type: ignore

class Variation_924(Element):
    cv_arg: TypeAlias = RuleContent_181.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_181

    @classmethod
    def create(cls, arg: "Variation_924.cv_arg") -> "Variation_924":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_181:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_181:
        return self.rule.content

class RuleVariation_894(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_924.cv_arg
    cv_variation: TypeAlias = Variation_924

    @classmethod
    def create(cls, arg : "RuleVariation_894.cv_arg") -> "RuleVariation_894":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_924:
        return self.arg # type: ignore

class NonSpare_1472(NonSpare):
    cv_arg: TypeAlias = RuleVariation_409.cv_arg
    cv_name = "PSR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_409

    @classmethod
    def create(cls, arg : "NonSpare_1472.cv_arg") -> "NonSpare_1472":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_409:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_420:
        return self.rule.variation

class Item_713(Item):
    cv_arg: TypeAlias = NonSpare_1472.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1472

    @classmethod
    def create(cls, arg : "Item_713.cv_arg") -> "Item_713":
        return cls._create(arg) # type: ignore

class NonSpare_1758(NonSpare):
    cv_arg: TypeAlias = RuleVariation_517.cv_arg
    cv_name = "SSR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_517

    @classmethod
    def create(cls, arg : "NonSpare_1758.cv_arg") -> "NonSpare_1758":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_517:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_528:
        return self.rule.variation

class Item_928(Item):
    cv_arg: TypeAlias = NonSpare_1758.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1758

    @classmethod
    def create(cls, arg : "Item_928.cv_arg") -> "Item_928":
        return cls._create(arg) # type: ignore

class NonSpare_1256(NonSpare):
    cv_arg: TypeAlias = RuleVariation_624.cv_arg
    cv_name = "MDS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_624

    @classmethod
    def create(cls, arg : "NonSpare_1256.cv_arg") -> "NonSpare_1256":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_624:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_635:
        return self.rule.variation

class Item_539(Item):
    cv_arg: TypeAlias = NonSpare_1256.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1256

    @classmethod
    def create(cls, arg : "Item_539.cv_arg") -> "Item_539":
        return cls._create(arg) # type: ignore

class NonSpare_573(NonSpare):
    cv_arg: TypeAlias = RuleVariation_706.cv_arg
    cv_name = "ADS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_706

    @classmethod
    def create(cls, arg : "NonSpare_573.cv_arg") -> "NonSpare_573":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_706:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_717:
        return self.rule.variation

class Item_45(Item):
    cv_arg: TypeAlias = NonSpare_573.cv_arg
    cv_non_spare: TypeAlias = NonSpare_573

    @classmethod
    def create(cls, arg : "Item_45.cv_arg") -> "Item_45":
        return cls._create(arg) # type: ignore

class NonSpare_1806(NonSpare):
    cv_arg: TypeAlias = RuleVariation_817.cv_arg
    cv_name = "SUC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_817

    @classmethod
    def create(cls, arg : "NonSpare_1806.cv_arg") -> "NonSpare_1806":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_817:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_847:
        return self.rule.variation

class Item_962(Item):
    cv_arg: TypeAlias = NonSpare_1806.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1806

    @classmethod
    def create(cls, arg : "Item_962.cv_arg") -> "Item_962":
        return cls._create(arg) # type: ignore

class NonSpare_551(NonSpare):
    cv_arg: TypeAlias = RuleVariation_894.cv_arg
    cv_name = "AAC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_894

    @classmethod
    def create(cls, arg : "NonSpare_551.cv_arg") -> "NonSpare_551":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_894:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_924:
        return self.rule.variation

class Item_35(Item):
    cv_arg: TypeAlias = NonSpare_551.cv_arg
    cv_non_spare: TypeAlias = NonSpare_551

    @classmethod
    def create(cls, arg : "Item_35.cv_arg") -> "Item_35":
        return cls._create(arg) # type: ignore

class Variation_1367(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_54.cv_arg, Tuple[Literal["MON"], RuleVariation_54.cv_arg]], Union[RuleVariation_450.cv_arg, Tuple[Literal["GBS"], RuleVariation_450.cv_arg]], Union[RuleVariation_500.cv_arg, Tuple[Literal["MRH"], RuleVariation_500.cv_arg]], Union[RuleVariation_679.cv_arg, Tuple[Literal["SRC"], RuleVariation_679.cv_arg]], Union[RuleVariation_877.cv_arg, Tuple[Literal["CNF"], RuleVariation_877.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_4.cv_arg, Tuple[Literal["SIM"], RuleVariation_4.cv_arg]], Union[RuleVariation_413.cv_arg, Tuple[Literal["TSE"], RuleVariation_413.cv_arg]], Union[RuleVariation_521.cv_arg, Tuple[Literal["TSB"], RuleVariation_521.cv_arg]], Union[RuleVariation_668.cv_arg, Tuple[Literal["FRIFOE"], RuleVariation_668.cv_arg]], Union[RuleVariation_815.cv_arg, Tuple[Literal["ME"], RuleVariation_815.cv_arg]], Union[RuleVariation_896.cv_arg, Tuple[Literal["MI"], RuleVariation_896.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_90.cv_arg, Tuple[Literal["AMA"], RuleVariation_90.cv_arg]], Union[RuleVariation_412.cv_arg, Tuple[Literal["SPI"], RuleVariation_412.cv_arg]], Union[RuleVariation_518.cv_arg, Tuple[Literal["CST"], RuleVariation_518.cv_arg]], Union[RuleVariation_647.cv_arg, Tuple[Literal["FPC"], RuleVariation_647.cv_arg]], Union[RuleVariation_705.cv_arg, Tuple[Literal["AFF"], RuleVariation_705.cv_arg]], int, None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_409.cv_arg, Tuple[Literal["PSR"], RuleVariation_409.cv_arg]], Union[RuleVariation_517.cv_arg, Tuple[Literal["SSR"], RuleVariation_517.cv_arg]], Union[RuleVariation_624.cv_arg, Tuple[Literal["MDS"], RuleVariation_624.cv_arg]], Union[RuleVariation_706.cv_arg, Tuple[Literal["ADS"], RuleVariation_706.cv_arg]], Union[RuleVariation_817.cv_arg, Tuple[Literal["SUC"], RuleVariation_817.cv_arg]], Union[RuleVariation_894.cv_arg, Tuple[Literal["AAC"], RuleVariation_894.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1367.cv_arg_group_1"],
        Tuple["Variation_1367.cv_arg_group_1", "Variation_1367.cv_arg_group_2"],
        Tuple["Variation_1367.cv_arg_group_1", "Variation_1367.cv_arg_group_2", "Variation_1367.cv_arg_group_3"],
        Tuple["Variation_1367.cv_arg_group_1", "Variation_1367.cv_arg_group_2", "Variation_1367.cv_arg_group_3", "Variation_1367.cv_arg_group_4"],
    ]
    cv_items_list = [[(Item_578, 1), (Item_365, 1), (Item_581, 1), (Item_921, 3), (Item_167, 1), None], [(Item_897, 1), (Item_1047, 1), (Item_1045, 1), (Item_345, 2), (Item_546, 1), (Item_553, 1), None], [(Item_71, 1), (Item_911, 1), (Item_222, 1), (Item_338, 1), (Item_50, 1), (Item_24, 2), None], [(Item_0, 1), (Item_713, 1), (Item_928, 1), (Item_539, 1), (Item_45, 1), (Item_962, 1), (Item_35, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1367.cv_arg") -> 'Variation_1367':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_54:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_450:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_500:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_679:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_877:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_4]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_413]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_521]:
        ...
    @overload
    def get_item(self, key : Literal["FRIFOE"]) -> Optional[RuleVariation_668]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_815]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_896]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_90]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_412]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_518]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_647]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_624]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_706]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_817]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_894]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1288(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1367.cv_arg
    cv_variation: TypeAlias = Variation_1367

    @classmethod
    def create(cls, arg : "RuleVariation_1288.cv_arg") -> "RuleVariation_1288":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1367:
        return self.arg # type: ignore

class NonSpare_380(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1288.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1288

    @classmethod
    def create(cls, arg : "NonSpare_380.cv_arg") -> "NonSpare_380":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1367:
        return self.rule.variation

class UapItem_380(UapItem):
    cv_non_spare: TypeAlias = NonSpare_380

class NonSpare_1475(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "PSR"
    cv_title = "Age of the Last Primary Report Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1475.cv_arg") -> "NonSpare_1475":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1761(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "SSR"
    cv_title = "Age of the Last Secondary Report Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1761.cv_arg") -> "NonSpare_1761":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1253(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MDA"
    cv_title = "Age of the Last Valid Mode A Report Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1253.cv_arg") -> "NonSpare_1253":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1275(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MFL"
    cv_title = "Age of the Last Valid and Credible Mode C Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1275.cv_arg") -> "NonSpare_1275":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1259(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MDS"
    cv_title = "Age of the Last Mode S Report Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1259.cv_arg") -> "NonSpare_1259":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class NonSpare_1244(NonSpare):
    cv_arg: TypeAlias = RuleVariation_228.cv_arg
    cv_name = "MD2"
    cv_title = "Age of the Last Valid Mode 2 Used to Update the Track"
    cv_rule: TypeAlias = RuleVariation_228

    @classmethod
    def create(cls, arg : "NonSpare_1244.cv_arg") -> "NonSpare_1244":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_235:
        return self.rule.variation

class Variation_1501(Compound):
    cv_arg = TypedDict('cv_arg', {
        "PSR": NonSpare_1475.cv_arg,
        "SSR": NonSpare_1761.cv_arg,
        "MDA": NonSpare_1253.cv_arg,
        "MFL": NonSpare_1275.cv_arg,
        "MDS": NonSpare_1259.cv_arg,
        "ADS": NonSpare_577.cv_arg,
        "ADB": NonSpare_567.cv_arg,
        "MD1": NonSpare_1241.cv_arg,
        "MD2": NonSpare_1244.cv_arg,
        "LOP": NonSpare_1195.cv_arg,
        "TRK": NonSpare_1917.cv_arg,
        "MUL": NonSpare_1336.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1475, NonSpare_1761, NonSpare_1253, NonSpare_1275, NonSpare_1259, NonSpare_577, NonSpare_567, NonSpare_1241, NonSpare_1244, NonSpare_1195, NonSpare_1917, NonSpare_1336]
    cv_items_dict = {"PSR": NonSpare_1475, "SSR": NonSpare_1761, "MDA": NonSpare_1253, "MFL": NonSpare_1275, "MDS": NonSpare_1259, "ADS": NonSpare_577, "ADB": NonSpare_567, "MD1": NonSpare_1241, "MD2": NonSpare_1244, "LOP": NonSpare_1195, "TRK": NonSpare_1917, "MUL": NonSpare_1336}

    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1761:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MFL"]) -> NonSpare_1275:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1259:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADS"]) -> NonSpare_577:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADB"]) -> NonSpare_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD1"]) -> NonSpare_1241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD2"]) -> NonSpare_1244:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOP"]) -> NonSpare_1195:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRK"]) -> NonSpare_1917:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MUL"]) -> NonSpare_1336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PSR"], Literal["SSR"], Literal["MDA"], Literal["MFL"], Literal["MDS"], Literal["ADS"], Literal["ADB"], Literal["MD1"], Literal["MD2"], Literal["LOP"], Literal["TRK"], Literal["MUL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1475]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1761]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1253]:
        ...
    @overload
    def get_item(self, key : Literal["MFL"]) -> Optional[NonSpare_1275]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1259]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[NonSpare_577]:
        ...
    @overload
    def get_item(self, key : Literal["ADB"]) -> Optional[NonSpare_567]:
        ...
    @overload
    def get_item(self, key : Literal["MD1"]) -> Optional[NonSpare_1241]:
        ...
    @overload
    def get_item(self, key : Literal["MD2"]) -> Optional[NonSpare_1244]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[NonSpare_1195]:
        ...
    @overload
    def get_item(self, key : Literal["TRK"]) -> Optional[NonSpare_1917]:
        ...
    @overload
    def get_item(self, key : Literal["MUL"]) -> Optional[NonSpare_1336]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1475.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1761.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1253.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["MFL"], val : NonSpare_1275.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1259.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["ADS"], val : NonSpare_577.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["ADB"], val : NonSpare_567.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["MD1"], val : NonSpare_1241.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["MD2"], val : NonSpare_1244.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["LOP"], val : NonSpare_1195.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["TRK"], val : NonSpare_1917.cv_arg) -> "Variation_1501":
        ...
    @overload
    def set_item(self, key : Literal["MUL"], val : NonSpare_1336.cv_arg) -> "Variation_1501":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["MFL"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["ADS"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["ADB"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["MD1"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["MD2"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["LOP"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["TRK"]) -> "Variation_1501":
        ...
    @overload
    def del_item(self, key : Literal["MUL"]) -> "Variation_1501":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1501.cv_arg") -> 'Variation_1501':
        return cls._create(arg) # type: ignore

class RuleVariation_1422(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1501.cv_arg
    cv_variation: TypeAlias = Variation_1501

    @classmethod
    def create(cls, arg : "RuleVariation_1422.cv_arg") -> "RuleVariation_1422":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1501:
        return self.arg # type: ignore

class NonSpare_469(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1422.cv_arg
    cv_name = "290"
    cv_title = "System Track Update Ages"
    cv_rule: TypeAlias = RuleVariation_1422

    @classmethod
    def create(cls, arg : "NonSpare_469.cv_arg") -> "NonSpare_469":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1422:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1501:
        return self.rule.variation

class UapItem_469(UapItem):
    cv_non_spare: TypeAlias = NonSpare_469

class Content_315(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No QNH Correction Applied", 1: "QNH Correction Applied"}

class RuleContent_315(RuleContentContextFree):
    cv_arg: TypeAlias = Content_315.cv_arg
    cv_content: TypeAlias = Content_315

    @property
    def content(self) -> Content_315:
        return self._get_content() # type: ignore

class Variation_58(Element):
    cv_arg: TypeAlias = RuleContent_315.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_315

    @classmethod
    def create(cls, arg: "Variation_58.cv_arg") -> "Variation_58":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_315:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_315:
        return self.rule.content

class RuleVariation_58(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_58.cv_arg
    cv_variation: TypeAlias = Variation_58

    @classmethod
    def create(cls, arg : "RuleVariation_58.cv_arg") -> "RuleVariation_58":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_58:
        return self.arg # type: ignore

class NonSpare_1529(NonSpare):
    cv_arg: TypeAlias = RuleVariation_58.cv_arg
    cv_name = "QNH"
    cv_title = "QNH Correction Applied"
    cv_rule: TypeAlias = RuleVariation_58

    @classmethod
    def create(cls, arg : "NonSpare_1529.cv_arg") -> "NonSpare_1529":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_58:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_58:
        return self.rule.variation

class Item_761(Item):
    cv_arg: TypeAlias = NonSpare_1529.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1529

    @classmethod
    def create(cls, arg : "Item_761.cv_arg") -> "Item_761":
        return cls._create(arg) # type: ignore

class Variation_1167(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_58.cv_arg, Tuple[Literal["QNH"], RuleVariation_58.cv_arg]], Union[RuleVariation_489.cv_arg, Tuple[Literal["CTBA"], RuleVariation_489.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1167.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_761, 1), (Item_230, 15)]
    cv_items_dict = {"QNH": RuleVariation_58, "CTBA": RuleVariation_489}

    @overload
    @classmethod
    def spec(cls, key : Literal["QNH"]) -> RuleVariation_58:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTBA"]) -> RuleVariation_489:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QNH"], Literal["CTBA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QNH"]) -> RuleVariation_58:
        ...
    @overload
    def get_item(self, key : Literal["CTBA"]) -> RuleVariation_489:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1167.cv_arg") -> 'Variation_1167':
        return cls._create(arg) # type: ignore

class RuleVariation_1118(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1167.cv_arg
    cv_variation: TypeAlias = Variation_1167

    @classmethod
    def create(cls, arg : "RuleVariation_1118.cv_arg") -> "RuleVariation_1118":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1167:
        return self.arg # type: ignore

class NonSpare_264(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1118.cv_arg
    cv_name = "093"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_1118

    @classmethod
    def create(cls, arg : "NonSpare_264.cv_arg") -> "NonSpare_264":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1118:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1167:
        return self.rule.variation

class UapItem_264(UapItem):
    cv_non_spare: TypeAlias = NonSpare_264

class NonSpare_463(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1284.cv_arg
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule: TypeAlias = RuleVariation_1284

    @classmethod
    def create(cls, arg : "NonSpare_463.cv_arg") -> "NonSpare_463":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1363:
        return self.rule.variation

class UapItem_463(UapItem):
    cv_non_spare: TypeAlias = NonSpare_463

class Content_245(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Instrument Flight Rules", 1: "Visual Flight Rules", 2: "Not applicable", 3: "Controlled Visual Flight Rules"}

class RuleContent_245(RuleContentContextFree):
    cv_arg: TypeAlias = Content_245.cv_arg
    cv_content: TypeAlias = Content_245

    @property
    def content(self) -> Content_245:
        return self._get_content() # type: ignore

class Variation_591(Element):
    cv_arg: TypeAlias = RuleContent_245.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_245

    @classmethod
    def create(cls, arg: "Variation_591.cv_arg") -> "Variation_591":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_245:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_245:
        return self.rule.content

class RuleVariation_580(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_591.cv_arg
    cv_variation: TypeAlias = Variation_591

    @classmethod
    def create(cls, arg : "RuleVariation_580.cv_arg") -> "RuleVariation_580":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_591:
        return self.arg # type: ignore

class NonSpare_994(NonSpare):
    cv_arg: TypeAlias = RuleVariation_580.cv_arg
    cv_name = "FR1FR2"
    cv_title = "Flight Rules"
    cv_rule: TypeAlias = RuleVariation_580

    @classmethod
    def create(cls, arg : "NonSpare_994.cv_arg") -> "NonSpare_994":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_580:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_591:
        return self.rule.variation

class Item_343(Item):
    cv_arg: TypeAlias = NonSpare_994.cv_arg
    cv_non_spare: TypeAlias = NonSpare_994

    @classmethod
    def create(cls, arg : "Item_343.cv_arg") -> "Item_343":
        return cls._create(arg) # type: ignore

class Variation_1111(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_116.cv_arg, Tuple[Literal["GATOAT"], RuleVariation_116.cv_arg]], Union[RuleVariation_580.cv_arg, Tuple[Literal["FR1FR2"], RuleVariation_580.cv_arg]], Union[RuleVariation_758.cv_arg, Tuple[Literal["RVSM"], RuleVariation_758.cv_arg]], Union[RuleVariation_912.cv_arg, Tuple[Literal["HPR"], RuleVariation_912.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1111.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_363, 2), (Item_343, 2), (Item_845, 2), (Item_403, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_116, "FR1FR2": RuleVariation_580, "RVSM": RuleVariation_758, "HPR": RuleVariation_912}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_580:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_580:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1111.cv_arg") -> 'Variation_1111':
        return cls._create(arg) # type: ignore

class RuleVariation_1069(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1111.cv_arg
    cv_variation: TypeAlias = Variation_1111

    @classmethod
    def create(cls, arg : "RuleVariation_1069.cv_arg") -> "RuleVariation_1069":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1111:
        return self.arg # type: ignore

class NonSpare_977(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1069.cv_arg
    cv_name = "FLIGHTCAT"
    cv_title = "Flight Category"
    cv_rule: TypeAlias = RuleVariation_1069

    @classmethod
    def create(cls, arg : "NonSpare_977.cv_arg") -> "NonSpare_977":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1069:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1111:
        return self.rule.variation

class Variation_1487(Compound):
    cv_arg = TypedDict('cv_arg', {
        "FPPSID": NonSpare_990.cv_arg,
        "CSN": NonSpare_835.cv_arg,
        "IFPSFLIGHTID": NonSpare_1119.cv_arg,
        "FLIGHTCAT": NonSpare_977.cv_arg,
        "TOA": NonSpare_1880.cv_arg,
        "WTC": NonSpare_2069.cv_arg,
        "ADEP": NonSpare_568.cv_arg,
        "ADES": NonSpare_569.cv_arg,
        "RWY": NonSpare_1644.cv_arg,
        "CFL": NonSpare_727.cv_arg,
        "CCP": NonSpare_712.cv_arg,
        "TOD": NonSpare_1881.cv_arg,
        "AST": NonSpare_639.cv_arg,
        "STS": NonSpare_1799.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_990, NonSpare_835, NonSpare_1119, NonSpare_977, NonSpare_1880, NonSpare_2069, NonSpare_568, NonSpare_569, NonSpare_1644, NonSpare_727, NonSpare_712, NonSpare_1881, NonSpare_639, NonSpare_1799]
    cv_items_dict = {"FPPSID": NonSpare_990, "CSN": NonSpare_835, "IFPSFLIGHTID": NonSpare_1119, "FLIGHTCAT": NonSpare_977, "TOA": NonSpare_1880, "WTC": NonSpare_2069, "ADEP": NonSpare_568, "ADES": NonSpare_569, "RWY": NonSpare_1644, "CFL": NonSpare_727, "CCP": NonSpare_712, "TOD": NonSpare_1881, "AST": NonSpare_639, "STS": NonSpare_1799}

    @overload
    @classmethod
    def spec(cls, key : Literal["FPPSID"]) -> NonSpare_990:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_835:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFPSFLIGHTID"]) -> NonSpare_1119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FLIGHTCAT"]) -> NonSpare_977:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> NonSpare_1880:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2069:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADEP"]) -> NonSpare_568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADES"]) -> NonSpare_569:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RWY"]) -> NonSpare_1644:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_727:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CCP"]) -> NonSpare_712:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1881:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_639:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1799:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FPPSID"], Literal["CSN"], Literal["IFPSFLIGHTID"], Literal["FLIGHTCAT"], Literal["TOA"], Literal["WTC"], Literal["ADEP"], Literal["ADES"], Literal["RWY"], Literal["CFL"], Literal["CCP"], Literal["TOD"], Literal["AST"], Literal["STS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FPPSID"]) -> Optional[NonSpare_990]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_835]:
        ...
    @overload
    def get_item(self, key : Literal["IFPSFLIGHTID"]) -> Optional[NonSpare_1119]:
        ...
    @overload
    def get_item(self, key : Literal["FLIGHTCAT"]) -> Optional[NonSpare_977]:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> Optional[NonSpare_1880]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2069]:
        ...
    @overload
    def get_item(self, key : Literal["ADEP"]) -> Optional[NonSpare_568]:
        ...
    @overload
    def get_item(self, key : Literal["ADES"]) -> Optional[NonSpare_569]:
        ...
    @overload
    def get_item(self, key : Literal["RWY"]) -> Optional[NonSpare_1644]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_727]:
        ...
    @overload
    def get_item(self, key : Literal["CCP"]) -> Optional[NonSpare_712]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1881]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_639]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1799]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["FPPSID"], val : NonSpare_990.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_835.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["IFPSFLIGHTID"], val : NonSpare_1119.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["FLIGHTCAT"], val : NonSpare_977.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["TOA"], val : NonSpare_1880.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2069.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["ADEP"], val : NonSpare_568.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["ADES"], val : NonSpare_569.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["RWY"], val : NonSpare_1644.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_727.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["CCP"], val : NonSpare_712.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1881.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_639.cv_arg) -> "Variation_1487":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1799.cv_arg) -> "Variation_1487":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["FPPSID"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["IFPSFLIGHTID"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["FLIGHTCAT"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["TOA"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["ADEP"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["ADES"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["RWY"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["CCP"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1487":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1487":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1487.cv_arg") -> 'Variation_1487':
        return cls._create(arg) # type: ignore

class RuleVariation_1408(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1487.cv_arg
    cv_variation: TypeAlias = Variation_1487

    @classmethod
    def create(cls, arg : "RuleVariation_1408.cv_arg") -> "RuleVariation_1408":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1487:
        return self.arg # type: ignore

class NonSpare_491(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1408.cv_arg
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule: TypeAlias = RuleVariation_1408

    @classmethod
    def create(cls, arg : "NonSpare_491.cv_arg") -> "NonSpare_491":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1408:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1487:
        return self.rule.variation

class UapItem_491(UapItem):
    cv_non_spare: TypeAlias = NonSpare_491

class Record_47(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_48.cv_arg,
        "000": NonSpare_14.cv_arg,
        "015": NonSpare_62.cv_arg,
        "140": NonSpare_335.cv_arg,
        "041": NonSpare_156.cv_arg,
        "042": NonSpare_158.cv_arg,
        "202": NonSpare_406.cv_arg,
        "210": NonSpare_408.cv_arg,
        "060": NonSpare_190.cv_arg,
        "245": NonSpare_442.cv_arg,
        "380": NonSpare_490.cv_arg,
        "161": NonSpare_361.cv_arg,
        "170": NonSpare_380.cv_arg,
        "290": NonSpare_469.cv_arg,
        "430": NonSpare_506.cv_arg,
        "090": NonSpare_252.cv_arg,
        "093": NonSpare_264.cv_arg,
        "092": NonSpare_262.cv_arg,
        "215": NonSpare_418.cv_arg,
        "270": NonSpare_463.cv_arg,
        "390": NonSpare_491.cv_arg,
        "300": NonSpare_476.cv_arg,
        "310": NonSpare_480.cv_arg,
        "500": NonSpare_516.cv_arg,
        "600": NonSpare_528.cv_arg,
        "605": NonSpare_536.cv_arg,
        "610": NonSpare_540.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_48, UapItem_14, UapItem_62, UapItem_335, UapItem_156, UapItem_158, UapItem_406, UapItem_408, UapItem_190, UapItem_442, UapItem_490, UapItem_361, UapItem_380, UapItem_469, UapItem_505, UapItem_252, UapItem_264, UapItem_262, UapItem_418, UapItem_463, UapItem_491, UapItem_476, UapItem_480, UapItem_515, UapItem_527, UapItem_535, UapItem_539, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_48, "000": NonSpare_14, "015": NonSpare_62, "140": NonSpare_335, "041": NonSpare_156, "042": NonSpare_158, "202": NonSpare_406, "210": NonSpare_408, "060": NonSpare_190, "245": NonSpare_442, "380": NonSpare_490, "161": NonSpare_361, "170": NonSpare_380, "290": NonSpare_469, "430": NonSpare_506, "090": NonSpare_252, "093": NonSpare_264, "092": NonSpare_262, "215": NonSpare_418, "270": NonSpare_463, "390": NonSpare_491, "300": NonSpare_476, "310": NonSpare_480, "500": NonSpare_516, "600": NonSpare_528, "605": NonSpare_536, "610": NonSpare_540, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_48:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_14:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_62:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_156:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_158:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_406:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_408:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_190:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_442:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_490:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_361:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_380:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_469:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["430"]) -> NonSpare_506:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_252:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["093"]) -> NonSpare_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["092"]) -> NonSpare_262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["215"]) -> NonSpare_418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_463:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_491:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_476:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_480:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_516:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_528:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["605"]) -> NonSpare_536:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_540:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["140"], Literal["041"], Literal["042"], Literal["202"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["161"], Literal["170"], Literal["290"], Literal["430"], Literal["090"], Literal["093"], Literal["092"], Literal["215"], Literal["270"], Literal["390"], Literal["300"], Literal["310"], Literal["500"], Literal["600"], Literal["605"], Literal["610"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_48]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_14]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_62]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_335]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_156]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_158]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_406]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_408]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_190]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_442]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_490]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_361]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_380]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_469]:
        ...
    @overload
    def get_item(self, key : Literal["430"]) -> Optional[NonSpare_506]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_252]:
        ...
    @overload
    def get_item(self, key : Literal["093"]) -> Optional[NonSpare_264]:
        ...
    @overload
    def get_item(self, key : Literal["092"]) -> Optional[NonSpare_262]:
        ...
    @overload
    def get_item(self, key : Literal["215"]) -> Optional[NonSpare_418]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_463]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_491]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_476]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_480]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_516]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_528]:
        ...
    @overload
    def get_item(self, key : Literal["605"]) -> Optional[NonSpare_536]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_540]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_48.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_14.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_62.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_335.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_156.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_158.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_406.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_408.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_190.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_442.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_490.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_361.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_380.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_469.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["430"], val : NonSpare_506.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_252.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["093"], val : NonSpare_264.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["092"], val : NonSpare_262.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["215"], val : NonSpare_418.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_463.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_491.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_476.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_480.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_516.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_528.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["605"], val : NonSpare_536.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_540.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_47':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_47':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["430"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["093"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["092"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["215"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["605"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_47':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_47':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_47.cv_arg") -> 'Record_47':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_47", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_43(UapSingle):
    cv_arg: TypeAlias = Record_47
    cv_record: TypeAlias = Record_47

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_47]]:
        return cls._parse(bs)

class Asterix_13(AstCat):
    cv_category = 11
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_43
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_43.cv_arg]) -> "Asterix_13":
        return cls._create(records) # type: ignore

class NonSpare_40(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_40.cv_arg") -> "NonSpare_40":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_40(UapItem):
    cv_non_spare: TypeAlias = NonSpare_40

class Content_585(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Measurement Plot", 2: "Measurement Track", 3: "Sensor Centric Plot", 4: "Sensor Centric Track", 5: "Track End Message"}

class RuleContent_585(RuleContentContextFree):
    cv_arg: TypeAlias = Content_585.cv_arg
    cv_content: TypeAlias = Content_585

    @property
    def content(self) -> Content_585:
        return self._get_content() # type: ignore

class Variation_158(Element):
    cv_arg: TypeAlias = RuleContent_585.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_585

    @classmethod
    def create(cls, arg: "Variation_158.cv_arg") -> "Variation_158":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_585:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_585:
        return self.rule.content

class RuleVariation_152(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_158.cv_arg
    cv_variation: TypeAlias = Variation_158

    @classmethod
    def create(cls, arg : "RuleVariation_152.cv_arg") -> "RuleVariation_152":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_158:
        return self.arg # type: ignore

class NonSpare_1334(NonSpare):
    cv_arg: TypeAlias = RuleVariation_152.cv_arg
    cv_name = "MT"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_152

    @classmethod
    def create(cls, arg : "NonSpare_1334.cv_arg") -> "NonSpare_1334":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_152:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_158:
        return self.rule.variation

class Item_598(Item):
    cv_arg: TypeAlias = NonSpare_1334.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1334

    @classmethod
    def create(cls, arg : "Item_598.cv_arg") -> "Item_598":
        return cls._create(arg) # type: ignore

class Content_425(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Periodic Report", 1: "Event Driven Report"}

class RuleContent_425(RuleContentContextFree):
    cv_arg: TypeAlias = Content_425.cv_arg
    cv_content: TypeAlias = Content_425

    @property
    def content(self) -> Content_425:
        return self._get_content() # type: ignore

class Variation_986(Element):
    cv_arg: TypeAlias = RuleContent_425.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_425

    @classmethod
    def create(cls, arg: "Variation_986.cv_arg") -> "Variation_986":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_425:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_425:
        return self.rule.content

class RuleVariation_956(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_986.cv_arg
    cv_variation: TypeAlias = Variation_986

    @classmethod
    def create(cls, arg : "RuleVariation_956.cv_arg") -> "RuleVariation_956":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_986:
        return self.arg # type: ignore

class NonSpare_1586(NonSpare):
    cv_arg: TypeAlias = RuleVariation_956.cv_arg
    cv_name = "RG"
    cv_title = "Report Generation"
    cv_rule: TypeAlias = RuleVariation_956

    @classmethod
    def create(cls, arg : "NonSpare_1586.cv_arg") -> "NonSpare_1586":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_956:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_986:
        return self.rule.variation

class Item_811(Item):
    cv_arg: TypeAlias = NonSpare_1586.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1586

    @classmethod
    def create(cls, arg : "Item_811.cv_arg") -> "Item_811":
        return cls._create(arg) # type: ignore

class Variation_1145(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_152.cv_arg, Tuple[Literal["MT"], RuleVariation_152.cv_arg]], Union[RuleVariation_956.cv_arg, Tuple[Literal["RG"], RuleVariation_956.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1145.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_598, 7), (Item_811, 1)]
    cv_items_dict = {"MT": RuleVariation_152, "RG": RuleVariation_956}

    @overload
    @classmethod
    def spec(cls, key : Literal["MT"]) -> RuleVariation_152:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RG"]) -> RuleVariation_956:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MT"], Literal["RG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MT"]) -> RuleVariation_152:
        ...
    @overload
    def get_item(self, key : Literal["RG"]) -> RuleVariation_956:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1145.cv_arg") -> 'Variation_1145':
        return cls._create(arg) # type: ignore

class RuleVariation_1098(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1145.cv_arg
    cv_variation: TypeAlias = Variation_1145

    @classmethod
    def create(cls, arg : "RuleVariation_1098.cv_arg") -> "RuleVariation_1098":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1145:
        return self.arg # type: ignore

class NonSpare_17(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1098.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_1098

    @classmethod
    def create(cls, arg : "NonSpare_17.cv_arg") -> "NonSpare_17":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1098:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1145:
        return self.rule.variation

class UapItem_17(UapItem):
    cv_non_spare: TypeAlias = NonSpare_17

class NonSpare_60(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_60.cv_arg") -> "NonSpare_60":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_60(UapItem):
    cv_non_spare: TypeAlias = NonSpare_60

class Content_297(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mono-Static Sensor", 1: "Multi-Static Sensor", 2: "Other", 3: "Unknown"}

class RuleContent_297(RuleContentContextFree):
    cv_arg: TypeAlias = Content_297.cv_arg
    cv_content: TypeAlias = Content_297

    @property
    def content(self) -> Content_297:
        return self._get_content() # type: ignore

class Variation_105(Element):
    cv_arg: TypeAlias = RuleContent_297.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_297

    @classmethod
    def create(cls, arg: "Variation_105.cv_arg") -> "Variation_105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_297:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_297:
        return self.rule.content

class RuleVariation_105(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_105.cv_arg
    cv_variation: TypeAlias = Variation_105

    @classmethod
    def create(cls, arg : "RuleVariation_105.cv_arg") -> "RuleVariation_105":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_105:
        return self.arg # type: ignore

class Content_16(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Actual Target Report", 1: "Reference Target", 2: "Synthetic Target", 3: "Simulated / Replayed Target"}

class RuleContent_16(RuleContentContextFree):
    cv_arg: TypeAlias = Content_16.cv_arg
    cv_content: TypeAlias = Content_16

    @property
    def content(self) -> Content_16:
        return self._get_content() # type: ignore

class Variation_587(Element):
    cv_arg: TypeAlias = RuleContent_16.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_16

    @classmethod
    def create(cls, arg: "Variation_587.cv_arg") -> "Variation_587":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_16:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_16:
        return self.rule.content

class RuleVariation_576(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_587.cv_arg
    cv_variation: TypeAlias = Variation_587

    @classmethod
    def create(cls, arg : "RuleVariation_576.cv_arg") -> "RuleVariation_576":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_587:
        return self.arg # type: ignore

class Content_547(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Forward", 2: "Backward", 3: "Static"}

class RuleContent_547(RuleContentContextFree):
    cv_arg: TypeAlias = Content_547.cv_arg
    cv_content: TypeAlias = Content_547

    @property
    def content(self) -> Content_547:
        return self._get_content() # type: ignore

class Variation_772(Element):
    cv_arg: TypeAlias = RuleContent_547.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_547

    @classmethod
    def create(cls, arg: "Variation_772.cv_arg") -> "Variation_772":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_547:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_547:
        return self.rule.content

class RuleVariation_761(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_772.cv_arg
    cv_variation: TypeAlias = Variation_772

    @classmethod
    def create(cls, arg : "RuleVariation_761.cv_arg") -> "RuleVariation_761":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_772:
        return self.arg # type: ignore

class NonSpare_1311(NonSpare):
    cv_arg: TypeAlias = RuleVariation_105.cv_arg
    cv_name = "MOMU"
    cv_title = "Mono-Static Target Report or Multi-Static Target Report"
    cv_rule: TypeAlias = RuleVariation_105

    @classmethod
    def create(cls, arg : "NonSpare_1311.cv_arg") -> "NonSpare_1311":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_105:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_105:
        return self.rule.variation

class Item_577(Item):
    cv_arg: TypeAlias = NonSpare_1311.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1311

    @classmethod
    def create(cls, arg : "Item_577.cv_arg") -> "Item_577":
        return cls._create(arg) # type: ignore

class NonSpare_1947(NonSpare):
    cv_arg: TypeAlias = RuleVariation_576.cv_arg
    cv_name = "TTAX"
    cv_title = "Target Taxonomy"
    cv_rule: TypeAlias = RuleVariation_576

    @classmethod
    def create(cls, arg : "NonSpare_1947.cv_arg") -> "NonSpare_1947":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_576:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_587:
        return self.rule.variation

class Item_1062(Item):
    cv_arg: TypeAlias = NonSpare_1947.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1947

    @classmethod
    def create(cls, arg : "Item_1062.cv_arg") -> "Item_1062":
        return cls._create(arg) # type: ignore

class NonSpare_1668(NonSpare):
    cv_arg: TypeAlias = RuleVariation_761.cv_arg
    cv_name = "SCD"
    cv_title = "Scanning Direction"
    cv_rule: TypeAlias = RuleVariation_761

    @classmethod
    def create(cls, arg : "NonSpare_1668.cv_arg") -> "NonSpare_1668":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_761:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_772:
        return self.rule.variation

class Item_863(Item):
    cv_arg: TypeAlias = NonSpare_1668.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1668

    @classmethod
    def create(cls, arg : "Item_863.cv_arg") -> "Item_863":
        return cls._create(arg) # type: ignore

class Variation_1365(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_105.cv_arg, Tuple[Literal["MOMU"], RuleVariation_105.cv_arg]], Union[RuleVariation_576.cv_arg, Tuple[Literal["TTAX"], RuleVariation_576.cv_arg]], Union[RuleVariation_761.cv_arg, Tuple[Literal["SCD"], RuleVariation_761.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1365.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_577, 2), (Item_1062, 2), (Item_863, 2), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1365.cv_arg") -> 'Variation_1365':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MOMU"]) -> RuleVariation_105:
        ...
    @overload
    def get_item(self, key : Literal["TTAX"]) -> RuleVariation_576:
        ...
    @overload
    def get_item(self, key : Literal["SCD"]) -> RuleVariation_761:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1286(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1365.cv_arg
    cv_variation: TypeAlias = Variation_1365

    @classmethod
    def create(cls, arg : "RuleVariation_1286.cv_arg") -> "RuleVariation_1286":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1365:
        return self.arg # type: ignore

class NonSpare_85(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1286.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1286

    @classmethod
    def create(cls, arg : "NonSpare_85.cv_arg") -> "NonSpare_85":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1365:
        return self.rule.variation

class UapItem_85(UapItem):
    cv_non_spare: TypeAlias = NonSpare_85

class NonSpare_116(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1375.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions"
    cv_rule: TypeAlias = RuleVariation_1375

    @classmethod
    def create(cls, arg : "NonSpare_116.cv_arg") -> "NonSpare_116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1454:
        return self.rule.variation

class UapItem_116(UapItem):
    cv_non_spare: TypeAlias = NonSpare_116

class Content_771(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_770(RuleContentContextFree):
    cv_arg: TypeAlias = Content_771.cv_arg
    cv_content: TypeAlias = Content_771

    @property
    def content(self) -> Content_771:
        return self._get_content() # type: ignore

class Variation_371(Element):
    cv_arg: TypeAlias = RuleContent_770.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_770

    @classmethod
    def create(cls, arg: "Variation_371.cv_arg") -> "Variation_371":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_770:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_771:
        return self.rule.content

class RuleVariation_364(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_371.cv_arg
    cv_variation: TypeAlias = Variation_371

    @classmethod
    def create(cls, arg : "RuleVariation_364.cv_arg") -> "RuleVariation_364":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_371:
        return self.arg # type: ignore

class NonSpare_339(NonSpare):
    cv_arg: TypeAlias = RuleVariation_364.cv_arg
    cv_name = "145"
    cv_title = "Time of Applicability"
    cv_rule: TypeAlias = RuleVariation_364

    @classmethod
    def create(cls, arg : "NonSpare_339.cv_arg") -> "NonSpare_339":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_371:
        return self.rule.variation

class UapItem_339(UapItem):
    cv_non_spare: TypeAlias = NonSpare_339

class Content_621(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_621(RuleContentContextFree):
    cv_arg: TypeAlias = Content_621.cv_arg
    cv_content: TypeAlias = Content_621

    @property
    def content(self) -> Content_621:
        return self._get_content() # type: ignore

class Variation_257(Element):
    cv_arg: TypeAlias = RuleContent_621.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_621

    @classmethod
    def create(cls, arg: "Variation_257.cv_arg") -> "Variation_257":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_621:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_621:
        return self.rule.content

class RuleVariation_250(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_257.cv_arg
    cv_variation: TypeAlias = Variation_257

    @classmethod
    def create(cls, arg : "RuleVariation_250.cv_arg") -> "RuleVariation_250":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_257:
        return self.arg # type: ignore

class NonSpare_367(NonSpare):
    cv_arg: TypeAlias = RuleVariation_250.cv_arg
    cv_name = "161"
    cv_title = "Track/Plot Number"
    cv_rule: TypeAlias = RuleVariation_250

    @classmethod
    def create(cls, arg : "NonSpare_367.cv_arg") -> "NonSpare_367":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_257:
        return self.rule.variation

class UapItem_367(UapItem):
    cv_non_spare: TypeAlias = NonSpare_367

class Content_482(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Target not in Blind Zone", 1: "Target in Blind Zone"}

class RuleContent_482(RuleContentContextFree):
    cv_arg: TypeAlias = Content_482.cv_arg
    cv_content: TypeAlias = Content_482

    @property
    def content(self) -> Content_482:
        return self._get_content() # type: ignore

class Variation_83(Element):
    cv_arg: TypeAlias = RuleContent_482.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_482

    @classmethod
    def create(cls, arg: "Variation_83.cv_arg") -> "Variation_83":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_482:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_482:
        return self.rule.content

class RuleVariation_83(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_83.cv_arg
    cv_variation: TypeAlias = Variation_83

    @classmethod
    def create(cls, arg : "RuleVariation_83.cv_arg") -> "RuleVariation_83":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_83:
        return self.arg # type: ignore

class Content_481(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Target not in Blanked Zone", 1: "Target in Blanked Zone"}

class RuleContent_481(RuleContentContextFree):
    cv_arg: TypeAlias = Content_481.cv_arg
    cv_content: TypeAlias = Content_481

    @property
    def content(self) -> Content_481:
        return self._get_content() # type: ignore

class Variation_454(Element):
    cv_arg: TypeAlias = RuleContent_481.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_481

    @classmethod
    def create(cls, arg: "Variation_454.cv_arg") -> "Variation_454":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_481:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_481:
        return self.rule.content

class RuleVariation_443(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_454.cv_arg
    cv_variation: TypeAlias = Variation_454

    @classmethod
    def create(cls, arg : "RuleVariation_443.cv_arg") -> "RuleVariation_443":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_454:
        return self.arg # type: ignore

class Content_511(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Track Alive", 1: "Track Terminated by User Request"}

class RuleContent_511(RuleContentContextFree):
    cv_arg: TypeAlias = Content_511.cv_arg
    cv_content: TypeAlias = Content_511

    @property
    def content(self) -> Content_511:
        return self._get_content() # type: ignore

class Variation_582(Element):
    cv_arg: TypeAlias = RuleContent_511.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_511

    @classmethod
    def create(cls, arg: "Variation_582.cv_arg") -> "Variation_582":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_511:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_511:
        return self.rule.content

class RuleVariation_571(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_582.cv_arg
    cv_variation: TypeAlias = Variation_582

    @classmethod
    def create(cls, arg : "RuleVariation_571.cv_arg") -> "RuleVariation_571":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_582:
        return self.arg # type: ignore

class Content_398(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not extrapolated", 1: "Extrapolated"}

class RuleContent_398(RuleContentContextFree):
    cv_arg: TypeAlias = Content_398.cv_arg
    cv_content: TypeAlias = Content_398

    @property
    def content(self) -> Content_398:
        return self._get_content() # type: ignore

class Variation_743(Element):
    cv_arg: TypeAlias = RuleContent_398.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_398

    @classmethod
    def create(cls, arg: "Variation_743.cv_arg") -> "Variation_743":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_398:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_398:
        return self.rule.content

class RuleVariation_732(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_743.cv_arg
    cv_variation: TypeAlias = Variation_743

    @classmethod
    def create(cls, arg : "RuleVariation_732.cv_arg") -> "RuleVariation_732":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_743:
        return self.arg # type: ignore

class Variation_866(Element):
    cv_arg: TypeAlias = RuleContent_398.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_398

    @classmethod
    def create(cls, arg: "Variation_866.cv_arg") -> "Variation_866":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_398:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_398:
        return self.rule.content

class RuleVariation_836(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_866.cv_arg
    cv_variation: TypeAlias = Variation_866

    @classmethod
    def create(cls, arg : "RuleVariation_836.cv_arg") -> "RuleVariation_836":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_866:
        return self.arg # type: ignore

class Content_60(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Confirmed Track", 1: "Tentative Track"}

class RuleContent_60(RuleContentContextFree):
    cv_arg: TypeAlias = Content_60.cv_arg
    cv_content: TypeAlias = Content_60

    @property
    def content(self) -> Content_60:
        return self._get_content() # type: ignore

class Variation_906(Element):
    cv_arg: TypeAlias = RuleContent_60.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_60

    @classmethod
    def create(cls, arg: "Variation_906.cv_arg") -> "Variation_906":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_60:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_60:
        return self.rule.content

class RuleVariation_876(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_906.cv_arg
    cv_variation: TypeAlias = Variation_906

    @classmethod
    def create(cls, arg : "RuleVariation_876.cv_arg") -> "RuleVariation_876":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_906:
        return self.arg # type: ignore

class NonSpare_688(NonSpare):
    cv_arg: TypeAlias = RuleVariation_83.cv_arg
    cv_name = "BIZ"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_83

    @classmethod
    def create(cls, arg : "NonSpare_688.cv_arg") -> "NonSpare_688":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_83:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_83:
        return self.rule.variation

class Item_127(Item):
    cv_arg: TypeAlias = NonSpare_688.cv_arg
    cv_non_spare: TypeAlias = NonSpare_688

    @classmethod
    def create(cls, arg : "Item_127.cv_arg") -> "Item_127":
        return cls._create(arg) # type: ignore

class NonSpare_674(NonSpare):
    cv_arg: TypeAlias = RuleVariation_443.cv_arg
    cv_name = "BAZ"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_443

    @classmethod
    def create(cls, arg : "NonSpare_674.cv_arg") -> "NonSpare_674":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_443:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_454:
        return self.rule.variation

class Item_114(Item):
    cv_arg: TypeAlias = NonSpare_674.cv_arg
    cv_non_spare: TypeAlias = NonSpare_674

    @classmethod
    def create(cls, arg : "Item_114.cv_arg") -> "Item_114":
        return cls._create(arg) # type: ignore

class NonSpare_1953(NonSpare):
    cv_arg: TypeAlias = RuleVariation_571.cv_arg
    cv_name = "TUR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_571

    @classmethod
    def create(cls, arg : "NonSpare_1953.cv_arg") -> "NonSpare_1953":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_571:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_582:
        return self.rule.variation

class Item_1068(Item):
    cv_arg: TypeAlias = NonSpare_1953.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1953

    @classmethod
    def create(cls, arg : "Item_1068.cv_arg") -> "Item_1068":
        return cls._create(arg) # type: ignore

class NonSpare_846(NonSpare):
    cv_arg: TypeAlias = RuleVariation_732.cv_arg
    cv_name = "CSTP"
    cv_title = "Coasted - Position"
    cv_rule: TypeAlias = RuleVariation_732

    @classmethod
    def create(cls, arg : "NonSpare_846.cv_arg") -> "NonSpare_846":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_732:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_743:
        return self.rule.variation

class Item_228(Item):
    cv_arg: TypeAlias = NonSpare_846.cv_arg
    cv_non_spare: TypeAlias = NonSpare_846

    @classmethod
    def create(cls, arg : "Item_228.cv_arg") -> "Item_228":
        return cls._create(arg) # type: ignore

class NonSpare_845(NonSpare):
    cv_arg: TypeAlias = RuleVariation_836.cv_arg
    cv_name = "CSTH"
    cv_title = "Coasted – Height"
    cv_rule: TypeAlias = RuleVariation_836

    @classmethod
    def create(cls, arg : "NonSpare_845.cv_arg") -> "NonSpare_845":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_836:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_866:
        return self.rule.variation

class Item_227(Item):
    cv_arg: TypeAlias = NonSpare_845.cv_arg
    cv_non_spare: TypeAlias = NonSpare_845

    @classmethod
    def create(cls, arg : "Item_227.cv_arg") -> "Item_227":
        return cls._create(arg) # type: ignore

class NonSpare_751(NonSpare):
    cv_arg: TypeAlias = RuleVariation_876.cv_arg
    cv_name = "CNF"
    cv_title = "Confirmed vs. Tentative Track"
    cv_rule: TypeAlias = RuleVariation_876

    @classmethod
    def create(cls, arg : "NonSpare_751.cv_arg") -> "NonSpare_751":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_876:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_906:
        return self.rule.variation

class Item_169(Item):
    cv_arg: TypeAlias = NonSpare_751.cv_arg
    cv_non_spare: TypeAlias = NonSpare_751

    @classmethod
    def create(cls, arg : "Item_169.cv_arg") -> "Item_169":
        return cls._create(arg) # type: ignore

class Variation_1350(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_83.cv_arg, Tuple[Literal["BIZ"], RuleVariation_83.cv_arg]], Union[RuleVariation_443.cv_arg, Tuple[Literal["BAZ"], RuleVariation_443.cv_arg]], Union[RuleVariation_571.cv_arg, Tuple[Literal["TUR"], RuleVariation_571.cv_arg]], int, Union[RuleVariation_732.cv_arg, Tuple[Literal["CSTP"], RuleVariation_732.cv_arg]], Union[RuleVariation_836.cv_arg, Tuple[Literal["CSTH"], RuleVariation_836.cv_arg]], Union[RuleVariation_876.cv_arg, Tuple[Literal["CNF"], RuleVariation_876.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1350.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_127, 1), (Item_114, 1), (Item_1068, 1), (Item_16, 1), (Item_228, 1), (Item_227, 1), (Item_169, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1350.cv_arg") -> 'Variation_1350':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["BIZ"]) -> RuleVariation_83:
        ...
    @overload
    def get_item(self, key : Literal["BAZ"]) -> RuleVariation_443:
        ...
    @overload
    def get_item(self, key : Literal["TUR"]) -> RuleVariation_571:
        ...
    @overload
    def get_item(self, key : Literal["CSTP"]) -> RuleVariation_732:
        ...
    @overload
    def get_item(self, key : Literal["CSTH"]) -> RuleVariation_836:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_876:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1271(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1350.cv_arg
    cv_variation: TypeAlias = Variation_1350

    @classmethod
    def create(cls, arg : "RuleVariation_1271.cv_arg") -> "RuleVariation_1271":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1350:
        return self.arg # type: ignore

class NonSpare_381(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1271.cv_arg
    cv_name = "170"
    cv_title = "Track/Plot Status"
    cv_rule: TypeAlias = RuleVariation_1271

    @classmethod
    def create(cls, arg : "NonSpare_381.cv_arg") -> "NonSpare_381":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1350:
        return self.rule.variation

class UapItem_381(UapItem):
    cv_non_spare: TypeAlias = NonSpare_381

class Content_772(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_771(RuleContentContextFree):
    cv_arg: TypeAlias = Content_772.cv_arg
    cv_content: TypeAlias = Content_772

    @property
    def content(self) -> Content_772:
        return self._get_content() # type: ignore

class Variation_612(Element):
    cv_arg: TypeAlias = RuleContent_771.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_771

    @classmethod
    def create(cls, arg: "Variation_612.cv_arg") -> "Variation_612":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_771:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_772:
        return self.rule.content

class RuleVariation_601(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_612.cv_arg
    cv_variation: TypeAlias = Variation_612

    @classmethod
    def create(cls, arg : "RuleVariation_601.cv_arg") -> "RuleVariation_601":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_612:
        return self.arg # type: ignore

class NonSpare_1988(NonSpare):
    cv_arg: TypeAlias = RuleVariation_601.cv_arg
    cv_name = "UPD"
    cv_title = "Update Period"
    cv_rule: TypeAlias = RuleVariation_601

    @classmethod
    def create(cls, arg : "NonSpare_1988.cv_arg") -> "NonSpare_1988":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_601:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_612:
        return self.rule.variation

class Item_1100(Item):
    cv_arg: TypeAlias = NonSpare_1988.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1988

    @classmethod
    def create(cls, arg : "Item_1100.cv_arg") -> "Item_1100":
        return cls._create(arg) # type: ignore

class Variation_1009(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_601.cv_arg, Tuple[Literal["UPD"], RuleVariation_601.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1009.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1, 2), (Item_1100, 14)]
    cv_items_dict = {"UPD": RuleVariation_601}

    @classmethod
    def spec(cls, key : Literal["UPD"]) -> RuleVariation_601:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["UPD"]) -> RuleVariation_601:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1009.cv_arg") -> 'Variation_1009':
        return cls._create(arg) # type: ignore

class RuleVariation_979(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1009.cv_arg
    cv_variation: TypeAlias = Variation_1009

    @classmethod
    def create(cls, arg : "RuleVariation_979.cv_arg") -> "RuleVariation_979":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1009:
        return self.arg # type: ignore

class NonSpare_182(NonSpare):
    cv_arg: TypeAlias = RuleVariation_979.cv_arg
    cv_name = "050"
    cv_title = "Update Period"
    cv_rule: TypeAlias = RuleVariation_979

    @classmethod
    def create(cls, arg : "NonSpare_182.cv_arg") -> "NonSpare_182":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_979:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1009:
        return self.rule.variation

class UapItem_182(UapItem):
    cv_non_spare: TypeAlias = NonSpare_182

class Content_743(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_743(RuleContentContextFree):
    cv_arg: TypeAlias = Content_743.cv_arg
    cv_content: TypeAlias = Content_743

    @property
    def content(self) -> Content_743:
        return self._get_content() # type: ignore

class Variation_315(Element):
    cv_arg: TypeAlias = RuleContent_743.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_743

    @classmethod
    def create(cls, arg: "Variation_315.cv_arg") -> "Variation_315":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_743:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_743:
        return self.rule.content

class RuleVariation_308(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_315.cv_arg
    cv_variation: TypeAlias = Variation_315

    @classmethod
    def create(cls, arg : "RuleVariation_308.cv_arg") -> "RuleVariation_308":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_315:
        return self.arg # type: ignore

class NonSpare_1167(NonSpare):
    cv_arg: TypeAlias = RuleVariation_308.cv_arg
    cv_name = "LEN"
    cv_title = "Target Length"
    cv_rule: TypeAlias = RuleVariation_308

    @classmethod
    def create(cls, arg : "NonSpare_1167.cv_arg") -> "NonSpare_1167":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_308:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_315:
        return self.rule.variation

class NonSpare_2061(NonSpare):
    cv_arg: TypeAlias = RuleVariation_308.cv_arg
    cv_name = "WDT"
    cv_title = "Target Width"
    cv_rule: TypeAlias = RuleVariation_308

    @classmethod
    def create(cls, arg : "NonSpare_2061.cv_arg") -> "NonSpare_2061":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_308:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_315:
        return self.rule.variation

class NonSpare_1070(NonSpare):
    cv_arg: TypeAlias = RuleVariation_308.cv_arg
    cv_name = "HGT"
    cv_title = "Target Height"
    cv_rule: TypeAlias = RuleVariation_308

    @classmethod
    def create(cls, arg : "NonSpare_1070.cv_arg") -> "NonSpare_1070":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_308:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_315:
        return self.rule.variation

class Content_796(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_795(RuleContentContextFree):
    cv_arg: TypeAlias = Content_796.cv_arg
    cv_content: TypeAlias = Content_796

    @property
    def content(self) -> Content_796:
        return self._get_content() # type: ignore

class Variation_346(Element):
    cv_arg: TypeAlias = RuleContent_795.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_795

    @classmethod
    def create(cls, arg: "Variation_346.cv_arg") -> "Variation_346":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_795:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_796:
        return self.rule.content

class RuleVariation_339(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_346.cv_arg
    cv_variation: TypeAlias = Variation_346

    @classmethod
    def create(cls, arg : "RuleVariation_339.cv_arg") -> "RuleVariation_339":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_346:
        return self.arg # type: ignore

class NonSpare_1405(NonSpare):
    cv_arg: TypeAlias = RuleVariation_339.cv_arg
    cv_name = "ORT"
    cv_title = "Target Orientation"
    cv_rule: TypeAlias = RuleVariation_339

    @classmethod
    def create(cls, arg : "NonSpare_1405.cv_arg") -> "NonSpare_1405":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_339:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_346:
        return self.rule.variation

class Variation_1493(Compound):
    cv_arg = TypedDict('cv_arg', {
        "LEN": NonSpare_1167.cv_arg,
        "WDT": NonSpare_2061.cv_arg,
        "HGT": NonSpare_1070.cv_arg,
        "ORT": NonSpare_1405.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1167, NonSpare_2061, NonSpare_1070, NonSpare_1405]
    cv_items_dict = {"LEN": NonSpare_1167, "WDT": NonSpare_2061, "HGT": NonSpare_1070, "ORT": NonSpare_1405}

    @overload
    @classmethod
    def spec(cls, key : Literal["LEN"]) -> NonSpare_1167:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WDT"]) -> NonSpare_2061:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HGT"]) -> NonSpare_1070:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ORT"]) -> NonSpare_1405:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LEN"], Literal["WDT"], Literal["HGT"], Literal["ORT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LEN"]) -> Optional[NonSpare_1167]:
        ...
    @overload
    def get_item(self, key : Literal["WDT"]) -> Optional[NonSpare_2061]:
        ...
    @overload
    def get_item(self, key : Literal["HGT"]) -> Optional[NonSpare_1070]:
        ...
    @overload
    def get_item(self, key : Literal["ORT"]) -> Optional[NonSpare_1405]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["LEN"], val : NonSpare_1167.cv_arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["WDT"], val : NonSpare_2061.cv_arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["HGT"], val : NonSpare_1070.cv_arg) -> "Variation_1493":
        ...
    @overload
    def set_item(self, key : Literal["ORT"], val : NonSpare_1405.cv_arg) -> "Variation_1493":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["LEN"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["WDT"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["HGT"]) -> "Variation_1493":
        ...
    @overload
    def del_item(self, key : Literal["ORT"]) -> "Variation_1493":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1493.cv_arg") -> 'Variation_1493':
        return cls._create(arg) # type: ignore

class RuleVariation_1414(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1493.cv_arg
    cv_variation: TypeAlias = Variation_1493

    @classmethod
    def create(cls, arg : "RuleVariation_1414.cv_arg") -> "RuleVariation_1414":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1493:
        return self.arg # type: ignore

class NonSpare_460(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1414.cv_arg
    cv_name = "270"
    cv_title = "Target Size & Orientation"
    cv_rule: TypeAlias = RuleVariation_1414

    @classmethod
    def create(cls, arg : "NonSpare_460.cv_arg") -> "NonSpare_460":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1414:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1493:
        return self.rule.variation

class UapItem_460(UapItem):
    cv_non_spare: TypeAlias = NonSpare_460

class Variation_246(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 9
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_246.cv_arg") -> "Variation_246":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_239(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_246.cv_arg
    cv_variation: TypeAlias = Variation_246

    @classmethod
    def create(cls, arg : "RuleVariation_239.cv_arg") -> "RuleVariation_239":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_246:
        return self.arg # type: ignore

class NonSpare_744(NonSpare):
    cv_arg: TypeAlias = RuleVariation_239.cv_arg
    cv_name = "CLS"
    cv_title = "Classification"
    cv_rule: TypeAlias = RuleVariation_239

    @classmethod
    def create(cls, arg : "NonSpare_744.cv_arg") -> "NonSpare_744":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_239:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_246:
        return self.rule.variation

class Item_163(Item):
    cv_arg: TypeAlias = NonSpare_744.cv_arg
    cv_non_spare: TypeAlias = NonSpare_744

    @classmethod
    def create(cls, arg : "Item_163.cv_arg") -> "Item_163":
        return cls._create(arg) # type: ignore

class Variation_497(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_497.cv_arg") -> "Variation_497":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_486(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_497.cv_arg
    cv_variation: TypeAlias = Variation_497

    @classmethod
    def create(cls, arg : "RuleVariation_486.cv_arg") -> "RuleVariation_486":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_497:
        return self.arg # type: ignore

class NonSpare_1458(NonSpare):
    cv_arg: TypeAlias = RuleVariation_486.cv_arg
    cv_name = "PRB"
    cv_title = "Probability"
    cv_rule: TypeAlias = RuleVariation_486

    @classmethod
    def create(cls, arg : "NonSpare_1458.cv_arg") -> "NonSpare_1458":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_486:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_497:
        return self.rule.variation

class Item_701(Item):
    cv_arg: TypeAlias = NonSpare_1458.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1458

    @classmethod
    def create(cls, arg : "Item_701.cv_arg") -> "Item_701":
        return cls._create(arg) # type: ignore

class Variation_1071(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_239.cv_arg, Tuple[Literal["CLS"], RuleVariation_239.cv_arg]], Union[RuleVariation_486.cv_arg, Tuple[Literal["PRB"], RuleVariation_486.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1071.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_163, 9), (Item_701, 7)]
    cv_items_dict = {"CLS": RuleVariation_239, "PRB": RuleVariation_486}

    @overload
    @classmethod
    def spec(cls, key : Literal["CLS"]) -> RuleVariation_239:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PRB"]) -> RuleVariation_486:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CLS"], Literal["PRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CLS"]) -> RuleVariation_239:
        ...
    @overload
    def get_item(self, key : Literal["PRB"]) -> RuleVariation_486:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1071.cv_arg") -> 'Variation_1071':
        return cls._create(arg) # type: ignore

class Variation_1416(Repetitive):
    cv_arg: TypeAlias = List[Variation_1071.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1071

    @classmethod
    def create(cls, arg: "Variation_1416.cv_arg") -> 'Variation_1416':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1071]:
        return self._get_list() # type: ignore

class RuleVariation_1337(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1416.cv_arg
    cv_variation: TypeAlias = Variation_1416

    @classmethod
    def create(cls, arg : "RuleVariation_1337.cv_arg") -> "RuleVariation_1337":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1416:
        return self.arg # type: ignore

class NonSpare_474(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1337.cv_arg
    cv_name = "300"
    cv_title = "Object Classification"
    cv_rule: TypeAlias = RuleVariation_1337

    @classmethod
    def create(cls, arg : "NonSpare_474.cv_arg") -> "NonSpare_474":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1416:
        return self.rule.variation

class UapItem_474(UapItem):
    cv_non_spare: TypeAlias = NonSpare_474

class NonSpare_1430(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "PID"
    cv_title = "Pair Identifier"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_1430.cv_arg") -> "NonSpare_1430":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class Item_684(Item):
    cv_arg: TypeAlias = NonSpare_1430.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1430

    @classmethod
    def create(cls, arg : "Item_684.cv_arg") -> "Item_684":
        return cls._create(arg) # type: ignore

class Variation_351(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_351.cv_arg") -> "Variation_351":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_344(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_351.cv_arg
    cv_variation: TypeAlias = Variation_351

    @classmethod
    def create(cls, arg : "RuleVariation_344.cv_arg") -> "RuleVariation_344":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_351:
        return self.arg # type: ignore

class NonSpare_1398(NonSpare):
    cv_arg: TypeAlias = RuleVariation_344.cv_arg
    cv_name = "ON"
    cv_title = "Observation Number"
    cv_rule: TypeAlias = RuleVariation_344

    @classmethod
    def create(cls, arg : "NonSpare_1398.cv_arg") -> "NonSpare_1398":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_351:
        return self.rule.variation

class Item_657(Item):
    cv_arg: TypeAlias = NonSpare_1398.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1398

    @classmethod
    def create(cls, arg : "Item_657.cv_arg") -> "Item_657":
        return cls._create(arg) # type: ignore

class Variation_1158(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_249.cv_arg, Tuple[Literal["PID"], RuleVariation_249.cv_arg]], Union[RuleVariation_344.cv_arg, Tuple[Literal["ON"], RuleVariation_344.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1158.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_684, 16), (Item_657, 24)]
    cv_items_dict = {"PID": RuleVariation_249, "ON": RuleVariation_344}

    @overload
    @classmethod
    def spec(cls, key : Literal["PID"]) -> RuleVariation_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ON"]) -> RuleVariation_344:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PID"], Literal["ON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PID"]) -> RuleVariation_249:
        ...
    @overload
    def get_item(self, key : Literal["ON"]) -> RuleVariation_344:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1158.cv_arg") -> 'Variation_1158':
        return cls._create(arg) # type: ignore

class RuleVariation_1110(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1158.cv_arg
    cv_variation: TypeAlias = Variation_1158

    @classmethod
    def create(cls, arg : "RuleVariation_1110.cv_arg") -> "RuleVariation_1110":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1158:
        return self.arg # type: ignore

class NonSpare_498(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1110.cv_arg
    cv_name = "400"
    cv_title = "Measurement Identifier"
    cv_rule: TypeAlias = RuleVariation_1110

    @classmethod
    def create(cls, arg : "NonSpare_498.cv_arg") -> "NonSpare_498":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1110:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1158:
        return self.rule.variation

class UapItem_497(UapItem):
    cv_non_spare: TypeAlias = NonSpare_498

class Content_704(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 8.381903171539307e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_704(RuleContentContextFree):
    cv_arg: TypeAlias = Content_704.cv_arg
    cv_content: TypeAlias = Content_704

    @property
    def content(self) -> Content_704:
        return self._get_content() # type: ignore

class Variation_382(Element):
    cv_arg: TypeAlias = RuleContent_704.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_704

    @classmethod
    def create(cls, arg: "Variation_382.cv_arg") -> "Variation_382":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_704:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_704:
        return self.rule.content

class RuleVariation_375(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_382.cv_arg
    cv_variation: TypeAlias = Variation_382

    @classmethod
    def create(cls, arg : "RuleVariation_375.cv_arg") -> "RuleVariation_375":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_382:
        return self.arg # type: ignore

class NonSpare_1162(NonSpare):
    cv_arg: TypeAlias = RuleVariation_375.cv_arg
    cv_name = "LATITUDE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_375

    @classmethod
    def create(cls, arg : "NonSpare_1162.cv_arg") -> "NonSpare_1162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_375:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_382:
        return self.rule.variation

class Item_474(Item):
    cv_arg: TypeAlias = NonSpare_1162.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1162

    @classmethod
    def create(cls, arg : "Item_474.cv_arg") -> "Item_474":
        return cls._create(arg) # type: ignore

class NonSpare_1193(NonSpare):
    cv_arg: TypeAlias = RuleVariation_374.cv_arg
    cv_name = "LONGITUDE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_374

    @classmethod
    def create(cls, arg : "NonSpare_1193.cv_arg") -> "NonSpare_1193":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_374:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_381:
        return self.rule.variation

class Item_503(Item):
    cv_arg: TypeAlias = NonSpare_1193.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1193

    @classmethod
    def create(cls, arg : "Item_503.cv_arg") -> "Item_503":
        return cls._create(arg) # type: ignore

class Variation_1137(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_375.cv_arg, Tuple[Literal["LATITUDE"], RuleVariation_375.cv_arg]], Union[RuleVariation_374.cv_arg, Tuple[Literal["LONGITUDE"], RuleVariation_374.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1137.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_474, 32), (Item_503, 32)]
    cv_items_dict = {"LATITUDE": RuleVariation_375, "LONGITUDE": RuleVariation_374}

    @overload
    @classmethod
    def spec(cls, key : Literal["LATITUDE"]) -> RuleVariation_375:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LONGITUDE"]) -> RuleVariation_374:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LATITUDE"], Literal["LONGITUDE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LATITUDE"]) -> RuleVariation_375:
        ...
    @overload
    def get_item(self, key : Literal["LONGITUDE"]) -> RuleVariation_374:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1137.cv_arg") -> 'Variation_1137':
        return cls._create(arg) # type: ignore

class RuleVariation_1093(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1137.cv_arg
    cv_variation: TypeAlias = Variation_1137

    @classmethod
    def create(cls, arg : "RuleVariation_1093.cv_arg") -> "RuleVariation_1093":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1137:
        return self.arg # type: ignore

class NonSpare_1418(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1093.cv_arg
    cv_name = "P84"
    cv_title = "Horizontal Position in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1093

    @classmethod
    def create(cls, arg : "NonSpare_1418.cv_arg") -> "NonSpare_1418":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1093:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1137:
        return self.rule.variation

class Content_733(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_733(RuleContentContextFree):
    cv_arg: TypeAlias = Content_733.cv_arg
    cv_content: TypeAlias = Content_733

    @property
    def content(self) -> Content_733:
        return self._get_content() # type: ignore

class Variation_312(Element):
    cv_arg: TypeAlias = RuleContent_733.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_733

    @classmethod
    def create(cls, arg: "Variation_312.cv_arg") -> "Variation_312":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_733:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_733:
        return self.rule.content

class RuleVariation_305(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_312.cv_arg
    cv_variation: TypeAlias = Variation_312

    @classmethod
    def create(cls, arg : "RuleVariation_305.cv_arg") -> "RuleVariation_305":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_312:
        return self.arg # type: ignore

class NonSpare_1619(NonSpare):
    cv_arg: TypeAlias = RuleVariation_305.cv_arg
    cv_name = "RSHPX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_305

    @classmethod
    def create(cls, arg : "NonSpare_1619.cv_arg") -> "NonSpare_1619":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_305:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_312:
        return self.rule.variation

class Item_834(Item):
    cv_arg: TypeAlias = NonSpare_1619.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1619

    @classmethod
    def create(cls, arg : "Item_834.cv_arg") -> "Item_834":
        return cls._create(arg) # type: ignore

class NonSpare_1620(NonSpare):
    cv_arg: TypeAlias = RuleVariation_305.cv_arg
    cv_name = "RSHPY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_305

    @classmethod
    def create(cls, arg : "NonSpare_1620.cv_arg") -> "NonSpare_1620":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_305:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_312:
        return self.rule.variation

class Item_835(Item):
    cv_arg: TypeAlias = NonSpare_1620.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1620

    @classmethod
    def create(cls, arg : "Item_835.cv_arg") -> "Item_835":
        return cls._create(arg) # type: ignore

class Content_676(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 7.8125e-3
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

class RuleContent_676(RuleContentContextFree):
    cv_arg: TypeAlias = Content_676.cv_arg
    cv_content: TypeAlias = Content_676

    @property
    def content(self) -> Content_676:
        return self._get_content() # type: ignore

class Variation_214(Element):
    cv_arg: TypeAlias = RuleContent_676.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_676

    @classmethod
    def create(cls, arg: "Variation_214.cv_arg") -> "Variation_214":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_676:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_676:
        return self.rule.content

class RuleVariation_207(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_214.cv_arg
    cv_variation: TypeAlias = Variation_214

    @classmethod
    def create(cls, arg : "RuleVariation_207.cv_arg") -> "RuleVariation_207":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_214:
        return self.arg # type: ignore

class NonSpare_796(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CORSHPXY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_796.cv_arg") -> "NonSpare_796":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_195(Item):
    cv_arg: TypeAlias = NonSpare_796.cv_arg
    cv_non_spare: TypeAlias = NonSpare_796

    @classmethod
    def create(cls, arg : "Item_195.cv_arg") -> "Item_195":
        return cls._create(arg) # type: ignore

class Variation_1186(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_305.cv_arg, Tuple[Literal["RSHPX"], RuleVariation_305.cv_arg]], Union[RuleVariation_305.cv_arg, Tuple[Literal["RSHPY"], RuleVariation_305.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["CORSHPXY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1186.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_834, 16), (Item_835, 16), (Item_195, 8)]
    cv_items_dict = {"RSHPX": RuleVariation_305, "RSHPY": RuleVariation_305, "CORSHPXY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["RSHPX"]) -> RuleVariation_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSHPY"]) -> RuleVariation_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORSHPXY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RSHPX"], Literal["RSHPY"], Literal["CORSHPXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RSHPX"]) -> RuleVariation_305:
        ...
    @overload
    def get_item(self, key : Literal["RSHPY"]) -> RuleVariation_305:
        ...
    @overload
    def get_item(self, key : Literal["CORSHPXY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1186.cv_arg") -> 'Variation_1186':
        return cls._create(arg) # type: ignore

class RuleVariation_1136(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1186.cv_arg
    cv_variation: TypeAlias = Variation_1186

    @classmethod
    def create(cls, arg : "RuleVariation_1136.cv_arg") -> "RuleVariation_1136":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1186:
        return self.arg # type: ignore

class NonSpare_1080(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1136.cv_arg
    cv_name = "HPR"
    cv_title = "Horizontal Position Resolution"
    cv_rule: TypeAlias = RuleVariation_1136

    @classmethod
    def create(cls, arg : "NonSpare_1080.cv_arg") -> "NonSpare_1080":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1136:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1186:
        return self.rule.variation

class Content_756(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_755(RuleContentContextFree):
    cv_arg: TypeAlias = Content_756.cv_arg
    cv_content: TypeAlias = Content_756

    @property
    def content(self) -> Content_756:
        return self._get_content() # type: ignore

class Variation_325(Element):
    cv_arg: TypeAlias = RuleContent_755.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_755

    @classmethod
    def create(cls, arg: "Variation_325.cv_arg") -> "Variation_325":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_755:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_756:
        return self.rule.content

class RuleVariation_318(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_325.cv_arg
    cv_variation: TypeAlias = Variation_325

    @classmethod
    def create(cls, arg : "RuleVariation_318.cv_arg") -> "RuleVariation_318":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_325:
        return self.arg # type: ignore

class NonSpare_1686(NonSpare):
    cv_arg: TypeAlias = RuleVariation_318.cv_arg
    cv_name = "SDHPX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_318

    @classmethod
    def create(cls, arg : "NonSpare_1686.cv_arg") -> "NonSpare_1686":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_318:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_325:
        return self.rule.variation

class Item_871(Item):
    cv_arg: TypeAlias = NonSpare_1686.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1686

    @classmethod
    def create(cls, arg : "Item_871.cv_arg") -> "Item_871":
        return cls._create(arg) # type: ignore

class NonSpare_1687(NonSpare):
    cv_arg: TypeAlias = RuleVariation_318.cv_arg
    cv_name = "SDHPY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_318

    @classmethod
    def create(cls, arg : "NonSpare_1687.cv_arg") -> "NonSpare_1687":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_318:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_325:
        return self.rule.variation

class Item_872(Item):
    cv_arg: TypeAlias = NonSpare_1687.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1687

    @classmethod
    def create(cls, arg : "Item_872.cv_arg") -> "Item_872":
        return cls._create(arg) # type: ignore

class NonSpare_798(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COSDHPXY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_798.cv_arg") -> "NonSpare_798":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_197(Item):
    cv_arg: TypeAlias = NonSpare_798.cv_arg
    cv_non_spare: TypeAlias = NonSpare_798

    @classmethod
    def create(cls, arg : "Item_197.cv_arg") -> "Item_197":
        return cls._create(arg) # type: ignore

class Variation_1205(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_318.cv_arg, Tuple[Literal["SDHPX"], RuleVariation_318.cv_arg]], Union[RuleVariation_318.cv_arg, Tuple[Literal["SDHPY"], RuleVariation_318.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COSDHPXY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1205.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_871, 16), (Item_872, 16), (Item_197, 8)]
    cv_items_dict = {"SDHPX": RuleVariation_318, "SDHPY": RuleVariation_318, "COSDHPXY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDHPX"]) -> RuleVariation_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDHPY"]) -> RuleVariation_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COSDHPXY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDHPX"], Literal["SDHPY"], Literal["COSDHPXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDHPX"]) -> RuleVariation_318:
        ...
    @overload
    def get_item(self, key : Literal["SDHPY"]) -> RuleVariation_318:
        ...
    @overload
    def get_item(self, key : Literal["COSDHPXY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1205.cv_arg") -> 'Variation_1205':
        return cls._create(arg) # type: ignore

class RuleVariation_1149(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1205.cv_arg
    cv_variation: TypeAlias = Variation_1205

    @classmethod
    def create(cls, arg : "RuleVariation_1149.cv_arg") -> "RuleVariation_1149":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1205:
        return self.arg # type: ignore

class NonSpare_1076(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1149.cv_arg
    cv_name = "HPP"
    cv_title = "Horizontal Position Precision"
    cv_rule: TypeAlias = RuleVariation_1149

    @classmethod
    def create(cls, arg : "NonSpare_1076.cv_arg") -> "NonSpare_1076":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1149:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1205:
        return self.rule.variation

class Variation_1497(Compound):
    cv_arg = TypedDict('cv_arg', {
        "P84": NonSpare_1418.cv_arg,
        "HPR": NonSpare_1080.cv_arg,
        "HPP": NonSpare_1076.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1418, NonSpare_1080, NonSpare_1076]
    cv_items_dict = {"P84": NonSpare_1418, "HPR": NonSpare_1080, "HPP": NonSpare_1076}

    @overload
    @classmethod
    def spec(cls, key : Literal["P84"]) -> NonSpare_1418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> NonSpare_1080:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPP"]) -> NonSpare_1076:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["P84"], Literal["HPR"], Literal["HPP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["P84"]) -> Optional[NonSpare_1418]:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> Optional[NonSpare_1080]:
        ...
    @overload
    def get_item(self, key : Literal["HPP"]) -> Optional[NonSpare_1076]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["P84"], val : NonSpare_1418.cv_arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["HPR"], val : NonSpare_1080.cv_arg) -> "Variation_1497":
        ...
    @overload
    def set_item(self, key : Literal["HPP"], val : NonSpare_1076.cv_arg) -> "Variation_1497":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["P84"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["HPR"]) -> "Variation_1497":
        ...
    @overload
    def del_item(self, key : Literal["HPP"]) -> "Variation_1497":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1497.cv_arg") -> 'Variation_1497':
        return cls._create(arg) # type: ignore

class RuleVariation_1418(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1497.cv_arg
    cv_variation: TypeAlias = Variation_1497

    @classmethod
    def create(cls, arg : "RuleVariation_1418.cv_arg") -> "RuleVariation_1418":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1497:
        return self.arg # type: ignore

class NonSpare_529(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1418.cv_arg
    cv_name = "600"
    cv_title = "Horizontal Position Information"
    cv_rule: TypeAlias = RuleVariation_1418

    @classmethod
    def create(cls, arg : "NonSpare_529.cv_arg") -> "NonSpare_529":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1418:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1497:
        return self.rule.variation

class UapItem_528(UapItem):
    cv_non_spare: TypeAlias = NonSpare_529

class Content_645(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_645(RuleContentContextFree):
    cv_arg: TypeAlias = Content_645.cv_arg
    cv_content: TypeAlias = Content_645

    @property
    def content(self) -> Content_645:
        return self._get_content() # type: ignore

class Variation_356(Element):
    cv_arg: TypeAlias = RuleContent_645.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_645

    @classmethod
    def create(cls, arg: "Variation_356.cv_arg") -> "Variation_356":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_645:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_645:
        return self.rule.content

class RuleVariation_349(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_356.cv_arg
    cv_variation: TypeAlias = Variation_356

    @classmethod
    def create(cls, arg : "RuleVariation_349.cv_arg") -> "RuleVariation_349":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_356:
        return self.arg # type: ignore

class NonSpare_1033(NonSpare):
    cv_arg: TypeAlias = RuleVariation_349.cv_arg
    cv_name = "GH"
    cv_title = "Geometric Height (WGS-84)"
    cv_rule: TypeAlias = RuleVariation_349

    @classmethod
    def create(cls, arg : "NonSpare_1033.cv_arg") -> "NonSpare_1033":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_349:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_356:
        return self.rule.variation

class Content_744(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_744(RuleContentContextFree):
    cv_arg: TypeAlias = Content_744.cv_arg
    cv_content: TypeAlias = Content_744

    @property
    def content(self) -> Content_744:
        return self._get_content() # type: ignore

class Variation_369(Element):
    cv_arg: TypeAlias = RuleContent_744.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_744

    @classmethod
    def create(cls, arg: "Variation_369.cv_arg") -> "Variation_369":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_744:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_744:
        return self.rule.content

class RuleVariation_362(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_369.cv_arg
    cv_variation: TypeAlias = Variation_369

    @classmethod
    def create(cls, arg : "RuleVariation_362.cv_arg") -> "RuleVariation_362":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_369:
        return self.arg # type: ignore

class NonSpare_1618(NonSpare):
    cv_arg: TypeAlias = RuleVariation_362.cv_arg
    cv_name = "RSGH"
    cv_title = "Geometric Height Resolution"
    cv_rule: TypeAlias = RuleVariation_362

    @classmethod
    def create(cls, arg : "NonSpare_1618.cv_arg") -> "NonSpare_1618":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_369:
        return self.rule.variation

class NonSpare_1683(NonSpare):
    cv_arg: TypeAlias = RuleVariation_362.cv_arg
    cv_name = "SDGH"
    cv_title = "Geometric Height Precision"
    cv_rule: TypeAlias = RuleVariation_362

    @classmethod
    def create(cls, arg : "NonSpare_1683.cv_arg") -> "NonSpare_1683":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_369:
        return self.rule.variation

class Content_728(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 16.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_728(RuleContentContextFree):
    cv_arg: TypeAlias = Content_728.cv_arg
    cv_content: TypeAlias = Content_728

    @property
    def content(self) -> Content_728:
        return self._get_content() # type: ignore

class Variation_248(Element):
    cv_arg: TypeAlias = RuleContent_728.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 12
    cv_rule = RuleContent_728

    @classmethod
    def create(cls, arg: "Variation_248.cv_arg") -> "Variation_248":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_728:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_728:
        return self.rule.content

class RuleVariation_241(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_248.cv_arg
    cv_variation: TypeAlias = Variation_248

    @classmethod
    def create(cls, arg : "RuleVariation_241.cv_arg") -> "RuleVariation_241":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_248:
        return self.arg # type: ignore

class NonSpare_1983(NonSpare):
    cv_arg: TypeAlias = RuleVariation_241.cv_arg
    cv_name = "UCI6"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_241

    @classmethod
    def create(cls, arg : "NonSpare_1983.cv_arg") -> "NonSpare_1983":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_241:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_248:
        return self.rule.variation

class Item_1095(Item):
    cv_arg: TypeAlias = NonSpare_1983.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1983

    @classmethod
    def create(cls, arg : "Item_1095.cv_arg") -> "Item_1095":
        return cls._create(arg) # type: ignore

class Variation_811(Element):
    cv_arg: TypeAlias = RuleContent_728.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_728

    @classmethod
    def create(cls, arg: "Variation_811.cv_arg") -> "Variation_811":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_728:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_728:
        return self.rule.content

class RuleVariation_781(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_811.cv_arg
    cv_variation: TypeAlias = Variation_811

    @classmethod
    def create(cls, arg : "RuleVariation_781.cv_arg") -> "RuleVariation_781":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_811:
        return self.arg # type: ignore

class NonSpare_1163(NonSpare):
    cv_arg: TypeAlias = RuleVariation_781.cv_arg
    cv_name = "LCI6"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_781

    @classmethod
    def create(cls, arg : "NonSpare_1163.cv_arg") -> "NonSpare_1163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_781:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_811:
        return self.rule.variation

class Item_475(Item):
    cv_arg: TypeAlias = NonSpare_1163.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1163

    @classmethod
    def create(cls, arg : "Item_475.cv_arg") -> "Item_475":
        return cls._create(arg) # type: ignore

class Variation_1247(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_241.cv_arg, Tuple[Literal["UCI6"], RuleVariation_241.cv_arg]], Union[RuleVariation_781.cv_arg, Tuple[Literal["LCI6"], RuleVariation_781.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1247.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1095, 12), (Item_475, 12)]
    cv_items_dict = {"UCI6": RuleVariation_241, "LCI6": RuleVariation_781}

    @overload
    @classmethod
    def spec(cls, key : Literal["UCI6"]) -> RuleVariation_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCI6"]) -> RuleVariation_781:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["UCI6"], Literal["LCI6"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["UCI6"]) -> RuleVariation_241:
        ...
    @overload
    def get_item(self, key : Literal["LCI6"]) -> RuleVariation_781:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1247.cv_arg") -> 'Variation_1247':
        return cls._create(arg) # type: ignore

class RuleVariation_1176(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1247.cv_arg
    cv_variation: TypeAlias = Variation_1247

    @classmethod
    def create(cls, arg : "RuleVariation_1176.cv_arg") -> "RuleVariation_1176":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1247:
        return self.arg # type: ignore

class NonSpare_739(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1176.cv_arg
    cv_name = "CI6"
    cv_title = "Confidence Interval for Geometric Height (67%)"
    cv_rule: TypeAlias = RuleVariation_1176

    @classmethod
    def create(cls, arg : "NonSpare_739.cv_arg") -> "NonSpare_739":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1176:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1247:
        return self.rule.variation

class NonSpare_1984(NonSpare):
    cv_arg: TypeAlias = RuleVariation_241.cv_arg
    cv_name = "UCI9"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_241

    @classmethod
    def create(cls, arg : "NonSpare_1984.cv_arg") -> "NonSpare_1984":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_241:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_248:
        return self.rule.variation

class Item_1096(Item):
    cv_arg: TypeAlias = NonSpare_1984.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1984

    @classmethod
    def create(cls, arg : "Item_1096.cv_arg") -> "Item_1096":
        return cls._create(arg) # type: ignore

class NonSpare_1164(NonSpare):
    cv_arg: TypeAlias = RuleVariation_781.cv_arg
    cv_name = "LCI9"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_781

    @classmethod
    def create(cls, arg : "NonSpare_1164.cv_arg") -> "NonSpare_1164":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_781:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_811:
        return self.rule.variation

class Item_476(Item):
    cv_arg: TypeAlias = NonSpare_1164.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1164

    @classmethod
    def create(cls, arg : "Item_476.cv_arg") -> "Item_476":
        return cls._create(arg) # type: ignore

class Variation_1248(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_241.cv_arg, Tuple[Literal["UCI9"], RuleVariation_241.cv_arg]], Union[RuleVariation_781.cv_arg, Tuple[Literal["LCI9"], RuleVariation_781.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1248.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1096, 12), (Item_476, 12)]
    cv_items_dict = {"UCI9": RuleVariation_241, "LCI9": RuleVariation_781}

    @overload
    @classmethod
    def spec(cls, key : Literal["UCI9"]) -> RuleVariation_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCI9"]) -> RuleVariation_781:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["UCI9"], Literal["LCI9"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["UCI9"]) -> RuleVariation_241:
        ...
    @overload
    def get_item(self, key : Literal["LCI9"]) -> RuleVariation_781:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1248.cv_arg") -> 'Variation_1248':
        return cls._create(arg) # type: ignore

class RuleVariation_1177(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1248.cv_arg
    cv_variation: TypeAlias = Variation_1248

    @classmethod
    def create(cls, arg : "RuleVariation_1177.cv_arg") -> "RuleVariation_1177":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1248:
        return self.arg # type: ignore

class NonSpare_740(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1177.cv_arg
    cv_name = "CI9"
    cv_title = "Confidence Interval for Geometric Height (95%)"
    cv_rule: TypeAlias = RuleVariation_1177

    @classmethod
    def create(cls, arg : "NonSpare_740.cv_arg") -> "NonSpare_740":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1177:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1248:
        return self.rule.variation

class NonSpare_2072(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2072.cv_arg") -> "NonSpare_2072":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1173(Item):
    cv_arg: TypeAlias = NonSpare_2072.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2072

    @classmethod
    def create(cls, arg : "Item_1173.cv_arg") -> "Item_1173":
        return cls._create(arg) # type: ignore

class NonSpare_2125(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2125.cv_arg") -> "NonSpare_2125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1223(Item):
    cv_arg: TypeAlias = NonSpare_2125.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2125

    @classmethod
    def create(cls, arg : "Item_1223.cv_arg") -> "Item_1223":
        return cls._create(arg) # type: ignore

class Variation_1286(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1286.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1173, 8), (Item_1223, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1286.cv_arg") -> 'Variation_1286':
        return cls._create(arg) # type: ignore

class RuleVariation_1215(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1286.cv_arg
    cv_variation: TypeAlias = Variation_1286

    @classmethod
    def create(cls, arg : "RuleVariation_1215.cv_arg") -> "RuleVariation_1215":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1286:
        return self.arg # type: ignore

class NonSpare_763(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1215.cv_arg
    cv_name = "COGHHP"
    cv_title = "Correlation of Geometric Height and Horizontal Position"
    cv_rule: TypeAlias = RuleVariation_1215

    @classmethod
    def create(cls, arg : "NonSpare_763.cv_arg") -> "NonSpare_763":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1215:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1286:
        return self.rule.variation

class NonSpare_2073(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2073.cv_arg") -> "NonSpare_2073":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1174(Item):
    cv_arg: TypeAlias = NonSpare_2073.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2073

    @classmethod
    def create(cls, arg : "Item_1174.cv_arg") -> "Item_1174":
        return cls._create(arg) # type: ignore

class NonSpare_2126(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2126.cv_arg") -> "NonSpare_2126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1224(Item):
    cv_arg: TypeAlias = NonSpare_2126.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2126

    @classmethod
    def create(cls, arg : "Item_1224.cv_arg") -> "Item_1224":
        return cls._create(arg) # type: ignore

class Variation_1287(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1287.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1174, 8), (Item_1224, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1287.cv_arg") -> 'Variation_1287':
        return cls._create(arg) # type: ignore

class RuleVariation_1216(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1287.cv_arg
    cv_variation: TypeAlias = Variation_1287

    @classmethod
    def create(cls, arg : "RuleVariation_1216.cv_arg") -> "RuleVariation_1216":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1287:
        return self.arg # type: ignore

class NonSpare_764(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1216.cv_arg
    cv_name = "COGHHV"
    cv_title = "Correlation of Geometric Height and Horizontal Velocity"
    cv_rule: TypeAlias = RuleVariation_1216

    @classmethod
    def create(cls, arg : "NonSpare_764.cv_arg") -> "NonSpare_764":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1216:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1287:
        return self.rule.variation

class NonSpare_2071(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2071.cv_arg") -> "NonSpare_2071":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1172(Item):
    cv_arg: TypeAlias = NonSpare_2071.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2071

    @classmethod
    def create(cls, arg : "Item_1172.cv_arg") -> "Item_1172":
        return cls._create(arg) # type: ignore

class NonSpare_2124(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2124.cv_arg") -> "NonSpare_2124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1222(Item):
    cv_arg: TypeAlias = NonSpare_2124.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2124

    @classmethod
    def create(cls, arg : "Item_1222.cv_arg") -> "Item_1222":
        return cls._create(arg) # type: ignore

class Variation_1285(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1285.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1172, 8), (Item_1222, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1285.cv_arg") -> 'Variation_1285':
        return cls._create(arg) # type: ignore

class RuleVariation_1214(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1285.cv_arg
    cv_variation: TypeAlias = Variation_1285

    @classmethod
    def create(cls, arg : "RuleVariation_1214.cv_arg") -> "RuleVariation_1214":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1285:
        return self.arg # type: ignore

class NonSpare_762(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1214.cv_arg
    cv_name = "COGHHA"
    cv_title = "Correlation of Geometric Height and Horizontal Acceleration"
    cv_rule: TypeAlias = RuleVariation_1214

    @classmethod
    def create(cls, arg : "NonSpare_762.cv_arg") -> "NonSpare_762":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1214:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1285:
        return self.rule.variation

class Variation_1489(Compound):
    cv_arg = TypedDict('cv_arg', {
        "GH": NonSpare_1033.cv_arg,
        "RSGH": NonSpare_1618.cv_arg,
        "SDGH": NonSpare_1683.cv_arg,
        "CI6": NonSpare_739.cv_arg,
        "CI9": NonSpare_740.cv_arg,
        "COGHHP": NonSpare_763.cv_arg,
        "COGHHV": NonSpare_764.cv_arg,
        "COGHHA": NonSpare_762.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1033, NonSpare_1618, NonSpare_1683, NonSpare_739, NonSpare_740, NonSpare_763, NonSpare_764, NonSpare_762]
    cv_items_dict = {"GH": NonSpare_1033, "RSGH": NonSpare_1618, "SDGH": NonSpare_1683, "CI6": NonSpare_739, "CI9": NonSpare_740, "COGHHP": NonSpare_763, "COGHHV": NonSpare_764, "COGHHA": NonSpare_762}

    @overload
    @classmethod
    def spec(cls, key : Literal["GH"]) -> NonSpare_1033:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSGH"]) -> NonSpare_1618:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDGH"]) -> NonSpare_1683:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CI6"]) -> NonSpare_739:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CI9"]) -> NonSpare_740:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COGHHP"]) -> NonSpare_763:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COGHHV"]) -> NonSpare_764:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COGHHA"]) -> NonSpare_762:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GH"], Literal["RSGH"], Literal["SDGH"], Literal["CI6"], Literal["CI9"], Literal["COGHHP"], Literal["COGHHV"], Literal["COGHHA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GH"]) -> Optional[NonSpare_1033]:
        ...
    @overload
    def get_item(self, key : Literal["RSGH"]) -> Optional[NonSpare_1618]:
        ...
    @overload
    def get_item(self, key : Literal["SDGH"]) -> Optional[NonSpare_1683]:
        ...
    @overload
    def get_item(self, key : Literal["CI6"]) -> Optional[NonSpare_739]:
        ...
    @overload
    def get_item(self, key : Literal["CI9"]) -> Optional[NonSpare_740]:
        ...
    @overload
    def get_item(self, key : Literal["COGHHP"]) -> Optional[NonSpare_763]:
        ...
    @overload
    def get_item(self, key : Literal["COGHHV"]) -> Optional[NonSpare_764]:
        ...
    @overload
    def get_item(self, key : Literal["COGHHA"]) -> Optional[NonSpare_762]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["GH"], val : NonSpare_1033.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["RSGH"], val : NonSpare_1618.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["SDGH"], val : NonSpare_1683.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["CI6"], val : NonSpare_739.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["CI9"], val : NonSpare_740.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["COGHHP"], val : NonSpare_763.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["COGHHV"], val : NonSpare_764.cv_arg) -> "Variation_1489":
        ...
    @overload
    def set_item(self, key : Literal["COGHHA"], val : NonSpare_762.cv_arg) -> "Variation_1489":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["GH"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["RSGH"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["SDGH"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["CI6"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["CI9"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["COGHHP"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["COGHHV"]) -> "Variation_1489":
        ...
    @overload
    def del_item(self, key : Literal["COGHHA"]) -> "Variation_1489":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1489.cv_arg") -> 'Variation_1489':
        return cls._create(arg) # type: ignore

class RuleVariation_1410(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1489.cv_arg
    cv_variation: TypeAlias = Variation_1489

    @classmethod
    def create(cls, arg : "RuleVariation_1410.cv_arg") -> "RuleVariation_1410":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1489:
        return self.arg # type: ignore

class NonSpare_532(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1410.cv_arg
    cv_name = "601"
    cv_title = "Geometric Height Information"
    cv_rule: TypeAlias = RuleVariation_1410

    @classmethod
    def create(cls, arg : "NonSpare_532.cv_arg") -> "NonSpare_532":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1410:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1489:
        return self.rule.variation

class UapItem_531(UapItem):
    cv_non_spare: TypeAlias = NonSpare_532

class Content_647(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_647(RuleContentContextFree):
    cv_arg: TypeAlias = Content_647.cv_arg
    cv_content: TypeAlias = Content_647

    @property
    def content(self) -> Content_647:
        return self._get_content() # type: ignore

class Variation_348(Element):
    cv_arg: TypeAlias = RuleContent_647.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 20
    cv_rule = RuleContent_647

    @classmethod
    def create(cls, arg: "Variation_348.cv_arg") -> "Variation_348":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_647:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_647:
        return self.rule.content

class RuleVariation_341(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_348.cv_arg
    cv_variation: TypeAlias = Variation_348

    @classmethod
    def create(cls, arg : "RuleVariation_341.cv_arg") -> "RuleVariation_341":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_348:
        return self.arg # type: ignore

class NonSpare_2084(NonSpare):
    cv_arg: TypeAlias = RuleVariation_341.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_341

    @classmethod
    def create(cls, arg : "NonSpare_2084.cv_arg") -> "NonSpare_2084":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_341:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_348:
        return self.rule.variation

class Item_1185(Item):
    cv_arg: TypeAlias = NonSpare_2084.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2084

    @classmethod
    def create(cls, arg : "Item_1185.cv_arg") -> "Item_1185":
        return cls._create(arg) # type: ignore

class Variation_815(Element):
    cv_arg: TypeAlias = RuleContent_647.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 20
    cv_rule = RuleContent_647

    @classmethod
    def create(cls, arg: "Variation_815.cv_arg") -> "Variation_815":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_647:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_647:
        return self.rule.content

class RuleVariation_785(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_815.cv_arg
    cv_variation: TypeAlias = Variation_815

    @classmethod
    def create(cls, arg : "RuleVariation_785.cv_arg") -> "RuleVariation_785":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_815:
        return self.arg # type: ignore

class NonSpare_2137(NonSpare):
    cv_arg: TypeAlias = RuleVariation_785.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_785

    @classmethod
    def create(cls, arg : "NonSpare_2137.cv_arg") -> "NonSpare_2137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_785:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_815:
        return self.rule.variation

class Item_1235(Item):
    cv_arg: TypeAlias = NonSpare_2137.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2137

    @classmethod
    def create(cls, arg : "Item_1235.cv_arg") -> "Item_1235":
        return cls._create(arg) # type: ignore

class Variation_1298(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_341.cv_arg, Tuple[Literal["X"], RuleVariation_341.cv_arg]], Union[RuleVariation_785.cv_arg, Tuple[Literal["Y"], RuleVariation_785.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1298.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_1185, 20), (Item_1235, 20)]
    cv_items_dict = {"X": RuleVariation_341, "Y": RuleVariation_785}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_785:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_341:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_785:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1298.cv_arg") -> 'Variation_1298':
        return cls._create(arg) # type: ignore

class RuleVariation_1227(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1298.cv_arg
    cv_variation: TypeAlias = Variation_1298

    @classmethod
    def create(cls, arg : "RuleVariation_1227.cv_arg") -> "RuleVariation_1227":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1298:
        return self.arg # type: ignore

class NonSpare_1084(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1227.cv_arg
    cv_name = "HV"
    cv_title = "Horizontal Velocity Vector"
    cv_rule: TypeAlias = RuleVariation_1227

    @classmethod
    def create(cls, arg : "NonSpare_1084.cv_arg") -> "NonSpare_1084":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1298:
        return self.rule.variation

class Content_745(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_745(RuleContentContextFree):
    cv_arg: TypeAlias = Content_745.cv_arg
    cv_content: TypeAlias = Content_745

    @property
    def content(self) -> Content_745:
        return self._get_content() # type: ignore

class Variation_316(Element):
    cv_arg: TypeAlias = RuleContent_745.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_745

    @classmethod
    def create(cls, arg: "Variation_316.cv_arg") -> "Variation_316":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_745:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_745:
        return self.rule.content

class RuleVariation_309(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_316.cv_arg
    cv_variation: TypeAlias = Variation_316

    @classmethod
    def create(cls, arg : "RuleVariation_309.cv_arg") -> "RuleVariation_309":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_316:
        return self.arg # type: ignore

class NonSpare_2082(NonSpare):
    cv_arg: TypeAlias = RuleVariation_309.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_309

    @classmethod
    def create(cls, arg : "NonSpare_2082.cv_arg") -> "NonSpare_2082":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class Item_1183(Item):
    cv_arg: TypeAlias = NonSpare_2082.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2082

    @classmethod
    def create(cls, arg : "Item_1183.cv_arg") -> "Item_1183":
        return cls._create(arg) # type: ignore

class NonSpare_2133(NonSpare):
    cv_arg: TypeAlias = RuleVariation_309.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_309

    @classmethod
    def create(cls, arg : "NonSpare_2133.cv_arg") -> "NonSpare_2133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class Item_1231(Item):
    cv_arg: TypeAlias = NonSpare_2133.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2133

    @classmethod
    def create(cls, arg : "Item_1231.cv_arg") -> "Item_1231":
        return cls._create(arg) # type: ignore

class NonSpare_797(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CORSHVXY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_797.cv_arg") -> "NonSpare_797":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_196(Item):
    cv_arg: TypeAlias = NonSpare_797.cv_arg
    cv_non_spare: TypeAlias = NonSpare_797

    @classmethod
    def create(cls, arg : "Item_196.cv_arg") -> "Item_196":
        return cls._create(arg) # type: ignore

class Variation_1296(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_309.cv_arg, Tuple[Literal["X"], RuleVariation_309.cv_arg]], Union[RuleVariation_309.cv_arg, Tuple[Literal["Y"], RuleVariation_309.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["CORSHVXY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1296.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_1183, 16), (Item_1231, 16), (Item_196, 8)]
    cv_items_dict = {"X": RuleVariation_309, "Y": RuleVariation_309, "CORSHVXY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORSHVXY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["CORSHVXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_309:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_309:
        ...
    @overload
    def get_item(self, key : Literal["CORSHVXY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1296.cv_arg") -> 'Variation_1296':
        return cls._create(arg) # type: ignore

class RuleVariation_1225(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1296.cv_arg
    cv_variation: TypeAlias = Variation_1296

    @classmethod
    def create(cls, arg : "RuleVariation_1225.cv_arg") -> "RuleVariation_1225":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1296:
        return self.arg # type: ignore

class NonSpare_1621(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1225.cv_arg
    cv_name = "RSHV"
    cv_title = "Horizontal Velocity Resolution"
    cv_rule: TypeAlias = RuleVariation_1225

    @classmethod
    def create(cls, arg : "NonSpare_1621.cv_arg") -> "NonSpare_1621":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1225:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1296:
        return self.rule.variation

class NonSpare_2083(NonSpare):
    cv_arg: TypeAlias = RuleVariation_309.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_309

    @classmethod
    def create(cls, arg : "NonSpare_2083.cv_arg") -> "NonSpare_2083":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class Item_1184(Item):
    cv_arg: TypeAlias = NonSpare_2083.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2083

    @classmethod
    def create(cls, arg : "Item_1184.cv_arg") -> "Item_1184":
        return cls._create(arg) # type: ignore

class NonSpare_2134(NonSpare):
    cv_arg: TypeAlias = RuleVariation_309.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_309

    @classmethod
    def create(cls, arg : "NonSpare_2134.cv_arg") -> "NonSpare_2134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class Item_1232(Item):
    cv_arg: TypeAlias = NonSpare_2134.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2134

    @classmethod
    def create(cls, arg : "Item_1232.cv_arg") -> "Item_1232":
        return cls._create(arg) # type: ignore

class NonSpare_778(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHVXY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_778.cv_arg") -> "NonSpare_778":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_184(Item):
    cv_arg: TypeAlias = NonSpare_778.cv_arg
    cv_non_spare: TypeAlias = NonSpare_778

    @classmethod
    def create(cls, arg : "Item_184.cv_arg") -> "Item_184":
        return cls._create(arg) # type: ignore

class Variation_1297(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_309.cv_arg, Tuple[Literal["X"], RuleVariation_309.cv_arg]], Union[RuleVariation_309.cv_arg, Tuple[Literal["Y"], RuleVariation_309.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHVXY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1297.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_1184, 16), (Item_1232, 16), (Item_184, 8)]
    cv_items_dict = {"X": RuleVariation_309, "Y": RuleVariation_309, "COHVXY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVXY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["COHVXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_309:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_309:
        ...
    @overload
    def get_item(self, key : Literal["COHVXY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1297.cv_arg") -> 'Variation_1297':
        return cls._create(arg) # type: ignore

class RuleVariation_1226(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1297.cv_arg
    cv_variation: TypeAlias = Variation_1297

    @classmethod
    def create(cls, arg : "RuleVariation_1226.cv_arg") -> "RuleVariation_1226":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1297:
        return self.arg # type: ignore

class NonSpare_1688(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1226.cv_arg
    cv_name = "SDHV"
    cv_title = "Horizontal Velocity Precision"
    cv_rule: TypeAlias = RuleVariation_1226

    @classmethod
    def create(cls, arg : "NonSpare_1688.cv_arg") -> "NonSpare_1688":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1297:
        return self.rule.variation

class NonSpare_776(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHVXHPX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_776.cv_arg") -> "NonSpare_776":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_182(Item):
    cv_arg: TypeAlias = NonSpare_776.cv_arg
    cv_non_spare: TypeAlias = NonSpare_776

    @classmethod
    def create(cls, arg : "Item_182.cv_arg") -> "Item_182":
        return cls._create(arg) # type: ignore

class NonSpare_777(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHVXHPY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_777.cv_arg") -> "NonSpare_777":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_183(Item):
    cv_arg: TypeAlias = NonSpare_777.cv_arg
    cv_non_spare: TypeAlias = NonSpare_777

    @classmethod
    def create(cls, arg : "Item_183.cv_arg") -> "Item_183":
        return cls._create(arg) # type: ignore

class NonSpare_779(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHVYHPX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_779.cv_arg") -> "NonSpare_779":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_185(Item):
    cv_arg: TypeAlias = NonSpare_779.cv_arg
    cv_non_spare: TypeAlias = NonSpare_779

    @classmethod
    def create(cls, arg : "Item_185.cv_arg") -> "Item_185":
        return cls._create(arg) # type: ignore

class NonSpare_780(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHVYHPY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_780.cv_arg") -> "NonSpare_780":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_186(Item):
    cv_arg: TypeAlias = NonSpare_780.cv_arg
    cv_non_spare: TypeAlias = NonSpare_780

    @classmethod
    def create(cls, arg : "Item_186.cv_arg") -> "Item_186":
        return cls._create(arg) # type: ignore

class Variation_1074(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["COHVXHPX"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHVXHPY"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHVYHPX"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHVYHPY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1074.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_182, 8), (Item_183, 8), (Item_185, 8), (Item_186, 8)]
    cv_items_dict = {"COHVXHPX": RuleVariation_207, "COHVXHPY": RuleVariation_207, "COHVYHPX": RuleVariation_207, "COHVYHPY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["COHVXHPX"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVXHPY"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVYHPX"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVYHPY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COHVXHPX"], Literal["COHVXHPY"], Literal["COHVYHPX"], Literal["COHVYHPY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COHVXHPX"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHVXHPY"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHVYHPX"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHVYHPY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1074.cv_arg") -> 'Variation_1074':
        return cls._create(arg) # type: ignore

class RuleVariation_1034(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1074.cv_arg
    cv_variation: TypeAlias = Variation_1074

    @classmethod
    def create(cls, arg : "RuleVariation_1034.cv_arg") -> "RuleVariation_1034":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1074:
        return self.arg # type: ignore

class NonSpare_775(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1034.cv_arg
    cv_name = "COHVHP"
    cv_title = "Correlation of Horizontal Velocity and Horizontal Position"
    cv_rule: TypeAlias = RuleVariation_1034

    @classmethod
    def create(cls, arg : "NonSpare_775.cv_arg") -> "NonSpare_775":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1034:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1074:
        return self.rule.variation

class Variation_1491(Compound):
    cv_arg = TypedDict('cv_arg', {
        "HV": NonSpare_1084.cv_arg,
        "RSHV": NonSpare_1621.cv_arg,
        "SDHV": NonSpare_1688.cv_arg,
        "COHVHP": NonSpare_775.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1084, NonSpare_1621, NonSpare_1688, NonSpare_775]
    cv_items_dict = {"HV": NonSpare_1084, "RSHV": NonSpare_1621, "SDHV": NonSpare_1688, "COHVHP": NonSpare_775}

    @overload
    @classmethod
    def spec(cls, key : Literal["HV"]) -> NonSpare_1084:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSHV"]) -> NonSpare_1621:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDHV"]) -> NonSpare_1688:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHVHP"]) -> NonSpare_775:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HV"], Literal["RSHV"], Literal["SDHV"], Literal["COHVHP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HV"]) -> Optional[NonSpare_1084]:
        ...
    @overload
    def get_item(self, key : Literal["RSHV"]) -> Optional[NonSpare_1621]:
        ...
    @overload
    def get_item(self, key : Literal["SDHV"]) -> Optional[NonSpare_1688]:
        ...
    @overload
    def get_item(self, key : Literal["COHVHP"]) -> Optional[NonSpare_775]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["HV"], val : NonSpare_1084.cv_arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["RSHV"], val : NonSpare_1621.cv_arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["SDHV"], val : NonSpare_1688.cv_arg) -> "Variation_1491":
        ...
    @overload
    def set_item(self, key : Literal["COHVHP"], val : NonSpare_775.cv_arg) -> "Variation_1491":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["HV"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["RSHV"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["SDHV"]) -> "Variation_1491":
        ...
    @overload
    def del_item(self, key : Literal["COHVHP"]) -> "Variation_1491":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1491.cv_arg") -> 'Variation_1491':
        return cls._create(arg) # type: ignore

class RuleVariation_1412(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1491.cv_arg
    cv_variation: TypeAlias = Variation_1491

    @classmethod
    def create(cls, arg : "RuleVariation_1412.cv_arg") -> "RuleVariation_1412":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1491:
        return self.arg # type: ignore

class NonSpare_533(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1412.cv_arg
    cv_name = "602"
    cv_title = "Horizontal Velocity Information"
    cv_rule: TypeAlias = RuleVariation_1412

    @classmethod
    def create(cls, arg : "NonSpare_533.cv_arg") -> "NonSpare_533":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1412:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1491:
        return self.rule.variation

class UapItem_532(UapItem):
    cv_non_spare: TypeAlias = NonSpare_533

class Content_670(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_670(RuleContentContextFree):
    cv_arg: TypeAlias = Content_670.cv_arg
    cv_content: TypeAlias = Content_670

    @property
    def content(self) -> Content_670:
        return self._get_content() # type: ignore

class Variation_247(Element):
    cv_arg: TypeAlias = RuleContent_670.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 12
    cv_rule = RuleContent_670

    @classmethod
    def create(cls, arg: "Variation_247.cv_arg") -> "Variation_247":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_670:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_670:
        return self.rule.content

class RuleVariation_240(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_247.cv_arg
    cv_variation: TypeAlias = Variation_247

    @classmethod
    def create(cls, arg : "RuleVariation_240.cv_arg") -> "RuleVariation_240":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_247:
        return self.arg # type: ignore

class NonSpare_2080(NonSpare):
    cv_arg: TypeAlias = RuleVariation_240.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_240

    @classmethod
    def create(cls, arg : "NonSpare_2080.cv_arg") -> "NonSpare_2080":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_240:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_247:
        return self.rule.variation

class Item_1181(Item):
    cv_arg: TypeAlias = NonSpare_2080.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2080

    @classmethod
    def create(cls, arg : "Item_1181.cv_arg") -> "Item_1181":
        return cls._create(arg) # type: ignore

class Variation_810(Element):
    cv_arg: TypeAlias = RuleContent_670.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_670

    @classmethod
    def create(cls, arg: "Variation_810.cv_arg") -> "Variation_810":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_670:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_670:
        return self.rule.content

class RuleVariation_780(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_810.cv_arg
    cv_variation: TypeAlias = Variation_810

    @classmethod
    def create(cls, arg : "RuleVariation_780.cv_arg") -> "RuleVariation_780":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_810:
        return self.arg # type: ignore

class NonSpare_2135(NonSpare):
    cv_arg: TypeAlias = RuleVariation_780.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_780

    @classmethod
    def create(cls, arg : "NonSpare_2135.cv_arg") -> "NonSpare_2135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_780:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_810:
        return self.rule.variation

class Item_1233(Item):
    cv_arg: TypeAlias = NonSpare_2135.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2135

    @classmethod
    def create(cls, arg : "Item_1233.cv_arg") -> "Item_1233":
        return cls._create(arg) # type: ignore

class Variation_1294(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_240.cv_arg, Tuple[Literal["X"], RuleVariation_240.cv_arg]], Union[RuleVariation_780.cv_arg, Tuple[Literal["Y"], RuleVariation_780.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1294.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1181, 12), (Item_1233, 12)]
    cv_items_dict = {"X": RuleVariation_240, "Y": RuleVariation_780}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_780:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_240:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_780:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1294.cv_arg") -> 'Variation_1294':
        return cls._create(arg) # type: ignore

class RuleVariation_1223(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1294.cv_arg
    cv_variation: TypeAlias = Variation_1294

    @classmethod
    def create(cls, arg : "RuleVariation_1223.cv_arg") -> "RuleVariation_1223":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1294:
        return self.arg # type: ignore

class NonSpare_1053(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1223.cv_arg
    cv_name = "HA"
    cv_title = "Horizontal Acceleration Vector"
    cv_rule: TypeAlias = RuleVariation_1223

    @classmethod
    def create(cls, arg : "NonSpare_1053.cv_arg") -> "NonSpare_1053":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1223:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1294:
        return self.rule.variation

class Content_763(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.25e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_762(RuleContentContextFree):
    cv_arg: TypeAlias = Content_763.cv_arg
    cv_content: TypeAlias = Content_763

    @property
    def content(self) -> Content_763:
        return self._get_content() # type: ignore

class Variation_249(Element):
    cv_arg: TypeAlias = RuleContent_762.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 12
    cv_rule = RuleContent_762

    @classmethod
    def create(cls, arg: "Variation_249.cv_arg") -> "Variation_249":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_762:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_763:
        return self.rule.content

class RuleVariation_242(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_249.cv_arg
    cv_variation: TypeAlias = Variation_249

    @classmethod
    def create(cls, arg : "RuleVariation_242.cv_arg") -> "RuleVariation_242":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_249:
        return self.arg # type: ignore

class NonSpare_2081(NonSpare):
    cv_arg: TypeAlias = RuleVariation_242.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_242

    @classmethod
    def create(cls, arg : "NonSpare_2081.cv_arg") -> "NonSpare_2081":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_242:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_249:
        return self.rule.variation

class Item_1182(Item):
    cv_arg: TypeAlias = NonSpare_2081.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2081

    @classmethod
    def create(cls, arg : "Item_1182.cv_arg") -> "Item_1182":
        return cls._create(arg) # type: ignore

class Variation_814(Element):
    cv_arg: TypeAlias = RuleContent_762.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_762

    @classmethod
    def create(cls, arg: "Variation_814.cv_arg") -> "Variation_814":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_762:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_763:
        return self.rule.content

class RuleVariation_784(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_814.cv_arg
    cv_variation: TypeAlias = Variation_814

    @classmethod
    def create(cls, arg : "RuleVariation_784.cv_arg") -> "RuleVariation_784":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_814:
        return self.arg # type: ignore

class NonSpare_2136(NonSpare):
    cv_arg: TypeAlias = RuleVariation_784.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_784

    @classmethod
    def create(cls, arg : "NonSpare_2136.cv_arg") -> "NonSpare_2136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_784:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_814:
        return self.rule.variation

class Item_1234(Item):
    cv_arg: TypeAlias = NonSpare_2136.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2136

    @classmethod
    def create(cls, arg : "Item_1234.cv_arg") -> "Item_1234":
        return cls._create(arg) # type: ignore

class NonSpare_771(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAXY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_771.cv_arg") -> "NonSpare_771":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_178(Item):
    cv_arg: TypeAlias = NonSpare_771.cv_arg
    cv_non_spare: TypeAlias = NonSpare_771

    @classmethod
    def create(cls, arg : "Item_178.cv_arg") -> "Item_178":
        return cls._create(arg) # type: ignore

class Variation_1295(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_242.cv_arg, Tuple[Literal["X"], RuleVariation_242.cv_arg]], Union[RuleVariation_784.cv_arg, Tuple[Literal["Y"], RuleVariation_784.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAXY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1295.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1182, 12), (Item_1234, 12), (Item_178, 8)]
    cv_items_dict = {"X": RuleVariation_242, "Y": RuleVariation_784, "COHAXY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_242:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_784:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["COHAXY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_242:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_784:
        ...
    @overload
    def get_item(self, key : Literal["COHAXY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1295.cv_arg") -> 'Variation_1295':
        return cls._create(arg) # type: ignore

class RuleVariation_1224(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1295.cv_arg
    cv_variation: TypeAlias = Variation_1295

    @classmethod
    def create(cls, arg : "RuleVariation_1224.cv_arg") -> "RuleVariation_1224":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1295:
        return self.arg # type: ignore

class NonSpare_1685(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1224.cv_arg
    cv_name = "SDHA"
    cv_title = "Horizontal Acceleration Precision"
    cv_rule: TypeAlias = RuleVariation_1224

    @classmethod
    def create(cls, arg : "NonSpare_1685.cv_arg") -> "NonSpare_1685":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1224:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1295:
        return self.rule.variation

class NonSpare_767(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAXHPX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_767.cv_arg") -> "NonSpare_767":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_174(Item):
    cv_arg: TypeAlias = NonSpare_767.cv_arg
    cv_non_spare: TypeAlias = NonSpare_767

    @classmethod
    def create(cls, arg : "Item_174.cv_arg") -> "Item_174":
        return cls._create(arg) # type: ignore

class NonSpare_768(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAXHPY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_768.cv_arg") -> "NonSpare_768":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_175(Item):
    cv_arg: TypeAlias = NonSpare_768.cv_arg
    cv_non_spare: TypeAlias = NonSpare_768

    @classmethod
    def create(cls, arg : "Item_175.cv_arg") -> "Item_175":
        return cls._create(arg) # type: ignore

class NonSpare_772(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAYHPX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_772.cv_arg") -> "NonSpare_772":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_179(Item):
    cv_arg: TypeAlias = NonSpare_772.cv_arg
    cv_non_spare: TypeAlias = NonSpare_772

    @classmethod
    def create(cls, arg : "Item_179.cv_arg") -> "Item_179":
        return cls._create(arg) # type: ignore

class NonSpare_752(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COAYHPY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_752.cv_arg") -> "NonSpare_752":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_170(Item):
    cv_arg: TypeAlias = NonSpare_752.cv_arg
    cv_non_spare: TypeAlias = NonSpare_752

    @classmethod
    def create(cls, arg : "Item_170.cv_arg") -> "Item_170":
        return cls._create(arg) # type: ignore

class Variation_1072(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAXHPX"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAXHPY"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAYHPX"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COAYHPY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1072.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_174, 8), (Item_175, 8), (Item_179, 8), (Item_170, 8)]
    cv_items_dict = {"COHAXHPX": RuleVariation_207, "COHAXHPY": RuleVariation_207, "COHAYHPX": RuleVariation_207, "COAYHPY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHPX"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHPY"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAYHPX"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COAYHPY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COHAXHPX"], Literal["COHAXHPY"], Literal["COHAYHPX"], Literal["COAYHPY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COHAXHPX"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHAXHPY"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHAYHPX"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COAYHPY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1072.cv_arg") -> 'Variation_1072':
        return cls._create(arg) # type: ignore

class RuleVariation_1032(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1072.cv_arg
    cv_variation: TypeAlias = Variation_1072

    @classmethod
    def create(cls, arg : "RuleVariation_1032.cv_arg") -> "RuleVariation_1032":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1072:
        return self.arg # type: ignore

class NonSpare_765(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1032.cv_arg
    cv_name = "COHAHP"
    cv_title = "Correlation of Horizontal Acceleration and Horizontal Position"
    cv_rule: TypeAlias = RuleVariation_1032

    @classmethod
    def create(cls, arg : "NonSpare_765.cv_arg") -> "NonSpare_765":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1032:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1072:
        return self.rule.variation

class NonSpare_769(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAXHVX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_769.cv_arg") -> "NonSpare_769":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_176(Item):
    cv_arg: TypeAlias = NonSpare_769.cv_arg
    cv_non_spare: TypeAlias = NonSpare_769

    @classmethod
    def create(cls, arg : "Item_176.cv_arg") -> "Item_176":
        return cls._create(arg) # type: ignore

class NonSpare_770(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAXHVY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_770.cv_arg") -> "NonSpare_770":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_177(Item):
    cv_arg: TypeAlias = NonSpare_770.cv_arg
    cv_non_spare: TypeAlias = NonSpare_770

    @classmethod
    def create(cls, arg : "Item_177.cv_arg") -> "Item_177":
        return cls._create(arg) # type: ignore

class NonSpare_773(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAYHVX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_773.cv_arg") -> "NonSpare_773":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_180(Item):
    cv_arg: TypeAlias = NonSpare_773.cv_arg
    cv_non_spare: TypeAlias = NonSpare_773

    @classmethod
    def create(cls, arg : "Item_180.cv_arg") -> "Item_180":
        return cls._create(arg) # type: ignore

class NonSpare_774(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COHAYHVY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_774.cv_arg") -> "NonSpare_774":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_181(Item):
    cv_arg: TypeAlias = NonSpare_774.cv_arg
    cv_non_spare: TypeAlias = NonSpare_774

    @classmethod
    def create(cls, arg : "Item_181.cv_arg") -> "Item_181":
        return cls._create(arg) # type: ignore

class Variation_1073(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAXHVX"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAXHVY"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAYHVX"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COHAYHVY"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1073.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_176, 8), (Item_177, 8), (Item_180, 8), (Item_181, 8)]
    cv_items_dict = {"COHAXHVX": RuleVariation_207, "COHAXHVY": RuleVariation_207, "COHAYHVX": RuleVariation_207, "COHAYHVY": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHVX"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAXHVY"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAYHVX"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAYHVY"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COHAXHVX"], Literal["COHAXHVY"], Literal["COHAYHVX"], Literal["COHAYHVY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COHAXHVX"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHAXHVY"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHAYHVX"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COHAYHVY"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1073.cv_arg") -> 'Variation_1073':
        return cls._create(arg) # type: ignore

class RuleVariation_1033(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1073.cv_arg
    cv_variation: TypeAlias = Variation_1073

    @classmethod
    def create(cls, arg : "RuleVariation_1033.cv_arg") -> "RuleVariation_1033":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1073:
        return self.arg # type: ignore

class NonSpare_766(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1033.cv_arg
    cv_name = "COHAHV"
    cv_title = "Correlation of Horizontal Acceleration and Horizontal Velocity"
    cv_rule: TypeAlias = RuleVariation_1033

    @classmethod
    def create(cls, arg : "NonSpare_766.cv_arg") -> "NonSpare_766":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1033:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1073:
        return self.rule.variation

class Variation_1490(Compound):
    cv_arg = TypedDict('cv_arg', {
        "HA": NonSpare_1053.cv_arg,
        "SDHA": NonSpare_1685.cv_arg,
        "COHAHP": NonSpare_765.cv_arg,
        "COHAHV": NonSpare_766.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1053, NonSpare_1685, NonSpare_765, NonSpare_766]
    cv_items_dict = {"HA": NonSpare_1053, "SDHA": NonSpare_1685, "COHAHP": NonSpare_765, "COHAHV": NonSpare_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["HA"]) -> NonSpare_1053:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDHA"]) -> NonSpare_1685:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAHP"]) -> NonSpare_765:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COHAHV"]) -> NonSpare_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HA"], Literal["SDHA"], Literal["COHAHP"], Literal["COHAHV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HA"]) -> Optional[NonSpare_1053]:
        ...
    @overload
    def get_item(self, key : Literal["SDHA"]) -> Optional[NonSpare_1685]:
        ...
    @overload
    def get_item(self, key : Literal["COHAHP"]) -> Optional[NonSpare_765]:
        ...
    @overload
    def get_item(self, key : Literal["COHAHV"]) -> Optional[NonSpare_766]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["HA"], val : NonSpare_1053.cv_arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["SDHA"], val : NonSpare_1685.cv_arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["COHAHP"], val : NonSpare_765.cv_arg) -> "Variation_1490":
        ...
    @overload
    def set_item(self, key : Literal["COHAHV"], val : NonSpare_766.cv_arg) -> "Variation_1490":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["HA"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["SDHA"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["COHAHP"]) -> "Variation_1490":
        ...
    @overload
    def del_item(self, key : Literal["COHAHV"]) -> "Variation_1490":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1490.cv_arg") -> 'Variation_1490':
        return cls._create(arg) # type: ignore

class RuleVariation_1411(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1490.cv_arg
    cv_variation: TypeAlias = Variation_1490

    @classmethod
    def create(cls, arg : "RuleVariation_1411.cv_arg") -> "RuleVariation_1411":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1490:
        return self.arg # type: ignore

class NonSpare_534(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1411.cv_arg
    cv_name = "603"
    cv_title = "Horizontal Acceleration Information"
    cv_rule: TypeAlias = RuleVariation_1411

    @classmethod
    def create(cls, arg : "NonSpare_534.cv_arg") -> "NonSpare_534":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1411:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1490:
        return self.rule.variation

class UapItem_533(UapItem):
    cv_non_spare: TypeAlias = NonSpare_534

class Content_646(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_646(RuleContentContextFree):
    cv_arg: TypeAlias = Content_646.cv_arg
    cv_content: TypeAlias = Content_646

    @property
    def content(self) -> Content_646:
        return self._get_content() # type: ignore

class Variation_357(Element):
    cv_arg: TypeAlias = RuleContent_646.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_646

    @classmethod
    def create(cls, arg: "Variation_357.cv_arg") -> "Variation_357":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_646:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_646:
        return self.rule.content

class RuleVariation_350(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_357.cv_arg
    cv_variation: TypeAlias = Variation_357

    @classmethod
    def create(cls, arg : "RuleVariation_350.cv_arg") -> "RuleVariation_350":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_357:
        return self.arg # type: ignore

class NonSpare_2047(NonSpare):
    cv_arg: TypeAlias = RuleVariation_350.cv_arg
    cv_name = "VV"
    cv_title = "Vertical Velocity"
    cv_rule: TypeAlias = RuleVariation_350

    @classmethod
    def create(cls, arg : "NonSpare_2047.cv_arg") -> "NonSpare_2047":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_350:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_357:
        return self.rule.variation

class NonSpare_1628(NonSpare):
    cv_arg: TypeAlias = RuleVariation_309.cv_arg
    cv_name = "RSVV"
    cv_title = "Vertical Velocity Resolution"
    cv_rule: TypeAlias = RuleVariation_309

    @classmethod
    def create(cls, arg : "NonSpare_1628.cv_arg") -> "NonSpare_1628":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class NonSpare_1697(NonSpare):
    cv_arg: TypeAlias = RuleVariation_309.cv_arg
    cv_name = "SDVV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_309

    @classmethod
    def create(cls, arg : "NonSpare_1697.cv_arg") -> "NonSpare_1697":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_309:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_316:
        return self.rule.variation

class Item_877(Item):
    cv_arg: TypeAlias = NonSpare_1697.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1697

    @classmethod
    def create(cls, arg : "Item_877.cv_arg") -> "Item_877":
        return cls._create(arg) # type: ignore

class NonSpare_809(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COVVGH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_809.cv_arg") -> "NonSpare_809":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_204(Item):
    cv_arg: TypeAlias = NonSpare_809.cv_arg
    cv_non_spare: TypeAlias = NonSpare_809

    @classmethod
    def create(cls, arg : "Item_204.cv_arg") -> "Item_204":
        return cls._create(arg) # type: ignore

class Variation_1209(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_309.cv_arg, Tuple[Literal["SDVV"], RuleVariation_309.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COVVGH"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1209.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_877, 16), (Item_204, 8)]
    cv_items_dict = {"SDVV": RuleVariation_309, "COVVGH": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDVV"]) -> RuleVariation_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVGH"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDVV"], Literal["COVVGH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDVV"]) -> RuleVariation_309:
        ...
    @overload
    def get_item(self, key : Literal["COVVGH"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1209.cv_arg") -> 'Variation_1209':
        return cls._create(arg) # type: ignore

class RuleVariation_1153(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1209.cv_arg
    cv_variation: TypeAlias = Variation_1209

    @classmethod
    def create(cls, arg : "RuleVariation_1153.cv_arg") -> "RuleVariation_1153":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1209:
        return self.arg # type: ignore

class NonSpare_1698(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1153.cv_arg
    cv_name = "SDVV"
    cv_title = "Vertical Velocity Precision"
    cv_rule: TypeAlias = RuleVariation_1153

    @classmethod
    def create(cls, arg : "NonSpare_1698.cv_arg") -> "NonSpare_1698":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1153:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1209:
        return self.rule.variation

class NonSpare_2077(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2077.cv_arg") -> "NonSpare_2077":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1178(Item):
    cv_arg: TypeAlias = NonSpare_2077.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2077

    @classmethod
    def create(cls, arg : "Item_1178.cv_arg") -> "Item_1178":
        return cls._create(arg) # type: ignore

class NonSpare_2131(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2131.cv_arg") -> "NonSpare_2131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1229(Item):
    cv_arg: TypeAlias = NonSpare_2131.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2131

    @classmethod
    def create(cls, arg : "Item_1229.cv_arg") -> "Item_1229":
        return cls._create(arg) # type: ignore

class Variation_1291(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1291.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1178, 8), (Item_1229, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1291.cv_arg") -> 'Variation_1291':
        return cls._create(arg) # type: ignore

class RuleVariation_1220(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1291.cv_arg
    cv_variation: TypeAlias = Variation_1291

    @classmethod
    def create(cls, arg : "RuleVariation_1220.cv_arg") -> "RuleVariation_1220":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1291:
        return self.arg # type: ignore

class NonSpare_811(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1220.cv_arg
    cv_name = "COVVHP"
    cv_title = "Correlation of Vertical Velocity and Horizontal Position"
    cv_rule: TypeAlias = RuleVariation_1220

    @classmethod
    def create(cls, arg : "NonSpare_811.cv_arg") -> "NonSpare_811":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1291:
        return self.rule.variation

class NonSpare_2078(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2078.cv_arg") -> "NonSpare_2078":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1179(Item):
    cv_arg: TypeAlias = NonSpare_2078.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2078

    @classmethod
    def create(cls, arg : "Item_1179.cv_arg") -> "Item_1179":
        return cls._create(arg) # type: ignore

class NonSpare_2132(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2132.cv_arg") -> "NonSpare_2132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1230(Item):
    cv_arg: TypeAlias = NonSpare_2132.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2132

    @classmethod
    def create(cls, arg : "Item_1230.cv_arg") -> "Item_1230":
        return cls._create(arg) # type: ignore

class Variation_1292(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1292.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1179, 8), (Item_1230, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1292.cv_arg") -> 'Variation_1292':
        return cls._create(arg) # type: ignore

class RuleVariation_1221(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1292.cv_arg
    cv_variation: TypeAlias = Variation_1292

    @classmethod
    def create(cls, arg : "RuleVariation_1221.cv_arg") -> "RuleVariation_1221":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1292:
        return self.arg # type: ignore

class NonSpare_812(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1221.cv_arg
    cv_name = "COVVHV"
    cv_title = "Correlation of Vertical Velocity and Horizontal Velocity"
    cv_rule: TypeAlias = RuleVariation_1221

    @classmethod
    def create(cls, arg : "NonSpare_812.cv_arg") -> "NonSpare_812":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1221:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1292:
        return self.rule.variation

class NonSpare_2079(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2079.cv_arg") -> "NonSpare_2079":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1180(Item):
    cv_arg: TypeAlias = NonSpare_2079.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2079

    @classmethod
    def create(cls, arg : "Item_1180.cv_arg") -> "Item_1180":
        return cls._create(arg) # type: ignore

class NonSpare_2130(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2130.cv_arg") -> "NonSpare_2130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1228(Item):
    cv_arg: TypeAlias = NonSpare_2130.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2130

    @classmethod
    def create(cls, arg : "Item_1228.cv_arg") -> "Item_1228":
        return cls._create(arg) # type: ignore

class Variation_1293(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1293.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1180, 8), (Item_1228, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1293.cv_arg") -> 'Variation_1293':
        return cls._create(arg) # type: ignore

class RuleVariation_1222(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1293.cv_arg
    cv_variation: TypeAlias = Variation_1293

    @classmethod
    def create(cls, arg : "RuleVariation_1222.cv_arg") -> "RuleVariation_1222":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1293:
        return self.arg # type: ignore

class NonSpare_810(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1222.cv_arg
    cv_name = "COVVHA"
    cv_title = "Correlation of Vertical Velocity and Horizontal Acceleration"
    cv_rule: TypeAlias = RuleVariation_1222

    @classmethod
    def create(cls, arg : "NonSpare_810.cv_arg") -> "NonSpare_810":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1293:
        return self.rule.variation

class Variation_1519(Compound):
    cv_arg = TypedDict('cv_arg', {
        "VV": NonSpare_2047.cv_arg,
        "RSVV": NonSpare_1628.cv_arg,
        "SDVV": NonSpare_1698.cv_arg,
        "COVVHP": NonSpare_811.cv_arg,
        "COVVHV": NonSpare_812.cv_arg,
        "COVVHA": NonSpare_810.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_2047, NonSpare_1628, NonSpare_1698, NonSpare_811, NonSpare_812, NonSpare_810]
    cv_items_dict = {"VV": NonSpare_2047, "RSVV": NonSpare_1628, "SDVV": NonSpare_1698, "COVVHP": NonSpare_811, "COVVHV": NonSpare_812, "COVVHA": NonSpare_810}

    @overload
    @classmethod
    def spec(cls, key : Literal["VV"]) -> NonSpare_2047:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSVV"]) -> NonSpare_1628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDVV"]) -> NonSpare_1698:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVHP"]) -> NonSpare_811:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVHV"]) -> NonSpare_812:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVVHA"]) -> NonSpare_810:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VV"], Literal["RSVV"], Literal["SDVV"], Literal["COVVHP"], Literal["COVVHV"], Literal["COVVHA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VV"]) -> Optional[NonSpare_2047]:
        ...
    @overload
    def get_item(self, key : Literal["RSVV"]) -> Optional[NonSpare_1628]:
        ...
    @overload
    def get_item(self, key : Literal["SDVV"]) -> Optional[NonSpare_1698]:
        ...
    @overload
    def get_item(self, key : Literal["COVVHP"]) -> Optional[NonSpare_811]:
        ...
    @overload
    def get_item(self, key : Literal["COVVHV"]) -> Optional[NonSpare_812]:
        ...
    @overload
    def get_item(self, key : Literal["COVVHA"]) -> Optional[NonSpare_810]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["VV"], val : NonSpare_2047.cv_arg) -> "Variation_1519":
        ...
    @overload
    def set_item(self, key : Literal["RSVV"], val : NonSpare_1628.cv_arg) -> "Variation_1519":
        ...
    @overload
    def set_item(self, key : Literal["SDVV"], val : NonSpare_1698.cv_arg) -> "Variation_1519":
        ...
    @overload
    def set_item(self, key : Literal["COVVHP"], val : NonSpare_811.cv_arg) -> "Variation_1519":
        ...
    @overload
    def set_item(self, key : Literal["COVVHV"], val : NonSpare_812.cv_arg) -> "Variation_1519":
        ...
    @overload
    def set_item(self, key : Literal["COVVHA"], val : NonSpare_810.cv_arg) -> "Variation_1519":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["VV"]) -> "Variation_1519":
        ...
    @overload
    def del_item(self, key : Literal["RSVV"]) -> "Variation_1519":
        ...
    @overload
    def del_item(self, key : Literal["SDVV"]) -> "Variation_1519":
        ...
    @overload
    def del_item(self, key : Literal["COVVHP"]) -> "Variation_1519":
        ...
    @overload
    def del_item(self, key : Literal["COVVHV"]) -> "Variation_1519":
        ...
    @overload
    def del_item(self, key : Literal["COVVHA"]) -> "Variation_1519":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1519.cv_arg") -> 'Variation_1519':
        return cls._create(arg) # type: ignore

class RuleVariation_1440(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1519.cv_arg
    cv_variation: TypeAlias = Variation_1519

    @classmethod
    def create(cls, arg : "RuleVariation_1440.cv_arg") -> "RuleVariation_1440":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1519:
        return self.arg # type: ignore

class NonSpare_535(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1440.cv_arg
    cv_name = "604"
    cv_title = "Vertical Velocity Information"
    cv_rule: TypeAlias = RuleVariation_1440

    @classmethod
    def create(cls, arg : "NonSpare_535.cv_arg") -> "NonSpare_535":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1440:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1519:
        return self.rule.variation

class UapItem_534(UapItem):
    cv_non_spare: TypeAlias = NonSpare_535

class Content_648(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_648(RuleContentContextFree):
    cv_arg: TypeAlias = Content_648.cv_arg
    cv_content: TypeAlias = Content_648

    @property
    def content(self) -> Content_648:
        return self._get_content() # type: ignore

class Variation_268(Element):
    cv_arg: TypeAlias = RuleContent_648.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_648

    @classmethod
    def create(cls, arg: "Variation_268.cv_arg") -> "Variation_268":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_648:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_648:
        return self.rule.content

class RuleVariation_261(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_268.cv_arg
    cv_variation: TypeAlias = Variation_268

    @classmethod
    def create(cls, arg : "RuleVariation_261.cv_arg") -> "RuleVariation_261":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_268:
        return self.arg # type: ignore

class NonSpare_1994(NonSpare):
    cv_arg: TypeAlias = RuleVariation_261.cv_arg
    cv_name = "VA"
    cv_title = "Vertical Acceleration"
    cv_rule: TypeAlias = RuleVariation_261

    @classmethod
    def create(cls, arg : "NonSpare_1994.cv_arg") -> "NonSpare_1994":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_261:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_268:
        return self.rule.variation

class Content_747(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_747(RuleContentContextFree):
    cv_arg: TypeAlias = Content_747.cv_arg
    cv_content: TypeAlias = Content_747

    @property
    def content(self) -> Content_747:
        return self._get_content() # type: ignore

class Variation_317(Element):
    cv_arg: TypeAlias = RuleContent_747.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_747

    @classmethod
    def create(cls, arg: "Variation_317.cv_arg") -> "Variation_317":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_747:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_747:
        return self.rule.content

class RuleVariation_310(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_317.cv_arg
    cv_variation: TypeAlias = Variation_317

    @classmethod
    def create(cls, arg : "RuleVariation_310.cv_arg") -> "RuleVariation_310":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_317:
        return self.arg # type: ignore

class NonSpare_1696(NonSpare):
    cv_arg: TypeAlias = RuleVariation_310.cv_arg
    cv_name = "SDVA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_310

    @classmethod
    def create(cls, arg : "NonSpare_1696.cv_arg") -> "NonSpare_1696":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_310:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_317:
        return self.rule.variation

class Item_876(Item):
    cv_arg: TypeAlias = NonSpare_1696.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1696

    @classmethod
    def create(cls, arg : "Item_876.cv_arg") -> "Item_876":
        return cls._create(arg) # type: ignore

class NonSpare_803(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COVAGH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_803.cv_arg") -> "NonSpare_803":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_201(Item):
    cv_arg: TypeAlias = NonSpare_803.cv_arg
    cv_non_spare: TypeAlias = NonSpare_803

    @classmethod
    def create(cls, arg : "Item_201.cv_arg") -> "Item_201":
        return cls._create(arg) # type: ignore

class NonSpare_807(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COVAVV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_807.cv_arg") -> "NonSpare_807":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_202(Item):
    cv_arg: TypeAlias = NonSpare_807.cv_arg
    cv_non_spare: TypeAlias = NonSpare_807

    @classmethod
    def create(cls, arg : "Item_202.cv_arg") -> "Item_202":
        return cls._create(arg) # type: ignore

class Variation_1208(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_310.cv_arg, Tuple[Literal["SDVA"], RuleVariation_310.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COVAGH"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COVAVV"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1208.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_876, 16), (Item_201, 8), (Item_202, 8)]
    cv_items_dict = {"SDVA": RuleVariation_310, "COVAGH": RuleVariation_207, "COVAVV": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDVA"]) -> RuleVariation_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAGH"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAVV"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDVA"], Literal["COVAGH"], Literal["COVAVV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDVA"]) -> RuleVariation_310:
        ...
    @overload
    def get_item(self, key : Literal["COVAGH"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["COVAVV"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1208.cv_arg") -> 'Variation_1208':
        return cls._create(arg) # type: ignore

class RuleVariation_1152(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1208.cv_arg
    cv_variation: TypeAlias = Variation_1208

    @classmethod
    def create(cls, arg : "RuleVariation_1152.cv_arg") -> "RuleVariation_1152":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1208:
        return self.arg # type: ignore

class NonSpare_1627(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1152.cv_arg
    cv_name = "RSVA"
    cv_title = "Vertical Acceleration Precision"
    cv_rule: TypeAlias = RuleVariation_1152

    @classmethod
    def create(cls, arg : "NonSpare_1627.cv_arg") -> "NonSpare_1627":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1152:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1208:
        return self.rule.variation

class NonSpare_2075(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2075.cv_arg") -> "NonSpare_2075":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1176(Item):
    cv_arg: TypeAlias = NonSpare_2075.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2075

    @classmethod
    def create(cls, arg : "Item_1176.cv_arg") -> "Item_1176":
        return cls._create(arg) # type: ignore

class NonSpare_2128(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2128.cv_arg") -> "NonSpare_2128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1226(Item):
    cv_arg: TypeAlias = NonSpare_2128.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2128

    @classmethod
    def create(cls, arg : "Item_1226.cv_arg") -> "Item_1226":
        return cls._create(arg) # type: ignore

class Variation_1289(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1289.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1176, 8), (Item_1226, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1289.cv_arg") -> 'Variation_1289':
        return cls._create(arg) # type: ignore

class RuleVariation_1218(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1289.cv_arg
    cv_variation: TypeAlias = Variation_1289

    @classmethod
    def create(cls, arg : "RuleVariation_1218.cv_arg") -> "RuleVariation_1218":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1289:
        return self.arg # type: ignore

class NonSpare_805(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1218.cv_arg
    cv_name = "COVAHP"
    cv_title = "Correlation of Vertical Acceleration and Horizontal Position"
    cv_rule: TypeAlias = RuleVariation_1218

    @classmethod
    def create(cls, arg : "NonSpare_805.cv_arg") -> "NonSpare_805":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1218:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1289:
        return self.rule.variation

class NonSpare_2076(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2076.cv_arg") -> "NonSpare_2076":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1177(Item):
    cv_arg: TypeAlias = NonSpare_2076.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2076

    @classmethod
    def create(cls, arg : "Item_1177.cv_arg") -> "Item_1177":
        return cls._create(arg) # type: ignore

class NonSpare_2129(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2129.cv_arg") -> "NonSpare_2129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1227(Item):
    cv_arg: TypeAlias = NonSpare_2129.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2129

    @classmethod
    def create(cls, arg : "Item_1227.cv_arg") -> "Item_1227":
        return cls._create(arg) # type: ignore

class Variation_1290(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1290.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1177, 8), (Item_1227, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1290.cv_arg") -> 'Variation_1290':
        return cls._create(arg) # type: ignore

class RuleVariation_1219(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1290.cv_arg
    cv_variation: TypeAlias = Variation_1290

    @classmethod
    def create(cls, arg : "RuleVariation_1219.cv_arg") -> "RuleVariation_1219":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1290:
        return self.arg # type: ignore

class NonSpare_806(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1219.cv_arg
    cv_name = "COVAHV"
    cv_title = "Correlation of Vertical Acceleration and Horizontal Velocity"
    cv_rule: TypeAlias = RuleVariation_1219

    @classmethod
    def create(cls, arg : "NonSpare_806.cv_arg") -> "NonSpare_806":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1219:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1290:
        return self.rule.variation

class NonSpare_2074(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "X"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2074.cv_arg") -> "NonSpare_2074":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1175(Item):
    cv_arg: TypeAlias = NonSpare_2074.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2074

    @classmethod
    def create(cls, arg : "Item_1175.cv_arg") -> "Item_1175":
        return cls._create(arg) # type: ignore

class NonSpare_2127(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "Y"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_2127.cv_arg") -> "NonSpare_2127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_1225(Item):
    cv_arg: TypeAlias = NonSpare_2127.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2127

    @classmethod
    def create(cls, arg : "Item_1225.cv_arg") -> "Item_1225":
        return cls._create(arg) # type: ignore

class Variation_1288(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_207.cv_arg, Tuple[Literal["X"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["Y"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1288.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1175, 8), (Item_1225, 8)]
    cv_items_dict = {"X": RuleVariation_207, "Y": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1288.cv_arg") -> 'Variation_1288':
        return cls._create(arg) # type: ignore

class RuleVariation_1217(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1288.cv_arg
    cv_variation: TypeAlias = Variation_1288

    @classmethod
    def create(cls, arg : "RuleVariation_1217.cv_arg") -> "RuleVariation_1217":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1288:
        return self.arg # type: ignore

class NonSpare_804(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1217.cv_arg
    cv_name = "COVAHA"
    cv_title = "Correlation of Vertical Acceleration and Horizontal Acceleration"
    cv_rule: TypeAlias = RuleVariation_1217

    @classmethod
    def create(cls, arg : "NonSpare_804.cv_arg") -> "NonSpare_804":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1217:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1288:
        return self.rule.variation

class Variation_1518(Compound):
    cv_arg = TypedDict('cv_arg', {
        "VA": NonSpare_1994.cv_arg,
        "RSVA": NonSpare_1627.cv_arg,
        "COVAHP": NonSpare_805.cv_arg,
        "COVAHV": NonSpare_806.cv_arg,
        "COVAHA": NonSpare_804.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1994, NonSpare_1627, NonSpare_805, NonSpare_806, NonSpare_804]
    cv_items_dict = {"VA": NonSpare_1994, "RSVA": NonSpare_1627, "COVAHP": NonSpare_805, "COVAHV": NonSpare_806, "COVAHA": NonSpare_804}

    @overload
    @classmethod
    def spec(cls, key : Literal["VA"]) -> NonSpare_1994:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSVA"]) -> NonSpare_1627:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAHP"]) -> NonSpare_805:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAHV"]) -> NonSpare_806:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVAHA"]) -> NonSpare_804:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VA"], Literal["RSVA"], Literal["COVAHP"], Literal["COVAHV"], Literal["COVAHA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VA"]) -> Optional[NonSpare_1994]:
        ...
    @overload
    def get_item(self, key : Literal["RSVA"]) -> Optional[NonSpare_1627]:
        ...
    @overload
    def get_item(self, key : Literal["COVAHP"]) -> Optional[NonSpare_805]:
        ...
    @overload
    def get_item(self, key : Literal["COVAHV"]) -> Optional[NonSpare_806]:
        ...
    @overload
    def get_item(self, key : Literal["COVAHA"]) -> Optional[NonSpare_804]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["VA"], val : NonSpare_1994.cv_arg) -> "Variation_1518":
        ...
    @overload
    def set_item(self, key : Literal["RSVA"], val : NonSpare_1627.cv_arg) -> "Variation_1518":
        ...
    @overload
    def set_item(self, key : Literal["COVAHP"], val : NonSpare_805.cv_arg) -> "Variation_1518":
        ...
    @overload
    def set_item(self, key : Literal["COVAHV"], val : NonSpare_806.cv_arg) -> "Variation_1518":
        ...
    @overload
    def set_item(self, key : Literal["COVAHA"], val : NonSpare_804.cv_arg) -> "Variation_1518":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["VA"]) -> "Variation_1518":
        ...
    @overload
    def del_item(self, key : Literal["RSVA"]) -> "Variation_1518":
        ...
    @overload
    def del_item(self, key : Literal["COVAHP"]) -> "Variation_1518":
        ...
    @overload
    def del_item(self, key : Literal["COVAHV"]) -> "Variation_1518":
        ...
    @overload
    def del_item(self, key : Literal["COVAHA"]) -> "Variation_1518":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1518.cv_arg") -> 'Variation_1518':
        return cls._create(arg) # type: ignore

class RuleVariation_1439(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1518.cv_arg
    cv_variation: TypeAlias = Variation_1518

    @classmethod
    def create(cls, arg : "RuleVariation_1439.cv_arg") -> "RuleVariation_1439":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1518:
        return self.arg # type: ignore

class NonSpare_537(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1439.cv_arg
    cv_name = "605"
    cv_title = "Vertical Velocity Information"
    cv_rule: TypeAlias = RuleVariation_1439

    @classmethod
    def create(cls, arg : "NonSpare_537.cv_arg") -> "NonSpare_537":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1439:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1518:
        return self.rule.variation

class UapItem_536(UapItem):
    cv_non_spare: TypeAlias = NonSpare_537

class Variation_388(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_388.cv_arg") -> "Variation_388":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class Variation_1403(Repetitive):
    cv_arg: TypeAlias = List[Variation_388.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_388

    @classmethod
    def create(cls, arg: "Variation_1403.cv_arg") -> 'Variation_1403':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_388]:
        return self._get_list() # type: ignore

class RuleVariation_1324(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1403.cv_arg
    cv_variation: TypeAlias = Variation_1403

    @classmethod
    def create(cls, arg : "RuleVariation_1324.cv_arg") -> "RuleVariation_1324":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1403:
        return self.arg # type: ignore

class NonSpare_512(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1324.cv_arg
    cv_name = "480"
    cv_title = "Associations"
    cv_rule: TypeAlias = RuleVariation_1324

    @classmethod
    def create(cls, arg : "NonSpare_512.cv_arg") -> "NonSpare_512":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1324:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1403:
        return self.rule.variation

class UapItem_511(UapItem):
    cv_non_spare: TypeAlias = NonSpare_512

class Content_641(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.1
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_641(RuleContentContextFree):
    cv_arg: TypeAlias = Content_641.cv_arg
    cv_content: TypeAlias = Content_641

    @property
    def content(self) -> Content_641:
        return self._get_content() # type: ignore

class Variation_354(Element):
    cv_arg: TypeAlias = RuleContent_641.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_641

    @classmethod
    def create(cls, arg: "Variation_354.cv_arg") -> "Variation_354":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_641:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_641:
        return self.rule.content

class RuleVariation_347(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_354.cv_arg
    cv_variation: TypeAlias = Variation_354

    @classmethod
    def create(cls, arg : "RuleVariation_347.cv_arg") -> "RuleVariation_347":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_354:
        return self.arg # type: ignore

class NonSpare_1532(NonSpare):
    cv_arg: TypeAlias = RuleVariation_347.cv_arg
    cv_name = "R"
    cv_title = "Range"
    cv_rule: TypeAlias = RuleVariation_347

    @classmethod
    def create(cls, arg : "NonSpare_1532.cv_arg") -> "NonSpare_1532":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_347:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_354:
        return self.rule.variation

class Content_737(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_737(RuleContentContextFree):
    cv_arg: TypeAlias = Content_737.cv_arg
    cv_content: TypeAlias = Content_737

    @property
    def content(self) -> Content_737:
        return self._get_content() # type: ignore

class Variation_367(Element):
    cv_arg: TypeAlias = RuleContent_737.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_737

    @classmethod
    def create(cls, arg: "Variation_367.cv_arg") -> "Variation_367":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_737:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_737:
        return self.rule.content

class RuleVariation_360(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_367.cv_arg
    cv_variation: TypeAlias = Variation_367

    @classmethod
    def create(cls, arg : "RuleVariation_360.cv_arg") -> "RuleVariation_360":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_367:
        return self.arg # type: ignore

class NonSpare_1624(NonSpare):
    cv_arg: TypeAlias = RuleVariation_360.cv_arg
    cv_name = "RSR"
    cv_title = "Range Resolution"
    cv_rule: TypeAlias = RuleVariation_360

    @classmethod
    def create(cls, arg : "NonSpare_1624.cv_arg") -> "NonSpare_1624":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_360:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_367:
        return self.rule.variation

class NonSpare_1690(NonSpare):
    cv_arg: TypeAlias = RuleVariation_360.cv_arg
    cv_name = "SDR"
    cv_title = "Range Precision"
    cv_rule: TypeAlias = RuleVariation_360

    @classmethod
    def create(cls, arg : "NonSpare_1690.cv_arg") -> "NonSpare_1690":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_360:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_367:
        return self.rule.variation

class Content_643(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_643(RuleContentContextFree):
    cv_arg: TypeAlias = Content_643.cv_arg
    cv_content: TypeAlias = Content_643

    @property
    def content(self) -> Content_643:
        return self._get_content() # type: ignore

class Variation_355(Element):
    cv_arg: TypeAlias = RuleContent_643.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_643

    @classmethod
    def create(cls, arg: "Variation_355.cv_arg") -> "Variation_355":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_643:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_643:
        return self.rule.content

class RuleVariation_348(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_355.cv_arg
    cv_variation: TypeAlias = Variation_355

    @classmethod
    def create(cls, arg : "RuleVariation_348.cv_arg") -> "RuleVariation_348":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_355:
        return self.arg # type: ignore

class NonSpare_1610(NonSpare):
    cv_arg: TypeAlias = RuleVariation_348.cv_arg
    cv_name = "RR"
    cv_title = "Range Rate"
    cv_rule: TypeAlias = RuleVariation_348

    @classmethod
    def create(cls, arg : "NonSpare_1610.cv_arg") -> "NonSpare_1610":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_348:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_355:
        return self.rule.variation

class Content_739(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_739(RuleContentContextFree):
    cv_arg: TypeAlias = Content_739.cv_arg
    cv_content: TypeAlias = Content_739

    @property
    def content(self) -> Content_739:
        return self._get_content() # type: ignore

class Variation_368(Element):
    cv_arg: TypeAlias = RuleContent_739.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_739

    @classmethod
    def create(cls, arg: "Variation_368.cv_arg") -> "Variation_368":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_739:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_739:
        return self.rule.content

class RuleVariation_361(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_368.cv_arg
    cv_variation: TypeAlias = Variation_368

    @classmethod
    def create(cls, arg : "RuleVariation_361.cv_arg") -> "RuleVariation_361":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_368:
        return self.arg # type: ignore

class NonSpare_1625(NonSpare):
    cv_arg: TypeAlias = RuleVariation_361.cv_arg
    cv_name = "RSRR"
    cv_title = "Range Rate Resolution"
    cv_rule: TypeAlias = RuleVariation_361

    @classmethod
    def create(cls, arg : "NonSpare_1625.cv_arg") -> "NonSpare_1625":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class NonSpare_1693(NonSpare):
    cv_arg: TypeAlias = RuleVariation_361.cv_arg
    cv_name = "SDRR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_361

    @classmethod
    def create(cls, arg : "NonSpare_1693.cv_arg") -> "NonSpare_1693":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_368:
        return self.rule.variation

class Item_874(Item):
    cv_arg: TypeAlias = NonSpare_1693.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1693

    @classmethod
    def create(cls, arg : "Item_874.cv_arg") -> "Item_874":
        return cls._create(arg) # type: ignore

class NonSpare_795(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CORRR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_795.cv_arg") -> "NonSpare_795":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_194(Item):
    cv_arg: TypeAlias = NonSpare_795.cv_arg
    cv_non_spare: TypeAlias = NonSpare_795

    @classmethod
    def create(cls, arg : "Item_194.cv_arg") -> "Item_194":
        return cls._create(arg) # type: ignore

class Variation_1207(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_361.cv_arg, Tuple[Literal["SDRR"], RuleVariation_361.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["CORRR"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1207.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_874, 24), (Item_194, 8)]
    cv_items_dict = {"SDRR": RuleVariation_361, "CORRR": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDRR"]) -> RuleVariation_361:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORRR"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDRR"], Literal["CORRR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDRR"]) -> RuleVariation_361:
        ...
    @overload
    def get_item(self, key : Literal["CORRR"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1207.cv_arg") -> 'Variation_1207':
        return cls._create(arg) # type: ignore

class RuleVariation_1151(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1207.cv_arg
    cv_variation: TypeAlias = Variation_1207

    @classmethod
    def create(cls, arg : "RuleVariation_1151.cv_arg") -> "RuleVariation_1151":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1207:
        return self.arg # type: ignore

class NonSpare_1694(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1151.cv_arg
    cv_name = "SDRR"
    cv_title = "Range Rate Precision"
    cv_rule: TypeAlias = RuleVariation_1151

    @classmethod
    def create(cls, arg : "NonSpare_1694.cv_arg") -> "NonSpare_1694":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1151:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1207:
        return self.rule.variation

class Content_675(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.5625e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_675(RuleContentContextFree):
    cv_arg: TypeAlias = Content_675.cv_arg
    cv_content: TypeAlias = Content_675

    @property
    def content(self) -> Content_675:
        return self._get_content() # type: ignore

class Variation_285(Element):
    cv_arg: TypeAlias = RuleContent_675.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_675

    @classmethod
    def create(cls, arg: "Variation_285.cv_arg") -> "Variation_285":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_675:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_675:
        return self.rule.content

class RuleVariation_278(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_285.cv_arg
    cv_variation: TypeAlias = Variation_285

    @classmethod
    def create(cls, arg : "RuleVariation_278.cv_arg") -> "RuleVariation_278":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_285:
        return self.arg # type: ignore

class NonSpare_1534(NonSpare):
    cv_arg: TypeAlias = RuleVariation_278.cv_arg
    cv_name = "RA"
    cv_title = "Range Acceleration"
    cv_rule: TypeAlias = RuleVariation_278

    @classmethod
    def create(cls, arg : "NonSpare_1534.cv_arg") -> "NonSpare_1534":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_285:
        return self.rule.variation

class Content_769(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_768(RuleContentContextFree):
    cv_arg: TypeAlias = Content_769.cv_arg
    cv_content: TypeAlias = Content_769

    @property
    def content(self) -> Content_769:
        return self._get_content() # type: ignore

class Variation_333(Element):
    cv_arg: TypeAlias = RuleContent_768.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_768

    @classmethod
    def create(cls, arg: "Variation_333.cv_arg") -> "Variation_333":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_768:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_769:
        return self.rule.content

class RuleVariation_326(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_333.cv_arg
    cv_variation: TypeAlias = Variation_333

    @classmethod
    def create(cls, arg : "RuleVariation_326.cv_arg") -> "RuleVariation_326":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_333:
        return self.arg # type: ignore

class NonSpare_1691(NonSpare):
    cv_arg: TypeAlias = RuleVariation_326.cv_arg
    cv_name = "SDRA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_326

    @classmethod
    def create(cls, arg : "NonSpare_1691.cv_arg") -> "NonSpare_1691":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_326:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_333:
        return self.rule.variation

class Item_873(Item):
    cv_arg: TypeAlias = NonSpare_1691.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1691

    @classmethod
    def create(cls, arg : "Item_873.cv_arg") -> "Item_873":
        return cls._create(arg) # type: ignore

class NonSpare_793(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CORAR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_793.cv_arg") -> "NonSpare_793":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_192(Item):
    cv_arg: TypeAlias = NonSpare_793.cv_arg
    cv_non_spare: TypeAlias = NonSpare_793

    @classmethod
    def create(cls, arg : "Item_192.cv_arg") -> "Item_192":
        return cls._create(arg) # type: ignore

class NonSpare_794(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CORARR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_794.cv_arg") -> "NonSpare_794":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_193(Item):
    cv_arg: TypeAlias = NonSpare_794.cv_arg
    cv_non_spare: TypeAlias = NonSpare_794

    @classmethod
    def create(cls, arg : "Item_193.cv_arg") -> "Item_193":
        return cls._create(arg) # type: ignore

class Variation_1206(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_326.cv_arg, Tuple[Literal["SDRA"], RuleVariation_326.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["CORAR"], RuleVariation_207.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["CORARR"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1206.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_873, 16), (Item_192, 8), (Item_193, 8)]
    cv_items_dict = {"SDRA": RuleVariation_326, "CORAR": RuleVariation_207, "CORARR": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDRA"]) -> RuleVariation_326:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORAR"]) -> RuleVariation_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CORARR"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDRA"], Literal["CORAR"], Literal["CORARR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDRA"]) -> RuleVariation_326:
        ...
    @overload
    def get_item(self, key : Literal["CORAR"]) -> RuleVariation_207:
        ...
    @overload
    def get_item(self, key : Literal["CORARR"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1206.cv_arg") -> 'Variation_1206':
        return cls._create(arg) # type: ignore

class RuleVariation_1150(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1206.cv_arg
    cv_variation: TypeAlias = Variation_1206

    @classmethod
    def create(cls, arg : "RuleVariation_1150.cv_arg") -> "RuleVariation_1150":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1206:
        return self.arg # type: ignore

class NonSpare_1692(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1150.cv_arg
    cv_name = "SDRA"
    cv_title = "Range Acceleration Precision"
    cv_rule: TypeAlias = RuleVariation_1150

    @classmethod
    def create(cls, arg : "NonSpare_1692.cv_arg") -> "NonSpare_1692":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1150:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1206:
        return self.rule.variation

class Variation_1504(Compound):
    cv_arg = TypedDict('cv_arg', {
        "R": NonSpare_1532.cv_arg,
        "RSR": NonSpare_1624.cv_arg,
        "SDR": NonSpare_1690.cv_arg,
        "RR": NonSpare_1610.cv_arg,
        "RSRR": NonSpare_1625.cv_arg,
        "SDRR": NonSpare_1694.cv_arg,
        "RA": NonSpare_1534.cv_arg,
        "SDRA": NonSpare_1692.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1532, NonSpare_1624, NonSpare_1690, NonSpare_1610, NonSpare_1625, NonSpare_1694, NonSpare_1534, NonSpare_1692]
    cv_items_dict = {"R": NonSpare_1532, "RSR": NonSpare_1624, "SDR": NonSpare_1690, "RR": NonSpare_1610, "RSRR": NonSpare_1625, "SDRR": NonSpare_1694, "RA": NonSpare_1534, "SDRA": NonSpare_1692}

    @overload
    @classmethod
    def spec(cls, key : Literal["R"]) -> NonSpare_1532:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSR"]) -> NonSpare_1624:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDR"]) -> NonSpare_1690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RR"]) -> NonSpare_1610:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSRR"]) -> NonSpare_1625:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDRR"]) -> NonSpare_1694:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RA"]) -> NonSpare_1534:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDRA"]) -> NonSpare_1692:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["R"], Literal["RSR"], Literal["SDR"], Literal["RR"], Literal["RSRR"], Literal["SDRR"], Literal["RA"], Literal["SDRA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["R"]) -> Optional[NonSpare_1532]:
        ...
    @overload
    def get_item(self, key : Literal["RSR"]) -> Optional[NonSpare_1624]:
        ...
    @overload
    def get_item(self, key : Literal["SDR"]) -> Optional[NonSpare_1690]:
        ...
    @overload
    def get_item(self, key : Literal["RR"]) -> Optional[NonSpare_1610]:
        ...
    @overload
    def get_item(self, key : Literal["RSRR"]) -> Optional[NonSpare_1625]:
        ...
    @overload
    def get_item(self, key : Literal["SDRR"]) -> Optional[NonSpare_1694]:
        ...
    @overload
    def get_item(self, key : Literal["RA"]) -> Optional[NonSpare_1534]:
        ...
    @overload
    def get_item(self, key : Literal["SDRA"]) -> Optional[NonSpare_1692]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["R"], val : NonSpare_1532.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["RSR"], val : NonSpare_1624.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["SDR"], val : NonSpare_1690.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["RR"], val : NonSpare_1610.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["RSRR"], val : NonSpare_1625.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["SDRR"], val : NonSpare_1694.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["RA"], val : NonSpare_1534.cv_arg) -> "Variation_1504":
        ...
    @overload
    def set_item(self, key : Literal["SDRA"], val : NonSpare_1692.cv_arg) -> "Variation_1504":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["R"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["RSR"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["SDR"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["RR"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["RSRR"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["SDRR"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["RA"]) -> "Variation_1504":
        ...
    @overload
    def del_item(self, key : Literal["SDRA"]) -> "Variation_1504":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1504.cv_arg") -> 'Variation_1504':
        return cls._create(arg) # type: ignore

class RuleVariation_1425(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1504.cv_arg
    cv_variation: TypeAlias = Variation_1504

    @classmethod
    def create(cls, arg : "RuleVariation_1425.cv_arg") -> "RuleVariation_1425":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1504:
        return self.arg # type: ignore

class NonSpare_542(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1425.cv_arg
    cv_name = "625"
    cv_title = "Range Information"
    cv_rule: TypeAlias = RuleVariation_1425

    @classmethod
    def create(cls, arg : "NonSpare_542.cv_arg") -> "NonSpare_542":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1425:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1504:
        return self.rule.variation

class UapItem_541(UapItem):
    cv_non_spare: TypeAlias = NonSpare_542

class NonSpare_915(NonSpare):
    cv_arg: TypeAlias = RuleVariation_350.cv_arg
    cv_name = "DV"
    cv_title = "Doppler Velocity"
    cv_rule: TypeAlias = RuleVariation_350

    @classmethod
    def create(cls, arg : "NonSpare_915.cv_arg") -> "NonSpare_915":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_350:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_357:
        return self.rule.variation

class Content_764(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.5625e-2
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_763(RuleContentContextFree):
    cv_arg: TypeAlias = Content_764.cv_arg
    cv_content: TypeAlias = Content_764

    @property
    def content(self) -> Content_764:
        return self._get_content() # type: ignore

class Variation_328(Element):
    cv_arg: TypeAlias = RuleContent_763.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_763

    @classmethod
    def create(cls, arg: "Variation_328.cv_arg") -> "Variation_328":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_763:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_764:
        return self.rule.content

class RuleVariation_321(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_328.cv_arg
    cv_variation: TypeAlias = Variation_328

    @classmethod
    def create(cls, arg : "RuleVariation_321.cv_arg") -> "RuleVariation_321":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_328:
        return self.arg # type: ignore

class NonSpare_1679(NonSpare):
    cv_arg: TypeAlias = RuleVariation_321.cv_arg
    cv_name = "SDDV"
    cv_title = "Precision of Doppler Velocity"
    cv_rule: TypeAlias = RuleVariation_321

    @classmethod
    def create(cls, arg : "NonSpare_1679.cv_arg") -> "NonSpare_1679":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_328:
        return self.rule.variation

class NonSpare_859(NonSpare):
    cv_arg: TypeAlias = RuleVariation_278.cv_arg
    cv_name = "DA"
    cv_title = "Doppler Acceleration"
    cv_rule: TypeAlias = RuleVariation_278

    @classmethod
    def create(cls, arg : "NonSpare_859.cv_arg") -> "NonSpare_859":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_285:
        return self.rule.variation

class Content_765(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.5625e-2
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_764(RuleContentContextFree):
    cv_arg: TypeAlias = Content_765.cv_arg
    cv_content: TypeAlias = Content_765

    @property
    def content(self) -> Content_765:
        return self._get_content() # type: ignore

class Variation_329(Element):
    cv_arg: TypeAlias = RuleContent_764.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_764

    @classmethod
    def create(cls, arg: "Variation_329.cv_arg") -> "Variation_329":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_764:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_765:
        return self.rule.content

class RuleVariation_322(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_329.cv_arg
    cv_variation: TypeAlias = Variation_329

    @classmethod
    def create(cls, arg : "RuleVariation_322.cv_arg") -> "RuleVariation_322":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_329:
        return self.arg # type: ignore

class NonSpare_1677(NonSpare):
    cv_arg: TypeAlias = RuleVariation_322.cv_arg
    cv_name = "SDDA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_322

    @classmethod
    def create(cls, arg : "NonSpare_1677.cv_arg") -> "NonSpare_1677":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_322:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_329:
        return self.rule.variation

class Item_869(Item):
    cv_arg: TypeAlias = NonSpare_1677.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1677

    @classmethod
    def create(cls, arg : "Item_869.cv_arg") -> "Item_869":
        return cls._create(arg) # type: ignore

class NonSpare_754(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODADV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_754.cv_arg") -> "NonSpare_754":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_172(Item):
    cv_arg: TypeAlias = NonSpare_754.cv_arg
    cv_non_spare: TypeAlias = NonSpare_754

    @classmethod
    def create(cls, arg : "Item_172.cv_arg") -> "Item_172":
        return cls._create(arg) # type: ignore

class Variation_1203(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_322.cv_arg, Tuple[Literal["SDDA"], RuleVariation_322.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["CODADV"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1203.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_869, 16), (Item_172, 8)]
    cv_items_dict = {"SDDA": RuleVariation_322, "CODADV": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDDA"]) -> RuleVariation_322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODADV"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDDA"], Literal["CODADV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDDA"]) -> RuleVariation_322:
        ...
    @overload
    def get_item(self, key : Literal["CODADV"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1203.cv_arg") -> 'Variation_1203':
        return cls._create(arg) # type: ignore

class RuleVariation_1147(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1203.cv_arg
    cv_variation: TypeAlias = Variation_1203

    @classmethod
    def create(cls, arg : "RuleVariation_1147.cv_arg") -> "RuleVariation_1147":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1203:
        return self.arg # type: ignore

class NonSpare_1678(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1147.cv_arg
    cv_name = "SDDA"
    cv_title = "Precision of Doppler Acceleration"
    cv_rule: TypeAlias = RuleVariation_1147

    @classmethod
    def create(cls, arg : "NonSpare_1678.cv_arg") -> "NonSpare_1678":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1147:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1203:
        return self.rule.variation

class NonSpare_758(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODVR"
    cv_title = "Correlation of Doppler Velocity and Range"
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_758.cv_arg") -> "NonSpare_758":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class NonSpare_760(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODVRR"
    cv_title = "Correlation of Doppler Velocity and Range Rate"
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_760.cv_arg") -> "NonSpare_760":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class NonSpare_759(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODVRA"
    cv_title = "Correlation of Doppler Velocity and Range Acceleration"
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_759.cv_arg") -> "NonSpare_759":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class NonSpare_755(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODAR"
    cv_title = "Correlation of Doppler Acceleration and Range"
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_755.cv_arg") -> "NonSpare_755":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class NonSpare_757(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODARR"
    cv_title = "Correlation of Doppler Acceleration and Range Rate"
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_757.cv_arg") -> "NonSpare_757":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class NonSpare_756(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "CODARA"
    cv_title = "Correlation of Doppler Acceleration and Range Acceleration"
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_756.cv_arg") -> "NonSpare_756":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Variation_1485(Compound):
    cv_arg = TypedDict('cv_arg', {
        "DV": NonSpare_915.cv_arg,
        "SDDV": NonSpare_1679.cv_arg,
        "DA": NonSpare_859.cv_arg,
        "SDDA": NonSpare_1678.cv_arg,
        "CODVR": NonSpare_758.cv_arg,
        "CODVRR": NonSpare_760.cv_arg,
        "CODVRA": NonSpare_759.cv_arg,
        "CODAR": NonSpare_755.cv_arg,
        "CODARR": NonSpare_757.cv_arg,
        "CODARA": NonSpare_756.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_915, NonSpare_1679, NonSpare_859, NonSpare_1678, NonSpare_758, NonSpare_760, NonSpare_759, NonSpare_755, NonSpare_757, NonSpare_756]
    cv_items_dict = {"DV": NonSpare_915, "SDDV": NonSpare_1679, "DA": NonSpare_859, "SDDA": NonSpare_1678, "CODVR": NonSpare_758, "CODVRR": NonSpare_760, "CODVRA": NonSpare_759, "CODAR": NonSpare_755, "CODARR": NonSpare_757, "CODARA": NonSpare_756}

    @overload
    @classmethod
    def spec(cls, key : Literal["DV"]) -> NonSpare_915:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDDV"]) -> NonSpare_1679:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> NonSpare_859:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDDA"]) -> NonSpare_1678:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODVR"]) -> NonSpare_758:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODVRR"]) -> NonSpare_760:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODVRA"]) -> NonSpare_759:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODAR"]) -> NonSpare_755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODARR"]) -> NonSpare_757:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CODARA"]) -> NonSpare_756:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DV"], Literal["SDDV"], Literal["DA"], Literal["SDDA"], Literal["CODVR"], Literal["CODVRR"], Literal["CODVRA"], Literal["CODAR"], Literal["CODARR"], Literal["CODARA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DV"]) -> Optional[NonSpare_915]:
        ...
    @overload
    def get_item(self, key : Literal["SDDV"]) -> Optional[NonSpare_1679]:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> Optional[NonSpare_859]:
        ...
    @overload
    def get_item(self, key : Literal["SDDA"]) -> Optional[NonSpare_1678]:
        ...
    @overload
    def get_item(self, key : Literal["CODVR"]) -> Optional[NonSpare_758]:
        ...
    @overload
    def get_item(self, key : Literal["CODVRR"]) -> Optional[NonSpare_760]:
        ...
    @overload
    def get_item(self, key : Literal["CODVRA"]) -> Optional[NonSpare_759]:
        ...
    @overload
    def get_item(self, key : Literal["CODAR"]) -> Optional[NonSpare_755]:
        ...
    @overload
    def get_item(self, key : Literal["CODARR"]) -> Optional[NonSpare_757]:
        ...
    @overload
    def get_item(self, key : Literal["CODARA"]) -> Optional[NonSpare_756]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["DV"], val : NonSpare_915.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["SDDV"], val : NonSpare_1679.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["DA"], val : NonSpare_859.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["SDDA"], val : NonSpare_1678.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["CODVR"], val : NonSpare_758.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["CODVRR"], val : NonSpare_760.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["CODVRA"], val : NonSpare_759.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["CODAR"], val : NonSpare_755.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["CODARR"], val : NonSpare_757.cv_arg) -> "Variation_1485":
        ...
    @overload
    def set_item(self, key : Literal["CODARA"], val : NonSpare_756.cv_arg) -> "Variation_1485":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["DV"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["SDDV"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["DA"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["SDDA"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["CODVR"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["CODVRR"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["CODVRA"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["CODAR"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["CODARR"]) -> "Variation_1485":
        ...
    @overload
    def del_item(self, key : Literal["CODARA"]) -> "Variation_1485":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1485.cv_arg") -> 'Variation_1485':
        return cls._create(arg) # type: ignore

class RuleVariation_1406(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1485.cv_arg
    cv_variation: TypeAlias = Variation_1485

    @classmethod
    def create(cls, arg : "RuleVariation_1406.cv_arg") -> "RuleVariation_1406":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1485:
        return self.arg # type: ignore

class NonSpare_543(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1406.cv_arg
    cv_name = "626"
    cv_title = "Doppler Information"
    cv_rule: TypeAlias = RuleVariation_1406

    @classmethod
    def create(cls, arg : "NonSpare_543.cv_arg") -> "NonSpare_543":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1406:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1485:
        return self.rule.variation

class UapItem_542(UapItem):
    cv_non_spare: TypeAlias = NonSpare_543

class Content_795(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_794(RuleContentContextFree):
    cv_arg: TypeAlias = Content_795.cv_arg
    cv_content: TypeAlias = Content_795

    @property
    def content(self) -> Content_795:
        return self._get_content() # type: ignore

class Variation_345(Element):
    cv_arg: TypeAlias = RuleContent_794.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_794

    @classmethod
    def create(cls, arg: "Variation_345.cv_arg") -> "Variation_345":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_794:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_795:
        return self.rule.content

class RuleVariation_338(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_345.cv_arg
    cv_variation: TypeAlias = Variation_345

    @classmethod
    def create(cls, arg : "RuleVariation_338.cv_arg") -> "RuleVariation_338":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_345:
        return self.arg # type: ignore

class NonSpare_664(NonSpare):
    cv_arg: TypeAlias = RuleVariation_338.cv_arg
    cv_name = "AZ"
    cv_title = "Azimuth"
    cv_rule: TypeAlias = RuleVariation_338

    @classmethod
    def create(cls, arg : "NonSpare_664.cv_arg") -> "NonSpare_664":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_345:
        return self.rule.variation

class Content_786(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.866455078125e-4
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_785(RuleContentContextFree):
    cv_arg: TypeAlias = Content_786.cv_arg
    cv_content: TypeAlias = Content_786

    @property
    def content(self) -> Content_786:
        return self._get_content() # type: ignore

class Variation_340(Element):
    cv_arg: TypeAlias = RuleContent_785.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_785

    @classmethod
    def create(cls, arg: "Variation_340.cv_arg") -> "Variation_340":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_785:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_786:
        return self.rule.content

class RuleVariation_333(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_340.cv_arg
    cv_variation: TypeAlias = Variation_340

    @classmethod
    def create(cls, arg : "RuleVariation_333.cv_arg") -> "RuleVariation_333":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_340:
        return self.arg # type: ignore

class NonSpare_1616(NonSpare):
    cv_arg: TypeAlias = RuleVariation_333.cv_arg
    cv_name = "RSAZ"
    cv_title = "Azimuth Resolution"
    cv_rule: TypeAlias = RuleVariation_333

    @classmethod
    def create(cls, arg : "NonSpare_1616.cv_arg") -> "NonSpare_1616":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

class NonSpare_1674(NonSpare):
    cv_arg: TypeAlias = RuleVariation_333.cv_arg
    cv_name = "SDASZ"
    cv_title = "Standard Deviation of Azimuth"
    cv_rule: TypeAlias = RuleVariation_333

    @classmethod
    def create(cls, arg : "NonSpare_1674.cv_arg") -> "NonSpare_1674":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

class Content_690(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.74658203125e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_690(RuleContentContextFree):
    cv_arg: TypeAlias = Content_690.cv_arg
    cv_content: TypeAlias = Content_690

    @property
    def content(self) -> Content_690:
        return self._get_content() # type: ignore

class Variation_295(Element):
    cv_arg: TypeAlias = RuleContent_690.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_690

    @classmethod
    def create(cls, arg: "Variation_295.cv_arg") -> "Variation_295":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_690:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_690:
        return self.rule.content

class RuleVariation_288(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_295.cv_arg
    cv_variation: TypeAlias = Variation_295

    @classmethod
    def create(cls, arg : "RuleVariation_288.cv_arg") -> "RuleVariation_288":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_295:
        return self.arg # type: ignore

class NonSpare_668(NonSpare):
    cv_arg: TypeAlias = RuleVariation_288.cv_arg
    cv_name = "AZR"
    cv_title = "Azimuth Rate"
    cv_rule: TypeAlias = RuleVariation_288

    @classmethod
    def create(cls, arg : "NonSpare_668.cv_arg") -> "NonSpare_668":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_295:
        return self.rule.variation

class NonSpare_1675(NonSpare):
    cv_arg: TypeAlias = RuleVariation_333.cv_arg
    cv_name = "SDAZR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_333

    @classmethod
    def create(cls, arg : "NonSpare_1675.cv_arg") -> "NonSpare_1675":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

class Item_868(Item):
    cv_arg: TypeAlias = NonSpare_1675.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1675

    @classmethod
    def create(cls, arg : "Item_868.cv_arg") -> "Item_868":
        return cls._create(arg) # type: ignore

class NonSpare_753(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COAZRAZ"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_753.cv_arg") -> "NonSpare_753":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_171(Item):
    cv_arg: TypeAlias = NonSpare_753.cv_arg
    cv_non_spare: TypeAlias = NonSpare_753

    @classmethod
    def create(cls, arg : "Item_171.cv_arg") -> "Item_171":
        return cls._create(arg) # type: ignore

class Variation_1202(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_333.cv_arg, Tuple[Literal["SDAZR"], RuleVariation_333.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COAZRAZ"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1202.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_868, 16), (Item_171, 8)]
    cv_items_dict = {"SDAZR": RuleVariation_333, "COAZRAZ": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDAZR"]) -> RuleVariation_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COAZRAZ"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDAZR"], Literal["COAZRAZ"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDAZR"]) -> RuleVariation_333:
        ...
    @overload
    def get_item(self, key : Literal["COAZRAZ"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1202.cv_arg") -> 'Variation_1202':
        return cls._create(arg) # type: ignore

class RuleVariation_1146(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1202.cv_arg
    cv_variation: TypeAlias = Variation_1202

    @classmethod
    def create(cls, arg : "RuleVariation_1146.cv_arg") -> "RuleVariation_1146":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1202:
        return self.arg # type: ignore

class NonSpare_1676(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1146.cv_arg
    cv_name = "SDAZR"
    cv_title = "Standard Deviation of Azimuth Rate"
    cv_rule: TypeAlias = RuleVariation_1146

    @classmethod
    def create(cls, arg : "NonSpare_1676.cv_arg") -> "NonSpare_1676":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1146:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1202:
        return self.rule.variation

class NonSpare_1646(NonSpare):
    cv_arg: TypeAlias = RuleVariation_339.cv_arg
    cv_name = "S"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_339

    @classmethod
    def create(cls, arg : "NonSpare_1646.cv_arg") -> "NonSpare_1646":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_339:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_346:
        return self.rule.variation

class Item_849(Item):
    cv_arg: TypeAlias = NonSpare_1646.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1646

    @classmethod
    def create(cls, arg : "Item_849.cv_arg") -> "Item_849":
        return cls._create(arg) # type: ignore

class NonSpare_917(NonSpare):
    cv_arg: TypeAlias = RuleVariation_339.cv_arg
    cv_name = "E"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_339

    @classmethod
    def create(cls, arg : "NonSpare_917.cv_arg") -> "NonSpare_917":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_339:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_346:
        return self.rule.variation

class Item_286(Item):
    cv_arg: TypeAlias = NonSpare_917.cv_arg
    cv_non_spare: TypeAlias = NonSpare_917

    @classmethod
    def create(cls, arg : "Item_286.cv_arg") -> "Item_286":
        return cls._create(arg) # type: ignore

class Variation_1190(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_339.cv_arg, Tuple[Literal["S"], RuleVariation_339.cv_arg]], Union[RuleVariation_339.cv_arg, Tuple[Literal["E"], RuleVariation_339.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1190.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_849, 16), (Item_286, 16)]
    cv_items_dict = {"S": RuleVariation_339, "E": RuleVariation_339}

    @overload
    @classmethod
    def spec(cls, key : Literal["S"]) -> RuleVariation_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["E"]) -> RuleVariation_339:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["S"], Literal["E"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_339:
        ...
    @overload
    def get_item(self, key : Literal["E"]) -> RuleVariation_339:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1190.cv_arg") -> 'Variation_1190':
        return cls._create(arg) # type: ignore

class RuleVariation_1139(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1190.cv_arg
    cv_variation: TypeAlias = Variation_1190

    @classmethod
    def create(cls, arg : "RuleVariation_1139.cv_arg") -> "RuleVariation_1139":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1190:
        return self.arg # type: ignore

class NonSpare_666(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1139.cv_arg
    cv_name = "AZEX"
    cv_title = "Azimuth Extent"
    cv_rule: TypeAlias = RuleVariation_1139

    @classmethod
    def create(cls, arg : "NonSpare_666.cv_arg") -> "NonSpare_666":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1139:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1190:
        return self.rule.variation

class Variation_1477(Compound):
    cv_arg = TypedDict('cv_arg', {
        "AZ": NonSpare_664.cv_arg,
        "RSAZ": NonSpare_1616.cv_arg,
        "SDASZ": NonSpare_1674.cv_arg,
        "AZR": NonSpare_668.cv_arg,
        "SDAZR": NonSpare_1676.cv_arg,
        "AZEX": NonSpare_666.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_664, NonSpare_1616, NonSpare_1674, NonSpare_668, NonSpare_1676, NonSpare_666]
    cv_items_dict = {"AZ": NonSpare_664, "RSAZ": NonSpare_1616, "SDASZ": NonSpare_1674, "AZR": NonSpare_668, "SDAZR": NonSpare_1676, "AZEX": NonSpare_666}

    @overload
    @classmethod
    def spec(cls, key : Literal["AZ"]) -> NonSpare_664:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSAZ"]) -> NonSpare_1616:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDASZ"]) -> NonSpare_1674:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZR"]) -> NonSpare_668:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDAZR"]) -> NonSpare_1676:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZEX"]) -> NonSpare_666:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AZ"], Literal["RSAZ"], Literal["SDASZ"], Literal["AZR"], Literal["SDAZR"], Literal["AZEX"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AZ"]) -> Optional[NonSpare_664]:
        ...
    @overload
    def get_item(self, key : Literal["RSAZ"]) -> Optional[NonSpare_1616]:
        ...
    @overload
    def get_item(self, key : Literal["SDASZ"]) -> Optional[NonSpare_1674]:
        ...
    @overload
    def get_item(self, key : Literal["AZR"]) -> Optional[NonSpare_668]:
        ...
    @overload
    def get_item(self, key : Literal["SDAZR"]) -> Optional[NonSpare_1676]:
        ...
    @overload
    def get_item(self, key : Literal["AZEX"]) -> Optional[NonSpare_666]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AZ"], val : NonSpare_664.cv_arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["RSAZ"], val : NonSpare_1616.cv_arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["SDASZ"], val : NonSpare_1674.cv_arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["AZR"], val : NonSpare_668.cv_arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["SDAZR"], val : NonSpare_1676.cv_arg) -> "Variation_1477":
        ...
    @overload
    def set_item(self, key : Literal["AZEX"], val : NonSpare_666.cv_arg) -> "Variation_1477":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AZ"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["RSAZ"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["SDASZ"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["AZR"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["SDAZR"]) -> "Variation_1477":
        ...
    @overload
    def del_item(self, key : Literal["AZEX"]) -> "Variation_1477":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1477.cv_arg") -> 'Variation_1477':
        return cls._create(arg) # type: ignore

class RuleVariation_1398(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1477.cv_arg
    cv_variation: TypeAlias = Variation_1477

    @classmethod
    def create(cls, arg : "RuleVariation_1398.cv_arg") -> "RuleVariation_1398":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1477:
        return self.arg # type: ignore

class NonSpare_544(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1398.cv_arg
    cv_name = "627"
    cv_title = "Azimuth Information"
    cv_rule: TypeAlias = RuleVariation_1398

    @classmethod
    def create(cls, arg : "NonSpare_544.cv_arg") -> "NonSpare_544":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1398:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1477:
        return self.rule.variation

class UapItem_543(UapItem):
    cv_non_spare: TypeAlias = NonSpare_544

class NonSpare_921(NonSpare):
    cv_arg: TypeAlias = RuleVariation_288.cv_arg
    cv_name = "EL"
    cv_title = "Elevation"
    cv_rule: TypeAlias = RuleVariation_288

    @classmethod
    def create(cls, arg : "NonSpare_921.cv_arg") -> "NonSpare_921":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_295:
        return self.rule.variation

class NonSpare_1617(NonSpare):
    cv_arg: TypeAlias = RuleVariation_333.cv_arg
    cv_name = "RSEL"
    cv_title = "Elevation Resolution"
    cv_rule: TypeAlias = RuleVariation_333

    @classmethod
    def create(cls, arg : "NonSpare_1617.cv_arg") -> "NonSpare_1617":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

class NonSpare_1680(NonSpare):
    cv_arg: TypeAlias = RuleVariation_333.cv_arg
    cv_name = "SDEL"
    cv_title = "Standard Deviation of Elevation"
    cv_rule: TypeAlias = RuleVariation_333

    @classmethod
    def create(cls, arg : "NonSpare_1680.cv_arg") -> "NonSpare_1680":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_333:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_340:
        return self.rule.variation

class Content_692(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.74658203125e-3
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_692(RuleContentContextFree):
    cv_arg: TypeAlias = Content_692.cv_arg
    cv_content: TypeAlias = Content_692

    @property
    def content(self) -> Content_692:
        return self._get_content() # type: ignore

class Variation_297(Element):
    cv_arg: TypeAlias = RuleContent_692.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_692

    @classmethod
    def create(cls, arg: "Variation_297.cv_arg") -> "Variation_297":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_692:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_692:
        return self.rule.content

class RuleVariation_290(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_297.cv_arg
    cv_variation: TypeAlias = Variation_297

    @classmethod
    def create(cls, arg : "RuleVariation_290.cv_arg") -> "RuleVariation_290":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_297:
        return self.arg # type: ignore

class NonSpare_957(NonSpare):
    cv_arg: TypeAlias = RuleVariation_290.cv_arg
    cv_name = "ER"
    cv_title = "Elevation Rate"
    cv_rule: TypeAlias = RuleVariation_290

    @classmethod
    def create(cls, arg : "NonSpare_957.cv_arg") -> "NonSpare_957":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_290:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_297:
        return self.rule.variation

class Content_787(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.866455078125e-4
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_786(RuleContentContextFree):
    cv_arg: TypeAlias = Content_787.cv_arg
    cv_content: TypeAlias = Content_787

    @property
    def content(self) -> Content_787:
        return self._get_content() # type: ignore

class Variation_341(Element):
    cv_arg: TypeAlias = RuleContent_786.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_786

    @classmethod
    def create(cls, arg: "Variation_341.cv_arg") -> "Variation_341":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_786:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_787:
        return self.rule.content

class RuleVariation_334(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_341.cv_arg
    cv_variation: TypeAlias = Variation_341

    @classmethod
    def create(cls, arg : "RuleVariation_334.cv_arg") -> "RuleVariation_334":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_341:
        return self.arg # type: ignore

class NonSpare_1681(NonSpare):
    cv_arg: TypeAlias = RuleVariation_334.cv_arg
    cv_name = "SDELR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_334

    @classmethod
    def create(cls, arg : "NonSpare_1681.cv_arg") -> "NonSpare_1681":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_341:
        return self.rule.variation

class Item_870(Item):
    cv_arg: TypeAlias = NonSpare_1681.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1681

    @classmethod
    def create(cls, arg : "Item_870.cv_arg") -> "Item_870":
        return cls._create(arg) # type: ignore

class NonSpare_761(NonSpare):
    cv_arg: TypeAlias = RuleVariation_207.cv_arg
    cv_name = "COELREL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_207

    @classmethod
    def create(cls, arg : "NonSpare_761.cv_arg") -> "NonSpare_761":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_207:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_214:
        return self.rule.variation

class Item_173(Item):
    cv_arg: TypeAlias = NonSpare_761.cv_arg
    cv_non_spare: TypeAlias = NonSpare_761

    @classmethod
    def create(cls, arg : "Item_173.cv_arg") -> "Item_173":
        return cls._create(arg) # type: ignore

class Variation_1204(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_334.cv_arg, Tuple[Literal["SDELR"], RuleVariation_334.cv_arg]], Union[RuleVariation_207.cv_arg, Tuple[Literal["COELREL"], RuleVariation_207.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1204.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_870, 16), (Item_173, 8)]
    cv_items_dict = {"SDELR": RuleVariation_334, "COELREL": RuleVariation_207}

    @overload
    @classmethod
    def spec(cls, key : Literal["SDELR"]) -> RuleVariation_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COELREL"]) -> RuleVariation_207:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SDELR"], Literal["COELREL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SDELR"]) -> RuleVariation_334:
        ...
    @overload
    def get_item(self, key : Literal["COELREL"]) -> RuleVariation_207:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1204.cv_arg") -> 'Variation_1204':
        return cls._create(arg) # type: ignore

class RuleVariation_1148(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1204.cv_arg
    cv_variation: TypeAlias = Variation_1204

    @classmethod
    def create(cls, arg : "RuleVariation_1148.cv_arg") -> "RuleVariation_1148":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1204:
        return self.arg # type: ignore

class NonSpare_1682(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1148.cv_arg
    cv_name = "SDER"
    cv_title = "Standard Deviation of Elevation Rate"
    cv_rule: TypeAlias = RuleVariation_1148

    @classmethod
    def create(cls, arg : "NonSpare_1682.cv_arg") -> "NonSpare_1682":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1148:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1204:
        return self.rule.variation

class NonSpare_1645(NonSpare):
    cv_arg: TypeAlias = RuleVariation_288.cv_arg
    cv_name = "S"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_288

    @classmethod
    def create(cls, arg : "NonSpare_1645.cv_arg") -> "NonSpare_1645":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_295:
        return self.rule.variation

class Item_848(Item):
    cv_arg: TypeAlias = NonSpare_1645.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1645

    @classmethod
    def create(cls, arg : "Item_848.cv_arg") -> "Item_848":
        return cls._create(arg) # type: ignore

class NonSpare_916(NonSpare):
    cv_arg: TypeAlias = RuleVariation_288.cv_arg
    cv_name = "E"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_288

    @classmethod
    def create(cls, arg : "NonSpare_916.cv_arg") -> "NonSpare_916":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_288:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_295:
        return self.rule.variation

class Item_285(Item):
    cv_arg: TypeAlias = NonSpare_916.cv_arg
    cv_non_spare: TypeAlias = NonSpare_916

    @classmethod
    def create(cls, arg : "Item_285.cv_arg") -> "Item_285":
        return cls._create(arg) # type: ignore

class Variation_1189(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_288.cv_arg, Tuple[Literal["S"], RuleVariation_288.cv_arg]], Union[RuleVariation_288.cv_arg, Tuple[Literal["E"], RuleVariation_288.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1189.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_848, 16), (Item_285, 16)]
    cv_items_dict = {"S": RuleVariation_288, "E": RuleVariation_288}

    @overload
    @classmethod
    def spec(cls, key : Literal["S"]) -> RuleVariation_288:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["E"]) -> RuleVariation_288:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["S"], Literal["E"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_288:
        ...
    @overload
    def get_item(self, key : Literal["E"]) -> RuleVariation_288:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1189.cv_arg") -> 'Variation_1189':
        return cls._create(arg) # type: ignore

class RuleVariation_1138(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1189.cv_arg
    cv_variation: TypeAlias = Variation_1189

    @classmethod
    def create(cls, arg : "RuleVariation_1138.cv_arg") -> "RuleVariation_1138":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1189:
        return self.arg # type: ignore

class NonSpare_923(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1138.cv_arg
    cv_name = "ELEX"
    cv_title = "Elevation Extent"
    cv_rule: TypeAlias = RuleVariation_1138

    @classmethod
    def create(cls, arg : "NonSpare_923.cv_arg") -> "NonSpare_923":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1138:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1189:
        return self.rule.variation

class Variation_1486(Compound):
    cv_arg = TypedDict('cv_arg', {
        "EL": NonSpare_921.cv_arg,
        "RSEL": NonSpare_1617.cv_arg,
        "SDEL": NonSpare_1680.cv_arg,
        "ER": NonSpare_957.cv_arg,
        "SDER": NonSpare_1682.cv_arg,
        "ELEX": NonSpare_923.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_921, NonSpare_1617, NonSpare_1680, NonSpare_957, NonSpare_1682, NonSpare_923]
    cv_items_dict = {"EL": NonSpare_921, "RSEL": NonSpare_1617, "SDEL": NonSpare_1680, "ER": NonSpare_957, "SDER": NonSpare_1682, "ELEX": NonSpare_923}

    @overload
    @classmethod
    def spec(cls, key : Literal["EL"]) -> NonSpare_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSEL"]) -> NonSpare_1617:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDEL"]) -> NonSpare_1680:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ER"]) -> NonSpare_957:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDER"]) -> NonSpare_1682:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ELEX"]) -> NonSpare_923:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EL"], Literal["RSEL"], Literal["SDEL"], Literal["ER"], Literal["SDER"], Literal["ELEX"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EL"]) -> Optional[NonSpare_921]:
        ...
    @overload
    def get_item(self, key : Literal["RSEL"]) -> Optional[NonSpare_1617]:
        ...
    @overload
    def get_item(self, key : Literal["SDEL"]) -> Optional[NonSpare_1680]:
        ...
    @overload
    def get_item(self, key : Literal["ER"]) -> Optional[NonSpare_957]:
        ...
    @overload
    def get_item(self, key : Literal["SDER"]) -> Optional[NonSpare_1682]:
        ...
    @overload
    def get_item(self, key : Literal["ELEX"]) -> Optional[NonSpare_923]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["EL"], val : NonSpare_921.cv_arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["RSEL"], val : NonSpare_1617.cv_arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["SDEL"], val : NonSpare_1680.cv_arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["ER"], val : NonSpare_957.cv_arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["SDER"], val : NonSpare_1682.cv_arg) -> "Variation_1486":
        ...
    @overload
    def set_item(self, key : Literal["ELEX"], val : NonSpare_923.cv_arg) -> "Variation_1486":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["EL"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["RSEL"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["SDEL"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["ER"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["SDER"]) -> "Variation_1486":
        ...
    @overload
    def del_item(self, key : Literal["ELEX"]) -> "Variation_1486":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1486.cv_arg") -> 'Variation_1486':
        return cls._create(arg) # type: ignore

class RuleVariation_1407(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1486.cv_arg
    cv_variation: TypeAlias = Variation_1486

    @classmethod
    def create(cls, arg : "RuleVariation_1407.cv_arg") -> "RuleVariation_1407":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1486:
        return self.arg # type: ignore

class NonSpare_545(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1407.cv_arg
    cv_name = "628"
    cv_title = "Elevation Information"
    cv_rule: TypeAlias = RuleVariation_1407

    @classmethod
    def create(cls, arg : "NonSpare_545.cv_arg") -> "NonSpare_545":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1407:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1486:
        return self.rule.variation

class UapItem_544(UapItem):
    cv_non_spare: TypeAlias = NonSpare_545

class Content_624(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["dB"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "dB"

    def as_quantity(self, cv_unit : Optional[Literal["dB"]] = None) -> float:
        return self._as_quantity()

class RuleContent_624(RuleContentContextFree):
    cv_arg: TypeAlias = Content_624.cv_arg
    cv_content: TypeAlias = Content_624

    @property
    def content(self) -> Content_624:
        return self._get_content() # type: ignore

class Variation_207(Element):
    cv_arg: TypeAlias = RuleContent_624.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_624

    @classmethod
    def create(cls, arg: "Variation_207.cv_arg") -> "Variation_207":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_624:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_624:
        return self.rule.content

class RuleVariation_200(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_207.cv_arg
    cv_variation: TypeAlias = Variation_207

    @classmethod
    def create(cls, arg : "RuleVariation_200.cv_arg") -> "RuleVariation_200":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_207:
        return self.arg # type: ignore

class NonSpare_896(NonSpare):
    cv_arg: TypeAlias = RuleVariation_200.cv_arg
    cv_name = "DPP"
    cv_title = "Direct Path - Power"
    cv_rule: TypeAlias = RuleVariation_200

    @classmethod
    def create(cls, arg : "NonSpare_896.cv_arg") -> "NonSpare_896":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_207:
        return self.rule.variation

class NonSpare_897(NonSpare):
    cv_arg: TypeAlias = RuleVariation_200.cv_arg
    cv_name = "DPS"
    cv_title = "Direct Path - Signal to Noise Ratio (SNR)"
    cv_rule: TypeAlias = RuleVariation_200

    @classmethod
    def create(cls, arg : "NonSpare_897.cv_arg") -> "NonSpare_897":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_207:
        return self.rule.variation

class Item_6(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 7

class Content_623(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["dB"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "dB"

    def as_quantity(self, cv_unit : Optional[Literal["dB"]] = None) -> float:
        return self._as_quantity()

class RuleContent_623(RuleContentContextFree):
    cv_arg: TypeAlias = Content_623.cv_arg
    cv_content: TypeAlias = Content_623

    @property
    def content(self) -> Content_623:
        return self._get_content() # type: ignore

class Variation_994(Element):
    cv_arg: TypeAlias = RuleContent_623.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 9
    cv_rule = RuleContent_623

    @classmethod
    def create(cls, arg: "Variation_994.cv_arg") -> "Variation_994":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_623:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_623:
        return self.rule.content

class RuleVariation_964(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_994.cv_arg
    cv_variation: TypeAlias = Variation_994

    @classmethod
    def create(cls, arg : "RuleVariation_964.cv_arg") -> "RuleVariation_964":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_994:
        return self.arg # type: ignore

class NonSpare_1607(NonSpare):
    cv_arg: TypeAlias = RuleVariation_964.cv_arg
    cv_name = "RPP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_964

    @classmethod
    def create(cls, arg : "NonSpare_1607.cv_arg") -> "NonSpare_1607":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_964:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_994:
        return self.rule.variation

class Item_828(Item):
    cv_arg: TypeAlias = NonSpare_1607.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1607

    @classmethod
    def create(cls, arg : "Item_828.cv_arg") -> "Item_828":
        return cls._create(arg) # type: ignore

class Variation_1042(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_964.cv_arg, Tuple[Literal["RPP"], RuleVariation_964.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1042.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_6, 7), (Item_828, 9)]
    cv_items_dict = {"RPP": RuleVariation_964}

    @classmethod
    def spec(cls, key : Literal["RPP"]) -> RuleVariation_964:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["RPP"]) -> RuleVariation_964:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1042.cv_arg") -> 'Variation_1042':
        return cls._create(arg) # type: ignore

class RuleVariation_1010(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1042.cv_arg
    cv_variation: TypeAlias = Variation_1042

    @classmethod
    def create(cls, arg : "RuleVariation_1010.cv_arg") -> "RuleVariation_1010":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1042:
        return self.arg # type: ignore

class NonSpare_1608(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1010.cv_arg
    cv_name = "RPP"
    cv_title = "Reflected Path - Power"
    cv_rule: TypeAlias = RuleVariation_1010

    @classmethod
    def create(cls, arg : "NonSpare_1608.cv_arg") -> "NonSpare_1608":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1010:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1042:
        return self.rule.variation

class NonSpare_1609(NonSpare):
    cv_arg: TypeAlias = RuleVariation_200.cv_arg
    cv_name = "RPS"
    cv_title = "Reflected Path - Signal to Noise Ratio (SNR)"
    cv_rule: TypeAlias = RuleVariation_200

    @classmethod
    def create(cls, arg : "NonSpare_1609.cv_arg") -> "NonSpare_1609":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_207:
        return self.rule.variation

class Variation_1484(Compound):
    cv_arg = TypedDict('cv_arg', {
        "DPP": NonSpare_896.cv_arg,
        "DPS": NonSpare_897.cv_arg,
        "RPP": NonSpare_1608.cv_arg,
        "RPS": NonSpare_1609.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_896, NonSpare_897, NonSpare_1608, NonSpare_1609]
    cv_items_dict = {"DPP": NonSpare_896, "DPS": NonSpare_897, "RPP": NonSpare_1608, "RPS": NonSpare_1609}

    @overload
    @classmethod
    def spec(cls, key : Literal["DPP"]) -> NonSpare_896:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DPS"]) -> NonSpare_897:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPP"]) -> NonSpare_1608:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPS"]) -> NonSpare_1609:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DPP"], Literal["DPS"], Literal["RPP"], Literal["RPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DPP"]) -> Optional[NonSpare_896]:
        ...
    @overload
    def get_item(self, key : Literal["DPS"]) -> Optional[NonSpare_897]:
        ...
    @overload
    def get_item(self, key : Literal["RPP"]) -> Optional[NonSpare_1608]:
        ...
    @overload
    def get_item(self, key : Literal["RPS"]) -> Optional[NonSpare_1609]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["DPP"], val : NonSpare_896.cv_arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["DPS"], val : NonSpare_897.cv_arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["RPP"], val : NonSpare_1608.cv_arg) -> "Variation_1484":
        ...
    @overload
    def set_item(self, key : Literal["RPS"], val : NonSpare_1609.cv_arg) -> "Variation_1484":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["DPP"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["DPS"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["RPP"]) -> "Variation_1484":
        ...
    @overload
    def del_item(self, key : Literal["RPS"]) -> "Variation_1484":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1484.cv_arg") -> 'Variation_1484':
        return cls._create(arg) # type: ignore

class RuleVariation_1405(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1484.cv_arg
    cv_variation: TypeAlias = Variation_1484

    @classmethod
    def create(cls, arg : "RuleVariation_1405.cv_arg") -> "RuleVariation_1405":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1484:
        return self.arg # type: ignore

class NonSpare_546(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1405.cv_arg
    cv_name = "630"
    cv_title = "Path Quality"
    cv_rule: TypeAlias = RuleVariation_1405

    @classmethod
    def create(cls, arg : "NonSpare_546.cv_arg") -> "NonSpare_546":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1405:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1484:
        return self.rule.variation

class UapItem_545(UapItem):
    cv_non_spare: TypeAlias = NonSpare_546

class NonSpare_665(NonSpare):
    cv_arg: TypeAlias = RuleVariation_338.cv_arg
    cv_name = "AZCON"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_338

    @classmethod
    def create(cls, arg : "NonSpare_665.cv_arg") -> "NonSpare_665":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_345:
        return self.rule.variation

class Item_107(Item):
    cv_arg: TypeAlias = NonSpare_665.cv_arg
    cv_non_spare: TypeAlias = NonSpare_665

    @classmethod
    def create(cls, arg : "Item_107.cv_arg") -> "Item_107":
        return cls._create(arg) # type: ignore

class Content_691(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.74658203125e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_691(RuleContentContextFree):
    cv_arg: TypeAlias = Content_691.cv_arg
    cv_content: TypeAlias = Content_691

    @property
    def content(self) -> Content_691:
        return self._get_content() # type: ignore

class Variation_296(Element):
    cv_arg: TypeAlias = RuleContent_691.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_691

    @classmethod
    def create(cls, arg: "Variation_296.cv_arg") -> "Variation_296":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_691:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_691:
        return self.rule.content

class RuleVariation_289(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_296.cv_arg
    cv_variation: TypeAlias = Variation_296

    @classmethod
    def create(cls, arg : "RuleVariation_289.cv_arg") -> "RuleVariation_289":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_296:
        return self.arg # type: ignore

class NonSpare_922(NonSpare):
    cv_arg: TypeAlias = RuleVariation_289.cv_arg
    cv_name = "ELCON"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_289

    @classmethod
    def create(cls, arg : "NonSpare_922.cv_arg") -> "NonSpare_922":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_289:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_296:
        return self.rule.variation

class Item_289(Item):
    cv_arg: TypeAlias = NonSpare_922.cv_arg
    cv_non_spare: TypeAlias = NonSpare_922

    @classmethod
    def create(cls, arg : "Item_289.cv_arg") -> "Item_289":
        return cls._create(arg) # type: ignore

class Content_797(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.152587890625
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_796(RuleContentContextFree):
    cv_arg: TypeAlias = Content_797.cv_arg
    cv_content: TypeAlias = Content_797

    @property
    def content(self) -> Content_797:
        return self._get_content() # type: ignore

class Variation_347(Element):
    cv_arg: TypeAlias = RuleContent_796.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_796

    @classmethod
    def create(cls, arg: "Variation_347.cv_arg") -> "Variation_347":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_796:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_797:
        return self.rule.content

class RuleVariation_340(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_347.cv_arg
    cv_variation: TypeAlias = Variation_347

    @classmethod
    def create(cls, arg : "RuleVariation_340.cv_arg") -> "RuleVariation_340":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_347:
        return self.arg # type: ignore

class NonSpare_1588(NonSpare):
    cv_arg: TypeAlias = RuleVariation_340.cv_arg
    cv_name = "RGCONSTOP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_340

    @classmethod
    def create(cls, arg : "NonSpare_1588.cv_arg") -> "NonSpare_1588":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class Item_813(Item):
    cv_arg: TypeAlias = NonSpare_1588.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1588

    @classmethod
    def create(cls, arg : "Item_813.cv_arg") -> "Item_813":
        return cls._create(arg) # type: ignore

class NonSpare_1587(NonSpare):
    cv_arg: TypeAlias = RuleVariation_340.cv_arg
    cv_name = "RGCONSTART"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_340

    @classmethod
    def create(cls, arg : "NonSpare_1587.cv_arg") -> "NonSpare_1587":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_347:
        return self.rule.variation

class Item_812(Item):
    cv_arg: TypeAlias = NonSpare_1587.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1587

    @classmethod
    def create(cls, arg : "Item_812.cv_arg") -> "Item_812":
        return cls._create(arg) # type: ignore

class Variation_1059(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_338.cv_arg, Tuple[Literal["AZCON"], RuleVariation_338.cv_arg]], Union[RuleVariation_289.cv_arg, Tuple[Literal["ELCON"], RuleVariation_289.cv_arg]], Union[RuleVariation_340.cv_arg, Tuple[Literal["RGCONSTOP"], RuleVariation_340.cv_arg]], Union[RuleVariation_340.cv_arg, Tuple[Literal["RGCONSTART"], RuleVariation_340.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1059.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_107, 16), (Item_289, 16), (Item_813, 16), (Item_812, 16)]
    cv_items_dict = {"AZCON": RuleVariation_338, "ELCON": RuleVariation_289, "RGCONSTOP": RuleVariation_340, "RGCONSTART": RuleVariation_340}

    @overload
    @classmethod
    def spec(cls, key : Literal["AZCON"]) -> RuleVariation_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ELCON"]) -> RuleVariation_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RGCONSTOP"]) -> RuleVariation_340:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RGCONSTART"]) -> RuleVariation_340:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AZCON"], Literal["ELCON"], Literal["RGCONSTOP"], Literal["RGCONSTART"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AZCON"]) -> RuleVariation_338:
        ...
    @overload
    def get_item(self, key : Literal["ELCON"]) -> RuleVariation_289:
        ...
    @overload
    def get_item(self, key : Literal["RGCONSTOP"]) -> RuleVariation_340:
        ...
    @overload
    def get_item(self, key : Literal["RGCONSTART"]) -> RuleVariation_340:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1059.cv_arg") -> 'Variation_1059':
        return cls._create(arg) # type: ignore

class Variation_1410(Repetitive):
    cv_arg: TypeAlias = List[Variation_1059.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1059

    @classmethod
    def create(cls, arg: "Variation_1410.cv_arg") -> 'Variation_1410':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1059]:
        return self._get_list() # type: ignore

class RuleVariation_1331(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1410.cv_arg
    cv_variation: TypeAlias = Variation_1410

    @classmethod
    def create(cls, arg : "RuleVariation_1331.cv_arg") -> "RuleVariation_1331":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1410:
        return self.arg # type: ignore

class NonSpare_547(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1331.cv_arg
    cv_name = "631"
    cv_title = "Contour (Azimuth, Elevation Angle, Range Extent)"
    cv_rule: TypeAlias = RuleVariation_1331

    @classmethod
    def create(cls, arg : "NonSpare_547.cv_arg") -> "NonSpare_547":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1410:
        return self.rule.variation

class UapItem_546(UapItem):
    cv_non_spare: TypeAlias = NonSpare_547

class Record_34(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_40.cv_arg,
        "000": NonSpare_17.cv_arg,
        "015": NonSpare_60.cv_arg,
        "020": NonSpare_85.cv_arg,
        "030": NonSpare_116.cv_arg,
        "145": NonSpare_339.cv_arg,
        "161": NonSpare_367.cv_arg,
        "170": NonSpare_381.cv_arg,
        "050": NonSpare_182.cv_arg,
        "270": NonSpare_460.cv_arg,
        "300": NonSpare_474.cv_arg,
        "400": NonSpare_498.cv_arg,
        "600": NonSpare_529.cv_arg,
        "601": NonSpare_532.cv_arg,
        "602": NonSpare_533.cv_arg,
        "603": NonSpare_534.cv_arg,
        "604": NonSpare_535.cv_arg,
        "605": NonSpare_537.cv_arg,
        "480": NonSpare_512.cv_arg,
        "625": NonSpare_542.cv_arg,
        "626": NonSpare_543.cv_arg,
        "627": NonSpare_544.cv_arg,
        "628": NonSpare_545.cv_arg,
        "630": NonSpare_546.cv_arg,
        "631": NonSpare_547.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_40, UapItem_17, UapItem_60, UapItem_85, UapItem_116, UapItem_339, UapItem_367, UapItem_381, UapItem_182, UapItem_460, UapItem_474, UapItem_497, UapItem_528, UapItem_531, UapItem_532, UapItem_533, UapItem_534, UapItem_536, UapItem_511, UapItem_541, UapItem_542, UapItem_543, UapItem_544, UapItem_545, UapItem_546, UapItem_548]
    cv_items_dict = {"010": NonSpare_40, "000": NonSpare_17, "015": NonSpare_60, "020": NonSpare_85, "030": NonSpare_116, "145": NonSpare_339, "161": NonSpare_367, "170": NonSpare_381, "050": NonSpare_182, "270": NonSpare_460, "300": NonSpare_474, "400": NonSpare_498, "600": NonSpare_529, "601": NonSpare_532, "602": NonSpare_533, "603": NonSpare_534, "604": NonSpare_535, "605": NonSpare_537, "480": NonSpare_512, "625": NonSpare_542, "626": NonSpare_543, "627": NonSpare_544, "628": NonSpare_545, "630": NonSpare_546, "631": NonSpare_547, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_40:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_17:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_60:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_85:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_339:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_367:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_381:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_182:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_460:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_474:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_498:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_529:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["601"]) -> NonSpare_532:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["602"]) -> NonSpare_533:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["603"]) -> NonSpare_534:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["604"]) -> NonSpare_535:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["605"]) -> NonSpare_537:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["480"]) -> NonSpare_512:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["625"]) -> NonSpare_542:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["626"]) -> NonSpare_543:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["627"]) -> NonSpare_544:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["628"]) -> NonSpare_545:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["630"]) -> NonSpare_546:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["631"]) -> NonSpare_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["020"], Literal["030"], Literal["145"], Literal["161"], Literal["170"], Literal["050"], Literal["270"], Literal["300"], Literal["400"], Literal["600"], Literal["601"], Literal["602"], Literal["603"], Literal["604"], Literal["605"], Literal["480"], Literal["625"], Literal["626"], Literal["627"], Literal["628"], Literal["630"], Literal["631"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_40]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_17]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_60]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_85]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_116]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_339]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_367]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_381]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_182]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_460]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_474]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_498]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_529]:
        ...
    @overload
    def get_item(self, key : Literal["601"]) -> Optional[NonSpare_532]:
        ...
    @overload
    def get_item(self, key : Literal["602"]) -> Optional[NonSpare_533]:
        ...
    @overload
    def get_item(self, key : Literal["603"]) -> Optional[NonSpare_534]:
        ...
    @overload
    def get_item(self, key : Literal["604"]) -> Optional[NonSpare_535]:
        ...
    @overload
    def get_item(self, key : Literal["605"]) -> Optional[NonSpare_537]:
        ...
    @overload
    def get_item(self, key : Literal["480"]) -> Optional[NonSpare_512]:
        ...
    @overload
    def get_item(self, key : Literal["625"]) -> Optional[NonSpare_542]:
        ...
    @overload
    def get_item(self, key : Literal["626"]) -> Optional[NonSpare_543]:
        ...
    @overload
    def get_item(self, key : Literal["627"]) -> Optional[NonSpare_544]:
        ...
    @overload
    def get_item(self, key : Literal["628"]) -> Optional[NonSpare_545]:
        ...
    @overload
    def get_item(self, key : Literal["630"]) -> Optional[NonSpare_546]:
        ...
    @overload
    def get_item(self, key : Literal["631"]) -> Optional[NonSpare_547]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_40.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_17.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_60.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_85.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_116.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_339.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_367.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_381.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_182.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_460.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_474.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_498.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_529.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["601"], val : NonSpare_532.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["602"], val : NonSpare_533.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["603"], val : NonSpare_534.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["604"], val : NonSpare_535.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["605"], val : NonSpare_537.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["480"], val : NonSpare_512.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["625"], val : NonSpare_542.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["626"], val : NonSpare_543.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["627"], val : NonSpare_544.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["628"], val : NonSpare_545.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["630"], val : NonSpare_546.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["631"], val : NonSpare_547.cv_arg) -> 'Record_34':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_34':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["601"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["602"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["603"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["604"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["605"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["480"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["625"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["626"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["627"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["628"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["630"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["631"]) -> 'Record_34':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_34':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_34.cv_arg") -> 'Record_34':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_34", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_30(UapSingle):
    cv_arg: TypeAlias = Record_34
    cv_record: TypeAlias = Record_34

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_34]]:
        return cls._parse(bs)

class Asterix_14(AstCat):
    cv_category = 15
    cv_edition = (1, 0)
    cv_uap: TypeAlias = Uap_30
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_30.cv_arg]) -> "Asterix_14":
        return cls._create(records) # type: ignore

class Asterix_15(AstCat):
    cv_category = 15
    cv_edition = (1, 1)
    cv_uap: TypeAlias = Uap_30
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_30.cv_arg]) -> "Asterix_15":
        return cls._create(records) # type: ignore

class Asterix_16(AstCat):
    cv_category = 15
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_30
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_30.cv_arg]) -> "Asterix_16":
        return cls._create(records) # type: ignore

class NonSpare_31(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_31.cv_arg") -> "NonSpare_31":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_31(UapItem):
    cv_non_spare: TypeAlias = NonSpare_31

class NonSpare_67(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_67.cv_arg") -> "NonSpare_67":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_67(UapItem):
    cv_non_spare: TypeAlias = NonSpare_67

class Content_597(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "System Configuration", 2: "Transmitter / Receiver Configuration"}

class RuleContent_597(RuleContentContextFree):
    cv_arg: TypeAlias = Content_597.cv_arg
    cv_content: TypeAlias = Content_597

    @property
    def content(self) -> Content_597:
        return self._get_content() # type: ignore

class Variation_196(Element):
    cv_arg: TypeAlias = RuleContent_597.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_597

    @classmethod
    def create(cls, arg: "Variation_196.cv_arg") -> "Variation_196":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_597:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_597:
        return self.rule.content

class RuleVariation_189(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_196.cv_arg
    cv_variation: TypeAlias = Variation_196

    @classmethod
    def create(cls, arg : "RuleVariation_189.cv_arg") -> "RuleVariation_189":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_196:
        return self.arg # type: ignore

class NonSpare_11(NonSpare):
    cv_arg: TypeAlias = RuleVariation_189.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_189

    @classmethod
    def create(cls, arg : "NonSpare_11.cv_arg") -> "NonSpare_11":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_189:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_196:
        return self.rule.variation

class UapItem_11(UapItem):
    cv_non_spare: TypeAlias = NonSpare_11

class NonSpare_327(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_327.cv_arg") -> "NonSpare_327":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_327(UapItem):
    cv_non_spare: TypeAlias = NonSpare_327

class Content_725(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_725(RuleContentContextFree):
    cv_arg: TypeAlias = Content_725.cv_arg
    cv_content: TypeAlias = Content_725

    @property
    def content(self) -> Content_725:
        return self._get_content() # type: ignore

class Variation_224(Element):
    cv_arg: TypeAlias = RuleContent_725.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_725

    @classmethod
    def create(cls, arg: "Variation_224.cv_arg") -> "Variation_224":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_725:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_725:
        return self.rule.content

class RuleVariation_217(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_224.cv_arg
    cv_variation: TypeAlias = Variation_224

    @classmethod
    def create(cls, arg : "RuleVariation_217.cv_arg") -> "RuleVariation_217":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_224:
        return self.arg # type: ignore

class NonSpare_397(NonSpare):
    cv_arg: TypeAlias = RuleVariation_217.cv_arg
    cv_name = "200"
    cv_title = "System Configuration Reporting Period"
    cv_rule: TypeAlias = RuleVariation_217

    @classmethod
    def create(cls, arg : "NonSpare_397.cv_arg") -> "NonSpare_397":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_217:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_224:
        return self.rule.variation

class UapItem_397(UapItem):
    cv_non_spare: TypeAlias = NonSpare_397

class NonSpare_1429(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "PID"
    cv_title = "Pair Identification"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1429.cv_arg") -> "NonSpare_1429":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_683(Item):
    cv_arg: TypeAlias = NonSpare_1429.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1429

    @classmethod
    def create(cls, arg : "Item_683.cv_arg") -> "Item_683":
        return cls._create(arg) # type: ignore

class NonSpare_1869(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "TID"
    cv_title = "Transmitter Identification"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1869.cv_arg") -> "NonSpare_1869":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_1002(Item):
    cv_arg: TypeAlias = NonSpare_1869.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1869

    @classmethod
    def create(cls, arg : "Item_1002.cv_arg") -> "Item_1002":
        return cls._create(arg) # type: ignore

class NonSpare_1596(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "RID"
    cv_title = "Receiver Identification"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1596.cv_arg") -> "NonSpare_1596":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_821(Item):
    cv_arg: TypeAlias = NonSpare_1596.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1596

    @classmethod
    def create(cls, arg : "Item_821.cv_arg") -> "Item_821":
        return cls._create(arg) # type: ignore

class Variation_1157(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_246.cv_arg, Tuple[Literal["PID"], RuleVariation_246.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["TID"], RuleVariation_246.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["RID"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1157.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_683, 16), (Item_1002, 16), (Item_821, 16)]
    cv_items_dict = {"PID": RuleVariation_246, "TID": RuleVariation_246, "RID": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["PID"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RID"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PID"], Literal["TID"], Literal["RID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PID"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["RID"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1157.cv_arg") -> 'Variation_1157':
        return cls._create(arg) # type: ignore

class Variation_1424(Repetitive):
    cv_arg: TypeAlias = List[Variation_1157.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1157

    @classmethod
    def create(cls, arg: "Variation_1424.cv_arg") -> 'Variation_1424':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1157]:
        return self._get_list() # type: ignore

class RuleVariation_1345(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1424.cv_arg
    cv_variation: TypeAlias = Variation_1424

    @classmethod
    def create(cls, arg : "RuleVariation_1345.cv_arg") -> "RuleVariation_1345":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1424:
        return self.arg # type: ignore

class NonSpare_475(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1345.cv_arg
    cv_name = "300"
    cv_title = "Pair Identification"
    cv_rule: TypeAlias = RuleVariation_1345

    @classmethod
    def create(cls, arg : "NonSpare_475.cv_arg") -> "NonSpare_475":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1424:
        return self.rule.variation

class UapItem_475(UapItem):
    cv_non_spare: TypeAlias = NonSpare_475

class NonSpare_499(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1086.cv_arg
    cv_name = "400"
    cv_title = "Position of the System Reference Point"
    cv_rule: TypeAlias = RuleVariation_1086

    @classmethod
    def create(cls, arg : "NonSpare_499.cv_arg") -> "NonSpare_499":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1086:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1130:
        return self.rule.variation

class UapItem_498(UapItem):
    cv_non_spare: TypeAlias = NonSpare_499

class Content_659(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_659(RuleContentContextFree):
    cv_arg: TypeAlias = Content_659.cv_arg
    cv_content: TypeAlias = Content_659

    @property
    def content(self) -> Content_659:
        return self._get_content() # type: ignore

class Variation_276(Element):
    cv_arg: TypeAlias = RuleContent_659.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_659

    @classmethod
    def create(cls, arg: "Variation_276.cv_arg") -> "Variation_276":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_659:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_659:
        return self.rule.content

class RuleVariation_269(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_276.cv_arg
    cv_variation: TypeAlias = Variation_276

    @classmethod
    def create(cls, arg : "RuleVariation_269.cv_arg") -> "RuleVariation_269":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_276:
        return self.arg # type: ignore

class NonSpare_501(NonSpare):
    cv_arg: TypeAlias = RuleVariation_269.cv_arg
    cv_name = "405"
    cv_title = "Height of System Reference Point"
    cv_rule: TypeAlias = RuleVariation_269

    @classmethod
    def create(cls, arg : "NonSpare_501.cv_arg") -> "NonSpare_501":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_269:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_276:
        return self.rule.variation

class UapItem_500(UapItem):
    cv_non_spare: TypeAlias = NonSpare_501

class NonSpare_1868(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "TID"
    cv_title = "Transmitter ID"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1868.cv_arg") -> "NonSpare_1868":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_1001(Item):
    cv_arg: TypeAlias = NonSpare_1868.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1868

    @classmethod
    def create(cls, arg : "Item_1001.cv_arg") -> "Item_1001":
        return cls._create(arg) # type: ignore

class NonSpare_591(NonSpare):
    cv_arg: TypeAlias = RuleVariation_269.cv_arg
    cv_name = "ALT"
    cv_title = "Altitude"
    cv_rule: TypeAlias = RuleVariation_269

    @classmethod
    def create(cls, arg : "NonSpare_591.cv_arg") -> "NonSpare_591":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_269:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_276:
        return self.rule.variation

class Item_58(Item):
    cv_arg: TypeAlias = NonSpare_591.cv_arg
    cv_non_spare: TypeAlias = NonSpare_591

    @classmethod
    def create(cls, arg : "Item_58.cv_arg") -> "Item_58":
        return cls._create(arg) # type: ignore

class Content_631(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ns"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.0
    cv_unit = "ns"

    def as_quantity(self, cv_unit : Optional[Literal["ns"]] = None) -> float:
        return self._as_quantity()

class RuleContent_631(RuleContentContextFree):
    cv_arg: TypeAlias = Content_631.cv_arg
    cv_content: TypeAlias = Content_631

    @property
    def content(self) -> Content_631:
        return self._get_content() # type: ignore

class Variation_376(Element):
    cv_arg: TypeAlias = RuleContent_631.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_631

    @classmethod
    def create(cls, arg: "Variation_376.cv_arg") -> "Variation_376":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_631:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_631:
        return self.rule.content

class RuleVariation_369(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_376.cv_arg
    cv_variation: TypeAlias = Variation_376

    @classmethod
    def create(cls, arg : "RuleVariation_369.cv_arg") -> "RuleVariation_369":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_376:
        return self.arg # type: ignore

class NonSpare_1951(NonSpare):
    cv_arg: TypeAlias = RuleVariation_369.cv_arg
    cv_name = "TTO"
    cv_title = "Transmission Time Offset"
    cv_rule: TypeAlias = RuleVariation_369

    @classmethod
    def create(cls, arg : "NonSpare_1951.cv_arg") -> "NonSpare_1951":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_376:
        return self.rule.variation

class Item_1066(Item):
    cv_arg: TypeAlias = NonSpare_1951.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1951

    @classmethod
    def create(cls, arg : "Item_1066.cv_arg") -> "Item_1066":
        return cls._create(arg) # type: ignore

class Content_723(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ns"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "ns"

    def as_quantity(self, cv_unit : Optional[Literal["ns"]] = None) -> float:
        return self._as_quantity()

class RuleContent_723(RuleContentContextFree):
    cv_arg: TypeAlias = Content_723.cv_arg
    cv_content: TypeAlias = Content_723

    @property
    def content(self) -> Content_723:
        return self._get_content() # type: ignore

class Variation_816(Element):
    cv_arg: TypeAlias = RuleContent_723.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 20
    cv_rule = RuleContent_723

    @classmethod
    def create(cls, arg: "Variation_816.cv_arg") -> "Variation_816":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_723:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_723:
        return self.rule.content

class RuleVariation_786(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_816.cv_arg
    cv_variation: TypeAlias = Variation_816

    @classmethod
    def create(cls, arg : "RuleVariation_786.cv_arg") -> "RuleVariation_786":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_816:
        return self.arg # type: ignore

class NonSpare_643(NonSpare):
    cv_arg: TypeAlias = RuleVariation_786.cv_arg
    cv_name = "ATO"
    cv_title = "Accuracy of Transmission Time Offset"
    cv_rule: TypeAlias = RuleVariation_786

    @classmethod
    def create(cls, arg : "NonSpare_643.cv_arg") -> "NonSpare_643":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_786:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_816:
        return self.rule.variation

class Item_89(Item):
    cv_arg: TypeAlias = NonSpare_643.cv_arg
    cv_non_spare: TypeAlias = NonSpare_643

    @classmethod
    def create(cls, arg : "Item_89.cv_arg") -> "Item_89":
        return cls._create(arg) # type: ignore

class NonSpare_1424(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "PCI"
    cv_title = "Parallel Transmitter Index"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_1424.cv_arg") -> "NonSpare_1424":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class Item_680(Item):
    cv_arg: TypeAlias = NonSpare_1424.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1424

    @classmethod
    def create(cls, arg : "Item_680.cv_arg") -> "Item_680":
        return cls._create(arg) # type: ignore

class Variation_1226(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_246.cv_arg, Tuple[Literal["TID"], RuleVariation_246.cv_arg]], Union[RuleVariation_376.cv_arg, Tuple[Literal["LAT"], RuleVariation_376.cv_arg]], Union[RuleVariation_374.cv_arg, Tuple[Literal["LON"], RuleVariation_374.cv_arg]], Union[RuleVariation_269.cv_arg, Tuple[Literal["ALT"], RuleVariation_269.cv_arg]], Union[RuleVariation_369.cv_arg, Tuple[Literal["TTO"], RuleVariation_369.cv_arg]], int, Union[RuleVariation_786.cv_arg, Tuple[Literal["ATO"], RuleVariation_786.cv_arg]], Union[RuleVariation_249.cv_arg, Tuple[Literal["PCI"], RuleVariation_249.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1226.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 168
    cv_items_list = [(Item_1001, 16), (Item_466, 32), (Item_494, 32), (Item_58, 16), (Item_1066, 32), (Item_3, 4), (Item_89, 20), (Item_680, 16)]
    cv_items_dict = {"TID": RuleVariation_246, "LAT": RuleVariation_376, "LON": RuleVariation_374, "ALT": RuleVariation_269, "TTO": RuleVariation_369, "ATO": RuleVariation_786, "PCI": RuleVariation_249}

    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_269:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTO"]) -> RuleVariation_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATO"]) -> RuleVariation_786:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PCI"]) -> RuleVariation_249:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TID"], Literal["LAT"], Literal["LON"], Literal["ALT"], Literal["TTO"], Literal["ATO"], Literal["PCI"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_374:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_269:
        ...
    @overload
    def get_item(self, key : Literal["TTO"]) -> RuleVariation_369:
        ...
    @overload
    def get_item(self, key : Literal["ATO"]) -> RuleVariation_786:
        ...
    @overload
    def get_item(self, key : Literal["PCI"]) -> RuleVariation_249:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1226.cv_arg") -> 'Variation_1226':
        return cls._create(arg) # type: ignore

class Variation_1438(Repetitive):
    cv_arg: TypeAlias = List[Variation_1226.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1226

    @classmethod
    def create(cls, arg: "Variation_1438.cv_arg") -> 'Variation_1438':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1226]:
        return self._get_list() # type: ignore

class RuleVariation_1359(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1438.cv_arg
    cv_variation: TypeAlias = Variation_1438

    @classmethod
    def create(cls, arg : "RuleVariation_1359.cv_arg") -> "RuleVariation_1359":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1438:
        return self.arg # type: ignore

class NonSpare_503(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1359.cv_arg
    cv_name = "410"
    cv_title = "Transmitter Properties"
    cv_rule: TypeAlias = RuleVariation_1359

    @classmethod
    def create(cls, arg : "NonSpare_503.cv_arg") -> "NonSpare_503":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1359:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1438:
        return self.rule.variation

class UapItem_502(UapItem):
    cv_non_spare: TypeAlias = NonSpare_503

class NonSpare_1595(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "RID"
    cv_title = "Receiver Component ID"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1595.cv_arg") -> "NonSpare_1595":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_820(Item):
    cv_arg: TypeAlias = NonSpare_1595.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1595

    @classmethod
    def create(cls, arg : "Item_820.cv_arg") -> "Item_820":
        return cls._create(arg) # type: ignore

class Variation_1183(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_246.cv_arg, Tuple[Literal["RID"], RuleVariation_246.cv_arg]], Union[RuleVariation_376.cv_arg, Tuple[Literal["LAT"], RuleVariation_376.cv_arg]], Union[RuleVariation_374.cv_arg, Tuple[Literal["LON"], RuleVariation_374.cv_arg]], Union[RuleVariation_269.cv_arg, Tuple[Literal["ALT"], RuleVariation_269.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1183.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_820, 16), (Item_466, 32), (Item_494, 32), (Item_58, 16)]
    cv_items_dict = {"RID": RuleVariation_246, "LAT": RuleVariation_376, "LON": RuleVariation_374, "ALT": RuleVariation_269}

    @overload
    @classmethod
    def spec(cls, key : Literal["RID"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_374:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_269:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RID"], Literal["LAT"], Literal["LON"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RID"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_376:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_374:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_269:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1183.cv_arg") -> 'Variation_1183':
        return cls._create(arg) # type: ignore

class Variation_1426(Repetitive):
    cv_arg: TypeAlias = List[Variation_1183.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1183

    @classmethod
    def create(cls, arg: "Variation_1426.cv_arg") -> 'Variation_1426':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1183]:
        return self._get_list() # type: ignore

class RuleVariation_1347(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1426.cv_arg
    cv_variation: TypeAlias = Variation_1426

    @classmethod
    def create(cls, arg : "RuleVariation_1347.cv_arg") -> "RuleVariation_1347":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1426:
        return self.arg # type: ignore

class NonSpare_505(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1347.cv_arg
    cv_name = "420"
    cv_title = "Receiver Properties"
    cv_rule: TypeAlias = RuleVariation_1347

    @classmethod
    def create(cls, arg : "NonSpare_505.cv_arg") -> "NonSpare_505":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1347:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1426:
        return self.rule.variation

class UapItem_504(UapItem):
    cv_non_spare: TypeAlias = NonSpare_505

class Record_10(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_31.cv_arg,
        "015": NonSpare_67.cv_arg,
        "000": NonSpare_11.cv_arg,
        "140": NonSpare_327.cv_arg,
        "200": NonSpare_397.cv_arg,
        "300": NonSpare_475.cv_arg,
        "400": NonSpare_499.cv_arg,
        "405": NonSpare_501.cv_arg,
        "410": NonSpare_503.cv_arg,
        "420": NonSpare_505.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_31, UapItem_67, UapItem_11, UapItem_327, UapItem_397, UapItem_475, UapItem_498, UapItem_500, UapItem_502, UapItem_504, UapItem_548]
    cv_items_dict = {"010": NonSpare_31, "015": NonSpare_67, "000": NonSpare_11, "140": NonSpare_327, "200": NonSpare_397, "300": NonSpare_475, "400": NonSpare_499, "405": NonSpare_501, "410": NonSpare_503, "420": NonSpare_505, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_31:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_67:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_11:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_397:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_499:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["405"]) -> NonSpare_501:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["410"]) -> NonSpare_503:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["420"]) -> NonSpare_505:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["000"], Literal["140"], Literal["200"], Literal["300"], Literal["400"], Literal["405"], Literal["410"], Literal["420"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_31]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_67]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_11]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_327]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_397]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_475]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_499]:
        ...
    @overload
    def get_item(self, key : Literal["405"]) -> Optional[NonSpare_501]:
        ...
    @overload
    def get_item(self, key : Literal["410"]) -> Optional[NonSpare_503]:
        ...
    @overload
    def get_item(self, key : Literal["420"]) -> Optional[NonSpare_505]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_31.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_67.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_11.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_327.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_397.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_475.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_499.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["405"], val : NonSpare_501.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["410"], val : NonSpare_503.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["420"], val : NonSpare_505.cv_arg) -> 'Record_10':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_10':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["405"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["410"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["420"]) -> 'Record_10':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_10':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_10.cv_arg") -> 'Record_10':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_10", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_10(UapSingle):
    cv_arg: TypeAlias = Record_10
    cv_record: TypeAlias = Record_10

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_10]]:
        return cls._parse(bs)

class Asterix_17(AstCat):
    cv_category = 16
    cv_edition = (1, 0)
    cv_uap: TypeAlias = Uap_10
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_10.cv_arg]) -> "Asterix_17":
        return cls._create(records) # type: ignore

class NonSpare_41(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_41.cv_arg") -> "NonSpare_41":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_41(UapItem):
    cv_non_spare: TypeAlias = NonSpare_41

class NonSpare_54(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "012"
    cv_title = "Data Destination Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_54.cv_arg") -> "NonSpare_54":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_54(UapItem):
    cv_non_spare: TypeAlias = NonSpare_54

class Content_303(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Network information", 10: "Track data", 20: "Track data request", 21: "Track data stop", 22: "Cancel track data request", 23: "Track data stop acknowledgement", 30: "New Node / Change-over Initial or intermediate message segment", 31: "New Node / Change-over Final or only message segment", 32: "New Node / Change-over Initial or intermediate message segment reply", 33: "New Node / Change-over Final or only message segment reply", 110: "Move node to new cluster state;", 111: "Move node to new cluster state acknowledgement"}

class RuleContent_303(RuleContentContextFree):
    cv_arg: TypeAlias = Content_303.cv_arg
    cv_content: TypeAlias = Content_303

    @property
    def content(self) -> Content_303:
        return self._get_content() # type: ignore

class Variation_169(Element):
    cv_arg: TypeAlias = RuleContent_303.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_303

    @classmethod
    def create(cls, arg: "Variation_169.cv_arg") -> "Variation_169":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_303:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_303:
        return self.rule.content

class RuleVariation_163(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_169.cv_arg
    cv_variation: TypeAlias = Variation_169

    @classmethod
    def create(cls, arg : "RuleVariation_163.cv_arg") -> "RuleVariation_163":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_169:
        return self.arg # type: ignore

class NonSpare_1(NonSpare):
    cv_arg: TypeAlias = RuleVariation_163.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_163

    @classmethod
    def create(cls, arg : "NonSpare_1.cv_arg") -> "NonSpare_1":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_163:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_169:
        return self.rule.variation

class UapItem_1(UapItem):
    cv_non_spare: TypeAlias = NonSpare_1

class NonSpare_483(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1350.cv_arg
    cv_name = "350"
    cv_title = "Cluster Station/Node List"
    cv_rule: TypeAlias = RuleVariation_1350

    @classmethod
    def create(cls, arg : "NonSpare_483.cv_arg") -> "NonSpare_483":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1350:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1429:
        return self.rule.variation

class UapItem_483(UapItem):
    cv_non_spare: TypeAlias = NonSpare_483

class NonSpare_419(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "220"
    cv_title = "Aircraft Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_419.cv_arg") -> "NonSpare_419":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_419(UapItem):
    cv_non_spare: TypeAlias = NonSpare_419

class NonSpare_428(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "221"
    cv_title = "Duplicate Address Reference Number (DRN)"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_428.cv_arg") -> "NonSpare_428":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_428(UapItem):
    cv_non_spare: TypeAlias = NonSpare_428

class NonSpare_334(NonSpare):
    cv_arg: TypeAlias = RuleVariation_364.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_364

    @classmethod
    def create(cls, arg : "NonSpare_334.cv_arg") -> "NonSpare_334":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_371:
        return self.rule.variation

class UapItem_334(UapItem):
    cv_non_spare: TypeAlias = NonSpare_334

class Variation_364(Element):
    cv_arg: TypeAlias = RuleContent_699.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_699

    @classmethod
    def create(cls, arg: "Variation_364.cv_arg") -> "Variation_364":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_699:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_699:
        return self.rule.content

class RuleVariation_357(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_364.cv_arg
    cv_variation: TypeAlias = Variation_364

    @classmethod
    def create(cls, arg : "RuleVariation_357.cv_arg") -> "RuleVariation_357":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_364:
        return self.arg # type: ignore

class NonSpare_1151(NonSpare):
    cv_arg: TypeAlias = RuleVariation_357.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule: TypeAlias = RuleVariation_357

    @classmethod
    def create(cls, arg : "NonSpare_1151.cv_arg") -> "NonSpare_1151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_357:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_364:
        return self.rule.variation

class Item_463(Item):
    cv_arg: TypeAlias = NonSpare_1151.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1151

    @classmethod
    def create(cls, arg : "Item_463.cv_arg") -> "Item_463":
        return cls._create(arg) # type: ignore

class Variation_363(Element):
    cv_arg: TypeAlias = RuleContent_698.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_698

    @classmethod
    def create(cls, arg: "Variation_363.cv_arg") -> "Variation_363":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_698:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_698:
        return self.rule.content

class RuleVariation_356(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_363.cv_arg
    cv_variation: TypeAlias = Variation_363

    @classmethod
    def create(cls, arg : "RuleVariation_356.cv_arg") -> "RuleVariation_356":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_363:
        return self.arg # type: ignore

class NonSpare_1181(NonSpare):
    cv_arg: TypeAlias = RuleVariation_356.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_356

    @classmethod
    def create(cls, arg : "NonSpare_1181.cv_arg") -> "NonSpare_1181":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_356:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_363:
        return self.rule.variation

class Item_491(Item):
    cv_arg: TypeAlias = NonSpare_1181.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1181

    @classmethod
    def create(cls, arg : "Item_491.cv_arg") -> "Item_491":
        return cls._create(arg) # type: ignore

class Variation_1127(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_357.cv_arg, Tuple[Literal["LAT"], RuleVariation_357.cv_arg]], Union[RuleVariation_356.cv_arg, Tuple[Literal["LON"], RuleVariation_356.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1127.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_463, 24), (Item_491, 24)]
    cv_items_dict = {"LAT": RuleVariation_357, "LON": RuleVariation_356}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_356:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_357:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_356:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1127.cv_arg") -> 'Variation_1127':
        return cls._create(arg) # type: ignore

class RuleVariation_1083(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1127.cv_arg
    cv_variation: TypeAlias = Variation_1127

    @classmethod
    def create(cls, arg : "RuleVariation_1083.cv_arg") -> "RuleVariation_1083":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1127:
        return self.arg # type: ignore

class NonSpare_165(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1083.cv_arg
    cv_name = "045"
    cv_title = "Calculated Position in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1083

    @classmethod
    def create(cls, arg : "NonSpare_165.cv_arg") -> "NonSpare_165":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1083:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1127:
        return self.rule.variation

class UapItem_165(UapItem):
    cv_non_spare: TypeAlias = NonSpare_165

class Content_293(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Smoothed Mode-3/A code not extracted during the last scan"}

class RuleContent_293(RuleContentContextFree):
    cv_arg: TypeAlias = Content_293.cv_arg
    cv_content: TypeAlias = Content_293

    @property
    def content(self) -> Content_293:
        return self._get_content() # type: ignore

class Variation_556(Element):
    cv_arg: TypeAlias = RuleContent_293.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_293

    @classmethod
    def create(cls, arg: "Variation_556.cv_arg") -> "Variation_556":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_293:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_293:
        return self.rule.content

class RuleVariation_545(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_556.cv_arg
    cv_variation: TypeAlias = Variation_556

    @classmethod
    def create(cls, arg : "RuleVariation_545.cv_arg") -> "RuleVariation_545":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_556:
        return self.arg # type: ignore

class NonSpare_1144(NonSpare):
    cv_arg: TypeAlias = RuleVariation_545.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_545

    @classmethod
    def create(cls, arg : "NonSpare_1144.cv_arg") -> "NonSpare_1144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_545:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_556:
        return self.rule.variation

class Item_456(Item):
    cv_arg: TypeAlias = NonSpare_1144.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1144

    @classmethod
    def create(cls, arg : "Item_456.cv_arg") -> "Item_456":
        return cls._create(arg) # type: ignore

class NonSpare_1306(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE3A"
    cv_title = "Mode 3/A Reply in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1306.cv_arg") -> "NonSpare_1306":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_572(Item):
    cv_arg: TypeAlias = NonSpare_1306.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1306

    @classmethod
    def create(cls, arg : "Item_572.cv_arg") -> "Item_572":
        return cls._create(arg) # type: ignore

class Variation_1267(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_545.cv_arg, Tuple[Literal["L"], RuleVariation_545.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1267.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_456, 1), (Item_16, 1), (Item_572, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_545, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_545:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_545:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1267.cv_arg") -> 'Variation_1267':
        return cls._create(arg) # type: ignore

class RuleVariation_1196(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1267.cv_arg
    cv_variation: TypeAlias = Variation_1267

    @classmethod
    def create(cls, arg : "RuleVariation_1196.cv_arg") -> "RuleVariation_1196":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1267:
        return self.arg # type: ignore

class NonSpare_210(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1196.cv_arg
    cv_name = "070"
    cv_title = "Mode 3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1196

    @classmethod
    def create(cls, arg : "NonSpare_210.cv_arg") -> "NonSpare_210":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1267:
        return self.rule.variation

class UapItem_210(UapItem):
    cv_non_spare: TypeAlias = NonSpare_210

class Content_98(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Garbled code / Error correction applied"}

class RuleContent_98(RuleContentContextFree):
    cv_arg: TypeAlias = Content_98.cv_arg
    cv_content: TypeAlias = Content_98

    @property
    def content(self) -> Content_98:
        return self._get_content() # type: ignore

class Variation_408(Element):
    cv_arg: TypeAlias = RuleContent_98.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_98

    @classmethod
    def create(cls, arg: "Variation_408.cv_arg") -> "Variation_408":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_98:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_98:
        return self.rule.content

class RuleVariation_397(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_408.cv_arg
    cv_variation: TypeAlias = Variation_408

    @classmethod
    def create(cls, arg : "RuleVariation_397.cv_arg") -> "RuleVariation_397":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_408:
        return self.arg # type: ignore

class NonSpare_1010(NonSpare):
    cv_arg: TypeAlias = RuleVariation_397.cv_arg
    cv_name = "G"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_397

    @classmethod
    def create(cls, arg : "NonSpare_1010.cv_arg") -> "NonSpare_1010":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_397:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_408:
        return self.rule.variation

class Item_356(Item):
    cv_arg: TypeAlias = NonSpare_1010.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1010

    @classmethod
    def create(cls, arg : "Item_356.cv_arg") -> "Item_356":
        return cls._create(arg) # type: ignore

class Variation_611(Element):
    cv_arg: TypeAlias = RuleContent_751.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_751

    @classmethod
    def create(cls, arg: "Variation_611.cv_arg") -> "Variation_611":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_751:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_752:
        return self.rule.content

class RuleVariation_600(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_611.cv_arg
    cv_variation: TypeAlias = Variation_611

    @classmethod
    def create(cls, arg : "RuleVariation_600.cv_arg") -> "RuleVariation_600":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_611:
        return self.arg # type: ignore

class NonSpare_592(NonSpare):
    cv_arg: TypeAlias = RuleVariation_600.cv_arg
    cv_name = "ALT"
    cv_title = "Altitude"
    cv_rule: TypeAlias = RuleVariation_600

    @classmethod
    def create(cls, arg : "NonSpare_592.cv_arg") -> "NonSpare_592":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_600:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_611:
        return self.rule.variation

class Item_59(Item):
    cv_arg: TypeAlias = NonSpare_592.cv_arg
    cv_non_spare: TypeAlias = NonSpare_592

    @classmethod
    def create(cls, arg : "Item_59.cv_arg") -> "Item_59":
        return cls._create(arg) # type: ignore

class Variation_1268(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_397.cv_arg, Tuple[Literal["G"], RuleVariation_397.cv_arg]], Union[RuleVariation_600.cv_arg, Tuple[Literal["ALT"], RuleVariation_600.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1268.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_356, 1), (Item_59, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_397, "ALT": RuleVariation_600}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_397:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_600:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_397:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_600:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1268.cv_arg") -> 'Variation_1268':
        return cls._create(arg) # type: ignore

class RuleVariation_1197(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1268.cv_arg
    cv_variation: TypeAlias = Variation_1268

    @classmethod
    def create(cls, arg : "RuleVariation_1197.cv_arg") -> "RuleVariation_1197":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1268:
        return self.arg # type: ignore

class NonSpare_170(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1197.cv_arg
    cv_name = "050"
    cv_title = "Flight Level in Binary Representation"
    cv_rule: TypeAlias = RuleVariation_1197

    @classmethod
    def create(cls, arg : "NonSpare_170.cv_arg") -> "NonSpare_170":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1197:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1268:
        return self.rule.variation

class UapItem_170(UapItem):
    cv_non_spare: TypeAlias = NonSpare_170

class NonSpare_403(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1072.cv_arg
    cv_name = "200"
    cv_title = "Track Velocity in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1072

    @classmethod
    def create(cls, arg : "NonSpare_403.cv_arg") -> "NonSpare_403":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1072:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1114:
        return self.rule.variation

class UapItem_403(UapItem):
    cv_non_spare: TypeAlias = NonSpare_403

class Content_340(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No communications capability (surveillance only), no ability to set CA code 7 either airborne or on the ground", 1: "Reserved", 2: "Reserved", 3: "Reserved", 4: "At Least Comm. A and Comm. B capability and the ability to set CA code 7 and on the ground", 5: "At Least Comm. A and Comm. B capability and the ability to set CA code 7 and airborne", 6: "At Least Comm. A and Comm. B capability and the ability to set CA code 7 and either airborne or on the ground", 7: "Signifies the DR field is not equal to 0 or the FS field equals 2, 3, 4 or 5 and either airborne or on the ground SI/II-capabilities of the Transponder"}

class RuleContent_340(RuleContentContextFree):
    cv_arg: TypeAlias = Content_340.cv_arg
    cv_content: TypeAlias = Content_340

    @property
    def content(self) -> Content_340:
        return self._get_content() # type: ignore

class Variation_125(Element):
    cv_arg: TypeAlias = RuleContent_340.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_340

    @classmethod
    def create(cls, arg: "Variation_125.cv_arg") -> "Variation_125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_340:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_340:
        return self.rule.content

class RuleVariation_125(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_125.cv_arg
    cv_variation: TypeAlias = Variation_125

    @classmethod
    def create(cls, arg : "RuleVariation_125.cv_arg") -> "RuleVariation_125":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_125:
        return self.arg # type: ignore

class NonSpare_701(NonSpare):
    cv_arg: TypeAlias = RuleVariation_125.cv_arg
    cv_name = "CA"
    cv_title = "Communications Capability of the Transponder"
    cv_rule: TypeAlias = RuleVariation_125

    @classmethod
    def create(cls, arg : "NonSpare_701.cv_arg") -> "NonSpare_701":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_125:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_125:
        return self.rule.variation

class Item_133(Item):
    cv_arg: TypeAlias = NonSpare_701.cv_arg
    cv_non_spare: TypeAlias = NonSpare_701

    @classmethod
    def create(cls, arg : "Item_133.cv_arg") -> "Item_133":
        return cls._create(arg) # type: ignore

class Content_523(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Transponder SI capable", 1: "Transponder not SI capable"}

class RuleContent_523(RuleContentContextFree):
    cv_arg: TypeAlias = Content_523.cv_arg
    cv_content: TypeAlias = Content_523

    @property
    def content(self) -> Content_523:
        return self._get_content() # type: ignore

class Variation_669(Element):
    cv_arg: TypeAlias = RuleContent_523.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_523

    @classmethod
    def create(cls, arg: "Variation_669.cv_arg") -> "Variation_669":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_523:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_523:
        return self.rule.content

class RuleVariation_658(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_669.cv_arg
    cv_variation: TypeAlias = Variation_669

    @classmethod
    def create(cls, arg : "RuleVariation_658.cv_arg") -> "RuleVariation_658":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_669:
        return self.arg # type: ignore

class NonSpare_1708(NonSpare):
    cv_arg: TypeAlias = RuleVariation_658.cv_arg
    cv_name = "SI"
    cv_title = "SI/II-capabilities of the Transponder"
    cv_rule: TypeAlias = RuleVariation_658

    @classmethod
    def create(cls, arg : "NonSpare_1708.cv_arg") -> "NonSpare_1708":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_658:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_669:
        return self.rule.variation

class Item_885(Item):
    cv_arg: TypeAlias = NonSpare_1708.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1708

    @classmethod
    def create(cls, arg : "Item_885.cv_arg") -> "Item_885":
        return cls._create(arg) # type: ignore

class Variation_1063(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_125.cv_arg, Tuple[Literal["CA"], RuleVariation_125.cv_arg]], Union[RuleVariation_658.cv_arg, Tuple[Literal["SI"], RuleVariation_658.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1063.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_133, 3), (Item_885, 1), (Item_22, 4)]
    cv_items_dict = {"CA": RuleVariation_125, "SI": RuleVariation_658}

    @overload
    @classmethod
    def spec(cls, key : Literal["CA"]) -> RuleVariation_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SI"]) -> RuleVariation_658:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CA"], Literal["SI"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CA"]) -> RuleVariation_125:
        ...
    @overload
    def get_item(self, key : Literal["SI"]) -> RuleVariation_658:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1063.cv_arg") -> 'Variation_1063':
        return cls._create(arg) # type: ignore

class RuleVariation_1027(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1063.cv_arg
    cv_variation: TypeAlias = Variation_1063

    @classmethod
    def create(cls, arg : "RuleVariation_1027.cv_arg") -> "RuleVariation_1027":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1063:
        return self.arg # type: ignore

class NonSpare_435(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1027.cv_arg
    cv_name = "230"
    cv_title = "Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_1027

    @classmethod
    def create(cls, arg : "NonSpare_435.cv_arg") -> "NonSpare_435":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1027:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1063:
        return self.rule.variation

class UapItem_435(UapItem):
    cv_non_spare: TypeAlias = NonSpare_435

class Content_267(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Measured position", 1: "No measured position (coasted)"}

class RuleContent_267(RuleContentContextFree):
    cv_arg: TypeAlias = Content_267.cv_arg
    cv_content: TypeAlias = Content_267

    @property
    def content(self) -> Content_267:
        return self._get_content() # type: ignore

class Variation_53(Element):
    cv_arg: TypeAlias = RuleContent_267.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_267

    @classmethod
    def create(cls, arg: "Variation_53.cv_arg") -> "Variation_53":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_267:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_267:
        return self.rule.content

class RuleVariation_53(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_53.cv_arg
    cv_variation: TypeAlias = Variation_53

    @classmethod
    def create(cls, arg : "RuleVariation_53.cv_arg") -> "RuleVariation_53":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_53:
        return self.arg # type: ignore

class NonSpare_844(NonSpare):
    cv_arg: TypeAlias = RuleVariation_53.cv_arg
    cv_name = "CST"
    cv_title = "Track Coasted"
    cv_rule: TypeAlias = RuleVariation_53

    @classmethod
    def create(cls, arg : "NonSpare_844.cv_arg") -> "NonSpare_844":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_53:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_53:
        return self.rule.variation

class Item_226(Item):
    cv_arg: TypeAlias = NonSpare_844.cv_arg
    cv_non_spare: TypeAlias = NonSpare_844

    @classmethod
    def create(cls, arg : "Item_226.cv_arg") -> "Item_226":
        return cls._create(arg) # type: ignore

class Content_255(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Last Measured Flight Level", 1: "Predicted Flight Level"}

class RuleContent_255(RuleContentContextFree):
    cv_arg: TypeAlias = Content_255.cv_arg
    cv_content: TypeAlias = Content_255

    @property
    def content(self) -> Content_255:
        return self._get_content() # type: ignore

class Variation_436(Element):
    cv_arg: TypeAlias = RuleContent_255.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_255

    @classmethod
    def create(cls, arg: "Variation_436.cv_arg") -> "Variation_436":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_255:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_255:
        return self.rule.content

class RuleVariation_425(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_436.cv_arg
    cv_variation: TypeAlias = Variation_436

    @classmethod
    def create(cls, arg : "RuleVariation_425.cv_arg") -> "RuleVariation_425":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_436:
        return self.arg # type: ignore

class NonSpare_979(NonSpare):
    cv_arg: TypeAlias = RuleVariation_425.cv_arg
    cv_name = "FLT"
    cv_title = "Flight Level Tracking"
    cv_rule: TypeAlias = RuleVariation_425

    @classmethod
    def create(cls, arg : "NonSpare_979.cv_arg") -> "NonSpare_979":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_425:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_436:
        return self.rule.variation

class Item_333(Item):
    cv_arg: TypeAlias = NonSpare_979.cv_arg
    cv_non_spare: TypeAlias = NonSpare_979

    @classmethod
    def create(cls, arg : "Item_333.cv_arg") -> "Item_333":
        return cls._create(arg) # type: ignore

class Variation_1081(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_53.cv_arg, Tuple[Literal["CST"], RuleVariation_53.cv_arg]], Union[RuleVariation_425.cv_arg, Tuple[Literal["FLT"], RuleVariation_425.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1081.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_226, 1), (Item_333, 1), (Item_15, 6)]
    cv_items_dict = {"CST": RuleVariation_53, "FLT": RuleVariation_425}

    @overload
    @classmethod
    def spec(cls, key : Literal["CST"]) -> RuleVariation_53:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FLT"]) -> RuleVariation_425:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CST"], Literal["FLT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_53:
        ...
    @overload
    def get_item(self, key : Literal["FLT"]) -> RuleVariation_425:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1081.cv_arg") -> 'Variation_1081':
        return cls._create(arg) # type: ignore

class RuleVariation_1041(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1081.cv_arg
    cv_variation: TypeAlias = Variation_1081

    @classmethod
    def create(cls, arg : "RuleVariation_1041.cv_arg") -> "RuleVariation_1041":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1081:
        return self.arg # type: ignore

class NonSpare_439(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1041.cv_arg
    cv_name = "240"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1041

    @classmethod
    def create(cls, arg : "NonSpare_439.cv_arg") -> "NonSpare_439":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1041:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1081:
        return self.rule.variation

class UapItem_439(UapItem):
    cv_non_spare: TypeAlias = NonSpare_439

class Variation_1398(Repetitive):
    cv_arg: TypeAlias = List[Variation_349.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_349

    @classmethod
    def create(cls, arg: "Variation_1398.cv_arg") -> 'Variation_1398':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_349]:
        return self._get_list() # type: ignore

class RuleVariation_1319(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1398.cv_arg
    cv_variation: TypeAlias = Variation_1398

    @classmethod
    def create(cls, arg : "RuleVariation_1319.cv_arg") -> "RuleVariation_1319":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1398:
        return self.arg # type: ignore

class NonSpare_415(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1319.cv_arg
    cv_name = "210"
    cv_title = "Mode S Address List"
    cv_rule: TypeAlias = RuleVariation_1319

    @classmethod
    def create(cls, arg : "NonSpare_415.cv_arg") -> "NonSpare_415":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1398:
        return self.rule.variation

class UapItem_415(UapItem):
    cv_non_spare: TypeAlias = NonSpare_415

class NonSpare_484(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "360"
    cv_title = "Cluster Controller Command State"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_484.cv_arg") -> "NonSpare_484":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_484(UapItem):
    cv_non_spare: TypeAlias = NonSpare_484

class Record_35(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_41.cv_arg,
        "012": NonSpare_54.cv_arg,
        "000": NonSpare_1.cv_arg,
        "350": NonSpare_483.cv_arg,
        "220": NonSpare_419.cv_arg,
        "221": NonSpare_428.cv_arg,
        "140": NonSpare_334.cv_arg,
        "045": NonSpare_165.cv_arg,
        "070": NonSpare_210.cv_arg,
        "050": NonSpare_170.cv_arg,
        "200": NonSpare_403.cv_arg,
        "230": NonSpare_435.cv_arg,
        "240": NonSpare_439.cv_arg,
        "210": NonSpare_415.cv_arg,
        "360": NonSpare_484.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_41, UapItem_54, UapItem_1, UapItem_483, UapItem_419, UapItem_428, UapItem_334, UapItem_165, UapItem_210, UapItem_170, UapItem_403, UapItem_435, UapItem_439, UapItem_415, UapItem_484, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_548]
    cv_items_dict = {"010": NonSpare_41, "012": NonSpare_54, "000": NonSpare_1, "350": NonSpare_483, "220": NonSpare_419, "221": NonSpare_428, "140": NonSpare_334, "045": NonSpare_165, "070": NonSpare_210, "050": NonSpare_170, "200": NonSpare_403, "230": NonSpare_435, "240": NonSpare_439, "210": NonSpare_415, "360": NonSpare_484, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["012"]) -> NonSpare_54:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_1:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["350"]) -> NonSpare_483:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_419:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["221"]) -> NonSpare_428:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_334:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["045"]) -> NonSpare_165:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_210:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_170:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_403:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_415:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["360"]) -> NonSpare_484:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["012"], Literal["000"], Literal["350"], Literal["220"], Literal["221"], Literal["140"], Literal["045"], Literal["070"], Literal["050"], Literal["200"], Literal["230"], Literal["240"], Literal["210"], Literal["360"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_41]:
        ...
    @overload
    def get_item(self, key : Literal["012"]) -> Optional[NonSpare_54]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_1]:
        ...
    @overload
    def get_item(self, key : Literal["350"]) -> Optional[NonSpare_483]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_419]:
        ...
    @overload
    def get_item(self, key : Literal["221"]) -> Optional[NonSpare_428]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_334]:
        ...
    @overload
    def get_item(self, key : Literal["045"]) -> Optional[NonSpare_165]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_210]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_170]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_403]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_435]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_439]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_415]:
        ...
    @overload
    def get_item(self, key : Literal["360"]) -> Optional[NonSpare_484]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_41.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["012"], val : NonSpare_54.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_1.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["350"], val : NonSpare_483.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_419.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["221"], val : NonSpare_428.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_334.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["045"], val : NonSpare_165.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_210.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_170.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_403.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_435.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_439.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_415.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["360"], val : NonSpare_484.cv_arg) -> 'Record_35':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_35':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["012"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["350"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["221"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["045"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["360"]) -> 'Record_35':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_35':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_35.cv_arg") -> 'Record_35':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_35", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_31(UapSingle):
    cv_arg: TypeAlias = Record_35
    cv_record: TypeAlias = Record_35

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_35]]:
        return cls._parse(bs)

class Asterix_18(AstCat):
    cv_category = 17
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_31
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_31.cv_arg]) -> "Asterix_18":
        return cls._create(records) # type: ignore

class NonSpare_132(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "036"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_132.cv_arg") -> "NonSpare_132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_132(UapItem):
    cv_non_spare: TypeAlias = NonSpare_132

class NonSpare_134(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "037"
    cv_title = "Data Destination Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_134.cv_arg") -> "NonSpare_134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_134(UapItem):
    cv_non_spare: TypeAlias = NonSpare_134

class Content_36(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Associate_req", 1: "Associate_resp", 2: "Release_req", 3: "Release_resp", 4: "Abort_req", 5: "Keep_alive", 16: "Aircraft_report", 17: "Aircraft_command", 18: "II_code_change", 32: "Uplink_packet", 33: "Cancel_uplink_packet", 34: "Uplink_packet_ack", 35: "Downlink_packet", 38: "Data_XON", 39: "Data_XOFF", 48: "Uplink_broadcast", 49: "Cancel_uplink_broadcast", 50: "Uplink_broadcast_ack", 52: "Downlink_broadcast", 64: "GICB_extraction", 65: "Cancel_GICB_extraction", 66: "GICB_extraction_ack", 67: "GICB_response"}

class RuleContent_36(RuleContentContextFree):
    cv_arg: TypeAlias = Content_36.cv_arg
    cv_content: TypeAlias = Content_36

    @property
    def content(self) -> Content_36:
        return self._get_content() # type: ignore

class Variation_166(Element):
    cv_arg: TypeAlias = RuleContent_36.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_36

    @classmethod
    def create(cls, arg: "Variation_166.cv_arg") -> "Variation_166":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_36:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_36:
        return self.rule.content

class RuleVariation_160(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_166.cv_arg
    cv_variation: TypeAlias = Variation_166

    @classmethod
    def create(cls, arg : "RuleVariation_160.cv_arg") -> "RuleVariation_160":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_166:
        return self.arg # type: ignore

class NonSpare_0(NonSpare):
    cv_arg: TypeAlias = RuleVariation_160.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_160

    @classmethod
    def create(cls, arg : "NonSpare_0.cv_arg") -> "NonSpare_0":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_160:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_166:
        return self.rule.variation

class UapItem_0(UapItem):
    cv_non_spare: TypeAlias = NonSpare_0

class Content_14(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Accepted, the request is accepted and is under processing", 1: "Rejected, the request has not been accepted", 2: "Cancelled, the request has been cancelled", 3: "Finished, the request has been accepted and successfully processed", 4: "Delayed, the request processing is temporarily delayed but the request is still valid", 5: "In Progress, the request is being successfully processed", 6: "In Progress, the request is being successfully processed"}

class RuleContent_14(RuleContentContextFree):
    cv_arg: TypeAlias = Content_14.cv_arg
    cv_content: TypeAlias = Content_14

    @property
    def content(self) -> Content_14:
        return self._get_content() # type: ignore

class Variation_133(Element):
    cv_arg: TypeAlias = RuleContent_14.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_14

    @classmethod
    def create(cls, arg: "Variation_133.cv_arg") -> "Variation_133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_14:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_14:
        return self.rule.content

class RuleVariation_133(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_133.cv_arg
    cv_variation: TypeAlias = Variation_133

    @classmethod
    def create(cls, arg : "RuleVariation_133.cv_arg") -> "RuleVariation_133":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_133:
        return self.arg # type: ignore

class NonSpare_709(NonSpare):
    cv_arg: TypeAlias = RuleVariation_133.cv_arg
    cv_name = "CAUSE"
    cv_title = "Cause"
    cv_rule: TypeAlias = RuleVariation_133

    @classmethod
    def create(cls, arg : "NonSpare_709.cv_arg") -> "NonSpare_709":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_133:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_133:
        return self.rule.variation

class Item_139(Item):
    cv_arg: TypeAlias = NonSpare_709.cv_arg
    cv_non_spare: TypeAlias = NonSpare_709

    @classmethod
    def create(cls, arg : "Item_139.cv_arg") -> "Item_139":
        return cls._create(arg) # type: ignore

class Content_351(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No diagnostic available", 1: "Aircraft Exit", 2: "Incorrect aircraft address", 3: "Impossibility to process the message", 4: "Insufficient or change in data link capability", 5: "Invalid LV field", 6: "Duplicate request number", 7: "Unknown request number", 8: "Timer T3 expiry", 9: "Expiry of I/R delivery timer", 10: "Uplink flow disabled by UC"}

class RuleContent_351(RuleContentContextFree):
    cv_arg: TypeAlias = Content_351.cv_arg
    cv_content: TypeAlias = Content_351

    @property
    def content(self) -> Content_351:
        return self._get_content() # type: ignore

class Variation_801(Element):
    cv_arg: TypeAlias = RuleContent_351.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_351

    @classmethod
    def create(cls, arg: "Variation_801.cv_arg") -> "Variation_801":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_351:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_351:
        return self.rule.content

class RuleVariation_771(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_801.cv_arg
    cv_variation: TypeAlias = Variation_801

    @classmethod
    def create(cls, arg : "RuleVariation_771.cv_arg") -> "RuleVariation_771":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_801:
        return self.arg # type: ignore

class NonSpare_884(NonSpare):
    cv_arg: TypeAlias = RuleVariation_771.cv_arg
    cv_name = "DIAG"
    cv_title = "Diagnostic"
    cv_rule: TypeAlias = RuleVariation_771

    @classmethod
    def create(cls, arg : "NonSpare_884.cv_arg") -> "NonSpare_884":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_771:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_801:
        return self.rule.variation

class Item_261(Item):
    cv_arg: TypeAlias = NonSpare_884.cv_arg
    cv_non_spare: TypeAlias = NonSpare_884

    @classmethod
    def create(cls, arg : "Item_261.cv_arg") -> "Item_261":
        return cls._create(arg) # type: ignore

class Variation_1065(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_133.cv_arg, Tuple[Literal["CAUSE"], RuleVariation_133.cv_arg]], Union[RuleVariation_771.cv_arg, Tuple[Literal["DIAG"], RuleVariation_771.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1065.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_139, 4), (Item_261, 4)]
    cv_items_dict = {"CAUSE": RuleVariation_133, "DIAG": RuleVariation_771}

    @overload
    @classmethod
    def spec(cls, key : Literal["CAUSE"]) -> RuleVariation_133:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DIAG"]) -> RuleVariation_771:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CAUSE"], Literal["DIAG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CAUSE"]) -> RuleVariation_133:
        ...
    @overload
    def get_item(self, key : Literal["DIAG"]) -> RuleVariation_771:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1065.cv_arg") -> 'Variation_1065':
        return cls._create(arg) # type: ignore

class RuleVariation_1028(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1065.cv_arg
    cv_variation: TypeAlias = Variation_1065

    @classmethod
    def create(cls, arg : "RuleVariation_1028.cv_arg") -> "RuleVariation_1028":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1065:
        return self.arg # type: ignore

class NonSpare_20(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1028.cv_arg
    cv_name = "001"
    cv_title = "Result"
    cv_rule: TypeAlias = RuleVariation_1028

    @classmethod
    def create(cls, arg : "NonSpare_20.cv_arg") -> "NonSpare_20":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1028:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1065:
        return self.rule.variation

class UapItem_20(UapItem):
    cv_non_spare: TypeAlias = NonSpare_20

class NonSpare_23(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "005"
    cv_title = "Mode S Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_23.cv_arg") -> "NonSpare_23":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_23(UapItem):
    cv_non_spare: TypeAlias = NonSpare_23

class Variation_375(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_375.cv_arg") -> "Variation_375":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_368(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_375.cv_arg
    cv_variation: TypeAlias = Variation_375

    @classmethod
    def create(cls, arg : "RuleVariation_368.cv_arg") -> "RuleVariation_368":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_375:
        return self.arg # type: ignore

class NonSpare_71(NonSpare):
    cv_arg: TypeAlias = RuleVariation_368.cv_arg
    cv_name = "016"
    cv_title = "Packet Number"
    cv_rule: TypeAlias = RuleVariation_368

    @classmethod
    def create(cls, arg : "NonSpare_71.cv_arg") -> "NonSpare_71":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

class UapItem_71(UapItem):
    cv_non_spare: TypeAlias = NonSpare_71

class Variation_1402(Repetitive):
    cv_arg: TypeAlias = List[Variation_375.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_375

    @classmethod
    def create(cls, arg: "Variation_1402.cv_arg") -> 'Variation_1402':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_375]:
        return self._get_list() # type: ignore

class RuleVariation_1323(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1402.cv_arg
    cv_variation: TypeAlias = Variation_1402

    @classmethod
    def create(cls, arg : "RuleVariation_1323.cv_arg") -> "RuleVariation_1323":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1402:
        return self.arg # type: ignore

class NonSpare_73(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1323.cv_arg
    cv_name = "017"
    cv_title = "Packet Number List"
    cv_rule: TypeAlias = RuleVariation_1323

    @classmethod
    def create(cls, arg : "NonSpare_73.cv_arg") -> "NonSpare_73":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1402:
        return self.rule.variation

class UapItem_73(UapItem):
    cv_non_spare: TypeAlias = NonSpare_73

class Variation_492(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 5
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_492.cv_arg") -> "Variation_492":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_481(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_492.cv_arg
    cv_variation: TypeAlias = Variation_492

    @classmethod
    def create(cls, arg : "RuleVariation_481.cv_arg") -> "RuleVariation_481":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_492:
        return self.arg # type: ignore

class NonSpare_1456(NonSpare):
    cv_arg: TypeAlias = RuleVariation_481.cv_arg
    cv_name = "PR"
    cv_title = "Mode S Packet Internal Priority"
    cv_rule: TypeAlias = RuleVariation_481

    @classmethod
    def create(cls, arg : "NonSpare_1456.cv_arg") -> "NonSpare_1456":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_481:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_492:
        return self.rule.variation

class Item_699(Item):
    cv_arg: TypeAlias = NonSpare_1456.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1456

    @classmethod
    def create(cls, arg : "Item_699.cv_arg") -> "Item_699":
        return cls._create(arg) # type: ignore

class Content_453(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "SVC packets", 1: "MSP packets", 2: "Route packets"}

class RuleContent_453(RuleContentContextFree):
    cv_arg: TypeAlias = Content_453.cv_arg
    cv_content: TypeAlias = Content_453

    @property
    def content(self) -> Content_453:
        return self._get_content() # type: ignore

class Variation_964(Element):
    cv_arg: TypeAlias = RuleContent_453.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_453

    @classmethod
    def create(cls, arg: "Variation_964.cv_arg") -> "Variation_964":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_453:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_453:
        return self.rule.content

class RuleVariation_934(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_964.cv_arg
    cv_variation: TypeAlias = Variation_964

    @classmethod
    def create(cls, arg : "RuleVariation_934.cv_arg") -> "RuleVariation_934":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_964:
        return self.arg # type: ignore

class NonSpare_1481(NonSpare):
    cv_arg: TypeAlias = RuleVariation_934.cv_arg
    cv_name = "PT"
    cv_title = "Packet Type"
    cv_rule: TypeAlias = RuleVariation_934

    @classmethod
    def create(cls, arg : "NonSpare_1481.cv_arg") -> "NonSpare_1481":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_934:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_964:
        return self.rule.variation

class Item_717(Item):
    cv_arg: TypeAlias = NonSpare_1481.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1481

    @classmethod
    def create(cls, arg : "Item_717.cv_arg") -> "Item_717":
        return cls._create(arg) # type: ignore

class Variation_997(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_481.cv_arg, Tuple[Literal["PR"], RuleVariation_481.cv_arg]], Union[RuleVariation_934.cv_arg, Tuple[Literal["PT"], RuleVariation_934.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_997.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_699, 5), (Item_717, 2)]
    cv_items_dict = {"PR": RuleVariation_481, "PT": RuleVariation_934}

    @overload
    @classmethod
    def spec(cls, key : Literal["PR"]) -> RuleVariation_481:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PT"]) -> RuleVariation_934:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PR"], Literal["PT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PR"]) -> RuleVariation_481:
        ...
    @overload
    def get_item(self, key : Literal["PT"]) -> RuleVariation_934:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_997.cv_arg") -> 'Variation_997':
        return cls._create(arg) # type: ignore

class RuleVariation_967(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_997.cv_arg
    cv_variation: TypeAlias = Variation_997

    @classmethod
    def create(cls, arg : "RuleVariation_967.cv_arg") -> "RuleVariation_967":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_997:
        return self.arg # type: ignore

class NonSpare_75(NonSpare):
    cv_arg: TypeAlias = RuleVariation_967.cv_arg
    cv_name = "018"
    cv_title = "Mode S Packet Properties"
    cv_rule: TypeAlias = RuleVariation_967

    @classmethod
    def create(cls, arg : "NonSpare_75.cv_arg") -> "NonSpare_75":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_967:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_997:
        return self.rule.variation

class UapItem_75(UapItem):
    cv_non_spare: TypeAlias = NonSpare_75

class Variation_1462(Explicit):
    cv_arg: TypeAlias = bytes
    cv_explicit_type: TypeAlias = None

    @classmethod
    def create(cls, arg: "Variation_1462.cv_arg") -> 'Variation_1462':
        return cls._create(arg) # type: ignore

class RuleVariation_1383(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1462.cv_arg
    cv_variation: TypeAlias = Variation_1462

    @classmethod
    def create(cls, arg : "RuleVariation_1383.cv_arg") -> "RuleVariation_1383":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1462:
        return self.arg # type: ignore

class NonSpare_76(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1383.cv_arg
    cv_name = "019"
    cv_title = "Mode S Packet"
    cv_rule: TypeAlias = RuleVariation_1383

    @classmethod
    def create(cls, arg : "NonSpare_76.cv_arg") -> "NonSpare_76":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1462:
        return self.rule.variation

class UapItem_76(UapItem):
    cv_non_spare: TypeAlias = NonSpare_76

class Content_724(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_724(RuleContentContextFree):
    cv_arg: TypeAlias = Content_724.cv_arg
    cv_content: TypeAlias = Content_724

    @property
    def content(self) -> Content_724:
        return self._get_content() # type: ignore

class Variation_308(Element):
    cv_arg: TypeAlias = RuleContent_724.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_724

    @classmethod
    def create(cls, arg: "Variation_308.cv_arg") -> "Variation_308":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_724:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_724:
        return self.rule.content

class RuleVariation_301(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_308.cv_arg
    cv_variation: TypeAlias = Variation_308

    @classmethod
    def create(cls, arg : "RuleVariation_301.cv_arg") -> "RuleVariation_301":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_308:
        return self.arg # type: ignore

class NonSpare_103(NonSpare):
    cv_arg: TypeAlias = RuleVariation_301.cv_arg
    cv_name = "028"
    cv_title = "GICB Extraction Periodicity"
    cv_rule: TypeAlias = RuleVariation_301

    @classmethod
    def create(cls, arg : "NonSpare_103.cv_arg") -> "NonSpare_103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_301:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_308:
        return self.rule.variation

class UapItem_103(UapItem):
    cv_non_spare: TypeAlias = NonSpare_103

class Variation_147(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_147.cv_arg") -> "Variation_147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_147(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_147.cv_arg
    cv_variation: TypeAlias = Variation_147

    @classmethod
    def create(cls, arg : "RuleVariation_147.cv_arg") -> "RuleVariation_147":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_147:
        return self.arg # type: ignore

class NonSpare_1466(NonSpare):
    cv_arg: TypeAlias = RuleVariation_147.cv_arg
    cv_name = "PRIORITY"
    cv_title = "GICB Priority"
    cv_rule: TypeAlias = RuleVariation_147

    @classmethod
    def create(cls, arg : "NonSpare_1466.cv_arg") -> "NonSpare_1466":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_147:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_147:
        return self.rule.variation

class Item_709(Item):
    cv_arg: TypeAlias = NonSpare_1466.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1466

    @classmethod
    def create(cls, arg : "Item_709.cv_arg") -> "Item_709":
        return cls._create(arg) # type: ignore

class Item_25(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 5
    cv_bit_size = 3

class Content_508(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The periodicity may not be strictly respected", 1: "The periodicity shall be strictly respected"}

class RuleContent_508(RuleContentContextFree):
    cv_arg: TypeAlias = Content_508.cv_arg
    cv_content: TypeAlias = Content_508

    @property
    def content(self) -> Content_508:
        return self._get_content() # type: ignore

class Variation_89(Element):
    cv_arg: TypeAlias = RuleContent_508.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_508

    @classmethod
    def create(cls, arg: "Variation_89.cv_arg") -> "Variation_89":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_508:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_508:
        return self.rule.content

class RuleVariation_89(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_89.cv_arg
    cv_variation: TypeAlias = Variation_89

    @classmethod
    def create(cls, arg : "RuleVariation_89.cv_arg") -> "RuleVariation_89":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_89:
        return self.arg # type: ignore

class NonSpare_1423(NonSpare):
    cv_arg: TypeAlias = RuleVariation_89.cv_arg
    cv_name = "PC"
    cv_title = "Periodicity Constraint"
    cv_rule: TypeAlias = RuleVariation_89

    @classmethod
    def create(cls, arg : "NonSpare_1423.cv_arg") -> "NonSpare_1423":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_89:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_89:
        return self.rule.variation

class Item_679(Item):
    cv_arg: TypeAlias = NonSpare_1423.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1423

    @classmethod
    def create(cls, arg : "Item_679.cv_arg") -> "Item_679":
        return cls._create(arg) # type: ignore

class Content_220(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "GICB extractions should be sent only when required by the periodicity", 1: "If a GICB extraction is done due to external conditions, an update will also be sent, even if it does not match the expected periodicity"}

class RuleContent_220(RuleContentContextFree):
    cv_arg: TypeAlias = Content_220.cv_arg
    cv_content: TypeAlias = Content_220

    @property
    def content(self) -> Content_220:
        return self._get_content() # type: ignore

class Variation_428(Element):
    cv_arg: TypeAlias = RuleContent_220.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_220

    @classmethod
    def create(cls, arg: "Variation_428.cv_arg") -> "Variation_428":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_220:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_220:
        return self.rule.content

class RuleVariation_417(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_428.cv_arg
    cv_variation: TypeAlias = Variation_428

    @classmethod
    def create(cls, arg : "RuleVariation_417.cv_arg") -> "RuleVariation_417":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_428:
        return self.arg # type: ignore

class NonSpare_647(NonSpare):
    cv_arg: TypeAlias = RuleVariation_417.cv_arg
    cv_name = "AU"
    cv_title = "Asynchronous Update"
    cv_rule: TypeAlias = RuleVariation_417

    @classmethod
    def create(cls, arg : "NonSpare_647.cv_arg") -> "NonSpare_647":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_417:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_428:
        return self.rule.variation

class Item_92(Item):
    cv_arg: TypeAlias = NonSpare_647.cv_arg
    cv_non_spare: TypeAlias = NonSpare_647

    @classmethod
    def create(cls, arg : "Item_92.cv_arg") -> "Item_92":
        return cls._create(arg) # type: ignore

class Content_489(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The GICB extraction is attempted according to the periodicity", 1: "There will no GICB attempts"}

class RuleContent_489(RuleContentContextFree):
    cv_arg: TypeAlias = Content_489.cv_arg
    cv_content: TypeAlias = Content_489

    @property
    def content(self) -> Content_489:
        return self._get_content() # type: ignore

class Variation_578(Element):
    cv_arg: TypeAlias = RuleContent_489.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_489

    @classmethod
    def create(cls, arg: "Variation_578.cv_arg") -> "Variation_578":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_489:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_489:
        return self.rule.content

class RuleVariation_567(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_578.cv_arg
    cv_variation: TypeAlias = Variation_578

    @classmethod
    def create(cls, arg : "RuleVariation_567.cv_arg") -> "RuleVariation_567":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_578:
        return self.arg # type: ignore

class NonSpare_1358(NonSpare):
    cv_arg: TypeAlias = RuleVariation_567.cv_arg
    cv_name = "NE"
    cv_title = "Non Extraction"
    cv_rule: TypeAlias = RuleVariation_567

    @classmethod
    def create(cls, arg : "NonSpare_1358.cv_arg") -> "NonSpare_1358":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_567:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_578:
        return self.rule.variation

class Item_618(Item):
    cv_arg: TypeAlias = NonSpare_1358.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1358

    @classmethod
    def create(cls, arg : "Item_618.cv_arg") -> "Item_618":
        return cls._create(arg) # type: ignore

class Content_492(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The extracted GICB must be sent only on the Data Link line", 1: "The extracted GICB must be sent only on the Surveillance line", 2: "The extracted GICB must be sent both on the Data Link and on the Surveillance lines"}

class RuleContent_492(RuleContentContextFree):
    cv_arg: TypeAlias = Content_492.cv_arg
    cv_content: TypeAlias = Content_492

    @property
    def content(self) -> Content_492:
        return self._get_content() # type: ignore

class Variation_681(Element):
    cv_arg: TypeAlias = RuleContent_492.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_492

    @classmethod
    def create(cls, arg: "Variation_681.cv_arg") -> "Variation_681":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_492:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_492:
        return self.rule.content

class RuleVariation_670(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_681.cv_arg
    cv_variation: TypeAlias = Variation_681

    @classmethod
    def create(cls, arg : "RuleVariation_670.cv_arg") -> "RuleVariation_670":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_681:
        return self.arg # type: ignore

class NonSpare_1558(NonSpare):
    cv_arg: TypeAlias = RuleVariation_670.cv_arg
    cv_name = "RD"
    cv_title = "Reply Destination"
    cv_rule: TypeAlias = RuleVariation_670

    @classmethod
    def create(cls, arg : "NonSpare_1558.cv_arg") -> "NonSpare_1558":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_670:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_681:
        return self.rule.variation

class Item_786(Item):
    cv_arg: TypeAlias = NonSpare_1558.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1558

    @classmethod
    def create(cls, arg : "Item_786.cv_arg") -> "Item_786":
        return cls._create(arg) # type: ignore

class Variation_1164(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_147.cv_arg, Tuple[Literal["PRIORITY"], RuleVariation_147.cv_arg]], int, Union[RuleVariation_89.cv_arg, Tuple[Literal["PC"], RuleVariation_89.cv_arg]], Union[RuleVariation_417.cv_arg, Tuple[Literal["AU"], RuleVariation_417.cv_arg]], Union[RuleVariation_567.cv_arg, Tuple[Literal["NE"], RuleVariation_567.cv_arg]], Union[RuleVariation_670.cv_arg, Tuple[Literal["RD"], RuleVariation_670.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1164.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_709, 5), (Item_25, 3), (Item_679, 1), (Item_92, 1), (Item_618, 1), (Item_786, 2), (Item_25, 3)]
    cv_items_dict = {"PRIORITY": RuleVariation_147, "PC": RuleVariation_89, "AU": RuleVariation_417, "NE": RuleVariation_567, "RD": RuleVariation_670}

    @overload
    @classmethod
    def spec(cls, key : Literal["PRIORITY"]) -> RuleVariation_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PC"]) -> RuleVariation_89:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AU"]) -> RuleVariation_417:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NE"]) -> RuleVariation_567:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RD"]) -> RuleVariation_670:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PRIORITY"], Literal["PC"], Literal["AU"], Literal["NE"], Literal["RD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PRIORITY"]) -> RuleVariation_147:
        ...
    @overload
    def get_item(self, key : Literal["PC"]) -> RuleVariation_89:
        ...
    @overload
    def get_item(self, key : Literal["AU"]) -> RuleVariation_417:
        ...
    @overload
    def get_item(self, key : Literal["NE"]) -> RuleVariation_567:
        ...
    @overload
    def get_item(self, key : Literal["RD"]) -> RuleVariation_670:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1164.cv_arg") -> 'Variation_1164':
        return cls._create(arg) # type: ignore

class RuleVariation_1115(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1164.cv_arg
    cv_variation: TypeAlias = Variation_1164

    @classmethod
    def create(cls, arg : "RuleVariation_1115.cv_arg") -> "RuleVariation_1115":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1164:
        return self.arg # type: ignore

class NonSpare_105(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1115.cv_arg
    cv_name = "030"
    cv_title = "GICB Properties"
    cv_rule: TypeAlias = RuleVariation_1115

    @classmethod
    def create(cls, arg : "NonSpare_105.cv_arg") -> "NonSpare_105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1115:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1164:
        return self.rule.variation

class UapItem_105(UapItem):
    cv_non_spare: TypeAlias = NonSpare_105

class NonSpare_101(NonSpare):
    cv_arg: TypeAlias = RuleVariation_368.cv_arg
    cv_name = "025"
    cv_title = "GICB Number"
    cv_rule: TypeAlias = RuleVariation_368

    @classmethod
    def create(cls, arg : "NonSpare_101.cv_arg") -> "NonSpare_101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

class UapItem_101(UapItem):
    cv_non_spare: TypeAlias = NonSpare_101

class NonSpare_102(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "027"
    cv_title = "BDS Code"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_102.cv_arg") -> "NonSpare_102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_102(UapItem):
    cv_non_spare: TypeAlias = NonSpare_102

class Content_799(ContentBds):
    cv_arg: TypeAlias = int
    cv_bds_type = (BdsAt, None)

class RuleContent_798(RuleContentContextFree):
    cv_arg: TypeAlias = Content_799.cv_arg
    cv_content: TypeAlias = Content_799

    @property
    def content(self) -> Content_799:
        return self._get_content() # type: ignore

class Variation_394(Element):
    cv_arg: TypeAlias = RuleContent_798.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_798

    @classmethod
    def create(cls, arg: "Variation_394.cv_arg") -> "Variation_394":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_798:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_799:
        return self.rule.content

class RuleVariation_386(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_394.cv_arg
    cv_variation: TypeAlias = Variation_394

    @classmethod
    def create(cls, arg : "RuleVariation_386.cv_arg") -> "RuleVariation_386":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_394:
        return self.arg # type: ignore

class NonSpare_104(NonSpare):
    cv_arg: TypeAlias = RuleVariation_386.cv_arg
    cv_name = "029"
    cv_title = "GICB Extracted"
    cv_rule: TypeAlias = RuleVariation_386

    @classmethod
    def create(cls, arg : "NonSpare_104.cv_arg") -> "NonSpare_104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_386:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_394:
        return self.rule.variation

class UapItem_104(UapItem):
    cv_non_spare: TypeAlias = NonSpare_104

class NonSpare_21(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "002"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_21.cv_arg") -> "NonSpare_21":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_21(UapItem):
    cv_non_spare: TypeAlias = NonSpare_21

class NonSpare_24(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1319.cv_arg
    cv_name = "006"
    cv_title = "Mode S Address List"
    cv_rule: TypeAlias = RuleVariation_1319

    @classmethod
    def create(cls, arg : "NonSpare_24.cv_arg") -> "NonSpare_24":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1319:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1398:
        return self.rule.variation

class UapItem_24(UapItem):
    cv_non_spare: TypeAlias = NonSpare_24

class Content_530(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "UC shall be ignored", 1: "UC shall be taken into account"}

class RuleContent_530(RuleContentContextFree):
    cv_arg: TypeAlias = Content_530.cv_arg
    cv_content: TypeAlias = Content_530

    @property
    def content(self) -> Content_530:
        return self._get_content() # type: ignore

class Variation_94(Element):
    cv_arg: TypeAlias = RuleContent_530.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_530

    @classmethod
    def create(cls, arg: "Variation_94.cv_arg") -> "Variation_94":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_530:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_530:
        return self.rule.content

class RuleVariation_94(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_94.cv_arg
    cv_variation: TypeAlias = Variation_94

    @classmethod
    def create(cls, arg : "RuleVariation_94.cv_arg") -> "RuleVariation_94":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_94:
        return self.arg # type: ignore

class NonSpare_1987(NonSpare):
    cv_arg: TypeAlias = RuleVariation_94.cv_arg
    cv_name = "UM"
    cv_title = "Uplink Mask"
    cv_rule: TypeAlias = RuleVariation_94

    @classmethod
    def create(cls, arg : "NonSpare_1987.cv_arg") -> "NonSpare_1987":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_94:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_94:
        return self.rule.variation

class Item_1099(Item):
    cv_arg: TypeAlias = NonSpare_1987.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1987

    @classmethod
    def create(cls, arg : "Item_1099.cv_arg") -> "Item_1099":
        return cls._create(arg) # type: ignore

class Content_71(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "DC shall be ignored", 1: "DC shall be taken into account"}

class RuleContent_71(RuleContentContextFree):
    cv_arg: TypeAlias = Content_71.cv_arg
    cv_content: TypeAlias = Content_71

    @property
    def content(self) -> Content_71:
        return self._get_content() # type: ignore

class Variation_405(Element):
    cv_arg: TypeAlias = RuleContent_71.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_71

    @classmethod
    def create(cls, arg: "Variation_405.cv_arg") -> "Variation_405":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_71:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_71:
        return self.rule.content

class RuleVariation_394(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_405.cv_arg
    cv_variation: TypeAlias = Variation_405

    @classmethod
    def create(cls, arg : "RuleVariation_394.cv_arg") -> "RuleVariation_394":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_405:
        return self.arg # type: ignore

class NonSpare_889(NonSpare):
    cv_arg: TypeAlias = RuleVariation_394.cv_arg
    cv_name = "DM"
    cv_title = "Downlink Mask"
    cv_rule: TypeAlias = RuleVariation_394

    @classmethod
    def create(cls, arg : "NonSpare_889.cv_arg") -> "NonSpare_889":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_394:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_405:
        return self.rule.variation

class Item_265(Item):
    cv_arg: TypeAlias = NonSpare_889.cv_arg
    cv_non_spare: TypeAlias = NonSpare_889

    @classmethod
    def create(cls, arg : "Item_265.cv_arg") -> "Item_265":
        return cls._create(arg) # type: ignore

class Content_573(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "the uplink flow shall be enabled", 1: "the uplink flow shall be stopped"}

class RuleContent_573(RuleContentContextFree):
    cv_arg: TypeAlias = Content_573.cv_arg
    cv_content: TypeAlias = Content_573

    @property
    def content(self) -> Content_573:
        return self._get_content() # type: ignore

class Variation_586(Element):
    cv_arg: TypeAlias = RuleContent_573.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_573

    @classmethod
    def create(cls, arg: "Variation_586.cv_arg") -> "Variation_586":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_573:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_573:
        return self.rule.content

class RuleVariation_575(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_586.cv_arg
    cv_variation: TypeAlias = Variation_586

    @classmethod
    def create(cls, arg : "RuleVariation_575.cv_arg") -> "RuleVariation_575":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_586:
        return self.arg # type: ignore

class NonSpare_1982(NonSpare):
    cv_arg: TypeAlias = RuleVariation_575.cv_arg
    cv_name = "UC"
    cv_title = "Uplink Command"
    cv_rule: TypeAlias = RuleVariation_575

    @classmethod
    def create(cls, arg : "NonSpare_1982.cv_arg") -> "NonSpare_1982":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_575:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_586:
        return self.rule.variation

class Item_1094(Item):
    cv_arg: TypeAlias = NonSpare_1982.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1982

    @classmethod
    def create(cls, arg : "Item_1094.cv_arg") -> "Item_1094":
        return cls._create(arg) # type: ignore

class Content_572(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "the downlink flow shall be enabled", 1: "the downlink flow shall be stopped"}

class RuleContent_572(RuleContentContextFree):
    cv_arg: TypeAlias = Content_572.cv_arg
    cv_content: TypeAlias = Content_572

    @property
    def content(self) -> Content_572:
        return self._get_content() # type: ignore

class Variation_675(Element):
    cv_arg: TypeAlias = RuleContent_572.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_572

    @classmethod
    def create(cls, arg: "Variation_675.cv_arg") -> "Variation_675":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_572:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_572:
        return self.rule.content

class RuleVariation_664(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_675.cv_arg
    cv_variation: TypeAlias = Variation_675

    @classmethod
    def create(cls, arg : "RuleVariation_664.cv_arg") -> "RuleVariation_664":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_675:
        return self.arg # type: ignore

class NonSpare_874(NonSpare):
    cv_arg: TypeAlias = RuleVariation_664.cv_arg
    cv_name = "DC"
    cv_title = "Downlink Command"
    cv_rule: TypeAlias = RuleVariation_664

    @classmethod
    def create(cls, arg : "NonSpare_874.cv_arg") -> "NonSpare_874":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_664:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_675:
        return self.rule.variation

class Item_252(Item):
    cv_arg: TypeAlias = NonSpare_874.cv_arg
    cv_non_spare: TypeAlias = NonSpare_874

    @classmethod
    def create(cls, arg : "Item_252.cv_arg") -> "Item_252":
        return cls._create(arg) # type: ignore

class Variation_1249(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_94.cv_arg, Tuple[Literal["UM"], RuleVariation_94.cv_arg]], Union[RuleVariation_394.cv_arg, Tuple[Literal["DM"], RuleVariation_394.cv_arg]], Union[RuleVariation_575.cv_arg, Tuple[Literal["UC"], RuleVariation_575.cv_arg]], Union[RuleVariation_664.cv_arg, Tuple[Literal["DC"], RuleVariation_664.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1249.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1099, 1), (Item_265, 1), (Item_1094, 1), (Item_252, 1), (Item_22, 4)]
    cv_items_dict = {"UM": RuleVariation_94, "DM": RuleVariation_394, "UC": RuleVariation_575, "DC": RuleVariation_664}

    @overload
    @classmethod
    def spec(cls, key : Literal["UM"]) -> RuleVariation_94:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DM"]) -> RuleVariation_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UC"]) -> RuleVariation_575:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_664:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["UM"], Literal["DM"], Literal["UC"], Literal["DC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["UM"]) -> RuleVariation_94:
        ...
    @overload
    def get_item(self, key : Literal["DM"]) -> RuleVariation_394:
        ...
    @overload
    def get_item(self, key : Literal["UC"]) -> RuleVariation_575:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_664:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1249.cv_arg") -> 'Variation_1249':
        return cls._create(arg) # type: ignore

class RuleVariation_1178(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1249.cv_arg
    cv_variation: TypeAlias = Variation_1249

    @classmethod
    def create(cls, arg : "RuleVariation_1178.cv_arg") -> "RuleVariation_1178":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1249:
        return self.arg # type: ignore

class NonSpare_25(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1178.cv_arg
    cv_name = "007"
    cv_title = "Aircraft Data Link Command"
    cv_rule: TypeAlias = RuleVariation_1178

    @classmethod
    def create(cls, arg : "NonSpare_25.cv_arg") -> "NonSpare_25":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1178:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1249:
        return self.rule.variation

class UapItem_25(UapItem):
    cv_non_spare: TypeAlias = NonSpare_25

class Content_494(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The interrogator is enabled to uplink frames", 1: "The interrogator is disabled to uplink frames"}

class RuleContent_494(RuleContentContextFree):
    cv_arg: TypeAlias = Content_494.cv_arg
    cv_content: TypeAlias = Content_494

    @property
    def content(self) -> Content_494:
        return self._get_content() # type: ignore

class Variation_85(Element):
    cv_arg: TypeAlias = RuleContent_494.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_494

    @classmethod
    def create(cls, arg: "Variation_85.cv_arg") -> "Variation_85":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_494:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_494:
        return self.rule.content

class RuleVariation_85(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_85.cv_arg
    cv_variation: TypeAlias = Variation_85

    @classmethod
    def create(cls, arg : "RuleVariation_85.cv_arg") -> "RuleVariation_85":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_85:
        return self.arg # type: ignore

class Content_493(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The interrogator is enabled to extract frames", 1: "The interrogator is disabled to extract frames"}

class RuleContent_493(RuleContentContextFree):
    cv_arg: TypeAlias = Content_493.cv_arg
    cv_content: TypeAlias = Content_493

    @property
    def content(self) -> Content_493:
        return self._get_content() # type: ignore

class Variation_456(Element):
    cv_arg: TypeAlias = RuleContent_493.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_493

    @classmethod
    def create(cls, arg: "Variation_456.cv_arg") -> "Variation_456":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_493:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_493:
        return self.rule.content

class RuleVariation_445(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_456.cv_arg
    cv_variation: TypeAlias = Variation_456

    @classmethod
    def create(cls, arg : "RuleVariation_445.cv_arg") -> "RuleVariation_445":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_456:
        return self.arg # type: ignore

class Variation_579(Element):
    cv_arg: TypeAlias = RuleContent_494.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_494

    @classmethod
    def create(cls, arg: "Variation_579.cv_arg") -> "Variation_579":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_494:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_494:
        return self.rule.content

class RuleVariation_568(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_579.cv_arg
    cv_variation: TypeAlias = Variation_579

    @classmethod
    def create(cls, arg : "RuleVariation_568.cv_arg") -> "RuleVariation_568":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_579:
        return self.arg # type: ignore

class Variation_663(Element):
    cv_arg: TypeAlias = RuleContent_493.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_493

    @classmethod
    def create(cls, arg: "Variation_663.cv_arg") -> "Variation_663":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_493:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_493:
        return self.rule.content

class RuleVariation_652(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_663.cv_arg
    cv_variation: TypeAlias = Variation_663

    @classmethod
    def create(cls, arg : "RuleVariation_652.cv_arg") -> "RuleVariation_652":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_663:
        return self.arg # type: ignore

class Content_491(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The aircraft is in the Datalink coverage map of the interrogator", 1: "The aircraft is not in the Datalink coverage map of the interrogator"}

class RuleContent_491(RuleContentContextFree):
    cv_arg: TypeAlias = Content_491.cv_arg
    cv_content: TypeAlias = Content_491

    @property
    def content(self) -> Content_491:
        return self._get_content() # type: ignore

class Variation_955(Element):
    cv_arg: TypeAlias = RuleContent_491.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_491

    @classmethod
    def create(cls, arg: "Variation_955.cv_arg") -> "Variation_955":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_491:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_491:
        return self.rule.content

class RuleVariation_925(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_955.cv_arg
    cv_variation: TypeAlias = Variation_955

    @classmethod
    def create(cls, arg : "RuleVariation_925.cv_arg") -> "RuleVariation_925":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_955:
        return self.arg # type: ignore

class Content_495(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The interrogators current ability to uplink/downlink frames (UCS/DCS) and the content of the Aircraft_report could be changed using D_Data_link_command", 1: "The interrogators current ability to uplink/downlink frames (UCS/DCS) and the content of the Aircraft_report cannot be changed using D_Data_link_command"}

class RuleContent_495(RuleContentContextFree):
    cv_arg: TypeAlias = Content_495.cv_arg
    cv_content: TypeAlias = Content_495

    @property
    def content(self) -> Content_495:
        return self._get_content() # type: ignore

class Variation_86(Element):
    cv_arg: TypeAlias = RuleContent_495.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_495

    @classmethod
    def create(cls, arg: "Variation_86.cv_arg") -> "Variation_86":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_495:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_495:
        return self.rule.content

class RuleVariation_86(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_86.cv_arg
    cv_variation: TypeAlias = Variation_86

    @classmethod
    def create(cls, arg : "RuleVariation_86.cv_arg") -> "RuleVariation_86":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_86:
        return self.arg # type: ignore

class NonSpare_1986(NonSpare):
    cv_arg: TypeAlias = RuleVariation_85.cv_arg
    cv_name = "UDS"
    cv_title = "Uplink Default Status"
    cv_rule: TypeAlias = RuleVariation_85

    @classmethod
    def create(cls, arg : "NonSpare_1986.cv_arg") -> "NonSpare_1986":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_85:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_85:
        return self.rule.variation

class Item_1098(Item):
    cv_arg: TypeAlias = NonSpare_1986.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1986

    @classmethod
    def create(cls, arg : "Item_1098.cv_arg") -> "Item_1098":
        return cls._create(arg) # type: ignore

class NonSpare_878(NonSpare):
    cv_arg: TypeAlias = RuleVariation_445.cv_arg
    cv_name = "DDS"
    cv_title = "Downlink Default Status"
    cv_rule: TypeAlias = RuleVariation_445

    @classmethod
    def create(cls, arg : "NonSpare_878.cv_arg") -> "NonSpare_878":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_445:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_456:
        return self.rule.variation

class Item_256(Item):
    cv_arg: TypeAlias = NonSpare_878.cv_arg
    cv_non_spare: TypeAlias = NonSpare_878

    @classmethod
    def create(cls, arg : "Item_256.cv_arg") -> "Item_256":
        return cls._create(arg) # type: ignore

class NonSpare_1985(NonSpare):
    cv_arg: TypeAlias = RuleVariation_568.cv_arg
    cv_name = "UCS"
    cv_title = "Uplink Current Status"
    cv_rule: TypeAlias = RuleVariation_568

    @classmethod
    def create(cls, arg : "NonSpare_1985.cv_arg") -> "NonSpare_1985":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_568:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_579:
        return self.rule.variation

class Item_1097(Item):
    cv_arg: TypeAlias = NonSpare_1985.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1985

    @classmethod
    def create(cls, arg : "Item_1097.cv_arg") -> "Item_1097":
        return cls._create(arg) # type: ignore

class NonSpare_877(NonSpare):
    cv_arg: TypeAlias = RuleVariation_652.cv_arg
    cv_name = "DCS"
    cv_title = "Downlink Current Status"
    cv_rule: TypeAlias = RuleVariation_652

    @classmethod
    def create(cls, arg : "NonSpare_877.cv_arg") -> "NonSpare_877":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_652:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_663:
        return self.rule.variation

class Item_255(Item):
    cv_arg: TypeAlias = NonSpare_877.cv_arg
    cv_non_spare: TypeAlias = NonSpare_877

    @classmethod
    def create(cls, arg : "Item_255.cv_arg") -> "Item_255":
        return cls._create(arg) # type: ignore

class NonSpare_920(NonSpare):
    cv_arg: TypeAlias = RuleVariation_925.cv_arg
    cv_name = "EI"
    cv_title = "Exit Indication"
    cv_rule: TypeAlias = RuleVariation_925

    @classmethod
    def create(cls, arg : "NonSpare_920.cv_arg") -> "NonSpare_920":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_925:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_955:
        return self.rule.variation

class Item_288(Item):
    cv_arg: TypeAlias = NonSpare_920.cv_arg
    cv_non_spare: TypeAlias = NonSpare_920

    @classmethod
    def create(cls, arg : "Item_288.cv_arg") -> "Item_288":
        return cls._create(arg) # type: ignore

class NonSpare_1106(NonSpare):
    cv_arg: TypeAlias = RuleVariation_86.cv_arg
    cv_name = "IC"
    cv_title = "Interrogator Control"
    cv_rule: TypeAlias = RuleVariation_86

    @classmethod
    def create(cls, arg : "NonSpare_1106.cv_arg") -> "NonSpare_1106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_86:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_86:
        return self.rule.variation

class Item_424(Item):
    cv_arg: TypeAlias = NonSpare_1106.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1106

    @classmethod
    def create(cls, arg : "Item_424.cv_arg") -> "Item_424":
        return cls._create(arg) # type: ignore

class Variation_1393(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_85.cv_arg, Tuple[Literal["UDS"], RuleVariation_85.cv_arg]], Union[RuleVariation_445.cv_arg, Tuple[Literal["DDS"], RuleVariation_445.cv_arg]], Union[RuleVariation_568.cv_arg, Tuple[Literal["UCS"], RuleVariation_568.cv_arg]], Union[RuleVariation_652.cv_arg, Tuple[Literal["DCS"], RuleVariation_652.cv_arg]], int, Union[RuleVariation_925.cv_arg, Tuple[Literal["EI"], RuleVariation_925.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_86.cv_arg, Tuple[Literal["IC"], RuleVariation_86.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1393.cv_arg_group_1"],
        Tuple["Variation_1393.cv_arg_group_1", "Variation_1393.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_1098, 1), (Item_256, 1), (Item_1097, 1), (Item_255, 1), (Item_20, 2), (Item_288, 1), None], [(Item_424, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1393.cv_arg") -> 'Variation_1393':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["UDS"]) -> RuleVariation_85:
        ...
    @overload
    def get_item(self, key : Literal["DDS"]) -> RuleVariation_445:
        ...
    @overload
    def get_item(self, key : Literal["UCS"]) -> RuleVariation_568:
        ...
    @overload
    def get_item(self, key : Literal["DCS"]) -> RuleVariation_652:
        ...
    @overload
    def get_item(self, key : Literal["EI"]) -> RuleVariation_925:
        ...
    @overload
    def get_item(self, key : Literal["IC"]) -> Optional[RuleVariation_86]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1314(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1393.cv_arg
    cv_variation: TypeAlias = Variation_1393

    @classmethod
    def create(cls, arg : "RuleVariation_1314.cv_arg") -> "RuleVariation_1314":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1393:
        return self.arg # type: ignore

class NonSpare_26(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1314.cv_arg
    cv_name = "008"
    cv_title = "Aircraft Data Link Status"
    cv_rule: TypeAlias = RuleVariation_1314

    @classmethod
    def create(cls, arg : "NonSpare_26.cv_arg") -> "NonSpare_26":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1314:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1393:
        return self.rule.variation

class UapItem_26(UapItem):
    cv_non_spare: TypeAlias = NonSpare_26

class Content_501(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_Data_link_status", 1: "The next Aircraft_report shall include D_Data_link_status"}

class RuleContent_501(RuleContentContextFree):
    cv_arg: TypeAlias = Content_501.cv_arg
    cv_content: TypeAlias = Content_501

    @property
    def content(self) -> Content_501:
        return self._get_content() # type: ignore

class Variation_88(Element):
    cv_arg: TypeAlias = RuleContent_501.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_501

    @classmethod
    def create(cls, arg: "Variation_88.cv_arg") -> "Variation_88":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_501:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_501:
        return self.rule.content

class RuleVariation_88(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_88.cv_arg
    cv_variation: TypeAlias = Variation_88

    @classmethod
    def create(cls, arg : "RuleVariation_88.cv_arg") -> "RuleVariation_88":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_88:
        return self.arg # type: ignore

class Content_497(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_COM", 1: "The next Aircraft_report shall include D_COM"}

class RuleContent_497(RuleContentContextFree):
    cv_arg: TypeAlias = Content_497.cv_arg
    cv_content: TypeAlias = Content_497

    @property
    def content(self) -> Content_497:
        return self._get_content() # type: ignore

class Variation_457(Element):
    cv_arg: TypeAlias = RuleContent_497.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_497

    @classmethod
    def create(cls, arg: "Variation_457.cv_arg") -> "Variation_457":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_497:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_497:
        return self.rule.content

class RuleVariation_446(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_457.cv_arg
    cv_variation: TypeAlias = Variation_457

    @classmethod
    def create(cls, arg : "RuleVariation_446.cv_arg") -> "RuleVariation_446":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_457:
        return self.arg # type: ignore

class Content_502(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_ECA", 1: "The next Aircraft_report shall include D_ECA"}

class RuleContent_502(RuleContentContextFree):
    cv_arg: TypeAlias = Content_502.cv_arg
    cv_content: TypeAlias = Content_502

    @property
    def content(self) -> Content_502:
        return self._get_content() # type: ignore

class Variation_580(Element):
    cv_arg: TypeAlias = RuleContent_502.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_502

    @classmethod
    def create(cls, arg: "Variation_580.cv_arg") -> "Variation_580":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_502:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_502:
        return self.rule.content

class RuleVariation_569(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_580.cv_arg
    cv_variation: TypeAlias = Variation_580

    @classmethod
    def create(cls, arg : "RuleVariation_569.cv_arg") -> "RuleVariation_569":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_580:
        return self.arg # type: ignore

class Content_498(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_CQF", 1: "The next Aircraft_report shall include D_CQF"}

class RuleContent_498(RuleContentContextFree):
    cv_arg: TypeAlias = Content_498.cv_arg
    cv_content: TypeAlias = Content_498

    @property
    def content(self) -> Content_498:
        return self._get_content() # type: ignore

class Variation_664(Element):
    cv_arg: TypeAlias = RuleContent_498.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_498

    @classmethod
    def create(cls, arg: "Variation_664.cv_arg") -> "Variation_664":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_498:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_498:
        return self.rule.content

class RuleVariation_653(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_664.cv_arg
    cv_variation: TypeAlias = Variation_664

    @classmethod
    def create(cls, arg : "RuleVariation_653.cv_arg") -> "RuleVariation_653":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_664:
        return self.arg # type: ignore

class Content_499(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_CQF_method", 1: "The next Aircraft_report shall include D_CQF_method"}

class RuleContent_499(RuleContentContextFree):
    cv_arg: TypeAlias = Content_499.cv_arg
    cv_content: TypeAlias = Content_499

    @property
    def content(self) -> Content_499:
        return self._get_content() # type: ignore

class Variation_756(Element):
    cv_arg: TypeAlias = RuleContent_499.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_499

    @classmethod
    def create(cls, arg: "Variation_756.cv_arg") -> "Variation_756":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_499:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_499:
        return self.rule.content

class RuleVariation_745(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_756.cv_arg
    cv_variation: TypeAlias = Variation_756

    @classmethod
    def create(cls, arg : "RuleVariation_745.cv_arg") -> "RuleVariation_745":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_756:
        return self.arg # type: ignore

class Content_503(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_Polar_position", 1: "The next Aircraft_report shall include D_Polar_position"}

class RuleContent_503(RuleContentContextFree):
    cv_arg: TypeAlias = Content_503.cv_arg
    cv_content: TypeAlias = Content_503

    @property
    def content(self) -> Content_503:
        return self._get_content() # type: ignore

class Variation_873(Element):
    cv_arg: TypeAlias = RuleContent_503.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_503

    @classmethod
    def create(cls, arg: "Variation_873.cv_arg") -> "Variation_873":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_503:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_503:
        return self.rule.content

class RuleVariation_843(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_873.cv_arg
    cv_variation: TypeAlias = Variation_873

    @classmethod
    def create(cls, arg : "RuleVariation_843.cv_arg") -> "RuleVariation_843":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_873:
        return self.arg # type: ignore

class Content_500(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include D_Cartesian_position", 1: "The next Aircraft_report shall include D_Cartesian_position"}

class RuleContent_500(RuleContentContextFree):
    cv_arg: TypeAlias = Content_500.cv_arg
    cv_content: TypeAlias = Content_500

    @property
    def content(self) -> Content_500:
        return self._get_content() # type: ignore

class Variation_956(Element):
    cv_arg: TypeAlias = RuleContent_500.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_500

    @classmethod
    def create(cls, arg: "Variation_956.cv_arg") -> "Variation_956":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_500:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_500:
        return self.rule.content

class RuleVariation_926(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_956.cv_arg
    cv_variation: TypeAlias = Variation_956

    @classmethod
    def create(cls, arg : "RuleVariation_926.cv_arg") -> "RuleVariation_926":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_956:
        return self.arg # type: ignore

class Content_496(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include Aircraft_ID", 1: "The next Aircraft_report shall include Aircraft_ID"}

class RuleContent_496(RuleContentContextFree):
    cv_arg: TypeAlias = Content_496.cv_arg
    cv_content: TypeAlias = Content_496

    @property
    def content(self) -> Content_496:
        return self._get_content() # type: ignore

class Variation_87(Element):
    cv_arg: TypeAlias = RuleContent_496.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_496

    @classmethod
    def create(cls, arg: "Variation_87.cv_arg") -> "Variation_87":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_496:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_496:
        return self.rule.content

class RuleVariation_87(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_87.cv_arg
    cv_variation: TypeAlias = Variation_87

    @classmethod
    def create(cls, arg : "RuleVariation_87.cv_arg") -> "RuleVariation_87":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_87:
        return self.arg # type: ignore

class Content_506(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include Mode_A", 1: "The next Aircraft_report shall include Mode_A"}

class RuleContent_506(RuleContentContextFree):
    cv_arg: TypeAlias = Content_506.cv_arg
    cv_content: TypeAlias = Content_506

    @property
    def content(self) -> Content_506:
        return self._get_content() # type: ignore

class Variation_458(Element):
    cv_arg: TypeAlias = RuleContent_506.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_506

    @classmethod
    def create(cls, arg: "Variation_458.cv_arg") -> "Variation_458":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_506:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_506:
        return self.rule.content

class RuleVariation_447(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_458.cv_arg
    cv_variation: TypeAlias = Variation_458

    @classmethod
    def create(cls, arg : "RuleVariation_447.cv_arg") -> "RuleVariation_447":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_458:
        return self.arg # type: ignore

class Content_507(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include Speed", 1: "The next Aircraft_report shall include Speed"}

class RuleContent_507(RuleContentContextFree):
    cv_arg: TypeAlias = Content_507.cv_arg
    cv_content: TypeAlias = Content_507

    @property
    def content(self) -> Content_507:
        return self._get_content() # type: ignore

class Variation_581(Element):
    cv_arg: TypeAlias = RuleContent_507.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_507

    @classmethod
    def create(cls, arg: "Variation_581.cv_arg") -> "Variation_581":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_507:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_507:
        return self.rule.content

class RuleVariation_570(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_581.cv_arg
    cv_variation: TypeAlias = Variation_581

    @classmethod
    def create(cls, arg : "RuleVariation_570.cv_arg") -> "RuleVariation_570":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_581:
        return self.arg # type: ignore

class Content_505(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include Height", 1: "The next Aircraft_report shall include Height"}

class RuleContent_505(RuleContentContextFree):
    cv_arg: TypeAlias = Content_505.cv_arg
    cv_content: TypeAlias = Content_505

    @property
    def content(self) -> Content_505:
        return self._get_content() # type: ignore

class Variation_665(Element):
    cv_arg: TypeAlias = RuleContent_505.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_505

    @classmethod
    def create(cls, arg: "Variation_665.cv_arg") -> "Variation_665":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_505:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_505:
        return self.rule.content

class RuleVariation_654(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_665.cv_arg
    cv_variation: TypeAlias = Variation_665

    @classmethod
    def create(cls, arg : "RuleVariation_654.cv_arg") -> "RuleVariation_654":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_665:
        return self.arg # type: ignore

class Content_504(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The next Aircraft_report may not include Heading", 1: "The next Aircraft_report shall include Heading"}

class RuleContent_504(RuleContentContextFree):
    cv_arg: TypeAlias = Content_504.cv_arg
    cv_content: TypeAlias = Content_504

    @property
    def content(self) -> Content_504:
        return self._get_content() # type: ignore

class Variation_757(Element):
    cv_arg: TypeAlias = RuleContent_504.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_504

    @classmethod
    def create(cls, arg: "Variation_757.cv_arg") -> "Variation_757":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_504:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_504:
        return self.rule.content

class RuleVariation_746(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_757.cv_arg
    cv_variation: TypeAlias = Variation_757

    @classmethod
    def create(cls, arg : "RuleVariation_746.cv_arg") -> "RuleVariation_746":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_757:
        return self.arg # type: ignore

class NonSpare_1745(NonSpare):
    cv_arg: TypeAlias = RuleVariation_88.cv_arg
    cv_name = "SR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_88

    @classmethod
    def create(cls, arg : "NonSpare_1745.cv_arg") -> "NonSpare_1745":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_88:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_88:
        return self.rule.variation

class Item_918(Item):
    cv_arg: TypeAlias = NonSpare_1745.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1745

    @classmethod
    def create(cls, arg : "Item_918.cv_arg") -> "Item_918":
        return cls._create(arg) # type: ignore

class NonSpare_622(NonSpare):
    cv_arg: TypeAlias = RuleVariation_446.cv_arg
    cv_name = "AR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_446

    @classmethod
    def create(cls, arg : "NonSpare_622.cv_arg") -> "NonSpare_622":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_446:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_457:
        return self.rule.variation

class Item_79(Item):
    cv_arg: TypeAlias = NonSpare_622.cv_arg
    cv_non_spare: TypeAlias = NonSpare_622

    @classmethod
    def create(cls, arg : "Item_79.cv_arg") -> "Item_79":
        return cls._create(arg) # type: ignore

class NonSpare_955(NonSpare):
    cv_arg: TypeAlias = RuleVariation_569.cv_arg
    cv_name = "ER"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_569

    @classmethod
    def create(cls, arg : "NonSpare_955.cv_arg") -> "NonSpare_955":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_569:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_580:
        return self.rule.variation

class Item_316(Item):
    cv_arg: TypeAlias = NonSpare_955.cv_arg
    cv_non_spare: TypeAlias = NonSpare_955

    @classmethod
    def create(cls, arg : "Item_316.cv_arg") -> "Item_316":
        return cls._create(arg) # type: ignore

class NonSpare_991(NonSpare):
    cv_arg: TypeAlias = RuleVariation_653.cv_arg
    cv_name = "FR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_653

    @classmethod
    def create(cls, arg : "NonSpare_991.cv_arg") -> "NonSpare_991":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_653:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_664:
        return self.rule.variation

class Item_340(Item):
    cv_arg: TypeAlias = NonSpare_991.cv_arg
    cv_non_spare: TypeAlias = NonSpare_991

    @classmethod
    def create(cls, arg : "Item_340.cv_arg") -> "Item_340":
        return cls._create(arg) # type: ignore

class NonSpare_1314(NonSpare):
    cv_arg: TypeAlias = RuleVariation_745.cv_arg
    cv_name = "MR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_745

    @classmethod
    def create(cls, arg : "NonSpare_1314.cv_arg") -> "NonSpare_1314":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_745:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_756:
        return self.rule.variation

class Item_580(Item):
    cv_arg: TypeAlias = NonSpare_1314.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1314

    @classmethod
    def create(cls, arg : "Item_580.cv_arg") -> "Item_580":
        return cls._create(arg) # type: ignore

class NonSpare_1455(NonSpare):
    cv_arg: TypeAlias = RuleVariation_843.cv_arg
    cv_name = "PR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_843

    @classmethod
    def create(cls, arg : "NonSpare_1455.cv_arg") -> "NonSpare_1455":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_843:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_873:
        return self.rule.variation

class Item_698(Item):
    cv_arg: TypeAlias = NonSpare_1455.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1455

    @classmethod
    def create(cls, arg : "Item_698.cv_arg") -> "Item_698":
        return cls._create(arg) # type: ignore

class NonSpare_827(NonSpare):
    cv_arg: TypeAlias = RuleVariation_926.cv_arg
    cv_name = "CR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_926

    @classmethod
    def create(cls, arg : "NonSpare_827.cv_arg") -> "NonSpare_827":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_926:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_956:
        return self.rule.variation

class Item_213(Item):
    cv_arg: TypeAlias = NonSpare_827.cv_arg
    cv_non_spare: TypeAlias = NonSpare_827

    @classmethod
    def create(cls, arg : "Item_213.cv_arg") -> "Item_213":
        return cls._create(arg) # type: ignore

class NonSpare_1108(NonSpare):
    cv_arg: TypeAlias = RuleVariation_87.cv_arg
    cv_name = "ID"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_87

    @classmethod
    def create(cls, arg : "NonSpare_1108.cv_arg") -> "NonSpare_1108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_87:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_87:
        return self.rule.variation

class Item_426(Item):
    cv_arg: TypeAlias = NonSpare_1108.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1108

    @classmethod
    def create(cls, arg : "Item_426.cv_arg") -> "Item_426":
        return cls._create(arg) # type: ignore

class NonSpare_1221(NonSpare):
    cv_arg: TypeAlias = RuleVariation_447.cv_arg
    cv_name = "MA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_447

    @classmethod
    def create(cls, arg : "NonSpare_1221.cv_arg") -> "NonSpare_1221":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_447:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_458:
        return self.rule.variation

class Item_523(Item):
    cv_arg: TypeAlias = NonSpare_1221.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1221

    @classmethod
    def create(cls, arg : "Item_523.cv_arg") -> "Item_523":
        return cls._create(arg) # type: ignore

class NonSpare_1731(NonSpare):
    cv_arg: TypeAlias = RuleVariation_570.cv_arg
    cv_name = "SP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_570

    @classmethod
    def create(cls, arg : "NonSpare_1731.cv_arg") -> "NonSpare_1731":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_570:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_581:
        return self.rule.variation

class Item_905(Item):
    cv_arg: TypeAlias = NonSpare_1731.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1731

    @classmethod
    def create(cls, arg : "Item_905.cv_arg") -> "Item_905":
        return cls._create(arg) # type: ignore

class NonSpare_1066(NonSpare):
    cv_arg: TypeAlias = RuleVariation_654.cv_arg
    cv_name = "HG"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_654

    @classmethod
    def create(cls, arg : "NonSpare_1066.cv_arg") -> "NonSpare_1066":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_654:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_665:
        return self.rule.variation

class Item_392(Item):
    cv_arg: TypeAlias = NonSpare_1066.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1066

    @classmethod
    def create(cls, arg : "Item_392.cv_arg") -> "Item_392":
        return cls._create(arg) # type: ignore

class NonSpare_1060(NonSpare):
    cv_arg: TypeAlias = RuleVariation_746.cv_arg
    cv_name = "HD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_746

    @classmethod
    def create(cls, arg : "NonSpare_1060.cv_arg") -> "NonSpare_1060":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_746:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_757:
        return self.rule.variation

class Item_388(Item):
    cv_arg: TypeAlias = NonSpare_1060.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1060

    @classmethod
    def create(cls, arg : "Item_388.cv_arg") -> "Item_388":
        return cls._create(arg) # type: ignore

class Variation_1383(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_88.cv_arg, Tuple[Literal["SR"], RuleVariation_88.cv_arg]], Union[RuleVariation_446.cv_arg, Tuple[Literal["AR"], RuleVariation_446.cv_arg]], Union[RuleVariation_569.cv_arg, Tuple[Literal["ER"], RuleVariation_569.cv_arg]], Union[RuleVariation_653.cv_arg, Tuple[Literal["FR"], RuleVariation_653.cv_arg]], Union[RuleVariation_745.cv_arg, Tuple[Literal["MR"], RuleVariation_745.cv_arg]], Union[RuleVariation_843.cv_arg, Tuple[Literal["PR"], RuleVariation_843.cv_arg]], Union[RuleVariation_926.cv_arg, Tuple[Literal["CR"], RuleVariation_926.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_87.cv_arg, Tuple[Literal["ID"], RuleVariation_87.cv_arg]], Union[RuleVariation_447.cv_arg, Tuple[Literal["MA"], RuleVariation_447.cv_arg]], Union[RuleVariation_570.cv_arg, Tuple[Literal["SP"], RuleVariation_570.cv_arg]], Union[RuleVariation_654.cv_arg, Tuple[Literal["HG"], RuleVariation_654.cv_arg]], Union[RuleVariation_746.cv_arg, Tuple[Literal["HD"], RuleVariation_746.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1383.cv_arg_group_1"],
        Tuple["Variation_1383.cv_arg_group_1", "Variation_1383.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_918, 1), (Item_79, 1), (Item_316, 1), (Item_340, 1), (Item_580, 1), (Item_698, 1), (Item_213, 1), None], [(Item_426, 1), (Item_523, 1), (Item_905, 1), (Item_392, 1), (Item_388, 1), (Item_24, 2), None]]

    @classmethod
    def create(cls, arg: "Variation_1383.cv_arg") -> 'Variation_1383':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["SR"]) -> RuleVariation_88:
        ...
    @overload
    def get_item(self, key : Literal["AR"]) -> RuleVariation_446:
        ...
    @overload
    def get_item(self, key : Literal["ER"]) -> RuleVariation_569:
        ...
    @overload
    def get_item(self, key : Literal["FR"]) -> RuleVariation_653:
        ...
    @overload
    def get_item(self, key : Literal["MR"]) -> RuleVariation_745:
        ...
    @overload
    def get_item(self, key : Literal["PR"]) -> RuleVariation_843:
        ...
    @overload
    def get_item(self, key : Literal["CR"]) -> RuleVariation_926:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[RuleVariation_87]:
        ...
    @overload
    def get_item(self, key : Literal["MA"]) -> Optional[RuleVariation_447]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[RuleVariation_570]:
        ...
    @overload
    def get_item(self, key : Literal["HG"]) -> Optional[RuleVariation_654]:
        ...
    @overload
    def get_item(self, key : Literal["HD"]) -> Optional[RuleVariation_746]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1304(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1383.cv_arg
    cv_variation: TypeAlias = Variation_1383

    @classmethod
    def create(cls, arg : "RuleVariation_1304.cv_arg") -> "RuleVariation_1304":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1383:
        return self.arg # type: ignore

class NonSpare_28(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1304.cv_arg
    cv_name = "009"
    cv_title = "Aircraft Data Link Report Request"
    cv_rule: TypeAlias = RuleVariation_1304

    @classmethod
    def create(cls, arg : "NonSpare_28.cv_arg") -> "NonSpare_28":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1383:
        return self.rule.variation

class UapItem_28(UapItem):
    cv_non_spare: TypeAlias = NonSpare_28

class Content_337(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No communications capability (surveillance only)", 1: "Comm. A and Comm. B capability", 2: "Comm. A, Comm. B and Uplink ELM", 3: "Comm. A, Comm. B and Uplink ELM and Downlink ELM", 4: "Level 5 Transponder capability"}

class RuleContent_337(RuleContentContextFree):
    cv_arg: TypeAlias = Content_337.cv_arg
    cv_content: TypeAlias = Content_337

    @property
    def content(self) -> Content_337:
        return self._get_content() # type: ignore

class Variation_890(Element):
    cv_arg: TypeAlias = RuleContent_337.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_337

    @classmethod
    def create(cls, arg: "Variation_890.cv_arg") -> "Variation_890":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_337:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_337:
        return self.rule.content

class RuleVariation_860(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_890.cv_arg
    cv_variation: TypeAlias = Variation_890

    @classmethod
    def create(cls, arg : "RuleVariation_860.cv_arg") -> "RuleVariation_860":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_890:
        return self.arg # type: ignore

class NonSpare_786(NonSpare):
    cv_arg: TypeAlias = RuleVariation_860.cv_arg
    cv_name = "COM"
    cv_title = "Communications Capability of the Transponder"
    cv_rule: TypeAlias = RuleVariation_860

    @classmethod
    def create(cls, arg : "NonSpare_786.cv_arg") -> "NonSpare_786":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_860:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_890:
        return self.rule.variation

class Item_189(Item):
    cv_arg: TypeAlias = NonSpare_786.cv_arg
    cv_non_spare: TypeAlias = NonSpare_786

    @classmethod
    def create(cls, arg : "Item_189.cv_arg") -> "Item_189":
        return cls._create(arg) # type: ignore

class Variation_1037(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_860.cv_arg, Tuple[Literal["COM"], RuleVariation_860.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1037.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_4, 5), (Item_189, 3)]
    cv_items_dict = {"COM": RuleVariation_860}

    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_860:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["COM"]) -> RuleVariation_860:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1037.cv_arg") -> 'Variation_1037':
        return cls._create(arg) # type: ignore

class RuleVariation_1005(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1037.cv_arg
    cv_variation: TypeAlias = Variation_1037

    @classmethod
    def create(cls, arg : "RuleVariation_1005.cv_arg") -> "RuleVariation_1005":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1037:
        return self.arg # type: ignore

class NonSpare_51(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1005.cv_arg
    cv_name = "010"
    cv_title = "Transponder Communications Capability"
    cv_rule: TypeAlias = RuleVariation_1005

    @classmethod
    def create(cls, arg : "NonSpare_51.cv_arg") -> "NonSpare_51":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1005:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1037:
        return self.rule.variation

class UapItem_51(UapItem):
    cv_non_spare: TypeAlias = NonSpare_51

class NonSpare_52(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "011"
    cv_title = "Capability Report"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_52.cv_arg") -> "NonSpare_52":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class UapItem_52(UapItem):
    cv_non_spare: TypeAlias = NonSpare_52

class Content_773(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_772(RuleContentContextFree):
    cv_arg: TypeAlias = Content_773.cv_arg
    cv_content: TypeAlias = Content_773

    @property
    def content(self) -> Content_773:
        return self._get_content() # type: ignore

class Variation_335(Element):
    cv_arg: TypeAlias = RuleContent_772.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_772

    @classmethod
    def create(cls, arg: "Variation_335.cv_arg") -> "Variation_335":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_772:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_773:
        return self.rule.content

class RuleVariation_328(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_335.cv_arg
    cv_variation: TypeAlias = Variation_335

    @classmethod
    def create(cls, arg : "RuleVariation_328.cv_arg") -> "RuleVariation_328":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_335:
        return self.arg # type: ignore

class NonSpare_1590(NonSpare):
    cv_arg: TypeAlias = RuleVariation_328.cv_arg
    cv_name = "RHO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_328

    @classmethod
    def create(cls, arg : "NonSpare_1590.cv_arg") -> "NonSpare_1590":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_328:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_335:
        return self.rule.variation

class Item_815(Item):
    cv_arg: TypeAlias = NonSpare_1590.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1590

    @classmethod
    def create(cls, arg : "Item_815.cv_arg") -> "Item_815":
        return cls._create(arg) # type: ignore

class Variation_1179(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_328.cv_arg, Tuple[Literal["RHO"], RuleVariation_328.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["THETA"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1179.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_815, 16), (Item_993, 16)]
    cv_items_dict = {"RHO": RuleVariation_328, "THETA": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETA"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["THETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_328:
        ...
    @overload
    def get_item(self, key : Literal["THETA"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1179.cv_arg") -> 'Variation_1179':
        return cls._create(arg) # type: ignore

class RuleVariation_1130(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1179.cv_arg
    cv_variation: TypeAlias = Variation_1179

    @classmethod
    def create(cls, arg : "RuleVariation_1130.cv_arg") -> "RuleVariation_1130":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1179:
        return self.arg # type: ignore

class NonSpare_56(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1130.cv_arg
    cv_name = "014"
    cv_title = "Aircraft Position in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1130

    @classmethod
    def create(cls, arg : "NonSpare_56.cv_arg") -> "NonSpare_56":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1130:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1179:
        return self.rule.variation

class UapItem_56(UapItem):
    cv_non_spare: TypeAlias = NonSpare_56

class Content_678(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_678(RuleContentContextFree):
    cv_arg: TypeAlias = Content_678.cv_arg
    cv_content: TypeAlias = Content_678

    @property
    def content(self) -> Content_678:
        return self._get_content() # type: ignore

class Variation_287(Element):
    cv_arg: TypeAlias = RuleContent_678.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_678

    @classmethod
    def create(cls, arg: "Variation_287.cv_arg") -> "Variation_287":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_678:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_678:
        return self.rule.content

class RuleVariation_280(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_287.cv_arg
    cv_variation: TypeAlias = Variation_287

    @classmethod
    def create(cls, arg : "RuleVariation_280.cv_arg") -> "RuleVariation_280":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_287:
        return self.arg # type: ignore

class NonSpare_2100(NonSpare):
    cv_arg: TypeAlias = RuleVariation_280.cv_arg
    cv_name = "X"
    cv_title = "X-Component"
    cv_rule: TypeAlias = RuleVariation_280

    @classmethod
    def create(cls, arg : "NonSpare_2100.cv_arg") -> "NonSpare_2100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_287:
        return self.rule.variation

class Item_1201(Item):
    cv_arg: TypeAlias = NonSpare_2100.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2100

    @classmethod
    def create(cls, arg : "Item_1201.cv_arg") -> "Item_1201":
        return cls._create(arg) # type: ignore

class NonSpare_2154(NonSpare):
    cv_arg: TypeAlias = RuleVariation_280.cv_arg
    cv_name = "Y"
    cv_title = "Y-Component"
    cv_rule: TypeAlias = RuleVariation_280

    @classmethod
    def create(cls, arg : "NonSpare_2154.cv_arg") -> "NonSpare_2154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_287:
        return self.rule.variation

class Item_1252(Item):
    cv_arg: TypeAlias = NonSpare_2154.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2154

    @classmethod
    def create(cls, arg : "Item_1252.cv_arg") -> "Item_1252":
        return cls._create(arg) # type: ignore

class Variation_1315(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_280.cv_arg, Tuple[Literal["X"], RuleVariation_280.cv_arg]], Union[RuleVariation_280.cv_arg, Tuple[Literal["Y"], RuleVariation_280.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1315.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1201, 16), (Item_1252, 16)]
    cv_items_dict = {"X": RuleVariation_280, "Y": RuleVariation_280}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_280:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_280:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_280:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1315.cv_arg") -> 'Variation_1315':
        return cls._create(arg) # type: ignore

class RuleVariation_1242(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1315.cv_arg
    cv_variation: TypeAlias = Variation_1315

    @classmethod
    def create(cls, arg : "RuleVariation_1242.cv_arg") -> "RuleVariation_1242":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1315:
        return self.arg # type: ignore

class NonSpare_57(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1242.cv_arg
    cv_name = "015"
    cv_title = "Aircraft Position in Cartesian Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1242

    @classmethod
    def create(cls, arg : "NonSpare_57.cv_arg") -> "NonSpare_57":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1242:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1315:
        return self.rule.variation

class UapItem_57(UapItem):
    cv_non_spare: TypeAlias = NonSpare_57

class NonSpare_78(NonSpare):
    cv_arg: TypeAlias = RuleVariation_368.cv_arg
    cv_name = "020"
    cv_title = "Broadcast Number"
    cv_rule: TypeAlias = RuleVariation_368

    @classmethod
    def create(cls, arg : "NonSpare_78.cv_arg") -> "NonSpare_78":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

class UapItem_78(UapItem):
    cv_non_spare: TypeAlias = NonSpare_78

class Variation_137(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_137.cv_arg") -> "Variation_137":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_137(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_137.cv_arg
    cv_variation: TypeAlias = Variation_137

    @classmethod
    def create(cls, arg : "RuleVariation_137.cv_arg") -> "RuleVariation_137":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_137:
        return self.arg # type: ignore

class NonSpare_1467(NonSpare):
    cv_arg: TypeAlias = RuleVariation_137.cv_arg
    cv_name = "PRIORITY"
    cv_title = "Priority"
    cv_rule: TypeAlias = RuleVariation_137

    @classmethod
    def create(cls, arg : "NonSpare_1467.cv_arg") -> "NonSpare_1467":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_137:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_137:
        return self.rule.variation

class Item_710(Item):
    cv_arg: TypeAlias = NonSpare_1467.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1467

    @classmethod
    def create(cls, arg : "Item_710.cv_arg") -> "Item_710":
        return cls._create(arg) # type: ignore

class Variation_804(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_804.cv_arg") -> "Variation_804":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_774(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_804.cv_arg
    cv_variation: TypeAlias = Variation_804

    @classmethod
    def create(cls, arg : "RuleVariation_774.cv_arg") -> "RuleVariation_774":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_804:
        return self.arg # type: ignore

class NonSpare_1453(NonSpare):
    cv_arg: TypeAlias = RuleVariation_774.cv_arg
    cv_name = "POWER"
    cv_title = "Power"
    cv_rule: TypeAlias = RuleVariation_774

    @classmethod
    def create(cls, arg : "NonSpare_1453.cv_arg") -> "NonSpare_1453":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_774:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_804:
        return self.rule.variation

class Item_696(Item):
    cv_arg: TypeAlias = NonSpare_1453.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1453

    @classmethod
    def create(cls, arg : "Item_696.cv_arg") -> "Item_696":
        return cls._create(arg) # type: ignore

class Variation_223(Element):
    cv_arg: TypeAlias = RuleContent_724.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_724

    @classmethod
    def create(cls, arg: "Variation_223.cv_arg") -> "Variation_223":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_724:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_724:
        return self.rule.content

class RuleVariation_216(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_223.cv_arg
    cv_variation: TypeAlias = Variation_223

    @classmethod
    def create(cls, arg : "RuleVariation_216.cv_arg") -> "RuleVariation_216":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_223:
        return self.arg # type: ignore

class NonSpare_914(NonSpare):
    cv_arg: TypeAlias = RuleVariation_216.cv_arg
    cv_name = "DURATION"
    cv_title = "Duration"
    cv_rule: TypeAlias = RuleVariation_216

    @classmethod
    def create(cls, arg : "NonSpare_914.cv_arg") -> "NonSpare_914":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_216:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_223:
        return self.rule.variation

class Item_284(Item):
    cv_arg: TypeAlias = NonSpare_914.cv_arg
    cv_non_spare: TypeAlias = NonSpare_914

    @classmethod
    def create(cls, arg : "Item_284.cv_arg") -> "Item_284":
        return cls._create(arg) # type: ignore

class Variation_373(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_373.cv_arg") -> "Variation_373":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_366(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_373.cv_arg
    cv_variation: TypeAlias = Variation_373

    @classmethod
    def create(cls, arg : "RuleVariation_366.cv_arg") -> "RuleVariation_366":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_373:
        return self.arg # type: ignore

class NonSpare_808(NonSpare):
    cv_arg: TypeAlias = RuleVariation_366.cv_arg
    cv_name = "COVERAGE"
    cv_title = "Coverage"
    cv_rule: TypeAlias = RuleVariation_366

    @classmethod
    def create(cls, arg : "NonSpare_808.cv_arg") -> "NonSpare_808":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

class Item_203(Item):
    cv_arg: TypeAlias = NonSpare_808.cv_arg
    cv_non_spare: TypeAlias = NonSpare_808

    @classmethod
    def create(cls, arg : "Item_203.cv_arg") -> "Item_203":
        return cls._create(arg) # type: ignore

class Variation_1165(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_137.cv_arg, Tuple[Literal["PRIORITY"], RuleVariation_137.cv_arg]], Union[RuleVariation_774.cv_arg, Tuple[Literal["POWER"], RuleVariation_774.cv_arg]], Union[RuleVariation_216.cv_arg, Tuple[Literal["DURATION"], RuleVariation_216.cv_arg]], Union[RuleVariation_366.cv_arg, Tuple[Literal["COVERAGE"], RuleVariation_366.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1165.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_710, 4), (Item_696, 4), (Item_284, 8), (Item_203, 32)]
    cv_items_dict = {"PRIORITY": RuleVariation_137, "POWER": RuleVariation_774, "DURATION": RuleVariation_216, "COVERAGE": RuleVariation_366}

    @overload
    @classmethod
    def spec(cls, key : Literal["PRIORITY"]) -> RuleVariation_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POWER"]) -> RuleVariation_774:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DURATION"]) -> RuleVariation_216:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COVERAGE"]) -> RuleVariation_366:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PRIORITY"], Literal["POWER"], Literal["DURATION"], Literal["COVERAGE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PRIORITY"]) -> RuleVariation_137:
        ...
    @overload
    def get_item(self, key : Literal["POWER"]) -> RuleVariation_774:
        ...
    @overload
    def get_item(self, key : Literal["DURATION"]) -> RuleVariation_216:
        ...
    @overload
    def get_item(self, key : Literal["COVERAGE"]) -> RuleVariation_366:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1165.cv_arg") -> 'Variation_1165':
        return cls._create(arg) # type: ignore

class RuleVariation_1116(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1165.cv_arg
    cv_variation: TypeAlias = Variation_1165

    @classmethod
    def create(cls, arg : "RuleVariation_1116.cv_arg") -> "RuleVariation_1116":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1165:
        return self.arg # type: ignore

class NonSpare_98(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1116.cv_arg
    cv_name = "021"
    cv_title = "Broadcast Properties"
    cv_rule: TypeAlias = RuleVariation_1116

    @classmethod
    def create(cls, arg : "NonSpare_98.cv_arg") -> "NonSpare_98":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1116:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1165:
        return self.rule.variation

class UapItem_98(UapItem):
    cv_non_spare: TypeAlias = NonSpare_98

class NonSpare_1462(NonSpare):
    cv_arg: TypeAlias = RuleVariation_866.cv_arg
    cv_name = "PREFIX"
    cv_title = "Prefix Field"
    cv_rule: TypeAlias = RuleVariation_866

    @classmethod
    def create(cls, arg : "NonSpare_1462.cv_arg") -> "NonSpare_1462":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_866:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_896:
        return self.rule.variation

class Item_705(Item):
    cv_arg: TypeAlias = NonSpare_1462.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1462

    @classmethod
    def create(cls, arg : "Item_705.cv_arg") -> "Item_705":
        return cls._create(arg) # type: ignore

class Variation_1039(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_866.cv_arg, Tuple[Literal["PREFIX"], RuleVariation_866.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1039.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_4, 5), (Item_705, 27)]
    cv_items_dict = {"PREFIX": RuleVariation_866}

    @classmethod
    def spec(cls, key : Literal["PREFIX"]) -> RuleVariation_866:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["PREFIX"]) -> RuleVariation_866:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1039.cv_arg") -> 'Variation_1039':
        return cls._create(arg) # type: ignore

class RuleVariation_1007(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1039.cv_arg
    cv_variation: TypeAlias = Variation_1039

    @classmethod
    def create(cls, arg : "RuleVariation_1007.cv_arg") -> "RuleVariation_1007":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1039:
        return self.arg # type: ignore

class NonSpare_99(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1007.cv_arg
    cv_name = "022"
    cv_title = "Broadcast Prefix"
    cv_rule: TypeAlias = RuleVariation_1007

    @classmethod
    def create(cls, arg : "NonSpare_99.cv_arg") -> "NonSpare_99":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1007:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1039:
        return self.rule.variation

class UapItem_99(UapItem):
    cv_non_spare: TypeAlias = NonSpare_99

class NonSpare_100(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "023"
    cv_title = "Uplink or Downlink Broadcast"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_100.cv_arg") -> "NonSpare_100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class UapItem_100(UapItem):
    cv_non_spare: TypeAlias = NonSpare_100

class NonSpare_1463(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "PREVIOUSII"
    cv_title = "Former II Code"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_1463.cv_arg") -> "NonSpare_1463":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_706(Item):
    cv_arg: TypeAlias = NonSpare_1463.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1463

    @classmethod
    def create(cls, arg : "Item_706.cv_arg") -> "Item_706":
        return cls._create(arg) # type: ignore

class NonSpare_850(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "CURRENTII"
    cv_title = "Current II Code"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_850.cv_arg") -> "NonSpare_850":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_231(Item):
    cv_arg: TypeAlias = NonSpare_850.cv_arg
    cv_non_spare: TypeAlias = NonSpare_850

    @classmethod
    def create(cls, arg : "Item_231.cv_arg") -> "Item_231":
        return cls._create(arg) # type: ignore

class Variation_1162(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["PREVIOUSII"], RuleVariation_132.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["CURRENTII"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1162.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_706, 4), (Item_231, 4)]
    cv_items_dict = {"PREVIOUSII": RuleVariation_132, "CURRENTII": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["PREVIOUSII"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CURRENTII"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PREVIOUSII"], Literal["CURRENTII"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PREVIOUSII"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["CURRENTII"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1162.cv_arg") -> 'Variation_1162':
        return cls._create(arg) # type: ignore

class RuleVariation_1113(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1162.cv_arg
    cv_variation: TypeAlias = Variation_1162

    @classmethod
    def create(cls, arg : "RuleVariation_1113.cv_arg") -> "RuleVariation_1113":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1162:
        return self.arg # type: ignore

class NonSpare_22(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1113.cv_arg
    cv_name = "004"
    cv_title = "II Code"
    cv_rule: TypeAlias = RuleVariation_1113

    @classmethod
    def create(cls, arg : "NonSpare_22.cv_arg") -> "NonSpare_22":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1113:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1162:
        return self.rule.variation

class UapItem_22(UapItem):
    cv_non_spare: TypeAlias = NonSpare_22

class Variation_389(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_389.cv_arg") -> "Variation_389":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_381(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_389.cv_arg
    cv_variation: TypeAlias = Variation_389

    @classmethod
    def create(cls, arg : "RuleVariation_381.cv_arg") -> "RuleVariation_381":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_389:
        return self.arg # type: ignore

class NonSpare_123(NonSpare):
    cv_arg: TypeAlias = RuleVariation_381.cv_arg
    cv_name = "031"
    cv_title = "Aircraft Identity"
    cv_rule: TypeAlias = RuleVariation_381

    @classmethod
    def create(cls, arg : "NonSpare_123.cv_arg") -> "NonSpare_123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_389:
        return self.rule.variation

class UapItem_123(UapItem):
    cv_non_spare: TypeAlias = NonSpare_123

class NonSpare_1298(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MOD3A"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1298.cv_arg") -> "NonSpare_1298":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_564(Item):
    cv_arg: TypeAlias = NonSpare_1298.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1298

    @classmethod
    def create(cls, arg : "Item_564.cv_arg") -> "Item_564":
        return cls._create(arg) # type: ignore

class Variation_1264(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_542.cv_arg, Tuple[Literal["L"], RuleVariation_542.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MOD3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1264.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_453, 1), (Item_16, 1), (Item_564, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_542, "MOD3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MOD3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MOD3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    def get_item(self, key : Literal["MOD3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1264.cv_arg") -> 'Variation_1264':
        return cls._create(arg) # type: ignore

class RuleVariation_1193(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1264.cv_arg
    cv_variation: TypeAlias = Variation_1264

    @classmethod
    def create(cls, arg : "RuleVariation_1193.cv_arg") -> "RuleVariation_1193":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1264:
        return self.arg # type: ignore

class NonSpare_124(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1193.cv_arg
    cv_name = "032"
    cv_title = "Aircraft Mode A"
    cv_rule: TypeAlias = RuleVariation_1193

    @classmethod
    def create(cls, arg : "NonSpare_124.cv_arg") -> "NonSpare_124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1193:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1264:
        return self.rule.variation

class UapItem_124(UapItem):
    cv_non_spare: TypeAlias = NonSpare_124

class Variation_1257(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_598.cv_arg, Tuple[Literal["FL"], RuleVariation_598.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1257.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_331, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "FL": RuleVariation_598}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_598:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_598:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1257.cv_arg") -> 'Variation_1257':
        return cls._create(arg) # type: ignore

class RuleVariation_1186(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1257.cv_arg
    cv_variation: TypeAlias = Variation_1257

    @classmethod
    def create(cls, arg : "RuleVariation_1186.cv_arg") -> "RuleVariation_1186":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1257:
        return self.arg # type: ignore

class NonSpare_126(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1186.cv_arg
    cv_name = "033"
    cv_title = "Aircraft Height"
    cv_rule: TypeAlias = RuleVariation_1186

    @classmethod
    def create(cls, arg : "NonSpare_126.cv_arg") -> "NonSpare_126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1186:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1257:
        return self.rule.variation

class UapItem_126(UapItem):
    cv_non_spare: TypeAlias = NonSpare_126

class NonSpare_127(NonSpare):
    cv_arg: TypeAlias = RuleVariation_331.cv_arg
    cv_name = "034"
    cv_title = "Aircraft Speed"
    cv_rule: TypeAlias = RuleVariation_331

    @classmethod
    def create(cls, arg : "NonSpare_127.cv_arg") -> "NonSpare_127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_331:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_338:
        return self.rule.variation

class UapItem_127(UapItem):
    cv_non_spare: TypeAlias = NonSpare_127

class NonSpare_129(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "035"
    cv_title = "Aircraft Heading"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_129.cv_arg") -> "NonSpare_129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class UapItem_129(UapItem):
    cv_non_spare: TypeAlias = NonSpare_129

class Content_29(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft is airborne", 1: "Aircraft is on the ground"}

class RuleContent_29(RuleContentContextFree):
    cv_arg: TypeAlias = Content_29.cv_arg
    cv_content: TypeAlias = Content_29

    @property
    def content(self) -> Content_29:
        return self._get_content() # type: ignore

class Variation_10(Element):
    cv_arg: TypeAlias = RuleContent_29.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_29

    @classmethod
    def create(cls, arg: "Variation_10.cv_arg") -> "Variation_10":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_29:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_29:
        return self.rule.content

class RuleVariation_10(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_10.cv_arg
    cv_variation: TypeAlias = Variation_10

    @classmethod
    def create(cls, arg : "RuleVariation_10.cv_arg") -> "RuleVariation_10":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_10:
        return self.arg # type: ignore

class NonSpare_998(NonSpare):
    cv_arg: TypeAlias = RuleVariation_10.cv_arg
    cv_name = "FS"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_10

    @classmethod
    def create(cls, arg : "NonSpare_998.cv_arg") -> "NonSpare_998":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_10:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_10:
        return self.rule.variation

class Item_347(Item):
    cv_arg: TypeAlias = NonSpare_998.cv_arg
    cv_non_spare: TypeAlias = NonSpare_998

    @classmethod
    def create(cls, arg : "Item_347.cv_arg") -> "Item_347":
        return cls._create(arg) # type: ignore

class Content_488(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The CQF calculation method is not supported", 1: "The CQF is minimum", 126: "The CQF is maximum", 127: "The CQF is undefined according to the calculation method"}

class RuleContent_488(RuleContentContextFree):
    cv_arg: TypeAlias = Content_488.cv_arg
    cv_content: TypeAlias = Content_488

    @property
    def content(self) -> Content_488:
        return self._get_content() # type: ignore

class Variation_494(Element):
    cv_arg: TypeAlias = RuleContent_488.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_488

    @classmethod
    def create(cls, arg: "Variation_494.cv_arg") -> "Variation_494":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_488:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_488:
        return self.rule.content

class RuleVariation_483(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_494.cv_arg
    cv_variation: TypeAlias = Variation_494

    @classmethod
    def create(cls, arg : "RuleVariation_483.cv_arg") -> "RuleVariation_483":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_494:
        return self.arg # type: ignore

class NonSpare_826(NonSpare):
    cv_arg: TypeAlias = RuleVariation_483.cv_arg
    cv_name = "CQF"
    cv_title = "Aircraft CQF"
    cv_rule: TypeAlias = RuleVariation_483

    @classmethod
    def create(cls, arg : "NonSpare_826.cv_arg") -> "NonSpare_826":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_483:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_494:
        return self.rule.variation

class Item_212(Item):
    cv_arg: TypeAlias = NonSpare_826.cv_arg
    cv_non_spare: TypeAlias = NonSpare_826

    @classmethod
    def create(cls, arg : "Item_212.cv_arg") -> "Item_212":
        return cls._create(arg) # type: ignore

class Variation_1105(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_10.cv_arg, Tuple[Literal["FS"], RuleVariation_10.cv_arg]], Union[RuleVariation_483.cv_arg, Tuple[Literal["CQF"], RuleVariation_483.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1105.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_347, 1), (Item_212, 7)]
    cv_items_dict = {"FS": RuleVariation_10, "CQF": RuleVariation_483}

    @overload
    @classmethod
    def spec(cls, key : Literal["FS"]) -> RuleVariation_10:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CQF"]) -> RuleVariation_483:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FS"], Literal["CQF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FS"]) -> RuleVariation_10:
        ...
    @overload
    def get_item(self, key : Literal["CQF"]) -> RuleVariation_483:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1105.cv_arg") -> 'Variation_1105':
        return cls._create(arg) # type: ignore

class RuleVariation_1063(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1105.cv_arg
    cv_variation: TypeAlias = Variation_1105

    @classmethod
    def create(cls, arg : "RuleVariation_1063.cv_arg") -> "RuleVariation_1063":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1105:
        return self.arg # type: ignore

class NonSpare_53(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1063.cv_arg
    cv_name = "012"
    cv_title = "Aircraft Coverage Quality Factor"
    cv_rule: TypeAlias = RuleVariation_1063

    @classmethod
    def create(cls, arg : "NonSpare_53.cv_arg") -> "NonSpare_53":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1063:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1105:
        return self.rule.variation

class UapItem_53(UapItem):
    cv_non_spare: TypeAlias = NonSpare_53

class NonSpare_55(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "013"
    cv_title = "Aircraft CQF Calculation Method"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_55.cv_arg") -> "NonSpare_55":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_55(UapItem):
    cv_non_spare: TypeAlias = NonSpare_55

class Record_51(Record):
    cv_arg = TypedDict('cv_arg', {
        "036": NonSpare_132.cv_arg,
        "037": NonSpare_134.cv_arg,
        "000": NonSpare_0.cv_arg,
        "001": NonSpare_20.cv_arg,
        "005": NonSpare_23.cv_arg,
        "016": NonSpare_71.cv_arg,
        "017": NonSpare_73.cv_arg,
        "018": NonSpare_75.cv_arg,
        "019": NonSpare_76.cv_arg,
        "028": NonSpare_103.cv_arg,
        "030": NonSpare_105.cv_arg,
        "025": NonSpare_101.cv_arg,
        "027": NonSpare_102.cv_arg,
        "029": NonSpare_104.cv_arg,
        "002": NonSpare_21.cv_arg,
        "006": NonSpare_24.cv_arg,
        "007": NonSpare_25.cv_arg,
        "008": NonSpare_26.cv_arg,
        "009": NonSpare_28.cv_arg,
        "010": NonSpare_51.cv_arg,
        "011": NonSpare_52.cv_arg,
        "014": NonSpare_56.cv_arg,
        "015": NonSpare_57.cv_arg,
        "020": NonSpare_78.cv_arg,
        "021": NonSpare_98.cv_arg,
        "022": NonSpare_99.cv_arg,
        "023": NonSpare_100.cv_arg,
        "004": NonSpare_22.cv_arg,
        "031": NonSpare_123.cv_arg,
        "032": NonSpare_124.cv_arg,
        "033": NonSpare_126.cv_arg,
        "034": NonSpare_127.cv_arg,
        "035": NonSpare_129.cv_arg,
        "012": NonSpare_53.cv_arg,
        "013": NonSpare_55.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_132, UapItem_134, UapItem_0, UapItem_20, UapItem_23, UapItem_71, UapItem_73, UapItem_75, UapItem_76, UapItem_103, UapItem_105, UapItem_101, UapItem_102, UapItem_104, UapItem_21, UapItem_24, UapItem_25, UapItem_26, UapItem_28, UapItem_51, UapItem_52, UapItem_56, UapItem_57, UapItem_78, UapItem_98, UapItem_99, UapItem_100, UapItem_22, UapItem_123, UapItem_124, UapItem_126, UapItem_127, UapItem_129, UapItem_53, UapItem_55]
    cv_items_dict = {"036": NonSpare_132, "037": NonSpare_134, "000": NonSpare_0, "001": NonSpare_20, "005": NonSpare_23, "016": NonSpare_71, "017": NonSpare_73, "018": NonSpare_75, "019": NonSpare_76, "028": NonSpare_103, "030": NonSpare_105, "025": NonSpare_101, "027": NonSpare_102, "029": NonSpare_104, "002": NonSpare_21, "006": NonSpare_24, "007": NonSpare_25, "008": NonSpare_26, "009": NonSpare_28, "010": NonSpare_51, "011": NonSpare_52, "014": NonSpare_56, "015": NonSpare_57, "020": NonSpare_78, "021": NonSpare_98, "022": NonSpare_99, "023": NonSpare_100, "004": NonSpare_22, "031": NonSpare_123, "032": NonSpare_124, "033": NonSpare_126, "034": NonSpare_127, "035": NonSpare_129, "012": NonSpare_53, "013": NonSpare_55}

    @overload
    @classmethod
    def spec(cls, key : Literal["036"]) -> NonSpare_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["037"]) -> NonSpare_134:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_0:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["001"]) -> NonSpare_20:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["005"]) -> NonSpare_23:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["017"]) -> NonSpare_73:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["018"]) -> NonSpare_75:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["019"]) -> NonSpare_76:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["028"]) -> NonSpare_103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_105:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["025"]) -> NonSpare_101:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["027"]) -> NonSpare_102:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["029"]) -> NonSpare_104:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["002"]) -> NonSpare_21:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["006"]) -> NonSpare_24:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["007"]) -> NonSpare_25:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_26:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["009"]) -> NonSpare_28:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_51:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["011"]) -> NonSpare_52:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["014"]) -> NonSpare_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_57:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["021"]) -> NonSpare_98:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["022"]) -> NonSpare_99:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["023"]) -> NonSpare_100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["004"]) -> NonSpare_22:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["031"]) -> NonSpare_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["033"]) -> NonSpare_126:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["034"]) -> NonSpare_127:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_129:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["012"]) -> NonSpare_53:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["013"]) -> NonSpare_55:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["036"], Literal["037"], Literal["000"], Literal["001"], Literal["005"], Literal["016"], Literal["017"], Literal["018"], Literal["019"], Literal["028"], Literal["030"], Literal["025"], Literal["027"], Literal["029"], Literal["002"], Literal["006"], Literal["007"], Literal["008"], Literal["009"], Literal["010"], Literal["011"], Literal["014"], Literal["015"], Literal["020"], Literal["021"], Literal["022"], Literal["023"], Literal["004"], Literal["031"], Literal["032"], Literal["033"], Literal["034"], Literal["035"], Literal["012"], Literal["013"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["036"]) -> Optional[NonSpare_132]:
        ...
    @overload
    def get_item(self, key : Literal["037"]) -> Optional[NonSpare_134]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_0]:
        ...
    @overload
    def get_item(self, key : Literal["001"]) -> Optional[NonSpare_20]:
        ...
    @overload
    def get_item(self, key : Literal["005"]) -> Optional[NonSpare_23]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_71]:
        ...
    @overload
    def get_item(self, key : Literal["017"]) -> Optional[NonSpare_73]:
        ...
    @overload
    def get_item(self, key : Literal["018"]) -> Optional[NonSpare_75]:
        ...
    @overload
    def get_item(self, key : Literal["019"]) -> Optional[NonSpare_76]:
        ...
    @overload
    def get_item(self, key : Literal["028"]) -> Optional[NonSpare_103]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_105]:
        ...
    @overload
    def get_item(self, key : Literal["025"]) -> Optional[NonSpare_101]:
        ...
    @overload
    def get_item(self, key : Literal["027"]) -> Optional[NonSpare_102]:
        ...
    @overload
    def get_item(self, key : Literal["029"]) -> Optional[NonSpare_104]:
        ...
    @overload
    def get_item(self, key : Literal["002"]) -> Optional[NonSpare_21]:
        ...
    @overload
    def get_item(self, key : Literal["006"]) -> Optional[NonSpare_24]:
        ...
    @overload
    def get_item(self, key : Literal["007"]) -> Optional[NonSpare_25]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_26]:
        ...
    @overload
    def get_item(self, key : Literal["009"]) -> Optional[NonSpare_28]:
        ...
    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_51]:
        ...
    @overload
    def get_item(self, key : Literal["011"]) -> Optional[NonSpare_52]:
        ...
    @overload
    def get_item(self, key : Literal["014"]) -> Optional[NonSpare_56]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_57]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_78]:
        ...
    @overload
    def get_item(self, key : Literal["021"]) -> Optional[NonSpare_98]:
        ...
    @overload
    def get_item(self, key : Literal["022"]) -> Optional[NonSpare_99]:
        ...
    @overload
    def get_item(self, key : Literal["023"]) -> Optional[NonSpare_100]:
        ...
    @overload
    def get_item(self, key : Literal["004"]) -> Optional[NonSpare_22]:
        ...
    @overload
    def get_item(self, key : Literal["031"]) -> Optional[NonSpare_123]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_124]:
        ...
    @overload
    def get_item(self, key : Literal["033"]) -> Optional[NonSpare_126]:
        ...
    @overload
    def get_item(self, key : Literal["034"]) -> Optional[NonSpare_127]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_129]:
        ...
    @overload
    def get_item(self, key : Literal["012"]) -> Optional[NonSpare_53]:
        ...
    @overload
    def get_item(self, key : Literal["013"]) -> Optional[NonSpare_55]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["036"], val : NonSpare_132.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["037"], val : NonSpare_134.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_0.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["001"], val : NonSpare_20.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["005"], val : NonSpare_23.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_71.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["017"], val : NonSpare_73.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["018"], val : NonSpare_75.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["019"], val : NonSpare_76.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["028"], val : NonSpare_103.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_105.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["025"], val : NonSpare_101.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["027"], val : NonSpare_102.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["029"], val : NonSpare_104.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["002"], val : NonSpare_21.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["006"], val : NonSpare_24.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["007"], val : NonSpare_25.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_26.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["009"], val : NonSpare_28.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_51.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["011"], val : NonSpare_52.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["014"], val : NonSpare_56.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_57.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_78.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["021"], val : NonSpare_98.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["022"], val : NonSpare_99.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["023"], val : NonSpare_100.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["004"], val : NonSpare_22.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["031"], val : NonSpare_123.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_124.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["033"], val : NonSpare_126.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["034"], val : NonSpare_127.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_129.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["012"], val : NonSpare_53.cv_arg) -> 'Record_51':
        ...
    @overload
    def set_item(self, key : Literal["013"], val : NonSpare_55.cv_arg) -> 'Record_51':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["036"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["037"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["001"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["005"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["017"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["018"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["019"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["028"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["025"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["027"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["029"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["002"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["006"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["007"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["009"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["011"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["014"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["021"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["022"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["023"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["004"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["031"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["033"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["034"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["012"]) -> 'Record_51':
        ...
    @overload
    def del_item(self, key : Literal["013"]) -> 'Record_51':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_51.cv_arg") -> 'Record_51':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_51", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_47(UapSingle):
    cv_arg: TypeAlias = Record_51
    cv_record: TypeAlias = Record_51

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_51]]:
        return cls._parse(bs)

class Asterix_19(AstCat):
    cv_category = 18
    cv_edition = (1, 7)
    cv_uap: TypeAlias = Uap_47
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_47.cv_arg]) -> "Asterix_19":
        return cls._create(records) # type: ignore

class Asterix_20(AstCat):
    cv_category = 18
    cv_edition = (1, 8)
    cv_uap: TypeAlias = Uap_47
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_47.cv_arg]) -> "Asterix_20":
        return cls._create(records) # type: ignore

class NonSpare_45(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_45.cv_arg") -> "NonSpare_45":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_45(UapItem):
    cv_non_spare: TypeAlias = NonSpare_45

class Content_596(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Start of Update Cycle", 2: "Periodic Status Message", 3: "Event-triggered Status Message"}

class RuleContent_596(RuleContentContextFree):
    cv_arg: TypeAlias = Content_596.cv_arg
    cv_content: TypeAlias = Content_596

    @property
    def content(self) -> Content_596:
        return self._get_content() # type: ignore

class Variation_195(Element):
    cv_arg: TypeAlias = RuleContent_596.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_596

    @classmethod
    def create(cls, arg: "Variation_195.cv_arg") -> "Variation_195":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_596:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_596:
        return self.rule.content

class RuleVariation_188(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_195.cv_arg
    cv_variation: TypeAlias = Variation_195

    @classmethod
    def create(cls, arg : "RuleVariation_188.cv_arg") -> "RuleVariation_188":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_195:
        return self.arg # type: ignore

class NonSpare_10(NonSpare):
    cv_arg: TypeAlias = RuleVariation_188.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_188

    @classmethod
    def create(cls, arg : "NonSpare_10.cv_arg") -> "NonSpare_10":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_188:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_195:
        return self.rule.variation

class UapItem_10(UapItem):
    cv_non_spare: TypeAlias = NonSpare_10

class NonSpare_329(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_329.cv_arg") -> "NonSpare_329":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_329(UapItem):
    cv_non_spare: TypeAlias = NonSpare_329

class Content_412(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Operational", 1: "Degraded", 2: "NOGO", 3: "Undefined"}

class RuleContent_412(RuleContentContextFree):
    cv_arg: TypeAlias = Content_412.cv_arg
    cv_content: TypeAlias = Content_412

    @property
    def content(self) -> Content_412:
        return self._get_content() # type: ignore

class Variation_109(Element):
    cv_arg: TypeAlias = RuleContent_412.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_412

    @classmethod
    def create(cls, arg: "Variation_109.cv_arg") -> "Variation_109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_412:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_412:
        return self.rule.content

class RuleVariation_109(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_109.cv_arg
    cv_variation: TypeAlias = Variation_109

    @classmethod
    def create(cls, arg : "RuleVariation_109.cv_arg") -> "RuleVariation_109":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_109:
        return self.arg # type: ignore

class NonSpare_1370(NonSpare):
    cv_arg: TypeAlias = RuleVariation_109.cv_arg
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the System"
    cv_rule: TypeAlias = RuleVariation_109

    @classmethod
    def create(cls, arg : "NonSpare_1370.cv_arg") -> "NonSpare_1370":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_109:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_109:
        return self.rule.variation

class Item_630(Item):
    cv_arg: TypeAlias = NonSpare_1370.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1370

    @classmethod
    def create(cls, arg : "Item_630.cv_arg") -> "Item_630":
        return cls._create(arg) # type: ignore

class Variation_755(Element):
    cv_arg: TypeAlias = RuleContent_487.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_487

    @classmethod
    def create(cls, arg: "Variation_755.cv_arg") -> "Variation_755":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_487:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_487:
        return self.rule.content

class RuleVariation_744(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_755.cv_arg
    cv_variation: TypeAlias = Variation_755

    @classmethod
    def create(cls, arg : "RuleVariation_744.cv_arg") -> "RuleVariation_744":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_755:
        return self.arg # type: ignore

class NonSpare_1949(NonSpare):
    cv_arg: TypeAlias = RuleVariation_744.cv_arg
    cv_name = "TTF"
    cv_title = "Test Target"
    cv_rule: TypeAlias = RuleVariation_744

    @classmethod
    def create(cls, arg : "NonSpare_1949.cv_arg") -> "NonSpare_1949":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_744:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_755:
        return self.rule.variation

class Item_1064(Item):
    cv_arg: TypeAlias = NonSpare_1949.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1949

    @classmethod
    def create(cls, arg : "Item_1064.cv_arg") -> "Item_1064":
        return cls._create(arg) # type: ignore

class Variation_1154(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_109.cv_arg, Tuple[Literal["NOGO"], RuleVariation_109.cv_arg]], Union[RuleVariation_553.cv_arg, Tuple[Literal["OVL"], RuleVariation_553.cv_arg]], Union[RuleVariation_662.cv_arg, Tuple[Literal["TSV"], RuleVariation_662.cv_arg]], Union[RuleVariation_744.cv_arg, Tuple[Literal["TTF"], RuleVariation_744.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1154.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_630, 2), (Item_668, 1), (Item_1058, 1), (Item_1064, 1), (Item_25, 3)]
    cv_items_dict = {"NOGO": RuleVariation_109, "OVL": RuleVariation_553, "TSV": RuleVariation_662, "TTF": RuleVariation_744}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_109:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_553:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_662:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTF"]) -> RuleVariation_744:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["OVL"], Literal["TSV"], Literal["TTF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_109:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_553:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_662:
        ...
    @overload
    def get_item(self, key : Literal["TTF"]) -> RuleVariation_744:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1154.cv_arg") -> 'Variation_1154':
        return cls._create(arg) # type: ignore

class RuleVariation_1107(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1154.cv_arg
    cv_variation: TypeAlias = Variation_1154

    @classmethod
    def create(cls, arg : "RuleVariation_1107.cv_arg") -> "RuleVariation_1107":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1154:
        return self.arg # type: ignore

class NonSpare_524(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1107.cv_arg
    cv_name = "550"
    cv_title = "System Status"
    cv_rule: TypeAlias = RuleVariation_1107

    @classmethod
    def create(cls, arg : "NonSpare_524.cv_arg") -> "NonSpare_524":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1107:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1154:
        return self.rule.variation

class UapItem_523(UapItem):
    cv_non_spare: TypeAlias = NonSpare_524

class Content_459(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Standby", 1: "Exec"}

class RuleContent_459(RuleContentContextFree):
    cv_arg: TypeAlias = Content_459.cv_arg
    cv_content: TypeAlias = Content_459

    @property
    def content(self) -> Content_459:
        return self._get_content() # type: ignore

class Variation_76(Element):
    cv_arg: TypeAlias = RuleContent_459.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_459

    @classmethod
    def create(cls, arg: "Variation_76.cv_arg") -> "Variation_76":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_459:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_459:
        return self.rule.content

class RuleVariation_76(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_76.cv_arg
    cv_variation: TypeAlias = Variation_76

    @classmethod
    def create(cls, arg : "RuleVariation_76.cv_arg") -> "RuleVariation_76":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_76:
        return self.arg # type: ignore

class NonSpare_1890(NonSpare):
    cv_arg: TypeAlias = RuleVariation_76.cv_arg
    cv_name = "TP1A"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_76

    @classmethod
    def create(cls, arg : "NonSpare_1890.cv_arg") -> "NonSpare_1890":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_76:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_76:
        return self.rule.variation

class Item_1013(Item):
    cv_arg: TypeAlias = NonSpare_1890.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1890

    @classmethod
    def create(cls, arg : "Item_1013.cv_arg") -> "Item_1013":
        return cls._create(arg) # type: ignore

class Content_211(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Faulted", 1: "Good"}

class RuleContent_211(RuleContentContextFree):
    cv_arg: TypeAlias = Content_211.cv_arg
    cv_content: TypeAlias = Content_211

    @property
    def content(self) -> Content_211:
        return self._get_content() # type: ignore

class Variation_426(Element):
    cv_arg: TypeAlias = RuleContent_211.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg: "Variation_426.cv_arg") -> "Variation_426":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_211:
        return self.rule.content

class RuleVariation_415(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_426.cv_arg
    cv_variation: TypeAlias = Variation_426

    @classmethod
    def create(cls, arg : "RuleVariation_415.cv_arg") -> "RuleVariation_415":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_426:
        return self.arg # type: ignore

class NonSpare_1891(NonSpare):
    cv_arg: TypeAlias = RuleVariation_415.cv_arg
    cv_name = "TP1B"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_415

    @classmethod
    def create(cls, arg : "NonSpare_1891.cv_arg") -> "NonSpare_1891":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_415:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_426:
        return self.rule.variation

class Item_1014(Item):
    cv_arg: TypeAlias = NonSpare_1891.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1891

    @classmethod
    def create(cls, arg : "Item_1014.cv_arg") -> "Item_1014":
        return cls._create(arg) # type: ignore

class Variation_576(Element):
    cv_arg: TypeAlias = RuleContent_459.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_459

    @classmethod
    def create(cls, arg: "Variation_576.cv_arg") -> "Variation_576":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_459:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_459:
        return self.rule.content

class RuleVariation_565(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_576.cv_arg
    cv_variation: TypeAlias = Variation_576

    @classmethod
    def create(cls, arg : "RuleVariation_565.cv_arg") -> "RuleVariation_565":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_576:
        return self.arg # type: ignore

class NonSpare_1892(NonSpare):
    cv_arg: TypeAlias = RuleVariation_565.cv_arg
    cv_name = "TP2A"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_565

    @classmethod
    def create(cls, arg : "NonSpare_1892.cv_arg") -> "NonSpare_1892":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_565:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_576:
        return self.rule.variation

class Item_1015(Item):
    cv_arg: TypeAlias = NonSpare_1892.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1892

    @classmethod
    def create(cls, arg : "Item_1015.cv_arg") -> "Item_1015":
        return cls._create(arg) # type: ignore

class Variation_640(Element):
    cv_arg: TypeAlias = RuleContent_211.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg: "Variation_640.cv_arg") -> "Variation_640":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_211:
        return self.rule.content

class RuleVariation_629(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_640.cv_arg
    cv_variation: TypeAlias = Variation_640

    @classmethod
    def create(cls, arg : "RuleVariation_629.cv_arg") -> "RuleVariation_629":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_640:
        return self.arg # type: ignore

class NonSpare_1893(NonSpare):
    cv_arg: TypeAlias = RuleVariation_629.cv_arg
    cv_name = "TP2B"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_629

    @classmethod
    def create(cls, arg : "NonSpare_1893.cv_arg") -> "NonSpare_1893":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_629:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_640:
        return self.rule.variation

class Item_1016(Item):
    cv_arg: TypeAlias = NonSpare_1893.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1893

    @classmethod
    def create(cls, arg : "Item_1016.cv_arg") -> "Item_1016":
        return cls._create(arg) # type: ignore

class Variation_752(Element):
    cv_arg: TypeAlias = RuleContent_459.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_459

    @classmethod
    def create(cls, arg: "Variation_752.cv_arg") -> "Variation_752":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_459:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_459:
        return self.rule.content

class RuleVariation_741(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_752.cv_arg
    cv_variation: TypeAlias = Variation_752

    @classmethod
    def create(cls, arg : "RuleVariation_741.cv_arg") -> "RuleVariation_741":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_752:
        return self.arg # type: ignore

class NonSpare_1894(NonSpare):
    cv_arg: TypeAlias = RuleVariation_741.cv_arg
    cv_name = "TP3A"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_741

    @classmethod
    def create(cls, arg : "NonSpare_1894.cv_arg") -> "NonSpare_1894":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_741:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_752:
        return self.rule.variation

class Item_1017(Item):
    cv_arg: TypeAlias = NonSpare_1894.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1894

    @classmethod
    def create(cls, arg : "Item_1017.cv_arg") -> "Item_1017":
        return cls._create(arg) # type: ignore

class Variation_850(Element):
    cv_arg: TypeAlias = RuleContent_211.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg: "Variation_850.cv_arg") -> "Variation_850":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_211:
        return self.rule.content

class RuleVariation_820(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_850.cv_arg
    cv_variation: TypeAlias = Variation_850

    @classmethod
    def create(cls, arg : "RuleVariation_820.cv_arg") -> "RuleVariation_820":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_850:
        return self.arg # type: ignore

class NonSpare_1895(NonSpare):
    cv_arg: TypeAlias = RuleVariation_820.cv_arg
    cv_name = "TP3B"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_820

    @classmethod
    def create(cls, arg : "NonSpare_1895.cv_arg") -> "NonSpare_1895":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_820:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_850:
        return self.rule.variation

class Item_1018(Item):
    cv_arg: TypeAlias = NonSpare_1895.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1895

    @classmethod
    def create(cls, arg : "Item_1018.cv_arg") -> "Item_1018":
        return cls._create(arg) # type: ignore

class Variation_951(Element):
    cv_arg: TypeAlias = RuleContent_459.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_459

    @classmethod
    def create(cls, arg: "Variation_951.cv_arg") -> "Variation_951":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_459:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_459:
        return self.rule.content

class RuleVariation_921(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_951.cv_arg
    cv_variation: TypeAlias = Variation_951

    @classmethod
    def create(cls, arg : "RuleVariation_921.cv_arg") -> "RuleVariation_921":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_951:
        return self.arg # type: ignore

class NonSpare_1896(NonSpare):
    cv_arg: TypeAlias = RuleVariation_921.cv_arg
    cv_name = "TP4A"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_921

    @classmethod
    def create(cls, arg : "NonSpare_1896.cv_arg") -> "NonSpare_1896":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_921:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_951:
        return self.rule.variation

class Item_1019(Item):
    cv_arg: TypeAlias = NonSpare_1896.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1896

    @classmethod
    def create(cls, arg : "Item_1019.cv_arg") -> "Item_1019":
        return cls._create(arg) # type: ignore

class Variation_975(Element):
    cv_arg: TypeAlias = RuleContent_211.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg: "Variation_975.cv_arg") -> "Variation_975":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_211:
        return self.rule.content

class RuleVariation_945(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_975.cv_arg
    cv_variation: TypeAlias = Variation_975

    @classmethod
    def create(cls, arg : "RuleVariation_945.cv_arg") -> "RuleVariation_945":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_975:
        return self.arg # type: ignore

class NonSpare_1897(NonSpare):
    cv_arg: TypeAlias = RuleVariation_945.cv_arg
    cv_name = "TP4B"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_945

    @classmethod
    def create(cls, arg : "NonSpare_1897.cv_arg") -> "NonSpare_1897":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_945:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_975:
        return self.rule.variation

class Item_1020(Item):
    cv_arg: TypeAlias = NonSpare_1897.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1897

    @classmethod
    def create(cls, arg : "Item_1020.cv_arg") -> "Item_1020":
        return cls._create(arg) # type: ignore

class Variation_1227(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_76.cv_arg, Tuple[Literal["TP1A"], RuleVariation_76.cv_arg]], Union[RuleVariation_415.cv_arg, Tuple[Literal["TP1B"], RuleVariation_415.cv_arg]], Union[RuleVariation_565.cv_arg, Tuple[Literal["TP2A"], RuleVariation_565.cv_arg]], Union[RuleVariation_629.cv_arg, Tuple[Literal["TP2B"], RuleVariation_629.cv_arg]], Union[RuleVariation_741.cv_arg, Tuple[Literal["TP3A"], RuleVariation_741.cv_arg]], Union[RuleVariation_820.cv_arg, Tuple[Literal["TP3B"], RuleVariation_820.cv_arg]], Union[RuleVariation_921.cv_arg, Tuple[Literal["TP4A"], RuleVariation_921.cv_arg]], Union[RuleVariation_945.cv_arg, Tuple[Literal["TP4B"], RuleVariation_945.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1227.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1013, 1), (Item_1014, 1), (Item_1015, 1), (Item_1016, 1), (Item_1017, 1), (Item_1018, 1), (Item_1019, 1), (Item_1020, 1)]
    cv_items_dict = {"TP1A": RuleVariation_76, "TP1B": RuleVariation_415, "TP2A": RuleVariation_565, "TP2B": RuleVariation_629, "TP3A": RuleVariation_741, "TP3B": RuleVariation_820, "TP4A": RuleVariation_921, "TP4B": RuleVariation_945}

    @overload
    @classmethod
    def spec(cls, key : Literal["TP1A"]) -> RuleVariation_76:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP1B"]) -> RuleVariation_415:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP2A"]) -> RuleVariation_565:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP2B"]) -> RuleVariation_629:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP3A"]) -> RuleVariation_741:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP3B"]) -> RuleVariation_820:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP4A"]) -> RuleVariation_921:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TP4B"]) -> RuleVariation_945:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TP1A"], Literal["TP1B"], Literal["TP2A"], Literal["TP2B"], Literal["TP3A"], Literal["TP3B"], Literal["TP4A"], Literal["TP4B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TP1A"]) -> RuleVariation_76:
        ...
    @overload
    def get_item(self, key : Literal["TP1B"]) -> RuleVariation_415:
        ...
    @overload
    def get_item(self, key : Literal["TP2A"]) -> RuleVariation_565:
        ...
    @overload
    def get_item(self, key : Literal["TP2B"]) -> RuleVariation_629:
        ...
    @overload
    def get_item(self, key : Literal["TP3A"]) -> RuleVariation_741:
        ...
    @overload
    def get_item(self, key : Literal["TP3B"]) -> RuleVariation_820:
        ...
    @overload
    def get_item(self, key : Literal["TP4A"]) -> RuleVariation_921:
        ...
    @overload
    def get_item(self, key : Literal["TP4B"]) -> RuleVariation_945:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1227.cv_arg") -> 'Variation_1227':
        return cls._create(arg) # type: ignore

class RuleVariation_1166(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1227.cv_arg
    cv_variation: TypeAlias = Variation_1227

    @classmethod
    def create(cls, arg : "RuleVariation_1166.cv_arg") -> "RuleVariation_1166":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1227:
        return self.arg # type: ignore

class NonSpare_525(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1166.cv_arg
    cv_name = "551"
    cv_title = "Tracking Processor Detailed Status"
    cv_rule: TypeAlias = RuleVariation_1166

    @classmethod
    def create(cls, arg : "NonSpare_525.cv_arg") -> "NonSpare_525":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1166:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1227:
        return self.rule.variation

class UapItem_524(UapItem):
    cv_non_spare: TypeAlias = NonSpare_525

class NonSpare_1622(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "RSI"
    cv_title = "8-bit Identification Number of RS"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1622.cv_arg") -> "NonSpare_1622":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_836(Item):
    cv_arg: TypeAlias = NonSpare_1622.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1622

    @classmethod
    def create(cls, arg : "Item_836.cv_arg") -> "Item_836":
        return cls._create(arg) # type: ignore

class Content_400(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not present", 1: "Present"}

class RuleContent_400(RuleContentContextFree):
    cv_arg: TypeAlias = Content_400.cv_arg
    cv_content: TypeAlias = Content_400

    @property
    def content(self) -> Content_400:
        return self._get_content() # type: ignore

class Variation_446(Element):
    cv_arg: TypeAlias = RuleContent_400.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_400

    @classmethod
    def create(cls, arg: "Variation_446.cv_arg") -> "Variation_446":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_400:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_400:
        return self.rule.content

class RuleVariation_435(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_446.cv_arg
    cv_variation: TypeAlias = Variation_446

    @classmethod
    def create(cls, arg : "RuleVariation_435.cv_arg") -> "RuleVariation_435":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_446:
        return self.arg # type: ignore

class NonSpare_1615(NonSpare):
    cv_arg: TypeAlias = RuleVariation_435.cv_arg
    cv_name = "RS1090"
    cv_title = "Receiver 1090 MHz"
    cv_rule: TypeAlias = RuleVariation_435

    @classmethod
    def create(cls, arg : "NonSpare_1615.cv_arg") -> "NonSpare_1615":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_435:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_446:
        return self.rule.variation

class Item_833(Item):
    cv_arg: TypeAlias = NonSpare_1615.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1615

    @classmethod
    def create(cls, arg : "Item_833.cv_arg") -> "Item_833":
        return cls._create(arg) # type: ignore

class Variation_570(Element):
    cv_arg: TypeAlias = RuleContent_400.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_400

    @classmethod
    def create(cls, arg: "Variation_570.cv_arg") -> "Variation_570":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_400:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_400:
        return self.rule.content

class RuleVariation_559(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_570.cv_arg
    cv_variation: TypeAlias = Variation_570

    @classmethod
    def create(cls, arg : "RuleVariation_559.cv_arg") -> "RuleVariation_559":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_570:
        return self.arg # type: ignore

class NonSpare_1955(NonSpare):
    cv_arg: TypeAlias = RuleVariation_559.cv_arg
    cv_name = "TX1030"
    cv_title = "Transmitter 1030 MHz"
    cv_rule: TypeAlias = RuleVariation_559

    @classmethod
    def create(cls, arg : "NonSpare_1955.cv_arg") -> "NonSpare_1955":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_559:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_570:
        return self.rule.variation

class Item_1069(Item):
    cv_arg: TypeAlias = NonSpare_1955.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1955

    @classmethod
    def create(cls, arg : "Item_1069.cv_arg") -> "Item_1069":
        return cls._create(arg) # type: ignore

class Variation_659(Element):
    cv_arg: TypeAlias = RuleContent_400.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_400

    @classmethod
    def create(cls, arg: "Variation_659.cv_arg") -> "Variation_659":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_400:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_400:
        return self.rule.content

class RuleVariation_648(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_659.cv_arg
    cv_variation: TypeAlias = Variation_659

    @classmethod
    def create(cls, arg : "RuleVariation_648.cv_arg") -> "RuleVariation_648":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_659:
        return self.arg # type: ignore

class NonSpare_1956(NonSpare):
    cv_arg: TypeAlias = RuleVariation_648.cv_arg
    cv_name = "TX1090"
    cv_title = "Transmitter 1090 MHz"
    cv_rule: TypeAlias = RuleVariation_648

    @classmethod
    def create(cls, arg : "NonSpare_1956.cv_arg") -> "NonSpare_1956":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_648:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_659:
        return self.rule.variation

class Item_1070(Item):
    cv_arg: TypeAlias = NonSpare_1956.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1956

    @classmethod
    def create(cls, arg : "Item_1070.cv_arg") -> "Item_1070":
        return cls._create(arg) # type: ignore

class Variation_723(Element):
    cv_arg: TypeAlias = RuleContent_211.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_211

    @classmethod
    def create(cls, arg: "Variation_723.cv_arg") -> "Variation_723":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_211:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_211:
        return self.rule.content

class RuleVariation_712(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_723.cv_arg
    cv_variation: TypeAlias = Variation_723

    @classmethod
    def create(cls, arg : "RuleVariation_712.cv_arg") -> "RuleVariation_712":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_723:
        return self.arg # type: ignore

class NonSpare_1626(NonSpare):
    cv_arg: TypeAlias = RuleVariation_712.cv_arg
    cv_name = "RSS"
    cv_title = "RS Status"
    cv_rule: TypeAlias = RuleVariation_712

    @classmethod
    def create(cls, arg : "NonSpare_1626.cv_arg") -> "NonSpare_1626":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_712:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_723:
        return self.rule.variation

class Item_838(Item):
    cv_arg: TypeAlias = NonSpare_1626.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1626

    @classmethod
    def create(cls, arg : "Item_838.cv_arg") -> "Item_838":
        return cls._create(arg) # type: ignore

class Content_409(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Offline", 1: "Online"}

class RuleContent_409(RuleContentContextFree):
    cv_arg: TypeAlias = Content_409.cv_arg
    cv_content: TypeAlias = Content_409

    @property
    def content(self) -> Content_409:
        return self._get_content() # type: ignore

class Variation_868(Element):
    cv_arg: TypeAlias = RuleContent_409.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_409

    @classmethod
    def create(cls, arg: "Variation_868.cv_arg") -> "Variation_868":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_409:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_409:
        return self.rule.content

class RuleVariation_838(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_868.cv_arg
    cv_variation: TypeAlias = Variation_868

    @classmethod
    def create(cls, arg : "RuleVariation_838.cv_arg") -> "RuleVariation_838":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_868:
        return self.arg # type: ignore

class NonSpare_1623(NonSpare):
    cv_arg: TypeAlias = RuleVariation_838.cv_arg
    cv_name = "RSO"
    cv_title = "RS Operational"
    cv_rule: TypeAlias = RuleVariation_838

    @classmethod
    def create(cls, arg : "NonSpare_1623.cv_arg") -> "NonSpare_1623":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_838:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_868:
        return self.rule.variation

class Item_837(Item):
    cv_arg: TypeAlias = NonSpare_1623.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1623

    @classmethod
    def create(cls, arg : "Item_837.cv_arg") -> "Item_837":
        return cls._create(arg) # type: ignore

class Variation_1187(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["RSI"], RuleVariation_159.cv_arg]], int, Union[RuleVariation_435.cv_arg, Tuple[Literal["RS1090"], RuleVariation_435.cv_arg]], Union[RuleVariation_559.cv_arg, Tuple[Literal["TX1030"], RuleVariation_559.cv_arg]], Union[RuleVariation_648.cv_arg, Tuple[Literal["TX1090"], RuleVariation_648.cv_arg]], Union[RuleVariation_712.cv_arg, Tuple[Literal["RSS"], RuleVariation_712.cv_arg]], Union[RuleVariation_838.cv_arg, Tuple[Literal["RSO"], RuleVariation_838.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1187.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_836, 8), (Item_0, 1), (Item_833, 1), (Item_1069, 1), (Item_1070, 1), (Item_838, 1), (Item_837, 1), (Item_27, 2)]
    cv_items_dict = {"RSI": RuleVariation_159, "RS1090": RuleVariation_435, "TX1030": RuleVariation_559, "TX1090": RuleVariation_648, "RSS": RuleVariation_712, "RSO": RuleVariation_838}

    @overload
    @classmethod
    def spec(cls, key : Literal["RSI"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RS1090"]) -> RuleVariation_435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TX1030"]) -> RuleVariation_559:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TX1090"]) -> RuleVariation_648:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSS"]) -> RuleVariation_712:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RSO"]) -> RuleVariation_838:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RSI"], Literal["RS1090"], Literal["TX1030"], Literal["TX1090"], Literal["RSS"], Literal["RSO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RSI"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["RS1090"]) -> RuleVariation_435:
        ...
    @overload
    def get_item(self, key : Literal["TX1030"]) -> RuleVariation_559:
        ...
    @overload
    def get_item(self, key : Literal["TX1090"]) -> RuleVariation_648:
        ...
    @overload
    def get_item(self, key : Literal["RSS"]) -> RuleVariation_712:
        ...
    @overload
    def get_item(self, key : Literal["RSO"]) -> RuleVariation_838:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1187.cv_arg") -> 'Variation_1187':
        return cls._create(arg) # type: ignore

class Variation_1427(Repetitive):
    cv_arg: TypeAlias = List[Variation_1187.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1187

    @classmethod
    def create(cls, arg: "Variation_1427.cv_arg") -> 'Variation_1427':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1187]:
        return self._get_list() # type: ignore

class RuleVariation_1348(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1427.cv_arg
    cv_variation: TypeAlias = Variation_1427

    @classmethod
    def create(cls, arg : "RuleVariation_1348.cv_arg") -> "RuleVariation_1348":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1427:
        return self.arg # type: ignore

class NonSpare_526(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1348.cv_arg
    cv_name = "552"
    cv_title = "Remote Sensor Detailed Status"
    cv_rule: TypeAlias = RuleVariation_1348

    @classmethod
    def create(cls, arg : "NonSpare_526.cv_arg") -> "NonSpare_526":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1348:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1427:
        return self.rule.variation

class UapItem_525(UapItem):
    cv_non_spare: TypeAlias = NonSpare_526

class Content_604(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Warning", 2: "Faulted", 3: "Good"}

class RuleContent_604(RuleContentContextFree):
    cv_arg: TypeAlias = Content_604.cv_arg
    cv_content: TypeAlias = Content_604

    @property
    def content(self) -> Content_604:
        return self._get_content() # type: ignore

class Variation_118(Element):
    cv_arg: TypeAlias = RuleContent_604.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_604

    @classmethod
    def create(cls, arg: "Variation_118.cv_arg") -> "Variation_118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_604:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_604:
        return self.rule.content

class RuleVariation_118(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_118.cv_arg
    cv_variation: TypeAlias = Variation_118

    @classmethod
    def create(cls, arg : "RuleVariation_118.cv_arg") -> "RuleVariation_118":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_118:
        return self.arg # type: ignore

class Variation_773(Element):
    cv_arg: TypeAlias = RuleContent_604.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_604

    @classmethod
    def create(cls, arg: "Variation_773.cv_arg") -> "Variation_773":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_604:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_604:
        return self.rule.content

class RuleVariation_762(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_773.cv_arg
    cv_variation: TypeAlias = Variation_773

    @classmethod
    def create(cls, arg : "RuleVariation_762.cv_arg") -> "RuleVariation_762":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_773:
        return self.arg # type: ignore

class NonSpare_1577(NonSpare):
    cv_arg: TypeAlias = RuleVariation_118.cv_arg
    cv_name = "REFTR1"
    cv_title = "Ref Trans 1 Status"
    cv_rule: TypeAlias = RuleVariation_118

    @classmethod
    def create(cls, arg : "NonSpare_1577.cv_arg") -> "NonSpare_1577":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_118:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_118:
        return self.rule.variation

class Item_802(Item):
    cv_arg: TypeAlias = NonSpare_1577.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1577

    @classmethod
    def create(cls, arg : "Item_802.cv_arg") -> "Item_802":
        return cls._create(arg) # type: ignore

class NonSpare_1578(NonSpare):
    cv_arg: TypeAlias = RuleVariation_762.cv_arg
    cv_name = "REFTR2"
    cv_title = "Ref Trans 2 Status"
    cv_rule: TypeAlias = RuleVariation_762

    @classmethod
    def create(cls, arg : "NonSpare_1578.cv_arg") -> "NonSpare_1578":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_762:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_773:
        return self.rule.variation

class Item_803(Item):
    cv_arg: TypeAlias = NonSpare_1578.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1578

    @classmethod
    def create(cls, arg : "Item_803.cv_arg") -> "Item_803":
        return cls._create(arg) # type: ignore

class NonSpare_1579(NonSpare):
    cv_arg: TypeAlias = RuleVariation_118.cv_arg
    cv_name = "REFTR3"
    cv_title = "Ref Trans 3 Status"
    cv_rule: TypeAlias = RuleVariation_118

    @classmethod
    def create(cls, arg : "NonSpare_1579.cv_arg") -> "NonSpare_1579":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_118:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_118:
        return self.rule.variation

class Item_804(Item):
    cv_arg: TypeAlias = NonSpare_1579.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1579

    @classmethod
    def create(cls, arg : "Item_804.cv_arg") -> "Item_804":
        return cls._create(arg) # type: ignore

class NonSpare_1580(NonSpare):
    cv_arg: TypeAlias = RuleVariation_762.cv_arg
    cv_name = "REFTR4"
    cv_title = "Ref Trans 4 Status"
    cv_rule: TypeAlias = RuleVariation_762

    @classmethod
    def create(cls, arg : "NonSpare_1580.cv_arg") -> "NonSpare_1580":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_762:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_773:
        return self.rule.variation

class Item_805(Item):
    cv_arg: TypeAlias = NonSpare_1580.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1580

    @classmethod
    def create(cls, arg : "Item_805.cv_arg") -> "Item_805":
        return cls._create(arg) # type: ignore

class Variation_1380(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_118.cv_arg, Tuple[Literal["REFTR1"], RuleVariation_118.cv_arg]], int, Union[RuleVariation_762.cv_arg, Tuple[Literal["REFTR2"], RuleVariation_762.cv_arg]], int, None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_118.cv_arg, Tuple[Literal["REFTR3"], RuleVariation_118.cv_arg]], int, Union[RuleVariation_762.cv_arg, Tuple[Literal["REFTR4"], RuleVariation_762.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1380.cv_arg_group_1"],
        Tuple["Variation_1380.cv_arg_group_1", "Variation_1380.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_802, 2), (Item_12, 2), (Item_803, 2), (Item_26, 1), None], [(Item_804, 2), (Item_12, 2), (Item_805, 2), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1380.cv_arg") -> 'Variation_1380':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["REFTR1"]) -> RuleVariation_118:
        ...
    @overload
    def get_item(self, key : Literal["REFTR2"]) -> RuleVariation_762:
        ...
    @overload
    def get_item(self, key : Literal["REFTR3"]) -> Optional[RuleVariation_118]:
        ...
    @overload
    def get_item(self, key : Literal["REFTR4"]) -> Optional[RuleVariation_762]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1301(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1380.cv_arg
    cv_variation: TypeAlias = Variation_1380

    @classmethod
    def create(cls, arg : "RuleVariation_1301.cv_arg") -> "RuleVariation_1301":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1380:
        return self.arg # type: ignore

class NonSpare_527(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1301.cv_arg
    cv_name = "553"
    cv_title = "Reference Transponder Detailed Status"
    cv_rule: TypeAlias = RuleVariation_1301

    @classmethod
    def create(cls, arg : "NonSpare_527.cv_arg") -> "NonSpare_527":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1301:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1380:
        return self.rule.variation

class UapItem_526(UapItem):
    cv_non_spare: TypeAlias = NonSpare_527

class Content_701(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.6763806343078613e-7
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_701(RuleContentContextFree):
    cv_arg: TypeAlias = Content_701.cv_arg
    cv_content: TypeAlias = Content_701

    @property
    def content(self) -> Content_701:
        return self._get_content() # type: ignore

class Variation_380(Element):
    cv_arg: TypeAlias = RuleContent_701.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_701

    @classmethod
    def create(cls, arg: "Variation_380.cv_arg") -> "Variation_380":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_701:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_701:
        return self.rule.content

class RuleVariation_373(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_380.cv_arg
    cv_variation: TypeAlias = Variation_380

    @classmethod
    def create(cls, arg : "RuleVariation_373.cv_arg") -> "RuleVariation_373":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_380:
        return self.arg # type: ignore

class NonSpare_1153(NonSpare):
    cv_arg: TypeAlias = RuleVariation_373.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule: TypeAlias = RuleVariation_373

    @classmethod
    def create(cls, arg : "NonSpare_1153.cv_arg") -> "NonSpare_1153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_373:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_380:
        return self.rule.variation

class Item_465(Item):
    cv_arg: TypeAlias = NonSpare_1153.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1153

    @classmethod
    def create(cls, arg : "Item_465.cv_arg") -> "Item_465":
        return cls._create(arg) # type: ignore

class Content_700(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.6763806343078613e-7
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_700(RuleContentContextFree):
    cv_arg: TypeAlias = Content_700.cv_arg
    cv_content: TypeAlias = Content_700

    @property
    def content(self) -> Content_700:
        return self._get_content() # type: ignore

class Variation_379(Element):
    cv_arg: TypeAlias = RuleContent_700.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_700

    @classmethod
    def create(cls, arg: "Variation_379.cv_arg") -> "Variation_379":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_700:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_700:
        return self.rule.content

class RuleVariation_372(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_379.cv_arg
    cv_variation: TypeAlias = Variation_379

    @classmethod
    def create(cls, arg : "RuleVariation_372.cv_arg") -> "RuleVariation_372":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_379:
        return self.arg # type: ignore

class NonSpare_1183(NonSpare):
    cv_arg: TypeAlias = RuleVariation_372.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_372

    @classmethod
    def create(cls, arg : "NonSpare_1183.cv_arg") -> "NonSpare_1183":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_372:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_379:
        return self.rule.variation

class Item_493(Item):
    cv_arg: TypeAlias = NonSpare_1183.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1183

    @classmethod
    def create(cls, arg : "Item_493.cv_arg") -> "Item_493":
        return cls._create(arg) # type: ignore

class Variation_1129(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_373.cv_arg, Tuple[Literal["LAT"], RuleVariation_373.cv_arg]], Union[RuleVariation_372.cv_arg, Tuple[Literal["LON"], RuleVariation_372.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1129.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_465, 32), (Item_493, 32)]
    cv_items_dict = {"LAT": RuleVariation_373, "LON": RuleVariation_372}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_372:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_373:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_372:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1129.cv_arg") -> 'Variation_1129':
        return cls._create(arg) # type: ignore

class RuleVariation_1085(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1129.cv_arg
    cv_variation: TypeAlias = Variation_1129

    @classmethod
    def create(cls, arg : "RuleVariation_1085.cv_arg") -> "RuleVariation_1085":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1129:
        return self.arg # type: ignore

class NonSpare_530(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1085.cv_arg
    cv_name = "600"
    cv_title = "Position of the MLT System Reference Point"
    cv_rule: TypeAlias = RuleVariation_1085

    @classmethod
    def create(cls, arg : "NonSpare_530.cv_arg") -> "NonSpare_530":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1085:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1129:
        return self.rule.variation

class UapItem_529(UapItem):
    cv_non_spare: TypeAlias = NonSpare_530

class Content_660(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_660(RuleContentContextFree):
    cv_arg: TypeAlias = Content_660.cv_arg
    cv_content: TypeAlias = Content_660

    @property
    def content(self) -> Content_660:
        return self._get_content() # type: ignore

class Variation_277(Element):
    cv_arg: TypeAlias = RuleContent_660.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_660

    @classmethod
    def create(cls, arg: "Variation_277.cv_arg") -> "Variation_277":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_660:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_660:
        return self.rule.content

class RuleVariation_270(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_277.cv_arg
    cv_variation: TypeAlias = Variation_277

    @classmethod
    def create(cls, arg : "RuleVariation_270.cv_arg") -> "RuleVariation_270":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_277:
        return self.arg # type: ignore

class NonSpare_538(NonSpare):
    cv_arg: TypeAlias = RuleVariation_270.cv_arg
    cv_name = "610"
    cv_title = "Height of the MLT System Reference Point"
    cv_rule: TypeAlias = RuleVariation_270

    @classmethod
    def create(cls, arg : "NonSpare_538.cv_arg") -> "NonSpare_538":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_277:
        return self.rule.variation

class UapItem_537(UapItem):
    cv_non_spare: TypeAlias = NonSpare_538

class Content_626(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_626(RuleContentContextFree):
    cv_arg: TypeAlias = Content_626.cv_arg
    cv_content: TypeAlias = Content_626

    @property
    def content(self) -> Content_626:
        return self._get_content() # type: ignore

class Variation_209(Element):
    cv_arg: TypeAlias = RuleContent_626.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_626

    @classmethod
    def create(cls, arg: "Variation_209.cv_arg") -> "Variation_209":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_626:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_626:
        return self.rule.content

class RuleVariation_202(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_209.cv_arg
    cv_variation: TypeAlias = Variation_209

    @classmethod
    def create(cls, arg : "RuleVariation_202.cv_arg") -> "RuleVariation_202":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_209:
        return self.arg # type: ignore

class NonSpare_541(NonSpare):
    cv_arg: TypeAlias = RuleVariation_202.cv_arg
    cv_name = "620"
    cv_title = "WGS-84 Undulation"
    cv_rule: TypeAlias = RuleVariation_202

    @classmethod
    def create(cls, arg : "NonSpare_541.cv_arg") -> "NonSpare_541":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_202:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_209:
        return self.rule.variation

class UapItem_540(UapItem):
    cv_non_spare: TypeAlias = NonSpare_541

class Record_40(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_45.cv_arg,
        "000": NonSpare_10.cv_arg,
        "140": NonSpare_329.cv_arg,
        "550": NonSpare_524.cv_arg,
        "551": NonSpare_525.cv_arg,
        "552": NonSpare_526.cv_arg,
        "553": NonSpare_527.cv_arg,
        "600": NonSpare_530.cv_arg,
        "610": NonSpare_538.cv_arg,
        "620": NonSpare_541.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_45, UapItem_10, UapItem_329, UapItem_523, UapItem_524, UapItem_525, UapItem_526, UapItem_529, UapItem_537, UapItem_540, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_45, "000": NonSpare_10, "140": NonSpare_329, "550": NonSpare_524, "551": NonSpare_525, "552": NonSpare_526, "553": NonSpare_527, "600": NonSpare_530, "610": NonSpare_538, "620": NonSpare_541, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_10:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_329:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_524:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["551"]) -> NonSpare_525:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["552"]) -> NonSpare_526:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["553"]) -> NonSpare_527:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_530:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["620"]) -> NonSpare_541:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["140"], Literal["550"], Literal["551"], Literal["552"], Literal["553"], Literal["600"], Literal["610"], Literal["620"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_45]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_10]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_329]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_524]:
        ...
    @overload
    def get_item(self, key : Literal["551"]) -> Optional[NonSpare_525]:
        ...
    @overload
    def get_item(self, key : Literal["552"]) -> Optional[NonSpare_526]:
        ...
    @overload
    def get_item(self, key : Literal["553"]) -> Optional[NonSpare_527]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_530]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_538]:
        ...
    @overload
    def get_item(self, key : Literal["620"]) -> Optional[NonSpare_541]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_45.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_10.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_329.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_524.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["551"], val : NonSpare_525.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["552"], val : NonSpare_526.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["553"], val : NonSpare_527.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_530.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_538.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["620"], val : NonSpare_541.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_40':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_40':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["551"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["552"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["553"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["620"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_40':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_40':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_40.cv_arg") -> 'Record_40':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_40", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_36(UapSingle):
    cv_arg: TypeAlias = Record_40
    cv_record: TypeAlias = Record_40

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_40]]:
        return cls._parse(bs)

class Asterix_21(AstCat):
    cv_category = 19
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_36
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_36.cv_arg]) -> "Asterix_21":
        return cls._create(records) # type: ignore

class NonSpare_42(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_42.cv_arg") -> "NonSpare_42":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_42(UapItem):
    cv_non_spare: TypeAlias = NonSpare_42

class Content_381(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Non-Mode S 1090MHz multilateration", 1: "No Non-Mode S 1090MHz multilat"}

class RuleContent_381(RuleContentContextFree):
    cv_arg: TypeAlias = Content_381.cv_arg
    cv_content: TypeAlias = Content_381

    @property
    def content(self) -> Content_381:
        return self._get_content() # type: ignore

class Variation_66(Element):
    cv_arg: TypeAlias = RuleContent_381.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_381

    @classmethod
    def create(cls, arg: "Variation_66.cv_arg") -> "Variation_66":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_381:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_381:
        return self.rule.content

class RuleVariation_66(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_66.cv_arg
    cv_variation: TypeAlias = Variation_66

    @classmethod
    def create(cls, arg : "RuleVariation_66.cv_arg") -> "RuleVariation_66":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_66:
        return self.arg # type: ignore

class Content_294(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-S 1090 MHz multilateration", 1: "No Mode-S 1090 MHz multilateration"}

class RuleContent_294(RuleContentContextFree):
    cv_arg: TypeAlias = Content_294.cv_arg
    cv_content: TypeAlias = Content_294

    @property
    def content(self) -> Content_294:
        return self._get_content() # type: ignore

class Variation_438(Element):
    cv_arg: TypeAlias = RuleContent_294.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_294

    @classmethod
    def create(cls, arg: "Variation_438.cv_arg") -> "Variation_438":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_294:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_294:
        return self.rule.content

class RuleVariation_427(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_438.cv_arg
    cv_variation: TypeAlias = Variation_438

    @classmethod
    def create(cls, arg : "RuleVariation_427.cv_arg") -> "RuleVariation_427":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_438:
        return self.arg # type: ignore

class Content_222(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "HF multilateration", 1: "No HF multilateration"}

class RuleContent_222(RuleContentContextFree):
    cv_arg: TypeAlias = Content_222.cv_arg
    cv_content: TypeAlias = Content_222

    @property
    def content(self) -> Content_222:
        return self._get_content() # type: ignore

class Variation_535(Element):
    cv_arg: TypeAlias = RuleContent_222.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_222

    @classmethod
    def create(cls, arg: "Variation_535.cv_arg") -> "Variation_535":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_222:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_222:
        return self.rule.content

class RuleVariation_524(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_535.cv_arg
    cv_variation: TypeAlias = Variation_535

    @classmethod
    def create(cls, arg : "RuleVariation_524.cv_arg") -> "RuleVariation_524":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_535:
        return self.arg # type: ignore

class Content_556(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "VDL Mode 4 multilateration", 1: "No VDL Mode 4 multilateration"}

class RuleContent_556(RuleContentContextFree):
    cv_arg: TypeAlias = Content_556.cv_arg
    cv_content: TypeAlias = Content_556

    @property
    def content(self) -> Content_556:
        return self._get_content() # type: ignore

class Variation_672(Element):
    cv_arg: TypeAlias = RuleContent_556.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_556

    @classmethod
    def create(cls, arg: "Variation_672.cv_arg") -> "Variation_672":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_556:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_556:
        return self.rule.content

class RuleVariation_661(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_672.cv_arg
    cv_variation: TypeAlias = Variation_672

    @classmethod
    def create(cls, arg : "RuleVariation_661.cv_arg") -> "RuleVariation_661":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_672:
        return self.arg # type: ignore

class Content_529(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "UAT multilateration", 1: "No UAT multilateration"}

class RuleContent_529(RuleContentContextFree):
    cv_arg: TypeAlias = Content_529.cv_arg
    cv_content: TypeAlias = Content_529

    @property
    def content(self) -> Content_529:
        return self._get_content() # type: ignore

class Variation_759(Element):
    cv_arg: TypeAlias = RuleContent_529.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_529

    @classmethod
    def create(cls, arg: "Variation_759.cv_arg") -> "Variation_759":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_529:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_529:
        return self.rule.content

class RuleVariation_748(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_759.cv_arg
    cv_variation: TypeAlias = Variation_759

    @classmethod
    def create(cls, arg : "RuleVariation_748.cv_arg") -> "RuleVariation_748":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_759:
        return self.arg # type: ignore

class Content_72(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "DME/TACAN multilateration", 1: "No DME/TACAN multilateration"}

class RuleContent_72(RuleContentContextFree):
    cv_arg: TypeAlias = Content_72.cv_arg
    cv_content: TypeAlias = Content_72

    @property
    def content(self) -> Content_72:
        return self._get_content() # type: ignore

class Variation_827(Element):
    cv_arg: TypeAlias = RuleContent_72.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_72

    @classmethod
    def create(cls, arg: "Variation_827.cv_arg") -> "Variation_827":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_72:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_72:
        return self.rule.content

class RuleVariation_797(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_827.cv_arg
    cv_variation: TypeAlias = Variation_827

    @classmethod
    def create(cls, arg : "RuleVariation_797.cv_arg") -> "RuleVariation_797":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_827:
        return self.arg # type: ignore

class Content_416(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Other Technology Multilateration", 1: "No Other Technology Multilateration"}

class RuleContent_416(RuleContentContextFree):
    cv_arg: TypeAlias = Content_416.cv_arg
    cv_content: TypeAlias = Content_416

    @property
    def content(self) -> Content_416:
        return self._get_content() # type: ignore

class Variation_944(Element):
    cv_arg: TypeAlias = RuleContent_416.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_416

    @classmethod
    def create(cls, arg: "Variation_944.cv_arg") -> "Variation_944":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_416:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_416:
        return self.rule.content

class RuleVariation_914(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_944.cv_arg
    cv_variation: TypeAlias = Variation_944

    @classmethod
    def create(cls, arg : "RuleVariation_914.cv_arg") -> "RuleVariation_914":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_944:
        return self.arg # type: ignore

class Content_441(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Report from target transponder", 1: "Report from field monitor (element transponder)"}

class RuleContent_441(RuleContentContextFree):
    cv_arg: TypeAlias = Content_441.cv_arg
    cv_content: TypeAlias = Content_441

    @property
    def content(self) -> Content_441:
        return self._get_content() # type: ignore

class Variation_74(Element):
    cv_arg: TypeAlias = RuleContent_441.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_441

    @classmethod
    def create(cls, arg: "Variation_74.cv_arg") -> "Variation_74":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_441:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_441:
        return self.rule.content

class RuleVariation_74(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_74.cv_arg
    cv_variation: TypeAlias = Variation_74

    @classmethod
    def create(cls, arg : "RuleVariation_74.cv_arg") -> "RuleVariation_74":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_74:
        return self.arg # type: ignore

class Variation_402(Element):
    cv_arg: TypeAlias = RuleContent_13.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg: "Variation_402.cv_arg") -> "Variation_402":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_13:
        return self.rule.content

class RuleVariation_391(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_402.cv_arg
    cv_variation: TypeAlias = Variation_402

    @classmethod
    def create(cls, arg : "RuleVariation_391.cv_arg") -> "RuleVariation_391":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_402:
        return self.arg # type: ignore

class Variation_512(Element):
    cv_arg: TypeAlias = RuleContent_53.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_53

    @classmethod
    def create(cls, arg: "Variation_512.cv_arg") -> "Variation_512":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_53:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_53:
        return self.rule.content

class RuleVariation_501(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_512.cv_arg
    cv_variation: TypeAlias = Variation_512

    @classmethod
    def create(cls, arg : "RuleVariation_501.cv_arg") -> "RuleVariation_501":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_512:
        return self.arg # type: ignore

class Variation_668(Element):
    cv_arg: TypeAlias = RuleContent_521.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_521

    @classmethod
    def create(cls, arg: "Variation_668.cv_arg") -> "Variation_668":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_521:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_521:
        return self.rule.content

class RuleVariation_657(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_668.cv_arg
    cv_variation: TypeAlias = Variation_668

    @classmethod
    def create(cls, arg : "RuleVariation_657.cv_arg") -> "RuleVariation_657":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_668:
        return self.arg # type: ignore

class Variation_737(Element):
    cv_arg: TypeAlias = RuleContent_306.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_306

    @classmethod
    def create(cls, arg: "Variation_737.cv_arg") -> "Variation_737":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_306:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_306:
        return self.rule.content

class RuleVariation_726(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_737.cv_arg
    cv_variation: TypeAlias = Variation_737

    @classmethod
    def create(cls, arg : "RuleVariation_726.cv_arg") -> "RuleVariation_726":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_737:
        return self.arg # type: ignore

class Variation_820(Element):
    cv_arg: TypeAlias = RuleContent_19.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg: "Variation_820.cv_arg") -> "Variation_820":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_19:
        return self.rule.content

class RuleVariation_790(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_820.cv_arg
    cv_variation: TypeAlias = Variation_820

    @classmethod
    def create(cls, arg : "RuleVariation_790.cv_arg") -> "RuleVariation_790":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_820:
        return self.arg # type: ignore

class Variation_920(Element):
    cv_arg: TypeAlias = RuleContent_155.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_155

    @classmethod
    def create(cls, arg: "Variation_920.cv_arg") -> "Variation_920":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_155:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_155:
        return self.rule.content

class RuleVariation_890(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_920.cv_arg
    cv_variation: TypeAlias = Variation_920

    @classmethod
    def create(cls, arg : "RuleVariation_890.cv_arg") -> "RuleVariation_890":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_920:
        return self.arg # type: ignore

class NonSpare_1757(NonSpare):
    cv_arg: TypeAlias = RuleVariation_66.cv_arg
    cv_name = "SSR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_66

    @classmethod
    def create(cls, arg : "NonSpare_1757.cv_arg") -> "NonSpare_1757":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_66:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_66:
        return self.rule.variation

class Item_927(Item):
    cv_arg: TypeAlias = NonSpare_1757.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1757

    @classmethod
    def create(cls, arg : "Item_927.cv_arg") -> "Item_927":
        return cls._create(arg) # type: ignore

class NonSpare_1320(NonSpare):
    cv_arg: TypeAlias = RuleVariation_427.cv_arg
    cv_name = "MS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_427

    @classmethod
    def create(cls, arg : "NonSpare_1320.cv_arg") -> "NonSpare_1320":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_427:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_438:
        return self.rule.variation

class Item_586(Item):
    cv_arg: TypeAlias = NonSpare_1320.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1320

    @classmethod
    def create(cls, arg : "Item_586.cv_arg") -> "Item_586":
        return cls._create(arg) # type: ignore

class NonSpare_1065(NonSpare):
    cv_arg: TypeAlias = RuleVariation_524.cv_arg
    cv_name = "HF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_524

    @classmethod
    def create(cls, arg : "NonSpare_1065.cv_arg") -> "NonSpare_1065":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_524:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_535:
        return self.rule.variation

class Item_391(Item):
    cv_arg: TypeAlias = NonSpare_1065.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1065

    @classmethod
    def create(cls, arg : "Item_391.cv_arg") -> "Item_391":
        return cls._create(arg) # type: ignore

class NonSpare_2032(NonSpare):
    cv_arg: TypeAlias = RuleVariation_661.cv_arg
    cv_name = "VDL4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_661

    @classmethod
    def create(cls, arg : "NonSpare_2032.cv_arg") -> "NonSpare_2032":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_661:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_672:
        return self.rule.variation

class Item_1141(Item):
    cv_arg: TypeAlias = NonSpare_2032.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2032

    @classmethod
    def create(cls, arg : "Item_1141.cv_arg") -> "Item_1141":
        return cls._create(arg) # type: ignore

class NonSpare_1977(NonSpare):
    cv_arg: TypeAlias = RuleVariation_748.cv_arg
    cv_name = "UAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_748

    @classmethod
    def create(cls, arg : "NonSpare_1977.cv_arg") -> "NonSpare_1977":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_748:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_759:
        return self.rule.variation

class Item_1090(Item):
    cv_arg: TypeAlias = NonSpare_1977.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1977

    @classmethod
    def create(cls, arg : "Item_1090.cv_arg") -> "Item_1090":
        return cls._create(arg) # type: ignore

class NonSpare_890(NonSpare):
    cv_arg: TypeAlias = RuleVariation_797.cv_arg
    cv_name = "DME"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_797

    @classmethod
    def create(cls, arg : "NonSpare_890.cv_arg") -> "NonSpare_890":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_797:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_827:
        return self.rule.variation

class Item_266(Item):
    cv_arg: TypeAlias = NonSpare_890.cv_arg
    cv_non_spare: TypeAlias = NonSpare_890

    @classmethod
    def create(cls, arg : "Item_266.cv_arg") -> "Item_266":
        return cls._create(arg) # type: ignore

class NonSpare_1406(NonSpare):
    cv_arg: TypeAlias = RuleVariation_914.cv_arg
    cv_name = "OT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_914

    @classmethod
    def create(cls, arg : "NonSpare_1406.cv_arg") -> "NonSpare_1406":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_914:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_944:
        return self.rule.variation

class Item_664(Item):
    cv_arg: TypeAlias = NonSpare_1406.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1406

    @classmethod
    def create(cls, arg : "Item_664.cv_arg") -> "Item_664":
        return cls._create(arg) # type: ignore

class NonSpare_1536(NonSpare):
    cv_arg: TypeAlias = RuleVariation_74.cv_arg
    cv_name = "RAB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_74

    @classmethod
    def create(cls, arg : "NonSpare_1536.cv_arg") -> "NonSpare_1536":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_74:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_74:
        return self.rule.variation

class Item_766(Item):
    cv_arg: TypeAlias = NonSpare_1536.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1536

    @classmethod
    def create(cls, arg : "Item_766.cv_arg") -> "Item_766":
        return cls._create(arg) # type: ignore

class NonSpare_1737(NonSpare):
    cv_arg: TypeAlias = RuleVariation_391.cv_arg
    cv_name = "SPI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_391

    @classmethod
    def create(cls, arg : "NonSpare_1737.cv_arg") -> "NonSpare_1737":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_391:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_402:
        return self.rule.variation

class Item_910(Item):
    cv_arg: TypeAlias = NonSpare_1737.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1737

    @classmethod
    def create(cls, arg : "Item_910.cv_arg") -> "Item_910":
        return cls._create(arg) # type: ignore

class NonSpare_734(NonSpare):
    cv_arg: TypeAlias = RuleVariation_501.cv_arg
    cv_name = "CHN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_501

    @classmethod
    def create(cls, arg : "NonSpare_734.cv_arg") -> "NonSpare_734":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_501:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_512:
        return self.rule.variation

class Item_156(Item):
    cv_arg: TypeAlias = NonSpare_734.cv_arg
    cv_non_spare: TypeAlias = NonSpare_734

    @classmethod
    def create(cls, arg : "Item_156.cv_arg") -> "Item_156":
        return cls._create(arg) # type: ignore

class NonSpare_1028(NonSpare):
    cv_arg: TypeAlias = RuleVariation_657.cv_arg
    cv_name = "GBS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_657

    @classmethod
    def create(cls, arg : "NonSpare_1028.cv_arg") -> "NonSpare_1028":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_657:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_668:
        return self.rule.variation

class Item_366(Item):
    cv_arg: TypeAlias = NonSpare_1028.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1028

    @classmethod
    def create(cls, arg : "Item_366.cv_arg") -> "Item_366":
        return cls._create(arg) # type: ignore

class NonSpare_830(NonSpare):
    cv_arg: TypeAlias = RuleVariation_726.cv_arg
    cv_name = "CRT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_726

    @classmethod
    def create(cls, arg : "NonSpare_830.cv_arg") -> "NonSpare_830":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_726:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_737:
        return self.rule.variation

class Item_216(Item):
    cv_arg: TypeAlias = NonSpare_830.cv_arg
    cv_non_spare: TypeAlias = NonSpare_830

    @classmethod
    def create(cls, arg : "Item_216.cv_arg") -> "Item_216":
        return cls._create(arg) # type: ignore

class NonSpare_1727(NonSpare):
    cv_arg: TypeAlias = RuleVariation_790.cv_arg
    cv_name = "SIM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_790

    @classmethod
    def create(cls, arg : "NonSpare_1727.cv_arg") -> "NonSpare_1727":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_790:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_820:
        return self.rule.variation

class Item_902(Item):
    cv_arg: TypeAlias = NonSpare_1727.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1727

    @classmethod
    def create(cls, arg : "Item_902.cv_arg") -> "Item_902":
        return cls._create(arg) # type: ignore

class NonSpare_1938(NonSpare):
    cv_arg: TypeAlias = RuleVariation_890.cv_arg
    cv_name = "TST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_890

    @classmethod
    def create(cls, arg : "NonSpare_1938.cv_arg") -> "NonSpare_1938":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_890:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_920:
        return self.rule.variation

class Item_1055(Item):
    cv_arg: TypeAlias = NonSpare_1938.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1938

    @classmethod
    def create(cls, arg : "Item_1055.cv_arg") -> "Item_1055":
        return cls._create(arg) # type: ignore

class Variation_1384(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_66.cv_arg, Tuple[Literal["SSR"], RuleVariation_66.cv_arg]], Union[RuleVariation_427.cv_arg, Tuple[Literal["MS"], RuleVariation_427.cv_arg]], Union[RuleVariation_524.cv_arg, Tuple[Literal["HF"], RuleVariation_524.cv_arg]], Union[RuleVariation_661.cv_arg, Tuple[Literal["VDL4"], RuleVariation_661.cv_arg]], Union[RuleVariation_748.cv_arg, Tuple[Literal["UAT"], RuleVariation_748.cv_arg]], Union[RuleVariation_797.cv_arg, Tuple[Literal["DME"], RuleVariation_797.cv_arg]], Union[RuleVariation_914.cv_arg, Tuple[Literal["OT"], RuleVariation_914.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_74.cv_arg, Tuple[Literal["RAB"], RuleVariation_74.cv_arg]], Union[RuleVariation_391.cv_arg, Tuple[Literal["SPI"], RuleVariation_391.cv_arg]], Union[RuleVariation_501.cv_arg, Tuple[Literal["CHN"], RuleVariation_501.cv_arg]], Union[RuleVariation_657.cv_arg, Tuple[Literal["GBS"], RuleVariation_657.cv_arg]], Union[RuleVariation_726.cv_arg, Tuple[Literal["CRT"], RuleVariation_726.cv_arg]], Union[RuleVariation_790.cv_arg, Tuple[Literal["SIM"], RuleVariation_790.cv_arg]], Union[RuleVariation_890.cv_arg, Tuple[Literal["TST"], RuleVariation_890.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1384.cv_arg_group_1"],
        Tuple["Variation_1384.cv_arg_group_1", "Variation_1384.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_927, 1), (Item_586, 1), (Item_391, 1), (Item_1141, 1), (Item_1090, 1), (Item_266, 1), (Item_664, 1), None], [(Item_766, 1), (Item_910, 1), (Item_156, 1), (Item_366, 1), (Item_216, 1), (Item_902, 1), (Item_1055, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1384.cv_arg") -> 'Variation_1384':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["SSR"]) -> RuleVariation_66:
        ...
    @overload
    def get_item(self, key : Literal["MS"]) -> RuleVariation_427:
        ...
    @overload
    def get_item(self, key : Literal["HF"]) -> RuleVariation_524:
        ...
    @overload
    def get_item(self, key : Literal["VDL4"]) -> RuleVariation_661:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_748:
        ...
    @overload
    def get_item(self, key : Literal["DME"]) -> RuleVariation_797:
        ...
    @overload
    def get_item(self, key : Literal["OT"]) -> RuleVariation_914:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> Optional[RuleVariation_74]:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> Optional[RuleVariation_391]:
        ...
    @overload
    def get_item(self, key : Literal["CHN"]) -> Optional[RuleVariation_501]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_657]:
        ...
    @overload
    def get_item(self, key : Literal["CRT"]) -> Optional[RuleVariation_726]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_790]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_890]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1305(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1384.cv_arg
    cv_variation: TypeAlias = Variation_1384

    @classmethod
    def create(cls, arg : "RuleVariation_1305.cv_arg") -> "RuleVariation_1305":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1384:
        return self.arg # type: ignore

class NonSpare_86(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1305.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1305

    @classmethod
    def create(cls, arg : "NonSpare_86.cv_arg") -> "NonSpare_86":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1305:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1384:
        return self.rule.variation

class UapItem_86(UapItem):
    cv_non_spare: TypeAlias = NonSpare_86

class NonSpare_328(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_328.cv_arg") -> "NonSpare_328":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_328(UapItem):
    cv_non_spare: TypeAlias = NonSpare_328

class NonSpare_1152(NonSpare):
    cv_arg: TypeAlias = RuleVariation_371.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule: TypeAlias = RuleVariation_371

    @classmethod
    def create(cls, arg : "NonSpare_1152.cv_arg") -> "NonSpare_1152":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_371:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_378:
        return self.rule.variation

class Item_464(Item):
    cv_arg: TypeAlias = NonSpare_1152.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1152

    @classmethod
    def create(cls, arg : "Item_464.cv_arg") -> "Item_464":
        return cls._create(arg) # type: ignore

class NonSpare_1182(NonSpare):
    cv_arg: TypeAlias = RuleVariation_370.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_370

    @classmethod
    def create(cls, arg : "NonSpare_1182.cv_arg") -> "NonSpare_1182":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_370:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_377:
        return self.rule.variation

class Item_492(Item):
    cv_arg: TypeAlias = NonSpare_1182.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1182

    @classmethod
    def create(cls, arg : "Item_492.cv_arg") -> "Item_492":
        return cls._create(arg) # type: ignore

class Variation_1128(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_371.cv_arg, Tuple[Literal["LAT"], RuleVariation_371.cv_arg]], Union[RuleVariation_370.cv_arg, Tuple[Literal["LON"], RuleVariation_370.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1128.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_464, 32), (Item_492, 32)]
    cv_items_dict = {"LAT": RuleVariation_371, "LON": RuleVariation_370}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_370:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_370:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1128.cv_arg") -> 'Variation_1128':
        return cls._create(arg) # type: ignore

class RuleVariation_1084(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1128.cv_arg
    cv_variation: TypeAlias = Variation_1128

    @classmethod
    def create(cls, arg : "RuleVariation_1084.cv_arg") -> "RuleVariation_1084":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1128:
        return self.arg # type: ignore

class NonSpare_154(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1084.cv_arg
    cv_name = "041"
    cv_title = "Position In WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1084

    @classmethod
    def create(cls, arg : "NonSpare_154.cv_arg") -> "NonSpare_154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1084:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1128:
        return self.rule.variation

class UapItem_154(UapItem):
    cv_non_spare: TypeAlias = NonSpare_154

class Content_640(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.5
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_640(RuleContentContextFree):
    cv_arg: TypeAlias = Content_640.cv_arg
    cv_content: TypeAlias = Content_640

    @property
    def content(self) -> Content_640:
        return self._get_content() # type: ignore

class Variation_353(Element):
    cv_arg: TypeAlias = RuleContent_640.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_640

    @classmethod
    def create(cls, arg: "Variation_353.cv_arg") -> "Variation_353":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_640:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_640:
        return self.rule.content

class RuleVariation_346(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_353.cv_arg
    cv_variation: TypeAlias = Variation_353

    @classmethod
    def create(cls, arg : "RuleVariation_346.cv_arg") -> "RuleVariation_346":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_353:
        return self.arg # type: ignore

class NonSpare_2102(NonSpare):
    cv_arg: TypeAlias = RuleVariation_346.cv_arg
    cv_name = "X"
    cv_title = "X-coordinate"
    cv_rule: TypeAlias = RuleVariation_346

    @classmethod
    def create(cls, arg : "NonSpare_2102.cv_arg") -> "NonSpare_2102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_346:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_353:
        return self.rule.variation

class Item_1203(Item):
    cv_arg: TypeAlias = NonSpare_2102.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2102

    @classmethod
    def create(cls, arg : "Item_1203.cv_arg") -> "Item_1203":
        return cls._create(arg) # type: ignore

class NonSpare_2156(NonSpare):
    cv_arg: TypeAlias = RuleVariation_346.cv_arg
    cv_name = "Y"
    cv_title = "Y-coordinate"
    cv_rule: TypeAlias = RuleVariation_346

    @classmethod
    def create(cls, arg : "NonSpare_2156.cv_arg") -> "NonSpare_2156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_346:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_353:
        return self.rule.variation

class Item_1254(Item):
    cv_arg: TypeAlias = NonSpare_2156.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2156

    @classmethod
    def create(cls, arg : "Item_1254.cv_arg") -> "Item_1254":
        return cls._create(arg) # type: ignore

class Variation_1317(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_346.cv_arg, Tuple[Literal["X"], RuleVariation_346.cv_arg]], Union[RuleVariation_346.cv_arg, Tuple[Literal["Y"], RuleVariation_346.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1317.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1203, 24), (Item_1254, 24)]
    cv_items_dict = {"X": RuleVariation_346, "Y": RuleVariation_346}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_346:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_346:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_346:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1317.cv_arg") -> 'Variation_1317':
        return cls._create(arg) # type: ignore

class RuleVariation_1243(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1317.cv_arg
    cv_variation: TypeAlias = Variation_1317

    @classmethod
    def create(cls, arg : "RuleVariation_1243.cv_arg") -> "RuleVariation_1243":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1317:
        return self.arg # type: ignore

class NonSpare_162(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1243.cv_arg
    cv_name = "042"
    cv_title = "Position in Cartesian Coordinates"
    cv_rule: TypeAlias = RuleVariation_1243

    @classmethod
    def create(cls, arg : "NonSpare_162.cv_arg") -> "NonSpare_162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1243:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1317:
        return self.rule.variation

class UapItem_162(UapItem):
    cv_non_spare: TypeAlias = NonSpare_162

class NonSpare_1921(NonSpare):
    cv_arg: TypeAlias = RuleVariation_778.cv_arg
    cv_name = "TRN"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_778

    @classmethod
    def create(cls, arg : "NonSpare_1921.cv_arg") -> "NonSpare_1921":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

class Item_1040(Item):
    cv_arg: TypeAlias = NonSpare_1921.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1921

    @classmethod
    def create(cls, arg : "Item_1040.cv_arg") -> "Item_1040":
        return cls._create(arg) # type: ignore

class Variation_1035(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_778.cv_arg, Tuple[Literal["TRN"], RuleVariation_778.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1035.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_1040, 12)]
    cv_items_dict = {"TRN": RuleVariation_778}

    @classmethod
    def spec(cls, key : Literal["TRN"]) -> RuleVariation_778:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TRN"]) -> RuleVariation_778:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1035.cv_arg") -> 'Variation_1035':
        return cls._create(arg) # type: ignore

class RuleVariation_1003(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1035.cv_arg
    cv_variation: TypeAlias = Variation_1035

    @classmethod
    def create(cls, arg : "RuleVariation_1003.cv_arg") -> "RuleVariation_1003":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1035:
        return self.arg # type: ignore

class NonSpare_363(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1003.cv_arg
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_1003

    @classmethod
    def create(cls, arg : "NonSpare_363.cv_arg") -> "NonSpare_363":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1003:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1035:
        return self.rule.variation

class UapItem_363(UapItem):
    cv_non_spare: TypeAlias = NonSpare_363

class Content_64(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Confirmed track", 1: "Track in initiation phase"}

class RuleContent_64(RuleContentContextFree):
    cv_arg: TypeAlias = Content_64.cv_arg
    cv_content: TypeAlias = Content_64

    @property
    def content(self) -> Content_64:
        return self._get_content() # type: ignore

class Variation_19(Element):
    cv_arg: TypeAlias = RuleContent_64.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_64

    @classmethod
    def create(cls, arg: "Variation_19.cv_arg") -> "Variation_19":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_64:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_64:
        return self.rule.content

class RuleVariation_19(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_19.cv_arg
    cv_variation: TypeAlias = Variation_19

    @classmethod
    def create(cls, arg : "RuleVariation_19.cv_arg") -> "RuleVariation_19":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_19:
        return self.arg # type: ignore

class Variation_569(Element):
    cv_arg: TypeAlias = RuleContent_398.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_398

    @classmethod
    def create(cls, arg: "Variation_569.cv_arg") -> "Variation_569":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_398:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_398:
        return self.rule.content

class RuleVariation_558(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_569.cv_arg
    cv_variation: TypeAlias = Variation_569

    @classmethod
    def create(cls, arg : "RuleVariation_558.cv_arg") -> "RuleVariation_558":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_569:
        return self.arg # type: ignore

class Variation_678(Element):
    cv_arg: TypeAlias = RuleContent_263.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_263

    @classmethod
    def create(cls, arg: "Variation_678.cv_arg") -> "Variation_678":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_263:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_263:
        return self.rule.content

class RuleVariation_667(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_678.cv_arg
    cv_variation: TypeAlias = Variation_678

    @classmethod
    def create(cls, arg : "RuleVariation_667.cv_arg") -> "RuleVariation_667":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_678:
        return self.arg # type: ignore

class Variation_831(Element):
    cv_arg: TypeAlias = RuleContent_105.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_105

    @classmethod
    def create(cls, arg: "Variation_831.cv_arg") -> "Variation_831":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_105:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_105:
        return self.rule.content

class RuleVariation_801(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_831.cv_arg
    cv_variation: TypeAlias = Variation_831

    @classmethod
    def create(cls, arg : "RuleVariation_801.cv_arg") -> "RuleVariation_801":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_831:
        return self.arg # type: ignore

class NonSpare_748(NonSpare):
    cv_arg: TypeAlias = RuleVariation_19.cv_arg
    cv_name = "CNF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_19

    @classmethod
    def create(cls, arg : "NonSpare_748.cv_arg") -> "NonSpare_748":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_19:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_19:
        return self.rule.variation

class Item_166(Item):
    cv_arg: TypeAlias = NonSpare_748.cv_arg
    cv_non_spare: TypeAlias = NonSpare_748

    @classmethod
    def create(cls, arg : "Item_166.cv_arg") -> "Item_166":
        return cls._create(arg) # type: ignore

class NonSpare_841(NonSpare):
    cv_arg: TypeAlias = RuleVariation_558.cv_arg
    cv_name = "CST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_558

    @classmethod
    def create(cls, arg : "NonSpare_841.cv_arg") -> "NonSpare_841":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_558:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_569:
        return self.rule.variation

class Item_224(Item):
    cv_arg: TypeAlias = NonSpare_841.cv_arg
    cv_non_spare: TypeAlias = NonSpare_841

    @classmethod
    def create(cls, arg : "Item_224.cv_arg") -> "Item_224":
        return cls._create(arg) # type: ignore

class NonSpare_714(NonSpare):
    cv_arg: TypeAlias = RuleVariation_667.cv_arg
    cv_name = "CDM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_667

    @classmethod
    def create(cls, arg : "NonSpare_714.cv_arg") -> "NonSpare_714":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_667:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_678:
        return self.rule.variation

class Item_140(Item):
    cv_arg: TypeAlias = NonSpare_714.cv_arg
    cv_non_spare: TypeAlias = NonSpare_714

    @classmethod
    def create(cls, arg : "Item_140.cv_arg") -> "Item_140":
        return cls._create(arg) # type: ignore

class NonSpare_1225(NonSpare):
    cv_arg: TypeAlias = RuleVariation_801.cv_arg
    cv_name = "MAH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_801

    @classmethod
    def create(cls, arg : "NonSpare_1225.cv_arg") -> "NonSpare_1225":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_801:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_831:
        return self.rule.variation

class Item_525(Item):
    cv_arg: TypeAlias = NonSpare_1225.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1225

    @classmethod
    def create(cls, arg : "Item_525.cv_arg") -> "Item_525":
        return cls._create(arg) # type: ignore

class Variation_1353(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_19.cv_arg, Tuple[Literal["CNF"], RuleVariation_19.cv_arg]], Union[RuleVariation_400.cv_arg, Tuple[Literal["TRE"], RuleVariation_400.cv_arg]], Union[RuleVariation_558.cv_arg, Tuple[Literal["CST"], RuleVariation_558.cv_arg]], Union[RuleVariation_667.cv_arg, Tuple[Literal["CDM"], RuleVariation_667.cv_arg]], Union[RuleVariation_801.cv_arg, Tuple[Literal["MAH"], RuleVariation_801.cv_arg]], Union[RuleVariation_907.cv_arg, Tuple[Literal["STH"], RuleVariation_907.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_28.cv_arg, Tuple[Literal["GHO"], RuleVariation_28.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1353.cv_arg_group_1"],
        Tuple["Variation_1353.cv_arg_group_1", "Variation_1353.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_166, 1), (Item_1036, 1), (Item_224, 1), (Item_140, 2), (Item_525, 1), (Item_949, 1), None], [(Item_370, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1353.cv_arg") -> 'Variation_1353':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_19:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> RuleVariation_400:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_558:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> RuleVariation_667:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_801:
        ...
    @overload
    def get_item(self, key : Literal["STH"]) -> RuleVariation_907:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_28]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1274(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1353.cv_arg
    cv_variation: TypeAlias = Variation_1353

    @classmethod
    def create(cls, arg : "RuleVariation_1274.cv_arg") -> "RuleVariation_1274":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1353:
        return self.arg # type: ignore

class NonSpare_376(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1274.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1274

    @classmethod
    def create(cls, arg : "NonSpare_376.cv_arg") -> "NonSpare_376":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1353:
        return self.rule.variation

class UapItem_376(UapItem):
    cv_non_spare: TypeAlias = NonSpare_376

class Content_291(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-3/A code derived from the reply of the transponder", 1: "Mode-3/A code not extracted during the last update period"}

class RuleContent_291(RuleContentContextFree):
    cv_arg: TypeAlias = Content_291.cv_arg
    cv_content: TypeAlias = Content_291

    @property
    def content(self) -> Content_291:
        return self._get_content() # type: ignore

class Variation_554(Element):
    cv_arg: TypeAlias = RuleContent_291.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_291

    @classmethod
    def create(cls, arg: "Variation_554.cv_arg") -> "Variation_554":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_291:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_291:
        return self.rule.content

class RuleVariation_543(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_554.cv_arg
    cv_variation: TypeAlias = Variation_554

    @classmethod
    def create(cls, arg : "RuleVariation_543.cv_arg") -> "RuleVariation_543":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_554:
        return self.arg # type: ignore

class NonSpare_1142(NonSpare):
    cv_arg: TypeAlias = RuleVariation_543.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_543

    @classmethod
    def create(cls, arg : "NonSpare_1142.cv_arg") -> "NonSpare_1142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_543:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_554:
        return self.rule.variation

class Item_454(Item):
    cv_arg: TypeAlias = NonSpare_1142.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1142

    @classmethod
    def create(cls, arg : "Item_454.cv_arg") -> "Item_454":
        return cls._create(arg) # type: ignore

class Variation_1276(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_543.cv_arg, Tuple[Literal["L"], RuleVariation_543.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1276.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_454, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_543, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_543:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_543:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1276.cv_arg") -> 'Variation_1276':
        return cls._create(arg) # type: ignore

class RuleVariation_1205(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1276.cv_arg
    cv_variation: TypeAlias = Variation_1276

    @classmethod
    def create(cls, arg : "RuleVariation_1205.cv_arg") -> "RuleVariation_1205":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1276:
        return self.arg # type: ignore

class NonSpare_214(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1205.cv_arg
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1205

    @classmethod
    def create(cls, arg : "NonSpare_214.cv_arg") -> "NonSpare_214":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1276:
        return self.rule.variation

class UapItem_214(UapItem):
    cv_non_spare: TypeAlias = NonSpare_214

class NonSpare_2048(NonSpare):
    cv_arg: TypeAlias = RuleVariation_272.cv_arg
    cv_name = "VX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_272

    @classmethod
    def create(cls, arg : "NonSpare_2048.cv_arg") -> "NonSpare_2048":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_279:
        return self.rule.variation

class Item_1154(Item):
    cv_arg: TypeAlias = NonSpare_2048.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2048

    @classmethod
    def create(cls, arg : "Item_1154.cv_arg") -> "Item_1154":
        return cls._create(arg) # type: ignore

class NonSpare_2053(NonSpare):
    cv_arg: TypeAlias = RuleVariation_272.cv_arg
    cv_name = "VY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_272

    @classmethod
    def create(cls, arg : "NonSpare_2053.cv_arg") -> "NonSpare_2053":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_272:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_279:
        return self.rule.variation

class Item_1159(Item):
    cv_arg: TypeAlias = NonSpare_2053.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2053

    @classmethod
    def create(cls, arg : "Item_1159.cv_arg") -> "Item_1159":
        return cls._create(arg) # type: ignore

class Variation_1279(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_272.cv_arg, Tuple[Literal["VX"], RuleVariation_272.cv_arg]], Union[RuleVariation_272.cv_arg, Tuple[Literal["VY"], RuleVariation_272.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1279.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1154, 16), (Item_1159, 16)]
    cv_items_dict = {"VX": RuleVariation_272, "VY": RuleVariation_272}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_272:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_272:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_272:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1279.cv_arg") -> 'Variation_1279':
        return cls._create(arg) # type: ignore

class RuleVariation_1208(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1279.cv_arg
    cv_variation: TypeAlias = Variation_1279

    @classmethod
    def create(cls, arg : "RuleVariation_1208.cv_arg") -> "RuleVariation_1208":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1279:
        return self.arg # type: ignore

class NonSpare_405(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1208.cv_arg
    cv_name = "202"
    cv_title = "Calculated Track Velocity in Cartesian Coordinates"
    cv_rule: TypeAlias = RuleVariation_1208

    @classmethod
    def create(cls, arg : "NonSpare_405.cv_arg") -> "NonSpare_405":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1208:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1279:
        return self.rule.variation

class UapItem_405(UapItem):
    cv_non_spare: TypeAlias = NonSpare_405

class NonSpare_251(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1200.cv_arg
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule: TypeAlias = RuleVariation_1200

    @classmethod
    def create(cls, arg : "NonSpare_251.cv_arg") -> "NonSpare_251":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1200:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1271:
        return self.rule.variation

class UapItem_251(UapItem):
    cv_non_spare: TypeAlias = NonSpare_251

class NonSpare_1511(NonSpare):
    cv_arg: TypeAlias = RuleVariation_717.cv_arg
    cv_name = "QC1"
    cv_title = "Quality Pulse C1"
    cv_rule: TypeAlias = RuleVariation_717

    @classmethod
    def create(cls, arg : "NonSpare_1511.cv_arg") -> "NonSpare_1511":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_717:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_728:
        return self.rule.variation

class Item_744(Item):
    cv_arg: TypeAlias = NonSpare_1511.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1511

    @classmethod
    def create(cls, arg : "Item_744.cv_arg") -> "Item_744":
        return cls._create(arg) # type: ignore

class NonSpare_1490(NonSpare):
    cv_arg: TypeAlias = RuleVariation_822.cv_arg
    cv_name = "QA1"
    cv_title = "Quality Pulse A1"
    cv_rule: TypeAlias = RuleVariation_822

    @classmethod
    def create(cls, arg : "NonSpare_1490.cv_arg") -> "NonSpare_1490":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_822:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_852:
        return self.rule.variation

class Item_723(Item):
    cv_arg: TypeAlias = NonSpare_1490.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1490

    @classmethod
    def create(cls, arg : "Item_723.cv_arg") -> "Item_723":
        return cls._create(arg) # type: ignore

class NonSpare_1514(NonSpare):
    cv_arg: TypeAlias = RuleVariation_902.cv_arg
    cv_name = "QC2"
    cv_title = "Quality Pulse C2"
    cv_rule: TypeAlias = RuleVariation_902

    @classmethod
    def create(cls, arg : "NonSpare_1514.cv_arg") -> "NonSpare_1514":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_902:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_932:
        return self.rule.variation

class Item_747(Item):
    cv_arg: TypeAlias = NonSpare_1514.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1514

    @classmethod
    def create(cls, arg : "Item_747.cv_arg") -> "Item_747":
        return cls._create(arg) # type: ignore

class NonSpare_1494(NonSpare):
    cv_arg: TypeAlias = RuleVariation_946.cv_arg
    cv_name = "QA2"
    cv_title = "Quality Pulse A2"
    cv_rule: TypeAlias = RuleVariation_946

    @classmethod
    def create(cls, arg : "NonSpare_1494.cv_arg") -> "NonSpare_1494":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_946:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_976:
        return self.rule.variation

class Item_727(Item):
    cv_arg: TypeAlias = NonSpare_1494.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1494

    @classmethod
    def create(cls, arg : "Item_727.cv_arg") -> "Item_727":
        return cls._create(arg) # type: ignore

class NonSpare_1517(NonSpare):
    cv_arg: TypeAlias = RuleVariation_47.cv_arg
    cv_name = "QC4"
    cv_title = "Quality Pulse C4"
    cv_rule: TypeAlias = RuleVariation_47

    @classmethod
    def create(cls, arg : "NonSpare_1517.cv_arg") -> "NonSpare_1517":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_47:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_47:
        return self.rule.variation

class Item_750(Item):
    cv_arg: TypeAlias = NonSpare_1517.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1517

    @classmethod
    def create(cls, arg : "Item_750.cv_arg") -> "Item_750":
        return cls._create(arg) # type: ignore

class NonSpare_1498(NonSpare):
    cv_arg: TypeAlias = RuleVariation_420.cv_arg
    cv_name = "QA4"
    cv_title = "Quality Pulse A4"
    cv_rule: TypeAlias = RuleVariation_420

    @classmethod
    def create(cls, arg : "NonSpare_1498.cv_arg") -> "NonSpare_1498":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_420:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_431:
        return self.rule.variation

class Item_731(Item):
    cv_arg: TypeAlias = NonSpare_1498.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1498

    @classmethod
    def create(cls, arg : "Item_731.cv_arg") -> "Item_731":
        return cls._create(arg) # type: ignore

class NonSpare_1502(NonSpare):
    cv_arg: TypeAlias = RuleVariation_526.cv_arg
    cv_name = "QB1"
    cv_title = "Quality Pulse B1"
    cv_rule: TypeAlias = RuleVariation_526

    @classmethod
    def create(cls, arg : "NonSpare_1502.cv_arg") -> "NonSpare_1502":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_526:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_537:
        return self.rule.variation

class Item_735(Item):
    cv_arg: TypeAlias = NonSpare_1502.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1502

    @classmethod
    def create(cls, arg : "Item_735.cv_arg") -> "Item_735":
        return cls._create(arg) # type: ignore

class NonSpare_1520(NonSpare):
    cv_arg: TypeAlias = RuleVariation_632.cv_arg
    cv_name = "QD1"
    cv_title = "Quality Pulse D1"
    cv_rule: TypeAlias = RuleVariation_632

    @classmethod
    def create(cls, arg : "NonSpare_1520.cv_arg") -> "NonSpare_1520":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_632:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_643:
        return self.rule.variation

class Item_753(Item):
    cv_arg: TypeAlias = NonSpare_1520.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1520

    @classmethod
    def create(cls, arg : "Item_753.cv_arg") -> "Item_753":
        return cls._create(arg) # type: ignore

class NonSpare_1506(NonSpare):
    cv_arg: TypeAlias = RuleVariation_716.cv_arg
    cv_name = "QB2"
    cv_title = "Quality Pulse B2"
    cv_rule: TypeAlias = RuleVariation_716

    @classmethod
    def create(cls, arg : "NonSpare_1506.cv_arg") -> "NonSpare_1506":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_716:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_727:
        return self.rule.variation

class Item_739(Item):
    cv_arg: TypeAlias = NonSpare_1506.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1506

    @classmethod
    def create(cls, arg : "Item_739.cv_arg") -> "Item_739":
        return cls._create(arg) # type: ignore

class Variation_854(Element):
    cv_arg: TypeAlias = RuleContent_229.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_229

    @classmethod
    def create(cls, arg: "Variation_854.cv_arg") -> "Variation_854":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_229:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_229:
        return self.rule.content

class RuleVariation_824(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_854.cv_arg
    cv_variation: TypeAlias = Variation_854

    @classmethod
    def create(cls, arg : "RuleVariation_824.cv_arg") -> "RuleVariation_824":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_854:
        return self.arg # type: ignore

class NonSpare_1523(NonSpare):
    cv_arg: TypeAlias = RuleVariation_824.cv_arg
    cv_name = "QD2"
    cv_title = "Quality Pulse D2"
    cv_rule: TypeAlias = RuleVariation_824

    @classmethod
    def create(cls, arg : "NonSpare_1523.cv_arg") -> "NonSpare_1523":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_824:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_854:
        return self.rule.variation

class Item_756(Item):
    cv_arg: TypeAlias = NonSpare_1523.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1523

    @classmethod
    def create(cls, arg : "Item_756.cv_arg") -> "Item_756":
        return cls._create(arg) # type: ignore

class NonSpare_1509(NonSpare):
    cv_arg: TypeAlias = RuleVariation_901.cv_arg
    cv_name = "QB4"
    cv_title = "Quality Pulse B4"
    cv_rule: TypeAlias = RuleVariation_901

    @classmethod
    def create(cls, arg : "NonSpare_1509.cv_arg") -> "NonSpare_1509":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_901:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_931:
        return self.rule.variation

class Item_742(Item):
    cv_arg: TypeAlias = NonSpare_1509.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1509

    @classmethod
    def create(cls, arg : "Item_742.cv_arg") -> "Item_742":
        return cls._create(arg) # type: ignore

class NonSpare_1526(NonSpare):
    cv_arg: TypeAlias = RuleVariation_950.cv_arg
    cv_name = "QD4"
    cv_title = "Quality Pulse D4"
    cv_rule: TypeAlias = RuleVariation_950

    @classmethod
    def create(cls, arg : "NonSpare_1526.cv_arg") -> "NonSpare_1526":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_950:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_980:
        return self.rule.variation

class Item_759(Item):
    cv_arg: TypeAlias = NonSpare_1526.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1526

    @classmethod
    def create(cls, arg : "Item_759.cv_arg") -> "Item_759":
        return cls._create(arg) # type: ignore

class Variation_1269(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], int, Union[RuleVariation_778.cv_arg, Tuple[Literal["MODEC"], RuleVariation_778.cv_arg]], int, Union[RuleVariation_717.cv_arg, Tuple[Literal["QC1"], RuleVariation_717.cv_arg]], Union[RuleVariation_822.cv_arg, Tuple[Literal["QA1"], RuleVariation_822.cv_arg]], Union[RuleVariation_902.cv_arg, Tuple[Literal["QC2"], RuleVariation_902.cv_arg]], Union[RuleVariation_946.cv_arg, Tuple[Literal["QA2"], RuleVariation_946.cv_arg]], Union[RuleVariation_47.cv_arg, Tuple[Literal["QC4"], RuleVariation_47.cv_arg]], Union[RuleVariation_420.cv_arg, Tuple[Literal["QA4"], RuleVariation_420.cv_arg]], Union[RuleVariation_526.cv_arg, Tuple[Literal["QB1"], RuleVariation_526.cv_arg]], Union[RuleVariation_632.cv_arg, Tuple[Literal["QD1"], RuleVariation_632.cv_arg]], Union[RuleVariation_716.cv_arg, Tuple[Literal["QB2"], RuleVariation_716.cv_arg]], Union[RuleVariation_824.cv_arg, Tuple[Literal["QD2"], RuleVariation_824.cv_arg]], Union[RuleVariation_901.cv_arg, Tuple[Literal["QB4"], RuleVariation_901.cv_arg]], Union[RuleVariation_950.cv_arg, Tuple[Literal["QD4"], RuleVariation_950.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1269.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_12, 2), (Item_576, 12), (Item_3, 4), (Item_744, 1), (Item_723, 1), (Item_747, 1), (Item_727, 1), (Item_750, 1), (Item_731, 1), (Item_735, 1), (Item_753, 1), (Item_739, 1), (Item_756, 1), (Item_742, 1), (Item_759, 1)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "MODEC": RuleVariation_778, "QC1": RuleVariation_717, "QA1": RuleVariation_822, "QC2": RuleVariation_902, "QA2": RuleVariation_946, "QC4": RuleVariation_47, "QA4": RuleVariation_420, "QB1": RuleVariation_526, "QD1": RuleVariation_632, "QB2": RuleVariation_716, "QD2": RuleVariation_824, "QB4": RuleVariation_901, "QD4": RuleVariation_950}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODEC"]) -> RuleVariation_778:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC1"]) -> RuleVariation_717:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC2"]) -> RuleVariation_902:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_946:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QC4"]) -> RuleVariation_47:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_526:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD1"]) -> RuleVariation_632:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_716:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD2"]) -> RuleVariation_824:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB4"]) -> RuleVariation_901:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QD4"]) -> RuleVariation_950:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["MODEC"], Literal["QC1"], Literal["QA1"], Literal["QC2"], Literal["QA2"], Literal["QC4"], Literal["QA4"], Literal["QB1"], Literal["QD1"], Literal["QB2"], Literal["QD2"], Literal["QB4"], Literal["QD4"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["MODEC"]) -> RuleVariation_778:
        ...
    @overload
    def get_item(self, key : Literal["QC1"]) -> RuleVariation_717:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_822:
        ...
    @overload
    def get_item(self, key : Literal["QC2"]) -> RuleVariation_902:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_946:
        ...
    @overload
    def get_item(self, key : Literal["QC4"]) -> RuleVariation_47:
        ...
    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_420:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_526:
        ...
    @overload
    def get_item(self, key : Literal["QD1"]) -> RuleVariation_632:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_716:
        ...
    @overload
    def get_item(self, key : Literal["QD2"]) -> RuleVariation_824:
        ...
    @overload
    def get_item(self, key : Literal["QB4"]) -> RuleVariation_901:
        ...
    @overload
    def get_item(self, key : Literal["QD4"]) -> RuleVariation_950:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1269.cv_arg") -> 'Variation_1269':
        return cls._create(arg) # type: ignore

class RuleVariation_1198(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1269.cv_arg
    cv_variation: TypeAlias = Variation_1269

    @classmethod
    def create(cls, arg : "RuleVariation_1198.cv_arg") -> "RuleVariation_1198":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1269:
        return self.arg # type: ignore

class NonSpare_272(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1198.cv_arg
    cv_name = "100"
    cv_title = "Mode C Code"
    cv_rule: TypeAlias = RuleVariation_1198

    @classmethod
    def create(cls, arg : "NonSpare_272.cv_arg") -> "NonSpare_272":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1269:
        return self.rule.variation

class UapItem_272(UapItem):
    cv_non_spare: TypeAlias = NonSpare_272

class NonSpare_427(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "220"
    cv_title = "Target Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_427.cv_arg") -> "NonSpare_427":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_427(UapItem):
    cv_non_spare: TypeAlias = NonSpare_427

class Content_52(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Callsign or registration not downlinked from transponder", 1: "Registration downlinked from transponder", 2: "Callsign downlinked from transponder", 3: "Not defined"}

class RuleContent_52(RuleContentContextFree):
    cv_arg: TypeAlias = Content_52.cv_arg
    cv_content: TypeAlias = Content_52

    @property
    def content(self) -> Content_52:
        return self._get_content() # type: ignore

class Variation_99(Element):
    cv_arg: TypeAlias = RuleContent_52.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_52

    @classmethod
    def create(cls, arg: "Variation_99.cv_arg") -> "Variation_99":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_52:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_52:
        return self.rule.content

class RuleVariation_99(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_99.cv_arg
    cv_variation: TypeAlias = Variation_99

    @classmethod
    def create(cls, arg : "RuleVariation_99.cv_arg") -> "RuleVariation_99":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_99:
        return self.arg # type: ignore

class NonSpare_1792(NonSpare):
    cv_arg: TypeAlias = RuleVariation_99.cv_arg
    cv_name = "STI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_99

    @classmethod
    def create(cls, arg : "NonSpare_1792.cv_arg") -> "NonSpare_1792":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_99:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_99:
        return self.rule.variation

class Item_952(Item):
    cv_arg: TypeAlias = NonSpare_1792.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1792

    @classmethod
    def create(cls, arg : "Item_952.cv_arg") -> "Item_952":
        return cls._create(arg) # type: ignore

class NonSpare_737(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "CHR"
    cv_title = "Characters 1-8 (coded on 6 Bits Each) Defining Target Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_737.cv_arg") -> "NonSpare_737":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class Item_159(Item):
    cv_arg: TypeAlias = NonSpare_737.cv_arg
    cv_non_spare: TypeAlias = NonSpare_737

    @classmethod
    def create(cls, arg : "Item_159.cv_arg") -> "Item_159":
        return cls._create(arg) # type: ignore

class Variation_1218(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_99.cv_arg, Tuple[Literal["STI"], RuleVariation_99.cv_arg]], int, Union[RuleVariation_383.cv_arg, Tuple[Literal["CHR"], RuleVariation_383.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1218.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_952, 2), (Item_15, 6), (Item_159, 48)]
    cv_items_dict = {"STI": RuleVariation_99, "CHR": RuleVariation_383}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_99:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHR"]) -> RuleVariation_383:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["CHR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_99:
        ...
    @overload
    def get_item(self, key : Literal["CHR"]) -> RuleVariation_383:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1218.cv_arg") -> 'Variation_1218':
        return cls._create(arg) # type: ignore

class RuleVariation_1162(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1218.cv_arg
    cv_variation: TypeAlias = Variation_1218

    @classmethod
    def create(cls, arg : "RuleVariation_1162.cv_arg") -> "RuleVariation_1162":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1218:
        return self.arg # type: ignore

class NonSpare_443(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1162.cv_arg
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_1162

    @classmethod
    def create(cls, arg : "NonSpare_443.cv_arg") -> "NonSpare_443":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1162:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1218:
        return self.rule.variation

class UapItem_443(UapItem):
    cv_non_spare: TypeAlias = NonSpare_443

class NonSpare_288(NonSpare):
    cv_arg: TypeAlias = RuleVariation_283.cv_arg
    cv_name = "110"
    cv_title = "Measured Height (Local Cartesian Coordinates)"
    cv_rule: TypeAlias = RuleVariation_283

    @classmethod
    def create(cls, arg : "NonSpare_288.cv_arg") -> "NonSpare_288":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_290:
        return self.rule.variation

class UapItem_288(UapItem):
    cv_non_spare: TypeAlias = NonSpare_288

class NonSpare_282(NonSpare):
    cv_arg: TypeAlias = RuleVariation_283.cv_arg
    cv_name = "105"
    cv_title = "Geometric Height (WGS-84)"
    cv_rule: TypeAlias = RuleVariation_283

    @classmethod
    def create(cls, arg : "NonSpare_282.cv_arg") -> "NonSpare_282":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_283:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_290:
        return self.rule.variation

class UapItem_282(UapItem):
    cv_non_spare: TypeAlias = NonSpare_282

class NonSpare_656(NonSpare):
    cv_arg: TypeAlias = RuleVariation_205.cv_arg
    cv_name = "AX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_205

    @classmethod
    def create(cls, arg : "NonSpare_656.cv_arg") -> "NonSpare_656":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

class Item_99(Item):
    cv_arg: TypeAlias = NonSpare_656.cv_arg
    cv_non_spare: TypeAlias = NonSpare_656

    @classmethod
    def create(cls, arg : "Item_99.cv_arg") -> "Item_99":
        return cls._create(arg) # type: ignore

class NonSpare_660(NonSpare):
    cv_arg: TypeAlias = RuleVariation_205.cv_arg
    cv_name = "AY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_205

    @classmethod
    def create(cls, arg : "NonSpare_660.cv_arg") -> "NonSpare_660":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_205:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_212:
        return self.rule.variation

class Item_103(Item):
    cv_arg: TypeAlias = NonSpare_660.cv_arg
    cv_non_spare: TypeAlias = NonSpare_660

    @classmethod
    def create(cls, arg : "Item_103.cv_arg") -> "Item_103":
        return cls._create(arg) # type: ignore

class Variation_1056(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_205.cv_arg, Tuple[Literal["AX"], RuleVariation_205.cv_arg]], Union[RuleVariation_205.cv_arg, Tuple[Literal["AY"], RuleVariation_205.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1056.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_99, 8), (Item_103, 8)]
    cv_items_dict = {"AX": RuleVariation_205, "AY": RuleVariation_205}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_205:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_205:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_205:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1056.cv_arg") -> 'Variation_1056':
        return cls._create(arg) # type: ignore

class RuleVariation_1023(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1056.cv_arg
    cv_variation: TypeAlias = Variation_1056

    @classmethod
    def create(cls, arg : "RuleVariation_1023.cv_arg") -> "RuleVariation_1023":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1056:
        return self.arg # type: ignore

class NonSpare_407(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1023.cv_arg
    cv_name = "210"
    cv_title = "Calculated Acceleration"
    cv_rule: TypeAlias = RuleVariation_1023

    @classmethod
    def create(cls, arg : "NonSpare_407.cv_arg") -> "NonSpare_407":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1023:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1056:
        return self.rule.variation

class UapItem_407(UapItem):
    cv_non_spare: TypeAlias = NonSpare_407

class NonSpare_1329(NonSpare):
    cv_arg: TypeAlias = RuleVariation_484.cv_arg
    cv_name = "MSG"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_484

    @classmethod
    def create(cls, arg : "NonSpare_1329.cv_arg") -> "NonSpare_1329":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_484:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_495:
        return self.rule.variation

class Item_593(Item):
    cv_arg: TypeAlias = NonSpare_1329.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1329

    @classmethod
    def create(cls, arg : "Item_593.cv_arg") -> "Item_593":
        return cls._create(arg) # type: ignore

class Variation_1230(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_30.cv_arg, Tuple[Literal["TRB"], RuleVariation_30.cv_arg]], Union[RuleVariation_484.cv_arg, Tuple[Literal["MSG"], RuleVariation_484.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1230.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1031, 1), (Item_593, 7)]
    cv_items_dict = {"TRB": RuleVariation_30, "MSG": RuleVariation_484}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSG"]) -> RuleVariation_484:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRB"], Literal["MSG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_30:
        ...
    @overload
    def get_item(self, key : Literal["MSG"]) -> RuleVariation_484:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1230.cv_arg") -> 'Variation_1230':
        return cls._create(arg) # type: ignore

class RuleVariation_1168(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1230.cv_arg
    cv_variation: TypeAlias = Variation_1230

    @classmethod
    def create(cls, arg : "RuleVariation_1168.cv_arg") -> "RuleVariation_1168":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1230:
        return self.arg # type: ignore

class NonSpare_478(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1168.cv_arg
    cv_name = "310"
    cv_title = "Pre-programmed Message"
    cv_rule: TypeAlias = RuleVariation_1168

    @classmethod
    def create(cls, arg : "NonSpare_478.cv_arg") -> "NonSpare_478":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1230:
        return self.rule.variation

class UapItem_478(UapItem):
    cv_non_spare: TypeAlias = NonSpare_478

class Content_751(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

class RuleContent_750(RuleContentContextFree):
    cv_arg: TypeAlias = Content_751.cv_arg
    cv_content: TypeAlias = Content_751

    @property
    def content(self) -> Content_751:
        return self._get_content() # type: ignore

class Variation_320(Element):
    cv_arg: TypeAlias = RuleContent_750.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_750

    @classmethod
    def create(cls, arg: "Variation_320.cv_arg") -> "Variation_320":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_750:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_751:
        return self.rule.content

class RuleVariation_313(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_320.cv_arg
    cv_variation: TypeAlias = Variation_320

    @classmethod
    def create(cls, arg : "RuleVariation_313.cv_arg") -> "RuleVariation_313":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_320:
        return self.arg # type: ignore

class NonSpare_2088(NonSpare):
    cv_arg: TypeAlias = RuleVariation_313.cv_arg
    cv_name = "X"
    cv_title = "DOP (X-Component)"
    cv_rule: TypeAlias = RuleVariation_313

    @classmethod
    def create(cls, arg : "NonSpare_2088.cv_arg") -> "NonSpare_2088":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_320:
        return self.rule.variation

class Item_1189(Item):
    cv_arg: TypeAlias = NonSpare_2088.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2088

    @classmethod
    def create(cls, arg : "Item_1189.cv_arg") -> "Item_1189":
        return cls._create(arg) # type: ignore

class NonSpare_2141(NonSpare):
    cv_arg: TypeAlias = RuleVariation_313.cv_arg
    cv_name = "Y"
    cv_title = "DOP (Y-Component)"
    cv_rule: TypeAlias = RuleVariation_313

    @classmethod
    def create(cls, arg : "NonSpare_2141.cv_arg") -> "NonSpare_2141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_320:
        return self.rule.variation

class Item_1239(Item):
    cv_arg: TypeAlias = NonSpare_2141.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2141

    @classmethod
    def create(cls, arg : "Item_1239.cv_arg") -> "Item_1239":
        return cls._create(arg) # type: ignore

class NonSpare_2122(NonSpare):
    cv_arg: TypeAlias = RuleVariation_313.cv_arg
    cv_name = "XY"
    cv_title = "DOP (Correlation XY)"
    cv_rule: TypeAlias = RuleVariation_313

    @classmethod
    def create(cls, arg : "NonSpare_2122.cv_arg") -> "NonSpare_2122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_320:
        return self.rule.variation

class Item_1220(Item):
    cv_arg: TypeAlias = NonSpare_2122.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2122

    @classmethod
    def create(cls, arg : "Item_1220.cv_arg") -> "Item_1220":
        return cls._create(arg) # type: ignore

class Variation_1302(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_313.cv_arg, Tuple[Literal["X"], RuleVariation_313.cv_arg]], Union[RuleVariation_313.cv_arg, Tuple[Literal["Y"], RuleVariation_313.cv_arg]], Union[RuleVariation_313.cv_arg, Tuple[Literal["XY"], RuleVariation_313.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1302.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1189, 16), (Item_1239, 16), (Item_1220, 16)]
    cv_items_dict = {"X": RuleVariation_313, "Y": RuleVariation_313, "XY": RuleVariation_313}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XY"]) -> RuleVariation_313:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["XY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_313:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_313:
        ...
    @overload
    def get_item(self, key : Literal["XY"]) -> RuleVariation_313:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1302.cv_arg") -> 'Variation_1302':
        return cls._create(arg) # type: ignore

class RuleVariation_1231(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1302.cv_arg
    cv_variation: TypeAlias = Variation_1302

    @classmethod
    def create(cls, arg : "RuleVariation_1231.cv_arg") -> "RuleVariation_1231":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1302:
        return self.arg # type: ignore

class NonSpare_891(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1231.cv_arg
    cv_name = "DOP"
    cv_title = "DOP of Position"
    cv_rule: TypeAlias = RuleVariation_1231

    @classmethod
    def create(cls, arg : "NonSpare_891.cv_arg") -> "NonSpare_891":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1231:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1302:
        return self.rule.variation

class Variation_324(Element):
    cv_arg: TypeAlias = RuleContent_754.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_754

    @classmethod
    def create(cls, arg: "Variation_324.cv_arg") -> "Variation_324":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_754:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_755:
        return self.rule.content

class RuleVariation_317(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_324.cv_arg
    cv_variation: TypeAlias = Variation_324

    @classmethod
    def create(cls, arg : "RuleVariation_317.cv_arg") -> "RuleVariation_317":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_324:
        return self.arg # type: ignore

class NonSpare_2092(NonSpare):
    cv_arg: TypeAlias = RuleVariation_317.cv_arg
    cv_name = "X"
    cv_title = "SDP (X-Component)"
    cv_rule: TypeAlias = RuleVariation_317

    @classmethod
    def create(cls, arg : "NonSpare_2092.cv_arg") -> "NonSpare_2092":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_317:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_324:
        return self.rule.variation

class Item_1193(Item):
    cv_arg: TypeAlias = NonSpare_2092.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2092

    @classmethod
    def create(cls, arg : "Item_1193.cv_arg") -> "Item_1193":
        return cls._create(arg) # type: ignore

class NonSpare_2145(NonSpare):
    cv_arg: TypeAlias = RuleVariation_317.cv_arg
    cv_name = "Y"
    cv_title = "SDP (Y-Component)"
    cv_rule: TypeAlias = RuleVariation_317

    @classmethod
    def create(cls, arg : "NonSpare_2145.cv_arg") -> "NonSpare_2145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_317:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_324:
        return self.rule.variation

class Item_1243(Item):
    cv_arg: TypeAlias = NonSpare_2145.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2145

    @classmethod
    def create(cls, arg : "Item_1243.cv_arg") -> "Item_1243":
        return cls._create(arg) # type: ignore

class NonSpare_2123(NonSpare):
    cv_arg: TypeAlias = RuleVariation_313.cv_arg
    cv_name = "XY"
    cv_title = "SDP (Correlation XY)"
    cv_rule: TypeAlias = RuleVariation_313

    @classmethod
    def create(cls, arg : "NonSpare_2123.cv_arg") -> "NonSpare_2123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_313:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_320:
        return self.rule.variation

class Item_1221(Item):
    cv_arg: TypeAlias = NonSpare_2123.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2123

    @classmethod
    def create(cls, arg : "Item_1221.cv_arg") -> "Item_1221":
        return cls._create(arg) # type: ignore

class Variation_1306(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_317.cv_arg, Tuple[Literal["X"], RuleVariation_317.cv_arg]], Union[RuleVariation_317.cv_arg, Tuple[Literal["Y"], RuleVariation_317.cv_arg]], Union[RuleVariation_313.cv_arg, Tuple[Literal["XY"], RuleVariation_313.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1306.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1193, 16), (Item_1243, 16), (Item_1221, 16)]
    cv_items_dict = {"X": RuleVariation_317, "Y": RuleVariation_317, "XY": RuleVariation_313}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_317:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_317:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XY"]) -> RuleVariation_313:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"], Literal["XY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_317:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_317:
        ...
    @overload
    def get_item(self, key : Literal["XY"]) -> RuleVariation_313:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1306.cv_arg") -> 'Variation_1306':
        return cls._create(arg) # type: ignore

class RuleVariation_1235(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1306.cv_arg
    cv_variation: TypeAlias = Variation_1306

    @classmethod
    def create(cls, arg : "RuleVariation_1235.cv_arg") -> "RuleVariation_1235":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1306:
        return self.arg # type: ignore

class NonSpare_1689(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1235.cv_arg
    cv_name = "SDP"
    cv_title = "Standard Deviation of Position"
    cv_rule: TypeAlias = RuleVariation_1235

    @classmethod
    def create(cls, arg : "NonSpare_1689.cv_arg") -> "NonSpare_1689":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1235:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1306:
        return self.rule.variation

class NonSpare_1684(NonSpare):
    cv_arg: TypeAlias = RuleVariation_304.cv_arg
    cv_name = "SDH"
    cv_title = "Standard Deviation of Geometric Height (WGS 84)"
    cv_rule: TypeAlias = RuleVariation_304

    @classmethod
    def create(cls, arg : "NonSpare_1684.cv_arg") -> "NonSpare_1684":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

class Variation_1483(Compound):
    cv_arg = TypedDict('cv_arg', {
        "DOP": NonSpare_891.cv_arg,
        "SDP": NonSpare_1689.cv_arg,
        "SDH": NonSpare_1684.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_891, NonSpare_1689, NonSpare_1684]
    cv_items_dict = {"DOP": NonSpare_891, "SDP": NonSpare_1689, "SDH": NonSpare_1684}

    @overload
    @classmethod
    def spec(cls, key : Literal["DOP"]) -> NonSpare_891:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDP"]) -> NonSpare_1689:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SDH"]) -> NonSpare_1684:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DOP"], Literal["SDP"], Literal["SDH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DOP"]) -> Optional[NonSpare_891]:
        ...
    @overload
    def get_item(self, key : Literal["SDP"]) -> Optional[NonSpare_1689]:
        ...
    @overload
    def get_item(self, key : Literal["SDH"]) -> Optional[NonSpare_1684]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["DOP"], val : NonSpare_891.cv_arg) -> "Variation_1483":
        ...
    @overload
    def set_item(self, key : Literal["SDP"], val : NonSpare_1689.cv_arg) -> "Variation_1483":
        ...
    @overload
    def set_item(self, key : Literal["SDH"], val : NonSpare_1684.cv_arg) -> "Variation_1483":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["DOP"]) -> "Variation_1483":
        ...
    @overload
    def del_item(self, key : Literal["SDP"]) -> "Variation_1483":
        ...
    @overload
    def del_item(self, key : Literal["SDH"]) -> "Variation_1483":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1483.cv_arg") -> 'Variation_1483':
        return cls._create(arg) # type: ignore

class RuleVariation_1404(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1483.cv_arg
    cv_variation: TypeAlias = Variation_1483

    @classmethod
    def create(cls, arg : "RuleVariation_1404.cv_arg") -> "RuleVariation_1404":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1483:
        return self.arg # type: ignore

class NonSpare_517(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1404.cv_arg
    cv_name = "500"
    cv_title = "Position Accuracy"
    cv_rule: TypeAlias = RuleVariation_1404

    @classmethod
    def create(cls, arg : "NonSpare_517.cv_arg") -> "NonSpare_517":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1404:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1483:
        return self.rule.variation

class UapItem_516(UapItem):
    cv_non_spare: TypeAlias = NonSpare_517

class Content_469(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU1/RU1 has NOT contributed to the target detection", 1: "TU1/RU1 has contributed to the target detection"}

class RuleContent_469(RuleContentContextFree):
    cv_arg: TypeAlias = Content_469.cv_arg
    cv_content: TypeAlias = Content_469

    @property
    def content(self) -> Content_469:
        return self._get_content() # type: ignore

class Variation_81(Element):
    cv_arg: TypeAlias = RuleContent_469.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_469

    @classmethod
    def create(cls, arg: "Variation_81.cv_arg") -> "Variation_81":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_469:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_469:
        return self.rule.content

class RuleVariation_81(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_81.cv_arg
    cv_variation: TypeAlias = Variation_81

    @classmethod
    def create(cls, arg : "RuleVariation_81.cv_arg") -> "RuleVariation_81":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_81:
        return self.arg # type: ignore

class NonSpare_680(NonSpare):
    cv_arg: TypeAlias = RuleVariation_81.cv_arg
    cv_name = "BIT1"
    cv_title = "TU1/RU1 Contribution"
    cv_rule: TypeAlias = RuleVariation_81

    @classmethod
    def create(cls, arg : "NonSpare_680.cv_arg") -> "NonSpare_680":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_81:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_81:
        return self.rule.variation

class Item_119(Item):
    cv_arg: TypeAlias = NonSpare_680.cv_arg
    cv_non_spare: TypeAlias = NonSpare_680

    @classmethod
    def create(cls, arg : "Item_119.cv_arg") -> "Item_119":
        return cls._create(arg) # type: ignore

class Content_470(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU2/RU2 has NOT contributed to the target detection", 1: "TU2/RU2 has contributed to the target detection"}

class RuleContent_470(RuleContentContextFree):
    cv_arg: TypeAlias = Content_470.cv_arg
    cv_content: TypeAlias = Content_470

    @property
    def content(self) -> Content_470:
        return self._get_content() # type: ignore

class Variation_452(Element):
    cv_arg: TypeAlias = RuleContent_470.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_470

    @classmethod
    def create(cls, arg: "Variation_452.cv_arg") -> "Variation_452":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_470:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_470:
        return self.rule.content

class RuleVariation_441(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_452.cv_arg
    cv_variation: TypeAlias = Variation_452

    @classmethod
    def create(cls, arg : "RuleVariation_441.cv_arg") -> "RuleVariation_441":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_452:
        return self.arg # type: ignore

class NonSpare_681(NonSpare):
    cv_arg: TypeAlias = RuleVariation_441.cv_arg
    cv_name = "BIT2"
    cv_title = "TU2/RU2 Contribution"
    cv_rule: TypeAlias = RuleVariation_441

    @classmethod
    def create(cls, arg : "NonSpare_681.cv_arg") -> "NonSpare_681":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_441:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_452:
        return self.rule.variation

class Item_120(Item):
    cv_arg: TypeAlias = NonSpare_681.cv_arg
    cv_non_spare: TypeAlias = NonSpare_681

    @classmethod
    def create(cls, arg : "Item_120.cv_arg") -> "Item_120":
        return cls._create(arg) # type: ignore

class Content_471(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU3/RU3 has NOT contributed to the target detection", 1: "TU3/RU3 has contributed to the target detection"}

class RuleContent_471(RuleContentContextFree):
    cv_arg: TypeAlias = Content_471.cv_arg
    cv_content: TypeAlias = Content_471

    @property
    def content(self) -> Content_471:
        return self._get_content() # type: ignore

class Variation_577(Element):
    cv_arg: TypeAlias = RuleContent_471.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_471

    @classmethod
    def create(cls, arg: "Variation_577.cv_arg") -> "Variation_577":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_471:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_471:
        return self.rule.content

class RuleVariation_566(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_577.cv_arg
    cv_variation: TypeAlias = Variation_577

    @classmethod
    def create(cls, arg : "RuleVariation_566.cv_arg") -> "RuleVariation_566":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_577:
        return self.arg # type: ignore

class NonSpare_682(NonSpare):
    cv_arg: TypeAlias = RuleVariation_566.cv_arg
    cv_name = "BIT3"
    cv_title = "TU3/RU3 Contribution"
    cv_rule: TypeAlias = RuleVariation_566

    @classmethod
    def create(cls, arg : "NonSpare_682.cv_arg") -> "NonSpare_682":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_566:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_577:
        return self.rule.variation

class Item_121(Item):
    cv_arg: TypeAlias = NonSpare_682.cv_arg
    cv_non_spare: TypeAlias = NonSpare_682

    @classmethod
    def create(cls, arg : "Item_121.cv_arg") -> "Item_121":
        return cls._create(arg) # type: ignore

class Content_472(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU4/RU4 has NOT contributed to the target detection", 1: "TU4/RU4 has contributed to the target detection"}

class RuleContent_472(RuleContentContextFree):
    cv_arg: TypeAlias = Content_472.cv_arg
    cv_content: TypeAlias = Content_472

    @property
    def content(self) -> Content_472:
        return self._get_content() # type: ignore

class Variation_662(Element):
    cv_arg: TypeAlias = RuleContent_472.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_472

    @classmethod
    def create(cls, arg: "Variation_662.cv_arg") -> "Variation_662":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_472:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_472:
        return self.rule.content

class RuleVariation_651(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_662.cv_arg
    cv_variation: TypeAlias = Variation_662

    @classmethod
    def create(cls, arg : "RuleVariation_651.cv_arg") -> "RuleVariation_651":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_662:
        return self.arg # type: ignore

class NonSpare_683(NonSpare):
    cv_arg: TypeAlias = RuleVariation_651.cv_arg
    cv_name = "BIT4"
    cv_title = "TU4/RU4 Contribution"
    cv_rule: TypeAlias = RuleVariation_651

    @classmethod
    def create(cls, arg : "NonSpare_683.cv_arg") -> "NonSpare_683":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_651:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_662:
        return self.rule.variation

class Item_122(Item):
    cv_arg: TypeAlias = NonSpare_683.cv_arg
    cv_non_spare: TypeAlias = NonSpare_683

    @classmethod
    def create(cls, arg : "Item_122.cv_arg") -> "Item_122":
        return cls._create(arg) # type: ignore

class Content_473(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU5/RU5 has NOT contributed to the target detection", 1: "TU5/RU5 has contributed to the target detection"}

class RuleContent_473(RuleContentContextFree):
    cv_arg: TypeAlias = Content_473.cv_arg
    cv_content: TypeAlias = Content_473

    @property
    def content(self) -> Content_473:
        return self._get_content() # type: ignore

class Variation_753(Element):
    cv_arg: TypeAlias = RuleContent_473.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_473

    @classmethod
    def create(cls, arg: "Variation_753.cv_arg") -> "Variation_753":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_473:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_473:
        return self.rule.content

class RuleVariation_742(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_753.cv_arg
    cv_variation: TypeAlias = Variation_753

    @classmethod
    def create(cls, arg : "RuleVariation_742.cv_arg") -> "RuleVariation_742":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_753:
        return self.arg # type: ignore

class NonSpare_684(NonSpare):
    cv_arg: TypeAlias = RuleVariation_742.cv_arg
    cv_name = "BIT5"
    cv_title = "TU5/RU5 Contribution"
    cv_rule: TypeAlias = RuleVariation_742

    @classmethod
    def create(cls, arg : "NonSpare_684.cv_arg") -> "NonSpare_684":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_742:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_753:
        return self.rule.variation

class Item_123(Item):
    cv_arg: TypeAlias = NonSpare_684.cv_arg
    cv_non_spare: TypeAlias = NonSpare_684

    @classmethod
    def create(cls, arg : "Item_123.cv_arg") -> "Item_123":
        return cls._create(arg) # type: ignore

class Content_474(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU6/RU6 has NOT contributed to the target detection", 1: "TU6/RU6 has contributed to the target detection"}

class RuleContent_474(RuleContentContextFree):
    cv_arg: TypeAlias = Content_474.cv_arg
    cv_content: TypeAlias = Content_474

    @property
    def content(self) -> Content_474:
        return self._get_content() # type: ignore

class Variation_871(Element):
    cv_arg: TypeAlias = RuleContent_474.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_474

    @classmethod
    def create(cls, arg: "Variation_871.cv_arg") -> "Variation_871":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_474:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_474:
        return self.rule.content

class RuleVariation_841(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_871.cv_arg
    cv_variation: TypeAlias = Variation_871

    @classmethod
    def create(cls, arg : "RuleVariation_841.cv_arg") -> "RuleVariation_841":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_871:
        return self.arg # type: ignore

class NonSpare_685(NonSpare):
    cv_arg: TypeAlias = RuleVariation_841.cv_arg
    cv_name = "BIT6"
    cv_title = "TU6/RU6 Contribution"
    cv_rule: TypeAlias = RuleVariation_841

    @classmethod
    def create(cls, arg : "NonSpare_685.cv_arg") -> "NonSpare_685":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_841:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_871:
        return self.rule.variation

class Item_124(Item):
    cv_arg: TypeAlias = NonSpare_685.cv_arg
    cv_non_spare: TypeAlias = NonSpare_685

    @classmethod
    def create(cls, arg : "Item_124.cv_arg") -> "Item_124":
        return cls._create(arg) # type: ignore

class Content_475(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU7/RU7 has NOT contributed to the target detection", 1: "TU7/RU7 has contributed to the target detection"}

class RuleContent_475(RuleContentContextFree):
    cv_arg: TypeAlias = Content_475.cv_arg
    cv_content: TypeAlias = Content_475

    @property
    def content(self) -> Content_475:
        return self._get_content() # type: ignore

class Variation_954(Element):
    cv_arg: TypeAlias = RuleContent_475.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_475

    @classmethod
    def create(cls, arg: "Variation_954.cv_arg") -> "Variation_954":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_475:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_475:
        return self.rule.content

class RuleVariation_924(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_954.cv_arg
    cv_variation: TypeAlias = Variation_954

    @classmethod
    def create(cls, arg : "RuleVariation_924.cv_arg") -> "RuleVariation_924":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_954:
        return self.arg # type: ignore

class NonSpare_686(NonSpare):
    cv_arg: TypeAlias = RuleVariation_924.cv_arg
    cv_name = "BIT7"
    cv_title = "TU7/RU7 Contribution"
    cv_rule: TypeAlias = RuleVariation_924

    @classmethod
    def create(cls, arg : "NonSpare_686.cv_arg") -> "NonSpare_686":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_924:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_954:
        return self.rule.variation

class Item_125(Item):
    cv_arg: TypeAlias = NonSpare_686.cv_arg
    cv_non_spare: TypeAlias = NonSpare_686

    @classmethod
    def create(cls, arg : "Item_125.cv_arg") -> "Item_125":
        return cls._create(arg) # type: ignore

class Content_476(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TU8/RU8 has NOT contributed to the target detection", 1: "TU8/RU8 has contributed to the target detection"}

class RuleContent_476(RuleContentContextFree):
    cv_arg: TypeAlias = Content_476.cv_arg
    cv_content: TypeAlias = Content_476

    @property
    def content(self) -> Content_476:
        return self._get_content() # type: ignore

class Variation_989(Element):
    cv_arg: TypeAlias = RuleContent_476.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_476

    @classmethod
    def create(cls, arg: "Variation_989.cv_arg") -> "Variation_989":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_476:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_476:
        return self.rule.content

class RuleVariation_959(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_989.cv_arg
    cv_variation: TypeAlias = Variation_989

    @classmethod
    def create(cls, arg : "RuleVariation_959.cv_arg") -> "RuleVariation_959":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_989:
        return self.arg # type: ignore

class NonSpare_687(NonSpare):
    cv_arg: TypeAlias = RuleVariation_959.cv_arg
    cv_name = "BIT8"
    cv_title = "TU8/RU8 Contribution"
    cv_rule: TypeAlias = RuleVariation_959

    @classmethod
    def create(cls, arg : "NonSpare_687.cv_arg") -> "NonSpare_687":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_959:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_989:
        return self.rule.variation

class Item_126(Item):
    cv_arg: TypeAlias = NonSpare_687.cv_arg
    cv_non_spare: TypeAlias = NonSpare_687

    @classmethod
    def create(cls, arg : "Item_126.cv_arg") -> "Item_126":
        return cls._create(arg) # type: ignore

class Variation_1060(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_81.cv_arg, Tuple[Literal["BIT1"], RuleVariation_81.cv_arg]], Union[RuleVariation_441.cv_arg, Tuple[Literal["BIT2"], RuleVariation_441.cv_arg]], Union[RuleVariation_566.cv_arg, Tuple[Literal["BIT3"], RuleVariation_566.cv_arg]], Union[RuleVariation_651.cv_arg, Tuple[Literal["BIT4"], RuleVariation_651.cv_arg]], Union[RuleVariation_742.cv_arg, Tuple[Literal["BIT5"], RuleVariation_742.cv_arg]], Union[RuleVariation_841.cv_arg, Tuple[Literal["BIT6"], RuleVariation_841.cv_arg]], Union[RuleVariation_924.cv_arg, Tuple[Literal["BIT7"], RuleVariation_924.cv_arg]], Union[RuleVariation_959.cv_arg, Tuple[Literal["BIT8"], RuleVariation_959.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1060.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_119, 1), (Item_120, 1), (Item_121, 1), (Item_122, 1), (Item_123, 1), (Item_124, 1), (Item_125, 1), (Item_126, 1)]
    cv_items_dict = {"BIT1": RuleVariation_81, "BIT2": RuleVariation_441, "BIT3": RuleVariation_566, "BIT4": RuleVariation_651, "BIT5": RuleVariation_742, "BIT6": RuleVariation_841, "BIT7": RuleVariation_924, "BIT8": RuleVariation_959}

    @overload
    @classmethod
    def spec(cls, key : Literal["BIT1"]) -> RuleVariation_81:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT2"]) -> RuleVariation_441:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT3"]) -> RuleVariation_566:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT4"]) -> RuleVariation_651:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT5"]) -> RuleVariation_742:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT6"]) -> RuleVariation_841:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT7"]) -> RuleVariation_924:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BIT8"]) -> RuleVariation_959:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BIT1"], Literal["BIT2"], Literal["BIT3"], Literal["BIT4"], Literal["BIT5"], Literal["BIT6"], Literal["BIT7"], Literal["BIT8"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BIT1"]) -> RuleVariation_81:
        ...
    @overload
    def get_item(self, key : Literal["BIT2"]) -> RuleVariation_441:
        ...
    @overload
    def get_item(self, key : Literal["BIT3"]) -> RuleVariation_566:
        ...
    @overload
    def get_item(self, key : Literal["BIT4"]) -> RuleVariation_651:
        ...
    @overload
    def get_item(self, key : Literal["BIT5"]) -> RuleVariation_742:
        ...
    @overload
    def get_item(self, key : Literal["BIT6"]) -> RuleVariation_841:
        ...
    @overload
    def get_item(self, key : Literal["BIT7"]) -> RuleVariation_924:
        ...
    @overload
    def get_item(self, key : Literal["BIT8"]) -> RuleVariation_959:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1060.cv_arg") -> 'Variation_1060':
        return cls._create(arg) # type: ignore

class Variation_1411(Repetitive):
    cv_arg: TypeAlias = List[Variation_1060.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1060

    @classmethod
    def create(cls, arg: "Variation_1411.cv_arg") -> 'Variation_1411':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1060]:
        return self._get_list() # type: ignore

class RuleVariation_1332(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1411.cv_arg
    cv_variation: TypeAlias = Variation_1411

    @classmethod
    def create(cls, arg : "RuleVariation_1332.cv_arg") -> "RuleVariation_1332":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1411:
        return self.arg # type: ignore

class NonSpare_497(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1332.cv_arg
    cv_name = "400"
    cv_title = "Contributing Devices"
    cv_rule: TypeAlias = RuleVariation_1332

    @classmethod
    def create(cls, arg : "NonSpare_497.cv_arg") -> "NonSpare_497":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1332:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1411:
        return self.rule.variation

class UapItem_496(UapItem):
    cv_non_spare: TypeAlias = NonSpare_497

class NonSpare_1236(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "MBDATA"
    cv_title = "56-bit Message Conveying Mode S Comm B Message Data"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_1236.cv_arg") -> "NonSpare_1236":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class Item_532(Item):
    cv_arg: TypeAlias = NonSpare_1236.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1236

    @classmethod
    def create(cls, arg : "Item_532.cv_arg") -> "Item_532":
        return cls._create(arg) # type: ignore

class NonSpare_676(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "BDS1"
    cv_title = "Comm B Data Buffer Store 1 Address"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_676.cv_arg") -> "NonSpare_676":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_116(Item):
    cv_arg: TypeAlias = NonSpare_676.cv_arg
    cv_non_spare: TypeAlias = NonSpare_676

    @classmethod
    def create(cls, arg : "Item_116.cv_arg") -> "Item_116":
        return cls._create(arg) # type: ignore

class NonSpare_678(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "BDS2"
    cv_title = "Comm B Data Buffer Store 2 Address"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_678.cv_arg") -> "NonSpare_678":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_118(Item):
    cv_arg: TypeAlias = NonSpare_678.cv_arg
    cv_non_spare: TypeAlias = NonSpare_678

    @classmethod
    def create(cls, arg : "Item_118.cv_arg") -> "Item_118":
        return cls._create(arg) # type: ignore

class Variation_1143(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_384.cv_arg, Tuple[Literal["MBDATA"], RuleVariation_384.cv_arg]], Union[RuleVariation_132.cv_arg, Tuple[Literal["BDS1"], RuleVariation_132.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["BDS2"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1143.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_532, 56), (Item_116, 4), (Item_118, 4)]
    cv_items_dict = {"MBDATA": RuleVariation_384, "BDS1": RuleVariation_132, "BDS2": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["MBDATA"]) -> RuleVariation_384:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS1"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS2"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MBDATA"], Literal["BDS1"], Literal["BDS2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MBDATA"]) -> RuleVariation_384:
        ...
    @overload
    def get_item(self, key : Literal["BDS1"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["BDS2"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1143.cv_arg") -> 'Variation_1143':
        return cls._create(arg) # type: ignore

class Variation_1422(Repetitive):
    cv_arg: TypeAlias = List[Variation_1143.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1143

    @classmethod
    def create(cls, arg: "Variation_1422.cv_arg") -> 'Variation_1422':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1143]:
        return self._get_list() # type: ignore

class RuleVariation_1343(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1422.cv_arg
    cv_variation: TypeAlias = Variation_1422

    @classmethod
    def create(cls, arg : "RuleVariation_1343.cv_arg") -> "RuleVariation_1343":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1422:
        return self.arg # type: ignore

class NonSpare_449(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1343.cv_arg
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule: TypeAlias = RuleVariation_1343

    @classmethod
    def create(cls, arg : "NonSpare_449.cv_arg") -> "NonSpare_449":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1422:
        return self.rule.variation

class UapItem_449(UapItem):
    cv_non_spare: TypeAlias = NonSpare_449

class Content_322(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "Not assigned", 7: "Information not yet extracted"}

class RuleContent_322(RuleContentContextFree):
    cv_arg: TypeAlias = Content_322.cv_arg
    cv_content: TypeAlias = Content_322

    @property
    def content(self) -> Content_322:
        return self._get_content() # type: ignore

class Variation_685(Element):
    cv_arg: TypeAlias = RuleContent_322.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_322

    @classmethod
    def create(cls, arg: "Variation_685.cv_arg") -> "Variation_685":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_322:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_322:
        return self.rule.content

class RuleVariation_674(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_685.cv_arg
    cv_variation: TypeAlias = Variation_685

    @classmethod
    def create(cls, arg : "RuleVariation_674.cv_arg") -> "RuleVariation_674":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_685:
        return self.arg # type: ignore

class NonSpare_1776(NonSpare):
    cv_arg: TypeAlias = RuleVariation_674.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_674

    @classmethod
    def create(cls, arg : "NonSpare_1776.cv_arg") -> "NonSpare_1776":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_674:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_685:
        return self.rule.variation

class Item_937(Item):
    cv_arg: TypeAlias = NonSpare_1776.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1776

    @classmethod
    def create(cls, arg : "Item_937.cv_arg") -> "Item_937":
        return cls._create(arg) # type: ignore

class NonSpare_1333(NonSpare):
    cv_arg: TypeAlias = RuleVariation_56.cv_arg
    cv_name = "MSSC"
    cv_title = "Mode-S Specific Service Capability"
    cv_rule: TypeAlias = RuleVariation_56

    @classmethod
    def create(cls, arg : "NonSpare_1333.cv_arg") -> "NonSpare_1333":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_56:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_56:
        return self.rule.variation

class Item_597(Item):
    cv_arg: TypeAlias = NonSpare_1333.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1333

    @classmethod
    def create(cls, arg : "Item_597.cv_arg") -> "Item_597":
        return cls._create(arg) # type: ignore

class NonSpare_671(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "B1B"
    cv_title = "BDS 1,0 Bits 37/40"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_671.cv_arg") -> "NonSpare_671":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_111(Item):
    cv_arg: TypeAlias = NonSpare_671.cv_arg
    cv_non_spare: TypeAlias = NonSpare_671

    @classmethod
    def create(cls, arg : "Item_111.cv_arg") -> "Item_111":
        return cls._create(arg) # type: ignore

class Variation_1077(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_124.cv_arg, Tuple[Literal["COM"], RuleVariation_124.cv_arg]], Union[RuleVariation_674.cv_arg, Tuple[Literal["STAT"], RuleVariation_674.cv_arg]], int, Union[RuleVariation_56.cv_arg, Tuple[Literal["MSSC"], RuleVariation_56.cv_arg]], Union[RuleVariation_390.cv_arg, Tuple[Literal["ARC"], RuleVariation_390.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["AIC"], RuleVariation_547.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["B1A"], RuleVariation_603.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["B1B"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1077.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_188, 3), (Item_937, 3), (Item_27, 2), (Item_597, 1), (Item_81, 1), (Item_55, 1), (Item_109, 1), (Item_111, 4)]
    cv_items_dict = {"COM": RuleVariation_124, "STAT": RuleVariation_674, "MSSC": RuleVariation_56, "ARC": RuleVariation_390, "AIC": RuleVariation_547, "B1A": RuleVariation_603, "B1B": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_674:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSSC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["MSSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_674:
        ...
    @overload
    def get_item(self, key : Literal["MSSC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1077.cv_arg") -> 'Variation_1077':
        return cls._create(arg) # type: ignore

class RuleVariation_1037(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1077.cv_arg
    cv_variation: TypeAlias = Variation_1077

    @classmethod
    def create(cls, arg : "RuleVariation_1037.cv_arg") -> "RuleVariation_1037":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1077:
        return self.arg # type: ignore

class NonSpare_431(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1037.cv_arg
    cv_name = "230"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1037

    @classmethod
    def create(cls, arg : "NonSpare_431.cv_arg") -> "NonSpare_431":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1037:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1077:
        return self.rule.variation

class UapItem_431(UapItem):
    cv_non_spare: TypeAlias = NonSpare_431

class NonSpare_453(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_453.cv_arg") -> "NonSpare_453":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class UapItem_453(UapItem):
    cv_non_spare: TypeAlias = NonSpare_453

class Content_397(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 3: "Split plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code"}

class RuleContent_397(RuleContentContextFree):
    cv_arg: TypeAlias = Content_397.cv_arg
    cv_content: TypeAlias = Content_397

    @property
    def content(self) -> Content_397:
        return self._get_content() # type: ignore

class Variation_157(Element):
    cv_arg: TypeAlias = RuleContent_397.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_397

    @classmethod
    def create(cls, arg: "Variation_157.cv_arg") -> "Variation_157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_397:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_397:
        return self.rule.content

class Variation_1460(Repetitive):
    cv_arg: TypeAlias = List[Variation_157.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_157

    @classmethod
    def create(cls, arg: "Variation_1460.cv_arg") -> 'Variation_1460':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_157]:
        return self._get_list() # type: ignore

class RuleVariation_1381(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1460.cv_arg
    cv_variation: TypeAlias = Variation_1460

    @classmethod
    def create(cls, arg : "RuleVariation_1381.cv_arg") -> "RuleVariation_1381":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1460:
        return self.arg # type: ignore

class NonSpare_118(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1381.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions"
    cv_rule: TypeAlias = RuleVariation_1381

    @classmethod
    def create(cls, arg : "NonSpare_118.cv_arg") -> "NonSpare_118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1381:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1460:
        return self.rule.variation

class UapItem_118(UapItem):
    cv_non_spare: TypeAlias = NonSpare_118

class Content_284(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-1 code derived from the reply of the transponder", 1: "Smoothed Mode-1 code as provided by a local tracker"}

class RuleContent_284(RuleContentContextFree):
    cv_arg: TypeAlias = Content_284.cv_arg
    cv_content: TypeAlias = Content_284

    @property
    def content(self) -> Content_284:
        return self._get_content() # type: ignore

class Variation_547(Element):
    cv_arg: TypeAlias = RuleContent_284.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_284

    @classmethod
    def create(cls, arg: "Variation_547.cv_arg") -> "Variation_547":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_284:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_284:
        return self.rule.content

class RuleVariation_536(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_547.cv_arg
    cv_variation: TypeAlias = Variation_547

    @classmethod
    def create(cls, arg : "RuleVariation_536.cv_arg") -> "RuleVariation_536":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_547:
        return self.arg # type: ignore

class NonSpare_1135(NonSpare):
    cv_arg: TypeAlias = RuleVariation_536.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_536

    @classmethod
    def create(cls, arg : "NonSpare_1135.cv_arg") -> "NonSpare_1135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_536:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_547:
        return self.rule.variation

class Item_447(Item):
    cv_arg: TypeAlias = NonSpare_1135.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1135

    @classmethod
    def create(cls, arg : "Item_447.cv_arg") -> "Item_447":
        return cls._create(arg) # type: ignore

class Variation_695(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 5
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_695.cv_arg") -> "Variation_695":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_684(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_695.cv_arg
    cv_variation: TypeAlias = Variation_695

    @classmethod
    def create(cls, arg : "RuleVariation_684.cv_arg") -> "RuleVariation_684":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_695:
        return self.arg # type: ignore

class NonSpare_1301(NonSpare):
    cv_arg: TypeAlias = RuleVariation_684.cv_arg
    cv_name = "MODE1"
    cv_title = "Mode-1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_684

    @classmethod
    def create(cls, arg : "NonSpare_1301.cv_arg") -> "NonSpare_1301":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

class Item_567(Item):
    cv_arg: TypeAlias = NonSpare_1301.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1301

    @classmethod
    def create(cls, arg : "Item_567.cv_arg") -> "Item_567":
        return cls._create(arg) # type: ignore

class Variation_1273(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_536.cv_arg, Tuple[Literal["L"], RuleVariation_536.cv_arg]], Union[RuleVariation_684.cv_arg, Tuple[Literal["MODE1"], RuleVariation_684.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1273.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_447, 1), (Item_567, 5)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_536, "MODE1": RuleVariation_684}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_536:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE1"]) -> RuleVariation_684:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_536:
        ...
    @overload
    def get_item(self, key : Literal["MODE1"]) -> RuleVariation_684:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1273.cv_arg") -> 'Variation_1273':
        return cls._create(arg) # type: ignore

class RuleVariation_1202(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1273.cv_arg
    cv_variation: TypeAlias = Variation_1273

    @classmethod
    def create(cls, arg : "RuleVariation_1202.cv_arg") -> "RuleVariation_1202":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1273:
        return self.arg # type: ignore

class NonSpare_187(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1202.cv_arg
    cv_name = "055"
    cv_title = "Mode-1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1202

    @classmethod
    def create(cls, arg : "NonSpare_187.cv_arg") -> "NonSpare_187":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1202:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1273:
        return self.rule.variation

class UapItem_187(UapItem):
    cv_non_spare: TypeAlias = NonSpare_187

class Content_287(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-2 code derived from the reply of the transponder", 1: "Smoothed Mode-2 code as provided by a local tracker n"}

class RuleContent_287(RuleContentContextFree):
    cv_arg: TypeAlias = Content_287.cv_arg
    cv_content: TypeAlias = Content_287

    @property
    def content(self) -> Content_287:
        return self._get_content() # type: ignore

class Variation_550(Element):
    cv_arg: TypeAlias = RuleContent_287.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_287

    @classmethod
    def create(cls, arg: "Variation_550.cv_arg") -> "Variation_550":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_287:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_287:
        return self.rule.content

class RuleVariation_539(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_550.cv_arg
    cv_variation: TypeAlias = Variation_550

    @classmethod
    def create(cls, arg : "RuleVariation_539.cv_arg") -> "RuleVariation_539":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_550:
        return self.arg # type: ignore

class NonSpare_1138(NonSpare):
    cv_arg: TypeAlias = RuleVariation_539.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_539

    @classmethod
    def create(cls, arg : "NonSpare_1138.cv_arg") -> "NonSpare_1138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_539:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_550:
        return self.rule.variation

class Item_450(Item):
    cv_arg: TypeAlias = NonSpare_1138.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1138

    @classmethod
    def create(cls, arg : "Item_450.cv_arg") -> "Item_450":
        return cls._create(arg) # type: ignore

class NonSpare_1304(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE2"
    cv_title = "Mode-2 Reply in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1304.cv_arg") -> "NonSpare_1304":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_570(Item):
    cv_arg: TypeAlias = NonSpare_1304.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1304

    @classmethod
    def create(cls, arg : "Item_570.cv_arg") -> "Item_570":
        return cls._create(arg) # type: ignore

class Variation_1274(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_539.cv_arg, Tuple[Literal["L"], RuleVariation_539.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE2"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1274.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_450, 1), (Item_16, 1), (Item_570, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_539, "MODE2": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_539:
        ...
    @overload
    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1274.cv_arg") -> 'Variation_1274':
        return cls._create(arg) # type: ignore

class RuleVariation_1203(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1274.cv_arg
    cv_variation: TypeAlias = Variation_1274

    @classmethod
    def create(cls, arg : "RuleVariation_1203.cv_arg") -> "RuleVariation_1203":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1274:
        return self.arg # type: ignore

class NonSpare_175(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1203.cv_arg
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1203

    @classmethod
    def create(cls, arg : "NonSpare_175.cv_arg") -> "NonSpare_175":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1203:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1274:
        return self.rule.variation

class UapItem_175(UapItem):
    cv_non_spare: TypeAlias = NonSpare_175

class Record_37(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_42.cv_arg,
        "020": NonSpare_86.cv_arg,
        "140": NonSpare_328.cv_arg,
        "041": NonSpare_154.cv_arg,
        "042": NonSpare_162.cv_arg,
        "161": NonSpare_363.cv_arg,
        "170": NonSpare_376.cv_arg,
        "070": NonSpare_214.cv_arg,
        "202": NonSpare_405.cv_arg,
        "090": NonSpare_251.cv_arg,
        "100": NonSpare_272.cv_arg,
        "220": NonSpare_427.cv_arg,
        "245": NonSpare_443.cv_arg,
        "110": NonSpare_288.cv_arg,
        "105": NonSpare_282.cv_arg,
        "210": NonSpare_407.cv_arg,
        "300": NonSpare_477.cv_arg,
        "310": NonSpare_478.cv_arg,
        "500": NonSpare_517.cv_arg,
        "400": NonSpare_497.cv_arg,
        "250": NonSpare_449.cv_arg,
        "230": NonSpare_431.cv_arg,
        "260": NonSpare_453.cv_arg,
        "030": NonSpare_118.cv_arg,
        "055": NonSpare_187.cv_arg,
        "050": NonSpare_175.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_42, UapItem_86, UapItem_328, UapItem_154, UapItem_162, UapItem_363, UapItem_376, UapItem_214, UapItem_405, UapItem_251, UapItem_272, UapItem_427, UapItem_443, UapItem_288, UapItem_282, UapItem_407, UapItem_477, UapItem_478, UapItem_516, UapItem_496, UapItem_449, UapItem_431, UapItem_453, UapItem_118, UapItem_187, UapItem_175, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_42, "020": NonSpare_86, "140": NonSpare_328, "041": NonSpare_154, "042": NonSpare_162, "161": NonSpare_363, "170": NonSpare_376, "070": NonSpare_214, "202": NonSpare_405, "090": NonSpare_251, "100": NonSpare_272, "220": NonSpare_427, "245": NonSpare_443, "110": NonSpare_288, "105": NonSpare_282, "210": NonSpare_407, "300": NonSpare_477, "310": NonSpare_478, "500": NonSpare_517, "400": NonSpare_497, "250": NonSpare_449, "230": NonSpare_431, "260": NonSpare_453, "030": NonSpare_118, "055": NonSpare_187, "050": NonSpare_175, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_86:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_154:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_162:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_363:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_376:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_214:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_405:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_427:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_443:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_288:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_282:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_407:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_478:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_517:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_497:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_453:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_187:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_175:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["140"], Literal["041"], Literal["042"], Literal["161"], Literal["170"], Literal["070"], Literal["202"], Literal["090"], Literal["100"], Literal["220"], Literal["245"], Literal["110"], Literal["105"], Literal["210"], Literal["300"], Literal["310"], Literal["500"], Literal["400"], Literal["250"], Literal["230"], Literal["260"], Literal["030"], Literal["055"], Literal["050"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_42]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_86]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_154]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_162]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_363]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_376]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_214]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_405]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_251]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_272]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_427]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_443]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_288]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_282]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_407]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_478]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_517]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_497]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_449]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_431]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_453]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_118]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_187]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_175]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_42.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_86.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_154.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_162.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_363.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_376.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_214.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_405.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_251.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_272.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_427.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_443.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_288.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_282.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_407.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_478.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_517.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_497.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_449.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_431.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_453.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_118.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_187.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_175.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_37':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_37':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_37':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_37':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_37.cv_arg") -> 'Record_37':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_37", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_33(UapSingle):
    cv_arg: TypeAlias = Record_37
    cv_record: TypeAlias = Record_37

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_37]]:
        return cls._parse(bs)

class Asterix_22(AstCat):
    cv_category = 20
    cv_edition = (1, 9)
    cv_uap: TypeAlias = Uap_33
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_33.cv_arg]) -> "Asterix_22":
        return cls._create(records) # type: ignore

class Content_385(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not Coasted", 1: "Coasted"}

class RuleContent_385(RuleContentContextFree):
    cv_arg: TypeAlias = Content_385.cv_arg
    cv_content: TypeAlias = Content_385

    @property
    def content(self) -> Content_385:
        return self._get_content() # type: ignore

class Variation_566(Element):
    cv_arg: TypeAlias = RuleContent_385.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_385

    @classmethod
    def create(cls, arg: "Variation_566.cv_arg") -> "Variation_566":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_385:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_385:
        return self.rule.content

class RuleVariation_555(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_566.cv_arg
    cv_variation: TypeAlias = Variation_566

    @classmethod
    def create(cls, arg : "RuleVariation_555.cv_arg") -> "RuleVariation_555":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_566:
        return self.arg # type: ignore

class NonSpare_840(NonSpare):
    cv_arg: TypeAlias = RuleVariation_555.cv_arg
    cv_name = "CST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_555

    @classmethod
    def create(cls, arg : "NonSpare_840.cv_arg") -> "NonSpare_840":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_555:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_566:
        return self.rule.variation

class Item_223(Item):
    cv_arg: TypeAlias = NonSpare_840.cv_arg
    cv_non_spare: TypeAlias = NonSpare_840

    @classmethod
    def create(cls, arg : "Item_223.cv_arg") -> "Item_223":
        return cls._create(arg) # type: ignore

class Variation_1352(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_19.cv_arg, Tuple[Literal["CNF"], RuleVariation_19.cv_arg]], Union[RuleVariation_400.cv_arg, Tuple[Literal["TRE"], RuleVariation_400.cv_arg]], Union[RuleVariation_555.cv_arg, Tuple[Literal["CST"], RuleVariation_555.cv_arg]], Union[RuleVariation_667.cv_arg, Tuple[Literal["CDM"], RuleVariation_667.cv_arg]], Union[RuleVariation_801.cv_arg, Tuple[Literal["MAH"], RuleVariation_801.cv_arg]], Union[RuleVariation_907.cv_arg, Tuple[Literal["STH"], RuleVariation_907.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_28.cv_arg, Tuple[Literal["GHO"], RuleVariation_28.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1352.cv_arg_group_1"],
        Tuple["Variation_1352.cv_arg_group_1", "Variation_1352.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_166, 1), (Item_1036, 1), (Item_223, 1), (Item_140, 2), (Item_525, 1), (Item_949, 1), None], [(Item_370, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1352.cv_arg") -> 'Variation_1352':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_19:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> RuleVariation_400:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> RuleVariation_555:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> RuleVariation_667:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_801:
        ...
    @overload
    def get_item(self, key : Literal["STH"]) -> RuleVariation_907:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_28]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1273(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1352.cv_arg
    cv_variation: TypeAlias = Variation_1352

    @classmethod
    def create(cls, arg : "RuleVariation_1273.cv_arg") -> "RuleVariation_1273":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1352:
        return self.arg # type: ignore

class NonSpare_375(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1273.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1273

    @classmethod
    def create(cls, arg : "NonSpare_375.cv_arg") -> "NonSpare_375":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1352:
        return self.rule.variation

class UapItem_375(UapItem):
    cv_non_spare: TypeAlias = NonSpare_375

class NonSpare_425(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "220"
    cv_title = "Target Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_425.cv_arg") -> "NonSpare_425":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_425(UapItem):
    cv_non_spare: TypeAlias = NonSpare_425

class NonSpare_444(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1343.cv_arg
    cv_name = "250"
    cv_title = "BDS Register Data"
    cv_rule: TypeAlias = RuleVariation_1343

    @classmethod
    def create(cls, arg : "NonSpare_444.cv_arg") -> "NonSpare_444":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1422:
        return self.rule.variation

class UapItem_444(UapItem):
    cv_non_spare: TypeAlias = NonSpare_444

class Record_36(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_42.cv_arg,
        "020": NonSpare_86.cv_arg,
        "140": NonSpare_328.cv_arg,
        "041": NonSpare_154.cv_arg,
        "042": NonSpare_162.cv_arg,
        "161": NonSpare_363.cv_arg,
        "170": NonSpare_375.cv_arg,
        "070": NonSpare_214.cv_arg,
        "202": NonSpare_405.cv_arg,
        "090": NonSpare_251.cv_arg,
        "100": NonSpare_272.cv_arg,
        "220": NonSpare_425.cv_arg,
        "245": NonSpare_443.cv_arg,
        "110": NonSpare_288.cv_arg,
        "105": NonSpare_282.cv_arg,
        "210": NonSpare_407.cv_arg,
        "300": NonSpare_477.cv_arg,
        "310": NonSpare_478.cv_arg,
        "500": NonSpare_517.cv_arg,
        "400": NonSpare_497.cv_arg,
        "250": NonSpare_444.cv_arg,
        "230": NonSpare_431.cv_arg,
        "260": NonSpare_453.cv_arg,
        "030": NonSpare_118.cv_arg,
        "055": NonSpare_187.cv_arg,
        "050": NonSpare_175.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_42, UapItem_86, UapItem_328, UapItem_154, UapItem_162, UapItem_363, UapItem_375, UapItem_214, UapItem_405, UapItem_251, UapItem_272, UapItem_425, UapItem_443, UapItem_288, UapItem_282, UapItem_407, UapItem_477, UapItem_478, UapItem_516, UapItem_496, UapItem_444, UapItem_431, UapItem_453, UapItem_118, UapItem_187, UapItem_175, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_42, "020": NonSpare_86, "140": NonSpare_328, "041": NonSpare_154, "042": NonSpare_162, "161": NonSpare_363, "170": NonSpare_375, "070": NonSpare_214, "202": NonSpare_405, "090": NonSpare_251, "100": NonSpare_272, "220": NonSpare_425, "245": NonSpare_443, "110": NonSpare_288, "105": NonSpare_282, "210": NonSpare_407, "300": NonSpare_477, "310": NonSpare_478, "500": NonSpare_517, "400": NonSpare_497, "250": NonSpare_444, "230": NonSpare_431, "260": NonSpare_453, "030": NonSpare_118, "055": NonSpare_187, "050": NonSpare_175, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_86:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_328:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_154:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_162:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_363:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_375:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_214:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["202"]) -> NonSpare_405:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_425:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_443:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_288:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_282:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_407:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["310"]) -> NonSpare_478:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_517:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_497:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_444:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_453:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_187:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_175:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["140"], Literal["041"], Literal["042"], Literal["161"], Literal["170"], Literal["070"], Literal["202"], Literal["090"], Literal["100"], Literal["220"], Literal["245"], Literal["110"], Literal["105"], Literal["210"], Literal["300"], Literal["310"], Literal["500"], Literal["400"], Literal["250"], Literal["230"], Literal["260"], Literal["030"], Literal["055"], Literal["050"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_42]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_86]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_328]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_154]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_162]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_363]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_375]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_214]:
        ...
    @overload
    def get_item(self, key : Literal["202"]) -> Optional[NonSpare_405]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_251]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_272]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_425]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_443]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_288]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_282]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_407]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["310"]) -> Optional[NonSpare_478]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_517]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_497]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_444]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_431]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_453]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_118]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_187]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_175]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_42.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_86.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_328.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_154.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_162.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_363.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_375.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_214.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["202"], val : NonSpare_405.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_251.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_272.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_425.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_443.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_288.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_282.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_407.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["310"], val : NonSpare_478.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_517.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_497.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_444.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_431.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_453.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_118.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_187.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_175.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_36':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_36':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["202"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["310"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_36':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_36':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_36.cv_arg") -> 'Record_36':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_36", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_32(UapSingle):
    cv_arg: TypeAlias = Record_36
    cv_record: TypeAlias = Record_36

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_36]]:
        return cls._parse(bs)

class Asterix_23(AstCat):
    cv_category = 20
    cv_edition = (1, 10)
    cv_uap: TypeAlias = Uap_32
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_32.cv_arg]) -> "Asterix_23":
        return cls._create(records) # type: ignore

class NonSpare_29(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identification"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_29.cv_arg") -> "NonSpare_29":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_29(UapItem):
    cv_non_spare: TypeAlias = NonSpare_29

class Variation_61(Element):
    cv_arg: TypeAlias = RuleContent_352.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_352

    @classmethod
    def create(cls, arg: "Variation_61.cv_arg") -> "Variation_61":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_352:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_352:
        return self.rule.content

class RuleVariation_61(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_61.cv_arg
    cv_variation: TypeAlias = Variation_61

    @classmethod
    def create(cls, arg : "RuleVariation_61.cv_arg") -> "RuleVariation_61":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_61:
        return self.arg # type: ignore

class NonSpare_876(NonSpare):
    cv_arg: TypeAlias = RuleVariation_61.cv_arg
    cv_name = "DCR"
    cv_title = "Differential Correction"
    cv_rule: TypeAlias = RuleVariation_61

    @classmethod
    def create(cls, arg : "NonSpare_876.cv_arg") -> "NonSpare_876":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_61:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_61:
        return self.rule.variation

class Item_254(Item):
    cv_arg: TypeAlias = NonSpare_876.cv_arg
    cv_non_spare: TypeAlias = NonSpare_876

    @classmethod
    def create(cls, arg : "Item_254.cv_arg") -> "Item_254":
        return cls._create(arg) # type: ignore

class Content_221(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Ground Bit not set", 1: "Ground Bit set"}

class RuleContent_221(RuleContentContextFree):
    cv_arg: TypeAlias = Content_221.cv_arg
    cv_content: TypeAlias = Content_221

    @property
    def content(self) -> Content_221:
        return self._get_content() # type: ignore

class Variation_429(Element):
    cv_arg: TypeAlias = RuleContent_221.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_221

    @classmethod
    def create(cls, arg: "Variation_429.cv_arg") -> "Variation_429":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_221:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_221:
        return self.rule.content

class RuleVariation_418(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_429.cv_arg
    cv_variation: TypeAlias = Variation_429

    @classmethod
    def create(cls, arg : "RuleVariation_418.cv_arg") -> "RuleVariation_418":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_429:
        return self.arg # type: ignore

class NonSpare_1031(NonSpare):
    cv_arg: TypeAlias = RuleVariation_418.cv_arg
    cv_name = "GBS"
    cv_title = "Ground Bit Setting"
    cv_rule: TypeAlias = RuleVariation_418

    @classmethod
    def create(cls, arg : "NonSpare_1031.cv_arg") -> "NonSpare_1031":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_418:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_429:
        return self.rule.variation

class Item_369(Item):
    cv_arg: TypeAlias = NonSpare_1031.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1031

    @classmethod
    def create(cls, arg : "Item_369.cv_arg") -> "Item_369":
        return cls._create(arg) # type: ignore

class Variation_508(Element):
    cv_arg: TypeAlias = RuleContent_19.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg: "Variation_508.cv_arg") -> "Variation_508":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_19:
        return self.rule.content

class RuleVariation_497(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_508.cv_arg
    cv_variation: TypeAlias = Variation_508

    @classmethod
    def create(cls, arg : "RuleVariation_497.cv_arg") -> "RuleVariation_497":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_508:
        return self.arg # type: ignore

class NonSpare_1728(NonSpare):
    cv_arg: TypeAlias = RuleVariation_497.cv_arg
    cv_name = "SIM"
    cv_title = "Simulated Target"
    cv_rule: TypeAlias = RuleVariation_497

    @classmethod
    def create(cls, arg : "NonSpare_1728.cv_arg") -> "NonSpare_1728":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_497:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_508:
        return self.rule.variation

class Item_903(Item):
    cv_arg: TypeAlias = NonSpare_1728.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1728

    @classmethod
    def create(cls, arg : "Item_903.cv_arg") -> "Item_903":
        return cls._create(arg) # type: ignore

class Variation_633(Element):
    cv_arg: TypeAlias = RuleContent_155.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_155

    @classmethod
    def create(cls, arg: "Variation_633.cv_arg") -> "Variation_633":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_155:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_155:
        return self.rule.content

class RuleVariation_622(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_633.cv_arg
    cv_variation: TypeAlias = Variation_633

    @classmethod
    def create(cls, arg : "RuleVariation_622.cv_arg") -> "RuleVariation_622":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_633:
        return self.arg # type: ignore

class NonSpare_1939(NonSpare):
    cv_arg: TypeAlias = RuleVariation_622.cv_arg
    cv_name = "TST"
    cv_title = "Test Target"
    cv_rule: TypeAlias = RuleVariation_622

    @classmethod
    def create(cls, arg : "NonSpare_1939.cv_arg") -> "NonSpare_1939":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_622:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_633:
        return self.rule.variation

class Item_1056(Item):
    cv_arg: TypeAlias = NonSpare_1939.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1939

    @classmethod
    def create(cls, arg : "Item_1056.cv_arg") -> "Item_1056":
        return cls._create(arg) # type: ignore

class Variation_749(Element):
    cv_arg: TypeAlias = RuleContent_442.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_442

    @classmethod
    def create(cls, arg: "Variation_749.cv_arg") -> "Variation_749":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_442:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_442:
        return self.rule.content

class RuleVariation_738(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_749.cv_arg
    cv_variation: TypeAlias = Variation_749

    @classmethod
    def create(cls, arg : "RuleVariation_738.cv_arg") -> "RuleVariation_738":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_749:
        return self.arg # type: ignore

class NonSpare_1541(NonSpare):
    cv_arg: TypeAlias = RuleVariation_738.cv_arg
    cv_name = "RAB"
    cv_title = "Report Type"
    cv_rule: TypeAlias = RuleVariation_738

    @classmethod
    def create(cls, arg : "NonSpare_1541.cv_arg") -> "NonSpare_1541":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_738:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_749:
        return self.rule.variation

class Item_771(Item):
    cv_arg: TypeAlias = NonSpare_1541.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1541

    @classmethod
    def create(cls, arg : "Item_771.cv_arg") -> "Item_771":
        return cls._create(arg) # type: ignore

class Content_210(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Equipment capable to provide Selected Altitude", 1: "Equipment not capable to provide Selected Altitude"}

class RuleContent_210(RuleContentContextFree):
    cv_arg: TypeAlias = Content_210.cv_arg
    cv_content: TypeAlias = Content_210

    @property
    def content(self) -> Content_210:
        return self._get_content() # type: ignore

class Variation_849(Element):
    cv_arg: TypeAlias = RuleContent_210.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg: "Variation_849.cv_arg") -> "Variation_849":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_210:
        return self.rule.content

class RuleVariation_819(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_849.cv_arg
    cv_variation: TypeAlias = Variation_849

    @classmethod
    def create(cls, arg : "RuleVariation_819.cv_arg") -> "RuleVariation_819":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_849:
        return self.arg # type: ignore

class NonSpare_1651(NonSpare):
    cv_arg: TypeAlias = RuleVariation_819.cv_arg
    cv_name = "SAA"
    cv_title = "Selected Altitude Available"
    cv_rule: TypeAlias = RuleVariation_819

    @classmethod
    def create(cls, arg : "NonSpare_1651.cv_arg") -> "NonSpare_1651":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_819:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_849:
        return self.rule.variation

class Item_854(Item):
    cv_arg: TypeAlias = NonSpare_1651.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1651

    @classmethod
    def create(cls, arg : "Item_854.cv_arg") -> "Item_854":
        return cls._create(arg) # type: ignore

class Variation_901(Element):
    cv_arg: TypeAlias = RuleContent_13.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg: "Variation_901.cv_arg") -> "Variation_901":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_13:
        return self.rule.content

class RuleVariation_871(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_901.cv_arg
    cv_variation: TypeAlias = Variation_901

    @classmethod
    def create(cls, arg : "RuleVariation_871.cv_arg") -> "RuleVariation_871":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_901:
        return self.arg # type: ignore

class NonSpare_1741(NonSpare):
    cv_arg: TypeAlias = RuleVariation_871.cv_arg
    cv_name = "SPI"
    cv_title = "Special Position Identification"
    cv_rule: TypeAlias = RuleVariation_871

    @classmethod
    def create(cls, arg : "NonSpare_1741.cv_arg") -> "NonSpare_1741":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_871:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_901:
        return self.rule.variation

class Item_914(Item):
    cv_arg: TypeAlias = NonSpare_1741.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1741

    @classmethod
    def create(cls, arg : "Item_914.cv_arg") -> "Item_914":
        return cls._create(arg) # type: ignore

class Content_379(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Non unique address", 1: "24-Bit ICAO address", 2: "Surface vehicle address", 3: "Anonymous address", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

class RuleContent_379(RuleContentContextFree):
    cv_arg: TypeAlias = Content_379.cv_arg
    cv_content: TypeAlias = Content_379

    @property
    def content(self) -> Content_379:
        return self._get_content() # type: ignore

class Variation_130(Element):
    cv_arg: TypeAlias = RuleContent_379.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_379

    @classmethod
    def create(cls, arg: "Variation_130.cv_arg") -> "Variation_130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_379:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_379:
        return self.rule.content

class RuleVariation_130(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_130.cv_arg
    cv_variation: TypeAlias = Variation_130

    @classmethod
    def create(cls, arg : "RuleVariation_130.cv_arg") -> "RuleVariation_130":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_130:
        return self.arg # type: ignore

class NonSpare_645(NonSpare):
    cv_arg: TypeAlias = RuleVariation_130.cv_arg
    cv_name = "ATP"
    cv_title = "Address Type"
    cv_rule: TypeAlias = RuleVariation_130

    @classmethod
    def create(cls, arg : "NonSpare_645.cv_arg") -> "NonSpare_645":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_130:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_130:
        return self.rule.variation

class Item_91(Item):
    cv_arg: TypeAlias = NonSpare_645.cv_arg
    cv_non_spare: TypeAlias = NonSpare_645

    @classmethod
    def create(cls, arg : "Item_91.cv_arg") -> "Item_91":
        return cls._create(arg) # type: ignore

class Content_534(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "25 ft", 2: "100 ft"}

class RuleContent_534(RuleContentContextFree):
    cv_arg: TypeAlias = Content_534.cv_arg
    cv_content: TypeAlias = Content_534

    @property
    def content(self) -> Content_534:
        return self._get_content() # type: ignore

class Variation_683(Element):
    cv_arg: TypeAlias = RuleContent_534.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_534

    @classmethod
    def create(cls, arg: "Variation_683.cv_arg") -> "Variation_683":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_534:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_534:
        return self.rule.content

class RuleVariation_672(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_683.cv_arg
    cv_variation: TypeAlias = Variation_683

    @classmethod
    def create(cls, arg : "RuleVariation_672.cv_arg") -> "RuleVariation_672":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_683:
        return self.arg # type: ignore

class NonSpare_628(NonSpare):
    cv_arg: TypeAlias = RuleVariation_672.cv_arg
    cv_name = "ARC"
    cv_title = "Altitude Reporting Capability"
    cv_rule: TypeAlias = RuleVariation_672

    @classmethod
    def create(cls, arg : "NonSpare_628.cv_arg") -> "NonSpare_628":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_672:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_683:
        return self.rule.variation

class Item_83(Item):
    cv_arg: TypeAlias = NonSpare_628.cv_arg
    cv_non_spare: TypeAlias = NonSpare_628

    @classmethod
    def create(cls, arg : "Item_83.cv_arg") -> "Item_83":
        return cls._create(arg) # type: ignore

class Variation_1083(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_61.cv_arg, Tuple[Literal["DCR"], RuleVariation_61.cv_arg]], Union[RuleVariation_418.cv_arg, Tuple[Literal["GBS"], RuleVariation_418.cv_arg]], Union[RuleVariation_497.cv_arg, Tuple[Literal["SIM"], RuleVariation_497.cv_arg]], Union[RuleVariation_622.cv_arg, Tuple[Literal["TST"], RuleVariation_622.cv_arg]], Union[RuleVariation_738.cv_arg, Tuple[Literal["RAB"], RuleVariation_738.cv_arg]], Union[RuleVariation_819.cv_arg, Tuple[Literal["SAA"], RuleVariation_819.cv_arg]], Union[RuleVariation_871.cv_arg, Tuple[Literal["SPI"], RuleVariation_871.cv_arg]], int, Union[RuleVariation_130.cv_arg, Tuple[Literal["ATP"], RuleVariation_130.cv_arg]], Union[RuleVariation_672.cv_arg, Tuple[Literal["ARC"], RuleVariation_672.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1083.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_254, 1), (Item_369, 1), (Item_903, 1), (Item_1056, 1), (Item_771, 1), (Item_854, 1), (Item_914, 1), (Item_29, 1), (Item_91, 3), (Item_83, 2), (Item_25, 3)]
    cv_items_dict = {"DCR": RuleVariation_61, "GBS": RuleVariation_418, "SIM": RuleVariation_497, "TST": RuleVariation_622, "RAB": RuleVariation_738, "SAA": RuleVariation_819, "SPI": RuleVariation_871, "ATP": RuleVariation_130, "ARC": RuleVariation_672}

    @overload
    @classmethod
    def spec(cls, key : Literal["DCR"]) -> RuleVariation_61:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GBS"]) -> RuleVariation_418:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIM"]) -> RuleVariation_497:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TST"]) -> RuleVariation_622:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAB"]) -> RuleVariation_738:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAA"]) -> RuleVariation_819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SPI"]) -> RuleVariation_871:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATP"]) -> RuleVariation_130:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_672:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DCR"], Literal["GBS"], Literal["SIM"], Literal["TST"], Literal["RAB"], Literal["SAA"], Literal["SPI"], Literal["ATP"], Literal["ARC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DCR"]) -> RuleVariation_61:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_418:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_497:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> RuleVariation_622:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_738:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> RuleVariation_819:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_871:
        ...
    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_130:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_672:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1083.cv_arg") -> 'Variation_1083':
        return cls._create(arg) # type: ignore

class RuleVariation_1043(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1083.cv_arg
    cv_variation: TypeAlias = Variation_1083

    @classmethod
    def create(cls, arg : "RuleVariation_1043.cv_arg") -> "RuleVariation_1043":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1083:
        return self.arg # type: ignore

class NonSpare_144(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1043.cv_arg
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1043

    @classmethod
    def create(cls, arg : "NonSpare_144.cv_arg") -> "NonSpare_144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1043:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1083:
        return self.rule.variation

class UapItem_144(UapItem):
    cv_non_spare: TypeAlias = NonSpare_144

class NonSpare_110(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_110.cv_arg") -> "NonSpare_110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_110(UapItem):
    cv_non_spare: TypeAlias = NonSpare_110

class Content_695(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_695(RuleContentContextFree):
    cv_arg: TypeAlias = Content_695.cv_arg
    cv_content: TypeAlias = Content_695

    @property
    def content(self) -> Content_695:
        return self._get_content() # type: ignore

class Variation_360(Element):
    cv_arg: TypeAlias = RuleContent_695.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_695

    @classmethod
    def create(cls, arg: "Variation_360.cv_arg") -> "Variation_360":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_695:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_695:
        return self.rule.content

class RuleVariation_353(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_360.cv_arg
    cv_variation: TypeAlias = Variation_360

    @classmethod
    def create(cls, arg : "RuleVariation_353.cv_arg") -> "RuleVariation_353":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_360:
        return self.arg # type: ignore

class NonSpare_1150(NonSpare):
    cv_arg: TypeAlias = RuleVariation_353.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule: TypeAlias = RuleVariation_353

    @classmethod
    def create(cls, arg : "NonSpare_1150.cv_arg") -> "NonSpare_1150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_360:
        return self.rule.variation

class Item_462(Item):
    cv_arg: TypeAlias = NonSpare_1150.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1150

    @classmethod
    def create(cls, arg : "Item_462.cv_arg") -> "Item_462":
        return cls._create(arg) # type: ignore

class Content_693(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_693(RuleContentContextFree):
    cv_arg: TypeAlias = Content_693.cv_arg
    cv_content: TypeAlias = Content_693

    @property
    def content(self) -> Content_693:
        return self._get_content() # type: ignore

class Variation_358(Element):
    cv_arg: TypeAlias = RuleContent_693.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_693

    @classmethod
    def create(cls, arg: "Variation_358.cv_arg") -> "Variation_358":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_693:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_693:
        return self.rule.content

class RuleVariation_351(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_358.cv_arg
    cv_variation: TypeAlias = Variation_358

    @classmethod
    def create(cls, arg : "RuleVariation_351.cv_arg") -> "RuleVariation_351":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_358:
        return self.arg # type: ignore

class NonSpare_1179(NonSpare):
    cv_arg: TypeAlias = RuleVariation_351.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_351

    @classmethod
    def create(cls, arg : "NonSpare_1179.cv_arg") -> "NonSpare_1179":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

class Item_489(Item):
    cv_arg: TypeAlias = NonSpare_1179.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1179

    @classmethod
    def create(cls, arg : "Item_489.cv_arg") -> "Item_489":
        return cls._create(arg) # type: ignore

class Variation_1126(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_353.cv_arg, Tuple[Literal["LAT"], RuleVariation_353.cv_arg]], Union[RuleVariation_351.cv_arg, Tuple[Literal["LON"], RuleVariation_351.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1126.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_462, 24), (Item_489, 24)]
    cv_items_dict = {"LAT": RuleVariation_353, "LON": RuleVariation_351}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_351:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_351:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1126.cv_arg") -> 'Variation_1126':
        return cls._create(arg) # type: ignore

class RuleVariation_1082(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1126.cv_arg
    cv_variation: TypeAlias = Variation_1126

    @classmethod
    def create(cls, arg : "RuleVariation_1082.cv_arg") -> "RuleVariation_1082":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1126:
        return self.arg # type: ignore

class NonSpare_309(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1082.cv_arg
    cv_name = "130"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1082

    @classmethod
    def create(cls, arg : "NonSpare_309.cv_arg") -> "NonSpare_309":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1082:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1126:
        return self.rule.variation

class UapItem_309(UapItem):
    cv_non_spare: TypeAlias = NonSpare_309

class NonSpare_237(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "080"
    cv_title = "Target Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_237.cv_arg") -> "NonSpare_237":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_237(UapItem):
    cv_non_spare: TypeAlias = NonSpare_237

class Content_686(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_686(RuleContentContextFree):
    cv_arg: TypeAlias = Content_686.cv_arg
    cv_content: TypeAlias = Content_686

    @property
    def content(self) -> Content_686:
        return self._get_content() # type: ignore

class Variation_291(Element):
    cv_arg: TypeAlias = RuleContent_686.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_686

    @classmethod
    def create(cls, arg: "Variation_291.cv_arg") -> "Variation_291":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_686:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_686:
        return self.rule.content

class RuleVariation_284(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_291.cv_arg
    cv_variation: TypeAlias = Variation_291

    @classmethod
    def create(cls, arg : "RuleVariation_284.cv_arg") -> "RuleVariation_284":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_291:
        return self.arg # type: ignore

class NonSpare_322(NonSpare):
    cv_arg: TypeAlias = RuleVariation_284.cv_arg
    cv_name = "140"
    cv_title = "Geometric Altitude"
    cv_rule: TypeAlias = RuleVariation_284

    @classmethod
    def create(cls, arg : "NonSpare_322.cv_arg") -> "NonSpare_322":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

class UapItem_322(UapItem):
    cv_non_spare: TypeAlias = NonSpare_322

class Content_535(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "ACAS not operational", 2: "ACAS operartional", 3: "Invalid"}

class RuleContent_535(RuleContentContextFree):
    cv_arg: TypeAlias = Content_535.cv_arg
    cv_content: TypeAlias = Content_535

    @property
    def content(self) -> Content_535:
        return self._get_content() # type: ignore

class Variation_114(Element):
    cv_arg: TypeAlias = RuleContent_535.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_535

    @classmethod
    def create(cls, arg: "Variation_114.cv_arg") -> "Variation_114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_535:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_535:
        return self.rule.content

class RuleVariation_114(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_114.cv_arg
    cv_variation: TypeAlias = Variation_114

    @classmethod
    def create(cls, arg : "RuleVariation_114.cv_arg") -> "RuleVariation_114":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_114:
        return self.arg # type: ignore

class NonSpare_554(NonSpare):
    cv_arg: TypeAlias = RuleVariation_114.cv_arg
    cv_name = "AC"
    cv_title = "ACAS Capabilities"
    cv_rule: TypeAlias = RuleVariation_114

    @classmethod
    def create(cls, arg : "NonSpare_554.cv_arg") -> "NonSpare_554":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_114:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_114:
        return self.rule.variation

class Item_36(Item):
    cv_arg: TypeAlias = NonSpare_554.cv_arg
    cv_non_spare: TypeAlias = NonSpare_554

    @classmethod
    def create(cls, arg : "Item_36.cv_arg") -> "Item_36":
        return cls._create(arg) # type: ignore

class Content_549(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Multiple Navigation not operational", 2: "Multiple Navigation operartional", 3: "Invalid"}

class RuleContent_549(RuleContentContextFree):
    cv_arg: TypeAlias = Content_549.cv_arg
    cv_content: TypeAlias = Content_549

    @property
    def content(self) -> Content_549:
        return self._get_content() # type: ignore

class Variation_595(Element):
    cv_arg: TypeAlias = RuleContent_549.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_549

    @classmethod
    def create(cls, arg: "Variation_595.cv_arg") -> "Variation_595":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_549:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_549:
        return self.rule.content

class RuleVariation_584(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_595.cv_arg
    cv_variation: TypeAlias = Variation_595

    @classmethod
    def create(cls, arg : "RuleVariation_584.cv_arg") -> "RuleVariation_584":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_595:
        return self.arg # type: ignore

class NonSpare_1295(NonSpare):
    cv_arg: TypeAlias = RuleVariation_584.cv_arg
    cv_name = "MN"
    cv_title = "Multiple Navigation Aids"
    cv_rule: TypeAlias = RuleVariation_584

    @classmethod
    def create(cls, arg : "NonSpare_1295.cv_arg") -> "NonSpare_1295":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_584:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_595:
        return self.rule.variation

class Item_561(Item):
    cv_arg: TypeAlias = NonSpare_1295.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1295

    @classmethod
    def create(cls, arg : "Item_561.cv_arg") -> "Item_561":
        return cls._create(arg) # type: ignore

class Content_543(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Differencial Correction", 2: "NO Differencial Correction", 3: "Invalid"}

class RuleContent_543(RuleContentContextFree):
    cv_arg: TypeAlias = Content_543.cv_arg
    cv_content: TypeAlias = Content_543

    @property
    def content(self) -> Content_543:
        return self._get_content() # type: ignore

class Variation_770(Element):
    cv_arg: TypeAlias = RuleContent_543.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_543

    @classmethod
    def create(cls, arg: "Variation_770.cv_arg") -> "Variation_770":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_543:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_543:
        return self.rule.content

class RuleVariation_759(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_770.cv_arg
    cv_variation: TypeAlias = Variation_770

    @classmethod
    def create(cls, arg : "RuleVariation_759.cv_arg") -> "RuleVariation_759":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_770:
        return self.arg # type: ignore

class NonSpare_871(NonSpare):
    cv_arg: TypeAlias = RuleVariation_759.cv_arg
    cv_name = "DC"
    cv_title = "Differencial Correction"
    cv_rule: TypeAlias = RuleVariation_759

    @classmethod
    def create(cls, arg : "NonSpare_871.cv_arg") -> "NonSpare_871":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_759:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_770:
        return self.rule.variation

class Item_249(Item):
    cv_arg: TypeAlias = NonSpare_871.cv_arg
    cv_non_spare: TypeAlias = NonSpare_871

    @classmethod
    def create(cls, arg : "Item_249.cv_arg") -> "Item_249":
        return cls._create(arg) # type: ignore

class Item_28(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 6
    cv_bit_size = 6

class Content_622(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

class RuleContent_622(RuleContentContextFree):
    cv_arg: TypeAlias = Content_622.cv_arg
    cv_content: TypeAlias = Content_622

    @property
    def content(self) -> Content_622:
        return self._get_content() # type: ignore

class Variation_806(Element):
    cv_arg: TypeAlias = RuleContent_622.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_622

    @classmethod
    def create(cls, arg: "Variation_806.cv_arg") -> "Variation_806":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_622:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_622:
        return self.rule.content

class RuleVariation_776(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_806.cv_arg
    cv_variation: TypeAlias = Variation_806

    @classmethod
    def create(cls, arg : "RuleVariation_776.cv_arg") -> "RuleVariation_776":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_806:
        return self.arg # type: ignore

class NonSpare_1419(NonSpare):
    cv_arg: TypeAlias = RuleVariation_776.cv_arg
    cv_name = "PA"
    cv_title = "Position Accuracy"
    cv_rule: TypeAlias = RuleVariation_776

    @classmethod
    def create(cls, arg : "NonSpare_1419.cv_arg") -> "NonSpare_1419":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_776:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_806:
        return self.rule.variation

class Item_676(Item):
    cv_arg: TypeAlias = NonSpare_1419.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1419

    @classmethod
    def create(cls, arg : "Item_676.cv_arg") -> "Item_676":
        return cls._create(arg) # type: ignore

class Variation_1045(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_114.cv_arg, Tuple[Literal["AC"], RuleVariation_114.cv_arg]], Union[RuleVariation_584.cv_arg, Tuple[Literal["MN"], RuleVariation_584.cv_arg]], Union[RuleVariation_759.cv_arg, Tuple[Literal["DC"], RuleVariation_759.cv_arg]], int, Union[RuleVariation_776.cv_arg, Tuple[Literal["PA"], RuleVariation_776.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1045.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_36, 2), (Item_561, 2), (Item_249, 2), (Item_28, 6), (Item_676, 4)]
    cv_items_dict = {"AC": RuleVariation_114, "MN": RuleVariation_584, "DC": RuleVariation_759, "PA": RuleVariation_776}

    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_114:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_584:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_759:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PA"]) -> RuleVariation_776:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AC"], Literal["MN"], Literal["DC"], Literal["PA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_114:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_584:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_759:
        ...
    @overload
    def get_item(self, key : Literal["PA"]) -> RuleVariation_776:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1045.cv_arg") -> 'Variation_1045':
        return cls._create(arg) # type: ignore

class RuleVariation_1012(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1045.cv_arg
    cv_variation: TypeAlias = Variation_1045

    @classmethod
    def create(cls, arg : "RuleVariation_1012.cv_arg") -> "RuleVariation_1012":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1045:
        return self.arg # type: ignore

class NonSpare_247(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1012.cv_arg
    cv_name = "090"
    cv_title = "Figure of Merit"
    cv_rule: TypeAlias = RuleVariation_1012

    @classmethod
    def create(cls, arg : "NonSpare_247.cv_arg") -> "NonSpare_247":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1012:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1045:
        return self.rule.variation

class UapItem_247(UapItem):
    cv_non_spare: TypeAlias = NonSpare_247

class Content_540(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Aircraft equiped with CDTI"}

class RuleContent_540(RuleContentContextFree):
    cv_arg: TypeAlias = Content_540.cv_arg
    cv_content: TypeAlias = Content_540

    @property
    def content(self) -> Content_540:
        return self._get_content() # type: ignore

class Variation_671(Element):
    cv_arg: TypeAlias = RuleContent_540.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_540

    @classmethod
    def create(cls, arg: "Variation_671.cv_arg") -> "Variation_671":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_540:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_540:
        return self.rule.content

class RuleVariation_660(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_671.cv_arg
    cv_variation: TypeAlias = Variation_671

    @classmethod
    def create(cls, arg : "RuleVariation_660.cv_arg") -> "RuleVariation_660":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_671:
        return self.arg # type: ignore

class NonSpare_910(NonSpare):
    cv_arg: TypeAlias = RuleVariation_660.cv_arg
    cv_name = "DTI"
    cv_title = "Cockpit Display of Traffic Information"
    cv_rule: TypeAlias = RuleVariation_660

    @classmethod
    def create(cls, arg : "NonSpare_910.cv_arg") -> "NonSpare_910":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_660:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_671:
        return self.rule.variation

class Item_280(Item):
    cv_arg: TypeAlias = NonSpare_910.cv_arg
    cv_non_spare: TypeAlias = NonSpare_910

    @classmethod
    def create(cls, arg : "Item_280.cv_arg") -> "Item_280":
        return cls._create(arg) # type: ignore

class Content_401(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not used", 1: "Used"}

class RuleContent_401(RuleContentContextFree):
    cv_arg: TypeAlias = Content_401.cv_arg
    cv_content: TypeAlias = Content_401

    @property
    def content(self) -> Content_401:
        return self._get_content() # type: ignore

class Variation_744(Element):
    cv_arg: TypeAlias = RuleContent_401.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_401

    @classmethod
    def create(cls, arg: "Variation_744.cv_arg") -> "Variation_744":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_401:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_401:
        return self.rule.content

class RuleVariation_733(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_744.cv_arg
    cv_variation: TypeAlias = Variation_744

    @classmethod
    def create(cls, arg : "RuleVariation_733.cv_arg") -> "RuleVariation_733":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_744:
        return self.arg # type: ignore

class NonSpare_1262(NonSpare):
    cv_arg: TypeAlias = RuleVariation_733.cv_arg
    cv_name = "MDS"
    cv_title = "Mode-S Extended Squitter"
    cv_rule: TypeAlias = RuleVariation_733

    @classmethod
    def create(cls, arg : "NonSpare_1262.cv_arg") -> "NonSpare_1262":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_733:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_744:
        return self.rule.variation

class Item_542(Item):
    cv_arg: TypeAlias = NonSpare_1262.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1262

    @classmethod
    def create(cls, arg : "Item_542.cv_arg") -> "Item_542":
        return cls._create(arg) # type: ignore

class Variation_867(Element):
    cv_arg: TypeAlias = RuleContent_401.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_401

    @classmethod
    def create(cls, arg: "Variation_867.cv_arg") -> "Variation_867":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_401:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_401:
        return self.rule.content

class RuleVariation_837(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_867.cv_arg
    cv_variation: TypeAlias = Variation_867

    @classmethod
    def create(cls, arg : "RuleVariation_837.cv_arg") -> "RuleVariation_837":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_867:
        return self.arg # type: ignore

class NonSpare_1980(NonSpare):
    cv_arg: TypeAlias = RuleVariation_837.cv_arg
    cv_name = "UAT"
    cv_title = "UAT"
    cv_rule: TypeAlias = RuleVariation_837

    @classmethod
    def create(cls, arg : "NonSpare_1980.cv_arg") -> "NonSpare_1980":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_837:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_867:
        return self.rule.variation

class Item_1092(Item):
    cv_arg: TypeAlias = NonSpare_1980.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1980

    @classmethod
    def create(cls, arg : "Item_1092.cv_arg") -> "Item_1092":
        return cls._create(arg) # type: ignore

class Variation_943(Element):
    cv_arg: TypeAlias = RuleContent_401.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_401

    @classmethod
    def create(cls, arg: "Variation_943.cv_arg") -> "Variation_943":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_401:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_401:
        return self.rule.content

class RuleVariation_913(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_943.cv_arg
    cv_variation: TypeAlias = Variation_943

    @classmethod
    def create(cls, arg : "RuleVariation_913.cv_arg") -> "RuleVariation_913":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_943:
        return self.arg # type: ignore

class NonSpare_2031(NonSpare):
    cv_arg: TypeAlias = RuleVariation_913.cv_arg
    cv_name = "VDL"
    cv_title = "VDL Mode 4"
    cv_rule: TypeAlias = RuleVariation_913

    @classmethod
    def create(cls, arg : "NonSpare_2031.cv_arg") -> "NonSpare_2031":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_913:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_943:
        return self.rule.variation

class Item_1140(Item):
    cv_arg: TypeAlias = NonSpare_2031.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2031

    @classmethod
    def create(cls, arg : "Item_1140.cv_arg") -> "Item_1140":
        return cls._create(arg) # type: ignore

class Variation_985(Element):
    cv_arg: TypeAlias = RuleContent_401.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_401

    @classmethod
    def create(cls, arg: "Variation_985.cv_arg") -> "Variation_985":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_401:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_401:
        return self.rule.content

class RuleVariation_955(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_985.cv_arg
    cv_variation: TypeAlias = Variation_985

    @classmethod
    def create(cls, arg : "RuleVariation_955.cv_arg") -> "RuleVariation_955":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_985:
        return self.arg # type: ignore

class NonSpare_1407(NonSpare):
    cv_arg: TypeAlias = RuleVariation_955.cv_arg
    cv_name = "OTR"
    cv_title = "Other Technology"
    cv_rule: TypeAlias = RuleVariation_955

    @classmethod
    def create(cls, arg : "NonSpare_1407.cv_arg") -> "NonSpare_1407":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_955:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_985:
        return self.rule.variation

class Item_665(Item):
    cv_arg: TypeAlias = NonSpare_1407.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1407

    @classmethod
    def create(cls, arg : "Item_665.cv_arg") -> "Item_665":
        return cls._create(arg) # type: ignore

class Variation_1012(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_660.cv_arg, Tuple[Literal["DTI"], RuleVariation_660.cv_arg]], Union[RuleVariation_733.cv_arg, Tuple[Literal["MDS"], RuleVariation_733.cv_arg]], Union[RuleVariation_837.cv_arg, Tuple[Literal["UAT"], RuleVariation_837.cv_arg]], Union[RuleVariation_913.cv_arg, Tuple[Literal["VDL"], RuleVariation_913.cv_arg]], Union[RuleVariation_955.cv_arg, Tuple[Literal["OTR"], RuleVariation_955.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1012.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_280, 1), (Item_542, 1), (Item_1092, 1), (Item_1140, 1), (Item_665, 1)]
    cv_items_dict = {"DTI": RuleVariation_660, "MDS": RuleVariation_733, "UAT": RuleVariation_837, "VDL": RuleVariation_913, "OTR": RuleVariation_955}

    @overload
    @classmethod
    def spec(cls, key : Literal["DTI"]) -> RuleVariation_660:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> RuleVariation_733:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UAT"]) -> RuleVariation_837:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VDL"]) -> RuleVariation_913:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OTR"]) -> RuleVariation_955:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DTI"], Literal["MDS"], Literal["UAT"], Literal["VDL"], Literal["OTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DTI"]) -> RuleVariation_660:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> RuleVariation_733:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_837:
        ...
    @overload
    def get_item(self, key : Literal["VDL"]) -> RuleVariation_913:
        ...
    @overload
    def get_item(self, key : Literal["OTR"]) -> RuleVariation_955:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1012.cv_arg") -> 'Variation_1012':
        return cls._create(arg) # type: ignore

class RuleVariation_982(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1012.cv_arg
    cv_variation: TypeAlias = Variation_1012

    @classmethod
    def create(cls, arg : "RuleVariation_982.cv_arg") -> "RuleVariation_982":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1012:
        return self.arg # type: ignore

class NonSpare_412(NonSpare):
    cv_arg: TypeAlias = RuleVariation_982.cv_arg
    cv_name = "210"
    cv_title = "Link Technology Indicator"
    cv_rule: TypeAlias = RuleVariation_982

    @classmethod
    def create(cls, arg : "NonSpare_412.cv_arg") -> "NonSpare_412":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_982:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1012:
        return self.rule.variation

class UapItem_412(UapItem):
    cv_non_spare: TypeAlias = NonSpare_412

class Content_649(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_649(RuleContentContextFree):
    cv_arg: TypeAlias = Content_649.cv_arg
    cv_content: TypeAlias = Content_649

    @property
    def content(self) -> Content_649:
        return self._get_content() # type: ignore

class Variation_269(Element):
    cv_arg: TypeAlias = RuleContent_649.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_649

    @classmethod
    def create(cls, arg: "Variation_269.cv_arg") -> "Variation_269":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_649:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_649:
        return self.rule.content

class RuleVariation_262(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_269.cv_arg
    cv_variation: TypeAlias = Variation_269

    @classmethod
    def create(cls, arg : "RuleVariation_262.cv_arg") -> "RuleVariation_262":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_269:
        return self.arg # type: ignore

class NonSpare_434(NonSpare):
    cv_arg: TypeAlias = RuleVariation_262.cv_arg
    cv_name = "230"
    cv_title = "Roll Angle"
    cv_rule: TypeAlias = RuleVariation_262

    @classmethod
    def create(cls, arg : "NonSpare_434.cv_arg") -> "NonSpare_434":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_269:
        return self.rule.variation

class UapItem_434(UapItem):
    cv_non_spare: TypeAlias = NonSpare_434

class Content_654(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_654(RuleContentContextFree):
    cv_arg: TypeAlias = Content_654.cv_arg
    cv_content: TypeAlias = Content_654

    @property
    def content(self) -> Content_654:
        return self._get_content() # type: ignore

class Variation_272(Element):
    cv_arg: TypeAlias = RuleContent_654.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_654

    @classmethod
    def create(cls, arg: "Variation_272.cv_arg") -> "Variation_272":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_654:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_654:
        return self.rule.content

class RuleVariation_265(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_272.cv_arg
    cv_variation: TypeAlias = Variation_272

    @classmethod
    def create(cls, arg : "RuleVariation_265.cv_arg") -> "RuleVariation_265":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_272:
        return self.arg # type: ignore

class NonSpare_338(NonSpare):
    cv_arg: TypeAlias = RuleVariation_265.cv_arg
    cv_name = "145"
    cv_title = "Flight Level"
    cv_rule: TypeAlias = RuleVariation_265

    @classmethod
    def create(cls, arg : "NonSpare_338.cv_arg") -> "NonSpare_338":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_265:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_272:
        return self.rule.variation

class UapItem_338(UapItem):
    cv_non_spare: TypeAlias = NonSpare_338

class Content_22(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Air Speed = IAS, LSB (Bit-1) = 2 -14 NM/s", 1: "Air Speed = Mach, LSB (Bit-1) = 0.001"}

class RuleContent_22(RuleContentContextFree):
    cv_arg: TypeAlias = Content_22.cv_arg
    cv_content: TypeAlias = Content_22

    @property
    def content(self) -> Content_22:
        return self._get_content() # type: ignore

class Variation_7(Element):
    cv_arg: TypeAlias = RuleContent_22.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_22

    @classmethod
    def create(cls, arg: "Variation_7.cv_arg") -> "Variation_7":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_22:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_22:
        return self.rule.content

class RuleVariation_7(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_7.cv_arg
    cv_variation: TypeAlias = Variation_7

    @classmethod
    def create(cls, arg : "RuleVariation_7.cv_arg") -> "RuleVariation_7":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_7:
        return self.arg # type: ignore

class NonSpare_1121(NonSpare):
    cv_arg: TypeAlias = RuleVariation_7.cv_arg
    cv_name = "IM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_7

    @classmethod
    def create(cls, arg : "NonSpare_1121.cv_arg") -> "NonSpare_1121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_7:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_7:
        return self.rule.variation

class Item_435(Item):
    cv_arg: TypeAlias = NonSpare_1121.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1121

    @classmethod
    def create(cls, arg : "Item_435.cv_arg") -> "Item_435":
        return cls._create(arg) # type: ignore

class Content_750(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["Mach"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-3
    cv_unit = "Mach"

    def as_quantity(self, cv_unit : Optional[Literal["Mach"]] = None) -> float:
        return self._as_quantity()

class RuleContent_800(RuleContentDependent):
    cv_arg: TypeAlias = Union[
        Tuple[None, Content_0.cv_arg],
        Tuple[Tuple[Literal[0]], Content_778.cv_arg],
        Tuple[Tuple[Literal[1]], Content_750.cv_arg],
    ]
    cv_depends_on = [["150", "IM"]]
    cv_default_content: TypeAlias = Content_0
    cv_cases = [
        ([0], Content_778),
        ([1], Content_750),
    ]

    @overload
    def content(self, arg : Literal[None]) -> Content_0:
        ...
    @overload
    def content(self, arg : Tuple[Literal[0]]) -> Content_778:
        ...
    @overload
    def content(self, arg : Tuple[Literal[1]]) -> Content_750:
        ...
    def content(self, arg : Any) -> Any:
        return self._get_content(arg)

class Variation_505(Element):
    cv_arg: TypeAlias = RuleContent_800.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_800

    @classmethod
    def create(cls, arg: "Variation_505.cv_arg") -> "Variation_505":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_800:
        return self._get_rule() # type: ignore

class RuleVariation_494(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_505.cv_arg
    cv_variation: TypeAlias = Variation_505

    @classmethod
    def create(cls, arg : "RuleVariation_494.cv_arg") -> "RuleVariation_494":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_505:
        return self.arg # type: ignore

class NonSpare_633(NonSpare):
    cv_arg: TypeAlias = RuleVariation_494.cv_arg
    cv_name = "AS"
    cv_title = "Air Speed (IAS or Mach)"
    cv_rule: TypeAlias = RuleVariation_494

    @classmethod
    def create(cls, arg : "NonSpare_633.cv_arg") -> "NonSpare_633":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_494:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_505:
        return self.rule.variation

class Item_86(Item):
    cv_arg: TypeAlias = NonSpare_633.cv_arg
    cv_non_spare: TypeAlias = NonSpare_633

    @classmethod
    def create(cls, arg : "Item_86.cv_arg") -> "Item_86":
        return cls._create(arg) # type: ignore

class Variation_1121(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_7.cv_arg, Tuple[Literal["IM"], RuleVariation_7.cv_arg]], Union[RuleVariation_494.cv_arg, Tuple[Literal["AS"], RuleVariation_494.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1121.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_435, 1), (Item_86, 15)]
    cv_items_dict = {"IM": RuleVariation_7, "AS": RuleVariation_494}

    @overload
    @classmethod
    def spec(cls, key : Literal["IM"]) -> RuleVariation_7:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> RuleVariation_494:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IM"], Literal["AS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IM"]) -> RuleVariation_7:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> RuleVariation_494:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1121.cv_arg") -> 'Variation_1121':
        return cls._create(arg) # type: ignore

class RuleVariation_1077(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1121.cv_arg
    cv_variation: TypeAlias = Variation_1121

    @classmethod
    def create(cls, arg : "RuleVariation_1077.cv_arg") -> "RuleVariation_1077":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1121:
        return self.arg # type: ignore

class NonSpare_344(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1077.cv_arg
    cv_name = "150"
    cv_title = "Air Speed"
    cv_rule: TypeAlias = RuleVariation_1077

    @classmethod
    def create(cls, arg : "NonSpare_344.cv_arg") -> "NonSpare_344":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1077:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1121:
        return self.rule.variation

class UapItem_344(UapItem):
    cv_non_spare: TypeAlias = NonSpare_344

class Content_715(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

class RuleContent_715(RuleContentContextFree):
    cv_arg: TypeAlias = Content_715.cv_arg
    cv_content: TypeAlias = Content_715

    @property
    def content(self) -> Content_715:
        return self._get_content() # type: ignore

class Variation_301(Element):
    cv_arg: TypeAlias = RuleContent_715.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_715

    @classmethod
    def create(cls, arg: "Variation_301.cv_arg") -> "Variation_301":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_715:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_715:
        return self.rule.content

class RuleVariation_294(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_301.cv_arg
    cv_variation: TypeAlias = Variation_301

    @classmethod
    def create(cls, arg : "RuleVariation_294.cv_arg") -> "RuleVariation_294":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_301:
        return self.arg # type: ignore

class NonSpare_349(NonSpare):
    cv_arg: TypeAlias = RuleVariation_294.cv_arg
    cv_name = "151"
    cv_title = "True Airspeed"
    cv_rule: TypeAlias = RuleVariation_294

    @classmethod
    def create(cls, arg : "NonSpare_349.cv_arg") -> "NonSpare_349":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_294:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_301:
        return self.rule.variation

class UapItem_349(UapItem):
    cv_non_spare: TypeAlias = NonSpare_349

class NonSpare_351(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "152"
    cv_title = "Magnetic Heading"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_351.cv_arg") -> "NonSpare_351":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class UapItem_351(UapItem):
    cv_non_spare: TypeAlias = NonSpare_351

class Content_688(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft/min"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.25
    cv_unit = "ft/min"

    def as_quantity(self, cv_unit : Optional[Literal["ft/min"]] = None) -> float:
        return self._as_quantity()

class RuleContent_688(RuleContentContextFree):
    cv_arg: TypeAlias = Content_688.cv_arg
    cv_content: TypeAlias = Content_688

    @property
    def content(self) -> Content_688:
        return self._get_content() # type: ignore

class Variation_293(Element):
    cv_arg: TypeAlias = RuleContent_688.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_688

    @classmethod
    def create(cls, arg: "Variation_293.cv_arg") -> "Variation_293":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_688:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_688:
        return self.rule.content

class RuleVariation_286(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_293.cv_arg
    cv_variation: TypeAlias = Variation_293

    @classmethod
    def create(cls, arg : "RuleVariation_286.cv_arg") -> "RuleVariation_286":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_293:
        return self.arg # type: ignore

class NonSpare_353(NonSpare):
    cv_arg: TypeAlias = RuleVariation_286.cv_arg
    cv_name = "155"
    cv_title = "Barometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_286

    @classmethod
    def create(cls, arg : "NonSpare_353.cv_arg") -> "NonSpare_353":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

class UapItem_353(UapItem):
    cv_non_spare: TypeAlias = NonSpare_353

class NonSpare_355(NonSpare):
    cv_arg: TypeAlias = RuleVariation_286.cv_arg
    cv_name = "157"
    cv_title = "Geometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_286

    @classmethod
    def create(cls, arg : "NonSpare_355.cv_arg") -> "NonSpare_355":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

class UapItem_355(UapItem):
    cv_non_spare: TypeAlias = NonSpare_355

class Content_683(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_683(RuleContentContextFree):
    cv_arg: TypeAlias = Content_683.cv_arg
    cv_content: TypeAlias = Content_683

    @property
    def content(self) -> Content_683:
        return self._get_content() # type: ignore

class Variation_289(Element):
    cv_arg: TypeAlias = RuleContent_683.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_683

    @classmethod
    def create(cls, arg: "Variation_289.cv_arg") -> "Variation_289":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_683:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_683:
        return self.rule.content

class RuleVariation_282(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_289.cv_arg
    cv_variation: TypeAlias = Variation_289

    @classmethod
    def create(cls, arg : "RuleVariation_282.cv_arg") -> "RuleVariation_282":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_289:
        return self.arg # type: ignore

class NonSpare_1040(NonSpare):
    cv_arg: TypeAlias = RuleVariation_282.cv_arg
    cv_name = "GS"
    cv_title = "Ground Speed in Two's Complement Form Referenced to WGS84"
    cv_rule: TypeAlias = RuleVariation_282

    @classmethod
    def create(cls, arg : "NonSpare_1040.cv_arg") -> "NonSpare_1040":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_282:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_289:
        return self.rule.variation

class Item_374(Item):
    cv_arg: TypeAlias = NonSpare_1040.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1040

    @classmethod
    def create(cls, arg : "Item_374.cv_arg") -> "Item_374":
        return cls._create(arg) # type: ignore

class NonSpare_1817(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TA"
    cv_title = "Track Angle"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1817.cv_arg") -> "NonSpare_1817":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_969(Item):
    cv_arg: TypeAlias = NonSpare_1817.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1817

    @classmethod
    def create(cls, arg : "Item_969.cv_arg") -> "Item_969":
        return cls._create(arg) # type: ignore

class Variation_1113(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_282.cv_arg, Tuple[Literal["GS"], RuleVariation_282.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["TA"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1113.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_374, 16), (Item_969, 16)]
    cv_items_dict = {"GS": RuleVariation_282, "TA": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> RuleVariation_282:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TA"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GS"], Literal["TA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GS"]) -> RuleVariation_282:
        ...
    @overload
    def get_item(self, key : Literal["TA"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1113.cv_arg") -> 'Variation_1113':
        return cls._create(arg) # type: ignore

class RuleVariation_1071(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1113.cv_arg
    cv_variation: TypeAlias = Variation_1113

    @classmethod
    def create(cls, arg : "RuleVariation_1071.cv_arg") -> "RuleVariation_1071":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1113:
        return self.arg # type: ignore

class NonSpare_358(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1071.cv_arg
    cv_name = "160"
    cv_title = "Ground Vector"
    cv_rule: TypeAlias = RuleVariation_1071

    @classmethod
    def create(cls, arg : "NonSpare_358.cv_arg") -> "NonSpare_358":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1071:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1113:
        return self.rule.variation

class UapItem_358(UapItem):
    cv_non_spare: TypeAlias = NonSpare_358

class Content_392(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not available", 1: "Left", 2: "Right", 3: "Straight"}

class RuleContent_392(RuleContentContextFree):
    cv_arg: TypeAlias = Content_392.cv_arg
    cv_content: TypeAlias = Content_392

    @property
    def content(self) -> Content_392:
        return self._get_content() # type: ignore

class Variation_106(Element):
    cv_arg: TypeAlias = RuleContent_392.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_392

    @classmethod
    def create(cls, arg: "Variation_106.cv_arg") -> "Variation_106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_392:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_392:
        return self.rule.content

class RuleVariation_106(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_106.cv_arg
    cv_variation: TypeAlias = Variation_106

    @classmethod
    def create(cls, arg : "RuleVariation_106.cv_arg") -> "RuleVariation_106":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_106:
        return self.arg # type: ignore

class Content_667(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_667(RuleContentContextFree):
    cv_arg: TypeAlias = Content_667.cv_arg
    cv_content: TypeAlias = Content_667

    @property
    def content(self) -> Content_667:
        return self._get_content() # type: ignore

class Variation_160(Element):
    cv_arg: TypeAlias = RuleContent_667.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_667

    @classmethod
    def create(cls, arg: "Variation_160.cv_arg") -> "Variation_160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_667:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_667:
        return self.rule.content

class RuleVariation_154(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_160.cv_arg
    cv_variation: TypeAlias = Variation_160

    @classmethod
    def create(cls, arg : "RuleVariation_154.cv_arg") -> "RuleVariation_154":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_160:
        return self.arg # type: ignore

class NonSpare_1859(NonSpare):
    cv_arg: TypeAlias = RuleVariation_106.cv_arg
    cv_name = "TI"
    cv_title = "Turn Indicator"
    cv_rule: TypeAlias = RuleVariation_106

    @classmethod
    def create(cls, arg : "NonSpare_1859.cv_arg") -> "NonSpare_1859":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_106:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_106:
        return self.rule.variation

class Item_997(Item):
    cv_arg: TypeAlias = NonSpare_1859.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1859

    @classmethod
    def create(cls, arg : "Item_997.cv_arg") -> "Item_997":
        return cls._create(arg) # type: ignore

class Item_14(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 2
    cv_bit_size = 5

class NonSpare_1601(NonSpare):
    cv_arg: TypeAlias = RuleVariation_154.cv_arg
    cv_name = "ROT"
    cv_title = "Rate of Turn"
    cv_rule: TypeAlias = RuleVariation_154

    @classmethod
    def create(cls, arg : "NonSpare_1601.cv_arg") -> "NonSpare_1601":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_154:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_160:
        return self.rule.variation

class Item_825(Item):
    cv_arg: TypeAlias = NonSpare_1601.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1601

    @classmethod
    def create(cls, arg : "Item_825.cv_arg") -> "Item_825":
        return cls._create(arg) # type: ignore

class Variation_1387(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_106.cv_arg, Tuple[Literal["TI"], RuleVariation_106.cv_arg]], int, None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_154.cv_arg, Tuple[Literal["ROT"], RuleVariation_154.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1387.cv_arg_group_1"],
        Tuple["Variation_1387.cv_arg_group_1", "Variation_1387.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_997, 2), (Item_14, 5), None], [(Item_825, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1387.cv_arg") -> 'Variation_1387':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TI"]) -> RuleVariation_106:
        ...
    @overload
    def get_item(self, key : Literal["ROT"]) -> Optional[RuleVariation_154]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1308(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1387.cv_arg
    cv_variation: TypeAlias = Variation_1387

    @classmethod
    def create(cls, arg : "RuleVariation_1308.cv_arg") -> "RuleVariation_1308":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1387:
        return self.arg # type: ignore

class NonSpare_368(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1308.cv_arg
    cv_name = "165"
    cv_title = "Rate Of Turn"
    cv_rule: TypeAlias = RuleVariation_1308

    @classmethod
    def create(cls, arg : "NonSpare_368.cv_arg") -> "NonSpare_368":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1308:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1387:
        return self.rule.variation

class UapItem_368(UapItem):
    cv_non_spare: TypeAlias = NonSpare_368

class NonSpare_373(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "170"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_373.cv_arg") -> "NonSpare_373":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_373(UapItem):
    cv_non_spare: TypeAlias = NonSpare_373

class NonSpare_266(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "095"
    cv_title = "Velocity Accuracy"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_266.cv_arg") -> "NonSpare_266":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_266(UapItem):
    cv_non_spare: TypeAlias = NonSpare_266

class Content_777(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_776(RuleContentContextFree):
    cv_arg: TypeAlias = Content_777.cv_arg
    cv_content: TypeAlias = Content_777

    @property
    def content(self) -> Content_777:
        return self._get_content() # type: ignore

class Variation_239(Element):
    cv_arg: TypeAlias = RuleContent_776.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_776

    @classmethod
    def create(cls, arg: "Variation_239.cv_arg") -> "Variation_239":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_776:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_777:
        return self.rule.content

class RuleVariation_232(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_239.cv_arg
    cv_variation: TypeAlias = Variation_239

    @classmethod
    def create(cls, arg : "RuleVariation_232.cv_arg") -> "RuleVariation_232":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_239:
        return self.arg # type: ignore

class NonSpare_125(NonSpare):
    cv_arg: TypeAlias = RuleVariation_232.cv_arg
    cv_name = "032"
    cv_title = "Time of Day Accuracy"
    cv_rule: TypeAlias = RuleVariation_232

    @classmethod
    def create(cls, arg : "NonSpare_125.cv_arg") -> "NonSpare_125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_232:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_239:
        return self.rule.variation

class UapItem_125(UapItem):
    cv_non_spare: TypeAlias = NonSpare_125

class Content_356(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "Lifeguard / medical", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference"}

class RuleContent_356(RuleContentContextFree):
    cv_arg: TypeAlias = Content_356.cv_arg
    cv_content: TypeAlias = Content_356

    @property
    def content(self) -> Content_356:
        return self._get_content() # type: ignore

class Variation_171(Element):
    cv_arg: TypeAlias = RuleContent_356.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_356

    @classmethod
    def create(cls, arg: "Variation_171.cv_arg") -> "Variation_171":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_356:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_356:
        return self.rule.content

class RuleVariation_165(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_171.cv_arg
    cv_variation: TypeAlias = Variation_171

    @classmethod
    def create(cls, arg : "RuleVariation_165.cv_arg") -> "RuleVariation_165":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_171:
        return self.arg # type: ignore

class NonSpare_398(NonSpare):
    cv_arg: TypeAlias = RuleVariation_165.cv_arg
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule: TypeAlias = RuleVariation_165

    @classmethod
    def create(cls, arg : "NonSpare_398.cv_arg") -> "NonSpare_398":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_165:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_171:
        return self.rule.variation

class UapItem_398(UapItem):
    cv_non_spare: TypeAlias = NonSpare_398

class Content_582(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Light aircraft <= 7000 kg", 2: "Reserved", 3: "7000 kg < Medium aircraft < 136000 kg", 4: "Reserved", 5: "136000 kg <= Heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (>400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Reserved", 24: "Reserved"}

class RuleContent_582(RuleContentContextFree):
    cv_arg: TypeAlias = Content_582.cv_arg
    cv_content: TypeAlias = Content_582

    @property
    def content(self) -> Content_582:
        return self._get_content() # type: ignore

class Variation_184(Element):
    cv_arg: TypeAlias = RuleContent_582.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_582

    @classmethod
    def create(cls, arg: "Variation_184.cv_arg") -> "Variation_184":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_582:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_582:
        return self.rule.content

class RuleVariation_177(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_184.cv_arg
    cv_variation: TypeAlias = Variation_184

    @classmethod
    def create(cls, arg : "RuleVariation_177.cv_arg") -> "RuleVariation_177":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_184:
        return self.arg # type: ignore

class NonSpare_80(NonSpare):
    cv_arg: TypeAlias = RuleVariation_177.cv_arg
    cv_name = "020"
    cv_title = "Emitter Category"
    cv_rule: TypeAlias = RuleVariation_177

    @classmethod
    def create(cls, arg : "NonSpare_80.cv_arg") -> "NonSpare_80":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_177:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_184:
        return self.rule.variation

class UapItem_80(UapItem):
    cv_non_spare: TypeAlias = NonSpare_80

class Content_716(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

class RuleContent_716(RuleContentContextFree):
    cv_arg: TypeAlias = Content_716.cv_arg
    cv_content: TypeAlias = Content_716

    @property
    def content(self) -> Content_716:
        return self._get_content() # type: ignore

class Variation_302(Element):
    cv_arg: TypeAlias = RuleContent_716.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_716

    @classmethod
    def create(cls, arg: "Variation_302.cv_arg") -> "Variation_302":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_716:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_716:
        return self.rule.content

class RuleVariation_295(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_302.cv_arg
    cv_variation: TypeAlias = Variation_302

    @classmethod
    def create(cls, arg : "RuleVariation_295.cv_arg") -> "RuleVariation_295":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_302:
        return self.arg # type: ignore

class NonSpare_2065(NonSpare):
    cv_arg: TypeAlias = RuleVariation_295.cv_arg
    cv_name = "WS"
    cv_title = "Wind Speed"
    cv_rule: TypeAlias = RuleVariation_295

    @classmethod
    def create(cls, arg : "NonSpare_2065.cv_arg") -> "NonSpare_2065":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_295:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_302:
        return self.rule.variation

class Content_727(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_727(RuleContentContextFree):
    cv_arg: TypeAlias = Content_727.cv_arg
    cv_content: TypeAlias = Content_727

    @property
    def content(self) -> Content_727:
        return self._get_content() # type: ignore

class Variation_309(Element):
    cv_arg: TypeAlias = RuleContent_727.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_727

    @classmethod
    def create(cls, arg: "Variation_309.cv_arg") -> "Variation_309":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_727:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_727:
        return self.rule.content

class RuleVariation_302(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_309.cv_arg
    cv_variation: TypeAlias = Variation_309

    @classmethod
    def create(cls, arg : "RuleVariation_302.cv_arg") -> "RuleVariation_302":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_309:
        return self.arg # type: ignore

class NonSpare_2058(NonSpare):
    cv_arg: TypeAlias = RuleVariation_302.cv_arg
    cv_name = "WD"
    cv_title = "Wind Direction"
    cv_rule: TypeAlias = RuleVariation_302

    @classmethod
    def create(cls, arg : "NonSpare_2058.cv_arg") -> "NonSpare_2058":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

class Content_668(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°C"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "°C"

    def as_quantity(self, cv_unit : Optional[Literal["°C"]] = None) -> float:
        return self._as_quantity()

class RuleContent_668(RuleContentContextFree):
    cv_arg: TypeAlias = Content_668.cv_arg
    cv_content: TypeAlias = Content_668

    @property
    def content(self) -> Content_668:
        return self._get_content() # type: ignore

class Variation_281(Element):
    cv_arg: TypeAlias = RuleContent_668.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_668

    @classmethod
    def create(cls, arg: "Variation_281.cv_arg") -> "Variation_281":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_668:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_668:
        return self.rule.content

class RuleVariation_274(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_281.cv_arg
    cv_variation: TypeAlias = Variation_281

    @classmethod
    def create(cls, arg : "RuleVariation_274.cv_arg") -> "RuleVariation_274":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_281:
        return self.arg # type: ignore

class NonSpare_1874(NonSpare):
    cv_arg: TypeAlias = RuleVariation_274.cv_arg
    cv_name = "TMP"
    cv_title = "Temperature"
    cv_rule: TypeAlias = RuleVariation_274

    @classmethod
    def create(cls, arg : "NonSpare_1874.cv_arg") -> "NonSpare_1874":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_281:
        return self.rule.variation

class Content_617(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_617(RuleContentContextFree):
    cv_arg: TypeAlias = Content_617.cv_arg
    cv_content: TypeAlias = Content_617

    @property
    def content(self) -> Content_617:
        return self._get_content() # type: ignore

class Variation_206(Element):
    cv_arg: TypeAlias = RuleContent_617.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_617

    @classmethod
    def create(cls, arg: "Variation_206.cv_arg") -> "Variation_206":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_617:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_617:
        return self.rule.content

class RuleVariation_199(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_206.cv_arg
    cv_variation: TypeAlias = Variation_206

    @classmethod
    def create(cls, arg : "RuleVariation_199.cv_arg") -> "RuleVariation_199":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_206:
        return self.arg # type: ignore

class NonSpare_1910(NonSpare):
    cv_arg: TypeAlias = RuleVariation_199.cv_arg
    cv_name = "TRB"
    cv_title = "Turbulence"
    cv_rule: TypeAlias = RuleVariation_199

    @classmethod
    def create(cls, arg : "NonSpare_1910.cv_arg") -> "NonSpare_1910":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_206:
        return self.rule.variation

class Variation_1520(Compound):
    cv_arg = TypedDict('cv_arg', {
        "WS": NonSpare_2065.cv_arg,
        "WD": NonSpare_2058.cv_arg,
        "TMP": NonSpare_1874.cv_arg,
        "TRB": NonSpare_1910.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_2065, NonSpare_2058, NonSpare_1874, NonSpare_1910]
    cv_items_dict = {"WS": NonSpare_2065, "WD": NonSpare_2058, "TMP": NonSpare_1874, "TRB": NonSpare_1910}

    @overload
    @classmethod
    def spec(cls, key : Literal["WS"]) -> NonSpare_2065:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WD"]) -> NonSpare_2058:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TMP"]) -> NonSpare_1874:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> NonSpare_1910:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["WS"], Literal["WD"], Literal["TMP"], Literal["TRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["WS"]) -> Optional[NonSpare_2065]:
        ...
    @overload
    def get_item(self, key : Literal["WD"]) -> Optional[NonSpare_2058]:
        ...
    @overload
    def get_item(self, key : Literal["TMP"]) -> Optional[NonSpare_1874]:
        ...
    @overload
    def get_item(self, key : Literal["TRB"]) -> Optional[NonSpare_1910]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["WS"], val : NonSpare_2065.cv_arg) -> "Variation_1520":
        ...
    @overload
    def set_item(self, key : Literal["WD"], val : NonSpare_2058.cv_arg) -> "Variation_1520":
        ...
    @overload
    def set_item(self, key : Literal["TMP"], val : NonSpare_1874.cv_arg) -> "Variation_1520":
        ...
    @overload
    def set_item(self, key : Literal["TRB"], val : NonSpare_1910.cv_arg) -> "Variation_1520":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["WS"]) -> "Variation_1520":
        ...
    @overload
    def del_item(self, key : Literal["WD"]) -> "Variation_1520":
        ...
    @overload
    def del_item(self, key : Literal["TMP"]) -> "Variation_1520":
        ...
    @overload
    def del_item(self, key : Literal["TRB"]) -> "Variation_1520":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1520.cv_arg") -> 'Variation_1520':
        return cls._create(arg) # type: ignore

class RuleVariation_1441(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1520.cv_arg
    cv_variation: TypeAlias = Variation_1520

    @classmethod
    def create(cls, arg : "RuleVariation_1441.cv_arg") -> "RuleVariation_1441":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1520:
        return self.arg # type: ignore

class NonSpare_424(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1441.cv_arg
    cv_name = "220"
    cv_title = "Met Information"
    cv_rule: TypeAlias = RuleVariation_1441

    @classmethod
    def create(cls, arg : "NonSpare_424.cv_arg") -> "NonSpare_424":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1441:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1520:
        return self.rule.variation

class UapItem_424(UapItem):
    cv_non_spare: TypeAlias = NonSpare_424

class Content_373(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No source information provided", 1: "Source Information provided"}

class RuleContent_373(RuleContentContextFree):
    cv_arg: TypeAlias = Content_373.cv_arg
    cv_content: TypeAlias = Content_373

    @property
    def content(self) -> Content_373:
        return self._get_content() # type: ignore

class Variation_64(Element):
    cv_arg: TypeAlias = RuleContent_373.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_373

    @classmethod
    def create(cls, arg: "Variation_64.cv_arg") -> "Variation_64":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_373:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_373:
        return self.rule.content

class RuleVariation_64(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_64.cv_arg
    cv_variation: TypeAlias = Variation_64

    @classmethod
    def create(cls, arg : "RuleVariation_64.cv_arg") -> "RuleVariation_64":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_64:
        return self.arg # type: ignore

class NonSpare_1664(NonSpare):
    cv_arg: TypeAlias = RuleVariation_64.cv_arg
    cv_name = "SAS"
    cv_title = "Source Availability"
    cv_rule: TypeAlias = RuleVariation_64

    @classmethod
    def create(cls, arg : "NonSpare_1664.cv_arg") -> "NonSpare_1664":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_64:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_64:
        return self.rule.variation

class Item_861(Item):
    cv_arg: TypeAlias = NonSpare_1664.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1664

    @classmethod
    def create(cls, arg : "Item_861.cv_arg") -> "Item_861":
        return cls._create(arg) # type: ignore

class Content_538(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Aircraft Altitude (Holding Altitude)", 2: "MCP/FCU Selected Altitude", 3: "FMS Selected Altitude"}

class RuleContent_538(RuleContentContextFree):
    cv_arg: TypeAlias = Content_538.cv_arg
    cv_content: TypeAlias = Content_538

    @property
    def content(self) -> Content_538:
        return self._get_content() # type: ignore

class Variation_477(Element):
    cv_arg: TypeAlias = RuleContent_538.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_538

    @classmethod
    def create(cls, arg: "Variation_477.cv_arg") -> "Variation_477":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_538:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_538:
        return self.rule.content

class RuleVariation_466(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_477.cv_arg
    cv_variation: TypeAlias = Variation_477

    @classmethod
    def create(cls, arg : "RuleVariation_466.cv_arg") -> "RuleVariation_466":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_477:
        return self.arg # type: ignore

class NonSpare_1750(NonSpare):
    cv_arg: TypeAlias = RuleVariation_466.cv_arg
    cv_name = "SRC"
    cv_title = "Source"
    cv_rule: TypeAlias = RuleVariation_466

    @classmethod
    def create(cls, arg : "NonSpare_1750.cv_arg") -> "NonSpare_1750":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_466:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_477:
        return self.rule.variation

class Item_922(Item):
    cv_arg: TypeAlias = NonSpare_1750.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1750

    @classmethod
    def create(cls, arg : "Item_922.cv_arg") -> "Item_922":
        return cls._create(arg) # type: ignore

class Content_635(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_635(RuleContentContextFree):
    cv_arg: TypeAlias = Content_635.cv_arg
    cv_content: TypeAlias = Content_635

    @property
    def content(self) -> Content_635:
        return self._get_content() # type: ignore

class Variation_697(Element):
    cv_arg: TypeAlias = RuleContent_635.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 13
    cv_rule = RuleContent_635

    @classmethod
    def create(cls, arg: "Variation_697.cv_arg") -> "Variation_697":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_635:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_635:
        return self.rule.content

class RuleVariation_686(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_697.cv_arg
    cv_variation: TypeAlias = Variation_697

    @classmethod
    def create(cls, arg : "RuleVariation_686.cv_arg") -> "RuleVariation_686":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_697:
        return self.arg # type: ignore

class NonSpare_593(NonSpare):
    cv_arg: TypeAlias = RuleVariation_686.cv_arg
    cv_name = "ALT"
    cv_title = "Altitude"
    cv_rule: TypeAlias = RuleVariation_686

    @classmethod
    def create(cls, arg : "NonSpare_593.cv_arg") -> "NonSpare_593":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_686:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_697:
        return self.rule.variation

class Item_60(Item):
    cv_arg: TypeAlias = NonSpare_593.cv_arg
    cv_non_spare: TypeAlias = NonSpare_593

    @classmethod
    def create(cls, arg : "Item_60.cv_arg") -> "Item_60":
        return cls._create(arg) # type: ignore

class Variation_1201(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_64.cv_arg, Tuple[Literal["SAS"], RuleVariation_64.cv_arg]], Union[RuleVariation_466.cv_arg, Tuple[Literal["SRC"], RuleVariation_466.cv_arg]], Union[RuleVariation_686.cv_arg, Tuple[Literal["ALT"], RuleVariation_686.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1201.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_861, 1), (Item_922, 2), (Item_60, 13)]
    cv_items_dict = {"SAS": RuleVariation_64, "SRC": RuleVariation_466, "ALT": RuleVariation_686}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAS"]) -> RuleVariation_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRC"]) -> RuleVariation_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAS"], Literal["SRC"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAS"]) -> RuleVariation_64:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_466:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1201.cv_arg") -> 'Variation_1201':
        return cls._create(arg) # type: ignore

class RuleVariation_1145(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1201.cv_arg
    cv_variation: TypeAlias = Variation_1201

    @classmethod
    def create(cls, arg : "RuleVariation_1145.cv_arg") -> "RuleVariation_1145":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1201:
        return self.arg # type: ignore

class NonSpare_340(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1145.cv_arg
    cv_name = "146"
    cv_title = "Intermediate State Selected Altitude"
    cv_rule: TypeAlias = RuleVariation_1145

    @classmethod
    def create(cls, arg : "NonSpare_340.cv_arg") -> "NonSpare_340":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1145:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1201:
        return self.rule.variation

class UapItem_340(UapItem):
    cv_non_spare: TypeAlias = NonSpare_340

class Content_388(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not active", 1: "Active"}

class RuleContent_388(RuleContentContextFree):
    cv_arg: TypeAlias = Content_388.cv_arg
    cv_content: TypeAlias = Content_388

    @property
    def content(self) -> Content_388:
        return self._get_content() # type: ignore

class Variation_67(Element):
    cv_arg: TypeAlias = RuleContent_388.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_388

    @classmethod
    def create(cls, arg: "Variation_67.cv_arg") -> "Variation_67":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_388:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_388:
        return self.rule.content

class RuleVariation_67(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_67.cv_arg
    cv_variation: TypeAlias = Variation_67

    @classmethod
    def create(cls, arg : "RuleVariation_67.cv_arg") -> "RuleVariation_67":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_67:
        return self.arg # type: ignore

class NonSpare_1338(NonSpare):
    cv_arg: TypeAlias = RuleVariation_67.cv_arg
    cv_name = "MV"
    cv_title = "Manage Vertical Mode"
    cv_rule: TypeAlias = RuleVariation_67

    @classmethod
    def create(cls, arg : "NonSpare_1338.cv_arg") -> "NonSpare_1338":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_67:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_67:
        return self.rule.variation

class Item_601(Item):
    cv_arg: TypeAlias = NonSpare_1338.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1338

    @classmethod
    def create(cls, arg : "Item_601.cv_arg") -> "Item_601":
        return cls._create(arg) # type: ignore

class Variation_443(Element):
    cv_arg: TypeAlias = RuleContent_388.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_388

    @classmethod
    def create(cls, arg: "Variation_443.cv_arg") -> "Variation_443":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_388:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_388:
        return self.rule.content

class RuleVariation_432(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_443.cv_arg
    cv_variation: TypeAlias = Variation_443

    @classmethod
    def create(cls, arg : "RuleVariation_432.cv_arg") -> "RuleVariation_432":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_443:
        return self.arg # type: ignore

class NonSpare_584(NonSpare):
    cv_arg: TypeAlias = RuleVariation_432.cv_arg
    cv_name = "AH"
    cv_title = "Altitude Hold Mode"
    cv_rule: TypeAlias = RuleVariation_432

    @classmethod
    def create(cls, arg : "NonSpare_584.cv_arg") -> "NonSpare_584":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_432:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_443:
        return self.rule.variation

class Item_53(Item):
    cv_arg: TypeAlias = NonSpare_584.cv_arg
    cv_non_spare: TypeAlias = NonSpare_584

    @classmethod
    def create(cls, arg : "Item_53.cv_arg") -> "Item_53":
        return cls._create(arg) # type: ignore

class Variation_567(Element):
    cv_arg: TypeAlias = RuleContent_388.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_388

    @classmethod
    def create(cls, arg: "Variation_567.cv_arg") -> "Variation_567":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_388:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_388:
        return self.rule.content

class RuleVariation_556(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_567.cv_arg
    cv_variation: TypeAlias = Variation_567

    @classmethod
    def create(cls, arg : "RuleVariation_556.cv_arg") -> "RuleVariation_556":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_567:
        return self.arg # type: ignore

class NonSpare_603(NonSpare):
    cv_arg: TypeAlias = RuleVariation_556.cv_arg
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule: TypeAlias = RuleVariation_556

    @classmethod
    def create(cls, arg : "NonSpare_603.cv_arg") -> "NonSpare_603":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_556:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_567:
        return self.rule.variation

class Item_67(Item):
    cv_arg: TypeAlias = NonSpare_603.cv_arg
    cv_non_spare: TypeAlias = NonSpare_603

    @classmethod
    def create(cls, arg : "Item_67.cv_arg") -> "Item_67":
        return cls._create(arg) # type: ignore

class Variation_1146(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_67.cv_arg, Tuple[Literal["MV"], RuleVariation_67.cv_arg]], Union[RuleVariation_432.cv_arg, Tuple[Literal["AH"], RuleVariation_432.cv_arg]], Union[RuleVariation_556.cv_arg, Tuple[Literal["AM"], RuleVariation_556.cv_arg]], Union[RuleVariation_686.cv_arg, Tuple[Literal["ALT"], RuleVariation_686.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1146.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_601, 1), (Item_53, 1), (Item_67, 1), (Item_60, 13)]
    cv_items_dict = {"MV": RuleVariation_67, "AH": RuleVariation_432, "AM": RuleVariation_556, "ALT": RuleVariation_686}

    @overload
    @classmethod
    def spec(cls, key : Literal["MV"]) -> RuleVariation_67:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_432:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_556:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MV"], Literal["AH"], Literal["AM"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MV"]) -> RuleVariation_67:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_432:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_556:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1146.cv_arg") -> 'Variation_1146':
        return cls._create(arg) # type: ignore

class RuleVariation_1099(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1146.cv_arg
    cv_variation: TypeAlias = Variation_1146

    @classmethod
    def create(cls, arg : "RuleVariation_1099.cv_arg") -> "RuleVariation_1099":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1146:
        return self.arg # type: ignore

class NonSpare_342(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1099.cv_arg
    cv_name = "148"
    cv_title = "Final State Selected Altitude"
    cv_rule: TypeAlias = RuleVariation_1099

    @classmethod
    def create(cls, arg : "NonSpare_342.cv_arg") -> "NonSpare_342":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1099:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1146:
        return self.rule.variation

class UapItem_342(UapItem):
    cv_non_spare: TypeAlias = NonSpare_342

class Content_517(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Trajectory Intent Data is available for this aircraft", 1: "Trajectory Intent Data is not available for this aircraft"}

class RuleContent_517(RuleContentContextFree):
    cv_arg: TypeAlias = Content_517.cv_arg
    cv_content: TypeAlias = Content_517

    @property
    def content(self) -> Content_517:
        return self._get_content() # type: ignore

class Variation_92(Element):
    cv_arg: TypeAlias = RuleContent_517.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_517

    @classmethod
    def create(cls, arg: "Variation_92.cv_arg") -> "Variation_92":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_517:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_517:
        return self.rule.content

class RuleVariation_92(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_92.cv_arg
    cv_variation: TypeAlias = Variation_92

    @classmethod
    def create(cls, arg : "RuleVariation_92.cv_arg") -> "RuleVariation_92":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_92:
        return self.arg # type: ignore

class Content_518(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Trajectory Intent Data is valid", 1: "Trajectory Intent Data is not valid"}

class RuleContent_518(RuleContentContextFree):
    cv_arg: TypeAlias = Content_518.cv_arg
    cv_content: TypeAlias = Content_518

    @property
    def content(self) -> Content_518:
        return self._get_content() # type: ignore

class Variation_459(Element):
    cv_arg: TypeAlias = RuleContent_518.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_518

    @classmethod
    def create(cls, arg: "Variation_459.cv_arg") -> "Variation_459":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_518:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_518:
        return self.rule.content

class RuleVariation_448(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_459.cv_arg
    cv_variation: TypeAlias = Variation_459

    @classmethod
    def create(cls, arg : "RuleVariation_448.cv_arg") -> "RuleVariation_448":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_459:
        return self.arg # type: ignore

class NonSpare_1345(NonSpare):
    cv_arg: TypeAlias = RuleVariation_92.cv_arg
    cv_name = "NAV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_92

    @classmethod
    def create(cls, arg : "NonSpare_1345.cv_arg") -> "NonSpare_1345":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_92:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_92:
        return self.rule.variation

class Item_607(Item):
    cv_arg: TypeAlias = NonSpare_1345.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1345

    @classmethod
    def create(cls, arg : "Item_607.cv_arg") -> "Item_607":
        return cls._create(arg) # type: ignore

class NonSpare_1387(NonSpare):
    cv_arg: TypeAlias = RuleVariation_448.cv_arg
    cv_name = "NVB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_448

    @classmethod
    def create(cls, arg : "NonSpare_1387.cv_arg") -> "NonSpare_1387":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_448:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_459:
        return self.rule.variation

class Item_646(Item):
    cv_arg: TypeAlias = NonSpare_1387.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1387

    @classmethod
    def create(cls, arg : "Item_646.cv_arg") -> "Item_646":
        return cls._create(arg) # type: ignore

class Variation_1373(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_92.cv_arg, Tuple[Literal["NAV"], RuleVariation_92.cv_arg]], Union[RuleVariation_448.cv_arg, Tuple[Literal["NVB"], RuleVariation_448.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1373.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_607, 1), (Item_646, 1), (Item_14, 5), None]]

    @classmethod
    def create(cls, arg: "Variation_1373.cv_arg") -> 'Variation_1373':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NAV"]) -> RuleVariation_92:
        ...
    @overload
    def get_item(self, key : Literal["NVB"]) -> RuleVariation_448:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1294(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1373.cv_arg
    cv_variation: TypeAlias = Variation_1373

    @classmethod
    def create(cls, arg : "RuleVariation_1294.cv_arg") -> "RuleVariation_1294":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1373:
        return self.arg # type: ignore

class NonSpare_1871(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1294.cv_arg
    cv_name = "TIS"
    cv_title = "Trajectory Intent Status"
    cv_rule: TypeAlias = RuleVariation_1294

    @classmethod
    def create(cls, arg : "NonSpare_1871.cv_arg") -> "NonSpare_1871":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1294:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1373:
        return self.rule.variation

class Content_466(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TCP number available", 1: "TCP number not available"}

class RuleContent_466(RuleContentContextFree):
    cv_arg: TypeAlias = Content_466.cv_arg
    cv_content: TypeAlias = Content_466

    @property
    def content(self) -> Content_466:
        return self._get_content() # type: ignore

class Variation_80(Element):
    cv_arg: TypeAlias = RuleContent_466.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_466

    @classmethod
    def create(cls, arg: "Variation_80.cv_arg") -> "Variation_80":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_466:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_466:
        return self.rule.content

class RuleVariation_80(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_80.cv_arg
    cv_variation: TypeAlias = Variation_80

    @classmethod
    def create(cls, arg : "RuleVariation_80.cv_arg") -> "RuleVariation_80":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_80:
        return self.arg # type: ignore

class NonSpare_1837(NonSpare):
    cv_arg: TypeAlias = RuleVariation_80.cv_arg
    cv_name = "TCA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_80

    @classmethod
    def create(cls, arg : "NonSpare_1837.cv_arg") -> "NonSpare_1837":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_80:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_80:
        return self.rule.variation

class Item_977(Item):
    cv_arg: TypeAlias = NonSpare_1837.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1837

    @classmethod
    def create(cls, arg : "Item_977.cv_arg") -> "Item_977":
        return cls._create(arg) # type: ignore

class Content_465(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TCP compliance", 1: "TCP non-compliance"}

class RuleContent_465(RuleContentContextFree):
    cv_arg: TypeAlias = Content_465.cv_arg
    cv_content: TypeAlias = Content_465

    @property
    def content(self) -> Content_465:
        return self._get_content() # type: ignore

class Variation_451(Element):
    cv_arg: TypeAlias = RuleContent_465.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_465

    @classmethod
    def create(cls, arg: "Variation_451.cv_arg") -> "Variation_451":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_465:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_465:
        return self.rule.content

class RuleVariation_440(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_451.cv_arg
    cv_variation: TypeAlias = Variation_451

    @classmethod
    def create(cls, arg : "RuleVariation_440.cv_arg") -> "RuleVariation_440":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_451:
        return self.arg # type: ignore

class NonSpare_1356(NonSpare):
    cv_arg: TypeAlias = RuleVariation_440.cv_arg
    cv_name = "NC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_440

    @classmethod
    def create(cls, arg : "NonSpare_1356.cv_arg") -> "NonSpare_1356":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_440:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_451:
        return self.rule.variation

class Item_616(Item):
    cv_arg: TypeAlias = NonSpare_1356.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1356

    @classmethod
    def create(cls, arg : "Item_616.cv_arg") -> "Item_616":
        return cls._create(arg) # type: ignore

class Variation_602(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 6
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_602.cv_arg") -> "Variation_602":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_591(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_602.cv_arg
    cv_variation: TypeAlias = Variation_602

    @classmethod
    def create(cls, arg : "RuleVariation_591.cv_arg") -> "RuleVariation_591":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_602:
        return self.arg # type: ignore

class NonSpare_1848(NonSpare):
    cv_arg: TypeAlias = RuleVariation_591.cv_arg
    cv_name = "TCPN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_591

    @classmethod
    def create(cls, arg : "NonSpare_1848.cv_arg") -> "NonSpare_1848":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_591:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_602:
        return self.rule.variation

class Item_987(Item):
    cv_arg: TypeAlias = NonSpare_1848.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1848

    @classmethod
    def create(cls, arg : "Item_987.cv_arg") -> "Item_987":
        return cls._create(arg) # type: ignore

class Content_632(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 10.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_632(RuleContentContextFree):
    cv_arg: TypeAlias = Content_632.cv_arg
    cv_content: TypeAlias = Content_632

    @property
    def content(self) -> Content_632:
        return self._get_content() # type: ignore

class Variation_261(Element):
    cv_arg: TypeAlias = RuleContent_632.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_632

    @classmethod
    def create(cls, arg: "Variation_261.cv_arg") -> "Variation_261":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_632:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_632:
        return self.rule.content

class RuleVariation_254(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_261.cv_arg
    cv_variation: TypeAlias = Variation_261

    @classmethod
    def create(cls, arg : "RuleVariation_254.cv_arg") -> "RuleVariation_254":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_261:
        return self.arg # type: ignore

class NonSpare_594(NonSpare):
    cv_arg: TypeAlias = RuleVariation_254.cv_arg
    cv_name = "ALT"
    cv_title = "Altitude in Two's Complement Form"
    cv_rule: TypeAlias = RuleVariation_254

    @classmethod
    def create(cls, arg : "NonSpare_594.cv_arg") -> "NonSpare_594":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_254:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_261:
        return self.rule.variation

class Item_61(Item):
    cv_arg: TypeAlias = NonSpare_594.cv_arg
    cv_non_spare: TypeAlias = NonSpare_594

    @classmethod
    def create(cls, arg : "Item_61.cv_arg") -> "Item_61":
        return cls._create(arg) # type: ignore

class NonSpare_1149(NonSpare):
    cv_arg: TypeAlias = RuleVariation_353.cv_arg
    cv_name = "LAT"
    cv_title = "In WGS.84 in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_353

    @classmethod
    def create(cls, arg : "NonSpare_1149.cv_arg") -> "NonSpare_1149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_360:
        return self.rule.variation

class Item_461(Item):
    cv_arg: TypeAlias = NonSpare_1149.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1149

    @classmethod
    def create(cls, arg : "Item_461.cv_arg") -> "Item_461":
        return cls._create(arg) # type: ignore

class NonSpare_1178(NonSpare):
    cv_arg: TypeAlias = RuleVariation_351.cv_arg
    cv_name = "LON"
    cv_title = "In WGS.84 in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_351

    @classmethod
    def create(cls, arg : "NonSpare_1178.cv_arg") -> "NonSpare_1178":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

class Item_488(Item):
    cv_arg: TypeAlias = NonSpare_1178.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1178

    @classmethod
    def create(cls, arg : "Item_488.cv_arg") -> "Item_488":
        return cls._create(arg) # type: ignore

class Content_546(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Fly by waypoint (LT)", 2: "Fly over waypoint (LT)", 3: "Hold pattern (LT)", 4: "Procedure hold (LT)", 5: "Procedure turn (LT)", 6: "RF leg (LT)", 7: "Top of climb (VT)", 8: "Top of descent (VT)", 9: "Start of level (VT)", 10: "Cross-over altitude (VT)", 11: "Transition altitude (VT)"}

class RuleContent_546(RuleContentContextFree):
    cv_arg: TypeAlias = Content_546.cv_arg
    cv_content: TypeAlias = Content_546

    @property
    def content(self) -> Content_546:
        return self._get_content() # type: ignore

class Variation_135(Element):
    cv_arg: TypeAlias = RuleContent_546.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_546

    @classmethod
    def create(cls, arg: "Variation_135.cv_arg") -> "Variation_135":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_546:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_546:
        return self.rule.content

class RuleVariation_135(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_135.cv_arg
    cv_variation: TypeAlias = Variation_135

    @classmethod
    def create(cls, arg : "RuleVariation_135.cv_arg") -> "RuleVariation_135":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_135:
        return self.arg # type: ignore

class NonSpare_1482(NonSpare):
    cv_arg: TypeAlias = RuleVariation_135.cv_arg
    cv_name = "PT"
    cv_title = "Point Type"
    cv_rule: TypeAlias = RuleVariation_135

    @classmethod
    def create(cls, arg : "NonSpare_1482.cv_arg") -> "NonSpare_1482":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_135:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_135:
        return self.rule.variation

class Item_718(Item):
    cv_arg: TypeAlias = NonSpare_1482.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1482

    @classmethod
    def create(cls, arg : "Item_718.cv_arg") -> "Item_718":
        return cls._create(arg) # type: ignore

class Content_300(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "N/A", 1: "Turn right", 2: "Turn left", 3: "No turn"}

class RuleContent_300(RuleContentContextFree):
    cv_arg: TypeAlias = Content_300.cv_arg
    cv_content: TypeAlias = Content_300

    @property
    def content(self) -> Content_300:
        return self._get_content() # type: ignore

class Variation_766(Element):
    cv_arg: TypeAlias = RuleContent_300.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_300

    @classmethod
    def create(cls, arg: "Variation_766.cv_arg") -> "Variation_766":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_300:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_300:
        return self.rule.content

class RuleVariation_755(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_766.cv_arg
    cv_variation: TypeAlias = Variation_766

    @classmethod
    def create(cls, arg : "RuleVariation_755.cv_arg") -> "RuleVariation_755":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_766:
        return self.arg # type: ignore

class NonSpare_1850(NonSpare):
    cv_arg: TypeAlias = RuleVariation_755.cv_arg
    cv_name = "TD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_755

    @classmethod
    def create(cls, arg : "NonSpare_1850.cv_arg") -> "NonSpare_1850":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_755:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_766:
        return self.rule.variation

class Item_989(Item):
    cv_arg: TypeAlias = NonSpare_1850.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1850

    @classmethod
    def create(cls, arg : "Item_989.cv_arg") -> "Item_989":
        return cls._create(arg) # type: ignore

class Content_468(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TTR not available", 1: "TTR available"}

class RuleContent_468(RuleContentContextFree):
    cv_arg: TypeAlias = Content_468.cv_arg
    cv_content: TypeAlias = Content_468

    @property
    def content(self) -> Content_468:
        return self._get_content() # type: ignore

class Variation_953(Element):
    cv_arg: TypeAlias = RuleContent_468.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_468

    @classmethod
    def create(cls, arg: "Variation_953.cv_arg") -> "Variation_953":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_468:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_468:
        return self.rule.content

class RuleVariation_923(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_953.cv_arg
    cv_variation: TypeAlias = Variation_953

    @classmethod
    def create(cls, arg : "RuleVariation_923.cv_arg") -> "RuleVariation_923":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_953:
        return self.arg # type: ignore

class NonSpare_1900(NonSpare):
    cv_arg: TypeAlias = RuleVariation_923.cv_arg
    cv_name = "TRA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_923

    @classmethod
    def create(cls, arg : "NonSpare_1900.cv_arg") -> "NonSpare_1900":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_923:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_953:
        return self.rule.variation

class Item_1023(Item):
    cv_arg: TypeAlias = NonSpare_1900.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1900

    @classmethod
    def create(cls, arg : "Item_1023.cv_arg") -> "Item_1023":
        return cls._create(arg) # type: ignore

class Content_467(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TOV available", 1: "TOV not available"}

class RuleContent_467(RuleContentContextFree):
    cv_arg: TypeAlias = Content_467.cv_arg
    cv_content: TypeAlias = Content_467

    @property
    def content(self) -> Content_467:
        return self._get_content() # type: ignore

class Variation_988(Element):
    cv_arg: TypeAlias = RuleContent_467.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_467

    @classmethod
    def create(cls, arg: "Variation_988.cv_arg") -> "Variation_988":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_467:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_467:
        return self.rule.content

class RuleVariation_958(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_988.cv_arg
    cv_variation: TypeAlias = Variation_988

    @classmethod
    def create(cls, arg : "RuleVariation_958.cv_arg") -> "RuleVariation_958":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_988:
        return self.arg # type: ignore

class NonSpare_1878(NonSpare):
    cv_arg: TypeAlias = RuleVariation_958.cv_arg
    cv_name = "TOA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_958

    @classmethod
    def create(cls, arg : "NonSpare_1878.cv_arg") -> "NonSpare_1878":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_958:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_988:
        return self.rule.variation

class Item_1006(Item):
    cv_arg: TypeAlias = NonSpare_1878.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1878

    @classmethod
    def create(cls, arg : "Item_1006.cv_arg") -> "Item_1006":
        return cls._create(arg) # type: ignore

class Variation_365(Element):
    cv_arg: TypeAlias = RuleContent_724.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_724

    @classmethod
    def create(cls, arg: "Variation_365.cv_arg") -> "Variation_365":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_724:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_724:
        return self.rule.content

class RuleVariation_358(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_365.cv_arg
    cv_variation: TypeAlias = Variation_365

    @classmethod
    def create(cls, arg : "RuleVariation_358.cv_arg") -> "RuleVariation_358":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_365:
        return self.arg # type: ignore

class NonSpare_1889(NonSpare):
    cv_arg: TypeAlias = RuleVariation_358.cv_arg
    cv_name = "TOV"
    cv_title = "Time Over Point"
    cv_rule: TypeAlias = RuleVariation_358

    @classmethod
    def create(cls, arg : "NonSpare_1889.cv_arg") -> "NonSpare_1889":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_358:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_365:
        return self.rule.variation

class Item_1012(Item):
    cv_arg: TypeAlias = NonSpare_1889.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1889

    @classmethod
    def create(cls, arg : "Item_1012.cv_arg") -> "Item_1012":
        return cls._create(arg) # type: ignore

class Content_742(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_742(RuleContentContextFree):
    cv_arg: TypeAlias = Content_742.cv_arg
    cv_content: TypeAlias = Content_742

    @property
    def content(self) -> Content_742:
        return self._get_content() # type: ignore

class Variation_314(Element):
    cv_arg: TypeAlias = RuleContent_742.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_742

    @classmethod
    def create(cls, arg: "Variation_314.cv_arg") -> "Variation_314":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_742:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_742:
        return self.rule.content

class RuleVariation_307(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_314.cv_arg
    cv_variation: TypeAlias = Variation_314

    @classmethod
    def create(cls, arg : "RuleVariation_307.cv_arg") -> "RuleVariation_307":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_314:
        return self.arg # type: ignore

class NonSpare_1952(NonSpare):
    cv_arg: TypeAlias = RuleVariation_307.cv_arg
    cv_name = "TTR"
    cv_title = "TCP Turn Radius"
    cv_rule: TypeAlias = RuleVariation_307

    @classmethod
    def create(cls, arg : "NonSpare_1952.cv_arg") -> "NonSpare_1952":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_314:
        return self.rule.variation

class Item_1067(Item):
    cv_arg: TypeAlias = NonSpare_1952.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1952

    @classmethod
    def create(cls, arg : "Item_1067.cv_arg") -> "Item_1067":
        return cls._create(arg) # type: ignore

class Variation_1221(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_80.cv_arg, Tuple[Literal["TCA"], RuleVariation_80.cv_arg]], Union[RuleVariation_440.cv_arg, Tuple[Literal["NC"], RuleVariation_440.cv_arg]], Union[RuleVariation_591.cv_arg, Tuple[Literal["TCPN"], RuleVariation_591.cv_arg]], Union[RuleVariation_254.cv_arg, Tuple[Literal["ALT"], RuleVariation_254.cv_arg]], Union[RuleVariation_353.cv_arg, Tuple[Literal["LAT"], RuleVariation_353.cv_arg]], Union[RuleVariation_351.cv_arg, Tuple[Literal["LON"], RuleVariation_351.cv_arg]], Union[RuleVariation_135.cv_arg, Tuple[Literal["PT"], RuleVariation_135.cv_arg]], Union[RuleVariation_755.cv_arg, Tuple[Literal["TD"], RuleVariation_755.cv_arg]], Union[RuleVariation_923.cv_arg, Tuple[Literal["TRA"], RuleVariation_923.cv_arg]], Union[RuleVariation_958.cv_arg, Tuple[Literal["TOA"], RuleVariation_958.cv_arg]], Union[RuleVariation_358.cv_arg, Tuple[Literal["TOV"], RuleVariation_358.cv_arg]], Union[RuleVariation_307.cv_arg, Tuple[Literal["TTR"], RuleVariation_307.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1221.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 120
    cv_items_list = [(Item_977, 1), (Item_616, 1), (Item_987, 6), (Item_61, 16), (Item_461, 24), (Item_488, 24), (Item_718, 4), (Item_989, 2), (Item_1023, 1), (Item_1006, 1), (Item_1012, 24), (Item_1067, 16)]
    cv_items_dict = {"TCA": RuleVariation_80, "NC": RuleVariation_440, "TCPN": RuleVariation_591, "ALT": RuleVariation_254, "LAT": RuleVariation_353, "LON": RuleVariation_351, "PT": RuleVariation_135, "TD": RuleVariation_755, "TRA": RuleVariation_923, "TOA": RuleVariation_958, "TOV": RuleVariation_358, "TTR": RuleVariation_307}

    @overload
    @classmethod
    def spec(cls, key : Literal["TCA"]) -> RuleVariation_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NC"]) -> RuleVariation_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCPN"]) -> RuleVariation_591:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_254:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PT"]) -> RuleVariation_135:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TD"]) -> RuleVariation_755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRA"]) -> RuleVariation_923:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> RuleVariation_958:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOV"]) -> RuleVariation_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTR"]) -> RuleVariation_307:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TCA"], Literal["NC"], Literal["TCPN"], Literal["ALT"], Literal["LAT"], Literal["LON"], Literal["PT"], Literal["TD"], Literal["TRA"], Literal["TOA"], Literal["TOV"], Literal["TTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TCA"]) -> RuleVariation_80:
        ...
    @overload
    def get_item(self, key : Literal["NC"]) -> RuleVariation_440:
        ...
    @overload
    def get_item(self, key : Literal["TCPN"]) -> RuleVariation_591:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_254:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["PT"]) -> RuleVariation_135:
        ...
    @overload
    def get_item(self, key : Literal["TD"]) -> RuleVariation_755:
        ...
    @overload
    def get_item(self, key : Literal["TRA"]) -> RuleVariation_923:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> RuleVariation_958:
        ...
    @overload
    def get_item(self, key : Literal["TOV"]) -> RuleVariation_358:
        ...
    @overload
    def get_item(self, key : Literal["TTR"]) -> RuleVariation_307:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1221.cv_arg") -> 'Variation_1221':
        return cls._create(arg) # type: ignore

class Variation_1436(Repetitive):
    cv_arg: TypeAlias = List[Variation_1221.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1221

    @classmethod
    def create(cls, arg: "Variation_1436.cv_arg") -> 'Variation_1436':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1221]:
        return self._get_list() # type: ignore

class RuleVariation_1357(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1436.cv_arg
    cv_variation: TypeAlias = Variation_1436

    @classmethod
    def create(cls, arg : "RuleVariation_1357.cv_arg") -> "RuleVariation_1357":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1436:
        return self.arg # type: ignore

class NonSpare_1866(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1357.cv_arg
    cv_name = "TID"
    cv_title = "Trajectory Intent Data"
    cv_rule: TypeAlias = RuleVariation_1357

    @classmethod
    def create(cls, arg : "NonSpare_1866.cv_arg") -> "NonSpare_1866":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1357:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1436:
        return self.rule.variation

class Variation_1516(Compound):
    cv_arg = TypedDict('cv_arg', {
        "TIS": NonSpare_1871.cv_arg,
        "TID": NonSpare_1866.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1871, NonSpare_1866]
    cv_items_dict = {"TIS": NonSpare_1871, "TID": NonSpare_1866}

    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1871:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1866:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TIS"], Literal["TID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1871]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1866]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1871.cv_arg) -> "Variation_1516":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1866.cv_arg) -> "Variation_1516":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1516":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1516":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1516.cv_arg") -> 'Variation_1516':
        return cls._create(arg) # type: ignore

class RuleVariation_1437(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1516.cv_arg
    cv_variation: TypeAlias = Variation_1516

    @classmethod
    def create(cls, arg : "RuleVariation_1437.cv_arg") -> "RuleVariation_1437":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1516:
        return self.arg # type: ignore

class NonSpare_293(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1437.cv_arg
    cv_name = "110"
    cv_title = "Trajectory Intent"
    cv_rule: TypeAlias = RuleVariation_1437

    @classmethod
    def create(cls, arg : "NonSpare_293.cv_arg") -> "NonSpare_293":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1437:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1516:
        return self.rule.variation

class UapItem_293(UapItem):
    cv_non_spare: TypeAlias = NonSpare_293

class Record_0(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_144.cv_arg,
        "030": NonSpare_110.cv_arg,
        "130": NonSpare_309.cv_arg,
        "080": NonSpare_237.cv_arg,
        "140": NonSpare_322.cv_arg,
        "090": NonSpare_247.cv_arg,
        "210": NonSpare_412.cv_arg,
        "230": NonSpare_434.cv_arg,
        "145": NonSpare_338.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_349.cv_arg,
        "152": NonSpare_351.cv_arg,
        "155": NonSpare_353.cv_arg,
        "157": NonSpare_355.cv_arg,
        "160": NonSpare_358.cv_arg,
        "165": NonSpare_368.cv_arg,
        "170": NonSpare_373.cv_arg,
        "095": NonSpare_266.cv_arg,
        "032": NonSpare_125.cv_arg,
        "200": NonSpare_398.cv_arg,
        "020": NonSpare_80.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_340.cv_arg,
        "148": NonSpare_342.cv_arg,
        "110": NonSpare_293.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_29, UapItem_144, UapItem_110, UapItem_309, UapItem_237, UapItem_322, UapItem_247, UapItem_412, UapItem_434, UapItem_338, UapItem_344, UapItem_349, UapItem_351, UapItem_353, UapItem_355, UapItem_358, UapItem_368, UapItem_373, UapItem_266, UapItem_125, UapItem_398, UapItem_80, UapItem_424, UapItem_340, UapItem_342, UapItem_293, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_144, "030": NonSpare_110, "130": NonSpare_309, "080": NonSpare_237, "140": NonSpare_322, "090": NonSpare_247, "210": NonSpare_412, "230": NonSpare_434, "145": NonSpare_338, "150": NonSpare_344, "151": NonSpare_349, "152": NonSpare_351, "155": NonSpare_353, "157": NonSpare_355, "160": NonSpare_358, "165": NonSpare_368, "170": NonSpare_373, "095": NonSpare_266, "032": NonSpare_125, "200": NonSpare_398, "020": NonSpare_80, "220": NonSpare_424, "146": NonSpare_340, "148": NonSpare_342, "110": NonSpare_293, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_309:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_398:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_340:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_342:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_144]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_110]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_309]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_322]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_247]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_412]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_434]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_355]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_358]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_125]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_398]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_80]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_340]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_342]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_144.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_110.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_309.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_322.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_247.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_412.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_434.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_349.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_351.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_353.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_355.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_358.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_368.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_266.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_125.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_398.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_80.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_340.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_342.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_0':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_0':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_0':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_0':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_0.cv_arg") -> 'Record_0':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_0", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_0(UapSingle):
    cv_arg: TypeAlias = Record_0
    cv_record: TypeAlias = Record_0

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_0]]:
        return cls._parse(bs)

class Asterix_24(AstCat):
    cv_category = 21
    cv_edition = (0, 23)
    cv_uap: TypeAlias = Uap_0
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_0.cv_arg]) -> "Asterix_24":
        return cls._create(records) # type: ignore

class NonSpare_311(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1084.cv_arg
    cv_name = "130"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1084

    @classmethod
    def create(cls, arg : "NonSpare_311.cv_arg") -> "NonSpare_311":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1084:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1128:
        return self.rule.variation

class UapItem_311(UapItem):
    cv_non_spare: TypeAlias = NonSpare_311

class Record_1(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_144.cv_arg,
        "030": NonSpare_110.cv_arg,
        "130": NonSpare_311.cv_arg,
        "080": NonSpare_237.cv_arg,
        "140": NonSpare_322.cv_arg,
        "090": NonSpare_247.cv_arg,
        "210": NonSpare_412.cv_arg,
        "230": NonSpare_434.cv_arg,
        "145": NonSpare_338.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_349.cv_arg,
        "152": NonSpare_351.cv_arg,
        "155": NonSpare_353.cv_arg,
        "157": NonSpare_355.cv_arg,
        "160": NonSpare_358.cv_arg,
        "165": NonSpare_368.cv_arg,
        "170": NonSpare_373.cv_arg,
        "095": NonSpare_266.cv_arg,
        "032": NonSpare_125.cv_arg,
        "200": NonSpare_398.cv_arg,
        "020": NonSpare_80.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_340.cv_arg,
        "148": NonSpare_342.cv_arg,
        "110": NonSpare_293.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_29, UapItem_144, UapItem_110, UapItem_311, UapItem_237, UapItem_322, UapItem_247, UapItem_412, UapItem_434, UapItem_338, UapItem_344, UapItem_349, UapItem_351, UapItem_353, UapItem_355, UapItem_358, UapItem_368, UapItem_373, UapItem_266, UapItem_125, UapItem_398, UapItem_80, UapItem_424, UapItem_340, UapItem_342, UapItem_293, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_144, "030": NonSpare_110, "130": NonSpare_311, "080": NonSpare_237, "140": NonSpare_322, "090": NonSpare_247, "210": NonSpare_412, "230": NonSpare_434, "145": NonSpare_338, "150": NonSpare_344, "151": NonSpare_349, "152": NonSpare_351, "155": NonSpare_353, "157": NonSpare_355, "160": NonSpare_358, "165": NonSpare_368, "170": NonSpare_373, "095": NonSpare_266, "032": NonSpare_125, "200": NonSpare_398, "020": NonSpare_80, "220": NonSpare_424, "146": NonSpare_340, "148": NonSpare_342, "110": NonSpare_293, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_322:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_398:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_340:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_342:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_144]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_110]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_322]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_247]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_412]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_434]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_355]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_358]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_125]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_398]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_80]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_340]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_342]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_144.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_110.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_311.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_322.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_247.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_412.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_434.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_349.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_351.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_353.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_355.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_358.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_368.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_266.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_125.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_398.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_80.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_340.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_342.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_1':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_1':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_1':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_1':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_1.cv_arg") -> 'Record_1':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_1", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_1(UapSingle):
    cv_arg: TypeAlias = Record_1
    cv_record: TypeAlias = Record_1

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_1]]:
        return cls._parse(bs)

class Asterix_25(AstCat):
    cv_category = 21
    cv_edition = (0, 24)
    cv_uap: TypeAlias = Uap_1
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_1.cv_arg]) -> "Asterix_25":
        return cls._create(records) # type: ignore

class NonSpare_323(NonSpare):
    cv_arg: TypeAlias = RuleVariation_284.cv_arg
    cv_name = "140"
    cv_title = "Geometric Altitude"
    cv_rule: TypeAlias = RuleVariation_284

    @classmethod
    def create(cls, arg : "NonSpare_323.cv_arg") -> "NonSpare_323":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

class UapItem_323(UapItem):
    cv_non_spare: TypeAlias = NonSpare_323

class Record_3(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_144.cv_arg,
        "030": NonSpare_110.cv_arg,
        "130": NonSpare_311.cv_arg,
        "080": NonSpare_237.cv_arg,
        "140": NonSpare_323.cv_arg,
        "090": NonSpare_247.cv_arg,
        "210": NonSpare_412.cv_arg,
        "230": NonSpare_434.cv_arg,
        "145": NonSpare_338.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_349.cv_arg,
        "152": NonSpare_351.cv_arg,
        "155": NonSpare_353.cv_arg,
        "157": NonSpare_355.cv_arg,
        "160": NonSpare_358.cv_arg,
        "165": NonSpare_368.cv_arg,
        "170": NonSpare_373.cv_arg,
        "095": NonSpare_266.cv_arg,
        "032": NonSpare_125.cv_arg,
        "200": NonSpare_398.cv_arg,
        "020": NonSpare_80.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_340.cv_arg,
        "148": NonSpare_342.cv_arg,
        "110": NonSpare_293.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_29, UapItem_144, UapItem_110, UapItem_311, UapItem_237, UapItem_323, UapItem_247, UapItem_412, UapItem_434, UapItem_338, UapItem_344, UapItem_349, UapItem_351, UapItem_353, UapItem_355, UapItem_358, UapItem_368, UapItem_373, UapItem_266, UapItem_125, UapItem_398, UapItem_80, UapItem_424, UapItem_340, UapItem_342, UapItem_293, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_144, "030": NonSpare_110, "130": NonSpare_311, "080": NonSpare_237, "140": NonSpare_323, "090": NonSpare_247, "210": NonSpare_412, "230": NonSpare_434, "145": NonSpare_338, "150": NonSpare_344, "151": NonSpare_349, "152": NonSpare_351, "155": NonSpare_353, "157": NonSpare_355, "160": NonSpare_358, "165": NonSpare_368, "170": NonSpare_373, "095": NonSpare_266, "032": NonSpare_125, "200": NonSpare_398, "020": NonSpare_80, "220": NonSpare_424, "146": NonSpare_340, "148": NonSpare_342, "110": NonSpare_293, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_398:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_340:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_342:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_144]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_110]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_323]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_247]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_412]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_434]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_355]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_358]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_125]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_398]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_80]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_340]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_342]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_144.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_110.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_311.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_323.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_247.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_412.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_434.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_349.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_351.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_353.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_355.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_358.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_368.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_266.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_125.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_398.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_80.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_340.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_342.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_3':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_3':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_3':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_3':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_3.cv_arg") -> 'Record_3':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_3", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_3(UapSingle):
    cv_arg: TypeAlias = Record_3
    cv_record: TypeAlias = Record_3

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_3]]:
        return cls._parse(bs)

class Asterix_26(AstCat):
    cv_category = 21
    cv_edition = (0, 25)
    cv_uap: TypeAlias = Uap_3
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_3.cv_arg]) -> "Asterix_26":
        return cls._create(records) # type: ignore

class Content_289(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-3/A code derived during last update", 1: "Mode-3/A code not extracted during the last update"}

class RuleContent_289(RuleContentContextFree):
    cv_arg: TypeAlias = Content_289.cv_arg
    cv_content: TypeAlias = Content_289

    @property
    def content(self) -> Content_289:
        return self._get_content() # type: ignore

class Variation_552(Element):
    cv_arg: TypeAlias = RuleContent_289.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_289

    @classmethod
    def create(cls, arg: "Variation_552.cv_arg") -> "Variation_552":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_289:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_289:
        return self.rule.content

class RuleVariation_541(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_552.cv_arg
    cv_variation: TypeAlias = Variation_552

    @classmethod
    def create(cls, arg : "RuleVariation_541.cv_arg") -> "RuleVariation_541":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_552:
        return self.arg # type: ignore

class NonSpare_1140(NonSpare):
    cv_arg: TypeAlias = RuleVariation_541.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_541

    @classmethod
    def create(cls, arg : "NonSpare_1140.cv_arg") -> "NonSpare_1140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_541:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_552:
        return self.rule.variation

class Item_452(Item):
    cv_arg: TypeAlias = NonSpare_1140.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1140

    @classmethod
    def create(cls, arg : "Item_452.cv_arg") -> "Item_452":
        return cls._create(arg) # type: ignore

class Variation_1263(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_541.cv_arg, Tuple[Literal["L"], RuleVariation_541.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1263.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_452, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_541, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_541:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_541:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1263.cv_arg") -> 'Variation_1263':
        return cls._create(arg) # type: ignore

class RuleVariation_1192(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1263.cv_arg
    cv_variation: TypeAlias = Variation_1263

    @classmethod
    def create(cls, arg : "RuleVariation_1192.cv_arg") -> "RuleVariation_1192":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1263:
        return self.arg # type: ignore

class NonSpare_209(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1192.cv_arg
    cv_name = "070"
    cv_title = "Mode 3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1192

    @classmethod
    def create(cls, arg : "NonSpare_209.cv_arg") -> "NonSpare_209":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1192:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1263:
        return self.rule.variation

class UapItem_209(UapItem):
    cv_non_spare: TypeAlias = NonSpare_209

class NonSpare_317(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "131"
    cv_title = "Signal Amplitude"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_317.cv_arg") -> "NonSpare_317":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_317(UapItem):
    cv_non_spare: TypeAlias = NonSpare_317

class Record_2(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_144.cv_arg,
        "030": NonSpare_110.cv_arg,
        "130": NonSpare_311.cv_arg,
        "080": NonSpare_237.cv_arg,
        "140": NonSpare_323.cv_arg,
        "090": NonSpare_247.cv_arg,
        "210": NonSpare_412.cv_arg,
        "230": NonSpare_434.cv_arg,
        "145": NonSpare_338.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_349.cv_arg,
        "152": NonSpare_351.cv_arg,
        "155": NonSpare_353.cv_arg,
        "157": NonSpare_355.cv_arg,
        "160": NonSpare_358.cv_arg,
        "165": NonSpare_368.cv_arg,
        "170": NonSpare_373.cv_arg,
        "095": NonSpare_266.cv_arg,
        "032": NonSpare_125.cv_arg,
        "200": NonSpare_398.cv_arg,
        "020": NonSpare_80.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_340.cv_arg,
        "148": NonSpare_342.cv_arg,
        "110": NonSpare_293.cv_arg,
        "070": NonSpare_209.cv_arg,
        "131": NonSpare_317.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_29, UapItem_144, UapItem_110, UapItem_311, UapItem_237, UapItem_323, UapItem_247, UapItem_412, UapItem_434, UapItem_338, UapItem_344, UapItem_349, UapItem_351, UapItem_353, UapItem_355, UapItem_358, UapItem_368, UapItem_373, UapItem_266, UapItem_125, UapItem_398, UapItem_80, UapItem_424, UapItem_340, UapItem_342, UapItem_293, UapItem_209, UapItem_317, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_144, "030": NonSpare_110, "130": NonSpare_311, "080": NonSpare_237, "140": NonSpare_323, "090": NonSpare_247, "210": NonSpare_412, "230": NonSpare_434, "145": NonSpare_338, "150": NonSpare_344, "151": NonSpare_349, "152": NonSpare_351, "155": NonSpare_353, "157": NonSpare_355, "160": NonSpare_358, "165": NonSpare_368, "170": NonSpare_373, "095": NonSpare_266, "032": NonSpare_125, "200": NonSpare_398, "020": NonSpare_80, "220": NonSpare_424, "146": NonSpare_340, "148": NonSpare_342, "110": NonSpare_293, "070": NonSpare_209, "131": NonSpare_317, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_311:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_412:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_349:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["095"]) -> NonSpare_266:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["032"]) -> NonSpare_125:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_398:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_340:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_342:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_209:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_317:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["030"], Literal["130"], Literal["080"], Literal["140"], Literal["090"], Literal["210"], Literal["230"], Literal["145"], Literal["150"], Literal["151"], Literal["152"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["170"], Literal["095"], Literal["032"], Literal["200"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["070"], Literal["131"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_144]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_110]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_311]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_323]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_247]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_412]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_434]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_349]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_351]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_353]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_355]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_358]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_368]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["095"]) -> Optional[NonSpare_266]:
        ...
    @overload
    def get_item(self, key : Literal["032"]) -> Optional[NonSpare_125]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_398]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_80]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_340]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_342]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_209]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_317]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_144.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_110.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_311.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_323.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_247.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_412.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_434.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_349.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_351.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_353.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_355.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_358.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_368.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["095"], val : NonSpare_266.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["032"], val : NonSpare_125.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_398.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_80.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_340.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_342.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_209.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_317.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_2':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_2':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["095"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["032"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_2':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_2':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_2.cv_arg") -> 'Record_2':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_2", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_2(UapSingle):
    cv_arg: TypeAlias = Record_2
    cv_record: TypeAlias = Record_2

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_2]]:
        return cls._parse(bs)

class Asterix_27(AstCat):
    cv_category = 21
    cv_edition = (0, 26)
    cv_uap: TypeAlias = Uap_2
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_2.cv_arg]) -> "Asterix_27":
        return cls._create(records) # type: ignore

class Content_736(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["hPa"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "hPa"

    def as_quantity(self, cv_unit : Optional[Literal["hPa"]] = None) -> float:
        return self._as_quantity()

class RuleContent_736(RuleContentContextFree):
    cv_arg: TypeAlias = Content_736.cv_arg
    cv_content: TypeAlias = Content_736

    @property
    def content(self) -> Content_736:
        return self._get_content() # type: ignore

class Variation_812(Element):
    cv_arg: TypeAlias = RuleContent_736.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_736

    @classmethod
    def create(cls, arg: "Variation_812.cv_arg") -> "Variation_812":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_736:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_736:
        return self.rule.content

class RuleVariation_782(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_812.cv_arg
    cv_variation: TypeAlias = Variation_812

    @classmethod
    def create(cls, arg : "RuleVariation_782.cv_arg") -> "RuleVariation_782":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_812:
        return self.arg # type: ignore

class NonSpare_691(NonSpare):
    cv_arg: TypeAlias = RuleVariation_782.cv_arg
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting"
    cv_rule: TypeAlias = RuleVariation_782

    @classmethod
    def create(cls, arg : "NonSpare_691.cv_arg") -> "NonSpare_691":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_782:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_812:
        return self.rule.variation

class Item_130(Item):
    cv_arg: TypeAlias = NonSpare_691.cv_arg
    cv_non_spare: TypeAlias = NonSpare_691

    @classmethod
    def create(cls, arg : "Item_130.cv_arg") -> "Item_130":
        return cls._create(arg) # type: ignore

class Variation_1020(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_782.cv_arg, Tuple[Literal["BPS"], RuleVariation_782.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1020.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_130, 12)]
    cv_items_dict = {"BPS": RuleVariation_782}

    @classmethod
    def spec(cls, key : Literal["BPS"]) -> RuleVariation_782:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["BPS"]) -> RuleVariation_782:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1020.cv_arg") -> 'Variation_1020':
        return cls._create(arg) # type: ignore

class RuleVariation_990(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1020.cv_arg
    cv_variation: TypeAlias = Variation_1020

    @classmethod
    def create(cls, arg : "RuleVariation_990.cv_arg") -> "RuleVariation_990":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1020:
        return self.arg # type: ignore

class NonSpare_693(NonSpare):
    cv_arg: TypeAlias = RuleVariation_990.cv_arg
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting"
    cv_rule: TypeAlias = RuleVariation_990

    @classmethod
    def create(cls, arg : "NonSpare_693.cv_arg") -> "NonSpare_693":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_990:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1020:
        return self.rule.variation

class Content_526(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "True North", 1: "Magnetic North"}

class RuleContent_526(RuleContentContextFree):
    cv_arg: TypeAlias = Content_526.cv_arg
    cv_content: TypeAlias = Content_526

    @property
    def content(self) -> Content_526:
        return self._get_content() # type: ignore

class Variation_758(Element):
    cv_arg: TypeAlias = RuleContent_526.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_526

    @classmethod
    def create(cls, arg: "Variation_758.cv_arg") -> "Variation_758":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_526:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_526:
        return self.rule.content

class RuleVariation_747(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_758.cv_arg
    cv_variation: TypeAlias = Variation_758

    @classmethod
    def create(cls, arg : "RuleVariation_747.cv_arg") -> "RuleVariation_747":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_758:
        return self.arg # type: ignore

class NonSpare_1062(NonSpare):
    cv_arg: TypeAlias = RuleVariation_747.cv_arg
    cv_name = "HDR"
    cv_title = "Horizontal Reference Direction"
    cv_rule: TypeAlias = RuleVariation_747

    @classmethod
    def create(cls, arg : "NonSpare_1062.cv_arg") -> "NonSpare_1062":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_747:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_758:
        return self.rule.variation

class Item_390(Item):
    cv_arg: TypeAlias = NonSpare_1062.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1062

    @classmethod
    def create(cls, arg : "Item_390.cv_arg") -> "Item_390":
        return cls._create(arg) # type: ignore

class Content_76(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Data is either unavailable or invalid", 1: "Data is available and valid"}

class RuleContent_76(RuleContentContextFree):
    cv_arg: TypeAlias = Content_76.cv_arg
    cv_content: TypeAlias = Content_76

    @property
    def content(self) -> Content_76:
        return self._get_content() # type: ignore

class Variation_828(Element):
    cv_arg: TypeAlias = RuleContent_76.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_76

    @classmethod
    def create(cls, arg: "Variation_828.cv_arg") -> "Variation_828":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_76:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_76:
        return self.rule.content

class RuleVariation_798(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_828.cv_arg
    cv_variation: TypeAlias = Variation_828

    @classmethod
    def create(cls, arg : "RuleVariation_798.cv_arg") -> "RuleVariation_798":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_828:
        return self.arg # type: ignore

class NonSpare_1782(NonSpare):
    cv_arg: TypeAlias = RuleVariation_798.cv_arg
    cv_name = "STAT"
    cv_title = "Selected Heading Status"
    cv_rule: TypeAlias = RuleVariation_798

    @classmethod
    def create(cls, arg : "NonSpare_1782.cv_arg") -> "NonSpare_1782":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_798:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_828:
        return self.rule.variation

class Item_943(Item):
    cv_arg: TypeAlias = NonSpare_1782.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1782

    @classmethod
    def create(cls, arg : "Item_943.cv_arg") -> "Item_943":
        return cls._create(arg) # type: ignore

class Content_785(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.703125
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_784(RuleContentContextFree):
    cv_arg: TypeAlias = Content_785.cv_arg
    cv_content: TypeAlias = Content_785

    @property
    def content(self) -> Content_785:
        return self._get_content() # type: ignore

class Variation_970(Element):
    cv_arg: TypeAlias = RuleContent_784.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_784

    @classmethod
    def create(cls, arg: "Variation_970.cv_arg") -> "Variation_970":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_784:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_785:
        return self.rule.content

class RuleVariation_940(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_970.cv_arg
    cv_variation: TypeAlias = Variation_970

    @classmethod
    def create(cls, arg : "RuleVariation_940.cv_arg") -> "RuleVariation_940":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_970:
        return self.arg # type: ignore

class NonSpare_1705(NonSpare):
    cv_arg: TypeAlias = RuleVariation_940.cv_arg
    cv_name = "SH"
    cv_title = "Selected Heading"
    cv_rule: TypeAlias = RuleVariation_940

    @classmethod
    def create(cls, arg : "NonSpare_1705.cv_arg") -> "NonSpare_1705":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_940:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_970:
        return self.rule.variation

class Item_883(Item):
    cv_arg: TypeAlias = NonSpare_1705.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1705

    @classmethod
    def create(cls, arg : "Item_883.cv_arg") -> "Item_883":
        return cls._create(arg) # type: ignore

class Variation_1023(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_747.cv_arg, Tuple[Literal["HDR"], RuleVariation_747.cv_arg]], Union[RuleVariation_798.cv_arg, Tuple[Literal["STAT"], RuleVariation_798.cv_arg]], Union[RuleVariation_940.cv_arg, Tuple[Literal["SH"], RuleVariation_940.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1023.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_390, 1), (Item_943, 1), (Item_883, 10)]
    cv_items_dict = {"HDR": RuleVariation_747, "STAT": RuleVariation_798, "SH": RuleVariation_940}

    @overload
    @classmethod
    def spec(cls, key : Literal["HDR"]) -> RuleVariation_747:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_798:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SH"]) -> RuleVariation_940:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HDR"], Literal["STAT"], Literal["SH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HDR"]) -> RuleVariation_747:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_798:
        ...
    @overload
    def get_item(self, key : Literal["SH"]) -> RuleVariation_940:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1023.cv_arg") -> 'Variation_1023':
        return cls._create(arg) # type: ignore

class RuleVariation_992(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1023.cv_arg
    cv_variation: TypeAlias = Variation_1023

    @classmethod
    def create(cls, arg : "RuleVariation_992.cv_arg") -> "RuleVariation_992":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1023:
        return self.arg # type: ignore

class NonSpare_1706(NonSpare):
    cv_arg: TypeAlias = RuleVariation_992.cv_arg
    cv_name = "SH"
    cv_title = "Selected Heading"
    cv_rule: TypeAlias = RuleVariation_992

    @classmethod
    def create(cls, arg : "NonSpare_1706.cv_arg") -> "NonSpare_1706":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_992:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1023:
        return self.rule.variation

class Content_42(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Autopilot not engaged", 1: "Autopilot engaged"}

class RuleContent_42(RuleContentContextFree):
    cv_arg: TypeAlias = Content_42.cv_arg
    cv_content: TypeAlias = Content_42

    @property
    def content(self) -> Content_42:
        return self._get_content() # type: ignore

class Variation_13(Element):
    cv_arg: TypeAlias = RuleContent_42.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_42

    @classmethod
    def create(cls, arg: "Variation_13.cv_arg") -> "Variation_13":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_42:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_42:
        return self.rule.content

class RuleVariation_13(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_13.cv_arg
    cv_variation: TypeAlias = Variation_13

    @classmethod
    def create(cls, arg : "RuleVariation_13.cv_arg") -> "RuleVariation_13":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_13:
        return self.arg # type: ignore

class NonSpare_614(NonSpare):
    cv_arg: TypeAlias = RuleVariation_13.cv_arg
    cv_name = "AP"
    cv_title = "Autopilot"
    cv_rule: TypeAlias = RuleVariation_13

    @classmethod
    def create(cls, arg : "NonSpare_614.cv_arg") -> "NonSpare_614":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_13:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_13:
        return self.rule.variation

class Item_76(Item):
    cv_arg: TypeAlias = NonSpare_614.cv_arg
    cv_non_spare: TypeAlias = NonSpare_614

    @classmethod
    def create(cls, arg : "Item_76.cv_arg") -> "Item_76":
        return cls._create(arg) # type: ignore

class Content_561(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Vertical Navigation not active", 1: "Vertical Navigation active"}

class RuleContent_561(RuleContentContextFree):
    cv_arg: TypeAlias = Content_561.cv_arg
    cv_content: TypeAlias = Content_561

    @property
    def content(self) -> Content_561:
        return self._get_content() # type: ignore

class Variation_464(Element):
    cv_arg: TypeAlias = RuleContent_561.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_561

    @classmethod
    def create(cls, arg: "Variation_464.cv_arg") -> "Variation_464":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_561:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_561:
        return self.rule.content

class RuleVariation_453(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_464.cv_arg
    cv_variation: TypeAlias = Variation_464

    @classmethod
    def create(cls, arg : "RuleVariation_453.cv_arg") -> "RuleVariation_453":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_464:
        return self.arg # type: ignore

class NonSpare_2036(NonSpare):
    cv_arg: TypeAlias = RuleVariation_453.cv_arg
    cv_name = "VN"
    cv_title = "Vertical Navigation"
    cv_rule: TypeAlias = RuleVariation_453

    @classmethod
    def create(cls, arg : "NonSpare_2036.cv_arg") -> "NonSpare_2036":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_453:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_464:
        return self.rule.variation

class Item_1145(Item):
    cv_arg: TypeAlias = NonSpare_2036.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2036

    @classmethod
    def create(cls, arg : "Item_1145.cv_arg") -> "Item_1145":
        return cls._create(arg) # type: ignore

class Content_32(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Altitude Hold not engaged", 1: "Altitude Hold engaged"}

class RuleContent_32(RuleContentContextFree):
    cv_arg: TypeAlias = Content_32.cv_arg
    cv_content: TypeAlias = Content_32

    @property
    def content(self) -> Content_32:
        return self._get_content() # type: ignore

class Variation_510(Element):
    cv_arg: TypeAlias = RuleContent_32.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_32

    @classmethod
    def create(cls, arg: "Variation_510.cv_arg") -> "Variation_510":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_32:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_32:
        return self.rule.content

class RuleVariation_499(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_510.cv_arg
    cv_variation: TypeAlias = Variation_510

    @classmethod
    def create(cls, arg : "RuleVariation_499.cv_arg") -> "RuleVariation_499":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_510:
        return self.arg # type: ignore

class NonSpare_583(NonSpare):
    cv_arg: TypeAlias = RuleVariation_499.cv_arg
    cv_name = "AH"
    cv_title = "Altitude Hold"
    cv_rule: TypeAlias = RuleVariation_499

    @classmethod
    def create(cls, arg : "NonSpare_583.cv_arg") -> "NonSpare_583":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_499:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_510:
        return self.rule.variation

class Item_52(Item):
    cv_arg: TypeAlias = NonSpare_583.cv_arg
    cv_non_spare: TypeAlias = NonSpare_583

    @classmethod
    def create(cls, arg : "Item_52.cv_arg") -> "Item_52":
        return cls._create(arg) # type: ignore

class Content_35(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Approach Mode not active", 1: "Approach Mode active"}

class RuleContent_35(RuleContentContextFree):
    cv_arg: TypeAlias = Content_35.cv_arg
    cv_content: TypeAlias = Content_35

    @property
    def content(self) -> Content_35:
        return self._get_content() # type: ignore

class Variation_617(Element):
    cv_arg: TypeAlias = RuleContent_35.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_35

    @classmethod
    def create(cls, arg: "Variation_617.cv_arg") -> "Variation_617":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_35:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_35:
        return self.rule.content

class RuleVariation_606(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_617.cv_arg
    cv_variation: TypeAlias = Variation_617

    @classmethod
    def create(cls, arg : "RuleVariation_606.cv_arg") -> "RuleVariation_606":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_617:
        return self.arg # type: ignore

class NonSpare_606(NonSpare):
    cv_arg: TypeAlias = RuleVariation_606.cv_arg
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule: TypeAlias = RuleVariation_606

    @classmethod
    def create(cls, arg : "NonSpare_606.cv_arg") -> "NonSpare_606":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_606:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_617:
        return self.rule.variation

class Item_70(Item):
    cv_arg: TypeAlias = NonSpare_606.cv_arg
    cv_non_spare: TypeAlias = NonSpare_606

    @classmethod
    def create(cls, arg : "Item_70.cv_arg") -> "Item_70":
        return cls._create(arg) # type: ignore

class Variation_1052(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_13.cv_arg, Tuple[Literal["AP"], RuleVariation_13.cv_arg]], Union[RuleVariation_453.cv_arg, Tuple[Literal["VN"], RuleVariation_453.cv_arg]], Union[RuleVariation_499.cv_arg, Tuple[Literal["AH"], RuleVariation_499.cv_arg]], Union[RuleVariation_606.cv_arg, Tuple[Literal["AM"], RuleVariation_606.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1052.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_76, 1), (Item_1145, 1), (Item_52, 1), (Item_70, 1), (Item_22, 4)]
    cv_items_dict = {"AP": RuleVariation_13, "VN": RuleVariation_453, "AH": RuleVariation_499, "AM": RuleVariation_606}

    @overload
    @classmethod
    def spec(cls, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_453:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_499:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_606:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AP"], Literal["VN"], Literal["AH"], Literal["AM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_453:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_499:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_606:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1052.cv_arg") -> 'Variation_1052':
        return cls._create(arg) # type: ignore

class RuleVariation_1019(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1052.cv_arg
    cv_variation: TypeAlias = Variation_1052

    @classmethod
    def create(cls, arg : "RuleVariation_1019.cv_arg") -> "RuleVariation_1019":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1052:
        return self.arg # type: ignore

class NonSpare_1346(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1019.cv_arg
    cv_name = "NAV"
    cv_title = "Navigation Mode"
    cv_rule: TypeAlias = RuleVariation_1019

    @classmethod
    def create(cls, arg : "NonSpare_1346.cv_arg") -> "NonSpare_1346":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1019:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1052:
        return self.rule.variation

class NonSpare_1022(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "GAO"
    cv_title = "GPS Antenna Offset"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1022.cv_arg") -> "NonSpare_1022":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Content_27(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft has not stopped", 1: "Aircraft has stopped"}

class RuleContent_27(RuleContentContextFree):
    cv_arg: TypeAlias = Content_27.cv_arg
    cv_content: TypeAlias = Content_27

    @property
    def content(self) -> Content_27:
        return self._get_content() # type: ignore

class Variation_9(Element):
    cv_arg: TypeAlias = RuleContent_27.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_27

    @classmethod
    def create(cls, arg: "Variation_9.cv_arg") -> "Variation_9":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_27:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_27:
        return self.rule.content

class RuleVariation_9(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_9.cv_arg
    cv_variation: TypeAlias = Variation_9

    @classmethod
    def create(cls, arg : "RuleVariation_9.cv_arg") -> "RuleVariation_9":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_9:
        return self.arg # type: ignore

class Content_224(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Heading/Ground Track data is not valid", 1: "Heading/Ground Track data is valid"}

class RuleContent_224(RuleContentContextFree):
    cv_arg: TypeAlias = Content_224.cv_arg
    cv_content: TypeAlias = Content_224

    @property
    def content(self) -> Content_224:
        return self._get_content() # type: ignore

class Variation_430(Element):
    cv_arg: TypeAlias = RuleContent_224.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_224

    @classmethod
    def create(cls, arg: "Variation_430.cv_arg") -> "Variation_430":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_224:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_224:
        return self.rule.content

class RuleVariation_419(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_430.cv_arg
    cv_variation: TypeAlias = Variation_430

    @classmethod
    def create(cls, arg : "RuleVariation_419.cv_arg") -> "RuleVariation_419":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_430:
        return self.arg # type: ignore

class Content_223(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Heading data provided", 1: "Ground Track provided"}

class RuleContent_223(RuleContentContextFree):
    cv_arg: TypeAlias = Content_223.cv_arg
    cv_content: TypeAlias = Content_223

    @property
    def content(self) -> Content_223:
        return self._get_content() # type: ignore

class Variation_536(Element):
    cv_arg: TypeAlias = RuleContent_223.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_223

    @classmethod
    def create(cls, arg: "Variation_536.cv_arg") -> "Variation_536":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_223:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_223:
        return self.rule.content

class RuleVariation_525(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_536.cv_arg
    cv_variation: TypeAlias = Variation_536

    @classmethod
    def create(cls, arg : "RuleVariation_525.cv_arg") -> "RuleVariation_525":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_536:
        return self.arg # type: ignore

class Variation_670(Element):
    cv_arg: TypeAlias = RuleContent_526.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_526

    @classmethod
    def create(cls, arg: "Variation_670.cv_arg") -> "Variation_670":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_526:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_526:
        return self.rule.content

class RuleVariation_659(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_670.cv_arg
    cv_variation: TypeAlias = Variation_670

    @classmethod
    def create(cls, arg : "RuleVariation_659.cv_arg") -> "RuleVariation_659":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_670:
        return self.arg # type: ignore

class Content_762(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.125
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

class RuleContent_761(RuleContentContextFree):
    cv_arg: TypeAlias = Content_762.cv_arg
    cv_content: TypeAlias = Content_762

    @property
    def content(self) -> Content_762:
        return self._get_content() # type: ignore

class Variation_807(Element):
    cv_arg: TypeAlias = RuleContent_761.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 11
    cv_rule = RuleContent_761

    @classmethod
    def create(cls, arg: "Variation_807.cv_arg") -> "Variation_807":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_761:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_762:
        return self.rule.content

class RuleVariation_777(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_807.cv_arg
    cv_variation: TypeAlias = Variation_807

    @classmethod
    def create(cls, arg : "RuleVariation_777.cv_arg") -> "RuleVariation_777":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_807:
        return self.arg # type: ignore

class Content_784(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 2.8125
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_783(RuleContentContextFree):
    cv_arg: TypeAlias = Content_784.cv_arg
    cv_content: TypeAlias = Content_784

    @property
    def content(self) -> Content_784:
        return self._get_content() # type: ignore

class Variation_163(Element):
    cv_arg: TypeAlias = RuleContent_783.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_783

    @classmethod
    def create(cls, arg: "Variation_163.cv_arg") -> "Variation_163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_783:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_784:
        return self.rule.content

class RuleVariation_157(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_163.cv_arg
    cv_variation: TypeAlias = Variation_163

    @classmethod
    def create(cls, arg : "RuleVariation_157.cv_arg") -> "RuleVariation_157":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_163:
        return self.arg # type: ignore

class NonSpare_1795(NonSpare):
    cv_arg: TypeAlias = RuleVariation_9.cv_arg
    cv_name = "STP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_9

    @classmethod
    def create(cls, arg : "NonSpare_1795.cv_arg") -> "NonSpare_1795":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_9:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_9:
        return self.rule.variation

class Item_955(Item):
    cv_arg: TypeAlias = NonSpare_1795.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1795

    @classmethod
    def create(cls, arg : "Item_955.cv_arg") -> "Item_955":
        return cls._create(arg) # type: ignore

class NonSpare_1082(NonSpare):
    cv_arg: TypeAlias = RuleVariation_419.cv_arg
    cv_name = "HTS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_419

    @classmethod
    def create(cls, arg : "NonSpare_1082.cv_arg") -> "NonSpare_1082":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_419:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_430:
        return self.rule.variation

class Item_405(Item):
    cv_arg: TypeAlias = NonSpare_1082.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1082

    @classmethod
    def create(cls, arg : "Item_405.cv_arg") -> "Item_405":
        return cls._create(arg) # type: ignore

class NonSpare_1083(NonSpare):
    cv_arg: TypeAlias = RuleVariation_525.cv_arg
    cv_name = "HTT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_525

    @classmethod
    def create(cls, arg : "NonSpare_1083.cv_arg") -> "NonSpare_1083":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_525:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_536:
        return self.rule.variation

class Item_406(Item):
    cv_arg: TypeAlias = NonSpare_1083.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1083

    @classmethod
    def create(cls, arg : "Item_406.cv_arg") -> "Item_406":
        return cls._create(arg) # type: ignore

class NonSpare_1081(NonSpare):
    cv_arg: TypeAlias = RuleVariation_659.cv_arg
    cv_name = "HRD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_659

    @classmethod
    def create(cls, arg : "NonSpare_1081.cv_arg") -> "NonSpare_1081":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_659:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_670:
        return self.rule.variation

class Item_404(Item):
    cv_arg: TypeAlias = NonSpare_1081.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1081

    @classmethod
    def create(cls, arg : "Item_404.cv_arg") -> "Item_404":
        return cls._create(arg) # type: ignore

class NonSpare_1044(NonSpare):
    cv_arg: TypeAlias = RuleVariation_777.cv_arg
    cv_name = "GSS"
    cv_title = "Ground Speed"
    cv_rule: TypeAlias = RuleVariation_777

    @classmethod
    def create(cls, arg : "NonSpare_1044.cv_arg") -> "NonSpare_1044":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_777:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_807:
        return self.rule.variation

class Item_377(Item):
    cv_arg: TypeAlias = NonSpare_1044.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1044

    @classmethod
    def create(cls, arg : "Item_377.cv_arg") -> "Item_377":
        return cls._create(arg) # type: ignore

class NonSpare_1067(NonSpare):
    cv_arg: TypeAlias = RuleVariation_157.cv_arg
    cv_name = "HGT"
    cv_title = "Heading/Ground Track Information"
    cv_rule: TypeAlias = RuleVariation_157

    @classmethod
    def create(cls, arg : "NonSpare_1067.cv_arg") -> "NonSpare_1067":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_157:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_163:
        return self.rule.variation

class Item_393(Item):
    cv_arg: TypeAlias = NonSpare_1067.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1067

    @classmethod
    def create(cls, arg : "Item_393.cv_arg") -> "Item_393":
        return cls._create(arg) # type: ignore

class Variation_1385(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_9.cv_arg, Tuple[Literal["STP"], RuleVariation_9.cv_arg]], Union[RuleVariation_419.cv_arg, Tuple[Literal["HTS"], RuleVariation_419.cv_arg]], Union[RuleVariation_525.cv_arg, Tuple[Literal["HTT"], RuleVariation_525.cv_arg]], Union[RuleVariation_659.cv_arg, Tuple[Literal["HRD"], RuleVariation_659.cv_arg]], Union[RuleVariation_777.cv_arg, Tuple[Literal["GSS"], RuleVariation_777.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_157.cv_arg, Tuple[Literal["HGT"], RuleVariation_157.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1385.cv_arg_group_1"],
        Tuple["Variation_1385.cv_arg_group_1", "Variation_1385.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_955, 1), (Item_405, 1), (Item_406, 1), (Item_404, 1), (Item_377, 11), None], [(Item_393, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1385.cv_arg") -> 'Variation_1385':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["STP"]) -> RuleVariation_9:
        ...
    @overload
    def get_item(self, key : Literal["HTS"]) -> RuleVariation_419:
        ...
    @overload
    def get_item(self, key : Literal["HTT"]) -> RuleVariation_525:
        ...
    @overload
    def get_item(self, key : Literal["HRD"]) -> RuleVariation_659:
        ...
    @overload
    def get_item(self, key : Literal["GSS"]) -> RuleVariation_777:
        ...
    @overload
    def get_item(self, key : Literal["HGT"]) -> Optional[RuleVariation_157]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1306(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1385.cv_arg
    cv_variation: TypeAlias = Variation_1385

    @classmethod
    def create(cls, arg : "RuleVariation_1306.cv_arg") -> "RuleVariation_1306":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1385:
        return self.arg # type: ignore

class NonSpare_1704(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1306.cv_arg
    cv_name = "SGV"
    cv_title = "Surface Ground Vector"
    cv_rule: TypeAlias = RuleVariation_1306

    @classmethod
    def create(cls, arg : "NonSpare_1704.cv_arg") -> "NonSpare_1704":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1306:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1385:
        return self.rule.variation

class Content_479(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Target is not 1090 ES IN capable", 1: "Target is 1090 ES IN capable"}

class RuleContent_479(RuleContentContextFree):
    cv_arg: TypeAlias = Content_479.cv_arg
    cv_content: TypeAlias = Content_479

    @property
    def content(self) -> Content_479:
        return self._get_content() # type: ignore

class Variation_82(Element):
    cv_arg: TypeAlias = RuleContent_479.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_479

    @classmethod
    def create(cls, arg: "Variation_82.cv_arg") -> "Variation_82":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_479:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_479:
        return self.rule.content

class RuleVariation_82(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_82.cv_arg
    cv_variation: TypeAlias = Variation_82

    @classmethod
    def create(cls, arg : "RuleVariation_82.cv_arg") -> "RuleVariation_82":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_82:
        return self.arg # type: ignore

class Content_480(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Target is not UAT IN capable", 1: "Target is UAT IN capable"}

class RuleContent_480(RuleContentContextFree):
    cv_arg: TypeAlias = Content_480.cv_arg
    cv_content: TypeAlias = Content_480

    @property
    def content(self) -> Content_480:
        return self._get_content() # type: ignore

class Variation_453(Element):
    cv_arg: TypeAlias = RuleContent_480.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_480

    @classmethod
    def create(cls, arg: "Variation_453.cv_arg") -> "Variation_453":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_480:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_480:
        return self.rule.content

class RuleVariation_442(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_453.cv_arg
    cv_variation: TypeAlias = Variation_453

    @classmethod
    def create(cls, arg : "RuleVariation_442.cv_arg") -> "RuleVariation_442":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_453:
        return self.arg # type: ignore

class NonSpare_961(NonSpare):
    cv_arg: TypeAlias = RuleVariation_82.cv_arg
    cv_name = "ES"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_82

    @classmethod
    def create(cls, arg : "NonSpare_961.cv_arg") -> "NonSpare_961":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_82:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_82:
        return self.rule.variation

class Item_320(Item):
    cv_arg: TypeAlias = NonSpare_961.cv_arg
    cv_non_spare: TypeAlias = NonSpare_961

    @classmethod
    def create(cls, arg : "Item_320.cv_arg") -> "Item_320":
        return cls._create(arg) # type: ignore

class NonSpare_1976(NonSpare):
    cv_arg: TypeAlias = RuleVariation_442.cv_arg
    cv_name = "UAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_442

    @classmethod
    def create(cls, arg : "NonSpare_1976.cv_arg") -> "NonSpare_1976":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_442:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_453:
        return self.rule.variation

class Item_1089(Item):
    cv_arg: TypeAlias = NonSpare_1976.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1976

    @classmethod
    def create(cls, arg : "Item_1089.cv_arg") -> "Item_1089":
        return cls._create(arg) # type: ignore

class Variation_1357(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_82.cv_arg, Tuple[Literal["ES"], RuleVariation_82.cv_arg]], Union[RuleVariation_442.cv_arg, Tuple[Literal["UAT"], RuleVariation_442.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1357.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_320, 1), (Item_1089, 1), (Item_14, 5), None]]

    @classmethod
    def create(cls, arg: "Variation_1357.cv_arg") -> 'Variation_1357':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ES"]) -> RuleVariation_82:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_442:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1278(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1357.cv_arg
    cv_variation: TypeAlias = Variation_1357

    @classmethod
    def create(cls, arg : "RuleVariation_1278.cv_arg") -> "RuleVariation_1278":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1357:
        return self.arg # type: ignore

class NonSpare_1769(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1278.cv_arg
    cv_name = "STA"
    cv_title = "Aircraft Status"
    cv_rule: TypeAlias = RuleVariation_1278

    @classmethod
    def create(cls, arg : "NonSpare_1769.cv_arg") -> "NonSpare_1769":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1278:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1357:
        return self.rule.variation

class NonSpare_1877(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TNH"
    cv_title = "True North Heading"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1877.cv_arg") -> "NonSpare_1877":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Content_313(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Mode 5 interrogation", 1: "Mode 5 interrogation"}

class RuleContent_313(RuleContentContextFree):
    cv_arg: TypeAlias = Content_313.cv_arg
    cv_content: TypeAlias = Content_313

    @property
    def content(self) -> Content_313:
        return self._get_content() # type: ignore

class Variation_57(Element):
    cv_arg: TypeAlias = RuleContent_313.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_313

    @classmethod
    def create(cls, arg: "Variation_57.cv_arg") -> "Variation_57":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_313:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_313:
        return self.rule.content

class RuleVariation_57(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_57.cv_arg
    cv_variation: TypeAlias = Variation_57

    @classmethod
    def create(cls, arg : "RuleVariation_57.cv_arg") -> "RuleVariation_57":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_57:
        return self.arg # type: ignore

class NonSpare_1219(NonSpare):
    cv_arg: TypeAlias = RuleVariation_57.cv_arg
    cv_name = "M5"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_57

    @classmethod
    def create(cls, arg : "NonSpare_1219.cv_arg") -> "NonSpare_1219":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_57:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_57:
        return self.rule.variation

class Item_522(Item):
    cv_arg: TypeAlias = NonSpare_1219.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1219

    @classmethod
    def create(cls, arg : "Item_522.cv_arg") -> "Item_522":
        return cls._create(arg) # type: ignore

class Content_329(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No authenticated Mode 5 ID reply/report", 1: "Authenticated Mode 5 ID reply/report"}

class RuleContent_329(RuleContentContextFree):
    cv_arg: TypeAlias = Content_329.cv_arg
    cv_content: TypeAlias = Content_329

    @property
    def content(self) -> Content_329:
        return self._get_content() # type: ignore

class Variation_442(Element):
    cv_arg: TypeAlias = RuleContent_329.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_329

    @classmethod
    def create(cls, arg: "Variation_442.cv_arg") -> "Variation_442":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_329:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_329:
        return self.rule.content

class RuleVariation_431(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_442.cv_arg
    cv_variation: TypeAlias = Variation_442

    @classmethod
    def create(cls, arg : "RuleVariation_431.cv_arg") -> "RuleVariation_431":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_442:
        return self.arg # type: ignore

class NonSpare_1110(NonSpare):
    cv_arg: TypeAlias = RuleVariation_431.cv_arg
    cv_name = "ID"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_431

    @classmethod
    def create(cls, arg : "NonSpare_1110.cv_arg") -> "NonSpare_1110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_431:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_442:
        return self.rule.variation

class Item_428(Item):
    cv_arg: TypeAlias = NonSpare_1110.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1110

    @classmethod
    def create(cls, arg : "Item_428.cv_arg") -> "Item_428":
        return cls._create(arg) # type: ignore

class Content_326(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No authenticated Mode 5 Data reply or Report", 1: "Authenticated Mode 5 Data reply or Report (i.e any valid Mode 5 reply type other than ID)"}

class RuleContent_326(RuleContentContextFree):
    cv_arg: TypeAlias = Content_326.cv_arg
    cv_content: TypeAlias = Content_326

    @property
    def content(self) -> Content_326:
        return self._get_content() # type: ignore

class Variation_560(Element):
    cv_arg: TypeAlias = RuleContent_326.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_326

    @classmethod
    def create(cls, arg: "Variation_560.cv_arg") -> "Variation_560":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_326:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_326:
        return self.rule.content

class RuleVariation_549(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_560.cv_arg
    cv_variation: TypeAlias = Variation_560

    @classmethod
    def create(cls, arg : "RuleVariation_549.cv_arg") -> "RuleVariation_549":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_560:
        return self.arg # type: ignore

class NonSpare_857(NonSpare):
    cv_arg: TypeAlias = RuleVariation_549.cv_arg
    cv_name = "DA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_549

    @classmethod
    def create(cls, arg : "NonSpare_857.cv_arg") -> "NonSpare_857":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_549:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_560:
        return self.rule.variation

class Item_237(Item):
    cv_arg: TypeAlias = NonSpare_857.cv_arg
    cv_non_spare: TypeAlias = NonSpare_857

    @classmethod
    def create(cls, arg : "Item_237.cv_arg") -> "Item_237":
        return cls._create(arg) # type: ignore

class Content_274(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 1 code not present or not from Mode 5 reply/report", 1: "Mode 1 code from Mode 5 reply/report"}

class RuleContent_274(RuleContentContextFree):
    cv_arg: TypeAlias = Content_274.cv_arg
    cv_content: TypeAlias = Content_274

    @property
    def content(self) -> Content_274:
        return self._get_content() # type: ignore

class Variation_647(Element):
    cv_arg: TypeAlias = RuleContent_274.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_274

    @classmethod
    def create(cls, arg: "Variation_647.cv_arg") -> "Variation_647":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_274:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_274:
        return self.rule.content

class RuleVariation_636(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_647.cv_arg
    cv_variation: TypeAlias = Variation_647

    @classmethod
    def create(cls, arg : "RuleVariation_636.cv_arg") -> "RuleVariation_636":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_647:
        return self.arg # type: ignore

class NonSpare_1207(NonSpare):
    cv_arg: TypeAlias = RuleVariation_636.cv_arg
    cv_name = "M1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_636

    @classmethod
    def create(cls, arg : "NonSpare_1207.cv_arg") -> "NonSpare_1207":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_636:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_647:
        return self.rule.variation

class Item_515(Item):
    cv_arg: TypeAlias = NonSpare_1207.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1207

    @classmethod
    def create(cls, arg : "Item_515.cv_arg") -> "Item_515":
        return cls._create(arg) # type: ignore

class Content_276(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 2 code not present or not from Mode 5 reply/report", 1: "Mode 2 code from Mode 5 reply/report"}

class RuleContent_276(RuleContentContextFree):
    cv_arg: TypeAlias = Content_276.cv_arg
    cv_content: TypeAlias = Content_276

    @property
    def content(self) -> Content_276:
        return self._get_content() # type: ignore

class Variation_734(Element):
    cv_arg: TypeAlias = RuleContent_276.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_276

    @classmethod
    def create(cls, arg: "Variation_734.cv_arg") -> "Variation_734":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_276:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_276:
        return self.rule.content

class RuleVariation_723(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_734.cv_arg
    cv_variation: TypeAlias = Variation_734

    @classmethod
    def create(cls, arg : "RuleVariation_723.cv_arg") -> "RuleVariation_723":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_734:
        return self.arg # type: ignore

class NonSpare_1209(NonSpare):
    cv_arg: TypeAlias = RuleVariation_723.cv_arg
    cv_name = "M2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_723

    @classmethod
    def create(cls, arg : "NonSpare_1209.cv_arg") -> "NonSpare_1209":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_723:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_734:
        return self.rule.variation

class Item_517(Item):
    cv_arg: TypeAlias = NonSpare_1209.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1209

    @classmethod
    def create(cls, arg : "Item_517.cv_arg") -> "Item_517":
        return cls._create(arg) # type: ignore

class Content_278(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 3 code not present or not from Mode 5 reply/report", 1: "Mode 3 code from Mode 5 reply/report"}

class RuleContent_278(RuleContentContextFree):
    cv_arg: TypeAlias = Content_278.cv_arg
    cv_content: TypeAlias = Content_278

    @property
    def content(self) -> Content_278:
        return self._get_content() # type: ignore

class Variation_861(Element):
    cv_arg: TypeAlias = RuleContent_278.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_278

    @classmethod
    def create(cls, arg: "Variation_861.cv_arg") -> "Variation_861":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_278:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_278:
        return self.rule.content

class RuleVariation_831(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_861.cv_arg
    cv_variation: TypeAlias = Variation_861

    @classmethod
    def create(cls, arg : "RuleVariation_831.cv_arg") -> "RuleVariation_831":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_861:
        return self.arg # type: ignore

class NonSpare_1213(NonSpare):
    cv_arg: TypeAlias = RuleVariation_831.cv_arg
    cv_name = "M3"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_831

    @classmethod
    def create(cls, arg : "NonSpare_1213.cv_arg") -> "NonSpare_1213":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_831:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_861:
        return self.rule.variation

class Item_520(Item):
    cv_arg: TypeAlias = NonSpare_1213.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1213

    @classmethod
    def create(cls, arg : "Item_520.cv_arg") -> "Item_520":
        return cls._create(arg) # type: ignore

class Content_214(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Flightlevel not present or not from Mode 5 reply/report", 1: "Flightlevel from Mode 5 reply/report"}

class RuleContent_214(RuleContentContextFree):
    cv_arg: TypeAlias = Content_214.cv_arg
    cv_content: TypeAlias = Content_214

    @property
    def content(self) -> Content_214:
        return self._get_content() # type: ignore

class Variation_928(Element):
    cv_arg: TypeAlias = RuleContent_214.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_214

    @classmethod
    def create(cls, arg: "Variation_928.cv_arg") -> "Variation_928":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_214:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_214:
        return self.rule.content

class RuleVariation_898(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_928.cv_arg
    cv_variation: TypeAlias = Variation_928

    @classmethod
    def create(cls, arg : "RuleVariation_898.cv_arg") -> "RuleVariation_898":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_928:
        return self.arg # type: ignore

class NonSpare_1238(NonSpare):
    cv_arg: TypeAlias = RuleVariation_898.cv_arg
    cv_name = "MC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_898

    @classmethod
    def create(cls, arg : "NonSpare_1238.cv_arg") -> "NonSpare_1238":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_898:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_928:
        return self.rule.variation

class Item_534(Item):
    cv_arg: TypeAlias = NonSpare_1238.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1238

    @classmethod
    def create(cls, arg : "Item_534.cv_arg") -> "Item_534":
        return cls._create(arg) # type: ignore

class Content_429(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Position not from Mode 5 report (ADS-B report)", 1: "Position from Mode 5 report"}

class RuleContent_429(RuleContentContextFree):
    cv_arg: TypeAlias = Content_429.cv_arg
    cv_content: TypeAlias = Content_429

    @property
    def content(self) -> Content_429:
        return self._get_content() # type: ignore

class Variation_987(Element):
    cv_arg: TypeAlias = RuleContent_429.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_429

    @classmethod
    def create(cls, arg: "Variation_987.cv_arg") -> "Variation_987":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_429:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_429:
        return self.rule.content

class RuleVariation_957(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_987.cv_arg
    cv_variation: TypeAlias = Variation_987

    @classmethod
    def create(cls, arg : "RuleVariation_957.cv_arg") -> "RuleVariation_957":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_987:
        return self.arg # type: ignore

class NonSpare_1439(NonSpare):
    cv_arg: TypeAlias = RuleVariation_957.cv_arg
    cv_name = "PO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_957

    @classmethod
    def create(cls, arg : "NonSpare_1439.cv_arg") -> "NonSpare_1439":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_957:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_987:
        return self.rule.variation

class Item_688(Item):
    cv_arg: TypeAlias = NonSpare_1439.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1439

    @classmethod
    def create(cls, arg : "Item_688.cv_arg") -> "Item_688":
        return cls._create(arg) # type: ignore

class Variation_1140(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_57.cv_arg, Tuple[Literal["M5"], RuleVariation_57.cv_arg]], Union[RuleVariation_431.cv_arg, Tuple[Literal["ID"], RuleVariation_431.cv_arg]], Union[RuleVariation_549.cv_arg, Tuple[Literal["DA"], RuleVariation_549.cv_arg]], Union[RuleVariation_636.cv_arg, Tuple[Literal["M1"], RuleVariation_636.cv_arg]], Union[RuleVariation_723.cv_arg, Tuple[Literal["M2"], RuleVariation_723.cv_arg]], Union[RuleVariation_831.cv_arg, Tuple[Literal["M3"], RuleVariation_831.cv_arg]], Union[RuleVariation_898.cv_arg, Tuple[Literal["MC"], RuleVariation_898.cv_arg]], Union[RuleVariation_957.cv_arg, Tuple[Literal["PO"], RuleVariation_957.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1140.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_522, 1), (Item_428, 1), (Item_237, 1), (Item_515, 1), (Item_517, 1), (Item_520, 1), (Item_534, 1), (Item_688, 1)]
    cv_items_dict = {"M5": RuleVariation_57, "ID": RuleVariation_431, "DA": RuleVariation_549, "M1": RuleVariation_636, "M2": RuleVariation_723, "M3": RuleVariation_831, "MC": RuleVariation_898, "PO": RuleVariation_957}

    @overload
    @classmethod
    def spec(cls, key : Literal["M5"]) -> RuleVariation_57:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> RuleVariation_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> RuleVariation_549:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_636:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3"]) -> RuleVariation_831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MC"]) -> RuleVariation_898:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PO"]) -> RuleVariation_957:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["M5"], Literal["ID"], Literal["DA"], Literal["M1"], Literal["M2"], Literal["M3"], Literal["MC"], Literal["PO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["M5"]) -> RuleVariation_57:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> RuleVariation_431:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> RuleVariation_549:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_636:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_723:
        ...
    @overload
    def get_item(self, key : Literal["M3"]) -> RuleVariation_831:
        ...
    @overload
    def get_item(self, key : Literal["MC"]) -> RuleVariation_898:
        ...
    @overload
    def get_item(self, key : Literal["PO"]) -> RuleVariation_957:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1140.cv_arg") -> 'Variation_1140':
        return cls._create(arg) # type: ignore

class RuleVariation_1096(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1140.cv_arg
    cv_variation: TypeAlias = Variation_1140

    @classmethod
    def create(cls, arg : "RuleVariation_1096.cv_arg") -> "RuleVariation_1096":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1140:
        return self.arg # type: ignore

class NonSpare_1809(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1096.cv_arg
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule: TypeAlias = RuleVariation_1096

    @classmethod
    def create(cls, arg : "NonSpare_1809.cv_arg") -> "NonSpare_1809":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1096:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1140:
        return self.rule.variation

class Variation_604(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_604.cv_arg") -> "Variation_604":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_593(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_604.cv_arg
    cv_variation: TypeAlias = Variation_604

    @classmethod
    def create(cls, arg : "RuleVariation_593.cv_arg") -> "RuleVariation_593":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_604:
        return self.arg # type: ignore

class NonSpare_1431(NonSpare):
    cv_arg: TypeAlias = RuleVariation_593.cv_arg
    cv_name = "PIN"
    cv_title = "PIN Code"
    cv_rule: TypeAlias = RuleVariation_593

    @classmethod
    def create(cls, arg : "NonSpare_1431.cv_arg") -> "NonSpare_1431":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_593:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_604:
        return self.rule.variation

class Item_685(Item):
    cv_arg: TypeAlias = NonSpare_1431.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1431

    @classmethod
    def create(cls, arg : "Item_685.cv_arg") -> "Item_685":
        return cls._create(arg) # type: ignore

class Variation_894(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 11
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_894.cv_arg") -> "Variation_894":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_864(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_894.cv_arg
    cv_variation: TypeAlias = Variation_894

    @classmethod
    def create(cls, arg : "RuleVariation_864.cv_arg") -> "RuleVariation_864":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_894:
        return self.arg # type: ignore

class NonSpare_1361(NonSpare):
    cv_arg: TypeAlias = RuleVariation_864.cv_arg
    cv_name = "NO"
    cv_title = "National Origin Code"
    cv_rule: TypeAlias = RuleVariation_864

    @classmethod
    def create(cls, arg : "NonSpare_1361.cv_arg") -> "NonSpare_1361":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_864:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_894:
        return self.rule.variation

class Item_621(Item):
    cv_arg: TypeAlias = NonSpare_1361.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1361

    @classmethod
    def create(cls, arg : "Item_621.cv_arg") -> "Item_621":
        return cls._create(arg) # type: ignore

class Variation_1008(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_593.cv_arg, Tuple[Literal["PIN"], RuleVariation_593.cv_arg]], int, Union[RuleVariation_864.cv_arg, Tuple[Literal["NO"], RuleVariation_864.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1008.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_685, 14), (Item_4, 5), (Item_621, 11)]
    cv_items_dict = {"PIN": RuleVariation_593, "NO": RuleVariation_864}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NO"]) -> RuleVariation_864:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    def get_item(self, key : Literal["NO"]) -> RuleVariation_864:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1008.cv_arg") -> 'Variation_1008':
        return cls._create(arg) # type: ignore

class RuleVariation_978(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1008.cv_arg
    cv_variation: TypeAlias = Variation_1008

    @classmethod
    def create(cls, arg : "RuleVariation_978.cv_arg") -> "RuleVariation_978":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1008:
        return self.arg # type: ignore

class NonSpare_1438(NonSpare):
    cv_arg: TypeAlias = RuleVariation_978.cv_arg
    cv_name = "PNO"
    cv_title = "Mode 5 PIN / National Origin"
    cv_rule: TypeAlias = RuleVariation_978

    @classmethod
    def create(cls, arg : "NonSpare_1438.cv_arg") -> "NonSpare_1438":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_978:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1008:
        return self.rule.variation

class Content_272(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 1 code as derived from the report of the transponder", 1: "Smoothed Mode 1 code as provided by a local tracker"}

class RuleContent_272(RuleContentContextFree):
    cv_arg: TypeAlias = Content_272.cv_arg
    cv_content: TypeAlias = Content_272

    @property
    def content(self) -> Content_272:
        return self._get_content() # type: ignore

class Variation_544(Element):
    cv_arg: TypeAlias = RuleContent_272.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_272

    @classmethod
    def create(cls, arg: "Variation_544.cv_arg") -> "Variation_544":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_272:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_272:
        return self.rule.content

class RuleVariation_533(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_544.cv_arg
    cv_variation: TypeAlias = Variation_544

    @classmethod
    def create(cls, arg : "RuleVariation_533.cv_arg") -> "RuleVariation_533":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_544:
        return self.arg # type: ignore

class NonSpare_1132(NonSpare):
    cv_arg: TypeAlias = RuleVariation_533.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_533

    @classmethod
    def create(cls, arg : "NonSpare_1132.cv_arg") -> "NonSpare_1132":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_533:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_544:
        return self.rule.variation

class Item_444(Item):
    cv_arg: TypeAlias = NonSpare_1132.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1132

    @classmethod
    def create(cls, arg : "Item_444.cv_arg") -> "Item_444":
        return cls._create(arg) # type: ignore

class NonSpare_924(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_924.cv_arg") -> "NonSpare_924":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_290(Item):
    cv_arg: TypeAlias = NonSpare_924.cv_arg
    cv_non_spare: TypeAlias = NonSpare_924

    @classmethod
    def create(cls, arg : "Item_290.cv_arg") -> "Item_290":
        return cls._create(arg) # type: ignore

class Variation_1251(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], int, Union[RuleVariation_533.cv_arg, Tuple[Literal["L"], RuleVariation_533.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["EM1"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1251.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_7, 1), (Item_444, 1), (Item_16, 1), (Item_290, 12)]
    cv_items_dict = {"V": RuleVariation_15, "L": RuleVariation_533, "EM1": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_533:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["L"], Literal["EM1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_533:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1251.cv_arg") -> 'Variation_1251':
        return cls._create(arg) # type: ignore

class RuleVariation_1180(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1251.cv_arg
    cv_variation: TypeAlias = Variation_1251

    @classmethod
    def create(cls, arg : "RuleVariation_1180.cv_arg") -> "RuleVariation_1180":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1251:
        return self.arg # type: ignore

class NonSpare_927(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1180.cv_arg
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1180

    @classmethod
    def create(cls, arg : "NonSpare_927.cv_arg") -> "NonSpare_927":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1180:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1251:
        return self.rule.variation

class Content_564(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-Pulse not present", 1: "X-pulse present"}

class RuleContent_564(RuleContentContextFree):
    cv_arg: TypeAlias = Content_564.cv_arg
    cv_content: TypeAlias = Content_564

    @property
    def content(self) -> Content_564:
        return self._get_content() # type: ignore

class Variation_584(Element):
    cv_arg: TypeAlias = RuleContent_564.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_564

    @classmethod
    def create(cls, arg: "Variation_584.cv_arg") -> "Variation_584":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_564:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_564:
        return self.rule.content

class RuleVariation_573(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_584.cv_arg
    cv_variation: TypeAlias = Variation_584

    @classmethod
    def create(cls, arg : "RuleVariation_573.cv_arg") -> "RuleVariation_573":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_584:
        return self.arg # type: ignore

class NonSpare_2120(NonSpare):
    cv_arg: TypeAlias = RuleVariation_573.cv_arg
    cv_name = "XP"
    cv_title = "X-pulse from Mode 5 PIN Reply/report"
    cv_rule: TypeAlias = RuleVariation_573

    @classmethod
    def create(cls, arg : "NonSpare_2120.cv_arg") -> "NonSpare_2120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_573:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_584:
        return self.rule.variation

class Item_1218(Item):
    cv_arg: TypeAlias = NonSpare_2120.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2120

    @classmethod
    def create(cls, arg : "Item_1218.cv_arg") -> "Item_1218":
        return cls._create(arg) # type: ignore

class Content_570(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-pulse set to zero or no authenticated Data reply or Report received", 1: "X-pulse set to one (present)"}

class RuleContent_570(RuleContentContextFree):
    cv_arg: TypeAlias = Content_570.cv_arg
    cv_content: TypeAlias = Content_570

    @property
    def content(self) -> Content_570:
        return self._get_content() # type: ignore

class Variation_674(Element):
    cv_arg: TypeAlias = RuleContent_570.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_570

    @classmethod
    def create(cls, arg: "Variation_674.cv_arg") -> "Variation_674":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_570:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_570:
        return self.rule.content

class RuleVariation_663(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_674.cv_arg
    cv_variation: TypeAlias = Variation_674

    @classmethod
    def create(cls, arg : "RuleVariation_663.cv_arg") -> "RuleVariation_663":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_674:
        return self.arg # type: ignore

class NonSpare_2112(NonSpare):
    cv_arg: TypeAlias = RuleVariation_663.cv_arg
    cv_name = "X5"
    cv_title = "X-pulse from Mode 5 Data Reply or Report"
    cv_rule: TypeAlias = RuleVariation_663

    @classmethod
    def create(cls, arg : "NonSpare_2112.cv_arg") -> "NonSpare_2112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_663:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_674:
        return self.rule.variation

class Item_1213(Item):
    cv_arg: TypeAlias = NonSpare_2112.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2112

    @classmethod
    def create(cls, arg : "Item_1213.cv_arg") -> "Item_1213":
        return cls._create(arg) # type: ignore

class Content_568(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-pulse set to zero or no Mode C reply", 1: "X-pulse set to one (present)"}

class RuleContent_568(RuleContentContextFree):
    cv_arg: TypeAlias = Content_568.cv_arg
    cv_content: TypeAlias = Content_568

    @property
    def content(self) -> Content_568:
        return self._get_content() # type: ignore

class Variation_762(Element):
    cv_arg: TypeAlias = RuleContent_568.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_568

    @classmethod
    def create(cls, arg: "Variation_762.cv_arg") -> "Variation_762":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_568:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_568:
        return self.rule.content

class RuleVariation_751(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_762.cv_arg
    cv_variation: TypeAlias = Variation_762

    @classmethod
    def create(cls, arg : "RuleVariation_751.cv_arg") -> "RuleVariation_751":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_762:
        return self.arg # type: ignore

class NonSpare_2115(NonSpare):
    cv_arg: TypeAlias = RuleVariation_751.cv_arg
    cv_name = "XC"
    cv_title = "X-pulse from Mode C Reply"
    cv_rule: TypeAlias = RuleVariation_751

    @classmethod
    def create(cls, arg : "NonSpare_2115.cv_arg") -> "NonSpare_2115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_751:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_762:
        return self.rule.variation

class Item_1216(Item):
    cv_arg: TypeAlias = NonSpare_2115.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2115

    @classmethod
    def create(cls, arg : "Item_1216.cv_arg") -> "Item_1216":
        return cls._create(arg) # type: ignore

class Content_567(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-pulse set to zero or no Mode 3/A reply", 1: "X-pulse set to one (present)"}

class RuleContent_567(RuleContentContextFree):
    cv_arg: TypeAlias = Content_567.cv_arg
    cv_content: TypeAlias = Content_567

    @property
    def content(self) -> Content_567:
        return self._get_content() # type: ignore

class Variation_876(Element):
    cv_arg: TypeAlias = RuleContent_567.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_567

    @classmethod
    def create(cls, arg: "Variation_876.cv_arg") -> "Variation_876":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_567:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_567:
        return self.rule.content

class RuleVariation_846(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_876.cv_arg
    cv_variation: TypeAlias = Variation_876

    @classmethod
    def create(cls, arg : "RuleVariation_846.cv_arg") -> "RuleVariation_846":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_876:
        return self.arg # type: ignore

class NonSpare_2111(NonSpare):
    cv_arg: TypeAlias = RuleVariation_846.cv_arg
    cv_name = "X3"
    cv_title = "X-pulse from Mode 3/A Reply"
    cv_rule: TypeAlias = RuleVariation_846

    @classmethod
    def create(cls, arg : "NonSpare_2111.cv_arg") -> "NonSpare_2111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_846:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_876:
        return self.rule.variation

class Item_1212(Item):
    cv_arg: TypeAlias = NonSpare_2111.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2111

    @classmethod
    def create(cls, arg : "Item_1212.cv_arg") -> "Item_1212":
        return cls._create(arg) # type: ignore

class Content_1(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "0 X-pulse set to zero or no Mode 2 reply", 1: "X-pulse set to one (present)"}

class RuleContent_1(RuleContentContextFree):
    cv_arg: TypeAlias = Content_1.cv_arg
    cv_content: TypeAlias = Content_1

    @property
    def content(self) -> Content_1:
        return self._get_content() # type: ignore

class Variation_900(Element):
    cv_arg: TypeAlias = RuleContent_1.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_1

    @classmethod
    def create(cls, arg: "Variation_900.cv_arg") -> "Variation_900":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_1:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_1:
        return self.rule.content

class RuleVariation_870(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_900.cv_arg
    cv_variation: TypeAlias = Variation_900

    @classmethod
    def create(cls, arg : "RuleVariation_870.cv_arg") -> "RuleVariation_870":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_900:
        return self.arg # type: ignore

class NonSpare_2108(NonSpare):
    cv_arg: TypeAlias = RuleVariation_870.cv_arg
    cv_name = "X2"
    cv_title = "X-pulse from Mode 2 Reply"
    cv_rule: TypeAlias = RuleVariation_870

    @classmethod
    def create(cls, arg : "NonSpare_2108.cv_arg") -> "NonSpare_2108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_870:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_900:
        return self.rule.variation

class Item_1209(Item):
    cv_arg: TypeAlias = NonSpare_2108.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2108

    @classmethod
    def create(cls, arg : "Item_1209.cv_arg") -> "Item_1209":
        return cls._create(arg) # type: ignore

class Content_565(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-pulse set to zero or no Mode 1 reply", 1: "X-pulse set to one (present)"}

class RuleContent_565(RuleContentContextFree):
    cv_arg: TypeAlias = Content_565.cv_arg
    cv_content: TypeAlias = Content_565

    @property
    def content(self) -> Content_565:
        return self._get_content() # type: ignore

class Variation_990(Element):
    cv_arg: TypeAlias = RuleContent_565.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_565

    @classmethod
    def create(cls, arg: "Variation_990.cv_arg") -> "Variation_990":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_565:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_565:
        return self.rule.content

class RuleVariation_960(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_990.cv_arg
    cv_variation: TypeAlias = Variation_990

    @classmethod
    def create(cls, arg : "RuleVariation_960.cv_arg") -> "RuleVariation_960":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_990:
        return self.arg # type: ignore

class NonSpare_2105(NonSpare):
    cv_arg: TypeAlias = RuleVariation_960.cv_arg
    cv_name = "X1"
    cv_title = "X-pulse from Mode 1 Reply"
    cv_rule: TypeAlias = RuleVariation_960

    @classmethod
    def create(cls, arg : "NonSpare_2105.cv_arg") -> "NonSpare_2105":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_960:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_990:
        return self.rule.variation

class Item_1206(Item):
    cv_arg: TypeAlias = NonSpare_2105.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2105

    @classmethod
    def create(cls, arg : "Item_1206.cv_arg") -> "Item_1206":
        return cls._create(arg) # type: ignore

class Variation_1011(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_573.cv_arg, Tuple[Literal["XP"], RuleVariation_573.cv_arg]], Union[RuleVariation_663.cv_arg, Tuple[Literal["X5"], RuleVariation_663.cv_arg]], Union[RuleVariation_751.cv_arg, Tuple[Literal["XC"], RuleVariation_751.cv_arg]], Union[RuleVariation_846.cv_arg, Tuple[Literal["X3"], RuleVariation_846.cv_arg]], Union[RuleVariation_870.cv_arg, Tuple[Literal["X2"], RuleVariation_870.cv_arg]], Union[RuleVariation_960.cv_arg, Tuple[Literal["X1"], RuleVariation_960.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1011.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1, 2), (Item_1218, 1), (Item_1213, 1), (Item_1216, 1), (Item_1212, 1), (Item_1209, 1), (Item_1206, 1)]
    cv_items_dict = {"XP": RuleVariation_573, "X5": RuleVariation_663, "XC": RuleVariation_751, "X3": RuleVariation_846, "X2": RuleVariation_870, "X1": RuleVariation_960}

    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> RuleVariation_573:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X5"]) -> RuleVariation_663:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_751:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X3"]) -> RuleVariation_846:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_870:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_960:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["XP"], Literal["X5"], Literal["XC"], Literal["X3"], Literal["X2"], Literal["X1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["XP"]) -> RuleVariation_573:
        ...
    @overload
    def get_item(self, key : Literal["X5"]) -> RuleVariation_663:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_751:
        ...
    @overload
    def get_item(self, key : Literal["X3"]) -> RuleVariation_846:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_870:
        ...
    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_960:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1011.cv_arg") -> 'Variation_1011':
        return cls._create(arg) # type: ignore

class RuleVariation_981(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1011.cv_arg
    cv_variation: TypeAlias = Variation_1011

    @classmethod
    def create(cls, arg : "RuleVariation_981.cv_arg") -> "RuleVariation_981":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1011:
        return self.arg # type: ignore

class NonSpare_2117(NonSpare):
    cv_arg: TypeAlias = RuleVariation_981.cv_arg
    cv_name = "XP"
    cv_title = "X Pulse Presence"
    cv_rule: TypeAlias = RuleVariation_981

    @classmethod
    def create(cls, arg : "NonSpare_2117.cv_arg") -> "NonSpare_2117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_981:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1011:
        return self.rule.variation

class NonSpare_983(NonSpare):
    cv_arg: TypeAlias = RuleVariation_684.cv_arg
    cv_name = "FOM"
    cv_title = "Figure of Merit"
    cv_rule: TypeAlias = RuleVariation_684

    @classmethod
    def create(cls, arg : "NonSpare_983.cv_arg") -> "NonSpare_983":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

class Item_337(Item):
    cv_arg: TypeAlias = NonSpare_983.cv_arg
    cv_non_spare: TypeAlias = NonSpare_983

    @classmethod
    def create(cls, arg : "Item_337.cv_arg") -> "Item_337":
        return cls._create(arg) # type: ignore

class Variation_1014(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_684.cv_arg, Tuple[Literal["FOM"], RuleVariation_684.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1014.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_337, 5)]
    cv_items_dict = {"FOM": RuleVariation_684}

    @classmethod
    def spec(cls, key : Literal["FOM"]) -> RuleVariation_684:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FOM"]) -> RuleVariation_684:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1014.cv_arg") -> 'Variation_1014':
        return cls._create(arg) # type: ignore

class RuleVariation_984(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1014.cv_arg
    cv_variation: TypeAlias = Variation_1014

    @classmethod
    def create(cls, arg : "RuleVariation_984.cv_arg") -> "RuleVariation_984":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1014:
        return self.arg # type: ignore

class NonSpare_985(NonSpare):
    cv_arg: TypeAlias = RuleVariation_984.cv_arg
    cv_name = "FOM"
    cv_title = "Figure of Merit"
    cv_rule: TypeAlias = RuleVariation_984

    @classmethod
    def create(cls, arg : "NonSpare_985.cv_arg") -> "NonSpare_985":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_984:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1014:
        return self.rule.variation

class NonSpare_1302(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE2"
    cv_title = "Mode 2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1302.cv_arg") -> "NonSpare_1302":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_568(Item):
    cv_arg: TypeAlias = NonSpare_1302.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1302

    @classmethod
    def create(cls, arg : "Item_568.cv_arg") -> "Item_568":
        return cls._create(arg) # type: ignore

class Variation_1252(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], int, Union[RuleVariation_538.cv_arg, Tuple[Literal["L"], RuleVariation_538.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE2"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1252.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_7, 1), (Item_449, 1), (Item_16, 1), (Item_568, 12)]
    cv_items_dict = {"V": RuleVariation_15, "L": RuleVariation_538, "MODE2": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_538:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["L"], Literal["MODE2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_538:
        ...
    @overload
    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1252.cv_arg") -> 'Variation_1252':
        return cls._create(arg) # type: ignore

class RuleVariation_1181(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1252.cv_arg
    cv_variation: TypeAlias = Variation_1252

    @classmethod
    def create(cls, arg : "RuleVariation_1181.cv_arg") -> "RuleVariation_1181":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1252:
        return self.arg # type: ignore

class NonSpare_1211(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1181.cv_arg
    cv_name = "M2"
    cv_title = "Mode 2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1181

    @classmethod
    def create(cls, arg : "NonSpare_1211.cv_arg") -> "NonSpare_1211":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1181:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1252:
        return self.rule.variation

class Variation_1510(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SUM": NonSpare_1809.cv_arg,
        "PNO": NonSpare_1438.cv_arg,
        "EM1": NonSpare_927.cv_arg,
        "XP": NonSpare_2117.cv_arg,
        "FOM": NonSpare_985.cv_arg,
        "M2": NonSpare_1211.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1809, NonSpare_1438, NonSpare_927, NonSpare_2117, NonSpare_985, NonSpare_1211]
    cv_items_dict = {"SUM": NonSpare_1809, "PNO": NonSpare_1438, "EM1": NonSpare_927, "XP": NonSpare_2117, "FOM": NonSpare_985, "M2": NonSpare_1211}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1809:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PNO"]) -> NonSpare_1438:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_927:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FOM"]) -> NonSpare_985:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> NonSpare_1211:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PNO"], Literal["EM1"], Literal["XP"], Literal["FOM"], Literal["M2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1809]:
        ...
    @overload
    def get_item(self, key : Literal["PNO"]) -> Optional[NonSpare_1438]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_927]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2117]:
        ...
    @overload
    def get_item(self, key : Literal["FOM"]) -> Optional[NonSpare_985]:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> Optional[NonSpare_1211]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1809.cv_arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["PNO"], val : NonSpare_1438.cv_arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_927.cv_arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2117.cv_arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["FOM"], val : NonSpare_985.cv_arg) -> "Variation_1510":
        ...
    @overload
    def set_item(self, key : Literal["M2"], val : NonSpare_1211.cv_arg) -> "Variation_1510":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["PNO"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["FOM"]) -> "Variation_1510":
        ...
    @overload
    def del_item(self, key : Literal["M2"]) -> "Variation_1510":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1510.cv_arg") -> 'Variation_1510':
        return cls._create(arg) # type: ignore

class RuleVariation_1431(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1510.cv_arg
    cv_variation: TypeAlias = Variation_1510

    @classmethod
    def create(cls, arg : "RuleVariation_1431.cv_arg") -> "RuleVariation_1431":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1510:
        return self.arg # type: ignore

class NonSpare_1270(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1431.cv_arg
    cv_name = "MES"
    cv_title = "Military Extended Squitter"
    cv_rule: TypeAlias = RuleVariation_1431

    @classmethod
    def create(cls, arg : "NonSpare_1270.cv_arg") -> "NonSpare_1270":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1431:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1510:
        return self.rule.variation

class Expansion_0(Expansion):
    cv_arg = TypedDict('cv_arg', {
        "BPS": NonSpare_693.cv_arg,
        "SH": NonSpare_1706.cv_arg,
        "NAV": NonSpare_1346.cv_arg,
        "GAO": NonSpare_1022.cv_arg,
        "SGV": NonSpare_1704.cv_arg,
        "STA": NonSpare_1769.cv_arg,
        "TNH": NonSpare_1877.cv_arg,
        "MES": NonSpare_1270.cv_arg,
    }, total=False)
    cv_type = (FspecFixed, 1)
    cv_items_list = [NonSpare_693, NonSpare_1706, NonSpare_1346, NonSpare_1022, NonSpare_1704, NonSpare_1769, NonSpare_1877, NonSpare_1270]
    cv_items_dict = {"BPS": NonSpare_693, "SH": NonSpare_1706, "NAV": NonSpare_1346, "GAO": NonSpare_1022, "SGV": NonSpare_1704, "STA": NonSpare_1769, "TNH": NonSpare_1877, "MES": NonSpare_1270}

    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_693:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SH"]) -> NonSpare_1706:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAV"]) -> NonSpare_1346:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAO"]) -> NonSpare_1022:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SGV"]) -> NonSpare_1704:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1769:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TNH"]) -> NonSpare_1877:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MES"]) -> NonSpare_1270:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BPS"], Literal["SH"], Literal["NAV"], Literal["GAO"], Literal["SGV"], Literal["STA"], Literal["TNH"], Literal["MES"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_693]:
        ...
    @overload
    def get_item(self, key : Literal["SH"]) -> Optional[NonSpare_1706]:
        ...
    @overload
    def get_item(self, key : Literal["NAV"]) -> Optional[NonSpare_1346]:
        ...
    @overload
    def get_item(self, key : Literal["GAO"]) -> Optional[NonSpare_1022]:
        ...
    @overload
    def get_item(self, key : Literal["SGV"]) -> Optional[NonSpare_1704]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1769]:
        ...
    @overload
    def get_item(self, key : Literal["TNH"]) -> Optional[NonSpare_1877]:
        ...
    @overload
    def get_item(self, key : Literal["MES"]) -> Optional[NonSpare_1270]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_693.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["SH"], val : NonSpare_1706.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["NAV"], val : NonSpare_1346.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["GAO"], val : NonSpare_1022.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["SGV"], val : NonSpare_1704.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1769.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["TNH"], val : NonSpare_1877.cv_arg) -> "Expansion_0":
        ...
    @overload
    def set_item(self, key : Literal["MES"], val : NonSpare_1270.cv_arg) -> "Expansion_0":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["BPS"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["SH"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["NAV"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["GAO"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["SGV"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["TNH"]) -> "Expansion_0":
        ...
    @overload
    def del_item(self, key : Literal["MES"]) -> "Expansion_0":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Expansion_0.cv_arg") -> 'Expansion_0':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_0", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_28(AstRef):
    cv_category = 21
    cv_edition = (1, 4)
    cv_expansion: TypeAlias = Expansion_0

class Variation_721(Element):
    cv_arg: TypeAlias = RuleContent_204.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_204

    @classmethod
    def create(cls, arg: "Variation_721.cv_arg") -> "Variation_721":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_204:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_204:
        return self.rule.content

class RuleVariation_710(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_721.cv_arg
    cv_variation: TypeAlias = Variation_721

    @classmethod
    def create(cls, arg : "RuleVariation_710.cv_arg") -> "RuleVariation_710":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_721:
        return self.arg # type: ignore

class NonSpare_944(NonSpare):
    cv_arg: TypeAlias = RuleVariation_710.cv_arg
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_710

    @classmethod
    def create(cls, arg : "NonSpare_944.cv_arg") -> "NonSpare_944":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_710:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_721:
        return self.rule.variation

class Item_305(Item):
    cv_arg: TypeAlias = NonSpare_944.cv_arg
    cv_non_spare: TypeAlias = NonSpare_944

    @classmethod
    def create(cls, arg : "Item_305.cv_arg") -> "Item_305":
        return cls._create(arg) # type: ignore

class Content_260(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "MCP/FCU Mode Bits not populated", 1: "MCP/FCU Mode Bits populated"}

class RuleContent_260(RuleContentContextFree):
    cv_arg: TypeAlias = Content_260.cv_arg
    cv_content: TypeAlias = Content_260

    @property
    def content(self) -> Content_260:
        return self._get_content() # type: ignore

class Variation_859(Element):
    cv_arg: TypeAlias = RuleContent_260.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_260

    @classmethod
    def create(cls, arg: "Variation_859.cv_arg") -> "Variation_859":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_260:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_260:
        return self.rule.content

class RuleVariation_829(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_859.cv_arg
    cv_variation: TypeAlias = Variation_859

    @classmethod
    def create(cls, arg : "RuleVariation_829.cv_arg") -> "RuleVariation_829":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_859:
        return self.arg # type: ignore

class NonSpare_2022(NonSpare):
    cv_arg: TypeAlias = RuleVariation_829.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_829

    @classmethod
    def create(cls, arg : "NonSpare_2022.cv_arg") -> "NonSpare_2022":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_829:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_859:
        return self.rule.variation

class Item_1132(Item):
    cv_arg: TypeAlias = NonSpare_2022.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2022

    @classmethod
    def create(cls, arg : "Item_1132.cv_arg") -> "Item_1132":
        return cls._create(arg) # type: ignore

class Variation_1333(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_710.cv_arg, Tuple[Literal["EP"], RuleVariation_710.cv_arg]], Union[RuleVariation_829.cv_arg, Tuple[Literal["VAL"], RuleVariation_829.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1333.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_items_list = [(Item_305, 1), (Item_1132, 1)]
    cv_items_dict = {"EP": RuleVariation_710, "VAL": RuleVariation_829}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_710:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_829:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_710:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_829:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1333.cv_arg") -> 'Variation_1333':
        return cls._create(arg) # type: ignore

class RuleVariation_1257(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1333.cv_arg
    cv_variation: TypeAlias = Variation_1333

    @classmethod
    def create(cls, arg : "RuleVariation_1257.cv_arg") -> "RuleVariation_1257":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1333:
        return self.arg # type: ignore

class NonSpare_1277(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1257.cv_arg
    cv_name = "MFM"
    cv_title = "Status of MCP/FCU Mode Bits"
    cv_rule: TypeAlias = RuleVariation_1257

    @classmethod
    def create(cls, arg : "NonSpare_1277.cv_arg") -> "NonSpare_1277":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1257:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1333:
        return self.rule.variation

class Item_548(Item):
    cv_arg: TypeAlias = NonSpare_1277.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1277

    @classmethod
    def create(cls, arg : "Item_548.cv_arg") -> "Item_548":
        return cls._create(arg) # type: ignore

class Variation_1053(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_13.cv_arg, Tuple[Literal["AP"], RuleVariation_13.cv_arg]], Union[RuleVariation_453.cv_arg, Tuple[Literal["VN"], RuleVariation_453.cv_arg]], Union[RuleVariation_499.cv_arg, Tuple[Literal["AH"], RuleVariation_499.cv_arg]], Union[RuleVariation_606.cv_arg, Tuple[Literal["AM"], RuleVariation_606.cv_arg]], Union[RuleVariation_1257.cv_arg, Tuple[Literal["MFM"], RuleVariation_1257.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1053.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_76, 1), (Item_1145, 1), (Item_52, 1), (Item_70, 1), (Item_548, 2), (Item_27, 2)]
    cv_items_dict = {"AP": RuleVariation_13, "VN": RuleVariation_453, "AH": RuleVariation_499, "AM": RuleVariation_606, "MFM": RuleVariation_1257}

    @overload
    @classmethod
    def spec(cls, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_453:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_499:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_606:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MFM"]) -> RuleVariation_1257:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AP"], Literal["VN"], Literal["AH"], Literal["AM"], Literal["MFM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AP"]) -> RuleVariation_13:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_453:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_499:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_606:
        ...
    @overload
    def get_item(self, key : Literal["MFM"]) -> RuleVariation_1257:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1053.cv_arg") -> 'Variation_1053':
        return cls._create(arg) # type: ignore

class RuleVariation_1020(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1053.cv_arg
    cv_variation: TypeAlias = Variation_1053

    @classmethod
    def create(cls, arg : "RuleVariation_1020.cv_arg") -> "RuleVariation_1020":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1053:
        return self.arg # type: ignore

class NonSpare_1347(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1020.cv_arg
    cv_name = "NAV"
    cv_title = "Navigation Mode"
    cv_rule: TypeAlias = RuleVariation_1020

    @classmethod
    def create(cls, arg : "NonSpare_1347.cv_arg") -> "NonSpare_1347":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1020:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1053:
        return self.rule.variation

class NonSpare_1021(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "GAO"
    cv_title = "GPS Antenna Offset"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1021.cv_arg") -> "NonSpare_1021":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Variation_534(Element):
    cv_arg: TypeAlias = RuleContent_204.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_204

    @classmethod
    def create(cls, arg: "Variation_534.cv_arg") -> "Variation_534":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_204:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_204:
        return self.rule.content

class RuleVariation_523(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_534.cv_arg
    cv_variation: TypeAlias = Variation_534

    @classmethod
    def create(cls, arg : "RuleVariation_523.cv_arg") -> "RuleVariation_523":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_534:
        return self.arg # type: ignore

class NonSpare_942(NonSpare):
    cv_arg: TypeAlias = RuleVariation_523.cv_arg
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_523

    @classmethod
    def create(cls, arg : "NonSpare_942.cv_arg") -> "NonSpare_942":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_523:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_534:
        return self.rule.variation

class Item_303(Item):
    cv_arg: TypeAlias = NonSpare_942.cv_arg
    cv_non_spare: TypeAlias = NonSpare_942

    @classmethod
    def create(cls, arg : "Item_303.cv_arg") -> "Item_303":
        return cls._create(arg) # type: ignore

class Content_387(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not RCE", 1: "TABS (see Note 2)", 2: "Reserved for future use", 3: "Other RCE"}

class RuleContent_387(RuleContentContextFree):
    cv_arg: TypeAlias = Content_387.cv_arg
    cv_content: TypeAlias = Content_387

    @property
    def content(self) -> Content_387:
        return self._get_content() # type: ignore

class Variation_680(Element):
    cv_arg: TypeAlias = RuleContent_387.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_387

    @classmethod
    def create(cls, arg: "Variation_680.cv_arg") -> "Variation_680":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_387:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_387:
        return self.rule.content

class RuleVariation_669(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_680.cv_arg
    cv_variation: TypeAlias = Variation_680

    @classmethod
    def create(cls, arg : "RuleVariation_669.cv_arg") -> "RuleVariation_669":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_680:
        return self.arg # type: ignore

class NonSpare_2017(NonSpare):
    cv_arg: TypeAlias = RuleVariation_669.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_669

    @classmethod
    def create(cls, arg : "NonSpare_2017.cv_arg") -> "NonSpare_2017":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_669:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_680:
        return self.rule.variation

class Item_1127(Item):
    cv_arg: TypeAlias = NonSpare_2017.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2017

    @classmethod
    def create(cls, arg : "Item_1127.cv_arg") -> "Item_1127":
        return cls._create(arg) # type: ignore

class Variation_1324(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_523.cv_arg, Tuple[Literal["EP"], RuleVariation_523.cv_arg]], Union[RuleVariation_669.cv_arg, Tuple[Literal["VAL"], RuleVariation_669.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1324.cv_arg_group"]
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_items_list = [(Item_303, 1), (Item_1127, 2)]
    cv_items_dict = {"EP": RuleVariation_523, "VAL": RuleVariation_669}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_523:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_669:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_523:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_669:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1324.cv_arg") -> 'Variation_1324':
        return cls._create(arg) # type: ignore

class RuleVariation_1248(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1324.cv_arg
    cv_variation: TypeAlias = Variation_1324

    @classmethod
    def create(cls, arg : "RuleVariation_1248.cv_arg") -> "RuleVariation_1248":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1324:
        return self.arg # type: ignore

class Variation_848(Element):
    cv_arg: TypeAlias = RuleContent_204.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_204

    @classmethod
    def create(cls, arg: "Variation_848.cv_arg") -> "Variation_848":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_204:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_204:
        return self.rule.content

class RuleVariation_818(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_848.cv_arg
    cv_variation: TypeAlias = Variation_848

    @classmethod
    def create(cls, arg : "RuleVariation_818.cv_arg") -> "RuleVariation_818":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_848:
        return self.arg # type: ignore

class NonSpare_945(NonSpare):
    cv_arg: TypeAlias = RuleVariation_818.cv_arg
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_818

    @classmethod
    def create(cls, arg : "NonSpare_945.cv_arg") -> "NonSpare_945":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_818:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_848:
        return self.rule.variation

class Item_306(Item):
    cv_arg: TypeAlias = NonSpare_945.cv_arg
    cv_non_spare: TypeAlias = NonSpare_945

    @classmethod
    def create(cls, arg : "Item_306.cv_arg") -> "Item_306":
        return cls._create(arg) # type: ignore

class Content_438(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Reply Rate Limiting is not active", 1: "Reply Rate Limiting is active"}

class RuleContent_438(RuleContentContextFree):
    cv_arg: TypeAlias = Content_438.cv_arg
    cv_content: TypeAlias = Content_438

    @property
    def content(self) -> Content_438:
        return self._get_content() # type: ignore

class Variation_947(Element):
    cv_arg: TypeAlias = RuleContent_438.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_438

    @classmethod
    def create(cls, arg: "Variation_947.cv_arg") -> "Variation_947":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_438:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_438:
        return self.rule.content

class RuleVariation_917(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_947.cv_arg
    cv_variation: TypeAlias = Variation_947

    @classmethod
    def create(cls, arg : "RuleVariation_917.cv_arg") -> "RuleVariation_917":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_947:
        return self.arg # type: ignore

class NonSpare_2026(NonSpare):
    cv_arg: TypeAlias = RuleVariation_917.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_917

    @classmethod
    def create(cls, arg : "NonSpare_2026.cv_arg") -> "NonSpare_2026":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_917:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_947:
        return self.rule.variation

class Item_1136(Item):
    cv_arg: TypeAlias = NonSpare_2026.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2026

    @classmethod
    def create(cls, arg : "Item_1136.cv_arg") -> "Item_1136":
        return cls._create(arg) # type: ignore

class Variation_1340(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_818.cv_arg, Tuple[Literal["EP"], RuleVariation_818.cv_arg]], Union[RuleVariation_917.cv_arg, Tuple[Literal["VAL"], RuleVariation_917.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1340.cv_arg_group"]
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_items_list = [(Item_306, 1), (Item_1136, 1)]
    cv_items_dict = {"EP": RuleVariation_818, "VAL": RuleVariation_917}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_917:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_818:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_917:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1340.cv_arg") -> 'Variation_1340':
        return cls._create(arg) # type: ignore

class RuleVariation_1261(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1340.cv_arg
    cv_variation: TypeAlias = Variation_1340

    @classmethod
    def create(cls, arg : "RuleVariation_1261.cv_arg") -> "RuleVariation_1261":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1340:
        return self.arg # type: ignore

class Content_358(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "UAS/RPAS - Lost link", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Aircraft in Distress", 7: "Aircraft in Distress Manual Activation"}

class RuleContent_358(RuleContentContextFree):
    cv_arg: TypeAlias = Content_358.cv_arg
    cv_content: TypeAlias = Content_358

    @property
    def content(self) -> Content_358:
        return self._get_content() # type: ignore

class Variation_484(Element):
    cv_arg: TypeAlias = RuleContent_358.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_358

    @classmethod
    def create(cls, arg: "Variation_484.cv_arg") -> "Variation_484":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_358:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_358:
        return self.rule.content

class RuleVariation_473(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_484.cv_arg
    cv_variation: TypeAlias = Variation_484

    @classmethod
    def create(cls, arg : "RuleVariation_473.cv_arg") -> "RuleVariation_473":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_484:
        return self.arg # type: ignore

class NonSpare_2013(NonSpare):
    cv_arg: TypeAlias = RuleVariation_473.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_473

    @classmethod
    def create(cls, arg : "NonSpare_2013.cv_arg") -> "NonSpare_2013":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_473:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_484:
        return self.rule.variation

class Item_1123(Item):
    cv_arg: TypeAlias = NonSpare_2013.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2013

    @classmethod
    def create(cls, arg : "Item_1123.cv_arg") -> "Item_1123":
        return cls._create(arg) # type: ignore

class Variation_1098(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_473.cv_arg, Tuple[Literal["VAL"], RuleVariation_473.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1098.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_items_list = [(Item_302, 1), (Item_1123, 3)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_473}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_473:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_473:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1098.cv_arg") -> 'Variation_1098':
        return cls._create(arg) # type: ignore

class RuleVariation_1056(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1098.cv_arg
    cv_variation: TypeAlias = Variation_1098

    @classmethod
    def create(cls, arg : "RuleVariation_1056.cv_arg") -> "RuleVariation_1056":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1098:
        return self.arg # type: ignore

class Content_531(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unavailable, Unknown, or less than 70 W", 1: "70 W", 2: "125 W", 3: "200 W"}

class RuleContent_531(RuleContentContextFree):
    cv_arg: TypeAlias = Content_531.cv_arg
    cv_content: TypeAlias = Content_531

    @property
    def content(self) -> Content_531:
        return self._get_content() # type: ignore

class Variation_886(Element):
    cv_arg: TypeAlias = RuleContent_531.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_531

    @classmethod
    def create(cls, arg: "Variation_886.cv_arg") -> "Variation_886":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_531:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_531:
        return self.rule.content

class RuleVariation_856(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_886.cv_arg
    cv_variation: TypeAlias = Variation_886

    @classmethod
    def create(cls, arg : "RuleVariation_856.cv_arg") -> "RuleVariation_856":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_886:
        return self.arg # type: ignore

class NonSpare_2023(NonSpare):
    cv_arg: TypeAlias = RuleVariation_856.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_856

    @classmethod
    def create(cls, arg : "NonSpare_2023.cv_arg") -> "NonSpare_2023":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_856:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_886:
        return self.rule.variation

class Item_1133(Item):
    cv_arg: TypeAlias = NonSpare_2023.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2023

    @classmethod
    def create(cls, arg : "Item_1133.cv_arg") -> "Item_1133":
        return cls._create(arg) # type: ignore

class Variation_1334(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_710.cv_arg, Tuple[Literal["EP"], RuleVariation_710.cv_arg]], Union[RuleVariation_856.cv_arg, Tuple[Literal["VAL"], RuleVariation_856.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1334.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_items_list = [(Item_305, 1), (Item_1133, 2)]
    cv_items_dict = {"EP": RuleVariation_710, "VAL": RuleVariation_856}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_710:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_856:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_710:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_856:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1334.cv_arg") -> 'Variation_1334':
        return cls._create(arg) # type: ignore

class RuleVariation_1258(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1334.cv_arg
    cv_variation: TypeAlias = Variation_1334

    @classmethod
    def create(cls, arg : "RuleVariation_1258.cv_arg") -> "RuleVariation_1258":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1334:
        return self.arg # type: ignore

class Content_553(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Transponder #1 (left/pilot side or single)", 2: "Transponder #2 (right/co-pilot side)", 3: "Transponder #3 (auxiliary or Backup)"}

class RuleContent_553(RuleContentContextFree):
    cv_arg: TypeAlias = Content_553.cv_arg
    cv_content: TypeAlias = Content_553

    @property
    def content(self) -> Content_553:
        return self._get_content() # type: ignore

class Variation_480(Element):
    cv_arg: TypeAlias = RuleContent_553.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_553

    @classmethod
    def create(cls, arg: "Variation_480.cv_arg") -> "Variation_480":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_553:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_553:
        return self.rule.content

class RuleVariation_469(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_480.cv_arg
    cv_variation: TypeAlias = Variation_480

    @classmethod
    def create(cls, arg : "RuleVariation_469.cv_arg") -> "RuleVariation_469":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_480:
        return self.arg # type: ignore

class NonSpare_2011(NonSpare):
    cv_arg: TypeAlias = RuleVariation_469.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_469

    @classmethod
    def create(cls, arg : "NonSpare_2011.cv_arg") -> "NonSpare_2011":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_469:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_480:
        return self.rule.variation

class Item_1121(Item):
    cv_arg: TypeAlias = NonSpare_2011.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2011

    @classmethod
    def create(cls, arg : "Item_1121.cv_arg") -> "Item_1121":
        return cls._create(arg) # type: ignore

class Variation_1096(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_469.cv_arg, Tuple[Literal["VAL"], RuleVariation_469.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1096.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_302, 1), (Item_1121, 2)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_469}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_469:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_469:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1096.cv_arg") -> 'Variation_1096':
        return cls._create(arg) # type: ignore

class RuleVariation_1054(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1096.cv_arg
    cv_variation: TypeAlias = Variation_1096

    @classmethod
    def create(cls, arg : "RuleVariation_1054.cv_arg") -> "RuleVariation_1054":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1096:
        return self.arg # type: ignore

class Variation_639(Element):
    cv_arg: TypeAlias = RuleContent_204.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_204

    @classmethod
    def create(cls, arg: "Variation_639.cv_arg") -> "Variation_639":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_204:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_204:
        return self.rule.content

class RuleVariation_628(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_639.cv_arg
    cv_variation: TypeAlias = Variation_639

    @classmethod
    def create(cls, arg : "RuleVariation_628.cv_arg") -> "RuleVariation_628":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_639:
        return self.arg # type: ignore

class NonSpare_943(NonSpare):
    cv_arg: TypeAlias = RuleVariation_628.cv_arg
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_628

    @classmethod
    def create(cls, arg : "NonSpare_943.cv_arg") -> "NonSpare_943":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_628:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_639:
        return self.rule.variation

class Item_304(Item):
    cv_arg: TypeAlias = NonSpare_943.cv_arg
    cv_non_spare: TypeAlias = NonSpare_943

    @classmethod
    def create(cls, arg : "Item_304.cv_arg") -> "Item_304":
        return cls._create(arg) # type: ignore

class Content_265(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Manned Operation", 1: "Unmanned Operation"}

class RuleContent_265(RuleContentContextFree):
    cv_arg: TypeAlias = Content_265.cv_arg
    cv_content: TypeAlias = Content_265

    @property
    def content(self) -> Content_265:
        return self._get_content() # type: ignore

class Variation_731(Element):
    cv_arg: TypeAlias = RuleContent_265.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_265

    @classmethod
    def create(cls, arg: "Variation_731.cv_arg") -> "Variation_731":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_265:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_265:
        return self.rule.content

class RuleVariation_720(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_731.cv_arg
    cv_variation: TypeAlias = Variation_731

    @classmethod
    def create(cls, arg : "RuleVariation_720.cv_arg") -> "RuleVariation_720":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_731:
        return self.arg # type: ignore

class NonSpare_2018(NonSpare):
    cv_arg: TypeAlias = RuleVariation_720.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_720

    @classmethod
    def create(cls, arg : "NonSpare_2018.cv_arg") -> "NonSpare_2018":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_720:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_731:
        return self.rule.variation

class Item_1128(Item):
    cv_arg: TypeAlias = NonSpare_2018.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2018

    @classmethod
    def create(cls, arg : "Item_1128.cv_arg") -> "Item_1128":
        return cls._create(arg) # type: ignore

class Variation_1328(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_628.cv_arg, Tuple[Literal["EP"], RuleVariation_628.cv_arg]], Union[RuleVariation_720.cv_arg, Tuple[Literal["VAL"], RuleVariation_720.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1328.cv_arg_group"]
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_items_list = [(Item_304, 1), (Item_1128, 1)]
    cv_items_dict = {"EP": RuleVariation_628, "VAL": RuleVariation_720}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_720:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_720:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1328.cv_arg") -> 'Variation_1328':
        return cls._create(arg) # type: ignore

class RuleVariation_1252(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1328.cv_arg
    cv_variation: TypeAlias = Variation_1328

    @classmethod
    def create(cls, arg : "RuleVariation_1252.cv_arg") -> "RuleVariation_1252":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1328:
        return self.arg # type: ignore

class Content_435(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "RWC Corrective Alert not active", 1: "RWC Corrective Alert active"}

class RuleContent_435(RuleContentContextFree):
    cv_arg: TypeAlias = Content_435.cv_arg
    cv_content: TypeAlias = Content_435

    @property
    def content(self) -> Content_435:
        return self._get_content() # type: ignore

class Variation_946(Element):
    cv_arg: TypeAlias = RuleContent_435.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_435

    @classmethod
    def create(cls, arg: "Variation_946.cv_arg") -> "Variation_946":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_435:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_435:
        return self.rule.content

class RuleVariation_916(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_946.cv_arg
    cv_variation: TypeAlias = Variation_946

    @classmethod
    def create(cls, arg : "RuleVariation_916.cv_arg") -> "RuleVariation_916":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_946:
        return self.arg # type: ignore

class NonSpare_2025(NonSpare):
    cv_arg: TypeAlias = RuleVariation_916.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_916

    @classmethod
    def create(cls, arg : "NonSpare_2025.cv_arg") -> "NonSpare_2025":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_916:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_946:
        return self.rule.variation

class Item_1135(Item):
    cv_arg: TypeAlias = NonSpare_2025.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2025

    @classmethod
    def create(cls, arg : "Item_1135.cv_arg") -> "Item_1135":
        return cls._create(arg) # type: ignore

class Variation_1339(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_818.cv_arg, Tuple[Literal["EP"], RuleVariation_818.cv_arg]], Union[RuleVariation_916.cv_arg, Tuple[Literal["VAL"], RuleVariation_916.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1339.cv_arg_group"]
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_items_list = [(Item_306, 1), (Item_1135, 1)]
    cv_items_dict = {"EP": RuleVariation_818, "VAL": RuleVariation_916}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_916:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_818:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_916:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1339.cv_arg") -> 'Variation_1339':
        return cls._create(arg) # type: ignore

class RuleVariation_1260(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1339.cv_arg
    cv_variation: TypeAlias = Variation_1339

    @classmethod
    def create(cls, arg : "RuleVariation_1260.cv_arg") -> "RuleVariation_1260":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1339:
        return self.arg # type: ignore

class Content_317(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No RWC Capability", 1: "RWC/RA/OCM Capability", 2: "RWC/OCM Capability", 3: "Invalid ASTERIX Value"}

class RuleContent_317(RuleContentContextFree):
    cv_arg: TypeAlias = Content_317.cv_arg
    cv_content: TypeAlias = Content_317

    @property
    def content(self) -> Content_317:
        return self._get_content() # type: ignore

class Variation_470(Element):
    cv_arg: TypeAlias = RuleContent_317.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_317

    @classmethod
    def create(cls, arg: "Variation_470.cv_arg") -> "Variation_470":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_317:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_317:
        return self.rule.content

class RuleVariation_459(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_470.cv_arg
    cv_variation: TypeAlias = Variation_470

    @classmethod
    def create(cls, arg : "RuleVariation_459.cv_arg") -> "RuleVariation_459":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_470:
        return self.arg # type: ignore

class NonSpare_2008(NonSpare):
    cv_arg: TypeAlias = RuleVariation_459.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_459

    @classmethod
    def create(cls, arg : "NonSpare_2008.cv_arg") -> "NonSpare_2008":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_459:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_470:
        return self.rule.variation

class Item_1118(Item):
    cv_arg: TypeAlias = NonSpare_2008.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2008

    @classmethod
    def create(cls, arg : "Item_1118.cv_arg") -> "Item_1118":
        return cls._create(arg) # type: ignore

class Variation_1093(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_459.cv_arg, Tuple[Literal["VAL"], RuleVariation_459.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1093.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_302, 1), (Item_1118, 2)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_459}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_459:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_459:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1093.cv_arg") -> 'Variation_1093':
        return cls._create(arg) # type: ignore

class RuleVariation_1051(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1093.cv_arg
    cv_variation: TypeAlias = Variation_1093

    @classmethod
    def create(cls, arg : "RuleVariation_1051.cv_arg") -> "RuleVariation_1051":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1093:
        return self.arg # type: ignore

class NonSpare_2020(NonSpare):
    cv_arg: TypeAlias = RuleVariation_763.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_763

    @classmethod
    def create(cls, arg : "NonSpare_2020.cv_arg") -> "NonSpare_2020":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_763:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_774:
        return self.rule.variation

class Item_1130(Item):
    cv_arg: TypeAlias = NonSpare_2020.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2020

    @classmethod
    def create(cls, arg : "Item_1130.cv_arg") -> "Item_1130":
        return cls._create(arg) # type: ignore

class Variation_1330(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_628.cv_arg, Tuple[Literal["EP"], RuleVariation_628.cv_arg]], Union[RuleVariation_763.cv_arg, Tuple[Literal["VAL"], RuleVariation_763.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1330.cv_arg_group"]
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_items_list = [(Item_304, 1), (Item_1130, 3)]
    cv_items_dict = {"EP": RuleVariation_628, "VAL": RuleVariation_763}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_763:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_763:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1330.cv_arg") -> 'Variation_1330':
        return cls._create(arg) # type: ignore

class RuleVariation_1254(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1330.cv_arg
    cv_variation: TypeAlias = Variation_1330

    @classmethod
    def create(cls, arg : "RuleVariation_1254.cv_arg") -> "RuleVariation_1254":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1330:
        return self.arg # type: ignore

class Content_562(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Vertical Only", 1: "Horizontal Only", 2: "Blended", 3: "Vertical Only or Horizontal Only per intruder"}

class RuleContent_562(RuleContentContextFree):
    cv_arg: TypeAlias = Content_562.cv_arg
    cv_content: TypeAlias = Content_562

    @property
    def content(self) -> Content_562:
        return self._get_content() # type: ignore

class Variation_481(Element):
    cv_arg: TypeAlias = RuleContent_562.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_562

    @classmethod
    def create(cls, arg: "Variation_481.cv_arg") -> "Variation_481":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_562:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_562:
        return self.rule.content

class RuleVariation_470(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_481.cv_arg
    cv_variation: TypeAlias = Variation_481

    @classmethod
    def create(cls, arg : "RuleVariation_470.cv_arg") -> "RuleVariation_470":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_481:
        return self.arg # type: ignore

class NonSpare_2012(NonSpare):
    cv_arg: TypeAlias = RuleVariation_470.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_470

    @classmethod
    def create(cls, arg : "NonSpare_2012.cv_arg") -> "NonSpare_2012":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_470:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_481:
        return self.rule.variation

class Item_1122(Item):
    cv_arg: TypeAlias = NonSpare_2012.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2012

    @classmethod
    def create(cls, arg : "Item_1122.cv_arg") -> "Item_1122":
        return cls._create(arg) # type: ignore

class Variation_1097(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_470.cv_arg, Tuple[Literal["VAL"], RuleVariation_470.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1097.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_302, 1), (Item_1122, 2)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_470}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_470:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_470:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1097.cv_arg") -> 'Variation_1097':
        return cls._create(arg) # type: ignore

class RuleVariation_1055(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1097.cv_arg
    cv_variation: TypeAlias = Variation_1097

    @classmethod
    def create(cls, arg : "RuleVariation_1055.cv_arg") -> "RuleVariation_1055":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1097:
        return self.arg # type: ignore

class NonSpare_946(NonSpare):
    cv_arg: TypeAlias = RuleVariation_628.cv_arg
    cv_name = "EP"
    cv_title = "Element Population Bit"
    cv_rule: TypeAlias = RuleVariation_628

    @classmethod
    def create(cls, arg : "NonSpare_946.cv_arg") -> "NonSpare_946":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_628:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_639:
        return self.rule.variation

class Item_307(Item):
    cv_arg: TypeAlias = NonSpare_946.cv_arg
    cv_non_spare: TypeAlias = NonSpare_946

    @classmethod
    def create(cls, arg : "Item_307.cv_arg") -> "Item_307":
        return cls._create(arg) # type: ignore

class Content_15(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Active CAS (TCAS II) or no CAS", 1: "Active CAS (not TCAS II)", 2: "Active CAS (not TCAS II) with OCM transmit capability", 3: "Active CAS of Junior Status", 4: "Passive CAS with 1030TCAS Resolution Message receive capability", 5: "Passive CAS with only OCM receive capability", 6: "Reserved for future use", 7: "Reserved for future use"}

class RuleContent_15(RuleContentContextFree):
    cv_arg: TypeAlias = Content_15.cv_arg
    cv_content: TypeAlias = Content_15

    @property
    def content(self) -> Content_15:
        return self._get_content() # type: ignore

class Variation_779(Element):
    cv_arg: TypeAlias = RuleContent_15.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_15

    @classmethod
    def create(cls, arg: "Variation_779.cv_arg") -> "Variation_779":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_15:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_15:
        return self.rule.content

class RuleVariation_765(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_779.cv_arg
    cv_variation: TypeAlias = Variation_779

    @classmethod
    def create(cls, arg : "RuleVariation_765.cv_arg") -> "RuleVariation_765":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_779:
        return self.arg # type: ignore

class NonSpare_2021(NonSpare):
    cv_arg: TypeAlias = RuleVariation_765.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_765

    @classmethod
    def create(cls, arg : "NonSpare_2021.cv_arg") -> "NonSpare_2021":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_765:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_779:
        return self.rule.variation

class Item_1131(Item):
    cv_arg: TypeAlias = NonSpare_2021.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2021

    @classmethod
    def create(cls, arg : "Item_1131.cv_arg") -> "Item_1131":
        return cls._create(arg) # type: ignore

class Variation_1331(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_628.cv_arg, Tuple[Literal["EP"], RuleVariation_628.cv_arg]], Union[RuleVariation_765.cv_arg, Tuple[Literal["VAL"], RuleVariation_765.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1331.cv_arg_group"]
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_items_list = [(Item_307, 1), (Item_1131, 3)]
    cv_items_dict = {"EP": RuleVariation_628, "VAL": RuleVariation_765}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_765:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_765:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1331.cv_arg") -> 'Variation_1331':
        return cls._create(arg) # type: ignore

class RuleVariation_1255(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1331.cv_arg
    cv_variation: TypeAlias = Variation_1331

    @classmethod
    def create(cls, arg : "RuleVariation_1255.cv_arg") -> "RuleVariation_1255":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1331:
        return self.arg # type: ignore

class Content_203(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Element Not Populated", 1: "Element Populated"}

class RuleContent_203(RuleContentContextFree):
    cv_arg: TypeAlias = Content_203.cv_arg
    cv_content: TypeAlias = Content_203

    @property
    def content(self) -> Content_203:
        return self._get_content() # type: ignore

class Variation_41(Element):
    cv_arg: TypeAlias = RuleContent_203.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_203

    @classmethod
    def create(cls, arg: "Variation_41.cv_arg") -> "Variation_41":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_203:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_203:
        return self.rule.content

class RuleVariation_41(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_41.cv_arg
    cv_variation: TypeAlias = Variation_41

    @classmethod
    def create(cls, arg : "RuleVariation_41.cv_arg") -> "RuleVariation_41":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_41:
        return self.arg # type: ignore

class NonSpare_940(NonSpare):
    cv_arg: TypeAlias = RuleVariation_41.cv_arg
    cv_name = "EP"
    cv_title = "Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_41

    @classmethod
    def create(cls, arg : "NonSpare_940.cv_arg") -> "NonSpare_940":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_41:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_41:
        return self.rule.variation

class Item_301(Item):
    cv_arg: TypeAlias = NonSpare_940.cv_arg
    cv_non_spare: TypeAlias = NonSpare_940

    @classmethod
    def create(cls, arg : "Item_301.cv_arg") -> "Item_301":
        return cls._create(arg) # type: ignore

class Content_344(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No data", 1: "0 ≤ TAO ≤ 1", 2: "1 < TAO ≤ 2", 3: "2 < TAO ≤ 4", 4: "4 < TAO ≤ 6", 5: "6 < TAO ≤ 8", 6: "8 < TAO ≤ 10", 7: "10 < TAO ≤ 12", 8: "12 < TAO ≤ 14", 9: "14 < TAO ≤ 16", 10: "16 < TAO ≤ 18", 11: "18 < TAO ≤ 20", 12: "20 < TAO ≤ 22", 13: "22 < TAO ≤ 24", 14: "24 < TAO ≤ 26", 15: "26 < TAO ≤ 28", 16: "28 < TAO ≤ 30", 17: "30 < TAO ≤ 32", 18: "32 < TAO ≤ 34", 19: "34 < TAO ≤ 36", 20: "36 < TAO ≤ 38", 21: "38 < TAO ≤ 40", 22: "40 < TAO ≤ 42", 23: "42 < TAO ≤ 44", 24: "44 < TAO ≤ 46", 25: "46 < TAO ≤ 48", 26: "48 < TAO ≤ 50", 27: "50 < TAO ≤ 52", 28: "52 < TAO ≤ 54", 29: "54 < TAO ≤ 56", 30: "56 < TAO ≤ 58", 31: "TAO > 58"}

class RuleContent_344(RuleContentContextFree):
    cv_arg: TypeAlias = Content_344.cv_arg
    cv_content: TypeAlias = Content_344

    @property
    def content(self) -> Content_344:
        return self._get_content() # type: ignore

class Variation_490(Element):
    cv_arg: TypeAlias = RuleContent_344.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 5
    cv_rule = RuleContent_344

    @classmethod
    def create(cls, arg: "Variation_490.cv_arg") -> "Variation_490":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_344:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_344:
        return self.rule.content

class RuleVariation_479(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_490.cv_arg
    cv_variation: TypeAlias = Variation_490

    @classmethod
    def create(cls, arg : "RuleVariation_479.cv_arg") -> "RuleVariation_479":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_490:
        return self.arg # type: ignore

class NonSpare_2014(NonSpare):
    cv_arg: TypeAlias = RuleVariation_479.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_479

    @classmethod
    def create(cls, arg : "NonSpare_2014.cv_arg") -> "NonSpare_2014":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_479:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_490:
        return self.rule.variation

class Item_1124(Item):
    cv_arg: TypeAlias = NonSpare_2014.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2014

    @classmethod
    def create(cls, arg : "Item_1124.cv_arg") -> "Item_1124":
        return cls._create(arg) # type: ignore

class Variation_1091(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_41.cv_arg, Tuple[Literal["EP"], RuleVariation_41.cv_arg]], Union[RuleVariation_479.cv_arg, Tuple[Literal["VAL"], RuleVariation_479.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1091.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_items_list = [(Item_301, 1), (Item_1124, 5), (Item_26, 1)]
    cv_items_dict = {"EP": RuleVariation_41, "VAL": RuleVariation_479}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_479:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_41:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_479:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1091.cv_arg") -> 'Variation_1091':
        return cls._create(arg) # type: ignore

class RuleVariation_1049(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1091.cv_arg
    cv_variation: TypeAlias = Variation_1091

    @classmethod
    def create(cls, arg : "RuleVariation_1049.cv_arg") -> "RuleVariation_1049":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1091:
        return self.arg # type: ignore

class NonSpare_963(NonSpare):
    cv_arg: TypeAlias = RuleVariation_82.cv_arg
    cv_name = "ES"
    cv_title = "ES IN Capability"
    cv_rule: TypeAlias = RuleVariation_82

    @classmethod
    def create(cls, arg : "NonSpare_963.cv_arg") -> "NonSpare_963":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_82:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_82:
        return self.rule.variation

class Item_321(Item):
    cv_arg: TypeAlias = NonSpare_963.cv_arg
    cv_non_spare: TypeAlias = NonSpare_963

    @classmethod
    def create(cls, arg : "Item_321.cv_arg") -> "Item_321":
        return cls._create(arg) # type: ignore

class NonSpare_1981(NonSpare):
    cv_arg: TypeAlias = RuleVariation_442.cv_arg
    cv_name = "UAT"
    cv_title = "UAT IN Capability"
    cv_rule: TypeAlias = RuleVariation_442

    @classmethod
    def create(cls, arg : "NonSpare_1981.cv_arg") -> "NonSpare_1981":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_442:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_453:
        return self.rule.variation

class Item_1093(Item):
    cv_arg: TypeAlias = NonSpare_1981.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1981

    @classmethod
    def create(cls, arg : "Item_1093.cv_arg") -> "Item_1093":
        return cls._create(arg) # type: ignore

class NonSpare_1556(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1248.cv_arg
    cv_name = "RCE"
    cv_title = "Reduced Capability Equipment"
    cv_rule: TypeAlias = RuleVariation_1248

    @classmethod
    def create(cls, arg : "NonSpare_1556.cv_arg") -> "NonSpare_1556":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1248:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1324:
        return self.rule.variation

class Item_784(Item):
    cv_arg: TypeAlias = NonSpare_1556.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1556

    @classmethod
    def create(cls, arg : "Item_784.cv_arg") -> "Item_784":
        return cls._create(arg) # type: ignore

class NonSpare_1613(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1261.cv_arg
    cv_name = "RRL"
    cv_title = "Reply Rate Limiting"
    cv_rule: TypeAlias = RuleVariation_1261

    @classmethod
    def create(cls, arg : "NonSpare_1613.cv_arg") -> "NonSpare_1613":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1261:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1340:
        return self.rule.variation

class Item_831(Item):
    cv_arg: TypeAlias = NonSpare_1613.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1613

    @classmethod
    def create(cls, arg : "Item_831.cv_arg") -> "Item_831":
        return cls._create(arg) # type: ignore

class NonSpare_1470(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1056.cv_arg
    cv_name = "PS3"
    cv_title = "Priority Status for Version 3 ADS-B Systems"
    cv_rule: TypeAlias = RuleVariation_1056

    @classmethod
    def create(cls, arg : "NonSpare_1470.cv_arg") -> "NonSpare_1470":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1056:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1098:
        return self.rule.variation

class Item_712(Item):
    cv_arg: TypeAlias = NonSpare_1470.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1470

    @classmethod
    def create(cls, arg : "Item_712.cv_arg") -> "Item_712":
        return cls._create(arg) # type: ignore

class NonSpare_1898(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1258.cv_arg
    cv_name = "TPW"
    cv_title = "Transmit Power"
    cv_rule: TypeAlias = RuleVariation_1258

    @classmethod
    def create(cls, arg : "NonSpare_1898.cv_arg") -> "NonSpare_1898":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1258:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1334:
        return self.rule.variation

class Item_1021(Item):
    cv_arg: TypeAlias = NonSpare_1898.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1898

    @classmethod
    def create(cls, arg : "Item_1021.cv_arg") -> "Item_1021":
        return cls._create(arg) # type: ignore

class NonSpare_1932(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1054.cv_arg
    cv_name = "TSI"
    cv_title = "Transponder Side Indication"
    cv_rule: TypeAlias = RuleVariation_1054

    @classmethod
    def create(cls, arg : "NonSpare_1932.cv_arg") -> "NonSpare_1932":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1054:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1096:
        return self.rule.variation

class Item_1049(Item):
    cv_arg: TypeAlias = NonSpare_1932.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1932

    @classmethod
    def create(cls, arg : "Item_1049.cv_arg") -> "Item_1049":
        return cls._create(arg) # type: ignore

class NonSpare_1337(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1252.cv_arg
    cv_name = "MUO"
    cv_title = "Manned / Unmanned Operation"
    cv_rule: TypeAlias = RuleVariation_1252

    @classmethod
    def create(cls, arg : "NonSpare_1337.cv_arg") -> "NonSpare_1337":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1252:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1328:
        return self.rule.variation

class Item_600(Item):
    cv_arg: TypeAlias = NonSpare_1337.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1337

    @classmethod
    def create(cls, arg : "Item_600.cv_arg") -> "Item_600":
        return cls._create(arg) # type: ignore

class NonSpare_1643(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1260.cv_arg
    cv_name = "RWC"
    cv_title = "Remain Well Clear Corrective Alert"
    cv_rule: TypeAlias = RuleVariation_1260

    @classmethod
    def create(cls, arg : "NonSpare_1643.cv_arg") -> "NonSpare_1643":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1260:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1339:
        return self.rule.variation

class Item_847(Item):
    cv_arg: TypeAlias = NonSpare_1643.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1643

    @classmethod
    def create(cls, arg : "Item_847.cv_arg") -> "Item_847":
        return cls._create(arg) # type: ignore

class NonSpare_860(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1051.cv_arg
    cv_name = "DAA"
    cv_title = "Detectand Avoid Capabilities"
    cv_rule: TypeAlias = RuleVariation_1051

    @classmethod
    def create(cls, arg : "NonSpare_860.cv_arg") -> "NonSpare_860":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1051:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1093:
        return self.rule.variation

class Item_239(Item):
    cv_arg: TypeAlias = NonSpare_860.cv_arg
    cv_non_spare: TypeAlias = NonSpare_860

    @classmethod
    def create(cls, arg : "Item_239.cv_arg") -> "Item_239":
        return cls._create(arg) # type: ignore

class NonSpare_882(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1254.cv_arg
    cv_name = "DF17CA"
    cv_title = "Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_1254

    @classmethod
    def create(cls, arg : "NonSpare_882.cv_arg") -> "NonSpare_882":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1254:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1330:
        return self.rule.variation

class Item_259(Item):
    cv_arg: TypeAlias = NonSpare_882.cv_arg
    cv_non_spare: TypeAlias = NonSpare_882

    @classmethod
    def create(cls, arg : "Item_259.cv_arg") -> "Item_259":
        return cls._create(arg) # type: ignore

class NonSpare_1813(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1055.cv_arg
    cv_name = "SVH"
    cv_title = "Sense Vertical & Horizontal"
    cv_rule: TypeAlias = RuleVariation_1055

    @classmethod
    def create(cls, arg : "NonSpare_1813.cv_arg") -> "NonSpare_1813":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1055:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1097:
        return self.rule.variation

class Item_965(Item):
    cv_arg: TypeAlias = NonSpare_1813.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1813

    @classmethod
    def create(cls, arg : "Item_965.cv_arg") -> "Item_965":
        return cls._create(arg) # type: ignore

class NonSpare_708(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1255.cv_arg
    cv_name = "CATC"
    cv_title = "CAS Type & Capability"
    cv_rule: TypeAlias = RuleVariation_1255

    @classmethod
    def create(cls, arg : "NonSpare_708.cv_arg") -> "NonSpare_708":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1255:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1331:
        return self.rule.variation

class Item_138(Item):
    cv_arg: TypeAlias = NonSpare_708.cv_arg
    cv_non_spare: TypeAlias = NonSpare_708

    @classmethod
    def create(cls, arg : "Item_138.cv_arg") -> "Item_138":
        return cls._create(arg) # type: ignore

class NonSpare_1823(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1049.cv_arg
    cv_name = "TAO"
    cv_title = "Transponder Antenna Offset"
    cv_rule: TypeAlias = RuleVariation_1049

    @classmethod
    def create(cls, arg : "NonSpare_1823.cv_arg") -> "NonSpare_1823":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1049:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1091:
        return self.rule.variation

class Item_971(Item):
    cv_arg: TypeAlias = NonSpare_1823.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1823

    @classmethod
    def create(cls, arg : "Item_971.cv_arg") -> "Item_971":
        return cls._create(arg) # type: ignore

class Variation_1358(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_82.cv_arg, Tuple[Literal["ES"], RuleVariation_82.cv_arg]], Union[RuleVariation_442.cv_arg, Tuple[Literal["UAT"], RuleVariation_442.cv_arg]], Union[RuleVariation_1248.cv_arg, Tuple[Literal["RCE"], RuleVariation_1248.cv_arg]], Union[RuleVariation_1261.cv_arg, Tuple[Literal["RRL"], RuleVariation_1261.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_1056.cv_arg, Tuple[Literal["PS3"], RuleVariation_1056.cv_arg]], Union[RuleVariation_1258.cv_arg, Tuple[Literal["TPW"], RuleVariation_1258.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_1054.cv_arg, Tuple[Literal["TSI"], RuleVariation_1054.cv_arg]], Union[RuleVariation_1252.cv_arg, Tuple[Literal["MUO"], RuleVariation_1252.cv_arg]], Union[RuleVariation_1260.cv_arg, Tuple[Literal["RWC"], RuleVariation_1260.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_1051.cv_arg, Tuple[Literal["DAA"], RuleVariation_1051.cv_arg]], Union[RuleVariation_1254.cv_arg, Tuple[Literal["DF17CA"], RuleVariation_1254.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_1055.cv_arg, Tuple[Literal["SVH"], RuleVariation_1055.cv_arg]], Union[RuleVariation_1255.cv_arg, Tuple[Literal["CATC"], RuleVariation_1255.cv_arg]], None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_1049.cv_arg, Tuple[Literal["TAO"], RuleVariation_1049.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1358.cv_arg_group_1"],
        Tuple["Variation_1358.cv_arg_group_1", "Variation_1358.cv_arg_group_2"],
        Tuple["Variation_1358.cv_arg_group_1", "Variation_1358.cv_arg_group_2", "Variation_1358.cv_arg_group_3"],
        Tuple["Variation_1358.cv_arg_group_1", "Variation_1358.cv_arg_group_2", "Variation_1358.cv_arg_group_3", "Variation_1358.cv_arg_group_4"],
        Tuple["Variation_1358.cv_arg_group_1", "Variation_1358.cv_arg_group_2", "Variation_1358.cv_arg_group_3", "Variation_1358.cv_arg_group_4", "Variation_1358.cv_arg_group_5"],
        Tuple["Variation_1358.cv_arg_group_1", "Variation_1358.cv_arg_group_2", "Variation_1358.cv_arg_group_3", "Variation_1358.cv_arg_group_4", "Variation_1358.cv_arg_group_5", "Variation_1358.cv_arg_group_6"],
    ]
    cv_items_list = [[(Item_321, 1), (Item_1093, 1), (Item_784, 3), (Item_831, 2), None], [(Item_712, 4), (Item_1021, 3), None], [(Item_1049, 3), (Item_600, 2), (Item_847, 2), None], [(Item_239, 3), (Item_259, 4), None], [(Item_965, 3), (Item_138, 4), None], [(Item_971, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1358.cv_arg") -> 'Variation_1358':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ES"]) -> RuleVariation_82:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> RuleVariation_442:
        ...
    @overload
    def get_item(self, key : Literal["RCE"]) -> RuleVariation_1248:
        ...
    @overload
    def get_item(self, key : Literal["RRL"]) -> RuleVariation_1261:
        ...
    @overload
    def get_item(self, key : Literal["PS3"]) -> Optional[RuleVariation_1056]:
        ...
    @overload
    def get_item(self, key : Literal["TPW"]) -> Optional[RuleVariation_1258]:
        ...
    @overload
    def get_item(self, key : Literal["TSI"]) -> Optional[RuleVariation_1054]:
        ...
    @overload
    def get_item(self, key : Literal["MUO"]) -> Optional[RuleVariation_1252]:
        ...
    @overload
    def get_item(self, key : Literal["RWC"]) -> Optional[RuleVariation_1260]:
        ...
    @overload
    def get_item(self, key : Literal["DAA"]) -> Optional[RuleVariation_1051]:
        ...
    @overload
    def get_item(self, key : Literal["DF17CA"]) -> Optional[RuleVariation_1254]:
        ...
    @overload
    def get_item(self, key : Literal["SVH"]) -> Optional[RuleVariation_1055]:
        ...
    @overload
    def get_item(self, key : Literal["CATC"]) -> Optional[RuleVariation_1255]:
        ...
    @overload
    def get_item(self, key : Literal["TAO"]) -> Optional[RuleVariation_1049]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1279(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1358.cv_arg
    cv_variation: TypeAlias = Variation_1358

    @classmethod
    def create(cls, arg : "RuleVariation_1279.cv_arg") -> "RuleVariation_1279":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1358:
        return self.arg # type: ignore

class NonSpare_1770(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1279.cv_arg
    cv_name = "STA"
    cv_title = "Aircraft Status"
    cv_rule: TypeAlias = RuleVariation_1279

    @classmethod
    def create(cls, arg : "NonSpare_1770.cv_arg") -> "NonSpare_1770":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1279:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1358:
        return self.rule.variation

class Expansion_1(Expansion):
    cv_arg = TypedDict('cv_arg', {
        "BPS": NonSpare_693.cv_arg,
        "SH": NonSpare_1706.cv_arg,
        "NAV": NonSpare_1347.cv_arg,
        "GAO": NonSpare_1021.cv_arg,
        "SGV": NonSpare_1704.cv_arg,
        "STA": NonSpare_1770.cv_arg,
        "TNH": NonSpare_1877.cv_arg,
        "MES": NonSpare_1270.cv_arg,
    }, total=False)
    cv_type = (FspecFixed, 1)
    cv_items_list = [NonSpare_693, NonSpare_1706, NonSpare_1347, NonSpare_1021, NonSpare_1704, NonSpare_1770, NonSpare_1877, NonSpare_1270]
    cv_items_dict = {"BPS": NonSpare_693, "SH": NonSpare_1706, "NAV": NonSpare_1347, "GAO": NonSpare_1021, "SGV": NonSpare_1704, "STA": NonSpare_1770, "TNH": NonSpare_1877, "MES": NonSpare_1270}

    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_693:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SH"]) -> NonSpare_1706:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAV"]) -> NonSpare_1347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAO"]) -> NonSpare_1021:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SGV"]) -> NonSpare_1704:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1770:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TNH"]) -> NonSpare_1877:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MES"]) -> NonSpare_1270:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["BPS"], Literal["SH"], Literal["NAV"], Literal["GAO"], Literal["SGV"], Literal["STA"], Literal["TNH"], Literal["MES"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_693]:
        ...
    @overload
    def get_item(self, key : Literal["SH"]) -> Optional[NonSpare_1706]:
        ...
    @overload
    def get_item(self, key : Literal["NAV"]) -> Optional[NonSpare_1347]:
        ...
    @overload
    def get_item(self, key : Literal["GAO"]) -> Optional[NonSpare_1021]:
        ...
    @overload
    def get_item(self, key : Literal["SGV"]) -> Optional[NonSpare_1704]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1770]:
        ...
    @overload
    def get_item(self, key : Literal["TNH"]) -> Optional[NonSpare_1877]:
        ...
    @overload
    def get_item(self, key : Literal["MES"]) -> Optional[NonSpare_1270]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_693.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["SH"], val : NonSpare_1706.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["NAV"], val : NonSpare_1347.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["GAO"], val : NonSpare_1021.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["SGV"], val : NonSpare_1704.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1770.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["TNH"], val : NonSpare_1877.cv_arg) -> "Expansion_1":
        ...
    @overload
    def set_item(self, key : Literal["MES"], val : NonSpare_1270.cv_arg) -> "Expansion_1":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["BPS"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["SH"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["NAV"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["GAO"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["SGV"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["TNH"]) -> "Expansion_1":
        ...
    @overload
    def del_item(self, key : Literal["MES"]) -> "Expansion_1":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Expansion_1.cv_arg") -> 'Expansion_1':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_1", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_29(AstRef):
    cv_category = 21
    cv_edition = (1, 5)
    cv_expansion: TypeAlias = Expansion_1

class Content_5(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "24-Bit ICAO address", 1: "Duplicate address", 2: "Surface vehicle address", 3: "Anonymous address", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

class RuleContent_5(RuleContentContextFree):
    cv_arg: TypeAlias = Content_5.cv_arg
    cv_content: TypeAlias = Content_5

    @property
    def content(self) -> Content_5:
        return self._get_content() # type: ignore

class Variation_122(Element):
    cv_arg: TypeAlias = RuleContent_5.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_5

    @classmethod
    def create(cls, arg: "Variation_122.cv_arg") -> "Variation_122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_5:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_5:
        return self.rule.content

class RuleVariation_122(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_122.cv_arg
    cv_variation: TypeAlias = Variation_122

    @classmethod
    def create(cls, arg : "RuleVariation_122.cv_arg") -> "RuleVariation_122":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_122:
        return self.arg # type: ignore

class Content_6(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "25 ft", 1: "100 ft", 2: "Unknown", 3: "Invalid"}

class RuleContent_6(RuleContentContextFree):
    cv_arg: TypeAlias = Content_6.cv_arg
    cv_content: TypeAlias = Content_6

    @property
    def content(self) -> Content_6:
        return self._get_content() # type: ignore

class Variation_677(Element):
    cv_arg: TypeAlias = RuleContent_6.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_6

    @classmethod
    def create(cls, arg: "Variation_677.cv_arg") -> "Variation_677":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_6:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_6:
        return self.rule.content

class RuleVariation_666(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_677.cv_arg
    cv_variation: TypeAlias = Variation_677

    @classmethod
    def create(cls, arg : "RuleVariation_666.cv_arg") -> "RuleVariation_666":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_677:
        return self.arg # type: ignore

class Content_145(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Range Check passed, CPR Validation pending"}

class RuleContent_145(RuleContentContextFree):
    cv_arg: TypeAlias = Content_145.cv_arg
    cv_content: TypeAlias = Content_145

    @property
    def content(self) -> Content_145:
        return self._get_content() # type: ignore

class Variation_835(Element):
    cv_arg: TypeAlias = RuleContent_145.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_145

    @classmethod
    def create(cls, arg: "Variation_835.cv_arg") -> "Variation_835":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_145:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_145:
        return self.rule.content

class RuleVariation_805(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_835.cv_arg
    cv_variation: TypeAlias = Variation_835

    @classmethod
    def create(cls, arg : "RuleVariation_805.cv_arg") -> "RuleVariation_805":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_835:
        return self.arg # type: ignore

class Variation_949(Element):
    cv_arg: TypeAlias = RuleContent_442.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_442

    @classmethod
    def create(cls, arg: "Variation_949.cv_arg") -> "Variation_949":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_442:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_442:
        return self.rule.content

class RuleVariation_919(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_949.cv_arg
    cv_variation: TypeAlias = Variation_949

    @classmethod
    def create(cls, arg : "RuleVariation_919.cv_arg") -> "RuleVariation_919":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_949:
        return self.arg # type: ignore

class Variation_722(Element):
    cv_arg: TypeAlias = RuleContent_210.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_210

    @classmethod
    def create(cls, arg: "Variation_722.cv_arg") -> "Variation_722":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_210:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_210:
        return self.rule.content

class RuleVariation_711(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_722.cv_arg
    cv_variation: TypeAlias = Variation_722

    @classmethod
    def create(cls, arg : "RuleVariation_711.cv_arg") -> "RuleVariation_711":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_722:
        return self.arg # type: ignore

class Content_444(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Report valid", 1: "Report suspect", 2: "No information", 3: "Reserved for future use"}

class RuleContent_444(RuleContentContextFree):
    cv_arg: TypeAlias = Content_444.cv_arg
    cv_content: TypeAlias = Content_444

    @property
    def content(self) -> Content_444:
        return self._get_content() # type: ignore

class Variation_883(Element):
    cv_arg: TypeAlias = RuleContent_444.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_444

    @classmethod
    def create(cls, arg: "Variation_883.cv_arg") -> "Variation_883":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_444:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_444:
        return self.rule.content

class RuleVariation_853(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_883.cv_arg
    cv_variation: TypeAlias = Variation_883

    @classmethod
    def create(cls, arg : "RuleVariation_853.cv_arg") -> "RuleVariation_853":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_883:
        return self.arg # type: ignore

class Content_170(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default (see note)", 1: "Independent Position Check failed"}

class RuleContent_170(RuleContentContextFree):
    cv_arg: TypeAlias = Content_170.cv_arg
    cv_content: TypeAlias = Content_170

    @property
    def content(self) -> Content_170:
        return self._get_content() # type: ignore

class Variation_526(Element):
    cv_arg: TypeAlias = RuleContent_170.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_170

    @classmethod
    def create(cls, arg: "Variation_526.cv_arg") -> "Variation_526":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_170:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_170:
        return self.rule.content

class RuleVariation_515(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_526.cv_arg
    cv_variation: TypeAlias = Variation_526

    @classmethod
    def create(cls, arg : "RuleVariation_515.cv_arg") -> "RuleVariation_515":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_526:
        return self.arg # type: ignore

class Content_301(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "NOGO-bit not set", 1: "NOGO-bit set"}

class RuleContent_301(RuleContentContextFree):
    cv_arg: TypeAlias = Content_301.cv_arg
    cv_content: TypeAlias = Content_301

    @property
    def content(self) -> Content_301:
        return self._get_content() # type: ignore

class Variation_650(Element):
    cv_arg: TypeAlias = RuleContent_301.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_301

    @classmethod
    def create(cls, arg: "Variation_650.cv_arg") -> "Variation_650":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_301:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_301:
        return self.rule.content

class RuleVariation_639(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_650.cv_arg
    cv_variation: TypeAlias = Variation_650

    @classmethod
    def create(cls, arg : "RuleVariation_639.cv_arg") -> "RuleVariation_639":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_650:
        return self.arg # type: ignore

class Content_49(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "CPR Validation correct", 1: "CPR Validation failed"}

class RuleContent_49(RuleContentContextFree):
    cv_arg: TypeAlias = Content_49.cv_arg
    cv_content: TypeAlias = Content_49

    @property
    def content(self) -> Content_49:
        return self._get_content() # type: ignore

class Variation_702(Element):
    cv_arg: TypeAlias = RuleContent_49.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_49

    @classmethod
    def create(cls, arg: "Variation_702.cv_arg") -> "Variation_702":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_49:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_49:
        return self.rule.content

class RuleVariation_691(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_702.cv_arg
    cv_variation: TypeAlias = Variation_702

    @classmethod
    def create(cls, arg : "RuleVariation_691.cv_arg") -> "RuleVariation_691":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_702:
        return self.arg # type: ignore

class Content_249(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "LDPJ not detected", 1: "LDPJ detected"}

class RuleContent_249(RuleContentContextFree):
    cv_arg: TypeAlias = Content_249.cv_arg
    cv_content: TypeAlias = Content_249

    @property
    def content(self) -> Content_249:
        return self._get_content() # type: ignore

class Variation_858(Element):
    cv_arg: TypeAlias = RuleContent_249.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_249

    @classmethod
    def create(cls, arg: "Variation_858.cv_arg") -> "Variation_858":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_249:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_249:
        return self.rule.content

class RuleVariation_828(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_858.cv_arg
    cv_variation: TypeAlias = Variation_858

    @classmethod
    def create(cls, arg : "RuleVariation_828.cv_arg") -> "RuleVariation_828":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_858:
        return self.arg # type: ignore

class Content_144(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Range Check failed"}

class RuleContent_144(RuleContentContextFree):
    cv_arg: TypeAlias = Content_144.cv_arg
    cv_content: TypeAlias = Content_144

    @property
    def content(self) -> Content_144:
        return self._get_content() # type: ignore

class Variation_918(Element):
    cv_arg: TypeAlias = RuleContent_144.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_144

    @classmethod
    def create(cls, arg: "Variation_918.cv_arg") -> "Variation_918":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_144:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_144:
        return self.rule.content

class RuleVariation_888(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_918.cv_arg
    cv_variation: TypeAlias = Variation_918

    @classmethod
    def create(cls, arg : "RuleVariation_888.cv_arg") -> "RuleVariation_888":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_918:
        return self.arg # type: ignore

class NonSpare_644(NonSpare):
    cv_arg: TypeAlias = RuleVariation_122.cv_arg
    cv_name = "ATP"
    cv_title = "Address Type"
    cv_rule: TypeAlias = RuleVariation_122

    @classmethod
    def create(cls, arg : "NonSpare_644.cv_arg") -> "NonSpare_644":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_122:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_122:
        return self.rule.variation

class Item_90(Item):
    cv_arg: TypeAlias = NonSpare_644.cv_arg
    cv_non_spare: TypeAlias = NonSpare_644

    @classmethod
    def create(cls, arg : "Item_90.cv_arg") -> "Item_90":
        return cls._create(arg) # type: ignore

class NonSpare_627(NonSpare):
    cv_arg: TypeAlias = RuleVariation_666.cv_arg
    cv_name = "ARC"
    cv_title = "Altitude Reporting Capability"
    cv_rule: TypeAlias = RuleVariation_666

    @classmethod
    def create(cls, arg : "NonSpare_627.cv_arg") -> "NonSpare_627":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_666:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_677:
        return self.rule.variation

class Item_82(Item):
    cv_arg: TypeAlias = NonSpare_627.cv_arg
    cv_non_spare: TypeAlias = NonSpare_627

    @classmethod
    def create(cls, arg : "Item_82.cv_arg") -> "Item_82":
        return cls._create(arg) # type: ignore

class NonSpare_1553(NonSpare):
    cv_arg: TypeAlias = RuleVariation_805.cv_arg
    cv_name = "RC"
    cv_title = "Range Check"
    cv_rule: TypeAlias = RuleVariation_805

    @classmethod
    def create(cls, arg : "NonSpare_1553.cv_arg") -> "NonSpare_1553":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_805:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_835:
        return self.rule.variation

class Item_781(Item):
    cv_arg: TypeAlias = NonSpare_1553.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1553

    @classmethod
    def create(cls, arg : "Item_781.cv_arg") -> "Item_781":
        return cls._create(arg) # type: ignore

class NonSpare_1542(NonSpare):
    cv_arg: TypeAlias = RuleVariation_919.cv_arg
    cv_name = "RAB"
    cv_title = "Report Type"
    cv_rule: TypeAlias = RuleVariation_919

    @classmethod
    def create(cls, arg : "NonSpare_1542.cv_arg") -> "NonSpare_1542":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_919:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_949:
        return self.rule.variation

class Item_772(Item):
    cv_arg: TypeAlias = NonSpare_1542.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1542

    @classmethod
    def create(cls, arg : "Item_772.cv_arg") -> "Item_772":
        return cls._create(arg) # type: ignore

class NonSpare_1650(NonSpare):
    cv_arg: TypeAlias = RuleVariation_711.cv_arg
    cv_name = "SAA"
    cv_title = "Selected Altitude Available"
    cv_rule: TypeAlias = RuleVariation_711

    @classmethod
    def create(cls, arg : "NonSpare_1650.cv_arg") -> "NonSpare_1650":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_711:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_722:
        return self.rule.variation

class Item_853(Item):
    cv_arg: TypeAlias = NonSpare_1650.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1650

    @classmethod
    def create(cls, arg : "Item_853.cv_arg") -> "Item_853":
        return cls._create(arg) # type: ignore

class NonSpare_742(NonSpare):
    cv_arg: TypeAlias = RuleVariation_853.cv_arg
    cv_name = "CL"
    cv_title = "Confidence Level"
    cv_rule: TypeAlias = RuleVariation_853

    @classmethod
    def create(cls, arg : "NonSpare_742.cv_arg") -> "NonSpare_742":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_853:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_883:
        return self.rule.variation

class Item_161(Item):
    cv_arg: TypeAlias = NonSpare_742.cv_arg
    cv_non_spare: TypeAlias = NonSpare_742

    @classmethod
    def create(cls, arg : "Item_161.cv_arg") -> "Item_161":
        return cls._create(arg) # type: ignore

class NonSpare_1123(NonSpare):
    cv_arg: TypeAlias = RuleVariation_515.cv_arg
    cv_name = "IPC"
    cv_title = "Independent Position Check"
    cv_rule: TypeAlias = RuleVariation_515

    @classmethod
    def create(cls, arg : "NonSpare_1123.cv_arg") -> "NonSpare_1123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_515:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_526:
        return self.rule.variation

class Item_437(Item):
    cv_arg: TypeAlias = NonSpare_1123.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1123

    @classmethod
    def create(cls, arg : "Item_437.cv_arg") -> "Item_437":
        return cls._create(arg) # type: ignore

class NonSpare_1366(NonSpare):
    cv_arg: TypeAlias = RuleVariation_639.cv_arg
    cv_name = "NOGO"
    cv_title = "No-go Bit Status"
    cv_rule: TypeAlias = RuleVariation_639

    @classmethod
    def create(cls, arg : "NonSpare_1366.cv_arg") -> "NonSpare_1366":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_639:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_650:
        return self.rule.variation

class Item_626(Item):
    cv_arg: TypeAlias = NonSpare_1366.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1366

    @classmethod
    def create(cls, arg : "Item_626.cv_arg") -> "Item_626":
        return cls._create(arg) # type: ignore

class NonSpare_823(NonSpare):
    cv_arg: TypeAlias = RuleVariation_691.cv_arg
    cv_name = "CPR"
    cv_title = "Compact Position Reporting"
    cv_rule: TypeAlias = RuleVariation_691

    @classmethod
    def create(cls, arg : "NonSpare_823.cv_arg") -> "NonSpare_823":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_691:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_702:
        return self.rule.variation

class Item_211(Item):
    cv_arg: TypeAlias = NonSpare_823.cv_arg
    cv_non_spare: TypeAlias = NonSpare_823

    @classmethod
    def create(cls, arg : "Item_211.cv_arg") -> "Item_211":
        return cls._create(arg) # type: ignore

class NonSpare_1166(NonSpare):
    cv_arg: TypeAlias = RuleVariation_828.cv_arg
    cv_name = "LDPJ"
    cv_title = "Local Decoding Position Jump"
    cv_rule: TypeAlias = RuleVariation_828

    @classmethod
    def create(cls, arg : "NonSpare_1166.cv_arg") -> "NonSpare_1166":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_828:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_858:
        return self.rule.variation

class Item_477(Item):
    cv_arg: TypeAlias = NonSpare_1166.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1166

    @classmethod
    def create(cls, arg : "Item_477.cv_arg") -> "Item_477":
        return cls._create(arg) # type: ignore

class NonSpare_1557(NonSpare):
    cv_arg: TypeAlias = RuleVariation_888.cv_arg
    cv_name = "RCF"
    cv_title = "Range Check"
    cv_rule: TypeAlias = RuleVariation_888

    @classmethod
    def create(cls, arg : "NonSpare_1557.cv_arg") -> "NonSpare_1557":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_888:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_918:
        return self.rule.variation

class Item_785(Item):
    cv_arg: TypeAlias = NonSpare_1557.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1557

    @classmethod
    def create(cls, arg : "Item_785.cv_arg") -> "Item_785":
        return cls._create(arg) # type: ignore

class Variation_1349(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_122.cv_arg, Tuple[Literal["ATP"], RuleVariation_122.cv_arg]], Union[RuleVariation_666.cv_arg, Tuple[Literal["ARC"], RuleVariation_666.cv_arg]], Union[RuleVariation_805.cv_arg, Tuple[Literal["RC"], RuleVariation_805.cv_arg]], Union[RuleVariation_919.cv_arg, Tuple[Literal["RAB"], RuleVariation_919.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_61.cv_arg, Tuple[Literal["DCR"], RuleVariation_61.cv_arg]], Union[RuleVariation_418.cv_arg, Tuple[Literal["GBS"], RuleVariation_418.cv_arg]], Union[RuleVariation_497.cv_arg, Tuple[Literal["SIM"], RuleVariation_497.cv_arg]], Union[RuleVariation_622.cv_arg, Tuple[Literal["TST"], RuleVariation_622.cv_arg]], Union[RuleVariation_711.cv_arg, Tuple[Literal["SAA"], RuleVariation_711.cv_arg]], Union[RuleVariation_853.cv_arg, Tuple[Literal["CL"], RuleVariation_853.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_515.cv_arg, Tuple[Literal["IPC"], RuleVariation_515.cv_arg]], Union[RuleVariation_639.cv_arg, Tuple[Literal["NOGO"], RuleVariation_639.cv_arg]], Union[RuleVariation_691.cv_arg, Tuple[Literal["CPR"], RuleVariation_691.cv_arg]], Union[RuleVariation_828.cv_arg, Tuple[Literal["LDPJ"], RuleVariation_828.cv_arg]], Union[RuleVariation_888.cv_arg, Tuple[Literal["RCF"], RuleVariation_888.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1349.cv_arg_group_1"],
        Tuple["Variation_1349.cv_arg_group_1", "Variation_1349.cv_arg_group_2"],
        Tuple["Variation_1349.cv_arg_group_1", "Variation_1349.cv_arg_group_2", "Variation_1349.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_90, 3), (Item_82, 2), (Item_781, 1), (Item_772, 1), None], [(Item_254, 1), (Item_369, 1), (Item_903, 1), (Item_1056, 1), (Item_853, 1), (Item_161, 2), None], [(Item_1, 2), (Item_437, 1), (Item_626, 1), (Item_211, 1), (Item_477, 1), (Item_785, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1349.cv_arg") -> 'Variation_1349':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_122:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_666:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_805:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_919:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> Optional[RuleVariation_61]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_418]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_497]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_622]:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> Optional[RuleVariation_711]:
        ...
    @overload
    def get_item(self, key : Literal["CL"]) -> Optional[RuleVariation_853]:
        ...
    @overload
    def get_item(self, key : Literal["IPC"]) -> Optional[RuleVariation_515]:
        ...
    @overload
    def get_item(self, key : Literal["NOGO"]) -> Optional[RuleVariation_639]:
        ...
    @overload
    def get_item(self, key : Literal["CPR"]) -> Optional[RuleVariation_691]:
        ...
    @overload
    def get_item(self, key : Literal["LDPJ"]) -> Optional[RuleVariation_828]:
        ...
    @overload
    def get_item(self, key : Literal["RCF"]) -> Optional[RuleVariation_888]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1270(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1349.cv_arg
    cv_variation: TypeAlias = Variation_1349

    @classmethod
    def create(cls, arg : "RuleVariation_1270.cv_arg") -> "RuleVariation_1270":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1349:
        return self.arg # type: ignore

class NonSpare_148(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1270.cv_arg
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1270

    @classmethod
    def create(cls, arg : "NonSpare_148.cv_arg") -> "NonSpare_148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1270:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1349:
        return self.rule.variation

class UapItem_148(UapItem):
    cv_non_spare: TypeAlias = NonSpare_148

class NonSpare_1923(NonSpare):
    cv_arg: TypeAlias = RuleVariation_778.cv_arg
    cv_name = "TRNUM"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_778

    @classmethod
    def create(cls, arg : "NonSpare_1923.cv_arg") -> "NonSpare_1923":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_778:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_808:
        return self.rule.variation

class Item_1041(Item):
    cv_arg: TypeAlias = NonSpare_1923.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1923

    @classmethod
    def create(cls, arg : "Item_1041.cv_arg") -> "Item_1041":
        return cls._create(arg) # type: ignore

class Variation_1036(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_778.cv_arg, Tuple[Literal["TRNUM"], RuleVariation_778.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1036.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_1041, 12)]
    cv_items_dict = {"TRNUM": RuleVariation_778}

    @classmethod
    def spec(cls, key : Literal["TRNUM"]) -> RuleVariation_778:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TRNUM"]) -> RuleVariation_778:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1036.cv_arg") -> 'Variation_1036':
        return cls._create(arg) # type: ignore

class RuleVariation_1004(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1036.cv_arg
    cv_variation: TypeAlias = Variation_1036

    @classmethod
    def create(cls, arg : "RuleVariation_1004.cv_arg") -> "RuleVariation_1004":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1036:
        return self.arg # type: ignore

class NonSpare_365(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1004.cv_arg
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_1004

    @classmethod
    def create(cls, arg : "NonSpare_365.cv_arg") -> "NonSpare_365":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1004:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1036:
        return self.rule.variation

class UapItem_365(UapItem):
    cv_non_spare: TypeAlias = NonSpare_365

class NonSpare_64(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_64.cv_arg") -> "NonSpare_64":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_64(UapItem):
    cv_non_spare: TypeAlias = NonSpare_64

class NonSpare_222(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "071"
    cv_title = "Time of Applicability for Position"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_222.cv_arg") -> "NonSpare_222":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_222(UapItem):
    cv_non_spare: TypeAlias = NonSpare_222

class NonSpare_310(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1082.cv_arg
    cv_name = "130"
    cv_title = "Position in WGS-84 Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1082

    @classmethod
    def create(cls, arg : "NonSpare_310.cv_arg") -> "NonSpare_310":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1082:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1126:
        return self.rule.variation

class UapItem_310(UapItem):
    cv_non_spare: TypeAlias = NonSpare_310

class NonSpare_315(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1085.cv_arg
    cv_name = "131"
    cv_title = "High-Resolution Position in WGS-84 Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1085

    @classmethod
    def create(cls, arg : "NonSpare_315.cv_arg") -> "NonSpare_315":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1085:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1129:
        return self.rule.variation

class UapItem_315(UapItem):
    cv_non_spare: TypeAlias = NonSpare_315

class NonSpare_223(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "072"
    cv_title = "Time of Applicability for Velocity"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_223.cv_arg") -> "NonSpare_223":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_223(UapItem):
    cv_non_spare: TypeAlias = NonSpare_223

class Content_560(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Value in defined range", 1: "Value exceeds defined range"}

class RuleContent_560(RuleContentContextFree):
    cv_arg: TypeAlias = Content_560.cv_arg
    cv_content: TypeAlias = Content_560

    @property
    def content(self) -> Content_560:
        return self._get_content() # type: ignore

class Variation_96(Element):
    cv_arg: TypeAlias = RuleContent_560.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_560

    @classmethod
    def create(cls, arg: "Variation_96.cv_arg") -> "Variation_96":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_560:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_560:
        return self.rule.content

class RuleVariation_96(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_96.cv_arg
    cv_variation: TypeAlias = Variation_96

    @classmethod
    def create(cls, arg : "RuleVariation_96.cv_arg") -> "RuleVariation_96":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_96:
        return self.arg # type: ignore

class NonSpare_1567(NonSpare):
    cv_arg: TypeAlias = RuleVariation_96.cv_arg
    cv_name = "RE"
    cv_title = "Range Exceeded Indicator"
    cv_rule: TypeAlias = RuleVariation_96

    @classmethod
    def create(cls, arg : "NonSpare_1567.cv_arg") -> "NonSpare_1567":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_96:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_96:
        return self.rule.variation

class Item_793(Item):
    cv_arg: TypeAlias = NonSpare_1567.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1567

    @classmethod
    def create(cls, arg : "Item_793.cv_arg") -> "Item_793":
        return cls._create(arg) # type: ignore

class Variation_502(Element):
    cv_arg: TypeAlias = RuleContent_715.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_715

    @classmethod
    def create(cls, arg: "Variation_502.cv_arg") -> "Variation_502":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_715:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_715:
        return self.rule.content

class RuleVariation_491(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_502.cv_arg
    cv_variation: TypeAlias = Variation_502

    @classmethod
    def create(cls, arg : "RuleVariation_491.cv_arg") -> "RuleVariation_491":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_502:
        return self.arg # type: ignore

class NonSpare_1829(NonSpare):
    cv_arg: TypeAlias = RuleVariation_491.cv_arg
    cv_name = "TAS"
    cv_title = "True Air Speed"
    cv_rule: TypeAlias = RuleVariation_491

    @classmethod
    def create(cls, arg : "NonSpare_1829.cv_arg") -> "NonSpare_1829":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_491:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_502:
        return self.rule.variation

class Item_974(Item):
    cv_arg: TypeAlias = NonSpare_1829.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1829

    @classmethod
    def create(cls, arg : "Item_974.cv_arg") -> "Item_974":
        return cls._create(arg) # type: ignore

class Variation_1175(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_96.cv_arg, Tuple[Literal["RE"], RuleVariation_96.cv_arg]], Union[RuleVariation_491.cv_arg, Tuple[Literal["TAS"], RuleVariation_491.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1175.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_793, 1), (Item_974, 15)]
    cv_items_dict = {"RE": RuleVariation_96, "TAS": RuleVariation_491}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> RuleVariation_491:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["TAS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> RuleVariation_491:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1175.cv_arg") -> 'Variation_1175':
        return cls._create(arg) # type: ignore

class RuleVariation_1126(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1175.cv_arg
    cv_variation: TypeAlias = Variation_1175

    @classmethod
    def create(cls, arg : "RuleVariation_1126.cv_arg") -> "RuleVariation_1126":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1175:
        return self.arg # type: ignore

class NonSpare_350(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1126.cv_arg
    cv_name = "151"
    cv_title = "True Airspeed"
    cv_rule: TypeAlias = RuleVariation_1126

    @classmethod
    def create(cls, arg : "NonSpare_350.cv_arg") -> "NonSpare_350":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1126:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1175:
        return self.rule.variation

class UapItem_350(UapItem):
    cv_non_spare: TypeAlias = NonSpare_350

class NonSpare_224(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "073"
    cv_title = "Time of Message Reception for Position"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_224.cv_arg") -> "NonSpare_224":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_224(UapItem):
    cv_non_spare: TypeAlias = NonSpare_224

class Content_606(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {3: "Reserved", 2: "TOMRp whole seconds = (I021/073) Whole seconds - 1", 1: "TOMRp whole seconds = (I021/073) Whole seconds + 1", 0: "TOMRp whole seconds = (I021/073) Whole seconds"}

class RuleContent_606(RuleContentContextFree):
    cv_arg: TypeAlias = Content_606.cv_arg
    cv_content: TypeAlias = Content_606

    @property
    def content(self) -> Content_606:
        return self._get_content() # type: ignore

class Variation_119(Element):
    cv_arg: TypeAlias = RuleContent_606.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_606

    @classmethod
    def create(cls, arg: "Variation_119.cv_arg") -> "Variation_119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_606:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_606:
        return self.rule.content

class RuleVariation_119(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_119.cv_arg
    cv_variation: TypeAlias = Variation_119

    @classmethod
    def create(cls, arg : "RuleVariation_119.cv_arg") -> "RuleVariation_119":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_119:
        return self.arg # type: ignore

class NonSpare_1000(NonSpare):
    cv_arg: TypeAlias = RuleVariation_119.cv_arg
    cv_name = "FSI"
    cv_title = "Full Second Indication"
    cv_rule: TypeAlias = RuleVariation_119

    @classmethod
    def create(cls, arg : "NonSpare_1000.cv_arg") -> "NonSpare_1000":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_119:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_119:
        return self.rule.variation

class Item_348(Item):
    cv_arg: TypeAlias = NonSpare_1000.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1000

    @classmethod
    def create(cls, arg : "Item_348.cv_arg") -> "Item_348":
        return cls._create(arg) # type: ignore

class Content_781(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 9.313225746154785e-10
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_780(RuleContentContextFree):
    cv_arg: TypeAlias = Content_781.cv_arg
    cv_content: TypeAlias = Content_781

    @property
    def content(self) -> Content_781:
        return self._get_content() # type: ignore

class Variation_613(Element):
    cv_arg: TypeAlias = RuleContent_780.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 30
    cv_rule = RuleContent_780

    @classmethod
    def create(cls, arg: "Variation_613.cv_arg") -> "Variation_613":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_780:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_781:
        return self.rule.content

class RuleVariation_602(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_613.cv_arg
    cv_variation: TypeAlias = Variation_613

    @classmethod
    def create(cls, arg : "RuleVariation_602.cv_arg") -> "RuleVariation_602":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_613:
        return self.arg # type: ignore

class NonSpare_1885(NonSpare):
    cv_arg: TypeAlias = RuleVariation_602.cv_arg
    cv_name = "TOMRP"
    cv_title = "Fractional Part of the Time of Message Reception for Position in the Ground Station"
    cv_rule: TypeAlias = RuleVariation_602

    @classmethod
    def create(cls, arg : "NonSpare_1885.cv_arg") -> "NonSpare_1885":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_602:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_613:
        return self.rule.variation

class Item_1010(Item):
    cv_arg: TypeAlias = NonSpare_1885.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1885

    @classmethod
    def create(cls, arg : "Item_1010.cv_arg") -> "Item_1010":
        return cls._create(arg) # type: ignore

class Variation_1106(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_119.cv_arg, Tuple[Literal["FSI"], RuleVariation_119.cv_arg]], Union[RuleVariation_602.cv_arg, Tuple[Literal["TOMRP"], RuleVariation_602.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1106.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_348, 2), (Item_1010, 30)]
    cv_items_dict = {"FSI": RuleVariation_119, "TOMRP": RuleVariation_602}

    @overload
    @classmethod
    def spec(cls, key : Literal["FSI"]) -> RuleVariation_119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOMRP"]) -> RuleVariation_602:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FSI"], Literal["TOMRP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FSI"]) -> RuleVariation_119:
        ...
    @overload
    def get_item(self, key : Literal["TOMRP"]) -> RuleVariation_602:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1106.cv_arg") -> 'Variation_1106':
        return cls._create(arg) # type: ignore

class RuleVariation_1064(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1106.cv_arg
    cv_variation: TypeAlias = Variation_1106

    @classmethod
    def create(cls, arg : "RuleVariation_1064.cv_arg") -> "RuleVariation_1064":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1106:
        return self.arg # type: ignore

class NonSpare_226(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1064.cv_arg
    cv_name = "074"
    cv_title = "Time of Message Reception of Position-High Precision"
    cv_rule: TypeAlias = RuleVariation_1064

    @classmethod
    def create(cls, arg : "NonSpare_226.cv_arg") -> "NonSpare_226":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1064:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1106:
        return self.rule.variation

class UapItem_226(UapItem):
    cv_non_spare: TypeAlias = NonSpare_226

class NonSpare_227(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "075"
    cv_title = "Time of Message Reception for Velocity"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_227.cv_arg") -> "NonSpare_227":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_227(UapItem):
    cv_non_spare: TypeAlias = NonSpare_227

class Content_607(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {3: "Reserved", 2: "TOMRp whole seconds = (I021/075) Whole seconds - 1", 1: "TOMRp whole seconds = (I021/075) Whole seconds + 1", 0: "TOMRp whole seconds = (I021/075) Whole seconds"}

class RuleContent_607(RuleContentContextFree):
    cv_arg: TypeAlias = Content_607.cv_arg
    cv_content: TypeAlias = Content_607

    @property
    def content(self) -> Content_607:
        return self._get_content() # type: ignore

class Variation_120(Element):
    cv_arg: TypeAlias = RuleContent_607.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_607

    @classmethod
    def create(cls, arg: "Variation_120.cv_arg") -> "Variation_120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_607:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_607:
        return self.rule.content

class RuleVariation_120(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_120.cv_arg
    cv_variation: TypeAlias = Variation_120

    @classmethod
    def create(cls, arg : "RuleVariation_120.cv_arg") -> "RuleVariation_120":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_120:
        return self.arg # type: ignore

class NonSpare_1001(NonSpare):
    cv_arg: TypeAlias = RuleVariation_120.cv_arg
    cv_name = "FSI"
    cv_title = "Full Second Indication"
    cv_rule: TypeAlias = RuleVariation_120

    @classmethod
    def create(cls, arg : "NonSpare_1001.cv_arg") -> "NonSpare_1001":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_120:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_120:
        return self.rule.variation

class Item_349(Item):
    cv_arg: TypeAlias = NonSpare_1001.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1001

    @classmethod
    def create(cls, arg : "Item_349.cv_arg") -> "Item_349":
        return cls._create(arg) # type: ignore

class Variation_1107(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_120.cv_arg, Tuple[Literal["FSI"], RuleVariation_120.cv_arg]], Union[RuleVariation_602.cv_arg, Tuple[Literal["TOMRP"], RuleVariation_602.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1107.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_349, 2), (Item_1010, 30)]
    cv_items_dict = {"FSI": RuleVariation_120, "TOMRP": RuleVariation_602}

    @overload
    @classmethod
    def spec(cls, key : Literal["FSI"]) -> RuleVariation_120:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOMRP"]) -> RuleVariation_602:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FSI"], Literal["TOMRP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FSI"]) -> RuleVariation_120:
        ...
    @overload
    def get_item(self, key : Literal["TOMRP"]) -> RuleVariation_602:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1107.cv_arg") -> 'Variation_1107':
        return cls._create(arg) # type: ignore

class RuleVariation_1065(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1107.cv_arg
    cv_variation: TypeAlias = Variation_1107

    @classmethod
    def create(cls, arg : "RuleVariation_1065.cv_arg") -> "RuleVariation_1065":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1107:
        return self.arg # type: ignore

class NonSpare_229(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1065.cv_arg
    cv_name = "076"
    cv_title = "Time of Message Reception of Velocity-High Precision"
    cv_rule: TypeAlias = RuleVariation_1065

    @classmethod
    def create(cls, arg : "NonSpare_229.cv_arg") -> "NonSpare_229":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1065:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1107:
        return self.rule.variation

class UapItem_229(UapItem):
    cv_non_spare: TypeAlias = NonSpare_229

class NonSpare_324(NonSpare):
    cv_arg: TypeAlias = RuleVariation_284.cv_arg
    cv_name = "140"
    cv_title = "Geometric Height"
    cv_rule: TypeAlias = RuleVariation_284

    @classmethod
    def create(cls, arg : "NonSpare_324.cv_arg") -> "NonSpare_324":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_291:
        return self.rule.variation

class UapItem_324(UapItem):
    cv_non_spare: TypeAlias = NonSpare_324

class Variation_121(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_121.cv_arg") -> "Variation_121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_121(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_121.cv_arg
    cv_variation: TypeAlias = Variation_121

    @classmethod
    def create(cls, arg : "RuleVariation_121.cv_arg") -> "RuleVariation_121":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_121:
        return self.arg # type: ignore

class Variation_691(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_691.cv_arg") -> "Variation_691":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_680(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_691.cv_arg
    cv_variation: TypeAlias = Variation_691

    @classmethod
    def create(cls, arg : "RuleVariation_680.cv_arg") -> "RuleVariation_680":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_691:
        return self.arg # type: ignore

class Variation_0(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_0.cv_arg") -> "Variation_0":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_0(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_0.cv_arg
    cv_variation: TypeAlias = Variation_0

    @classmethod
    def create(cls, arg : "RuleVariation_0.cv_arg") -> "RuleVariation_0":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_0:
        return self.arg # type: ignore

class Variation_465(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_465.cv_arg") -> "Variation_465":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_454(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_465.cv_arg
    cv_variation: TypeAlias = Variation_465

    @classmethod
    def create(cls, arg : "RuleVariation_454.cv_arg") -> "RuleVariation_454":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_465:
        return self.arg # type: ignore

class Content_266(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Measured per flight-hour", 1: "Measured per sample"}

class RuleContent_266(RuleContentContextFree):
    cv_arg: TypeAlias = Content_266.cv_arg
    cv_content: TypeAlias = Content_266

    @property
    def content(self) -> Content_266:
        return self._get_content() # type: ignore

class Variation_542(Element):
    cv_arg: TypeAlias = RuleContent_266.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_266

    @classmethod
    def create(cls, arg: "Variation_542.cv_arg") -> "Variation_542":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_266:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_266:
        return self.rule.content

class RuleVariation_531(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_542.cv_arg
    cv_variation: TypeAlias = Variation_542

    @classmethod
    def create(cls, arg : "RuleVariation_531.cv_arg") -> "RuleVariation_531":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_542:
        return self.arg # type: ignore

class Variation_676(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_676.cv_arg") -> "Variation_676":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_665(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_676.cv_arg
    cv_variation: TypeAlias = Variation_676

    @classmethod
    def create(cls, arg : "RuleVariation_665.cv_arg") -> "RuleVariation_665":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_676:
        return self.arg # type: ignore

class Variation_877(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_877.cv_arg") -> "Variation_877":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_847(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_877.cv_arg
    cv_variation: TypeAlias = Variation_877

    @classmethod
    def create(cls, arg : "RuleVariation_847.cv_arg") -> "RuleVariation_847":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_877:
        return self.arg # type: ignore

class NonSpare_1386(NonSpare):
    cv_arg: TypeAlias = RuleVariation_121.cv_arg
    cv_name = "NUCRNACV"
    cv_title = "Navigation Uncertainty Category for Velocity NUCr or the Navigation Accuracy Category for Velocity NACv"
    cv_rule: TypeAlias = RuleVariation_121

    @classmethod
    def create(cls, arg : "NonSpare_1386.cv_arg") -> "NonSpare_1386":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_121:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_121:
        return self.rule.variation

class Item_645(Item):
    cv_arg: TypeAlias = NonSpare_1386.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1386

    @classmethod
    def create(cls, arg : "Item_645.cv_arg") -> "Item_645":
        return cls._create(arg) # type: ignore

class NonSpare_1385(NonSpare):
    cv_arg: TypeAlias = RuleVariation_680.cv_arg
    cv_name = "NUCPNIC"
    cv_title = "Navigation Uncertainty Category for Position NUCp or Navigation Integrity Category NIC"
    cv_rule: TypeAlias = RuleVariation_680

    @classmethod
    def create(cls, arg : "NonSpare_1385.cv_arg") -> "NonSpare_1385":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_680:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_691:
        return self.rule.variation

class Item_644(Item):
    cv_arg: TypeAlias = NonSpare_1385.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1385

    @classmethod
    def create(cls, arg : "Item_644.cv_arg") -> "Item_644":
        return cls._create(arg) # type: ignore

class NonSpare_1359(NonSpare):
    cv_arg: TypeAlias = RuleVariation_0.cv_arg
    cv_name = "NICBARO"
    cv_title = "Navigation Integrity Category for Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_0

    @classmethod
    def create(cls, arg : "NonSpare_1359.cv_arg") -> "NonSpare_1359":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_0:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_0:
        return self.rule.variation

class Item_619(Item):
    cv_arg: TypeAlias = NonSpare_1359.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1359

    @classmethod
    def create(cls, arg : "Item_619.cv_arg") -> "Item_619":
        return cls._create(arg) # type: ignore

class NonSpare_1720(NonSpare):
    cv_arg: TypeAlias = RuleVariation_454.cv_arg
    cv_name = "SIL"
    cv_title = "Surveillance (version 1) or Source (version 2) Integrity Level"
    cv_rule: TypeAlias = RuleVariation_454

    @classmethod
    def create(cls, arg : "NonSpare_1720.cv_arg") -> "NonSpare_1720":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_454:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_465:
        return self.rule.variation

class Item_895(Item):
    cv_arg: TypeAlias = NonSpare_1720.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1720

    @classmethod
    def create(cls, arg : "Item_895.cv_arg") -> "Item_895":
        return cls._create(arg) # type: ignore

class NonSpare_1342(NonSpare):
    cv_arg: TypeAlias = RuleVariation_680.cv_arg
    cv_name = "NACP"
    cv_title = "Navigation Accuracy Category for Position"
    cv_rule: TypeAlias = RuleVariation_680

    @classmethod
    def create(cls, arg : "NonSpare_1342.cv_arg") -> "NonSpare_1342":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_680:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_691:
        return self.rule.variation

class Item_604(Item):
    cv_arg: TypeAlias = NonSpare_1342.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1342

    @classmethod
    def create(cls, arg : "Item_604.cv_arg") -> "Item_604":
        return cls._create(arg) # type: ignore

class NonSpare_1721(NonSpare):
    cv_arg: TypeAlias = RuleVariation_531.cv_arg
    cv_name = "SILS"
    cv_title = "SIL-Supplement"
    cv_rule: TypeAlias = RuleVariation_531

    @classmethod
    def create(cls, arg : "NonSpare_1721.cv_arg") -> "NonSpare_1721":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_531:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_542:
        return self.rule.variation

class Item_896(Item):
    cv_arg: TypeAlias = NonSpare_1721.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1721

    @classmethod
    def create(cls, arg : "Item_896.cv_arg") -> "Item_896":
        return cls._create(arg) # type: ignore

class NonSpare_1673(NonSpare):
    cv_arg: TypeAlias = RuleVariation_665.cv_arg
    cv_name = "SDA"
    cv_title = "Horizontal Position System Design Assurance Level (as Defined in Version 2)"
    cv_rule: TypeAlias = RuleVariation_665

    @classmethod
    def create(cls, arg : "NonSpare_1673.cv_arg") -> "NonSpare_1673":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_665:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_676:
        return self.rule.variation

class Item_867(Item):
    cv_arg: TypeAlias = NonSpare_1673.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1673

    @classmethod
    def create(cls, arg : "Item_867.cv_arg") -> "Item_867":
        return cls._create(arg) # type: ignore

class NonSpare_1048(NonSpare):
    cv_arg: TypeAlias = RuleVariation_847.cv_arg
    cv_name = "GVA"
    cv_title = "Geometric Altitude Accuracy"
    cv_rule: TypeAlias = RuleVariation_847

    @classmethod
    def create(cls, arg : "NonSpare_1048.cv_arg") -> "NonSpare_1048":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_847:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_877:
        return self.rule.variation

class Item_380(Item):
    cv_arg: TypeAlias = NonSpare_1048.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1048

    @classmethod
    def create(cls, arg : "Item_380.cv_arg") -> "Item_380":
        return cls._create(arg) # type: ignore

class NonSpare_1428(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "PIC"
    cv_title = "Position Integrity Category"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_1428.cv_arg") -> "NonSpare_1428":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_682(Item):
    cv_arg: TypeAlias = NonSpare_1428.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1428

    @classmethod
    def create(cls, arg : "Item_682.cv_arg") -> "Item_682":
        return cls._create(arg) # type: ignore

class Variation_1377(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_121.cv_arg, Tuple[Literal["NUCRNACV"], RuleVariation_121.cv_arg]], Union[RuleVariation_680.cv_arg, Tuple[Literal["NUCPNIC"], RuleVariation_680.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_0.cv_arg, Tuple[Literal["NICBARO"], RuleVariation_0.cv_arg]], Union[RuleVariation_454.cv_arg, Tuple[Literal["SIL"], RuleVariation_454.cv_arg]], Union[RuleVariation_680.cv_arg, Tuple[Literal["NACP"], RuleVariation_680.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_531.cv_arg, Tuple[Literal["SILS"], RuleVariation_531.cv_arg]], Union[RuleVariation_665.cv_arg, Tuple[Literal["SDA"], RuleVariation_665.cv_arg]], Union[RuleVariation_847.cv_arg, Tuple[Literal["GVA"], RuleVariation_847.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["PIC"], RuleVariation_132.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1377.cv_arg_group_1"],
        Tuple["Variation_1377.cv_arg_group_1", "Variation_1377.cv_arg_group_2"],
        Tuple["Variation_1377.cv_arg_group_1", "Variation_1377.cv_arg_group_2", "Variation_1377.cv_arg_group_3"],
        Tuple["Variation_1377.cv_arg_group_1", "Variation_1377.cv_arg_group_2", "Variation_1377.cv_arg_group_3", "Variation_1377.cv_arg_group_4"],
    ]
    cv_items_list = [[(Item_645, 3), (Item_644, 4), None], [(Item_619, 1), (Item_895, 2), (Item_604, 4), None], [(Item_1, 2), (Item_896, 1), (Item_867, 2), (Item_380, 2), None], [(Item_682, 4), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1377.cv_arg") -> 'Variation_1377':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NUCRNACV"]) -> RuleVariation_121:
        ...
    @overload
    def get_item(self, key : Literal["NUCPNIC"]) -> RuleVariation_680:
        ...
    @overload
    def get_item(self, key : Literal["NICBARO"]) -> Optional[RuleVariation_0]:
        ...
    @overload
    def get_item(self, key : Literal["SIL"]) -> Optional[RuleVariation_454]:
        ...
    @overload
    def get_item(self, key : Literal["NACP"]) -> Optional[RuleVariation_680]:
        ...
    @overload
    def get_item(self, key : Literal["SILS"]) -> Optional[RuleVariation_531]:
        ...
    @overload
    def get_item(self, key : Literal["SDA"]) -> Optional[RuleVariation_665]:
        ...
    @overload
    def get_item(self, key : Literal["GVA"]) -> Optional[RuleVariation_847]:
        ...
    @overload
    def get_item(self, key : Literal["PIC"]) -> Optional[RuleVariation_132]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1298(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1377.cv_arg
    cv_variation: TypeAlias = Variation_1377

    @classmethod
    def create(cls, arg : "RuleVariation_1298.cv_arg") -> "RuleVariation_1298":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1377:
        return self.arg # type: ignore

class NonSpare_255(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1298.cv_arg
    cv_name = "090"
    cv_title = "Quality Indicators"
    cv_rule: TypeAlias = RuleVariation_1298

    @classmethod
    def create(cls, arg : "NonSpare_255.cv_arg") -> "NonSpare_255":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1298:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1377:
        return self.rule.variation

class UapItem_255(UapItem):
    cv_non_spare: TypeAlias = NonSpare_255

class Content_490(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "The MOPS Version is supported by the GS", 1: "The MOPS Version is not supported by the GS"}

class RuleContent_490(RuleContentContextFree):
    cv_arg: TypeAlias = Content_490.cv_arg
    cv_content: TypeAlias = Content_490

    @property
    def content(self) -> Content_490:
        return self._get_content() # type: ignore

class Variation_455(Element):
    cv_arg: TypeAlias = RuleContent_490.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_490

    @classmethod
    def create(cls, arg: "Variation_455.cv_arg") -> "Variation_455":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_490:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_490:
        return self.rule.content

class RuleVariation_444(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_455.cv_arg
    cv_variation: TypeAlias = Variation_455

    @classmethod
    def create(cls, arg : "RuleVariation_444.cv_arg") -> "RuleVariation_444":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_455:
        return self.arg # type: ignore

class NonSpare_2037(NonSpare):
    cv_arg: TypeAlias = RuleVariation_444.cv_arg
    cv_name = "VNS"
    cv_title = "Version Not Supported"
    cv_rule: TypeAlias = RuleVariation_444

    @classmethod
    def create(cls, arg : "NonSpare_2037.cv_arg") -> "NonSpare_2037":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_444:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_455:
        return self.rule.variation

class Item_1146(Item):
    cv_arg: TypeAlias = NonSpare_2037.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2037

    @classmethod
    def create(cls, arg : "Item_1146.cv_arg") -> "Item_1146":
        return cls._create(arg) # type: ignore

class Content_202(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "ED102/DO-260 [Ref. 8]", 1: "DO-260A [Ref. 9]", 2: "ED102A/DO-260B [Ref. 11]"}

class RuleContent_202(RuleContentContextFree):
    cv_arg: TypeAlias = Content_202.cv_arg
    cv_content: TypeAlias = Content_202

    @property
    def content(self) -> Content_202:
        return self._get_content() # type: ignore

class Variation_599(Element):
    cv_arg: TypeAlias = RuleContent_202.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_202

    @classmethod
    def create(cls, arg: "Variation_599.cv_arg") -> "Variation_599":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_202:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_202:
        return self.rule.content

class RuleVariation_588(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_599.cv_arg
    cv_variation: TypeAlias = Variation_599

    @classmethod
    def create(cls, arg : "RuleVariation_588.cv_arg") -> "RuleVariation_588":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_599:
        return self.arg # type: ignore

class NonSpare_2035(NonSpare):
    cv_arg: TypeAlias = RuleVariation_588.cv_arg
    cv_name = "VN"
    cv_title = "Version Number"
    cv_rule: TypeAlias = RuleVariation_588

    @classmethod
    def create(cls, arg : "NonSpare_2035.cv_arg") -> "NonSpare_2035":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_588:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_599:
        return self.rule.variation

class Item_1144(Item):
    cv_arg: TypeAlias = NonSpare_2035.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2035

    @classmethod
    def create(cls, arg : "Item_1144.cv_arg") -> "Item_1144":
        return cls._create(arg) # type: ignore

class Content_415(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Other", 1: "UAT", 2: "1090 ES", 3: "VDL 4", 4: "Not assigned", 5: "Not assigned", 6: "Not assigned", 7: "Not assigned"}

class RuleContent_415(RuleContentContextFree):
    cv_arg: TypeAlias = Content_415.cv_arg
    cv_content: TypeAlias = Content_415

    @property
    def content(self) -> Content_415:
        return self._get_content() # type: ignore

class Variation_892(Element):
    cv_arg: TypeAlias = RuleContent_415.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_415

    @classmethod
    def create(cls, arg: "Variation_892.cv_arg") -> "Variation_892":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_415:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_415:
        return self.rule.content

class RuleVariation_862(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_892.cv_arg
    cv_variation: TypeAlias = Variation_892

    @classmethod
    def create(cls, arg : "RuleVariation_862.cv_arg") -> "RuleVariation_862":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_892:
        return self.arg # type: ignore

class NonSpare_1201(NonSpare):
    cv_arg: TypeAlias = RuleVariation_862.cv_arg
    cv_name = "LTT"
    cv_title = "Link Technology Type"
    cv_rule: TypeAlias = RuleVariation_862

    @classmethod
    def create(cls, arg : "NonSpare_1201.cv_arg") -> "NonSpare_1201":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_862:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_892:
        return self.rule.variation

class Item_509(Item):
    cv_arg: TypeAlias = NonSpare_1201.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1201

    @classmethod
    def create(cls, arg : "Item_509.cv_arg") -> "Item_509":
        return cls._create(arg) # type: ignore

class Variation_1003(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_444.cv_arg, Tuple[Literal["VNS"], RuleVariation_444.cv_arg]], Union[RuleVariation_588.cv_arg, Tuple[Literal["VN"], RuleVariation_588.cv_arg]], Union[RuleVariation_862.cv_arg, Tuple[Literal["LTT"], RuleVariation_862.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1003.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_1146, 1), (Item_1144, 3), (Item_509, 3)]
    cv_items_dict = {"VNS": RuleVariation_444, "VN": RuleVariation_588, "LTT": RuleVariation_862}

    @overload
    @classmethod
    def spec(cls, key : Literal["VNS"]) -> RuleVariation_444:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_588:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTT"]) -> RuleVariation_862:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VNS"], Literal["VN"], Literal["LTT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VNS"]) -> RuleVariation_444:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_588:
        ...
    @overload
    def get_item(self, key : Literal["LTT"]) -> RuleVariation_862:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1003.cv_arg") -> 'Variation_1003':
        return cls._create(arg) # type: ignore

class RuleVariation_973(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1003.cv_arg
    cv_variation: TypeAlias = Variation_1003

    @classmethod
    def create(cls, arg : "RuleVariation_973.cv_arg") -> "RuleVariation_973":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1003:
        return self.arg # type: ignore

class NonSpare_414(NonSpare):
    cv_arg: TypeAlias = RuleVariation_973.cv_arg
    cv_name = "210"
    cv_title = "MOPS Version"
    cv_rule: TypeAlias = RuleVariation_973

    @classmethod
    def create(cls, arg : "NonSpare_414.cv_arg") -> "NonSpare_414":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_973:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1003:
        return self.rule.variation

class UapItem_414(UapItem):
    cv_non_spare: TypeAlias = NonSpare_414

class Variation_1029(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1029.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_575, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1029.cv_arg") -> 'Variation_1029':
        return cls._create(arg) # type: ignore

class RuleVariation_998(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1029.cv_arg
    cv_variation: TypeAlias = Variation_1029

    @classmethod
    def create(cls, arg : "RuleVariation_998.cv_arg") -> "RuleVariation_998":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1029:
        return self.arg # type: ignore

class NonSpare_208(NonSpare):
    cv_arg: TypeAlias = RuleVariation_998.cv_arg
    cv_name = "070"
    cv_title = "Mode 3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_998

    @classmethod
    def create(cls, arg : "NonSpare_208.cv_arg") -> "NonSpare_208":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_998:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1029:
        return self.rule.variation

class UapItem_208(UapItem):
    cv_non_spare: TypeAlias = NonSpare_208

class NonSpare_433(NonSpare):
    cv_arg: TypeAlias = RuleVariation_262.cv_arg
    cv_name = "230"
    cv_title = "Roll Angle"
    cv_rule: TypeAlias = RuleVariation_262

    @classmethod
    def create(cls, arg : "NonSpare_433.cv_arg") -> "NonSpare_433":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_269:
        return self.rule.variation

class UapItem_433(UapItem):
    cv_non_spare: TypeAlias = NonSpare_433

class NonSpare_352(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "152"
    cv_title = "Magnetic Heading"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_352.cv_arg") -> "NonSpare_352":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class UapItem_352(UapItem):
    cv_non_spare: TypeAlias = NonSpare_352

class Content_366(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No intent change active", 1: "Intent change flag raised"}

class RuleContent_366(RuleContentContextFree):
    cv_arg: TypeAlias = Content_366.cv_arg
    cv_content: TypeAlias = Content_366

    @property
    def content(self) -> Content_366:
        return self._get_content() # type: ignore

class Variation_62(Element):
    cv_arg: TypeAlias = RuleContent_366.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_366

    @classmethod
    def create(cls, arg: "Variation_62.cv_arg") -> "Variation_62":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_366:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_366:
        return self.rule.content

class RuleVariation_62(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_62.cv_arg
    cv_variation: TypeAlias = Variation_62

    @classmethod
    def create(cls, arg : "RuleVariation_62.cv_arg") -> "RuleVariation_62":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_62:
        return self.arg # type: ignore

class NonSpare_1107(NonSpare):
    cv_arg: TypeAlias = RuleVariation_62.cv_arg
    cv_name = "ICF"
    cv_title = "Intent Change Flag (see Note)"
    cv_rule: TypeAlias = RuleVariation_62

    @classmethod
    def create(cls, arg : "NonSpare_1107.cv_arg") -> "NonSpare_1107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_62:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_62:
        return self.rule.variation

class Item_425(Item):
    cv_arg: TypeAlias = NonSpare_1107.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1107

    @classmethod
    def create(cls, arg : "Item_425.cv_arg") -> "Item_425":
        return cls._create(arg) # type: ignore

class Content_251(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "LNAV Mode engaged", 1: "LNAV Mode not engaged"}

class RuleContent_251(RuleContentContextFree):
    cv_arg: TypeAlias = Content_251.cv_arg
    cv_content: TypeAlias = Content_251

    @property
    def content(self) -> Content_251:
        return self._get_content() # type: ignore

class Variation_434(Element):
    cv_arg: TypeAlias = RuleContent_251.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_251

    @classmethod
    def create(cls, arg: "Variation_434.cv_arg") -> "Variation_434":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_251:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_251:
        return self.rule.content

class RuleVariation_423(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_434.cv_arg
    cv_variation: TypeAlias = Variation_434

    @classmethod
    def create(cls, arg : "RuleVariation_423.cv_arg") -> "RuleVariation_423":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_434:
        return self.arg # type: ignore

class NonSpare_1173(NonSpare):
    cv_arg: TypeAlias = RuleVariation_423.cv_arg
    cv_name = "LNAV"
    cv_title = "LNAV Mode"
    cv_rule: TypeAlias = RuleVariation_423

    @classmethod
    def create(cls, arg : "NonSpare_1173.cv_arg") -> "NonSpare_1173":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_423:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_434:
        return self.rule.variation

class Item_483(Item):
    cv_arg: TypeAlias = NonSpare_1173.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1173

    @classmethod
    def create(cls, arg : "Item_483.cv_arg") -> "Item_483":
        return cls._create(arg) # type: ignore

class Item_11(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 2
    cv_bit_size = 1

class Content_357(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "Lifeguard / medical emergency", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "DOWNED Aircraft"}

class RuleContent_357(RuleContentContextFree):
    cv_arg: TypeAlias = Content_357.cv_arg
    cv_content: TypeAlias = Content_357

    @property
    def content(self) -> Content_357:
        return self._get_content() # type: ignore

class Variation_688(Element):
    cv_arg: TypeAlias = RuleContent_357.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_357

    @classmethod
    def create(cls, arg: "Variation_688.cv_arg") -> "Variation_688":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_357:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_357:
        return self.rule.content

class RuleVariation_677(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_688.cv_arg
    cv_variation: TypeAlias = Variation_688

    @classmethod
    def create(cls, arg : "RuleVariation_677.cv_arg") -> "RuleVariation_677":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_688:
        return self.arg # type: ignore

class NonSpare_1469(NonSpare):
    cv_arg: TypeAlias = RuleVariation_677.cv_arg
    cv_name = "PS"
    cv_title = "Priority Status"
    cv_rule: TypeAlias = RuleVariation_677

    @classmethod
    def create(cls, arg : "NonSpare_1469.cv_arg") -> "NonSpare_1469":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_677:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_688:
        return self.rule.variation

class Item_711(Item):
    cv_arg: TypeAlias = NonSpare_1469.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1469

    @classmethod
    def create(cls, arg : "Item_711.cv_arg") -> "Item_711":
        return cls._create(arg) # type: ignore

class Content_342(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No condition reported", 1: "Permanent Alert (Emergency condition)", 2: "Temporary Alert (change in Mode 3/A Code other than emergency)", 3: "SPI set"}

class RuleContent_342(RuleContentContextFree):
    cv_arg: TypeAlias = Content_342.cv_arg
    cv_content: TypeAlias = Content_342

    @property
    def content(self) -> Content_342:
        return self._get_content() # type: ignore

class Variation_962(Element):
    cv_arg: TypeAlias = RuleContent_342.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_342

    @classmethod
    def create(cls, arg: "Variation_962.cv_arg") -> "Variation_962":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_342:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_342:
        return self.rule.content

class RuleVariation_932(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_962.cv_arg
    cv_variation: TypeAlias = Variation_962

    @classmethod
    def create(cls, arg : "RuleVariation_932.cv_arg") -> "RuleVariation_932":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_962:
        return self.arg # type: ignore

class NonSpare_1755(NonSpare):
    cv_arg: TypeAlias = RuleVariation_932.cv_arg
    cv_name = "SS"
    cv_title = "Surveillance Status"
    cv_rule: TypeAlias = RuleVariation_932

    @classmethod
    def create(cls, arg : "NonSpare_1755.cv_arg") -> "NonSpare_1755":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_932:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_962:
        return self.rule.variation

class Item_925(Item):
    cv_arg: TypeAlias = NonSpare_1755.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1755

    @classmethod
    def create(cls, arg : "Item_925.cv_arg") -> "Item_925":
        return cls._create(arg) # type: ignore

class Variation_1118(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_62.cv_arg, Tuple[Literal["ICF"], RuleVariation_62.cv_arg]], Union[RuleVariation_423.cv_arg, Tuple[Literal["LNAV"], RuleVariation_423.cv_arg]], int, Union[RuleVariation_677.cv_arg, Tuple[Literal["PS"], RuleVariation_677.cv_arg]], Union[RuleVariation_932.cv_arg, Tuple[Literal["SS"], RuleVariation_932.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1118.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_425, 1), (Item_483, 1), (Item_11, 1), (Item_711, 3), (Item_925, 2)]
    cv_items_dict = {"ICF": RuleVariation_62, "LNAV": RuleVariation_423, "PS": RuleVariation_677, "SS": RuleVariation_932}

    @overload
    @classmethod
    def spec(cls, key : Literal["ICF"]) -> RuleVariation_62:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LNAV"]) -> RuleVariation_423:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PS"]) -> RuleVariation_677:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SS"]) -> RuleVariation_932:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ICF"], Literal["LNAV"], Literal["PS"], Literal["SS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ICF"]) -> RuleVariation_62:
        ...
    @overload
    def get_item(self, key : Literal["LNAV"]) -> RuleVariation_423:
        ...
    @overload
    def get_item(self, key : Literal["PS"]) -> RuleVariation_677:
        ...
    @overload
    def get_item(self, key : Literal["SS"]) -> RuleVariation_932:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1118.cv_arg") -> 'Variation_1118':
        return cls._create(arg) # type: ignore

class RuleVariation_1075(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1118.cv_arg
    cv_variation: TypeAlias = Variation_1118

    @classmethod
    def create(cls, arg : "RuleVariation_1075.cv_arg") -> "RuleVariation_1075":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1118:
        return self.arg # type: ignore

class NonSpare_399(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1075.cv_arg
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule: TypeAlias = RuleVariation_1075

    @classmethod
    def create(cls, arg : "NonSpare_399.cv_arg") -> "NonSpare_399":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1075:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1118:
        return self.rule.variation

class UapItem_399(UapItem):
    cv_non_spare: TypeAlias = NonSpare_399

class Variation_501(Element):
    cv_arg: TypeAlias = RuleContent_688.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_688

    @classmethod
    def create(cls, arg: "Variation_501.cv_arg") -> "Variation_501":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_688:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_688:
        return self.rule.content

class RuleVariation_490(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_501.cv_arg
    cv_variation: TypeAlias = Variation_501

    @classmethod
    def create(cls, arg : "RuleVariation_490.cv_arg") -> "RuleVariation_490":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_501:
        return self.arg # type: ignore

class NonSpare_697(NonSpare):
    cv_arg: TypeAlias = RuleVariation_490.cv_arg
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_490

    @classmethod
    def create(cls, arg : "NonSpare_697.cv_arg") -> "NonSpare_697":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_490:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_501:
        return self.rule.variation

class Item_131(Item):
    cv_arg: TypeAlias = NonSpare_697.cv_arg
    cv_non_spare: TypeAlias = NonSpare_697

    @classmethod
    def create(cls, arg : "Item_131.cv_arg") -> "Item_131":
        return cls._create(arg) # type: ignore

class Variation_1172(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_96.cv_arg, Tuple[Literal["RE"], RuleVariation_96.cv_arg]], Union[RuleVariation_490.cv_arg, Tuple[Literal["BVR"], RuleVariation_490.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1172.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_793, 1), (Item_131, 15)]
    cv_items_dict = {"RE": RuleVariation_96, "BVR": RuleVariation_490}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> RuleVariation_490:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["BVR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> RuleVariation_490:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1172.cv_arg") -> 'Variation_1172':
        return cls._create(arg) # type: ignore

class RuleVariation_1123(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1172.cv_arg
    cv_variation: TypeAlias = Variation_1172

    @classmethod
    def create(cls, arg : "RuleVariation_1123.cv_arg") -> "RuleVariation_1123":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1172:
        return self.arg # type: ignore

class NonSpare_354(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1123.cv_arg
    cv_name = "155"
    cv_title = "Barometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_1123

    @classmethod
    def create(cls, arg : "NonSpare_354.cv_arg") -> "NonSpare_354":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1123:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1172:
        return self.rule.variation

class UapItem_354(UapItem):
    cv_non_spare: TypeAlias = NonSpare_354

class NonSpare_1050(NonSpare):
    cv_arg: TypeAlias = RuleVariation_490.cv_arg
    cv_name = "GVR"
    cv_title = "Geometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_490

    @classmethod
    def create(cls, arg : "NonSpare_1050.cv_arg") -> "NonSpare_1050":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_490:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_501:
        return self.rule.variation

class Item_381(Item):
    cv_arg: TypeAlias = NonSpare_1050.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1050

    @classmethod
    def create(cls, arg : "Item_381.cv_arg") -> "Item_381":
        return cls._create(arg) # type: ignore

class Variation_1174(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_96.cv_arg, Tuple[Literal["RE"], RuleVariation_96.cv_arg]], Union[RuleVariation_490.cv_arg, Tuple[Literal["GVR"], RuleVariation_490.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1174.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_793, 1), (Item_381, 15)]
    cv_items_dict = {"RE": RuleVariation_96, "GVR": RuleVariation_490}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> RuleVariation_490:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["GVR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> RuleVariation_490:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1174.cv_arg") -> 'Variation_1174':
        return cls._create(arg) # type: ignore

class RuleVariation_1125(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1174.cv_arg
    cv_variation: TypeAlias = Variation_1174

    @classmethod
    def create(cls, arg : "RuleVariation_1125.cv_arg") -> "RuleVariation_1125":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1174:
        return self.arg # type: ignore

class NonSpare_356(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1125.cv_arg
    cv_name = "157"
    cv_title = "Geometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_1125

    @classmethod
    def create(cls, arg : "NonSpare_356.cv_arg") -> "NonSpare_356":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1125:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1174:
        return self.rule.variation

class UapItem_356(UapItem):
    cv_non_spare: TypeAlias = NonSpare_356

class Content_779(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_778(RuleContentContextFree):
    cv_arg: TypeAlias = Content_779.cv_arg
    cv_content: TypeAlias = Content_779

    @property
    def content(self) -> Content_779:
        return self._get_content() # type: ignore

class Variation_504(Element):
    cv_arg: TypeAlias = RuleContent_778.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_778

    @classmethod
    def create(cls, arg: "Variation_504.cv_arg") -> "Variation_504":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_778:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_779:
        return self.rule.content

class RuleVariation_493(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_504.cv_arg
    cv_variation: TypeAlias = Variation_504

    @classmethod
    def create(cls, arg : "RuleVariation_493.cv_arg") -> "RuleVariation_493":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_504:
        return self.arg # type: ignore

class NonSpare_1039(NonSpare):
    cv_arg: TypeAlias = RuleVariation_493.cv_arg
    cv_name = "GS"
    cv_title = "Ground Speed Referenced to WGS-84"
    cv_rule: TypeAlias = RuleVariation_493

    @classmethod
    def create(cls, arg : "NonSpare_1039.cv_arg") -> "NonSpare_1039":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_493:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_504:
        return self.rule.variation

class Item_373(Item):
    cv_arg: TypeAlias = NonSpare_1039.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1039

    @classmethod
    def create(cls, arg : "Item_373.cv_arg") -> "Item_373":
        return cls._create(arg) # type: ignore

class NonSpare_1818(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TA"
    cv_title = "Track Angle Clockwise Reference to True North"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1818.cv_arg") -> "NonSpare_1818":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_970(Item):
    cv_arg: TypeAlias = NonSpare_1818.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1818

    @classmethod
    def create(cls, arg : "Item_970.cv_arg") -> "Item_970":
        return cls._create(arg) # type: ignore

class Variation_1173(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_96.cv_arg, Tuple[Literal["RE"], RuleVariation_96.cv_arg]], Union[RuleVariation_493.cv_arg, Tuple[Literal["GS"], RuleVariation_493.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["TA"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1173.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_793, 1), (Item_373, 15), (Item_970, 16)]
    cv_items_dict = {"RE": RuleVariation_96, "GS": RuleVariation_493, "TA": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> RuleVariation_493:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TA"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RE"], Literal["GS"], Literal["TA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_96:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> RuleVariation_493:
        ...
    @overload
    def get_item(self, key : Literal["TA"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1173.cv_arg") -> 'Variation_1173':
        return cls._create(arg) # type: ignore

class RuleVariation_1124(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1173.cv_arg
    cv_variation: TypeAlias = Variation_1173

    @classmethod
    def create(cls, arg : "RuleVariation_1124.cv_arg") -> "RuleVariation_1124":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1173:
        return self.arg # type: ignore

class NonSpare_357(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1124.cv_arg
    cv_name = "160"
    cv_title = "Airborne Ground Vector"
    cv_rule: TypeAlias = RuleVariation_1124

    @classmethod
    def create(cls, arg : "NonSpare_357.cv_arg") -> "NonSpare_357":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1124:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1173:
        return self.rule.variation

class UapItem_357(UapItem):
    cv_non_spare: TypeAlias = NonSpare_357

class Item_5(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 0
    cv_bit_size = 6

class Content_672(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 3.125e-2
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_672(RuleContentContextFree):
    cv_arg: TypeAlias = Content_672.cv_arg
    cv_content: TypeAlias = Content_672

    @property
    def content(self) -> Content_672:
        return self._get_content() # type: ignore

class Variation_969(Element):
    cv_arg: TypeAlias = RuleContent_672.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_672

    @classmethod
    def create(cls, arg: "Variation_969.cv_arg") -> "Variation_969":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_672:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_672:
        return self.rule.content

class RuleVariation_939(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_969.cv_arg
    cv_variation: TypeAlias = Variation_969

    @classmethod
    def create(cls, arg : "RuleVariation_939.cv_arg") -> "RuleVariation_939":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_969:
        return self.arg # type: ignore

class NonSpare_1825(NonSpare):
    cv_arg: TypeAlias = RuleVariation_939.cv_arg
    cv_name = "TAR"
    cv_title = "Track Angle Rate"
    cv_rule: TypeAlias = RuleVariation_939

    @classmethod
    def create(cls, arg : "NonSpare_1825.cv_arg") -> "NonSpare_1825":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_939:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_969:
        return self.rule.variation

class Item_973(Item):
    cv_arg: TypeAlias = NonSpare_1825.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1825

    @classmethod
    def create(cls, arg : "Item_973.cv_arg") -> "Item_973":
        return cls._create(arg) # type: ignore

class Variation_1041(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_939.cv_arg, Tuple[Literal["TAR"], RuleVariation_939.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1041.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_5, 6), (Item_973, 10)]
    cv_items_dict = {"TAR": RuleVariation_939}

    @classmethod
    def spec(cls, key : Literal["TAR"]) -> RuleVariation_939:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["TAR"]) -> RuleVariation_939:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1041.cv_arg") -> 'Variation_1041':
        return cls._create(arg) # type: ignore

class RuleVariation_1009(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1041.cv_arg
    cv_variation: TypeAlias = Variation_1041

    @classmethod
    def create(cls, arg : "RuleVariation_1009.cv_arg") -> "RuleVariation_1009":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1041:
        return self.arg # type: ignore

class NonSpare_369(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1009.cv_arg
    cv_name = "165"
    cv_title = "Track Angle Rate"
    cv_rule: TypeAlias = RuleVariation_1009

    @classmethod
    def create(cls, arg : "NonSpare_369.cv_arg") -> "NonSpare_369":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1009:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1041:
        return self.rule.variation

class UapItem_369(UapItem):
    cv_non_spare: TypeAlias = NonSpare_369

class NonSpare_231(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "077"
    cv_title = "Time of ASTERIX Report Transmission"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_231.cv_arg") -> "NonSpare_231":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_231(UapItem):
    cv_non_spare: TypeAlias = NonSpare_231

class Content_305(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No ADS-B Emitter Category Information", 1: "Light aircraft <= 15500 lbs", 2: "15500 lbs < small aircraft <75000 lbs", 3: "75000 lbs < medium a/c < 300000 lbs", 4: "High Vortex Large", 5: "300000 lbs <= heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (>400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Cluster obstacle", 24: "Line obstacle"}

class RuleContent_305(RuleContentContextFree):
    cv_arg: TypeAlias = Content_305.cv_arg
    cv_content: TypeAlias = Content_305

    @property
    def content(self) -> Content_305:
        return self._get_content() # type: ignore

class Variation_170(Element):
    cv_arg: TypeAlias = RuleContent_305.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_305

    @classmethod
    def create(cls, arg: "Variation_170.cv_arg") -> "Variation_170":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_305:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_305:
        return self.rule.content

class RuleVariation_164(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_170.cv_arg
    cv_variation: TypeAlias = Variation_170

    @classmethod
    def create(cls, arg : "RuleVariation_164.cv_arg") -> "RuleVariation_164":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_170:
        return self.arg # type: ignore

class NonSpare_79(NonSpare):
    cv_arg: TypeAlias = RuleVariation_164.cv_arg
    cv_name = "020"
    cv_title = "Emitter Category"
    cv_rule: TypeAlias = RuleVariation_164

    @classmethod
    def create(cls, arg : "NonSpare_79.cv_arg") -> "NonSpare_79":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_164:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_170:
        return self.rule.variation

class UapItem_79(UapItem):
    cv_non_spare: TypeAlias = NonSpare_79

class NonSpare_1648(NonSpare):
    cv_arg: TypeAlias = RuleVariation_466.cv_arg
    cv_name = "S"
    cv_title = "Source"
    cv_rule: TypeAlias = RuleVariation_466

    @classmethod
    def create(cls, arg : "NonSpare_1648.cv_arg") -> "NonSpare_1648":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_466:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_477:
        return self.rule.variation

class Item_851(Item):
    cv_arg: TypeAlias = NonSpare_1648.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1648

    @classmethod
    def create(cls, arg : "Item_851.cv_arg") -> "Item_851":
        return cls._create(arg) # type: ignore

class Variation_1200(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_64.cv_arg, Tuple[Literal["SAS"], RuleVariation_64.cv_arg]], Union[RuleVariation_466.cv_arg, Tuple[Literal["S"], RuleVariation_466.cv_arg]], Union[RuleVariation_686.cv_arg, Tuple[Literal["ALT"], RuleVariation_686.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1200.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_861, 1), (Item_851, 2), (Item_60, 13)]
    cv_items_dict = {"SAS": RuleVariation_64, "S": RuleVariation_466, "ALT": RuleVariation_686}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAS"]) -> RuleVariation_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["S"]) -> RuleVariation_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAS"], Literal["S"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAS"]) -> RuleVariation_64:
        ...
    @overload
    def get_item(self, key : Literal["S"]) -> RuleVariation_466:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1200.cv_arg") -> 'Variation_1200':
        return cls._create(arg) # type: ignore

class RuleVariation_1144(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1200.cv_arg
    cv_variation: TypeAlias = Variation_1200

    @classmethod
    def create(cls, arg : "RuleVariation_1144.cv_arg") -> "RuleVariation_1144":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1200:
        return self.arg # type: ignore

class NonSpare_341(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1144.cv_arg
    cv_name = "146"
    cv_title = "Selected Altitude"
    cv_rule: TypeAlias = RuleVariation_1144

    @classmethod
    def create(cls, arg : "NonSpare_341.cv_arg") -> "NonSpare_341":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1144:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1200:
        return self.rule.variation

class UapItem_341(UapItem):
    cv_non_spare: TypeAlias = NonSpare_341

class Content_389(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not active or unknown", 1: "Active"}

class RuleContent_389(RuleContentContextFree):
    cv_arg: TypeAlias = Content_389.cv_arg
    cv_content: TypeAlias = Content_389

    @property
    def content(self) -> Content_389:
        return self._get_content() # type: ignore

class Variation_68(Element):
    cv_arg: TypeAlias = RuleContent_389.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_389

    @classmethod
    def create(cls, arg: "Variation_68.cv_arg") -> "Variation_68":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_389:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_389:
        return self.rule.content

class RuleVariation_68(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_68.cv_arg
    cv_variation: TypeAlias = Variation_68

    @classmethod
    def create(cls, arg : "RuleVariation_68.cv_arg") -> "RuleVariation_68":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_68:
        return self.arg # type: ignore

class NonSpare_1340(NonSpare):
    cv_arg: TypeAlias = RuleVariation_68.cv_arg
    cv_name = "MV"
    cv_title = "Manage Vertical Mode"
    cv_rule: TypeAlias = RuleVariation_68

    @classmethod
    def create(cls, arg : "NonSpare_1340.cv_arg") -> "NonSpare_1340":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_68:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_68:
        return self.rule.variation

class Item_603(Item):
    cv_arg: TypeAlias = NonSpare_1340.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1340

    @classmethod
    def create(cls, arg : "Item_603.cv_arg") -> "Item_603":
        return cls._create(arg) # type: ignore

class Variation_444(Element):
    cv_arg: TypeAlias = RuleContent_389.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_389

    @classmethod
    def create(cls, arg: "Variation_444.cv_arg") -> "Variation_444":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_389:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_389:
        return self.rule.content

class RuleVariation_433(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_444.cv_arg
    cv_variation: TypeAlias = Variation_444

    @classmethod
    def create(cls, arg : "RuleVariation_433.cv_arg") -> "RuleVariation_433":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_444:
        return self.arg # type: ignore

class NonSpare_585(NonSpare):
    cv_arg: TypeAlias = RuleVariation_433.cv_arg
    cv_name = "AH"
    cv_title = "Altitude Hold Mode"
    cv_rule: TypeAlias = RuleVariation_433

    @classmethod
    def create(cls, arg : "NonSpare_585.cv_arg") -> "NonSpare_585":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_433:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_444:
        return self.rule.variation

class Item_54(Item):
    cv_arg: TypeAlias = NonSpare_585.cv_arg
    cv_non_spare: TypeAlias = NonSpare_585

    @classmethod
    def create(cls, arg : "Item_54.cv_arg") -> "Item_54":
        return cls._create(arg) # type: ignore

class Variation_568(Element):
    cv_arg: TypeAlias = RuleContent_389.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_389

    @classmethod
    def create(cls, arg: "Variation_568.cv_arg") -> "Variation_568":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_389:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_389:
        return self.rule.content

class RuleVariation_557(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_568.cv_arg
    cv_variation: TypeAlias = Variation_568

    @classmethod
    def create(cls, arg : "RuleVariation_557.cv_arg") -> "RuleVariation_557":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_568:
        return self.arg # type: ignore

class NonSpare_605(NonSpare):
    cv_arg: TypeAlias = RuleVariation_557.cv_arg
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule: TypeAlias = RuleVariation_557

    @classmethod
    def create(cls, arg : "NonSpare_605.cv_arg") -> "NonSpare_605":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_557:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_568:
        return self.rule.variation

class Item_69(Item):
    cv_arg: TypeAlias = NonSpare_605.cv_arg
    cv_non_spare: TypeAlias = NonSpare_605

    @classmethod
    def create(cls, arg : "Item_69.cv_arg") -> "Item_69":
        return cls._create(arg) # type: ignore

class Variation_1148(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_68.cv_arg, Tuple[Literal["MV"], RuleVariation_68.cv_arg]], Union[RuleVariation_433.cv_arg, Tuple[Literal["AH"], RuleVariation_433.cv_arg]], Union[RuleVariation_557.cv_arg, Tuple[Literal["AM"], RuleVariation_557.cv_arg]], Union[RuleVariation_686.cv_arg, Tuple[Literal["ALT"], RuleVariation_686.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1148.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_603, 1), (Item_54, 1), (Item_69, 1), (Item_60, 13)]
    cv_items_dict = {"MV": RuleVariation_68, "AH": RuleVariation_433, "AM": RuleVariation_557, "ALT": RuleVariation_686}

    @overload
    @classmethod
    def spec(cls, key : Literal["MV"]) -> RuleVariation_68:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_557:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MV"], Literal["AH"], Literal["AM"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MV"]) -> RuleVariation_68:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_433:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_557:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_686:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1148.cv_arg") -> 'Variation_1148':
        return cls._create(arg) # type: ignore

class RuleVariation_1101(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1148.cv_arg
    cv_variation: TypeAlias = Variation_1148

    @classmethod
    def create(cls, arg : "RuleVariation_1101.cv_arg") -> "RuleVariation_1101":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1148:
        return self.arg # type: ignore

class NonSpare_343(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1101.cv_arg
    cv_name = "148"
    cv_title = "Final State Selected Altitude"
    cv_rule: TypeAlias = RuleVariation_1101

    @classmethod
    def create(cls, arg : "NonSpare_343.cv_arg") -> "NonSpare_343":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1101:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1148:
        return self.rule.variation

class UapItem_343(UapItem):
    cv_non_spare: TypeAlias = NonSpare_343

class Content_734(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.5
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_734(RuleContentContextFree):
    cv_arg: TypeAlias = Content_734.cv_arg
    cv_content: TypeAlias = Content_734

    @property
    def content(self) -> Content_734:
        return self._get_content() # type: ignore

class Variation_227(Element):
    cv_arg: TypeAlias = RuleContent_734.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_734

    @classmethod
    def create(cls, arg: "Variation_227.cv_arg") -> "Variation_227":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_734:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_734:
        return self.rule.content

class RuleVariation_220(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_227.cv_arg
    cv_variation: TypeAlias = Variation_227

    @classmethod
    def create(cls, arg : "RuleVariation_220.cv_arg") -> "RuleVariation_220":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_227:
        return self.arg # type: ignore

class NonSpare_72(NonSpare):
    cv_arg: TypeAlias = RuleVariation_220.cv_arg
    cv_name = "016"
    cv_title = "Service Management"
    cv_rule: TypeAlias = RuleVariation_220

    @classmethod
    def create(cls, arg : "NonSpare_72.cv_arg") -> "NonSpare_72":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

class UapItem_72(UapItem):
    cv_non_spare: TypeAlias = NonSpare_72

class Content_463(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TCAS II or ACAS RA not active", 1: "TCAS RA active"}

class RuleContent_463(RuleContentContextFree):
    cv_arg: TypeAlias = Content_463.cv_arg
    cv_content: TypeAlias = Content_463

    @property
    def content(self) -> Content_463:
        return self._get_content() # type: ignore

class Variation_79(Element):
    cv_arg: TypeAlias = RuleContent_463.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_463

    @classmethod
    def create(cls, arg: "Variation_79.cv_arg") -> "Variation_79":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_463:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_463:
        return self.rule.content

class RuleVariation_79(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_79.cv_arg
    cv_variation: TypeAlias = Variation_79

    @classmethod
    def create(cls, arg : "RuleVariation_79.cv_arg") -> "RuleVariation_79":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_79:
        return self.arg # type: ignore

class NonSpare_1535(NonSpare):
    cv_arg: TypeAlias = RuleVariation_79.cv_arg
    cv_name = "RA"
    cv_title = "TCAS Resolution Advisory Active"
    cv_rule: TypeAlias = RuleVariation_79

    @classmethod
    def create(cls, arg : "NonSpare_1535.cv_arg") -> "NonSpare_1535":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_79:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_79:
        return self.rule.variation

class Item_765(Item):
    cv_arg: TypeAlias = NonSpare_1535.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1535

    @classmethod
    def create(cls, arg : "Item_765.cv_arg") -> "Item_765":
        return cls._create(arg) # type: ignore

class Content_330(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No capability for Trajectory Change Reports", 1: "Support for TC+0 reports only", 2: "Support for multiple TC reports", 3: "Reserved"}

class RuleContent_330(RuleContentContextFree):
    cv_arg: TypeAlias = Content_330.cv_arg
    cv_content: TypeAlias = Content_330

    @property
    def content(self) -> Content_330:
        return self._get_content() # type: ignore

class Variation_471(Element):
    cv_arg: TypeAlias = RuleContent_330.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_330

    @classmethod
    def create(cls, arg: "Variation_471.cv_arg") -> "Variation_471":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_330:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_330:
        return self.rule.content

class RuleVariation_460(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_471.cv_arg
    cv_variation: TypeAlias = Variation_471

    @classmethod
    def create(cls, arg : "RuleVariation_460.cv_arg") -> "RuleVariation_460":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_471:
        return self.arg # type: ignore

class NonSpare_1834(NonSpare):
    cv_arg: TypeAlias = RuleVariation_460.cv_arg
    cv_name = "TC"
    cv_title = "Target Trajectory Change Report Capability"
    cv_rule: TypeAlias = RuleVariation_460

    @classmethod
    def create(cls, arg : "NonSpare_1834.cv_arg") -> "NonSpare_1834":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_460:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_471:
        return self.rule.variation

class Item_976(Item):
    cv_arg: TypeAlias = NonSpare_1834.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1834

    @classmethod
    def create(cls, arg : "Item_976.cv_arg") -> "Item_976":
        return cls._create(arg) # type: ignore

class Content_332(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No capability to support Target State Reports", 1: "Capable of supporting target State Reports"}

class RuleContent_332(RuleContentContextFree):
    cv_arg: TypeAlias = Content_332.cv_arg
    cv_content: TypeAlias = Content_332

    @property
    def content(self) -> Content_332:
        return self._get_content() # type: ignore

class Variation_651(Element):
    cv_arg: TypeAlias = RuleContent_332.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_332

    @classmethod
    def create(cls, arg: "Variation_651.cv_arg") -> "Variation_651":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_332:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_332:
        return self.rule.content

class RuleVariation_640(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_651.cv_arg
    cv_variation: TypeAlias = Variation_651

    @classmethod
    def create(cls, arg : "RuleVariation_640.cv_arg") -> "RuleVariation_640":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_651:
        return self.arg # type: ignore

class NonSpare_1924(NonSpare):
    cv_arg: TypeAlias = RuleVariation_640.cv_arg
    cv_name = "TS"
    cv_title = "Target State Report Capability"
    cv_rule: TypeAlias = RuleVariation_640

    @classmethod
    def create(cls, arg : "NonSpare_1924.cv_arg") -> "NonSpare_1924":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_640:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_651:
        return self.rule.variation

class Item_1042(Item):
    cv_arg: TypeAlias = NonSpare_1924.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1924

    @classmethod
    def create(cls, arg : "Item_1042.cv_arg") -> "Item_1042":
        return cls._create(arg) # type: ignore

class Content_331(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No capability to generate ARV-reports", 1: "Capable of generate ARV-reports"}

class RuleContent_331(RuleContentContextFree):
    cv_arg: TypeAlias = Content_331.cv_arg
    cv_content: TypeAlias = Content_331

    @property
    def content(self) -> Content_331:
        return self._get_content() # type: ignore

class Variation_738(Element):
    cv_arg: TypeAlias = RuleContent_331.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_331

    @classmethod
    def create(cls, arg: "Variation_738.cv_arg") -> "Variation_738":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_331:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_331:
        return self.rule.content

class RuleVariation_727(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_738.cv_arg
    cv_variation: TypeAlias = Variation_738

    @classmethod
    def create(cls, arg : "RuleVariation_727.cv_arg") -> "RuleVariation_727":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_738:
        return self.arg # type: ignore

class NonSpare_632(NonSpare):
    cv_arg: TypeAlias = RuleVariation_727.cv_arg
    cv_name = "ARV"
    cv_title = "Air-Referenced Velocity Report Capability"
    cv_rule: TypeAlias = RuleVariation_727

    @classmethod
    def create(cls, arg : "NonSpare_632.cv_arg") -> "NonSpare_632":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_727:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_738:
        return self.rule.variation

class Item_85(Item):
    cv_arg: TypeAlias = NonSpare_632.cv_arg
    cv_non_spare: TypeAlias = NonSpare_632

    @classmethod
    def create(cls, arg : "Item_85.cv_arg") -> "Item_85":
        return cls._create(arg) # type: ignore

class Content_48(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "CDTI not operational", 1: "CDTI operational"}

class RuleContent_48(RuleContentContextFree):
    cv_arg: TypeAlias = Content_48.cv_arg
    cv_content: TypeAlias = Content_48

    @property
    def content(self) -> Content_48:
        return self._get_content() # type: ignore

class Variation_825(Element):
    cv_arg: TypeAlias = RuleContent_48.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_48

    @classmethod
    def create(cls, arg: "Variation_825.cv_arg") -> "Variation_825":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_48:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_48:
        return self.rule.content

class RuleVariation_795(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_825.cv_arg
    cv_variation: TypeAlias = Variation_825

    @classmethod
    def create(cls, arg : "RuleVariation_795.cv_arg") -> "RuleVariation_795":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_825:
        return self.arg # type: ignore

class NonSpare_717(NonSpare):
    cv_arg: TypeAlias = RuleVariation_795.cv_arg
    cv_name = "CDTIA"
    cv_title = "Cockpit Display of Traffic Information Airborne"
    cv_rule: TypeAlias = RuleVariation_795

    @classmethod
    def create(cls, arg : "NonSpare_717.cv_arg") -> "NonSpare_717":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_795:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_825:
        return self.rule.variation

class Item_143(Item):
    cv_arg: TypeAlias = NonSpare_717.cv_arg
    cv_non_spare: TypeAlias = NonSpare_717

    @classmethod
    def create(cls, arg : "Item_143.cv_arg") -> "Item_143":
        return cls._create(arg) # type: ignore

class Content_464(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "TCAS operational", 1: "TCAS not operational"}

class RuleContent_464(RuleContentContextFree):
    cv_arg: TypeAlias = Content_464.cv_arg
    cv_content: TypeAlias = Content_464

    @property
    def content(self) -> Content_464:
        return self._get_content() # type: ignore

class Variation_952(Element):
    cv_arg: TypeAlias = RuleContent_464.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_464

    @classmethod
    def create(cls, arg: "Variation_952.cv_arg") -> "Variation_952":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_464:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_464:
        return self.rule.content

class RuleVariation_922(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_952.cv_arg
    cv_variation: TypeAlias = Variation_952

    @classmethod
    def create(cls, arg : "RuleVariation_922.cv_arg") -> "RuleVariation_922":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_952:
        return self.arg # type: ignore

class NonSpare_1377(NonSpare):
    cv_arg: TypeAlias = RuleVariation_922.cv_arg
    cv_name = "NOTTCAS"
    cv_title = "TCAS System Status"
    cv_rule: TypeAlias = RuleVariation_922

    @classmethod
    def create(cls, arg : "NonSpare_1377.cv_arg") -> "NonSpare_1377":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_922:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_952:
        return self.rule.variation

class Item_637(Item):
    cv_arg: TypeAlias = NonSpare_1377.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1377

    @classmethod
    def create(cls, arg : "Item_637.cv_arg") -> "Item_637":
        return cls._create(arg) # type: ignore

class Content_34(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Antenna Diversity", 1: "Single Antenna only"}

class RuleContent_34(RuleContentContextFree):
    cv_arg: TypeAlias = Content_34.cv_arg
    cv_content: TypeAlias = Content_34

    @property
    def content(self) -> Content_34:
        return self._get_content() # type: ignore

class Variation_972(Element):
    cv_arg: TypeAlias = RuleContent_34.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_34

    @classmethod
    def create(cls, arg: "Variation_972.cv_arg") -> "Variation_972":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_34:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_34:
        return self.rule.content

class RuleVariation_942(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_972.cv_arg
    cv_variation: TypeAlias = Variation_972

    @classmethod
    def create(cls, arg : "RuleVariation_942.cv_arg") -> "RuleVariation_942":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_972:
        return self.arg # type: ignore

class NonSpare_1649(NonSpare):
    cv_arg: TypeAlias = RuleVariation_942.cv_arg
    cv_name = "SA"
    cv_title = "Single Antenna"
    cv_rule: TypeAlias = RuleVariation_942

    @classmethod
    def create(cls, arg : "NonSpare_1649.cv_arg") -> "NonSpare_1649":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_942:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_972:
        return self.rule.variation

class Item_852(Item):
    cv_arg: TypeAlias = NonSpare_1649.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1649

    @classmethod
    def create(cls, arg : "Item_852.cv_arg") -> "Item_852":
        return cls._create(arg) # type: ignore

class Variation_1169(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_79.cv_arg, Tuple[Literal["RA"], RuleVariation_79.cv_arg]], Union[RuleVariation_460.cv_arg, Tuple[Literal["TC"], RuleVariation_460.cv_arg]], Union[RuleVariation_640.cv_arg, Tuple[Literal["TS"], RuleVariation_640.cv_arg]], Union[RuleVariation_727.cv_arg, Tuple[Literal["ARV"], RuleVariation_727.cv_arg]], Union[RuleVariation_795.cv_arg, Tuple[Literal["CDTIA"], RuleVariation_795.cv_arg]], Union[RuleVariation_922.cv_arg, Tuple[Literal["NOTTCAS"], RuleVariation_922.cv_arg]], Union[RuleVariation_942.cv_arg, Tuple[Literal["SA"], RuleVariation_942.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1169.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_765, 1), (Item_976, 2), (Item_1042, 1), (Item_85, 1), (Item_143, 1), (Item_637, 1), (Item_852, 1)]
    cv_items_dict = {"RA": RuleVariation_79, "TC": RuleVariation_460, "TS": RuleVariation_640, "ARV": RuleVariation_727, "CDTIA": RuleVariation_795, "NOTTCAS": RuleVariation_922, "SA": RuleVariation_942}

    @overload
    @classmethod
    def spec(cls, key : Literal["RA"]) -> RuleVariation_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> RuleVariation_460:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> RuleVariation_640:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARV"]) -> RuleVariation_727:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CDTIA"]) -> RuleVariation_795:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOTTCAS"]) -> RuleVariation_922:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SA"]) -> RuleVariation_942:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RA"], Literal["TC"], Literal["TS"], Literal["ARV"], Literal["CDTIA"], Literal["NOTTCAS"], Literal["SA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RA"]) -> RuleVariation_79:
        ...
    @overload
    def get_item(self, key : Literal["TC"]) -> RuleVariation_460:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> RuleVariation_640:
        ...
    @overload
    def get_item(self, key : Literal["ARV"]) -> RuleVariation_727:
        ...
    @overload
    def get_item(self, key : Literal["CDTIA"]) -> RuleVariation_795:
        ...
    @overload
    def get_item(self, key : Literal["NOTTCAS"]) -> RuleVariation_922:
        ...
    @overload
    def get_item(self, key : Literal["SA"]) -> RuleVariation_942:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1169.cv_arg") -> 'Variation_1169':
        return cls._create(arg) # type: ignore

class RuleVariation_1120(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1169.cv_arg
    cv_variation: TypeAlias = Variation_1169

    @classmethod
    def create(cls, arg : "RuleVariation_1120.cv_arg") -> "RuleVariation_1120":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1169:
        return self.arg # type: ignore

class NonSpare_27(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1120.cv_arg
    cv_name = "008"
    cv_title = "Aircraft Operational Status"
    cv_rule: TypeAlias = RuleVariation_1120

    @classmethod
    def create(cls, arg : "NonSpare_27.cv_arg") -> "NonSpare_27":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1120:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1169:
        return self.rule.variation

class UapItem_27(UapItem):
    cv_non_spare: TypeAlias = NonSpare_27

class Content_430(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Position transmitted is not ADS-B position reference point", 1: "Position transmitted is the ADS-B position reference point"}

class RuleContent_430(RuleContentContextFree):
    cv_arg: TypeAlias = Content_430.cv_arg
    cv_content: TypeAlias = Content_430

    @property
    def content(self) -> Content_430:
        return self._get_content() # type: ignore

class Variation_573(Element):
    cv_arg: TypeAlias = RuleContent_430.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_430

    @classmethod
    def create(cls, arg: "Variation_573.cv_arg") -> "Variation_573":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_430:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_430:
        return self.rule.content

class RuleVariation_562(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_573.cv_arg
    cv_variation: TypeAlias = Variation_573

    @classmethod
    def create(cls, arg : "RuleVariation_562.cv_arg") -> "RuleVariation_562":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_573:
        return self.arg # type: ignore

class Variation_620(Element):
    cv_arg: TypeAlias = RuleContent_48.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_48

    @classmethod
    def create(cls, arg: "Variation_620.cv_arg") -> "Variation_620":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_48:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_48:
        return self.rule.content

class RuleVariation_609(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_620.cv_arg
    cv_variation: TypeAlias = Variation_620

    @classmethod
    def create(cls, arg : "RuleVariation_609.cv_arg") -> "RuleVariation_609":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_620:
        return self.arg # type: ignore

class Content_7(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: ">= 70 Watts", 1: "< 70 Watts"}

class RuleContent_7(RuleContentContextFree):
    cv_arg: TypeAlias = Content_7.cv_arg
    cv_content: TypeAlias = Content_7

    @property
    def content(self) -> Content_7:
        return self._get_content() # type: ignore

class Variation_700(Element):
    cv_arg: TypeAlias = RuleContent_7.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_7

    @classmethod
    def create(cls, arg: "Variation_700.cv_arg") -> "Variation_700":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_7:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_7:
        return self.rule.content

class RuleVariation_689(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_700.cv_arg
    cv_variation: TypeAlias = Variation_700

    @classmethod
    def create(cls, arg : "RuleVariation_689.cv_arg") -> "RuleVariation_689":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_700:
        return self.arg # type: ignore

class Content_30(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Aircraft not receiving ATC-services", 1: "Aircraft receiving ATC services"}

class RuleContent_30(RuleContentContextFree):
    cv_arg: TypeAlias = Content_30.cv_arg
    cv_content: TypeAlias = Content_30

    @property
    def content(self) -> Content_30:
        return self._get_content() # type: ignore

class Variation_822(Element):
    cv_arg: TypeAlias = RuleContent_30.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_30

    @classmethod
    def create(cls, arg: "Variation_822.cv_arg") -> "Variation_822":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_30:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_30:
        return self.rule.content

class RuleVariation_792(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_822.cv_arg
    cv_variation: TypeAlias = Variation_822

    @classmethod
    def create(cls, arg : "RuleVariation_792.cv_arg") -> "RuleVariation_792":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_822:
        return self.arg # type: ignore

class Content_237(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "IDENT switch not active", 1: "IDENT switch active"}

class RuleContent_237(RuleContentContextFree):
    cv_arg: TypeAlias = Content_237.cv_arg
    cv_content: TypeAlias = Content_237

    @property
    def content(self) -> Content_237:
        return self._get_content() # type: ignore

class Variation_934(Element):
    cv_arg: TypeAlias = RuleContent_237.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_237

    @classmethod
    def create(cls, arg: "Variation_934.cv_arg") -> "Variation_934":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_237:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_237:
        return self.rule.content

class RuleVariation_904(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_934.cv_arg
    cv_variation: TypeAlias = Variation_934

    @classmethod
    def create(cls, arg : "RuleVariation_904.cv_arg") -> "RuleVariation_904":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_934:
        return self.arg # type: ignore

class NonSpare_1440(NonSpare):
    cv_arg: TypeAlias = RuleVariation_562.cv_arg
    cv_name = "POA"
    cv_title = "Position Offset Applied"
    cv_rule: TypeAlias = RuleVariation_562

    @classmethod
    def create(cls, arg : "NonSpare_1440.cv_arg") -> "NonSpare_1440":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_562:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_573:
        return self.rule.variation

class Item_689(Item):
    cv_arg: TypeAlias = NonSpare_1440.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1440

    @classmethod
    def create(cls, arg : "Item_689.cv_arg") -> "Item_689":
        return cls._create(arg) # type: ignore

class NonSpare_718(NonSpare):
    cv_arg: TypeAlias = RuleVariation_609.cv_arg
    cv_name = "CDTIS"
    cv_title = "Cockpit Display of Traffic Information Surface"
    cv_rule: TypeAlias = RuleVariation_609

    @classmethod
    def create(cls, arg : "NonSpare_718.cv_arg") -> "NonSpare_718":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_609:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_620:
        return self.rule.variation

class Item_144(Item):
    cv_arg: TypeAlias = NonSpare_718.cv_arg
    cv_non_spare: TypeAlias = NonSpare_718

    @classmethod
    def create(cls, arg : "Item_144.cv_arg") -> "Item_144":
        return cls._create(arg) # type: ignore

class NonSpare_673(NonSpare):
    cv_arg: TypeAlias = RuleVariation_689.cv_arg
    cv_name = "B2LOW"
    cv_title = "Class B2 Transmit Power Less Than 70 Watts"
    cv_rule: TypeAlias = RuleVariation_689

    @classmethod
    def create(cls, arg : "NonSpare_673.cv_arg") -> "NonSpare_673":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_689:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_700:
        return self.rule.variation

class Item_113(Item):
    cv_arg: TypeAlias = NonSpare_673.cv_arg
    cv_non_spare: TypeAlias = NonSpare_673

    @classmethod
    def create(cls, arg : "Item_113.cv_arg") -> "Item_113":
        return cls._create(arg) # type: ignore

class NonSpare_1551(NonSpare):
    cv_arg: TypeAlias = RuleVariation_792.cv_arg
    cv_name = "RAS"
    cv_title = "Receiving ATC Services"
    cv_rule: TypeAlias = RuleVariation_792

    @classmethod
    def create(cls, arg : "NonSpare_1551.cv_arg") -> "NonSpare_1551":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_792:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_822:
        return self.rule.variation

class Item_779(Item):
    cv_arg: TypeAlias = NonSpare_1551.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1551

    @classmethod
    def create(cls, arg : "Item_779.cv_arg") -> "Item_779":
        return cls._create(arg) # type: ignore

class NonSpare_1114(NonSpare):
    cv_arg: TypeAlias = RuleVariation_904.cv_arg
    cv_name = "IDENT"
    cv_title = "Setting of IDENT Switch"
    cv_rule: TypeAlias = RuleVariation_904

    @classmethod
    def create(cls, arg : "NonSpare_1114.cv_arg") -> "NonSpare_1114":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_904:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_934:
        return self.rule.variation

class Item_431(Item):
    cv_arg: TypeAlias = NonSpare_1114.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1114

    @classmethod
    def create(cls, arg : "Item_431.cv_arg") -> "Item_431":
        return cls._create(arg) # type: ignore

class NonSpare_1204(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "LW"
    cv_title = "Length and Width of the Aircraft"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_1204.cv_arg") -> "NonSpare_1204":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_512(Item):
    cv_arg: TypeAlias = NonSpare_1204.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1204

    @classmethod
    def create(cls, arg : "Item_512.cv_arg") -> "Item_512":
        return cls._create(arg) # type: ignore

class Variation_1343(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_562.cv_arg, Tuple[Literal["POA"], RuleVariation_562.cv_arg]], Union[RuleVariation_609.cv_arg, Tuple[Literal["CDTIS"], RuleVariation_609.cv_arg]], Union[RuleVariation_689.cv_arg, Tuple[Literal["B2LOW"], RuleVariation_689.cv_arg]], Union[RuleVariation_792.cv_arg, Tuple[Literal["RAS"], RuleVariation_792.cv_arg]], Union[RuleVariation_904.cv_arg, Tuple[Literal["IDENT"], RuleVariation_904.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_769.cv_arg, Tuple[Literal["LW"], RuleVariation_769.cv_arg]]]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1343.cv_arg_group_1"],
        Tuple["Variation_1343.cv_arg_group_1", "Variation_1343.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_1, 2), (Item_689, 1), (Item_144, 1), (Item_113, 1), (Item_779, 1), (Item_431, 1), None], [(Item_3, 4), (Item_512, 4)]]

    @classmethod
    def create(cls, arg: "Variation_1343.cv_arg") -> 'Variation_1343':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["POA"]) -> RuleVariation_562:
        ...
    @overload
    def get_item(self, key : Literal["CDTIS"]) -> RuleVariation_609:
        ...
    @overload
    def get_item(self, key : Literal["B2LOW"]) -> RuleVariation_689:
        ...
    @overload
    def get_item(self, key : Literal["RAS"]) -> RuleVariation_792:
        ...
    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_904:
        ...
    @overload
    def get_item(self, key : Literal["LW"]) -> Optional[RuleVariation_769]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1264(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1343.cv_arg
    cv_variation: TypeAlias = Variation_1343

    @classmethod
    def create(cls, arg : "RuleVariation_1264.cv_arg") -> "RuleVariation_1264":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1343:
        return self.arg # type: ignore

class NonSpare_465(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1264.cv_arg
    cv_name = "271"
    cv_title = "Surface Capabilities and Characteristics"
    cv_rule: TypeAlias = RuleVariation_1264

    @classmethod
    def create(cls, arg : "NonSpare_465.cv_arg") -> "NonSpare_465":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1264:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1343:
        return self.rule.variation

class UapItem_465(UapItem):
    cv_non_spare: TypeAlias = NonSpare_465

class NonSpare_318(NonSpare):
    cv_arg: TypeAlias = RuleVariation_201.cv_arg
    cv_name = "132"
    cv_title = "Message Amplitude"
    cv_rule: TypeAlias = RuleVariation_201

    @classmethod
    def create(cls, arg : "NonSpare_318.cv_arg") -> "NonSpare_318":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_208:
        return self.rule.variation

class UapItem_318(UapItem):
    cv_non_spare: TypeAlias = NonSpare_318

class NonSpare_447(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1325.cv_arg
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule: TypeAlias = RuleVariation_1325

    @classmethod
    def create(cls, arg : "NonSpare_447.cv_arg") -> "NonSpare_447":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1404:
        return self.rule.variation

class UapItem_447(UapItem):
    cv_non_spare: TypeAlias = NonSpare_447

class Variation_141(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_141.cv_arg") -> "Variation_141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_141(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_141.cv_arg
    cv_variation: TypeAlias = Variation_141

    @classmethod
    def create(cls, arg : "RuleVariation_141.cv_arg") -> "RuleVariation_141":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_141:
        return self.arg # type: ignore

class NonSpare_1966(NonSpare):
    cv_arg: TypeAlias = RuleVariation_141.cv_arg
    cv_name = "TYP"
    cv_title = "Message Type (= 28 for 1090 ES, Version 2)"
    cv_rule: TypeAlias = RuleVariation_141

    @classmethod
    def create(cls, arg : "NonSpare_1966.cv_arg") -> "NonSpare_1966":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_141:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_141:
        return self.rule.variation

class Item_1079(Item):
    cv_arg: TypeAlias = NonSpare_1966.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1966

    @classmethod
    def create(cls, arg : "Item_1079.cv_arg") -> "Item_1079":
        return cls._create(arg) # type: ignore

class NonSpare_1803(NonSpare):
    cv_arg: TypeAlias = RuleVariation_859.cv_arg
    cv_name = "STYP"
    cv_title = "Message Sub-type (= 2 for 1090 ES, Version 2)"
    cv_rule: TypeAlias = RuleVariation_859

    @classmethod
    def create(cls, arg : "NonSpare_1803.cv_arg") -> "NonSpare_1803":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_859:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_889:
        return self.rule.variation

class Item_959(Item):
    cv_arg: TypeAlias = NonSpare_1803.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1803

    @classmethod
    def create(cls, arg : "Item_959.cv_arg") -> "Item_959":
        return cls._create(arg) # type: ignore

class Variation_250(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 14
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_250.cv_arg") -> "Variation_250":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_243(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_250.cv_arg
    cv_variation: TypeAlias = Variation_250

    @classmethod
    def create(cls, arg : "RuleVariation_243.cv_arg") -> "RuleVariation_243":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_250:
        return self.arg # type: ignore

class NonSpare_625(NonSpare):
    cv_arg: TypeAlias = RuleVariation_243.cv_arg
    cv_name = "ARA"
    cv_title = "Active Resolution Advisories"
    cv_rule: TypeAlias = RuleVariation_243

    @classmethod
    def create(cls, arg : "NonSpare_625.cv_arg") -> "NonSpare_625":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_243:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_250:
        return self.rule.variation

class Item_80(Item):
    cv_arg: TypeAlias = NonSpare_625.cv_arg
    cv_non_spare: TypeAlias = NonSpare_625

    @classmethod
    def create(cls, arg : "Item_80.cv_arg") -> "Item_80":
        return cls._create(arg) # type: ignore

class Variation_966(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 4
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_966.cv_arg") -> "Variation_966":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_936(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_966.cv_arg
    cv_variation: TypeAlias = Variation_966

    @classmethod
    def create(cls, arg : "RuleVariation_936.cv_arg") -> "RuleVariation_936":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_966:
        return self.arg # type: ignore

class NonSpare_1543(NonSpare):
    cv_arg: TypeAlias = RuleVariation_936.cv_arg
    cv_name = "RAC"
    cv_title = "RAC (RA Complement) Record"
    cv_rule: TypeAlias = RuleVariation_936

    @classmethod
    def create(cls, arg : "NonSpare_1543.cv_arg") -> "NonSpare_1543":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_936:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_966:
        return self.rule.variation

class Item_773(Item):
    cv_arg: TypeAlias = NonSpare_1543.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1543

    @classmethod
    def create(cls, arg : "Item_773.cv_arg") -> "Item_773":
        return cls._create(arg) # type: ignore

class Variation_507(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_507.cv_arg") -> "Variation_507":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_496(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_507.cv_arg
    cv_variation: TypeAlias = Variation_507

    @classmethod
    def create(cls, arg : "RuleVariation_496.cv_arg") -> "RuleVariation_496":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_507:
        return self.arg # type: ignore

class NonSpare_1552(NonSpare):
    cv_arg: TypeAlias = RuleVariation_496.cv_arg
    cv_name = "RAT"
    cv_title = "RA Terminated"
    cv_rule: TypeAlias = RuleVariation_496

    @classmethod
    def create(cls, arg : "NonSpare_1552.cv_arg") -> "NonSpare_1552":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_496:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_507:
        return self.rule.variation

class Item_780(Item):
    cv_arg: TypeAlias = NonSpare_1552.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1552

    @classmethod
    def create(cls, arg : "Item_780.cv_arg") -> "Item_780":
        return cls._create(arg) # type: ignore

class NonSpare_1335(NonSpare):
    cv_arg: TypeAlias = RuleVariation_603.cv_arg
    cv_name = "MTE"
    cv_title = "Multiple Threat Encounter"
    cv_rule: TypeAlias = RuleVariation_603

    @classmethod
    def create(cls, arg : "NonSpare_1335.cv_arg") -> "NonSpare_1335":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_603:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_614:
        return self.rule.variation

class Item_599(Item):
    cv_arg: TypeAlias = NonSpare_1335.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1335

    @classmethod
    def create(cls, arg : "Item_599.cv_arg") -> "Item_599":
        return cls._create(arg) # type: ignore

class Variation_763(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_763.cv_arg") -> "Variation_763":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_752(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_763.cv_arg
    cv_variation: TypeAlias = Variation_763

    @classmethod
    def create(cls, arg : "RuleVariation_752.cv_arg") -> "RuleVariation_752":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_763:
        return self.arg # type: ignore

class NonSpare_1950(NonSpare):
    cv_arg: TypeAlias = RuleVariation_752.cv_arg
    cv_name = "TTI"
    cv_title = "Threat Type Indicator"
    cv_rule: TypeAlias = RuleVariation_752

    @classmethod
    def create(cls, arg : "NonSpare_1950.cv_arg") -> "NonSpare_1950":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_752:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_763:
        return self.rule.variation

class Item_1065(Item):
    cv_arg: TypeAlias = NonSpare_1950.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1950

    @classmethod
    def create(cls, arg : "Item_1065.cv_arg") -> "Item_1065":
        return cls._create(arg) # type: ignore

class Variation_971(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 26
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_971.cv_arg") -> "Variation_971":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_941(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_971.cv_arg
    cv_variation: TypeAlias = Variation_971

    @classmethod
    def create(cls, arg : "RuleVariation_941.cv_arg") -> "RuleVariation_941":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_971:
        return self.arg # type: ignore

class NonSpare_1864(NonSpare):
    cv_arg: TypeAlias = RuleVariation_941.cv_arg
    cv_name = "TID"
    cv_title = "Threat Identity Data"
    cv_rule: TypeAlias = RuleVariation_941

    @classmethod
    def create(cls, arg : "NonSpare_1864.cv_arg") -> "NonSpare_1864":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_941:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_971:
        return self.rule.variation

class Item_1000(Item):
    cv_arg: TypeAlias = NonSpare_1864.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1864

    @classmethod
    def create(cls, arg : "Item_1000.cv_arg") -> "Item_1000":
        return cls._create(arg) # type: ignore

class Variation_1238(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_141.cv_arg, Tuple[Literal["TYP"], RuleVariation_141.cv_arg]], Union[RuleVariation_859.cv_arg, Tuple[Literal["STYP"], RuleVariation_859.cv_arg]], Union[RuleVariation_243.cv_arg, Tuple[Literal["ARA"], RuleVariation_243.cv_arg]], Union[RuleVariation_936.cv_arg, Tuple[Literal["RAC"], RuleVariation_936.cv_arg]], Union[RuleVariation_496.cv_arg, Tuple[Literal["RAT"], RuleVariation_496.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["MTE"], RuleVariation_603.cv_arg]], Union[RuleVariation_752.cv_arg, Tuple[Literal["TTI"], RuleVariation_752.cv_arg]], Union[RuleVariation_941.cv_arg, Tuple[Literal["TID"], RuleVariation_941.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1238.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_1079, 5), (Item_959, 3), (Item_80, 14), (Item_773, 4), (Item_780, 1), (Item_599, 1), (Item_1065, 2), (Item_1000, 26)]
    cv_items_dict = {"TYP": RuleVariation_141, "STYP": RuleVariation_859, "ARA": RuleVariation_243, "RAC": RuleVariation_936, "RAT": RuleVariation_496, "MTE": RuleVariation_603, "TTI": RuleVariation_752, "TID": RuleVariation_941}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_141:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STYP"]) -> RuleVariation_859:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARA"]) -> RuleVariation_243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAC"]) -> RuleVariation_936:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAT"]) -> RuleVariation_496:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MTE"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTI"]) -> RuleVariation_752:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> RuleVariation_941:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["STYP"], Literal["ARA"], Literal["RAC"], Literal["RAT"], Literal["MTE"], Literal["TTI"], Literal["TID"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_141:
        ...
    @overload
    def get_item(self, key : Literal["STYP"]) -> RuleVariation_859:
        ...
    @overload
    def get_item(self, key : Literal["ARA"]) -> RuleVariation_243:
        ...
    @overload
    def get_item(self, key : Literal["RAC"]) -> RuleVariation_936:
        ...
    @overload
    def get_item(self, key : Literal["RAT"]) -> RuleVariation_496:
        ...
    @overload
    def get_item(self, key : Literal["MTE"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["TTI"]) -> RuleVariation_752:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> RuleVariation_941:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1238.cv_arg") -> 'Variation_1238':
        return cls._create(arg) # type: ignore

class RuleVariation_1174(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1238.cv_arg
    cv_variation: TypeAlias = Variation_1238

    @classmethod
    def create(cls, arg : "RuleVariation_1174.cv_arg") -> "RuleVariation_1174":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1238:
        return self.arg # type: ignore

class NonSpare_459(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1174.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_1174

    @classmethod
    def create(cls, arg : "NonSpare_459.cv_arg") -> "NonSpare_459":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1238:
        return self.rule.variation

class UapItem_459(UapItem):
    cv_non_spare: TypeAlias = NonSpare_459

class NonSpare_500(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "400"
    cv_title = "Receiver ID"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_500.cv_arg") -> "NonSpare_500":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_499(UapItem):
    cv_non_spare: TypeAlias = NonSpare_500

class Content_741(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_741(RuleContentContextFree):
    cv_arg: TypeAlias = Content_741.cv_arg
    cv_content: TypeAlias = Content_741

    @property
    def content(self) -> Content_741:
        return self._get_content() # type: ignore

class Variation_229(Element):
    cv_arg: TypeAlias = RuleContent_741.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_741

    @classmethod
    def create(cls, arg: "Variation_229.cv_arg") -> "Variation_229":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_741:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_741:
        return self.rule.content

class RuleVariation_222(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_229.cv_arg
    cv_variation: TypeAlias = Variation_229

    @classmethod
    def create(cls, arg : "RuleVariation_222.cv_arg") -> "RuleVariation_222":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_229:
        return self.arg # type: ignore

class NonSpare_613(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "AOS"
    cv_title = "Aircraft Operational Status Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_613.cv_arg") -> "NonSpare_613":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1913(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "TRD"
    cv_title = "Target Report Descriptor Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1913.cv_arg") -> "NonSpare_1913":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1217(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "M3A"
    cv_title = "Mode 3/A Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1217.cv_arg") -> "NonSpare_1217":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1527(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "QI"
    cv_title = "Quality Indicators Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1527.cv_arg") -> "NonSpare_1527":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1860(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "TI1"
    cv_title = "Trajectory Intent Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1860.cv_arg") -> "NonSpare_1860":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1228(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "MAM"
    cv_title = "Message Amplitude Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1228.cv_arg") -> "NonSpare_1228":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1034(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "GH"
    cv_title = "Geometric Height Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1034.cv_arg") -> "NonSpare_1034":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_975(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "FL"
    cv_title = "Flight Level Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_975.cv_arg") -> "NonSpare_975":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1128(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "ISA"
    cv_title = "Intermediate State Selected Altitude Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1128.cv_arg") -> "NonSpare_1128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_999(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "FSA"
    cv_title = "Final State Selected Altitude Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_999.cv_arg") -> "NonSpare_999":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_634(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "AS"
    cv_title = "Air Speed Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_634.cv_arg") -> "NonSpare_634":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1830(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "TAS"
    cv_title = "True Air Speed Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1830.cv_arg") -> "NonSpare_1830":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1278(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "MH"
    cv_title = "Magnetic Heading Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1278.cv_arg") -> "NonSpare_1278":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_698(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_698.cv_arg") -> "NonSpare_698":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1051(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "GVR"
    cv_title = "Geometric Vertical Rate Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1051.cv_arg") -> "NonSpare_1051":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1047(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "GV"
    cv_title = "Ground Vector Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1047.cv_arg") -> "NonSpare_1047":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1827(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "TAR"
    cv_title = "Track Angle Rate Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1827.cv_arg") -> "NonSpare_1827":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1861(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "TI2"
    cv_title = "Target Identification Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1861.cv_arg") -> "NonSpare_1861":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1925(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "TS"
    cv_title = "Target Status Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1925.cv_arg") -> "NonSpare_1925":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1271(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "MET"
    cv_title = "Met Information Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1271.cv_arg") -> "NonSpare_1271":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1600(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "ROA"
    cv_title = "Roll Angle Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1600.cv_arg") -> "NonSpare_1600":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_624(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "ARA"
    cv_title = "ACAS Resolution Advisory Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_624.cv_arg") -> "NonSpare_624":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class NonSpare_1667(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "SCC"
    cv_title = "Surface Capabilities and Characteristics Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1667.cv_arg") -> "NonSpare_1667":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class Variation_1473(Compound):
    cv_arg = TypedDict('cv_arg', {
        "AOS": NonSpare_613.cv_arg,
        "TRD": NonSpare_1913.cv_arg,
        "M3A": NonSpare_1217.cv_arg,
        "QI": NonSpare_1527.cv_arg,
        "TI1": NonSpare_1860.cv_arg,
        "MAM": NonSpare_1228.cv_arg,
        "GH": NonSpare_1034.cv_arg,
        "FL": NonSpare_975.cv_arg,
        "ISA": NonSpare_1128.cv_arg,
        "FSA": NonSpare_999.cv_arg,
        "AS": NonSpare_634.cv_arg,
        "TAS": NonSpare_1830.cv_arg,
        "MH": NonSpare_1278.cv_arg,
        "BVR": NonSpare_698.cv_arg,
        "GVR": NonSpare_1051.cv_arg,
        "GV": NonSpare_1047.cv_arg,
        "TAR": NonSpare_1827.cv_arg,
        "TI2": NonSpare_1861.cv_arg,
        "TS": NonSpare_1925.cv_arg,
        "MET": NonSpare_1271.cv_arg,
        "ROA": NonSpare_1600.cv_arg,
        "ARA": NonSpare_624.cv_arg,
        "SCC": NonSpare_1667.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_613, NonSpare_1913, NonSpare_1217, NonSpare_1527, NonSpare_1860, NonSpare_1228, NonSpare_1034, NonSpare_975, NonSpare_1128, NonSpare_999, NonSpare_634, NonSpare_1830, NonSpare_1278, NonSpare_698, NonSpare_1051, NonSpare_1047, NonSpare_1827, NonSpare_1861, NonSpare_1925, NonSpare_1271, NonSpare_1600, NonSpare_624, NonSpare_1667]
    cv_items_dict = {"AOS": NonSpare_613, "TRD": NonSpare_1913, "M3A": NonSpare_1217, "QI": NonSpare_1527, "TI1": NonSpare_1860, "MAM": NonSpare_1228, "GH": NonSpare_1034, "FL": NonSpare_975, "ISA": NonSpare_1128, "FSA": NonSpare_999, "AS": NonSpare_634, "TAS": NonSpare_1830, "MH": NonSpare_1278, "BVR": NonSpare_698, "GVR": NonSpare_1051, "GV": NonSpare_1047, "TAR": NonSpare_1827, "TI2": NonSpare_1861, "TS": NonSpare_1925, "MET": NonSpare_1271, "ROA": NonSpare_1600, "ARA": NonSpare_624, "SCC": NonSpare_1667}

    @overload
    @classmethod
    def spec(cls, key : Literal["AOS"]) -> NonSpare_613:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRD"]) -> NonSpare_1913:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3A"]) -> NonSpare_1217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QI"]) -> NonSpare_1527:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI1"]) -> NonSpare_1860:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAM"]) -> NonSpare_1228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GH"]) -> NonSpare_1034:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> NonSpare_975:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ISA"]) -> NonSpare_1128:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSA"]) -> NonSpare_999:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> NonSpare_634:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1830:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MH"]) -> NonSpare_1278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_698:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1051:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GV"]) -> NonSpare_1047:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI2"]) -> NonSpare_1861:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> NonSpare_1925:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ROA"]) -> NonSpare_1600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARA"]) -> NonSpare_624:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SCC"]) -> NonSpare_1667:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AOS"], Literal["TRD"], Literal["M3A"], Literal["QI"], Literal["TI1"], Literal["MAM"], Literal["GH"], Literal["FL"], Literal["ISA"], Literal["FSA"], Literal["AS"], Literal["TAS"], Literal["MH"], Literal["BVR"], Literal["GVR"], Literal["GV"], Literal["TAR"], Literal["TI2"], Literal["TS"], Literal["MET"], Literal["ROA"], Literal["ARA"], Literal["SCC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AOS"]) -> Optional[NonSpare_613]:
        ...
    @overload
    def get_item(self, key : Literal["TRD"]) -> Optional[NonSpare_1913]:
        ...
    @overload
    def get_item(self, key : Literal["M3A"]) -> Optional[NonSpare_1217]:
        ...
    @overload
    def get_item(self, key : Literal["QI"]) -> Optional[NonSpare_1527]:
        ...
    @overload
    def get_item(self, key : Literal["TI1"]) -> Optional[NonSpare_1860]:
        ...
    @overload
    def get_item(self, key : Literal["MAM"]) -> Optional[NonSpare_1228]:
        ...
    @overload
    def get_item(self, key : Literal["GH"]) -> Optional[NonSpare_1034]:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> Optional[NonSpare_975]:
        ...
    @overload
    def get_item(self, key : Literal["ISA"]) -> Optional[NonSpare_1128]:
        ...
    @overload
    def get_item(self, key : Literal["FSA"]) -> Optional[NonSpare_999]:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> Optional[NonSpare_634]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1830]:
        ...
    @overload
    def get_item(self, key : Literal["MH"]) -> Optional[NonSpare_1278]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_698]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1051]:
        ...
    @overload
    def get_item(self, key : Literal["GV"]) -> Optional[NonSpare_1047]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1827]:
        ...
    @overload
    def get_item(self, key : Literal["TI2"]) -> Optional[NonSpare_1861]:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> Optional[NonSpare_1925]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1271]:
        ...
    @overload
    def get_item(self, key : Literal["ROA"]) -> Optional[NonSpare_1600]:
        ...
    @overload
    def get_item(self, key : Literal["ARA"]) -> Optional[NonSpare_624]:
        ...
    @overload
    def get_item(self, key : Literal["SCC"]) -> Optional[NonSpare_1667]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AOS"], val : NonSpare_613.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["TRD"], val : NonSpare_1913.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["M3A"], val : NonSpare_1217.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["QI"], val : NonSpare_1527.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["TI1"], val : NonSpare_1860.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["MAM"], val : NonSpare_1228.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["GH"], val : NonSpare_1034.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["FL"], val : NonSpare_975.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["ISA"], val : NonSpare_1128.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["FSA"], val : NonSpare_999.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["AS"], val : NonSpare_634.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1830.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["MH"], val : NonSpare_1278.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_698.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1051.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["GV"], val : NonSpare_1047.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1827.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["TI2"], val : NonSpare_1861.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["TS"], val : NonSpare_1925.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1271.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["ROA"], val : NonSpare_1600.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["ARA"], val : NonSpare_624.cv_arg) -> "Variation_1473":
        ...
    @overload
    def set_item(self, key : Literal["SCC"], val : NonSpare_1667.cv_arg) -> "Variation_1473":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AOS"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["TRD"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["M3A"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["QI"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["TI1"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["MAM"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["GH"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["FL"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["ISA"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["FSA"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["AS"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["MH"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["GV"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["TI2"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["TS"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["ROA"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["ARA"]) -> "Variation_1473":
        ...
    @overload
    def del_item(self, key : Literal["SCC"]) -> "Variation_1473":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1473.cv_arg") -> 'Variation_1473':
        return cls._create(arg) # type: ignore

class RuleVariation_1394(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1473.cv_arg
    cv_variation: TypeAlias = Variation_1473

    @classmethod
    def create(cls, arg : "RuleVariation_1394.cv_arg") -> "RuleVariation_1394":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1473:
        return self.arg # type: ignore

class NonSpare_471(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1394.cv_arg
    cv_name = "295"
    cv_title = "Data Ages"
    cv_rule: TypeAlias = RuleVariation_1394

    @classmethod
    def create(cls, arg : "NonSpare_471.cv_arg") -> "NonSpare_471":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1394:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1473:
        return self.rule.variation

class UapItem_471(UapItem):
    cv_non_spare: TypeAlias = NonSpare_471

class Record_7(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_148.cv_arg,
        "161": NonSpare_365.cv_arg,
        "015": NonSpare_64.cv_arg,
        "071": NonSpare_222.cv_arg,
        "130": NonSpare_310.cv_arg,
        "131": NonSpare_315.cv_arg,
        "072": NonSpare_223.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_350.cv_arg,
        "080": NonSpare_237.cv_arg,
        "073": NonSpare_224.cv_arg,
        "074": NonSpare_226.cv_arg,
        "075": NonSpare_227.cv_arg,
        "076": NonSpare_229.cv_arg,
        "140": NonSpare_324.cv_arg,
        "090": NonSpare_255.cv_arg,
        "210": NonSpare_414.cv_arg,
        "070": NonSpare_208.cv_arg,
        "230": NonSpare_433.cv_arg,
        "145": NonSpare_338.cv_arg,
        "152": NonSpare_352.cv_arg,
        "200": NonSpare_399.cv_arg,
        "155": NonSpare_354.cv_arg,
        "157": NonSpare_356.cv_arg,
        "160": NonSpare_357.cv_arg,
        "165": NonSpare_369.cv_arg,
        "077": NonSpare_231.cv_arg,
        "170": NonSpare_373.cv_arg,
        "020": NonSpare_79.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_341.cv_arg,
        "148": NonSpare_343.cv_arg,
        "110": NonSpare_293.cv_arg,
        "016": NonSpare_72.cv_arg,
        "008": NonSpare_27.cv_arg,
        "271": NonSpare_465.cv_arg,
        "132": NonSpare_318.cv_arg,
        "250": NonSpare_447.cv_arg,
        "260": NonSpare_459.cv_arg,
        "400": NonSpare_500.cv_arg,
        "295": NonSpare_471.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_29, UapItem_148, UapItem_365, UapItem_64, UapItem_222, UapItem_310, UapItem_315, UapItem_223, UapItem_344, UapItem_350, UapItem_237, UapItem_224, UapItem_226, UapItem_227, UapItem_229, UapItem_324, UapItem_255, UapItem_414, UapItem_208, UapItem_433, UapItem_338, UapItem_352, UapItem_399, UapItem_354, UapItem_356, UapItem_357, UapItem_369, UapItem_231, UapItem_373, UapItem_79, UapItem_424, UapItem_341, UapItem_343, UapItem_293, UapItem_72, UapItem_27, UapItem_465, UapItem_318, UapItem_447, UapItem_459, UapItem_499, UapItem_471, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_148, "161": NonSpare_365, "015": NonSpare_64, "071": NonSpare_222, "130": NonSpare_310, "131": NonSpare_315, "072": NonSpare_223, "150": NonSpare_344, "151": NonSpare_350, "080": NonSpare_237, "073": NonSpare_224, "074": NonSpare_226, "075": NonSpare_227, "076": NonSpare_229, "140": NonSpare_324, "090": NonSpare_255, "210": NonSpare_414, "070": NonSpare_208, "230": NonSpare_433, "145": NonSpare_338, "152": NonSpare_352, "200": NonSpare_399, "155": NonSpare_354, "157": NonSpare_356, "160": NonSpare_357, "165": NonSpare_369, "077": NonSpare_231, "170": NonSpare_373, "020": NonSpare_79, "220": NonSpare_424, "146": NonSpare_341, "148": NonSpare_343, "110": NonSpare_293, "016": NonSpare_72, "008": NonSpare_27, "271": NonSpare_465, "132": NonSpare_318, "250": NonSpare_447, "260": NonSpare_459, "400": NonSpare_500, "295": NonSpare_471, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_148:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_255:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_399:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_354:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_72:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_27:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_465:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_459:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_500:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_148]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_365]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_64]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_224]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_226]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_324]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_255]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_414]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_208]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_433]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_399]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_354]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_357]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_369]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_231]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_343]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_72]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_27]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_465]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_447]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_459]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_500]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_471]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_148.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_365.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_64.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_222.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_310.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_315.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_223.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_350.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_224.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_226.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_227.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_229.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_324.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_255.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_414.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_208.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_433.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_352.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_399.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_354.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_356.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_357.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_369.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_231.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_341.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_343.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_72.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_27.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_465.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_318.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_447.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_459.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_500.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_471.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_7':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_7':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_7':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_7':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_7.cv_arg") -> 'Record_7':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_7", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_7(UapSingle):
    cv_arg: TypeAlias = Record_7
    cv_record: TypeAlias = Record_7

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_7]]:
        return cls._parse(bs)

class Asterix_30(AstCat):
    cv_category = 21
    cv_edition = (2, 1)
    cv_uap: TypeAlias = Uap_7
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_7.cv_arg]) -> "Asterix_30":
        return cls._create(records) # type: ignore

class NonSpare_256(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1298.cv_arg
    cv_name = "090"
    cv_title = "Quality Indicators"
    cv_rule: TypeAlias = RuleVariation_1298

    @classmethod
    def create(cls, arg : "NonSpare_256.cv_arg") -> "NonSpare_256":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1298:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1377:
        return self.rule.variation

class UapItem_256(UapItem):
    cv_non_spare: TypeAlias = NonSpare_256

class Content_367(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No military emergency", 1: "Military emergency"}

class RuleContent_367(RuleContentContextFree):
    cv_arg: TypeAlias = Content_367.cv_arg
    cv_content: TypeAlias = Content_367

    @property
    def content(self) -> Content_367:
        return self._get_content() # type: ignore

class Variation_563(Element):
    cv_arg: TypeAlias = RuleContent_367.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_367

    @classmethod
    def create(cls, arg: "Variation_563.cv_arg") -> "Variation_563":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_367:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_367:
        return self.rule.content

class RuleVariation_552(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_563.cv_arg
    cv_variation: TypeAlias = Variation_563

    @classmethod
    def create(cls, arg : "RuleVariation_552.cv_arg") -> "RuleVariation_552":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_563:
        return self.arg # type: ignore

class NonSpare_1269(NonSpare):
    cv_arg: TypeAlias = RuleVariation_552.cv_arg
    cv_name = "ME"
    cv_title = "Military Emergency"
    cv_rule: TypeAlias = RuleVariation_552

    @classmethod
    def create(cls, arg : "NonSpare_1269.cv_arg") -> "NonSpare_1269":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_552:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_563:
        return self.rule.variation

class Item_547(Item):
    cv_arg: TypeAlias = NonSpare_1269.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1269

    @classmethod
    def create(cls, arg : "Item_547.cv_arg") -> "Item_547":
        return cls._create(arg) # type: ignore

class Variation_1119(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_62.cv_arg, Tuple[Literal["ICF"], RuleVariation_62.cv_arg]], Union[RuleVariation_423.cv_arg, Tuple[Literal["LNAV"], RuleVariation_423.cv_arg]], Union[RuleVariation_552.cv_arg, Tuple[Literal["ME"], RuleVariation_552.cv_arg]], Union[RuleVariation_677.cv_arg, Tuple[Literal["PS"], RuleVariation_677.cv_arg]], Union[RuleVariation_932.cv_arg, Tuple[Literal["SS"], RuleVariation_932.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1119.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_425, 1), (Item_483, 1), (Item_547, 1), (Item_711, 3), (Item_925, 2)]
    cv_items_dict = {"ICF": RuleVariation_62, "LNAV": RuleVariation_423, "ME": RuleVariation_552, "PS": RuleVariation_677, "SS": RuleVariation_932}

    @overload
    @classmethod
    def spec(cls, key : Literal["ICF"]) -> RuleVariation_62:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LNAV"]) -> RuleVariation_423:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ME"]) -> RuleVariation_552:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PS"]) -> RuleVariation_677:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SS"]) -> RuleVariation_932:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ICF"], Literal["LNAV"], Literal["ME"], Literal["PS"], Literal["SS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ICF"]) -> RuleVariation_62:
        ...
    @overload
    def get_item(self, key : Literal["LNAV"]) -> RuleVariation_423:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> RuleVariation_552:
        ...
    @overload
    def get_item(self, key : Literal["PS"]) -> RuleVariation_677:
        ...
    @overload
    def get_item(self, key : Literal["SS"]) -> RuleVariation_932:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1119.cv_arg") -> 'Variation_1119':
        return cls._create(arg) # type: ignore

class RuleVariation_1076(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1119.cv_arg
    cv_variation: TypeAlias = Variation_1119

    @classmethod
    def create(cls, arg : "RuleVariation_1076.cv_arg") -> "RuleVariation_1076":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1119:
        return self.arg # type: ignore

class NonSpare_400(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1076.cv_arg
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule: TypeAlias = RuleVariation_1076

    @classmethod
    def create(cls, arg : "NonSpare_400.cv_arg") -> "NonSpare_400":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1076:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1119:
        return self.rule.variation

class UapItem_400(UapItem):
    cv_non_spare: TypeAlias = NonSpare_400

class NonSpare_1203(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "LW"
    cv_title = "Length and Width of the Aircraft"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_1203.cv_arg") -> "NonSpare_1203":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_511(Item):
    cv_arg: TypeAlias = NonSpare_1203.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1203

    @classmethod
    def create(cls, arg : "Item_511.cv_arg") -> "Item_511":
        return cls._create(arg) # type: ignore

class Variation_1344(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_562.cv_arg, Tuple[Literal["POA"], RuleVariation_562.cv_arg]], Union[RuleVariation_609.cv_arg, Tuple[Literal["CDTIS"], RuleVariation_609.cv_arg]], Union[RuleVariation_689.cv_arg, Tuple[Literal["B2LOW"], RuleVariation_689.cv_arg]], Union[RuleVariation_792.cv_arg, Tuple[Literal["RAS"], RuleVariation_792.cv_arg]], Union[RuleVariation_904.cv_arg, Tuple[Literal["IDENT"], RuleVariation_904.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["LW"], RuleVariation_132.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1344.cv_arg_group_1"],
        Tuple["Variation_1344.cv_arg_group_1", "Variation_1344.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_1, 2), (Item_689, 1), (Item_144, 1), (Item_113, 1), (Item_779, 1), (Item_431, 1), None], [(Item_511, 4), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1344.cv_arg") -> 'Variation_1344':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["POA"]) -> RuleVariation_562:
        ...
    @overload
    def get_item(self, key : Literal["CDTIS"]) -> RuleVariation_609:
        ...
    @overload
    def get_item(self, key : Literal["B2LOW"]) -> RuleVariation_689:
        ...
    @overload
    def get_item(self, key : Literal["RAS"]) -> RuleVariation_792:
        ...
    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_904:
        ...
    @overload
    def get_item(self, key : Literal["LW"]) -> Optional[RuleVariation_132]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1265(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1344.cv_arg
    cv_variation: TypeAlias = Variation_1344

    @classmethod
    def create(cls, arg : "RuleVariation_1265.cv_arg") -> "RuleVariation_1265":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1344:
        return self.arg # type: ignore

class NonSpare_466(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1265.cv_arg
    cv_name = "271"
    cv_title = "Surface Capabilities and Characteristics"
    cv_rule: TypeAlias = RuleVariation_1265

    @classmethod
    def create(cls, arg : "NonSpare_466.cv_arg") -> "NonSpare_466":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1265:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1344:
        return self.rule.variation

class UapItem_466(UapItem):
    cv_non_spare: TypeAlias = NonSpare_466

class NonSpare_456(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1174.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_1174

    @classmethod
    def create(cls, arg : "NonSpare_456.cv_arg") -> "NonSpare_456":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1238:
        return self.rule.variation

class UapItem_456(UapItem):
    cv_non_spare: TypeAlias = NonSpare_456

class Record_8(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_148.cv_arg,
        "161": NonSpare_365.cv_arg,
        "015": NonSpare_64.cv_arg,
        "071": NonSpare_222.cv_arg,
        "130": NonSpare_310.cv_arg,
        "131": NonSpare_315.cv_arg,
        "072": NonSpare_223.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_350.cv_arg,
        "080": NonSpare_237.cv_arg,
        "073": NonSpare_224.cv_arg,
        "074": NonSpare_226.cv_arg,
        "075": NonSpare_227.cv_arg,
        "076": NonSpare_229.cv_arg,
        "140": NonSpare_324.cv_arg,
        "090": NonSpare_256.cv_arg,
        "210": NonSpare_414.cv_arg,
        "070": NonSpare_208.cv_arg,
        "230": NonSpare_433.cv_arg,
        "145": NonSpare_338.cv_arg,
        "152": NonSpare_352.cv_arg,
        "200": NonSpare_400.cv_arg,
        "155": NonSpare_354.cv_arg,
        "157": NonSpare_356.cv_arg,
        "160": NonSpare_357.cv_arg,
        "165": NonSpare_369.cv_arg,
        "077": NonSpare_231.cv_arg,
        "170": NonSpare_373.cv_arg,
        "020": NonSpare_79.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_341.cv_arg,
        "148": NonSpare_343.cv_arg,
        "110": NonSpare_293.cv_arg,
        "016": NonSpare_72.cv_arg,
        "008": NonSpare_27.cv_arg,
        "271": NonSpare_466.cv_arg,
        "132": NonSpare_318.cv_arg,
        "250": NonSpare_447.cv_arg,
        "260": NonSpare_456.cv_arg,
        "400": NonSpare_500.cv_arg,
        "295": NonSpare_471.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_29, UapItem_148, UapItem_365, UapItem_64, UapItem_222, UapItem_310, UapItem_315, UapItem_223, UapItem_344, UapItem_350, UapItem_237, UapItem_224, UapItem_226, UapItem_227, UapItem_229, UapItem_324, UapItem_256, UapItem_414, UapItem_208, UapItem_433, UapItem_338, UapItem_352, UapItem_400, UapItem_354, UapItem_356, UapItem_357, UapItem_369, UapItem_231, UapItem_373, UapItem_79, UapItem_424, UapItem_341, UapItem_343, UapItem_293, UapItem_72, UapItem_27, UapItem_466, UapItem_318, UapItem_447, UapItem_456, UapItem_499, UapItem_471, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_148, "161": NonSpare_365, "015": NonSpare_64, "071": NonSpare_222, "130": NonSpare_310, "131": NonSpare_315, "072": NonSpare_223, "150": NonSpare_344, "151": NonSpare_350, "080": NonSpare_237, "073": NonSpare_224, "074": NonSpare_226, "075": NonSpare_227, "076": NonSpare_229, "140": NonSpare_324, "090": NonSpare_256, "210": NonSpare_414, "070": NonSpare_208, "230": NonSpare_433, "145": NonSpare_338, "152": NonSpare_352, "200": NonSpare_400, "155": NonSpare_354, "157": NonSpare_356, "160": NonSpare_357, "165": NonSpare_369, "077": NonSpare_231, "170": NonSpare_373, "020": NonSpare_79, "220": NonSpare_424, "146": NonSpare_341, "148": NonSpare_343, "110": NonSpare_293, "016": NonSpare_72, "008": NonSpare_27, "271": NonSpare_466, "132": NonSpare_318, "250": NonSpare_447, "260": NonSpare_456, "400": NonSpare_500, "295": NonSpare_471, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_148:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_256:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_400:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_354:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_72:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_27:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_456:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_500:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_148]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_365]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_64]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_224]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_226]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_324]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_256]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_414]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_208]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_433]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_400]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_354]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_357]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_369]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_231]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_343]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_72]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_27]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_447]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_456]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_500]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_471]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_148.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_365.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_64.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_222.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_310.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_315.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_223.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_350.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_224.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_226.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_227.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_229.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_324.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_256.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_414.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_208.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_433.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_352.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_400.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_354.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_356.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_357.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_369.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_231.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_341.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_343.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_72.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_27.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_466.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_318.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_447.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_456.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_500.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_471.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_8':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_8':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_8':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_8':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_8.cv_arg") -> 'Record_8':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_8", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_8(UapSingle):
    cv_arg: TypeAlias = Record_8
    cv_record: TypeAlias = Record_8

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_8]]:
        return cls._parse(bs)

class Asterix_31(AstCat):
    cv_category = 21
    cv_edition = (2, 2)
    cv_uap: TypeAlias = Uap_8
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_8.cv_arg]) -> "Asterix_31":
        return cls._create(records) # type: ignore

class Content_113(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "List Lookup failed (see note)"}

class RuleContent_113(RuleContentContextFree):
    cv_arg: TypeAlias = Content_113.cv_arg
    cv_content: TypeAlias = Content_113

    @property
    def content(self) -> Content_113:
        return self._get_content() # type: ignore

class Variation_412(Element):
    cv_arg: TypeAlias = RuleContent_113.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_113

    @classmethod
    def create(cls, arg: "Variation_412.cv_arg") -> "Variation_412":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_113:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_113:
        return self.rule.content

class RuleVariation_401(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_412.cv_arg
    cv_variation: TypeAlias = Variation_412

    @classmethod
    def create(cls, arg : "RuleVariation_401.cv_arg") -> "RuleVariation_401":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_412:
        return self.arg # type: ignore

class NonSpare_1171(NonSpare):
    cv_arg: TypeAlias = RuleVariation_401.cv_arg
    cv_name = "LLC"
    cv_title = "List Lookup Check"
    cv_rule: TypeAlias = RuleVariation_401

    @classmethod
    def create(cls, arg : "NonSpare_1171.cv_arg") -> "NonSpare_1171":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_401:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_412:
        return self.rule.variation

class Item_481(Item):
    cv_arg: TypeAlias = NonSpare_1171.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1171

    @classmethod
    def create(cls, arg : "Item_481.cv_arg") -> "Item_481":
        return cls._create(arg) # type: ignore

class Variation_1347(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_122.cv_arg, Tuple[Literal["ATP"], RuleVariation_122.cv_arg]], Union[RuleVariation_666.cv_arg, Tuple[Literal["ARC"], RuleVariation_666.cv_arg]], Union[RuleVariation_805.cv_arg, Tuple[Literal["RC"], RuleVariation_805.cv_arg]], Union[RuleVariation_919.cv_arg, Tuple[Literal["RAB"], RuleVariation_919.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_61.cv_arg, Tuple[Literal["DCR"], RuleVariation_61.cv_arg]], Union[RuleVariation_418.cv_arg, Tuple[Literal["GBS"], RuleVariation_418.cv_arg]], Union[RuleVariation_497.cv_arg, Tuple[Literal["SIM"], RuleVariation_497.cv_arg]], Union[RuleVariation_622.cv_arg, Tuple[Literal["TST"], RuleVariation_622.cv_arg]], Union[RuleVariation_711.cv_arg, Tuple[Literal["SAA"], RuleVariation_711.cv_arg]], Union[RuleVariation_853.cv_arg, Tuple[Literal["CL"], RuleVariation_853.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_401.cv_arg, Tuple[Literal["LLC"], RuleVariation_401.cv_arg]], Union[RuleVariation_515.cv_arg, Tuple[Literal["IPC"], RuleVariation_515.cv_arg]], Union[RuleVariation_639.cv_arg, Tuple[Literal["NOGO"], RuleVariation_639.cv_arg]], Union[RuleVariation_691.cv_arg, Tuple[Literal["CPR"], RuleVariation_691.cv_arg]], Union[RuleVariation_828.cv_arg, Tuple[Literal["LDPJ"], RuleVariation_828.cv_arg]], Union[RuleVariation_888.cv_arg, Tuple[Literal["RCF"], RuleVariation_888.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1347.cv_arg_group_1"],
        Tuple["Variation_1347.cv_arg_group_1", "Variation_1347.cv_arg_group_2"],
        Tuple["Variation_1347.cv_arg_group_1", "Variation_1347.cv_arg_group_2", "Variation_1347.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_90, 3), (Item_82, 2), (Item_781, 1), (Item_772, 1), None], [(Item_254, 1), (Item_369, 1), (Item_903, 1), (Item_1056, 1), (Item_853, 1), (Item_161, 2), None], [(Item_0, 1), (Item_481, 1), (Item_437, 1), (Item_626, 1), (Item_211, 1), (Item_477, 1), (Item_785, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1347.cv_arg") -> 'Variation_1347':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_122:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_666:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_805:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_919:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> Optional[RuleVariation_61]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_418]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_497]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_622]:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> Optional[RuleVariation_711]:
        ...
    @overload
    def get_item(self, key : Literal["CL"]) -> Optional[RuleVariation_853]:
        ...
    @overload
    def get_item(self, key : Literal["LLC"]) -> Optional[RuleVariation_401]:
        ...
    @overload
    def get_item(self, key : Literal["IPC"]) -> Optional[RuleVariation_515]:
        ...
    @overload
    def get_item(self, key : Literal["NOGO"]) -> Optional[RuleVariation_639]:
        ...
    @overload
    def get_item(self, key : Literal["CPR"]) -> Optional[RuleVariation_691]:
        ...
    @overload
    def get_item(self, key : Literal["LDPJ"]) -> Optional[RuleVariation_828]:
        ...
    @overload
    def get_item(self, key : Literal["RCF"]) -> Optional[RuleVariation_888]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1268(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1347.cv_arg
    cv_variation: TypeAlias = Variation_1347

    @classmethod
    def create(cls, arg : "RuleVariation_1268.cv_arg") -> "RuleVariation_1268":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1347:
        return self.arg # type: ignore

class NonSpare_146(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1268.cv_arg
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1268

    @classmethod
    def create(cls, arg : "NonSpare_146.cv_arg") -> "NonSpare_146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1268:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1347:
        return self.rule.variation

class UapItem_146(UapItem):
    cv_non_spare: TypeAlias = NonSpare_146

class Record_5(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_146.cv_arg,
        "161": NonSpare_365.cv_arg,
        "015": NonSpare_64.cv_arg,
        "071": NonSpare_222.cv_arg,
        "130": NonSpare_310.cv_arg,
        "131": NonSpare_315.cv_arg,
        "072": NonSpare_223.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_350.cv_arg,
        "080": NonSpare_237.cv_arg,
        "073": NonSpare_224.cv_arg,
        "074": NonSpare_226.cv_arg,
        "075": NonSpare_227.cv_arg,
        "076": NonSpare_229.cv_arg,
        "140": NonSpare_324.cv_arg,
        "090": NonSpare_256.cv_arg,
        "210": NonSpare_414.cv_arg,
        "070": NonSpare_208.cv_arg,
        "230": NonSpare_433.cv_arg,
        "145": NonSpare_338.cv_arg,
        "152": NonSpare_352.cv_arg,
        "200": NonSpare_400.cv_arg,
        "155": NonSpare_354.cv_arg,
        "157": NonSpare_356.cv_arg,
        "160": NonSpare_357.cv_arg,
        "165": NonSpare_369.cv_arg,
        "077": NonSpare_231.cv_arg,
        "170": NonSpare_373.cv_arg,
        "020": NonSpare_79.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_341.cv_arg,
        "148": NonSpare_343.cv_arg,
        "110": NonSpare_293.cv_arg,
        "016": NonSpare_72.cv_arg,
        "008": NonSpare_27.cv_arg,
        "271": NonSpare_466.cv_arg,
        "132": NonSpare_318.cv_arg,
        "250": NonSpare_447.cv_arg,
        "260": NonSpare_456.cv_arg,
        "400": NonSpare_500.cv_arg,
        "295": NonSpare_471.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_29, UapItem_146, UapItem_365, UapItem_64, UapItem_222, UapItem_310, UapItem_315, UapItem_223, UapItem_344, UapItem_350, UapItem_237, UapItem_224, UapItem_226, UapItem_227, UapItem_229, UapItem_324, UapItem_256, UapItem_414, UapItem_208, UapItem_433, UapItem_338, UapItem_352, UapItem_400, UapItem_354, UapItem_356, UapItem_357, UapItem_369, UapItem_231, UapItem_373, UapItem_79, UapItem_424, UapItem_341, UapItem_343, UapItem_293, UapItem_72, UapItem_27, UapItem_466, UapItem_318, UapItem_447, UapItem_456, UapItem_499, UapItem_471, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_146, "161": NonSpare_365, "015": NonSpare_64, "071": NonSpare_222, "130": NonSpare_310, "131": NonSpare_315, "072": NonSpare_223, "150": NonSpare_344, "151": NonSpare_350, "080": NonSpare_237, "073": NonSpare_224, "074": NonSpare_226, "075": NonSpare_227, "076": NonSpare_229, "140": NonSpare_324, "090": NonSpare_256, "210": NonSpare_414, "070": NonSpare_208, "230": NonSpare_433, "145": NonSpare_338, "152": NonSpare_352, "200": NonSpare_400, "155": NonSpare_354, "157": NonSpare_356, "160": NonSpare_357, "165": NonSpare_369, "077": NonSpare_231, "170": NonSpare_373, "020": NonSpare_79, "220": NonSpare_424, "146": NonSpare_341, "148": NonSpare_343, "110": NonSpare_293, "016": NonSpare_72, "008": NonSpare_27, "271": NonSpare_466, "132": NonSpare_318, "250": NonSpare_447, "260": NonSpare_456, "400": NonSpare_500, "295": NonSpare_471, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_146:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_237:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_256:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_414:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_400:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_354:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_72:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_27:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_456:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_500:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_146]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_365]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_64]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_237]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_224]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_226]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_324]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_256]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_414]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_208]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_433]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_400]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_354]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_357]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_369]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_231]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_343]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_72]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_27]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_447]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_456]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_500]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_471]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_146.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_365.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_64.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_222.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_310.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_315.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_223.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_350.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_237.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_224.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_226.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_227.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_229.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_324.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_256.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_414.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_208.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_433.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_352.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_400.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_354.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_356.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_357.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_369.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_231.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_341.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_343.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_72.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_27.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_466.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_318.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_447.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_456.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_500.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_471.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_5':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_5':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_5':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_5':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_5.cv_arg") -> 'Record_5':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_5", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_5(UapSingle):
    cv_arg: TypeAlias = Record_5
    cv_record: TypeAlias = Record_5

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_5]]:
        return cls._parse(bs)

class Asterix_32(AstCat):
    cv_category = 21
    cv_edition = (2, 3)
    cv_uap: TypeAlias = Uap_5
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_5.cv_arg]) -> "Asterix_32":
        return cls._create(records) # type: ignore

class Asterix_33(AstCat):
    cv_category = 21
    cv_edition = (2, 4)
    cv_uap: TypeAlias = Uap_5
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_5.cv_arg]) -> "Asterix_33":
        return cls._create(records) # type: ignore

class NonSpare_145(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1268.cv_arg
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1268

    @classmethod
    def create(cls, arg : "NonSpare_145.cv_arg") -> "NonSpare_145":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1268:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1347:
        return self.rule.variation

class UapItem_145(UapItem):
    cv_non_spare: TypeAlias = NonSpare_145

class NonSpare_238(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "080"
    cv_title = "Target Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_238.cv_arg") -> "NonSpare_238":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_238(UapItem):
    cv_non_spare: TypeAlias = NonSpare_238

class Content_201(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "ED102/DO-260 [Ref. 7]", 1: "DO-260A [Ref. 8]", 2: "ED102A/DO-260B [Ref. 10]", 3: "ED-102B/DO-260C [Ref. 11]"}

class RuleContent_201(RuleContentContextFree):
    cv_arg: TypeAlias = Content_201.cv_arg
    cv_content: TypeAlias = Content_201

    @property
    def content(self) -> Content_201:
        return self._get_content() # type: ignore

class Variation_598(Element):
    cv_arg: TypeAlias = RuleContent_201.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_201

    @classmethod
    def create(cls, arg: "Variation_598.cv_arg") -> "Variation_598":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_201:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_201:
        return self.rule.content

class RuleVariation_587(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_598.cv_arg
    cv_variation: TypeAlias = Variation_598

    @classmethod
    def create(cls, arg : "RuleVariation_587.cv_arg") -> "RuleVariation_587":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_598:
        return self.arg # type: ignore

class NonSpare_2034(NonSpare):
    cv_arg: TypeAlias = RuleVariation_587.cv_arg
    cv_name = "VN"
    cv_title = "Version Number"
    cv_rule: TypeAlias = RuleVariation_587

    @classmethod
    def create(cls, arg : "NonSpare_2034.cv_arg") -> "NonSpare_2034":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_587:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_598:
        return self.rule.variation

class Item_1143(Item):
    cv_arg: TypeAlias = NonSpare_2034.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2034

    @classmethod
    def create(cls, arg : "Item_1143.cv_arg") -> "Item_1143":
        return cls._create(arg) # type: ignore

class Variation_1002(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_444.cv_arg, Tuple[Literal["VNS"], RuleVariation_444.cv_arg]], Union[RuleVariation_587.cv_arg, Tuple[Literal["VN"], RuleVariation_587.cv_arg]], Union[RuleVariation_862.cv_arg, Tuple[Literal["LTT"], RuleVariation_862.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1002.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_1146, 1), (Item_1143, 3), (Item_509, 3)]
    cv_items_dict = {"VNS": RuleVariation_444, "VN": RuleVariation_587, "LTT": RuleVariation_862}

    @overload
    @classmethod
    def spec(cls, key : Literal["VNS"]) -> RuleVariation_444:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VN"]) -> RuleVariation_587:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTT"]) -> RuleVariation_862:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VNS"], Literal["VN"], Literal["LTT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VNS"]) -> RuleVariation_444:
        ...
    @overload
    def get_item(self, key : Literal["VN"]) -> RuleVariation_587:
        ...
    @overload
    def get_item(self, key : Literal["LTT"]) -> RuleVariation_862:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1002.cv_arg") -> 'Variation_1002':
        return cls._create(arg) # type: ignore

class RuleVariation_972(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1002.cv_arg
    cv_variation: TypeAlias = Variation_1002

    @classmethod
    def create(cls, arg : "RuleVariation_972.cv_arg") -> "RuleVariation_972":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1002:
        return self.arg # type: ignore

class NonSpare_413(NonSpare):
    cv_arg: TypeAlias = RuleVariation_972.cv_arg
    cv_name = "210"
    cv_title = "MOPS Version"
    cv_rule: TypeAlias = RuleVariation_972

    @classmethod
    def create(cls, arg : "NonSpare_413.cv_arg") -> "NonSpare_413":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_972:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1002:
        return self.rule.variation

class UapItem_413(UapItem):
    cv_non_spare: TypeAlias = NonSpare_413

class NonSpare_401(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1076.cv_arg
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule: TypeAlias = RuleVariation_1076

    @classmethod
    def create(cls, arg : "NonSpare_401.cv_arg") -> "NonSpare_401":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1076:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1119:
        return self.rule.variation

class UapItem_401(UapItem):
    cv_non_spare: TypeAlias = NonSpare_401

class NonSpare_457(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1174.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_1174

    @classmethod
    def create(cls, arg : "NonSpare_457.cv_arg") -> "NonSpare_457":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1238:
        return self.rule.variation

class UapItem_457(UapItem):
    cv_non_spare: TypeAlias = NonSpare_457

class Record_4(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_145.cv_arg,
        "161": NonSpare_365.cv_arg,
        "015": NonSpare_64.cv_arg,
        "071": NonSpare_222.cv_arg,
        "130": NonSpare_310.cv_arg,
        "131": NonSpare_315.cv_arg,
        "072": NonSpare_223.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_350.cv_arg,
        "080": NonSpare_238.cv_arg,
        "073": NonSpare_224.cv_arg,
        "074": NonSpare_226.cv_arg,
        "075": NonSpare_227.cv_arg,
        "076": NonSpare_229.cv_arg,
        "140": NonSpare_324.cv_arg,
        "090": NonSpare_256.cv_arg,
        "210": NonSpare_413.cv_arg,
        "070": NonSpare_208.cv_arg,
        "230": NonSpare_433.cv_arg,
        "145": NonSpare_338.cv_arg,
        "152": NonSpare_352.cv_arg,
        "200": NonSpare_401.cv_arg,
        "155": NonSpare_354.cv_arg,
        "157": NonSpare_356.cv_arg,
        "160": NonSpare_357.cv_arg,
        "165": NonSpare_369.cv_arg,
        "077": NonSpare_231.cv_arg,
        "170": NonSpare_373.cv_arg,
        "020": NonSpare_79.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_341.cv_arg,
        "148": NonSpare_343.cv_arg,
        "110": NonSpare_293.cv_arg,
        "016": NonSpare_72.cv_arg,
        "008": NonSpare_27.cv_arg,
        "271": NonSpare_466.cv_arg,
        "132": NonSpare_318.cv_arg,
        "250": NonSpare_447.cv_arg,
        "260": NonSpare_457.cv_arg,
        "400": NonSpare_500.cv_arg,
        "295": NonSpare_471.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_29, UapItem_145, UapItem_365, UapItem_64, UapItem_222, UapItem_310, UapItem_315, UapItem_223, UapItem_344, UapItem_350, UapItem_238, UapItem_224, UapItem_226, UapItem_227, UapItem_229, UapItem_324, UapItem_256, UapItem_413, UapItem_208, UapItem_433, UapItem_338, UapItem_352, UapItem_401, UapItem_354, UapItem_356, UapItem_357, UapItem_369, UapItem_231, UapItem_373, UapItem_79, UapItem_424, UapItem_341, UapItem_343, UapItem_293, UapItem_72, UapItem_27, UapItem_466, UapItem_318, UapItem_447, UapItem_457, UapItem_499, UapItem_471, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_145, "161": NonSpare_365, "015": NonSpare_64, "071": NonSpare_222, "130": NonSpare_310, "131": NonSpare_315, "072": NonSpare_223, "150": NonSpare_344, "151": NonSpare_350, "080": NonSpare_238, "073": NonSpare_224, "074": NonSpare_226, "075": NonSpare_227, "076": NonSpare_229, "140": NonSpare_324, "090": NonSpare_256, "210": NonSpare_413, "070": NonSpare_208, "230": NonSpare_433, "145": NonSpare_338, "152": NonSpare_352, "200": NonSpare_401, "155": NonSpare_354, "157": NonSpare_356, "160": NonSpare_357, "165": NonSpare_369, "077": NonSpare_231, "170": NonSpare_373, "020": NonSpare_79, "220": NonSpare_424, "146": NonSpare_341, "148": NonSpare_343, "110": NonSpare_293, "016": NonSpare_72, "008": NonSpare_27, "271": NonSpare_466, "132": NonSpare_318, "250": NonSpare_447, "260": NonSpare_457, "400": NonSpare_500, "295": NonSpare_471, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_145:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_238:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_256:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_413:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_401:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_354:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_72:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_27:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_457:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_500:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_145]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_365]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_64]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_238]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_224]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_226]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_324]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_256]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_413]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_208]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_433]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_401]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_354]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_357]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_369]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_231]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_343]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_72]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_27]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_447]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_457]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_500]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_471]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_145.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_365.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_64.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_222.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_310.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_315.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_223.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_350.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_238.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_224.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_226.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_227.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_229.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_324.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_256.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_413.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_208.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_433.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_352.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_401.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_354.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_356.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_357.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_369.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_231.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_341.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_343.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_72.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_27.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_466.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_318.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_447.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_457.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_500.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_471.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_4':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_4':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_4':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_4':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_4.cv_arg") -> 'Record_4':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_4", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_4(UapSingle):
    cv_arg: TypeAlias = Record_4
    cv_record: TypeAlias = Record_4

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_4]]:
        return cls._parse(bs)

class Asterix_34(AstCat):
    cv_category = 21
    cv_edition = (2, 5)
    cv_uap: TypeAlias = Uap_4
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_4.cv_arg]) -> "Asterix_34":
        return cls._create(records) # type: ignore

class Variation_493(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 6
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_493.cv_arg") -> "Variation_493":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_482(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_493.cv_arg
    cv_variation: TypeAlias = Variation_493

    @classmethod
    def create(cls, arg : "RuleVariation_482.cv_arg") -> "RuleVariation_482":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_493:
        return self.arg # type: ignore

class NonSpare_2016(NonSpare):
    cv_arg: TypeAlias = RuleVariation_482.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_482

    @classmethod
    def create(cls, arg : "NonSpare_2016.cv_arg") -> "NonSpare_2016":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_482:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_493:
        return self.rule.variation

class Item_1126(Item):
    cv_arg: TypeAlias = NonSpare_2016.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2016

    @classmethod
    def create(cls, arg : "Item_1126.cv_arg") -> "Item_1126":
        return cls._create(arg) # type: ignore

class Variation_1100(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_482.cv_arg, Tuple[Literal["VAL"], RuleVariation_482.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1100.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_items_list = [(Item_302, 1), (Item_1126, 6)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_482}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_482:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_482:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1100.cv_arg") -> 'Variation_1100':
        return cls._create(arg) # type: ignore

class RuleVariation_1058(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1100.cv_arg
    cv_variation: TypeAlias = Variation_1100

    @classmethod
    def create(cls, arg : "RuleVariation_1058.cv_arg") -> "RuleVariation_1058":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1100:
        return self.arg # type: ignore

class NonSpare_2015(NonSpare):
    cv_arg: TypeAlias = RuleVariation_482.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_482

    @classmethod
    def create(cls, arg : "NonSpare_2015.cv_arg") -> "NonSpare_2015":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_482:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_493:
        return self.rule.variation

class Item_1125(Item):
    cv_arg: TypeAlias = NonSpare_2015.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2015

    @classmethod
    def create(cls, arg : "Item_1125.cv_arg") -> "Item_1125":
        return cls._create(arg) # type: ignore

class Variation_1099(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_482.cv_arg, Tuple[Literal["VAL"], RuleVariation_482.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1099.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_items_list = [(Item_302, 1), (Item_1125, 6)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_482}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_482:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_482:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1099.cv_arg") -> 'Variation_1099':
        return cls._create(arg) # type: ignore

class RuleVariation_1057(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1099.cv_arg
    cv_variation: TypeAlias = Variation_1099

    @classmethod
    def create(cls, arg : "RuleVariation_1057.cv_arg") -> "RuleVariation_1057":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1099:
        return self.arg # type: ignore

class NonSpare_1833(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1058.cv_arg
    cv_name = "TBC"
    cv_title = "Total Bits Corrected"
    cv_rule: TypeAlias = RuleVariation_1058

    @classmethod
    def create(cls, arg : "NonSpare_1833.cv_arg") -> "NonSpare_1833":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1058:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1100:
        return self.rule.variation

class Item_975(Item):
    cv_arg: TypeAlias = NonSpare_1833.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1833

    @classmethod
    def create(cls, arg : "Item_975.cv_arg") -> "Item_975":
        return cls._create(arg) # type: ignore

class NonSpare_1234(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1057.cv_arg
    cv_name = "MBC"
    cv_title = "Maximum Bits Corrected"
    cv_rule: TypeAlias = RuleVariation_1057

    @classmethod
    def create(cls, arg : "NonSpare_1234.cv_arg") -> "NonSpare_1234":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1057:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1099:
        return self.rule.variation

class Item_530(Item):
    cv_arg: TypeAlias = NonSpare_1234.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1234

    @classmethod
    def create(cls, arg : "Item_530.cv_arg") -> "Item_530":
        return cls._create(arg) # type: ignore

class Variation_1348(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_122.cv_arg, Tuple[Literal["ATP"], RuleVariation_122.cv_arg]], Union[RuleVariation_666.cv_arg, Tuple[Literal["ARC"], RuleVariation_666.cv_arg]], Union[RuleVariation_805.cv_arg, Tuple[Literal["RC"], RuleVariation_805.cv_arg]], Union[RuleVariation_919.cv_arg, Tuple[Literal["RAB"], RuleVariation_919.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_61.cv_arg, Tuple[Literal["DCR"], RuleVariation_61.cv_arg]], Union[RuleVariation_418.cv_arg, Tuple[Literal["GBS"], RuleVariation_418.cv_arg]], Union[RuleVariation_497.cv_arg, Tuple[Literal["SIM"], RuleVariation_497.cv_arg]], Union[RuleVariation_622.cv_arg, Tuple[Literal["TST"], RuleVariation_622.cv_arg]], Union[RuleVariation_711.cv_arg, Tuple[Literal["SAA"], RuleVariation_711.cv_arg]], Union[RuleVariation_853.cv_arg, Tuple[Literal["CL"], RuleVariation_853.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_401.cv_arg, Tuple[Literal["LLC"], RuleVariation_401.cv_arg]], Union[RuleVariation_515.cv_arg, Tuple[Literal["IPC"], RuleVariation_515.cv_arg]], Union[RuleVariation_639.cv_arg, Tuple[Literal["NOGO"], RuleVariation_639.cv_arg]], Union[RuleVariation_691.cv_arg, Tuple[Literal["CPR"], RuleVariation_691.cv_arg]], Union[RuleVariation_828.cv_arg, Tuple[Literal["LDPJ"], RuleVariation_828.cv_arg]], Union[RuleVariation_888.cv_arg, Tuple[Literal["RCF"], RuleVariation_888.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_1058.cv_arg, Tuple[Literal["TBC"], RuleVariation_1058.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_1057.cv_arg, Tuple[Literal["MBC"], RuleVariation_1057.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1348.cv_arg_group_1"],
        Tuple["Variation_1348.cv_arg_group_1", "Variation_1348.cv_arg_group_2"],
        Tuple["Variation_1348.cv_arg_group_1", "Variation_1348.cv_arg_group_2", "Variation_1348.cv_arg_group_3"],
        Tuple["Variation_1348.cv_arg_group_1", "Variation_1348.cv_arg_group_2", "Variation_1348.cv_arg_group_3", "Variation_1348.cv_arg_group_4"],
        Tuple["Variation_1348.cv_arg_group_1", "Variation_1348.cv_arg_group_2", "Variation_1348.cv_arg_group_3", "Variation_1348.cv_arg_group_4", "Variation_1348.cv_arg_group_5"],
    ]
    cv_items_list = [[(Item_90, 3), (Item_82, 2), (Item_781, 1), (Item_772, 1), None], [(Item_254, 1), (Item_369, 1), (Item_903, 1), (Item_1056, 1), (Item_853, 1), (Item_161, 2), None], [(Item_0, 1), (Item_481, 1), (Item_437, 1), (Item_626, 1), (Item_211, 1), (Item_477, 1), (Item_785, 1), None], [(Item_975, 7), None], [(Item_530, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1348.cv_arg") -> 'Variation_1348':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["ATP"]) -> RuleVariation_122:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_666:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_805:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_919:
        ...
    @overload
    def get_item(self, key : Literal["DCR"]) -> Optional[RuleVariation_61]:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> Optional[RuleVariation_418]:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_497]:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_622]:
        ...
    @overload
    def get_item(self, key : Literal["SAA"]) -> Optional[RuleVariation_711]:
        ...
    @overload
    def get_item(self, key : Literal["CL"]) -> Optional[RuleVariation_853]:
        ...
    @overload
    def get_item(self, key : Literal["LLC"]) -> Optional[RuleVariation_401]:
        ...
    @overload
    def get_item(self, key : Literal["IPC"]) -> Optional[RuleVariation_515]:
        ...
    @overload
    def get_item(self, key : Literal["NOGO"]) -> Optional[RuleVariation_639]:
        ...
    @overload
    def get_item(self, key : Literal["CPR"]) -> Optional[RuleVariation_691]:
        ...
    @overload
    def get_item(self, key : Literal["LDPJ"]) -> Optional[RuleVariation_828]:
        ...
    @overload
    def get_item(self, key : Literal["RCF"]) -> Optional[RuleVariation_888]:
        ...
    @overload
    def get_item(self, key : Literal["TBC"]) -> Optional[RuleVariation_1058]:
        ...
    @overload
    def get_item(self, key : Literal["MBC"]) -> Optional[RuleVariation_1057]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1269(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1348.cv_arg
    cv_variation: TypeAlias = Variation_1348

    @classmethod
    def create(cls, arg : "RuleVariation_1269.cv_arg") -> "RuleVariation_1269":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1348:
        return self.arg # type: ignore

class NonSpare_147(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1269.cv_arg
    cv_name = "040"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1269

    @classmethod
    def create(cls, arg : "NonSpare_147.cv_arg") -> "NonSpare_147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1269:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1348:
        return self.rule.variation

class UapItem_147(UapItem):
    cv_non_spare: TypeAlias = NonSpare_147

class NonSpare_402(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1076.cv_arg
    cv_name = "200"
    cv_title = "Target Status"
    cv_rule: TypeAlias = RuleVariation_1076

    @classmethod
    def create(cls, arg : "NonSpare_402.cv_arg") -> "NonSpare_402":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1076:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1119:
        return self.rule.variation

class UapItem_402(UapItem):
    cv_non_spare: TypeAlias = NonSpare_402

class NonSpare_458(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1174.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_1174

    @classmethod
    def create(cls, arg : "NonSpare_458.cv_arg") -> "NonSpare_458":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1238:
        return self.rule.variation

class UapItem_458(UapItem):
    cv_non_spare: TypeAlias = NonSpare_458

class NonSpare_1659(NonSpare):
    cv_arg: TypeAlias = RuleVariation_222.cv_arg
    cv_name = "SAL"
    cv_title = "Selected Altitude Age"
    cv_rule: TypeAlias = RuleVariation_222

    @classmethod
    def create(cls, arg : "NonSpare_1659.cv_arg") -> "NonSpare_1659":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_222:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_229:
        return self.rule.variation

class Variation_1474(Compound):
    cv_arg = TypedDict('cv_arg', {
        "AOS": NonSpare_613.cv_arg,
        "TRD": NonSpare_1913.cv_arg,
        "M3A": NonSpare_1217.cv_arg,
        "QI": NonSpare_1527.cv_arg,
        "TI1": NonSpare_1860.cv_arg,
        "MAM": NonSpare_1228.cv_arg,
        "GH": NonSpare_1034.cv_arg,
        "FL": NonSpare_975.cv_arg,
        "SAL": NonSpare_1659.cv_arg,
        "FSA": NonSpare_999.cv_arg,
        "AS": NonSpare_634.cv_arg,
        "TAS": NonSpare_1830.cv_arg,
        "MH": NonSpare_1278.cv_arg,
        "BVR": NonSpare_698.cv_arg,
        "GVR": NonSpare_1051.cv_arg,
        "GV": NonSpare_1047.cv_arg,
        "TAR": NonSpare_1827.cv_arg,
        "TI2": NonSpare_1861.cv_arg,
        "TS": NonSpare_1925.cv_arg,
        "MET": NonSpare_1271.cv_arg,
        "ROA": NonSpare_1600.cv_arg,
        "ARA": NonSpare_624.cv_arg,
        "SCC": NonSpare_1667.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_613, NonSpare_1913, NonSpare_1217, NonSpare_1527, NonSpare_1860, NonSpare_1228, NonSpare_1034, NonSpare_975, NonSpare_1659, NonSpare_999, NonSpare_634, NonSpare_1830, NonSpare_1278, NonSpare_698, NonSpare_1051, NonSpare_1047, NonSpare_1827, NonSpare_1861, NonSpare_1925, NonSpare_1271, NonSpare_1600, NonSpare_624, NonSpare_1667]
    cv_items_dict = {"AOS": NonSpare_613, "TRD": NonSpare_1913, "M3A": NonSpare_1217, "QI": NonSpare_1527, "TI1": NonSpare_1860, "MAM": NonSpare_1228, "GH": NonSpare_1034, "FL": NonSpare_975, "SAL": NonSpare_1659, "FSA": NonSpare_999, "AS": NonSpare_634, "TAS": NonSpare_1830, "MH": NonSpare_1278, "BVR": NonSpare_698, "GVR": NonSpare_1051, "GV": NonSpare_1047, "TAR": NonSpare_1827, "TI2": NonSpare_1861, "TS": NonSpare_1925, "MET": NonSpare_1271, "ROA": NonSpare_1600, "ARA": NonSpare_624, "SCC": NonSpare_1667}

    @overload
    @classmethod
    def spec(cls, key : Literal["AOS"]) -> NonSpare_613:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRD"]) -> NonSpare_1913:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3A"]) -> NonSpare_1217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QI"]) -> NonSpare_1527:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI1"]) -> NonSpare_1860:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAM"]) -> NonSpare_1228:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GH"]) -> NonSpare_1034:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> NonSpare_975:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1659:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSA"]) -> NonSpare_999:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> NonSpare_634:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1830:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MH"]) -> NonSpare_1278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_698:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1051:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GV"]) -> NonSpare_1047:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1827:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TI2"]) -> NonSpare_1861:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TS"]) -> NonSpare_1925:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ROA"]) -> NonSpare_1600:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARA"]) -> NonSpare_624:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SCC"]) -> NonSpare_1667:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AOS"], Literal["TRD"], Literal["M3A"], Literal["QI"], Literal["TI1"], Literal["MAM"], Literal["GH"], Literal["FL"], Literal["SAL"], Literal["FSA"], Literal["AS"], Literal["TAS"], Literal["MH"], Literal["BVR"], Literal["GVR"], Literal["GV"], Literal["TAR"], Literal["TI2"], Literal["TS"], Literal["MET"], Literal["ROA"], Literal["ARA"], Literal["SCC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AOS"]) -> Optional[NonSpare_613]:
        ...
    @overload
    def get_item(self, key : Literal["TRD"]) -> Optional[NonSpare_1913]:
        ...
    @overload
    def get_item(self, key : Literal["M3A"]) -> Optional[NonSpare_1217]:
        ...
    @overload
    def get_item(self, key : Literal["QI"]) -> Optional[NonSpare_1527]:
        ...
    @overload
    def get_item(self, key : Literal["TI1"]) -> Optional[NonSpare_1860]:
        ...
    @overload
    def get_item(self, key : Literal["MAM"]) -> Optional[NonSpare_1228]:
        ...
    @overload
    def get_item(self, key : Literal["GH"]) -> Optional[NonSpare_1034]:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> Optional[NonSpare_975]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1659]:
        ...
    @overload
    def get_item(self, key : Literal["FSA"]) -> Optional[NonSpare_999]:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> Optional[NonSpare_634]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1830]:
        ...
    @overload
    def get_item(self, key : Literal["MH"]) -> Optional[NonSpare_1278]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_698]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1051]:
        ...
    @overload
    def get_item(self, key : Literal["GV"]) -> Optional[NonSpare_1047]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1827]:
        ...
    @overload
    def get_item(self, key : Literal["TI2"]) -> Optional[NonSpare_1861]:
        ...
    @overload
    def get_item(self, key : Literal["TS"]) -> Optional[NonSpare_1925]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1271]:
        ...
    @overload
    def get_item(self, key : Literal["ROA"]) -> Optional[NonSpare_1600]:
        ...
    @overload
    def get_item(self, key : Literal["ARA"]) -> Optional[NonSpare_624]:
        ...
    @overload
    def get_item(self, key : Literal["SCC"]) -> Optional[NonSpare_1667]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["AOS"], val : NonSpare_613.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["TRD"], val : NonSpare_1913.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["M3A"], val : NonSpare_1217.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["QI"], val : NonSpare_1527.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["TI1"], val : NonSpare_1860.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["MAM"], val : NonSpare_1228.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["GH"], val : NonSpare_1034.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["FL"], val : NonSpare_975.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1659.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["FSA"], val : NonSpare_999.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["AS"], val : NonSpare_634.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1830.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["MH"], val : NonSpare_1278.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_698.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1051.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["GV"], val : NonSpare_1047.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1827.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["TI2"], val : NonSpare_1861.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["TS"], val : NonSpare_1925.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1271.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["ROA"], val : NonSpare_1600.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["ARA"], val : NonSpare_624.cv_arg) -> "Variation_1474":
        ...
    @overload
    def set_item(self, key : Literal["SCC"], val : NonSpare_1667.cv_arg) -> "Variation_1474":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["AOS"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["TRD"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["M3A"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["QI"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["TI1"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["MAM"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["GH"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["FL"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["FSA"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["AS"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["MH"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["GV"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["TI2"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["TS"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["ROA"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["ARA"]) -> "Variation_1474":
        ...
    @overload
    def del_item(self, key : Literal["SCC"]) -> "Variation_1474":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1474.cv_arg") -> 'Variation_1474':
        return cls._create(arg) # type: ignore

class RuleVariation_1395(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1474.cv_arg
    cv_variation: TypeAlias = Variation_1474

    @classmethod
    def create(cls, arg : "RuleVariation_1395.cv_arg") -> "RuleVariation_1395":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1474:
        return self.arg # type: ignore

class NonSpare_472(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1395.cv_arg
    cv_name = "295"
    cv_title = "Data Ages"
    cv_rule: TypeAlias = RuleVariation_1395

    @classmethod
    def create(cls, arg : "NonSpare_472.cv_arg") -> "NonSpare_472":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1395:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1474:
        return self.rule.variation

class UapItem_472(UapItem):
    cv_non_spare: TypeAlias = NonSpare_472

class Record_6(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_29.cv_arg,
        "040": NonSpare_147.cv_arg,
        "161": NonSpare_365.cv_arg,
        "015": NonSpare_64.cv_arg,
        "071": NonSpare_222.cv_arg,
        "130": NonSpare_310.cv_arg,
        "131": NonSpare_315.cv_arg,
        "072": NonSpare_223.cv_arg,
        "150": NonSpare_344.cv_arg,
        "151": NonSpare_350.cv_arg,
        "080": NonSpare_238.cv_arg,
        "073": NonSpare_224.cv_arg,
        "074": NonSpare_226.cv_arg,
        "075": NonSpare_227.cv_arg,
        "076": NonSpare_229.cv_arg,
        "140": NonSpare_324.cv_arg,
        "090": NonSpare_256.cv_arg,
        "210": NonSpare_413.cv_arg,
        "070": NonSpare_208.cv_arg,
        "230": NonSpare_433.cv_arg,
        "145": NonSpare_338.cv_arg,
        "152": NonSpare_352.cv_arg,
        "200": NonSpare_402.cv_arg,
        "155": NonSpare_354.cv_arg,
        "157": NonSpare_356.cv_arg,
        "160": NonSpare_357.cv_arg,
        "165": NonSpare_369.cv_arg,
        "077": NonSpare_231.cv_arg,
        "170": NonSpare_373.cv_arg,
        "020": NonSpare_79.cv_arg,
        "220": NonSpare_424.cv_arg,
        "146": NonSpare_341.cv_arg,
        "148": NonSpare_343.cv_arg,
        "110": NonSpare_293.cv_arg,
        "016": NonSpare_72.cv_arg,
        "008": NonSpare_27.cv_arg,
        "271": NonSpare_466.cv_arg,
        "132": NonSpare_318.cv_arg,
        "250": NonSpare_447.cv_arg,
        "260": NonSpare_458.cv_arg,
        "400": NonSpare_500.cv_arg,
        "295": NonSpare_472.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 7
    cv_items_list = [UapItem_29, UapItem_147, UapItem_365, UapItem_64, UapItem_222, UapItem_310, UapItem_315, UapItem_223, UapItem_344, UapItem_350, UapItem_238, UapItem_224, UapItem_226, UapItem_227, UapItem_229, UapItem_324, UapItem_256, UapItem_413, UapItem_208, UapItem_433, UapItem_338, UapItem_352, UapItem_402, UapItem_354, UapItem_356, UapItem_357, UapItem_369, UapItem_231, UapItem_373, UapItem_79, UapItem_424, UapItem_341, UapItem_343, UapItem_293, UapItem_72, UapItem_27, UapItem_466, UapItem_318, UapItem_447, UapItem_458, UapItem_499, UapItem_472, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_29, "040": NonSpare_147, "161": NonSpare_365, "015": NonSpare_64, "071": NonSpare_222, "130": NonSpare_310, "131": NonSpare_315, "072": NonSpare_223, "150": NonSpare_344, "151": NonSpare_350, "080": NonSpare_238, "073": NonSpare_224, "074": NonSpare_226, "075": NonSpare_227, "076": NonSpare_229, "140": NonSpare_324, "090": NonSpare_256, "210": NonSpare_413, "070": NonSpare_208, "230": NonSpare_433, "145": NonSpare_338, "152": NonSpare_352, "200": NonSpare_402, "155": NonSpare_354, "157": NonSpare_356, "160": NonSpare_357, "165": NonSpare_369, "077": NonSpare_231, "170": NonSpare_373, "020": NonSpare_79, "220": NonSpare_424, "146": NonSpare_341, "148": NonSpare_343, "110": NonSpare_293, "016": NonSpare_72, "008": NonSpare_27, "271": NonSpare_466, "132": NonSpare_318, "250": NonSpare_447, "260": NonSpare_458, "400": NonSpare_500, "295": NonSpare_472, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_29:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_147:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_365:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_64:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["071"]) -> NonSpare_222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_310:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["131"]) -> NonSpare_315:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["072"]) -> NonSpare_223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_344:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_350:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_238:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["073"]) -> NonSpare_224:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["074"]) -> NonSpare_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["075"]) -> NonSpare_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["076"]) -> NonSpare_229:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_324:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_256:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_413:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_433:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["145"]) -> NonSpare_338:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["152"]) -> NonSpare_352:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_402:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["155"]) -> NonSpare_354:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["157"]) -> NonSpare_356:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_357:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["165"]) -> NonSpare_369:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["077"]) -> NonSpare_231:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_373:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_79:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["146"]) -> NonSpare_341:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["148"]) -> NonSpare_343:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_293:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["016"]) -> NonSpare_72:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["008"]) -> NonSpare_27:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["271"]) -> NonSpare_466:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["132"]) -> NonSpare_318:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_458:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_500:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_472:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["040"], Literal["161"], Literal["015"], Literal["071"], Literal["130"], Literal["131"], Literal["072"], Literal["150"], Literal["151"], Literal["080"], Literal["073"], Literal["074"], Literal["075"], Literal["076"], Literal["140"], Literal["090"], Literal["210"], Literal["070"], Literal["230"], Literal["145"], Literal["152"], Literal["200"], Literal["155"], Literal["157"], Literal["160"], Literal["165"], Literal["077"], Literal["170"], Literal["020"], Literal["220"], Literal["146"], Literal["148"], Literal["110"], Literal["016"], Literal["008"], Literal["271"], Literal["132"], Literal["250"], Literal["260"], Literal["400"], Literal["295"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_29]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_147]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_365]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_64]:
        ...
    @overload
    def get_item(self, key : Literal["071"]) -> Optional[NonSpare_222]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_310]:
        ...
    @overload
    def get_item(self, key : Literal["131"]) -> Optional[NonSpare_315]:
        ...
    @overload
    def get_item(self, key : Literal["072"]) -> Optional[NonSpare_223]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_344]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_350]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_238]:
        ...
    @overload
    def get_item(self, key : Literal["073"]) -> Optional[NonSpare_224]:
        ...
    @overload
    def get_item(self, key : Literal["074"]) -> Optional[NonSpare_226]:
        ...
    @overload
    def get_item(self, key : Literal["075"]) -> Optional[NonSpare_227]:
        ...
    @overload
    def get_item(self, key : Literal["076"]) -> Optional[NonSpare_229]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_324]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_256]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_413]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_208]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_433]:
        ...
    @overload
    def get_item(self, key : Literal["145"]) -> Optional[NonSpare_338]:
        ...
    @overload
    def get_item(self, key : Literal["152"]) -> Optional[NonSpare_352]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_402]:
        ...
    @overload
    def get_item(self, key : Literal["155"]) -> Optional[NonSpare_354]:
        ...
    @overload
    def get_item(self, key : Literal["157"]) -> Optional[NonSpare_356]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_357]:
        ...
    @overload
    def get_item(self, key : Literal["165"]) -> Optional[NonSpare_369]:
        ...
    @overload
    def get_item(self, key : Literal["077"]) -> Optional[NonSpare_231]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_373]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_79]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_424]:
        ...
    @overload
    def get_item(self, key : Literal["146"]) -> Optional[NonSpare_341]:
        ...
    @overload
    def get_item(self, key : Literal["148"]) -> Optional[NonSpare_343]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_293]:
        ...
    @overload
    def get_item(self, key : Literal["016"]) -> Optional[NonSpare_72]:
        ...
    @overload
    def get_item(self, key : Literal["008"]) -> Optional[NonSpare_27]:
        ...
    @overload
    def get_item(self, key : Literal["271"]) -> Optional[NonSpare_466]:
        ...
    @overload
    def get_item(self, key : Literal["132"]) -> Optional[NonSpare_318]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_447]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_458]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_500]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_472]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_29.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_147.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_365.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_64.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["071"], val : NonSpare_222.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_310.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["131"], val : NonSpare_315.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["072"], val : NonSpare_223.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_344.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_350.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_238.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["073"], val : NonSpare_224.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["074"], val : NonSpare_226.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["075"], val : NonSpare_227.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["076"], val : NonSpare_229.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_324.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_256.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_413.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_208.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_433.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["145"], val : NonSpare_338.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["152"], val : NonSpare_352.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_402.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["155"], val : NonSpare_354.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["157"], val : NonSpare_356.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_357.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["165"], val : NonSpare_369.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["077"], val : NonSpare_231.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_373.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_79.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_424.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["146"], val : NonSpare_341.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["148"], val : NonSpare_343.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_293.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["016"], val : NonSpare_72.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["008"], val : NonSpare_27.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["271"], val : NonSpare_466.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["132"], val : NonSpare_318.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_447.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_458.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_500.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_472.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_6':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_6':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["071"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["131"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["072"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["073"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["074"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["075"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["076"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["145"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["152"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["155"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["157"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["165"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["077"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["146"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["148"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["016"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["008"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["271"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["132"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_6':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_6':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_6.cv_arg") -> 'Record_6':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_6", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_6(UapSingle):
    cv_arg: TypeAlias = Record_6
    cv_record: TypeAlias = Record_6

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_6]]:
        return cls._parse(bs)

class Asterix_35(AstCat):
    cv_category = 21
    cv_edition = (2, 6)
    cv_uap: TypeAlias = Uap_6
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_6.cv_arg]) -> "Asterix_35":
        return cls._create(records) # type: ignore

class NonSpare_30(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_30.cv_arg") -> "NonSpare_30":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_30(UapItem):
    cv_non_spare: TypeAlias = NonSpare_30

class Content_579(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Ground station status report", 2: "Service status report", 3: "Service statistics report"}

class RuleContent_579(RuleContentContextFree):
    cv_arg: TypeAlias = Content_579.cv_arg
    cv_content: TypeAlias = Content_579

    @property
    def content(self) -> Content_579:
        return self._get_content() # type: ignore

class Variation_182(Element):
    cv_arg: TypeAlias = RuleContent_579.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_579

    @classmethod
    def create(cls, arg: "Variation_182.cv_arg") -> "Variation_182":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_579:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_579:
        return self.rule.content

class RuleVariation_175(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_182.cv_arg
    cv_variation: TypeAlias = Variation_182

    @classmethod
    def create(cls, arg : "RuleVariation_175.cv_arg") -> "RuleVariation_175":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_182:
        return self.arg # type: ignore

class NonSpare_18(NonSpare):
    cv_arg: TypeAlias = RuleVariation_175.cv_arg
    cv_name = "000"
    cv_title = "Report Type"
    cv_rule: TypeAlias = RuleVariation_175

    @classmethod
    def create(cls, arg : "NonSpare_18.cv_arg") -> "NonSpare_18":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_175:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_182:
        return self.rule.variation

class UapItem_18(UapItem):
    cv_non_spare: TypeAlias = NonSpare_18

class NonSpare_1714(NonSpare):
    cv_arg: TypeAlias = RuleVariation_132.cv_arg
    cv_name = "SID"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_132

    @classmethod
    def create(cls, arg : "NonSpare_1714.cv_arg") -> "NonSpare_1714":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_132:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_132:
        return self.rule.variation

class Item_890(Item):
    cv_arg: TypeAlias = NonSpare_1714.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1714

    @classmethod
    def create(cls, arg : "Item_890.cv_arg") -> "Item_890":
        return cls._create(arg) # type: ignore

class Content_574(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "ADS-B VDL4", 2: "ADS-B Ext Squitter", 3: "ADS-B UAT", 4: "TIS-B VDL4", 5: "TIS-B Ext Squitter", 6: "TIS-B UAT", 7: "FIS-B VDL4", 8: "GRAS VDL4", 9: "MLT"}

class RuleContent_574(RuleContentContextFree):
    cv_arg: TypeAlias = Content_574.cv_arg
    cv_content: TypeAlias = Content_574

    @property
    def content(self) -> Content_574:
        return self._get_content() # type: ignore

class Variation_802(Element):
    cv_arg: TypeAlias = RuleContent_574.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_574

    @classmethod
    def create(cls, arg: "Variation_802.cv_arg") -> "Variation_802":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_574:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_574:
        return self.rule.content

class RuleVariation_772(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_802.cv_arg
    cv_variation: TypeAlias = Variation_802

    @classmethod
    def create(cls, arg : "RuleVariation_772.cv_arg") -> "RuleVariation_772":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_802:
        return self.arg # type: ignore

class NonSpare_1804(NonSpare):
    cv_arg: TypeAlias = RuleVariation_772.cv_arg
    cv_name = "STYP"
    cv_title = "Type of Service"
    cv_rule: TypeAlias = RuleVariation_772

    @classmethod
    def create(cls, arg : "NonSpare_1804.cv_arg") -> "NonSpare_1804":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_772:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_802:
        return self.rule.variation

class Item_960(Item):
    cv_arg: TypeAlias = NonSpare_1804.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1804

    @classmethod
    def create(cls, arg : "Item_960.cv_arg") -> "Item_960":
        return cls._create(arg) # type: ignore

class Variation_1210(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_132.cv_arg, Tuple[Literal["SID"], RuleVariation_132.cv_arg]], Union[RuleVariation_772.cv_arg, Tuple[Literal["STYP"], RuleVariation_772.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1210.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_890, 4), (Item_960, 4)]
    cv_items_dict = {"SID": RuleVariation_132, "STYP": RuleVariation_772}

    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STYP"]) -> RuleVariation_772:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SID"], Literal["STYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SID"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["STYP"]) -> RuleVariation_772:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1210.cv_arg") -> 'Variation_1210':
        return cls._create(arg) # type: ignore

class RuleVariation_1154(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1210.cv_arg
    cv_variation: TypeAlias = Variation_1210

    @classmethod
    def create(cls, arg : "RuleVariation_1154.cv_arg") -> "RuleVariation_1154":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1210:
        return self.arg # type: ignore

class NonSpare_69(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1154.cv_arg
    cv_name = "015"
    cv_title = "Service Type and Identification"
    cv_rule: TypeAlias = RuleVariation_1154

    @classmethod
    def create(cls, arg : "NonSpare_69.cv_arg") -> "NonSpare_69":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1154:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1210:
        return self.rule.variation

class UapItem_69(UapItem):
    cv_non_spare: TypeAlias = NonSpare_69

class NonSpare_220(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "070"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_220.cv_arg") -> "NonSpare_220":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_220(UapItem):
    cv_non_spare: TypeAlias = NonSpare_220

class Content_77(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Data is released for operational use", 1: "Data must not be used operationally"}

class RuleContent_77(RuleContentContextFree):
    cv_arg: TypeAlias = Content_77.cv_arg
    cv_content: TypeAlias = Content_77

    @property
    def content(self) -> Content_77:
        return self._get_content() # type: ignore

class Variation_22(Element):
    cv_arg: TypeAlias = RuleContent_77.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_77

    @classmethod
    def create(cls, arg: "Variation_22.cv_arg") -> "Variation_22":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_77:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_77:
        return self.rule.content

class RuleVariation_22(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_22.cv_arg
    cv_variation: TypeAlias = Variation_22

    @classmethod
    def create(cls, arg : "RuleVariation_22.cv_arg") -> "RuleVariation_22":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_22:
        return self.arg # type: ignore

class Content_197(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default, no overload", 1: "Overload in DP"}

class RuleContent_197(RuleContentContextFree):
    cv_arg: TypeAlias = Content_197.cv_arg
    cv_content: TypeAlias = Content_197

    @property
    def content(self) -> Content_197:
        return self._get_content() # type: ignore

class Variation_425(Element):
    cv_arg: TypeAlias = RuleContent_197.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_197

    @classmethod
    def create(cls, arg: "Variation_425.cv_arg") -> "Variation_425":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_197:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_197:
        return self.rule.content

class RuleVariation_414(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_425.cv_arg
    cv_variation: TypeAlias = Variation_425

    @classmethod
    def create(cls, arg : "RuleVariation_414.cv_arg") -> "RuleVariation_414":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_425:
        return self.arg # type: ignore

class Content_199(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default, no overload", 1: "Overload in transmission subsystem"}

class RuleContent_199(RuleContentContextFree):
    cv_arg: TypeAlias = Content_199.cv_arg
    cv_content: TypeAlias = Content_199

    @property
    def content(self) -> Content_199:
        return self._get_content() # type: ignore

class Variation_533(Element):
    cv_arg: TypeAlias = RuleContent_199.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_199

    @classmethod
    def create(cls, arg: "Variation_533.cv_arg") -> "Variation_533":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_199:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_199:
        return self.rule.content

class RuleVariation_522(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_533.cv_arg
    cv_variation: TypeAlias = Variation_533

    @classmethod
    def create(cls, arg : "RuleVariation_522.cv_arg") -> "RuleVariation_522":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_533:
        return self.arg # type: ignore

class Content_296(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Monitoring system not connected or unknown", 1: "Monitoring system connected"}

class RuleContent_296(RuleContentContextFree):
    cv_arg: TypeAlias = Content_296.cv_arg
    cv_content: TypeAlias = Content_296

    @property
    def content(self) -> Content_296:
        return self._get_content() # type: ignore

class Variation_649(Element):
    cv_arg: TypeAlias = RuleContent_296.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_296

    @classmethod
    def create(cls, arg: "Variation_649.cv_arg") -> "Variation_649":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_296:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_296:
        return self.rule.content

class RuleVariation_638(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_649.cv_arg
    cv_variation: TypeAlias = Variation_649

    @classmethod
    def create(cls, arg : "RuleVariation_638.cv_arg") -> "RuleVariation_638":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_649:
        return self.arg # type: ignore

class Variation_760(Element):
    cv_arg: TypeAlias = RuleContent_559.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_559

    @classmethod
    def create(cls, arg: "Variation_760.cv_arg") -> "Variation_760":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_559:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_559:
        return self.rule.content

class RuleVariation_749(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_760.cv_arg
    cv_variation: TypeAlias = Variation_760

    @classmethod
    def create(cls, arg : "RuleVariation_749.cv_arg") -> "RuleVariation_749":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_760:
        return self.arg # type: ignore

class Content_375(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No spoofing detected", 1: "Potential spoofing attack"}

class RuleContent_375(RuleContentContextFree):
    cv_arg: TypeAlias = Content_375.cv_arg
    cv_content: TypeAlias = Content_375

    @property
    def content(self) -> Content_375:
        return self._get_content() # type: ignore

class Variation_864(Element):
    cv_arg: TypeAlias = RuleContent_375.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_375

    @classmethod
    def create(cls, arg: "Variation_864.cv_arg") -> "Variation_864":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_375:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_375:
        return self.rule.content

class RuleVariation_834(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_864.cv_arg
    cv_variation: TypeAlias = Variation_864

    @classmethod
    def create(cls, arg : "RuleVariation_834.cv_arg") -> "RuleVariation_834":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_864:
        return self.arg # type: ignore

class Content_158(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Track numbering has restarted"}

class RuleContent_158(RuleContentContextFree):
    cv_arg: TypeAlias = Content_158.cv_arg
    cv_content: TypeAlias = Content_158

    @property
    def content(self) -> Content_158:
        return self._get_content() # type: ignore

class Variation_921(Element):
    cv_arg: TypeAlias = RuleContent_158.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_158

    @classmethod
    def create(cls, arg: "Variation_921.cv_arg") -> "Variation_921":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_158:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_158:
        return self.rule.content

class RuleVariation_891(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_921.cv_arg
    cv_variation: TypeAlias = Variation_921

    @classmethod
    def create(cls, arg : "RuleVariation_891.cv_arg") -> "RuleVariation_891":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_921:
        return self.arg # type: ignore

class Content_726(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_726(RuleContentContextFree):
    cv_arg: TypeAlias = Content_726.cv_arg
    cv_content: TypeAlias = Content_726

    @property
    def content(self) -> Content_726:
        return self._get_content() # type: ignore

class Variation_162(Element):
    cv_arg: TypeAlias = RuleContent_726.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_726

    @classmethod
    def create(cls, arg: "Variation_162.cv_arg") -> "Variation_162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_726:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_726:
        return self.rule.content

class RuleVariation_156(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_162.cv_arg
    cv_variation: TypeAlias = Variation_162

    @classmethod
    def create(cls, arg : "RuleVariation_156.cv_arg") -> "RuleVariation_156":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_162:
        return self.arg # type: ignore

class NonSpare_1367(NonSpare):
    cv_arg: TypeAlias = RuleVariation_22.cv_arg
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the Data"
    cv_rule: TypeAlias = RuleVariation_22

    @classmethod
    def create(cls, arg : "NonSpare_1367.cv_arg") -> "NonSpare_1367":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_22:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_22:
        return self.rule.variation

class Item_627(Item):
    cv_arg: TypeAlias = NonSpare_1367.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1367

    @classmethod
    def create(cls, arg : "Item_627.cv_arg") -> "Item_627":
        return cls._create(arg) # type: ignore

class NonSpare_1395(NonSpare):
    cv_arg: TypeAlias = RuleVariation_414.cv_arg
    cv_name = "ODP"
    cv_title = "Data Processor Overload Indicator"
    cv_rule: TypeAlias = RuleVariation_414

    @classmethod
    def create(cls, arg : "NonSpare_1395.cv_arg") -> "NonSpare_1395":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_414:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_425:
        return self.rule.variation

class Item_654(Item):
    cv_arg: TypeAlias = NonSpare_1395.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1395

    @classmethod
    def create(cls, arg : "Item_654.cv_arg") -> "Item_654":
        return cls._create(arg) # type: ignore

class NonSpare_1416(NonSpare):
    cv_arg: TypeAlias = RuleVariation_522.cv_arg
    cv_name = "OXT"
    cv_title = "Ground Interface Data Communications Overload"
    cv_rule: TypeAlias = RuleVariation_522

    @classmethod
    def create(cls, arg : "NonSpare_1416.cv_arg") -> "NonSpare_1416":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_522:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_533:
        return self.rule.variation

class Item_674(Item):
    cv_arg: TypeAlias = NonSpare_1416.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1416

    @classmethod
    def create(cls, arg : "Item_674.cv_arg") -> "Item_674":
        return cls._create(arg) # type: ignore

class NonSpare_1325(NonSpare):
    cv_arg: TypeAlias = RuleVariation_638.cv_arg
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule: TypeAlias = RuleVariation_638

    @classmethod
    def create(cls, arg : "NonSpare_1325.cv_arg") -> "NonSpare_1325":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_638:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_649:
        return self.rule.variation

class Item_589(Item):
    cv_arg: TypeAlias = NonSpare_1325.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1325

    @classmethod
    def create(cls, arg : "Item_589.cv_arg") -> "Item_589":
        return cls._create(arg) # type: ignore

class NonSpare_1942(NonSpare):
    cv_arg: TypeAlias = RuleVariation_749.cv_arg
    cv_name = "TSV"
    cv_title = "Time Source Validity"
    cv_rule: TypeAlias = RuleVariation_749

    @classmethod
    def create(cls, arg : "NonSpare_1942.cv_arg") -> "NonSpare_1942":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_749:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_760:
        return self.rule.variation

class Item_1059(Item):
    cv_arg: TypeAlias = NonSpare_1942.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1942

    @classmethod
    def create(cls, arg : "Item_1059.cv_arg") -> "Item_1059":
        return cls._create(arg) # type: ignore

class NonSpare_1743(NonSpare):
    cv_arg: TypeAlias = RuleVariation_834.cv_arg
    cv_name = "SPO"
    cv_title = "Indication of Spoofing Attack"
    cv_rule: TypeAlias = RuleVariation_834

    @classmethod
    def create(cls, arg : "NonSpare_1743.cv_arg") -> "NonSpare_1743":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_834:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_864:
        return self.rule.variation

class Item_916(Item):
    cv_arg: TypeAlias = NonSpare_1743.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1743

    @classmethod
    def create(cls, arg : "Item_916.cv_arg") -> "Item_916":
        return cls._create(arg) # type: ignore

class NonSpare_1598(NonSpare):
    cv_arg: TypeAlias = RuleVariation_891.cv_arg
    cv_name = "RN"
    cv_title = "Renumbering Indication for Track ID"
    cv_rule: TypeAlias = RuleVariation_891

    @classmethod
    def create(cls, arg : "NonSpare_1598.cv_arg") -> "NonSpare_1598":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_891:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_921:
        return self.rule.variation

class Item_823(Item):
    cv_arg: TypeAlias = NonSpare_1598.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1598

    @classmethod
    def create(cls, arg : "Item_823.cv_arg") -> "Item_823":
        return cls._create(arg) # type: ignore

class NonSpare_1045(NonSpare):
    cv_arg: TypeAlias = RuleVariation_156.cv_arg
    cv_name = "GSSP"
    cv_title = "Ground Station Status Reporting Period"
    cv_rule: TypeAlias = RuleVariation_156

    @classmethod
    def create(cls, arg : "NonSpare_1045.cv_arg") -> "NonSpare_1045":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_156:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_162:
        return self.rule.variation

class Item_378(Item):
    cv_arg: TypeAlias = NonSpare_1045.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1045

    @classmethod
    def create(cls, arg : "Item_378.cv_arg") -> "Item_378":
        return cls._create(arg) # type: ignore

class Variation_1376(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_22.cv_arg, Tuple[Literal["NOGO"], RuleVariation_22.cv_arg]], Union[RuleVariation_414.cv_arg, Tuple[Literal["ODP"], RuleVariation_414.cv_arg]], Union[RuleVariation_522.cv_arg, Tuple[Literal["OXT"], RuleVariation_522.cv_arg]], Union[RuleVariation_638.cv_arg, Tuple[Literal["MSC"], RuleVariation_638.cv_arg]], Union[RuleVariation_749.cv_arg, Tuple[Literal["TSV"], RuleVariation_749.cv_arg]], Union[RuleVariation_834.cv_arg, Tuple[Literal["SPO"], RuleVariation_834.cv_arg]], Union[RuleVariation_891.cv_arg, Tuple[Literal["RN"], RuleVariation_891.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_156.cv_arg, Tuple[Literal["GSSP"], RuleVariation_156.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1376.cv_arg_group_1"],
        Tuple["Variation_1376.cv_arg_group_1", "Variation_1376.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_627, 1), (Item_654, 1), (Item_674, 1), (Item_589, 1), (Item_1059, 1), (Item_916, 1), (Item_823, 1), None], [(Item_378, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1376.cv_arg") -> 'Variation_1376':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_22:
        ...
    @overload
    def get_item(self, key : Literal["ODP"]) -> RuleVariation_414:
        ...
    @overload
    def get_item(self, key : Literal["OXT"]) -> RuleVariation_522:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_638:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_749:
        ...
    @overload
    def get_item(self, key : Literal["SPO"]) -> RuleVariation_834:
        ...
    @overload
    def get_item(self, key : Literal["RN"]) -> RuleVariation_891:
        ...
    @overload
    def get_item(self, key : Literal["GSSP"]) -> Optional[RuleVariation_156]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1297(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1376.cv_arg
    cv_variation: TypeAlias = Variation_1376

    @classmethod
    def create(cls, arg : "RuleVariation_1297.cv_arg") -> "RuleVariation_1297":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1376:
        return self.arg # type: ignore

class NonSpare_271(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1297.cv_arg
    cv_name = "100"
    cv_title = "Ground Station Status"
    cv_rule: TypeAlias = RuleVariation_1297

    @classmethod
    def create(cls, arg : "NonSpare_271.cv_arg") -> "NonSpare_271":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1297:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1376:
        return self.rule.variation

class UapItem_271(UapItem):
    cv_non_spare: TypeAlias = NonSpare_271

class Content_365(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No information", 1: "NRA class", 2: "Reserved for future use", 3: "Reserved for future use", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

class RuleContent_365(RuleContentContextFree):
    cv_arg: TypeAlias = Content_365.cv_arg
    cv_content: TypeAlias = Content_365

    @property
    def content(self) -> Content_365:
        return self._get_content() # type: ignore

class Variation_128(Element):
    cv_arg: TypeAlias = RuleContent_365.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_365

    @classmethod
    def create(cls, arg: "Variation_128.cv_arg") -> "Variation_128":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_365:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_365:
        return self.rule.content

class RuleVariation_128(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_128.cv_arg
    cv_variation: TypeAlias = Variation_128

    @classmethod
    def create(cls, arg : "RuleVariation_128.cv_arg") -> "RuleVariation_128":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_128:
        return self.arg # type: ignore

class NonSpare_1603(NonSpare):
    cv_arg: TypeAlias = RuleVariation_220.cv_arg
    cv_name = "RP"
    cv_title = "Report Period for Category 021 Reports"
    cv_rule: TypeAlias = RuleVariation_220

    @classmethod
    def create(cls, arg : "NonSpare_1603.cv_arg") -> "NonSpare_1603":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_220:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_227:
        return self.rule.variation

class Item_827(Item):
    cv_arg: TypeAlias = NonSpare_1603.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1603

    @classmethod
    def create(cls, arg : "Item_827.cv_arg") -> "Item_827":
        return cls._create(arg) # type: ignore

class NonSpare_1666(NonSpare):
    cv_arg: TypeAlias = RuleVariation_128.cv_arg
    cv_name = "SC"
    cv_title = "Service Class"
    cv_rule: TypeAlias = RuleVariation_128

    @classmethod
    def create(cls, arg : "NonSpare_1666.cv_arg") -> "NonSpare_1666":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_128:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_128:
        return self.rule.variation

class Item_862(Item):
    cv_arg: TypeAlias = NonSpare_1666.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1666

    @classmethod
    def create(cls, arg : "Item_862.cv_arg") -> "Item_862":
        return cls._create(arg) # type: ignore

class Item_18(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 3
    cv_bit_size = 4

class NonSpare_1766(NonSpare):
    cv_arg: TypeAlias = RuleVariation_156.cv_arg
    cv_name = "SSRP"
    cv_title = "Service Status Reporting Period"
    cv_rule: TypeAlias = RuleVariation_156

    @classmethod
    def create(cls, arg : "NonSpare_1766.cv_arg") -> "NonSpare_1766":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_156:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_162:
        return self.rule.variation

class Item_931(Item):
    cv_arg: TypeAlias = NonSpare_1766.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1766

    @classmethod
    def create(cls, arg : "Item_931.cv_arg") -> "Item_931":
        return cls._create(arg) # type: ignore

class Variation_1381(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_220.cv_arg, Tuple[Literal["RP"], RuleVariation_220.cv_arg]], Union[RuleVariation_128.cv_arg, Tuple[Literal["SC"], RuleVariation_128.cv_arg]], int, None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_156.cv_arg, Tuple[Literal["SSRP"], RuleVariation_156.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1381.cv_arg_group_1"],
        Tuple["Variation_1381.cv_arg_group_1", "Variation_1381.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_827, 8), (Item_862, 3), (Item_18, 4), None], [(Item_931, 7), None]]

    @classmethod
    def create(cls, arg: "Variation_1381.cv_arg") -> 'Variation_1381':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["RP"]) -> RuleVariation_220:
        ...
    @overload
    def get_item(self, key : Literal["SC"]) -> RuleVariation_128:
        ...
    @overload
    def get_item(self, key : Literal["SSRP"]) -> Optional[RuleVariation_156]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1302(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1381.cv_arg
    cv_variation: TypeAlias = Variation_1381

    @classmethod
    def create(cls, arg : "RuleVariation_1302.cv_arg") -> "RuleVariation_1302":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1381:
        return self.arg # type: ignore

class NonSpare_280(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1302.cv_arg
    cv_name = "101"
    cv_title = "Service Configuration"
    cv_rule: TypeAlias = RuleVariation_1302

    @classmethod
    def create(cls, arg : "NonSpare_280.cv_arg") -> "NonSpare_280":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1381:
        return self.rule.variation

class UapItem_280(UapItem):
    cv_non_spare: TypeAlias = NonSpare_280

class Content_713(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_713(RuleContentContextFree):
    cv_arg: TypeAlias = Content_713.cv_arg
    cv_content: TypeAlias = Content_713

    @property
    def content(self) -> Content_713:
        return self._get_content() # type: ignore

class Variation_222(Element):
    cv_arg: TypeAlias = RuleContent_713.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_713

    @classmethod
    def create(cls, arg: "Variation_222.cv_arg") -> "Variation_222":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_713:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_713:
        return self.rule.content

class RuleVariation_215(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_222.cv_arg
    cv_variation: TypeAlias = Variation_222

    @classmethod
    def create(cls, arg : "RuleVariation_215.cv_arg") -> "RuleVariation_215":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_222:
        return self.arg # type: ignore

class NonSpare_395(NonSpare):
    cv_arg: TypeAlias = RuleVariation_215.cv_arg
    cv_name = "200"
    cv_title = "Operational Range"
    cv_rule: TypeAlias = RuleVariation_215

    @classmethod
    def create(cls, arg : "NonSpare_395.cv_arg") -> "NonSpare_395":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_215:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_222:
        return self.rule.variation

class UapItem_395(UapItem):
    cv_non_spare: TypeAlias = NonSpare_395

class Content_545(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Failed", 2: "Disabled", 3: "Degraded", 4: "Normal", 5: "Initialisation"}

class RuleContent_545(RuleContentContextFree):
    cv_arg: TypeAlias = Content_545.cv_arg
    cv_content: TypeAlias = Content_545

    @property
    def content(self) -> Content_545:
        return self._get_content() # type: ignore

class Variation_794(Element):
    cv_arg: TypeAlias = RuleContent_545.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_545

    @classmethod
    def create(cls, arg: "Variation_794.cv_arg") -> "Variation_794":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_545:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_545:
        return self.rule.content

class RuleVariation_768(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_794.cv_arg
    cv_variation: TypeAlias = Variation_794

    @classmethod
    def create(cls, arg : "RuleVariation_768.cv_arg") -> "RuleVariation_768":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_794:
        return self.arg # type: ignore

class NonSpare_1784(NonSpare):
    cv_arg: TypeAlias = RuleVariation_768.cv_arg
    cv_name = "STAT"
    cv_title = "Status of the Service"
    cv_rule: TypeAlias = RuleVariation_768

    @classmethod
    def create(cls, arg : "NonSpare_1784.cv_arg") -> "NonSpare_1784":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_768:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_794:
        return self.rule.variation

class Item_945(Item):
    cv_arg: TypeAlias = NonSpare_1784.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1784

    @classmethod
    def create(cls, arg : "Item_945.cv_arg") -> "Item_945":
        return cls._create(arg) # type: ignore

class Variation_1345(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_768.cv_arg, Tuple[Literal["STAT"], RuleVariation_768.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1345.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_3, 4), (Item_945, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1345.cv_arg") -> 'Variation_1345':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_768:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1266(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1345.cv_arg
    cv_variation: TypeAlias = Variation_1345

    @classmethod
    def create(cls, arg : "RuleVariation_1266.cv_arg") -> "RuleVariation_1266":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1345:
        return self.arg # type: ignore

class NonSpare_290(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1266.cv_arg
    cv_name = "110"
    cv_title = "Service Status"
    cv_rule: TypeAlias = RuleVariation_1266

    @classmethod
    def create(cls, arg : "NonSpare_290.cv_arg") -> "NonSpare_290":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1266:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1345:
        return self.rule.variation

class UapItem_290(UapItem):
    cv_non_spare: TypeAlias = NonSpare_290

class Content_406(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Number of unknown messages received", 1: "Number of too old messages received", 2: "Number of failed message conversions", 3: "Total Number of messages received", 4: "Total Number of messages transmitted", 20: "Number of TIS-B management messages received", 21: "Number of Basic messages received", 22: "Number of High Dynamic messages received", 23: "Number of Full Position messages received", 24: "Number of Basic Ground  messages received", 25: "Number of TCP messages received", 26: "Number of UTC time  messages received", 27: "Number of Data messages received", 28: "Number of High Resolution messages received", 29: "Number of Aircraft Target Airborne messages received", 30: "Number of Aircraft Target Ground messages received", 31: "Number of Ground Vehicle Target messages received", 32: "Number of 2 slots TCP messages received"}

class RuleContent_406(RuleContentContextFree):
    cv_arg: TypeAlias = Content_406.cv_arg
    cv_content: TypeAlias = Content_406

    @property
    def content(self) -> Content_406:
        return self._get_content() # type: ignore

class Variation_173(Element):
    cv_arg: TypeAlias = RuleContent_406.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_406

    @classmethod
    def create(cls, arg: "Variation_173.cv_arg") -> "Variation_173":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_406:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_406:
        return self.rule.content

class RuleVariation_166(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_173.cv_arg
    cv_variation: TypeAlias = Variation_173

    @classmethod
    def create(cls, arg : "RuleVariation_166.cv_arg") -> "RuleVariation_166":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_173:
        return self.arg # type: ignore

class NonSpare_1973(NonSpare):
    cv_arg: TypeAlias = RuleVariation_166.cv_arg
    cv_name = "TYPE"
    cv_title = "Type of Report Counter"
    cv_rule: TypeAlias = RuleVariation_166

    @classmethod
    def create(cls, arg : "NonSpare_1973.cv_arg") -> "NonSpare_1973":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_166:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_173:
        return self.rule.variation

class Item_1086(Item):
    cv_arg: TypeAlias = NonSpare_1973.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1973

    @classmethod
    def create(cls, arg : "Item_1086.cv_arg") -> "Item_1086":
        return cls._create(arg) # type: ignore

class Content_217(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "From midnight", 1: "From the last report"}

class RuleContent_217(RuleContentContextFree):
    cv_arg: TypeAlias = Content_217.cv_arg
    cv_content: TypeAlias = Content_217

    @property
    def content(self) -> Content_217:
        return self._get_content() # type: ignore

class Variation_45(Element):
    cv_arg: TypeAlias = RuleContent_217.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_217

    @classmethod
    def create(cls, arg: "Variation_45.cv_arg") -> "Variation_45":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_217:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_217:
        return self.rule.content

class RuleVariation_45(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_45.cv_arg
    cv_variation: TypeAlias = Variation_45

    @classmethod
    def create(cls, arg : "RuleVariation_45.cv_arg") -> "RuleVariation_45":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_45:
        return self.arg # type: ignore

class NonSpare_1576(NonSpare):
    cv_arg: TypeAlias = RuleVariation_45.cv_arg
    cv_name = "REF"
    cv_title = "Reference from which the Messages Are Countered"
    cv_rule: TypeAlias = RuleVariation_45

    @classmethod
    def create(cls, arg : "NonSpare_1576.cv_arg") -> "NonSpare_1576":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_45:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_45:
        return self.rule.variation

class Item_801(Item):
    cv_arg: TypeAlias = NonSpare_1576.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1576

    @classmethod
    def create(cls, arg : "Item_801.cv_arg") -> "Item_801":
        return cls._create(arg) # type: ignore

class Item_10(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 1
    cv_bit_size = 7

class NonSpare_852(NonSpare):
    cv_arg: TypeAlias = RuleVariation_366.cv_arg
    cv_name = "CV"
    cv_title = "32-bit Counter Value"
    cv_rule: TypeAlias = RuleVariation_366

    @classmethod
    def create(cls, arg : "NonSpare_852.cv_arg") -> "NonSpare_852":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_373:
        return self.rule.variation

class Item_233(Item):
    cv_arg: TypeAlias = NonSpare_852.cv_arg
    cv_non_spare: TypeAlias = NonSpare_852

    @classmethod
    def create(cls, arg : "Item_233.cv_arg") -> "Item_233":
        return cls._create(arg) # type: ignore

class Variation_1245(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_166.cv_arg, Tuple[Literal["TYPE"], RuleVariation_166.cv_arg]], Union[RuleVariation_45.cv_arg, Tuple[Literal["REF"], RuleVariation_45.cv_arg]], int, Union[RuleVariation_366.cv_arg, Tuple[Literal["CV"], RuleVariation_366.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1245.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1086, 8), (Item_801, 1), (Item_10, 7), (Item_233, 32)]
    cv_items_dict = {"TYPE": RuleVariation_166, "REF": RuleVariation_45, "CV": RuleVariation_366}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_166:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REF"]) -> RuleVariation_45:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CV"]) -> RuleVariation_366:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["REF"], Literal["CV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_166:
        ...
    @overload
    def get_item(self, key : Literal["REF"]) -> RuleVariation_45:
        ...
    @overload
    def get_item(self, key : Literal["CV"]) -> RuleVariation_366:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1245.cv_arg") -> 'Variation_1245':
        return cls._create(arg) # type: ignore

class Variation_1447(Repetitive):
    cv_arg: TypeAlias = List[Variation_1245.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1245

    @classmethod
    def create(cls, arg: "Variation_1447.cv_arg") -> 'Variation_1447':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1245]:
        return self._get_list() # type: ignore

class RuleVariation_1368(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1447.cv_arg
    cv_variation: TypeAlias = Variation_1447

    @classmethod
    def create(cls, arg : "RuleVariation_1368.cv_arg") -> "RuleVariation_1368":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1447:
        return self.arg # type: ignore

class NonSpare_303(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1368.cv_arg
    cv_name = "120"
    cv_title = "Service Statistics"
    cv_rule: TypeAlias = RuleVariation_1368

    @classmethod
    def create(cls, arg : "NonSpare_303.cv_arg") -> "NonSpare_303":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1447:
        return self.rule.variation

class UapItem_303(UapItem):
    cv_non_spare: TypeAlias = NonSpare_303

class Record_9(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_30.cv_arg,
        "000": NonSpare_18.cv_arg,
        "015": NonSpare_69.cv_arg,
        "070": NonSpare_220.cv_arg,
        "100": NonSpare_271.cv_arg,
        "101": NonSpare_280.cv_arg,
        "200": NonSpare_395.cv_arg,
        "110": NonSpare_290.cv_arg,
        "120": NonSpare_303.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_30, UapItem_18, UapItem_69, UapItem_220, UapItem_271, UapItem_280, UapItem_395, UapItem_290, UapItem_303, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_30, "000": NonSpare_18, "015": NonSpare_69, "070": NonSpare_220, "100": NonSpare_271, "101": NonSpare_280, "200": NonSpare_395, "110": NonSpare_290, "120": NonSpare_303, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_30:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_18:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_69:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_271:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["101"]) -> NonSpare_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_395:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_290:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_303:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["070"], Literal["100"], Literal["101"], Literal["200"], Literal["110"], Literal["120"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_30]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_18]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_69]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_220]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_271]:
        ...
    @overload
    def get_item(self, key : Literal["101"]) -> Optional[NonSpare_280]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_395]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_290]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_303]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_30.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_18.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_69.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_220.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_271.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["101"], val : NonSpare_280.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_395.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_290.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_303.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_9':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_9':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["101"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_9':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_9':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_9.cv_arg") -> 'Record_9':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_9", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_9(UapSingle):
    cv_arg: TypeAlias = Record_9
    cv_record: TypeAlias = Record_9

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_9]]:
        return cls._parse(bs)

class Asterix_36(AstCat):
    cv_category = 23
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_9
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_9.cv_arg]) -> "Asterix_36":
        return cls._create(records) # type: ignore

class Asterix_37(AstCat):
    cv_category = 23
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_9
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_9.cv_arg]) -> "Asterix_37":
        return cls._create(records) # type: ignore

class NonSpare_32(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_32.cv_arg") -> "NonSpare_32":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_32(UapItem):
    cv_non_spare: TypeAlias = NonSpare_32

class RuleVariation_150(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_150.cv_arg
    cv_variation: TypeAlias = Variation_150

    @classmethod
    def create(cls, arg : "RuleVariation_150.cv_arg") -> "RuleVariation_150":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_150:
        return self.arg # type: ignore

class NonSpare_1634(NonSpare):
    cv_arg: TypeAlias = RuleVariation_150.cv_arg
    cv_name = "RTYP"
    cv_title = "Report Type"
    cv_rule: TypeAlias = RuleVariation_150

    @classmethod
    def create(cls, arg : "NonSpare_1634.cv_arg") -> "NonSpare_1634":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_150:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_150:
        return self.rule.variation

class Item_840(Item):
    cv_arg: TypeAlias = NonSpare_1634.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1634

    @classmethod
    def create(cls, arg : "Item_840.cv_arg") -> "Item_840":
        return cls._create(arg) # type: ignore

class Variation_1188(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_150.cv_arg, Tuple[Literal["RTYP"], RuleVariation_150.cv_arg]], Union[RuleVariation_956.cv_arg, Tuple[Literal["RG"], RuleVariation_956.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1188.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_840, 7), (Item_811, 1)]
    cv_items_dict = {"RTYP": RuleVariation_150, "RG": RuleVariation_956}

    @overload
    @classmethod
    def spec(cls, key : Literal["RTYP"]) -> RuleVariation_150:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RG"]) -> RuleVariation_956:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RTYP"], Literal["RG"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RTYP"]) -> RuleVariation_150:
        ...
    @overload
    def get_item(self, key : Literal["RG"]) -> RuleVariation_956:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1188.cv_arg") -> 'Variation_1188':
        return cls._create(arg) # type: ignore

class RuleVariation_1137(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1188.cv_arg
    cv_variation: TypeAlias = Variation_1188

    @classmethod
    def create(cls, arg : "RuleVariation_1137.cv_arg") -> "RuleVariation_1137":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1188:
        return self.arg # type: ignore

class NonSpare_19(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1137.cv_arg
    cv_name = "000"
    cv_title = "Report Type"
    cv_rule: TypeAlias = RuleVariation_1137

    @classmethod
    def create(cls, arg : "NonSpare_19.cv_arg") -> "NonSpare_19":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1137:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1188:
        return self.rule.variation

class UapItem_19(UapItem):
    cv_non_spare: TypeAlias = NonSpare_19

class NonSpare_393(NonSpare):
    cv_arg: TypeAlias = RuleVariation_344.cv_arg
    cv_name = "200"
    cv_title = "Message Identification"
    cv_rule: TypeAlias = RuleVariation_344

    @classmethod
    def create(cls, arg : "NonSpare_393.cv_arg") -> "NonSpare_393":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_351:
        return self.rule.variation

class UapItem_393(UapItem):
    cv_non_spare: TypeAlias = NonSpare_393

class NonSpare_68(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_68.cv_arg") -> "NonSpare_68":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_68(UapItem):
    cv_non_spare: TypeAlias = NonSpare_68

class NonSpare_83(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "020"
    cv_title = "Service Designator"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_83.cv_arg") -> "NonSpare_83":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_83(UapItem):
    cv_non_spare: TypeAlias = NonSpare_83

class NonSpare_219(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "070"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_219.cv_arg") -> "NonSpare_219":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_219(UapItem):
    cv_non_spare: TypeAlias = NonSpare_219

class Content_414(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Operational", 1: "Operational but in Standby", 2: "Maintenance", 3: "Reserved for future use"}

class RuleContent_414(RuleContentContextFree):
    cv_arg: TypeAlias = Content_414.cv_arg
    cv_content: TypeAlias = Content_414

    @property
    def content(self) -> Content_414:
        return self._get_content() # type: ignore

class Variation_476(Element):
    cv_arg: TypeAlias = RuleContent_414.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_414

    @classmethod
    def create(cls, arg: "Variation_476.cv_arg") -> "Variation_476":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_414:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_414:
        return self.rule.content

class RuleVariation_465(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_476.cv_arg
    cv_variation: TypeAlias = Variation_476

    @classmethod
    def create(cls, arg : "RuleVariation_465.cv_arg") -> "RuleVariation_465":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_476:
        return self.arg # type: ignore

class Content_445(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Running", 1: "Failed", 2: "Degraded", 3: "Undefined", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use", 8: "Reserved for future use", 9: "Reserved for future use", 10: "Reserved for future use", 11: "Reserved for future use", 12: "Reserved for future use", 13: "Reserved for future use", 14: "Reserved for future use", 15: "Reserved for future use"}

class RuleContent_445(RuleContentContextFree):
    cv_arg: TypeAlias = Content_445.cv_arg
    cv_content: TypeAlias = Content_445

    @property
    def content(self) -> Content_445:
        return self._get_content() # type: ignore

class Variation_694(Element):
    cv_arg: TypeAlias = RuleContent_445.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 4
    cv_rule = RuleContent_445

    @classmethod
    def create(cls, arg: "Variation_694.cv_arg") -> "Variation_694":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_445:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_445:
        return self.rule.content

class RuleVariation_683(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_694.cv_arg
    cv_variation: TypeAlias = Variation_694

    @classmethod
    def create(cls, arg : "RuleVariation_683.cv_arg") -> "RuleVariation_683":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_694:
        return self.arg # type: ignore

class Content_447(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Running / OK", 1: "Failed", 2: "Degraded", 3: "Undefined", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

class RuleContent_447(RuleContentContextFree):
    cv_arg: TypeAlias = Content_447.cv_arg
    cv_content: TypeAlias = Content_447

    @property
    def content(self) -> Content_447:
        return self._get_content() # type: ignore

class Variation_487(Element):
    cv_arg: TypeAlias = RuleContent_447.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_447

    @classmethod
    def create(cls, arg: "Variation_487.cv_arg") -> "Variation_487":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_447:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_447:
        return self.rule.content

class RuleVariation_476(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_487.cv_arg
    cv_variation: TypeAlias = Variation_487

    @classmethod
    def create(cls, arg : "RuleVariation_476.cv_arg") -> "RuleVariation_476":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_487:
        return self.arg # type: ignore

class Content_408(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "OK", 1: "Failed", 2: "Degraded", 3: "Undefined", 4: "Reserved for future use", 5: "Reserved for future use", 6: "Reserved for future use", 7: "Reserved for future use"}

class RuleContent_408(RuleContentContextFree):
    cv_arg: TypeAlias = Content_408.cv_arg
    cv_content: TypeAlias = Content_408

    @property
    def content(self) -> Content_408:
        return self._get_content() # type: ignore

class Variation_788(Element):
    cv_arg: TypeAlias = RuleContent_408.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_408

    @classmethod
    def create(cls, arg: "Variation_788.cv_arg") -> "Variation_788":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_408:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_408:
        return self.rule.content

class RuleVariation_767(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_788.cv_arg
    cv_variation: TypeAlias = Variation_788

    @classmethod
    def create(cls, arg : "RuleVariation_767.cv_arg") -> "RuleVariation_767":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_788:
        return self.arg # type: ignore

class NonSpare_1364(NonSpare):
    cv_arg: TypeAlias = RuleVariation_22.cv_arg
    cv_name = "NOGO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_22

    @classmethod
    def create(cls, arg : "NonSpare_1364.cv_arg") -> "NonSpare_1364":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_22:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_22:
        return self.rule.variation

class Item_624(Item):
    cv_arg: TypeAlias = NonSpare_1364.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1364

    @classmethod
    def create(cls, arg : "Item_624.cv_arg") -> "Item_624":
        return cls._create(arg) # type: ignore

class NonSpare_1400(NonSpare):
    cv_arg: TypeAlias = RuleVariation_465.cv_arg
    cv_name = "OPS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_465

    @classmethod
    def create(cls, arg : "NonSpare_1400.cv_arg") -> "NonSpare_1400":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_465:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_476:
        return self.rule.variation

class Item_659(Item):
    cv_arg: TypeAlias = NonSpare_1400.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1400

    @classmethod
    def create(cls, arg : "Item_659.cv_arg") -> "Item_659":
        return cls._create(arg) # type: ignore

class NonSpare_1768(NonSpare):
    cv_arg: TypeAlias = RuleVariation_683.cv_arg
    cv_name = "SSTAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_683

    @classmethod
    def create(cls, arg : "NonSpare_1768.cv_arg") -> "NonSpare_1768":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_683:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_694:
        return self.rule.variation

class Item_933(Item):
    cv_arg: TypeAlias = NonSpare_1768.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1768

    @classmethod
    def create(cls, arg : "Item_933.cv_arg") -> "Item_933":
        return cls._create(arg) # type: ignore

class NonSpare_1815(NonSpare):
    cv_arg: TypeAlias = RuleVariation_476.cv_arg
    cv_name = "SYSTAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_476

    @classmethod
    def create(cls, arg : "NonSpare_1815.cv_arg") -> "NonSpare_1815":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_476:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_487:
        return self.rule.variation

class Item_967(Item):
    cv_arg: TypeAlias = NonSpare_1815.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1815

    @classmethod
    def create(cls, arg : "Item_967.cv_arg") -> "Item_967":
        return cls._create(arg) # type: ignore

class NonSpare_1702(NonSpare):
    cv_arg: TypeAlias = RuleVariation_767.cv_arg
    cv_name = "SESTAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_767

    @classmethod
    def create(cls, arg : "NonSpare_1702.cv_arg") -> "NonSpare_1702":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_767:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_788:
        return self.rule.variation

class Item_881(Item):
    cv_arg: TypeAlias = NonSpare_1702.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1702

    @classmethod
    def create(cls, arg : "Item_881.cv_arg") -> "Item_881":
        return cls._create(arg) # type: ignore

class Variation_1375(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_22.cv_arg, Tuple[Literal["NOGO"], RuleVariation_22.cv_arg]], Union[RuleVariation_465.cv_arg, Tuple[Literal["OPS"], RuleVariation_465.cv_arg]], Union[RuleVariation_683.cv_arg, Tuple[Literal["SSTAT"], RuleVariation_683.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_476.cv_arg, Tuple[Literal["SYSTAT"], RuleVariation_476.cv_arg]], Union[RuleVariation_767.cv_arg, Tuple[Literal["SESTAT"], RuleVariation_767.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1375.cv_arg_group_1"],
        Tuple["Variation_1375.cv_arg_group_1", "Variation_1375.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_624, 1), (Item_659, 2), (Item_933, 4), None], [(Item_0, 1), (Item_967, 3), (Item_881, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1375.cv_arg") -> 'Variation_1375':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_22:
        ...
    @overload
    def get_item(self, key : Literal["OPS"]) -> RuleVariation_465:
        ...
    @overload
    def get_item(self, key : Literal["SSTAT"]) -> RuleVariation_683:
        ...
    @overload
    def get_item(self, key : Literal["SYSTAT"]) -> Optional[RuleVariation_476]:
        ...
    @overload
    def get_item(self, key : Literal["SESTAT"]) -> Optional[RuleVariation_767]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1296(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1375.cv_arg
    cv_variation: TypeAlias = Variation_1375

    @classmethod
    def create(cls, arg : "RuleVariation_1296.cv_arg") -> "RuleVariation_1296":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1375:
        return self.arg # type: ignore

class NonSpare_277(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1296.cv_arg
    cv_name = "100"
    cv_title = "System and Service Status"
    cv_rule: TypeAlias = RuleVariation_1296

    @classmethod
    def create(cls, arg : "NonSpare_277.cv_arg") -> "NonSpare_277":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1296:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1375:
        return self.rule.variation

class UapItem_277(UapItem):
    cv_non_spare: TypeAlias = NonSpare_277

class Content_360(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No error detected (shall not be sent)", 1: "Error Code Undefined", 2: "Time Source Invalid", 3: "Time Source Coasting", 4: "Track ID numbering has restarted", 5: "Data Processor Overload", 6: "Ground Interface Data Communications Overload", 7: "System stopped by operator", 8: "CBIT failed", 9: "Test Target Failure", 10: "Reserved for allocation by the AMG", 11: "Reserved for allocation by the AMG", 12: "Reserved for allocation by the AMG", 13: "Reserved for allocation by the AMG", 14: "Reserved for allocation by the AMG", 15: "Reserved for allocation by the AMG", 16: "Reserved for allocation by the AMG", 17: "Reserved for allocation by the AMG", 18: "Reserved for allocation by the AMG", 19: "Reserved for allocation by the AMG", 20: "Reserved for allocation by the AMG", 21: "Reserved for allocation by the AMG", 22: "Reserved for allocation by the AMG", 23: "Reserved for allocation by the AMG", 24: "Reserved for allocation by the AMG", 25: "Reserved for allocation by the AMG", 26: "Reserved for allocation by the AMG", 27: "Reserved for allocation by the AMG", 28: "Reserved for allocation by the AMG", 29: "Reserved for allocation by the AMG", 30: "Reserved for allocation by the AMG", 31: "Reserved for allocation by the AMG", 32: "Reserved for allocation by system manufacturers", 33: "Reserved for allocation by system manufacturers", 34: "Reserved for allocation by system manufacturers", 35: "Reserved for allocation by system manufacturers", 36: "Reserved for allocation by system manufacturers", 37: "Reserved for allocation by system manufacturers", 38: "Reserved for allocation by system manufacturers", 39: "Reserved for allocation by system manufacturers", 40: "Reserved for allocation by system manufacturers", 41: "Reserved for allocation by system manufacturers", 42: "Reserved for allocation by system manufacturers", 43: "Reserved for allocation by system manufacturers", 44: "Reserved for allocation by system manufacturers", 45: "Reserved for allocation by system manufacturers", 46: "Reserved for allocation by system manufacturers", 47: "Reserved for allocation by system manufacturers", 48: "Reserved for allocation by system manufacturers", 49: "Reserved for allocation by system manufacturers", 50: "Reserved for allocation by system manufacturers", 51: "Reserved for allocation by system manufacturers", 52: "Reserved for allocation by system manufacturers", 53: "Reserved for allocation by system manufacturers", 54: "Reserved for allocation by system manufacturers", 55: "Reserved for allocation by system manufacturers", 56: "Reserved for allocation by system manufacturers", 57: "Reserved for allocation by system manufacturers", 58: "Reserved for allocation by system manufacturers", 59: "Reserved for allocation by system manufacturers", 60: "Reserved for allocation by system manufacturers", 61: "Reserved for allocation by system manufacturers", 62: "Reserved for allocation by system manufacturers", 63: "Reserved for allocation by system manufacturers", 64: "Reserved for allocation by system manufacturers", 65: "Reserved for allocation by system manufacturers", 66: "Reserved for allocation by system manufacturers", 67: "Reserved for allocation by system manufacturers", 68: "Reserved for allocation by system manufacturers", 69: "Reserved for allocation by system manufacturers", 70: "Reserved for allocation by system manufacturers", 71: "Reserved for allocation by system manufacturers", 72: "Reserved for allocation by system manufacturers", 73: "Reserved for allocation by system manufacturers", 74: "Reserved for allocation by system manufacturers", 75: "Reserved for allocation by system manufacturers", 76: "Reserved for allocation by system manufacturers", 77: "Reserved for allocation by system manufacturers", 78: "Reserved for allocation by system manufacturers", 79: "Reserved for allocation by system manufacturers", 80: "Reserved for allocation by system manufacturers", 81: "Reserved for allocation by system manufacturers", 82: "Reserved for allocation by system manufacturers", 83: "Reserved for allocation by system manufacturers", 84: "Reserved for allocation by system manufacturers", 85: "Reserved for allocation by system manufacturers", 86: "Reserved for allocation by system manufacturers", 87: "Reserved for allocation by system manufacturers", 88: "Reserved for allocation by system manufacturers", 89: "Reserved for allocation by system manufacturers", 90: "Reserved for allocation by system manufacturers", 91: "Reserved for allocation by system manufacturers", 92: "Reserved for allocation by system manufacturers", 93: "Reserved for allocation by system manufacturers", 94: "Reserved for allocation by system manufacturers", 95: "Reserved for allocation by system manufacturers", 96: "Reserved for allocation by system manufacturers", 97: "Reserved for allocation by system manufacturers", 98: "Reserved for allocation by system manufacturers", 99: "Reserved for allocation by system manufacturers", 100: "Reserved for allocation by system manufacturers", 101: "Reserved for allocation by system manufacturers", 102: "Reserved for allocation by system manufacturers", 103: "Reserved for allocation by system manufacturers", 104: "Reserved for allocation by system manufacturers", 105: "Reserved for allocation by system manufacturers", 106: "Reserved for allocation by system manufacturers", 107: "Reserved for allocation by system manufacturers", 108: "Reserved for allocation by system manufacturers", 109: "Reserved for allocation by system manufacturers", 110: "Reserved for allocation by system manufacturers", 111: "Reserved for allocation by system manufacturers", 112: "Reserved for allocation by system manufacturers", 113: "Reserved for allocation by system manufacturers", 114: "Reserved for allocation by system manufacturers", 115: "Reserved for allocation by system manufacturers", 116: "Reserved for allocation by system manufacturers", 117: "Reserved for allocation by system manufacturers", 118: "Reserved for allocation by system manufacturers", 119: "Reserved for allocation by system manufacturers", 120: "Reserved for allocation by system manufacturers", 121: "Reserved for allocation by system manufacturers", 122: "Reserved for allocation by system manufacturers", 123: "Reserved for allocation by system manufacturers", 124: "Reserved for allocation by system manufacturers", 125: "Reserved for allocation by system manufacturers", 126: "Reserved for allocation by system manufacturers", 127: "Reserved for allocation by system manufacturers", 128: "Reserved for allocation by system manufacturers", 129: "Reserved for allocation by system manufacturers", 130: "Reserved for allocation by system manufacturers", 131: "Reserved for allocation by system manufacturers", 132: "Reserved for allocation by system manufacturers", 133: "Reserved for allocation by system manufacturers", 134: "Reserved for allocation by system manufacturers", 135: "Reserved for allocation by system manufacturers", 136: "Reserved for allocation by system manufacturers", 137: "Reserved for allocation by system manufacturers", 138: "Reserved for allocation by system manufacturers", 139: "Reserved for allocation by system manufacturers", 140: "Reserved for allocation by system manufacturers", 141: "Reserved for allocation by system manufacturers", 142: "Reserved for allocation by system manufacturers", 143: "Reserved for allocation by system manufacturers", 144: "Reserved for allocation by system manufacturers", 145: "Reserved for allocation by system manufacturers", 146: "Reserved for allocation by system manufacturers", 147: "Reserved for allocation by system manufacturers", 148: "Reserved for allocation by system manufacturers", 149: "Reserved for allocation by system manufacturers", 150: "Reserved for allocation by system manufacturers", 151: "Reserved for allocation by system manufacturers", 152: "Reserved for allocation by system manufacturers", 153: "Reserved for allocation by system manufacturers", 154: "Reserved for allocation by system manufacturers", 155: "Reserved for allocation by system manufacturers", 156: "Reserved for allocation by system manufacturers", 157: "Reserved for allocation by system manufacturers", 158: "Reserved for allocation by system manufacturers", 159: "Reserved for allocation by system manufacturers", 160: "Reserved for allocation by system manufacturers", 161: "Reserved for allocation by system manufacturers", 162: "Reserved for allocation by system manufacturers", 163: "Reserved for allocation by system manufacturers", 164: "Reserved for allocation by system manufacturers", 165: "Reserved for allocation by system manufacturers", 166: "Reserved for allocation by system manufacturers", 167: "Reserved for allocation by system manufacturers", 168: "Reserved for allocation by system manufacturers", 169: "Reserved for allocation by system manufacturers", 170: "Reserved for allocation by system manufacturers", 171: "Reserved for allocation by system manufacturers", 172: "Reserved for allocation by system manufacturers", 173: "Reserved for allocation by system manufacturers", 174: "Reserved for allocation by system manufacturers", 175: "Reserved for allocation by system manufacturers", 176: "Reserved for allocation by system manufacturers", 177: "Reserved for allocation by system manufacturers", 178: "Reserved for allocation by system manufacturers", 179: "Reserved for allocation by system manufacturers", 180: "Reserved for allocation by system manufacturers", 181: "Reserved for allocation by system manufacturers", 182: "Reserved for allocation by system manufacturers", 183: "Reserved for allocation by system manufacturers", 184: "Reserved for allocation by system manufacturers", 185: "Reserved for allocation by system manufacturers", 186: "Reserved for allocation by system manufacturers", 187: "Reserved for allocation by system manufacturers", 188: "Reserved for allocation by system manufacturers", 189: "Reserved for allocation by system manufacturers", 190: "Reserved for allocation by system manufacturers", 191: "Reserved for allocation by system manufacturers", 192: "Reserved for allocation by system manufacturers", 193: "Reserved for allocation by system manufacturers", 194: "Reserved for allocation by system manufacturers", 195: "Reserved for allocation by system manufacturers", 196: "Reserved for allocation by system manufacturers", 197: "Reserved for allocation by system manufacturers", 198: "Reserved for allocation by system manufacturers", 199: "Reserved for allocation by system manufacturers", 200: "Reserved for allocation by system manufacturers", 201: "Reserved for allocation by system manufacturers", 202: "Reserved for allocation by system manufacturers", 203: "Reserved for allocation by system manufacturers", 204: "Reserved for allocation by system manufacturers", 205: "Reserved for allocation by system manufacturers", 206: "Reserved for allocation by system manufacturers", 207: "Reserved for allocation by system manufacturers", 208: "Reserved for allocation by system manufacturers", 209: "Reserved for allocation by system manufacturers", 210: "Reserved for allocation by system manufacturers", 211: "Reserved for allocation by system manufacturers", 212: "Reserved for allocation by system manufacturers", 213: "Reserved for allocation by system manufacturers", 214: "Reserved for allocation by system manufacturers", 215: "Reserved for allocation by system manufacturers", 216: "Reserved for allocation by system manufacturers", 217: "Reserved for allocation by system manufacturers", 218: "Reserved for allocation by system manufacturers", 219: "Reserved for allocation by system manufacturers", 220: "Reserved for allocation by system manufacturers", 221: "Reserved for allocation by system manufacturers", 222: "Reserved for allocation by system manufacturers", 223: "Reserved for allocation by system manufacturers", 224: "Reserved for allocation by system manufacturers", 225: "Reserved for allocation by system manufacturers", 226: "Reserved for allocation by system manufacturers", 227: "Reserved for allocation by system manufacturers", 228: "Reserved for allocation by system manufacturers", 229: "Reserved for allocation by system manufacturers", 230: "Reserved for allocation by system manufacturers", 231: "Reserved for allocation by system manufacturers", 232: "Reserved for allocation by system manufacturers", 233: "Reserved for allocation by system manufacturers", 234: "Reserved for allocation by system manufacturers", 235: "Reserved for allocation by system manufacturers", 236: "Reserved for allocation by system manufacturers", 237: "Reserved for allocation by system manufacturers", 238: "Reserved for allocation by system manufacturers", 239: "Reserved for allocation by system manufacturers", 240: "Reserved for allocation by system manufacturers", 241: "Reserved for allocation by system manufacturers", 242: "Reserved for allocation by system manufacturers", 243: "Reserved for allocation by system manufacturers", 244: "Reserved for allocation by system manufacturers", 245: "Reserved for allocation by system manufacturers", 246: "Reserved for allocation by system manufacturers", 247: "Reserved for allocation by system manufacturers", 248: "Reserved for allocation by system manufacturers", 249: "Reserved for allocation by system manufacturers", 250: "Reserved for allocation by system manufacturers", 251: "Reserved for allocation by system manufacturers", 252: "Reserved for allocation by system manufacturers", 253: "Reserved for allocation by system manufacturers", 254: "Reserved for allocation by system manufacturers", 255: "Reserved for allocation by system manufacturers"}

class RuleContent_360(RuleContentContextFree):
    cv_arg: TypeAlias = Content_360.cv_arg
    cv_content: TypeAlias = Content_360

    @property
    def content(self) -> Content_360:
        return self._get_content() # type: ignore

class Variation_172(Element):
    cv_arg: TypeAlias = RuleContent_360.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_360

    @classmethod
    def create(cls, arg: "Variation_172.cv_arg") -> "Variation_172":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_360:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_360:
        return self.rule.content

class Variation_1395(Repetitive):
    cv_arg: TypeAlias = List[Variation_172.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_172

    @classmethod
    def create(cls, arg: "Variation_1395.cv_arg") -> 'Variation_1395':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_172]:
        return self._get_list() # type: ignore

class RuleVariation_1316(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1395.cv_arg
    cv_variation: TypeAlias = Variation_1395

    @classmethod
    def create(cls, arg : "RuleVariation_1316.cv_arg") -> "RuleVariation_1316":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1395:
        return self.arg # type: ignore

class NonSpare_283(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1316.cv_arg
    cv_name = "105"
    cv_title = "System and Service Error Codes"
    cv_rule: TypeAlias = RuleVariation_1316

    @classmethod
    def create(cls, arg : "NonSpare_283.cv_arg") -> "NonSpare_283":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1316:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1395:
        return self.rule.variation

class UapItem_283(UapItem):
    cv_non_spare: TypeAlias = NonSpare_283

class NonSpare_741(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "CID"
    cv_title = "Component ID"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_741.cv_arg") -> "NonSpare_741":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_160(Item):
    cv_arg: TypeAlias = NonSpare_741.cv_arg
    cv_non_spare: TypeAlias = NonSpare_741

    @classmethod
    def create(cls, arg : "Item_160.cv_arg") -> "Item_160":
        return cls._create(arg) # type: ignore

class Content_307(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Error Detected", 1: "Error Code Undefined", 2: "Reserved for allocation by the AMG", 3: "Reserved for allocation by the AMG", 4: "Reserved for allocation by the AMG", 5: "Reserved for allocation by the AMG", 6: "Reserved for allocation by the AMG", 7: "Reserved for allocation by the AMG", 8: "Reserved for allocation by the AMG", 9: "Reserved for allocation by the AMG", 10: "Reserved for allocation by the AMG", 11: "Reserved for allocation by the AMG", 12: "Reserved for allocation by the AMG", 13: "Reserved for allocation by the AMG", 14: "Reserved for allocation by the AMG", 15: "Reserved for allocation by the AMG", 16: "Reserved for allocation by system manufacturers", 17: "Reserved for allocation by system manufacturers", 18: "Reserved for allocation by system manufacturers", 19: "Reserved for allocation by system manufacturers", 20: "Reserved for allocation by system manufacturers", 21: "Reserved for allocation by system manufacturers", 22: "Reserved for allocation by system manufacturers", 23: "Reserved for allocation by system manufacturers", 24: "Reserved for allocation by system manufacturers", 25: "Reserved for allocation by system manufacturers", 26: "Reserved for allocation by system manufacturers", 27: "Reserved for allocation by system manufacturers", 28: "Reserved for allocation by system manufacturers", 29: "Reserved for allocation by system manufacturers", 30: "Reserved for allocation by system manufacturers", 31: "Reserved for allocation by system manufacturers", 32: "Reserved for allocation by system manufacturers", 33: "Reserved for allocation by system manufacturers", 34: "Reserved for allocation by system manufacturers", 35: "Reserved for allocation by system manufacturers", 36: "Reserved for allocation by system manufacturers", 37: "Reserved for allocation by system manufacturers", 38: "Reserved for allocation by system manufacturers", 39: "Reserved for allocation by system manufacturers", 40: "Reserved for allocation by system manufacturers", 41: "Reserved for allocation by system manufacturers", 42: "Reserved for allocation by system manufacturers", 43: "Reserved for allocation by system manufacturers", 44: "Reserved for allocation by system manufacturers", 45: "Reserved for allocation by system manufacturers", 46: "Reserved for allocation by system manufacturers", 47: "Reserved for allocation by system manufacturers", 48: "Reserved for allocation by system manufacturers", 49: "Reserved for allocation by system manufacturers", 50: "Reserved for allocation by system manufacturers", 51: "Reserved for allocation by system manufacturers", 52: "Reserved for allocation by system manufacturers", 53: "Reserved for allocation by system manufacturers", 54: "Reserved for allocation by system manufacturers", 55: "Reserved for allocation by system manufacturers", 56: "Reserved for allocation by system manufacturers", 57: "Reserved for allocation by system manufacturers", 58: "Reserved for allocation by system manufacturers", 59: "Reserved for allocation by system manufacturers", 60: "Reserved for allocation by system manufacturers", 61: "Reserved for allocation by system manufacturers", 62: "Reserved for allocation by system manufacturers", 63: "Reserved for allocation by system manufacturers"}

class RuleContent_307(RuleContentContextFree):
    cv_arg: TypeAlias = Content_307.cv_arg
    cv_content: TypeAlias = Content_307

    @property
    def content(self) -> Content_307:
        return self._get_content() # type: ignore

class Variation_148(Element):
    cv_arg: TypeAlias = RuleContent_307.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 6
    cv_rule = RuleContent_307

    @classmethod
    def create(cls, arg: "Variation_148.cv_arg") -> "Variation_148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_307:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_307:
        return self.rule.content

class RuleVariation_148(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_148.cv_arg
    cv_variation: TypeAlias = Variation_148

    @classmethod
    def create(cls, arg : "RuleVariation_148.cv_arg") -> "RuleVariation_148":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_148:
        return self.arg # type: ignore

class NonSpare_960(NonSpare):
    cv_arg: TypeAlias = RuleVariation_148.cv_arg
    cv_name = "ERRC"
    cv_title = "Error Code"
    cv_rule: TypeAlias = RuleVariation_148

    @classmethod
    def create(cls, arg : "NonSpare_960.cv_arg") -> "NonSpare_960":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_148:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_148:
        return self.rule.variation

class Item_319(Item):
    cv_arg: TypeAlias = NonSpare_960.cv_arg
    cv_non_spare: TypeAlias = NonSpare_960

    @classmethod
    def create(cls, arg : "Item_319.cv_arg") -> "Item_319":
        return cls._create(arg) # type: ignore

class Content_446(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Running", 1: "Failed", 2: "Maintenance", 3: "Reserved"}

class RuleContent_446(RuleContentContextFree):
    cv_arg: TypeAlias = Content_446.cv_arg
    cv_content: TypeAlias = Content_446

    @property
    def content(self) -> Content_446:
        return self._get_content() # type: ignore

class Variation_963(Element):
    cv_arg: TypeAlias = RuleContent_446.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_446

    @classmethod
    def create(cls, arg: "Variation_963.cv_arg") -> "Variation_963":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_446:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_446:
        return self.rule.content

class RuleVariation_933(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_963.cv_arg
    cv_variation: TypeAlias = Variation_963

    @classmethod
    def create(cls, arg : "RuleVariation_933.cv_arg") -> "RuleVariation_933":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_963:
        return self.arg # type: ignore

class NonSpare_833(NonSpare):
    cv_arg: TypeAlias = RuleVariation_933.cv_arg
    cv_name = "CS"
    cv_title = "Component State/Mode"
    cv_rule: TypeAlias = RuleVariation_933

    @classmethod
    def create(cls, arg : "NonSpare_833.cv_arg") -> "NonSpare_833":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_933:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_963:
        return self.rule.variation

class Item_218(Item):
    cv_arg: TypeAlias = NonSpare_833.cv_arg
    cv_non_spare: TypeAlias = NonSpare_833

    @classmethod
    def create(cls, arg : "Item_218.cv_arg") -> "Item_218":
        return cls._create(arg) # type: ignore

class Variation_1070(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_246.cv_arg, Tuple[Literal["CID"], RuleVariation_246.cv_arg]], Union[RuleVariation_148.cv_arg, Tuple[Literal["ERRC"], RuleVariation_148.cv_arg]], Union[RuleVariation_933.cv_arg, Tuple[Literal["CS"], RuleVariation_933.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1070.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_160, 16), (Item_319, 6), (Item_218, 2)]
    cv_items_dict = {"CID": RuleVariation_246, "ERRC": RuleVariation_148, "CS": RuleVariation_933}

    @overload
    @classmethod
    def spec(cls, key : Literal["CID"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ERRC"]) -> RuleVariation_148:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> RuleVariation_933:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CID"], Literal["ERRC"], Literal["CS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CID"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["ERRC"]) -> RuleVariation_148:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> RuleVariation_933:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1070.cv_arg") -> 'Variation_1070':
        return cls._create(arg) # type: ignore

class Variation_1415(Repetitive):
    cv_arg: TypeAlias = List[Variation_1070.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1070

    @classmethod
    def create(cls, arg: "Variation_1415.cv_arg") -> 'Variation_1415':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1070]:
        return self._get_list() # type: ignore

class RuleVariation_1336(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1415.cv_arg
    cv_variation: TypeAlias = Variation_1415

    @classmethod
    def create(cls, arg : "RuleVariation_1336.cv_arg") -> "RuleVariation_1336":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1415:
        return self.arg # type: ignore

class NonSpare_296(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1336.cv_arg
    cv_name = "120"
    cv_title = "Component Status"
    cv_rule: TypeAlias = RuleVariation_1336

    @classmethod
    def create(cls, arg : "NonSpare_296.cv_arg") -> "NonSpare_296":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1415:
        return self.rule.variation

class UapItem_296(UapItem):
    cv_non_spare: TypeAlias = NonSpare_296

class Content_407(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Number of unknown messages received", 1: "Number of too old messages received", 2: "Number of failed message conversions", 3: "Total Number of messages received", 4: "Total number of messages transmitted", 5: "Reserved for AMG", 6: "Reserved for AMG", 7: "Reserved for AMG", 8: "Reserved for AMG", 9: "Reserved for AMG", 10: "Reserved for AMG", 11: "Reserved for AMG", 12: "Reserved for AMG", 13: "Reserved for AMG", 14: "Reserved for AMG", 15: "Reserved for AMG", 16: "Reserved for AMG", 17: "Reserved for AMG", 18: "Reserved for AMG", 19: "Reserved for AMG", 20: "Implementation specific", 21: "Implementation specific", 22: "Implementation specific", 23: "Implementation specific", 24: "Implementation specific", 25: "Implementation specific", 26: "Implementation specific", 27: "Implementation specific", 28: "Implementation specific", 29: "Implementation specific", 30: "Implementation specific", 31: "Implementation specific", 32: "Implementation specific", 33: "Implementation specific", 34: "Implementation specific", 35: "Implementation specific", 36: "Implementation specific", 37: "Implementation specific", 38: "Implementation specific", 39: "Implementation specific", 40: "Implementation specific", 41: "Implementation specific", 42: "Implementation specific", 43: "Implementation specific", 44: "Implementation specific", 45: "Implementation specific", 46: "Implementation specific", 47: "Implementation specific", 48: "Implementation specific", 49: "Implementation specific", 50: "Implementation specific", 51: "Implementation specific", 52: "Implementation specific", 53: "Implementation specific", 54: "Implementation specific", 55: "Implementation specific", 56: "Implementation specific", 57: "Implementation specific", 58: "Implementation specific", 59: "Implementation specific", 60: "Implementation specific", 61: "Implementation specific", 62: "Implementation specific", 63: "Implementation specific", 64: "Implementation specific", 65: "Implementation specific", 66: "Implementation specific", 67: "Implementation specific", 68: "Implementation specific", 69: "Implementation specific", 70: "Implementation specific", 71: "Implementation specific", 72: "Implementation specific", 73: "Implementation specific", 74: "Implementation specific", 75: "Implementation specific", 76: "Implementation specific", 77: "Implementation specific", 78: "Implementation specific", 79: "Implementation specific", 80: "Implementation specific", 81: "Implementation specific", 82: "Implementation specific", 83: "Implementation specific", 84: "Implementation specific", 85: "Implementation specific", 86: "Implementation specific", 87: "Implementation specific", 88: "Implementation specific", 89: "Implementation specific", 90: "Implementation specific", 91: "Implementation specific", 92: "Implementation specific", 93: "Implementation specific", 94: "Implementation specific", 95: "Implementation specific", 96: "Implementation specific", 97: "Implementation specific", 98: "Implementation specific", 99: "Implementation specific", 100: "Implementation specific", 101: "Implementation specific", 102: "Implementation specific", 103: "Implementation specific", 104: "Implementation specific", 105: "Implementation specific", 106: "Implementation specific", 107: "Implementation specific", 108: "Implementation specific", 109: "Implementation specific", 110: "Implementation specific", 111: "Implementation specific", 112: "Implementation specific", 113: "Implementation specific", 114: "Implementation specific", 115: "Implementation specific", 116: "Implementation specific", 117: "Implementation specific", 118: "Implementation specific", 119: "Implementation specific", 120: "Implementation specific", 121: "Implementation specific", 122: "Implementation specific", 123: "Implementation specific", 124: "Implementation specific", 125: "Implementation specific", 126: "Implementation specific", 127: "Implementation specific", 128: "Implementation specific", 129: "Implementation specific", 130: "Implementation specific", 131: "Implementation specific", 132: "Implementation specific", 133: "Implementation specific", 134: "Implementation specific", 135: "Implementation specific", 136: "Implementation specific", 137: "Implementation specific", 138: "Implementation specific", 139: "Implementation specific", 140: "Implementation specific", 141: "Implementation specific", 142: "Implementation specific", 143: "Implementation specific", 144: "Implementation specific", 145: "Implementation specific", 146: "Implementation specific", 147: "Implementation specific", 148: "Implementation specific", 149: "Implementation specific", 150: "Implementation specific", 151: "Implementation specific", 152: "Implementation specific", 153: "Implementation specific", 154: "Implementation specific", 155: "Implementation specific", 156: "Implementation specific", 157: "Implementation specific", 158: "Implementation specific", 159: "Implementation specific", 160: "Implementation specific", 161: "Implementation specific", 162: "Implementation specific", 163: "Implementation specific", 164: "Implementation specific", 165: "Implementation specific", 166: "Implementation specific", 167: "Implementation specific", 168: "Implementation specific", 169: "Implementation specific", 170: "Implementation specific", 171: "Implementation specific", 172: "Implementation specific", 173: "Implementation specific", 174: "Implementation specific", 175: "Implementation specific", 176: "Implementation specific", 177: "Implementation specific", 178: "Implementation specific", 179: "Implementation specific", 180: "Implementation specific", 181: "Implementation specific", 182: "Implementation specific", 183: "Implementation specific", 184: "Implementation specific", 185: "Implementation specific", 186: "Implementation specific", 187: "Implementation specific", 188: "Implementation specific", 189: "Implementation specific", 190: "Implementation specific", 191: "Implementation specific", 192: "Implementation specific", 193: "Implementation specific", 194: "Implementation specific", 195: "Implementation specific", 196: "Implementation specific", 197: "Implementation specific", 198: "Implementation specific", 199: "Implementation specific", 200: "Implementation specific", 201: "Implementation specific", 202: "Implementation specific", 203: "Implementation specific", 204: "Implementation specific", 205: "Implementation specific", 206: "Implementation specific", 207: "Implementation specific", 208: "Implementation specific", 209: "Implementation specific", 210: "Implementation specific", 211: "Implementation specific", 212: "Implementation specific", 213: "Implementation specific", 214: "Implementation specific", 215: "Implementation specific", 216: "Implementation specific", 217: "Implementation specific", 218: "Implementation specific", 219: "Implementation specific", 220: "Implementation specific", 221: "Implementation specific", 222: "Implementation specific", 223: "Implementation specific", 224: "Implementation specific", 225: "Implementation specific", 226: "Implementation specific", 227: "Implementation specific", 228: "Implementation specific", 229: "Implementation specific", 230: "Implementation specific", 231: "Implementation specific", 232: "Implementation specific", 233: "Implementation specific", 234: "Implementation specific", 235: "Implementation specific", 236: "Implementation specific", 237: "Implementation specific", 238: "Implementation specific", 239: "Implementation specific", 240: "Implementation specific", 241: "Implementation specific", 242: "Implementation specific", 243: "Implementation specific", 244: "Implementation specific", 245: "Implementation specific", 246: "Implementation specific", 247: "Implementation specific", 248: "Implementation specific", 249: "Implementation specific", 250: "Implementation specific", 251: "Implementation specific", 252: "Implementation specific", 253: "Implementation specific", 254: "Implementation specific", 255: "Implementation specific"}

class RuleContent_407(RuleContentContextFree):
    cv_arg: TypeAlias = Content_407.cv_arg
    cv_content: TypeAlias = Content_407

    @property
    def content(self) -> Content_407:
        return self._get_content() # type: ignore

class Variation_174(Element):
    cv_arg: TypeAlias = RuleContent_407.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_407

    @classmethod
    def create(cls, arg: "Variation_174.cv_arg") -> "Variation_174":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_407:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_407:
        return self.rule.content

class RuleVariation_167(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_174.cv_arg
    cv_variation: TypeAlias = Variation_174

    @classmethod
    def create(cls, arg : "RuleVariation_167.cv_arg") -> "RuleVariation_167":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_174:
        return self.arg # type: ignore

class NonSpare_1974(NonSpare):
    cv_arg: TypeAlias = RuleVariation_167.cv_arg
    cv_name = "TYPE"
    cv_title = "Type of Report Counter"
    cv_rule: TypeAlias = RuleVariation_167

    @classmethod
    def create(cls, arg : "NonSpare_1974.cv_arg") -> "NonSpare_1974":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_167:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_174:
        return self.rule.variation

class Item_1087(Item):
    cv_arg: TypeAlias = NonSpare_1974.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1974

    @classmethod
    def create(cls, arg : "Item_1087.cv_arg") -> "Item_1087":
        return cls._create(arg) # type: ignore

class Content_216(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "From UTC midnight", 1: "From the previous report"}

class RuleContent_216(RuleContentContextFree):
    cv_arg: TypeAlias = Content_216.cv_arg
    cv_content: TypeAlias = Content_216

    @property
    def content(self) -> Content_216:
        return self._get_content() # type: ignore

class Variation_44(Element):
    cv_arg: TypeAlias = RuleContent_216.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_216

    @classmethod
    def create(cls, arg: "Variation_44.cv_arg") -> "Variation_44":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_216:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_216:
        return self.rule.content

class RuleVariation_44(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_44.cv_arg
    cv_variation: TypeAlias = Variation_44

    @classmethod
    def create(cls, arg : "RuleVariation_44.cv_arg") -> "RuleVariation_44":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_44:
        return self.arg # type: ignore

class NonSpare_1575(NonSpare):
    cv_arg: TypeAlias = RuleVariation_44.cv_arg
    cv_name = "REF"
    cv_title = "Reference from which the Messages Are Counted"
    cv_rule: TypeAlias = RuleVariation_44

    @classmethod
    def create(cls, arg : "NonSpare_1575.cv_arg") -> "NonSpare_1575":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_44:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_44:
        return self.rule.variation

class Item_800(Item):
    cv_arg: TypeAlias = NonSpare_1575.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1575

    @classmethod
    def create(cls, arg : "Item_800.cv_arg") -> "Item_800":
        return cls._create(arg) # type: ignore

class NonSpare_800(NonSpare):
    cv_arg: TypeAlias = RuleVariation_368.cv_arg
    cv_name = "COUNT"
    cv_title = "Counter Value"
    cv_rule: TypeAlias = RuleVariation_368

    @classmethod
    def create(cls, arg : "NonSpare_800.cv_arg") -> "NonSpare_800":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

class Item_199(Item):
    cv_arg: TypeAlias = NonSpare_800.cv_arg
    cv_non_spare: TypeAlias = NonSpare_800

    @classmethod
    def create(cls, arg : "Item_199.cv_arg") -> "Item_199":
        return cls._create(arg) # type: ignore

class Variation_1246(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_167.cv_arg, Tuple[Literal["TYPE"], RuleVariation_167.cv_arg]], Union[RuleVariation_44.cv_arg, Tuple[Literal["REF"], RuleVariation_44.cv_arg]], int, Union[RuleVariation_368.cv_arg, Tuple[Literal["COUNT"], RuleVariation_368.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1246.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1087, 8), (Item_800, 1), (Item_10, 7), (Item_199, 32)]
    cv_items_dict = {"TYPE": RuleVariation_167, "REF": RuleVariation_44, "COUNT": RuleVariation_368}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_167:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REF"]) -> RuleVariation_44:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNT"]) -> RuleVariation_368:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["REF"], Literal["COUNT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_167:
        ...
    @overload
    def get_item(self, key : Literal["REF"]) -> RuleVariation_44:
        ...
    @overload
    def get_item(self, key : Literal["COUNT"]) -> RuleVariation_368:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1246.cv_arg") -> 'Variation_1246':
        return cls._create(arg) # type: ignore

class Variation_1448(Repetitive):
    cv_arg: TypeAlias = List[Variation_1246.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1246

    @classmethod
    def create(cls, arg: "Variation_1448.cv_arg") -> 'Variation_1448':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1246]:
        return self._get_list() # type: ignore

class RuleVariation_1369(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1448.cv_arg
    cv_variation: TypeAlias = Variation_1448

    @classmethod
    def create(cls, arg : "RuleVariation_1369.cv_arg") -> "RuleVariation_1369":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1448:
        return self.arg # type: ignore

class NonSpare_326(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1369.cv_arg
    cv_name = "140"
    cv_title = "Service Statistics"
    cv_rule: TypeAlias = RuleVariation_1369

    @classmethod
    def create(cls, arg : "NonSpare_326.cv_arg") -> "NonSpare_326":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1369:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1448:
        return self.rule.variation

class UapItem_326(UapItem):
    cv_non_spare: TypeAlias = NonSpare_326

class Content_707(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 4.190951585769653e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_707(RuleContentContextFree):
    cv_arg: TypeAlias = Content_707.cv_arg
    cv_content: TypeAlias = Content_707

    @property
    def content(self) -> Content_707:
        return self._get_content() # type: ignore

class Variation_385(Element):
    cv_arg: TypeAlias = RuleContent_707.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_707

    @classmethod
    def create(cls, arg: "Variation_385.cv_arg") -> "Variation_385":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_707:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_707:
        return self.rule.content

class RuleVariation_378(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_385.cv_arg
    cv_variation: TypeAlias = Variation_385

    @classmethod
    def create(cls, arg : "RuleVariation_378.cv_arg") -> "RuleVariation_378":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_385:
        return self.arg # type: ignore

class NonSpare_1155(NonSpare):
    cv_arg: TypeAlias = RuleVariation_378.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude"
    cv_rule: TypeAlias = RuleVariation_378

    @classmethod
    def create(cls, arg : "NonSpare_1155.cv_arg") -> "NonSpare_1155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_378:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_385:
        return self.rule.variation

class Item_467(Item):
    cv_arg: TypeAlias = NonSpare_1155.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1155

    @classmethod
    def create(cls, arg : "Item_467.cv_arg") -> "Item_467":
        return cls._create(arg) # type: ignore

class Content_706(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 4.190951585769653e-8
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_706(RuleContentContextFree):
    cv_arg: TypeAlias = Content_706.cv_arg
    cv_content: TypeAlias = Content_706

    @property
    def content(self) -> Content_706:
        return self._get_content() # type: ignore

class Variation_384(Element):
    cv_arg: TypeAlias = RuleContent_706.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_706

    @classmethod
    def create(cls, arg: "Variation_384.cv_arg") -> "Variation_384":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_706:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_706:
        return self.rule.content

class RuleVariation_377(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_384.cv_arg
    cv_variation: TypeAlias = Variation_384

    @classmethod
    def create(cls, arg : "RuleVariation_377.cv_arg") -> "RuleVariation_377":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_384:
        return self.arg # type: ignore

class NonSpare_1185(NonSpare):
    cv_arg: TypeAlias = RuleVariation_377.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_377

    @classmethod
    def create(cls, arg : "NonSpare_1185.cv_arg") -> "NonSpare_1185":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_377:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_384:
        return self.rule.variation

class Item_495(Item):
    cv_arg: TypeAlias = NonSpare_1185.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1185

    @classmethod
    def create(cls, arg : "Item_495.cv_arg") -> "Item_495":
        return cls._create(arg) # type: ignore

class Variation_1131(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_378.cv_arg, Tuple[Literal["LAT"], RuleVariation_378.cv_arg]], Union[RuleVariation_377.cv_arg, Tuple[Literal["LON"], RuleVariation_377.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1131.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_467, 32), (Item_495, 32)]
    cv_items_dict = {"LAT": RuleVariation_378, "LON": RuleVariation_377}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_378:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_377:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_378:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_377:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1131.cv_arg") -> 'Variation_1131':
        return cls._create(arg) # type: ignore

class RuleVariation_1087(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1131.cv_arg
    cv_variation: TypeAlias = Variation_1131

    @classmethod
    def create(cls, arg : "RuleVariation_1087.cv_arg") -> "RuleVariation_1087":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1131:
        return self.arg # type: ignore

class NonSpare_531(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1087.cv_arg
    cv_name = "600"
    cv_title = "Position of the System Reference Point"
    cv_rule: TypeAlias = RuleVariation_1087

    @classmethod
    def create(cls, arg : "NonSpare_531.cv_arg") -> "NonSpare_531":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1087:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1131:
        return self.rule.variation

class UapItem_530(UapItem):
    cv_non_spare: TypeAlias = NonSpare_531

class Content_661(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_661(RuleContentContextFree):
    cv_arg: TypeAlias = Content_661.cv_arg
    cv_content: TypeAlias = Content_661

    @property
    def content(self) -> Content_661:
        return self._get_content() # type: ignore

class Variation_278(Element):
    cv_arg: TypeAlias = RuleContent_661.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_661

    @classmethod
    def create(cls, arg: "Variation_278.cv_arg") -> "Variation_278":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_661:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_661:
        return self.rule.content

class RuleVariation_271(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_278.cv_arg
    cv_variation: TypeAlias = Variation_278

    @classmethod
    def create(cls, arg : "RuleVariation_271.cv_arg") -> "RuleVariation_271":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_278:
        return self.arg # type: ignore

class NonSpare_539(NonSpare):
    cv_arg: TypeAlias = RuleVariation_271.cv_arg
    cv_name = "610"
    cv_title = "Height of the System Reference Point"
    cv_rule: TypeAlias = RuleVariation_271

    @classmethod
    def create(cls, arg : "NonSpare_539.cv_arg") -> "NonSpare_539":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_271:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_278:
        return self.rule.variation

class UapItem_538(UapItem):
    cv_non_spare: TypeAlias = NonSpare_539

class Record_11(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_32.cv_arg,
        "000": NonSpare_19.cv_arg,
        "200": NonSpare_393.cv_arg,
        "015": NonSpare_68.cv_arg,
        "020": NonSpare_83.cv_arg,
        "070": NonSpare_219.cv_arg,
        "100": NonSpare_277.cv_arg,
        "105": NonSpare_283.cv_arg,
        "120": NonSpare_296.cv_arg,
        "140": NonSpare_326.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "600": NonSpare_531.cv_arg,
        "610": NonSpare_539.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_32, UapItem_19, UapItem_393, UapItem_68, UapItem_83, UapItem_219, UapItem_277, UapItem_283, UapItem_296, UapItem_326, UapItem_548, UapItem_530, UapItem_538]
    cv_items_dict = {"010": NonSpare_32, "000": NonSpare_19, "200": NonSpare_393, "015": NonSpare_68, "020": NonSpare_83, "070": NonSpare_219, "100": NonSpare_277, "105": NonSpare_283, "120": NonSpare_296, "140": NonSpare_326, "SP": NonSpare_1732, "600": NonSpare_531, "610": NonSpare_539}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_32:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_19:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_393:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_68:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_83:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_219:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_277:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_283:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_296:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_326:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["600"]) -> NonSpare_531:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["610"]) -> NonSpare_539:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["200"], Literal["015"], Literal["020"], Literal["070"], Literal["100"], Literal["105"], Literal["120"], Literal["140"], Literal["SP"], Literal["600"], Literal["610"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_32]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_19]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_393]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_68]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_83]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_219]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_277]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_283]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_296]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_326]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["600"]) -> Optional[NonSpare_531]:
        ...
    @overload
    def get_item(self, key : Literal["610"]) -> Optional[NonSpare_539]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_32.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_19.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_393.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_68.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_83.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_219.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_277.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_283.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_296.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_326.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["600"], val : NonSpare_531.cv_arg) -> 'Record_11':
        ...
    @overload
    def set_item(self, key : Literal["610"], val : NonSpare_539.cv_arg) -> 'Record_11':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["600"]) -> 'Record_11':
        ...
    @overload
    def del_item(self, key : Literal["610"]) -> 'Record_11':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_11.cv_arg") -> 'Record_11':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_11", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_11(UapSingle):
    cv_arg: TypeAlias = Record_11
    cv_record: TypeAlias = Record_11

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_11]]:
        return cls._parse(bs)

class Asterix_38(AstCat):
    cv_category = 25
    cv_edition = (1, 5)
    cv_uap: TypeAlias = Uap_11
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_11.cv_arg]) -> "Asterix_38":
        return cls._create(records) # type: ignore

class NonSpare_50(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Server Identification Tag"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_50.cv_arg") -> "NonSpare_50":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_50(UapItem):
    cv_non_spare: TypeAlias = NonSpare_50

class NonSpare_70(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "015"
    cv_title = "User Number"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_70.cv_arg") -> "NonSpare_70":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_70(UapItem):
    cv_non_spare: TypeAlias = NonSpare_70

class NonSpare_74(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "018"
    cv_title = "Data Source Identification Tag"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_74.cv_arg") -> "NonSpare_74":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_74(UapItem):
    cv_non_spare: TypeAlias = NonSpare_74

class Content_580(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Information sent by an FPPS"}

class RuleContent_580(RuleContentContextFree):
    cv_arg: TypeAlias = Content_580.cv_arg
    cv_content: TypeAlias = Content_580

    @property
    def content(self) -> Content_580:
        return self._get_content() # type: ignore

class Variation_136(Element):
    cv_arg: TypeAlias = RuleContent_580.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_580

    @classmethod
    def create(cls, arg: "Variation_136.cv_arg") -> "Variation_136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_580:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_580:
        return self.rule.content

class RuleVariation_136(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_136.cv_arg
    cv_variation: TypeAlias = Variation_136

    @classmethod
    def create(cls, arg : "RuleVariation_136.cv_arg") -> "RuleVariation_136":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_136:
        return self.arg # type: ignore

class NonSpare_969(NonSpare):
    cv_arg: TypeAlias = RuleVariation_136.cv_arg
    cv_name = "FAMILY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_136

    @classmethod
    def create(cls, arg : "NonSpare_969.cv_arg") -> "NonSpare_969":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_136:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_136:
        return self.rule.variation

class Item_327(Item):
    cv_arg: TypeAlias = NonSpare_969.cv_arg
    cv_non_spare: TypeAlias = NonSpare_969

    @classmethod
    def create(cls, arg : "Item_327.cv_arg") -> "Item_327":
        return cls._create(arg) # type: ignore

class Content_577(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Flight Plan to track initial correlation", 2: "Miniplan update", 3: "End of correlation", 4: "Miniplan Cancellation", 5: "Retained Miniplan"}

class RuleContent_577(RuleContentContextFree):
    cv_arg: TypeAlias = Content_577.cv_arg
    cv_content: TypeAlias = Content_577

    @property
    def content(self) -> Content_577:
        return self._get_content() # type: ignore

class Variation_803(Element):
    cv_arg: TypeAlias = RuleContent_577.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_577

    @classmethod
    def create(cls, arg: "Variation_803.cv_arg") -> "Variation_803":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_577:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_577:
        return self.rule.content

class RuleVariation_773(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_803.cv_arg
    cv_variation: TypeAlias = Variation_803

    @classmethod
    def create(cls, arg : "RuleVariation_773.cv_arg") -> "RuleVariation_773":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_803:
        return self.arg # type: ignore

class NonSpare_1344(NonSpare):
    cv_arg: TypeAlias = RuleVariation_773.cv_arg
    cv_name = "NATURE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_773

    @classmethod
    def create(cls, arg : "NonSpare_1344.cv_arg") -> "NonSpare_1344":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_773:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_803:
        return self.rule.variation

class Item_606(Item):
    cv_arg: TypeAlias = NonSpare_1344.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1344

    @classmethod
    def create(cls, arg : "Item_606.cv_arg") -> "Item_606":
        return cls._create(arg) # type: ignore

class Variation_1104(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_136.cv_arg, Tuple[Literal["FAMILY"], RuleVariation_136.cv_arg]], Union[RuleVariation_773.cv_arg, Tuple[Literal["NATURE"], RuleVariation_773.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1104.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_327, 4), (Item_606, 4)]
    cv_items_dict = {"FAMILY": RuleVariation_136, "NATURE": RuleVariation_773}

    @overload
    @classmethod
    def spec(cls, key : Literal["FAMILY"]) -> RuleVariation_136:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NATURE"]) -> RuleVariation_773:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["FAMILY"], Literal["NATURE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["FAMILY"]) -> RuleVariation_136:
        ...
    @overload
    def get_item(self, key : Literal["NATURE"]) -> RuleVariation_773:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1104.cv_arg") -> 'Variation_1104':
        return cls._create(arg) # type: ignore

class RuleVariation_1062(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1104.cv_arg
    cv_variation: TypeAlias = Variation_1104

    @classmethod
    def create(cls, arg : "RuleVariation_1062.cv_arg") -> "RuleVariation_1062":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1104:
        return self.arg # type: ignore

class NonSpare_131(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1062.cv_arg
    cv_name = "035"
    cv_title = "Type of Message"
    cv_rule: TypeAlias = RuleVariation_1062

    @classmethod
    def create(cls, arg : "NonSpare_131.cv_arg") -> "NonSpare_131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1062:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1104:
        return self.rule.variation

class UapItem_131(UapItem):
    cv_non_spare: TypeAlias = NonSpare_131

class NonSpare_92(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "020"
    cv_title = "Time of ASTERIX Report Generation"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_92.cv_arg") -> "NonSpare_92":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_92(UapItem):
    cv_non_spare: TypeAlias = NonSpare_92

class NonSpare_150(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "040"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_150.cv_arg") -> "NonSpare_150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_150(UapItem):
    cv_non_spare: TypeAlias = NonSpare_150

class Variation_252(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 15
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_252.cv_arg") -> "Variation_252":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_245(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_252.cv_arg
    cv_variation: TypeAlias = Variation_252

    @classmethod
    def create(cls, arg : "RuleVariation_245.cv_arg") -> "RuleVariation_245":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_252:
        return self.arg # type: ignore

class NonSpare_1807(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "SUI"
    cv_title = "System Unit Identification"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1807.cv_arg") -> "NonSpare_1807":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_963(Item):
    cv_arg: TypeAlias = NonSpare_1807.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1807

    @classmethod
    def create(cls, arg : "Item_963.cv_arg") -> "Item_963":
        return cls._create(arg) # type: ignore

class NonSpare_1793(NonSpare):
    cv_arg: TypeAlias = RuleVariation_245.cv_arg
    cv_name = "STN"
    cv_title = "System Track Number"
    cv_rule: TypeAlias = RuleVariation_245

    @classmethod
    def create(cls, arg : "NonSpare_1793.cv_arg") -> "NonSpare_1793":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_252:
        return self.rule.variation

class Item_953(Item):
    cv_arg: TypeAlias = NonSpare_1793.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1793

    @classmethod
    def create(cls, arg : "Item_953.cv_arg") -> "Item_953":
        return cls._create(arg) # type: ignore

class Variation_1386(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_198.cv_arg, Tuple[Literal["SUI"], RuleVariation_198.cv_arg]], Union[RuleVariation_245.cv_arg, Tuple[Literal["STN"], RuleVariation_245.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1386.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_963, 8), (Item_953, 15), None]]

    @classmethod
    def create(cls, arg: "Variation_1386.cv_arg") -> 'Variation_1386':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["SUI"]) -> RuleVariation_198:
        ...
    @overload
    def get_item(self, key : Literal["STN"]) -> RuleVariation_245:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1307(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1386.cv_arg
    cv_variation: TypeAlias = Variation_1386

    @classmethod
    def create(cls, arg : "RuleVariation_1307.cv_arg") -> "RuleVariation_1307":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1386:
        return self.arg # type: ignore

class NonSpare_169(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1307.cv_arg
    cv_name = "050"
    cv_title = "Composed Track Number"
    cv_rule: TypeAlias = RuleVariation_1307

    @classmethod
    def create(cls, arg : "NonSpare_169.cv_arg") -> "NonSpare_169":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1307:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1386:
        return self.rule.variation

class UapItem_169(UapItem):
    cv_non_spare: TypeAlias = NonSpare_169

class NonSpare_1305(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "MODE3A"
    cv_title = "(Mode 3/A Code) 4 Digits, Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1305.cv_arg") -> "NonSpare_1305":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_571(Item):
    cv_arg: TypeAlias = NonSpare_1305.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1305

    @classmethod
    def create(cls, arg : "Item_571.cv_arg") -> "Item_571":
        return cls._create(arg) # type: ignore

class Variation_1026(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1026.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_571, 12)]
    cv_items_dict = {"MODE3A": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1026.cv_arg") -> 'Variation_1026':
        return cls._create(arg) # type: ignore

class RuleVariation_995(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1026.cv_arg
    cv_variation: TypeAlias = Variation_1026

    @classmethod
    def create(cls, arg : "RuleVariation_995.cv_arg") -> "RuleVariation_995":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1026:
        return self.arg # type: ignore

class NonSpare_201(NonSpare):
    cv_arg: TypeAlias = RuleVariation_995.cv_arg
    cv_name = "060"
    cv_title = "Track Mode 3/A"
    cv_rule: TypeAlias = RuleVariation_995

    @classmethod
    def create(cls, arg : "NonSpare_201.cv_arg") -> "NonSpare_201":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_995:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1026:
        return self.rule.variation

class UapItem_201(UapItem):
    cv_non_spare: TypeAlias = NonSpare_201

class NonSpare_496(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "400"
    cv_title = "Callsign"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_496.cv_arg") -> "NonSpare_496":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class UapItem_495(UapItem):
    cv_non_spare: TypeAlias = NonSpare_496

class NonSpare_502(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "410"
    cv_title = "Plan Number"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_502.cv_arg") -> "NonSpare_502":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_501(UapItem):
    cv_non_spare: TypeAlias = NonSpare_502

class NonSpare_1024(NonSpare):
    cv_arg: TypeAlias = RuleVariation_116.cv_arg
    cv_name = "GATOAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_116

    @classmethod
    def create(cls, arg : "NonSpare_1024.cv_arg") -> "NonSpare_1024":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_116:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_116:
        return self.rule.variation

class Item_362(Item):
    cv_arg: TypeAlias = NonSpare_1024.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1024

    @classmethod
    def create(cls, arg : "Item_362.cv_arg") -> "Item_362":
        return cls._create(arg) # type: ignore

class NonSpare_993(NonSpare):
    cv_arg: TypeAlias = RuleVariation_581.cv_arg
    cv_name = "FR1FR2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_581

    @classmethod
    def create(cls, arg : "NonSpare_993.cv_arg") -> "NonSpare_993":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_581:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_592:
        return self.rule.variation

class Item_342(Item):
    cv_arg: TypeAlias = NonSpare_993.cv_arg
    cv_non_spare: TypeAlias = NonSpare_993

    @classmethod
    def create(cls, arg : "Item_342.cv_arg") -> "Item_342":
        return cls._create(arg) # type: ignore

class NonSpare_1735(NonSpare):
    cv_arg: TypeAlias = RuleVariation_688.cv_arg
    cv_name = "SP3"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_688

    @classmethod
    def create(cls, arg : "NonSpare_1735.cv_arg") -> "NonSpare_1735":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_688:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_699:
        return self.rule.variation

class Item_908(Item):
    cv_arg: TypeAlias = NonSpare_1735.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1735

    @classmethod
    def create(cls, arg : "Item_908.cv_arg") -> "Item_908":
        return cls._create(arg) # type: ignore

class Variation_817(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_817.cv_arg") -> "Variation_817":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_787(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_817.cv_arg
    cv_variation: TypeAlias = Variation_817

    @classmethod
    def create(cls, arg : "RuleVariation_787.cv_arg") -> "RuleVariation_787":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_817:
        return self.arg # type: ignore

class NonSpare_1734(NonSpare):
    cv_arg: TypeAlias = RuleVariation_787.cv_arg
    cv_name = "SP2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_787

    @classmethod
    def create(cls, arg : "NonSpare_1734.cv_arg") -> "NonSpare_1734":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_787:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_817:
        return self.rule.variation

class Item_907(Item):
    cv_arg: TypeAlias = NonSpare_1734.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1734

    @classmethod
    def create(cls, arg : "Item_907.cv_arg") -> "Item_907":
        return cls._create(arg) # type: ignore

class Variation_899(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_899.cv_arg") -> "Variation_899":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_869(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_899.cv_arg
    cv_variation: TypeAlias = Variation_899

    @classmethod
    def create(cls, arg : "RuleVariation_869.cv_arg") -> "RuleVariation_869":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_899:
        return self.arg # type: ignore

class NonSpare_1733(NonSpare):
    cv_arg: TypeAlias = RuleVariation_869.cv_arg
    cv_name = "SP1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_869

    @classmethod
    def create(cls, arg : "NonSpare_1733.cv_arg") -> "NonSpare_1733":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_869:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_899:
        return self.rule.variation

class Item_906(Item):
    cv_arg: TypeAlias = NonSpare_1733.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1733

    @classmethod
    def create(cls, arg : "Item_906.cv_arg") -> "Item_906":
        return cls._create(arg) # type: ignore

class Variation_1110(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_116.cv_arg, Tuple[Literal["GATOAT"], RuleVariation_116.cv_arg]], Union[RuleVariation_581.cv_arg, Tuple[Literal["FR1FR2"], RuleVariation_581.cv_arg]], Union[RuleVariation_688.cv_arg, Tuple[Literal["SP3"], RuleVariation_688.cv_arg]], Union[RuleVariation_787.cv_arg, Tuple[Literal["SP2"], RuleVariation_787.cv_arg]], Union[RuleVariation_869.cv_arg, Tuple[Literal["SP1"], RuleVariation_869.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1110.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_362, 2), (Item_342, 2), (Item_908, 1), (Item_907, 1), (Item_906, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_116, "FR1FR2": RuleVariation_581, "SP3": RuleVariation_688, "SP2": RuleVariation_787, "SP1": RuleVariation_869}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_581:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP3"]) -> RuleVariation_688:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP2"]) -> RuleVariation_787:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP1"]) -> RuleVariation_869:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["SP3"], Literal["SP2"], Literal["SP1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_581:
        ...
    @overload
    def get_item(self, key : Literal["SP3"]) -> RuleVariation_688:
        ...
    @overload
    def get_item(self, key : Literal["SP2"]) -> RuleVariation_787:
        ...
    @overload
    def get_item(self, key : Literal["SP1"]) -> RuleVariation_869:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1110.cv_arg") -> 'Variation_1110':
        return cls._create(arg) # type: ignore

class RuleVariation_1068(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1110.cv_arg
    cv_variation: TypeAlias = Variation_1110

    @classmethod
    def create(cls, arg : "RuleVariation_1068.cv_arg") -> "RuleVariation_1068":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1110:
        return self.arg # type: ignore

class NonSpare_504(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1068.cv_arg
    cv_name = "420"
    cv_title = "Flight Category"
    cv_rule: TypeAlias = RuleVariation_1068

    @classmethod
    def create(cls, arg : "NonSpare_504.cv_arg") -> "NonSpare_504":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1068:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1110:
        return self.rule.variation

class UapItem_503(UapItem):
    cv_non_spare: TypeAlias = NonSpare_504

class NonSpare_509(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "440"
    cv_title = "Departure Aerodrome"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_509.cv_arg") -> "NonSpare_509":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_508(UapItem):
    cv_non_spare: TypeAlias = NonSpare_509

class NonSpare_510(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "450"
    cv_title = "Destination Aerodrome"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_510.cv_arg") -> "NonSpare_510":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_509(UapItem):
    cv_non_spare: TypeAlias = NonSpare_510

class Content_753(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_752(RuleContentContextFree):
    cv_arg: TypeAlias = Content_753.cv_arg
    cv_content: TypeAlias = Content_753

    @property
    def content(self) -> Content_753:
        return self._get_content() # type: ignore

class Variation_322(Element):
    cv_arg: TypeAlias = RuleContent_752.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_752

    @classmethod
    def create(cls, arg: "Variation_322.cv_arg") -> "Variation_322":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_752:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_753:
        return self.rule.content

class RuleVariation_315(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_322.cv_arg
    cv_variation: TypeAlias = Variation_322

    @classmethod
    def create(cls, arg : "RuleVariation_315.cv_arg") -> "RuleVariation_315":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_322:
        return self.arg # type: ignore

class NonSpare_513(NonSpare):
    cv_arg: TypeAlias = RuleVariation_315.cv_arg
    cv_name = "480"
    cv_title = "Current Cleared Flight Level"
    cv_rule: TypeAlias = RuleVariation_315

    @classmethod
    def create(cls, arg : "NonSpare_513.cv_arg") -> "NonSpare_513":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_315:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_322:
        return self.rule.variation

class UapItem_512(UapItem):
    cv_non_spare: TypeAlias = NonSpare_513

class NonSpare_722(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "CEN"
    cv_title = "Centre"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_722.cv_arg") -> "NonSpare_722":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_148(Item):
    cv_arg: TypeAlias = NonSpare_722.cv_arg
    cv_non_spare: TypeAlias = NonSpare_722

    @classmethod
    def create(cls, arg : "Item_148.cv_arg") -> "Item_148":
        return cls._create(arg) # type: ignore

class NonSpare_1448(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "POS"
    cv_title = "Position"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1448.cv_arg") -> "NonSpare_1448":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_693(Item):
    cv_arg: TypeAlias = NonSpare_1448.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1448

    @classmethod
    def create(cls, arg : "Item_693.cv_arg") -> "Item_693":
        return cls._create(arg) # type: ignore

class Variation_1067(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["CEN"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["POS"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1067.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_148, 8), (Item_693, 8)]
    cv_items_dict = {"CEN": RuleVariation_159, "POS": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["CEN"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CEN"], Literal["POS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CEN"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1067.cv_arg") -> 'Variation_1067':
        return cls._create(arg) # type: ignore

class RuleVariation_1029(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1067.cv_arg
    cv_variation: TypeAlias = Variation_1067

    @classmethod
    def create(cls, arg : "RuleVariation_1029.cv_arg") -> "RuleVariation_1029":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1067:
        return self.arg # type: ignore

class NonSpare_514(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1029.cv_arg
    cv_name = "490"
    cv_title = "Current Control Position"
    cv_rule: TypeAlias = RuleVariation_1029

    @classmethod
    def create(cls, arg : "NonSpare_514.cv_arg") -> "NonSpare_514":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1029:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1067:
        return self.rule.variation

class UapItem_513(UapItem):
    cv_non_spare: TypeAlias = NonSpare_514

class NonSpare_507(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "430"
    cv_title = "Type of Aircraft"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_507.cv_arg") -> "NonSpare_507":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_506(UapItem):
    cv_non_spare: TypeAlias = NonSpare_507

class NonSpare_508(NonSpare):
    cv_arg: TypeAlias = RuleVariation_195.cv_arg
    cv_name = "435"
    cv_title = "Wake Turbulence Category"
    cv_rule: TypeAlias = RuleVariation_195

    @classmethod
    def create(cls, arg : "NonSpare_508.cv_arg") -> "NonSpare_508":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_195:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_202:
        return self.rule.variation

class UapItem_507(UapItem):
    cv_non_spare: TypeAlias = NonSpare_508

class NonSpare_1391(NonSpare):
    cv_arg: TypeAlias = RuleVariation_763.cv_arg
    cv_name = "OCT1"
    cv_title = "1st Octal Digit"
    cv_rule: TypeAlias = RuleVariation_763

    @classmethod
    def create(cls, arg : "NonSpare_1391.cv_arg") -> "NonSpare_1391":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_763:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_774:
        return self.rule.variation

class Item_650(Item):
    cv_arg: TypeAlias = NonSpare_1391.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1391

    @classmethod
    def create(cls, arg : "Item_650.cv_arg") -> "Item_650":
        return cls._create(arg) # type: ignore

class Variation_992(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_992.cv_arg") -> "Variation_992":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_962(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_992.cv_arg
    cv_variation: TypeAlias = Variation_992

    @classmethod
    def create(cls, arg : "RuleVariation_962.cv_arg") -> "RuleVariation_962":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_992:
        return self.arg # type: ignore

class NonSpare_1392(NonSpare):
    cv_arg: TypeAlias = RuleVariation_962.cv_arg
    cv_name = "OCT2"
    cv_title = "2nd Octal Digit"
    cv_rule: TypeAlias = RuleVariation_962

    @classmethod
    def create(cls, arg : "NonSpare_1392.cv_arg") -> "NonSpare_1392":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_962:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_992:
        return self.rule.variation

class Item_651(Item):
    cv_arg: TypeAlias = NonSpare_1392.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1392

    @classmethod
    def create(cls, arg : "Item_651.cv_arg") -> "Item_651":
        return cls._create(arg) # type: ignore

class Variation_597(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_597.cv_arg") -> "Variation_597":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_586(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_597.cv_arg
    cv_variation: TypeAlias = Variation_597

    @classmethod
    def create(cls, arg : "RuleVariation_586.cv_arg") -> "RuleVariation_586":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_597:
        return self.arg # type: ignore

class NonSpare_1393(NonSpare):
    cv_arg: TypeAlias = RuleVariation_586.cv_arg
    cv_name = "OCT3"
    cv_title = "3rd Octal Digit"
    cv_rule: TypeAlias = RuleVariation_586

    @classmethod
    def create(cls, arg : "NonSpare_1393.cv_arg") -> "NonSpare_1393":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_586:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_597:
        return self.rule.variation

class Item_652(Item):
    cv_arg: TypeAlias = NonSpare_1393.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1393

    @classmethod
    def create(cls, arg : "Item_652.cv_arg") -> "Item_652":
        return cls._create(arg) # type: ignore

class NonSpare_1394(NonSpare):
    cv_arg: TypeAlias = RuleVariation_859.cv_arg
    cv_name = "OCT4"
    cv_title = "4th Octal Digit"
    cv_rule: TypeAlias = RuleVariation_859

    @classmethod
    def create(cls, arg : "NonSpare_1394.cv_arg") -> "NonSpare_1394":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_859:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_889:
        return self.rule.variation

class Item_653(Item):
    cv_arg: TypeAlias = NonSpare_1394.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1394

    @classmethod
    def create(cls, arg : "Item_653.cv_arg") -> "Item_653":
        return cls._create(arg) # type: ignore

class Variation_1030(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_763.cv_arg, Tuple[Literal["OCT1"], RuleVariation_763.cv_arg]], Union[RuleVariation_962.cv_arg, Tuple[Literal["OCT2"], RuleVariation_962.cv_arg]], Union[RuleVariation_586.cv_arg, Tuple[Literal["OCT3"], RuleVariation_586.cv_arg]], Union[RuleVariation_859.cv_arg, Tuple[Literal["OCT4"], RuleVariation_859.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1030.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_650, 3), (Item_651, 3), (Item_652, 3), (Item_653, 3)]
    cv_items_dict = {"OCT1": RuleVariation_763, "OCT2": RuleVariation_962, "OCT3": RuleVariation_586, "OCT4": RuleVariation_859}

    @overload
    @classmethod
    def spec(cls, key : Literal["OCT1"]) -> RuleVariation_763:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OCT2"]) -> RuleVariation_962:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OCT3"]) -> RuleVariation_586:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OCT4"]) -> RuleVariation_859:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["OCT1"], Literal["OCT2"], Literal["OCT3"], Literal["OCT4"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["OCT1"]) -> RuleVariation_763:
        ...
    @overload
    def get_item(self, key : Literal["OCT2"]) -> RuleVariation_962:
        ...
    @overload
    def get_item(self, key : Literal["OCT3"]) -> RuleVariation_586:
        ...
    @overload
    def get_item(self, key : Literal["OCT4"]) -> RuleVariation_859:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1030.cv_arg") -> 'Variation_1030':
        return cls._create(arg) # type: ignore

class Variation_1408(Repetitive):
    cv_arg: TypeAlias = List[Variation_1030.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1030

    @classmethod
    def create(cls, arg: "Variation_1408.cv_arg") -> 'Variation_1408':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1030]:
        return self._get_list() # type: ignore

class RuleVariation_1329(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1408.cv_arg
    cv_variation: TypeAlias = Variation_1408

    @classmethod
    def create(cls, arg : "RuleVariation_1329.cv_arg") -> "RuleVariation_1329":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1408:
        return self.arg # type: ignore

class NonSpare_511(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1329.cv_arg
    cv_name = "460"
    cv_title = "Allocated SSR Codes"
    cv_rule: TypeAlias = RuleVariation_1329

    @classmethod
    def create(cls, arg : "NonSpare_511.cv_arg") -> "NonSpare_511":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1408:
        return self.rule.variation

class UapItem_510(UapItem):
    cv_non_spare: TypeAlias = NonSpare_511

class Content_426(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Plan Number", 1: "Unit 1 internal flight number", 2: "Unit 2 internal flight number", 3: "Unit 3 internal flight number"}

class RuleContent_426(RuleContentContextFree):
    cv_arg: TypeAlias = Content_426.cv_arg
    cv_content: TypeAlias = Content_426

    @property
    def content(self) -> Content_426:
        return self._get_content() # type: ignore

class Variation_111(Element):
    cv_arg: TypeAlias = RuleContent_426.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_426

    @classmethod
    def create(cls, arg: "Variation_111.cv_arg") -> "Variation_111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_426:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_426:
        return self.rule.content

class RuleVariation_111(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_111.cv_arg
    cv_variation: TypeAlias = Variation_111

    @classmethod
    def create(cls, arg : "RuleVariation_111.cv_arg") -> "RuleVariation_111":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_111:
        return self.arg # type: ignore

class NonSpare_1958(NonSpare):
    cv_arg: TypeAlias = RuleVariation_111.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_111

    @classmethod
    def create(cls, arg : "NonSpare_1958.cv_arg") -> "NonSpare_1958":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_111:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_111:
        return self.rule.variation

class Item_1072(Item):
    cv_arg: TypeAlias = NonSpare_1958.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1958

    @classmethod
    def create(cls, arg : "Item_1072.cv_arg") -> "Item_1072":
        return cls._create(arg) # type: ignore

class Content_620(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_620(RuleContentContextFree):
    cv_arg: TypeAlias = Content_620.cv_arg
    cv_content: TypeAlias = Content_620

    @property
    def content(self) -> Content_620:
        return self._get_content() # type: ignore

class Variation_897(Element):
    cv_arg: TypeAlias = RuleContent_620.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 27
    cv_rule = RuleContent_620

    @classmethod
    def create(cls, arg: "Variation_897.cv_arg") -> "Variation_897":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_620:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_620:
        return self.rule.content

class RuleVariation_867(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_897.cv_arg
    cv_variation: TypeAlias = Variation_897

    @classmethod
    def create(cls, arg : "RuleVariation_867.cv_arg") -> "RuleVariation_867":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_897:
        return self.arg # type: ignore

class NonSpare_1351(NonSpare):
    cv_arg: TypeAlias = RuleVariation_867.cv_arg
    cv_name = "NBR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_867

    @classmethod
    def create(cls, arg : "NonSpare_1351.cv_arg") -> "NonSpare_1351":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_867:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_897:
        return self.rule.variation

class Item_611(Item):
    cv_arg: TypeAlias = NonSpare_1351.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1351

    @classmethod
    def create(cls, arg : "Item_611.cv_arg") -> "Item_611":
        return cls._create(arg) # type: ignore

class Variation_1233(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_111.cv_arg, Tuple[Literal["TYP"], RuleVariation_111.cv_arg]], int, Union[RuleVariation_867.cv_arg, Tuple[Literal["NBR"], RuleVariation_867.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1233.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1072, 2), (Item_13, 3), (Item_611, 27)]
    cv_items_dict = {"TYP": RuleVariation_111, "NBR": RuleVariation_867}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_867:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["NBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_111:
        ...
    @overload
    def get_item(self, key : Literal["NBR"]) -> RuleVariation_867:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1233.cv_arg") -> 'Variation_1233':
        return cls._create(arg) # type: ignore

class RuleVariation_1171(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1233.cv_arg
    cv_variation: TypeAlias = Variation_1233

    @classmethod
    def create(cls, arg : "RuleVariation_1171.cv_arg") -> "RuleVariation_1171":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1233:
        return self.arg # type: ignore

class NonSpare_1117(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1171.cv_arg
    cv_name = "IFI"
    cv_title = "IFPS FLIGHT ID"
    cv_rule: TypeAlias = RuleVariation_1171

    @classmethod
    def create(cls, arg : "NonSpare_1117.cv_arg") -> "NonSpare_1117":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1171:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1233:
        return self.rule.variation

class Content_542(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Approved", 2: "Exempt", 3: "Not approved"}

class RuleContent_542(RuleContentContextFree):
    cv_arg: TypeAlias = Content_542.cv_arg
    cv_content: TypeAlias = Content_542

    @property
    def content(self) -> Content_542:
        return self._get_content() # type: ignore

class Variation_888(Element):
    cv_arg: TypeAlias = RuleContent_542.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_542

    @classmethod
    def create(cls, arg: "Variation_888.cv_arg") -> "Variation_888":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_542:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_542:
        return self.rule.content

class RuleVariation_858(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_888.cv_arg
    cv_variation: TypeAlias = Variation_888

    @classmethod
    def create(cls, arg : "RuleVariation_858.cv_arg") -> "RuleVariation_858":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_888:
        return self.arg # type: ignore

class NonSpare_1639(NonSpare):
    cv_arg: TypeAlias = RuleVariation_858.cv_arg
    cv_name = "RVSM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_858

    @classmethod
    def create(cls, arg : "NonSpare_1639.cv_arg") -> "NonSpare_1639":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_858:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_888:
        return self.rule.variation

class Item_844(Item):
    cv_arg: TypeAlias = NonSpare_1639.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1639

    @classmethod
    def create(cls, arg : "Item_844.cv_arg") -> "Item_844":
        return cls._create(arg) # type: ignore

class Variation_984(Element):
    cv_arg: TypeAlias = RuleContent_383.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_383

    @classmethod
    def create(cls, arg: "Variation_984.cv_arg") -> "Variation_984":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_383:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_383:
        return self.rule.content

class RuleVariation_954(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_984.cv_arg
    cv_variation: TypeAlias = Variation_984

    @classmethod
    def create(cls, arg : "RuleVariation_954.cv_arg") -> "RuleVariation_954":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_984:
        return self.arg # type: ignore

class NonSpare_1078(NonSpare):
    cv_arg: TypeAlias = RuleVariation_954.cv_arg
    cv_name = "HPR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_954

    @classmethod
    def create(cls, arg : "NonSpare_1078.cv_arg") -> "NonSpare_1078":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_954:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_984:
        return self.rule.variation

class Item_402(Item):
    cv_arg: TypeAlias = NonSpare_1078.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1078

    @classmethod
    def create(cls, arg : "Item_402.cv_arg") -> "Item_402":
        return cls._create(arg) # type: ignore

class Variation_1040(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_858.cv_arg, Tuple[Literal["RVSM"], RuleVariation_858.cv_arg]], Union[RuleVariation_954.cv_arg, Tuple[Literal["HPR"], RuleVariation_954.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1040.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_4, 5), (Item_844, 2), (Item_402, 1)]
    cv_items_dict = {"RVSM": RuleVariation_858, "HPR": RuleVariation_954}

    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_858:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_954:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_858:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_954:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1040.cv_arg") -> 'Variation_1040':
        return cls._create(arg) # type: ignore

class RuleVariation_1008(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1040.cv_arg
    cv_variation: TypeAlias = Variation_1040

    @classmethod
    def create(cls, arg : "RuleVariation_1008.cv_arg") -> "RuleVariation_1008":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1040:
        return self.arg # type: ignore

class NonSpare_1636(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1008.cv_arg
    cv_name = "RVP"
    cv_title = "RVSM & Flight Priority"
    cv_rule: TypeAlias = RuleVariation_1008

    @classmethod
    def create(cls, arg : "NonSpare_1636.cv_arg") -> "NonSpare_1636":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1008:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1040:
        return self.rule.variation

class Variation_203(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_203.cv_arg") -> "Variation_203":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_196(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_203.cv_arg
    cv_variation: TypeAlias = Variation_203

    @classmethod
    def create(cls, arg : "RuleVariation_196.cv_arg") -> "RuleVariation_196":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_203:
        return self.arg # type: ignore

class NonSpare_1383(NonSpare):
    cv_arg: TypeAlias = RuleVariation_196.cv_arg
    cv_name = "NU1"
    cv_title = "First Number"
    cv_rule: TypeAlias = RuleVariation_196

    @classmethod
    def create(cls, arg : "NonSpare_1383.cv_arg") -> "NonSpare_1383":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

class Item_642(Item):
    cv_arg: TypeAlias = NonSpare_1383.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1383

    @classmethod
    def create(cls, arg : "Item_642.cv_arg") -> "Item_642":
        return cls._create(arg) # type: ignore

class NonSpare_1384(NonSpare):
    cv_arg: TypeAlias = RuleVariation_196.cv_arg
    cv_name = "NU2"
    cv_title = "Second Number"
    cv_rule: TypeAlias = RuleVariation_196

    @classmethod
    def create(cls, arg : "NonSpare_1384.cv_arg") -> "NonSpare_1384":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

class Item_643(Item):
    cv_arg: TypeAlias = NonSpare_1384.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1384

    @classmethod
    def create(cls, arg : "Item_643.cv_arg") -> "Item_643":
        return cls._create(arg) # type: ignore

class NonSpare_1200(NonSpare):
    cv_arg: TypeAlias = RuleVariation_196.cv_arg
    cv_name = "LTR"
    cv_title = "Letter"
    cv_rule: TypeAlias = RuleVariation_196

    @classmethod
    def create(cls, arg : "NonSpare_1200.cv_arg") -> "NonSpare_1200":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

class Item_508(Item):
    cv_arg: TypeAlias = NonSpare_1200.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1200

    @classmethod
    def create(cls, arg : "Item_508.cv_arg") -> "Item_508":
        return cls._create(arg) # type: ignore

class Variation_1155(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_196.cv_arg, Tuple[Literal["NU1"], RuleVariation_196.cv_arg]], Union[RuleVariation_196.cv_arg, Tuple[Literal["NU2"], RuleVariation_196.cv_arg]], Union[RuleVariation_196.cv_arg, Tuple[Literal["LTR"], RuleVariation_196.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1155.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_642, 8), (Item_643, 8), (Item_508, 8)]
    cv_items_dict = {"NU1": RuleVariation_196, "NU2": RuleVariation_196, "LTR": RuleVariation_196}

    @overload
    @classmethod
    def spec(cls, key : Literal["NU1"]) -> RuleVariation_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NU2"]) -> RuleVariation_196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTR"]) -> RuleVariation_196:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NU1"], Literal["NU2"], Literal["LTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NU1"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["NU2"]) -> RuleVariation_196:
        ...
    @overload
    def get_item(self, key : Literal["LTR"]) -> RuleVariation_196:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1155.cv_arg") -> 'Variation_1155':
        return cls._create(arg) # type: ignore

class RuleVariation_1108(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1155.cv_arg
    cv_variation: TypeAlias = Variation_1155

    @classmethod
    def create(cls, arg : "RuleVariation_1108.cv_arg") -> "RuleVariation_1108":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1155:
        return self.arg # type: ignore

class NonSpare_1564(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1108.cv_arg
    cv_name = "RDS"
    cv_title = "Runway Designation"
    cv_rule: TypeAlias = RuleVariation_1108

    @classmethod
    def create(cls, arg : "NonSpare_1564.cv_arg") -> "NonSpare_1564":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1108:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1155:
        return self.rule.variation

class Content_454(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Scheduled Off-Block Time", 1: "Estimated Off-Block Time", 2: "Estimated Take-Off Time", 3: "Actual Off-Block Time", 4: "Predicted Time at Runway Hold", 5: "Actual Time at Runway Hold", 6: "Actual Line-Up Time", 7: "Actual Take-Off Time", 8: "Estimated Time of Arrival", 9: "Predicted Landing Time", 10: "Actual Landing Time", 11: "Actual Time off Runway", 12: "Predicted Time to Gate", 13: "Actual On-Block Time"}

class RuleContent_454(RuleContentContextFree):
    cv_arg: TypeAlias = Content_454.cv_arg
    cv_content: TypeAlias = Content_454

    @property
    def content(self) -> Content_454:
        return self._get_content() # type: ignore

class Variation_144(Element):
    cv_arg: TypeAlias = RuleContent_454.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_454

    @classmethod
    def create(cls, arg: "Variation_144.cv_arg") -> "Variation_144":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_454:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_454:
        return self.rule.content

class RuleVariation_144(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_144.cv_arg
    cv_variation: TypeAlias = Variation_144

    @classmethod
    def create(cls, arg : "RuleVariation_144.cv_arg") -> "RuleVariation_144":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_144:
        return self.arg # type: ignore

class NonSpare_1961(NonSpare):
    cv_arg: TypeAlias = RuleVariation_144.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_144

    @classmethod
    def create(cls, arg : "NonSpare_1961.cv_arg") -> "NonSpare_1961":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_144:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_144:
        return self.rule.variation

class Item_1075(Item):
    cv_arg: TypeAlias = NonSpare_1961.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1961

    @classmethod
    def create(cls, arg : "Item_1075.cv_arg") -> "Item_1075":
        return cls._create(arg) # type: ignore

class Content_510(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Today", 1: "Yesterday", 2: "Tomorrow", 3: "Invalid"}

class RuleContent_510(RuleContentContextFree):
    cv_arg: TypeAlias = Content_510.cv_arg
    cv_content: TypeAlias = Content_510

    @property
    def content(self) -> Content_510:
        return self._get_content() # type: ignore

class Variation_885(Element):
    cv_arg: TypeAlias = RuleContent_510.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_510

    @classmethod
    def create(cls, arg: "Variation_885.cv_arg") -> "Variation_885":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_510:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_510:
        return self.rule.content

class RuleVariation_855(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_885.cv_arg
    cv_variation: TypeAlias = Variation_885

    @classmethod
    def create(cls, arg : "RuleVariation_855.cv_arg") -> "RuleVariation_855":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_885:
        return self.arg # type: ignore

class NonSpare_863(NonSpare):
    cv_arg: TypeAlias = RuleVariation_855.cv_arg
    cv_name = "DAY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_855

    @classmethod
    def create(cls, arg : "NonSpare_863.cv_arg") -> "NonSpare_863":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_855:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_885:
        return self.rule.variation

class Item_241(Item):
    cv_arg: TypeAlias = NonSpare_863.cv_arg
    cv_non_spare: TypeAlias = NonSpare_863

    @classmethod
    def create(cls, arg : "Item_241.cv_arg") -> "Item_241":
        return cls._create(arg) # type: ignore

class NonSpare_1073(NonSpare):
    cv_arg: TypeAlias = RuleVariation_685.cv_arg
    cv_name = "HOR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_685

    @classmethod
    def create(cls, arg : "NonSpare_1073.cv_arg") -> "NonSpare_1073":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_685:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_696:
        return self.rule.variation

class Item_398(Item):
    cv_arg: TypeAlias = NonSpare_1073.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1073

    @classmethod
    def create(cls, arg : "Item_398.cv_arg") -> "Item_398":
        return cls._create(arg) # type: ignore

class NonSpare_1287(NonSpare):
    cv_arg: TypeAlias = RuleVariation_592.cv_arg
    cv_name = "MIN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_592

    @classmethod
    def create(cls, arg : "NonSpare_1287.cv_arg") -> "NonSpare_1287":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

class Item_554(Item):
    cv_arg: TypeAlias = NonSpare_1287.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1287

    @classmethod
    def create(cls, arg : "Item_554.cv_arg") -> "Item_554":
        return cls._create(arg) # type: ignore

class NonSpare_651(NonSpare):
    cv_arg: TypeAlias = RuleVariation_75.cv_arg
    cv_name = "AVS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_75

    @classmethod
    def create(cls, arg : "NonSpare_651.cv_arg") -> "NonSpare_651":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_75:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_75:
        return self.rule.variation

class Item_95(Item):
    cv_arg: TypeAlias = NonSpare_651.cv_arg
    cv_non_spare: TypeAlias = NonSpare_651

    @classmethod
    def create(cls, arg : "Item_95.cv_arg") -> "Item_95":
        return cls._create(arg) # type: ignore

class NonSpare_1699(NonSpare):
    cv_arg: TypeAlias = RuleVariation_592.cv_arg
    cv_name = "SEC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_592

    @classmethod
    def create(cls, arg : "NonSpare_1699.cv_arg") -> "NonSpare_1699":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

class Item_878(Item):
    cv_arg: TypeAlias = NonSpare_1699.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1699

    @classmethod
    def create(cls, arg : "Item_878.cv_arg") -> "Item_878":
        return cls._create(arg) # type: ignore

class Variation_1235(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_144.cv_arg, Tuple[Literal["TYP"], RuleVariation_144.cv_arg]], Union[RuleVariation_855.cv_arg, Tuple[Literal["DAY"], RuleVariation_855.cv_arg]], int, Union[RuleVariation_685.cv_arg, Tuple[Literal["HOR"], RuleVariation_685.cv_arg]], int, Union[RuleVariation_592.cv_arg, Tuple[Literal["MIN"], RuleVariation_592.cv_arg]], Union[RuleVariation_75.cv_arg, Tuple[Literal["AVS"], RuleVariation_75.cv_arg]], int, Union[RuleVariation_592.cv_arg, Tuple[Literal["SEC"], RuleVariation_592.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1235.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1075, 5), (Item_241, 2), (Item_30, 4), (Item_398, 5), (Item_1, 2), (Item_554, 6), (Item_95, 1), (Item_7, 1), (Item_878, 6)]
    cv_items_dict = {"TYP": RuleVariation_144, "DAY": RuleVariation_855, "HOR": RuleVariation_685, "MIN": RuleVariation_592, "AVS": RuleVariation_75, "SEC": RuleVariation_592}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_144:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DAY"]) -> RuleVariation_855:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HOR"]) -> RuleVariation_685:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIN"]) -> RuleVariation_592:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVS"]) -> RuleVariation_75:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SEC"]) -> RuleVariation_592:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["DAY"], Literal["HOR"], Literal["MIN"], Literal["AVS"], Literal["SEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_144:
        ...
    @overload
    def get_item(self, key : Literal["DAY"]) -> RuleVariation_855:
        ...
    @overload
    def get_item(self, key : Literal["HOR"]) -> RuleVariation_685:
        ...
    @overload
    def get_item(self, key : Literal["MIN"]) -> RuleVariation_592:
        ...
    @overload
    def get_item(self, key : Literal["AVS"]) -> RuleVariation_75:
        ...
    @overload
    def get_item(self, key : Literal["SEC"]) -> RuleVariation_592:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1235.cv_arg") -> 'Variation_1235':
        return cls._create(arg) # type: ignore

class Variation_1440(Repetitive):
    cv_arg: TypeAlias = List[Variation_1235.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1235

    @classmethod
    def create(cls, arg: "Variation_1440.cv_arg") -> 'Variation_1440':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1235]:
        return self._get_list() # type: ignore

class RuleVariation_1361(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1440.cv_arg
    cv_variation: TypeAlias = Variation_1440

    @classmethod
    def create(cls, arg : "RuleVariation_1361.cv_arg") -> "RuleVariation_1361":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1440:
        return self.arg # type: ignore

class NonSpare_1882(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1361.cv_arg
    cv_name = "TOD"
    cv_title = "Time of Departure / Arrival"
    cv_rule: TypeAlias = RuleVariation_1361

    @classmethod
    def create(cls, arg : "NonSpare_1882.cv_arg") -> "NonSpare_1882":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1361:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1440:
        return self.rule.variation

class Content_206(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Empty", 1: "Occupied", 2: "Unknown", 3: "Invalid"}

class RuleContent_206(RuleContentContextFree):
    cv_arg: TypeAlias = Content_206.cv_arg
    cv_content: TypeAlias = Content_206

    @property
    def content(self) -> Content_206:
        return self._get_content() # type: ignore

class Variation_103(Element):
    cv_arg: TypeAlias = RuleContent_206.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_206

    @classmethod
    def create(cls, arg: "Variation_103.cv_arg") -> "Variation_103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_206:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_206:
        return self.rule.content

class RuleVariation_103(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_103.cv_arg
    cv_variation: TypeAlias = Variation_103

    @classmethod
    def create(cls, arg : "RuleVariation_103.cv_arg") -> "RuleVariation_103":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_103:
        return self.arg # type: ignore

class NonSpare_931(NonSpare):
    cv_arg: TypeAlias = RuleVariation_103.cv_arg
    cv_name = "EMP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_103

    @classmethod
    def create(cls, arg : "NonSpare_931.cv_arg") -> "NonSpare_931":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_103:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_103:
        return self.rule.variation

class Item_292(Item):
    cv_arg: TypeAlias = NonSpare_931.cv_arg
    cv_non_spare: TypeAlias = NonSpare_931

    @classmethod
    def create(cls, arg : "Item_292.cv_arg") -> "Item_292":
        return cls._create(arg) # type: ignore

class Content_44(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Available", 1: "Not available", 2: "Unknown", 3: "Invalid"}

class RuleContent_44(RuleContentContextFree):
    cv_arg: TypeAlias = Content_44.cv_arg
    cv_content: TypeAlias = Content_44

    @property
    def content(self) -> Content_44:
        return self._get_content() # type: ignore

class Variation_589(Element):
    cv_arg: TypeAlias = RuleContent_44.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_44

    @classmethod
    def create(cls, arg: "Variation_589.cv_arg") -> "Variation_589":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_44:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_44:
        return self.rule.content

class RuleVariation_578(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_589.cv_arg
    cv_variation: TypeAlias = Variation_589

    @classmethod
    def create(cls, arg : "RuleVariation_578.cv_arg") -> "RuleVariation_578":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_589:
        return self.arg # type: ignore

class NonSpare_649(NonSpare):
    cv_arg: TypeAlias = RuleVariation_578.cv_arg
    cv_name = "AVL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_578

    @classmethod
    def create(cls, arg : "NonSpare_649.cv_arg") -> "NonSpare_649":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_578:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_589:
        return self.rule.variation

class Item_93(Item):
    cv_arg: TypeAlias = NonSpare_649.cv_arg
    cv_non_spare: TypeAlias = NonSpare_649

    @classmethod
    def create(cls, arg : "Item_93.cv_arg") -> "Item_93":
        return cls._create(arg) # type: ignore

class Variation_1087(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_103.cv_arg, Tuple[Literal["EMP"], RuleVariation_103.cv_arg]], Union[RuleVariation_578.cv_arg, Tuple[Literal["AVL"], RuleVariation_578.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1087.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_292, 2), (Item_93, 2), (Item_22, 4)]
    cv_items_dict = {"EMP": RuleVariation_103, "AVL": RuleVariation_578}

    @overload
    @classmethod
    def spec(cls, key : Literal["EMP"]) -> RuleVariation_103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVL"]) -> RuleVariation_578:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EMP"], Literal["AVL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EMP"]) -> RuleVariation_103:
        ...
    @overload
    def get_item(self, key : Literal["AVL"]) -> RuleVariation_578:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1087.cv_arg") -> 'Variation_1087':
        return cls._create(arg) # type: ignore

class RuleVariation_1045(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1087.cv_arg
    cv_variation: TypeAlias = Variation_1087

    @classmethod
    def create(cls, arg : "RuleVariation_1045.cv_arg") -> "RuleVariation_1045":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1087:
        return self.arg # type: ignore

class NonSpare_1798(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1045.cv_arg
    cv_name = "STS"
    cv_title = "Stand Status"
    cv_rule: TypeAlias = RuleVariation_1045

    @classmethod
    def create(cls, arg : "NonSpare_1798.cv_arg") -> "NonSpare_1798":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1045:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1087:
        return self.rule.variation

class NonSpare_1715(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "SID"
    cv_title = "Standard Instrument Departure"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1715.cv_arg") -> "NonSpare_1715":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1772(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "STAR"
    cv_title = "Standard Instrument Arrival"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1772.cv_arg") -> "NonSpare_1772":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class Variation_1492(Compound):
    cv_arg = TypedDict('cv_arg', {
        "IFI": NonSpare_1117.cv_arg,
        "RVP": NonSpare_1636.cv_arg,
        "RDS": NonSpare_1564.cv_arg,
        "TOD": NonSpare_1882.cv_arg,
        "AST": NonSpare_639.cv_arg,
        "STS": NonSpare_1798.cv_arg,
        "SID": NonSpare_1715.cv_arg,
        "STAR": NonSpare_1772.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1117, NonSpare_1636, NonSpare_1564, NonSpare_1882, NonSpare_639, NonSpare_1798, NonSpare_1715, NonSpare_1772]
    cv_items_dict = {"IFI": NonSpare_1117, "RVP": NonSpare_1636, "RDS": NonSpare_1564, "TOD": NonSpare_1882, "AST": NonSpare_639, "STS": NonSpare_1798, "SID": NonSpare_1715, "STAR": NonSpare_1772}

    @overload
    @classmethod
    def spec(cls, key : Literal["IFI"]) -> NonSpare_1117:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVP"]) -> NonSpare_1636:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1882:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_639:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1798:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> NonSpare_1715:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAR"]) -> NonSpare_1772:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IFI"], Literal["RVP"], Literal["RDS"], Literal["TOD"], Literal["AST"], Literal["STS"], Literal["SID"], Literal["STAR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IFI"]) -> Optional[NonSpare_1117]:
        ...
    @overload
    def get_item(self, key : Literal["RVP"]) -> Optional[NonSpare_1636]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1564]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1882]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_639]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1798]:
        ...
    @overload
    def get_item(self, key : Literal["SID"]) -> Optional[NonSpare_1715]:
        ...
    @overload
    def get_item(self, key : Literal["STAR"]) -> Optional[NonSpare_1772]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["IFI"], val : NonSpare_1117.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["RVP"], val : NonSpare_1636.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1564.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1882.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_639.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1798.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["SID"], val : NonSpare_1715.cv_arg) -> "Variation_1492":
        ...
    @overload
    def set_item(self, key : Literal["STAR"], val : NonSpare_1772.cv_arg) -> "Variation_1492":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["IFI"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["RVP"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["SID"]) -> "Variation_1492":
        ...
    @overload
    def del_item(self, key : Literal["STAR"]) -> "Variation_1492":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1492.cv_arg") -> 'Variation_1492':
        return cls._create(arg) # type: ignore

class RuleVariation_1413(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1492.cv_arg
    cv_variation: TypeAlias = Variation_1492

    @classmethod
    def create(cls, arg : "RuleVariation_1413.cv_arg") -> "RuleVariation_1413":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1492:
        return self.arg # type: ignore

class NonSpare_519(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1413.cv_arg
    cv_name = "500"
    cv_title = "Supplementary Flight Data"
    cv_rule: TypeAlias = RuleVariation_1413

    @classmethod
    def create(cls, arg : "NonSpare_519.cv_arg") -> "NonSpare_519":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1413:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1492:
        return self.rule.variation

class UapItem_518(UapItem):
    cv_non_spare: TypeAlias = NonSpare_519

class Record_50(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_50.cv_arg,
        "015": NonSpare_70.cv_arg,
        "018": NonSpare_74.cv_arg,
        "035": NonSpare_131.cv_arg,
        "020": NonSpare_92.cv_arg,
        "040": NonSpare_150.cv_arg,
        "050": NonSpare_169.cv_arg,
        "060": NonSpare_201.cv_arg,
        "400": NonSpare_496.cv_arg,
        "410": NonSpare_502.cv_arg,
        "420": NonSpare_504.cv_arg,
        "440": NonSpare_509.cv_arg,
        "450": NonSpare_510.cv_arg,
        "480": NonSpare_513.cv_arg,
        "490": NonSpare_514.cv_arg,
        "430": NonSpare_507.cv_arg,
        "435": NonSpare_508.cv_arg,
        "460": NonSpare_511.cv_arg,
        "500": NonSpare_519.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 3
    cv_items_list = [UapItem_50, UapItem_70, UapItem_74, UapItem_131, UapItem_92, UapItem_150, UapItem_169, UapItem_201, UapItem_495, UapItem_501, UapItem_503, UapItem_508, UapItem_509, UapItem_512, UapItem_513, UapItem_506, UapItem_507, UapItem_510, UapItem_518, UapItem_549, UapItem_547]
    cv_items_dict = {"010": NonSpare_50, "015": NonSpare_70, "018": NonSpare_74, "035": NonSpare_131, "020": NonSpare_92, "040": NonSpare_150, "050": NonSpare_169, "060": NonSpare_201, "400": NonSpare_496, "410": NonSpare_502, "420": NonSpare_504, "440": NonSpare_509, "450": NonSpare_510, "480": NonSpare_513, "490": NonSpare_514, "430": NonSpare_507, "435": NonSpare_508, "460": NonSpare_511, "500": NonSpare_519, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_50:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_70:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["018"]) -> NonSpare_74:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["035"]) -> NonSpare_131:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_92:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_150:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_169:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_201:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["400"]) -> NonSpare_496:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["410"]) -> NonSpare_502:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["420"]) -> NonSpare_504:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["440"]) -> NonSpare_509:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["450"]) -> NonSpare_510:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["480"]) -> NonSpare_513:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["490"]) -> NonSpare_514:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["430"]) -> NonSpare_507:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["435"]) -> NonSpare_508:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["460"]) -> NonSpare_511:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_519:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["018"], Literal["035"], Literal["020"], Literal["040"], Literal["050"], Literal["060"], Literal["400"], Literal["410"], Literal["420"], Literal["440"], Literal["450"], Literal["480"], Literal["490"], Literal["430"], Literal["435"], Literal["460"], Literal["500"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_50]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_70]:
        ...
    @overload
    def get_item(self, key : Literal["018"]) -> Optional[NonSpare_74]:
        ...
    @overload
    def get_item(self, key : Literal["035"]) -> Optional[NonSpare_131]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_92]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_150]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_169]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_201]:
        ...
    @overload
    def get_item(self, key : Literal["400"]) -> Optional[NonSpare_496]:
        ...
    @overload
    def get_item(self, key : Literal["410"]) -> Optional[NonSpare_502]:
        ...
    @overload
    def get_item(self, key : Literal["420"]) -> Optional[NonSpare_504]:
        ...
    @overload
    def get_item(self, key : Literal["440"]) -> Optional[NonSpare_509]:
        ...
    @overload
    def get_item(self, key : Literal["450"]) -> Optional[NonSpare_510]:
        ...
    @overload
    def get_item(self, key : Literal["480"]) -> Optional[NonSpare_513]:
        ...
    @overload
    def get_item(self, key : Literal["490"]) -> Optional[NonSpare_514]:
        ...
    @overload
    def get_item(self, key : Literal["430"]) -> Optional[NonSpare_507]:
        ...
    @overload
    def get_item(self, key : Literal["435"]) -> Optional[NonSpare_508]:
        ...
    @overload
    def get_item(self, key : Literal["460"]) -> Optional[NonSpare_511]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_519]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_50.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_70.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["018"], val : NonSpare_74.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["035"], val : NonSpare_131.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_92.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_150.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_169.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_201.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["400"], val : NonSpare_496.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["410"], val : NonSpare_502.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["420"], val : NonSpare_504.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["440"], val : NonSpare_509.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["450"], val : NonSpare_510.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["480"], val : NonSpare_513.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["490"], val : NonSpare_514.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["430"], val : NonSpare_507.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["435"], val : NonSpare_508.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["460"], val : NonSpare_511.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_519.cv_arg) -> 'Record_50':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_50':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["018"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["035"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["400"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["410"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["420"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["440"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["450"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["480"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["490"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["430"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["435"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["460"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_50':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_50':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_50.cv_arg") -> 'Record_50':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_50", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_46(UapSingle):
    cv_arg: TypeAlias = Record_50
    cv_record: TypeAlias = Record_50

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_50]]:
        return cls._parse(bs)

class Asterix_39(AstCat):
    cv_category = 32
    cv_edition = (1, 1)
    cv_uap: TypeAlias = Uap_46
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_46.cv_arg]) -> "Asterix_39":
        return cls._create(records) # type: ignore

class NonSpare_35(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_35.cv_arg") -> "NonSpare_35":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_35(UapItem):
    cv_non_spare: TypeAlias = NonSpare_35

class Content_587(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "Geographical filtering message", 4: "Jamming strobe message"}

class RuleContent_587(RuleContentContextFree):
    cv_arg: TypeAlias = Content_587.cv_arg
    cv_content: TypeAlias = Content_587

    @property
    def content(self) -> Content_587:
        return self._get_content() # type: ignore

class Variation_187(Element):
    cv_arg: TypeAlias = RuleContent_587.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_587

    @classmethod
    def create(cls, arg: "Variation_187.cv_arg") -> "Variation_187":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_587:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_587:
        return self.rule.content

class RuleVariation_180(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_187.cv_arg
    cv_variation: TypeAlias = Variation_187

    @classmethod
    def create(cls, arg : "RuleVariation_180.cv_arg") -> "RuleVariation_180":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_187:
        return self.arg # type: ignore

class NonSpare_4(NonSpare):
    cv_arg: TypeAlias = RuleVariation_180.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_180

    @classmethod
    def create(cls, arg : "NonSpare_4.cv_arg") -> "NonSpare_4":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_180:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_187:
        return self.rule.variation

class UapItem_4(UapItem):
    cv_non_spare: TypeAlias = NonSpare_4

class NonSpare_108(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_108.cv_arg") -> "NonSpare_108":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_108(UapItem):
    cv_non_spare: TypeAlias = NonSpare_108

class NonSpare_82(NonSpare):
    cv_arg: TypeAlias = RuleVariation_236.cv_arg
    cv_name = "020"
    cv_title = "Sector Number"
    cv_rule: TypeAlias = RuleVariation_236

    @classmethod
    def create(cls, arg : "NonSpare_82.cv_arg") -> "NonSpare_82":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_236:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_243:
        return self.rule.variation

class UapItem_82(UapItem):
    cv_non_spare: TypeAlias = NonSpare_82

class NonSpare_153(NonSpare):
    cv_arg: TypeAlias = RuleVariation_327.cv_arg
    cv_name = "041"
    cv_title = "Antenna Rotation Speed"
    cv_rule: TypeAlias = RuleVariation_327

    @classmethod
    def create(cls, arg : "NonSpare_153.cv_arg") -> "NonSpare_153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

class UapItem_153(UapItem):
    cv_non_spare: TypeAlias = NonSpare_153

class Content_462(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "System is released for operational use", 1: "Operational use of System is inhibited, i.e. the data shall be discarded by an operational SDPS"}

class RuleContent_462(RuleContentContextFree):
    cv_arg: TypeAlias = Content_462.cv_arg
    cv_content: TypeAlias = Content_462

    @property
    def content(self) -> Content_462:
        return self._get_content() # type: ignore

class Variation_78(Element):
    cv_arg: TypeAlias = RuleContent_462.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_462

    @classmethod
    def create(cls, arg: "Variation_78.cv_arg") -> "Variation_78":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_462:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_462:
        return self.rule.content

class RuleVariation_78(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_78.cv_arg
    cv_variation: TypeAlias = Variation_78

    @classmethod
    def create(cls, arg : "RuleVariation_78.cv_arg") -> "RuleVariation_78":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_78:
        return self.arg # type: ignore

class NonSpare_1368(NonSpare):
    cv_arg: TypeAlias = RuleVariation_78.cv_arg
    cv_name = "NOGO"
    cv_title = "Operational Release Status of the System"
    cv_rule: TypeAlias = RuleVariation_78

    @classmethod
    def create(cls, arg : "NonSpare_1368.cv_arg") -> "NonSpare_1368":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_78:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_78:
        return self.rule.variation

class Item_628(Item):
    cv_arg: TypeAlias = NonSpare_1368.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1368

    @classmethod
    def create(cls, arg : "Item_628.cv_arg") -> "Item_628":
        return cls._create(arg) # type: ignore

class Content_434(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "RDPC-1 selected", 1: "RDPC-2 selected"}

class RuleContent_434(RuleContentContextFree):
    cv_arg: TypeAlias = Content_434.cv_arg
    cv_content: TypeAlias = Content_434

    @property
    def content(self) -> Content_434:
        return self._get_content() # type: ignore

class Variation_450(Element):
    cv_arg: TypeAlias = RuleContent_434.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_434

    @classmethod
    def create(cls, arg: "Variation_450.cv_arg") -> "Variation_450":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_434:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_434:
        return self.rule.content

class RuleVariation_439(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_450.cv_arg
    cv_variation: TypeAlias = Variation_450

    @classmethod
    def create(cls, arg : "RuleVariation_439.cv_arg") -> "RuleVariation_439":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_450:
        return self.arg # type: ignore

class NonSpare_1561(NonSpare):
    cv_arg: TypeAlias = RuleVariation_439.cv_arg
    cv_name = "RDPC"
    cv_title = "Radar Data Processor Chain Selection Status"
    cv_rule: TypeAlias = RuleVariation_439

    @classmethod
    def create(cls, arg : "NonSpare_1561.cv_arg") -> "NonSpare_1561":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_439:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_450:
        return self.rule.variation

class Item_789(Item):
    cv_arg: TypeAlias = NonSpare_1561.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1561

    @classmethod
    def create(cls, arg : "Item_789.cv_arg") -> "Item_789":
        return cls._create(arg) # type: ignore

class Content_171(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default situation", 1: "Reset of RDPC"}

class RuleContent_171(RuleContentContextFree):
    cv_arg: TypeAlias = Content_171.cv_arg
    cv_content: TypeAlias = Content_171

    @property
    def content(self) -> Content_171:
        return self._get_content() # type: ignore

class Variation_527(Element):
    cv_arg: TypeAlias = RuleContent_171.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_171

    @classmethod
    def create(cls, arg: "Variation_527.cv_arg") -> "Variation_527":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_171:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_171:
        return self.rule.content

class RuleVariation_516(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_527.cv_arg
    cv_variation: TypeAlias = Variation_527

    @classmethod
    def create(cls, arg : "RuleVariation_516.cv_arg") -> "RuleVariation_516":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_527:
        return self.arg # type: ignore

class NonSpare_1562(NonSpare):
    cv_arg: TypeAlias = RuleVariation_516.cv_arg
    cv_name = "RDPR"
    cv_title = "Event to Signal a Reset/restart of the Selected Radar Data Processor Chain, I.e. Expect a New Assignment of Track Numbers"
    cv_rule: TypeAlias = RuleVariation_516

    @classmethod
    def create(cls, arg : "NonSpare_1562.cv_arg") -> "NonSpare_1562":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_516:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_527:
        return self.rule.variation

class Item_790(Item):
    cv_arg: TypeAlias = NonSpare_1562.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1562

    @classmethod
    def create(cls, arg : "Item_790.cv_arg") -> "Item_790":
        return cls._create(arg) # type: ignore

class Content_198(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default, no overload", 1: "Overload in RDP"}

class RuleContent_198(RuleContentContextFree):
    cv_arg: TypeAlias = Content_198.cv_arg
    cv_content: TypeAlias = Content_198

    @property
    def content(self) -> Content_198:
        return self._get_content() # type: ignore

class Variation_638(Element):
    cv_arg: TypeAlias = RuleContent_198.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_198

    @classmethod
    def create(cls, arg: "Variation_638.cv_arg") -> "Variation_638":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_198:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_198:
        return self.rule.content

class RuleVariation_627(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_638.cv_arg
    cv_variation: TypeAlias = Variation_638

    @classmethod
    def create(cls, arg : "RuleVariation_627.cv_arg") -> "RuleVariation_627":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_638:
        return self.arg # type: ignore

class NonSpare_1412(NonSpare):
    cv_arg: TypeAlias = RuleVariation_627.cv_arg
    cv_name = "OVLRDP"
    cv_title = "Radar Data Processor Overload Indicator"
    cv_rule: TypeAlias = RuleVariation_627

    @classmethod
    def create(cls, arg : "NonSpare_1412.cv_arg") -> "NonSpare_1412":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_627:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_638:
        return self.rule.variation

class Item_670(Item):
    cv_arg: TypeAlias = NonSpare_1412.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1412

    @classmethod
    def create(cls, arg : "Item_670.cv_arg") -> "Item_670":
        return cls._create(arg) # type: ignore

class Variation_720(Element):
    cv_arg: TypeAlias = RuleContent_199.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_199

    @classmethod
    def create(cls, arg: "Variation_720.cv_arg") -> "Variation_720":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_199:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_199:
        return self.rule.content

class RuleVariation_709(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_720.cv_arg
    cv_variation: TypeAlias = Variation_720

    @classmethod
    def create(cls, arg : "RuleVariation_709.cv_arg") -> "RuleVariation_709":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_720:
        return self.arg # type: ignore

class NonSpare_1415(NonSpare):
    cv_arg: TypeAlias = RuleVariation_709.cv_arg
    cv_name = "OVLXMT"
    cv_title = "Transmission Subsystem Overload Status"
    cv_rule: TypeAlias = RuleVariation_709

    @classmethod
    def create(cls, arg : "NonSpare_1415.cv_arg") -> "NonSpare_1415":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_709:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_720:
        return self.rule.variation

class Item_673(Item):
    cv_arg: TypeAlias = NonSpare_1415.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1415

    @classmethod
    def create(cls, arg : "Item_673.cv_arg") -> "Item_673":
        return cls._create(arg) # type: ignore

class Content_295(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Monitoring system connected", 1: "Monitoring system disconnected"}

class RuleContent_295(RuleContentContextFree):
    cv_arg: TypeAlias = Content_295.cv_arg
    cv_content: TypeAlias = Content_295

    @property
    def content(self) -> Content_295:
        return self._get_content() # type: ignore

class Variation_862(Element):
    cv_arg: TypeAlias = RuleContent_295.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_295

    @classmethod
    def create(cls, arg: "Variation_862.cv_arg") -> "Variation_862":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_295:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_295:
        return self.rule.content

class RuleVariation_832(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_862.cv_arg
    cv_variation: TypeAlias = Variation_862

    @classmethod
    def create(cls, arg : "RuleVariation_832.cv_arg") -> "RuleVariation_832":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_862:
        return self.arg # type: ignore

class NonSpare_1327(NonSpare):
    cv_arg: TypeAlias = RuleVariation_832.cv_arg
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule: TypeAlias = RuleVariation_832

    @classmethod
    def create(cls, arg : "NonSpare_1327.cv_arg") -> "NonSpare_1327":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_832:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_862:
        return self.rule.variation

class Item_591(Item):
    cv_arg: TypeAlias = NonSpare_1327.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1327

    @classmethod
    def create(cls, arg : "Item_591.cv_arg") -> "Item_591":
        return cls._create(arg) # type: ignore

class Variation_958(Element):
    cv_arg: TypeAlias = RuleContent_559.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_559

    @classmethod
    def create(cls, arg: "Variation_958.cv_arg") -> "Variation_958":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_559:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_559:
        return self.rule.content

class RuleVariation_928(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_958.cv_arg
    cv_variation: TypeAlias = Variation_958

    @classmethod
    def create(cls, arg : "RuleVariation_928.cv_arg") -> "RuleVariation_928":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_958:
        return self.arg # type: ignore

class NonSpare_1943(NonSpare):
    cv_arg: TypeAlias = RuleVariation_928.cv_arg
    cv_name = "TSV"
    cv_title = "Time Source Validity"
    cv_rule: TypeAlias = RuleVariation_928

    @classmethod
    def create(cls, arg : "NonSpare_1943.cv_arg") -> "NonSpare_1943":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_928:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_958:
        return self.rule.variation

class Item_1060(Item):
    cv_arg: TypeAlias = NonSpare_1943.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1943

    @classmethod
    def create(cls, arg : "Item_1060.cv_arg") -> "Item_1060":
        return cls._create(arg) # type: ignore

class Variation_1152(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_78.cv_arg, Tuple[Literal["NOGO"], RuleVariation_78.cv_arg]], Union[RuleVariation_439.cv_arg, Tuple[Literal["RDPC"], RuleVariation_439.cv_arg]], Union[RuleVariation_516.cv_arg, Tuple[Literal["RDPR"], RuleVariation_516.cv_arg]], Union[RuleVariation_627.cv_arg, Tuple[Literal["OVLRDP"], RuleVariation_627.cv_arg]], Union[RuleVariation_709.cv_arg, Tuple[Literal["OVLXMT"], RuleVariation_709.cv_arg]], Union[RuleVariation_832.cv_arg, Tuple[Literal["MSC"], RuleVariation_832.cv_arg]], Union[RuleVariation_928.cv_arg, Tuple[Literal["TSV"], RuleVariation_928.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1152.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_628, 1), (Item_789, 1), (Item_790, 1), (Item_670, 1), (Item_673, 1), (Item_591, 1), (Item_1060, 1), (Item_29, 1)]
    cv_items_dict = {"NOGO": RuleVariation_78, "RDPC": RuleVariation_439, "RDPR": RuleVariation_516, "OVLRDP": RuleVariation_627, "OVLXMT": RuleVariation_709, "MSC": RuleVariation_832, "TSV": RuleVariation_928}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_78:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDPC"]) -> RuleVariation_439:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDPR"]) -> RuleVariation_516:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLRDP"]) -> RuleVariation_627:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLXMT"]) -> RuleVariation_709:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_832:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_928:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["RDPC"], Literal["RDPR"], Literal["OVLRDP"], Literal["OVLXMT"], Literal["MSC"], Literal["TSV"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_78:
        ...
    @overload
    def get_item(self, key : Literal["RDPC"]) -> RuleVariation_439:
        ...
    @overload
    def get_item(self, key : Literal["RDPR"]) -> RuleVariation_516:
        ...
    @overload
    def get_item(self, key : Literal["OVLRDP"]) -> RuleVariation_627:
        ...
    @overload
    def get_item(self, key : Literal["OVLXMT"]) -> RuleVariation_709:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_832:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_928:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1152.cv_arg") -> 'Variation_1152':
        return cls._create(arg) # type: ignore

class RuleVariation_1105(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1152.cv_arg
    cv_variation: TypeAlias = Variation_1152

    @classmethod
    def create(cls, arg : "RuleVariation_1105.cv_arg") -> "RuleVariation_1105":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1152:
        return self.arg # type: ignore

class NonSpare_782(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1105.cv_arg
    cv_name = "COM"
    cv_title = "Common Part"
    cv_rule: TypeAlias = RuleVariation_1105

    @classmethod
    def create(cls, arg : "NonSpare_782.cv_arg") -> "NonSpare_782":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1105:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1152:
        return self.rule.variation

class Content_33(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Antenna 1", 1: "Antenna 2"}

class RuleContent_33(RuleContentContextFree):
    cv_arg: TypeAlias = Content_33.cv_arg
    cv_content: TypeAlias = Content_33

    @property
    def content(self) -> Content_33:
        return self._get_content() # type: ignore

class Variation_12(Element):
    cv_arg: TypeAlias = RuleContent_33.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_33

    @classmethod
    def create(cls, arg: "Variation_12.cv_arg") -> "Variation_12":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_33:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_33:
        return self.rule.content

class RuleVariation_12(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_12.cv_arg
    cv_variation: TypeAlias = Variation_12

    @classmethod
    def create(cls, arg : "RuleVariation_12.cv_arg") -> "RuleVariation_12":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_12:
        return self.arg # type: ignore

class NonSpare_612(NonSpare):
    cv_arg: TypeAlias = RuleVariation_12.cv_arg
    cv_name = "ANT"
    cv_title = "Selected Antenna"
    cv_rule: TypeAlias = RuleVariation_12

    @classmethod
    def create(cls, arg : "NonSpare_612.cv_arg") -> "NonSpare_612":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_12:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_12:
        return self.rule.variation

class Item_75(Item):
    cv_arg: TypeAlias = NonSpare_612.cv_arg
    cv_non_spare: TypeAlias = NonSpare_612

    @classmethod
    def create(cls, arg : "Item_75.cv_arg") -> "Item_75":
        return cls._create(arg) # type: ignore

class Content_334(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No channel selected", 1: "Channel A only selected", 2: "Channel B only selected", 3: "Diversity mode ; Channel A and B selected"}

class RuleContent_334(RuleContentContextFree):
    cv_arg: TypeAlias = Content_334.cv_arg
    cv_content: TypeAlias = Content_334

    @property
    def content(self) -> Content_334:
        return self._get_content() # type: ignore

class Variation_472(Element):
    cv_arg: TypeAlias = RuleContent_334.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_334

    @classmethod
    def create(cls, arg: "Variation_472.cv_arg") -> "Variation_472":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_334:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_334:
        return self.rule.content

class RuleVariation_461(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_472.cv_arg
    cv_variation: TypeAlias = Variation_472

    @classmethod
    def create(cls, arg : "RuleVariation_461.cv_arg") -> "RuleVariation_461":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_472:
        return self.arg # type: ignore

class NonSpare_730(NonSpare):
    cv_arg: TypeAlias = RuleVariation_461.cv_arg
    cv_name = "CHAB"
    cv_title = "Channel A/B Selection Status"
    cv_rule: TypeAlias = RuleVariation_461

    @classmethod
    def create(cls, arg : "NonSpare_730.cv_arg") -> "NonSpare_730":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_461:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_472:
        return self.rule.variation

class Item_152(Item):
    cv_arg: TypeAlias = NonSpare_730.cv_arg
    cv_non_spare: TypeAlias = NonSpare_730

    @classmethod
    def create(cls, arg : "Item_152.cv_arg") -> "Item_152":
        return cls._create(arg) # type: ignore

class Variation_654(Element):
    cv_arg: TypeAlias = RuleContent_369.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_369

    @classmethod
    def create(cls, arg: "Variation_654.cv_arg") -> "Variation_654":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_369:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_369:
        return self.rule.content

class RuleVariation_643(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_654.cv_arg
    cv_variation: TypeAlias = Variation_654

    @classmethod
    def create(cls, arg : "RuleVariation_643.cv_arg") -> "RuleVariation_643":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_654:
        return self.arg # type: ignore

class NonSpare_1409(NonSpare):
    cv_arg: TypeAlias = RuleVariation_643.cv_arg
    cv_name = "OVL"
    cv_title = "Overload Condition"
    cv_rule: TypeAlias = RuleVariation_643

    @classmethod
    def create(cls, arg : "NonSpare_1409.cv_arg") -> "NonSpare_1409":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_643:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_654:
        return self.rule.variation

class Item_667(Item):
    cv_arg: TypeAlias = NonSpare_1409.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1409

    @classmethod
    def create(cls, arg : "Item_667.cv_arg") -> "Item_667":
        return cls._create(arg) # type: ignore

class Variation_735(Element):
    cv_arg: TypeAlias = RuleContent_295.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_295

    @classmethod
    def create(cls, arg: "Variation_735.cv_arg") -> "Variation_735":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_295:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_295:
        return self.rule.content

class RuleVariation_724(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_735.cv_arg
    cv_variation: TypeAlias = Variation_735

    @classmethod
    def create(cls, arg : "RuleVariation_724.cv_arg") -> "RuleVariation_724":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_735:
        return self.arg # type: ignore

class NonSpare_1326(NonSpare):
    cv_arg: TypeAlias = RuleVariation_724.cv_arg
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule: TypeAlias = RuleVariation_724

    @classmethod
    def create(cls, arg : "NonSpare_1326.cv_arg") -> "NonSpare_1326":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_724:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_735:
        return self.rule.variation

class Item_590(Item):
    cv_arg: TypeAlias = NonSpare_1326.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1326

    @classmethod
    def create(cls, arg : "Item_590.cv_arg") -> "Item_590":
        return cls._create(arg) # type: ignore

class Variation_1049(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_12.cv_arg, Tuple[Literal["ANT"], RuleVariation_12.cv_arg]], Union[RuleVariation_461.cv_arg, Tuple[Literal["CHAB"], RuleVariation_461.cv_arg]], Union[RuleVariation_643.cv_arg, Tuple[Literal["OVL"], RuleVariation_643.cv_arg]], Union[RuleVariation_724.cv_arg, Tuple[Literal["MSC"], RuleVariation_724.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1049.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_75, 1), (Item_152, 2), (Item_667, 1), (Item_590, 1), (Item_25, 3)]
    cv_items_dict = {"ANT": RuleVariation_12, "CHAB": RuleVariation_461, "OVL": RuleVariation_643, "MSC": RuleVariation_724}

    @overload
    @classmethod
    def spec(cls, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHAB"]) -> RuleVariation_461:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_643:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_724:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ANT"], Literal["CHAB"], Literal["OVL"], Literal["MSC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    def get_item(self, key : Literal["CHAB"]) -> RuleVariation_461:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_643:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_724:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1049.cv_arg") -> 'Variation_1049':
        return cls._create(arg) # type: ignore

class RuleVariation_1016(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1049.cv_arg
    cv_variation: TypeAlias = Variation_1049

    @classmethod
    def create(cls, arg : "RuleVariation_1016.cv_arg") -> "RuleVariation_1016":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1049:
        return self.arg # type: ignore

class NonSpare_1479(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1016.cv_arg
    cv_name = "PSR"
    cv_title = "Specific Status Information for a PSR Sensor"
    cv_rule: TypeAlias = RuleVariation_1016

    @classmethod
    def create(cls, arg : "NonSpare_1479.cv_arg") -> "NonSpare_1479":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1016:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1049:
        return self.rule.variation

class Content_336(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No channel selected", 1: "Channel A only selected", 2: "Channel B only selected", 3: "Invalid combination"}

class RuleContent_336(RuleContentContextFree):
    cv_arg: TypeAlias = Content_336.cv_arg
    cv_content: TypeAlias = Content_336

    @property
    def content(self) -> Content_336:
        return self._get_content() # type: ignore

class Variation_474(Element):
    cv_arg: TypeAlias = RuleContent_336.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_336

    @classmethod
    def create(cls, arg: "Variation_474.cv_arg") -> "Variation_474":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_336:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_336:
        return self.rule.content

class RuleVariation_463(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_474.cv_arg
    cv_variation: TypeAlias = Variation_474

    @classmethod
    def create(cls, arg : "RuleVariation_463.cv_arg") -> "RuleVariation_463":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_474:
        return self.arg # type: ignore

class NonSpare_732(NonSpare):
    cv_arg: TypeAlias = RuleVariation_463.cv_arg
    cv_name = "CHAB"
    cv_title = "Channel A/B Selection Status"
    cv_rule: TypeAlias = RuleVariation_463

    @classmethod
    def create(cls, arg : "NonSpare_732.cv_arg") -> "NonSpare_732":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_463:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_474:
        return self.rule.variation

class Item_154(Item):
    cv_arg: TypeAlias = NonSpare_732.cv_arg
    cv_non_spare: TypeAlias = NonSpare_732

    @classmethod
    def create(cls, arg : "Item_154.cv_arg") -> "Item_154":
        return cls._create(arg) # type: ignore

class NonSpare_1328(NonSpare):
    cv_arg: TypeAlias = RuleVariation_724.cv_arg
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status:"
    cv_rule: TypeAlias = RuleVariation_724

    @classmethod
    def create(cls, arg : "NonSpare_1328.cv_arg") -> "NonSpare_1328":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_724:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_735:
        return self.rule.variation

class Item_592(Item):
    cv_arg: TypeAlias = NonSpare_1328.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1328

    @classmethod
    def create(cls, arg : "Item_592.cv_arg") -> "Item_592":
        return cls._create(arg) # type: ignore

class Variation_1051(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_12.cv_arg, Tuple[Literal["ANT"], RuleVariation_12.cv_arg]], Union[RuleVariation_463.cv_arg, Tuple[Literal["CHAB"], RuleVariation_463.cv_arg]], Union[RuleVariation_643.cv_arg, Tuple[Literal["OVL"], RuleVariation_643.cv_arg]], Union[RuleVariation_724.cv_arg, Tuple[Literal["MSC"], RuleVariation_724.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1051.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_75, 1), (Item_154, 2), (Item_667, 1), (Item_592, 1), (Item_25, 3)]
    cv_items_dict = {"ANT": RuleVariation_12, "CHAB": RuleVariation_463, "OVL": RuleVariation_643, "MSC": RuleVariation_724}

    @overload
    @classmethod
    def spec(cls, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHAB"]) -> RuleVariation_463:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_643:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_724:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ANT"], Literal["CHAB"], Literal["OVL"], Literal["MSC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    def get_item(self, key : Literal["CHAB"]) -> RuleVariation_463:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_643:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_724:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1051.cv_arg") -> 'Variation_1051':
        return cls._create(arg) # type: ignore

class RuleVariation_1018(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1051.cv_arg
    cv_variation: TypeAlias = Variation_1051

    @classmethod
    def create(cls, arg : "RuleVariation_1018.cv_arg") -> "RuleVariation_1018":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1051:
        return self.arg # type: ignore

class NonSpare_1765(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1018.cv_arg
    cv_name = "SSR"
    cv_title = "Specific Status Information for a SSR Sensor"
    cv_rule: TypeAlias = RuleVariation_1018

    @classmethod
    def create(cls, arg : "NonSpare_1765.cv_arg") -> "NonSpare_1765":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1018:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1051:
        return self.rule.variation

class Content_335(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No channel selected", 1: "Channel A only selected", 2: "Channel B only selected", 3: "Illegal combination"}

class RuleContent_335(RuleContentContextFree):
    cv_arg: TypeAlias = Content_335.cv_arg
    cv_content: TypeAlias = Content_335

    @property
    def content(self) -> Content_335:
        return self._get_content() # type: ignore

class Variation_473(Element):
    cv_arg: TypeAlias = RuleContent_335.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_335

    @classmethod
    def create(cls, arg: "Variation_473.cv_arg") -> "Variation_473":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_335:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_335:
        return self.rule.content

class RuleVariation_462(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_473.cv_arg
    cv_variation: TypeAlias = Variation_473

    @classmethod
    def create(cls, arg : "RuleVariation_462.cv_arg") -> "RuleVariation_462":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_473:
        return self.arg # type: ignore

class NonSpare_731(NonSpare):
    cv_arg: TypeAlias = RuleVariation_462.cv_arg
    cv_name = "CHAB"
    cv_title = "Channel A/B Selection Status"
    cv_rule: TypeAlias = RuleVariation_462

    @classmethod
    def create(cls, arg : "NonSpare_731.cv_arg") -> "NonSpare_731":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_462:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_473:
        return self.rule.variation

class Item_153(Item):
    cv_arg: TypeAlias = NonSpare_731.cv_arg
    cv_non_spare: TypeAlias = NonSpare_731

    @classmethod
    def create(cls, arg : "Item_153.cv_arg") -> "Item_153":
        return cls._create(arg) # type: ignore

class NonSpare_1414(NonSpare):
    cv_arg: TypeAlias = RuleVariation_643.cv_arg
    cv_name = "OVLSUR"
    cv_title = "Overload Condition"
    cv_rule: TypeAlias = RuleVariation_643

    @classmethod
    def create(cls, arg : "NonSpare_1414.cv_arg") -> "NonSpare_1414":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_643:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_654:
        return self.rule.variation

class Item_672(Item):
    cv_arg: TypeAlias = NonSpare_1414.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1414

    @classmethod
    def create(cls, arg : "Item_672.cv_arg") -> "Item_672":
        return cls._create(arg) # type: ignore

class Content_54(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Channel A in use", 1: "Channel B in use"}

class RuleContent_54(RuleContentContextFree):
    cv_arg: TypeAlias = Content_54.cv_arg
    cv_content: TypeAlias = Content_54

    @property
    def content(self) -> Content_54:
        return self._get_content() # type: ignore

class Variation_826(Element):
    cv_arg: TypeAlias = RuleContent_54.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_54

    @classmethod
    def create(cls, arg: "Variation_826.cv_arg") -> "Variation_826":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_54:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_54:
        return self.rule.content

class RuleVariation_796(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_826.cv_arg
    cv_variation: TypeAlias = Variation_826

    @classmethod
    def create(cls, arg : "RuleVariation_796.cv_arg") -> "RuleVariation_796":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_826:
        return self.arg # type: ignore

class NonSpare_1669(NonSpare):
    cv_arg: TypeAlias = RuleVariation_796.cv_arg
    cv_name = "SCF"
    cv_title = "Channel A/B Selection Status for Surveillance Co-ordination Function"
    cv_rule: TypeAlias = RuleVariation_796

    @classmethod
    def create(cls, arg : "NonSpare_1669.cv_arg") -> "NonSpare_1669":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_796:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_826:
        return self.rule.variation

class Item_864(Item):
    cv_arg: TypeAlias = NonSpare_1669.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1669

    @classmethod
    def create(cls, arg : "Item_864.cv_arg") -> "Item_864":
        return cls._create(arg) # type: ignore

class Variation_904(Element):
    cv_arg: TypeAlias = RuleContent_54.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_54

    @classmethod
    def create(cls, arg: "Variation_904.cv_arg") -> "Variation_904":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_54:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_54:
        return self.rule.content

class RuleVariation_874(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_904.cv_arg
    cv_variation: TypeAlias = Variation_904

    @classmethod
    def create(cls, arg : "RuleVariation_874.cv_arg") -> "RuleVariation_874":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_904:
        return self.arg # type: ignore

class NonSpare_887(NonSpare):
    cv_arg: TypeAlias = RuleVariation_874.cv_arg
    cv_name = "DLF"
    cv_title = "Channel A/B Selection Status for Data Link Function"
    cv_rule: TypeAlias = RuleVariation_874

    @classmethod
    def create(cls, arg : "NonSpare_887.cv_arg") -> "NonSpare_887":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_874:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_904:
        return self.rule.variation

class Item_264(Item):
    cv_arg: TypeAlias = NonSpare_887.cv_arg
    cv_non_spare: TypeAlias = NonSpare_887

    @classmethod
    def create(cls, arg : "Item_264.cv_arg") -> "Item_264":
        return cls._create(arg) # type: ignore

class Variation_983(Element):
    cv_arg: TypeAlias = RuleContent_369.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_369

    @classmethod
    def create(cls, arg: "Variation_983.cv_arg") -> "Variation_983":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_369:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_369:
        return self.rule.content

class RuleVariation_953(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_983.cv_arg
    cv_variation: TypeAlias = Variation_983

    @classmethod
    def create(cls, arg : "RuleVariation_953.cv_arg") -> "RuleVariation_953":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_983:
        return self.arg # type: ignore

class NonSpare_1413(NonSpare):
    cv_arg: TypeAlias = RuleVariation_953.cv_arg
    cv_name = "OVLSCF"
    cv_title = "Overload in Surveillance Co-ordination Function"
    cv_rule: TypeAlias = RuleVariation_953

    @classmethod
    def create(cls, arg : "NonSpare_1413.cv_arg") -> "NonSpare_1413":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_953:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_983:
        return self.rule.variation

class Item_671(Item):
    cv_arg: TypeAlias = NonSpare_1413.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1413

    @classmethod
    def create(cls, arg : "Item_671.cv_arg") -> "Item_671":
        return cls._create(arg) # type: ignore

class Variation_63(Element):
    cv_arg: TypeAlias = RuleContent_369.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_369

    @classmethod
    def create(cls, arg: "Variation_63.cv_arg") -> "Variation_63":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_369:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_369:
        return self.rule.content

class RuleVariation_63(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_63.cv_arg
    cv_variation: TypeAlias = Variation_63

    @classmethod
    def create(cls, arg : "RuleVariation_63.cv_arg") -> "RuleVariation_63":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_63:
        return self.arg # type: ignore

class NonSpare_1411(NonSpare):
    cv_arg: TypeAlias = RuleVariation_63.cv_arg
    cv_name = "OVLDLF"
    cv_title = "Overload in Data Link Function"
    cv_rule: TypeAlias = RuleVariation_63

    @classmethod
    def create(cls, arg : "NonSpare_1411.cv_arg") -> "NonSpare_1411":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_63:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_63:
        return self.rule.variation

class Item_669(Item):
    cv_arg: TypeAlias = NonSpare_1411.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1411

    @classmethod
    def create(cls, arg : "Item_669.cv_arg") -> "Item_669":
        return cls._create(arg) # type: ignore

class Variation_1050(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_12.cv_arg, Tuple[Literal["ANT"], RuleVariation_12.cv_arg]], Union[RuleVariation_462.cv_arg, Tuple[Literal["CHAB"], RuleVariation_462.cv_arg]], Union[RuleVariation_643.cv_arg, Tuple[Literal["OVLSUR"], RuleVariation_643.cv_arg]], Union[RuleVariation_724.cv_arg, Tuple[Literal["MSC"], RuleVariation_724.cv_arg]], Union[RuleVariation_796.cv_arg, Tuple[Literal["SCF"], RuleVariation_796.cv_arg]], Union[RuleVariation_874.cv_arg, Tuple[Literal["DLF"], RuleVariation_874.cv_arg]], Union[RuleVariation_953.cv_arg, Tuple[Literal["OVLSCF"], RuleVariation_953.cv_arg]], Union[RuleVariation_63.cv_arg, Tuple[Literal["OVLDLF"], RuleVariation_63.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1050.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_75, 1), (Item_153, 2), (Item_672, 1), (Item_592, 1), (Item_864, 1), (Item_264, 1), (Item_671, 1), (Item_669, 1), (Item_10, 7)]
    cv_items_dict = {"ANT": RuleVariation_12, "CHAB": RuleVariation_462, "OVLSUR": RuleVariation_643, "MSC": RuleVariation_724, "SCF": RuleVariation_796, "DLF": RuleVariation_874, "OVLSCF": RuleVariation_953, "OVLDLF": RuleVariation_63}

    @overload
    @classmethod
    def spec(cls, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHAB"]) -> RuleVariation_462:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLSUR"]) -> RuleVariation_643:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSC"]) -> RuleVariation_724:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SCF"]) -> RuleVariation_796:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DLF"]) -> RuleVariation_874:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLSCF"]) -> RuleVariation_953:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVLDLF"]) -> RuleVariation_63:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ANT"], Literal["CHAB"], Literal["OVLSUR"], Literal["MSC"], Literal["SCF"], Literal["DLF"], Literal["OVLSCF"], Literal["OVLDLF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ANT"]) -> RuleVariation_12:
        ...
    @overload
    def get_item(self, key : Literal["CHAB"]) -> RuleVariation_462:
        ...
    @overload
    def get_item(self, key : Literal["OVLSUR"]) -> RuleVariation_643:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> RuleVariation_724:
        ...
    @overload
    def get_item(self, key : Literal["SCF"]) -> RuleVariation_796:
        ...
    @overload
    def get_item(self, key : Literal["DLF"]) -> RuleVariation_874:
        ...
    @overload
    def get_item(self, key : Literal["OVLSCF"]) -> RuleVariation_953:
        ...
    @overload
    def get_item(self, key : Literal["OVLDLF"]) -> RuleVariation_63:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1050.cv_arg") -> 'Variation_1050':
        return cls._create(arg) # type: ignore

class RuleVariation_1017(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1050.cv_arg
    cv_variation: TypeAlias = Variation_1050

    @classmethod
    def create(cls, arg : "RuleVariation_1017.cv_arg") -> "RuleVariation_1017":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1050:
        return self.arg # type: ignore

class NonSpare_1264(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1017.cv_arg
    cv_name = "MDS"
    cv_title = "Specific Status Information for a Mode S Sensor"
    cv_rule: TypeAlias = RuleVariation_1017

    @classmethod
    def create(cls, arg : "NonSpare_1264.cv_arg") -> "NonSpare_1264":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1017:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1050:
        return self.rule.variation

class Variation_1482(Compound):
    cv_arg = TypedDict('cv_arg', {
        "COM": NonSpare_782.cv_arg,
        "PSR": NonSpare_1479.cv_arg,
        "SSR": NonSpare_1765.cv_arg,
        "MDS": NonSpare_1264.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_782, None, None, NonSpare_1479, NonSpare_1765, NonSpare_1264]
    cv_items_dict = {"COM": NonSpare_782, "PSR": NonSpare_1479, "SSR": NonSpare_1765, "MDS": NonSpare_1264}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_782:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1479:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1765:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1264:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["PSR"], Literal["SSR"], Literal["MDS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_782]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1479]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1765]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1264]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_782.cv_arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1479.cv_arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1765.cv_arg) -> "Variation_1482":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1264.cv_arg) -> "Variation_1482":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1482":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1482":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1482.cv_arg") -> 'Variation_1482':
        return cls._create(arg) # type: ignore

class RuleVariation_1403(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1482.cv_arg
    cv_variation: TypeAlias = Variation_1482

    @classmethod
    def create(cls, arg : "RuleVariation_1403.cv_arg") -> "RuleVariation_1403":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1482:
        return self.arg # type: ignore

class NonSpare_181(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1403.cv_arg
    cv_name = "050"
    cv_title = "System Configuration and Status"
    cv_rule: TypeAlias = RuleVariation_1403

    @classmethod
    def create(cls, arg : "NonSpare_181.cv_arg") -> "NonSpare_181":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1403:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1482:
        return self.rule.variation

class UapItem_181(UapItem):
    cv_non_spare: TypeAlias = NonSpare_181

class Content_370(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No reduction active", 1: "Reduction step 1 active", 2: "Reduction step 2 active", 3: "Reduction step 3 active", 4: "Reduction step 4 active", 5: "Reduction step 5 active", 6: "Reduction step 6 active", 7: "Reduction step 7 active"}

class RuleContent_370(RuleContentContextFree):
    cv_arg: TypeAlias = Content_370.cv_arg
    cv_content: TypeAlias = Content_370

    @property
    def content(self) -> Content_370:
        return self._get_content() # type: ignore

class Variation_486(Element):
    cv_arg: TypeAlias = RuleContent_370.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_370

    @classmethod
    def create(cls, arg: "Variation_486.cv_arg") -> "Variation_486":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_370:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_370:
        return self.rule.content

class RuleVariation_475(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_486.cv_arg
    cv_variation: TypeAlias = Variation_486

    @classmethod
    def create(cls, arg : "RuleVariation_475.cv_arg") -> "RuleVariation_475":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_486:
        return self.arg # type: ignore

class NonSpare_1573(NonSpare):
    cv_arg: TypeAlias = RuleVariation_475.cv_arg
    cv_name = "REDRDP"
    cv_title = "Reduction Steps in Use for An Overload of the RDP"
    cv_rule: TypeAlias = RuleVariation_475

    @classmethod
    def create(cls, arg : "NonSpare_1573.cv_arg") -> "NonSpare_1573":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_475:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_486:
        return self.rule.variation

class Item_798(Item):
    cv_arg: TypeAlias = NonSpare_1573.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1573

    @classmethod
    def create(cls, arg : "Item_798.cv_arg") -> "Item_798":
        return cls._create(arg) # type: ignore

class Variation_787(Element):
    cv_arg: TypeAlias = RuleContent_370.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 3
    cv_rule = RuleContent_370

    @classmethod
    def create(cls, arg: "Variation_787.cv_arg") -> "Variation_787":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_370:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_370:
        return self.rule.content

class RuleVariation_766(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_787.cv_arg
    cv_variation: TypeAlias = Variation_787

    @classmethod
    def create(cls, arg : "RuleVariation_766.cv_arg") -> "RuleVariation_766":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_787:
        return self.arg # type: ignore

class NonSpare_1574(NonSpare):
    cv_arg: TypeAlias = RuleVariation_766.cv_arg
    cv_name = "REDXMT"
    cv_title = "Reduction Steps in Use for An Overload of the Transmission Subsystem"
    cv_rule: TypeAlias = RuleVariation_766

    @classmethod
    def create(cls, arg : "NonSpare_1574.cv_arg") -> "NonSpare_1574":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_766:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_787:
        return self.rule.variation

class Item_799(Item):
    cv_arg: TypeAlias = NonSpare_1574.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1574

    @classmethod
    def create(cls, arg : "Item_799.cv_arg") -> "Item_799":
        return cls._create(arg) # type: ignore

class Variation_998(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_475.cv_arg, Tuple[Literal["REDRDP"], RuleVariation_475.cv_arg]], Union[RuleVariation_766.cv_arg, Tuple[Literal["REDXMT"], RuleVariation_766.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_998.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_798, 3), (Item_799, 3), (Item_29, 1)]
    cv_items_dict = {"REDRDP": RuleVariation_475, "REDXMT": RuleVariation_766}

    @overload
    @classmethod
    def spec(cls, key : Literal["REDRDP"]) -> RuleVariation_475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REDXMT"]) -> RuleVariation_766:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["REDRDP"], Literal["REDXMT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["REDRDP"]) -> RuleVariation_475:
        ...
    @overload
    def get_item(self, key : Literal["REDXMT"]) -> RuleVariation_766:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_998.cv_arg") -> 'Variation_998':
        return cls._create(arg) # type: ignore

class RuleVariation_968(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_998.cv_arg
    cv_variation: TypeAlias = Variation_998

    @classmethod
    def create(cls, arg : "RuleVariation_968.cv_arg") -> "RuleVariation_968":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_998:
        return self.arg # type: ignore

class NonSpare_781(NonSpare):
    cv_arg: TypeAlias = RuleVariation_968.cv_arg
    cv_name = "COM"
    cv_title = "Common Part"
    cv_rule: TypeAlias = RuleVariation_968

    @classmethod
    def create(cls, arg : "NonSpare_781.cv_arg") -> "NonSpare_781":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_968:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_998:
        return self.rule.variation

class Content_258(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Linear polarization", 1: "Circular polarization"}

class RuleContent_258(RuleContentContextFree):
    cv_arg: TypeAlias = Content_258.cv_arg
    cv_content: TypeAlias = Content_258

    @property
    def content(self) -> Content_258:
        return self._get_content() # type: ignore

class Variation_51(Element):
    cv_arg: TypeAlias = RuleContent_258.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_258

    @classmethod
    def create(cls, arg: "Variation_51.cv_arg") -> "Variation_51":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_258:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_258:
        return self.rule.content

class RuleVariation_51(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_51.cv_arg
    cv_variation: TypeAlias = Variation_51

    @classmethod
    def create(cls, arg : "RuleVariation_51.cv_arg") -> "RuleVariation_51":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_51:
        return self.arg # type: ignore

class NonSpare_1442(NonSpare):
    cv_arg: TypeAlias = RuleVariation_51.cv_arg
    cv_name = "POL"
    cv_title = "Polarization in Use by PSR"
    cv_rule: TypeAlias = RuleVariation_51

    @classmethod
    def create(cls, arg : "NonSpare_1442.cv_arg") -> "NonSpare_1442":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_51:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_51:
        return self.rule.variation

class Item_691(Item):
    cv_arg: TypeAlias = NonSpare_1442.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1442

    @classmethod
    def create(cls, arg : "Item_691.cv_arg") -> "Item_691":
        return cls._create(arg) # type: ignore

class NonSpare_1571(NonSpare):
    cv_arg: TypeAlias = RuleVariation_475.cv_arg
    cv_name = "REDRAD"
    cv_title = "Reduction Steps in Use as Result of An Overload Within the PSR Subsystem"
    cv_rule: TypeAlias = RuleVariation_475

    @classmethod
    def create(cls, arg : "NonSpare_1571.cv_arg") -> "NonSpare_1571":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_475:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_486:
        return self.rule.variation

class Item_796(Item):
    cv_arg: TypeAlias = NonSpare_1571.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1571

    @classmethod
    def create(cls, arg : "Item_796.cv_arg") -> "Item_796":
        return cls._create(arg) # type: ignore

class Content_452(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "STC Map-1", 1: "STC Map-2", 2: "STC Map-3", 3: "STC Map-4"}

class RuleContent_452(RuleContentContextFree):
    cv_arg: TypeAlias = Content_452.cv_arg
    cv_content: TypeAlias = Content_452

    @property
    def content(self) -> Content_452:
        return self._get_content() # type: ignore

class Variation_768(Element):
    cv_arg: TypeAlias = RuleContent_452.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_452

    @classmethod
    def create(cls, arg: "Variation_768.cv_arg") -> "Variation_768":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_452:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_452:
        return self.rule.content

class RuleVariation_757(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_768.cv_arg
    cv_variation: TypeAlias = Variation_768

    @classmethod
    def create(cls, arg : "RuleVariation_757.cv_arg") -> "RuleVariation_757":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_768:
        return self.arg # type: ignore

class NonSpare_1786(NonSpare):
    cv_arg: TypeAlias = RuleVariation_757.cv_arg
    cv_name = "STC"
    cv_title = "Sensitivity Time Control Map in Use"
    cv_rule: TypeAlias = RuleVariation_757

    @classmethod
    def create(cls, arg : "NonSpare_1786.cv_arg") -> "NonSpare_1786":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_757:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_768:
        return self.rule.variation

class Item_947(Item):
    cv_arg: TypeAlias = NonSpare_1786.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1786

    @classmethod
    def create(cls, arg : "Item_947.cv_arg") -> "Item_947":
        return cls._create(arg) # type: ignore

class Variation_1160(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_51.cv_arg, Tuple[Literal["POL"], RuleVariation_51.cv_arg]], Union[RuleVariation_475.cv_arg, Tuple[Literal["REDRAD"], RuleVariation_475.cv_arg]], Union[RuleVariation_757.cv_arg, Tuple[Literal["STC"], RuleVariation_757.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1160.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_691, 1), (Item_796, 3), (Item_947, 2), (Item_27, 2)]
    cv_items_dict = {"POL": RuleVariation_51, "REDRAD": RuleVariation_475, "STC": RuleVariation_757}

    @overload
    @classmethod
    def spec(cls, key : Literal["POL"]) -> RuleVariation_51:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REDRAD"]) -> RuleVariation_475:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STC"]) -> RuleVariation_757:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["POL"], Literal["REDRAD"], Literal["STC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["POL"]) -> RuleVariation_51:
        ...
    @overload
    def get_item(self, key : Literal["REDRAD"]) -> RuleVariation_475:
        ...
    @overload
    def get_item(self, key : Literal["STC"]) -> RuleVariation_757:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1160.cv_arg") -> 'Variation_1160':
        return cls._create(arg) # type: ignore

class RuleVariation_1111(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1160.cv_arg
    cv_variation: TypeAlias = Variation_1160

    @classmethod
    def create(cls, arg : "RuleVariation_1111.cv_arg") -> "RuleVariation_1111":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1160:
        return self.arg # type: ignore

class NonSpare_1478(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1111.cv_arg
    cv_name = "PSR"
    cv_title = "Specific Processing Mode Information for a PSR Sensor"
    cv_rule: TypeAlias = RuleVariation_1111

    @classmethod
    def create(cls, arg : "NonSpare_1478.cv_arg") -> "NonSpare_1478":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1111:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1160:
        return self.rule.variation

class Variation_129(Element):
    cv_arg: TypeAlias = RuleContent_370.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_370

    @classmethod
    def create(cls, arg: "Variation_129.cv_arg") -> "Variation_129":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_370:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_370:
        return self.rule.content

class RuleVariation_129(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_129.cv_arg
    cv_variation: TypeAlias = Variation_129

    @classmethod
    def create(cls, arg : "RuleVariation_129.cv_arg") -> "RuleVariation_129":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_129:
        return self.arg # type: ignore

class NonSpare_1572(NonSpare):
    cv_arg: TypeAlias = RuleVariation_129.cv_arg
    cv_name = "REDRAD"
    cv_title = "Reduction Steps in Use as Result of An Overload Within the SSR Subsystem"
    cv_rule: TypeAlias = RuleVariation_129

    @classmethod
    def create(cls, arg : "NonSpare_1572.cv_arg") -> "NonSpare_1572":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_129:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_129:
        return self.rule.variation

class Item_797(Item):
    cv_arg: TypeAlias = NonSpare_1572.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1572

    @classmethod
    def create(cls, arg : "Item_797.cv_arg") -> "Item_797":
        return cls._create(arg) # type: ignore

class Variation_1177(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_129.cv_arg, Tuple[Literal["REDRAD"], RuleVariation_129.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1177.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_797, 3), (Item_19, 5)]
    cv_items_dict = {"REDRAD": RuleVariation_129}

    @classmethod
    def spec(cls, key : Literal["REDRAD"]) -> RuleVariation_129:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["REDRAD"]) -> RuleVariation_129:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1177.cv_arg") -> 'Variation_1177':
        return cls._create(arg) # type: ignore

class RuleVariation_1128(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1177.cv_arg
    cv_variation: TypeAlias = Variation_1177

    @classmethod
    def create(cls, arg : "RuleVariation_1128.cv_arg") -> "RuleVariation_1128":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1177:
        return self.arg # type: ignore

class NonSpare_1764(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1128.cv_arg
    cv_name = "SSR"
    cv_title = "Specific Processing Mode Information for a SSR Sensor"
    cv_rule: TypeAlias = RuleVariation_1128

    @classmethod
    def create(cls, arg : "NonSpare_1764.cv_arg") -> "NonSpare_1764":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1128:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1177:
        return self.rule.variation

class NonSpare_1570(NonSpare):
    cv_arg: TypeAlias = RuleVariation_129.cv_arg
    cv_name = "REDRAD"
    cv_title = "Reduction Steps in Use as Result of An Overload Within the Mode S Subsystem"
    cv_rule: TypeAlias = RuleVariation_129

    @classmethod
    def create(cls, arg : "NonSpare_1570.cv_arg") -> "NonSpare_1570":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_129:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_129:
        return self.rule.variation

class Item_795(Item):
    cv_arg: TypeAlias = NonSpare_1570.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1570

    @classmethod
    def create(cls, arg : "Item_795.cv_arg") -> "Item_795":
        return cls._create(arg) # type: ignore

class Content_41(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Autonomous", 1: "Not autonomous"}

class RuleContent_41(RuleContentContextFree):
    cv_arg: TypeAlias = Content_41.cv_arg
    cv_content: TypeAlias = Content_41

    @property
    def content(self) -> Content_41:
        return self._get_content() # type: ignore

class Variation_618(Element):
    cv_arg: TypeAlias = RuleContent_41.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_41

    @classmethod
    def create(cls, arg: "Variation_618.cv_arg") -> "Variation_618":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_41:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_41:
        return self.rule.content

class RuleVariation_607(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_618.cv_arg
    cv_variation: TypeAlias = Variation_618

    @classmethod
    def create(cls, arg : "RuleVariation_607.cv_arg") -> "RuleVariation_607":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_618:
        return self.arg # type: ignore

class NonSpare_745(NonSpare):
    cv_arg: TypeAlias = RuleVariation_607.cv_arg
    cv_name = "CLU"
    cv_title = "Cluster State"
    cv_rule: TypeAlias = RuleVariation_607

    @classmethod
    def create(cls, arg : "NonSpare_745.cv_arg") -> "NonSpare_745":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_607:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_618:
        return self.rule.variation

class Item_164(Item):
    cv_arg: TypeAlias = NonSpare_745.cv_arg
    cv_non_spare: TypeAlias = NonSpare_745

    @classmethod
    def create(cls, arg : "Item_164.cv_arg") -> "Item_164":
        return cls._create(arg) # type: ignore

class Variation_1176(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_129.cv_arg, Tuple[Literal["REDRAD"], RuleVariation_129.cv_arg]], Union[RuleVariation_607.cv_arg, Tuple[Literal["CLU"], RuleVariation_607.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1176.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_795, 3), (Item_164, 1), (Item_22, 4)]
    cv_items_dict = {"REDRAD": RuleVariation_129, "CLU": RuleVariation_607}

    @overload
    @classmethod
    def spec(cls, key : Literal["REDRAD"]) -> RuleVariation_129:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CLU"]) -> RuleVariation_607:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["REDRAD"], Literal["CLU"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["REDRAD"]) -> RuleVariation_129:
        ...
    @overload
    def get_item(self, key : Literal["CLU"]) -> RuleVariation_607:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1176.cv_arg") -> 'Variation_1176':
        return cls._create(arg) # type: ignore

class RuleVariation_1127(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1176.cv_arg
    cv_variation: TypeAlias = Variation_1176

    @classmethod
    def create(cls, arg : "RuleVariation_1127.cv_arg") -> "RuleVariation_1127":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1176:
        return self.arg # type: ignore

class NonSpare_1263(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1127.cv_arg
    cv_name = "MDS"
    cv_title = "Specific Processing Mode Information for a Mode S Sensor"
    cv_rule: TypeAlias = RuleVariation_1127

    @classmethod
    def create(cls, arg : "NonSpare_1263.cv_arg") -> "NonSpare_1263":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1127:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1176:
        return self.rule.variation

class Variation_1481(Compound):
    cv_arg = TypedDict('cv_arg', {
        "COM": NonSpare_781.cv_arg,
        "PSR": NonSpare_1478.cv_arg,
        "SSR": NonSpare_1764.cv_arg,
        "MDS": NonSpare_1263.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_781, None, None, NonSpare_1478, NonSpare_1764, NonSpare_1263]
    cv_items_dict = {"COM": NonSpare_781, "PSR": NonSpare_1478, "SSR": NonSpare_1764, "MDS": NonSpare_1263}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_781:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1478:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1764:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1263:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["PSR"], Literal["SSR"], Literal["MDS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_781]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1478]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1764]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1263]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_781.cv_arg) -> "Variation_1481":
        ...
    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1478.cv_arg) -> "Variation_1481":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1764.cv_arg) -> "Variation_1481":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1263.cv_arg) -> "Variation_1481":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1481":
        ...
    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1481":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1481":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1481":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1481.cv_arg") -> 'Variation_1481':
        return cls._create(arg) # type: ignore

class RuleVariation_1402(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1481.cv_arg
    cv_variation: TypeAlias = Variation_1481

    @classmethod
    def create(cls, arg : "RuleVariation_1402.cv_arg") -> "RuleVariation_1402":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1481:
        return self.arg # type: ignore

class NonSpare_200(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1402.cv_arg
    cv_name = "060"
    cv_title = "System Processing Mode"
    cv_rule: TypeAlias = RuleVariation_1402

    @classmethod
    def create(cls, arg : "NonSpare_200.cv_arg") -> "NonSpare_200":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1402:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1481:
        return self.rule.variation

class UapItem_200(UapItem):
    cv_non_spare: TypeAlias = NonSpare_200

class Content_349(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No detection (number of misses)", 1: "Single PSR target reports", 2: "Single SSR target reports (Non-Mode S)", 3: "SSR+PSR target reports (Non-Mode S)", 4: "Single All-Call target reports (Mode S)", 5: "Single Roll-Call target reports (Mode S)", 6: "All-Call + PSR (Mode S) target reports", 7: "Roll-Call + PSR (Mode S) target reports", 8: "Filter for Weather data", 9: "Filter for Jamming Strobe", 10: "Filter for PSR data", 11: "Filter for SSR/Mode S data", 12: "Filter for SSR/Mode S+PSR data", 13: "Filter for Enhanced Surveillance data", 14: "Filter for PSR+Enhanced Surveillance", 15: "Filter for PSR+Enhanced Surveillance + SSR/Mode S data not in Area of Prime Interest", 16: "Filter for PSR+Enhanced Surveillance + all SSR/Mode S data"}

class RuleContent_349(RuleContentContextFree):
    cv_arg: TypeAlias = Content_349.cv_arg
    cv_content: TypeAlias = Content_349

    @property
    def content(self) -> Content_349:
        return self._get_content() # type: ignore

class Variation_142(Element):
    cv_arg: TypeAlias = RuleContent_349.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_349

    @classmethod
    def create(cls, arg: "Variation_142.cv_arg") -> "Variation_142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_349:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_349:
        return self.rule.content

class RuleVariation_142(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_142.cv_arg
    cv_variation: TypeAlias = Variation_142

    @classmethod
    def create(cls, arg : "RuleVariation_142.cv_arg") -> "RuleVariation_142":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_142:
        return self.arg # type: ignore

class NonSpare_1969(NonSpare):
    cv_arg: TypeAlias = RuleVariation_142.cv_arg
    cv_name = "TYP"
    cv_title = "Type of Message Counter"
    cv_rule: TypeAlias = RuleVariation_142

    @classmethod
    def create(cls, arg : "NonSpare_1969.cv_arg") -> "NonSpare_1969":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_142:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_142:
        return self.rule.variation

class Item_1082(Item):
    cv_arg: TypeAlias = NonSpare_1969.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1969

    @classmethod
    def create(cls, arg : "Item_1082.cv_arg") -> "Item_1082":
        return cls._create(arg) # type: ignore

class Variation_895(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 11
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_895.cv_arg") -> "Variation_895":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_865(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_895.cv_arg
    cv_variation: TypeAlias = Variation_895

    @classmethod
    def create(cls, arg : "RuleVariation_865.cv_arg") -> "RuleVariation_865":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_895:
        return self.arg # type: ignore

class NonSpare_799(NonSpare):
    cv_arg: TypeAlias = RuleVariation_865.cv_arg
    cv_name = "COUNT"
    cv_title = "COUNTER"
    cv_rule: TypeAlias = RuleVariation_865

    @classmethod
    def create(cls, arg : "NonSpare_799.cv_arg") -> "NonSpare_799":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_865:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_895:
        return self.rule.variation

class Item_198(Item):
    cv_arg: TypeAlias = NonSpare_799.cv_arg
    cv_non_spare: TypeAlias = NonSpare_799

    @classmethod
    def create(cls, arg : "Item_198.cv_arg") -> "Item_198":
        return cls._create(arg) # type: ignore

class Variation_1241(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_142.cv_arg, Tuple[Literal["TYP"], RuleVariation_142.cv_arg]], Union[RuleVariation_865.cv_arg, Tuple[Literal["COUNT"], RuleVariation_865.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1241.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1082, 5), (Item_198, 11)]
    cv_items_dict = {"TYP": RuleVariation_142, "COUNT": RuleVariation_865}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNT"]) -> RuleVariation_865:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["COUNT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_142:
        ...
    @overload
    def get_item(self, key : Literal["COUNT"]) -> RuleVariation_865:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1241.cv_arg") -> 'Variation_1241':
        return cls._create(arg) # type: ignore

class Variation_1443(Repetitive):
    cv_arg: TypeAlias = List[Variation_1241.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1241

    @classmethod
    def create(cls, arg: "Variation_1443.cv_arg") -> 'Variation_1443':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1241]:
        return self._get_list() # type: ignore

class RuleVariation_1364(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1443.cv_arg
    cv_variation: TypeAlias = Variation_1443

    @classmethod
    def create(cls, arg : "RuleVariation_1364.cv_arg") -> "RuleVariation_1364":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1443:
        return self.arg # type: ignore

class NonSpare_206(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1364.cv_arg
    cv_name = "070"
    cv_title = "Message Count Values"
    cv_rule: TypeAlias = RuleVariation_1364

    @classmethod
    def create(cls, arg : "NonSpare_206.cv_arg") -> "NonSpare_206":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1443:
        return self.rule.variation

class UapItem_206(UapItem):
    cv_non_spare: TypeAlias = NonSpare_206

class Content_774(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_773(RuleContentContextFree):
    cv_arg: TypeAlias = Content_774.cv_arg
    cv_content: TypeAlias = Content_774

    @property
    def content(self) -> Content_774:
        return self._get_content() # type: ignore

class Variation_336(Element):
    cv_arg: TypeAlias = RuleContent_773.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_773

    @classmethod
    def create(cls, arg: "Variation_336.cv_arg") -> "Variation_336":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_773:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_774:
        return self.rule.content

class RuleVariation_329(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_336.cv_arg
    cv_variation: TypeAlias = Variation_336

    @classmethod
    def create(cls, arg : "RuleVariation_329.cv_arg") -> "RuleVariation_329":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_336:
        return self.arg # type: ignore

class NonSpare_1594(NonSpare):
    cv_arg: TypeAlias = RuleVariation_329.cv_arg
    cv_name = "RHOST"
    cv_title = "Rho Start"
    cv_rule: TypeAlias = RuleVariation_329

    @classmethod
    def create(cls, arg : "NonSpare_1594.cv_arg") -> "NonSpare_1594":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_336:
        return self.rule.variation

class Item_819(Item):
    cv_arg: TypeAlias = NonSpare_1594.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1594

    @classmethod
    def create(cls, arg : "Item_819.cv_arg") -> "Item_819":
        return cls._create(arg) # type: ignore

class NonSpare_1593(NonSpare):
    cv_arg: TypeAlias = RuleVariation_329.cv_arg
    cv_name = "RHOEND"
    cv_title = "Rho End"
    cv_rule: TypeAlias = RuleVariation_329

    @classmethod
    def create(cls, arg : "NonSpare_1593.cv_arg") -> "NonSpare_1593":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_336:
        return self.rule.variation

class Item_818(Item):
    cv_arg: TypeAlias = NonSpare_1593.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1593

    @classmethod
    def create(cls, arg : "Item_818.cv_arg") -> "Item_818":
        return cls._create(arg) # type: ignore

class NonSpare_1858(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "THETAST"
    cv_title = "Theta Start"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1858.cv_arg") -> "NonSpare_1858":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_996(Item):
    cv_arg: TypeAlias = NonSpare_1858.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1858

    @classmethod
    def create(cls, arg : "Item_996.cv_arg") -> "Item_996":
        return cls._create(arg) # type: ignore

class NonSpare_1857(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "THETAEND"
    cv_title = "Theta End"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1857.cv_arg") -> "NonSpare_1857":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_995(Item):
    cv_arg: TypeAlias = NonSpare_1857.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1857

    @classmethod
    def create(cls, arg : "Item_995.cv_arg") -> "Item_995":
        return cls._create(arg) # type: ignore

class Variation_1182(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_329.cv_arg, Tuple[Literal["RHOST"], RuleVariation_329.cv_arg]], Union[RuleVariation_329.cv_arg, Tuple[Literal["RHOEND"], RuleVariation_329.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["THETAST"], RuleVariation_336.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["THETAEND"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1182.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_819, 16), (Item_818, 16), (Item_996, 16), (Item_995, 16)]
    cv_items_dict = {"RHOST": RuleVariation_329, "RHOEND": RuleVariation_329, "THETAST": RuleVariation_336, "THETAEND": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHOST"]) -> RuleVariation_329:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RHOEND"]) -> RuleVariation_329:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETAST"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETAEND"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHOST"], Literal["RHOEND"], Literal["THETAST"], Literal["THETAEND"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHOST"]) -> RuleVariation_329:
        ...
    @overload
    def get_item(self, key : Literal["RHOEND"]) -> RuleVariation_329:
        ...
    @overload
    def get_item(self, key : Literal["THETAST"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["THETAEND"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1182.cv_arg") -> 'Variation_1182':
        return cls._create(arg) # type: ignore

class RuleVariation_1133(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1182.cv_arg
    cv_variation: TypeAlias = Variation_1182

    @classmethod
    def create(cls, arg : "RuleVariation_1133.cv_arg") -> "RuleVariation_1133":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1182:
        return self.arg # type: ignore

class NonSpare_270(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1133.cv_arg
    cv_name = "100"
    cv_title = "Generic Polar Window"
    cv_rule: TypeAlias = RuleVariation_1133

    @classmethod
    def create(cls, arg : "NonSpare_270.cv_arg") -> "NonSpare_270":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1133:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1182:
        return self.rule.variation

class UapItem_270(UapItem):
    cv_non_spare: TypeAlias = NonSpare_270

class Content_248(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Invalid value", 1: "Filter for Weather data", 2: "Filter for Jamming Strobe", 3: "Filter for PSR data", 4: "Filter for SSR/Mode S data", 5: "Filter for SSR/Mode S + PSR data", 6: "Enhanced Surveillance data", 7: "Filter for PSR+Enhanced Surveillance data", 8: "Filter for PSR+Enhanced Surveillance + SSR/Mode S data not in Area of Prime Interest", 9: "Filter for PSR+Enhanced Surveillance + all SSR/Mode S data"}

class RuleContent_248(RuleContentContextFree):
    cv_arg: TypeAlias = Content_248.cv_arg
    cv_content: TypeAlias = Content_248

    @property
    def content(self) -> Content_248:
        return self._get_content() # type: ignore

class Variation_168(Element):
    cv_arg: TypeAlias = RuleContent_248.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_248

    @classmethod
    def create(cls, arg: "Variation_168.cv_arg") -> "Variation_168":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_248:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_248:
        return self.rule.content

class RuleVariation_162(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_168.cv_arg
    cv_variation: TypeAlias = Variation_168

    @classmethod
    def create(cls, arg : "RuleVariation_162.cv_arg") -> "RuleVariation_162":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_168:
        return self.arg # type: ignore

class NonSpare_284(NonSpare):
    cv_arg: TypeAlias = RuleVariation_162.cv_arg
    cv_name = "110"
    cv_title = "Data Filter"
    cv_rule: TypeAlias = RuleVariation_162

    @classmethod
    def create(cls, arg : "NonSpare_284.cv_arg") -> "NonSpare_284":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_162:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_168:
        return self.rule.variation

class UapItem_284(UapItem):
    cv_non_spare: TypeAlias = NonSpare_284

class Variation_258(Element):
    cv_arg: TypeAlias = RuleContent_626.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_626

    @classmethod
    def create(cls, arg: "Variation_258.cv_arg") -> "Variation_258":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_626:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_626:
        return self.rule.content

class RuleVariation_251(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_258.cv_arg
    cv_variation: TypeAlias = Variation_258

    @classmethod
    def create(cls, arg : "RuleVariation_251.cv_arg") -> "RuleVariation_251":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_258:
        return self.arg # type: ignore

class NonSpare_1068(NonSpare):
    cv_arg: TypeAlias = RuleVariation_251.cv_arg
    cv_name = "HGT"
    cv_title = "Height of Data Source"
    cv_rule: TypeAlias = RuleVariation_251

    @classmethod
    def create(cls, arg : "NonSpare_1068.cv_arg") -> "NonSpare_1068":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_251:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_258:
        return self.rule.variation

class Item_394(Item):
    cv_arg: TypeAlias = NonSpare_1068.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1068

    @classmethod
    def create(cls, arg : "Item_394.cv_arg") -> "Item_394":
        return cls._create(arg) # type: ignore

class Content_694(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_694(RuleContentContextFree):
    cv_arg: TypeAlias = Content_694.cv_arg
    cv_content: TypeAlias = Content_694

    @property
    def content(self) -> Content_694:
        return self._get_content() # type: ignore

class Variation_359(Element):
    cv_arg: TypeAlias = RuleContent_694.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_694

    @classmethod
    def create(cls, arg: "Variation_359.cv_arg") -> "Variation_359":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_694:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_694:
        return self.rule.content

class RuleVariation_352(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_359.cv_arg
    cv_variation: TypeAlias = Variation_359

    @classmethod
    def create(cls, arg : "RuleVariation_352.cv_arg") -> "RuleVariation_352":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_359:
        return self.arg # type: ignore

class NonSpare_1180(NonSpare):
    cv_arg: TypeAlias = RuleVariation_352.cv_arg
    cv_name = "LON"
    cv_title = "Longitude"
    cv_rule: TypeAlias = RuleVariation_352

    @classmethod
    def create(cls, arg : "NonSpare_1180.cv_arg") -> "NonSpare_1180":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_352:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_359:
        return self.rule.variation

class Item_490(Item):
    cv_arg: TypeAlias = NonSpare_1180.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1180

    @classmethod
    def create(cls, arg : "Item_490.cv_arg") -> "Item_490":
        return cls._create(arg) # type: ignore

class Variation_1116(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_251.cv_arg, Tuple[Literal["HGT"], RuleVariation_251.cv_arg]], Union[RuleVariation_353.cv_arg, Tuple[Literal["LAT"], RuleVariation_353.cv_arg]], Union[RuleVariation_352.cv_arg, Tuple[Literal["LON"], RuleVariation_352.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1116.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_394, 16), (Item_462, 24), (Item_490, 24)]
    cv_items_dict = {"HGT": RuleVariation_251, "LAT": RuleVariation_353, "LON": RuleVariation_352}

    @overload
    @classmethod
    def spec(cls, key : Literal["HGT"]) -> RuleVariation_251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_352:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HGT"], Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HGT"]) -> RuleVariation_251:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_352:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1116.cv_arg") -> 'Variation_1116':
        return cls._create(arg) # type: ignore

class RuleVariation_1074(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1116.cv_arg
    cv_variation: TypeAlias = Variation_1116

    @classmethod
    def create(cls, arg : "RuleVariation_1074.cv_arg") -> "RuleVariation_1074":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1116:
        return self.arg # type: ignore

class NonSpare_294(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1074.cv_arg
    cv_name = "120"
    cv_title = "3D-Position Of Data Source"
    cv_rule: TypeAlias = RuleVariation_1074

    @classmethod
    def create(cls, arg : "NonSpare_294.cv_arg") -> "NonSpare_294":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1074:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1116:
        return self.rule.variation

class UapItem_294(UapItem):
    cv_non_spare: TypeAlias = NonSpare_294

class NonSpare_1599(NonSpare):
    cv_arg: TypeAlias = RuleVariation_208.cv_arg
    cv_name = "RNG"
    cv_title = "Range Error"
    cv_rule: TypeAlias = RuleVariation_208

    @classmethod
    def create(cls, arg : "NonSpare_1599.cv_arg") -> "NonSpare_1599":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_208:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_215:
        return self.rule.variation

class Item_824(Item):
    cv_arg: TypeAlias = NonSpare_1599.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1599

    @classmethod
    def create(cls, arg : "Item_824.cv_arg") -> "Item_824":
        return cls._create(arg) # type: ignore

class NonSpare_667(NonSpare):
    cv_arg: TypeAlias = RuleVariation_213.cv_arg
    cv_name = "AZM"
    cv_title = "Azimuth Error"
    cv_rule: TypeAlias = RuleVariation_213

    @classmethod
    def create(cls, arg : "NonSpare_667.cv_arg") -> "NonSpare_667":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_213:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_220:
        return self.rule.variation

class Item_108(Item):
    cv_arg: TypeAlias = NonSpare_667.cv_arg
    cv_non_spare: TypeAlias = NonSpare_667

    @classmethod
    def create(cls, arg : "Item_108.cv_arg") -> "Item_108":
        return cls._create(arg) # type: ignore

class Variation_1184(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_208.cv_arg, Tuple[Literal["RNG"], RuleVariation_208.cv_arg]], Union[RuleVariation_213.cv_arg, Tuple[Literal["AZM"], RuleVariation_213.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1184.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_824, 8), (Item_108, 8)]
    cv_items_dict = {"RNG": RuleVariation_208, "AZM": RuleVariation_213}

    @overload
    @classmethod
    def spec(cls, key : Literal["RNG"]) -> RuleVariation_208:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AZM"]) -> RuleVariation_213:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RNG"], Literal["AZM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RNG"]) -> RuleVariation_208:
        ...
    @overload
    def get_item(self, key : Literal["AZM"]) -> RuleVariation_213:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1184.cv_arg") -> 'Variation_1184':
        return cls._create(arg) # type: ignore

class RuleVariation_1134(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1184.cv_arg
    cv_variation: TypeAlias = Variation_1184

    @classmethod
    def create(cls, arg : "RuleVariation_1134.cv_arg") -> "RuleVariation_1134":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1184:
        return self.arg # type: ignore

class NonSpare_245(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1134.cv_arg
    cv_name = "090"
    cv_title = "Collimation Error"
    cv_rule: TypeAlias = RuleVariation_1134

    @classmethod
    def create(cls, arg : "NonSpare_245.cv_arg") -> "NonSpare_245":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1134:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1184:
        return self.rule.variation

class UapItem_245(UapItem):
    cv_non_spare: TypeAlias = NonSpare_245

class Record_15(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_35.cv_arg,
        "000": NonSpare_4.cv_arg,
        "030": NonSpare_108.cv_arg,
        "020": NonSpare_82.cv_arg,
        "041": NonSpare_153.cv_arg,
        "050": NonSpare_181.cv_arg,
        "060": NonSpare_200.cv_arg,
        "070": NonSpare_206.cv_arg,
        "100": NonSpare_270.cv_arg,
        "110": NonSpare_284.cv_arg,
        "120": NonSpare_294.cv_arg,
        "090": NonSpare_245.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_35, UapItem_4, UapItem_108, UapItem_82, UapItem_153, UapItem_181, UapItem_200, UapItem_206, UapItem_270, UapItem_284, UapItem_294, UapItem_245, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_35, "000": NonSpare_4, "030": NonSpare_108, "020": NonSpare_82, "041": NonSpare_153, "050": NonSpare_181, "060": NonSpare_200, "070": NonSpare_206, "100": NonSpare_270, "110": NonSpare_284, "120": NonSpare_294, "090": NonSpare_245, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_35:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_4:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_82:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_153:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_181:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_200:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_206:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_284:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_294:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["030"], Literal["020"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["110"], Literal["120"], Literal["090"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_35]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_4]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_82]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_153]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_181]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_200]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_206]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_284]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_294]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_35.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_4.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_82.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_153.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_181.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_200.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_206.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_284.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_294.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_15':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_15':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_15':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_15':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_15.cv_arg") -> 'Record_15':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_15", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_15(UapSingle):
    cv_arg: TypeAlias = Record_15
    cv_record: TypeAlias = Record_15

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_15]]:
        return cls._parse(bs)

class Asterix_40(AstCat):
    cv_category = 34
    cv_edition = (1, 27)
    cv_uap: TypeAlias = Uap_15
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_15.cv_arg]) -> "Asterix_40":
        return cls._create(records) # type: ignore

class Content_588(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "Geographical filtering message", 4: "Jamming strobe message", 5: "Solar Storm Message"}

class RuleContent_588(RuleContentContextFree):
    cv_arg: TypeAlias = Content_588.cv_arg
    cv_content: TypeAlias = Content_588

    @property
    def content(self) -> Content_588:
        return self._get_content() # type: ignore

class Variation_188(Element):
    cv_arg: TypeAlias = RuleContent_588.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_588

    @classmethod
    def create(cls, arg: "Variation_188.cv_arg") -> "Variation_188":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_588:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_588:
        return self.rule.content

class RuleVariation_181(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_188.cv_arg
    cv_variation: TypeAlias = Variation_188

    @classmethod
    def create(cls, arg : "RuleVariation_181.cv_arg") -> "RuleVariation_181":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_188:
        return self.arg # type: ignore

class NonSpare_5(NonSpare):
    cv_arg: TypeAlias = RuleVariation_181.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_181

    @classmethod
    def create(cls, arg : "NonSpare_5.cv_arg") -> "NonSpare_5":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_181:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_188:
        return self.rule.variation

class UapItem_5(UapItem):
    cv_non_spare: TypeAlias = NonSpare_5

class Content_350(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No detection (number of misses)", 1: "Single PSR target reports", 2: "Single SSR target reports (Non-Mode S)", 3: "SSR+PSR target reports (Non-Mode S)", 4: "Single All-Call target reports (Mode S)", 5: "Single Roll-Call target reports (Mode S)", 6: "All-Call + PSR (Mode S) target reports", 7: "Roll-Call + PSR (Mode S) target reports", 8: "Filter for Weather data", 9: "Filter for Jamming Strobe", 10: "Filter for PSR data", 11: "Filter for SSR/Mode S data", 12: "Filter for SSR/Mode S+PSR data", 13: "Filter for Enhanced Surveillance data", 14: "Filter for PSR+Enhanced Surveillance", 15: "Filter for PSR+Enhanced Surveillance + SSR/Mode S data not in Area of Prime Interest", 16: "Filter for PSR+Enhanced Surveillance + all SSR/Mode S data", 17: "Re-Interrogations (per sector)", 18: "BDS Swap and wrong DF replies(per sector)", 19: "Mode A/C FRUIT (per sector)", 20: "Mode S FRUIT (per sector)"}

class RuleContent_350(RuleContentContextFree):
    cv_arg: TypeAlias = Content_350.cv_arg
    cv_content: TypeAlias = Content_350

    @property
    def content(self) -> Content_350:
        return self._get_content() # type: ignore

class Variation_143(Element):
    cv_arg: TypeAlias = RuleContent_350.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_rule = RuleContent_350

    @classmethod
    def create(cls, arg: "Variation_143.cv_arg") -> "Variation_143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_350:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_350:
        return self.rule.content

class RuleVariation_143(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_143.cv_arg
    cv_variation: TypeAlias = Variation_143

    @classmethod
    def create(cls, arg : "RuleVariation_143.cv_arg") -> "RuleVariation_143":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_143:
        return self.arg # type: ignore

class NonSpare_1970(NonSpare):
    cv_arg: TypeAlias = RuleVariation_143.cv_arg
    cv_name = "TYP"
    cv_title = "Type of Message Counter"
    cv_rule: TypeAlias = RuleVariation_143

    @classmethod
    def create(cls, arg : "NonSpare_1970.cv_arg") -> "NonSpare_1970":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_143:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_143:
        return self.rule.variation

class Item_1083(Item):
    cv_arg: TypeAlias = NonSpare_1970.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1970

    @classmethod
    def create(cls, arg : "Item_1083.cv_arg") -> "Item_1083":
        return cls._create(arg) # type: ignore

class Variation_1242(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_143.cv_arg, Tuple[Literal["TYP"], RuleVariation_143.cv_arg]], Union[RuleVariation_865.cv_arg, Tuple[Literal["COUNT"], RuleVariation_865.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1242.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1083, 5), (Item_198, 11)]
    cv_items_dict = {"TYP": RuleVariation_143, "COUNT": RuleVariation_865}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_143:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COUNT"]) -> RuleVariation_865:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["COUNT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_143:
        ...
    @overload
    def get_item(self, key : Literal["COUNT"]) -> RuleVariation_865:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1242.cv_arg") -> 'Variation_1242':
        return cls._create(arg) # type: ignore

class Variation_1444(Repetitive):
    cv_arg: TypeAlias = List[Variation_1242.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1242

    @classmethod
    def create(cls, arg: "Variation_1444.cv_arg") -> 'Variation_1444':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1242]:
        return self._get_list() # type: ignore

class RuleVariation_1365(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1444.cv_arg
    cv_variation: TypeAlias = Variation_1444

    @classmethod
    def create(cls, arg : "RuleVariation_1365.cv_arg") -> "RuleVariation_1365":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1444:
        return self.arg # type: ignore

class NonSpare_207(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1365.cv_arg
    cv_name = "070"
    cv_title = "Message Count Values"
    cv_rule: TypeAlias = RuleVariation_1365

    @classmethod
    def create(cls, arg : "NonSpare_207.cv_arg") -> "NonSpare_207":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1444:
        return self.rule.variation

class UapItem_207(UapItem):
    cv_non_spare: TypeAlias = NonSpare_207

class Record_16(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_35.cv_arg,
        "000": NonSpare_5.cv_arg,
        "030": NonSpare_108.cv_arg,
        "020": NonSpare_82.cv_arg,
        "041": NonSpare_153.cv_arg,
        "050": NonSpare_181.cv_arg,
        "060": NonSpare_200.cv_arg,
        "070": NonSpare_207.cv_arg,
        "100": NonSpare_270.cv_arg,
        "110": NonSpare_284.cv_arg,
        "120": NonSpare_294.cv_arg,
        "090": NonSpare_245.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_35, UapItem_5, UapItem_108, UapItem_82, UapItem_153, UapItem_181, UapItem_200, UapItem_207, UapItem_270, UapItem_284, UapItem_294, UapItem_245, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_35, "000": NonSpare_5, "030": NonSpare_108, "020": NonSpare_82, "041": NonSpare_153, "050": NonSpare_181, "060": NonSpare_200, "070": NonSpare_207, "100": NonSpare_270, "110": NonSpare_284, "120": NonSpare_294, "090": NonSpare_245, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_35:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_5:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_82:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_153:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_181:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_200:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_284:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_294:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["030"], Literal["020"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["110"], Literal["120"], Literal["090"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_35]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_5]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_82]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_153]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_181]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_200]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_284]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_294]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_35.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_5.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_82.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_153.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_181.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_200.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_284.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_294.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_16':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_16':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_16':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_16':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_16.cv_arg") -> 'Record_16':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_16", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_16(UapSingle):
    cv_arg: TypeAlias = Record_16
    cv_record: TypeAlias = Record_16

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_16]]:
        return cls._parse(bs)

class Asterix_41(AstCat):
    cv_category = 34
    cv_edition = (1, 28)
    cv_uap: TypeAlias = Uap_16
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_16.cv_arg]) -> "Asterix_41":
        return cls._create(records) # type: ignore

class Content_589(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "North marker message", 2: "Sector crossing message", 3: "Geographical filtering message", 4: "Jamming strobe message", 5: "Solar Storm Message", 6: "SSR Jamming Strobe Message", 7: "Mode S Jamming Strobe Message"}

class RuleContent_589(RuleContentContextFree):
    cv_arg: TypeAlias = Content_589.cv_arg
    cv_content: TypeAlias = Content_589

    @property
    def content(self) -> Content_589:
        return self._get_content() # type: ignore

class Variation_189(Element):
    cv_arg: TypeAlias = RuleContent_589.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_589

    @classmethod
    def create(cls, arg: "Variation_189.cv_arg") -> "Variation_189":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_589:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_589:
        return self.rule.content

class RuleVariation_182(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_189.cv_arg
    cv_variation: TypeAlias = Variation_189

    @classmethod
    def create(cls, arg : "RuleVariation_182.cv_arg") -> "RuleVariation_182":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_189:
        return self.arg # type: ignore

class NonSpare_6(NonSpare):
    cv_arg: TypeAlias = RuleVariation_182.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_182

    @classmethod
    def create(cls, arg : "NonSpare_6.cv_arg") -> "NonSpare_6":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_182:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_189:
        return self.rule.variation

class UapItem_6(UapItem):
    cv_non_spare: TypeAlias = NonSpare_6

class Record_17(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_35.cv_arg,
        "000": NonSpare_6.cv_arg,
        "030": NonSpare_108.cv_arg,
        "020": NonSpare_82.cv_arg,
        "041": NonSpare_153.cv_arg,
        "050": NonSpare_181.cv_arg,
        "060": NonSpare_200.cv_arg,
        "070": NonSpare_207.cv_arg,
        "100": NonSpare_270.cv_arg,
        "110": NonSpare_284.cv_arg,
        "120": NonSpare_294.cv_arg,
        "090": NonSpare_245.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_35, UapItem_6, UapItem_108, UapItem_82, UapItem_153, UapItem_181, UapItem_200, UapItem_207, UapItem_270, UapItem_284, UapItem_294, UapItem_245, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_35, "000": NonSpare_6, "030": NonSpare_108, "020": NonSpare_82, "041": NonSpare_153, "050": NonSpare_181, "060": NonSpare_200, "070": NonSpare_207, "100": NonSpare_270, "110": NonSpare_284, "120": NonSpare_294, "090": NonSpare_245, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_35:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_6:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_108:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_82:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_153:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_181:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_200:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_207:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_270:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_284:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_294:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["030"], Literal["020"], Literal["041"], Literal["050"], Literal["060"], Literal["070"], Literal["100"], Literal["110"], Literal["120"], Literal["090"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_35]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_6]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_108]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_82]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_153]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_181]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_200]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_207]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_270]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_284]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_294]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_245]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_35.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_6.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_108.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_82.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_153.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_181.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_200.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_207.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_270.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_284.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_294.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_245.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_17':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_17':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_17':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_17':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_17.cv_arg") -> 'Record_17':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_17", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_17(UapSingle):
    cv_arg: TypeAlias = Record_17
    cv_record: TypeAlias = Record_17

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_17]]:
        return cls._parse(bs)

class Asterix_42(AstCat):
    cv_category = 34
    cv_edition = (1, 29)
    cv_uap: TypeAlias = Uap_17
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_17.cv_arg]) -> "Asterix_42":
        return cls._create(records) # type: ignore

class Content_327(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No authenticated Mode 5 Data reply/report", 1: "Authenticated Mode 5 Data reply/report (i.e any valid Mode 5 reply type other than ID)"}

class RuleContent_327(RuleContentContextFree):
    cv_arg: TypeAlias = Content_327.cv_arg
    cv_content: TypeAlias = Content_327

    @property
    def content(self) -> Content_327:
        return self._get_content() # type: ignore

class Variation_561(Element):
    cv_arg: TypeAlias = RuleContent_327.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_327

    @classmethod
    def create(cls, arg: "Variation_561.cv_arg") -> "Variation_561":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_327:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_327:
        return self.rule.content

class RuleVariation_550(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_561.cv_arg
    cv_variation: TypeAlias = Variation_561

    @classmethod
    def create(cls, arg : "RuleVariation_550.cv_arg") -> "RuleVariation_550":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_561:
        return self.arg # type: ignore

class NonSpare_858(NonSpare):
    cv_arg: TypeAlias = RuleVariation_550.cv_arg
    cv_name = "DA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_550

    @classmethod
    def create(cls, arg : "NonSpare_858.cv_arg") -> "NonSpare_858":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_550:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_561:
        return self.rule.variation

class Item_238(Item):
    cv_arg: TypeAlias = NonSpare_858.cv_arg
    cv_non_spare: TypeAlias = NonSpare_858

    @classmethod
    def create(cls, arg : "Item_238.cv_arg") -> "Item_238":
        return cls._create(arg) # type: ignore

class Content_281(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode C altitude not present or not from Mode 5 reply/report", 1: "Mode C altitude from Mode 5 reply/report"}

class RuleContent_281(RuleContentContextFree):
    cv_arg: TypeAlias = Content_281.cv_arg
    cv_content: TypeAlias = Content_281

    @property
    def content(self) -> Content_281:
        return self._get_content() # type: ignore

class Variation_939(Element):
    cv_arg: TypeAlias = RuleContent_281.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_281

    @classmethod
    def create(cls, arg: "Variation_939.cv_arg") -> "Variation_939":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_281:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_281:
        return self.rule.content

class RuleVariation_909(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_939.cv_arg
    cv_variation: TypeAlias = Variation_939

    @classmethod
    def create(cls, arg : "RuleVariation_909.cv_arg") -> "RuleVariation_909":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_939:
        return self.arg # type: ignore

class NonSpare_1240(NonSpare):
    cv_arg: TypeAlias = RuleVariation_909.cv_arg
    cv_name = "MC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_909

    @classmethod
    def create(cls, arg : "NonSpare_1240.cv_arg") -> "NonSpare_1240":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_909:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_939:
        return self.rule.variation

class Item_536(Item):
    cv_arg: TypeAlias = NonSpare_1240.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1240

    @classmethod
    def create(cls, arg : "Item_536.cv_arg") -> "Item_536":
        return cls._create(arg) # type: ignore

class Variation_1141(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_57.cv_arg, Tuple[Literal["M5"], RuleVariation_57.cv_arg]], Union[RuleVariation_431.cv_arg, Tuple[Literal["ID"], RuleVariation_431.cv_arg]], Union[RuleVariation_550.cv_arg, Tuple[Literal["DA"], RuleVariation_550.cv_arg]], Union[RuleVariation_636.cv_arg, Tuple[Literal["M1"], RuleVariation_636.cv_arg]], Union[RuleVariation_723.cv_arg, Tuple[Literal["M2"], RuleVariation_723.cv_arg]], Union[RuleVariation_831.cv_arg, Tuple[Literal["M3"], RuleVariation_831.cv_arg]], Union[RuleVariation_909.cv_arg, Tuple[Literal["MC"], RuleVariation_909.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1141.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_522, 1), (Item_428, 1), (Item_238, 1), (Item_515, 1), (Item_517, 1), (Item_520, 1), (Item_536, 1), (Item_29, 1)]
    cv_items_dict = {"M5": RuleVariation_57, "ID": RuleVariation_431, "DA": RuleVariation_550, "M1": RuleVariation_636, "M2": RuleVariation_723, "M3": RuleVariation_831, "MC": RuleVariation_909}

    @overload
    @classmethod
    def spec(cls, key : Literal["M5"]) -> RuleVariation_57:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> RuleVariation_431:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> RuleVariation_550:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_636:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_723:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3"]) -> RuleVariation_831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MC"]) -> RuleVariation_909:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["M5"], Literal["ID"], Literal["DA"], Literal["M1"], Literal["M2"], Literal["M3"], Literal["MC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["M5"]) -> RuleVariation_57:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> RuleVariation_431:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> RuleVariation_550:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_636:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_723:
        ...
    @overload
    def get_item(self, key : Literal["M3"]) -> RuleVariation_831:
        ...
    @overload
    def get_item(self, key : Literal["MC"]) -> RuleVariation_909:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1141.cv_arg") -> 'Variation_1141':
        return cls._create(arg) # type: ignore

class RuleVariation_1097(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1141.cv_arg
    cv_variation: TypeAlias = Variation_1141

    @classmethod
    def create(cls, arg : "RuleVariation_1097.cv_arg") -> "RuleVariation_1097":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1141:
        return self.arg # type: ignore

class NonSpare_1810(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1097.cv_arg
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule: TypeAlias = RuleVariation_1097

    @classmethod
    def create(cls, arg : "NonSpare_1810.cv_arg") -> "NonSpare_1810":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1097:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1141:
        return self.rule.variation

class Content_302(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "National Origin is valid", 1: "National Origin is invalid"}

class RuleContent_302(RuleContentContextFree):
    cv_arg: TypeAlias = Content_302.cv_arg
    cv_content: TypeAlias = Content_302

    @property
    def content(self) -> Content_302:
        return self._get_content() # type: ignore

class Variation_557(Element):
    cv_arg: TypeAlias = RuleContent_302.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_302

    @classmethod
    def create(cls, arg: "Variation_557.cv_arg") -> "Variation_557":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_302:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_302:
        return self.rule.content

class RuleVariation_546(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_557.cv_arg
    cv_variation: TypeAlias = Variation_557

    @classmethod
    def create(cls, arg : "RuleVariation_546.cv_arg") -> "RuleVariation_546":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_557:
        return self.arg # type: ignore

class NonSpare_1349(NonSpare):
    cv_arg: TypeAlias = RuleVariation_546.cv_arg
    cv_name = "NAV"
    cv_title = "Validity of NAT"
    cv_rule: TypeAlias = RuleVariation_546

    @classmethod
    def create(cls, arg : "NonSpare_1349.cv_arg") -> "NonSpare_1349":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_546:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_557:
        return self.rule.variation

class Item_609(Item):
    cv_arg: TypeAlias = NonSpare_1349.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1349

    @classmethod
    def create(cls, arg : "Item_609.cv_arg") -> "Item_609":
        return cls._create(arg) # type: ignore

class NonSpare_1343(NonSpare):
    cv_arg: TypeAlias = RuleVariation_684.cv_arg
    cv_name = "NAT"
    cv_title = "National Origin"
    cv_rule: TypeAlias = RuleVariation_684

    @classmethod
    def create(cls, arg : "NonSpare_1343.cv_arg") -> "NonSpare_1343":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

class Item_605(Item):
    cv_arg: TypeAlias = NonSpare_1343.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1343

    @classmethod
    def create(cls, arg : "Item_605.cv_arg") -> "Item_605":
        return cls._create(arg) # type: ignore

class NonSpare_1290(NonSpare):
    cv_arg: TypeAlias = RuleVariation_591.cv_arg
    cv_name = "MIS"
    cv_title = "Mission Code"
    cv_rule: TypeAlias = RuleVariation_591

    @classmethod
    def create(cls, arg : "NonSpare_1290.cv_arg") -> "NonSpare_1290":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_591:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_602:
        return self.rule.variation

class Item_557(Item):
    cv_arg: TypeAlias = NonSpare_1290.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1290

    @classmethod
    def create(cls, arg : "Item_557.cv_arg") -> "Item_557":
        return cls._create(arg) # type: ignore

class Variation_1005(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_593.cv_arg, Tuple[Literal["PIN"], RuleVariation_593.cv_arg]], int, Union[RuleVariation_546.cv_arg, Tuple[Literal["NAV"], RuleVariation_546.cv_arg]], Union[RuleVariation_684.cv_arg, Tuple[Literal["NAT"], RuleVariation_684.cv_arg]], int, Union[RuleVariation_591.cv_arg, Tuple[Literal["MIS"], RuleVariation_591.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1005.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_685, 14), (Item_1, 2), (Item_609, 1), (Item_605, 5), (Item_1, 2), (Item_557, 6)]
    cv_items_dict = {"PIN": RuleVariation_593, "NAV": RuleVariation_546, "NAT": RuleVariation_684, "MIS": RuleVariation_591}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAV"]) -> RuleVariation_546:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAT"]) -> RuleVariation_684:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIS"]) -> RuleVariation_591:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NAV"], Literal["NAT"], Literal["MIS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    def get_item(self, key : Literal["NAV"]) -> RuleVariation_546:
        ...
    @overload
    def get_item(self, key : Literal["NAT"]) -> RuleVariation_684:
        ...
    @overload
    def get_item(self, key : Literal["MIS"]) -> RuleVariation_591:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1005.cv_arg") -> 'Variation_1005':
        return cls._create(arg) # type: ignore

class RuleVariation_975(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1005.cv_arg
    cv_variation: TypeAlias = Variation_1005

    @classmethod
    def create(cls, arg : "RuleVariation_975.cv_arg") -> "RuleVariation_975":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1005:
        return self.arg # type: ignore

class NonSpare_1435(NonSpare):
    cv_arg: TypeAlias = RuleVariation_975.cv_arg
    cv_name = "PMN"
    cv_title = "PIN/ National Origin/Mission Code"
    cv_rule: TypeAlias = RuleVariation_975

    @classmethod
    def create(cls, arg : "NonSpare_1435.cv_arg") -> "NonSpare_1435":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_975:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1005:
        return self.rule.variation

class Content_697(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_697(RuleContentContextFree):
    cv_arg: TypeAlias = Content_697.cv_arg
    cv_content: TypeAlias = Content_697

    @property
    def content(self) -> Content_697:
        return self._get_content() # type: ignore

class Variation_362(Element):
    cv_arg: TypeAlias = RuleContent_697.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_697

    @classmethod
    def create(cls, arg: "Variation_362.cv_arg") -> "Variation_362":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_697:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_697:
        return self.rule.content

class RuleVariation_355(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_362.cv_arg
    cv_variation: TypeAlias = Variation_362

    @classmethod
    def create(cls, arg : "RuleVariation_355.cv_arg") -> "RuleVariation_355":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_362:
        return self.arg # type: ignore

class NonSpare_1156(NonSpare):
    cv_arg: TypeAlias = RuleVariation_355.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude in WGS 84"
    cv_rule: TypeAlias = RuleVariation_355

    @classmethod
    def create(cls, arg : "NonSpare_1156.cv_arg") -> "NonSpare_1156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_355:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_362:
        return self.rule.variation

class Item_468(Item):
    cv_arg: TypeAlias = NonSpare_1156.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1156

    @classmethod
    def create(cls, arg : "Item_468.cv_arg") -> "Item_468":
        return cls._create(arg) # type: ignore

class Content_696(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 2.1457672119140625e-5
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_696(RuleContentContextFree):
    cv_arg: TypeAlias = Content_696.cv_arg
    cv_content: TypeAlias = Content_696

    @property
    def content(self) -> Content_696:
        return self._get_content() # type: ignore

class Variation_361(Element):
    cv_arg: TypeAlias = RuleContent_696.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_696

    @classmethod
    def create(cls, arg: "Variation_361.cv_arg") -> "Variation_361":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_696:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_696:
        return self.rule.content

class RuleVariation_354(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_361.cv_arg
    cv_variation: TypeAlias = Variation_361

    @classmethod
    def create(cls, arg : "RuleVariation_354.cv_arg") -> "RuleVariation_354":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_361:
        return self.arg # type: ignore

class NonSpare_1186(NonSpare):
    cv_arg: TypeAlias = RuleVariation_354.cv_arg
    cv_name = "LON"
    cv_title = "Longitude in WGS 84"
    cv_rule: TypeAlias = RuleVariation_354

    @classmethod
    def create(cls, arg : "NonSpare_1186.cv_arg") -> "NonSpare_1186":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_354:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_361:
        return self.rule.variation

class Item_496(Item):
    cv_arg: TypeAlias = NonSpare_1186.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1186

    @classmethod
    def create(cls, arg : "Item_496.cv_arg") -> "Item_496":
        return cls._create(arg) # type: ignore

class Variation_1132(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_355.cv_arg, Tuple[Literal["LAT"], RuleVariation_355.cv_arg]], Union[RuleVariation_354.cv_arg, Tuple[Literal["LON"], RuleVariation_354.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1132.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_468, 24), (Item_496, 24)]
    cv_items_dict = {"LAT": RuleVariation_355, "LON": RuleVariation_354}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_355:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_354:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_355:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_354:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1132.cv_arg") -> 'Variation_1132':
        return cls._create(arg) # type: ignore

class RuleVariation_1088(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1132.cv_arg
    cv_variation: TypeAlias = Variation_1132

    @classmethod
    def create(cls, arg : "RuleVariation_1088.cv_arg") -> "RuleVariation_1088":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1132:
        return self.arg # type: ignore

class NonSpare_1447(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1088.cv_arg
    cv_name = "POS"
    cv_title = "Mode 5 Reported Position"
    cv_rule: TypeAlias = RuleVariation_1088

    @classmethod
    def create(cls, arg : "NonSpare_1447.cv_arg") -> "NonSpare_1447":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1088:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1132:
        return self.rule.variation

class Content_219(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "GA reported in 100 ft increments", 1: "GA reported in 25 ft increments"}

class RuleContent_219(RuleContentContextFree):
    cv_arg: TypeAlias = Content_219.cv_arg
    cv_content: TypeAlias = Content_219

    @property
    def content(self) -> Content_219:
        return self._get_content() # type: ignore

class Variation_427(Element):
    cv_arg: TypeAlias = RuleContent_219.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_219

    @classmethod
    def create(cls, arg: "Variation_427.cv_arg") -> "Variation_427":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_219:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_219:
        return self.rule.content

class RuleVariation_416(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_427.cv_arg
    cv_variation: TypeAlias = Variation_427

    @classmethod
    def create(cls, arg : "RuleVariation_416.cv_arg") -> "RuleVariation_416":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_427:
        return self.arg # type: ignore

class NonSpare_1582(NonSpare):
    cv_arg: TypeAlias = RuleVariation_416.cv_arg
    cv_name = "RES"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_416

    @classmethod
    def create(cls, arg : "NonSpare_1582.cv_arg") -> "NonSpare_1582":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_416:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_427:
        return self.rule.variation

class Item_807(Item):
    cv_arg: TypeAlias = NonSpare_1582.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1582

    @classmethod
    def create(cls, arg : "Item_807.cv_arg") -> "Item_807":
        return cls._create(arg) # type: ignore

class Content_637(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_637(RuleContentContextFree):
    cv_arg: TypeAlias = Content_637.cv_arg
    cv_content: TypeAlias = Content_637

    @property
    def content(self) -> Content_637:
        return self._get_content() # type: ignore

class Variation_607(Element):
    cv_arg: TypeAlias = RuleContent_637.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_637

    @classmethod
    def create(cls, arg: "Variation_607.cv_arg") -> "Variation_607":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_637:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_637:
        return self.rule.content

class RuleVariation_596(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_607.cv_arg
    cv_variation: TypeAlias = Variation_607

    @classmethod
    def create(cls, arg : "RuleVariation_596.cv_arg") -> "RuleVariation_596":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_607:
        return self.arg # type: ignore

class NonSpare_1013(NonSpare):
    cv_arg: TypeAlias = RuleVariation_596.cv_arg
    cv_name = "GA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_596

    @classmethod
    def create(cls, arg : "NonSpare_1013.cv_arg") -> "NonSpare_1013":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_596:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_607:
        return self.rule.variation

class Item_358(Item):
    cv_arg: TypeAlias = NonSpare_1013.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1013

    @classmethod
    def create(cls, arg : "Item_358.cv_arg") -> "Item_358":
        return cls._create(arg) # type: ignore

class Variation_999(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_416.cv_arg, Tuple[Literal["RES"], RuleVariation_416.cv_arg]], Union[RuleVariation_596.cv_arg, Tuple[Literal["GA"], RuleVariation_596.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_999.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_807, 1), (Item_358, 14)]
    cv_items_dict = {"RES": RuleVariation_416, "GA": RuleVariation_596}

    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> RuleVariation_596:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RES"], Literal["GA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_416:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> RuleVariation_596:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_999.cv_arg") -> 'Variation_999':
        return cls._create(arg) # type: ignore

class RuleVariation_969(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_999.cv_arg
    cv_variation: TypeAlias = Variation_999

    @classmethod
    def create(cls, arg : "RuleVariation_969.cv_arg") -> "RuleVariation_969":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_999:
        return self.arg # type: ignore

class NonSpare_1016(NonSpare):
    cv_arg: TypeAlias = RuleVariation_969.cv_arg
    cv_name = "GA"
    cv_title = "Mode 5 GNSS-derived Altitude"
    cv_rule: TypeAlias = RuleVariation_969

    @classmethod
    def create(cls, arg : "NonSpare_1016.cv_arg") -> "NonSpare_1016":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_969:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_999:
        return self.rule.variation

class Content_55(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Code not validated", 1: "Code validated"}

class RuleContent_55(RuleContentContextFree):
    cv_arg: TypeAlias = Content_55.cv_arg
    cv_content: TypeAlias = Content_55

    @property
    def content(self) -> Content_55:
        return self._get_content() # type: ignore

class Variation_14(Element):
    cv_arg: TypeAlias = RuleContent_55.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_55

    @classmethod
    def create(cls, arg: "Variation_14.cv_arg") -> "Variation_14":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_55:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_55:
        return self.rule.content

class RuleVariation_14(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_14.cv_arg
    cv_variation: TypeAlias = Variation_14

    @classmethod
    def create(cls, arg : "RuleVariation_14.cv_arg") -> "RuleVariation_14":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_14:
        return self.arg # type: ignore

class NonSpare_1989(NonSpare):
    cv_arg: TypeAlias = RuleVariation_14.cv_arg
    cv_name = "V"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_14

    @classmethod
    def create(cls, arg : "NonSpare_1989.cv_arg") -> "NonSpare_1989":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_14:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_14:
        return self.rule.variation

class Item_1101(Item):
    cv_arg: TypeAlias = NonSpare_1989.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1989

    @classmethod
    def create(cls, arg : "Item_1101.cv_arg") -> "Item_1101":
        return cls._create(arg) # type: ignore

class Content_271(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 1 Code derived from the reply of the transponder", 1: "Mode 1 Code not extracted during the last scan"}

class RuleContent_271(RuleContentContextFree):
    cv_arg: TypeAlias = Content_271.cv_arg
    cv_content: TypeAlias = Content_271

    @property
    def content(self) -> Content_271:
        return self._get_content() # type: ignore

class Variation_543(Element):
    cv_arg: TypeAlias = RuleContent_271.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_271

    @classmethod
    def create(cls, arg: "Variation_543.cv_arg") -> "Variation_543":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_271:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_271:
        return self.rule.content

class RuleVariation_532(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_543.cv_arg
    cv_variation: TypeAlias = Variation_543

    @classmethod
    def create(cls, arg : "RuleVariation_532.cv_arg") -> "RuleVariation_532":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_543:
        return self.arg # type: ignore

class NonSpare_1131(NonSpare):
    cv_arg: TypeAlias = RuleVariation_532.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_532

    @classmethod
    def create(cls, arg : "NonSpare_1131.cv_arg") -> "NonSpare_1131":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_532:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_543:
        return self.rule.variation

class Item_443(Item):
    cv_arg: TypeAlias = NonSpare_1131.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1131

    @classmethod
    def create(cls, arg : "Item_443.cv_arg") -> "Item_443":
        return cls._create(arg) # type: ignore

class Variation_1250(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_14.cv_arg, Tuple[Literal["V"], RuleVariation_14.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_532.cv_arg, Tuple[Literal["L"], RuleVariation_532.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["EM1"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1250.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1101, 1), (Item_355, 1), (Item_443, 1), (Item_16, 1), (Item_290, 12)]
    cv_items_dict = {"V": RuleVariation_14, "G": RuleVariation_396, "L": RuleVariation_532, "EM1": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_14:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_532:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["EM1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_14:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_532:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1250.cv_arg") -> 'Variation_1250':
        return cls._create(arg) # type: ignore

class RuleVariation_1179(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1250.cv_arg
    cv_variation: TypeAlias = Variation_1250

    @classmethod
    def create(cls, arg : "RuleVariation_1179.cv_arg") -> "RuleVariation_1179":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1250:
        return self.arg # type: ignore

class NonSpare_926(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1179.cv_arg
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1179

    @classmethod
    def create(cls, arg : "NonSpare_926.cv_arg") -> "NonSpare_926":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1179:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1250:
        return self.rule.variation

class Variation_238(Element):
    cv_arg: TypeAlias = RuleContent_769.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_769

    @classmethod
    def create(cls, arg: "Variation_238.cv_arg") -> "Variation_238":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_769:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_770:
        return self.rule.content

class RuleVariation_231(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_238.cv_arg
    cv_variation: TypeAlias = Variation_238

    @classmethod
    def create(cls, arg : "RuleVariation_231.cv_arg") -> "RuleVariation_231":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_238:
        return self.arg # type: ignore

class NonSpare_1887(NonSpare):
    cv_arg: TypeAlias = RuleVariation_231.cv_arg
    cv_name = "TOS"
    cv_title = "Time Offset for POS and GA"
    cv_rule: TypeAlias = RuleVariation_231

    @classmethod
    def create(cls, arg : "NonSpare_1887.cv_arg") -> "NonSpare_1887":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_231:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_238:
        return self.rule.variation

class NonSpare_2119(NonSpare):
    cv_arg: TypeAlias = RuleVariation_573.cv_arg
    cv_name = "XP"
    cv_title = "X-pulse from Mode 5 PIN Reply/Report"
    cv_rule: TypeAlias = RuleVariation_573

    @classmethod
    def create(cls, arg : "NonSpare_2119.cv_arg") -> "NonSpare_2119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_573:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_584:
        return self.rule.variation

class Item_1217(Item):
    cv_arg: TypeAlias = NonSpare_2119.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2119

    @classmethod
    def create(cls, arg : "Item_1217.cv_arg") -> "Item_1217":
        return cls._create(arg) # type: ignore

class Content_566(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-pulse set to zero or no Mode 2 reply", 1: "X-pulse set to one (present)"}

class RuleContent_566(RuleContentContextFree):
    cv_arg: TypeAlias = Content_566.cv_arg
    cv_content: TypeAlias = Content_566

    @property
    def content(self) -> Content_566:
        return self._get_content() # type: ignore

class Variation_959(Element):
    cv_arg: TypeAlias = RuleContent_566.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_566

    @classmethod
    def create(cls, arg: "Variation_959.cv_arg") -> "Variation_959":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_566:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_566:
        return self.rule.content

class RuleVariation_929(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_959.cv_arg
    cv_variation: TypeAlias = Variation_959

    @classmethod
    def create(cls, arg : "RuleVariation_929.cv_arg") -> "RuleVariation_929":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_959:
        return self.arg # type: ignore

class NonSpare_2109(NonSpare):
    cv_arg: TypeAlias = RuleVariation_929.cv_arg
    cv_name = "X2"
    cv_title = "X-pulse from Mode 2 Reply"
    cv_rule: TypeAlias = RuleVariation_929

    @classmethod
    def create(cls, arg : "NonSpare_2109.cv_arg") -> "NonSpare_2109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_929:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_959:
        return self.rule.variation

class Item_1210(Item):
    cv_arg: TypeAlias = NonSpare_2109.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2109

    @classmethod
    def create(cls, arg : "Item_1210.cv_arg") -> "Item_1210":
        return cls._create(arg) # type: ignore

class Variation_1010(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_573.cv_arg, Tuple[Literal["XP"], RuleVariation_573.cv_arg]], Union[RuleVariation_663.cv_arg, Tuple[Literal["X5"], RuleVariation_663.cv_arg]], Union[RuleVariation_751.cv_arg, Tuple[Literal["XC"], RuleVariation_751.cv_arg]], Union[RuleVariation_846.cv_arg, Tuple[Literal["X3"], RuleVariation_846.cv_arg]], Union[RuleVariation_929.cv_arg, Tuple[Literal["X2"], RuleVariation_929.cv_arg]], Union[RuleVariation_960.cv_arg, Tuple[Literal["X1"], RuleVariation_960.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1010.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1, 2), (Item_1217, 1), (Item_1213, 1), (Item_1216, 1), (Item_1212, 1), (Item_1210, 1), (Item_1206, 1)]
    cv_items_dict = {"XP": RuleVariation_573, "X5": RuleVariation_663, "XC": RuleVariation_751, "X3": RuleVariation_846, "X2": RuleVariation_929, "X1": RuleVariation_960}

    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> RuleVariation_573:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X5"]) -> RuleVariation_663:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_751:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X3"]) -> RuleVariation_846:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_929:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_960:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["XP"], Literal["X5"], Literal["XC"], Literal["X3"], Literal["X2"], Literal["X1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["XP"]) -> RuleVariation_573:
        ...
    @overload
    def get_item(self, key : Literal["X5"]) -> RuleVariation_663:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_751:
        ...
    @overload
    def get_item(self, key : Literal["X3"]) -> RuleVariation_846:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_929:
        ...
    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_960:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1010.cv_arg") -> 'Variation_1010':
        return cls._create(arg) # type: ignore

class RuleVariation_980(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1010.cv_arg
    cv_variation: TypeAlias = Variation_1010

    @classmethod
    def create(cls, arg : "RuleVariation_980.cv_arg") -> "RuleVariation_980":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1010:
        return self.arg # type: ignore

class NonSpare_2116(NonSpare):
    cv_arg: TypeAlias = RuleVariation_980.cv_arg
    cv_name = "XP"
    cv_title = "X Pulse Presence"
    cv_rule: TypeAlias = RuleVariation_980

    @classmethod
    def create(cls, arg : "NonSpare_2116.cv_arg") -> "NonSpare_2116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_980:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1010:
        return self.rule.variation

class Variation_1511(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SUM": NonSpare_1810.cv_arg,
        "PMN": NonSpare_1435.cv_arg,
        "POS": NonSpare_1447.cv_arg,
        "GA": NonSpare_1016.cv_arg,
        "EM1": NonSpare_926.cv_arg,
        "TOS": NonSpare_1887.cv_arg,
        "XP": NonSpare_2116.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1810, NonSpare_1435, NonSpare_1447, NonSpare_1016, NonSpare_926, NonSpare_1887, NonSpare_2116]
    cv_items_dict = {"SUM": NonSpare_1810, "PMN": NonSpare_1435, "POS": NonSpare_1447, "GA": NonSpare_1016, "EM1": NonSpare_926, "TOS": NonSpare_1887, "XP": NonSpare_2116}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1810:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PMN"]) -> NonSpare_1435:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1447:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> NonSpare_1016:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_926:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOS"]) -> NonSpare_1887:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2116:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PMN"], Literal["POS"], Literal["GA"], Literal["EM1"], Literal["TOS"], Literal["XP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1810]:
        ...
    @overload
    def get_item(self, key : Literal["PMN"]) -> Optional[NonSpare_1435]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1447]:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> Optional[NonSpare_1016]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_926]:
        ...
    @overload
    def get_item(self, key : Literal["TOS"]) -> Optional[NonSpare_1887]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2116]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1810.cv_arg) -> "Variation_1511":
        ...
    @overload
    def set_item(self, key : Literal["PMN"], val : NonSpare_1435.cv_arg) -> "Variation_1511":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1447.cv_arg) -> "Variation_1511":
        ...
    @overload
    def set_item(self, key : Literal["GA"], val : NonSpare_1016.cv_arg) -> "Variation_1511":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_926.cv_arg) -> "Variation_1511":
        ...
    @overload
    def set_item(self, key : Literal["TOS"], val : NonSpare_1887.cv_arg) -> "Variation_1511":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2116.cv_arg) -> "Variation_1511":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1511":
        ...
    @overload
    def del_item(self, key : Literal["PMN"]) -> "Variation_1511":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1511":
        ...
    @overload
    def del_item(self, key : Literal["GA"]) -> "Variation_1511":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1511":
        ...
    @overload
    def del_item(self, key : Literal["TOS"]) -> "Variation_1511":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1511":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1511.cv_arg") -> 'Variation_1511':
        return cls._create(arg) # type: ignore

class RuleVariation_1432(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1511.cv_arg
    cv_variation: TypeAlias = Variation_1511

    @classmethod
    def create(cls, arg : "RuleVariation_1432.cv_arg") -> "RuleVariation_1432":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1511:
        return self.arg # type: ignore

class NonSpare_1250(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1432.cv_arg
    cv_name = "MD5"
    cv_title = "Mode 5 Reports"
    cv_rule: TypeAlias = RuleVariation_1432

    @classmethod
    def create(cls, arg : "NonSpare_1250.cv_arg") -> "NonSpare_1250":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1432:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1511:
        return self.rule.variation

class NonSpare_1811(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1097.cv_arg
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule: TypeAlias = RuleVariation_1097

    @classmethod
    def create(cls, arg : "NonSpare_1811.cv_arg") -> "NonSpare_1811":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1097:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1141:
        return self.rule.variation

class Variation_736(Element):
    cv_arg: TypeAlias = RuleContent_302.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_302

    @classmethod
    def create(cls, arg: "Variation_736.cv_arg") -> "Variation_736":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_302:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_302:
        return self.rule.content

class RuleVariation_725(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_736.cv_arg
    cv_variation: TypeAlias = Variation_736

    @classmethod
    def create(cls, arg : "RuleVariation_725.cv_arg") -> "RuleVariation_725":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_736:
        return self.arg # type: ignore

class NonSpare_1378(NonSpare):
    cv_arg: TypeAlias = RuleVariation_725.cv_arg
    cv_name = "NOV"
    cv_title = "Validity of NO"
    cv_rule: TypeAlias = RuleVariation_725

    @classmethod
    def create(cls, arg : "NonSpare_1378.cv_arg") -> "NonSpare_1378":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_725:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_736:
        return self.rule.variation

class Item_638(Item):
    cv_arg: TypeAlias = NonSpare_1378.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1378

    @classmethod
    def create(cls, arg : "Item_638.cv_arg") -> "Item_638":
        return cls._create(arg) # type: ignore

class NonSpare_1360(NonSpare):
    cv_arg: TypeAlias = RuleVariation_864.cv_arg
    cv_name = "NO"
    cv_title = "National Origin"
    cv_rule: TypeAlias = RuleVariation_864

    @classmethod
    def create(cls, arg : "NonSpare_1360.cv_arg") -> "NonSpare_1360":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_864:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_894:
        return self.rule.variation

class Item_620(Item):
    cv_arg: TypeAlias = NonSpare_1360.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1360

    @classmethod
    def create(cls, arg : "Item_620.cv_arg") -> "Item_620":
        return cls._create(arg) # type: ignore

class Variation_1007(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_593.cv_arg, Tuple[Literal["PIN"], RuleVariation_593.cv_arg]], int, Union[RuleVariation_725.cv_arg, Tuple[Literal["NOV"], RuleVariation_725.cv_arg]], Union[RuleVariation_864.cv_arg, Tuple[Literal["NO"], RuleVariation_864.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1007.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_685, 14), (Item_3, 4), (Item_638, 1), (Item_620, 11)]
    cv_items_dict = {"PIN": RuleVariation_593, "NOV": RuleVariation_725, "NO": RuleVariation_864}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOV"]) -> RuleVariation_725:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NO"]) -> RuleVariation_864:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NOV"], Literal["NO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    def get_item(self, key : Literal["NOV"]) -> RuleVariation_725:
        ...
    @overload
    def get_item(self, key : Literal["NO"]) -> RuleVariation_864:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1007.cv_arg") -> 'Variation_1007':
        return cls._create(arg) # type: ignore

class RuleVariation_977(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1007.cv_arg
    cv_variation: TypeAlias = Variation_1007

    @classmethod
    def create(cls, arg : "RuleVariation_977.cv_arg") -> "RuleVariation_977":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1007:
        return self.arg # type: ignore

class NonSpare_1436(NonSpare):
    cv_arg: TypeAlias = RuleVariation_977.cv_arg
    cv_name = "PMN"
    cv_title = "PIN/ National Origin/Mission Code"
    cv_rule: TypeAlias = RuleVariation_977

    @classmethod
    def create(cls, arg : "NonSpare_1436.cv_arg") -> "NonSpare_1436":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_977:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1007:
        return self.rule.variation

class NonSpare_1446(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1088.cv_arg
    cv_name = "POS"
    cv_title = "Mode 5 Reported Position"
    cv_rule: TypeAlias = RuleVariation_1088

    @classmethod
    def create(cls, arg : "NonSpare_1446.cv_arg") -> "NonSpare_1446":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1088:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1132:
        return self.rule.variation

class NonSpare_1583(NonSpare):
    cv_arg: TypeAlias = RuleVariation_416.cv_arg
    cv_name = "RES"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_416

    @classmethod
    def create(cls, arg : "NonSpare_1583.cv_arg") -> "NonSpare_1583":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_416:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_427:
        return self.rule.variation

class Item_808(Item):
    cv_arg: TypeAlias = NonSpare_1583.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1583

    @classmethod
    def create(cls, arg : "Item_808.cv_arg") -> "Item_808":
        return cls._create(arg) # type: ignore

class NonSpare_1014(NonSpare):
    cv_arg: TypeAlias = RuleVariation_596.cv_arg
    cv_name = "GA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_596

    @classmethod
    def create(cls, arg : "NonSpare_1014.cv_arg") -> "NonSpare_1014":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_596:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_607:
        return self.rule.variation

class Item_359(Item):
    cv_arg: TypeAlias = NonSpare_1014.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1014

    @classmethod
    def create(cls, arg : "Item_359.cv_arg") -> "Item_359":
        return cls._create(arg) # type: ignore

class Variation_1000(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_416.cv_arg, Tuple[Literal["RES"], RuleVariation_416.cv_arg]], Union[RuleVariation_596.cv_arg, Tuple[Literal["GA"], RuleVariation_596.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1000.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_808, 1), (Item_359, 14)]
    cv_items_dict = {"RES": RuleVariation_416, "GA": RuleVariation_596}

    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> RuleVariation_596:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RES"], Literal["GA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_416:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> RuleVariation_596:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1000.cv_arg") -> 'Variation_1000':
        return cls._create(arg) # type: ignore

class RuleVariation_970(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1000.cv_arg
    cv_variation: TypeAlias = Variation_1000

    @classmethod
    def create(cls, arg : "RuleVariation_970.cv_arg") -> "RuleVariation_970":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1000:
        return self.arg # type: ignore

class NonSpare_1017(NonSpare):
    cv_arg: TypeAlias = RuleVariation_970.cv_arg
    cv_name = "GA"
    cv_title = "Mode 5 GNSS-derived Altitude"
    cv_rule: TypeAlias = RuleVariation_970

    @classmethod
    def create(cls, arg : "NonSpare_1017.cv_arg") -> "NonSpare_1017":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_970:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1000:
        return self.rule.variation

class NonSpare_982(NonSpare):
    cv_arg: TypeAlias = RuleVariation_684.cv_arg
    cv_name = "FOM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_684

    @classmethod
    def create(cls, arg : "NonSpare_982.cv_arg") -> "NonSpare_982":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

class Item_336(Item):
    cv_arg: TypeAlias = NonSpare_982.cv_arg
    cv_non_spare: TypeAlias = NonSpare_982

    @classmethod
    def create(cls, arg : "Item_336.cv_arg") -> "Item_336":
        return cls._create(arg) # type: ignore

class Variation_1013(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_684.cv_arg, Tuple[Literal["FOM"], RuleVariation_684.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1013.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_336, 5)]
    cv_items_dict = {"FOM": RuleVariation_684}

    @classmethod
    def spec(cls, key : Literal["FOM"]) -> RuleVariation_684:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["FOM"]) -> RuleVariation_684:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1013.cv_arg") -> 'Variation_1013':
        return cls._create(arg) # type: ignore

class RuleVariation_983(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1013.cv_arg
    cv_variation: TypeAlias = Variation_1013

    @classmethod
    def create(cls, arg : "RuleVariation_983.cv_arg") -> "RuleVariation_983":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1013:
        return self.arg # type: ignore

class NonSpare_984(NonSpare):
    cv_arg: TypeAlias = RuleVariation_983.cv_arg
    cv_name = "FOM"
    cv_title = "Figure of Merit"
    cv_rule: TypeAlias = RuleVariation_983

    @classmethod
    def create(cls, arg : "NonSpare_984.cv_arg") -> "NonSpare_984":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_983:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1013:
        return self.rule.variation

class Variation_1512(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SUM": NonSpare_1811.cv_arg,
        "PMN": NonSpare_1436.cv_arg,
        "POS": NonSpare_1446.cv_arg,
        "GA": NonSpare_1017.cv_arg,
        "EM1": NonSpare_926.cv_arg,
        "TOS": NonSpare_1887.cv_arg,
        "XP": NonSpare_2116.cv_arg,
        "FOM": NonSpare_984.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1811, NonSpare_1436, NonSpare_1446, NonSpare_1017, NonSpare_926, NonSpare_1887, NonSpare_2116, NonSpare_984]
    cv_items_dict = {"SUM": NonSpare_1811, "PMN": NonSpare_1436, "POS": NonSpare_1446, "GA": NonSpare_1017, "EM1": NonSpare_926, "TOS": NonSpare_1887, "XP": NonSpare_2116, "FOM": NonSpare_984}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1811:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PMN"]) -> NonSpare_1436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1446:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> NonSpare_1017:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_926:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOS"]) -> NonSpare_1887:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FOM"]) -> NonSpare_984:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PMN"], Literal["POS"], Literal["GA"], Literal["EM1"], Literal["TOS"], Literal["XP"], Literal["FOM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1811]:
        ...
    @overload
    def get_item(self, key : Literal["PMN"]) -> Optional[NonSpare_1436]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1446]:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> Optional[NonSpare_1017]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_926]:
        ...
    @overload
    def get_item(self, key : Literal["TOS"]) -> Optional[NonSpare_1887]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2116]:
        ...
    @overload
    def get_item(self, key : Literal["FOM"]) -> Optional[NonSpare_984]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1811.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["PMN"], val : NonSpare_1436.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1446.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["GA"], val : NonSpare_1017.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_926.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["TOS"], val : NonSpare_1887.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2116.cv_arg) -> "Variation_1512":
        ...
    @overload
    def set_item(self, key : Literal["FOM"], val : NonSpare_984.cv_arg) -> "Variation_1512":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["PMN"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["GA"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["TOS"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1512":
        ...
    @overload
    def del_item(self, key : Literal["FOM"]) -> "Variation_1512":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1512.cv_arg") -> 'Variation_1512':
        return cls._create(arg) # type: ignore

class RuleVariation_1433(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1512.cv_arg
    cv_variation: TypeAlias = Variation_1512

    @classmethod
    def create(cls, arg : "RuleVariation_1433.cv_arg") -> "RuleVariation_1433":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1512:
        return self.arg # type: ignore

class NonSpare_1220(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1433.cv_arg
    cv_name = "M5N"
    cv_title = "Mode 5 Reports, New Format"
    cv_rule: TypeAlias = RuleVariation_1433

    @classmethod
    def create(cls, arg : "NonSpare_1220.cv_arg") -> "NonSpare_1220":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1433:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1512:
        return self.rule.variation

class Content_310(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Mode 4 interrogation", 1: "Possibly friendly target", 2: "Probably friendly target", 3: "Friendly target"}

class RuleContent_310(RuleContentContextFree):
    cv_arg: TypeAlias = Content_310.cv_arg
    cv_content: TypeAlias = Content_310

    @property
    def content(self) -> Content_310:
        return self._get_content() # type: ignore

class Variation_881(Element):
    cv_arg: TypeAlias = RuleContent_310.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_310

    @classmethod
    def create(cls, arg: "Variation_881.cv_arg") -> "Variation_881":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_310:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_310:
        return self.rule.content

class RuleVariation_851(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_881.cv_arg
    cv_variation: TypeAlias = Variation_881

    @classmethod
    def create(cls, arg : "RuleVariation_851.cv_arg") -> "RuleVariation_851":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_881:
        return self.arg # type: ignore

class NonSpare_981(NonSpare):
    cv_arg: TypeAlias = RuleVariation_851.cv_arg
    cv_name = "FOEFRI"
    cv_title = "Indication Foe/Friend (Mode4)"
    cv_rule: TypeAlias = RuleVariation_851

    @classmethod
    def create(cls, arg : "NonSpare_981.cv_arg") -> "NonSpare_981":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_851:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_881:
        return self.rule.variation

class Item_335(Item):
    cv_arg: TypeAlias = NonSpare_981.cv_arg
    cv_non_spare: TypeAlias = NonSpare_981

    @classmethod
    def create(cls, arg : "Item_335.cv_arg") -> "Item_335":
        return cls._create(arg) # type: ignore

class Variation_1346(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[int, Union[RuleVariation_851.cv_arg, Tuple[Literal["FOEFRI"], RuleVariation_851.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1346.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_4, 5), (Item_335, 2), None]]

    @classmethod
    def create(cls, arg: "Variation_1346.cv_arg") -> 'Variation_1346':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["FOEFRI"]) -> RuleVariation_851:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1267(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1346.cv_arg
    cv_variation: TypeAlias = Variation_1346

    @classmethod
    def create(cls, arg : "RuleVariation_1267.cv_arg") -> "RuleVariation_1267":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1346:
        return self.arg # type: ignore

class NonSpare_1218(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1267.cv_arg
    cv_name = "M4E"
    cv_title = "Extended Mode 4 Report"
    cv_rule: TypeAlias = RuleVariation_1267

    @classmethod
    def create(cls, arg : "NonSpare_1218.cv_arg") -> "NonSpare_1218":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1267:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1346:
        return self.rule.variation

class NonSpare_1672(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "SCO"
    cv_title = "Score"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1672.cv_arg") -> "NonSpare_1672":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Content_735(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["dB"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "dB"

    def as_quantity(self, cv_unit : Optional[Literal["dB"]] = None) -> float:
        return self._as_quantity()

class RuleContent_735(RuleContentContextFree):
    cv_arg: TypeAlias = Content_735.cv_arg
    cv_content: TypeAlias = Content_735

    @property
    def content(self) -> Content_735:
        return self._get_content() # type: ignore

class Variation_313(Element):
    cv_arg: TypeAlias = RuleContent_735.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_735

    @classmethod
    def create(cls, arg: "Variation_313.cv_arg") -> "Variation_313":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_735:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_735:
        return self.rule.content

class RuleVariation_306(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_313.cv_arg
    cv_variation: TypeAlias = Variation_313

    @classmethod
    def create(cls, arg : "RuleVariation_306.cv_arg") -> "RuleVariation_306":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_313:
        return self.arg # type: ignore

class NonSpare_1749(NonSpare):
    cv_arg: TypeAlias = RuleVariation_306.cv_arg
    cv_name = "SRC"
    cv_title = "Signal/Clutter Ratio"
    cv_rule: TypeAlias = RuleVariation_306

    @classmethod
    def create(cls, arg : "NonSpare_1749.cv_arg") -> "NonSpare_1749":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_306:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_313:
        return self.rule.variation

class Content_776(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_775(RuleContentContextFree):
    cv_arg: TypeAlias = Content_776.cv_arg
    cv_content: TypeAlias = Content_776

    @property
    def content(self) -> Content_776:
        return self._get_content() # type: ignore

class Variation_337(Element):
    cv_arg: TypeAlias = RuleContent_775.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_775

    @classmethod
    def create(cls, arg: "Variation_337.cv_arg") -> "Variation_337":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_775:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_776:
        return self.rule.content

class RuleVariation_330(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_337.cv_arg
    cv_variation: TypeAlias = Variation_337

    @classmethod
    def create(cls, arg : "RuleVariation_330.cv_arg") -> "RuleVariation_330":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_337:
        return self.arg # type: ignore

class NonSpare_1642(NonSpare):
    cv_arg: TypeAlias = RuleVariation_330.cv_arg
    cv_name = "RW"
    cv_title = "Range Width"
    cv_rule: TypeAlias = RuleVariation_330

    @classmethod
    def create(cls, arg : "NonSpare_1642.cv_arg") -> "NonSpare_1642":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_330:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_337:
        return self.rule.variation

class NonSpare_623(NonSpare):
    cv_arg: TypeAlias = RuleVariation_330.cv_arg
    cv_name = "AR"
    cv_title = "Ambiguous Range"
    cv_rule: TypeAlias = RuleVariation_330

    @classmethod
    def create(cls, arg : "NonSpare_623.cv_arg") -> "NonSpare_623":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_330:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_337:
        return self.rule.variation

class Variation_1505(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SCO": NonSpare_1672.cv_arg,
        "SRC": NonSpare_1749.cv_arg,
        "RW": NonSpare_1642.cv_arg,
        "AR": NonSpare_623.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1672, NonSpare_1749, NonSpare_1642, NonSpare_623]
    cv_items_dict = {"SCO": NonSpare_1672, "SRC": NonSpare_1749, "RW": NonSpare_1642, "AR": NonSpare_623}

    @overload
    @classmethod
    def spec(cls, key : Literal["SCO"]) -> NonSpare_1672:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRC"]) -> NonSpare_1749:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RW"]) -> NonSpare_1642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AR"]) -> NonSpare_623:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SCO"], Literal["SRC"], Literal["RW"], Literal["AR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SCO"]) -> Optional[NonSpare_1672]:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> Optional[NonSpare_1749]:
        ...
    @overload
    def get_item(self, key : Literal["RW"]) -> Optional[NonSpare_1642]:
        ...
    @overload
    def get_item(self, key : Literal["AR"]) -> Optional[NonSpare_623]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SCO"], val : NonSpare_1672.cv_arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["SRC"], val : NonSpare_1749.cv_arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["RW"], val : NonSpare_1642.cv_arg) -> "Variation_1505":
        ...
    @overload
    def set_item(self, key : Literal["AR"], val : NonSpare_623.cv_arg) -> "Variation_1505":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SCO"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["SRC"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["RW"]) -> "Variation_1505":
        ...
    @overload
    def del_item(self, key : Literal["AR"]) -> "Variation_1505":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1505.cv_arg") -> 'Variation_1505':
        return cls._create(arg) # type: ignore

class RuleVariation_1426(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1505.cv_arg
    cv_variation: TypeAlias = Variation_1505

    @classmethod
    def create(cls, arg : "RuleVariation_1426.cv_arg") -> "RuleVariation_1426":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1505:
        return self.arg # type: ignore

class NonSpare_1604(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1426.cv_arg
    cv_name = "RPC"
    cv_title = "Radar Plot Characteristics"
    cv_rule: TypeAlias = RuleVariation_1426

    @classmethod
    def create(cls, arg : "NonSpare_1604.cv_arg") -> "NonSpare_1604":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1426:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1505:
        return self.rule.variation

class Content_775(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_774(RuleContentContextFree):
    cv_arg: TypeAlias = Content_775.cv_arg
    cv_content: TypeAlias = Content_775

    @property
    def content(self) -> Content_775:
        return self._get_content() # type: ignore

class Variation_372(Element):
    cv_arg: TypeAlias = RuleContent_774.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_rule = RuleContent_774

    @classmethod
    def create(cls, arg: "Variation_372.cv_arg") -> "Variation_372":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_774:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_775:
        return self.rule.content

class RuleVariation_365(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_372.cv_arg
    cv_variation: TypeAlias = Variation_372

    @classmethod
    def create(cls, arg : "RuleVariation_365.cv_arg") -> "RuleVariation_365":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_372:
        return self.arg # type: ignore

class NonSpare_959(NonSpare):
    cv_arg: TypeAlias = RuleVariation_365.cv_arg
    cv_name = "ERR"
    cv_title = "Extended Range Report"
    cv_rule: TypeAlias = RuleVariation_365

    @classmethod
    def create(cls, arg : "NonSpare_959.cv_arg") -> "NonSpare_959":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_365:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_372:
        return self.rule.variation

class Content_512(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Track is not associated with an SCN Plot", 1: "Track is associated with an SCN Plot"}

class RuleContent_512(RuleContentContextFree):
    cv_arg: TypeAlias = Content_512.cv_arg
    cv_content: TypeAlias = Content_512

    @property
    def content(self) -> Content_512:
        return self._get_content() # type: ignore

class Variation_666(Element):
    cv_arg: TypeAlias = RuleContent_512.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_512

    @classmethod
    def create(cls, arg: "Variation_666.cv_arg") -> "Variation_666":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_512:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_512:
        return self.rule.content

class RuleVariation_655(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_666.cv_arg
    cv_variation: TypeAlias = Variation_666

    @classmethod
    def create(cls, arg : "RuleVariation_655.cv_arg") -> "RuleVariation_655":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_666:
        return self.arg # type: ignore

class NonSpare_1671(NonSpare):
    cv_arg: TypeAlias = RuleVariation_655.cv_arg
    cv_name = "SCN"
    cv_title = "Track / SCN Association"
    cv_rule: TypeAlias = RuleVariation_655

    @classmethod
    def create(cls, arg : "NonSpare_1671.cv_arg") -> "NonSpare_1671":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_655:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_666:
        return self.rule.variation

class Item_866(Item):
    cv_arg: TypeAlias = NonSpare_1671.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1671

    @classmethod
    def create(cls, arg : "Item_866.cv_arg") -> "Item_866":
        return cls._create(arg) # type: ignore

class Content_38(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Associated Plot does not contain a Roll Call component", 1: "Associated Plot contains at least a Roll Call component"}

class RuleContent_38(RuleContentContextFree):
    cv_arg: TypeAlias = Content_38.cv_arg
    cv_content: TypeAlias = Content_38

    @property
    def content(self) -> Content_38:
        return self._get_content() # type: ignore

class Variation_701(Element):
    cv_arg: TypeAlias = RuleContent_38.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_38

    @classmethod
    def create(cls, arg: "Variation_701.cv_arg") -> "Variation_701":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_38:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_38:
        return self.rule.content

class RuleVariation_690(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_701.cv_arg
    cv_variation: TypeAlias = Variation_701

    @classmethod
    def create(cls, arg : "RuleVariation_690.cv_arg") -> "RuleVariation_690":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_701:
        return self.arg # type: ignore

class NonSpare_1554(NonSpare):
    cv_arg: TypeAlias = RuleVariation_690.cv_arg
    cv_name = "RC"
    cv_title = "Roll Call Component"
    cv_rule: TypeAlias = RuleVariation_690

    @classmethod
    def create(cls, arg : "NonSpare_1554.cv_arg") -> "NonSpare_1554":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_690:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_701:
        return self.rule.variation

class Item_782(Item):
    cv_arg: TypeAlias = NonSpare_1554.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1554

    @classmethod
    def create(cls, arg : "Item_782.cv_arg") -> "Item_782":
        return cls._create(arg) # type: ignore

class Content_39(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Associated Plot does not contain an All Call component", 1: "Associated Plot contains at least an All Call component"}

class RuleContent_39(RuleContentContextFree):
    cv_arg: TypeAlias = Content_39.cv_arg
    cv_content: TypeAlias = Content_39

    @property
    def content(self) -> Content_39:
        return self._get_content() # type: ignore

class Variation_823(Element):
    cv_arg: TypeAlias = RuleContent_39.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_39

    @classmethod
    def create(cls, arg: "Variation_823.cv_arg") -> "Variation_823":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_39:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_39:
        return self.rule.content

class RuleVariation_793(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_823.cv_arg
    cv_variation: TypeAlias = Variation_823

    @classmethod
    def create(cls, arg : "RuleVariation_793.cv_arg") -> "RuleVariation_793":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_823:
        return self.arg # type: ignore

class NonSpare_557(NonSpare):
    cv_arg: TypeAlias = RuleVariation_793.cv_arg
    cv_name = "AC"
    cv_title = "All Call Component"
    cv_rule: TypeAlias = RuleVariation_793

    @classmethod
    def create(cls, arg : "NonSpare_557.cv_arg") -> "NonSpare_557":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_793:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_823:
        return self.rule.variation

class Item_39(Item):
    cv_arg: TypeAlias = NonSpare_557.cv_arg
    cv_non_spare: TypeAlias = NonSpare_557

    @classmethod
    def create(cls, arg : "Item_39.cv_arg") -> "Item_39":
        return cls._create(arg) # type: ignore

class Content_40(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Associated Plot does not contain an SSR component", 1: "Associated Plot contains at least an SSR component"}

class RuleContent_40(RuleContentContextFree):
    cv_arg: TypeAlias = Content_40.cv_arg
    cv_content: TypeAlias = Content_40

    @property
    def content(self) -> Content_40:
        return self._get_content() # type: ignore

class Variation_903(Element):
    cv_arg: TypeAlias = RuleContent_40.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_40

    @classmethod
    def create(cls, arg: "Variation_903.cv_arg") -> "Variation_903":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_40:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_40:
        return self.rule.content

class RuleVariation_873(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_903.cv_arg
    cv_variation: TypeAlias = Variation_903

    @classmethod
    def create(cls, arg : "RuleVariation_873.cv_arg") -> "RuleVariation_873":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_903:
        return self.arg # type: ignore

class NonSpare_1763(NonSpare):
    cv_arg: TypeAlias = RuleVariation_873.cv_arg
    cv_name = "SSR"
    cv_title = "SSR Component"
    cv_rule: TypeAlias = RuleVariation_873

    @classmethod
    def create(cls, arg : "NonSpare_1763.cv_arg") -> "NonSpare_1763":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_873:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_903:
        return self.rule.variation

class Item_930(Item):
    cv_arg: TypeAlias = NonSpare_1763.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1763

    @classmethod
    def create(cls, arg : "Item_930.cv_arg") -> "Item_930":
        return cls._create(arg) # type: ignore

class Content_37(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Associated Plot does not contain a PSR component", 1: "Associated Plot contains at least a PSR component"}

class RuleContent_37(RuleContentContextFree):
    cv_arg: TypeAlias = Content_37.cv_arg
    cv_content: TypeAlias = Content_37

    @property
    def content(self) -> Content_37:
        return self._get_content() # type: ignore

class Variation_973(Element):
    cv_arg: TypeAlias = RuleContent_37.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_37

    @classmethod
    def create(cls, arg: "Variation_973.cv_arg") -> "Variation_973":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_37:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_37:
        return self.rule.content

class RuleVariation_943(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_973.cv_arg
    cv_variation: TypeAlias = Variation_973

    @classmethod
    def create(cls, arg : "RuleVariation_943.cv_arg") -> "RuleVariation_943":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_973:
        return self.arg # type: ignore

class NonSpare_1477(NonSpare):
    cv_arg: TypeAlias = RuleVariation_943.cv_arg
    cv_name = "PSR"
    cv_title = "PSR Component"
    cv_rule: TypeAlias = RuleVariation_943

    @classmethod
    def create(cls, arg : "NonSpare_1477.cv_arg") -> "NonSpare_1477":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_943:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_973:
        return self.rule.variation

class Item_715(Item):
    cv_arg: TypeAlias = NonSpare_1477.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1477

    @classmethod
    def create(cls, arg : "Item_715.cv_arg") -> "Item_715":
        return cls._create(arg) # type: ignore

class NonSpare_1433(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "PLOTNR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1433.cv_arg") -> "NonSpare_1433":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_687(Item):
    cv_arg: TypeAlias = NonSpare_1433.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1433

    @classmethod
    def create(cls, arg : "Item_687.cv_arg") -> "Item_687":
        return cls._create(arg) # type: ignore

class Variation_1016(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_655.cv_arg, Tuple[Literal["SCN"], RuleVariation_655.cv_arg]], Union[RuleVariation_690.cv_arg, Tuple[Literal["RC"], RuleVariation_690.cv_arg]], Union[RuleVariation_793.cv_arg, Tuple[Literal["AC"], RuleVariation_793.cv_arg]], Union[RuleVariation_873.cv_arg, Tuple[Literal["SSR"], RuleVariation_873.cv_arg]], Union[RuleVariation_943.cv_arg, Tuple[Literal["PSR"], RuleVariation_943.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["PLOTNR"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1016.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_2, 3), (Item_866, 1), (Item_782, 1), (Item_39, 1), (Item_930, 1), (Item_715, 1), (Item_687, 16)]
    cv_items_dict = {"SCN": RuleVariation_655, "RC": RuleVariation_690, "AC": RuleVariation_793, "SSR": RuleVariation_873, "PSR": RuleVariation_943, "PLOTNR": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["SCN"]) -> RuleVariation_655:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RC"]) -> RuleVariation_690:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_793:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> RuleVariation_873:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> RuleVariation_943:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PLOTNR"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SCN"], Literal["RC"], Literal["AC"], Literal["SSR"], Literal["PSR"], Literal["PLOTNR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SCN"]) -> RuleVariation_655:
        ...
    @overload
    def get_item(self, key : Literal["RC"]) -> RuleVariation_690:
        ...
    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_793:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> RuleVariation_873:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> RuleVariation_943:
        ...
    @overload
    def get_item(self, key : Literal["PLOTNR"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1016.cv_arg") -> 'Variation_1016':
        return cls._create(arg) # type: ignore

class RuleVariation_986(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1016.cv_arg
    cv_variation: TypeAlias = Variation_1016

    @classmethod
    def create(cls, arg : "RuleVariation_986.cv_arg") -> "RuleVariation_986":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1016:
        return self.arg # type: ignore

class NonSpare_1483(NonSpare):
    cv_arg: TypeAlias = RuleVariation_986.cv_arg
    cv_name = "PTL"
    cv_title = "Plot/Track Link"
    cv_rule: TypeAlias = RuleVariation_986

    @classmethod
    def create(cls, arg : "NonSpare_1483.cv_arg") -> "NonSpare_1483":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_986:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1016:
        return self.rule.variation

class Variation_1397(Repetitive):
    cv_arg: TypeAlias = List[Variation_253.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_253

    @classmethod
    def create(cls, arg: "Variation_1397.cv_arg") -> 'Variation_1397':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_253]:
        return self._get_list() # type: ignore

class RuleVariation_1318(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1397.cv_arg
    cv_variation: TypeAlias = Variation_1397

    @classmethod
    def create(cls, arg : "RuleVariation_1318.cv_arg") -> "RuleVariation_1318":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1397:
        return self.arg # type: ignore

class NonSpare_642(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1318.cv_arg
    cv_name = "ATL"
    cv_title = "ADS-B/Track Link"
    cv_rule: TypeAlias = RuleVariation_1318

    @classmethod
    def create(cls, arg : "NonSpare_642.cv_arg") -> "NonSpare_642":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1318:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1397:
        return self.rule.variation

class Content_711(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["%"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "%"

    def as_quantity(self, cv_unit : Optional[Literal["%"]] = None) -> float:
        return self._as_quantity()

class RuleContent_711(RuleContentContextFree):
    cv_arg: TypeAlias = Content_711.cv_arg
    cv_content: TypeAlias = Content_711

    @property
    def content(self) -> Content_711:
        return self._get_content() # type: ignore

class Variation_221(Element):
    cv_arg: TypeAlias = RuleContent_711.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_711

    @classmethod
    def create(cls, arg: "Variation_221.cv_arg") -> "Variation_221":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_711:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_711:
        return self.rule.content

class RuleVariation_214(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_221.cv_arg
    cv_variation: TypeAlias = Variation_221

    @classmethod
    def create(cls, arg : "RuleVariation_214.cv_arg") -> "RuleVariation_214":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_221:
        return self.arg # type: ignore

class NonSpare_1922(NonSpare):
    cv_arg: TypeAlias = RuleVariation_214.cv_arg
    cv_name = "TRN"
    cv_title = "Turn State"
    cv_rule: TypeAlias = RuleVariation_214

    @classmethod
    def create(cls, arg : "NonSpare_1922.cv_arg") -> "NonSpare_1922":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_214:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_221:
        return self.rule.variation

class Content_766(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 7.8125e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_765(RuleContentContextFree):
    cv_arg: TypeAlias = Content_766.cv_arg
    cv_content: TypeAlias = Content_766

    @property
    def content(self) -> Content_766:
        return self._get_content() # type: ignore

class Variation_330(Element):
    cv_arg: TypeAlias = RuleContent_765.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_765

    @classmethod
    def create(cls, arg: "Variation_330.cv_arg") -> "Variation_330":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_765:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_766:
        return self.rule.content

class RuleVariation_323(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_330.cv_arg
    cv_variation: TypeAlias = Variation_330

    @classmethod
    def create(cls, arg : "RuleVariation_323.cv_arg") -> "RuleVariation_323":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_330:
        return self.arg # type: ignore

class NonSpare_1459(NonSpare):
    cv_arg: TypeAlias = RuleVariation_323.cv_arg
    cv_name = "PREDRHO"
    cv_title = "Predicted Range"
    cv_rule: TypeAlias = RuleVariation_323

    @classmethod
    def create(cls, arg : "NonSpare_1459.cv_arg") -> "NonSpare_1459":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_330:
        return self.rule.variation

class Item_702(Item):
    cv_arg: TypeAlias = NonSpare_1459.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1459

    @classmethod
    def create(cls, arg : "Item_702.cv_arg") -> "Item_702":
        return cls._create(arg) # type: ignore

class NonSpare_1460(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "PREDTHETA"
    cv_title = "Predicted Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1460.cv_arg") -> "NonSpare_1460":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_703(Item):
    cv_arg: TypeAlias = NonSpare_1460.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1460

    @classmethod
    def create(cls, arg : "Item_703.cv_arg") -> "Item_703":
        return cls._create(arg) # type: ignore

class NonSpare_965(NonSpare):
    cv_arg: TypeAlias = RuleVariation_323.cv_arg
    cv_name = "EVOLRHOSTART"
    cv_title = "Predicted Closest Range"
    cv_rule: TypeAlias = RuleVariation_323

    @classmethod
    def create(cls, arg : "NonSpare_965.cv_arg") -> "NonSpare_965":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_330:
        return self.rule.variation

class Item_323(Item):
    cv_arg: TypeAlias = NonSpare_965.cv_arg
    cv_non_spare: TypeAlias = NonSpare_965

    @classmethod
    def create(cls, arg : "Item_323.cv_arg") -> "Item_323":
        return cls._create(arg) # type: ignore

class NonSpare_964(NonSpare):
    cv_arg: TypeAlias = RuleVariation_323.cv_arg
    cv_name = "EVOLRHOEND"
    cv_title = "Predicted Largest Range"
    cv_rule: TypeAlias = RuleVariation_323

    @classmethod
    def create(cls, arg : "NonSpare_964.cv_arg") -> "NonSpare_964":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_330:
        return self.rule.variation

class Item_322(Item):
    cv_arg: TypeAlias = NonSpare_964.cv_arg
    cv_non_spare: TypeAlias = NonSpare_964

    @classmethod
    def create(cls, arg : "Item_322.cv_arg") -> "Item_322":
        return cls._create(arg) # type: ignore

class NonSpare_967(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "EVOLTHETASTART"
    cv_title = "Predicted Smallest Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_967.cv_arg") -> "NonSpare_967":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_325(Item):
    cv_arg: TypeAlias = NonSpare_967.cv_arg
    cv_non_spare: TypeAlias = NonSpare_967

    @classmethod
    def create(cls, arg : "Item_325.cv_arg") -> "Item_325":
        return cls._create(arg) # type: ignore

class NonSpare_966(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "EVOLTHETAEND"
    cv_title = "Predicted Largest Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_966.cv_arg") -> "NonSpare_966":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_324(Item):
    cv_arg: TypeAlias = NonSpare_966.cv_arg
    cv_non_spare: TypeAlias = NonSpare_966

    @classmethod
    def create(cls, arg : "Item_324.cv_arg") -> "Item_324":
        return cls._create(arg) # type: ignore

class NonSpare_1373(NonSpare):
    cv_arg: TypeAlias = RuleVariation_323.cv_arg
    cv_name = "NOISERHOSTART"
    cv_title = "Predicted Closest Range"
    cv_rule: TypeAlias = RuleVariation_323

    @classmethod
    def create(cls, arg : "NonSpare_1373.cv_arg") -> "NonSpare_1373":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_330:
        return self.rule.variation

class Item_633(Item):
    cv_arg: TypeAlias = NonSpare_1373.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1373

    @classmethod
    def create(cls, arg : "Item_633.cv_arg") -> "Item_633":
        return cls._create(arg) # type: ignore

class NonSpare_1372(NonSpare):
    cv_arg: TypeAlias = RuleVariation_323.cv_arg
    cv_name = "NOISERHOEND"
    cv_title = "Predicted Largest Range"
    cv_rule: TypeAlias = RuleVariation_323

    @classmethod
    def create(cls, arg : "NonSpare_1372.cv_arg") -> "NonSpare_1372":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_323:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_330:
        return self.rule.variation

class Item_632(Item):
    cv_arg: TypeAlias = NonSpare_1372.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1372

    @classmethod
    def create(cls, arg : "Item_632.cv_arg") -> "Item_632":
        return cls._create(arg) # type: ignore

class NonSpare_1375(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "NOISETHETASTART"
    cv_title = "Predicted Smallest Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1375.cv_arg") -> "NonSpare_1375":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_635(Item):
    cv_arg: TypeAlias = NonSpare_1375.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1375

    @classmethod
    def create(cls, arg : "Item_635.cv_arg") -> "Item_635":
        return cls._create(arg) # type: ignore

class NonSpare_1374(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "NOISETHETAEND"
    cv_title = "Predicted Largest Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1374.cv_arg") -> "NonSpare_1374":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_634(Item):
    cv_arg: TypeAlias = NonSpare_1374.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1374

    @classmethod
    def create(cls, arg : "Item_634.cv_arg") -> "Item_634":
        return cls._create(arg) # type: ignore

class NonSpare_1461(NonSpare):
    cv_arg: TypeAlias = RuleVariation_327.cv_arg
    cv_name = "PREDTIME"
    cv_title = "Predicted Detection Time"
    cv_rule: TypeAlias = RuleVariation_327

    @classmethod
    def create(cls, arg : "NonSpare_1461.cv_arg") -> "NonSpare_1461":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

class Item_704(Item):
    cv_arg: TypeAlias = NonSpare_1461.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1461

    @classmethod
    def create(cls, arg : "Item_704.cv_arg") -> "Item_704":
        return cls._create(arg) # type: ignore

class Variation_1161(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_323.cv_arg, Tuple[Literal["PREDRHO"], RuleVariation_323.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["PREDTHETA"], RuleVariation_336.cv_arg]], Union[RuleVariation_323.cv_arg, Tuple[Literal["EVOLRHOSTART"], RuleVariation_323.cv_arg]], Union[RuleVariation_323.cv_arg, Tuple[Literal["EVOLRHOEND"], RuleVariation_323.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["EVOLTHETASTART"], RuleVariation_336.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["EVOLTHETAEND"], RuleVariation_336.cv_arg]], Union[RuleVariation_323.cv_arg, Tuple[Literal["NOISERHOSTART"], RuleVariation_323.cv_arg]], Union[RuleVariation_323.cv_arg, Tuple[Literal["NOISERHOEND"], RuleVariation_323.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["NOISETHETASTART"], RuleVariation_336.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["NOISETHETAEND"], RuleVariation_336.cv_arg]], Union[RuleVariation_327.cv_arg, Tuple[Literal["PREDTIME"], RuleVariation_327.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1161.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 176
    cv_items_list = [(Item_702, 16), (Item_703, 16), (Item_323, 16), (Item_322, 16), (Item_325, 16), (Item_324, 16), (Item_633, 16), (Item_632, 16), (Item_635, 16), (Item_634, 16), (Item_704, 16)]
    cv_items_dict = {"PREDRHO": RuleVariation_323, "PREDTHETA": RuleVariation_336, "EVOLRHOSTART": RuleVariation_323, "EVOLRHOEND": RuleVariation_323, "EVOLTHETASTART": RuleVariation_336, "EVOLTHETAEND": RuleVariation_336, "NOISERHOSTART": RuleVariation_323, "NOISERHOEND": RuleVariation_323, "NOISETHETASTART": RuleVariation_336, "NOISETHETAEND": RuleVariation_336, "PREDTIME": RuleVariation_327}

    @overload
    @classmethod
    def spec(cls, key : Literal["PREDRHO"]) -> RuleVariation_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PREDTHETA"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLRHOSTART"]) -> RuleVariation_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLRHOEND"]) -> RuleVariation_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLTHETASTART"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EVOLTHETAEND"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISERHOSTART"]) -> RuleVariation_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISERHOEND"]) -> RuleVariation_323:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISETHETASTART"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NOISETHETAEND"]) -> RuleVariation_336:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PREDTIME"]) -> RuleVariation_327:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PREDRHO"], Literal["PREDTHETA"], Literal["EVOLRHOSTART"], Literal["EVOLRHOEND"], Literal["EVOLTHETASTART"], Literal["EVOLTHETAEND"], Literal["NOISERHOSTART"], Literal["NOISERHOEND"], Literal["NOISETHETASTART"], Literal["NOISETHETAEND"], Literal["PREDTIME"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PREDRHO"]) -> RuleVariation_323:
        ...
    @overload
    def get_item(self, key : Literal["PREDTHETA"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["EVOLRHOSTART"]) -> RuleVariation_323:
        ...
    @overload
    def get_item(self, key : Literal["EVOLRHOEND"]) -> RuleVariation_323:
        ...
    @overload
    def get_item(self, key : Literal["EVOLTHETASTART"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["EVOLTHETAEND"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["NOISERHOSTART"]) -> RuleVariation_323:
        ...
    @overload
    def get_item(self, key : Literal["NOISERHOEND"]) -> RuleVariation_323:
        ...
    @overload
    def get_item(self, key : Literal["NOISETHETASTART"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["NOISETHETAEND"]) -> RuleVariation_336:
        ...
    @overload
    def get_item(self, key : Literal["PREDTIME"]) -> RuleVariation_327:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1161.cv_arg") -> 'Variation_1161':
        return cls._create(arg) # type: ignore

class RuleVariation_1112(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1161.cv_arg
    cv_variation: TypeAlias = Variation_1161

    @classmethod
    def create(cls, arg : "RuleVariation_1112.cv_arg") -> "RuleVariation_1112":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1161:
        return self.arg # type: ignore

class NonSpare_1379(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1112.cv_arg
    cv_name = "NPP"
    cv_title = "Next Predicted Position"
    cv_rule: TypeAlias = RuleVariation_1112

    @classmethod
    def create(cls, arg : "NonSpare_1379.cv_arg") -> "NonSpare_1379":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1112:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1161:
        return self.rule.variation

class Content_460(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Surveillance Mode A (alert bit or periodic)", 1: "Comm-A", 2: "Ground Initiated Comm-B", 3: "Air Initiated Comm-B", 4: "Broadcast Comm-B", 5: "Comm-C", 6: "Comm-D", 7: "Reserved for future use", 8: "Reserved for future use", 9: "Reserved for future use", 10: "Reserved for future use", 11: "Reserved for future use", 12: "Reserved for future use", 13: "Reserved for future use", 14: "Reserved for future use", 15: "Reserved for future use"}

class RuleContent_460(RuleContentContextFree):
    cv_arg: TypeAlias = Content_460.cv_arg
    cv_content: TypeAlias = Content_460

    @property
    def content(self) -> Content_460:
        return self._get_content() # type: ignore

class Variation_134(Element):
    cv_arg: TypeAlias = RuleContent_460.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_460

    @classmethod
    def create(cls, arg: "Variation_134.cv_arg") -> "Variation_134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_460:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_460:
        return self.rule.content

class RuleVariation_134(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_134.cv_arg
    cv_variation: TypeAlias = Variation_134

    @classmethod
    def create(cls, arg : "RuleVariation_134.cv_arg") -> "RuleVariation_134":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_134:
        return self.arg # type: ignore

class NonSpare_1971(NonSpare):
    cv_arg: TypeAlias = RuleVariation_134.cv_arg
    cv_name = "TYPE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_134

    @classmethod
    def create(cls, arg : "NonSpare_1971.cv_arg") -> "NonSpare_1971":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_134:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_134:
        return self.rule.variation

class Item_1084(Item):
    cv_arg: TypeAlias = NonSpare_1971.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1971

    @classmethod
    def create(cls, arg : "Item_1084.cv_arg") -> "Item_1084":
        return cls._create(arg) # type: ignore

class Content_218(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "From previous scan", 1: "New in current scan", 2: "Requested in the beam by transponder", 3: "Invalid ASTERIX value"}

class RuleContent_218(RuleContentContextFree):
    cv_arg: TypeAlias = Content_218.cv_arg
    cv_content: TypeAlias = Content_218

    @property
    def content(self) -> Content_218:
        return self._get_content() # type: ignore

class Variation_764(Element):
    cv_arg: TypeAlias = RuleContent_218.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_218

    @classmethod
    def create(cls, arg: "Variation_764.cv_arg") -> "Variation_764":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_218:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_218:
        return self.rule.content

class RuleVariation_753(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_764.cv_arg
    cv_variation: TypeAlias = Variation_764

    @classmethod
    def create(cls, arg : "RuleVariation_753.cv_arg") -> "RuleVariation_753":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_764:
        return self.arg # type: ignore

class NonSpare_1404(NonSpare):
    cv_arg: TypeAlias = RuleVariation_753.cv_arg
    cv_name = "ORIGIN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_753

    @classmethod
    def create(cls, arg : "NonSpare_1404.cv_arg") -> "NonSpare_1404":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_753:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_764:
        return self.rule.variation

class Item_663(Item):
    cv_arg: TypeAlias = NonSpare_1404.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1404

    @classmethod
    def create(cls, arg : "Item_663.cv_arg") -> "Item_663":
        return cls._create(arg) # type: ignore

class Content_242(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "In progress", 1: "Completed", 2: "Cancelled", 3: "Invalid ASTERIX value"}

class RuleContent_242(RuleContentContextFree):
    cv_arg: TypeAlias = Content_242.cv_arg
    cv_content: TypeAlias = Content_242

    @property
    def content(self) -> Content_242:
        return self._get_content() # type: ignore

class Variation_960(Element):
    cv_arg: TypeAlias = RuleContent_242.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_242

    @classmethod
    def create(cls, arg: "Variation_960.cv_arg") -> "Variation_960":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_242:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_242:
        return self.rule.content

class RuleVariation_930(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_960.cv_arg
    cv_variation: TypeAlias = Variation_960

    @classmethod
    def create(cls, arg : "RuleVariation_930.cv_arg") -> "RuleVariation_930":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_960:
        return self.arg # type: ignore

class NonSpare_1785(NonSpare):
    cv_arg: TypeAlias = RuleVariation_930.cv_arg
    cv_name = "STATE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_930

    @classmethod
    def create(cls, arg : "NonSpare_1785.cv_arg") -> "NonSpare_1785":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_930:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_960:
        return self.rule.variation

class Item_946(Item):
    cv_arg: TypeAlias = NonSpare_1785.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1785

    @classmethod
    def create(cls, arg : "Item_946.cv_arg") -> "Item_946":
        return cls._create(arg) # type: ignore

class Variation_1243(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_134.cv_arg, Tuple[Literal["TYPE"], RuleVariation_134.cv_arg]], Union[RuleVariation_753.cv_arg, Tuple[Literal["ORIGIN"], RuleVariation_753.cv_arg]], Union[RuleVariation_930.cv_arg, Tuple[Literal["STATE"], RuleVariation_930.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1243.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1084, 4), (Item_663, 2), (Item_946, 2)]
    cv_items_dict = {"TYPE": RuleVariation_134, "ORIGIN": RuleVariation_753, "STATE": RuleVariation_930}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_134:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ORIGIN"]) -> RuleVariation_753:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STATE"]) -> RuleVariation_930:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["ORIGIN"], Literal["STATE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_134:
        ...
    @overload
    def get_item(self, key : Literal["ORIGIN"]) -> RuleVariation_753:
        ...
    @overload
    def get_item(self, key : Literal["STATE"]) -> RuleVariation_930:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1243.cv_arg") -> 'Variation_1243':
        return cls._create(arg) # type: ignore

class Variation_1445(Repetitive):
    cv_arg: TypeAlias = List[Variation_1243.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1243

    @classmethod
    def create(cls, arg: "Variation_1445.cv_arg") -> 'Variation_1445':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1243]:
        return self._get_list() # type: ignore

class RuleVariation_1366(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1445.cv_arg
    cv_variation: TypeAlias = Variation_1445

    @classmethod
    def create(cls, arg : "RuleVariation_1366.cv_arg") -> "RuleVariation_1366":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1445:
        return self.arg # type: ignore

class NonSpare_888(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1366.cv_arg
    cv_name = "DLK"
    cv_title = "Data Link Characteristics"
    cv_rule: TypeAlias = RuleVariation_1366

    @classmethod
    def create(cls, arg : "NonSpare_888.cv_arg") -> "NonSpare_888":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1366:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1445:
        return self.rule.variation

class Content_483(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Target not locked out by this radar", 1: "Target locked out by this radar"}

class RuleContent_483(RuleContentContextFree):
    cv_arg: TypeAlias = Content_483.cv_arg
    cv_content: TypeAlias = Content_483

    @property
    def content(self) -> Content_483:
        return self._get_content() # type: ignore

class Variation_84(Element):
    cv_arg: TypeAlias = RuleContent_483.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_483

    @classmethod
    def create(cls, arg: "Variation_84.cv_arg") -> "Variation_84":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_483:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_483:
        return self.rule.content

class RuleVariation_84(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_84.cv_arg
    cv_variation: TypeAlias = Variation_84

    @classmethod
    def create(cls, arg : "RuleVariation_84.cv_arg") -> "RuleVariation_84":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_84:
        return self.arg # type: ignore

class NonSpare_1198(NonSpare):
    cv_arg: TypeAlias = RuleVariation_84.cv_arg
    cv_name = "LS"
    cv_title = "Lockout State"
    cv_rule: TypeAlias = RuleVariation_84

    @classmethod
    def create(cls, arg : "NonSpare_1198.cv_arg") -> "NonSpare_1198":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_84:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_84:
        return self.rule.variation

class Item_506(Item):
    cv_arg: TypeAlias = NonSpare_1198.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1198

    @classmethod
    def create(cls, arg : "Item_506.cv_arg") -> "Item_506":
        return cls._create(arg) # type: ignore

class Content_722(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ms"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "ms"

    def as_quantity(self, cv_unit : Optional[Literal["ms"]] = None) -> float:
        return self._as_quantity()

class RuleContent_722(RuleContentContextFree):
    cv_arg: TypeAlias = Content_722.cv_arg
    cv_content: TypeAlias = Content_722

    @property
    def content(self) -> Content_722:
        return self._get_content() # type: ignore

class Variation_503(Element):
    cv_arg: TypeAlias = RuleContent_722.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_722

    @classmethod
    def create(cls, arg: "Variation_503.cv_arg") -> "Variation_503":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_722:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_722:
        return self.rule.content

class RuleVariation_492(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_503.cv_arg
    cv_variation: TypeAlias = Variation_503

    @classmethod
    def create(cls, arg : "RuleVariation_492.cv_arg") -> "RuleVariation_492":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_503:
        return self.arg # type: ignore

class NonSpare_1175(NonSpare):
    cv_arg: TypeAlias = RuleVariation_492.cv_arg
    cv_name = "LOCTIM"
    cv_title = "Lockout Time"
    cv_rule: TypeAlias = RuleVariation_492

    @classmethod
    def create(cls, arg : "NonSpare_1175.cv_arg") -> "NonSpare_1175":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_492:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_503:
        return self.rule.variation

class Item_485(Item):
    cv_arg: TypeAlias = NonSpare_1175.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1175

    @classmethod
    def create(cls, arg : "Item_485.cv_arg") -> "Item_485":
        return cls._create(arg) # type: ignore

class Variation_1138(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_84.cv_arg, Tuple[Literal["LS"], RuleVariation_84.cv_arg]], Union[RuleVariation_492.cv_arg, Tuple[Literal["LOCTIM"], RuleVariation_492.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1138.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_506, 1), (Item_485, 15)]
    cv_items_dict = {"LS": RuleVariation_84, "LOCTIM": RuleVariation_492}

    @overload
    @classmethod
    def spec(cls, key : Literal["LS"]) -> RuleVariation_84:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOCTIM"]) -> RuleVariation_492:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LS"], Literal["LOCTIM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LS"]) -> RuleVariation_84:
        ...
    @overload
    def get_item(self, key : Literal["LOCTIM"]) -> RuleVariation_492:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1138.cv_arg") -> 'Variation_1138':
        return cls._create(arg) # type: ignore

class RuleVariation_1094(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1138.cv_arg
    cv_variation: TypeAlias = Variation_1138

    @classmethod
    def create(cls, arg : "RuleVariation_1094.cv_arg") -> "RuleVariation_1094":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1138:
        return self.arg # type: ignore

class NonSpare_1165(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1094.cv_arg
    cv_name = "LCK"
    cv_title = "Lockout Characteristics"
    cv_rule: TypeAlias = RuleVariation_1094

    @classmethod
    def create(cls, arg : "NonSpare_1165.cv_arg") -> "NonSpare_1165":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1094:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1138:
        return self.rule.variation

class Variation_993(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 4
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_993.cv_arg") -> "Variation_993":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_963(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_993.cv_arg
    cv_variation: TypeAlias = Variation_993

    @classmethod
    def create(cls, arg : "RuleVariation_963.cv_arg") -> "RuleVariation_963":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_993:
        return self.arg # type: ignore

class NonSpare_1845(NonSpare):
    cv_arg: TypeAlias = RuleVariation_963.cv_arg
    cv_name = "TCOUNT1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_963

    @classmethod
    def create(cls, arg : "NonSpare_1845.cv_arg") -> "NonSpare_1845":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_963:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_993:
        return self.rule.variation

class Item_984(Item):
    cv_arg: TypeAlias = NonSpare_1845.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1845

    @classmethod
    def create(cls, arg : "Item_984.cv_arg") -> "Item_984":
        return cls._create(arg) # type: ignore

class NonSpare_1842(NonSpare):
    cv_arg: TypeAlias = RuleVariation_684.cv_arg
    cv_name = "TCODE1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_684

    @classmethod
    def create(cls, arg : "NonSpare_1842.cv_arg") -> "NonSpare_1842":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

class Item_981(Item):
    cv_arg: TypeAlias = NonSpare_1842.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1842

    @classmethod
    def create(cls, arg : "Item_981.cv_arg") -> "Item_981":
        return cls._create(arg) # type: ignore

class NonSpare_1846(NonSpare):
    cv_arg: TypeAlias = RuleVariation_137.cv_arg
    cv_name = "TCOUNT2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_137

    @classmethod
    def create(cls, arg : "NonSpare_1846.cv_arg") -> "NonSpare_1846":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_137:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_137:
        return self.rule.variation

class Item_985(Item):
    cv_arg: TypeAlias = NonSpare_1846.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1846

    @classmethod
    def create(cls, arg : "Item_985.cv_arg") -> "Item_985":
        return cls._create(arg) # type: ignore

class NonSpare_1843(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "TCODE2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1843.cv_arg") -> "NonSpare_1843":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_982(Item):
    cv_arg: TypeAlias = NonSpare_1843.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1843

    @classmethod
    def create(cls, arg : "Item_982.cv_arg") -> "Item_982":
        return cls._create(arg) # type: ignore

class NonSpare_1847(NonSpare):
    cv_arg: TypeAlias = RuleVariation_137.cv_arg
    cv_name = "TCOUNT3"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_137

    @classmethod
    def create(cls, arg : "NonSpare_1847.cv_arg") -> "NonSpare_1847":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_137:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_137:
        return self.rule.variation

class Item_986(Item):
    cv_arg: TypeAlias = NonSpare_1847.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1847

    @classmethod
    def create(cls, arg : "Item_986.cv_arg") -> "Item_986":
        return cls._create(arg) # type: ignore

class NonSpare_1844(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "TCODE3"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_1844.cv_arg") -> "NonSpare_1844":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_983(Item):
    cv_arg: TypeAlias = NonSpare_1844.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1844

    @classmethod
    def create(cls, arg : "Item_983.cv_arg") -> "Item_983":
        return cls._create(arg) # type: ignore

class Variation_1043(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_963.cv_arg, Tuple[Literal["TCOUNT1"], RuleVariation_963.cv_arg]], Union[RuleVariation_684.cv_arg, Tuple[Literal["TCODE1"], RuleVariation_684.cv_arg]], Union[RuleVariation_137.cv_arg, Tuple[Literal["TCOUNT2"], RuleVariation_137.cv_arg]], Union[RuleVariation_779.cv_arg, Tuple[Literal["TCODE2"], RuleVariation_779.cv_arg]], Union[RuleVariation_137.cv_arg, Tuple[Literal["TCOUNT3"], RuleVariation_137.cv_arg]], Union[RuleVariation_779.cv_arg, Tuple[Literal["TCODE3"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1043.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_6, 7), (Item_984, 4), (Item_981, 5), (Item_985, 4), (Item_982, 12), (Item_986, 4), (Item_983, 12)]
    cv_items_dict = {"TCOUNT1": RuleVariation_963, "TCODE1": RuleVariation_684, "TCOUNT2": RuleVariation_137, "TCODE2": RuleVariation_779, "TCOUNT3": RuleVariation_137, "TCODE3": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["TCOUNT1"]) -> RuleVariation_963:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCODE1"]) -> RuleVariation_684:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCOUNT2"]) -> RuleVariation_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCODE2"]) -> RuleVariation_779:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCOUNT3"]) -> RuleVariation_137:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCODE3"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TCOUNT1"], Literal["TCODE1"], Literal["TCOUNT2"], Literal["TCODE2"], Literal["TCOUNT3"], Literal["TCODE3"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TCOUNT1"]) -> RuleVariation_963:
        ...
    @overload
    def get_item(self, key : Literal["TCODE1"]) -> RuleVariation_684:
        ...
    @overload
    def get_item(self, key : Literal["TCOUNT2"]) -> RuleVariation_137:
        ...
    @overload
    def get_item(self, key : Literal["TCODE2"]) -> RuleVariation_779:
        ...
    @overload
    def get_item(self, key : Literal["TCOUNT3"]) -> RuleVariation_137:
        ...
    @overload
    def get_item(self, key : Literal["TCODE3"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1043.cv_arg") -> 'Variation_1043':
        return cls._create(arg) # type: ignore

class RuleVariation_1011(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1043.cv_arg
    cv_variation: TypeAlias = Variation_1043

    @classmethod
    def create(cls, arg : "RuleVariation_1011.cv_arg") -> "RuleVariation_1011":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1043:
        return self.arg # type: ignore

class NonSpare_1836(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1011.cv_arg
    cv_name = "TC"
    cv_title = "Transition Code"
    cv_rule: TypeAlias = RuleVariation_1011

    @classmethod
    def create(cls, arg : "NonSpare_1836.cv_arg") -> "NonSpare_1836":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1011:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1043:
        return self.rule.variation

class Content_486(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Tentative Track with One Plot", 1: "Tentative Track with at least Two Plots", 2: "Pre-Confirmed Track", 3: "Confirmed Track"}

class RuleContent_486(RuleContentContextFree):
    cv_arg: TypeAlias = Content_486.cv_arg
    cv_content: TypeAlias = Content_486

    @property
    def content(self) -> Content_486:
        return self._get_content() # type: ignore

class Variation_113(Element):
    cv_arg: TypeAlias = RuleContent_486.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_486

    @classmethod
    def create(cls, arg: "Variation_113.cv_arg") -> "Variation_113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_486:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_486:
        return self.rule.content

class RuleVariation_113(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_113.cv_arg
    cv_variation: TypeAlias = Variation_113

    @classmethod
    def create(cls, arg : "RuleVariation_113.cv_arg") -> "RuleVariation_113":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_113:
        return self.arg # type: ignore

class NonSpare_563(NonSpare):
    cv_arg: TypeAlias = RuleVariation_113.cv_arg
    cv_name = "ACQI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_113

    @classmethod
    def create(cls, arg : "NonSpare_563.cv_arg") -> "NonSpare_563":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_113:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_113:
        return self.rule.variation

class Item_43(Item):
    cv_arg: TypeAlias = NonSpare_563.cv_arg
    cv_non_spare: TypeAlias = NonSpare_563

    @classmethod
    def create(cls, arg : "Item_43.cv_arg") -> "Item_43":
        return cls._create(arg) # type: ignore

class Variation_605(Element):
    cv_arg: TypeAlias = RuleContent_613.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_613

    @classmethod
    def create(cls, arg: "Variation_605.cv_arg") -> "Variation_605":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_613:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_613:
        return self.rule.content

class RuleVariation_594(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_605.cv_arg
    cv_variation: TypeAlias = Variation_605

    @classmethod
    def create(cls, arg : "RuleVariation_594.cv_arg") -> "RuleVariation_594":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_605:
        return self.arg # type: ignore

class NonSpare_1920(NonSpare):
    cv_arg: TypeAlias = RuleVariation_594.cv_arg
    cv_name = "TRKUPDCTR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_594

    @classmethod
    def create(cls, arg : "NonSpare_1920.cv_arg") -> "NonSpare_1920":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_594:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_605:
        return self.rule.variation

class Item_1039(Item):
    cv_arg: TypeAlias = NonSpare_1920.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1920

    @classmethod
    def create(cls, arg : "Item_1039.cv_arg") -> "Item_1039":
        return cls._create(arg) # type: ignore

class Variation_307(Element):
    cv_arg: TypeAlias = RuleContent_722.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_722

    @classmethod
    def create(cls, arg: "Variation_307.cv_arg") -> "Variation_307":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_722:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_722:
        return self.rule.content

class RuleVariation_300(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_307.cv_arg
    cv_variation: TypeAlias = Variation_307

    @classmethod
    def create(cls, arg : "RuleVariation_300.cv_arg") -> "RuleVariation_300":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_307:
        return self.arg # type: ignore

class NonSpare_1146(NonSpare):
    cv_arg: TypeAlias = RuleVariation_300.cv_arg
    cv_name = "LASTTRKUPD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_300

    @classmethod
    def create(cls, arg : "NonSpare_1146.cv_arg") -> "NonSpare_1146":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_300:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_307:
        return self.rule.variation

class Item_458(Item):
    cv_arg: TypeAlias = NonSpare_1146.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1146

    @classmethod
    def create(cls, arg : "Item_458.cv_arg") -> "Item_458":
        return cls._create(arg) # type: ignore

class Variation_1048(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_113.cv_arg, Tuple[Literal["ACQI"], RuleVariation_113.cv_arg]], Union[RuleVariation_594.cv_arg, Tuple[Literal["TRKUPDCTR"], RuleVariation_594.cv_arg]], Union[RuleVariation_300.cv_arg, Tuple[Literal["LASTTRKUPD"], RuleVariation_300.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1048.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_43, 2), (Item_1039, 14), (Item_458, 16)]
    cv_items_dict = {"ACQI": RuleVariation_113, "TRKUPDCTR": RuleVariation_594, "LASTTRKUPD": RuleVariation_300}

    @overload
    @classmethod
    def spec(cls, key : Literal["ACQI"]) -> RuleVariation_113:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRKUPDCTR"]) -> RuleVariation_594:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LASTTRKUPD"]) -> RuleVariation_300:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ACQI"], Literal["TRKUPDCTR"], Literal["LASTTRKUPD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ACQI"]) -> RuleVariation_113:
        ...
    @overload
    def get_item(self, key : Literal["TRKUPDCTR"]) -> RuleVariation_594:
        ...
    @overload
    def get_item(self, key : Literal["LASTTRKUPD"]) -> RuleVariation_300:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1048.cv_arg") -> 'Variation_1048':
        return cls._create(arg) # type: ignore

class RuleVariation_1015(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1048.cv_arg
    cv_variation: TypeAlias = Variation_1048

    @classmethod
    def create(cls, arg : "RuleVariation_1015.cv_arg") -> "RuleVariation_1015":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1048:
        return self.arg # type: ignore

class NonSpare_1873(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1015.cv_arg
    cv_name = "TLC"
    cv_title = "Track Life Cycle"
    cv_rule: TypeAlias = RuleVariation_1015

    @classmethod
    def create(cls, arg : "NonSpare_1873.cv_arg") -> "NonSpare_1873":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1015:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1048:
        return self.rule.variation

class NonSpare_1657(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SACADJS"
    cv_title = "SAC of the Adjacent Sensor"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1657.cv_arg") -> "NonSpare_1657":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_858(Item):
    cv_arg: TypeAlias = NonSpare_1657.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1657

    @classmethod
    def create(cls, arg : "Item_858.cv_arg") -> "Item_858":
        return cls._create(arg) # type: ignore

class NonSpare_1712(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "SICADJS"
    cv_title = "SIC of the Adjacent Sensor"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1712.cv_arg") -> "NonSpare_1712":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_889(Item):
    cv_arg: TypeAlias = NonSpare_1712.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1712

    @classmethod
    def create(cls, arg : "Item_889.cv_arg") -> "Item_889":
        return cls._create(arg) # type: ignore

class NonSpare_1870(NonSpare):
    cv_arg: TypeAlias = RuleVariation_327.cv_arg
    cv_name = "TIMEOFDAYSCN"
    cv_title = "Absolute Timestamp in UTC Provided by the SCN"
    cv_rule: TypeAlias = RuleVariation_327

    @classmethod
    def create(cls, arg : "NonSpare_1870.cv_arg") -> "NonSpare_1870":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_334:
        return self.rule.variation

class Item_1003(Item):
    cv_arg: TypeAlias = NonSpare_1870.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1870

    @classmethod
    def create(cls, arg : "Item_1003.cv_arg") -> "Item_1003":
        return cls._create(arg) # type: ignore

class Content_78(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Data used by Tracker", 1: "Data not used by Tracker", 2: "2-127: Reserved for future use"}

class RuleContent_78(RuleContentContextFree):
    cv_arg: TypeAlias = Content_78.cv_arg
    cv_content: TypeAlias = Content_78

    @property
    def content(self) -> Content_78:
        return self._get_content() # type: ignore

class Variation_151(Element):
    cv_arg: TypeAlias = RuleContent_78.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_78

    @classmethod
    def create(cls, arg: "Variation_151.cv_arg") -> "Variation_151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_78:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_78:
        return self.rule.content

class RuleVariation_151(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_151.cv_arg
    cv_variation: TypeAlias = Variation_151

    @classmethod
    def create(cls, arg : "RuleVariation_151.cv_arg") -> "RuleVariation_151":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_151:
        return self.arg # type: ignore

class NonSpare_861(NonSpare):
    cv_arg: TypeAlias = RuleVariation_151.cv_arg
    cv_name = "DATAUSE"
    cv_title = "Use of Adjacent Sensor Data"
    cv_rule: TypeAlias = RuleVariation_151

    @classmethod
    def create(cls, arg : "NonSpare_861.cv_arg") -> "NonSpare_861":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_151:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_151:
        return self.rule.variation

class Item_240(Item):
    cv_arg: TypeAlias = NonSpare_861.cv_arg
    cv_non_spare: TypeAlias = NonSpare_861

    @classmethod
    def create(cls, arg : "Item_240.cv_arg") -> "Item_240":
        return cls._create(arg) # type: ignore

class Content_73(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "DRN not available", 1: "DRN available"}

class RuleContent_73(RuleContentContextFree):
    cv_arg: TypeAlias = Content_73.cv_arg
    cv_content: TypeAlias = Content_73

    @property
    def content(self) -> Content_73:
        return self._get_content() # type: ignore

class Variation_974(Element):
    cv_arg: TypeAlias = RuleContent_73.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_73

    @classmethod
    def create(cls, arg: "Variation_974.cv_arg") -> "Variation_974":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_73:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_73:
        return self.rule.content

class RuleVariation_944(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_974.cv_arg
    cv_variation: TypeAlias = Variation_974

    @classmethod
    def create(cls, arg : "RuleVariation_944.cv_arg") -> "RuleVariation_944":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_974:
        return self.arg # type: ignore

class NonSpare_901(NonSpare):
    cv_arg: TypeAlias = RuleVariation_944.cv_arg
    cv_name = "DRNA"
    cv_title = "DRN Availability"
    cv_rule: TypeAlias = RuleVariation_944

    @classmethod
    def create(cls, arg : "NonSpare_901.cv_arg") -> "NonSpare_901":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_944:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_974:
        return self.rule.variation

class Item_274(Item):
    cv_arg: TypeAlias = NonSpare_901.cv_arg
    cv_non_spare: TypeAlias = NonSpare_901

    @classmethod
    def create(cls, arg : "Item_274.cv_arg") -> "Item_274":
        return cls._create(arg) # type: ignore

class NonSpare_900(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "DRN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_900.cv_arg") -> "NonSpare_900":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_273(Item):
    cv_arg: TypeAlias = NonSpare_900.cv_arg
    cv_non_spare: TypeAlias = NonSpare_900

    @classmethod
    def create(cls, arg : "Item_273.cv_arg") -> "Item_273":
        return cls._create(arg) # type: ignore

class Variation_1198(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SACADJS"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SICADJS"], RuleVariation_159.cv_arg]], Union[RuleVariation_327.cv_arg, Tuple[Literal["TIMEOFDAYSCN"], RuleVariation_327.cv_arg]], Union[RuleVariation_151.cv_arg, Tuple[Literal["DATAUSE"], RuleVariation_151.cv_arg]], Union[RuleVariation_944.cv_arg, Tuple[Literal["DRNA"], RuleVariation_944.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["DRN"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1198.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_858, 8), (Item_889, 8), (Item_1003, 16), (Item_240, 7), (Item_274, 1), (Item_273, 16)]
    cv_items_dict = {"SACADJS": RuleVariation_159, "SICADJS": RuleVariation_159, "TIMEOFDAYSCN": RuleVariation_327, "DATAUSE": RuleVariation_151, "DRNA": RuleVariation_944, "DRN": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["SACADJS"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SICADJS"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DATAUSE"]) -> RuleVariation_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRNA"]) -> RuleVariation_944:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRN"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SACADJS"], Literal["SICADJS"], Literal["TIMEOFDAYSCN"], Literal["DATAUSE"], Literal["DRNA"], Literal["DRN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SACADJS"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SICADJS"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_327:
        ...
    @overload
    def get_item(self, key : Literal["DATAUSE"]) -> RuleVariation_151:
        ...
    @overload
    def get_item(self, key : Literal["DRNA"]) -> RuleVariation_944:
        ...
    @overload
    def get_item(self, key : Literal["DRN"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1198.cv_arg") -> 'Variation_1198':
        return cls._create(arg) # type: ignore

class Variation_1433(Repetitive):
    cv_arg: TypeAlias = List[Variation_1198.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1198

    @classmethod
    def create(cls, arg: "Variation_1433.cv_arg") -> 'Variation_1433':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1198]:
        return self._get_list() # type: ignore

class RuleVariation_1354(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1433.cv_arg
    cv_variation: TypeAlias = Variation_1433

    @classmethod
    def create(cls, arg : "RuleVariation_1354.cv_arg") -> "RuleVariation_1354":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1433:
        return self.arg # type: ignore

class NonSpare_637(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1354.cv_arg
    cv_name = "ASI"
    cv_title = "Adjacent Sensor Information"
    cv_rule: TypeAlias = RuleVariation_1354

    @classmethod
    def create(cls, arg : "NonSpare_637.cv_arg") -> "NonSpare_637":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1354:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1433:
        return self.rule.variation

class Content_436(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Radar tracker calculation", 1: "Integrated ADS-B", 2: "External ADS-B", 3: "SCN"}

class RuleContent_436(RuleContentContextFree):
    cv_arg: TypeAlias = Content_436.cv_arg
    cv_content: TypeAlias = Content_436

    @property
    def content(self) -> Content_436:
        return self._get_content() # type: ignore

class Variation_176(Element):
    cv_arg: TypeAlias = RuleContent_436.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_436

    @classmethod
    def create(cls, arg: "Variation_176.cv_arg") -> "Variation_176":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_436:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_436:
        return self.rule.content

class RuleVariation_169(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_176.cv_arg
    cv_variation: TypeAlias = Variation_176

    @classmethod
    def create(cls, arg : "RuleVariation_169.cv_arg") -> "RuleVariation_169":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_176:
        return self.arg # type: ignore

class NonSpare_1853(NonSpare):
    cv_arg: TypeAlias = RuleVariation_169.cv_arg
    cv_name = "TES"
    cv_title = "Track Extrapolation Source"
    cv_rule: TypeAlias = RuleVariation_169

    @classmethod
    def create(cls, arg : "NonSpare_1853.cv_arg") -> "NonSpare_1853":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_169:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_176:
        return self.rule.variation

class Content_241(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Identity not requested", 1: "Identity requested"}

class RuleContent_241(RuleContentContextFree):
    cv_arg: TypeAlias = Content_241.cv_arg
    cv_content: TypeAlias = Content_241

    @property
    def content(self) -> Content_241:
        return self._get_content() # type: ignore

class Variation_49(Element):
    cv_arg: TypeAlias = RuleContent_241.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_241

    @classmethod
    def create(cls, arg: "Variation_49.cv_arg") -> "Variation_49":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_241:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_241:
        return self.rule.content

class RuleVariation_49(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_49.cv_arg
    cv_variation: TypeAlias = Variation_49

    @classmethod
    def create(cls, arg : "RuleVariation_49.cv_arg") -> "RuleVariation_49":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_49:
        return self.arg # type: ignore

class NonSpare_1124(NonSpare):
    cv_arg: TypeAlias = RuleVariation_49.cv_arg
    cv_name = "IR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_49

    @classmethod
    def create(cls, arg : "NonSpare_1124.cv_arg") -> "NonSpare_1124":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_49:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_49:
        return self.rule.variation

class Item_438(Item):
    cv_arg: TypeAlias = NonSpare_1124.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1124

    @classmethod
    def create(cls, arg : "Item_438.cv_arg") -> "Item_438":
        return cls._create(arg) # type: ignore

class Variation_498(Element):
    cv_arg: TypeAlias = RuleContent_724.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 7
    cv_rule = RuleContent_724

    @classmethod
    def create(cls, arg: "Variation_498.cv_arg") -> "Variation_498":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_724:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_724:
        return self.rule.content

class RuleVariation_487(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_498.cv_arg
    cv_variation: TypeAlias = Variation_498

    @classmethod
    def create(cls, arg : "RuleVariation_487.cv_arg") -> "RuleVariation_487":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_498:
        return self.arg # type: ignore

class NonSpare_1216(NonSpare):
    cv_arg: TypeAlias = RuleVariation_487.cv_arg
    cv_name = "M3A"
    cv_title = "Age of Mode 3/A Code (I048/070)"
    cv_rule: TypeAlias = RuleVariation_487

    @classmethod
    def create(cls, arg : "NonSpare_1216.cv_arg") -> "NonSpare_1216":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_487:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_498:
        return self.rule.variation

class Item_521(Item):
    cv_arg: TypeAlias = NonSpare_1216.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1216

    @classmethod
    def create(cls, arg : "Item_521.cv_arg") -> "Item_521":
        return cls._create(arg) # type: ignore

class Variation_1123(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_49.cv_arg, Tuple[Literal["IR"], RuleVariation_49.cv_arg]], Union[RuleVariation_487.cv_arg, Tuple[Literal["M3A"], RuleVariation_487.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1123.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_438, 1), (Item_521, 7)]
    cv_items_dict = {"IR": RuleVariation_49, "M3A": RuleVariation_487}

    @overload
    @classmethod
    def spec(cls, key : Literal["IR"]) -> RuleVariation_49:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3A"]) -> RuleVariation_487:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IR"], Literal["M3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IR"]) -> RuleVariation_49:
        ...
    @overload
    def get_item(self, key : Literal["M3A"]) -> RuleVariation_487:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1123.cv_arg") -> 'Variation_1123':
        return cls._create(arg) # type: ignore

class RuleVariation_1079(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1123.cv_arg
    cv_variation: TypeAlias = Variation_1123

    @classmethod
    def create(cls, arg : "RuleVariation_1079.cv_arg") -> "RuleVariation_1079":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1123:
        return self.arg # type: ignore

class NonSpare_1125(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1079.cv_arg
    cv_name = "IR"
    cv_title = "Identity Requested"
    cv_rule: TypeAlias = RuleVariation_1079

    @classmethod
    def create(cls, arg : "NonSpare_1125.cv_arg") -> "NonSpare_1125":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1079:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1123:
        return self.rule.variation

class Variation_1503(Compound):
    cv_arg = TypedDict('cv_arg', {
        "PTL": NonSpare_1483.cv_arg,
        "ATL": NonSpare_642.cv_arg,
        "TRN": NonSpare_1922.cv_arg,
        "NPP": NonSpare_1379.cv_arg,
        "DLK": NonSpare_888.cv_arg,
        "LCK": NonSpare_1165.cv_arg,
        "TC": NonSpare_1836.cv_arg,
        "TLC": NonSpare_1873.cv_arg,
        "ASI": NonSpare_637.cv_arg,
        "TES": NonSpare_1853.cv_arg,
        "IR": NonSpare_1125.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1483, NonSpare_642, NonSpare_1922, NonSpare_1379, NonSpare_888, NonSpare_1165, NonSpare_1836, NonSpare_1873, NonSpare_637, NonSpare_1853, NonSpare_1125]
    cv_items_dict = {"PTL": NonSpare_1483, "ATL": NonSpare_642, "TRN": NonSpare_1922, "NPP": NonSpare_1379, "DLK": NonSpare_888, "LCK": NonSpare_1165, "TC": NonSpare_1836, "TLC": NonSpare_1873, "ASI": NonSpare_637, "TES": NonSpare_1853, "IR": NonSpare_1125}

    @overload
    @classmethod
    def spec(cls, key : Literal["PTL"]) -> NonSpare_1483:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATL"]) -> NonSpare_642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRN"]) -> NonSpare_1922:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NPP"]) -> NonSpare_1379:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DLK"]) -> NonSpare_888:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCK"]) -> NonSpare_1165:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> NonSpare_1836:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TLC"]) -> NonSpare_1873:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ASI"]) -> NonSpare_637:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TES"]) -> NonSpare_1853:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IR"]) -> NonSpare_1125:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PTL"], Literal["ATL"], Literal["TRN"], Literal["NPP"], Literal["DLK"], Literal["LCK"], Literal["TC"], Literal["TLC"], Literal["ASI"], Literal["TES"], Literal["IR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PTL"]) -> Optional[NonSpare_1483]:
        ...
    @overload
    def get_item(self, key : Literal["ATL"]) -> Optional[NonSpare_642]:
        ...
    @overload
    def get_item(self, key : Literal["TRN"]) -> Optional[NonSpare_1922]:
        ...
    @overload
    def get_item(self, key : Literal["NPP"]) -> Optional[NonSpare_1379]:
        ...
    @overload
    def get_item(self, key : Literal["DLK"]) -> Optional[NonSpare_888]:
        ...
    @overload
    def get_item(self, key : Literal["LCK"]) -> Optional[NonSpare_1165]:
        ...
    @overload
    def get_item(self, key : Literal["TC"]) -> Optional[NonSpare_1836]:
        ...
    @overload
    def get_item(self, key : Literal["TLC"]) -> Optional[NonSpare_1873]:
        ...
    @overload
    def get_item(self, key : Literal["ASI"]) -> Optional[NonSpare_637]:
        ...
    @overload
    def get_item(self, key : Literal["TES"]) -> Optional[NonSpare_1853]:
        ...
    @overload
    def get_item(self, key : Literal["IR"]) -> Optional[NonSpare_1125]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PTL"], val : NonSpare_1483.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["ATL"], val : NonSpare_642.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["TRN"], val : NonSpare_1922.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["NPP"], val : NonSpare_1379.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["DLK"], val : NonSpare_888.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["LCK"], val : NonSpare_1165.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["TC"], val : NonSpare_1836.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["TLC"], val : NonSpare_1873.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["ASI"], val : NonSpare_637.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["TES"], val : NonSpare_1853.cv_arg) -> "Variation_1503":
        ...
    @overload
    def set_item(self, key : Literal["IR"], val : NonSpare_1125.cv_arg) -> "Variation_1503":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PTL"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["ATL"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["TRN"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["NPP"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["DLK"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["LCK"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["TC"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["TLC"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["ASI"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["TES"]) -> "Variation_1503":
        ...
    @overload
    def del_item(self, key : Literal["IR"]) -> "Variation_1503":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1503.cv_arg") -> 'Variation_1503':
        return cls._create(arg) # type: ignore

class RuleVariation_1424(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1503.cv_arg
    cv_variation: TypeAlias = Variation_1503

    @classmethod
    def create(cls, arg : "RuleVariation_1424.cv_arg") -> "RuleVariation_1424":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1503:
        return self.arg # type: ignore

class NonSpare_1632(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1424.cv_arg
    cv_name = "RTC"
    cv_title = "Radar Track Characteristics"
    cv_rule: TypeAlias = RuleVariation_1424

    @classmethod
    def create(cls, arg : "NonSpare_1632.cv_arg") -> "NonSpare_1632":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1424:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1503:
        return self.rule.variation

class NonSpare_1437(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "PNB"
    cv_title = "Plot Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1437.cv_arg") -> "NonSpare_1437":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Content_423(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "PSR Echo", 1: "SSR Reply", 2: "All Call Reply", 3: "Roll Call Reply"}

class RuleContent_423(RuleContentContextFree):
    cv_arg: TypeAlias = Content_423.cv_arg
    cv_content: TypeAlias = Content_423

    @property
    def content(self) -> Content_423:
        return self._get_content() # type: ignore

class Variation_175(Element):
    cv_arg: TypeAlias = RuleContent_423.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_423

    @classmethod
    def create(cls, arg: "Variation_175.cv_arg") -> "Variation_175":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_423:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_423:
        return self.rule.content

class RuleVariation_168(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_175.cv_arg
    cv_variation: TypeAlias = Variation_175

    @classmethod
    def create(cls, arg : "RuleVariation_168.cv_arg") -> "RuleVariation_168":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_175:
        return self.arg # type: ignore

class NonSpare_1972(NonSpare):
    cv_arg: TypeAlias = RuleVariation_168.cv_arg
    cv_name = "TYPE"
    cv_title = "Reply Type"
    cv_rule: TypeAlias = RuleVariation_168

    @classmethod
    def create(cls, arg : "NonSpare_1972.cv_arg") -> "NonSpare_1972":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_168:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_175:
        return self.rule.variation

class Item_1085(Item):
    cv_arg: TypeAlias = NonSpare_1972.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1972

    @classmethod
    def create(cls, arg : "Item_1085.cv_arg") -> "Item_1085":
        return cls._create(arg) # type: ignore

class NonSpare_1581(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "REPLYNBR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1581.cv_arg") -> "NonSpare_1581":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_806(Item):
    cv_arg: TypeAlias = NonSpare_1581.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1581

    @classmethod
    def create(cls, arg : "Item_806.cv_arg") -> "Item_806":
        return cls._create(arg) # type: ignore

class Variation_1244(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_168.cv_arg, Tuple[Literal["TYPE"], RuleVariation_168.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["REPLYNBR"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1244.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_1085, 8), (Item_806, 16)]
    cv_items_dict = {"TYPE": RuleVariation_168, "REPLYNBR": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYPE"]) -> RuleVariation_168:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["REPLYNBR"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYPE"], Literal["REPLYNBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYPE"]) -> RuleVariation_168:
        ...
    @overload
    def get_item(self, key : Literal["REPLYNBR"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1244.cv_arg") -> 'Variation_1244':
        return cls._create(arg) # type: ignore

class Variation_1446(Repetitive):
    cv_arg: TypeAlias = List[Variation_1244.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1244

    @classmethod
    def create(cls, arg: "Variation_1446.cv_arg") -> 'Variation_1446':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1244]:
        return self._get_list() # type: ignore

class RuleVariation_1367(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1446.cv_arg
    cv_variation: TypeAlias = Variation_1446

    @classmethod
    def create(cls, arg : "RuleVariation_1367.cv_arg") -> "RuleVariation_1367":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1446:
        return self.arg # type: ignore

class NonSpare_1606(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1367.cv_arg
    cv_name = "RPL"
    cv_title = "Replies/Plot Link"
    cv_rule: TypeAlias = RuleVariation_1367

    @classmethod
    def create(cls, arg : "NonSpare_1606.cv_arg") -> "NonSpare_1606":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1446:
        return self.rule.variation

class NonSpare_1730(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "SNB"
    cv_title = "Scan Number"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1730.cv_arg") -> "NonSpare_1730":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Content_616(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_616(RuleContentContextFree):
    cv_arg: TypeAlias = Content_616.cv_arg
    cv_content: TypeAlias = Content_616

    @property
    def content(self) -> Content_616:
        return self._get_content() # type: ignore

class Variation_140(Element):
    cv_arg: TypeAlias = RuleContent_616.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_616

    @classmethod
    def create(cls, arg: "Variation_140.cv_arg") -> "Variation_140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_616:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_616:
        return self.rule.content

class RuleVariation_140(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_140.cv_arg
    cv_variation: TypeAlias = Variation_140

    @classmethod
    def create(cls, arg : "RuleVariation_140.cv_arg") -> "RuleVariation_140":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_140:
        return self.arg # type: ignore

class NonSpare_2157(NonSpare):
    cv_arg: TypeAlias = RuleVariation_140.cv_arg
    cv_name = "Y1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_140

    @classmethod
    def create(cls, arg : "NonSpare_2157.cv_arg") -> "NonSpare_2157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_140:
        return self.rule.variation

class Item_1255(Item):
    cv_arg: TypeAlias = NonSpare_2157.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2157

    @classmethod
    def create(cls, arg : "Item_1255.cv_arg") -> "Item_1255":
        return cls._create(arg) # type: ignore

class Variation_805(Element):
    cv_arg: TypeAlias = RuleContent_616.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_616

    @classmethod
    def create(cls, arg: "Variation_805.cv_arg") -> "Variation_805":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_616:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_616:
        return self.rule.content

class RuleVariation_775(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_805.cv_arg
    cv_variation: TypeAlias = Variation_805

    @classmethod
    def create(cls, arg : "RuleVariation_775.cv_arg") -> "RuleVariation_775":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_805:
        return self.arg # type: ignore

class NonSpare_2160(NonSpare):
    cv_arg: TypeAlias = RuleVariation_775.cv_arg
    cv_name = "Y2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_775

    @classmethod
    def create(cls, arg : "NonSpare_2160.cv_arg") -> "NonSpare_2160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

class Item_1258(Item):
    cv_arg: TypeAlias = NonSpare_2160.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2160

    @classmethod
    def create(cls, arg : "Item_1258.cv_arg") -> "Item_1258":
        return cls._create(arg) # type: ignore

class NonSpare_2162(NonSpare):
    cv_arg: TypeAlias = RuleVariation_140.cv_arg
    cv_name = "Y3"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_140

    @classmethod
    def create(cls, arg : "NonSpare_2162.cv_arg") -> "NonSpare_2162":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_140:
        return self.rule.variation

class Item_1260(Item):
    cv_arg: TypeAlias = NonSpare_2162.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2162

    @classmethod
    def create(cls, arg : "Item_1260.cv_arg") -> "Item_1260":
        return cls._create(arg) # type: ignore

class NonSpare_2163(NonSpare):
    cv_arg: TypeAlias = RuleVariation_775.cv_arg
    cv_name = "Y4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_775

    @classmethod
    def create(cls, arg : "NonSpare_2163.cv_arg") -> "NonSpare_2163":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

class Item_1261(Item):
    cv_arg: TypeAlias = NonSpare_2163.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2163

    @classmethod
    def create(cls, arg : "Item_1261.cv_arg") -> "Item_1261":
        return cls._create(arg) # type: ignore

class Content_614(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_614(RuleContentContextFree):
    cv_arg: TypeAlias = Content_614.cv_arg
    cv_content: TypeAlias = Content_614

    @property
    def content(self) -> Content_614:
        return self._get_content() # type: ignore

class Variation_138(Element):
    cv_arg: TypeAlias = RuleContent_614.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_614

    @classmethod
    def create(cls, arg: "Variation_138.cv_arg") -> "Variation_138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_614:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_614:
        return self.rule.content

class RuleVariation_138(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_138.cv_arg
    cv_variation: TypeAlias = Variation_138

    @classmethod
    def create(cls, arg : "RuleVariation_138.cv_arg") -> "RuleVariation_138":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_138:
        return self.arg # type: ignore

class NonSpare_1205(NonSpare):
    cv_arg: TypeAlias = RuleVariation_138.cv_arg
    cv_name = "M1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_138

    @classmethod
    def create(cls, arg : "NonSpare_1205.cv_arg") -> "NonSpare_1205":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_138:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_138:
        return self.rule.variation

class Item_513(Item):
    cv_arg: TypeAlias = NonSpare_1205.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1205

    @classmethod
    def create(cls, arg : "Item_513.cv_arg") -> "Item_513":
        return cls._create(arg) # type: ignore

class NonSpare_1210(NonSpare):
    cv_arg: TypeAlias = RuleVariation_775.cv_arg
    cv_name = "M2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_775

    @classmethod
    def create(cls, arg : "NonSpare_1210.cv_arg") -> "NonSpare_1210":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

class Item_518(Item):
    cv_arg: TypeAlias = NonSpare_1210.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1210

    @classmethod
    def create(cls, arg : "Item_518.cv_arg") -> "Item_518":
        return cls._create(arg) # type: ignore

class Content_615(ContentInteger):
    cv_arg: TypeAlias = int
    cv_signedness: TypeAlias = Unsigned

class RuleContent_615(RuleContentContextFree):
    cv_arg: TypeAlias = Content_615.cv_arg
    cv_content: TypeAlias = Content_615

    @property
    def content(self) -> Content_615:
        return self._get_content() # type: ignore

class Variation_139(Element):
    cv_arg: TypeAlias = RuleContent_615.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 4
    cv_rule = RuleContent_615

    @classmethod
    def create(cls, arg: "Variation_139.cv_arg") -> "Variation_139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_615:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_615:
        return self.rule.content

class RuleVariation_139(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_139.cv_arg
    cv_variation: TypeAlias = Variation_139

    @classmethod
    def create(cls, arg : "RuleVariation_139.cv_arg") -> "RuleVariation_139":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_139:
        return self.arg # type: ignore

class NonSpare_855(NonSpare):
    cv_arg: TypeAlias = RuleVariation_139.cv_arg
    cv_name = "D1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_139

    @classmethod
    def create(cls, arg : "NonSpare_855.cv_arg") -> "NonSpare_855":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_139:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_139:
        return self.rule.variation

class Item_235(Item):
    cv_arg: TypeAlias = NonSpare_855.cv_arg
    cv_non_spare: TypeAlias = NonSpare_855

    @classmethod
    def create(cls, arg : "Item_235.cv_arg") -> "Item_235":
        return cls._create(arg) # type: ignore

class NonSpare_856(NonSpare):
    cv_arg: TypeAlias = RuleVariation_775.cv_arg
    cv_name = "D2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_775

    @classmethod
    def create(cls, arg : "NonSpare_856.cv_arg") -> "NonSpare_856":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_775:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_805:
        return self.rule.variation

class Item_236(Item):
    cv_arg: TypeAlias = NonSpare_856.cv_arg
    cv_non_spare: TypeAlias = NonSpare_856

    @classmethod
    def create(cls, arg : "Item_236.cv_arg") -> "Item_236":
        return cls._create(arg) # type: ignore

class Variation_1321(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_140.cv_arg, Tuple[Literal["Y1"], RuleVariation_140.cv_arg]], Union[RuleVariation_775.cv_arg, Tuple[Literal["Y2"], RuleVariation_775.cv_arg]], Union[RuleVariation_140.cv_arg, Tuple[Literal["Y3"], RuleVariation_140.cv_arg]], Union[RuleVariation_775.cv_arg, Tuple[Literal["Y4"], RuleVariation_775.cv_arg]], Union[RuleVariation_138.cv_arg, Tuple[Literal["M1"], RuleVariation_138.cv_arg]], Union[RuleVariation_775.cv_arg, Tuple[Literal["M2"], RuleVariation_775.cv_arg]], Union[RuleVariation_139.cv_arg, Tuple[Literal["D1"], RuleVariation_139.cv_arg]], Union[RuleVariation_775.cv_arg, Tuple[Literal["D2"], RuleVariation_775.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1321.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1255, 4), (Item_1258, 4), (Item_1260, 4), (Item_1261, 4), (Item_513, 4), (Item_518, 4), (Item_235, 4), (Item_236, 4)]
    cv_items_dict = {"Y1": RuleVariation_140, "Y2": RuleVariation_775, "Y3": RuleVariation_140, "Y4": RuleVariation_775, "M1": RuleVariation_138, "M2": RuleVariation_775, "D1": RuleVariation_139, "D2": RuleVariation_775}

    @overload
    @classmethod
    def spec(cls, key : Literal["Y1"]) -> RuleVariation_140:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y2"]) -> RuleVariation_775:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y3"]) -> RuleVariation_140:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y4"]) -> RuleVariation_775:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_138:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_775:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["D1"]) -> RuleVariation_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["D2"]) -> RuleVariation_775:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["Y1"], Literal["Y2"], Literal["Y3"], Literal["Y4"], Literal["M1"], Literal["M2"], Literal["D1"], Literal["D2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["Y1"]) -> RuleVariation_140:
        ...
    @overload
    def get_item(self, key : Literal["Y2"]) -> RuleVariation_775:
        ...
    @overload
    def get_item(self, key : Literal["Y3"]) -> RuleVariation_140:
        ...
    @overload
    def get_item(self, key : Literal["Y4"]) -> RuleVariation_775:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_138:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_775:
        ...
    @overload
    def get_item(self, key : Literal["D1"]) -> RuleVariation_139:
        ...
    @overload
    def get_item(self, key : Literal["D2"]) -> RuleVariation_775:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1321.cv_arg") -> 'Variation_1321':
        return cls._create(arg) # type: ignore

class RuleVariation_1245(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1321.cv_arg
    cv_variation: TypeAlias = Variation_1321

    @classmethod
    def create(cls, arg : "RuleVariation_1245.cv_arg") -> "RuleVariation_1245":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1321:
        return self.arg # type: ignore

class NonSpare_862(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1245.cv_arg
    cv_name = "DATE"
    cv_title = "Common and Plot Characteristics Date"
    cv_rule: TypeAlias = RuleVariation_1245

    @classmethod
    def create(cls, arg : "NonSpare_862.cv_arg") -> "NonSpare_862":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1245:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1321:
        return self.rule.variation

class Variation_1498(Compound):
    cv_arg = TypedDict('cv_arg', {
        "PNB": NonSpare_1437.cv_arg,
        "RPL": NonSpare_1606.cv_arg,
        "SNB": NonSpare_1730.cv_arg,
        "DATE": NonSpare_862.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1437, NonSpare_1606, NonSpare_1730, NonSpare_862]
    cv_items_dict = {"PNB": NonSpare_1437, "RPL": NonSpare_1606, "SNB": NonSpare_1730, "DATE": NonSpare_862}

    @overload
    @classmethod
    def spec(cls, key : Literal["PNB"]) -> NonSpare_1437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPL"]) -> NonSpare_1606:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SNB"]) -> NonSpare_1730:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DATE"]) -> NonSpare_862:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PNB"], Literal["RPL"], Literal["SNB"], Literal["DATE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PNB"]) -> Optional[NonSpare_1437]:
        ...
    @overload
    def get_item(self, key : Literal["RPL"]) -> Optional[NonSpare_1606]:
        ...
    @overload
    def get_item(self, key : Literal["SNB"]) -> Optional[NonSpare_1730]:
        ...
    @overload
    def get_item(self, key : Literal["DATE"]) -> Optional[NonSpare_862]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PNB"], val : NonSpare_1437.cv_arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["RPL"], val : NonSpare_1606.cv_arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["SNB"], val : NonSpare_1730.cv_arg) -> "Variation_1498":
        ...
    @overload
    def set_item(self, key : Literal["DATE"], val : NonSpare_862.cv_arg) -> "Variation_1498":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PNB"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["RPL"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["SNB"]) -> "Variation_1498":
        ...
    @overload
    def del_item(self, key : Literal["DATE"]) -> "Variation_1498":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1498.cv_arg") -> 'Variation_1498':
        return cls._create(arg) # type: ignore

class RuleVariation_1419(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1498.cv_arg
    cv_variation: TypeAlias = Variation_1498

    @classmethod
    def create(cls, arg : "RuleVariation_1419.cv_arg") -> "RuleVariation_1419":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1498:
        return self.arg # type: ignore

class NonSpare_816(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1419.cv_arg
    cv_name = "CPC"
    cv_title = "Common and Plot Characteristics"
    cv_rule: TypeAlias = RuleVariation_1419

    @classmethod
    def create(cls, arg : "NonSpare_816.cv_arg") -> "NonSpare_816":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1419:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1498:
        return self.rule.variation

class Expansion_5(Expansion):
    cv_arg = TypedDict('cv_arg', {
        "MD5": NonSpare_1250.cv_arg,
        "M5N": NonSpare_1220.cv_arg,
        "M4E": NonSpare_1218.cv_arg,
        "RPC": NonSpare_1604.cv_arg,
        "ERR": NonSpare_959.cv_arg,
        "RTC": NonSpare_1632.cv_arg,
        "CPC": NonSpare_816.cv_arg,
    }, total=False)
    cv_type = (FspecFixed, 1)
    cv_items_list = [NonSpare_1250, NonSpare_1220, NonSpare_1218, NonSpare_1604, NonSpare_959, NonSpare_1632, NonSpare_816]
    cv_items_dict = {"MD5": NonSpare_1250, "M5N": NonSpare_1220, "M4E": NonSpare_1218, "RPC": NonSpare_1604, "ERR": NonSpare_959, "RTC": NonSpare_1632, "CPC": NonSpare_816}

    @overload
    @classmethod
    def spec(cls, key : Literal["MD5"]) -> NonSpare_1250:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M5N"]) -> NonSpare_1220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M4E"]) -> NonSpare_1218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPC"]) -> NonSpare_1604:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ERR"]) -> NonSpare_959:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RTC"]) -> NonSpare_1632:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> NonSpare_816:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MD5"], Literal["M5N"], Literal["M4E"], Literal["RPC"], Literal["ERR"], Literal["RTC"], Literal["CPC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[NonSpare_1250]:
        ...
    @overload
    def get_item(self, key : Literal["M5N"]) -> Optional[NonSpare_1220]:
        ...
    @overload
    def get_item(self, key : Literal["M4E"]) -> Optional[NonSpare_1218]:
        ...
    @overload
    def get_item(self, key : Literal["RPC"]) -> Optional[NonSpare_1604]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[NonSpare_959]:
        ...
    @overload
    def get_item(self, key : Literal["RTC"]) -> Optional[NonSpare_1632]:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> Optional[NonSpare_816]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MD5"], val : NonSpare_1250.cv_arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["M5N"], val : NonSpare_1220.cv_arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["M4E"], val : NonSpare_1218.cv_arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["RPC"], val : NonSpare_1604.cv_arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["ERR"], val : NonSpare_959.cv_arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["RTC"], val : NonSpare_1632.cv_arg) -> "Expansion_5":
        ...
    @overload
    def set_item(self, key : Literal["CPC"], val : NonSpare_816.cv_arg) -> "Expansion_5":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MD5"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["M5N"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["M4E"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["RPC"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["ERR"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["RTC"]) -> "Expansion_5":
        ...
    @overload
    def del_item(self, key : Literal["CPC"]) -> "Expansion_5":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Expansion_5.cv_arg") -> 'Expansion_5':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_5", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_43(AstRef):
    cv_category = 48
    cv_edition = (1, 11)
    cv_expansion: TypeAlias = Expansion_5

class NonSpare_899(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "DRN"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_899.cv_arg") -> "NonSpare_899":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_272(Item):
    cv_arg: TypeAlias = NonSpare_899.cv_arg
    cv_non_spare: TypeAlias = NonSpare_899

    @classmethod
    def create(cls, arg : "Item_272.cv_arg") -> "Item_272":
        return cls._create(arg) # type: ignore

class Variation_1197(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SACADJS"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SICADJS"], RuleVariation_159.cv_arg]], Union[RuleVariation_327.cv_arg, Tuple[Literal["TIMEOFDAYSCN"], RuleVariation_327.cv_arg]], Union[RuleVariation_151.cv_arg, Tuple[Literal["DATAUSE"], RuleVariation_151.cv_arg]], Union[RuleVariation_944.cv_arg, Tuple[Literal["DRNA"], RuleVariation_944.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["DRN"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1197.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_858, 8), (Item_889, 8), (Item_1003, 16), (Item_240, 7), (Item_274, 1), (Item_272, 16)]
    cv_items_dict = {"SACADJS": RuleVariation_159, "SICADJS": RuleVariation_159, "TIMEOFDAYSCN": RuleVariation_327, "DATAUSE": RuleVariation_151, "DRNA": RuleVariation_944, "DRN": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["SACADJS"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SICADJS"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_327:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DATAUSE"]) -> RuleVariation_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRNA"]) -> RuleVariation_944:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DRN"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SACADJS"], Literal["SICADJS"], Literal["TIMEOFDAYSCN"], Literal["DATAUSE"], Literal["DRNA"], Literal["DRN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SACADJS"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SICADJS"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["TIMEOFDAYSCN"]) -> RuleVariation_327:
        ...
    @overload
    def get_item(self, key : Literal["DATAUSE"]) -> RuleVariation_151:
        ...
    @overload
    def get_item(self, key : Literal["DRNA"]) -> RuleVariation_944:
        ...
    @overload
    def get_item(self, key : Literal["DRN"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1197.cv_arg") -> 'Variation_1197':
        return cls._create(arg) # type: ignore

class Variation_1432(Repetitive):
    cv_arg: TypeAlias = List[Variation_1197.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1197

    @classmethod
    def create(cls, arg: "Variation_1432.cv_arg") -> 'Variation_1432':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1197]:
        return self._get_list() # type: ignore

class RuleVariation_1353(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1432.cv_arg
    cv_variation: TypeAlias = Variation_1432

    @classmethod
    def create(cls, arg : "RuleVariation_1353.cv_arg") -> "RuleVariation_1353":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1432:
        return self.arg # type: ignore

class NonSpare_636(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1353.cv_arg
    cv_name = "ASI"
    cv_title = "Adjacent Sensor Information"
    cv_rule: TypeAlias = RuleVariation_1353

    @classmethod
    def create(cls, arg : "NonSpare_636.cv_arg") -> "NonSpare_636":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1432:
        return self.rule.variation

class Variation_1502(Compound):
    cv_arg = TypedDict('cv_arg', {
        "PTL": NonSpare_1483.cv_arg,
        "ATL": NonSpare_642.cv_arg,
        "TRN": NonSpare_1922.cv_arg,
        "NPP": NonSpare_1379.cv_arg,
        "DLK": NonSpare_888.cv_arg,
        "LCK": NonSpare_1165.cv_arg,
        "TC": NonSpare_1836.cv_arg,
        "TLC": NonSpare_1873.cv_arg,
        "ASI": NonSpare_636.cv_arg,
        "TES": NonSpare_1853.cv_arg,
        "IR": NonSpare_1125.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1483, NonSpare_642, NonSpare_1922, NonSpare_1379, NonSpare_888, NonSpare_1165, NonSpare_1836, NonSpare_1873, NonSpare_636, NonSpare_1853, NonSpare_1125]
    cv_items_dict = {"PTL": NonSpare_1483, "ATL": NonSpare_642, "TRN": NonSpare_1922, "NPP": NonSpare_1379, "DLK": NonSpare_888, "LCK": NonSpare_1165, "TC": NonSpare_1836, "TLC": NonSpare_1873, "ASI": NonSpare_636, "TES": NonSpare_1853, "IR": NonSpare_1125}

    @overload
    @classmethod
    def spec(cls, key : Literal["PTL"]) -> NonSpare_1483:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATL"]) -> NonSpare_642:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRN"]) -> NonSpare_1922:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NPP"]) -> NonSpare_1379:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DLK"]) -> NonSpare_888:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LCK"]) -> NonSpare_1165:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TC"]) -> NonSpare_1836:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TLC"]) -> NonSpare_1873:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ASI"]) -> NonSpare_636:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TES"]) -> NonSpare_1853:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IR"]) -> NonSpare_1125:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PTL"], Literal["ATL"], Literal["TRN"], Literal["NPP"], Literal["DLK"], Literal["LCK"], Literal["TC"], Literal["TLC"], Literal["ASI"], Literal["TES"], Literal["IR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PTL"]) -> Optional[NonSpare_1483]:
        ...
    @overload
    def get_item(self, key : Literal["ATL"]) -> Optional[NonSpare_642]:
        ...
    @overload
    def get_item(self, key : Literal["TRN"]) -> Optional[NonSpare_1922]:
        ...
    @overload
    def get_item(self, key : Literal["NPP"]) -> Optional[NonSpare_1379]:
        ...
    @overload
    def get_item(self, key : Literal["DLK"]) -> Optional[NonSpare_888]:
        ...
    @overload
    def get_item(self, key : Literal["LCK"]) -> Optional[NonSpare_1165]:
        ...
    @overload
    def get_item(self, key : Literal["TC"]) -> Optional[NonSpare_1836]:
        ...
    @overload
    def get_item(self, key : Literal["TLC"]) -> Optional[NonSpare_1873]:
        ...
    @overload
    def get_item(self, key : Literal["ASI"]) -> Optional[NonSpare_636]:
        ...
    @overload
    def get_item(self, key : Literal["TES"]) -> Optional[NonSpare_1853]:
        ...
    @overload
    def get_item(self, key : Literal["IR"]) -> Optional[NonSpare_1125]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PTL"], val : NonSpare_1483.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["ATL"], val : NonSpare_642.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["TRN"], val : NonSpare_1922.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["NPP"], val : NonSpare_1379.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["DLK"], val : NonSpare_888.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["LCK"], val : NonSpare_1165.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["TC"], val : NonSpare_1836.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["TLC"], val : NonSpare_1873.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["ASI"], val : NonSpare_636.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["TES"], val : NonSpare_1853.cv_arg) -> "Variation_1502":
        ...
    @overload
    def set_item(self, key : Literal["IR"], val : NonSpare_1125.cv_arg) -> "Variation_1502":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PTL"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["ATL"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["TRN"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["NPP"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["DLK"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["LCK"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["TC"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["TLC"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["ASI"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["TES"]) -> "Variation_1502":
        ...
    @overload
    def del_item(self, key : Literal["IR"]) -> "Variation_1502":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1502.cv_arg") -> 'Variation_1502':
        return cls._create(arg) # type: ignore

class RuleVariation_1423(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1502.cv_arg
    cv_variation: TypeAlias = Variation_1502

    @classmethod
    def create(cls, arg : "RuleVariation_1423.cv_arg") -> "RuleVariation_1423":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1502:
        return self.arg # type: ignore

class NonSpare_1631(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1423.cv_arg
    cv_name = "RTC"
    cv_title = "Radar Track Characteristics"
    cv_rule: TypeAlias = RuleVariation_1423

    @classmethod
    def create(cls, arg : "NonSpare_1631.cv_arg") -> "NonSpare_1631":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1423:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1502:
        return self.rule.variation

class Content_285(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-2 code as derived from reply of the transponder", 1: "Smoothed Mode-2 as provided by a local tracker"}

class RuleContent_285(RuleContentContextFree):
    cv_arg: TypeAlias = Content_285.cv_arg
    cv_content: TypeAlias = Content_285

    @property
    def content(self) -> Content_285:
        return self._get_content() # type: ignore

class Variation_548(Element):
    cv_arg: TypeAlias = RuleContent_285.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_285

    @classmethod
    def create(cls, arg: "Variation_548.cv_arg") -> "Variation_548":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_285:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_285:
        return self.rule.content

class RuleVariation_537(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_548.cv_arg
    cv_variation: TypeAlias = Variation_548

    @classmethod
    def create(cls, arg : "RuleVariation_537.cv_arg") -> "RuleVariation_537":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_548:
        return self.arg # type: ignore

class NonSpare_1136(NonSpare):
    cv_arg: TypeAlias = RuleVariation_537.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_537

    @classmethod
    def create(cls, arg : "NonSpare_1136.cv_arg") -> "NonSpare_1136":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_537:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_548:
        return self.rule.variation

class Item_448(Item):
    cv_arg: TypeAlias = NonSpare_1136.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1136

    @classmethod
    def create(cls, arg : "Item_448.cv_arg") -> "Item_448":
        return cls._create(arg) # type: ignore

class NonSpare_600(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "ALTM2"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_600.cv_arg") -> "NonSpare_600":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_65(Item):
    cv_arg: TypeAlias = NonSpare_600.cv_arg
    cv_non_spare: TypeAlias = NonSpare_600

    @classmethod
    def create(cls, arg : "Item_65.cv_arg") -> "Item_65":
        return cls._create(arg) # type: ignore

class Variation_1260(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_537.cv_arg, Tuple[Literal["L"], RuleVariation_537.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["ALTM2"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1260.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_448, 1), (Item_16, 1), (Item_65, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_537, "ALTM2": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_537:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM2"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["ALTM2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_537:
        ...
    @overload
    def get_item(self, key : Literal["ALTM2"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1260.cv_arg") -> 'Variation_1260':
        return cls._create(arg) # type: ignore

class RuleVariation_1189(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1260.cv_arg
    cv_variation: TypeAlias = Variation_1260

    @classmethod
    def create(cls, arg : "RuleVariation_1189.cv_arg") -> "RuleVariation_1189":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1260:
        return self.arg # type: ignore

class NonSpare_599(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1189.cv_arg
    cv_name = "ALTM2"
    cv_title = "Alternative Mode 2 Code"
    cv_rule: TypeAlias = RuleVariation_1189

    @classmethod
    def create(cls, arg : "NonSpare_599.cv_arg") -> "NonSpare_599":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1189:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1260:
        return self.rule.variation

class Content_288(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-3/A code as derived from the reply of the transponder", 1: "Smoothed Mode-3/A code as provided by a local tracker"}

class RuleContent_288(RuleContentContextFree):
    cv_arg: TypeAlias = Content_288.cv_arg
    cv_content: TypeAlias = Content_288

    @property
    def content(self) -> Content_288:
        return self._get_content() # type: ignore

class Variation_551(Element):
    cv_arg: TypeAlias = RuleContent_288.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_288

    @classmethod
    def create(cls, arg: "Variation_551.cv_arg") -> "Variation_551":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_288:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_288:
        return self.rule.content

class RuleVariation_540(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_551.cv_arg
    cv_variation: TypeAlias = Variation_551

    @classmethod
    def create(cls, arg : "RuleVariation_540.cv_arg") -> "RuleVariation_540":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_551:
        return self.arg # type: ignore

class NonSpare_1139(NonSpare):
    cv_arg: TypeAlias = RuleVariation_540.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_540

    @classmethod
    def create(cls, arg : "NonSpare_1139.cv_arg") -> "NonSpare_1139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_540:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_551:
        return self.rule.variation

class Item_451(Item):
    cv_arg: TypeAlias = NonSpare_1139.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1139

    @classmethod
    def create(cls, arg : "Item_451.cv_arg") -> "Item_451":
        return cls._create(arg) # type: ignore

class NonSpare_602(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "ALTM3"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_602.cv_arg") -> "NonSpare_602":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_66(Item):
    cv_arg: TypeAlias = NonSpare_602.cv_arg
    cv_non_spare: TypeAlias = NonSpare_602

    @classmethod
    def create(cls, arg : "Item_66.cv_arg") -> "Item_66":
        return cls._create(arg) # type: ignore

class Variation_1262(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_540.cv_arg, Tuple[Literal["L"], RuleVariation_540.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["ALTM3"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1262.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_451, 1), (Item_16, 1), (Item_66, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_540, "ALTM3": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_540:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM3"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["ALTM3"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_540:
        ...
    @overload
    def get_item(self, key : Literal["ALTM3"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1262.cv_arg") -> 'Variation_1262':
        return cls._create(arg) # type: ignore

class RuleVariation_1191(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1262.cv_arg
    cv_variation: TypeAlias = Variation_1262

    @classmethod
    def create(cls, arg : "RuleVariation_1191.cv_arg") -> "RuleVariation_1191":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1262:
        return self.arg # type: ignore

class NonSpare_601(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1191.cv_arg
    cv_name = "ALTM3"
    cv_title = "Alternative Mode 3/A"
    cv_rule: TypeAlias = RuleVariation_1191

    @classmethod
    def create(cls, arg : "NonSpare_601.cv_arg") -> "NonSpare_601":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1191:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1262:
        return self.rule.variation

class Content_652(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ALTFL"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "ALTFL"

    def as_quantity(self, cv_unit : Optional[Literal["ALTFL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_652(RuleContentContextFree):
    cv_arg: TypeAlias = Content_652.cv_arg
    cv_content: TypeAlias = Content_652

    @property
    def content(self) -> Content_652:
        return self._get_content() # type: ignore

class Variation_608(Element):
    cv_arg: TypeAlias = RuleContent_652.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_652

    @classmethod
    def create(cls, arg: "Variation_608.cv_arg") -> "Variation_608":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_652:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_652:
        return self.rule.content

class RuleVariation_597(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_608.cv_arg
    cv_variation: TypeAlias = Variation_608

    @classmethod
    def create(cls, arg : "RuleVariation_597.cv_arg") -> "RuleVariation_597":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_608:
        return self.arg # type: ignore

class NonSpare_598(NonSpare):
    cv_arg: TypeAlias = RuleVariation_597.cv_arg
    cv_name = "ALTFL"
    cv_title = "Flight Level in Two's Complement Form"
    cv_rule: TypeAlias = RuleVariation_597

    @classmethod
    def create(cls, arg : "NonSpare_598.cv_arg") -> "NonSpare_598":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_597:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_608:
        return self.rule.variation

class Item_64(Item):
    cv_arg: TypeAlias = NonSpare_598.cv_arg
    cv_non_spare: TypeAlias = NonSpare_598

    @classmethod
    def create(cls, arg : "Item_64.cv_arg") -> "Item_64":
        return cls._create(arg) # type: ignore

class Variation_1254(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_597.cv_arg, Tuple[Literal["ALTFL"], RuleVariation_597.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1254.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_64, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "ALTFL": RuleVariation_597}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTFL"]) -> RuleVariation_597:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["ALTFL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["ALTFL"]) -> RuleVariation_597:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1254.cv_arg") -> 'Variation_1254':
        return cls._create(arg) # type: ignore

class RuleVariation_1183(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1254.cv_arg
    cv_variation: TypeAlias = Variation_1254

    @classmethod
    def create(cls, arg : "RuleVariation_1183.cv_arg") -> "RuleVariation_1183":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1254:
        return self.arg # type: ignore

class NonSpare_597(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1183.cv_arg
    cv_name = "ALTFL"
    cv_title = "Alternative Flight Level"
    cv_rule: TypeAlias = RuleVariation_1183

    @classmethod
    def create(cls, arg : "NonSpare_597.cv_arg") -> "NonSpare_597":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1183:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1254:
        return self.rule.variation

class Variation_1471(Compound):
    cv_arg = TypedDict('cv_arg', {
        "ALTM2": NonSpare_599.cv_arg,
        "ALTM3": NonSpare_601.cv_arg,
        "ALTFL": NonSpare_597.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_599, NonSpare_601, NonSpare_597]
    cv_items_dict = {"ALTM2": NonSpare_599, "ALTM3": NonSpare_601, "ALTFL": NonSpare_597}

    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM2"]) -> NonSpare_599:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTM3"]) -> NonSpare_601:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALTFL"]) -> NonSpare_597:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ALTM2"], Literal["ALTM3"], Literal["ALTFL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ALTM2"]) -> Optional[NonSpare_599]:
        ...
    @overload
    def get_item(self, key : Literal["ALTM3"]) -> Optional[NonSpare_601]:
        ...
    @overload
    def get_item(self, key : Literal["ALTFL"]) -> Optional[NonSpare_597]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ALTM2"], val : NonSpare_599.cv_arg) -> "Variation_1471":
        ...
    @overload
    def set_item(self, key : Literal["ALTM3"], val : NonSpare_601.cv_arg) -> "Variation_1471":
        ...
    @overload
    def set_item(self, key : Literal["ALTFL"], val : NonSpare_597.cv_arg) -> "Variation_1471":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ALTM2"]) -> "Variation_1471":
        ...
    @overload
    def del_item(self, key : Literal["ALTM3"]) -> "Variation_1471":
        ...
    @overload
    def del_item(self, key : Literal["ALTFL"]) -> "Variation_1471":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1471.cv_arg") -> 'Variation_1471':
        return cls._create(arg) # type: ignore

class RuleVariation_1392(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1471.cv_arg
    cv_variation: TypeAlias = Variation_1471

    @classmethod
    def create(cls, arg : "RuleVariation_1392.cv_arg") -> "RuleVariation_1392":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1471:
        return self.arg # type: ignore

class NonSpare_1032(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1392.cv_arg
    cv_name = "GEN48"
    cv_title = "Generic Category 048 Data"
    cv_rule: TypeAlias = RuleVariation_1392

    @classmethod
    def create(cls, arg : "NonSpare_1032.cv_arg") -> "NonSpare_1032":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1392:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1471:
        return self.rule.variation

class Expansion_4(Expansion):
    cv_arg = TypedDict('cv_arg', {
        "MD5": NonSpare_1250.cv_arg,
        "M5N": NonSpare_1220.cv_arg,
        "M4E": NonSpare_1218.cv_arg,
        "RPC": NonSpare_1604.cv_arg,
        "ERR": NonSpare_959.cv_arg,
        "RTC": NonSpare_1631.cv_arg,
        "CPC": NonSpare_816.cv_arg,
        "GEN48": NonSpare_1032.cv_arg,
    }, total=False)
    cv_type = (FspecFixed, 1)
    cv_items_list = [NonSpare_1250, NonSpare_1220, NonSpare_1218, NonSpare_1604, NonSpare_959, NonSpare_1631, NonSpare_816, NonSpare_1032]
    cv_items_dict = {"MD5": NonSpare_1250, "M5N": NonSpare_1220, "M4E": NonSpare_1218, "RPC": NonSpare_1604, "ERR": NonSpare_959, "RTC": NonSpare_1631, "CPC": NonSpare_816, "GEN48": NonSpare_1032}

    @overload
    @classmethod
    def spec(cls, key : Literal["MD5"]) -> NonSpare_1250:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M5N"]) -> NonSpare_1220:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M4E"]) -> NonSpare_1218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPC"]) -> NonSpare_1604:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ERR"]) -> NonSpare_959:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RTC"]) -> NonSpare_1631:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPC"]) -> NonSpare_816:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GEN48"]) -> NonSpare_1032:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MD5"], Literal["M5N"], Literal["M4E"], Literal["RPC"], Literal["ERR"], Literal["RTC"], Literal["CPC"], Literal["GEN48"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[NonSpare_1250]:
        ...
    @overload
    def get_item(self, key : Literal["M5N"]) -> Optional[NonSpare_1220]:
        ...
    @overload
    def get_item(self, key : Literal["M4E"]) -> Optional[NonSpare_1218]:
        ...
    @overload
    def get_item(self, key : Literal["RPC"]) -> Optional[NonSpare_1604]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[NonSpare_959]:
        ...
    @overload
    def get_item(self, key : Literal["RTC"]) -> Optional[NonSpare_1631]:
        ...
    @overload
    def get_item(self, key : Literal["CPC"]) -> Optional[NonSpare_816]:
        ...
    @overload
    def get_item(self, key : Literal["GEN48"]) -> Optional[NonSpare_1032]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MD5"], val : NonSpare_1250.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["M5N"], val : NonSpare_1220.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["M4E"], val : NonSpare_1218.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["RPC"], val : NonSpare_1604.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["ERR"], val : NonSpare_959.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["RTC"], val : NonSpare_1631.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["CPC"], val : NonSpare_816.cv_arg) -> "Expansion_4":
        ...
    @overload
    def set_item(self, key : Literal["GEN48"], val : NonSpare_1032.cv_arg) -> "Expansion_4":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MD5"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["M5N"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["M4E"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["RPC"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["ERR"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["RTC"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["CPC"]) -> "Expansion_4":
        ...
    @overload
    def del_item(self, key : Literal["GEN48"]) -> "Expansion_4":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Expansion_4.cv_arg") -> 'Expansion_4':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_4", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_44(AstRef):
    cv_category = 48
    cv_edition = (1, 12)
    cv_expansion: TypeAlias = Expansion_4

class NonSpare_39(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_39.cv_arg") -> "NonSpare_39":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_39(UapItem):
    cv_non_spare: TypeAlias = NonSpare_39

class NonSpare_333(NonSpare):
    cv_arg: TypeAlias = RuleVariation_364.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_364

    @classmethod
    def create(cls, arg : "NonSpare_333.cv_arg") -> "NonSpare_333":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_364:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_371:
        return self.rule.variation

class UapItem_333(UapItem):
    cv_non_spare: TypeAlias = NonSpare_333

class Content_346(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No detection", 1: "Single PSR detection", 2: "Single SSR detection", 3: "SSR + PSR detection", 4: "Single ModeS All-Call", 5: "Single ModeS Roll-Call", 6: "ModeS All-Call + PSR", 7: "ModeS Roll-Call +PSR"}

class RuleContent_346(RuleContentContextFree):
    cv_arg: TypeAlias = Content_346.cv_arg
    cv_content: TypeAlias = Content_346

    @property
    def content(self) -> Content_346:
        return self._get_content() # type: ignore

class Variation_127(Element):
    cv_arg: TypeAlias = RuleContent_346.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_346

    @classmethod
    def create(cls, arg: "Variation_127.cv_arg") -> "Variation_127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_346:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_346:
        return self.rule.content

class RuleVariation_127(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_127.cv_arg
    cv_variation: TypeAlias = Variation_127

    @classmethod
    def create(cls, arg : "RuleVariation_127.cv_arg") -> "RuleVariation_127":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_127:
        return self.arg # type: ignore

class Variation_615(Element):
    cv_arg: TypeAlias = RuleContent_19.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_19

    @classmethod
    def create(cls, arg: "Variation_615.cv_arg") -> "Variation_615":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_19:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_19:
        return self.rule.content

class RuleVariation_604(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_615.cv_arg
    cv_variation: TypeAlias = Variation_615

    @classmethod
    def create(cls, arg : "RuleVariation_604.cv_arg") -> "RuleVariation_604":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_615:
        return self.arg # type: ignore

class Content_439(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Report from RDP Chain 1", 1: "Report from RDP Chain 2"}

class RuleContent_439(RuleContentContextFree):
    cv_arg: TypeAlias = Content_439.cv_arg
    cv_content: TypeAlias = Content_439

    @property
    def content(self) -> Content_439:
        return self._get_content() # type: ignore

class Variation_748(Element):
    cv_arg: TypeAlias = RuleContent_439.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_439

    @classmethod
    def create(cls, arg: "Variation_748.cv_arg") -> "Variation_748":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_439:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_439:
        return self.rule.content

class RuleVariation_737(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_748.cv_arg
    cv_variation: TypeAlias = Variation_748

    @classmethod
    def create(cls, arg : "RuleVariation_737.cv_arg") -> "RuleVariation_737":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_748:
        return self.arg # type: ignore

class Variation_819(Element):
    cv_arg: TypeAlias = RuleContent_13.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_13

    @classmethod
    def create(cls, arg: "Variation_819.cv_arg") -> "Variation_819":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_13:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_13:
        return self.rule.content

class RuleVariation_789(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_819.cv_arg
    cv_variation: TypeAlias = Variation_819

    @classmethod
    def create(cls, arg : "RuleVariation_789.cv_arg") -> "RuleVariation_789":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_819:
        return self.arg # type: ignore

class Content_440(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Report from aircraft transponder", 1: "Report from field monitor (fixed transponder)"}

class RuleContent_440(RuleContentContextFree):
    cv_arg: TypeAlias = Content_440.cv_arg
    cv_content: TypeAlias = Content_440

    @property
    def content(self) -> Content_440:
        return self._get_content() # type: ignore

class Variation_948(Element):
    cv_arg: TypeAlias = RuleContent_440.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_440

    @classmethod
    def create(cls, arg: "Variation_948.cv_arg") -> "Variation_948":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_440:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_440:
        return self.rule.content

class RuleVariation_918(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_948.cv_arg
    cv_variation: TypeAlias = Variation_948

    @classmethod
    def create(cls, arg : "RuleVariation_918.cv_arg") -> "RuleVariation_918":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_948:
        return self.arg # type: ignore

class Content_437(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Real target report", 1: "Test target report"}

class RuleContent_437(RuleContentContextFree):
    cv_arg: TypeAlias = Content_437.cv_arg
    cv_content: TypeAlias = Content_437

    @property
    def content(self) -> Content_437:
        return self._get_content() # type: ignore

class Variation_73(Element):
    cv_arg: TypeAlias = RuleContent_437.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_437

    @classmethod
    def create(cls, arg: "Variation_73.cv_arg") -> "Variation_73":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_437:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_437:
        return self.rule.content

class RuleVariation_73(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_73.cv_arg
    cv_variation: TypeAlias = Variation_73

    @classmethod
    def create(cls, arg : "RuleVariation_73.cv_arg") -> "RuleVariation_73":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_73:
        return self.arg # type: ignore

class Content_308(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Extended Range", 1: "Extended Range present"}

class RuleContent_308(RuleContentContextFree):
    cv_arg: TypeAlias = Content_308.cv_arg
    cv_content: TypeAlias = Content_308

    @property
    def content(self) -> Content_308:
        return self._get_content() # type: ignore

class Variation_440(Element):
    cv_arg: TypeAlias = RuleContent_308.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_308

    @classmethod
    def create(cls, arg: "Variation_440.cv_arg") -> "Variation_440":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_308:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_308:
        return self.rule.content

class RuleVariation_429(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_440.cv_arg
    cv_variation: TypeAlias = Variation_440

    @classmethod
    def create(cls, arg : "RuleVariation_429.cv_arg") -> "RuleVariation_429":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_440:
        return self.arg # type: ignore

class Content_318(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No X-Pulse present", 1: "X-Pulse present"}

class RuleContent_318(RuleContentContextFree):
    cv_arg: TypeAlias = Content_318.cv_arg
    cv_content: TypeAlias = Content_318

    @property
    def content(self) -> Content_318:
        return self._get_content() # type: ignore

class Variation_559(Element):
    cv_arg: TypeAlias = RuleContent_318.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_318

    @classmethod
    def create(cls, arg: "Variation_559.cv_arg") -> "Variation_559":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_318:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_318:
        return self.rule.content

class RuleVariation_548(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_559.cv_arg
    cv_variation: TypeAlias = Variation_559

    @classmethod
    def create(cls, arg : "RuleVariation_548.cv_arg") -> "RuleVariation_548":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_559:
        return self.arg # type: ignore

class Variation_653(Element):
    cv_arg: TypeAlias = RuleContent_367.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_367

    @classmethod
    def create(cls, arg: "Variation_653.cv_arg") -> "Variation_653":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_367:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_367:
        return self.rule.content

class RuleVariation_642(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_653.cv_arg
    cv_variation: TypeAlias = Variation_653

    @classmethod
    def create(cls, arg : "RuleVariation_642.cv_arg") -> "RuleVariation_642":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_653:
        return self.arg # type: ignore

class Content_368(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No military identification", 1: "Military identification"}

class RuleContent_368(RuleContentContextFree):
    cv_arg: TypeAlias = Content_368.cv_arg
    cv_content: TypeAlias = Content_368

    @property
    def content(self) -> Content_368:
        return self._get_content() # type: ignore

class Variation_741(Element):
    cv_arg: TypeAlias = RuleContent_368.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_368

    @classmethod
    def create(cls, arg: "Variation_741.cv_arg") -> "Variation_741":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_368:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_368:
        return self.rule.content

class RuleVariation_730(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_741.cv_arg
    cv_variation: TypeAlias = Variation_741

    @classmethod
    def create(cls, arg : "RuleVariation_730.cv_arg") -> "RuleVariation_730":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_741:
        return self.arg # type: ignore

class Content_309(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Mode 4 interrogation", 1: "Friendly target", 2: "Unknown target", 3: "No reply"}

class RuleContent_309(RuleContentContextFree):
    cv_arg: TypeAlias = Content_309.cv_arg
    cv_content: TypeAlias = Content_309

    @property
    def content(self) -> Content_309:
        return self._get_content() # type: ignore

class Variation_880(Element):
    cv_arg: TypeAlias = RuleContent_309.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_309

    @classmethod
    def create(cls, arg: "Variation_880.cv_arg") -> "Variation_880":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_309:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_309:
        return self.rule.content

class RuleVariation_850(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_880.cv_arg
    cv_variation: TypeAlias = Variation_880

    @classmethod
    def create(cls, arg : "RuleVariation_850.cv_arg") -> "RuleVariation_850":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_880:
        return self.arg # type: ignore

class NonSpare_1959(NonSpare):
    cv_arg: TypeAlias = RuleVariation_127.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_127

    @classmethod
    def create(cls, arg : "NonSpare_1959.cv_arg") -> "NonSpare_1959":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_127:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_127:
        return self.rule.variation

class Item_1073(Item):
    cv_arg: TypeAlias = NonSpare_1959.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1959

    @classmethod
    def create(cls, arg : "Item_1073.cv_arg") -> "Item_1073":
        return cls._create(arg) # type: ignore

class NonSpare_1726(NonSpare):
    cv_arg: TypeAlias = RuleVariation_604.cv_arg
    cv_name = "SIM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_604

    @classmethod
    def create(cls, arg : "NonSpare_1726.cv_arg") -> "NonSpare_1726":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_604:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_615:
        return self.rule.variation

class Item_901(Item):
    cv_arg: TypeAlias = NonSpare_1726.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1726

    @classmethod
    def create(cls, arg : "Item_901.cv_arg") -> "Item_901":
        return cls._create(arg) # type: ignore

class NonSpare_1559(NonSpare):
    cv_arg: TypeAlias = RuleVariation_737.cv_arg
    cv_name = "RDP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_737

    @classmethod
    def create(cls, arg : "NonSpare_1559.cv_arg") -> "NonSpare_1559":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_737:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_748:
        return self.rule.variation

class Item_787(Item):
    cv_arg: TypeAlias = NonSpare_1559.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1559

    @classmethod
    def create(cls, arg : "Item_787.cv_arg") -> "Item_787":
        return cls._create(arg) # type: ignore

class NonSpare_1739(NonSpare):
    cv_arg: TypeAlias = RuleVariation_789.cv_arg
    cv_name = "SPI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_789

    @classmethod
    def create(cls, arg : "NonSpare_1739.cv_arg") -> "NonSpare_1739":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_789:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_819:
        return self.rule.variation

class Item_912(Item):
    cv_arg: TypeAlias = NonSpare_1739.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1739

    @classmethod
    def create(cls, arg : "Item_912.cv_arg") -> "Item_912":
        return cls._create(arg) # type: ignore

class NonSpare_1540(NonSpare):
    cv_arg: TypeAlias = RuleVariation_918.cv_arg
    cv_name = "RAB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_918

    @classmethod
    def create(cls, arg : "NonSpare_1540.cv_arg") -> "NonSpare_1540":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_918:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_948:
        return self.rule.variation

class Item_770(Item):
    cv_arg: TypeAlias = NonSpare_1540.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1540

    @classmethod
    def create(cls, arg : "Item_770.cv_arg") -> "Item_770":
        return cls._create(arg) # type: ignore

class NonSpare_1934(NonSpare):
    cv_arg: TypeAlias = RuleVariation_73.cv_arg
    cv_name = "TST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_73

    @classmethod
    def create(cls, arg : "NonSpare_1934.cv_arg") -> "NonSpare_1934":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_73:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_73:
        return self.rule.variation

class Item_1051(Item):
    cv_arg: TypeAlias = NonSpare_1934.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1934

    @classmethod
    def create(cls, arg : "Item_1051.cv_arg") -> "Item_1051":
        return cls._create(arg) # type: ignore

class NonSpare_958(NonSpare):
    cv_arg: TypeAlias = RuleVariation_429.cv_arg
    cv_name = "ERR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_429

    @classmethod
    def create(cls, arg : "NonSpare_958.cv_arg") -> "NonSpare_958":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_429:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_440:
        return self.rule.variation

class Item_318(Item):
    cv_arg: TypeAlias = NonSpare_958.cv_arg
    cv_non_spare: TypeAlias = NonSpare_958

    @classmethod
    def create(cls, arg : "Item_318.cv_arg") -> "Item_318":
        return cls._create(arg) # type: ignore

class NonSpare_2121(NonSpare):
    cv_arg: TypeAlias = RuleVariation_548.cv_arg
    cv_name = "XPP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_548

    @classmethod
    def create(cls, arg : "NonSpare_2121.cv_arg") -> "NonSpare_2121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_548:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_559:
        return self.rule.variation

class Item_1219(Item):
    cv_arg: TypeAlias = NonSpare_2121.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2121

    @classmethod
    def create(cls, arg : "Item_1219.cv_arg") -> "Item_1219":
        return cls._create(arg) # type: ignore

class NonSpare_1267(NonSpare):
    cv_arg: TypeAlias = RuleVariation_642.cv_arg
    cv_name = "ME"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_642

    @classmethod
    def create(cls, arg : "NonSpare_1267.cv_arg") -> "NonSpare_1267":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_642:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_653:
        return self.rule.variation

class Item_545(Item):
    cv_arg: TypeAlias = NonSpare_1267.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1267

    @classmethod
    def create(cls, arg : "Item_545.cv_arg") -> "Item_545":
        return cls._create(arg) # type: ignore

class NonSpare_1285(NonSpare):
    cv_arg: TypeAlias = RuleVariation_730.cv_arg
    cv_name = "MI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_730

    @classmethod
    def create(cls, arg : "NonSpare_1285.cv_arg") -> "NonSpare_1285":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_730:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_741:
        return self.rule.variation

class Item_552(Item):
    cv_arg: TypeAlias = NonSpare_1285.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1285

    @classmethod
    def create(cls, arg : "Item_552.cv_arg") -> "Item_552":
        return cls._create(arg) # type: ignore

class NonSpare_980(NonSpare):
    cv_arg: TypeAlias = RuleVariation_850.cv_arg
    cv_name = "FOEFRI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_850

    @classmethod
    def create(cls, arg : "NonSpare_980.cv_arg") -> "NonSpare_980":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_850:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_880:
        return self.rule.variation

class Item_334(Item):
    cv_arg: TypeAlias = NonSpare_980.cv_arg
    cv_non_spare: TypeAlias = NonSpare_980

    @classmethod
    def create(cls, arg : "Item_334.cv_arg") -> "Item_334":
        return cls._create(arg) # type: ignore

class Variation_1389(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_127.cv_arg, Tuple[Literal["TYP"], RuleVariation_127.cv_arg]], Union[RuleVariation_604.cv_arg, Tuple[Literal["SIM"], RuleVariation_604.cv_arg]], Union[RuleVariation_737.cv_arg, Tuple[Literal["RDP"], RuleVariation_737.cv_arg]], Union[RuleVariation_789.cv_arg, Tuple[Literal["SPI"], RuleVariation_789.cv_arg]], Union[RuleVariation_918.cv_arg, Tuple[Literal["RAB"], RuleVariation_918.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_73.cv_arg, Tuple[Literal["TST"], RuleVariation_73.cv_arg]], Union[RuleVariation_429.cv_arg, Tuple[Literal["ERR"], RuleVariation_429.cv_arg]], Union[RuleVariation_548.cv_arg, Tuple[Literal["XPP"], RuleVariation_548.cv_arg]], Union[RuleVariation_642.cv_arg, Tuple[Literal["ME"], RuleVariation_642.cv_arg]], Union[RuleVariation_730.cv_arg, Tuple[Literal["MI"], RuleVariation_730.cv_arg]], Union[RuleVariation_850.cv_arg, Tuple[Literal["FOEFRI"], RuleVariation_850.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1389.cv_arg_group_1"],
        Tuple["Variation_1389.cv_arg_group_1", "Variation_1389.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_1073, 3), (Item_901, 1), (Item_787, 1), (Item_912, 1), (Item_770, 1), None], [(Item_1051, 1), (Item_318, 1), (Item_1219, 1), (Item_545, 1), (Item_552, 1), (Item_334, 2), None]]

    @classmethod
    def create(cls, arg: "Variation_1389.cv_arg") -> 'Variation_1389':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_127:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_604:
        ...
    @overload
    def get_item(self, key : Literal["RDP"]) -> RuleVariation_737:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_789:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_918:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_73]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[RuleVariation_429]:
        ...
    @overload
    def get_item(self, key : Literal["XPP"]) -> Optional[RuleVariation_548]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_642]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_730]:
        ...
    @overload
    def get_item(self, key : Literal["FOEFRI"]) -> Optional[RuleVariation_850]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1310(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1389.cv_arg
    cv_variation: TypeAlias = Variation_1389

    @classmethod
    def create(cls, arg : "RuleVariation_1310.cv_arg") -> "RuleVariation_1310":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1389:
        return self.arg # type: ignore

class NonSpare_88(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1310.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1310

    @classmethod
    def create(cls, arg : "NonSpare_88.cv_arg") -> "NonSpare_88":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1310:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1389:
        return self.rule.variation

class UapItem_88(UapItem):
    cv_non_spare: TypeAlias = NonSpare_88

class NonSpare_139(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1130.cv_arg
    cv_name = "040"
    cv_title = "Measured Position in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1130

    @classmethod
    def create(cls, arg : "NonSpare_139.cv_arg") -> "NonSpare_139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1130:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1179:
        return self.rule.variation

class UapItem_139(UapItem):
    cv_non_spare: TypeAlias = NonSpare_139

class Variation_1265(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_542.cv_arg, Tuple[Literal["L"], RuleVariation_542.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1265.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_453, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_542, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_542:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1265.cv_arg") -> 'Variation_1265':
        return cls._create(arg) # type: ignore

class RuleVariation_1194(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1265.cv_arg
    cv_variation: TypeAlias = Variation_1265

    @classmethod
    def create(cls, arg : "RuleVariation_1194.cv_arg") -> "RuleVariation_1194":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1265:
        return self.arg # type: ignore

class NonSpare_211(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1194.cv_arg
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1194

    @classmethod
    def create(cls, arg : "NonSpare_211.cv_arg") -> "NonSpare_211":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1265:
        return self.rule.variation

class UapItem_211(UapItem):
    cv_non_spare: TypeAlias = NonSpare_211

class NonSpare_973(NonSpare):
    cv_arg: TypeAlias = RuleVariation_600.cv_arg
    cv_name = "FL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_600

    @classmethod
    def create(cls, arg : "NonSpare_973.cv_arg") -> "NonSpare_973":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_600:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_611:
        return self.rule.variation

class Item_330(Item):
    cv_arg: TypeAlias = NonSpare_973.cv_arg
    cv_non_spare: TypeAlias = NonSpare_973

    @classmethod
    def create(cls, arg : "Item_330.cv_arg") -> "Item_330":
        return cls._create(arg) # type: ignore

class Variation_1256(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_600.cv_arg, Tuple[Literal["FL"], RuleVariation_600.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1256.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_330, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "FL": RuleVariation_600}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_600:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_600:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1256.cv_arg") -> 'Variation_1256':
        return cls._create(arg) # type: ignore

class RuleVariation_1185(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1256.cv_arg
    cv_variation: TypeAlias = Variation_1256

    @classmethod
    def create(cls, arg : "RuleVariation_1185.cv_arg") -> "RuleVariation_1185":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1256:
        return self.arg # type: ignore

class NonSpare_249(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1185.cv_arg
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule: TypeAlias = RuleVariation_1185

    @classmethod
    def create(cls, arg : "NonSpare_249.cv_arg") -> "NonSpare_249":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1185:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1256:
        return self.rule.variation

class UapItem_249(UapItem):
    cv_non_spare: TypeAlias = NonSpare_249

class Content_792(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 4.39453125e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_791(RuleContentContextFree):
    cv_arg: TypeAlias = Content_792.cv_arg
    cv_content: TypeAlias = Content_792

    @property
    def content(self) -> Content_792:
        return self._get_content() # type: ignore

class Variation_245(Element):
    cv_arg: TypeAlias = RuleContent_791.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_791

    @classmethod
    def create(cls, arg: "Variation_245.cv_arg") -> "Variation_245":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_791:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_792:
        return self.rule.content

class RuleVariation_238(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_245.cv_arg
    cv_variation: TypeAlias = Variation_245

    @classmethod
    def create(cls, arg : "RuleVariation_238.cv_arg") -> "RuleVariation_238":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_245:
        return self.arg # type: ignore

class NonSpare_1753(NonSpare):
    cv_arg: TypeAlias = RuleVariation_238.cv_arg
    cv_name = "SRL"
    cv_title = "SSR Plot Runlength"
    cv_rule: TypeAlias = RuleVariation_238

    @classmethod
    def create(cls, arg : "NonSpare_1753.cv_arg") -> "NonSpare_1753":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_238:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_245:
        return self.rule.variation

class NonSpare_1754(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "SRR"
    cv_title = "Number of Received Replies for (M)SSR"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1754.cv_arg") -> "NonSpare_1754":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class NonSpare_1662(NonSpare):
    cv_arg: TypeAlias = RuleVariation_201.cv_arg
    cv_name = "SAM"
    cv_title = "Amplitude of (M)SSR Reply"
    cv_rule: TypeAlias = RuleVariation_201

    @classmethod
    def create(cls, arg : "NonSpare_1662.cv_arg") -> "NonSpare_1662":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_208:
        return self.rule.variation

class NonSpare_1468(NonSpare):
    cv_arg: TypeAlias = RuleVariation_238.cv_arg
    cv_name = "PRL"
    cv_title = "Primary Plot Runlength"
    cv_rule: TypeAlias = RuleVariation_238

    @classmethod
    def create(cls, arg : "NonSpare_1468.cv_arg") -> "NonSpare_1468":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_238:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_245:
        return self.rule.variation

class NonSpare_1422(NonSpare):
    cv_arg: TypeAlias = RuleVariation_201.cv_arg
    cv_name = "PAM"
    cv_title = "Amplitude of Primary Plot"
    cv_rule: TypeAlias = RuleVariation_201

    @classmethod
    def create(cls, arg : "NonSpare_1422.cv_arg") -> "NonSpare_1422":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_208:
        return self.rule.variation

class Content_680(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 3.90625e-3
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_680(RuleContentContextFree):
    cv_arg: TypeAlias = Content_680.cv_arg
    cv_content: TypeAlias = Content_680

    @property
    def content(self) -> Content_680:
        return self._get_content() # type: ignore

class Variation_217(Element):
    cv_arg: TypeAlias = RuleContent_680.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_680

    @classmethod
    def create(cls, arg: "Variation_217.cv_arg") -> "Variation_217":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_680:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_680:
        return self.rule.content

class RuleVariation_210(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_217.cv_arg
    cv_variation: TypeAlias = Variation_217

    @classmethod
    def create(cls, arg : "RuleVariation_210.cv_arg") -> "RuleVariation_210":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_217:
        return self.arg # type: ignore

class NonSpare_1605(NonSpare):
    cv_arg: TypeAlias = RuleVariation_210.cv_arg
    cv_name = "RPD"
    cv_title = "Difference in Range Between PSR and SSR Plot"
    cv_rule: TypeAlias = RuleVariation_210

    @classmethod
    def create(cls, arg : "NonSpare_1605.cv_arg") -> "NonSpare_1605":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_210:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_217:
        return self.rule.variation

class NonSpare_617(NonSpare):
    cv_arg: TypeAlias = RuleVariation_213.cv_arg
    cv_name = "APD"
    cv_title = "Difference in Azimuth Between PSR and SSR Plot"
    cv_rule: TypeAlias = RuleVariation_213

    @classmethod
    def create(cls, arg : "NonSpare_617.cv_arg") -> "NonSpare_617":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_213:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_220:
        return self.rule.variation

class Variation_1508(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SRL": NonSpare_1753.cv_arg,
        "SRR": NonSpare_1754.cv_arg,
        "SAM": NonSpare_1662.cv_arg,
        "PRL": NonSpare_1468.cv_arg,
        "PAM": NonSpare_1422.cv_arg,
        "RPD": NonSpare_1605.cv_arg,
        "APD": NonSpare_617.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1753, NonSpare_1754, NonSpare_1662, NonSpare_1468, NonSpare_1422, NonSpare_1605, NonSpare_617]
    cv_items_dict = {"SRL": NonSpare_1753, "SRR": NonSpare_1754, "SAM": NonSpare_1662, "PRL": NonSpare_1468, "PAM": NonSpare_1422, "RPD": NonSpare_1605, "APD": NonSpare_617}

    @overload
    @classmethod
    def spec(cls, key : Literal["SRL"]) -> NonSpare_1753:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRR"]) -> NonSpare_1754:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAM"]) -> NonSpare_1662:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PRL"]) -> NonSpare_1468:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PAM"]) -> NonSpare_1422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RPD"]) -> NonSpare_1605:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["APD"]) -> NonSpare_617:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SRL"], Literal["SRR"], Literal["SAM"], Literal["PRL"], Literal["PAM"], Literal["RPD"], Literal["APD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SRL"]) -> Optional[NonSpare_1753]:
        ...
    @overload
    def get_item(self, key : Literal["SRR"]) -> Optional[NonSpare_1754]:
        ...
    @overload
    def get_item(self, key : Literal["SAM"]) -> Optional[NonSpare_1662]:
        ...
    @overload
    def get_item(self, key : Literal["PRL"]) -> Optional[NonSpare_1468]:
        ...
    @overload
    def get_item(self, key : Literal["PAM"]) -> Optional[NonSpare_1422]:
        ...
    @overload
    def get_item(self, key : Literal["RPD"]) -> Optional[NonSpare_1605]:
        ...
    @overload
    def get_item(self, key : Literal["APD"]) -> Optional[NonSpare_617]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SRL"], val : NonSpare_1753.cv_arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["SRR"], val : NonSpare_1754.cv_arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["SAM"], val : NonSpare_1662.cv_arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["PRL"], val : NonSpare_1468.cv_arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["PAM"], val : NonSpare_1422.cv_arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["RPD"], val : NonSpare_1605.cv_arg) -> "Variation_1508":
        ...
    @overload
    def set_item(self, key : Literal["APD"], val : NonSpare_617.cv_arg) -> "Variation_1508":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SRL"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["SRR"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["SAM"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["PRL"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["PAM"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["RPD"]) -> "Variation_1508":
        ...
    @overload
    def del_item(self, key : Literal["APD"]) -> "Variation_1508":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1508.cv_arg") -> 'Variation_1508':
        return cls._create(arg) # type: ignore

class RuleVariation_1429(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1508.cv_arg
    cv_variation: TypeAlias = Variation_1508

    @classmethod
    def create(cls, arg : "RuleVariation_1429.cv_arg") -> "RuleVariation_1429":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1508:
        return self.arg # type: ignore

class NonSpare_313(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1429.cv_arg
    cv_name = "130"
    cv_title = "Radar Plot Characteristics"
    cv_rule: TypeAlias = RuleVariation_1429

    @classmethod
    def create(cls, arg : "NonSpare_313.cv_arg") -> "NonSpare_313":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1429:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1508:
        return self.rule.variation

class UapItem_313(UapItem):
    cv_non_spare: TypeAlias = NonSpare_313

class NonSpare_420(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "220"
    cv_title = "Aircraft Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_420.cv_arg") -> "NonSpare_420":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_420(UapItem):
    cv_non_spare: TypeAlias = NonSpare_420

class NonSpare_436(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "240"
    cv_title = "Aircraft Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_436.cv_arg") -> "NonSpare_436":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_436(UapItem):
    cv_non_spare: TypeAlias = NonSpare_436

class NonSpare_1237(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "MBDATA"
    cv_title = "Mode S Comm B Message Data"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_1237.cv_arg") -> "NonSpare_1237":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class Item_533(Item):
    cv_arg: TypeAlias = NonSpare_1237.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1237

    @classmethod
    def create(cls, arg : "Item_533.cv_arg") -> "Item_533":
        return cls._create(arg) # type: ignore

class Variation_1144(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_384.cv_arg, Tuple[Literal["MBDATA"], RuleVariation_384.cv_arg]], Union[RuleVariation_132.cv_arg, Tuple[Literal["BDS1"], RuleVariation_132.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["BDS2"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1144.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_533, 56), (Item_116, 4), (Item_118, 4)]
    cv_items_dict = {"MBDATA": RuleVariation_384, "BDS1": RuleVariation_132, "BDS2": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["MBDATA"]) -> RuleVariation_384:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS1"]) -> RuleVariation_132:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDS2"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MBDATA"], Literal["BDS1"], Literal["BDS2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MBDATA"]) -> RuleVariation_384:
        ...
    @overload
    def get_item(self, key : Literal["BDS1"]) -> RuleVariation_132:
        ...
    @overload
    def get_item(self, key : Literal["BDS2"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1144.cv_arg") -> 'Variation_1144':
        return cls._create(arg) # type: ignore

class Variation_1423(Repetitive):
    cv_arg: TypeAlias = List[Variation_1144.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1144

    @classmethod
    def create(cls, arg: "Variation_1423.cv_arg") -> 'Variation_1423':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1144]:
        return self._get_list() # type: ignore

class RuleVariation_1344(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1423.cv_arg
    cv_variation: TypeAlias = Variation_1423

    @classmethod
    def create(cls, arg : "RuleVariation_1344.cv_arg") -> "RuleVariation_1344":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1423:
        return self.arg # type: ignore

class NonSpare_450(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1344.cv_arg
    cv_name = "250"
    cv_title = "Mode S MB Data"
    cv_rule: TypeAlias = RuleVariation_1344

    @classmethod
    def create(cls, arg : "NonSpare_450.cv_arg") -> "NonSpare_450":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1423:
        return self.rule.variation

class UapItem_450(UapItem):
    cv_non_spare: TypeAlias = NonSpare_450

class NonSpare_364(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1003.cv_arg
    cv_name = "161"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_1003

    @classmethod
    def create(cls, arg : "NonSpare_364.cv_arg") -> "NonSpare_364":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1003:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1035:
        return self.rule.variation

class UapItem_364(UapItem):
    cv_non_spare: TypeAlias = NonSpare_364

class NonSpare_2147(NonSpare):
    cv_arg: TypeAlias = RuleVariation_280.cv_arg
    cv_name = "Y"
    cv_title = "X-Component"
    cv_rule: TypeAlias = RuleVariation_280

    @classmethod
    def create(cls, arg : "NonSpare_2147.cv_arg") -> "NonSpare_2147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_280:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_287:
        return self.rule.variation

class Item_1245(Item):
    cv_arg: TypeAlias = NonSpare_2147.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2147

    @classmethod
    def create(cls, arg : "Item_1245.cv_arg") -> "Item_1245":
        return cls._create(arg) # type: ignore

class Variation_1314(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_280.cv_arg, Tuple[Literal["X"], RuleVariation_280.cv_arg]], Union[RuleVariation_280.cv_arg, Tuple[Literal["Y"], RuleVariation_280.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1314.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1201, 16), (Item_1245, 16)]
    cv_items_dict = {"X": RuleVariation_280, "Y": RuleVariation_280}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_280:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_280:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_280:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1314.cv_arg") -> 'Variation_1314':
        return cls._create(arg) # type: ignore

class RuleVariation_1241(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1314.cv_arg
    cv_variation: TypeAlias = Variation_1314

    @classmethod
    def create(cls, arg : "RuleVariation_1241.cv_arg") -> "RuleVariation_1241":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1314:
        return self.arg # type: ignore

class NonSpare_160(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1241.cv_arg
    cv_name = "042"
    cv_title = "Calculated Position in Cartesian Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1241

    @classmethod
    def create(cls, arg : "NonSpare_160.cv_arg") -> "NonSpare_160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1241:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1314:
        return self.rule.variation

class UapItem_160(UapItem):
    cv_non_spare: TypeAlias = NonSpare_160

class NonSpare_390(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1072.cv_arg
    cv_name = "200"
    cv_title = "Calculated Track Velocity in Polar Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1072

    @classmethod
    def create(cls, arg : "NonSpare_390.cv_arg") -> "NonSpare_390":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1072:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1114:
        return self.rule.variation

class UapItem_390(UapItem):
    cv_non_spare: TypeAlias = NonSpare_390

class Variation_16(Element):
    cv_arg: TypeAlias = RuleContent_60.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_60

    @classmethod
    def create(cls, arg: "Variation_16.cv_arg") -> "Variation_16":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_60:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_60:
        return self.rule.content

class RuleVariation_16(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_16.cv_arg
    cv_variation: TypeAlias = Variation_16

    @classmethod
    def create(cls, arg : "RuleVariation_16.cv_arg") -> "RuleVariation_16":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_16:
        return self.arg # type: ignore

class Content_58(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Combined Track", 1: "PSR Track", 2: "SSR/Mode S Track", 3: "Invalid"}

class RuleContent_58(RuleContentContextFree):
    cv_arg: TypeAlias = Content_58.cv_arg
    cv_content: TypeAlias = Content_58

    @property
    def content(self) -> Content_58:
        return self._get_content() # type: ignore

class Variation_466(Element):
    cv_arg: TypeAlias = RuleContent_58.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_58

    @classmethod
    def create(cls, arg: "Variation_466.cv_arg") -> "Variation_466":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_58:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_58:
        return self.rule.content

class RuleVariation_455(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_466.cv_arg
    cv_variation: TypeAlias = Variation_466

    @classmethod
    def create(cls, arg : "RuleVariation_455.cv_arg") -> "RuleVariation_455":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_466:
        return self.arg # type: ignore

class Content_384(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Normal confidence", 1: "Low confidence in plot to track association"}

class RuleContent_384(RuleContentContextFree):
    cv_arg: TypeAlias = Content_384.cv_arg
    cv_content: TypeAlias = Content_384

    @property
    def content(self) -> Content_384:
        return self._get_content() # type: ignore

class Variation_656(Element):
    cv_arg: TypeAlias = RuleContent_384.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_384

    @classmethod
    def create(cls, arg: "Variation_656.cv_arg") -> "Variation_656":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_384:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_384:
        return self.rule.content

class RuleVariation_645(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_656.cv_arg
    cv_variation: TypeAlias = Variation_656

    @classmethod
    def create(cls, arg : "RuleVariation_645.cv_arg") -> "RuleVariation_645":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_656:
        return self.arg # type: ignore

class Content_362(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No horizontal man.sensed", 1: "Horizontal man. sensed"}

class RuleContent_362(RuleContentContextFree):
    cv_arg: TypeAlias = Content_362.cv_arg
    cv_content: TypeAlias = Content_362

    @property
    def content(self) -> Content_362:
        return self._get_content() # type: ignore

class Variation_739(Element):
    cv_arg: TypeAlias = RuleContent_362.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_362

    @classmethod
    def create(cls, arg: "Variation_739.cv_arg") -> "Variation_739":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_362:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_362:
        return self.rule.content

class RuleVariation_728(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_739.cv_arg
    cv_variation: TypeAlias = Variation_739

    @classmethod
    def create(cls, arg : "RuleVariation_728.cv_arg") -> "RuleVariation_728":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_739:
        return self.arg # type: ignore

class Content_264(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Maintaining", 1: "Climbing", 2: "Descending", 3: "Unknown"}

class RuleContent_264(RuleContentContextFree):
    cv_arg: TypeAlias = Content_264.cv_arg
    cv_content: TypeAlias = Content_264

    @property
    def content(self) -> Content_264:
        return self._get_content() # type: ignore

class Variation_878(Element):
    cv_arg: TypeAlias = RuleContent_264.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_264

    @classmethod
    def create(cls, arg: "Variation_878.cv_arg") -> "Variation_878":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_264:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_264:
        return self.rule.content

class RuleVariation_848(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_878.cv_arg
    cv_variation: TypeAlias = Variation_878

    @classmethod
    def create(cls, arg : "RuleVariation_848.cv_arg") -> "RuleVariation_848":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_878:
        return self.arg # type: ignore

class Content_514(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Track still alive", 1: "End of track lifetime(last report for this track)"}

class RuleContent_514(RuleContentContextFree):
    cv_arg: TypeAlias = Content_514.cv_arg
    cv_content: TypeAlias = Content_514

    @property
    def content(self) -> Content_514:
        return self._get_content() # type: ignore

class Variation_91(Element):
    cv_arg: TypeAlias = RuleContent_514.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_514

    @classmethod
    def create(cls, arg: "Variation_91.cv_arg") -> "Variation_91":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_514:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_514:
        return self.rule.content

class RuleVariation_91(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_91.cv_arg
    cv_variation: TypeAlias = Variation_91

    @classmethod
    def create(cls, arg : "RuleVariation_91.cv_arg") -> "RuleVariation_91":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_91:
        return self.arg # type: ignore

class Content_527(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "True target track", 1: "Ghost target track"}

class RuleContent_527(RuleContentContextFree):
    cv_arg: TypeAlias = Content_527.cv_arg
    cv_content: TypeAlias = Content_527

    @property
    def content(self) -> Content_527:
        return self._get_content() # type: ignore

class Variation_463(Element):
    cv_arg: TypeAlias = RuleContent_527.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_527

    @classmethod
    def create(cls, arg: "Variation_463.cv_arg") -> "Variation_463":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_527:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_527:
        return self.rule.content

class RuleVariation_452(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_463.cv_arg
    cv_variation: TypeAlias = Variation_463

    @classmethod
    def create(cls, arg : "RuleVariation_452.cv_arg") -> "RuleVariation_452":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_463:
        return self.arg # type: ignore

class Content_516(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Tracking performed in so-called 'Radar Plane', i.e. neither slant range correction nor stereographical projection was applied", 1: "Slant range correction and a suitable projection technique are used to track in a 2D.reference plane, tangential to the earth model at the Radar Site co-ordinates"}

class RuleContent_516(RuleContentContextFree):
    cv_arg: TypeAlias = Content_516.cv_arg
    cv_content: TypeAlias = Content_516

    @property
    def content(self) -> Content_516:
        return self._get_content() # type: ignore

class Variation_667(Element):
    cv_arg: TypeAlias = RuleContent_516.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_516

    @classmethod
    def create(cls, arg: "Variation_667.cv_arg") -> "Variation_667":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_516:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_516:
        return self.rule.content

class RuleVariation_656(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_667.cv_arg
    cv_variation: TypeAlias = Variation_667

    @classmethod
    def create(cls, arg : "RuleVariation_656.cv_arg") -> "RuleVariation_656":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_667:
        return self.arg # type: ignore

class NonSpare_750(NonSpare):
    cv_arg: TypeAlias = RuleVariation_16.cv_arg
    cv_name = "CNF"
    cv_title = "Confirmed Vs. Tentative Track"
    cv_rule: TypeAlias = RuleVariation_16

    @classmethod
    def create(cls, arg : "NonSpare_750.cv_arg") -> "NonSpare_750":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_16:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_16:
        return self.rule.variation

class Item_168(Item):
    cv_arg: TypeAlias = NonSpare_750.cv_arg
    cv_non_spare: TypeAlias = NonSpare_750

    @classmethod
    def create(cls, arg : "Item_168.cv_arg") -> "Item_168":
        return cls._create(arg) # type: ignore

class NonSpare_1545(NonSpare):
    cv_arg: TypeAlias = RuleVariation_455.cv_arg
    cv_name = "RAD"
    cv_title = "Type of Sensor(s) Maintaining Track"
    cv_rule: TypeAlias = RuleVariation_455

    @classmethod
    def create(cls, arg : "NonSpare_1545.cv_arg") -> "NonSpare_1545":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_455:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_466:
        return self.rule.variation

class Item_775(Item):
    cv_arg: TypeAlias = NonSpare_1545.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1545

    @classmethod
    def create(cls, arg : "Item_775.cv_arg") -> "Item_775":
        return cls._create(arg) # type: ignore

class NonSpare_895(NonSpare):
    cv_arg: TypeAlias = RuleVariation_645.cv_arg
    cv_name = "DOU"
    cv_title = "Signals Level of Confidence in Plot to Track Association Process"
    cv_rule: TypeAlias = RuleVariation_645

    @classmethod
    def create(cls, arg : "NonSpare_895.cv_arg") -> "NonSpare_895":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_645:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_656:
        return self.rule.variation

class Item_270(Item):
    cv_arg: TypeAlias = NonSpare_895.cv_arg
    cv_non_spare: TypeAlias = NonSpare_895

    @classmethod
    def create(cls, arg : "Item_270.cv_arg") -> "Item_270":
        return cls._create(arg) # type: ignore

class NonSpare_1226(NonSpare):
    cv_arg: TypeAlias = RuleVariation_728.cv_arg
    cv_name = "MAH"
    cv_title = "Manoeuvre Detection in Horizontal Sense"
    cv_rule: TypeAlias = RuleVariation_728

    @classmethod
    def create(cls, arg : "NonSpare_1226.cv_arg") -> "NonSpare_1226":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_728:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_739:
        return self.rule.variation

class Item_526(Item):
    cv_arg: TypeAlias = NonSpare_1226.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1226

    @classmethod
    def create(cls, arg : "Item_526.cv_arg") -> "Item_526":
        return cls._create(arg) # type: ignore

class NonSpare_715(NonSpare):
    cv_arg: TypeAlias = RuleVariation_848.cv_arg
    cv_name = "CDM"
    cv_title = "Climbing / Descending Mode"
    cv_rule: TypeAlias = RuleVariation_848

    @classmethod
    def create(cls, arg : "NonSpare_715.cv_arg") -> "NonSpare_715":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_848:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_878:
        return self.rule.variation

class Item_141(Item):
    cv_arg: TypeAlias = NonSpare_715.cv_arg
    cv_non_spare: TypeAlias = NonSpare_715

    @classmethod
    def create(cls, arg : "Item_141.cv_arg") -> "Item_141":
        return cls._create(arg) # type: ignore

class NonSpare_1916(NonSpare):
    cv_arg: TypeAlias = RuleVariation_91.cv_arg
    cv_name = "TRE"
    cv_title = "Signal for End_of_Track"
    cv_rule: TypeAlias = RuleVariation_91

    @classmethod
    def create(cls, arg : "NonSpare_1916.cv_arg") -> "NonSpare_1916":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_91:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_91:
        return self.rule.variation

class Item_1037(Item):
    cv_arg: TypeAlias = NonSpare_1916.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1916

    @classmethod
    def create(cls, arg : "Item_1037.cv_arg") -> "Item_1037":
        return cls._create(arg) # type: ignore

class NonSpare_1037(NonSpare):
    cv_arg: TypeAlias = RuleVariation_452.cv_arg
    cv_name = "GHO"
    cv_title = "Ghost Vs. True Target"
    cv_rule: TypeAlias = RuleVariation_452

    @classmethod
    def create(cls, arg : "NonSpare_1037.cv_arg") -> "NonSpare_1037":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_452:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_463:
        return self.rule.variation

class Item_372(Item):
    cv_arg: TypeAlias = NonSpare_1037.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1037

    @classmethod
    def create(cls, arg : "Item_372.cv_arg") -> "Item_372":
        return cls._create(arg) # type: ignore

class NonSpare_1812(NonSpare):
    cv_arg: TypeAlias = RuleVariation_547.cv_arg
    cv_name = "SUP"
    cv_title = "Track Maintained with Track Information from Neighbouring Node B on the Cluster, or Network"
    cv_rule: TypeAlias = RuleVariation_547

    @classmethod
    def create(cls, arg : "NonSpare_1812.cv_arg") -> "NonSpare_1812":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_547:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_558:
        return self.rule.variation

class Item_964(Item):
    cv_arg: TypeAlias = NonSpare_1812.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1812

    @classmethod
    def create(cls, arg : "Item_964.cv_arg") -> "Item_964":
        return cls._create(arg) # type: ignore

class NonSpare_1841(NonSpare):
    cv_arg: TypeAlias = RuleVariation_656.cv_arg
    cv_name = "TCC"
    cv_title = "Type of Plot Coordinate Transformation Mechanism:"
    cv_rule: TypeAlias = RuleVariation_656

    @classmethod
    def create(cls, arg : "NonSpare_1841.cv_arg") -> "NonSpare_1841":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_656:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_667:
        return self.rule.variation

class Item_980(Item):
    cv_arg: TypeAlias = NonSpare_1841.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1841

    @classmethod
    def create(cls, arg : "Item_980.cv_arg") -> "Item_980":
        return cls._create(arg) # type: ignore

class Variation_1354(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_16.cv_arg, Tuple[Literal["CNF"], RuleVariation_16.cv_arg]], Union[RuleVariation_455.cv_arg, Tuple[Literal["RAD"], RuleVariation_455.cv_arg]], Union[RuleVariation_645.cv_arg, Tuple[Literal["DOU"], RuleVariation_645.cv_arg]], Union[RuleVariation_728.cv_arg, Tuple[Literal["MAH"], RuleVariation_728.cv_arg]], Union[RuleVariation_848.cv_arg, Tuple[Literal["CDM"], RuleVariation_848.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_91.cv_arg, Tuple[Literal["TRE"], RuleVariation_91.cv_arg]], Union[RuleVariation_452.cv_arg, Tuple[Literal["GHO"], RuleVariation_452.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["SUP"], RuleVariation_547.cv_arg]], Union[RuleVariation_656.cv_arg, Tuple[Literal["TCC"], RuleVariation_656.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1354.cv_arg_group_1"],
        Tuple["Variation_1354.cv_arg_group_1", "Variation_1354.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_168, 1), (Item_775, 2), (Item_270, 1), (Item_526, 1), (Item_141, 2), None], [(Item_1037, 1), (Item_372, 1), (Item_964, 1), (Item_980, 1), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1354.cv_arg") -> 'Variation_1354':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_16:
        ...
    @overload
    def get_item(self, key : Literal["RAD"]) -> RuleVariation_455:
        ...
    @overload
    def get_item(self, key : Literal["DOU"]) -> RuleVariation_645:
        ...
    @overload
    def get_item(self, key : Literal["MAH"]) -> RuleVariation_728:
        ...
    @overload
    def get_item(self, key : Literal["CDM"]) -> RuleVariation_848:
        ...
    @overload
    def get_item(self, key : Literal["TRE"]) -> Optional[RuleVariation_91]:
        ...
    @overload
    def get_item(self, key : Literal["GHO"]) -> Optional[RuleVariation_452]:
        ...
    @overload
    def get_item(self, key : Literal["SUP"]) -> Optional[RuleVariation_547]:
        ...
    @overload
    def get_item(self, key : Literal["TCC"]) -> Optional[RuleVariation_656]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1275(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1354.cv_arg
    cv_variation: TypeAlias = Variation_1354

    @classmethod
    def create(cls, arg : "RuleVariation_1275.cv_arg") -> "RuleVariation_1275":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1354:
        return self.arg # type: ignore

class NonSpare_377(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1275.cv_arg
    cv_name = "170"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1275

    @classmethod
    def create(cls, arg : "NonSpare_377.cv_arg") -> "NonSpare_377":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1275:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1354:
        return self.rule.variation

class UapItem_377(UapItem):
    cv_non_spare: TypeAlias = NonSpare_377

class Variation_237(Element):
    cv_arg: TypeAlias = RuleContent_765.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_765

    @classmethod
    def create(cls, arg: "Variation_237.cv_arg") -> "Variation_237":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_765:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_766:
        return self.rule.content

class RuleVariation_230(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_237.cv_arg
    cv_variation: TypeAlias = Variation_237

    @classmethod
    def create(cls, arg : "RuleVariation_230.cv_arg") -> "RuleVariation_230":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_237:
        return self.arg # type: ignore

class NonSpare_1718(NonSpare):
    cv_arg: TypeAlias = RuleVariation_230.cv_arg
    cv_name = "SIGX"
    cv_title = "Sigma (X)) Standard Deviation on the Horizontal Axis of the Local Grid System"
    cv_rule: TypeAlias = RuleVariation_230

    @classmethod
    def create(cls, arg : "NonSpare_1718.cv_arg") -> "NonSpare_1718":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_230:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_237:
        return self.rule.variation

class Item_893(Item):
    cv_arg: TypeAlias = NonSpare_1718.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1718

    @classmethod
    def create(cls, arg : "Item_893.cv_arg") -> "Item_893":
        return cls._create(arg) # type: ignore

class NonSpare_1719(NonSpare):
    cv_arg: TypeAlias = RuleVariation_230.cv_arg
    cv_name = "SIGY"
    cv_title = "Sigma (Y)) Standard Deviation on the Vertical Axis of the Local Grid System"
    cv_rule: TypeAlias = RuleVariation_230

    @classmethod
    def create(cls, arg : "NonSpare_1719.cv_arg") -> "NonSpare_1719":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_230:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_237:
        return self.rule.variation

class Item_894(Item):
    cv_arg: TypeAlias = NonSpare_1719.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1719

    @classmethod
    def create(cls, arg : "Item_894.cv_arg") -> "Item_894":
        return cls._create(arg) # type: ignore

class Variation_240(Element):
    cv_arg: TypeAlias = RuleContent_777.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_777

    @classmethod
    def create(cls, arg: "Variation_240.cv_arg") -> "Variation_240":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_777:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_778:
        return self.rule.content

class RuleVariation_233(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_240.cv_arg
    cv_variation: TypeAlias = Variation_240

    @classmethod
    def create(cls, arg : "RuleVariation_233.cv_arg") -> "RuleVariation_233":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_240:
        return self.arg # type: ignore

class NonSpare_1717(NonSpare):
    cv_arg: TypeAlias = RuleVariation_233.cv_arg
    cv_name = "SIGV"
    cv_title = "Sigma (V)) Standard Deviation on the Groundspeed Within the Local Grid System"
    cv_rule: TypeAlias = RuleVariation_233

    @classmethod
    def create(cls, arg : "NonSpare_1717.cv_arg") -> "NonSpare_1717":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_233:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_240:
        return self.rule.variation

class Item_892(Item):
    cv_arg: TypeAlias = NonSpare_1717.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1717

    @classmethod
    def create(cls, arg : "Item_892.cv_arg") -> "Item_892":
        return cls._create(arg) # type: ignore

class Content_791(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 8.7890625e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_790(RuleContentContextFree):
    cv_arg: TypeAlias = Content_791.cv_arg
    cv_content: TypeAlias = Content_791

    @property
    def content(self) -> Content_791:
        return self._get_content() # type: ignore

class Variation_244(Element):
    cv_arg: TypeAlias = RuleContent_790.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_790

    @classmethod
    def create(cls, arg: "Variation_244.cv_arg") -> "Variation_244":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_790:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_791:
        return self.rule.content

class RuleVariation_237(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_244.cv_arg
    cv_variation: TypeAlias = Variation_244

    @classmethod
    def create(cls, arg : "RuleVariation_237.cv_arg") -> "RuleVariation_237":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_244:
        return self.arg # type: ignore

class NonSpare_1716(NonSpare):
    cv_arg: TypeAlias = RuleVariation_237.cv_arg
    cv_name = "SIGH"
    cv_title = "Sigma (H)) Standard Deviation on the Heading Within the Local Grid System"
    cv_rule: TypeAlias = RuleVariation_237

    @classmethod
    def create(cls, arg : "NonSpare_1716.cv_arg") -> "NonSpare_1716":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_237:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_244:
        return self.rule.variation

class Item_891(Item):
    cv_arg: TypeAlias = NonSpare_1716.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1716

    @classmethod
    def create(cls, arg : "Item_891.cv_arg") -> "Item_891":
        return cls._create(arg) # type: ignore

class Variation_1211(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_230.cv_arg, Tuple[Literal["SIGX"], RuleVariation_230.cv_arg]], Union[RuleVariation_230.cv_arg, Tuple[Literal["SIGY"], RuleVariation_230.cv_arg]], Union[RuleVariation_233.cv_arg, Tuple[Literal["SIGV"], RuleVariation_233.cv_arg]], Union[RuleVariation_237.cv_arg, Tuple[Literal["SIGH"], RuleVariation_237.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1211.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_893, 8), (Item_894, 8), (Item_892, 8), (Item_891, 8)]
    cv_items_dict = {"SIGX": RuleVariation_230, "SIGY": RuleVariation_230, "SIGV": RuleVariation_233, "SIGH": RuleVariation_237}

    @overload
    @classmethod
    def spec(cls, key : Literal["SIGX"]) -> RuleVariation_230:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIGY"]) -> RuleVariation_230:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIGV"]) -> RuleVariation_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIGH"]) -> RuleVariation_237:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SIGX"], Literal["SIGY"], Literal["SIGV"], Literal["SIGH"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SIGX"]) -> RuleVariation_230:
        ...
    @overload
    def get_item(self, key : Literal["SIGY"]) -> RuleVariation_230:
        ...
    @overload
    def get_item(self, key : Literal["SIGV"]) -> RuleVariation_233:
        ...
    @overload
    def get_item(self, key : Literal["SIGH"]) -> RuleVariation_237:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1211.cv_arg") -> 'Variation_1211':
        return cls._create(arg) # type: ignore

class RuleVariation_1155(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1211.cv_arg
    cv_variation: TypeAlias = Variation_1211

    @classmethod
    def create(cls, arg : "RuleVariation_1155.cv_arg") -> "RuleVariation_1155":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1211:
        return self.arg # type: ignore

class NonSpare_416(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1155.cv_arg
    cv_name = "210"
    cv_title = "Track Quality"
    cv_rule: TypeAlias = RuleVariation_1155

    @classmethod
    def create(cls, arg : "NonSpare_416.cv_arg") -> "NonSpare_416":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1155:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1211:
        return self.rule.variation

class UapItem_416(UapItem):
    cv_non_spare: TypeAlias = NonSpare_416

class Content_393(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected"}

class RuleContent_393(RuleContentContextFree):
    cv_arg: TypeAlias = Content_393.cv_arg
    cv_content: TypeAlias = Content_393

    @property
    def content(self) -> Content_393:
        return self._get_content() # type: ignore

class Variation_153(Element):
    cv_arg: TypeAlias = RuleContent_393.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_393

    @classmethod
    def create(cls, arg: "Variation_153.cv_arg") -> "Variation_153":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_393:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_393:
        return self.rule.content

class Variation_1456(Repetitive):
    cv_arg: TypeAlias = List[Variation_153.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_153

    @classmethod
    def create(cls, arg: "Variation_1456.cv_arg") -> 'Variation_1456':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_153]:
        return self._get_list() # type: ignore

class RuleVariation_1377(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1456.cv_arg
    cv_variation: TypeAlias = Variation_1456

    @classmethod
    def create(cls, arg : "RuleVariation_1377.cv_arg") -> "RuleVariation_1377":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1456:
        return self.arg # type: ignore

class NonSpare_119(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1377.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule: TypeAlias = RuleVariation_1377

    @classmethod
    def create(cls, arg : "NonSpare_119.cv_arg") -> "NonSpare_119":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1377:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1456:
        return self.rule.variation

class UapItem_119(UapItem):
    cv_non_spare: TypeAlias = NonSpare_119

class NonSpare_273(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1182.cv_arg
    cv_name = "100"
    cv_title = "Mode-C Code and Code Confidence Indicator"
    cv_rule: TypeAlias = RuleVariation_1182

    @classmethod
    def create(cls, arg : "NonSpare_273.cv_arg") -> "NonSpare_273":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1182:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1253:
        return self.rule.variation

class UapItem_273(UapItem):
    cv_non_spare: TypeAlias = NonSpare_273

class Variation_606(Element):
    cv_arg: TypeAlias = RuleContent_633.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_633

    @classmethod
    def create(cls, arg: "Variation_606.cv_arg") -> "Variation_606":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_633:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_633:
        return self.rule.content

class RuleVariation_595(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_606.cv_arg
    cv_variation: TypeAlias = Variation_606

    @classmethod
    def create(cls, arg : "RuleVariation_595.cv_arg") -> "RuleVariation_595":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_606:
        return self.arg # type: ignore

class NonSpare_495(NonSpare):
    cv_arg: TypeAlias = RuleVariation_595.cv_arg
    cv_name = "3DH"
    cv_title = "3D Height, in Binary Notation. Negative Values Are Expressed in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_595

    @classmethod
    def create(cls, arg : "NonSpare_495.cv_arg") -> "NonSpare_495":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_595:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_606:
        return self.rule.variation

class Item_32(Item):
    cv_arg: TypeAlias = NonSpare_495.cv_arg
    cv_non_spare: TypeAlias = NonSpare_495

    @classmethod
    def create(cls, arg : "Item_32.cv_arg") -> "Item_32":
        return cls._create(arg) # type: ignore

class Variation_1004(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_595.cv_arg, Tuple[Literal["3DH"], RuleVariation_595.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1004.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1, 2), (Item_32, 14)]
    cv_items_dict = {"3DH": RuleVariation_595}

    @classmethod
    def spec(cls, key : Literal["3DH"]) -> RuleVariation_595:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["3DH"]) -> RuleVariation_595:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1004.cv_arg") -> 'Variation_1004':
        return cls._create(arg) # type: ignore

class RuleVariation_974(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1004.cv_arg
    cv_variation: TypeAlias = Variation_1004

    @classmethod
    def create(cls, arg : "RuleVariation_974.cv_arg") -> "RuleVariation_974":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1004:
        return self.arg # type: ignore

class NonSpare_287(NonSpare):
    cv_arg: TypeAlias = RuleVariation_974.cv_arg
    cv_name = "110"
    cv_title = "Height Measured by a 3D Radar"
    cv_rule: TypeAlias = RuleVariation_974

    @classmethod
    def create(cls, arg : "NonSpare_287.cv_arg") -> "NonSpare_287":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_974:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1004:
        return self.rule.variation

class UapItem_287(UapItem):
    cv_non_spare: TypeAlias = NonSpare_287

class Content_200(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Doppler speed is valid", 1: "Doppler speed is doubtful"}

class RuleContent_200(RuleContentContextFree):
    cv_arg: TypeAlias = Content_200.cv_arg
    cv_content: TypeAlias = Content_200

    @property
    def content(self) -> Content_200:
        return self._get_content() # type: ignore

class Variation_40(Element):
    cv_arg: TypeAlias = RuleContent_200.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_200

    @classmethod
    def create(cls, arg: "Variation_40.cv_arg") -> "Variation_40":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_200:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_200:
        return self.rule.content

class RuleVariation_40(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_40.cv_arg
    cv_variation: TypeAlias = Variation_40

    @classmethod
    def create(cls, arg : "RuleVariation_40.cv_arg") -> "RuleVariation_40":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_40:
        return self.arg # type: ignore

class NonSpare_854(NonSpare):
    cv_arg: TypeAlias = RuleVariation_40.cv_arg
    cv_name = "D"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_40

    @classmethod
    def create(cls, arg : "NonSpare_854.cv_arg") -> "NonSpare_854":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_40:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_40:
        return self.rule.variation

class Item_234(Item):
    cv_arg: TypeAlias = NonSpare_854.cv_arg
    cv_non_spare: TypeAlias = NonSpare_854

    @classmethod
    def create(cls, arg : "Item_234.cv_arg") -> "Item_234":
        return cls._create(arg) # type: ignore

class Item_8(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 1
    cv_bit_size = 5

class Content_629(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_629(RuleContentContextFree):
    cv_arg: TypeAlias = Content_629.cv_arg
    cv_content: TypeAlias = Content_629

    @property
    def content(self) -> Content_629:
        return self._get_content() # type: ignore

class Variation_968(Element):
    cv_arg: TypeAlias = RuleContent_629.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 10
    cv_rule = RuleContent_629

    @classmethod
    def create(cls, arg: "Variation_968.cv_arg") -> "Variation_968":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_629:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_629:
        return self.rule.content

class RuleVariation_938(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_968.cv_arg
    cv_variation: TypeAlias = Variation_968

    @classmethod
    def create(cls, arg : "RuleVariation_938.cv_arg") -> "RuleVariation_938":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_968:
        return self.arg # type: ignore

class NonSpare_703(NonSpare):
    cv_arg: TypeAlias = RuleVariation_938.cv_arg
    cv_name = "CAL"
    cv_title = "Calculated Doppler Speed, Coded in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_938

    @classmethod
    def create(cls, arg : "NonSpare_703.cv_arg") -> "NonSpare_703":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_938:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_968:
        return self.rule.variation

class Item_134(Item):
    cv_arg: TypeAlias = NonSpare_703.cv_arg
    cv_non_spare: TypeAlias = NonSpare_703

    @classmethod
    def create(cls, arg : "Item_134.cv_arg") -> "Item_134":
        return cls._create(arg) # type: ignore

class Variation_1082(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_40.cv_arg, Tuple[Literal["D"], RuleVariation_40.cv_arg]], int, Union[RuleVariation_938.cv_arg, Tuple[Literal["CAL"], RuleVariation_938.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1082.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_234, 1), (Item_8, 5), (Item_134, 10)]
    cv_items_dict = {"D": RuleVariation_40, "CAL": RuleVariation_938}

    @overload
    @classmethod
    def spec(cls, key : Literal["D"]) -> RuleVariation_40:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CAL"]) -> RuleVariation_938:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["D"], Literal["CAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["D"]) -> RuleVariation_40:
        ...
    @overload
    def get_item(self, key : Literal["CAL"]) -> RuleVariation_938:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1082.cv_arg") -> 'Variation_1082':
        return cls._create(arg) # type: ignore

class RuleVariation_1042(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1082.cv_arg
    cv_variation: TypeAlias = Variation_1082

    @classmethod
    def create(cls, arg : "RuleVariation_1042.cv_arg") -> "RuleVariation_1042":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1082:
        return self.arg # type: ignore

class NonSpare_702(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1042.cv_arg
    cv_name = "CAL"
    cv_title = "Calculated Doppler Speed"
    cv_rule: TypeAlias = RuleVariation_1042

    @classmethod
    def create(cls, arg : "NonSpare_702.cv_arg") -> "NonSpare_702":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1042:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1082:
        return self.rule.variation

class Content_721(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_721(RuleContentContextFree):
    cv_arg: TypeAlias = Content_721.cv_arg
    cv_content: TypeAlias = Content_721

    @property
    def content(self) -> Content_721:
        return self._get_content() # type: ignore

class Variation_306(Element):
    cv_arg: TypeAlias = RuleContent_721.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_721

    @classmethod
    def create(cls, arg: "Variation_306.cv_arg") -> "Variation_306":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_721:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_721:
        return self.rule.content

class RuleVariation_299(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_306.cv_arg
    cv_variation: TypeAlias = Variation_306

    @classmethod
    def create(cls, arg : "RuleVariation_299.cv_arg") -> "RuleVariation_299":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_306:
        return self.arg # type: ignore

class NonSpare_892(NonSpare):
    cv_arg: TypeAlias = RuleVariation_299.cv_arg
    cv_name = "DOP"
    cv_title = "Doppler Speed"
    cv_rule: TypeAlias = RuleVariation_299

    @classmethod
    def create(cls, arg : "NonSpare_892.cv_arg") -> "NonSpare_892":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_299:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_306:
        return self.rule.variation

class Item_267(Item):
    cv_arg: TypeAlias = NonSpare_892.cv_arg
    cv_non_spare: TypeAlias = NonSpare_892

    @classmethod
    def create(cls, arg : "Item_267.cv_arg") -> "Item_267":
        return cls._create(arg) # type: ignore

class NonSpare_608(NonSpare):
    cv_arg: TypeAlias = RuleVariation_299.cv_arg
    cv_name = "AMB"
    cv_title = "Ambiguity Range"
    cv_rule: TypeAlias = RuleVariation_299

    @classmethod
    def create(cls, arg : "NonSpare_608.cv_arg") -> "NonSpare_608":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_299:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_306:
        return self.rule.variation

class Item_72(Item):
    cv_arg: TypeAlias = NonSpare_608.cv_arg
    cv_non_spare: TypeAlias = NonSpare_608

    @classmethod
    def create(cls, arg : "Item_72.cv_arg") -> "Item_72":
        return cls._create(arg) # type: ignore

class Content_712(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["MHz"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "MHz"

    def as_quantity(self, cv_unit : Optional[Literal["MHz"]] = None) -> float:
        return self._as_quantity()

class RuleContent_712(RuleContentContextFree):
    cv_arg: TypeAlias = Content_712.cv_arg
    cv_content: TypeAlias = Content_712

    @property
    def content(self) -> Content_712:
        return self._get_content() # type: ignore

class Variation_300(Element):
    cv_arg: TypeAlias = RuleContent_712.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_712

    @classmethod
    def create(cls, arg: "Variation_300.cv_arg") -> "Variation_300":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_712:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_712:
        return self.rule.content

class RuleVariation_293(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_300.cv_arg
    cv_variation: TypeAlias = Variation_300

    @classmethod
    def create(cls, arg : "RuleVariation_293.cv_arg") -> "RuleVariation_293":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_300:
        return self.arg # type: ignore

class NonSpare_997(NonSpare):
    cv_arg: TypeAlias = RuleVariation_293.cv_arg
    cv_name = "FRQ"
    cv_title = "Transmitter Frequency"
    cv_rule: TypeAlias = RuleVariation_293

    @classmethod
    def create(cls, arg : "NonSpare_997.cv_arg") -> "NonSpare_997":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_293:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_300:
        return self.rule.variation

class Item_346(Item):
    cv_arg: TypeAlias = NonSpare_997.cv_arg
    cv_non_spare: TypeAlias = NonSpare_997

    @classmethod
    def create(cls, arg : "Item_346.cv_arg") -> "Item_346":
        return cls._create(arg) # type: ignore

class Variation_1085(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_299.cv_arg, Tuple[Literal["DOP"], RuleVariation_299.cv_arg]], Union[RuleVariation_299.cv_arg, Tuple[Literal["AMB"], RuleVariation_299.cv_arg]], Union[RuleVariation_293.cv_arg, Tuple[Literal["FRQ"], RuleVariation_293.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1085.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_267, 16), (Item_72, 16), (Item_346, 16)]
    cv_items_dict = {"DOP": RuleVariation_299, "AMB": RuleVariation_299, "FRQ": RuleVariation_293}

    @overload
    @classmethod
    def spec(cls, key : Literal["DOP"]) -> RuleVariation_299:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AMB"]) -> RuleVariation_299:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FRQ"]) -> RuleVariation_293:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["DOP"], Literal["AMB"], Literal["FRQ"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["DOP"]) -> RuleVariation_299:
        ...
    @overload
    def get_item(self, key : Literal["AMB"]) -> RuleVariation_299:
        ...
    @overload
    def get_item(self, key : Literal["FRQ"]) -> RuleVariation_293:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1085.cv_arg") -> 'Variation_1085':
        return cls._create(arg) # type: ignore

class Variation_1417(Repetitive):
    cv_arg: TypeAlias = List[Variation_1085.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1085

    @classmethod
    def create(cls, arg: "Variation_1417.cv_arg") -> 'Variation_1417':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1085]:
        return self._get_list() # type: ignore

class RuleVariation_1338(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1417.cv_arg
    cv_variation: TypeAlias = Variation_1417

    @classmethod
    def create(cls, arg : "RuleVariation_1338.cv_arg") -> "RuleVariation_1338":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1417:
        return self.arg # type: ignore

class NonSpare_1563(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1338.cv_arg
    cv_name = "RDS"
    cv_title = "Raw Doppler Speed"
    cv_rule: TypeAlias = RuleVariation_1338

    @classmethod
    def create(cls, arg : "NonSpare_1563.cv_arg") -> "NonSpare_1563":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1338:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1417:
        return self.rule.variation

class Variation_1478(Compound):
    cv_arg = TypedDict('cv_arg', {
        "CAL": NonSpare_702.cv_arg,
        "RDS": NonSpare_1563.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_702, NonSpare_1563]
    cv_items_dict = {"CAL": NonSpare_702, "RDS": NonSpare_1563}

    @overload
    @classmethod
    def spec(cls, key : Literal["CAL"]) -> NonSpare_702:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1563:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CAL"], Literal["RDS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CAL"]) -> Optional[NonSpare_702]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1563]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CAL"], val : NonSpare_702.cv_arg) -> "Variation_1478":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1563.cv_arg) -> "Variation_1478":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CAL"]) -> "Variation_1478":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1478":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1478.cv_arg") -> 'Variation_1478':
        return cls._create(arg) # type: ignore

class RuleVariation_1399(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1478.cv_arg
    cv_variation: TypeAlias = Variation_1478

    @classmethod
    def create(cls, arg : "RuleVariation_1399.cv_arg") -> "RuleVariation_1399":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1478:
        return self.arg # type: ignore

class NonSpare_301(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1399.cv_arg
    cv_name = "120"
    cv_title = "Radial Doppler Speed"
    cv_rule: TypeAlias = RuleVariation_1399

    @classmethod
    def create(cls, arg : "NonSpare_301.cv_arg") -> "NonSpare_301":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1399:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1478:
        return self.rule.variation

class UapItem_301(UapItem):
    cv_non_spare: TypeAlias = NonSpare_301

class Content_338(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No communications capability (surveillance only)", 1: "Comm. A and Comm. B capability", 2: "Comm. A, Comm. B and Uplink ELM", 3: "Comm. A, Comm. B, Uplink ELM and Downlink ELM", 4: "Level 5 Transponder capability"}

class RuleContent_338(RuleContentContextFree):
    cv_arg: TypeAlias = Content_338.cv_arg
    cv_content: TypeAlias = Content_338

    @property
    def content(self) -> Content_338:
        return self._get_content() # type: ignore

class Variation_123(Element):
    cv_arg: TypeAlias = RuleContent_338.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_338

    @classmethod
    def create(cls, arg: "Variation_123.cv_arg") -> "Variation_123":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_338:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_338:
        return self.rule.content

class RuleVariation_123(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_123.cv_arg
    cv_variation: TypeAlias = Variation_123

    @classmethod
    def create(cls, arg : "RuleVariation_123.cv_arg") -> "RuleVariation_123":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_123:
        return self.arg # type: ignore

class NonSpare_784(NonSpare):
    cv_arg: TypeAlias = RuleVariation_123.cv_arg
    cv_name = "COM"
    cv_title = "Communications Capability of the Transponder"
    cv_rule: TypeAlias = RuleVariation_123

    @classmethod
    def create(cls, arg : "NonSpare_784.cv_arg") -> "NonSpare_784":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_123:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_123:
        return self.rule.variation

class Item_187(Item):
    cv_arg: TypeAlias = NonSpare_784.cv_arg
    cv_non_spare: TypeAlias = NonSpare_784

    @classmethod
    def create(cls, arg : "Item_187.cv_arg") -> "Item_187":
        return cls._create(arg) # type: ignore

class Content_324(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 7: "Unknown"}

class RuleContent_324(RuleContentContextFree):
    cv_arg: TypeAlias = Content_324.cv_arg
    cv_content: TypeAlias = Content_324

    @property
    def content(self) -> Content_324:
        return self._get_content() # type: ignore

class Variation_687(Element):
    cv_arg: TypeAlias = RuleContent_324.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_324

    @classmethod
    def create(cls, arg: "Variation_687.cv_arg") -> "Variation_687":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_324:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_324:
        return self.rule.content

class RuleVariation_676(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_687.cv_arg
    cv_variation: TypeAlias = Variation_687

    @classmethod
    def create(cls, arg : "RuleVariation_676.cv_arg") -> "RuleVariation_676":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_687:
        return self.arg # type: ignore

class NonSpare_1778(NonSpare):
    cv_arg: TypeAlias = RuleVariation_676.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_676

    @classmethod
    def create(cls, arg : "NonSpare_1778.cv_arg") -> "NonSpare_1778":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_676:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_687:
        return self.rule.variation

class Item_939(Item):
    cv_arg: TypeAlias = NonSpare_1778.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1778

    @classmethod
    def create(cls, arg : "Item_939.cv_arg") -> "Item_939":
        return cls._create(arg) # type: ignore

class Content_449(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "SI-Code Capable", 1: "II-Code Capable"}

class RuleContent_449(RuleContentContextFree):
    cv_arg: TypeAlias = Content_449.cv_arg
    cv_content: TypeAlias = Content_449

    @property
    def content(self) -> Content_449:
        return self._get_content() # type: ignore

class Variation_950(Element):
    cv_arg: TypeAlias = RuleContent_449.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_449

    @classmethod
    def create(cls, arg: "Variation_950.cv_arg") -> "Variation_950":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_449:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_449:
        return self.rule.content

class RuleVariation_920(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_950.cv_arg
    cv_variation: TypeAlias = Variation_950

    @classmethod
    def create(cls, arg : "RuleVariation_920.cv_arg") -> "RuleVariation_920":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_950:
        return self.arg # type: ignore

class NonSpare_1707(NonSpare):
    cv_arg: TypeAlias = RuleVariation_920.cv_arg
    cv_name = "SI"
    cv_title = "SI/II Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_920

    @classmethod
    def create(cls, arg : "NonSpare_1707.cv_arg") -> "NonSpare_1707":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_920:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_950:
        return self.rule.variation

class Item_884(Item):
    cv_arg: TypeAlias = NonSpare_1707.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1707

    @classmethod
    def create(cls, arg : "Item_884.cv_arg") -> "Item_884":
        return cls._create(arg) # type: ignore

class Variation_1075(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_123.cv_arg, Tuple[Literal["COM"], RuleVariation_123.cv_arg]], Union[RuleVariation_676.cv_arg, Tuple[Literal["STAT"], RuleVariation_676.cv_arg]], Union[RuleVariation_920.cv_arg, Tuple[Literal["SI"], RuleVariation_920.cv_arg]], int, Union[RuleVariation_56.cv_arg, Tuple[Literal["MSSC"], RuleVariation_56.cv_arg]], Union[RuleVariation_390.cv_arg, Tuple[Literal["ARC"], RuleVariation_390.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["AIC"], RuleVariation_547.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["B1A"], RuleVariation_603.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["B1B"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1075.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_187, 3), (Item_939, 3), (Item_884, 1), (Item_29, 1), (Item_597, 1), (Item_81, 1), (Item_55, 1), (Item_109, 1), (Item_111, 4)]
    cv_items_dict = {"COM": RuleVariation_123, "STAT": RuleVariation_676, "SI": RuleVariation_920, "MSSC": RuleVariation_56, "ARC": RuleVariation_390, "AIC": RuleVariation_547, "B1A": RuleVariation_603, "B1B": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_676:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SI"]) -> RuleVariation_920:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MSSC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SI"], Literal["MSSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_123:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_676:
        ...
    @overload
    def get_item(self, key : Literal["SI"]) -> RuleVariation_920:
        ...
    @overload
    def get_item(self, key : Literal["MSSC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1075.cv_arg") -> 'Variation_1075':
        return cls._create(arg) # type: ignore

class RuleVariation_1035(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1075.cv_arg
    cv_variation: TypeAlias = Variation_1075

    @classmethod
    def create(cls, arg : "RuleVariation_1035.cv_arg") -> "RuleVariation_1035":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1075:
        return self.arg # type: ignore

class NonSpare_429(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1035.cv_arg
    cv_name = "230"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1035

    @classmethod
    def create(cls, arg : "NonSpare_429.cv_arg") -> "NonSpare_429":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1035:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1075:
        return self.rule.variation

class UapItem_429(UapItem):
    cv_non_spare: TypeAlias = NonSpare_429

class NonSpare_454(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_454.cv_arg") -> "NonSpare_454":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class UapItem_454(UapItem):
    cv_non_spare: TypeAlias = NonSpare_454

class Content_283(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode-1 code as derived from the reply of the transponder", 1: "Smoothed Mode-1 code as provided by a local tracker"}

class RuleContent_283(RuleContentContextFree):
    cv_arg: TypeAlias = Content_283.cv_arg
    cv_content: TypeAlias = Content_283

    @property
    def content(self) -> Content_283:
        return self._get_content() # type: ignore

class Variation_546(Element):
    cv_arg: TypeAlias = RuleContent_283.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_283

    @classmethod
    def create(cls, arg: "Variation_546.cv_arg") -> "Variation_546":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_283:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_283:
        return self.rule.content

class RuleVariation_535(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_546.cv_arg
    cv_variation: TypeAlias = Variation_546

    @classmethod
    def create(cls, arg : "RuleVariation_535.cv_arg") -> "RuleVariation_535":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_546:
        return self.arg # type: ignore

class NonSpare_1134(NonSpare):
    cv_arg: TypeAlias = RuleVariation_535.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_535

    @classmethod
    def create(cls, arg : "NonSpare_1134.cv_arg") -> "NonSpare_1134":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_535:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_546:
        return self.rule.variation

class Item_446(Item):
    cv_arg: TypeAlias = NonSpare_1134.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1134

    @classmethod
    def create(cls, arg : "Item_446.cv_arg") -> "Item_446":
        return cls._create(arg) # type: ignore

class NonSpare_1300(NonSpare):
    cv_arg: TypeAlias = RuleVariation_684.cv_arg
    cv_name = "MODE1"
    cv_title = "Mode-1 Code"
    cv_rule: TypeAlias = RuleVariation_684

    @classmethod
    def create(cls, arg : "NonSpare_1300.cv_arg") -> "NonSpare_1300":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_684:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_695:
        return self.rule.variation

class Item_566(Item):
    cv_arg: TypeAlias = NonSpare_1300.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1300

    @classmethod
    def create(cls, arg : "Item_566.cv_arg") -> "Item_566":
        return cls._create(arg) # type: ignore

class Variation_1259(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_535.cv_arg, Tuple[Literal["L"], RuleVariation_535.cv_arg]], Union[RuleVariation_684.cv_arg, Tuple[Literal["MODE1"], RuleVariation_684.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1259.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_446, 1), (Item_566, 5)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_535, "MODE1": RuleVariation_684}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_535:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE1"]) -> RuleVariation_684:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_535:
        ...
    @overload
    def get_item(self, key : Literal["MODE1"]) -> RuleVariation_684:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1259.cv_arg") -> 'Variation_1259':
        return cls._create(arg) # type: ignore

class RuleVariation_1188(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1259.cv_arg
    cv_variation: TypeAlias = Variation_1259

    @classmethod
    def create(cls, arg : "RuleVariation_1188.cv_arg") -> "RuleVariation_1188":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1259:
        return self.arg # type: ignore

class NonSpare_186(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1188.cv_arg
    cv_name = "055"
    cv_title = "Mode-1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1188

    @classmethod
    def create(cls, arg : "NonSpare_186.cv_arg") -> "NonSpare_186":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1188:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1259:
        return self.rule.variation

class UapItem_186(UapItem):
    cv_non_spare: TypeAlias = NonSpare_186

class NonSpare_173(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1190.cv_arg
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1190

    @classmethod
    def create(cls, arg : "NonSpare_173.cv_arg") -> "NonSpare_173":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1261:
        return self.rule.variation

class UapItem_173(UapItem):
    cv_non_spare: TypeAlias = NonSpare_173

class Variation_641(Element):
    cv_arg: TypeAlias = RuleContent_227.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_227

    @classmethod
    def create(cls, arg: "Variation_641.cv_arg") -> "Variation_641":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_227:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_227:
        return self.rule.content

class RuleVariation_630(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_641.cv_arg
    cv_variation: TypeAlias = Variation_641

    @classmethod
    def create(cls, arg : "RuleVariation_630.cv_arg") -> "RuleVariation_630":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_641:
        return self.arg # type: ignore

class NonSpare_1496(NonSpare):
    cv_arg: TypeAlias = RuleVariation_630.cv_arg
    cv_name = "QA4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_630

    @classmethod
    def create(cls, arg : "NonSpare_1496.cv_arg") -> "NonSpare_1496":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_630:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_641:
        return self.rule.variation

class Item_729(Item):
    cv_arg: TypeAlias = NonSpare_1496.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1496

    @classmethod
    def create(cls, arg : "Item_729.cv_arg") -> "Item_729":
        return cls._create(arg) # type: ignore

class Variation_725(Element):
    cv_arg: TypeAlias = RuleContent_226.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_226

    @classmethod
    def create(cls, arg: "Variation_725.cv_arg") -> "Variation_725":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_226:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_226:
        return self.rule.content

class RuleVariation_714(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_725.cv_arg
    cv_variation: TypeAlias = Variation_725

    @classmethod
    def create(cls, arg : "RuleVariation_714.cv_arg") -> "RuleVariation_714":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_725:
        return self.arg # type: ignore

class NonSpare_1491(NonSpare):
    cv_arg: TypeAlias = RuleVariation_714.cv_arg
    cv_name = "QA2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_714

    @classmethod
    def create(cls, arg : "NonSpare_1491.cv_arg") -> "NonSpare_1491":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_714:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_725:
        return self.rule.variation

class Item_724(Item):
    cv_arg: TypeAlias = NonSpare_1491.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1491

    @classmethod
    def create(cls, arg : "Item_724.cv_arg") -> "Item_724":
        return cls._create(arg) # type: ignore

class Variation_930(Element):
    cv_arg: TypeAlias = RuleContent_229.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_229

    @classmethod
    def create(cls, arg: "Variation_930.cv_arg") -> "Variation_930":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_229:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_229:
        return self.rule.content

class RuleVariation_900(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_930.cv_arg
    cv_variation: TypeAlias = Variation_930

    @classmethod
    def create(cls, arg : "RuleVariation_900.cv_arg") -> "RuleVariation_900":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_930:
        return self.arg # type: ignore

class NonSpare_1505(NonSpare):
    cv_arg: TypeAlias = RuleVariation_900.cv_arg
    cv_name = "QB2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_900

    @classmethod
    def create(cls, arg : "NonSpare_1505.cv_arg") -> "NonSpare_1505":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_900:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_930:
        return self.rule.variation

class Item_738(Item):
    cv_arg: TypeAlias = NonSpare_1505.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1505

    @classmethod
    def create(cls, arg : "Item_738.cv_arg") -> "Item_738":
        return cls._create(arg) # type: ignore

class Variation_977(Element):
    cv_arg: TypeAlias = RuleContent_228.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_228

    @classmethod
    def create(cls, arg: "Variation_977.cv_arg") -> "Variation_977":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_228:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_228:
        return self.rule.content

class RuleVariation_947(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_977.cv_arg
    cv_variation: TypeAlias = Variation_977

    @classmethod
    def create(cls, arg : "RuleVariation_947.cv_arg") -> "RuleVariation_947":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_977:
        return self.arg # type: ignore

class NonSpare_1501(NonSpare):
    cv_arg: TypeAlias = RuleVariation_947.cv_arg
    cv_name = "QB1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_947

    @classmethod
    def create(cls, arg : "NonSpare_1501.cv_arg") -> "NonSpare_1501":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_947:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_977:
        return self.rule.variation

class Item_734(Item):
    cv_arg: TypeAlias = NonSpare_1501.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1501

    @classmethod
    def create(cls, arg : "Item_734.cv_arg") -> "Item_734":
        return cls._create(arg) # type: ignore

class Variation_1015(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_630.cv_arg, Tuple[Literal["QA4"], RuleVariation_630.cv_arg]], Union[RuleVariation_714.cv_arg, Tuple[Literal["QA2"], RuleVariation_714.cv_arg]], Union[RuleVariation_822.cv_arg, Tuple[Literal["QA1"], RuleVariation_822.cv_arg]], Union[RuleVariation_900.cv_arg, Tuple[Literal["QB2"], RuleVariation_900.cv_arg]], Union[RuleVariation_947.cv_arg, Tuple[Literal["QB1"], RuleVariation_947.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1015.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_729, 1), (Item_724, 1), (Item_721, 1), (Item_738, 1), (Item_734, 1)]
    cv_items_dict = {"QA4": RuleVariation_630, "QA2": RuleVariation_714, "QA1": RuleVariation_822, "QB2": RuleVariation_900, "QB1": RuleVariation_947}

    @overload
    @classmethod
    def spec(cls, key : Literal["QA4"]) -> RuleVariation_630:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA2"]) -> RuleVariation_714:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QA1"]) -> RuleVariation_822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB2"]) -> RuleVariation_900:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["QB1"]) -> RuleVariation_947:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QA4"], Literal["QA2"], Literal["QA1"], Literal["QB2"], Literal["QB1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QA4"]) -> RuleVariation_630:
        ...
    @overload
    def get_item(self, key : Literal["QA2"]) -> RuleVariation_714:
        ...
    @overload
    def get_item(self, key : Literal["QA1"]) -> RuleVariation_822:
        ...
    @overload
    def get_item(self, key : Literal["QB2"]) -> RuleVariation_900:
        ...
    @overload
    def get_item(self, key : Literal["QB1"]) -> RuleVariation_947:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1015.cv_arg") -> 'Variation_1015':
        return cls._create(arg) # type: ignore

class RuleVariation_985(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1015.cv_arg
    cv_variation: TypeAlias = Variation_1015

    @classmethod
    def create(cls, arg : "RuleVariation_985.cv_arg") -> "RuleVariation_985":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1015:
        return self.arg # type: ignore

class NonSpare_203(NonSpare):
    cv_arg: TypeAlias = RuleVariation_985.cv_arg
    cv_name = "065"
    cv_title = "Mode-1 Code Confidence Indicator"
    cv_rule: TypeAlias = RuleVariation_985

    @classmethod
    def create(cls, arg : "NonSpare_203.cv_arg") -> "NonSpare_203":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_985:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1015:
        return self.rule.variation

class UapItem_203(UapItem):
    cv_non_spare: TypeAlias = NonSpare_203

class NonSpare_188(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1000.cv_arg
    cv_name = "060"
    cv_title = "Mode-2 Code Confidence Indicator"
    cv_rule: TypeAlias = RuleVariation_1000

    @classmethod
    def create(cls, arg : "NonSpare_188.cv_arg") -> "NonSpare_188":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1000:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1032:
        return self.rule.variation

class UapItem_188(UapItem):
    cv_non_spare: TypeAlias = NonSpare_188

class Record_29(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_39.cv_arg,
        "140": NonSpare_333.cv_arg,
        "020": NonSpare_88.cv_arg,
        "040": NonSpare_139.cv_arg,
        "070": NonSpare_211.cv_arg,
        "090": NonSpare_249.cv_arg,
        "130": NonSpare_313.cv_arg,
        "220": NonSpare_420.cv_arg,
        "240": NonSpare_436.cv_arg,
        "250": NonSpare_450.cv_arg,
        "161": NonSpare_364.cv_arg,
        "042": NonSpare_160.cv_arg,
        "200": NonSpare_390.cv_arg,
        "170": NonSpare_377.cv_arg,
        "210": NonSpare_416.cv_arg,
        "030": NonSpare_119.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_273.cv_arg,
        "110": NonSpare_287.cv_arg,
        "120": NonSpare_301.cv_arg,
        "230": NonSpare_429.cv_arg,
        "260": NonSpare_454.cv_arg,
        "055": NonSpare_186.cv_arg,
        "050": NonSpare_173.cv_arg,
        "065": NonSpare_203.cv_arg,
        "060": NonSpare_188.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_333, UapItem_88, UapItem_139, UapItem_211, UapItem_249, UapItem_313, UapItem_420, UapItem_436, UapItem_450, UapItem_364, UapItem_160, UapItem_390, UapItem_377, UapItem_416, UapItem_119, UapItem_233, UapItem_273, UapItem_287, UapItem_301, UapItem_429, UapItem_454, UapItem_186, UapItem_173, UapItem_203, UapItem_188, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_39, "140": NonSpare_333, "020": NonSpare_88, "040": NonSpare_139, "070": NonSpare_211, "090": NonSpare_249, "130": NonSpare_313, "220": NonSpare_420, "240": NonSpare_436, "250": NonSpare_450, "161": NonSpare_364, "042": NonSpare_160, "200": NonSpare_390, "170": NonSpare_377, "210": NonSpare_416, "030": NonSpare_119, "080": NonSpare_233, "100": NonSpare_273, "110": NonSpare_287, "120": NonSpare_301, "230": NonSpare_429, "260": NonSpare_454, "055": NonSpare_186, "050": NonSpare_173, "065": NonSpare_203, "060": NonSpare_188, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_88:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_211:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_119:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_454:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_173:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_88]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_211]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_420]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_436]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_450]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_119]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_454]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_173]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_333.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_88.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_211.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_313.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_420.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_436.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_450.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_364.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_377.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_416.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_119.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_301.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_454.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_186.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_173.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_203.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_29':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_29':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_29':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_29':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_29.cv_arg") -> 'Record_29':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_29", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_25(UapSingle):
    cv_arg: TypeAlias = Record_29
    cv_record: TypeAlias = Record_29

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_29]]:
        return cls._parse(bs)

class Asterix_45(AstCat):
    cv_category = 48
    cv_edition = (1, 27)
    cv_uap: TypeAlias = Uap_25
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_25.cv_arg]) -> "Asterix_45":
        return cls._create(records) # type: ignore

class Content_394(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected", 32: "Wrong DF reply format detected", 33: "Transponder anomaly (MS XPD replies with Mode A/C to Mode A/C-only all-call)", 34: "Transponder anomaly (SI capability report wrong)"}

class RuleContent_394(RuleContentContextFree):
    cv_arg: TypeAlias = Content_394.cv_arg
    cv_content: TypeAlias = Content_394

    @property
    def content(self) -> Content_394:
        return self._get_content() # type: ignore

class Variation_154(Element):
    cv_arg: TypeAlias = RuleContent_394.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_394

    @classmethod
    def create(cls, arg: "Variation_154.cv_arg") -> "Variation_154":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_394:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_394:
        return self.rule.content

class Variation_1457(Repetitive):
    cv_arg: TypeAlias = List[Variation_154.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_154

    @classmethod
    def create(cls, arg: "Variation_1457.cv_arg") -> 'Variation_1457':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_154]:
        return self._get_list() # type: ignore

class RuleVariation_1378(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1457.cv_arg
    cv_variation: TypeAlias = Variation_1457

    @classmethod
    def create(cls, arg : "RuleVariation_1378.cv_arg") -> "RuleVariation_1378":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1457:
        return self.arg # type: ignore

class NonSpare_120(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1378.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule: TypeAlias = RuleVariation_1378

    @classmethod
    def create(cls, arg : "NonSpare_120.cv_arg") -> "NonSpare_120":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1378:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1457:
        return self.rule.variation

class UapItem_120(UapItem):
    cv_non_spare: TypeAlias = NonSpare_120

class Record_30(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_39.cv_arg,
        "140": NonSpare_333.cv_arg,
        "020": NonSpare_88.cv_arg,
        "040": NonSpare_139.cv_arg,
        "070": NonSpare_211.cv_arg,
        "090": NonSpare_249.cv_arg,
        "130": NonSpare_313.cv_arg,
        "220": NonSpare_420.cv_arg,
        "240": NonSpare_436.cv_arg,
        "250": NonSpare_450.cv_arg,
        "161": NonSpare_364.cv_arg,
        "042": NonSpare_160.cv_arg,
        "200": NonSpare_390.cv_arg,
        "170": NonSpare_377.cv_arg,
        "210": NonSpare_416.cv_arg,
        "030": NonSpare_120.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_273.cv_arg,
        "110": NonSpare_287.cv_arg,
        "120": NonSpare_301.cv_arg,
        "230": NonSpare_429.cv_arg,
        "260": NonSpare_454.cv_arg,
        "055": NonSpare_186.cv_arg,
        "050": NonSpare_173.cv_arg,
        "065": NonSpare_203.cv_arg,
        "060": NonSpare_188.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_333, UapItem_88, UapItem_139, UapItem_211, UapItem_249, UapItem_313, UapItem_420, UapItem_436, UapItem_450, UapItem_364, UapItem_160, UapItem_390, UapItem_377, UapItem_416, UapItem_120, UapItem_233, UapItem_273, UapItem_287, UapItem_301, UapItem_429, UapItem_454, UapItem_186, UapItem_173, UapItem_203, UapItem_188, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_39, "140": NonSpare_333, "020": NonSpare_88, "040": NonSpare_139, "070": NonSpare_211, "090": NonSpare_249, "130": NonSpare_313, "220": NonSpare_420, "240": NonSpare_436, "250": NonSpare_450, "161": NonSpare_364, "042": NonSpare_160, "200": NonSpare_390, "170": NonSpare_377, "210": NonSpare_416, "030": NonSpare_120, "080": NonSpare_233, "100": NonSpare_273, "110": NonSpare_287, "120": NonSpare_301, "230": NonSpare_429, "260": NonSpare_454, "055": NonSpare_186, "050": NonSpare_173, "065": NonSpare_203, "060": NonSpare_188, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_88:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_211:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_120:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_454:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_173:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_88]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_211]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_420]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_436]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_450]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_120]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_454]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_173]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_333.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_88.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_211.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_313.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_420.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_436.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_450.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_364.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_377.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_416.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_120.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_301.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_454.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_186.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_173.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_203.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_30':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_30':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_30':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_30':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_30.cv_arg") -> 'Record_30':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_30", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_26(UapSingle):
    cv_arg: TypeAlias = Record_30
    cv_record: TypeAlias = Record_30

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_30]]:
        return cls._parse(bs)

class Asterix_46(AstCat):
    cv_category = 48
    cv_edition = (1, 28)
    cv_uap: TypeAlias = Uap_26
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_26.cv_arg]) -> "Asterix_46":
        return cls._create(records) # type: ignore

class NonSpare_446(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1344.cv_arg
    cv_name = "250"
    cv_title = "BDS Register Data"
    cv_rule: TypeAlias = RuleVariation_1344

    @classmethod
    def create(cls, arg : "NonSpare_446.cv_arg") -> "NonSpare_446":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1423:
        return self.rule.variation

class UapItem_446(UapItem):
    cv_non_spare: TypeAlias = NonSpare_446

class NonSpare_455(NonSpare):
    cv_arg: TypeAlias = RuleVariation_384.cv_arg
    cv_name = "260"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_384

    @classmethod
    def create(cls, arg : "NonSpare_455.cv_arg") -> "NonSpare_455":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_384:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_392:
        return self.rule.variation

class UapItem_455(UapItem):
    cv_non_spare: TypeAlias = NonSpare_455

class Record_28(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_39.cv_arg,
        "140": NonSpare_333.cv_arg,
        "020": NonSpare_88.cv_arg,
        "040": NonSpare_139.cv_arg,
        "070": NonSpare_211.cv_arg,
        "090": NonSpare_249.cv_arg,
        "130": NonSpare_313.cv_arg,
        "220": NonSpare_420.cv_arg,
        "240": NonSpare_436.cv_arg,
        "250": NonSpare_446.cv_arg,
        "161": NonSpare_364.cv_arg,
        "042": NonSpare_160.cv_arg,
        "200": NonSpare_390.cv_arg,
        "170": NonSpare_377.cv_arg,
        "210": NonSpare_416.cv_arg,
        "030": NonSpare_120.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_273.cv_arg,
        "110": NonSpare_287.cv_arg,
        "120": NonSpare_301.cv_arg,
        "230": NonSpare_429.cv_arg,
        "260": NonSpare_455.cv_arg,
        "055": NonSpare_186.cv_arg,
        "050": NonSpare_173.cv_arg,
        "065": NonSpare_203.cv_arg,
        "060": NonSpare_188.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_333, UapItem_88, UapItem_139, UapItem_211, UapItem_249, UapItem_313, UapItem_420, UapItem_436, UapItem_446, UapItem_364, UapItem_160, UapItem_390, UapItem_377, UapItem_416, UapItem_120, UapItem_233, UapItem_273, UapItem_287, UapItem_301, UapItem_429, UapItem_455, UapItem_186, UapItem_173, UapItem_203, UapItem_188, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_39, "140": NonSpare_333, "020": NonSpare_88, "040": NonSpare_139, "070": NonSpare_211, "090": NonSpare_249, "130": NonSpare_313, "220": NonSpare_420, "240": NonSpare_436, "250": NonSpare_446, "161": NonSpare_364, "042": NonSpare_160, "200": NonSpare_390, "170": NonSpare_377, "210": NonSpare_416, "030": NonSpare_120, "080": NonSpare_233, "100": NonSpare_273, "110": NonSpare_287, "120": NonSpare_301, "230": NonSpare_429, "260": NonSpare_455, "055": NonSpare_186, "050": NonSpare_173, "065": NonSpare_203, "060": NonSpare_188, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_88:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_211:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_420:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_446:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_120:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_429:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_455:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_173:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_88]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_211]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_420]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_436]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_446]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_120]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_429]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_455]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_173]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_333.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_88.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_211.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_313.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_420.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_436.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_446.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_364.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_377.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_416.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_120.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_301.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_429.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_455.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_186.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_173.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_203.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_28':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_28':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_28':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_28':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_28.cv_arg") -> 'Record_28':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_28", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_24(UapSingle):
    cv_arg: TypeAlias = Record_28
    cv_record: TypeAlias = Record_28

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_28]]:
        return cls._parse(bs)

class Asterix_47(AstCat):
    cv_category = 48
    cv_edition = (1, 29)
    cv_uap: TypeAlias = Uap_24
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_24.cv_arg]) -> "Asterix_47":
        return cls._create(records) # type: ignore

class NonSpare_421(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "220"
    cv_title = "Aircraft Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_421.cv_arg") -> "NonSpare_421":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class UapItem_421(UapItem):
    cv_non_spare: TypeAlias = NonSpare_421

class NonSpare_437(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "240"
    cv_title = "Aircraft Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_437.cv_arg") -> "NonSpare_437":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class UapItem_437(UapItem):
    cv_non_spare: TypeAlias = NonSpare_437

class NonSpare_445(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1344.cv_arg
    cv_name = "250"
    cv_title = "BDS Register Data"
    cv_rule: TypeAlias = RuleVariation_1344

    @classmethod
    def create(cls, arg : "NonSpare_445.cv_arg") -> "NonSpare_445":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1423:
        return self.rule.variation

class UapItem_445(UapItem):
    cv_non_spare: TypeAlias = NonSpare_445

class NonSpare_430(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1035.cv_arg
    cv_name = "230"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1035

    @classmethod
    def create(cls, arg : "NonSpare_430.cv_arg") -> "NonSpare_430":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1035:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1075:
        return self.rule.variation

class UapItem_430(UapItem):
    cv_non_spare: TypeAlias = NonSpare_430

class NonSpare_171(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1190.cv_arg
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1190

    @classmethod
    def create(cls, arg : "NonSpare_171.cv_arg") -> "NonSpare_171":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1261:
        return self.rule.variation

class UapItem_171(UapItem):
    cv_non_spare: TypeAlias = NonSpare_171

class Record_31(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_39.cv_arg,
        "140": NonSpare_333.cv_arg,
        "020": NonSpare_88.cv_arg,
        "040": NonSpare_139.cv_arg,
        "070": NonSpare_211.cv_arg,
        "090": NonSpare_249.cv_arg,
        "130": NonSpare_313.cv_arg,
        "220": NonSpare_421.cv_arg,
        "240": NonSpare_437.cv_arg,
        "250": NonSpare_445.cv_arg,
        "161": NonSpare_364.cv_arg,
        "042": NonSpare_160.cv_arg,
        "200": NonSpare_390.cv_arg,
        "170": NonSpare_377.cv_arg,
        "210": NonSpare_416.cv_arg,
        "030": NonSpare_120.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_273.cv_arg,
        "110": NonSpare_287.cv_arg,
        "120": NonSpare_301.cv_arg,
        "230": NonSpare_430.cv_arg,
        "260": NonSpare_455.cv_arg,
        "055": NonSpare_186.cv_arg,
        "050": NonSpare_171.cv_arg,
        "065": NonSpare_203.cv_arg,
        "060": NonSpare_188.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_333, UapItem_88, UapItem_139, UapItem_211, UapItem_249, UapItem_313, UapItem_421, UapItem_437, UapItem_445, UapItem_364, UapItem_160, UapItem_390, UapItem_377, UapItem_416, UapItem_120, UapItem_233, UapItem_273, UapItem_287, UapItem_301, UapItem_430, UapItem_455, UapItem_186, UapItem_171, UapItem_203, UapItem_188, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_39, "140": NonSpare_333, "020": NonSpare_88, "040": NonSpare_139, "070": NonSpare_211, "090": NonSpare_249, "130": NonSpare_313, "220": NonSpare_421, "240": NonSpare_437, "250": NonSpare_445, "161": NonSpare_364, "042": NonSpare_160, "200": NonSpare_390, "170": NonSpare_377, "210": NonSpare_416, "030": NonSpare_120, "080": NonSpare_233, "100": NonSpare_273, "110": NonSpare_287, "120": NonSpare_301, "230": NonSpare_430, "260": NonSpare_455, "055": NonSpare_186, "050": NonSpare_171, "065": NonSpare_203, "060": NonSpare_188, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_88:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_211:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_445:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_120:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_301:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_455:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_171:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_88]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_211]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_421]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_437]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_445]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_120]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_301]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_430]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_455]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_171]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_333.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_88.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_211.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_313.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_421.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_437.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_445.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_364.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_377.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_416.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_120.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_301.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_430.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_455.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_186.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_171.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_203.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_31':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_31':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_31':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_31':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_31.cv_arg") -> 'Record_31':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_31", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_27(UapSingle):
    cv_arg: TypeAlias = Record_31
    cv_record: TypeAlias = Record_31

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_31]]:
        return cls._parse(bs)

class Asterix_48(AstCat):
    cv_category = 48
    cv_edition = (1, 30)
    cv_uap: TypeAlias = Uap_27
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_27.cv_arg]) -> "Asterix_48":
        return cls._create(records) # type: ignore

class Content_10(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "ADSB not populated", 1: "ADSB populated"}

class RuleContent_10(RuleContentContextFree):
    cv_arg: TypeAlias = Content_10.cv_arg
    cv_content: TypeAlias = Content_10

    @property
    def content(self) -> Content_10:
        return self._get_content() # type: ignore

class Variation_2(Element):
    cv_arg: TypeAlias = RuleContent_10.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_10

    @classmethod
    def create(cls, arg: "Variation_2.cv_arg") -> "Variation_2":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_10:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_10:
        return self.rule.content

class RuleVariation_2(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_2.cv_arg
    cv_variation: TypeAlias = Variation_2

    @classmethod
    def create(cls, arg : "RuleVariation_2.cv_arg") -> "RuleVariation_2":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_2:
        return self.arg # type: ignore

class NonSpare_937(NonSpare):
    cv_arg: TypeAlias = RuleVariation_2.cv_arg
    cv_name = "EP"
    cv_title = "ADSB Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_2

    @classmethod
    def create(cls, arg : "NonSpare_937.cv_arg") -> "NonSpare_937":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_2:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_2:
        return self.rule.variation

class Item_298(Item):
    cv_arg: TypeAlias = NonSpare_937.cv_arg
    cv_non_spare: TypeAlias = NonSpare_937

    @classmethod
    def create(cls, arg : "Item_298.cv_arg") -> "Item_298":
        return cls._create(arg) # type: ignore

class Content_391(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not available", 1: "Available"}

class RuleContent_391(RuleContentContextFree):
    cv_arg: TypeAlias = Content_391.cv_arg
    cv_content: TypeAlias = Content_391

    @property
    def content(self) -> Content_391:
        return self._get_content() # type: ignore

class Variation_445(Element):
    cv_arg: TypeAlias = RuleContent_391.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_391

    @classmethod
    def create(cls, arg: "Variation_445.cv_arg") -> "Variation_445":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_391:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_391:
        return self.rule.content

class RuleVariation_434(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_445.cv_arg
    cv_variation: TypeAlias = Variation_445

    @classmethod
    def create(cls, arg : "RuleVariation_434.cv_arg") -> "RuleVariation_434":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_445:
        return self.arg # type: ignore

class NonSpare_2001(NonSpare):
    cv_arg: TypeAlias = RuleVariation_434.cv_arg
    cv_name = "VAL"
    cv_title = "On-Site ADS-B Information"
    cv_rule: TypeAlias = RuleVariation_434

    @classmethod
    def create(cls, arg : "NonSpare_2001.cv_arg") -> "NonSpare_2001":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_434:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_445:
        return self.rule.variation

class Item_1111(Item):
    cv_arg: TypeAlias = NonSpare_2001.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2001

    @classmethod
    def create(cls, arg : "Item_1111.cv_arg") -> "Item_1111":
        return cls._create(arg) # type: ignore

class Variation_1090(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_2.cv_arg, Tuple[Literal["EP"], RuleVariation_2.cv_arg]], Union[RuleVariation_434.cv_arg, Tuple[Literal["VAL"], RuleVariation_434.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1090.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_items_list = [(Item_298, 1), (Item_1111, 1)]
    cv_items_dict = {"EP": RuleVariation_2, "VAL": RuleVariation_434}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_2:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_434:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_2:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_434:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1090.cv_arg") -> 'Variation_1090':
        return cls._create(arg) # type: ignore

class RuleVariation_1048(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1090.cv_arg
    cv_variation: TypeAlias = Variation_1090

    @classmethod
    def create(cls, arg : "RuleVariation_1048.cv_arg") -> "RuleVariation_1048":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1090:
        return self.arg # type: ignore

class Content_448(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "SCN not populated", 1: "SCN populated"}

class RuleContent_448(RuleContentContextFree):
    cv_arg: TypeAlias = Content_448.cv_arg
    cv_content: TypeAlias = Content_448

    @property
    def content(self) -> Content_448:
        return self._get_content() # type: ignore

class Variation_575(Element):
    cv_arg: TypeAlias = RuleContent_448.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_448

    @classmethod
    def create(cls, arg: "Variation_575.cv_arg") -> "Variation_575":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_448:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_448:
        return self.rule.content

class RuleVariation_564(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_575.cv_arg
    cv_variation: TypeAlias = Variation_575

    @classmethod
    def create(cls, arg : "RuleVariation_564.cv_arg") -> "RuleVariation_564":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_575:
        return self.arg # type: ignore

class NonSpare_954(NonSpare):
    cv_arg: TypeAlias = RuleVariation_564.cv_arg
    cv_name = "EP"
    cv_title = "SCN Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_564

    @classmethod
    def create(cls, arg : "NonSpare_954.cv_arg") -> "NonSpare_954":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_564:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_575:
        return self.rule.variation

class Item_315(Item):
    cv_arg: TypeAlias = NonSpare_954.cv_arg
    cv_non_spare: TypeAlias = NonSpare_954

    @classmethod
    def create(cls, arg : "Item_315.cv_arg") -> "Item_315":
        return cls._create(arg) # type: ignore

class Variation_657(Element):
    cv_arg: TypeAlias = RuleContent_391.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_391

    @classmethod
    def create(cls, arg: "Variation_657.cv_arg") -> "Variation_657":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_391:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_391:
        return self.rule.content

class RuleVariation_646(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_657.cv_arg
    cv_variation: TypeAlias = Variation_657

    @classmethod
    def create(cls, arg : "RuleVariation_646.cv_arg") -> "RuleVariation_646":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_657:
        return self.arg # type: ignore

class NonSpare_2006(NonSpare):
    cv_arg: TypeAlias = RuleVariation_646.cv_arg
    cv_name = "VAL"
    cv_title = "Surveillance Cluster Network Information"
    cv_rule: TypeAlias = RuleVariation_646

    @classmethod
    def create(cls, arg : "NonSpare_2006.cv_arg") -> "NonSpare_2006":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_646:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_657:
        return self.rule.variation

class Item_1116(Item):
    cv_arg: TypeAlias = NonSpare_2006.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2006

    @classmethod
    def create(cls, arg : "Item_1116.cv_arg") -> "Item_1116":
        return cls._create(arg) # type: ignore

class Variation_1326(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_564.cv_arg, Tuple[Literal["EP"], RuleVariation_564.cv_arg]], Union[RuleVariation_646.cv_arg, Tuple[Literal["VAL"], RuleVariation_646.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1326.cv_arg_group"]
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_items_list = [(Item_315, 1), (Item_1116, 1)]
    cv_items_dict = {"EP": RuleVariation_564, "VAL": RuleVariation_646}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_646:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_564:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_646:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1326.cv_arg") -> 'Variation_1326':
        return cls._create(arg) # type: ignore

class RuleVariation_1250(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1326.cv_arg
    cv_variation: TypeAlias = Variation_1326

    @classmethod
    def create(cls, arg : "RuleVariation_1250.cv_arg") -> "RuleVariation_1250":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1326:
        return self.arg # type: ignore

class Content_417(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "PAI not populated", 1: "PAI populated"}

class RuleContent_417(RuleContentContextFree):
    cv_arg: TypeAlias = Content_417.cv_arg
    cv_content: TypeAlias = Content_417

    @property
    def content(self) -> Content_417:
        return self._get_content() # type: ignore

class Variation_745(Element):
    cv_arg: TypeAlias = RuleContent_417.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_417

    @classmethod
    def create(cls, arg: "Variation_745.cv_arg") -> "Variation_745":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_417:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_417:
        return self.rule.content

class RuleVariation_734(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_745.cv_arg
    cv_variation: TypeAlias = Variation_745

    @classmethod
    def create(cls, arg : "RuleVariation_734.cv_arg") -> "RuleVariation_734":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_745:
        return self.arg # type: ignore

class NonSpare_950(NonSpare):
    cv_arg: TypeAlias = RuleVariation_734.cv_arg
    cv_name = "EP"
    cv_title = "PAI Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_734

    @classmethod
    def create(cls, arg : "NonSpare_950.cv_arg") -> "NonSpare_950":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_734:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_745:
        return self.rule.variation

class Item_311(Item):
    cv_arg: TypeAlias = NonSpare_950.cv_arg
    cv_non_spare: TypeAlias = NonSpare_950

    @classmethod
    def create(cls, arg : "Item_311.cv_arg") -> "Item_311":
        return cls._create(arg) # type: ignore

class Variation_865(Element):
    cv_arg: TypeAlias = RuleContent_391.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_391

    @classmethod
    def create(cls, arg: "Variation_865.cv_arg") -> "Variation_865":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_391:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_391:
        return self.rule.content

class RuleVariation_835(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_865.cv_arg
    cv_variation: TypeAlias = Variation_865

    @classmethod
    def create(cls, arg : "RuleVariation_835.cv_arg") -> "RuleVariation_835":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_865:
        return self.arg # type: ignore

class NonSpare_2004(NonSpare):
    cv_arg: TypeAlias = RuleVariation_835.cv_arg
    cv_name = "VAL"
    cv_title = "Passive Acquisition Interface Information"
    cv_rule: TypeAlias = RuleVariation_835

    @classmethod
    def create(cls, arg : "NonSpare_2004.cv_arg") -> "NonSpare_2004":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_835:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_865:
        return self.rule.variation

class Item_1114(Item):
    cv_arg: TypeAlias = NonSpare_2004.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2004

    @classmethod
    def create(cls, arg : "Item_1114.cv_arg") -> "Item_1114":
        return cls._create(arg) # type: ignore

class Variation_1335(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_734.cv_arg, Tuple[Literal["EP"], RuleVariation_734.cv_arg]], Union[RuleVariation_835.cv_arg, Tuple[Literal["VAL"], RuleVariation_835.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1335.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_items_list = [(Item_311, 1), (Item_1114, 1)]
    cv_items_dict = {"EP": RuleVariation_734, "VAL": RuleVariation_835}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_734:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_835:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_734:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_835:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1335.cv_arg") -> 'Variation_1335':
        return cls._create(arg) # type: ignore

class RuleVariation_1259(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1335.cv_arg
    cv_variation: TypeAlias = Variation_1335

    @classmethod
    def create(cls, arg : "RuleVariation_1259.cv_arg") -> "RuleVariation_1259":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1335:
        return self.arg # type: ignore

class NonSpare_578(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1048.cv_arg
    cv_name = "ADSB"
    cv_title = "On-Site ADS-B Information"
    cv_rule: TypeAlias = RuleVariation_1048

    @classmethod
    def create(cls, arg : "NonSpare_578.cv_arg") -> "NonSpare_578":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1048:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1090:
        return self.rule.variation

class Item_48(Item):
    cv_arg: TypeAlias = NonSpare_578.cv_arg
    cv_non_spare: TypeAlias = NonSpare_578

    @classmethod
    def create(cls, arg : "Item_48.cv_arg") -> "Item_48":
        return cls._create(arg) # type: ignore

class NonSpare_1670(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1250.cv_arg
    cv_name = "SCN"
    cv_title = "Surveillance Cluster Network Information"
    cv_rule: TypeAlias = RuleVariation_1250

    @classmethod
    def create(cls, arg : "NonSpare_1670.cv_arg") -> "NonSpare_1670":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1250:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1326:
        return self.rule.variation

class Item_865(Item):
    cv_arg: TypeAlias = NonSpare_1670.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1670

    @classmethod
    def create(cls, arg : "Item_865.cv_arg") -> "Item_865":
        return cls._create(arg) # type: ignore

class NonSpare_1420(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1259.cv_arg
    cv_name = "PAI"
    cv_title = "Passive Acquisition Interface Information"
    cv_rule: TypeAlias = RuleVariation_1259

    @classmethod
    def create(cls, arg : "NonSpare_1420.cv_arg") -> "NonSpare_1420":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1259:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1335:
        return self.rule.variation

class Item_677(Item):
    cv_arg: TypeAlias = NonSpare_1420.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1420

    @classmethod
    def create(cls, arg : "Item_677.cv_arg") -> "Item_677":
        return cls._create(arg) # type: ignore

class Variation_1390(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_127.cv_arg, Tuple[Literal["TYP"], RuleVariation_127.cv_arg]], Union[RuleVariation_604.cv_arg, Tuple[Literal["SIM"], RuleVariation_604.cv_arg]], Union[RuleVariation_737.cv_arg, Tuple[Literal["RDP"], RuleVariation_737.cv_arg]], Union[RuleVariation_789.cv_arg, Tuple[Literal["SPI"], RuleVariation_789.cv_arg]], Union[RuleVariation_918.cv_arg, Tuple[Literal["RAB"], RuleVariation_918.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_73.cv_arg, Tuple[Literal["TST"], RuleVariation_73.cv_arg]], Union[RuleVariation_429.cv_arg, Tuple[Literal["ERR"], RuleVariation_429.cv_arg]], Union[RuleVariation_548.cv_arg, Tuple[Literal["XPP"], RuleVariation_548.cv_arg]], Union[RuleVariation_642.cv_arg, Tuple[Literal["ME"], RuleVariation_642.cv_arg]], Union[RuleVariation_730.cv_arg, Tuple[Literal["MI"], RuleVariation_730.cv_arg]], Union[RuleVariation_850.cv_arg, Tuple[Literal["FOEFRI"], RuleVariation_850.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_1048.cv_arg, Tuple[Literal["ADSB"], RuleVariation_1048.cv_arg]], Union[RuleVariation_1250.cv_arg, Tuple[Literal["SCN"], RuleVariation_1250.cv_arg]], Union[RuleVariation_1259.cv_arg, Tuple[Literal["PAI"], RuleVariation_1259.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1390.cv_arg_group_1"],
        Tuple["Variation_1390.cv_arg_group_1", "Variation_1390.cv_arg_group_2"],
        Tuple["Variation_1390.cv_arg_group_1", "Variation_1390.cv_arg_group_2", "Variation_1390.cv_arg_group_3"],
    ]
    cv_items_list = [[(Item_1073, 3), (Item_901, 1), (Item_787, 1), (Item_912, 1), (Item_770, 1), None], [(Item_1051, 1), (Item_318, 1), (Item_1219, 1), (Item_545, 1), (Item_552, 1), (Item_334, 2), None], [(Item_48, 2), (Item_865, 2), (Item_677, 2), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1390.cv_arg") -> 'Variation_1390':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_127:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_604:
        ...
    @overload
    def get_item(self, key : Literal["RDP"]) -> RuleVariation_737:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_789:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_918:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_73]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[RuleVariation_429]:
        ...
    @overload
    def get_item(self, key : Literal["XPP"]) -> Optional[RuleVariation_548]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_642]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_730]:
        ...
    @overload
    def get_item(self, key : Literal["FOEFRI"]) -> Optional[RuleVariation_850]:
        ...
    @overload
    def get_item(self, key : Literal["ADSB"]) -> Optional[RuleVariation_1048]:
        ...
    @overload
    def get_item(self, key : Literal["SCN"]) -> Optional[RuleVariation_1250]:
        ...
    @overload
    def get_item(self, key : Literal["PAI"]) -> Optional[RuleVariation_1259]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1311(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1390.cv_arg
    cv_variation: TypeAlias = Variation_1390

    @classmethod
    def create(cls, arg : "RuleVariation_1311.cv_arg") -> "RuleVariation_1311":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1390:
        return self.arg # type: ignore

class NonSpare_89(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1311.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1311

    @classmethod
    def create(cls, arg : "NonSpare_89.cv_arg") -> "NonSpare_89":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1390:
        return self.rule.variation

class UapItem_89(UapItem):
    cv_non_spare: TypeAlias = NonSpare_89

class Content_395(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected", 32: "Wrong DF reply format detected", 33: "Transponder anomaly (MS XPD replies with Mode A/C to Mode A/C-only all-call)", 34: "Transponder anomaly (SI capability report wrong)", 35: "Potential IC Conflict", 36: "IC Conflict detection possible-no conflict currently detected"}

class RuleContent_395(RuleContentContextFree):
    cv_arg: TypeAlias = Content_395.cv_arg
    cv_content: TypeAlias = Content_395

    @property
    def content(self) -> Content_395:
        return self._get_content() # type: ignore

class Variation_155(Element):
    cv_arg: TypeAlias = RuleContent_395.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_395

    @classmethod
    def create(cls, arg: "Variation_155.cv_arg") -> "Variation_155":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_395:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_395:
        return self.rule.content

class Variation_1458(Repetitive):
    cv_arg: TypeAlias = List[Variation_155.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_155

    @classmethod
    def create(cls, arg: "Variation_1458.cv_arg") -> 'Variation_1458':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_155]:
        return self._get_list() # type: ignore

class RuleVariation_1379(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1458.cv_arg
    cv_variation: TypeAlias = Variation_1458

    @classmethod
    def create(cls, arg : "RuleVariation_1379.cv_arg") -> "RuleVariation_1379":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1458:
        return self.arg # type: ignore

class NonSpare_121(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1379.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule: TypeAlias = RuleVariation_1379

    @classmethod
    def create(cls, arg : "NonSpare_121.cv_arg") -> "NonSpare_121":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1379:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1458:
        return self.rule.variation

class UapItem_121(UapItem):
    cv_non_spare: TypeAlias = NonSpare_121

class NonSpare_302(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1399.cv_arg
    cv_name = "120"
    cv_title = "Radial Doppler Speed"
    cv_rule: TypeAlias = RuleVariation_1399

    @classmethod
    def create(cls, arg : "NonSpare_302.cv_arg") -> "NonSpare_302":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1399:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1478:
        return self.rule.variation

class UapItem_302(UapItem):
    cv_non_spare: TypeAlias = NonSpare_302

class Record_32(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_39.cv_arg,
        "140": NonSpare_333.cv_arg,
        "020": NonSpare_89.cv_arg,
        "040": NonSpare_139.cv_arg,
        "070": NonSpare_211.cv_arg,
        "090": NonSpare_249.cv_arg,
        "130": NonSpare_313.cv_arg,
        "220": NonSpare_421.cv_arg,
        "240": NonSpare_437.cv_arg,
        "250": NonSpare_445.cv_arg,
        "161": NonSpare_364.cv_arg,
        "042": NonSpare_160.cv_arg,
        "200": NonSpare_390.cv_arg,
        "170": NonSpare_377.cv_arg,
        "210": NonSpare_416.cv_arg,
        "030": NonSpare_121.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_273.cv_arg,
        "110": NonSpare_287.cv_arg,
        "120": NonSpare_302.cv_arg,
        "230": NonSpare_430.cv_arg,
        "260": NonSpare_455.cv_arg,
        "055": NonSpare_186.cv_arg,
        "050": NonSpare_171.cv_arg,
        "065": NonSpare_203.cv_arg,
        "060": NonSpare_188.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_333, UapItem_89, UapItem_139, UapItem_211, UapItem_249, UapItem_313, UapItem_421, UapItem_437, UapItem_445, UapItem_364, UapItem_160, UapItem_390, UapItem_377, UapItem_416, UapItem_121, UapItem_233, UapItem_273, UapItem_287, UapItem_302, UapItem_430, UapItem_455, UapItem_186, UapItem_171, UapItem_203, UapItem_188, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_39, "140": NonSpare_333, "020": NonSpare_89, "040": NonSpare_139, "070": NonSpare_211, "090": NonSpare_249, "130": NonSpare_313, "220": NonSpare_421, "240": NonSpare_437, "250": NonSpare_445, "161": NonSpare_364, "042": NonSpare_160, "200": NonSpare_390, "170": NonSpare_377, "210": NonSpare_416, "030": NonSpare_121, "080": NonSpare_233, "100": NonSpare_273, "110": NonSpare_287, "120": NonSpare_302, "230": NonSpare_430, "260": NonSpare_455, "055": NonSpare_186, "050": NonSpare_171, "065": NonSpare_203, "060": NonSpare_188, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_89:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_211:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_445:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_121:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_302:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_455:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_171:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_89]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_211]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_249]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_421]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_437]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_445]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_121]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_302]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_430]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_455]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_171]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_333.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_89.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_211.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_249.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_313.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_421.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_437.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_445.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_364.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_377.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_416.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_121.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_302.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_430.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_455.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_186.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_171.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_203.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_32':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_32':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_32':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_32':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_32.cv_arg") -> 'Record_32':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_32", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_28(UapSingle):
    cv_arg: TypeAlias = Record_32
    cv_record: TypeAlias = Record_32

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_32]]:
        return cls._parse(bs)

class Asterix_49(AstCat):
    cv_category = 48
    cv_edition = (1, 31)
    cv_uap: TypeAlias = Uap_28
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_28.cv_arg]) -> "Asterix_49":
        return cls._create(records) # type: ignore

class Content_8(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "ACASXV not populated", 1: "ACASXV populated"}

class RuleContent_8(RuleContentContextFree):
    cv_arg: TypeAlias = Content_8.cv_arg
    cv_content: TypeAlias = Content_8

    @property
    def content(self) -> Content_8:
        return self._get_content() # type: ignore

class Variation_1(Element):
    cv_arg: TypeAlias = RuleContent_8.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_8

    @classmethod
    def create(cls, arg: "Variation_1.cv_arg") -> "Variation_1":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_8:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_8:
        return self.rule.content

class RuleVariation_1(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1.cv_arg
    cv_variation: TypeAlias = Variation_1

    @classmethod
    def create(cls, arg : "RuleVariation_1.cv_arg") -> "RuleVariation_1":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1:
        return self.arg # type: ignore

class NonSpare_936(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1.cv_arg
    cv_name = "EP"
    cv_title = "ACASXV Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_1

    @classmethod
    def create(cls, arg : "NonSpare_936.cv_arg") -> "NonSpare_936":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1:
        return self.rule.variation

class Item_297(Item):
    cv_arg: TypeAlias = NonSpare_936.cv_arg
    cv_non_spare: TypeAlias = NonSpare_936

    @classmethod
    def create(cls, arg : "Item_297.cv_arg") -> "Item_297":
        return cls._create(arg) # type: ignore

class Content_380(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Non-Extended Version", 1: "ACAS Xa Version 1", 2: "ACAS Xu Version 1"}

class RuleContent_380(RuleContentContextFree):
    cv_arg: TypeAlias = Content_380.cv_arg
    cv_content: TypeAlias = Content_380

    @property
    def content(self) -> Content_380:
        return self._get_content() # type: ignore

class Variation_489(Element):
    cv_arg: TypeAlias = RuleContent_380.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 4
    cv_rule = RuleContent_380

    @classmethod
    def create(cls, arg: "Variation_489.cv_arg") -> "Variation_489":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_380:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_380:
        return self.rule.content

class RuleVariation_478(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_489.cv_arg
    cv_variation: TypeAlias = Variation_489

    @classmethod
    def create(cls, arg : "RuleVariation_478.cv_arg") -> "RuleVariation_478":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_489:
        return self.arg # type: ignore

class NonSpare_1995(NonSpare):
    cv_arg: TypeAlias = RuleVariation_478.cv_arg
    cv_name = "VAL"
    cv_title = "ACAS Extended Version Value"
    cv_rule: TypeAlias = RuleVariation_478

    @classmethod
    def create(cls, arg : "NonSpare_1995.cv_arg") -> "NonSpare_1995":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_478:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_489:
        return self.rule.variation

class Item_1105(Item):
    cv_arg: TypeAlias = NonSpare_1995.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1995

    @classmethod
    def create(cls, arg : "Item_1105.cv_arg") -> "Item_1105":
        return cls._create(arg) # type: ignore

class Variation_1089(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_1.cv_arg, Tuple[Literal["EP"], RuleVariation_1.cv_arg]], Union[RuleVariation_478.cv_arg, Tuple[Literal["VAL"], RuleVariation_478.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1089.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 5
    cv_items_list = [(Item_297, 1), (Item_1105, 4)]
    cv_items_dict = {"EP": RuleVariation_1, "VAL": RuleVariation_478}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_1:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_478:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_1:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_478:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1089.cv_arg") -> 'Variation_1089':
        return cls._create(arg) # type: ignore

class RuleVariation_1047(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1089.cv_arg
    cv_variation: TypeAlias = Variation_1089

    @classmethod
    def create(cls, arg : "RuleVariation_1047.cv_arg") -> "RuleVariation_1047":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1089:
        return self.arg # type: ignore

class Content_421(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "POXPR not populated", 1: "POXPR populated"}

class RuleContent_421(RuleContentContextFree):
    cv_arg: TypeAlias = Content_421.cv_arg
    cv_content: TypeAlias = Content_421

    @property
    def content(self) -> Content_421:
        return self._get_content() # type: ignore

class Variation_869(Element):
    cv_arg: TypeAlias = RuleContent_421.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_421

    @classmethod
    def create(cls, arg: "Variation_869.cv_arg") -> "Variation_869":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_421:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_421:
        return self.rule.content

class RuleVariation_839(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_869.cv_arg
    cv_variation: TypeAlias = Variation_869

    @classmethod
    def create(cls, arg : "RuleVariation_839.cv_arg") -> "RuleVariation_839":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_869:
        return self.arg # type: ignore

class NonSpare_952(NonSpare):
    cv_arg: TypeAlias = RuleVariation_839.cv_arg
    cv_name = "EP"
    cv_title = "POXPR Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_839

    @classmethod
    def create(cls, arg : "NonSpare_952.cv_arg") -> "NonSpare_952":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_839:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_869:
        return self.rule.variation

class Item_313(Item):
    cv_arg: TypeAlias = NonSpare_952.cv_arg
    cv_non_spare: TypeAlias = NonSpare_952

    @classmethod
    def create(cls, arg : "Item_313.cv_arg") -> "Item_313":
        return cls._create(arg) # type: ignore

class Content_419(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "PO not supported (PPM only)", 1: "PO supported"}

class RuleContent_419(RuleContentContextFree):
    cv_arg: TypeAlias = Content_419.cv_arg
    cv_content: TypeAlias = Content_419

    @property
    def content(self) -> Content_419:
        return self._get_content() # type: ignore

class Variation_945(Element):
    cv_arg: TypeAlias = RuleContent_419.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_419

    @classmethod
    def create(cls, arg: "Variation_945.cv_arg") -> "Variation_945":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_419:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_419:
        return self.rule.content

class RuleVariation_915(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_945.cv_arg
    cv_variation: TypeAlias = Variation_945

    @classmethod
    def create(cls, arg : "RuleVariation_915.cv_arg") -> "RuleVariation_915":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_945:
        return self.arg # type: ignore

class NonSpare_2002(NonSpare):
    cv_arg: TypeAlias = RuleVariation_915.cv_arg
    cv_name = "VAL"
    cv_title = "PO Transpomder Capability"
    cv_rule: TypeAlias = RuleVariation_915

    @classmethod
    def create(cls, arg : "NonSpare_2002.cv_arg") -> "NonSpare_2002":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_915:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_945:
        return self.rule.variation

class Item_1112(Item):
    cv_arg: TypeAlias = NonSpare_2002.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2002

    @classmethod
    def create(cls, arg : "Item_1112.cv_arg") -> "Item_1112":
        return cls._create(arg) # type: ignore

class Variation_1342(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_839.cv_arg, Tuple[Literal["EP"], RuleVariation_839.cv_arg]], Union[RuleVariation_915.cv_arg, Tuple[Literal["VAL"], RuleVariation_915.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1342.cv_arg_group"]
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_items_list = [(Item_313, 1), (Item_1112, 1)]
    cv_items_dict = {"EP": RuleVariation_839, "VAL": RuleVariation_915}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_839:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_915:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_839:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_915:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1342.cv_arg") -> 'Variation_1342':
        return cls._create(arg) # type: ignore

class RuleVariation_1263(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1342.cv_arg
    cv_variation: TypeAlias = Variation_1342

    @classmethod
    def create(cls, arg : "RuleVariation_1263.cv_arg") -> "RuleVariation_1263":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1342:
        return self.arg # type: ignore

class Content_420(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "POACT not populated", 1: "POACT populated"}

class RuleContent_420(RuleContentContextFree):
    cv_arg: TypeAlias = Content_420.cv_arg
    cv_content: TypeAlias = Content_420

    @property
    def content(self) -> Content_420:
        return self._get_content() # type: ignore

class Variation_70(Element):
    cv_arg: TypeAlias = RuleContent_420.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_420

    @classmethod
    def create(cls, arg: "Variation_70.cv_arg") -> "Variation_70":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_420:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_420:
        return self.rule.content

class RuleVariation_70(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_70.cv_arg
    cv_variation: TypeAlias = Variation_70

    @classmethod
    def create(cls, arg : "RuleVariation_70.cv_arg") -> "RuleVariation_70":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_70:
        return self.arg # type: ignore

class NonSpare_951(NonSpare):
    cv_arg: TypeAlias = RuleVariation_70.cv_arg
    cv_name = "EP"
    cv_title = "POACT Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_70

    @classmethod
    def create(cls, arg : "NonSpare_951.cv_arg") -> "NonSpare_951":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_70:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_70:
        return self.rule.variation

class Item_312(Item):
    cv_arg: TypeAlias = NonSpare_951.cv_arg
    cv_non_spare: TypeAlias = NonSpare_951

    @classmethod
    def create(cls, arg : "Item_312.cv_arg") -> "Item_312":
        return cls._create(arg) # type: ignore

class Content_418(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "PO not active", 1: "PO active"}

class RuleContent_418(RuleContentContextFree):
    cv_arg: TypeAlias = Content_418.cv_arg
    cv_content: TypeAlias = Content_418

    @property
    def content(self) -> Content_418:
        return self._get_content() # type: ignore

class Variation_448(Element):
    cv_arg: TypeAlias = RuleContent_418.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_418

    @classmethod
    def create(cls, arg: "Variation_448.cv_arg") -> "Variation_448":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_418:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_418:
        return self.rule.content

class RuleVariation_437(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_448.cv_arg
    cv_variation: TypeAlias = Variation_448

    @classmethod
    def create(cls, arg : "RuleVariation_437.cv_arg") -> "RuleVariation_437":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_448:
        return self.arg # type: ignore

class NonSpare_2003(NonSpare):
    cv_arg: TypeAlias = RuleVariation_437.cv_arg
    cv_name = "VAL"
    cv_title = "POACT Active for Current Plot"
    cv_rule: TypeAlias = RuleVariation_437

    @classmethod
    def create(cls, arg : "NonSpare_2003.cv_arg") -> "NonSpare_2003":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_437:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_448:
        return self.rule.variation

class Item_1113(Item):
    cv_arg: TypeAlias = NonSpare_2003.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2003

    @classmethod
    def create(cls, arg : "Item_1113.cv_arg") -> "Item_1113":
        return cls._create(arg) # type: ignore

class Variation_1102(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_70.cv_arg, Tuple[Literal["EP"], RuleVariation_70.cv_arg]], Union[RuleVariation_437.cv_arg, Tuple[Literal["VAL"], RuleVariation_437.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1102.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_items_list = [(Item_312, 1), (Item_1113, 1)]
    cv_items_dict = {"EP": RuleVariation_70, "VAL": RuleVariation_437}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_70:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_437:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_70:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_437:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1102.cv_arg") -> 'Variation_1102':
        return cls._create(arg) # type: ignore

class RuleVariation_1060(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1102.cv_arg
    cv_variation: TypeAlias = Variation_1102

    @classmethod
    def create(cls, arg : "RuleVariation_1060.cv_arg") -> "RuleVariation_1060":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1102:
        return self.arg # type: ignore

class Content_75(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "DTFXPR not populated", 1: "DTFXPR populated"}

class RuleContent_75(RuleContentContextFree):
    cv_arg: TypeAlias = Content_75.cv_arg
    cv_content: TypeAlias = Content_75

    @property
    def content(self) -> Content_75:
        return self._get_content() # type: ignore

class Variation_513(Element):
    cv_arg: TypeAlias = RuleContent_75.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_75

    @classmethod
    def create(cls, arg: "Variation_513.cv_arg") -> "Variation_513":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_75:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_75:
        return self.rule.content

class RuleVariation_502(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_513.cv_arg
    cv_variation: TypeAlias = Variation_513

    @classmethod
    def create(cls, arg : "RuleVariation_502.cv_arg") -> "RuleVariation_502":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_513:
        return self.arg # type: ignore

class NonSpare_939(NonSpare):
    cv_arg: TypeAlias = RuleVariation_502.cv_arg
    cv_name = "EP"
    cv_title = "DTFXPR Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_502

    @classmethod
    def create(cls, arg : "NonSpare_939.cv_arg") -> "NonSpare_939":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_502:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_513:
        return self.rule.variation

class Item_300(Item):
    cv_arg: TypeAlias = NonSpare_939.cv_arg
    cv_non_spare: TypeAlias = NonSpare_939

    @classmethod
    def create(cls, arg : "Item_300.cv_arg") -> "Item_300":
        return cls._create(arg) # type: ignore

class Content_47(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Basic Dataflash not supported", 1: "Basic Dataflash supported"}

class RuleContent_47(RuleContentContextFree):
    cv_arg: TypeAlias = Content_47.cv_arg
    cv_content: TypeAlias = Content_47

    @property
    def content(self) -> Content_47:
        return self._get_content() # type: ignore

class Variation_619(Element):
    cv_arg: TypeAlias = RuleContent_47.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_47

    @classmethod
    def create(cls, arg: "Variation_619.cv_arg") -> "Variation_619":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_47:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_47:
        return self.rule.content

class RuleVariation_608(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_619.cv_arg
    cv_variation: TypeAlias = Variation_619

    @classmethod
    def create(cls, arg : "RuleVariation_608.cv_arg") -> "RuleVariation_608":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_619:
        return self.arg # type: ignore

class NonSpare_1997(NonSpare):
    cv_arg: TypeAlias = RuleVariation_608.cv_arg
    cv_name = "VAL"
    cv_title = "Basic Dataflash Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_608

    @classmethod
    def create(cls, arg : "NonSpare_1997.cv_arg") -> "NonSpare_1997":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_608:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_619:
        return self.rule.variation

class Item_1107(Item):
    cv_arg: TypeAlias = NonSpare_1997.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1997

    @classmethod
    def create(cls, arg : "Item_1107.cv_arg") -> "Item_1107":
        return cls._create(arg) # type: ignore

class Variation_1323(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_502.cv_arg, Tuple[Literal["EP"], RuleVariation_502.cv_arg]], Union[RuleVariation_608.cv_arg, Tuple[Literal["VAL"], RuleVariation_608.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1323.cv_arg_group"]
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_items_list = [(Item_300, 1), (Item_1107, 1)]
    cv_items_dict = {"EP": RuleVariation_502, "VAL": RuleVariation_608}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_502:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_608:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_502:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_608:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1323.cv_arg") -> 'Variation_1323':
        return cls._create(arg) # type: ignore

class RuleVariation_1247(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1323.cv_arg
    cv_variation: TypeAlias = Variation_1323

    @classmethod
    def create(cls, arg : "RuleVariation_1247.cv_arg") -> "RuleVariation_1247":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1323:
        return self.arg # type: ignore

class Content_74(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "DTFACT not populated", 1: "DTFACT populated"}

class RuleContent_74(RuleContentContextFree):
    cv_arg: TypeAlias = Content_74.cv_arg
    cv_content: TypeAlias = Content_74

    @property
    def content(self) -> Content_74:
        return self._get_content() # type: ignore

class Variation_704(Element):
    cv_arg: TypeAlias = RuleContent_74.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_74

    @classmethod
    def create(cls, arg: "Variation_704.cv_arg") -> "Variation_704":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_74:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_74:
        return self.rule.content

class RuleVariation_693(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_704.cv_arg
    cv_variation: TypeAlias = Variation_704

    @classmethod
    def create(cls, arg : "RuleVariation_693.cv_arg") -> "RuleVariation_693":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_704:
        return self.arg # type: ignore

class NonSpare_938(NonSpare):
    cv_arg: TypeAlias = RuleVariation_693.cv_arg
    cv_name = "EP"
    cv_title = "DTFACT Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_693

    @classmethod
    def create(cls, arg : "NonSpare_938.cv_arg") -> "NonSpare_938":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_693:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_704:
        return self.rule.variation

class Item_299(Item):
    cv_arg: TypeAlias = NonSpare_938.cv_arg
    cv_non_spare: TypeAlias = NonSpare_938

    @classmethod
    def create(cls, arg : "Item_299.cv_arg") -> "Item_299":
        return cls._create(arg) # type: ignore

class Content_46(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Basic Dataflash not active", 1: "Basic Dataflash active"}

class RuleContent_46(RuleContentContextFree):
    cv_arg: TypeAlias = Content_46.cv_arg
    cv_content: TypeAlias = Content_46

    @property
    def content(self) -> Content_46:
        return self._get_content() # type: ignore

class Variation_824(Element):
    cv_arg: TypeAlias = RuleContent_46.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_46

    @classmethod
    def create(cls, arg: "Variation_824.cv_arg") -> "Variation_824":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_46:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_46:
        return self.rule.content

class RuleVariation_794(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_824.cv_arg
    cv_variation: TypeAlias = Variation_824

    @classmethod
    def create(cls, arg : "RuleVariation_794.cv_arg") -> "RuleVariation_794":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_824:
        return self.arg # type: ignore

class NonSpare_1998(NonSpare):
    cv_arg: TypeAlias = RuleVariation_794.cv_arg
    cv_name = "VAL"
    cv_title = "Basic Dataflash in Current Plot"
    cv_rule: TypeAlias = RuleVariation_794

    @classmethod
    def create(cls, arg : "NonSpare_1998.cv_arg") -> "NonSpare_1998":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_794:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_824:
        return self.rule.variation

class Item_1108(Item):
    cv_arg: TypeAlias = NonSpare_1998.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1998

    @classmethod
    def create(cls, arg : "Item_1108.cv_arg") -> "Item_1108":
        return cls._create(arg) # type: ignore

class Variation_1332(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_693.cv_arg, Tuple[Literal["EP"], RuleVariation_693.cv_arg]], Union[RuleVariation_794.cv_arg, Tuple[Literal["VAL"], RuleVariation_794.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1332.cv_arg_group"]
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_items_list = [(Item_299, 1), (Item_1108, 1)]
    cv_items_dict = {"EP": RuleVariation_693, "VAL": RuleVariation_794}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_693:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_794:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_693:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_794:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1332.cv_arg") -> 'Variation_1332':
        return cls._create(arg) # type: ignore

class RuleVariation_1256(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1332.cv_arg
    cv_variation: TypeAlias = Variation_1332

    @classmethod
    def create(cls, arg : "RuleVariation_1256.cv_arg") -> "RuleVariation_1256":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1332:
        return self.arg # type: ignore

class Content_240(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "IRMXPR not populated", 1: "IRMXPR populated"}

class RuleContent_240(RuleContentContextFree):
    cv_arg: TypeAlias = Content_240.cv_arg
    cv_content: TypeAlias = Content_240

    @property
    def content(self) -> Content_240:
        return self._get_content() # type: ignore

class Variation_48(Element):
    cv_arg: TypeAlias = RuleContent_240.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_240

    @classmethod
    def create(cls, arg: "Variation_48.cv_arg") -> "Variation_48":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_240:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_240:
        return self.rule.content

class RuleVariation_48(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_48.cv_arg
    cv_variation: TypeAlias = Variation_48

    @classmethod
    def create(cls, arg : "RuleVariation_48.cv_arg") -> "RuleVariation_48":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_48:
        return self.arg # type: ignore

class NonSpare_948(NonSpare):
    cv_arg: TypeAlias = RuleVariation_48.cv_arg
    cv_name = "EP"
    cv_title = "IRMXPR Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_48

    @classmethod
    def create(cls, arg : "NonSpare_948.cv_arg") -> "NonSpare_948":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_48:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_48:
        return self.rule.variation

class Item_309(Item):
    cv_arg: TypeAlias = NonSpare_948.cv_arg
    cv_non_spare: TypeAlias = NonSpare_948

    @classmethod
    def create(cls, arg : "Item_309.cv_arg") -> "Item_309":
        return cls._create(arg) # type: ignore

class Content_525(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Transponder not IRM capable", 1: "Transponder IRM capable"}

class RuleContent_525(RuleContentContextFree):
    cv_arg: TypeAlias = Content_525.cv_arg
    cv_content: TypeAlias = Content_525

    @property
    def content(self) -> Content_525:
        return self._get_content() # type: ignore

class Variation_462(Element):
    cv_arg: TypeAlias = RuleContent_525.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_525

    @classmethod
    def create(cls, arg: "Variation_462.cv_arg") -> "Variation_462":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_525:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_525:
        return self.rule.content

class RuleVariation_451(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_462.cv_arg
    cv_variation: TypeAlias = Variation_462

    @classmethod
    def create(cls, arg : "RuleVariation_451.cv_arg") -> "RuleVariation_451":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_462:
        return self.arg # type: ignore

class NonSpare_2007(NonSpare):
    cv_arg: TypeAlias = RuleVariation_451.cv_arg
    cv_name = "VAL"
    cv_title = "Transponder IRM Capability"
    cv_rule: TypeAlias = RuleVariation_451

    @classmethod
    def create(cls, arg : "NonSpare_2007.cv_arg") -> "NonSpare_2007":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_451:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_462:
        return self.rule.variation

class Item_1117(Item):
    cv_arg: TypeAlias = NonSpare_2007.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2007

    @classmethod
    def create(cls, arg : "Item_1117.cv_arg") -> "Item_1117":
        return cls._create(arg) # type: ignore

class Variation_1101(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_48.cv_arg, Tuple[Literal["EP"], RuleVariation_48.cv_arg]], Union[RuleVariation_451.cv_arg, Tuple[Literal["VAL"], RuleVariation_451.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1101.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_items_list = [(Item_309, 1), (Item_1117, 1)]
    cv_items_dict = {"EP": RuleVariation_48, "VAL": RuleVariation_451}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_48:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_451:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_48:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_451:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1101.cv_arg") -> 'Variation_1101':
        return cls._create(arg) # type: ignore

class RuleVariation_1059(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1101.cv_arg
    cv_variation: TypeAlias = Variation_1101

    @classmethod
    def create(cls, arg : "RuleVariation_1059.cv_arg") -> "RuleVariation_1059":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1101:
        return self.arg # type: ignore

class Content_239(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "IRMACT not populated", 1: "IRMACT populated"}

class RuleContent_239(RuleContentContextFree):
    cv_arg: TypeAlias = Content_239.cv_arg
    cv_content: TypeAlias = Content_239

    @property
    def content(self) -> Content_239:
        return self._get_content() # type: ignore

class Variation_539(Element):
    cv_arg: TypeAlias = RuleContent_239.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_239

    @classmethod
    def create(cls, arg: "Variation_539.cv_arg") -> "Variation_539":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_239:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_239:
        return self.rule.content

class RuleVariation_528(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_539.cv_arg
    cv_variation: TypeAlias = Variation_539

    @classmethod
    def create(cls, arg : "RuleVariation_528.cv_arg") -> "RuleVariation_528":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_539:
        return self.arg # type: ignore

class NonSpare_947(NonSpare):
    cv_arg: TypeAlias = RuleVariation_528.cv_arg
    cv_name = "EP"
    cv_title = "IRM Element Populated Bit"
    cv_rule: TypeAlias = RuleVariation_528

    @classmethod
    def create(cls, arg : "NonSpare_947.cv_arg") -> "NonSpare_947":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_528:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_539:
        return self.rule.variation

class Item_308(Item):
    cv_arg: TypeAlias = NonSpare_947.cv_arg
    cv_non_spare: TypeAlias = NonSpare_947

    @classmethod
    def create(cls, arg : "Item_308.cv_arg") -> "Item_308":
        return cls._create(arg) # type: ignore

class Content_238(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "IRM not active", 1: "IRM active"}

class RuleContent_238(RuleContentContextFree):
    cv_arg: TypeAlias = Content_238.cv_arg
    cv_content: TypeAlias = Content_238

    @property
    def content(self) -> Content_238:
        return self._get_content() # type: ignore

class Variation_644(Element):
    cv_arg: TypeAlias = RuleContent_238.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_238

    @classmethod
    def create(cls, arg: "Variation_644.cv_arg") -> "Variation_644":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_238:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_238:
        return self.rule.content

class RuleVariation_633(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_644.cv_arg
    cv_variation: TypeAlias = Variation_644

    @classmethod
    def create(cls, arg : "RuleVariation_633.cv_arg") -> "RuleVariation_633":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_644:
        return self.arg # type: ignore

class NonSpare_1999(NonSpare):
    cv_arg: TypeAlias = RuleVariation_633.cv_arg
    cv_name = "VAL"
    cv_title = "IRM Active for Current Plot"
    cv_rule: TypeAlias = RuleVariation_633

    @classmethod
    def create(cls, arg : "NonSpare_1999.cv_arg") -> "NonSpare_1999":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_633:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_644:
        return self.rule.variation

class Item_1109(Item):
    cv_arg: TypeAlias = NonSpare_1999.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1999

    @classmethod
    def create(cls, arg : "Item_1109.cv_arg") -> "Item_1109":
        return cls._create(arg) # type: ignore

class Variation_1325(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_528.cv_arg, Tuple[Literal["EP"], RuleVariation_528.cv_arg]], Union[RuleVariation_633.cv_arg, Tuple[Literal["VAL"], RuleVariation_633.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1325.cv_arg_group"]
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_items_list = [(Item_308, 1), (Item_1109, 1)]
    cv_items_dict = {"EP": RuleVariation_528, "VAL": RuleVariation_633}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_528:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_633:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_528:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_633:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1325.cv_arg") -> 'Variation_1325':
        return cls._create(arg) # type: ignore

class RuleVariation_1249(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1325.cv_arg
    cv_variation: TypeAlias = Variation_1325

    @classmethod
    def create(cls, arg : "RuleVariation_1249.cv_arg") -> "RuleVariation_1249":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1325:
        return self.arg # type: ignore

class NonSpare_561(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1047.cv_arg
    cv_name = "ACASXV"
    cv_title = "Extended Version"
    cv_rule: TypeAlias = RuleVariation_1047

    @classmethod
    def create(cls, arg : "NonSpare_561.cv_arg") -> "NonSpare_561":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1047:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1089:
        return self.rule.variation

class Item_41(Item):
    cv_arg: TypeAlias = NonSpare_561.cv_arg
    cv_non_spare: TypeAlias = NonSpare_561

    @classmethod
    def create(cls, arg : "Item_41.cv_arg") -> "Item_41":
        return cls._create(arg) # type: ignore

class NonSpare_1454(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1263.cv_arg
    cv_name = "POXPR"
    cv_title = "PO Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_1263

    @classmethod
    def create(cls, arg : "NonSpare_1454.cv_arg") -> "NonSpare_1454":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1263:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1342:
        return self.rule.variation

class Item_697(Item):
    cv_arg: TypeAlias = NonSpare_1454.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1454

    @classmethod
    def create(cls, arg : "Item_697.cv_arg") -> "Item_697":
        return cls._create(arg) # type: ignore

class NonSpare_1441(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1060.cv_arg
    cv_name = "POACT"
    cv_title = "PO Active for Current Plot"
    cv_rule: TypeAlias = RuleVariation_1060

    @classmethod
    def create(cls, arg : "NonSpare_1441.cv_arg") -> "NonSpare_1441":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1060:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1102:
        return self.rule.variation

class Item_690(Item):
    cv_arg: TypeAlias = NonSpare_1441.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1441

    @classmethod
    def create(cls, arg : "Item_690.cv_arg") -> "Item_690":
        return cls._create(arg) # type: ignore

class NonSpare_908(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1247.cv_arg
    cv_name = "DTFXPR"
    cv_title = "Basic Dataflash Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_1247

    @classmethod
    def create(cls, arg : "NonSpare_908.cv_arg") -> "NonSpare_908":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1323:
        return self.rule.variation

class Item_278(Item):
    cv_arg: TypeAlias = NonSpare_908.cv_arg
    cv_non_spare: TypeAlias = NonSpare_908

    @classmethod
    def create(cls, arg : "Item_278.cv_arg") -> "Item_278":
        return cls._create(arg) # type: ignore

class NonSpare_907(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1256.cv_arg
    cv_name = "DTFACT"
    cv_title = "Basic Dataflash Active for Current Plot"
    cv_rule: TypeAlias = RuleVariation_1256

    @classmethod
    def create(cls, arg : "NonSpare_907.cv_arg") -> "NonSpare_907":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1256:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1332:
        return self.rule.variation

class Item_277(Item):
    cv_arg: TypeAlias = NonSpare_907.cv_arg
    cv_non_spare: TypeAlias = NonSpare_907

    @classmethod
    def create(cls, arg : "Item_277.cv_arg") -> "Item_277":
        return cls._create(arg) # type: ignore

class NonSpare_1127(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1059.cv_arg
    cv_name = "IRMXPR"
    cv_title = "IRM Transponder Capability"
    cv_rule: TypeAlias = RuleVariation_1059

    @classmethod
    def create(cls, arg : "NonSpare_1127.cv_arg") -> "NonSpare_1127":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1059:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1101:
        return self.rule.variation

class Item_440(Item):
    cv_arg: TypeAlias = NonSpare_1127.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1127

    @classmethod
    def create(cls, arg : "Item_440.cv_arg") -> "Item_440":
        return cls._create(arg) # type: ignore

class NonSpare_1126(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1249.cv_arg
    cv_name = "IRMACT"
    cv_title = "IRM Active for Current Plot"
    cv_rule: TypeAlias = RuleVariation_1249

    @classmethod
    def create(cls, arg : "NonSpare_1126.cv_arg") -> "NonSpare_1126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1325:
        return self.rule.variation

class Item_439(Item):
    cv_arg: TypeAlias = NonSpare_1126.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1126

    @classmethod
    def create(cls, arg : "Item_439.cv_arg") -> "Item_439":
        return cls._create(arg) # type: ignore

class Variation_1391(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_127.cv_arg, Tuple[Literal["TYP"], RuleVariation_127.cv_arg]], Union[RuleVariation_604.cv_arg, Tuple[Literal["SIM"], RuleVariation_604.cv_arg]], Union[RuleVariation_737.cv_arg, Tuple[Literal["RDP"], RuleVariation_737.cv_arg]], Union[RuleVariation_789.cv_arg, Tuple[Literal["SPI"], RuleVariation_789.cv_arg]], Union[RuleVariation_918.cv_arg, Tuple[Literal["RAB"], RuleVariation_918.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_73.cv_arg, Tuple[Literal["TST"], RuleVariation_73.cv_arg]], Union[RuleVariation_429.cv_arg, Tuple[Literal["ERR"], RuleVariation_429.cv_arg]], Union[RuleVariation_548.cv_arg, Tuple[Literal["XPP"], RuleVariation_548.cv_arg]], Union[RuleVariation_642.cv_arg, Tuple[Literal["ME"], RuleVariation_642.cv_arg]], Union[RuleVariation_730.cv_arg, Tuple[Literal["MI"], RuleVariation_730.cv_arg]], Union[RuleVariation_850.cv_arg, Tuple[Literal["FOEFRI"], RuleVariation_850.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_1048.cv_arg, Tuple[Literal["ADSB"], RuleVariation_1048.cv_arg]], Union[RuleVariation_1250.cv_arg, Tuple[Literal["SCN"], RuleVariation_1250.cv_arg]], Union[RuleVariation_1259.cv_arg, Tuple[Literal["PAI"], RuleVariation_1259.cv_arg]], int, None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_1047.cv_arg, Tuple[Literal["ACASXV"], RuleVariation_1047.cv_arg]], Union[RuleVariation_1263.cv_arg, Tuple[Literal["POXPR"], RuleVariation_1263.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_1060.cv_arg, Tuple[Literal["POACT"], RuleVariation_1060.cv_arg]], Union[RuleVariation_1247.cv_arg, Tuple[Literal["DTFXPR"], RuleVariation_1247.cv_arg]], Union[RuleVariation_1256.cv_arg, Tuple[Literal["DTFACT"], RuleVariation_1256.cv_arg]], int, None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_1059.cv_arg, Tuple[Literal["IRMXPR"], RuleVariation_1059.cv_arg]], Union[RuleVariation_1249.cv_arg, Tuple[Literal["IRMACT"], RuleVariation_1249.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1391.cv_arg_group_1"],
        Tuple["Variation_1391.cv_arg_group_1", "Variation_1391.cv_arg_group_2"],
        Tuple["Variation_1391.cv_arg_group_1", "Variation_1391.cv_arg_group_2", "Variation_1391.cv_arg_group_3"],
        Tuple["Variation_1391.cv_arg_group_1", "Variation_1391.cv_arg_group_2", "Variation_1391.cv_arg_group_3", "Variation_1391.cv_arg_group_4"],
        Tuple["Variation_1391.cv_arg_group_1", "Variation_1391.cv_arg_group_2", "Variation_1391.cv_arg_group_3", "Variation_1391.cv_arg_group_4", "Variation_1391.cv_arg_group_5"],
        Tuple["Variation_1391.cv_arg_group_1", "Variation_1391.cv_arg_group_2", "Variation_1391.cv_arg_group_3", "Variation_1391.cv_arg_group_4", "Variation_1391.cv_arg_group_5", "Variation_1391.cv_arg_group_6"],
    ]
    cv_items_list = [[(Item_1073, 3), (Item_901, 1), (Item_787, 1), (Item_912, 1), (Item_770, 1), None], [(Item_1051, 1), (Item_318, 1), (Item_1219, 1), (Item_545, 1), (Item_552, 1), (Item_334, 2), None], [(Item_48, 2), (Item_865, 2), (Item_677, 2), (Item_26, 1), None], [(Item_41, 5), (Item_697, 2), None], [(Item_690, 2), (Item_278, 2), (Item_277, 2), (Item_26, 1), None], [(Item_440, 2), (Item_439, 2), (Item_21, 3), None]]

    @classmethod
    def create(cls, arg: "Variation_1391.cv_arg") -> 'Variation_1391':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_127:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_604:
        ...
    @overload
    def get_item(self, key : Literal["RDP"]) -> RuleVariation_737:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_789:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_918:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> Optional[RuleVariation_73]:
        ...
    @overload
    def get_item(self, key : Literal["ERR"]) -> Optional[RuleVariation_429]:
        ...
    @overload
    def get_item(self, key : Literal["XPP"]) -> Optional[RuleVariation_548]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_642]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_730]:
        ...
    @overload
    def get_item(self, key : Literal["FOEFRI"]) -> Optional[RuleVariation_850]:
        ...
    @overload
    def get_item(self, key : Literal["ADSB"]) -> Optional[RuleVariation_1048]:
        ...
    @overload
    def get_item(self, key : Literal["SCN"]) -> Optional[RuleVariation_1250]:
        ...
    @overload
    def get_item(self, key : Literal["PAI"]) -> Optional[RuleVariation_1259]:
        ...
    @overload
    def get_item(self, key : Literal["ACASXV"]) -> Optional[RuleVariation_1047]:
        ...
    @overload
    def get_item(self, key : Literal["POXPR"]) -> Optional[RuleVariation_1263]:
        ...
    @overload
    def get_item(self, key : Literal["POACT"]) -> Optional[RuleVariation_1060]:
        ...
    @overload
    def get_item(self, key : Literal["DTFXPR"]) -> Optional[RuleVariation_1247]:
        ...
    @overload
    def get_item(self, key : Literal["DTFACT"]) -> Optional[RuleVariation_1256]:
        ...
    @overload
    def get_item(self, key : Literal["IRMXPR"]) -> Optional[RuleVariation_1059]:
        ...
    @overload
    def get_item(self, key : Literal["IRMACT"]) -> Optional[RuleVariation_1249]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1312(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1391.cv_arg
    cv_variation: TypeAlias = Variation_1391

    @classmethod
    def create(cls, arg : "RuleVariation_1312.cv_arg") -> "RuleVariation_1312":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1391:
        return self.arg # type: ignore

class NonSpare_90(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1312.cv_arg
    cv_name = "020"
    cv_title = "Target Report Descriptor"
    cv_rule: TypeAlias = RuleVariation_1312

    @classmethod
    def create(cls, arg : "NonSpare_90.cv_arg") -> "NonSpare_90":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1391:
        return self.rule.variation

class UapItem_90(UapItem):
    cv_non_spare: TypeAlias = NonSpare_90

class NonSpare_212(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1194.cv_arg
    cv_name = "070"
    cv_title = "Mode-3/A Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1194

    @classmethod
    def create(cls, arg : "NonSpare_212.cv_arg") -> "NonSpare_212":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1194:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1265:
        return self.rule.variation

class UapItem_212(UapItem):
    cv_non_spare: TypeAlias = NonSpare_212

class NonSpare_972(NonSpare):
    cv_arg: TypeAlias = RuleVariation_598.cv_arg
    cv_name = "FL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_598

    @classmethod
    def create(cls, arg : "NonSpare_972.cv_arg") -> "NonSpare_972":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_598:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_609:
        return self.rule.variation

class Item_329(Item):
    cv_arg: TypeAlias = NonSpare_972.cv_arg
    cv_non_spare: TypeAlias = NonSpare_972

    @classmethod
    def create(cls, arg : "Item_329.cv_arg") -> "Item_329":
        return cls._create(arg) # type: ignore

class Variation_1255(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_598.cv_arg, Tuple[Literal["FL"], RuleVariation_598.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1255.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1102, 1), (Item_355, 1), (Item_329, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "FL": RuleVariation_598}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FL"]) -> RuleVariation_598:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["FL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["FL"]) -> RuleVariation_598:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1255.cv_arg") -> 'Variation_1255':
        return cls._create(arg) # type: ignore

class RuleVariation_1184(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1255.cv_arg
    cv_variation: TypeAlias = Variation_1255

    @classmethod
    def create(cls, arg : "RuleVariation_1184.cv_arg") -> "RuleVariation_1184":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1255:
        return self.arg # type: ignore

class NonSpare_248(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1184.cv_arg
    cv_name = "090"
    cv_title = "Flight Level in Binary Representation"
    cv_rule: TypeAlias = RuleVariation_1184

    @classmethod
    def create(cls, arg : "NonSpare_248.cv_arg") -> "NonSpare_248":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1255:
        return self.rule.variation

class UapItem_248(UapItem):
    cv_non_spare: TypeAlias = NonSpare_248

class Content_396(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not defined; never used", 1: "Multipath Reply (Reflection)", 2: "Reply due to sidelobe interrogation/reception", 3: "Split plot", 4: "Second time around reply", 5: "Angel", 6: "Slow moving target correlated with road infrastructure (terrestrial vehicle)", 7: "Fixed PSR plot", 8: "Slow PSR target", 9: "Low quality PSR plot", 10: "Phantom SSR plot", 11: "Non-Matching Mode-3/A Code", 12: "Mode C code / Mode S altitude code abnormal value compared to the track", 13: "Target in Clutter Area", 14: "Maximum Doppler Response in Zero Filter", 15: "Transponder anomaly detected", 16: "Duplicated or Illegal Mode S Aircraft Address", 17: "Mode S error correction applied", 18: "Undecodable Mode C code / Mode S altitude code", 19: "Birds", 20: "Flock of Birds", 21: "Mode-1 was present in original reply", 22: "Mode-2 was present in original reply", 23: "Plot potentially caused by Wind Turbine", 24: "Helicopter", 25: "Maximum number of re-interrogations reached (surveillance information)", 26: "Maximum number of re-interrogations reached (BDS Extractions)", 27: "BDS Overlay Incoherence", 28: "Potential BDS Swap Detected", 29: "Track Update in the Zenithal Gap", 30: "Mode S Track re-acquired", 31: "Duplicated Mode 5 Pair NO/PIN detected", 32: "Wrong DF reply format detected", 33: "Transponder anomaly (MS XPD replies with Mode A/C to Mode A/C-only all-call)", 34: "Transponder anomaly (SI capability report wrong)", 35: "Potential IC Conflict", 36: "IC Conflict detection possible-no conflict currently detected", 37: "Duplicate Mode 5 PIN (refer to the Mode 5 items in the REF)"}

class RuleContent_396(RuleContentContextFree):
    cv_arg: TypeAlias = Content_396.cv_arg
    cv_content: TypeAlias = Content_396

    @property
    def content(self) -> Content_396:
        return self._get_content() # type: ignore

class Variation_156(Element):
    cv_arg: TypeAlias = RuleContent_396.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_396

    @classmethod
    def create(cls, arg: "Variation_156.cv_arg") -> "Variation_156":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_396:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_396:
        return self.rule.content

class Variation_1459(Repetitive):
    cv_arg: TypeAlias = List[Variation_156.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_156

    @classmethod
    def create(cls, arg: "Variation_1459.cv_arg") -> 'Variation_1459':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_156]:
        return self._get_list() # type: ignore

class RuleVariation_1380(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1459.cv_arg
    cv_variation: TypeAlias = Variation_1459

    @classmethod
    def create(cls, arg : "RuleVariation_1380.cv_arg") -> "RuleVariation_1380":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1459:
        return self.arg # type: ignore

class NonSpare_122(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1380.cv_arg
    cv_name = "030"
    cv_title = "Warning/Error Conditions and Target Classification"
    cv_rule: TypeAlias = RuleVariation_1380

    @classmethod
    def create(cls, arg : "NonSpare_122.cv_arg") -> "NonSpare_122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1380:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1459:
        return self.rule.variation

class UapItem_122(UapItem):
    cv_non_spare: TypeAlias = NonSpare_122

class NonSpare_172(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1190.cv_arg
    cv_name = "050"
    cv_title = "Mode-2 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_1190

    @classmethod
    def create(cls, arg : "NonSpare_172.cv_arg") -> "NonSpare_172":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1261:
        return self.rule.variation

class UapItem_172(UapItem):
    cv_non_spare: TypeAlias = NonSpare_172

class Record_33(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_39.cv_arg,
        "140": NonSpare_333.cv_arg,
        "020": NonSpare_90.cv_arg,
        "040": NonSpare_139.cv_arg,
        "070": NonSpare_212.cv_arg,
        "090": NonSpare_248.cv_arg,
        "130": NonSpare_313.cv_arg,
        "220": NonSpare_421.cv_arg,
        "240": NonSpare_437.cv_arg,
        "250": NonSpare_445.cv_arg,
        "161": NonSpare_364.cv_arg,
        "042": NonSpare_160.cv_arg,
        "200": NonSpare_390.cv_arg,
        "170": NonSpare_377.cv_arg,
        "210": NonSpare_416.cv_arg,
        "030": NonSpare_122.cv_arg,
        "080": NonSpare_233.cv_arg,
        "100": NonSpare_273.cv_arg,
        "110": NonSpare_287.cv_arg,
        "120": NonSpare_302.cv_arg,
        "230": NonSpare_430.cv_arg,
        "260": NonSpare_455.cv_arg,
        "055": NonSpare_186.cv_arg,
        "050": NonSpare_172.cv_arg,
        "065": NonSpare_203.cv_arg,
        "060": NonSpare_188.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_39, UapItem_333, UapItem_90, UapItem_139, UapItem_212, UapItem_248, UapItem_313, UapItem_421, UapItem_437, UapItem_445, UapItem_364, UapItem_160, UapItem_390, UapItem_377, UapItem_416, UapItem_122, UapItem_233, UapItem_273, UapItem_287, UapItem_302, UapItem_430, UapItem_455, UapItem_186, UapItem_172, UapItem_203, UapItem_188, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_39, "140": NonSpare_333, "020": NonSpare_90, "040": NonSpare_139, "070": NonSpare_212, "090": NonSpare_248, "130": NonSpare_313, "220": NonSpare_421, "240": NonSpare_437, "250": NonSpare_445, "161": NonSpare_364, "042": NonSpare_160, "200": NonSpare_390, "170": NonSpare_377, "210": NonSpare_416, "030": NonSpare_122, "080": NonSpare_233, "100": NonSpare_273, "110": NonSpare_287, "120": NonSpare_302, "230": NonSpare_430, "260": NonSpare_455, "055": NonSpare_186, "050": NonSpare_172, "065": NonSpare_203, "060": NonSpare_188, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_39:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_333:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_90:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_139:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_212:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_248:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_313:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_421:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_437:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_445:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["161"]) -> NonSpare_364:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["042"]) -> NonSpare_160:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_377:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_122:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_287:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_302:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["260"]) -> NonSpare_455:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["055"]) -> NonSpare_186:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_172:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["065"]) -> NonSpare_203:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_188:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["140"], Literal["020"], Literal["040"], Literal["070"], Literal["090"], Literal["130"], Literal["220"], Literal["240"], Literal["250"], Literal["161"], Literal["042"], Literal["200"], Literal["170"], Literal["210"], Literal["030"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["230"], Literal["260"], Literal["055"], Literal["050"], Literal["065"], Literal["060"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_39]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_333]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_90]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_139]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_212]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_248]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_313]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_421]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_437]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_445]:
        ...
    @overload
    def get_item(self, key : Literal["161"]) -> Optional[NonSpare_364]:
        ...
    @overload
    def get_item(self, key : Literal["042"]) -> Optional[NonSpare_160]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_390]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_377]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_416]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_122]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_233]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_273]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_287]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_302]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_430]:
        ...
    @overload
    def get_item(self, key : Literal["260"]) -> Optional[NonSpare_455]:
        ...
    @overload
    def get_item(self, key : Literal["055"]) -> Optional[NonSpare_186]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_172]:
        ...
    @overload
    def get_item(self, key : Literal["065"]) -> Optional[NonSpare_203]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_188]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_39.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_333.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_90.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_139.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_212.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_248.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_313.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_421.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_437.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_445.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["161"], val : NonSpare_364.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["042"], val : NonSpare_160.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_390.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_377.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_416.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_122.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_233.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_273.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_287.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_302.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_430.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["260"], val : NonSpare_455.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["055"], val : NonSpare_186.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_172.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["065"], val : NonSpare_203.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_188.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_33':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_33':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["161"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["042"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["260"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["055"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["065"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_33':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_33':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_33.cv_arg") -> 'Record_33':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_33", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_29(UapSingle):
    cv_arg: TypeAlias = Record_33
    cv_record: TypeAlias = Record_33

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_33]]:
        return cls._parse(bs)

class Asterix_50(AstCat):
    cv_category = 48
    cv_edition = (1, 32)
    cv_uap: TypeAlias = Uap_29
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_29.cv_arg]) -> "Asterix_50":
        return cls._create(records) # type: ignore

class Content_347(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No detection", 1: "Single PSR detection", 2: "Single SSR detection", 3: "SSR+PSR detection", 4: "Single Mode S All-Call", 5: "Single Mode S Roll-Call", 6: "Mode S All-Call + PSR", 7: "Mode S Roll-Call + PSR", 8: "ADS-B", 9: "WAM"}

class RuleContent_347(RuleContentContextFree):
    cv_arg: TypeAlias = Content_347.cv_arg
    cv_content: TypeAlias = Content_347

    @property
    def content(self) -> Content_347:
        return self._get_content() # type: ignore

class Variation_800(Element):
    cv_arg: TypeAlias = RuleContent_347.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 4
    cv_rule = RuleContent_347

    @classmethod
    def create(cls, arg: "Variation_800.cv_arg") -> "Variation_800":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_347:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_347:
        return self.rule.content

class RuleVariation_770(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_800.cv_arg
    cv_variation: TypeAlias = Variation_800

    @classmethod
    def create(cls, arg : "RuleVariation_770.cv_arg") -> "RuleVariation_770":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_800:
        return self.arg # type: ignore

class NonSpare_1963(NonSpare):
    cv_arg: TypeAlias = RuleVariation_770.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_770

    @classmethod
    def create(cls, arg : "NonSpare_1963.cv_arg") -> "NonSpare_1963":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_770:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_800:
        return self.rule.variation

class Item_1077(Item):
    cv_arg: TypeAlias = NonSpare_1963.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1963

    @classmethod
    def create(cls, arg : "Item_1077.cv_arg") -> "Item_1077":
        return cls._create(arg) # type: ignore

class NonSpare_1199(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "LTN"
    cv_title = "Local Track Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1199.cv_arg") -> "NonSpare_1199":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_507(Item):
    cv_arg: TypeAlias = NonSpare_1199.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1199

    @classmethod
    def create(cls, arg : "Item_507.cv_arg") -> "Item_507":
        return cls._create(arg) # type: ignore

class Variation_1194(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SAC"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SIC"], RuleVariation_159.cv_arg]], int, Union[RuleVariation_770.cv_arg, Tuple[Literal["TYP"], RuleVariation_770.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["LTN"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1194.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_856, 8), (Item_887, 8), (Item_3, 4), (Item_1077, 4), (Item_507, 16)]
    cv_items_dict = {"SAC": RuleVariation_159, "SIC": RuleVariation_159, "TYP": RuleVariation_770, "LTN": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_770:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LTN"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"], Literal["TYP"], Literal["LTN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_770:
        ...
    @overload
    def get_item(self, key : Literal["LTN"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1194.cv_arg") -> 'Variation_1194':
        return cls._create(arg) # type: ignore

class Variation_1431(Repetitive):
    cv_arg: TypeAlias = List[Variation_1194.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1194

    @classmethod
    def create(cls, arg: "Variation_1431.cv_arg") -> 'Variation_1431':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1194]:
        return self._get_list() # type: ignore

class RuleVariation_1352(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1431.cv_arg
    cv_variation: TypeAlias = Variation_1431

    @classmethod
    def create(cls, arg : "RuleVariation_1352.cv_arg") -> "RuleVariation_1352":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1431:
        return self.arg # type: ignore

class NonSpare_843(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1352.cv_arg
    cv_name = "CST"
    cv_title = "Contributing Sensors With Local Tracknumbers"
    cv_rule: TypeAlias = RuleVariation_1352

    @classmethod
    def create(cls, arg : "NonSpare_843.cv_arg") -> "NonSpare_843":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1352:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1431:
        return self.rule.variation

class Variation_1193(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["SAC"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["SIC"], RuleVariation_159.cv_arg]], int, Union[RuleVariation_770.cv_arg, Tuple[Literal["TYP"], RuleVariation_770.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1193.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_856, 8), (Item_887, 8), (Item_3, 4), (Item_1077, 4)]
    cv_items_dict = {"SAC": RuleVariation_159, "SIC": RuleVariation_159, "TYP": RuleVariation_770}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_770:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAC"], Literal["SIC"], Literal["TYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["SIC"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_770:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1193.cv_arg") -> 'Variation_1193':
        return cls._create(arg) # type: ignore

class Variation_1430(Repetitive):
    cv_arg: TypeAlias = List[Variation_1193.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1193

    @classmethod
    def create(cls, arg: "Variation_1430.cv_arg") -> 'Variation_1430':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1193]:
        return self._get_list() # type: ignore

class RuleVariation_1351(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1430.cv_arg
    cv_variation: TypeAlias = Variation_1430

    @classmethod
    def create(cls, arg : "RuleVariation_1351.cv_arg") -> "RuleVariation_1351":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1430:
        return self.arg # type: ignore

class NonSpare_837(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1351.cv_arg
    cv_name = "CSN"
    cv_title = "Contributing Sensors No Local Tracknumbers"
    cv_rule: TypeAlias = RuleVariation_1351

    @classmethod
    def create(cls, arg : "NonSpare_837.cv_arg") -> "NonSpare_837":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1430:
        return self.rule.variation

class Content_663(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_663(RuleContentContextFree):
    cv_arg: TypeAlias = Content_663.cv_arg
    cv_content: TypeAlias = Content_663

    @property
    def content(self) -> Content_663:
        return self._get_content() # type: ignore

class Variation_280(Element):
    cv_arg: TypeAlias = RuleContent_663.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_663

    @classmethod
    def create(cls, arg: "Variation_280.cv_arg") -> "Variation_280":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_663:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_663:
        return self.rule.content

class RuleVariation_273(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_280.cv_arg
    cv_variation: TypeAlias = Variation_280

    @classmethod
    def create(cls, arg : "RuleVariation_273.cv_arg") -> "RuleVariation_273":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_280:
        return self.arg # type: ignore

class NonSpare_2049(NonSpare):
    cv_arg: TypeAlias = RuleVariation_273.cv_arg
    cv_name = "VX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_273

    @classmethod
    def create(cls, arg : "NonSpare_2049.cv_arg") -> "NonSpare_2049":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_280:
        return self.rule.variation

class Item_1155(Item):
    cv_arg: TypeAlias = NonSpare_2049.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2049

    @classmethod
    def create(cls, arg : "Item_1155.cv_arg") -> "Item_1155":
        return cls._create(arg) # type: ignore

class NonSpare_2054(NonSpare):
    cv_arg: TypeAlias = RuleVariation_273.cv_arg
    cv_name = "VY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_273

    @classmethod
    def create(cls, arg : "NonSpare_2054.cv_arg") -> "NonSpare_2054":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_280:
        return self.rule.variation

class Item_1160(Item):
    cv_arg: TypeAlias = NonSpare_2054.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2054

    @classmethod
    def create(cls, arg : "Item_1160.cv_arg") -> "Item_1160":
        return cls._create(arg) # type: ignore

class Variation_1280(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_273.cv_arg, Tuple[Literal["VX"], RuleVariation_273.cv_arg]], Union[RuleVariation_273.cv_arg, Tuple[Literal["VY"], RuleVariation_273.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1280.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1155, 16), (Item_1160, 16)]
    cv_items_dict = {"VX": RuleVariation_273, "VY": RuleVariation_273}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_273:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_273:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_273:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1280.cv_arg") -> 'Variation_1280':
        return cls._create(arg) # type: ignore

class RuleVariation_1209(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1280.cv_arg
    cv_variation: TypeAlias = Variation_1280

    @classmethod
    def create(cls, arg : "RuleVariation_1209.cv_arg") -> "RuleVariation_1209":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1280:
        return self.arg # type: ignore

class NonSpare_1954(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1209.cv_arg
    cv_name = "TVS"
    cv_title = "Calculated Track Velocity Relative to System Reference Point"
    cv_rule: TypeAlias = RuleVariation_1209

    @classmethod
    def create(cls, arg : "NonSpare_1954.cv_arg") -> "NonSpare_1954":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1209:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1280:
        return self.rule.variation

class Content_213(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Flight plan data from active FDPS", 1: "Flight plan data retained from no longer active FDPS"}

class RuleContent_213(RuleContentContextFree):
    cv_arg: TypeAlias = Content_213.cv_arg
    cv_content: TypeAlias = Content_213

    @property
    def content(self) -> Content_213:
        return self._get_content() # type: ignore

class Variation_43(Element):
    cv_arg: TypeAlias = RuleContent_213.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_213

    @classmethod
    def create(cls, arg: "Variation_43.cv_arg") -> "Variation_43":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_213:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_213:
        return self.rule.content

class RuleVariation_43(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_43.cv_arg
    cv_variation: TypeAlias = Variation_43

    @classmethod
    def create(cls, arg : "RuleVariation_43.cv_arg") -> "RuleVariation_43":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_43:
        return self.arg # type: ignore

class NonSpare_971(NonSpare):
    cv_arg: TypeAlias = RuleVariation_43.cv_arg
    cv_name = "FDR"
    cv_title = "Flight Data Retained"
    cv_rule: TypeAlias = RuleVariation_43

    @classmethod
    def create(cls, arg : "NonSpare_971.cv_arg") -> "NonSpare_971":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_43:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_43:
        return self.rule.variation

class Item_328(Item):
    cv_arg: TypeAlias = NonSpare_971.cv_arg
    cv_non_spare: TypeAlias = NonSpare_971

    @classmethod
    def create(cls, arg : "Item_328.cv_arg") -> "Item_328":
        return cls._create(arg) # type: ignore

class Variation_1360(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_43.cv_arg, Tuple[Literal["FDR"], RuleVariation_43.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1360.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_328, 1), (Item_9, 6), None]]

    @classmethod
    def create(cls, arg: "Variation_1360.cv_arg") -> 'Variation_1360':
        return cls._create(arg) # type: ignore

    @overload # type: ignore
    def get_item(self, key : Literal["FDR"]) -> RuleVariation_43:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1281(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1360.cv_arg
    cv_variation: TypeAlias = Variation_1360

    @classmethod
    def create(cls, arg : "RuleVariation_1281.cv_arg") -> "RuleVariation_1281":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1360:
        return self.arg # type: ignore

class NonSpare_1800(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1281.cv_arg
    cv_name = "STS"
    cv_title = "Supplementary Track Status"
    cv_rule: TypeAlias = RuleVariation_1281

    @classmethod
    def create(cls, arg : "NonSpare_1800.cv_arg") -> "NonSpare_1800":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1281:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1360:
        return self.rule.variation

class Expansion_2(Expansion):
    cv_arg = TypedDict('cv_arg', {
        "CST": NonSpare_843.cv_arg,
        "CSN": NonSpare_837.cv_arg,
        "TVS": NonSpare_1954.cv_arg,
        "STS": NonSpare_1800.cv_arg,
    }, total=False)
    cv_type = (FspecFixed, 1)
    cv_items_list = [NonSpare_843, NonSpare_837, NonSpare_1954, NonSpare_1800]
    cv_items_dict = {"CST": NonSpare_843, "CSN": NonSpare_837, "TVS": NonSpare_1954, "STS": NonSpare_1800}

    @overload
    @classmethod
    def spec(cls, key : Literal["CST"]) -> NonSpare_843:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_837:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TVS"]) -> NonSpare_1954:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1800:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CST"], Literal["CSN"], Literal["TVS"], Literal["STS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[NonSpare_843]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_837]:
        ...
    @overload
    def get_item(self, key : Literal["TVS"]) -> Optional[NonSpare_1954]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1800]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CST"], val : NonSpare_843.cv_arg) -> "Expansion_2":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_837.cv_arg) -> "Expansion_2":
        ...
    @overload
    def set_item(self, key : Literal["TVS"], val : NonSpare_1954.cv_arg) -> "Expansion_2":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1800.cv_arg) -> "Expansion_2":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CST"]) -> "Expansion_2":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Expansion_2":
        ...
    @overload
    def del_item(self, key : Literal["TVS"]) -> "Expansion_2":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Expansion_2":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Expansion_2.cv_arg") -> 'Expansion_2':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_2", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_51(AstRef):
    cv_category = 62
    cv_edition = (1, 2)
    cv_expansion: TypeAlias = Expansion_2

class Content_252(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "LNAV not populated", 1: "LNAV populated"}

class RuleContent_252(RuleContentContextFree):
    cv_arg: TypeAlias = Content_252.cv_arg
    cv_content: TypeAlias = Content_252

    @property
    def content(self) -> Content_252:
        return self._get_content() # type: ignore

class Variation_435(Element):
    cv_arg: TypeAlias = RuleContent_252.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_252

    @classmethod
    def create(cls, arg: "Variation_435.cv_arg") -> "Variation_435":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_252:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_252:
        return self.rule.content

class RuleVariation_424(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_435.cv_arg
    cv_variation: TypeAlias = Variation_435

    @classmethod
    def create(cls, arg : "RuleVariation_424.cv_arg") -> "RuleVariation_424":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_435:
        return self.arg # type: ignore

class NonSpare_949(NonSpare):
    cv_arg: TypeAlias = RuleVariation_424.cv_arg
    cv_name = "EP"
    cv_title = "LNAV Element Populated"
    cv_rule: TypeAlias = RuleVariation_424

    @classmethod
    def create(cls, arg : "NonSpare_949.cv_arg") -> "NonSpare_949":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_424:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_435:
        return self.rule.variation

class Item_310(Item):
    cv_arg: TypeAlias = NonSpare_949.cv_arg
    cv_non_spare: TypeAlias = NonSpare_949

    @classmethod
    def create(cls, arg : "Item_310.cv_arg") -> "Item_310":
        return cls._create(arg) # type: ignore

class Content_250(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "LNAV Mode Engaged", 1: "LNAV Mode not Engaged"}

class RuleContent_250(RuleContentContextFree):
    cv_arg: TypeAlias = Content_250.cv_arg
    cv_content: TypeAlias = Content_250

    @property
    def content(self) -> Content_250:
        return self._get_content() # type: ignore

class Variation_541(Element):
    cv_arg: TypeAlias = RuleContent_250.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_250

    @classmethod
    def create(cls, arg: "Variation_541.cv_arg") -> "Variation_541":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_250:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_250:
        return self.rule.content

class RuleVariation_530(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_541.cv_arg
    cv_variation: TypeAlias = Variation_541

    @classmethod
    def create(cls, arg : "RuleVariation_530.cv_arg") -> "RuleVariation_530":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_541:
        return self.arg # type: ignore

class NonSpare_2000(NonSpare):
    cv_arg: TypeAlias = RuleVariation_530.cv_arg
    cv_name = "VAL"
    cv_title = "LNAV Mode"
    cv_rule: TypeAlias = RuleVariation_530

    @classmethod
    def create(cls, arg : "NonSpare_2000.cv_arg") -> "NonSpare_2000":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_530:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_541:
        return self.rule.variation

class Item_1110(Item):
    cv_arg: TypeAlias = NonSpare_2000.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2000

    @classmethod
    def create(cls, arg : "Item_1110.cv_arg") -> "Item_1110":
        return cls._create(arg) # type: ignore

class Variation_1322(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_424.cv_arg, Tuple[Literal["EP"], RuleVariation_424.cv_arg]], Union[RuleVariation_530.cv_arg, Tuple[Literal["VAL"], RuleVariation_530.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1322.cv_arg_group"]
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_items_list = [(Item_310, 1), (Item_1110, 1)]
    cv_items_dict = {"EP": RuleVariation_424, "VAL": RuleVariation_530}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_424:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_530:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_424:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_530:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1322.cv_arg") -> 'Variation_1322':
        return cls._create(arg) # type: ignore

class RuleVariation_1246(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1322.cv_arg
    cv_variation: TypeAlias = Variation_1322

    @classmethod
    def create(cls, arg : "RuleVariation_1246.cv_arg") -> "RuleVariation_1246":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1322:
        return self.arg # type: ignore

class NonSpare_1174(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1246.cv_arg
    cv_name = "LNAV"
    cv_title = "Lateral Navigation Mode"
    cv_rule: TypeAlias = RuleVariation_1246

    @classmethod
    def create(cls, arg : "NonSpare_1174.cv_arg") -> "NonSpare_1174":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1322:
        return self.rule.variation

class Item_484(Item):
    cv_arg: TypeAlias = NonSpare_1174.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1174

    @classmethod
    def create(cls, arg : "Item_484.cv_arg") -> "Item_484":
        return cls._create(arg) # type: ignore

class Variation_1361(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_43.cv_arg, Tuple[Literal["FDR"], RuleVariation_43.cv_arg]], Union[RuleVariation_1246.cv_arg, Tuple[Literal["LNAV"], RuleVariation_1246.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1361.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_328, 1), (Item_484, 2), (Item_18, 4), None]]

    @classmethod
    def create(cls, arg: "Variation_1361.cv_arg") -> 'Variation_1361':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["FDR"]) -> RuleVariation_43:
        ...
    @overload
    def get_item(self, key : Literal["LNAV"]) -> RuleVariation_1246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1282(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1361.cv_arg
    cv_variation: TypeAlias = Variation_1361

    @classmethod
    def create(cls, arg : "RuleVariation_1282.cv_arg") -> "RuleVariation_1282":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1361:
        return self.arg # type: ignore

class NonSpare_1801(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1282.cv_arg
    cv_name = "STS"
    cv_title = "Supplementary Track Status"
    cv_rule: TypeAlias = RuleVariation_1282

    @classmethod
    def create(cls, arg : "NonSpare_1801.cv_arg") -> "NonSpare_1801":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1282:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1361:
        return self.rule.variation

class Content_422(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "PS3 Element not populated", 1: "PS3 Element populated"}

class RuleContent_422(RuleContentContextFree):
    cv_arg: TypeAlias = Content_422.cv_arg
    cv_content: TypeAlias = Content_422

    @property
    def content(self) -> Content_422:
        return self._get_content() # type: ignore

class Variation_71(Element):
    cv_arg: TypeAlias = RuleContent_422.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_422

    @classmethod
    def create(cls, arg: "Variation_71.cv_arg") -> "Variation_71":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_422:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_422:
        return self.rule.content

class RuleVariation_71(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_71.cv_arg
    cv_variation: TypeAlias = Variation_71

    @classmethod
    def create(cls, arg : "RuleVariation_71.cv_arg") -> "RuleVariation_71":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_71:
        return self.arg # type: ignore

class NonSpare_953(NonSpare):
    cv_arg: TypeAlias = RuleVariation_71.cv_arg
    cv_name = "EP"
    cv_title = "Priority Status for Version 3 ADS-B Systems Populated"
    cv_rule: TypeAlias = RuleVariation_71

    @classmethod
    def create(cls, arg : "NonSpare_953.cv_arg") -> "NonSpare_953":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_71:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_71:
        return self.rule.variation

class Item_314(Item):
    cv_arg: TypeAlias = NonSpare_953.cv_arg
    cv_non_spare: TypeAlias = NonSpare_953

    @classmethod
    def create(cls, arg : "Item_314.cv_arg") -> "Item_314":
        return cls._create(arg) # type: ignore

class Content_359(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No emergency / not reported", 1: "General emergency", 2: "UAS/RPAS - Lost link", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Aircraft in Distress Automatic Activation", 7: "Aircraft in Distress Manual Activation"}

class RuleContent_359(RuleContentContextFree):
    cv_arg: TypeAlias = Content_359.cv_arg
    cv_content: TypeAlias = Content_359

    @property
    def content(self) -> Content_359:
        return self._get_content() # type: ignore

class Variation_485(Element):
    cv_arg: TypeAlias = RuleContent_359.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 3
    cv_rule = RuleContent_359

    @classmethod
    def create(cls, arg: "Variation_485.cv_arg") -> "Variation_485":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_359:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_359:
        return self.rule.content

class RuleVariation_474(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_485.cv_arg
    cv_variation: TypeAlias = Variation_485

    @classmethod
    def create(cls, arg : "RuleVariation_474.cv_arg") -> "RuleVariation_474":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_485:
        return self.arg # type: ignore

class NonSpare_2005(NonSpare):
    cv_arg: TypeAlias = RuleVariation_474.cv_arg
    cv_name = "VAL"
    cv_title = "Priority Status for Version 3 ADS-B Systems"
    cv_rule: TypeAlias = RuleVariation_474

    @classmethod
    def create(cls, arg : "NonSpare_2005.cv_arg") -> "NonSpare_2005":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_474:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_485:
        return self.rule.variation

class Item_1115(Item):
    cv_arg: TypeAlias = NonSpare_2005.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2005

    @classmethod
    def create(cls, arg : "Item_1115.cv_arg") -> "Item_1115":
        return cls._create(arg) # type: ignore

class Variation_1103(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_71.cv_arg, Tuple[Literal["EP"], RuleVariation_71.cv_arg]], Union[RuleVariation_474.cv_arg, Tuple[Literal["VAL"], RuleVariation_474.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1103.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_314, 1), (Item_1115, 3), (Item_22, 4)]
    cv_items_dict = {"EP": RuleVariation_71, "VAL": RuleVariation_474}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_71:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_474:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_71:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_474:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1103.cv_arg") -> 'Variation_1103':
        return cls._create(arg) # type: ignore

class RuleVariation_1061(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1103.cv_arg
    cv_variation: TypeAlias = Variation_1103

    @classmethod
    def create(cls, arg : "RuleVariation_1061.cv_arg") -> "RuleVariation_1061":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1103:
        return self.arg # type: ignore

class NonSpare_1471(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1061.cv_arg
    cv_name = "PS3"
    cv_title = "Priority Status for Version 3 ADS-B Systems"
    cv_rule: TypeAlias = RuleVariation_1061

    @classmethod
    def create(cls, arg : "NonSpare_1471.cv_arg") -> "NonSpare_1471":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1061:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1103:
        return self.rule.variation

class Content_386(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not RCE", 1: "TABS", 2: "Reserved for future use", 3: "Other RCE"}

class RuleContent_386(RuleContentContextFree):
    cv_arg: TypeAlias = Content_386.cv_arg
    cv_content: TypeAlias = Content_386

    @property
    def content(self) -> Content_386:
        return self._get_content() # type: ignore

class Variation_475(Element):
    cv_arg: TypeAlias = RuleContent_386.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_386

    @classmethod
    def create(cls, arg: "Variation_475.cv_arg") -> "Variation_475":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_386:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_386:
        return self.rule.content

class RuleVariation_464(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_475.cv_arg
    cv_variation: TypeAlias = Variation_475

    @classmethod
    def create(cls, arg : "RuleVariation_464.cv_arg") -> "RuleVariation_464":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_475:
        return self.arg # type: ignore

class NonSpare_2009(NonSpare):
    cv_arg: TypeAlias = RuleVariation_464.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_464

    @classmethod
    def create(cls, arg : "NonSpare_2009.cv_arg") -> "NonSpare_2009":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_464:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_475:
        return self.rule.variation

class Item_1119(Item):
    cv_arg: TypeAlias = NonSpare_2009.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2009

    @classmethod
    def create(cls, arg : "Item_1119.cv_arg") -> "Item_1119":
        return cls._create(arg) # type: ignore

class Variation_1094(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_464.cv_arg, Tuple[Literal["VAL"], RuleVariation_464.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1094.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_302, 1), (Item_1119, 2)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_464}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_464:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_464:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1094.cv_arg") -> 'Variation_1094':
        return cls._create(arg) # type: ignore

class RuleVariation_1052(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1094.cv_arg
    cv_variation: TypeAlias = Variation_1094

    @classmethod
    def create(cls, arg : "RuleVariation_1052.cv_arg") -> "RuleVariation_1052":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1094:
        return self.arg # type: ignore

class NonSpare_1555(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1052.cv_arg
    cv_name = "RCE"
    cv_title = "Reduced Capability Equipment"
    cv_rule: TypeAlias = RuleVariation_1052

    @classmethod
    def create(cls, arg : "NonSpare_1555.cv_arg") -> "NonSpare_1555":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1052:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1094:
        return self.rule.variation

class Item_783(Item):
    cv_arg: TypeAlias = NonSpare_1555.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1555

    @classmethod
    def create(cls, arg : "Item_783.cv_arg") -> "Item_783":
        return cls._create(arg) # type: ignore

class Variation_747(Element):
    cv_arg: TypeAlias = RuleContent_438.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_438

    @classmethod
    def create(cls, arg: "Variation_747.cv_arg") -> "Variation_747":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_438:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_438:
        return self.rule.content

class RuleVariation_736(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_747.cv_arg
    cv_variation: TypeAlias = Variation_747

    @classmethod
    def create(cls, arg : "RuleVariation_736.cv_arg") -> "RuleVariation_736":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_747:
        return self.arg # type: ignore

class NonSpare_2019(NonSpare):
    cv_arg: TypeAlias = RuleVariation_736.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_736

    @classmethod
    def create(cls, arg : "NonSpare_2019.cv_arg") -> "NonSpare_2019":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_736:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_747:
        return self.rule.variation

class Item_1129(Item):
    cv_arg: TypeAlias = NonSpare_2019.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2019

    @classmethod
    def create(cls, arg : "Item_1129.cv_arg") -> "Item_1129":
        return cls._create(arg) # type: ignore

class Variation_1329(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_628.cv_arg, Tuple[Literal["EP"], RuleVariation_628.cv_arg]], Union[RuleVariation_736.cv_arg, Tuple[Literal["VAL"], RuleVariation_736.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1329.cv_arg_group"]
    cv_bit_offset8 = 3
    cv_bit_size = 2
    cv_items_list = [(Item_304, 1), (Item_1129, 1)]
    cv_items_dict = {"EP": RuleVariation_628, "VAL": RuleVariation_736}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_736:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_736:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1329.cv_arg") -> 'Variation_1329':
        return cls._create(arg) # type: ignore

class RuleVariation_1253(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1329.cv_arg
    cv_variation: TypeAlias = Variation_1329

    @classmethod
    def create(cls, arg : "RuleVariation_1253.cv_arg") -> "RuleVariation_1253":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1329:
        return self.arg # type: ignore

class NonSpare_1612(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1253.cv_arg
    cv_name = "RRL"
    cv_title = "Reply Rate Limiting"
    cv_rule: TypeAlias = RuleVariation_1253

    @classmethod
    def create(cls, arg : "NonSpare_1612.cv_arg") -> "NonSpare_1612":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1253:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1329:
        return self.rule.variation

class Item_830(Item):
    cv_arg: TypeAlias = NonSpare_1612.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1612

    @classmethod
    def create(cls, arg : "Item_830.cv_arg") -> "Item_830":
        return cls._create(arg) # type: ignore

class Variation_965(Element):
    cv_arg: TypeAlias = RuleContent_531.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 2
    cv_rule = RuleContent_531

    @classmethod
    def create(cls, arg: "Variation_965.cv_arg") -> "Variation_965":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_531:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_531:
        return self.rule.content

class RuleVariation_935(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_965.cv_arg
    cv_variation: TypeAlias = Variation_965

    @classmethod
    def create(cls, arg : "RuleVariation_935.cv_arg") -> "RuleVariation_935":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_965:
        return self.arg # type: ignore

class NonSpare_2027(NonSpare):
    cv_arg: TypeAlias = RuleVariation_935.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_935

    @classmethod
    def create(cls, arg : "NonSpare_2027.cv_arg") -> "NonSpare_2027":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_935:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_965:
        return self.rule.variation

class Item_1137(Item):
    cv_arg: TypeAlias = NonSpare_2027.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2027

    @classmethod
    def create(cls, arg : "Item_1137.cv_arg") -> "Item_1137":
        return cls._create(arg) # type: ignore

class Variation_1341(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_818.cv_arg, Tuple[Literal["EP"], RuleVariation_818.cv_arg]], Union[RuleVariation_935.cv_arg, Tuple[Literal["VAL"], RuleVariation_935.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1341.cv_arg_group"]
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_items_list = [(Item_306, 1), (Item_1137, 2)]
    cv_items_dict = {"EP": RuleVariation_818, "VAL": RuleVariation_935}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_818:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_935:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_818:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_935:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1341.cv_arg") -> 'Variation_1341':
        return cls._create(arg) # type: ignore

class RuleVariation_1262(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1341.cv_arg
    cv_variation: TypeAlias = Variation_1341

    @classmethod
    def create(cls, arg : "RuleVariation_1262.cv_arg") -> "RuleVariation_1262":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1341:
        return self.arg # type: ignore

class NonSpare_1899(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1262.cv_arg
    cv_name = "TPW"
    cv_title = "Transmit Power"
    cv_rule: TypeAlias = RuleVariation_1262

    @classmethod
    def create(cls, arg : "NonSpare_1899.cv_arg") -> "NonSpare_1899":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1341:
        return self.rule.variation

class Item_1022(Item):
    cv_arg: TypeAlias = NonSpare_1899.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1899

    @classmethod
    def create(cls, arg : "Item_1022.cv_arg") -> "Item_1022":
        return cls._create(arg) # type: ignore

class Content_552(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Transponder #1 (left/pilot side or single)", 2: "Transponder #2 (right/co-pilot side)", 3: "Transponder #3 (auxiliary or Back-up)"}

class RuleContent_552(RuleContentContextFree):
    cv_arg: TypeAlias = Content_552.cv_arg
    cv_content: TypeAlias = Content_552

    @property
    def content(self) -> Content_552:
        return self._get_content() # type: ignore

class Variation_479(Element):
    cv_arg: TypeAlias = RuleContent_552.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_552

    @classmethod
    def create(cls, arg: "Variation_479.cv_arg") -> "Variation_479":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_552:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_552:
        return self.rule.content

class RuleVariation_468(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_479.cv_arg
    cv_variation: TypeAlias = Variation_479

    @classmethod
    def create(cls, arg : "RuleVariation_468.cv_arg") -> "RuleVariation_468":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_479:
        return self.arg # type: ignore

class NonSpare_2010(NonSpare):
    cv_arg: TypeAlias = RuleVariation_468.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_468

    @classmethod
    def create(cls, arg : "NonSpare_2010.cv_arg") -> "NonSpare_2010":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_468:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_479:
        return self.rule.variation

class Item_1120(Item):
    cv_arg: TypeAlias = NonSpare_2010.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2010

    @classmethod
    def create(cls, arg : "Item_1120.cv_arg") -> "Item_1120":
        return cls._create(arg) # type: ignore

class Variation_1095(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_42.cv_arg, Tuple[Literal["EP"], RuleVariation_42.cv_arg]], Union[RuleVariation_468.cv_arg, Tuple[Literal["VAL"], RuleVariation_468.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1095.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_items_list = [(Item_302, 1), (Item_1120, 2)]
    cv_items_dict = {"EP": RuleVariation_42, "VAL": RuleVariation_468}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_468:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_42:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_468:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1095.cv_arg") -> 'Variation_1095':
        return cls._create(arg) # type: ignore

class RuleVariation_1053(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1095.cv_arg
    cv_variation: TypeAlias = Variation_1095

    @classmethod
    def create(cls, arg : "RuleVariation_1053.cv_arg") -> "RuleVariation_1053":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1095:
        return self.arg # type: ignore

class NonSpare_1931(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1053.cv_arg
    cv_name = "TSI"
    cv_title = "Transponder Side Indication"
    cv_rule: TypeAlias = RuleVariation_1053

    @classmethod
    def create(cls, arg : "NonSpare_1931.cv_arg") -> "NonSpare_1931":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1053:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1095:
        return self.rule.variation

class Item_1048(Item):
    cv_arg: TypeAlias = NonSpare_1931.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1931

    @classmethod
    def create(cls, arg : "Item_1048.cv_arg") -> "Item_1048":
        return cls._create(arg) # type: ignore

class Variation_761(Element):
    cv_arg: TypeAlias = RuleContent_560.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_560

    @classmethod
    def create(cls, arg: "Variation_761.cv_arg") -> "Variation_761":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_560:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_560:
        return self.rule.content

class RuleVariation_750(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_761.cv_arg
    cv_variation: TypeAlias = Variation_761

    @classmethod
    def create(cls, arg : "RuleVariation_750.cv_arg") -> "RuleVariation_750":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_761:
        return self.arg # type: ignore

class NonSpare_1566(NonSpare):
    cv_arg: TypeAlias = RuleVariation_750.cv_arg
    cv_name = "RE"
    cv_title = "Range Exceeded"
    cv_rule: TypeAlias = RuleVariation_750

    @classmethod
    def create(cls, arg : "NonSpare_1566.cv_arg") -> "NonSpare_1566":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_750:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_761:
        return self.rule.variation

class Item_792(Item):
    cv_arg: TypeAlias = NonSpare_1566.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1566

    @classmethod
    def create(cls, arg : "Item_792.cv_arg") -> "Item_792":
        return cls._create(arg) # type: ignore

class Variation_893(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 6
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_893.cv_arg") -> "Variation_893":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_863(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_893.cv_arg
    cv_variation: TypeAlias = Variation_893

    @classmethod
    def create(cls, arg : "RuleVariation_863.cv_arg") -> "RuleVariation_863":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_893:
        return self.arg # type: ignore

class NonSpare_2024(NonSpare):
    cv_arg: TypeAlias = RuleVariation_863.cv_arg
    cv_name = "VAL"
    cv_title = "Value"
    cv_rule: TypeAlias = RuleVariation_863

    @classmethod
    def create(cls, arg : "NonSpare_2024.cv_arg") -> "NonSpare_2024":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_863:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_893:
        return self.rule.variation

class Item_1134(Item):
    cv_arg: TypeAlias = NonSpare_2024.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2024

    @classmethod
    def create(cls, arg : "Item_1134.cv_arg") -> "Item_1134":
        return cls._create(arg) # type: ignore

class Variation_1327(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_628.cv_arg, Tuple[Literal["EP"], RuleVariation_628.cv_arg]], Union[RuleVariation_750.cv_arg, Tuple[Literal["RE"], RuleVariation_750.cv_arg]], Union[RuleVariation_863.cv_arg, Tuple[Literal["VAL"], RuleVariation_863.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1327.cv_arg_group"]
    cv_bit_offset8 = 3
    cv_bit_size = 8
    cv_items_list = [(Item_304, 1), (Item_792, 1), (Item_1134, 6)]
    cv_items_dict = {"EP": RuleVariation_628, "RE": RuleVariation_750, "VAL": RuleVariation_863}

    @overload
    @classmethod
    def spec(cls, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> RuleVariation_750:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VAL"]) -> RuleVariation_863:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["EP"], Literal["RE"], Literal["VAL"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["EP"]) -> RuleVariation_628:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> RuleVariation_750:
        ...
    @overload
    def get_item(self, key : Literal["VAL"]) -> RuleVariation_863:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1327.cv_arg") -> 'Variation_1327':
        return cls._create(arg) # type: ignore

class RuleVariation_1251(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1327.cv_arg
    cv_variation: TypeAlias = Variation_1327

    @classmethod
    def create(cls, arg : "RuleVariation_1251.cv_arg") -> "RuleVariation_1251":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1327:
        return self.arg # type: ignore

class NonSpare_1824(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1251.cv_arg
    cv_name = "TAO"
    cv_title = "Transponder Antenna Offset"
    cv_rule: TypeAlias = RuleVariation_1251

    @classmethod
    def create(cls, arg : "NonSpare_1824.cv_arg") -> "NonSpare_1824":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1251:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1327:
        return self.rule.variation

class Item_972(Item):
    cv_arg: TypeAlias = NonSpare_1824.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1824

    @classmethod
    def create(cls, arg : "Item_972.cv_arg") -> "Item_972":
        return cls._create(arg) # type: ignore

class Variation_1170(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_1052.cv_arg, Tuple[Literal["RCE"], RuleVariation_1052.cv_arg]], Union[RuleVariation_1253.cv_arg, Tuple[Literal["RRL"], RuleVariation_1253.cv_arg]], Union[RuleVariation_1262.cv_arg, Tuple[Literal["TPW"], RuleVariation_1262.cv_arg]], Union[RuleVariation_1053.cv_arg, Tuple[Literal["TSI"], RuleVariation_1053.cv_arg]], Union[RuleVariation_1251.cv_arg, Tuple[Literal["TAO"], RuleVariation_1251.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1170.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_783, 3), (Item_830, 2), (Item_1022, 3), (Item_1048, 3), (Item_972, 8), (Item_19, 5)]
    cv_items_dict = {"RCE": RuleVariation_1052, "RRL": RuleVariation_1253, "TPW": RuleVariation_1262, "TSI": RuleVariation_1053, "TAO": RuleVariation_1251}

    @overload
    @classmethod
    def spec(cls, key : Literal["RCE"]) -> RuleVariation_1052:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RRL"]) -> RuleVariation_1253:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TPW"]) -> RuleVariation_1262:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSI"]) -> RuleVariation_1053:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAO"]) -> RuleVariation_1251:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RCE"], Literal["RRL"], Literal["TPW"], Literal["TSI"], Literal["TAO"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RCE"]) -> RuleVariation_1052:
        ...
    @overload
    def get_item(self, key : Literal["RRL"]) -> RuleVariation_1253:
        ...
    @overload
    def get_item(self, key : Literal["TPW"]) -> RuleVariation_1262:
        ...
    @overload
    def get_item(self, key : Literal["TSI"]) -> RuleVariation_1053:
        ...
    @overload
    def get_item(self, key : Literal["TAO"]) -> RuleVariation_1251:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1170.cv_arg") -> 'Variation_1170':
        return cls._create(arg) # type: ignore

class RuleVariation_1121(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1170.cv_arg
    cv_variation: TypeAlias = Variation_1170

    @classmethod
    def create(cls, arg : "RuleVariation_1121.cv_arg") -> "RuleVariation_1121":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1170:
        return self.arg # type: ignore

class NonSpare_635(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1121.cv_arg
    cv_name = "AS"
    cv_title = "Aircraft Status"
    cv_rule: TypeAlias = RuleVariation_1121

    @classmethod
    def create(cls, arg : "NonSpare_635.cv_arg") -> "NonSpare_635":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1121:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1170:
        return self.rule.variation

class Variation_1499(Compound):
    cv_arg = TypedDict('cv_arg', {
        "PS3": NonSpare_1471.cv_arg,
        "AS": NonSpare_635.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1471, NonSpare_635]
    cv_items_dict = {"PS3": NonSpare_1471, "AS": NonSpare_635}

    @overload
    @classmethod
    def spec(cls, key : Literal["PS3"]) -> NonSpare_1471:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AS"]) -> NonSpare_635:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PS3"], Literal["AS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PS3"]) -> Optional[NonSpare_1471]:
        ...
    @overload
    def get_item(self, key : Literal["AS"]) -> Optional[NonSpare_635]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["PS3"], val : NonSpare_1471.cv_arg) -> "Variation_1499":
        ...
    @overload
    def set_item(self, key : Literal["AS"], val : NonSpare_635.cv_arg) -> "Variation_1499":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["PS3"]) -> "Variation_1499":
        ...
    @overload
    def del_item(self, key : Literal["AS"]) -> "Variation_1499":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1499.cv_arg") -> 'Variation_1499':
        return cls._create(arg) # type: ignore

class RuleVariation_1420(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1499.cv_arg
    cv_variation: TypeAlias = Variation_1499

    @classmethod
    def create(cls, arg : "RuleVariation_1420.cv_arg") -> "RuleVariation_1420":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1499:
        return self.arg # type: ignore

class NonSpare_1992(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1420.cv_arg
    cv_name = "V3"
    cv_title = "ADS-B Version 3 Data"
    cv_rule: TypeAlias = RuleVariation_1420

    @classmethod
    def create(cls, arg : "NonSpare_1992.cv_arg") -> "NonSpare_1992":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1420:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1499:
        return self.rule.variation

class Expansion_3(Expansion):
    cv_arg = TypedDict('cv_arg', {
        "CST": NonSpare_843.cv_arg,
        "CSN": NonSpare_837.cv_arg,
        "TVS": NonSpare_1954.cv_arg,
        "STS": NonSpare_1801.cv_arg,
        "V3": NonSpare_1992.cv_arg,
    }, total=False)
    cv_type = (FspecFixed, 1)
    cv_items_list = [NonSpare_843, NonSpare_837, NonSpare_1954, NonSpare_1801, NonSpare_1992]
    cv_items_dict = {"CST": NonSpare_843, "CSN": NonSpare_837, "TVS": NonSpare_1954, "STS": NonSpare_1801, "V3": NonSpare_1992}

    @overload
    @classmethod
    def spec(cls, key : Literal["CST"]) -> NonSpare_843:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CSN"]) -> NonSpare_837:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TVS"]) -> NonSpare_1954:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1801:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["V3"]) -> NonSpare_1992:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CST"], Literal["CSN"], Literal["TVS"], Literal["STS"], Literal["V3"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[NonSpare_843]:
        ...
    @overload
    def get_item(self, key : Literal["CSN"]) -> Optional[NonSpare_837]:
        ...
    @overload
    def get_item(self, key : Literal["TVS"]) -> Optional[NonSpare_1954]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1801]:
        ...
    @overload
    def get_item(self, key : Literal["V3"]) -> Optional[NonSpare_1992]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["CST"], val : NonSpare_843.cv_arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["CSN"], val : NonSpare_837.cv_arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["TVS"], val : NonSpare_1954.cv_arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1801.cv_arg) -> "Expansion_3":
        ...
    @overload
    def set_item(self, key : Literal["V3"], val : NonSpare_1992.cv_arg) -> "Expansion_3":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["CST"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["CSN"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["TVS"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Expansion_3":
        ...
    @overload
    def del_item(self, key : Literal["V3"]) -> "Expansion_3":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Expansion_3.cv_arg") -> 'Expansion_3':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, Tuple["Expansion_3", Bits]]:
        return cls._parse(bs) # type: ignore

class Asterix_52(AstRef):
    cv_category = 62
    cv_edition = (1, 3)
    cv_expansion: TypeAlias = Expansion_3

class NonSpare_46(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_46.cv_arg") -> "NonSpare_46":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_46(UapItem):
    cv_non_spare: TypeAlias = NonSpare_46

class NonSpare_59(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_59.cv_arg") -> "NonSpare_59":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_59(UapItem):
    cv_non_spare: TypeAlias = NonSpare_59

class NonSpare_217(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "070"
    cv_title = "Time Of Track Information"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_217.cv_arg") -> "NonSpare_217":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_217(UapItem):
    cv_non_spare: TypeAlias = NonSpare_217

class NonSpare_281(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1084.cv_arg
    cv_name = "105"
    cv_title = "Calculated Position In WGS-84 Co-ordinates"
    cv_rule: TypeAlias = RuleVariation_1084

    @classmethod
    def create(cls, arg : "NonSpare_281.cv_arg") -> "NonSpare_281":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1084:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1128:
        return self.rule.variation

class UapItem_281(UapItem):
    cv_non_spare: TypeAlias = NonSpare_281

class NonSpare_2096(NonSpare):
    cv_arg: TypeAlias = RuleVariation_345.cv_arg
    cv_name = "X"
    cv_title = "X Coordinate"
    cv_rule: TypeAlias = RuleVariation_345

    @classmethod
    def create(cls, arg : "NonSpare_2096.cv_arg") -> "NonSpare_2096":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_352:
        return self.rule.variation

class Item_1197(Item):
    cv_arg: TypeAlias = NonSpare_2096.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2096

    @classmethod
    def create(cls, arg : "Item_1197.cv_arg") -> "Item_1197":
        return cls._create(arg) # type: ignore

class NonSpare_2150(NonSpare):
    cv_arg: TypeAlias = RuleVariation_345.cv_arg
    cv_name = "Y"
    cv_title = "Y Coordinate"
    cv_rule: TypeAlias = RuleVariation_345

    @classmethod
    def create(cls, arg : "NonSpare_2150.cv_arg") -> "NonSpare_2150":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_345:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_352:
        return self.rule.variation

class Item_1248(Item):
    cv_arg: TypeAlias = NonSpare_2150.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2150

    @classmethod
    def create(cls, arg : "Item_1248.cv_arg") -> "Item_1248":
        return cls._create(arg) # type: ignore

class Variation_1310(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_345.cv_arg, Tuple[Literal["X"], RuleVariation_345.cv_arg]], Union[RuleVariation_345.cv_arg, Tuple[Literal["Y"], RuleVariation_345.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1310.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_1197, 24), (Item_1248, 24)]
    cv_items_dict = {"X": RuleVariation_345, "Y": RuleVariation_345}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_345:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_345:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_345:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1310.cv_arg") -> 'Variation_1310':
        return cls._create(arg) # type: ignore

class RuleVariation_1238(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1310.cv_arg
    cv_variation: TypeAlias = Variation_1310

    @classmethod
    def create(cls, arg : "RuleVariation_1238.cv_arg") -> "RuleVariation_1238":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1310:
        return self.arg # type: ignore

class NonSpare_268(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1238.cv_arg
    cv_name = "100"
    cv_title = "Calculated Track Position (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1238

    @classmethod
    def create(cls, arg : "NonSpare_268.cv_arg") -> "NonSpare_268":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1238:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1310:
        return self.rule.variation

class UapItem_268(UapItem):
    cv_non_spare: TypeAlias = NonSpare_268

class NonSpare_2050(NonSpare):
    cv_arg: TypeAlias = RuleVariation_273.cv_arg
    cv_name = "VX"
    cv_title = "Velocity (X-component)"
    cv_rule: TypeAlias = RuleVariation_273

    @classmethod
    def create(cls, arg : "NonSpare_2050.cv_arg") -> "NonSpare_2050":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_280:
        return self.rule.variation

class Item_1156(Item):
    cv_arg: TypeAlias = NonSpare_2050.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2050

    @classmethod
    def create(cls, arg : "Item_1156.cv_arg") -> "Item_1156":
        return cls._create(arg) # type: ignore

class NonSpare_2055(NonSpare):
    cv_arg: TypeAlias = RuleVariation_273.cv_arg
    cv_name = "VY"
    cv_title = "Velocity (Y-component)"
    cv_rule: TypeAlias = RuleVariation_273

    @classmethod
    def create(cls, arg : "NonSpare_2055.cv_arg") -> "NonSpare_2055":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_273:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_280:
        return self.rule.variation

class Item_1161(Item):
    cv_arg: TypeAlias = NonSpare_2055.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2055

    @classmethod
    def create(cls, arg : "Item_1161.cv_arg") -> "Item_1161":
        return cls._create(arg) # type: ignore

class Variation_1281(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_273.cv_arg, Tuple[Literal["VX"], RuleVariation_273.cv_arg]], Union[RuleVariation_273.cv_arg, Tuple[Literal["VY"], RuleVariation_273.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1281.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1156, 16), (Item_1161, 16)]
    cv_items_dict = {"VX": RuleVariation_273, "VY": RuleVariation_273}

    @overload
    @classmethod
    def spec(cls, key : Literal["VX"]) -> RuleVariation_273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VY"]) -> RuleVariation_273:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VX"], Literal["VY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VX"]) -> RuleVariation_273:
        ...
    @overload
    def get_item(self, key : Literal["VY"]) -> RuleVariation_273:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1281.cv_arg") -> 'Variation_1281':
        return cls._create(arg) # type: ignore

class RuleVariation_1210(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1281.cv_arg
    cv_variation: TypeAlias = Variation_1281

    @classmethod
    def create(cls, arg : "RuleVariation_1210.cv_arg") -> "RuleVariation_1210":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1281:
        return self.arg # type: ignore

class NonSpare_386(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1210.cv_arg
    cv_name = "185"
    cv_title = "Calculated Track Velocity (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1210

    @classmethod
    def create(cls, arg : "NonSpare_386.cv_arg") -> "NonSpare_386":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1210:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1281:
        return self.rule.variation

class UapItem_386(UapItem):
    cv_non_spare: TypeAlias = NonSpare_386

class Content_664(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_664(RuleContentContextFree):
    cv_arg: TypeAlias = Content_664.cv_arg
    cv_content: TypeAlias = Content_664

    @property
    def content(self) -> Content_664:
        return self._get_content() # type: ignore

class Variation_211(Element):
    cv_arg: TypeAlias = RuleContent_664.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_664

    @classmethod
    def create(cls, arg: "Variation_211.cv_arg") -> "Variation_211":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_664:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_664:
        return self.rule.content

class RuleVariation_204(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_211.cv_arg
    cv_variation: TypeAlias = Variation_211

    @classmethod
    def create(cls, arg : "RuleVariation_204.cv_arg") -> "RuleVariation_204":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_211:
        return self.arg # type: ignore

class NonSpare_655(NonSpare):
    cv_arg: TypeAlias = RuleVariation_204.cv_arg
    cv_name = "AX"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_204

    @classmethod
    def create(cls, arg : "NonSpare_655.cv_arg") -> "NonSpare_655":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_204:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_211:
        return self.rule.variation

class Item_98(Item):
    cv_arg: TypeAlias = NonSpare_655.cv_arg
    cv_non_spare: TypeAlias = NonSpare_655

    @classmethod
    def create(cls, arg : "Item_98.cv_arg") -> "Item_98":
        return cls._create(arg) # type: ignore

class NonSpare_659(NonSpare):
    cv_arg: TypeAlias = RuleVariation_204.cv_arg
    cv_name = "AY"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_204

    @classmethod
    def create(cls, arg : "NonSpare_659.cv_arg") -> "NonSpare_659":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_204:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_211:
        return self.rule.variation

class Item_102(Item):
    cv_arg: TypeAlias = NonSpare_659.cv_arg
    cv_non_spare: TypeAlias = NonSpare_659

    @classmethod
    def create(cls, arg : "Item_102.cv_arg") -> "Item_102":
        return cls._create(arg) # type: ignore

class Variation_1055(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_204.cv_arg, Tuple[Literal["AX"], RuleVariation_204.cv_arg]], Union[RuleVariation_204.cv_arg, Tuple[Literal["AY"], RuleVariation_204.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1055.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_98, 8), (Item_102, 8)]
    cv_items_dict = {"AX": RuleVariation_204, "AY": RuleVariation_204}

    @overload
    @classmethod
    def spec(cls, key : Literal["AX"]) -> RuleVariation_204:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AY"]) -> RuleVariation_204:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AX"], Literal["AY"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AX"]) -> RuleVariation_204:
        ...
    @overload
    def get_item(self, key : Literal["AY"]) -> RuleVariation_204:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1055.cv_arg") -> 'Variation_1055':
        return cls._create(arg) # type: ignore

class RuleVariation_1022(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1055.cv_arg
    cv_variation: TypeAlias = Variation_1055

    @classmethod
    def create(cls, arg : "RuleVariation_1022.cv_arg") -> "RuleVariation_1022":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1055:
        return self.arg # type: ignore

class NonSpare_410(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1022.cv_arg
    cv_name = "210"
    cv_title = "Calculated Acceleration (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1022

    @classmethod
    def create(cls, arg : "NonSpare_410.cv_arg") -> "NonSpare_410":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1022:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1055:
        return self.rule.variation

class UapItem_410(UapItem):
    cv_non_spare: TypeAlias = NonSpare_410

class Content_333(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No change", 1: "Mode 3/A has changed"}

class RuleContent_333(RuleContentContextFree):
    cv_arg: TypeAlias = Content_333.cv_arg
    cv_content: TypeAlias = Content_333

    @property
    def content(self) -> Content_333:
        return self._get_content() # type: ignore

class Variation_562(Element):
    cv_arg: TypeAlias = RuleContent_333.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_333

    @classmethod
    def create(cls, arg: "Variation_562.cv_arg") -> "Variation_562":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_333:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_333:
        return self.rule.content

class RuleVariation_551(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_562.cv_arg
    cv_variation: TypeAlias = Variation_562

    @classmethod
    def create(cls, arg : "RuleVariation_551.cv_arg") -> "RuleVariation_551":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_562:
        return self.arg # type: ignore

class NonSpare_729(NonSpare):
    cv_arg: TypeAlias = RuleVariation_551.cv_arg
    cv_name = "CH"
    cv_title = "Change in Mode 3/A"
    cv_rule: TypeAlias = RuleVariation_551

    @classmethod
    def create(cls, arg : "NonSpare_729.cv_arg") -> "NonSpare_729":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_551:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_562:
        return self.rule.variation

class Item_151(Item):
    cv_arg: TypeAlias = NonSpare_729.cv_arg
    cv_non_spare: TypeAlias = NonSpare_729

    @classmethod
    def create(cls, arg : "Item_151.cv_arg") -> "Item_151":
        return cls._create(arg) # type: ignore

class Variation_1270(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_551.cv_arg, Tuple[Literal["CH"], RuleVariation_551.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1270.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_151, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "CH": RuleVariation_551, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CH"]) -> RuleVariation_551:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["CH"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["CH"]) -> RuleVariation_551:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1270.cv_arg") -> 'Variation_1270':
        return cls._create(arg) # type: ignore

class RuleVariation_1199(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1270.cv_arg
    cv_variation: TypeAlias = Variation_1270

    @classmethod
    def create(cls, arg : "RuleVariation_1199.cv_arg") -> "RuleVariation_1199":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1270:
        return self.arg # type: ignore

class NonSpare_202(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1199.cv_arg
    cv_name = "060"
    cv_title = "Track Mode 3/A Code"
    cv_rule: TypeAlias = RuleVariation_1199

    @classmethod
    def create(cls, arg : "NonSpare_202.cv_arg") -> "NonSpare_202":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1270:
        return self.rule.variation

class UapItem_202(UapItem):
    cv_non_spare: TypeAlias = NonSpare_202

class Content_50(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Callsign or registration downlinked from target", 1: "Callsign not downlinked from target", 2: "Registration not downlinked from target", 3: "Invalid"}

class RuleContent_50(RuleContentContextFree):
    cv_arg: TypeAlias = Content_50.cv_arg
    cv_content: TypeAlias = Content_50

    @property
    def content(self) -> Content_50:
        return self._get_content() # type: ignore

class Variation_97(Element):
    cv_arg: TypeAlias = RuleContent_50.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_50

    @classmethod
    def create(cls, arg: "Variation_97.cv_arg") -> "Variation_97":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_50:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_50:
        return self.rule.content

class RuleVariation_97(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_97.cv_arg
    cv_variation: TypeAlias = Variation_97

    @classmethod
    def create(cls, arg : "RuleVariation_97.cv_arg") -> "RuleVariation_97":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_97:
        return self.arg # type: ignore

class NonSpare_1790(NonSpare):
    cv_arg: TypeAlias = RuleVariation_97.cv_arg
    cv_name = "STI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_97

    @classmethod
    def create(cls, arg : "NonSpare_1790.cv_arg") -> "NonSpare_1790":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_97:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_97:
        return self.rule.variation

class Item_950(Item):
    cv_arg: TypeAlias = NonSpare_1790.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1790

    @classmethod
    def create(cls, arg : "Item_950.cv_arg") -> "Item_950":
        return cls._create(arg) # type: ignore

class Variation_1215(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_97.cv_arg, Tuple[Literal["STI"], RuleVariation_97.cv_arg]], int, Union[RuleVariation_383.cv_arg, Tuple[Literal["CHR"], RuleVariation_383.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1215.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_950, 2), (Item_15, 6), (Item_158, 48)]
    cv_items_dict = {"STI": RuleVariation_97, "CHR": RuleVariation_383}

    @overload
    @classmethod
    def spec(cls, key : Literal["STI"]) -> RuleVariation_97:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CHR"]) -> RuleVariation_383:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STI"], Literal["CHR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STI"]) -> RuleVariation_97:
        ...
    @overload
    def get_item(self, key : Literal["CHR"]) -> RuleVariation_383:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1215.cv_arg") -> 'Variation_1215':
        return cls._create(arg) # type: ignore

class RuleVariation_1159(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1215.cv_arg
    cv_variation: TypeAlias = Variation_1215

    @classmethod
    def create(cls, arg : "RuleVariation_1159.cv_arg") -> "RuleVariation_1159":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1215:
        return self.arg # type: ignore

class NonSpare_440(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1159.cv_arg
    cv_name = "245"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_1159

    @classmethod
    def create(cls, arg : "NonSpare_440.cv_arg") -> "NonSpare_440":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1215:
        return self.rule.variation

class UapItem_440(UapItem):
    cv_non_spare: TypeAlias = NonSpare_440

class NonSpare_572(NonSpare):
    cv_arg: TypeAlias = RuleVariation_342.cv_arg
    cv_name = "ADR"
    cv_title = "Target Address"
    cv_rule: TypeAlias = RuleVariation_342

    @classmethod
    def create(cls, arg : "NonSpare_572.cv_arg") -> "NonSpare_572":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_342:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_349:
        return self.rule.variation

class NonSpare_1111(NonSpare):
    cv_arg: TypeAlias = RuleVariation_383.cv_arg
    cv_name = "ID"
    cv_title = "Target Identification"
    cv_rule: TypeAlias = RuleVariation_383

    @classmethod
    def create(cls, arg : "NonSpare_1111.cv_arg") -> "NonSpare_1111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_383:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_391:
        return self.rule.variation

class NonSpare_1280(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "MHG"
    cv_title = "Magnetic Heading"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1280.cv_arg") -> "NonSpare_1280":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Content_23(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Air Speed = IAS, LSB (Bit-1) = 2^-14 NM/s", 1: "Air Speed = Mach, LSB (Bit-1) = 0.001"}

class RuleContent_23(RuleContentContextFree):
    cv_arg: TypeAlias = Content_23.cv_arg
    cv_content: TypeAlias = Content_23

    @property
    def content(self) -> Content_23:
        return self._get_content() # type: ignore

class Variation_8(Element):
    cv_arg: TypeAlias = RuleContent_23.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_23

    @classmethod
    def create(cls, arg: "Variation_8.cv_arg") -> "Variation_8":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_23:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_23:
        return self.rule.content

class RuleVariation_8(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_8.cv_arg
    cv_variation: TypeAlias = Variation_8

    @classmethod
    def create(cls, arg : "RuleVariation_8.cv_arg") -> "RuleVariation_8":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_8:
        return self.arg # type: ignore

class NonSpare_1122(NonSpare):
    cv_arg: TypeAlias = RuleVariation_8.cv_arg
    cv_name = "IM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_8

    @classmethod
    def create(cls, arg : "NonSpare_1122.cv_arg") -> "NonSpare_1122":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_8:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_8:
        return self.rule.variation

class Item_436(Item):
    cv_arg: TypeAlias = NonSpare_1122.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1122

    @classmethod
    def create(cls, arg : "Item_436.cv_arg") -> "Item_436":
        return cls._create(arg) # type: ignore

class RuleContent_801(RuleContentDependent):
    cv_arg: TypeAlias = Union[
        Tuple[None, Content_0.cv_arg],
        Tuple[Tuple[Literal[0]], Content_778.cv_arg],
        Tuple[Tuple[Literal[1]], Content_750.cv_arg],
    ]
    cv_depends_on = [["380", "IAS", "IM"]]
    cv_default_content: TypeAlias = Content_0
    cv_cases = [
        ([0], Content_778),
        ([1], Content_750),
    ]

    @overload
    def content(self, arg : Literal[None]) -> Content_0:
        ...
    @overload
    def content(self, arg : Tuple[Literal[0]]) -> Content_778:
        ...
    @overload
    def content(self, arg : Tuple[Literal[1]]) -> Content_750:
        ...
    def content(self, arg : Any) -> Any:
        return self._get_content(arg)

class Variation_506(Element):
    cv_arg: TypeAlias = RuleContent_801.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 15
    cv_rule = RuleContent_801

    @classmethod
    def create(cls, arg: "Variation_506.cv_arg") -> "Variation_506":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_801:
        return self._get_rule() # type: ignore

class RuleVariation_495(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_506.cv_arg
    cv_variation: TypeAlias = Variation_506

    @classmethod
    def create(cls, arg : "RuleVariation_495.cv_arg") -> "RuleVariation_495":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_506:
        return self.arg # type: ignore

class NonSpare_1102(NonSpare):
    cv_arg: TypeAlias = RuleVariation_495.cv_arg
    cv_name = "IAS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_495

    @classmethod
    def create(cls, arg : "NonSpare_1102.cv_arg") -> "NonSpare_1102":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_495:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_506:
        return self.rule.variation

class Item_422(Item):
    cv_arg: TypeAlias = NonSpare_1102.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1102

    @classmethod
    def create(cls, arg : "Item_422.cv_arg") -> "Item_422":
        return cls._create(arg) # type: ignore

class Variation_1122(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_8.cv_arg, Tuple[Literal["IM"], RuleVariation_8.cv_arg]], Union[RuleVariation_495.cv_arg, Tuple[Literal["IAS"], RuleVariation_495.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1122.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_436, 1), (Item_422, 15)]
    cv_items_dict = {"IM": RuleVariation_8, "IAS": RuleVariation_495}

    @overload
    @classmethod
    def spec(cls, key : Literal["IM"]) -> RuleVariation_8:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> RuleVariation_495:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IM"], Literal["IAS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IM"]) -> RuleVariation_8:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> RuleVariation_495:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1122.cv_arg") -> 'Variation_1122':
        return cls._create(arg) # type: ignore

class RuleVariation_1078(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1122.cv_arg
    cv_variation: TypeAlias = Variation_1122

    @classmethod
    def create(cls, arg : "RuleVariation_1078.cv_arg") -> "RuleVariation_1078":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1122:
        return self.arg # type: ignore

class NonSpare_1104(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1078.cv_arg
    cv_name = "IAS"
    cv_title = "Indicated Airspeed/Mach No"
    cv_rule: TypeAlias = RuleVariation_1078

    @classmethod
    def create(cls, arg : "NonSpare_1104.cv_arg") -> "NonSpare_1104":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1078:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1122:
        return self.rule.variation

class Content_718(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

class RuleContent_718(RuleContentContextFree):
    cv_arg: TypeAlias = Content_718.cv_arg
    cv_content: TypeAlias = Content_718

    @property
    def content(self) -> Content_718:
        return self._get_content() # type: ignore

class Variation_304(Element):
    cv_arg: TypeAlias = RuleContent_718.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_718

    @classmethod
    def create(cls, arg: "Variation_304.cv_arg") -> "Variation_304":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_718:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_718:
        return self.rule.content

class RuleVariation_297(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_304.cv_arg
    cv_variation: TypeAlias = Variation_304

    @classmethod
    def create(cls, arg : "RuleVariation_297.cv_arg") -> "RuleVariation_297":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_304:
        return self.arg # type: ignore

class NonSpare_1831(NonSpare):
    cv_arg: TypeAlias = RuleVariation_297.cv_arg
    cv_name = "TAS"
    cv_title = "True Airspeed"
    cv_rule: TypeAlias = RuleVariation_297

    @classmethod
    def create(cls, arg : "NonSpare_1831.cv_arg") -> "NonSpare_1831":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_297:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_304:
        return self.rule.variation

class Content_374(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No source information provided", 1: "Source information provided"}

class RuleContent_374(RuleContentContextFree):
    cv_arg: TypeAlias = Content_374.cv_arg
    cv_content: TypeAlias = Content_374

    @property
    def content(self) -> Content_374:
        return self._get_content() # type: ignore

class Variation_65(Element):
    cv_arg: TypeAlias = RuleContent_374.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_374

    @classmethod
    def create(cls, arg: "Variation_65.cv_arg") -> "Variation_65":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_374:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_374:
        return self.rule.content

class RuleVariation_65(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_65.cv_arg
    cv_variation: TypeAlias = Variation_65

    @classmethod
    def create(cls, arg : "RuleVariation_65.cv_arg") -> "RuleVariation_65":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_65:
        return self.arg # type: ignore

class NonSpare_1663(NonSpare):
    cv_arg: TypeAlias = RuleVariation_65.cv_arg
    cv_name = "SAS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_65

    @classmethod
    def create(cls, arg : "NonSpare_1663.cv_arg") -> "NonSpare_1663":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_65:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_65:
        return self.rule.variation

class Item_860(Item):
    cv_arg: TypeAlias = NonSpare_1663.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1663

    @classmethod
    def create(cls, arg : "Item_860.cv_arg") -> "Item_860":
        return cls._create(arg) # type: ignore

class Content_539(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Aircraft altitude", 2: "FCU/MCP selected altitude", 3: "FMS selected altitude"}

class RuleContent_539(RuleContentContextFree):
    cv_arg: TypeAlias = Content_539.cv_arg
    cv_content: TypeAlias = Content_539

    @property
    def content(self) -> Content_539:
        return self._get_content() # type: ignore

class Variation_478(Element):
    cv_arg: TypeAlias = RuleContent_539.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_539

    @classmethod
    def create(cls, arg: "Variation_478.cv_arg") -> "Variation_478":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_539:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_539:
        return self.rule.content

class RuleVariation_467(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_478.cv_arg
    cv_variation: TypeAlias = Variation_478

    @classmethod
    def create(cls, arg : "RuleVariation_467.cv_arg") -> "RuleVariation_467":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_478:
        return self.arg # type: ignore

class NonSpare_1747(NonSpare):
    cv_arg: TypeAlias = RuleVariation_467.cv_arg
    cv_name = "SRC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_467

    @classmethod
    def create(cls, arg : "NonSpare_1747.cv_arg") -> "NonSpare_1747":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_467:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_478:
        return self.rule.variation

class Item_920(Item):
    cv_arg: TypeAlias = NonSpare_1747.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1747

    @classmethod
    def create(cls, arg : "Item_920.cv_arg") -> "Item_920":
        return cls._create(arg) # type: ignore

class Content_636(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 25.0
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_636(RuleContentContextFree):
    cv_arg: TypeAlias = Content_636.cv_arg
    cv_content: TypeAlias = Content_636

    @property
    def content(self) -> Content_636:
        return self._get_content() # type: ignore

class Variation_698(Element):
    cv_arg: TypeAlias = RuleContent_636.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 13
    cv_rule = RuleContent_636

    @classmethod
    def create(cls, arg: "Variation_698.cv_arg") -> "Variation_698":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_636:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_636:
        return self.rule.content

class RuleVariation_687(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_698.cv_arg
    cv_variation: TypeAlias = Variation_698

    @classmethod
    def create(cls, arg : "RuleVariation_687.cv_arg") -> "RuleVariation_687":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_698:
        return self.arg # type: ignore

class NonSpare_595(NonSpare):
    cv_arg: TypeAlias = RuleVariation_687.cv_arg
    cv_name = "ALT"
    cv_title = "Altitude in Two's Complement Form"
    cv_rule: TypeAlias = RuleVariation_687

    @classmethod
    def create(cls, arg : "NonSpare_595.cv_arg") -> "NonSpare_595":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_687:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_698:
        return self.rule.variation

class Item_62(Item):
    cv_arg: TypeAlias = NonSpare_595.cv_arg
    cv_non_spare: TypeAlias = NonSpare_595

    @classmethod
    def create(cls, arg : "Item_62.cv_arg") -> "Item_62":
        return cls._create(arg) # type: ignore

class Variation_1199(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_65.cv_arg, Tuple[Literal["SAS"], RuleVariation_65.cv_arg]], Union[RuleVariation_467.cv_arg, Tuple[Literal["SRC"], RuleVariation_467.cv_arg]], Union[RuleVariation_687.cv_arg, Tuple[Literal["ALT"], RuleVariation_687.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1199.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_860, 1), (Item_920, 2), (Item_62, 13)]
    cv_items_dict = {"SAS": RuleVariation_65, "SRC": RuleVariation_467, "ALT": RuleVariation_687}

    @overload
    @classmethod
    def spec(cls, key : Literal["SAS"]) -> RuleVariation_65:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRC"]) -> RuleVariation_467:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_687:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SAS"], Literal["SRC"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SAS"]) -> RuleVariation_65:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_467:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_687:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1199.cv_arg") -> 'Variation_1199':
        return cls._create(arg) # type: ignore

class RuleVariation_1143(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1199.cv_arg
    cv_variation: TypeAlias = Variation_1199

    @classmethod
    def create(cls, arg : "RuleVariation_1143.cv_arg") -> "RuleVariation_1143":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1199:
        return self.arg # type: ignore

class NonSpare_1658(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1143.cv_arg
    cv_name = "SAL"
    cv_title = "Selected Altitude"
    cv_rule: TypeAlias = RuleVariation_1143

    @classmethod
    def create(cls, arg : "NonSpare_1658.cv_arg") -> "NonSpare_1658":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1143:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1199:
        return self.rule.variation

class NonSpare_1339(NonSpare):
    cv_arg: TypeAlias = RuleVariation_67.cv_arg
    cv_name = "MV"
    cv_title = "Manage Vertical Mode"
    cv_rule: TypeAlias = RuleVariation_67

    @classmethod
    def create(cls, arg : "NonSpare_1339.cv_arg") -> "NonSpare_1339":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_67:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_67:
        return self.rule.variation

class Item_602(Item):
    cv_arg: TypeAlias = NonSpare_1339.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1339

    @classmethod
    def create(cls, arg : "Item_602.cv_arg") -> "Item_602":
        return cls._create(arg) # type: ignore

class NonSpare_582(NonSpare):
    cv_arg: TypeAlias = RuleVariation_432.cv_arg
    cv_name = "AH"
    cv_title = "Altitude Hold"
    cv_rule: TypeAlias = RuleVariation_432

    @classmethod
    def create(cls, arg : "NonSpare_582.cv_arg") -> "NonSpare_582":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_432:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_443:
        return self.rule.variation

class Item_51(Item):
    cv_arg: TypeAlias = NonSpare_582.cv_arg
    cv_non_spare: TypeAlias = NonSpare_582

    @classmethod
    def create(cls, arg : "Item_51.cv_arg") -> "Item_51":
        return cls._create(arg) # type: ignore

class NonSpare_604(NonSpare):
    cv_arg: TypeAlias = RuleVariation_556.cv_arg
    cv_name = "AM"
    cv_title = "Approach Mode"
    cv_rule: TypeAlias = RuleVariation_556

    @classmethod
    def create(cls, arg : "NonSpare_604.cv_arg") -> "NonSpare_604":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_556:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_567:
        return self.rule.variation

class Item_68(Item):
    cv_arg: TypeAlias = NonSpare_604.cv_arg
    cv_non_spare: TypeAlias = NonSpare_604

    @classmethod
    def create(cls, arg : "Item_68.cv_arg") -> "Item_68":
        return cls._create(arg) # type: ignore

class Variation_1147(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_67.cv_arg, Tuple[Literal["MV"], RuleVariation_67.cv_arg]], Union[RuleVariation_432.cv_arg, Tuple[Literal["AH"], RuleVariation_432.cv_arg]], Union[RuleVariation_556.cv_arg, Tuple[Literal["AM"], RuleVariation_556.cv_arg]], Union[RuleVariation_687.cv_arg, Tuple[Literal["ALT"], RuleVariation_687.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1147.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_602, 1), (Item_51, 1), (Item_68, 1), (Item_62, 13)]
    cv_items_dict = {"MV": RuleVariation_67, "AH": RuleVariation_432, "AM": RuleVariation_556, "ALT": RuleVariation_687}

    @overload
    @classmethod
    def spec(cls, key : Literal["MV"]) -> RuleVariation_67:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AH"]) -> RuleVariation_432:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AM"]) -> RuleVariation_556:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_687:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MV"], Literal["AH"], Literal["AM"], Literal["ALT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MV"]) -> RuleVariation_67:
        ...
    @overload
    def get_item(self, key : Literal["AH"]) -> RuleVariation_432:
        ...
    @overload
    def get_item(self, key : Literal["AM"]) -> RuleVariation_556:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_687:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1147.cv_arg") -> 'Variation_1147':
        return cls._create(arg) # type: ignore

class RuleVariation_1100(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1147.cv_arg
    cv_variation: TypeAlias = Variation_1147

    @classmethod
    def create(cls, arg : "RuleVariation_1100.cv_arg") -> "RuleVariation_1100":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1147:
        return self.arg # type: ignore

class NonSpare_1002(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1100.cv_arg
    cv_name = "FSS"
    cv_title = "Final State Selected Altitude"
    cv_rule: TypeAlias = RuleVariation_1100

    @classmethod
    def create(cls, arg : "NonSpare_1002.cv_arg") -> "NonSpare_1002":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1100:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1147:
        return self.rule.variation

class Content_519(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Trajectory intent data is available for this aircraft", 1: "Trajectory intent data is not available for this aircraft"}

class RuleContent_519(RuleContentContextFree):
    cv_arg: TypeAlias = Content_519.cv_arg
    cv_content: TypeAlias = Content_519

    @property
    def content(self) -> Content_519:
        return self._get_content() # type: ignore

class Variation_93(Element):
    cv_arg: TypeAlias = RuleContent_519.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_519

    @classmethod
    def create(cls, arg: "Variation_93.cv_arg") -> "Variation_93":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_519:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_519:
        return self.rule.content

class RuleVariation_93(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_93.cv_arg
    cv_variation: TypeAlias = Variation_93

    @classmethod
    def create(cls, arg : "RuleVariation_93.cv_arg") -> "RuleVariation_93":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_93:
        return self.arg # type: ignore

class Content_520(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Trajectory intent data is valid", 1: "Trajectory intent data is not valid"}

class RuleContent_520(RuleContentContextFree):
    cv_arg: TypeAlias = Content_520.cv_arg
    cv_content: TypeAlias = Content_520

    @property
    def content(self) -> Content_520:
        return self._get_content() # type: ignore

class Variation_460(Element):
    cv_arg: TypeAlias = RuleContent_520.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_520

    @classmethod
    def create(cls, arg: "Variation_460.cv_arg") -> "Variation_460":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_520:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_520:
        return self.rule.content

class RuleVariation_449(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_460.cv_arg
    cv_variation: TypeAlias = Variation_460

    @classmethod
    def create(cls, arg : "RuleVariation_449.cv_arg") -> "RuleVariation_449":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_460:
        return self.arg # type: ignore

class NonSpare_1348(NonSpare):
    cv_arg: TypeAlias = RuleVariation_93.cv_arg
    cv_name = "NAV"
    cv_title = "TID Available"
    cv_rule: TypeAlias = RuleVariation_93

    @classmethod
    def create(cls, arg : "NonSpare_1348.cv_arg") -> "NonSpare_1348":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_93:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_93:
        return self.rule.variation

class Item_608(Item):
    cv_arg: TypeAlias = NonSpare_1348.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1348

    @classmethod
    def create(cls, arg : "Item_608.cv_arg") -> "Item_608":
        return cls._create(arg) # type: ignore

class NonSpare_1388(NonSpare):
    cv_arg: TypeAlias = RuleVariation_449.cv_arg
    cv_name = "NVB"
    cv_title = "TID Valid"
    cv_rule: TypeAlias = RuleVariation_449

    @classmethod
    def create(cls, arg : "NonSpare_1388.cv_arg") -> "NonSpare_1388":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_449:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_460:
        return self.rule.variation

class Item_647(Item):
    cv_arg: TypeAlias = NonSpare_1388.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1388

    @classmethod
    def create(cls, arg : "Item_647.cv_arg") -> "Item_647":
        return cls._create(arg) # type: ignore

class Variation_1374(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_93.cv_arg, Tuple[Literal["NAV"], RuleVariation_93.cv_arg]], Union[RuleVariation_449.cv_arg, Tuple[Literal["NVB"], RuleVariation_449.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1374.cv_arg_group_1"],
    ]
    cv_items_list = [[(Item_608, 1), (Item_647, 1), (Item_14, 5), None]]

    @classmethod
    def create(cls, arg: "Variation_1374.cv_arg") -> 'Variation_1374':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["NAV"]) -> RuleVariation_93:
        ...
    @overload
    def get_item(self, key : Literal["NVB"]) -> RuleVariation_449:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1295(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1374.cv_arg
    cv_variation: TypeAlias = Variation_1374

    @classmethod
    def create(cls, arg : "RuleVariation_1295.cv_arg") -> "RuleVariation_1295":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1374:
        return self.arg # type: ignore

class NonSpare_1872(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1295.cv_arg
    cv_name = "TIS"
    cv_title = "Trajectory Intent Status"
    cv_rule: TypeAlias = RuleVariation_1295

    @classmethod
    def create(cls, arg : "NonSpare_1872.cv_arg") -> "NonSpare_1872":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1295:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1374:
        return self.rule.variation

class NonSpare_1838(NonSpare):
    cv_arg: TypeAlias = RuleVariation_80.cv_arg
    cv_name = "TCA"
    cv_title = "TCP Number Availability"
    cv_rule: TypeAlias = RuleVariation_80

    @classmethod
    def create(cls, arg : "NonSpare_1838.cv_arg") -> "NonSpare_1838":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_80:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_80:
        return self.rule.variation

class Item_978(Item):
    cv_arg: TypeAlias = NonSpare_1838.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1838

    @classmethod
    def create(cls, arg : "Item_978.cv_arg") -> "Item_978":
        return cls._create(arg) # type: ignore

class NonSpare_1357(NonSpare):
    cv_arg: TypeAlias = RuleVariation_440.cv_arg
    cv_name = "NC"
    cv_title = "TCP Compliance"
    cv_rule: TypeAlias = RuleVariation_440

    @classmethod
    def create(cls, arg : "NonSpare_1357.cv_arg") -> "NonSpare_1357":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_440:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_451:
        return self.rule.variation

class Item_617(Item):
    cv_arg: TypeAlias = NonSpare_1357.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1357

    @classmethod
    def create(cls, arg : "Item_617.cv_arg") -> "Item_617":
        return cls._create(arg) # type: ignore

class NonSpare_1849(NonSpare):
    cv_arg: TypeAlias = RuleVariation_591.cv_arg
    cv_name = "TCPN"
    cv_title = "Trajectory Change Point Number"
    cv_rule: TypeAlias = RuleVariation_591

    @classmethod
    def create(cls, arg : "NonSpare_1849.cv_arg") -> "NonSpare_1849":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_591:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_602:
        return self.rule.variation

class Item_988(Item):
    cv_arg: TypeAlias = NonSpare_1849.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1849

    @classmethod
    def create(cls, arg : "Item_988.cv_arg") -> "Item_988":
        return cls._create(arg) # type: ignore

class NonSpare_1160(NonSpare):
    cv_arg: TypeAlias = RuleVariation_353.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude in WGS.84 in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_353

    @classmethod
    def create(cls, arg : "NonSpare_1160.cv_arg") -> "NonSpare_1160":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_360:
        return self.rule.variation

class Item_472(Item):
    cv_arg: TypeAlias = NonSpare_1160.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1160

    @classmethod
    def create(cls, arg : "Item_472.cv_arg") -> "Item_472":
        return cls._create(arg) # type: ignore

class NonSpare_1190(NonSpare):
    cv_arg: TypeAlias = RuleVariation_351.cv_arg
    cv_name = "LON"
    cv_title = "Longitude in WGS.84 in Two's Complement"
    cv_rule: TypeAlias = RuleVariation_351

    @classmethod
    def create(cls, arg : "NonSpare_1190.cv_arg") -> "NonSpare_1190":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

class Item_500(Item):
    cv_arg: TypeAlias = NonSpare_1190.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1190

    @classmethod
    def create(cls, arg : "Item_500.cv_arg") -> "Item_500":
        return cls._create(arg) # type: ignore

class NonSpare_1851(NonSpare):
    cv_arg: TypeAlias = RuleVariation_755.cv_arg
    cv_name = "TD"
    cv_title = "Turn Direction"
    cv_rule: TypeAlias = RuleVariation_755

    @classmethod
    def create(cls, arg : "NonSpare_1851.cv_arg") -> "NonSpare_1851":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_755:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_766:
        return self.rule.variation

class Item_990(Item):
    cv_arg: TypeAlias = NonSpare_1851.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1851

    @classmethod
    def create(cls, arg : "Item_990.cv_arg") -> "Item_990":
        return cls._create(arg) # type: ignore

class NonSpare_1902(NonSpare):
    cv_arg: TypeAlias = RuleVariation_923.cv_arg
    cv_name = "TRA"
    cv_title = "Turn Radius Availability"
    cv_rule: TypeAlias = RuleVariation_923

    @classmethod
    def create(cls, arg : "NonSpare_1902.cv_arg") -> "NonSpare_1902":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_923:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_953:
        return self.rule.variation

class Item_1025(Item):
    cv_arg: TypeAlias = NonSpare_1902.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1902

    @classmethod
    def create(cls, arg : "Item_1025.cv_arg") -> "Item_1025":
        return cls._create(arg) # type: ignore

class NonSpare_1879(NonSpare):
    cv_arg: TypeAlias = RuleVariation_958.cv_arg
    cv_name = "TOA"
    cv_title = "TOV Available"
    cv_rule: TypeAlias = RuleVariation_958

    @classmethod
    def create(cls, arg : "NonSpare_1879.cv_arg") -> "NonSpare_1879":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_958:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_988:
        return self.rule.variation

class Item_1007(Item):
    cv_arg: TypeAlias = NonSpare_1879.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1879

    @classmethod
    def create(cls, arg : "Item_1007.cv_arg") -> "Item_1007":
        return cls._create(arg) # type: ignore

class Variation_1222(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_80.cv_arg, Tuple[Literal["TCA"], RuleVariation_80.cv_arg]], Union[RuleVariation_440.cv_arg, Tuple[Literal["NC"], RuleVariation_440.cv_arg]], Union[RuleVariation_591.cv_arg, Tuple[Literal["TCPN"], RuleVariation_591.cv_arg]], Union[RuleVariation_254.cv_arg, Tuple[Literal["ALT"], RuleVariation_254.cv_arg]], Union[RuleVariation_353.cv_arg, Tuple[Literal["LAT"], RuleVariation_353.cv_arg]], Union[RuleVariation_351.cv_arg, Tuple[Literal["LON"], RuleVariation_351.cv_arg]], Union[RuleVariation_135.cv_arg, Tuple[Literal["PT"], RuleVariation_135.cv_arg]], Union[RuleVariation_755.cv_arg, Tuple[Literal["TD"], RuleVariation_755.cv_arg]], Union[RuleVariation_923.cv_arg, Tuple[Literal["TRA"], RuleVariation_923.cv_arg]], Union[RuleVariation_958.cv_arg, Tuple[Literal["TOA"], RuleVariation_958.cv_arg]], Union[RuleVariation_358.cv_arg, Tuple[Literal["TOV"], RuleVariation_358.cv_arg]], Union[RuleVariation_307.cv_arg, Tuple[Literal["TTR"], RuleVariation_307.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1222.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 120
    cv_items_list = [(Item_978, 1), (Item_617, 1), (Item_988, 6), (Item_61, 16), (Item_472, 24), (Item_500, 24), (Item_718, 4), (Item_990, 2), (Item_1025, 1), (Item_1007, 1), (Item_1012, 24), (Item_1067, 16)]
    cv_items_dict = {"TCA": RuleVariation_80, "NC": RuleVariation_440, "TCPN": RuleVariation_591, "ALT": RuleVariation_254, "LAT": RuleVariation_353, "LON": RuleVariation_351, "PT": RuleVariation_135, "TD": RuleVariation_755, "TRA": RuleVariation_923, "TOA": RuleVariation_958, "TOV": RuleVariation_358, "TTR": RuleVariation_307}

    @overload
    @classmethod
    def spec(cls, key : Literal["TCA"]) -> RuleVariation_80:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NC"]) -> RuleVariation_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TCPN"]) -> RuleVariation_591:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ALT"]) -> RuleVariation_254:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_351:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PT"]) -> RuleVariation_135:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TD"]) -> RuleVariation_755:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRA"]) -> RuleVariation_923:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> RuleVariation_958:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOV"]) -> RuleVariation_358:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TTR"]) -> RuleVariation_307:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TCA"], Literal["NC"], Literal["TCPN"], Literal["ALT"], Literal["LAT"], Literal["LON"], Literal["PT"], Literal["TD"], Literal["TRA"], Literal["TOA"], Literal["TOV"], Literal["TTR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TCA"]) -> RuleVariation_80:
        ...
    @overload
    def get_item(self, key : Literal["NC"]) -> RuleVariation_440:
        ...
    @overload
    def get_item(self, key : Literal["TCPN"]) -> RuleVariation_591:
        ...
    @overload
    def get_item(self, key : Literal["ALT"]) -> RuleVariation_254:
        ...
    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_351:
        ...
    @overload
    def get_item(self, key : Literal["PT"]) -> RuleVariation_135:
        ...
    @overload
    def get_item(self, key : Literal["TD"]) -> RuleVariation_755:
        ...
    @overload
    def get_item(self, key : Literal["TRA"]) -> RuleVariation_923:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> RuleVariation_958:
        ...
    @overload
    def get_item(self, key : Literal["TOV"]) -> RuleVariation_358:
        ...
    @overload
    def get_item(self, key : Literal["TTR"]) -> RuleVariation_307:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1222.cv_arg") -> 'Variation_1222':
        return cls._create(arg) # type: ignore

class Variation_1437(Repetitive):
    cv_arg: TypeAlias = List[Variation_1222.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1222

    @classmethod
    def create(cls, arg: "Variation_1437.cv_arg") -> 'Variation_1437':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1222]:
        return self._get_list() # type: ignore

class RuleVariation_1358(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1437.cv_arg
    cv_variation: TypeAlias = Variation_1437

    @classmethod
    def create(cls, arg : "RuleVariation_1358.cv_arg") -> "RuleVariation_1358":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1437:
        return self.arg # type: ignore

class NonSpare_1867(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1358.cv_arg
    cv_name = "TID"
    cv_title = "Trajectory Intent Data"
    cv_rule: TypeAlias = RuleVariation_1358

    @classmethod
    def create(cls, arg : "NonSpare_1867.cv_arg") -> "NonSpare_1867":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1358:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1437:
        return self.rule.variation

class Content_319(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground"}

class RuleContent_319(RuleContentContextFree):
    cv_arg: TypeAlias = Content_319.cv_arg
    cv_content: TypeAlias = Content_319

    @property
    def content(self) -> Content_319:
        return self._get_content() # type: ignore

class Variation_684(Element):
    cv_arg: TypeAlias = RuleContent_319.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_319

    @classmethod
    def create(cls, arg: "Variation_684.cv_arg") -> "Variation_684":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_319:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_319:
        return self.rule.content

class RuleVariation_673(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_684.cv_arg
    cv_variation: TypeAlias = Variation_684

    @classmethod
    def create(cls, arg : "RuleVariation_673.cv_arg") -> "RuleVariation_673":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_684:
        return self.arg # type: ignore

class NonSpare_1775(NonSpare):
    cv_arg: TypeAlias = RuleVariation_673.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_673

    @classmethod
    def create(cls, arg : "NonSpare_1775.cv_arg") -> "NonSpare_1775":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_673:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_684:
        return self.rule.variation

class Item_936(Item):
    cv_arg: TypeAlias = NonSpare_1775.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1775

    @classmethod
    def create(cls, arg : "Item_936.cv_arg") -> "Item_936":
        return cls._create(arg) # type: ignore

class NonSpare_672(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "B1B"
    cv_title = "BDS BDS 1,0 Bits 37/40"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_672.cv_arg") -> "NonSpare_672":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_112(Item):
    cv_arg: TypeAlias = NonSpare_672.cv_arg
    cv_non_spare: TypeAlias = NonSpare_672

    @classmethod
    def create(cls, arg : "Item_112.cv_arg") -> "Item_112":
        return cls._create(arg) # type: ignore

class Variation_1076(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_124.cv_arg, Tuple[Literal["COM"], RuleVariation_124.cv_arg]], Union[RuleVariation_673.cv_arg, Tuple[Literal["STAT"], RuleVariation_673.cv_arg]], int, Union[RuleVariation_56.cv_arg, Tuple[Literal["SSC"], RuleVariation_56.cv_arg]], Union[RuleVariation_390.cv_arg, Tuple[Literal["ARC"], RuleVariation_390.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["AIC"], RuleVariation_547.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["B1A"], RuleVariation_603.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["B1B"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1076.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_188, 3), (Item_936, 3), (Item_27, 2), (Item_926, 1), (Item_81, 1), (Item_55, 1), (Item_109, 1), (Item_112, 4)]
    cv_items_dict = {"COM": RuleVariation_124, "STAT": RuleVariation_673, "SSC": RuleVariation_56, "ARC": RuleVariation_390, "AIC": RuleVariation_547, "B1A": RuleVariation_603, "B1B": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_673:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_673:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1076.cv_arg") -> 'Variation_1076':
        return cls._create(arg) # type: ignore

class RuleVariation_1036(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1076.cv_arg
    cv_variation: TypeAlias = Variation_1076

    @classmethod
    def create(cls, arg : "RuleVariation_1036.cv_arg") -> "RuleVariation_1036":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1076:
        return self.arg # type: ignore

class NonSpare_787(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1036.cv_arg
    cv_name = "COM"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1036

    @classmethod
    def create(cls, arg : "NonSpare_787.cv_arg") -> "NonSpare_787":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1036:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1076:
        return self.rule.variation

class Content_536(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "ACAS not operational", 2: "ACAS operational", 3: "Invalid"}

class RuleContent_536(RuleContentContextFree):
    cv_arg: TypeAlias = Content_536.cv_arg
    cv_content: TypeAlias = Content_536

    @property
    def content(self) -> Content_536:
        return self._get_content() # type: ignore

class Variation_115(Element):
    cv_arg: TypeAlias = RuleContent_536.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_536

    @classmethod
    def create(cls, arg: "Variation_115.cv_arg") -> "Variation_115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_536:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_536:
        return self.rule.content

class RuleVariation_115(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_115.cv_arg
    cv_variation: TypeAlias = Variation_115

    @classmethod
    def create(cls, arg : "RuleVariation_115.cv_arg") -> "RuleVariation_115":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_115:
        return self.arg # type: ignore

class NonSpare_556(NonSpare):
    cv_arg: TypeAlias = RuleVariation_115.cv_arg
    cv_name = "AC"
    cv_title = "ACAS Status"
    cv_rule: TypeAlias = RuleVariation_115

    @classmethod
    def create(cls, arg : "NonSpare_556.cv_arg") -> "NonSpare_556":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_115:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_115:
        return self.rule.variation

class Item_38(Item):
    cv_arg: TypeAlias = NonSpare_556.cv_arg
    cv_non_spare: TypeAlias = NonSpare_556

    @classmethod
    def create(cls, arg : "Item_38.cv_arg") -> "Item_38":
        return cls._create(arg) # type: ignore

class Content_550(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Multiple navigational aids not operating", 2: "Multiple navigational aids operating", 3: "Invalid"}

class RuleContent_550(RuleContentContextFree):
    cv_arg: TypeAlias = Content_550.cv_arg
    cv_content: TypeAlias = Content_550

    @property
    def content(self) -> Content_550:
        return self._get_content() # type: ignore

class Variation_596(Element):
    cv_arg: TypeAlias = RuleContent_550.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_550

    @classmethod
    def create(cls, arg: "Variation_596.cv_arg") -> "Variation_596":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_550:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_550:
        return self.rule.content

class RuleVariation_585(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_596.cv_arg
    cv_variation: TypeAlias = Variation_596

    @classmethod
    def create(cls, arg : "RuleVariation_585.cv_arg") -> "RuleVariation_585":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_596:
        return self.arg # type: ignore

class NonSpare_1297(NonSpare):
    cv_arg: TypeAlias = RuleVariation_585.cv_arg
    cv_name = "MN"
    cv_title = "Multiple Navigational Aids Status"
    cv_rule: TypeAlias = RuleVariation_585

    @classmethod
    def create(cls, arg : "NonSpare_1297.cv_arg") -> "NonSpare_1297":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_585:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_596:
        return self.rule.variation

class Item_563(Item):
    cv_arg: TypeAlias = NonSpare_1297.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1297

    @classmethod
    def create(cls, arg : "Item_563.cv_arg") -> "Item_563":
        return cls._create(arg) # type: ignore

class Content_544(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Unknown", 1: "Differential correction", 2: "No differential correction", 3: "Invalid"}

class RuleContent_544(RuleContentContextFree):
    cv_arg: TypeAlias = Content_544.cv_arg
    cv_content: TypeAlias = Content_544

    @property
    def content(self) -> Content_544:
        return self._get_content() # type: ignore

class Variation_771(Element):
    cv_arg: TypeAlias = RuleContent_544.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_544

    @classmethod
    def create(cls, arg: "Variation_771.cv_arg") -> "Variation_771":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_544:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_544:
        return self.rule.content

class RuleVariation_760(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_771.cv_arg
    cv_variation: TypeAlias = Variation_771

    @classmethod
    def create(cls, arg : "RuleVariation_760.cv_arg") -> "RuleVariation_760":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_771:
        return self.arg # type: ignore

class NonSpare_873(NonSpare):
    cv_arg: TypeAlias = RuleVariation_760.cv_arg
    cv_name = "DC"
    cv_title = "Differential Correction Status"
    cv_rule: TypeAlias = RuleVariation_760

    @classmethod
    def create(cls, arg : "NonSpare_873.cv_arg") -> "NonSpare_873":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_760:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_771:
        return self.rule.variation

class Item_251(Item):
    cv_arg: TypeAlias = NonSpare_873.cv_arg
    cv_non_spare: TypeAlias = NonSpare_873

    @classmethod
    def create(cls, arg : "Item_251.cv_arg") -> "Item_251":
        return cls._create(arg) # type: ignore

class Content_524(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Transponder ground bit not set or unknown", 1: "Transponder Ground Bit set"}

class RuleContent_524(RuleContentContextFree):
    cv_arg: TypeAlias = Content_524.cv_arg
    cv_content: TypeAlias = Content_524

    @property
    def content(self) -> Content_524:
        return self._get_content() # type: ignore

class Variation_957(Element):
    cv_arg: TypeAlias = RuleContent_524.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_524

    @classmethod
    def create(cls, arg: "Variation_957.cv_arg") -> "Variation_957":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_524:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_524:
        return self.rule.content

class RuleVariation_927(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_957.cv_arg
    cv_variation: TypeAlias = Variation_957

    @classmethod
    def create(cls, arg : "RuleVariation_927.cv_arg") -> "RuleVariation_927":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_957:
        return self.arg # type: ignore

class NonSpare_1030(NonSpare):
    cv_arg: TypeAlias = RuleVariation_927.cv_arg
    cv_name = "GBS"
    cv_title = "Ground Bit Set"
    cv_rule: TypeAlias = RuleVariation_927

    @classmethod
    def create(cls, arg : "NonSpare_1030.cv_arg") -> "NonSpare_1030":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_927:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_957:
        return self.rule.variation

class Item_368(Item):
    cv_arg: TypeAlias = NonSpare_1030.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1030

    @classmethod
    def create(cls, arg : "Item_368.cv_arg") -> "Item_368":
        return cls._create(arg) # type: ignore

class Item_31(Spare):
    cv_arg: TypeAlias = int
    cv_bit_offset8 = 7
    cv_bit_size = 6

class Content_355(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No emergency", 1: "General emergency", 2: "Lifeguard / medical", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Downed Aircraft", 7: "Unknown"}

class RuleContent_355(RuleContentContextFree):
    cv_arg: TypeAlias = Content_355.cv_arg
    cv_content: TypeAlias = Content_355

    @property
    def content(self) -> Content_355:
        return self._get_content() # type: ignore

class Variation_891(Element):
    cv_arg: TypeAlias = RuleContent_355.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 3
    cv_rule = RuleContent_355

    @classmethod
    def create(cls, arg: "Variation_891.cv_arg") -> "Variation_891":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_355:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_355:
        return self.rule.content

class RuleVariation_861(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_891.cv_arg
    cv_variation: TypeAlias = Variation_891

    @classmethod
    def create(cls, arg : "RuleVariation_861.cv_arg") -> "RuleVariation_861":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_891:
        return self.arg # type: ignore

class NonSpare_1781(NonSpare):
    cv_arg: TypeAlias = RuleVariation_861.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_861

    @classmethod
    def create(cls, arg : "NonSpare_1781.cv_arg") -> "NonSpare_1781":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_861:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_891:
        return self.rule.variation

class Item_942(Item):
    cv_arg: TypeAlias = NonSpare_1781.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1781

    @classmethod
    def create(cls, arg : "Item_942.cv_arg") -> "Item_942":
        return cls._create(arg) # type: ignore

class Variation_1046(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_115.cv_arg, Tuple[Literal["AC"], RuleVariation_115.cv_arg]], Union[RuleVariation_585.cv_arg, Tuple[Literal["MN"], RuleVariation_585.cv_arg]], Union[RuleVariation_760.cv_arg, Tuple[Literal["DC"], RuleVariation_760.cv_arg]], Union[RuleVariation_927.cv_arg, Tuple[Literal["GBS"], RuleVariation_927.cv_arg]], int, Union[RuleVariation_861.cv_arg, Tuple[Literal["STAT"], RuleVariation_861.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1046.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_38, 2), (Item_563, 2), (Item_251, 2), (Item_368, 1), (Item_31, 6), (Item_942, 3)]
    cv_items_dict = {"AC": RuleVariation_115, "MN": RuleVariation_585, "DC": RuleVariation_760, "GBS": RuleVariation_927, "STAT": RuleVariation_861}

    @overload
    @classmethod
    def spec(cls, key : Literal["AC"]) -> RuleVariation_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MN"]) -> RuleVariation_585:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DC"]) -> RuleVariation_760:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GBS"]) -> RuleVariation_927:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_861:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["AC"], Literal["MN"], Literal["DC"], Literal["GBS"], Literal["STAT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["AC"]) -> RuleVariation_115:
        ...
    @overload
    def get_item(self, key : Literal["MN"]) -> RuleVariation_585:
        ...
    @overload
    def get_item(self, key : Literal["DC"]) -> RuleVariation_760:
        ...
    @overload
    def get_item(self, key : Literal["GBS"]) -> RuleVariation_927:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_861:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1046.cv_arg") -> 'Variation_1046':
        return cls._create(arg) # type: ignore

class RuleVariation_1013(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1046.cv_arg
    cv_variation: TypeAlias = Variation_1046

    @classmethod
    def create(cls, arg : "RuleVariation_1013.cv_arg") -> "RuleVariation_1013":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1046:
        return self.arg # type: ignore

class NonSpare_1652(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1013.cv_arg
    cv_name = "SAB"
    cv_title = "Status Reported by ADS-B"
    cv_rule: TypeAlias = RuleVariation_1013

    @classmethod
    def create(cls, arg : "NonSpare_1652.cv_arg") -> "NonSpare_1652":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1013:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1046:
        return self.rule.variation

class Content_800(ContentBds):
    cv_arg: TypeAlias = int
    cv_bds_type = (BdsAt, 48)

class RuleContent_799(RuleContentContextFree):
    cv_arg: TypeAlias = Content_800.cv_arg
    cv_content: TypeAlias = Content_800

    @property
    def content(self) -> Content_800:
        return self._get_content() # type: ignore

class Variation_395(Element):
    cv_arg: TypeAlias = RuleContent_799.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_rule = RuleContent_799

    @classmethod
    def create(cls, arg: "Variation_395.cv_arg") -> "Variation_395":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_799:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_800:
        return self.rule.content

class RuleVariation_387(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_395.cv_arg
    cv_variation: TypeAlias = Variation_395

    @classmethod
    def create(cls, arg : "RuleVariation_387.cv_arg") -> "RuleVariation_387":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_395:
        return self.arg # type: ignore

class NonSpare_564(NonSpare):
    cv_arg: TypeAlias = RuleVariation_387.cv_arg
    cv_name = "ACS"
    cv_title = "ACAS Resolution Advisory Report"
    cv_rule: TypeAlias = RuleVariation_387

    @classmethod
    def create(cls, arg : "NonSpare_564.cv_arg") -> "NonSpare_564":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_387:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_395:
        return self.rule.variation

class NonSpare_696(NonSpare):
    cv_arg: TypeAlias = RuleVariation_286.cv_arg
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_286

    @classmethod
    def create(cls, arg : "NonSpare_696.cv_arg") -> "NonSpare_696":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

class NonSpare_1049(NonSpare):
    cv_arg: TypeAlias = RuleVariation_286.cv_arg
    cv_name = "GVR"
    cv_title = "Geometric Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_286

    @classmethod
    def create(cls, arg : "NonSpare_1049.cv_arg") -> "NonSpare_1049":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

class NonSpare_1548(NonSpare):
    cv_arg: TypeAlias = RuleVariation_262.cv_arg
    cv_name = "RAN"
    cv_title = "Roll Angle"
    cv_rule: TypeAlias = RuleVariation_262

    @classmethod
    def create(cls, arg : "NonSpare_1548.cv_arg") -> "NonSpare_1548":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_262:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_269:
        return self.rule.variation

class Content_666(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "°/s"

    def as_quantity(self, cv_unit : Optional[Literal["°/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_666(RuleContentContextFree):
    cv_arg: TypeAlias = Content_666.cv_arg
    cv_content: TypeAlias = Content_666

    @property
    def content(self) -> Content_666:
        return self._get_content() # type: ignore

class Variation_159(Element):
    cv_arg: TypeAlias = RuleContent_666.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 7
    cv_rule = RuleContent_666

    @classmethod
    def create(cls, arg: "Variation_159.cv_arg") -> "Variation_159":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_666:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_666:
        return self.rule.content

class RuleVariation_153(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_159.cv_arg
    cv_variation: TypeAlias = Variation_159

    @classmethod
    def create(cls, arg : "RuleVariation_153.cv_arg") -> "RuleVariation_153":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_159:
        return self.arg # type: ignore

class NonSpare_1602(NonSpare):
    cv_arg: TypeAlias = RuleVariation_153.cv_arg
    cv_name = "ROT"
    cv_title = "Rate of Turn in Two's Complement Form"
    cv_rule: TypeAlias = RuleVariation_153

    @classmethod
    def create(cls, arg : "NonSpare_1602.cv_arg") -> "NonSpare_1602":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_153:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_159:
        return self.rule.variation

class Item_826(Item):
    cv_arg: TypeAlias = NonSpare_1602.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1602

    @classmethod
    def create(cls, arg : "Item_826.cv_arg") -> "Item_826":
        return cls._create(arg) # type: ignore

class Variation_1223(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_106.cv_arg, Tuple[Literal["TI"], RuleVariation_106.cv_arg]], int, Union[RuleVariation_153.cv_arg, Tuple[Literal["ROT"], RuleVariation_153.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1223.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_997, 2), (Item_15, 6), (Item_826, 7), (Item_29, 1)]
    cv_items_dict = {"TI": RuleVariation_106, "ROT": RuleVariation_153}

    @overload
    @classmethod
    def spec(cls, key : Literal["TI"]) -> RuleVariation_106:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ROT"]) -> RuleVariation_153:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TI"], Literal["ROT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TI"]) -> RuleVariation_106:
        ...
    @overload
    def get_item(self, key : Literal["ROT"]) -> RuleVariation_153:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1223.cv_arg") -> 'Variation_1223':
        return cls._create(arg) # type: ignore

class RuleVariation_1163(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1223.cv_arg
    cv_variation: TypeAlias = Variation_1223

    @classmethod
    def create(cls, arg : "RuleVariation_1163.cv_arg") -> "RuleVariation_1163":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1223:
        return self.arg # type: ignore

class NonSpare_1826(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1163.cv_arg
    cv_name = "TAR"
    cv_title = "Track Angle Rate"
    cv_rule: TypeAlias = RuleVariation_1163

    @classmethod
    def create(cls, arg : "NonSpare_1826.cv_arg") -> "NonSpare_1826":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1163:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1223:
        return self.rule.variation

class NonSpare_1821(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "TAN"
    cv_title = "Track Angle"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1821.cv_arg") -> "NonSpare_1821":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Content_682(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM/s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 6.103515625e-5
    cv_unit = "NM/s"

    def as_quantity(self, cv_unit : Optional[Literal["NM/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_682(RuleContentContextFree):
    cv_arg: TypeAlias = Content_682.cv_arg
    cv_content: TypeAlias = Content_682

    @property
    def content(self) -> Content_682:
        return self._get_content() # type: ignore

class Variation_288(Element):
    cv_arg: TypeAlias = RuleContent_682.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_682

    @classmethod
    def create(cls, arg: "Variation_288.cv_arg") -> "Variation_288":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_682:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_682:
        return self.rule.content

class RuleVariation_281(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_288.cv_arg
    cv_variation: TypeAlias = Variation_288

    @classmethod
    def create(cls, arg : "RuleVariation_281.cv_arg") -> "RuleVariation_281":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_288:
        return self.arg # type: ignore

class NonSpare_1038(NonSpare):
    cv_arg: TypeAlias = RuleVariation_281.cv_arg
    cv_name = "GS"
    cv_title = "Ground Speed"
    cv_rule: TypeAlias = RuleVariation_281

    @classmethod
    def create(cls, arg : "NonSpare_1038.cv_arg") -> "NonSpare_1038":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_281:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_288:
        return self.rule.variation

class NonSpare_2045(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "VUN"
    cv_title = "Velocity Uncertainty"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_2045.cv_arg") -> "NonSpare_2045":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Content_405(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not valid Wind Speed", 1: "Valid Wind Speed"}

class RuleContent_405(RuleContentContextFree):
    cv_arg: TypeAlias = Content_405.cv_arg
    cv_content: TypeAlias = Content_405

    @property
    def content(self) -> Content_405:
        return self._get_content() # type: ignore

class Variation_69(Element):
    cv_arg: TypeAlias = RuleContent_405.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_405

    @classmethod
    def create(cls, arg: "Variation_69.cv_arg") -> "Variation_69":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_405:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_405:
        return self.rule.content

class RuleVariation_69(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_69.cv_arg
    cv_variation: TypeAlias = Variation_69

    @classmethod
    def create(cls, arg : "RuleVariation_69.cv_arg") -> "RuleVariation_69":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_69:
        return self.arg # type: ignore

class NonSpare_2066(NonSpare):
    cv_arg: TypeAlias = RuleVariation_69.cv_arg
    cv_name = "WS"
    cv_title = "Wind Speed Valid Flag"
    cv_rule: TypeAlias = RuleVariation_69

    @classmethod
    def create(cls, arg : "NonSpare_2066.cv_arg") -> "NonSpare_2066":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_69:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_69:
        return self.rule.variation

class Item_1169(Item):
    cv_arg: TypeAlias = NonSpare_2066.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2066

    @classmethod
    def create(cls, arg : "Item_1169.cv_arg") -> "Item_1169":
        return cls._create(arg) # type: ignore

class Content_404(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not valid Wind Direction", 1: "Valid Wind Direction"}

class RuleContent_404(RuleContentContextFree):
    cv_arg: TypeAlias = Content_404.cv_arg
    cv_content: TypeAlias = Content_404

    @property
    def content(self) -> Content_404:
        return self._get_content() # type: ignore

class Variation_447(Element):
    cv_arg: TypeAlias = RuleContent_404.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_404

    @classmethod
    def create(cls, arg: "Variation_447.cv_arg") -> "Variation_447":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_404:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_404:
        return self.rule.content

class RuleVariation_436(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_447.cv_arg
    cv_variation: TypeAlias = Variation_447

    @classmethod
    def create(cls, arg : "RuleVariation_436.cv_arg") -> "RuleVariation_436":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_447:
        return self.arg # type: ignore

class NonSpare_2059(NonSpare):
    cv_arg: TypeAlias = RuleVariation_436.cv_arg
    cv_name = "WD"
    cv_title = "Wind Direction Valid Flag"
    cv_rule: TypeAlias = RuleVariation_436

    @classmethod
    def create(cls, arg : "NonSpare_2059.cv_arg") -> "NonSpare_2059":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_436:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_447:
        return self.rule.variation

class Item_1164(Item):
    cv_arg: TypeAlias = NonSpare_2059.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2059

    @classmethod
    def create(cls, arg : "Item_1164.cv_arg") -> "Item_1164":
        return cls._create(arg) # type: ignore

class Content_402(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not valid Temperature", 1: "Valid Temperature"}

class RuleContent_402(RuleContentContextFree):
    cv_arg: TypeAlias = Content_402.cv_arg
    cv_content: TypeAlias = Content_402

    @property
    def content(self) -> Content_402:
        return self._get_content() # type: ignore

class Variation_571(Element):
    cv_arg: TypeAlias = RuleContent_402.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_402

    @classmethod
    def create(cls, arg: "Variation_571.cv_arg") -> "Variation_571":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_402:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_402:
        return self.rule.content

class RuleVariation_560(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_571.cv_arg
    cv_variation: TypeAlias = Variation_571

    @classmethod
    def create(cls, arg : "RuleVariation_560.cv_arg") -> "RuleVariation_560":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_571:
        return self.arg # type: ignore

class NonSpare_1875(NonSpare):
    cv_arg: TypeAlias = RuleVariation_560.cv_arg
    cv_name = "TMP"
    cv_title = "Temperature Valid Flag"
    cv_rule: TypeAlias = RuleVariation_560

    @classmethod
    def create(cls, arg : "NonSpare_1875.cv_arg") -> "NonSpare_1875":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_560:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_571:
        return self.rule.variation

class Item_1004(Item):
    cv_arg: TypeAlias = NonSpare_1875.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1875

    @classmethod
    def create(cls, arg : "Item_1004.cv_arg") -> "Item_1004":
        return cls._create(arg) # type: ignore

class Content_403(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not valid Turbulence", 1: "Valid Turbulence"}

class RuleContent_403(RuleContentContextFree):
    cv_arg: TypeAlias = Content_403.cv_arg
    cv_content: TypeAlias = Content_403

    @property
    def content(self) -> Content_403:
        return self._get_content() # type: ignore

class Variation_660(Element):
    cv_arg: TypeAlias = RuleContent_403.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_403

    @classmethod
    def create(cls, arg: "Variation_660.cv_arg") -> "Variation_660":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_403:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_403:
        return self.rule.content

class RuleVariation_649(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_660.cv_arg
    cv_variation: TypeAlias = Variation_660

    @classmethod
    def create(cls, arg : "RuleVariation_649.cv_arg") -> "RuleVariation_649":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_660:
        return self.arg # type: ignore

class NonSpare_1911(NonSpare):
    cv_arg: TypeAlias = RuleVariation_649.cv_arg
    cv_name = "TRB"
    cv_title = "Turbulence Valid Flag"
    cv_rule: TypeAlias = RuleVariation_649

    @classmethod
    def create(cls, arg : "NonSpare_1911.cv_arg") -> "NonSpare_1911":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_649:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_660:
        return self.rule.variation

class Item_1033(Item):
    cv_arg: TypeAlias = NonSpare_1911.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1911

    @classmethod
    def create(cls, arg : "Item_1033.cv_arg") -> "Item_1033":
        return cls._create(arg) # type: ignore

class NonSpare_2067(NonSpare):
    cv_arg: TypeAlias = RuleVariation_295.cv_arg
    cv_name = "WSD"
    cv_title = "Wind Speed"
    cv_rule: TypeAlias = RuleVariation_295

    @classmethod
    def create(cls, arg : "NonSpare_2067.cv_arg") -> "NonSpare_2067":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_295:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_302:
        return self.rule.variation

class Item_1170(Item):
    cv_arg: TypeAlias = NonSpare_2067.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2067

    @classmethod
    def create(cls, arg : "Item_1170.cv_arg") -> "Item_1170":
        return cls._create(arg) # type: ignore

class NonSpare_2060(NonSpare):
    cv_arg: TypeAlias = RuleVariation_302.cv_arg
    cv_name = "WDD"
    cv_title = "Wind Direction"
    cv_rule: TypeAlias = RuleVariation_302

    @classmethod
    def create(cls, arg : "NonSpare_2060.cv_arg") -> "NonSpare_2060":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_302:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_309:
        return self.rule.variation

class Item_1165(Item):
    cv_arg: TypeAlias = NonSpare_2060.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2060

    @classmethod
    def create(cls, arg : "Item_1165.cv_arg") -> "Item_1165":
        return cls._create(arg) # type: ignore

class NonSpare_1876(NonSpare):
    cv_arg: TypeAlias = RuleVariation_274.cv_arg
    cv_name = "TMPD"
    cv_title = "Temperature in Degrees Celsius"
    cv_rule: TypeAlias = RuleVariation_274

    @classmethod
    def create(cls, arg : "NonSpare_1876.cv_arg") -> "NonSpare_1876":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_274:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_281:
        return self.rule.variation

class Item_1005(Item):
    cv_arg: TypeAlias = NonSpare_1876.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1876

    @classmethod
    def create(cls, arg : "Item_1005.cv_arg") -> "Item_1005":
        return cls._create(arg) # type: ignore

class NonSpare_1912(NonSpare):
    cv_arg: TypeAlias = RuleVariation_199.cv_arg
    cv_name = "TRBD"
    cv_title = "Turbulence"
    cv_rule: TypeAlias = RuleVariation_199

    @classmethod
    def create(cls, arg : "NonSpare_1912.cv_arg") -> "NonSpare_1912":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_199:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_206:
        return self.rule.variation

class Item_1034(Item):
    cv_arg: TypeAlias = NonSpare_1912.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1912

    @classmethod
    def create(cls, arg : "Item_1034.cv_arg") -> "Item_1034":
        return cls._create(arg) # type: ignore

class Variation_1284(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_69.cv_arg, Tuple[Literal["WS"], RuleVariation_69.cv_arg]], Union[RuleVariation_436.cv_arg, Tuple[Literal["WD"], RuleVariation_436.cv_arg]], Union[RuleVariation_560.cv_arg, Tuple[Literal["TMP"], RuleVariation_560.cv_arg]], Union[RuleVariation_649.cv_arg, Tuple[Literal["TRB"], RuleVariation_649.cv_arg]], int, Union[RuleVariation_295.cv_arg, Tuple[Literal["WSD"], RuleVariation_295.cv_arg]], Union[RuleVariation_302.cv_arg, Tuple[Literal["WDD"], RuleVariation_302.cv_arg]], Union[RuleVariation_274.cv_arg, Tuple[Literal["TMPD"], RuleVariation_274.cv_arg]], Union[RuleVariation_199.cv_arg, Tuple[Literal["TRBD"], RuleVariation_199.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1284.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_1169, 1), (Item_1164, 1), (Item_1004, 1), (Item_1033, 1), (Item_22, 4), (Item_1170, 16), (Item_1165, 16), (Item_1005, 16), (Item_1034, 8)]
    cv_items_dict = {"WS": RuleVariation_69, "WD": RuleVariation_436, "TMP": RuleVariation_560, "TRB": RuleVariation_649, "WSD": RuleVariation_295, "WDD": RuleVariation_302, "TMPD": RuleVariation_274, "TRBD": RuleVariation_199}

    @overload
    @classmethod
    def spec(cls, key : Literal["WS"]) -> RuleVariation_69:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WD"]) -> RuleVariation_436:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TMP"]) -> RuleVariation_560:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRB"]) -> RuleVariation_649:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WSD"]) -> RuleVariation_295:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WDD"]) -> RuleVariation_302:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TMPD"]) -> RuleVariation_274:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRBD"]) -> RuleVariation_199:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["WS"], Literal["WD"], Literal["TMP"], Literal["TRB"], Literal["WSD"], Literal["WDD"], Literal["TMPD"], Literal["TRBD"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["WS"]) -> RuleVariation_69:
        ...
    @overload
    def get_item(self, key : Literal["WD"]) -> RuleVariation_436:
        ...
    @overload
    def get_item(self, key : Literal["TMP"]) -> RuleVariation_560:
        ...
    @overload
    def get_item(self, key : Literal["TRB"]) -> RuleVariation_649:
        ...
    @overload
    def get_item(self, key : Literal["WSD"]) -> RuleVariation_295:
        ...
    @overload
    def get_item(self, key : Literal["WDD"]) -> RuleVariation_302:
        ...
    @overload
    def get_item(self, key : Literal["TMPD"]) -> RuleVariation_274:
        ...
    @overload
    def get_item(self, key : Literal["TRBD"]) -> RuleVariation_199:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1284.cv_arg") -> 'Variation_1284':
        return cls._create(arg) # type: ignore

class RuleVariation_1213(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1284.cv_arg
    cv_variation: TypeAlias = Variation_1284

    @classmethod
    def create(cls, arg : "RuleVariation_1213.cv_arg") -> "RuleVariation_1213":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1284:
        return self.arg # type: ignore

class NonSpare_1272(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1213.cv_arg
    cv_name = "MET"
    cv_title = "Meteorological Data"
    cv_rule: TypeAlias = RuleVariation_1213

    @classmethod
    def create(cls, arg : "NonSpare_1272.cv_arg") -> "NonSpare_1272":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1213:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1284:
        return self.rule.variation

class Content_583(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Light aircraft =< 7000 kg", 2: "Reserved", 3: "7000 kg < medium aircraft < 136000 kg", 4: "Reserved", 5: "136000 kg <= heavy aircraft", 6: "Highly manoeuvrable (5g acceleration capability) and high speed (>400 knots cruise)", 7: "Reserved", 8: "Reserved", 9: "Reserved", 10: "Rotocraft", 11: "Glider / sailplane", 12: "Lighter-than-air", 13: "Unmanned aerial vehicle", 14: "Space / transatmospheric vehicle", 15: "Ultralight / handglider / paraglider", 16: "Parachutist / skydiver", 17: "Reserved", 18: "Reserved", 19: "Reserved", 20: "Surface emergency vehicle", 21: "Surface service vehicle", 22: "Fixed ground or tethered obstruction", 23: "Reserved", 24: "Reserved"}

class RuleContent_583(RuleContentContextFree):
    cv_arg: TypeAlias = Content_583.cv_arg
    cv_content: TypeAlias = Content_583

    @property
    def content(self) -> Content_583:
        return self._get_content() # type: ignore

class Variation_185(Element):
    cv_arg: TypeAlias = RuleContent_583.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_583

    @classmethod
    def create(cls, arg: "Variation_185.cv_arg") -> "Variation_185":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_583:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_583:
        return self.rule.content

class RuleVariation_178(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_185.cv_arg
    cv_variation: TypeAlias = Variation_185

    @classmethod
    def create(cls, arg : "RuleVariation_178.cv_arg") -> "RuleVariation_178":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_185:
        return self.arg # type: ignore

class NonSpare_929(NonSpare):
    cv_arg: TypeAlias = RuleVariation_178.cv_arg
    cv_name = "EMC"
    cv_title = "Emitter Category"
    cv_rule: TypeAlias = RuleVariation_178

    @classmethod
    def create(cls, arg : "NonSpare_929.cv_arg") -> "NonSpare_929":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_178:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_185:
        return self.rule.variation

class NonSpare_1161(NonSpare):
    cv_arg: TypeAlias = RuleVariation_353.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude in WGS.84 in Two's Complement Form"
    cv_rule: TypeAlias = RuleVariation_353

    @classmethod
    def create(cls, arg : "NonSpare_1161.cv_arg") -> "NonSpare_1161":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_353:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_360:
        return self.rule.variation

class Item_473(Item):
    cv_arg: TypeAlias = NonSpare_1161.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1161

    @classmethod
    def create(cls, arg : "Item_473.cv_arg") -> "Item_473":
        return cls._create(arg) # type: ignore

class NonSpare_1191(NonSpare):
    cv_arg: TypeAlias = RuleVariation_351.cv_arg
    cv_name = "LON"
    cv_title = "Longitude in WGS.84 in Two's Complement Form"
    cv_rule: TypeAlias = RuleVariation_351

    @classmethod
    def create(cls, arg : "NonSpare_1191.cv_arg") -> "NonSpare_1191":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_351:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_358:
        return self.rule.variation

class Item_501(Item):
    cv_arg: TypeAlias = NonSpare_1191.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1191

    @classmethod
    def create(cls, arg : "Item_501.cv_arg") -> "Item_501":
        return cls._create(arg) # type: ignore

class Variation_1136(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_353.cv_arg, Tuple[Literal["LAT"], RuleVariation_353.cv_arg]], Union[RuleVariation_351.cv_arg, Tuple[Literal["LON"], RuleVariation_351.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1136.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 48
    cv_items_list = [(Item_473, 24), (Item_501, 24)]
    cv_items_dict = {"LAT": RuleVariation_353, "LON": RuleVariation_351}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_351:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_353:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_351:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1136.cv_arg") -> 'Variation_1136':
        return cls._create(arg) # type: ignore

class RuleVariation_1092(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1136.cv_arg
    cv_variation: TypeAlias = Variation_1136

    @classmethod
    def create(cls, arg : "RuleVariation_1092.cv_arg") -> "RuleVariation_1092":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1136:
        return self.arg # type: ignore

class NonSpare_1449(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1092.cv_arg
    cv_name = "POS"
    cv_title = "Position"
    cv_rule: TypeAlias = RuleVariation_1092

    @classmethod
    def create(cls, arg : "NonSpare_1449.cv_arg") -> "NonSpare_1449":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1092:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1136:
        return self.rule.variation

class NonSpare_1019(NonSpare):
    cv_arg: TypeAlias = RuleVariation_285.cv_arg
    cv_name = "GAL"
    cv_title = "Geometric Altitude"
    cv_rule: TypeAlias = RuleVariation_285

    @classmethod
    def create(cls, arg : "NonSpare_1019.cv_arg") -> "NonSpare_1019":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_285:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_292:
        return self.rule.variation

class NonSpare_1484(NonSpare):
    cv_arg: TypeAlias = RuleVariation_769.cv_arg
    cv_name = "PUN"
    cv_title = "Position Uncertainty"
    cv_rule: TypeAlias = RuleVariation_769

    @classmethod
    def create(cls, arg : "NonSpare_1484.cv_arg") -> "NonSpare_1484":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_769:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_799:
        return self.rule.variation

class Item_719(Item):
    cv_arg: TypeAlias = NonSpare_1484.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1484

    @classmethod
    def create(cls, arg : "Item_719.cv_arg") -> "Item_719":
        return cls._create(arg) # type: ignore

class Variation_1031(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_769.cv_arg, Tuple[Literal["PUN"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1031.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_3, 4), (Item_719, 4)]
    cv_items_dict = {"PUN": RuleVariation_769}

    @classmethod
    def spec(cls, key : Literal["PUN"]) -> RuleVariation_769:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["PUN"]) -> RuleVariation_769:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1031.cv_arg") -> 'Variation_1031':
        return cls._create(arg) # type: ignore

class RuleVariation_999(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1031.cv_arg
    cv_variation: TypeAlias = Variation_1031

    @classmethod
    def create(cls, arg : "RuleVariation_999.cv_arg") -> "RuleVariation_999":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1031:
        return self.arg # type: ignore

class NonSpare_1485(NonSpare):
    cv_arg: TypeAlias = RuleVariation_999.cv_arg
    cv_name = "PUN"
    cv_title = "Position Uncertainty"
    cv_rule: TypeAlias = RuleVariation_999

    @classmethod
    def create(cls, arg : "NonSpare_1485.cv_arg") -> "NonSpare_1485":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_999:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1031:
        return self.rule.variation

class NonSpare_1232(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1325.cv_arg
    cv_name = "MB"
    cv_title = "MODE S MB DATA"
    cv_rule: TypeAlias = RuleVariation_1325

    @classmethod
    def create(cls, arg : "NonSpare_1232.cv_arg") -> "NonSpare_1232":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1404:
        return self.rule.variation

class Content_717(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["kt"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "kt"

    def as_quantity(self, cv_unit : Optional[Literal["kt"]] = None) -> float:
        return self._as_quantity()

class RuleContent_717(RuleContentContextFree):
    cv_arg: TypeAlias = Content_717.cv_arg
    cv_content: TypeAlias = Content_717

    @property
    def content(self) -> Content_717:
        return self._get_content() # type: ignore

class Variation_303(Element):
    cv_arg: TypeAlias = RuleContent_717.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_717

    @classmethod
    def create(cls, arg: "Variation_303.cv_arg") -> "Variation_303":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_717:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_717:
        return self.rule.content

class RuleVariation_296(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_303.cv_arg
    cv_variation: TypeAlias = Variation_303

    @classmethod
    def create(cls, arg : "RuleVariation_296.cv_arg") -> "RuleVariation_296":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_303:
        return self.arg # type: ignore

class NonSpare_1100(NonSpare):
    cv_arg: TypeAlias = RuleVariation_296.cv_arg
    cv_name = "IAR"
    cv_title = "Indicated Airspeed"
    cv_rule: TypeAlias = RuleVariation_296

    @classmethod
    def create(cls, arg : "NonSpare_1100.cv_arg") -> "NonSpare_1100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_296:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_303:
        return self.rule.variation

class Content_749(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["Mach"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 8.0e-3
    cv_unit = "Mach"

    def as_quantity(self, cv_unit : Optional[Literal["Mach"]] = None) -> float:
        return self._as_quantity()

class RuleContent_749(RuleContentContextFree):
    cv_arg: TypeAlias = Content_749.cv_arg
    cv_content: TypeAlias = Content_749

    @property
    def content(self) -> Content_749:
        return self._get_content() # type: ignore

class Variation_319(Element):
    cv_arg: TypeAlias = RuleContent_749.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_749

    @classmethod
    def create(cls, arg: "Variation_319.cv_arg") -> "Variation_319":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_749:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_749:
        return self.rule.content

class RuleVariation_312(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_319.cv_arg
    cv_variation: TypeAlias = Variation_319

    @classmethod
    def create(cls, arg : "RuleVariation_312.cv_arg") -> "RuleVariation_312":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_319:
        return self.arg # type: ignore

class NonSpare_1222(NonSpare):
    cv_arg: TypeAlias = RuleVariation_312.cv_arg
    cv_name = "MAC"
    cv_title = "Mach Number"
    cv_rule: TypeAlias = RuleVariation_312

    @classmethod
    def create(cls, arg : "NonSpare_1222.cv_arg") -> "NonSpare_1222":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_312:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_319:
        return self.rule.variation

class Content_740(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["mb"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.1
    cv_unit = "mb"

    def as_quantity(self, cv_unit : Optional[Literal["mb"]] = None) -> float:
        return self._as_quantity()

class RuleContent_740(RuleContentContextFree):
    cv_arg: TypeAlias = Content_740.cv_arg
    cv_content: TypeAlias = Content_740

    @property
    def content(self) -> Content_740:
        return self._get_content() # type: ignore

class Variation_813(Element):
    cv_arg: TypeAlias = RuleContent_740.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 12
    cv_rule = RuleContent_740

    @classmethod
    def create(cls, arg: "Variation_813.cv_arg") -> "Variation_813":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_740:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_740:
        return self.rule.content

class RuleVariation_783(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_813.cv_arg
    cv_variation: TypeAlias = Variation_813

    @classmethod
    def create(cls, arg : "RuleVariation_783.cv_arg") -> "RuleVariation_783":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_813:
        return self.arg # type: ignore

class NonSpare_690(NonSpare):
    cv_arg: TypeAlias = RuleVariation_783.cv_arg
    cv_name = "BPS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_783

    @classmethod
    def create(cls, arg : "NonSpare_690.cv_arg") -> "NonSpare_690":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_783:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_813:
        return self.rule.variation

class Item_129(Item):
    cv_arg: TypeAlias = NonSpare_690.cv_arg
    cv_non_spare: TypeAlias = NonSpare_690

    @classmethod
    def create(cls, arg : "Item_129.cv_arg") -> "Item_129":
        return cls._create(arg) # type: ignore

class Variation_1019(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_783.cv_arg, Tuple[Literal["BPS"], RuleVariation_783.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1019.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_129, 12)]
    cv_items_dict = {"BPS": RuleVariation_783}

    @classmethod
    def spec(cls, key : Literal["BPS"]) -> RuleVariation_783:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["BPS"]) -> RuleVariation_783:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1019.cv_arg") -> 'Variation_1019':
        return cls._create(arg) # type: ignore

class RuleVariation_989(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1019.cv_arg
    cv_variation: TypeAlias = Variation_1019

    @classmethod
    def create(cls, arg : "RuleVariation_989.cv_arg") -> "RuleVariation_989":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1019:
        return self.arg # type: ignore

class NonSpare_694(NonSpare):
    cv_arg: TypeAlias = RuleVariation_989.cv_arg
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting (derived from Mode S BDS 4,0)"
    cv_rule: TypeAlias = RuleVariation_989

    @classmethod
    def create(cls, arg : "NonSpare_694.cv_arg") -> "NonSpare_694":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_989:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1019:
        return self.rule.variation

class Variation_1465(Compound):
    cv_arg = TypedDict('cv_arg', {
        "ADR": NonSpare_572.cv_arg,
        "ID": NonSpare_1111.cv_arg,
        "MHG": NonSpare_1280.cv_arg,
        "IAS": NonSpare_1104.cv_arg,
        "TAS": NonSpare_1831.cv_arg,
        "SAL": NonSpare_1658.cv_arg,
        "FSS": NonSpare_1002.cv_arg,
        "TIS": NonSpare_1872.cv_arg,
        "TID": NonSpare_1867.cv_arg,
        "COM": NonSpare_787.cv_arg,
        "SAB": NonSpare_1652.cv_arg,
        "ACS": NonSpare_564.cv_arg,
        "BVR": NonSpare_696.cv_arg,
        "GVR": NonSpare_1049.cv_arg,
        "RAN": NonSpare_1548.cv_arg,
        "TAR": NonSpare_1826.cv_arg,
        "TAN": NonSpare_1821.cv_arg,
        "GS": NonSpare_1038.cv_arg,
        "VUN": NonSpare_2045.cv_arg,
        "MET": NonSpare_1272.cv_arg,
        "EMC": NonSpare_929.cv_arg,
        "POS": NonSpare_1449.cv_arg,
        "GAL": NonSpare_1019.cv_arg,
        "PUN": NonSpare_1485.cv_arg,
        "MB": NonSpare_1232.cv_arg,
        "IAR": NonSpare_1100.cv_arg,
        "MAC": NonSpare_1222.cv_arg,
        "BPS": NonSpare_694.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_572, NonSpare_1111, NonSpare_1280, NonSpare_1104, NonSpare_1831, NonSpare_1658, NonSpare_1002, NonSpare_1872, NonSpare_1867, NonSpare_787, NonSpare_1652, NonSpare_564, NonSpare_696, NonSpare_1049, NonSpare_1548, NonSpare_1826, NonSpare_1821, NonSpare_1038, NonSpare_2045, NonSpare_1272, NonSpare_929, NonSpare_1449, NonSpare_1019, NonSpare_1485, NonSpare_1232, NonSpare_1100, NonSpare_1222, NonSpare_694]
    cv_items_dict = {"ADR": NonSpare_572, "ID": NonSpare_1111, "MHG": NonSpare_1280, "IAS": NonSpare_1104, "TAS": NonSpare_1831, "SAL": NonSpare_1658, "FSS": NonSpare_1002, "TIS": NonSpare_1872, "TID": NonSpare_1867, "COM": NonSpare_787, "SAB": NonSpare_1652, "ACS": NonSpare_564, "BVR": NonSpare_696, "GVR": NonSpare_1049, "RAN": NonSpare_1548, "TAR": NonSpare_1826, "TAN": NonSpare_1821, "GS": NonSpare_1038, "VUN": NonSpare_2045, "MET": NonSpare_1272, "EMC": NonSpare_929, "POS": NonSpare_1449, "GAL": NonSpare_1019, "PUN": NonSpare_1485, "MB": NonSpare_1232, "IAR": NonSpare_1100, "MAC": NonSpare_1222, "BPS": NonSpare_694}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1104:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1658:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_1002:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1872:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1867:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_787:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1652:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1049:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1548:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1826:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1821:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1038:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2045:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_929:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1019:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1485:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1232:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_694:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_572]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1111]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1280]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1104]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1831]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1658]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_1002]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1872]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1867]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_787]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1652]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_564]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_696]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1049]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1548]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1826]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1821]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1038]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2045]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1272]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_929]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1449]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1019]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1485]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1232]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1100]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_694]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_572.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1111.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1280.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1104.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1831.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1658.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_1002.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1872.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1867.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_787.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1652.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_564.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_696.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1049.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1548.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1826.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1821.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1038.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2045.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1272.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_929.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1449.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1019.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1485.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1232.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1100.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1222.cv_arg) -> "Variation_1465":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_694.cv_arg) -> "Variation_1465":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1465":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1465":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1465.cv_arg") -> 'Variation_1465':
        return cls._create(arg) # type: ignore

class RuleVariation_1386(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1465.cv_arg
    cv_variation: TypeAlias = Variation_1465

    @classmethod
    def create(cls, arg : "RuleVariation_1386.cv_arg") -> "RuleVariation_1386":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1465:
        return self.arg # type: ignore

class NonSpare_485(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1386.cv_arg
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule: TypeAlias = RuleVariation_1386

    @classmethod
    def create(cls, arg : "NonSpare_485.cv_arg") -> "NonSpare_485":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1386:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1465:
        return self.rule.variation

class UapItem_485(UapItem):
    cv_non_spare: TypeAlias = NonSpare_485

class NonSpare_149(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "040"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_149.cv_arg") -> "NonSpare_149":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_149(UapItem):
    cv_non_spare: TypeAlias = NonSpare_149

class Content_299(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Multisensor track", 1: "Monosensor track"}

class RuleContent_299(RuleContentContextFree):
    cv_arg: TypeAlias = Content_299.cv_arg
    cv_content: TypeAlias = Content_299

    @property
    def content(self) -> Content_299:
        return self._get_content() # type: ignore

class Variation_55(Element):
    cv_arg: TypeAlias = RuleContent_299.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_299

    @classmethod
    def create(cls, arg: "Variation_55.cv_arg") -> "Variation_55":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_299:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_299:
        return self.rule.content

class RuleVariation_55(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_55.cv_arg
    cv_variation: TypeAlias = Variation_55

    @classmethod
    def create(cls, arg : "RuleVariation_55.cv_arg") -> "RuleVariation_55":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_55:
        return self.arg # type: ignore

class Content_371(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No source", 1: "GNSS", 2: "3D radar", 3: "Triangulation", 4: "Height from coverage", 5: "Speed look-up table", 6: "Default height", 7: "Multilateration"}

class RuleContent_371(RuleContentContextFree):
    cv_arg: TypeAlias = Content_371.cv_arg
    cv_content: TypeAlias = Content_371

    @property
    def content(self) -> Content_371:
        return self._get_content() # type: ignore

class Variation_689(Element):
    cv_arg: TypeAlias = RuleContent_371.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_371

    @classmethod
    def create(cls, arg: "Variation_689.cv_arg") -> "Variation_689":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_371:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_371:
        return self.rule.content

class RuleVariation_678(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_689.cv_arg
    cv_variation: TypeAlias = Variation_689

    @classmethod
    def create(cls, arg : "RuleVariation_678.cv_arg") -> "RuleVariation_678":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_689:
        return self.arg # type: ignore

class Content_20(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Actual track", 1: "Simulated track"}

class RuleContent_20(RuleContentContextFree):
    cv_arg: TypeAlias = Content_20.cv_arg
    cv_content: TypeAlias = Content_20

    @property
    def content(self) -> Content_20:
        return self._get_content() # type: ignore

class Variation_6(Element):
    cv_arg: TypeAlias = RuleContent_20.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_20

    @classmethod
    def create(cls, arg: "Variation_6.cv_arg") -> "Variation_6":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_20:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_20:
        return self.rule.content

class RuleVariation_6(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_6.cv_arg
    cv_variation: TypeAlias = Variation_6

    @classmethod
    def create(cls, arg : "RuleVariation_6.cv_arg") -> "RuleVariation_6":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_6:
        return self.arg # type: ignore

class Content_187(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Last message transmitted to the user for the track"}

class RuleContent_187(RuleContentContextFree):
    cv_arg: TypeAlias = Content_187.cv_arg
    cv_content: TypeAlias = Content_187

    @property
    def content(self) -> Content_187:
        return self._get_content() # type: ignore

class Variation_422(Element):
    cv_arg: TypeAlias = RuleContent_187.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_187

    @classmethod
    def create(cls, arg: "Variation_422.cv_arg") -> "Variation_422":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_187:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_187:
        return self.rule.content

class RuleVariation_411(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_422.cv_arg
    cv_variation: TypeAlias = Variation_422

    @classmethod
    def create(cls, arg : "RuleVariation_411.cv_arg") -> "RuleVariation_411":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_422:
        return self.arg # type: ignore

class Content_185(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "First message transmitted to the user for the track"}

class RuleContent_185(RuleContentContextFree):
    cv_arg: TypeAlias = Content_185.cv_arg
    cv_content: TypeAlias = Content_185

    @property
    def content(self) -> Content_185:
        return self._get_content() # type: ignore

class Variation_531(Element):
    cv_arg: TypeAlias = RuleContent_185.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_185

    @classmethod
    def create(cls, arg: "Variation_531.cv_arg") -> "Variation_531":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_185:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_185:
        return self.rule.content

class RuleVariation_520(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_531.cv_arg
    cv_variation: TypeAlias = Variation_531

    @classmethod
    def create(cls, arg : "RuleVariation_520.cv_arg") -> "RuleVariation_520":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_531:
        return self.arg # type: ignore

class Content_191(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Slave Track Promotion"}

class RuleContent_191(RuleContentContextFree):
    cv_arg: TypeAlias = Content_191.cv_arg
    cv_content: TypeAlias = Content_191

    @property
    def content(self) -> Content_191:
        return self._get_content() # type: ignore

class Variation_846(Element):
    cv_arg: TypeAlias = RuleContent_191.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_191

    @classmethod
    def create(cls, arg: "Variation_846.cv_arg") -> "Variation_846":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_191:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_191:
        return self.rule.content

class RuleVariation_816(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_846.cv_arg
    cv_variation: TypeAlias = Variation_846

    @classmethod
    def create(cls, arg : "RuleVariation_816.cv_arg") -> "RuleVariation_816":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_846:
        return self.arg # type: ignore

class Content_59(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Complementary service used", 1: "Background service used"}

class RuleContent_59(RuleContentContextFree):
    cv_arg: TypeAlias = Content_59.cv_arg
    cv_content: TypeAlias = Content_59

    @property
    def content(self) -> Content_59:
        return self._get_content() # type: ignore

class Variation_905(Element):
    cv_arg: TypeAlias = RuleContent_59.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_59

    @classmethod
    def create(cls, arg: "Variation_905.cv_arg") -> "Variation_905":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_59:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_59:
        return self.rule.content

class RuleVariation_875(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_905.cv_arg
    cv_variation: TypeAlias = Variation_905

    @classmethod
    def create(cls, arg : "RuleVariation_875.cv_arg") -> "RuleVariation_875":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_905:
        return self.arg # type: ignore

class Variation_469(Element):
    cv_arg: TypeAlias = RuleContent_309.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 2
    cv_rule = RuleContent_309

    @classmethod
    def create(cls, arg: "Variation_469.cv_arg") -> "Variation_469":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_309:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_309:
        return self.rule.content

class RuleVariation_458(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_469.cv_arg
    cv_variation: TypeAlias = Variation_469

    @classmethod
    def create(cls, arg : "RuleVariation_458.cv_arg") -> "RuleVariation_458":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_469:
        return self.arg # type: ignore

class Variation_636(Element):
    cv_arg: TypeAlias = RuleContent_188.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_188

    @classmethod
    def create(cls, arg: "Variation_636.cv_arg") -> "Variation_636":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_188:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_188:
        return self.rule.content

class RuleVariation_625(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_636.cv_arg
    cv_variation: TypeAlias = Variation_636

    @classmethod
    def create(cls, arg : "RuleVariation_625.cv_arg") -> "RuleVariation_625":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_636:
        return self.arg # type: ignore

class Content_189(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Military Identification present in the last report received from a sensor capable of decoding this data"}

class RuleContent_189(RuleContentContextFree):
    cv_arg: TypeAlias = Content_189.cv_arg
    cv_content: TypeAlias = Content_189

    @property
    def content(self) -> Content_189:
        return self._get_content() # type: ignore

class Variation_719(Element):
    cv_arg: TypeAlias = RuleContent_189.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_189

    @classmethod
    def create(cls, arg: "Variation_719.cv_arg") -> "Variation_719":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_189:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_189:
        return self.rule.content

class RuleVariation_708(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_719.cv_arg
    cv_variation: TypeAlias = Variation_719

    @classmethod
    def create(cls, arg : "RuleVariation_708.cv_arg") -> "RuleVariation_708":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_719:
        return self.arg # type: ignore

class Content_312(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No Mode 5 interrogation", 1: "Friendly target", 2: "Unknown target", 3: "No reply"}

class RuleContent_312(RuleContentContextFree):
    cv_arg: TypeAlias = Content_312.cv_arg
    cv_content: TypeAlias = Content_312

    @property
    def content(self) -> Content_312:
        return self._get_content() # type: ignore

class Variation_882(Element):
    cv_arg: TypeAlias = RuleContent_312.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 2
    cv_rule = RuleContent_312

    @classmethod
    def create(cls, arg: "Variation_882.cv_arg") -> "Variation_882":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_312:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_312:
        return self.rule.content

class RuleVariation_852(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_882.cv_arg
    cv_variation: TypeAlias = Variation_882

    @classmethod
    def create(cls, arg : "RuleVariation_852.cv_arg") -> "RuleVariation_852":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_882:
        return self.arg # type: ignore

class Variation_38(Element):
    cv_arg: TypeAlias = RuleContent_179.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_179

    @classmethod
    def create(cls, arg: "Variation_38.cv_arg") -> "Variation_38":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_179:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_179:
        return self.rule.content

class RuleVariation_38(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_38.cv_arg
    cv_variation: TypeAlias = Variation_38

    @classmethod
    def create(cls, arg : "RuleVariation_38.cv_arg") -> "RuleVariation_38":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_38:
        return self.arg # type: ignore

class Content_174(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received ADS-B track update is higher than system dependent threshold"}

class RuleContent_174(RuleContentContextFree):
    cv_arg: TypeAlias = Content_174.cv_arg
    cv_content: TypeAlias = Content_174

    @property
    def content(self) -> Content_174:
        return self._get_content() # type: ignore

class Variation_718(Element):
    cv_arg: TypeAlias = RuleContent_174.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_174

    @classmethod
    def create(cls, arg: "Variation_718.cv_arg") -> "Variation_718":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_174:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_174:
        return self.rule.content

class RuleVariation_707(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_718.cv_arg
    cv_variation: TypeAlias = Variation_718

    @classmethod
    def create(cls, arg : "RuleVariation_707.cv_arg") -> "RuleVariation_707":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_718:
        return self.arg # type: ignore

class Content_180(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Assigned Mode A Code Conflict (same discrete Mode A Code assigned to another track)"}

class RuleContent_180(RuleContentContextFree):
    cv_arg: TypeAlias = Content_180.cv_arg
    cv_content: TypeAlias = Content_180

    @property
    def content(self) -> Content_180:
        return self._get_content() # type: ignore

class Variation_923(Element):
    cv_arg: TypeAlias = RuleContent_180.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_180

    @classmethod
    def create(cls, arg: "Variation_923.cv_arg") -> "Variation_923":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_180:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_180:
        return self.rule.content

class RuleVariation_893(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_923.cv_arg
    cv_variation: TypeAlias = Variation_923

    @classmethod
    def create(cls, arg : "RuleVariation_893.cv_arg") -> "RuleVariation_893":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_923:
        return self.arg # type: ignore

class Content_57(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Combined", 1: "Co-operative only", 2: "Non-Cooperative only", 3: "Not defined"}

class RuleContent_57(RuleContentContextFree):
    cv_arg: TypeAlias = Content_57.cv_arg
    cv_content: TypeAlias = Content_57

    @property
    def content(self) -> Content_57:
        return self._get_content() # type: ignore

class Variation_100(Element):
    cv_arg: TypeAlias = RuleContent_57.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_57

    @classmethod
    def create(cls, arg: "Variation_100.cv_arg") -> "Variation_100":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_57:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_57:
        return self.rule.content

class RuleVariation_100(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_100.cv_arg
    cv_variation: TypeAlias = Variation_100

    @classmethod
    def create(cls, arg : "RuleVariation_100.cv_arg") -> "RuleVariation_100":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_100:
        return self.arg # type: ignore

class Content_354(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No emergency", 1: "General emergency", 2: "Lifeguard / medical", 3: "Minimum fuel", 4: "No communications", 5: "Unlawful interference", 6: "Downed Aircraft", 7: "Undefined"}

class RuleContent_354(RuleContentContextFree):
    cv_arg: TypeAlias = Content_354.cv_arg
    cv_content: TypeAlias = Content_354

    @property
    def content(self) -> Content_354:
        return self._get_content() # type: ignore

class Variation_601(Element):
    cv_arg: TypeAlias = RuleContent_354.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 3
    cv_rule = RuleContent_354

    @classmethod
    def create(cls, arg: "Variation_601.cv_arg") -> "Variation_601":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_354:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_354:
        return self.rule.content

class RuleVariation_590(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_601.cv_arg
    cv_variation: TypeAlias = Variation_601

    @classmethod
    def create(cls, arg : "RuleVariation_590.cv_arg") -> "RuleVariation_590":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_601:
        return self.arg # type: ignore

class Content_364(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No indication", 1: "Potential False Track Indication"}

class RuleContent_364(RuleContentContextFree):
    cv_arg: TypeAlias = Content_364.cv_arg
    cv_content: TypeAlias = Content_364

    @property
    def content(self) -> Content_364:
        return self._get_content() # type: ignore

class Variation_863(Element):
    cv_arg: TypeAlias = RuleContent_364.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_364

    @classmethod
    def create(cls, arg: "Variation_863.cv_arg") -> "Variation_863":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_364:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_364:
        return self.rule.content

class RuleVariation_833(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_863.cv_arg
    cv_variation: TypeAlias = Variation_863

    @classmethod
    def create(cls, arg : "RuleVariation_833.cv_arg") -> "RuleVariation_833":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_863:
        return self.arg # type: ignore

class Content_194(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Track created / updated with FPL data"}

class RuleContent_194(RuleContentContextFree):
    cv_arg: TypeAlias = Content_194.cv_arg
    cv_content: TypeAlias = Content_194

    @property
    def content(self) -> Content_194:
        return self._get_content() # type: ignore

class Variation_925(Element):
    cv_arg: TypeAlias = RuleContent_194.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_194

    @classmethod
    def create(cls, arg: "Variation_925.cv_arg") -> "Variation_925":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_194:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_194:
        return self.rule.content

class RuleVariation_895(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_925.cv_arg
    cv_variation: TypeAlias = Variation_925

    @classmethod
    def create(cls, arg : "RuleVariation_895.cv_arg") -> "RuleVariation_895":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_925:
        return self.arg # type: ignore

class Content_184(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Duplicate Mode 3/A Code"}

class RuleContent_184(RuleContentContextFree):
    cv_arg: TypeAlias = Content_184.cv_arg
    cv_content: TypeAlias = Content_184

    @property
    def content(self) -> Content_184:
        return self._get_content() # type: ignore

class Variation_39(Element):
    cv_arg: TypeAlias = RuleContent_184.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_184

    @classmethod
    def create(cls, arg: "Variation_39.cv_arg") -> "Variation_39":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_184:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_184:
        return self.rule.content

class RuleVariation_39(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_39.cv_arg
    cv_variation: TypeAlias = Variation_39

    @classmethod
    def create(cls, arg : "RuleVariation_39.cv_arg") -> "RuleVariation_39":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_39:
        return self.arg # type: ignore

class Content_182(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Duplicate Flight Plan"}

class RuleContent_182(RuleContentContextFree):
    cv_arg: TypeAlias = Content_182.cv_arg
    cv_content: TypeAlias = Content_182

    @property
    def content(self) -> Content_182:
        return self._get_content() # type: ignore

class Variation_421(Element):
    cv_arg: TypeAlias = RuleContent_182.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_182

    @classmethod
    def create(cls, arg: "Variation_421.cv_arg") -> "Variation_421":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_182:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_182:
        return self.rule.content

class RuleVariation_410(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_421.cv_arg
    cv_variation: TypeAlias = Variation_421

    @classmethod
    def create(cls, arg : "RuleVariation_410.cv_arg") -> "RuleVariation_410":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_421:
        return self.arg # type: ignore

class Content_183(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Duplicate Flight Plan due to manual correlation"}

class RuleContent_183(RuleContentContextFree):
    cv_arg: TypeAlias = Content_183.cv_arg
    cv_content: TypeAlias = Content_183

    @property
    def content(self) -> Content_183:
        return self._get_content() # type: ignore

class Variation_530(Element):
    cv_arg: TypeAlias = RuleContent_183.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_183

    @classmethod
    def create(cls, arg: "Variation_530.cv_arg") -> "Variation_530":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_183:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_183:
        return self.rule.content

class RuleVariation_519(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_530.cv_arg
    cv_variation: TypeAlias = Variation_530

    @classmethod
    def create(cls, arg : "RuleVariation_519.cv_arg") -> "RuleVariation_519":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_530:
        return self.arg # type: ignore

class NonSpare_1313(NonSpare):
    cv_arg: TypeAlias = RuleVariation_55.cv_arg
    cv_name = "MON"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_55

    @classmethod
    def create(cls, arg : "NonSpare_1313.cv_arg") -> "NonSpare_1313":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_55:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_55:
        return self.rule.variation

class Item_579(Item):
    cv_arg: TypeAlias = NonSpare_1313.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1313

    @classmethod
    def create(cls, arg : "Item_579.cv_arg") -> "Item_579":
        return cls._create(arg) # type: ignore

class NonSpare_1316(NonSpare):
    cv_arg: TypeAlias = RuleVariation_500.cv_arg
    cv_name = "MRH"
    cv_title = "Most Reliable Height"
    cv_rule: TypeAlias = RuleVariation_500

    @classmethod
    def create(cls, arg : "NonSpare_1316.cv_arg") -> "NonSpare_1316":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_500:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_511:
        return self.rule.variation

class Item_582(Item):
    cv_arg: TypeAlias = NonSpare_1316.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1316

    @classmethod
    def create(cls, arg : "Item_582.cv_arg") -> "Item_582":
        return cls._create(arg) # type: ignore

class NonSpare_1751(NonSpare):
    cv_arg: TypeAlias = RuleVariation_678.cv_arg
    cv_name = "SRC"
    cv_title = "Source of Calculated Track Altitude for I062/130"
    cv_rule: TypeAlias = RuleVariation_678

    @classmethod
    def create(cls, arg : "NonSpare_1751.cv_arg") -> "NonSpare_1751":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_678:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_689:
        return self.rule.variation

class Item_923(Item):
    cv_arg: TypeAlias = NonSpare_1751.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1751

    @classmethod
    def create(cls, arg : "Item_923.cv_arg") -> "Item_923":
        return cls._create(arg) # type: ignore

class NonSpare_1724(NonSpare):
    cv_arg: TypeAlias = RuleVariation_6.cv_arg
    cv_name = "SIM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_6

    @classmethod
    def create(cls, arg : "NonSpare_1724.cv_arg") -> "NonSpare_1724":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_6:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_6:
        return self.rule.variation

class Item_899(Item):
    cv_arg: TypeAlias = NonSpare_1724.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1724

    @classmethod
    def create(cls, arg : "Item_899.cv_arg") -> "Item_899":
        return cls._create(arg) # type: ignore

class NonSpare_1929(NonSpare):
    cv_arg: TypeAlias = RuleVariation_411.cv_arg
    cv_name = "TSE"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_411

    @classmethod
    def create(cls, arg : "NonSpare_1929.cv_arg") -> "NonSpare_1929":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_411:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_422:
        return self.rule.variation

class Item_1046(Item):
    cv_arg: TypeAlias = NonSpare_1929.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1929

    @classmethod
    def create(cls, arg : "Item_1046.cv_arg") -> "Item_1046":
        return cls._create(arg) # type: ignore

class NonSpare_1927(NonSpare):
    cv_arg: TypeAlias = RuleVariation_520.cv_arg
    cv_name = "TSB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_520

    @classmethod
    def create(cls, arg : "NonSpare_1927.cv_arg") -> "NonSpare_1927":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_520:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_531:
        return self.rule.variation

class Item_1044(Item):
    cv_arg: TypeAlias = NonSpare_1927.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1927

    @classmethod
    def create(cls, arg : "Item_1044.cv_arg") -> "Item_1044":
        return cls._create(arg) # type: ignore

class NonSpare_1796(NonSpare):
    cv_arg: TypeAlias = RuleVariation_816.cv_arg
    cv_name = "STP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_816

    @classmethod
    def create(cls, arg : "NonSpare_1796.cv_arg") -> "NonSpare_1796":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_816:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_846:
        return self.rule.variation

class Item_956(Item):
    cv_arg: TypeAlias = NonSpare_1796.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1796

    @classmethod
    def create(cls, arg : "Item_956.cv_arg") -> "Item_956":
        return cls._create(arg) # type: ignore

class NonSpare_1130(NonSpare):
    cv_arg: TypeAlias = RuleVariation_875.cv_arg
    cv_name = "KOS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_875

    @classmethod
    def create(cls, arg : "NonSpare_1130.cv_arg") -> "NonSpare_1130":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_875:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_905:
        return self.rule.variation

class Item_442(Item):
    cv_arg: TypeAlias = NonSpare_1130.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1130

    @classmethod
    def create(cls, arg : "Item_442.cv_arg") -> "Item_442":
        return cls._create(arg) # type: ignore

class NonSpare_1246(NonSpare):
    cv_arg: TypeAlias = RuleVariation_458.cv_arg
    cv_name = "MD4"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_458

    @classmethod
    def create(cls, arg : "NonSpare_1246.cv_arg") -> "NonSpare_1246":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_458:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_469:
        return self.rule.variation

class Item_537(Item):
    cv_arg: TypeAlias = NonSpare_1246.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1246

    @classmethod
    def create(cls, arg : "Item_537.cv_arg") -> "Item_537":
        return cls._create(arg) # type: ignore

class NonSpare_1266(NonSpare):
    cv_arg: TypeAlias = RuleVariation_625.cv_arg
    cv_name = "ME"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_625

    @classmethod
    def create(cls, arg : "NonSpare_1266.cv_arg") -> "NonSpare_1266":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_625:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_636:
        return self.rule.variation

class Item_544(Item):
    cv_arg: TypeAlias = NonSpare_1266.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1266

    @classmethod
    def create(cls, arg : "Item_544.cv_arg") -> "Item_544":
        return cls._create(arg) # type: ignore

class NonSpare_1284(NonSpare):
    cv_arg: TypeAlias = RuleVariation_708.cv_arg
    cv_name = "MI"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_708

    @classmethod
    def create(cls, arg : "NonSpare_1284.cv_arg") -> "NonSpare_1284":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_708:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_719:
        return self.rule.variation

class Item_551(Item):
    cv_arg: TypeAlias = NonSpare_1284.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1284

    @classmethod
    def create(cls, arg : "Item_551.cv_arg") -> "Item_551":
        return cls._create(arg) # type: ignore

class NonSpare_1248(NonSpare):
    cv_arg: TypeAlias = RuleVariation_852.cv_arg
    cv_name = "MD5"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_852

    @classmethod
    def create(cls, arg : "NonSpare_1248.cv_arg") -> "NonSpare_1248":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_852:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_882:
        return self.rule.variation

class Item_538(Item):
    cv_arg: TypeAlias = NonSpare_1248.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1248

    @classmethod
    def create(cls, arg : "Item_538.cv_arg") -> "Item_538":
        return cls._create(arg) # type: ignore

class NonSpare_838(NonSpare):
    cv_arg: TypeAlias = RuleVariation_38.cv_arg
    cv_name = "CST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_38

    @classmethod
    def create(cls, arg : "NonSpare_838.cv_arg") -> "NonSpare_838":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_38:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_38:
        return self.rule.variation

class Item_221(Item):
    cv_arg: TypeAlias = NonSpare_838.cv_arg
    cv_non_spare: TypeAlias = NonSpare_838

    @classmethod
    def create(cls, arg : "Item_221.cv_arg") -> "Item_221":
        return cls._create(arg) # type: ignore

class NonSpare_574(NonSpare):
    cv_arg: TypeAlias = RuleVariation_707.cv_arg
    cv_name = "ADS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_707

    @classmethod
    def create(cls, arg : "NonSpare_574.cv_arg") -> "NonSpare_574":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_707:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_718:
        return self.rule.variation

class Item_46(Item):
    cv_arg: TypeAlias = NonSpare_574.cv_arg
    cv_non_spare: TypeAlias = NonSpare_574

    @classmethod
    def create(cls, arg : "Item_46.cv_arg") -> "Item_46":
        return cls._create(arg) # type: ignore

class NonSpare_550(NonSpare):
    cv_arg: TypeAlias = RuleVariation_893.cv_arg
    cv_name = "AAC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_893

    @classmethod
    def create(cls, arg : "NonSpare_550.cv_arg") -> "NonSpare_550":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_893:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_923:
        return self.rule.variation

class Item_34(Item):
    cv_arg: TypeAlias = NonSpare_550.cv_arg
    cv_non_spare: TypeAlias = NonSpare_550

    @classmethod
    def create(cls, arg : "Item_34.cv_arg") -> "Item_34":
        return cls._create(arg) # type: ignore

class NonSpare_1695(NonSpare):
    cv_arg: TypeAlias = RuleVariation_100.cv_arg
    cv_name = "SDS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_100

    @classmethod
    def create(cls, arg : "NonSpare_1695.cv_arg") -> "NonSpare_1695":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_100:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_100:
        return self.rule.variation

class Item_875(Item):
    cv_arg: TypeAlias = NonSpare_1695.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1695

    @classmethod
    def create(cls, arg : "Item_875.cv_arg") -> "Item_875":
        return cls._create(arg) # type: ignore

class NonSpare_933(NonSpare):
    cv_arg: TypeAlias = RuleVariation_590.cv_arg
    cv_name = "EMS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_590

    @classmethod
    def create(cls, arg : "NonSpare_933.cv_arg") -> "NonSpare_933":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_590:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_601:
        return self.rule.variation

class Item_294(Item):
    cv_arg: TypeAlias = NonSpare_933.cv_arg
    cv_non_spare: TypeAlias = NonSpare_933

    @classmethod
    def create(cls, arg : "Item_294.cv_arg") -> "Item_294":
        return cls._create(arg) # type: ignore

class NonSpare_1427(NonSpare):
    cv_arg: TypeAlias = RuleVariation_833.cv_arg
    cv_name = "PFT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_833

    @classmethod
    def create(cls, arg : "NonSpare_1427.cv_arg") -> "NonSpare_1427":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_833:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_863:
        return self.rule.variation

class Item_681(Item):
    cv_arg: TypeAlias = NonSpare_1427.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1427

    @classmethod
    def create(cls, arg : "Item_681.cv_arg") -> "Item_681":
        return cls._create(arg) # type: ignore

class NonSpare_989(NonSpare):
    cv_arg: TypeAlias = RuleVariation_895.cv_arg
    cv_name = "FPLT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_895

    @classmethod
    def create(cls, arg : "NonSpare_989.cv_arg") -> "NonSpare_989":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_895:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_925:
        return self.rule.variation

class Item_339(Item):
    cv_arg: TypeAlias = NonSpare_989.cv_arg
    cv_non_spare: TypeAlias = NonSpare_989

    @classmethod
    def create(cls, arg : "Item_339.cv_arg") -> "Item_339":
        return cls._create(arg) # type: ignore

class NonSpare_913(NonSpare):
    cv_arg: TypeAlias = RuleVariation_39.cv_arg
    cv_name = "DUPT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_39

    @classmethod
    def create(cls, arg : "NonSpare_913.cv_arg") -> "NonSpare_913":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_39:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_39:
        return self.rule.variation

class Item_283(Item):
    cv_arg: TypeAlias = NonSpare_913.cv_arg
    cv_non_spare: TypeAlias = NonSpare_913

    @classmethod
    def create(cls, arg : "Item_283.cv_arg") -> "Item_283":
        return cls._create(arg) # type: ignore

class NonSpare_911(NonSpare):
    cv_arg: TypeAlias = RuleVariation_410.cv_arg
    cv_name = "DUPF"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_410

    @classmethod
    def create(cls, arg : "NonSpare_911.cv_arg") -> "NonSpare_911":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_410:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_421:
        return self.rule.variation

class Item_281(Item):
    cv_arg: TypeAlias = NonSpare_911.cv_arg
    cv_non_spare: TypeAlias = NonSpare_911

    @classmethod
    def create(cls, arg : "Item_281.cv_arg") -> "Item_281":
        return cls._create(arg) # type: ignore

class NonSpare_912(NonSpare):
    cv_arg: TypeAlias = RuleVariation_519.cv_arg
    cv_name = "DUPM"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_519

    @classmethod
    def create(cls, arg : "NonSpare_912.cv_arg") -> "NonSpare_912":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_519:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_530:
        return self.rule.variation

class Item_282(Item):
    cv_arg: TypeAlias = NonSpare_912.cv_arg
    cv_non_spare: TypeAlias = NonSpare_912

    @classmethod
    def create(cls, arg : "Item_282.cv_arg") -> "Item_282":
        return cls._create(arg) # type: ignore

class Variation_1368(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_55.cv_arg, Tuple[Literal["MON"], RuleVariation_55.cv_arg]], Union[RuleVariation_412.cv_arg, Tuple[Literal["SPI"], RuleVariation_412.cv_arg]], Union[RuleVariation_500.cv_arg, Tuple[Literal["MRH"], RuleVariation_500.cv_arg]], Union[RuleVariation_678.cv_arg, Tuple[Literal["SRC"], RuleVariation_678.cv_arg]], Union[RuleVariation_877.cv_arg, Tuple[Literal["CNF"], RuleVariation_877.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_6.cv_arg, Tuple[Literal["SIM"], RuleVariation_6.cv_arg]], Union[RuleVariation_411.cv_arg, Tuple[Literal["TSE"], RuleVariation_411.cv_arg]], Union[RuleVariation_520.cv_arg, Tuple[Literal["TSB"], RuleVariation_520.cv_arg]], Union[RuleVariation_647.cv_arg, Tuple[Literal["FPC"], RuleVariation_647.cv_arg]], Union[RuleVariation_705.cv_arg, Tuple[Literal["AFF"], RuleVariation_705.cv_arg]], Union[RuleVariation_816.cv_arg, Tuple[Literal["STP"], RuleVariation_816.cv_arg]], Union[RuleVariation_875.cv_arg, Tuple[Literal["KOS"], RuleVariation_875.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_90.cv_arg, Tuple[Literal["AMA"], RuleVariation_90.cv_arg]], Union[RuleVariation_458.cv_arg, Tuple[Literal["MD4"], RuleVariation_458.cv_arg]], Union[RuleVariation_625.cv_arg, Tuple[Literal["ME"], RuleVariation_625.cv_arg]], Union[RuleVariation_708.cv_arg, Tuple[Literal["MI"], RuleVariation_708.cv_arg]], Union[RuleVariation_852.cv_arg, Tuple[Literal["MD5"], RuleVariation_852.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_38.cv_arg, Tuple[Literal["CST"], RuleVariation_38.cv_arg]], Union[RuleVariation_409.cv_arg, Tuple[Literal["PSR"], RuleVariation_409.cv_arg]], Union[RuleVariation_517.cv_arg, Tuple[Literal["SSR"], RuleVariation_517.cv_arg]], Union[RuleVariation_624.cv_arg, Tuple[Literal["MDS"], RuleVariation_624.cv_arg]], Union[RuleVariation_707.cv_arg, Tuple[Literal["ADS"], RuleVariation_707.cv_arg]], Union[RuleVariation_817.cv_arg, Tuple[Literal["SUC"], RuleVariation_817.cv_arg]], Union[RuleVariation_893.cv_arg, Tuple[Literal["AAC"], RuleVariation_893.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_100.cv_arg, Tuple[Literal["SDS"], RuleVariation_100.cv_arg]], Union[RuleVariation_590.cv_arg, Tuple[Literal["EMS"], RuleVariation_590.cv_arg]], Union[RuleVariation_833.cv_arg, Tuple[Literal["PFT"], RuleVariation_833.cv_arg]], Union[RuleVariation_895.cv_arg, Tuple[Literal["FPLT"], RuleVariation_895.cv_arg]], None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_39.cv_arg, Tuple[Literal["DUPT"], RuleVariation_39.cv_arg]], Union[RuleVariation_410.cv_arg, Tuple[Literal["DUPF"], RuleVariation_410.cv_arg]], Union[RuleVariation_519.cv_arg, Tuple[Literal["DUPM"], RuleVariation_519.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1368.cv_arg_group_1"],
        Tuple["Variation_1368.cv_arg_group_1", "Variation_1368.cv_arg_group_2"],
        Tuple["Variation_1368.cv_arg_group_1", "Variation_1368.cv_arg_group_2", "Variation_1368.cv_arg_group_3"],
        Tuple["Variation_1368.cv_arg_group_1", "Variation_1368.cv_arg_group_2", "Variation_1368.cv_arg_group_3", "Variation_1368.cv_arg_group_4"],
        Tuple["Variation_1368.cv_arg_group_1", "Variation_1368.cv_arg_group_2", "Variation_1368.cv_arg_group_3", "Variation_1368.cv_arg_group_4", "Variation_1368.cv_arg_group_5"],
        Tuple["Variation_1368.cv_arg_group_1", "Variation_1368.cv_arg_group_2", "Variation_1368.cv_arg_group_3", "Variation_1368.cv_arg_group_4", "Variation_1368.cv_arg_group_5", "Variation_1368.cv_arg_group_6"],
    ]
    cv_items_list = [[(Item_579, 1), (Item_911, 1), (Item_582, 1), (Item_923, 3), (Item_167, 1), None], [(Item_899, 1), (Item_1046, 1), (Item_1044, 1), (Item_338, 1), (Item_50, 1), (Item_956, 1), (Item_442, 1), None], [(Item_71, 1), (Item_537, 2), (Item_544, 1), (Item_551, 1), (Item_538, 2), None], [(Item_221, 1), (Item_713, 1), (Item_928, 1), (Item_539, 1), (Item_46, 1), (Item_962, 1), (Item_34, 1), None], [(Item_875, 2), (Item_294, 3), (Item_681, 1), (Item_339, 1), None], [(Item_283, 1), (Item_281, 1), (Item_282, 1), (Item_18, 4), None]]

    @classmethod
    def create(cls, arg: "Variation_1368.cv_arg") -> 'Variation_1368':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_412:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_500:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_678:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_877:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_6]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_411]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_520]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_647]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["STP"]) -> Optional[RuleVariation_816]:
        ...
    @overload
    def get_item(self, key : Literal["KOS"]) -> Optional[RuleVariation_875]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_90]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[RuleVariation_458]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_625]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_708]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[RuleVariation_852]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_38]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_624]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_707]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_817]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_893]:
        ...
    @overload
    def get_item(self, key : Literal["SDS"]) -> Optional[RuleVariation_100]:
        ...
    @overload
    def get_item(self, key : Literal["EMS"]) -> Optional[RuleVariation_590]:
        ...
    @overload
    def get_item(self, key : Literal["PFT"]) -> Optional[RuleVariation_833]:
        ...
    @overload
    def get_item(self, key : Literal["FPLT"]) -> Optional[RuleVariation_895]:
        ...
    @overload
    def get_item(self, key : Literal["DUPT"]) -> Optional[RuleVariation_39]:
        ...
    @overload
    def get_item(self, key : Literal["DUPF"]) -> Optional[RuleVariation_410]:
        ...
    @overload
    def get_item(self, key : Literal["DUPM"]) -> Optional[RuleVariation_519]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1289(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1368.cv_arg
    cv_variation: TypeAlias = Variation_1368

    @classmethod
    def create(cls, arg : "RuleVariation_1289.cv_arg") -> "RuleVariation_1289":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1368:
        return self.arg # type: ignore

class NonSpare_239(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1289.cv_arg
    cv_name = "080"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1289

    @classmethod
    def create(cls, arg : "NonSpare_239.cv_arg") -> "NonSpare_239":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1289:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1368:
        return self.rule.variation

class UapItem_239(UapItem):
    cv_non_spare: TypeAlias = NonSpare_239

class Content_760(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_759(RuleContentContextFree):
    cv_arg: TypeAlias = Content_760.cv_arg
    cv_content: TypeAlias = Content_760

    @property
    def content(self) -> Content_760:
        return self._get_content() # type: ignore

class Variation_236(Element):
    cv_arg: TypeAlias = RuleContent_759.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_759

    @classmethod
    def create(cls, arg: "Variation_236.cv_arg") -> "Variation_236":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_759:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_760:
        return self.rule.content

class RuleVariation_229(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_236.cv_arg
    cv_variation: TypeAlias = Variation_236

    @classmethod
    def create(cls, arg : "RuleVariation_229.cv_arg") -> "RuleVariation_229":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_236:
        return self.arg # type: ignore

class NonSpare_1918(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "TRK"
    cv_title = "Track Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1918.cv_arg") -> "NonSpare_1918":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1476(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "PSR"
    cv_title = "PSR Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1476.cv_arg") -> "NonSpare_1476":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1762(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "SSR"
    cv_title = "SSR Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1762.cv_arg") -> "NonSpare_1762":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1261(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MDS"
    cv_title = "Mode S Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1261.cv_arg") -> "NonSpare_1261":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class Content_761(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_760(RuleContentContextFree):
    cv_arg: TypeAlias = Content_761.cv_arg
    cv_content: TypeAlias = Content_761

    @property
    def content(self) -> Content_761:
        return self._get_content() # type: ignore

class Variation_327(Element):
    cv_arg: TypeAlias = RuleContent_760.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_760

    @classmethod
    def create(cls, arg: "Variation_327.cv_arg") -> "Variation_327":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_760:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_761:
        return self.rule.content

class RuleVariation_320(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_327.cv_arg
    cv_variation: TypeAlias = Variation_327

    @classmethod
    def create(cls, arg : "RuleVariation_320.cv_arg") -> "RuleVariation_320":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_327:
        return self.arg # type: ignore

class NonSpare_576(NonSpare):
    cv_arg: TypeAlias = RuleVariation_320.cv_arg
    cv_name = "ADS"
    cv_title = "ADS-C Age"
    cv_rule: TypeAlias = RuleVariation_320

    @classmethod
    def create(cls, arg : "NonSpare_576.cv_arg") -> "NonSpare_576":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_320:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_327:
        return self.rule.variation

class NonSpare_962(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "ES"
    cv_title = "ADS-B Extended Squitter Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_962.cv_arg") -> "NonSpare_962":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_2029(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "VDL"
    cv_title = "ADS-B VDL Mode 4 Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_2029.cv_arg") -> "NonSpare_2029":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1978(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "UAT"
    cv_title = "ADS-B UAT Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1978.cv_arg") -> "NonSpare_1978":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1196(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "LOP"
    cv_title = "Loop Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1196.cv_arg") -> "NonSpare_1196":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1293(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MLT"
    cv_title = "Multilateration Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1293.cv_arg") -> "NonSpare_1293":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class Variation_1517(Compound):
    cv_arg = TypedDict('cv_arg', {
        "TRK": NonSpare_1918.cv_arg,
        "PSR": NonSpare_1476.cv_arg,
        "SSR": NonSpare_1762.cv_arg,
        "MDS": NonSpare_1261.cv_arg,
        "ADS": NonSpare_576.cv_arg,
        "ES": NonSpare_962.cv_arg,
        "VDL": NonSpare_2029.cv_arg,
        "UAT": NonSpare_1978.cv_arg,
        "LOP": NonSpare_1196.cv_arg,
        "MLT": NonSpare_1293.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_1918, NonSpare_1476, NonSpare_1762, NonSpare_1261, NonSpare_576, NonSpare_962, NonSpare_2029, NonSpare_1978, NonSpare_1196, NonSpare_1293]
    cv_items_dict = {"TRK": NonSpare_1918, "PSR": NonSpare_1476, "SSR": NonSpare_1762, "MDS": NonSpare_1261, "ADS": NonSpare_576, "ES": NonSpare_962, "VDL": NonSpare_2029, "UAT": NonSpare_1978, "LOP": NonSpare_1196, "MLT": NonSpare_1293}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRK"]) -> NonSpare_1918:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSR"]) -> NonSpare_1476:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSR"]) -> NonSpare_1762:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDS"]) -> NonSpare_1261:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADS"]) -> NonSpare_576:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ES"]) -> NonSpare_962:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VDL"]) -> NonSpare_2029:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["UAT"]) -> NonSpare_1978:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LOP"]) -> NonSpare_1196:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MLT"]) -> NonSpare_1293:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRK"], Literal["PSR"], Literal["SSR"], Literal["MDS"], Literal["ADS"], Literal["ES"], Literal["VDL"], Literal["UAT"], Literal["LOP"], Literal["MLT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRK"]) -> Optional[NonSpare_1918]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[NonSpare_1476]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[NonSpare_1762]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[NonSpare_1261]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[NonSpare_576]:
        ...
    @overload
    def get_item(self, key : Literal["ES"]) -> Optional[NonSpare_962]:
        ...
    @overload
    def get_item(self, key : Literal["VDL"]) -> Optional[NonSpare_2029]:
        ...
    @overload
    def get_item(self, key : Literal["UAT"]) -> Optional[NonSpare_1978]:
        ...
    @overload
    def get_item(self, key : Literal["LOP"]) -> Optional[NonSpare_1196]:
        ...
    @overload
    def get_item(self, key : Literal["MLT"]) -> Optional[NonSpare_1293]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TRK"], val : NonSpare_1918.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["PSR"], val : NonSpare_1476.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["SSR"], val : NonSpare_1762.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["MDS"], val : NonSpare_1261.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["ADS"], val : NonSpare_576.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["ES"], val : NonSpare_962.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["VDL"], val : NonSpare_2029.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["UAT"], val : NonSpare_1978.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["LOP"], val : NonSpare_1196.cv_arg) -> "Variation_1517":
        ...
    @overload
    def set_item(self, key : Literal["MLT"], val : NonSpare_1293.cv_arg) -> "Variation_1517":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TRK"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["PSR"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["SSR"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["MDS"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["ADS"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["ES"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["VDL"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["UAT"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["LOP"]) -> "Variation_1517":
        ...
    @overload
    def del_item(self, key : Literal["MLT"]) -> "Variation_1517":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1517.cv_arg") -> 'Variation_1517':
        return cls._create(arg) # type: ignore

class RuleVariation_1438(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1517.cv_arg
    cv_variation: TypeAlias = Variation_1517

    @classmethod
    def create(cls, arg : "RuleVariation_1438.cv_arg") -> "RuleVariation_1438":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1517:
        return self.arg # type: ignore

class NonSpare_470(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1438.cv_arg
    cv_name = "290"
    cv_title = "System Track Update Ages"
    cv_rule: TypeAlias = RuleVariation_1438

    @classmethod
    def create(cls, arg : "NonSpare_470.cv_arg") -> "NonSpare_470":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1438:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1517:
        return self.rule.variation

class UapItem_470(UapItem):
    cv_non_spare: TypeAlias = NonSpare_470

class Content_67(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Constant course", 1: "Right turn", 2: "Left turn", 3: "Undetermined"}

class RuleContent_67(RuleContentContextFree):
    cv_arg: TypeAlias = Content_67.cv_arg
    cv_content: TypeAlias = Content_67

    @property
    def content(self) -> Content_67:
        return self._get_content() # type: ignore

class Variation_101(Element):
    cv_arg: TypeAlias = RuleContent_67.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_67

    @classmethod
    def create(cls, arg: "Variation_101.cv_arg") -> "Variation_101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_67:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_67:
        return self.rule.content

class RuleVariation_101(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_101.cv_arg
    cv_variation: TypeAlias = Variation_101

    @classmethod
    def create(cls, arg : "RuleVariation_101.cv_arg") -> "RuleVariation_101":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_101:
        return self.arg # type: ignore

class NonSpare_1907(NonSpare):
    cv_arg: TypeAlias = RuleVariation_101.cv_arg
    cv_name = "TRANS"
    cv_title = "Transversal Acceleration"
    cv_rule: TypeAlias = RuleVariation_101

    @classmethod
    def create(cls, arg : "NonSpare_1907.cv_arg") -> "NonSpare_1907":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_101:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_101:
        return self.rule.variation

class Item_1030(Item):
    cv_arg: TypeAlias = NonSpare_1907.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1907

    @classmethod
    def create(cls, arg : "Item_1030.cv_arg") -> "Item_1030":
        return cls._create(arg) # type: ignore

class Content_68(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Constant groundspeed", 1: "Increasing groundspeed", 2: "Decreasing groundspeed", 3: "Undetermined"}

class RuleContent_68(RuleContentContextFree):
    cv_arg: TypeAlias = Content_68.cv_arg
    cv_content: TypeAlias = Content_68

    @property
    def content(self) -> Content_68:
        return self._get_content() # type: ignore

class Variation_590(Element):
    cv_arg: TypeAlias = RuleContent_68.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 2
    cv_rule = RuleContent_68

    @classmethod
    def create(cls, arg: "Variation_590.cv_arg") -> "Variation_590":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_68:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_68:
        return self.rule.content

class RuleVariation_579(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_590.cv_arg
    cv_variation: TypeAlias = Variation_590

    @classmethod
    def create(cls, arg : "RuleVariation_579.cv_arg") -> "RuleVariation_579":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_590:
        return self.arg # type: ignore

class NonSpare_1192(NonSpare):
    cv_arg: TypeAlias = RuleVariation_579.cv_arg
    cv_name = "LONG"
    cv_title = "Longitudinal Acceleration"
    cv_rule: TypeAlias = RuleVariation_579

    @classmethod
    def create(cls, arg : "NonSpare_1192.cv_arg") -> "NonSpare_1192":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_579:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_590:
        return self.rule.variation

class Item_502(Item):
    cv_arg: TypeAlias = NonSpare_1192.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1192

    @classmethod
    def create(cls, arg : "Item_502.cv_arg") -> "Item_502":
        return cls._create(arg) # type: ignore

class Content_256(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Level", 1: "Climb", 2: "Descent", 3: "Undetermined"}

class RuleContent_256(RuleContentContextFree):
    cv_arg: TypeAlias = Content_256.cv_arg
    cv_content: TypeAlias = Content_256

    @property
    def content(self) -> Content_256:
        return self._get_content() # type: ignore

class Variation_765(Element):
    cv_arg: TypeAlias = RuleContent_256.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_256

    @classmethod
    def create(cls, arg: "Variation_765.cv_arg") -> "Variation_765":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_256:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_256:
        return self.rule.content

class RuleVariation_754(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_765.cv_arg
    cv_variation: TypeAlias = Variation_765

    @classmethod
    def create(cls, arg : "RuleVariation_754.cv_arg") -> "RuleVariation_754":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_765:
        return self.arg # type: ignore

class NonSpare_2033(NonSpare):
    cv_arg: TypeAlias = RuleVariation_754.cv_arg
    cv_name = "VERT"
    cv_title = "Vertical Rate"
    cv_rule: TypeAlias = RuleVariation_754

    @classmethod
    def create(cls, arg : "NonSpare_2033.cv_arg") -> "NonSpare_2033":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_754:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_765:
        return self.rule.variation

class Item_1142(Item):
    cv_arg: TypeAlias = NonSpare_2033.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2033

    @classmethod
    def create(cls, arg : "Item_1142.cv_arg") -> "Item_1142":
        return cls._create(arg) # type: ignore

class Content_325(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No altitude discrepancy", 1: "Altitude discrepancy"}

class RuleContent_325(RuleContentContextFree):
    cv_arg: TypeAlias = Content_325.cv_arg
    cv_content: TypeAlias = Content_325

    @property
    def content(self) -> Content_325:
        return self._get_content() # type: ignore

class Variation_941(Element):
    cv_arg: TypeAlias = RuleContent_325.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_325

    @classmethod
    def create(cls, arg: "Variation_941.cv_arg") -> "Variation_941":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_325:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_325:
        return self.rule.content

class RuleVariation_911(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_941.cv_arg
    cv_variation: TypeAlias = Variation_941

    @classmethod
    def create(cls, arg : "RuleVariation_911.cv_arg") -> "RuleVariation_911":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_941:
        return self.arg # type: ignore

class NonSpare_570(NonSpare):
    cv_arg: TypeAlias = RuleVariation_911.cv_arg
    cv_name = "ADF"
    cv_title = "Altitude Discrepancy Flag"
    cv_rule: TypeAlias = RuleVariation_911

    @classmethod
    def create(cls, arg : "NonSpare_570.cv_arg") -> "NonSpare_570":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_911:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_941:
        return self.rule.variation

class Item_44(Item):
    cv_arg: TypeAlias = NonSpare_570.cv_arg
    cv_non_spare: TypeAlias = NonSpare_570

    @classmethod
    def create(cls, arg : "Item_44.cv_arg") -> "Item_44":
        return cls._create(arg) # type: ignore

class Variation_1229(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_101.cv_arg, Tuple[Literal["TRANS"], RuleVariation_101.cv_arg]], Union[RuleVariation_579.cv_arg, Tuple[Literal["LONG"], RuleVariation_579.cv_arg]], Union[RuleVariation_754.cv_arg, Tuple[Literal["VERT"], RuleVariation_754.cv_arg]], Union[RuleVariation_911.cv_arg, Tuple[Literal["ADF"], RuleVariation_911.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1229.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1030, 2), (Item_502, 2), (Item_1142, 2), (Item_44, 1), (Item_29, 1)]
    cv_items_dict = {"TRANS": RuleVariation_101, "LONG": RuleVariation_579, "VERT": RuleVariation_754, "ADF": RuleVariation_911}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRANS"]) -> RuleVariation_101:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LONG"]) -> RuleVariation_579:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VERT"]) -> RuleVariation_754:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ADF"]) -> RuleVariation_911:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRANS"], Literal["LONG"], Literal["VERT"], Literal["ADF"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRANS"]) -> RuleVariation_101:
        ...
    @overload
    def get_item(self, key : Literal["LONG"]) -> RuleVariation_579:
        ...
    @overload
    def get_item(self, key : Literal["VERT"]) -> RuleVariation_754:
        ...
    @overload
    def get_item(self, key : Literal["ADF"]) -> RuleVariation_911:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1229.cv_arg") -> 'Variation_1229':
        return cls._create(arg) # type: ignore

class RuleVariation_1167(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1229.cv_arg
    cv_variation: TypeAlias = Variation_1229

    @classmethod
    def create(cls, arg : "RuleVariation_1167.cv_arg") -> "RuleVariation_1167":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1229:
        return self.arg # type: ignore

class NonSpare_394(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1167.cv_arg
    cv_name = "200"
    cv_title = "Mode of Movement"
    cv_rule: TypeAlias = RuleVariation_1167

    @classmethod
    def create(cls, arg : "NonSpare_394.cv_arg") -> "NonSpare_394":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1167:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1229:
        return self.rule.variation

class UapItem_394(UapItem):
    cv_non_spare: TypeAlias = NonSpare_394

class NonSpare_1276(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MFL"
    cv_title = "Measured Flight Level Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1276.cv_arg") -> "NonSpare_1276":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1242(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MD1"
    cv_title = "Mode 1 Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1242.cv_arg") -> "NonSpare_1242":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1245(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MD2"
    cv_title = "Mode 2 Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1245.cv_arg") -> "NonSpare_1245":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1254(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MDA"
    cv_title = "Mode 3/A Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1254.cv_arg") -> "NonSpare_1254":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1247(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MD4"
    cv_title = "Mode 4 Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1247.cv_arg") -> "NonSpare_1247":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1249(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MD5"
    cv_title = "Mode 5 Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1249.cv_arg") -> "NonSpare_1249":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1281(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MHG"
    cv_title = "Magnetic Heading Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1281.cv_arg") -> "NonSpare_1281":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1103(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "IAS"
    cv_title = "Indicated Airspeed / Mach Nb Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1103.cv_arg") -> "NonSpare_1103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1832(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "TAS"
    cv_title = "True Airspeed Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1832.cv_arg") -> "NonSpare_1832":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1660(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "SAL"
    cv_title = "Selected Altitude Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1660.cv_arg") -> "NonSpare_1660":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1003(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "FSS"
    cv_title = "Final State Selected Altitude Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1003.cv_arg") -> "NonSpare_1003":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1865(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "TID"
    cv_title = "Trajectory Intent Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1865.cv_arg") -> "NonSpare_1865":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_783(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "COM"
    cv_title = "Communication/ACAS Capability and Flight Status Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_783.cv_arg") -> "NonSpare_783":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1653(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "SAB"
    cv_title = "Status Reported by ADS-B Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1653.cv_arg") -> "NonSpare_1653":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_565(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "ACS"
    cv_title = "ACAS Resolution Advisory Report Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_565.cv_arg") -> "NonSpare_565":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_699(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "BVR"
    cv_title = "Barometric Vertical Rate Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_699.cv_arg") -> "NonSpare_699":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1052(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "GVR"
    cv_title = "Geometrical Vertical Rate Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1052.cv_arg") -> "NonSpare_1052":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1549(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "RAN"
    cv_title = "Roll Angle Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1549.cv_arg") -> "NonSpare_1549":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1828(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "TAR"
    cv_title = "Track Angle Rate Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1828.cv_arg") -> "NonSpare_1828":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1822(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "TAN"
    cv_title = "Track Angle Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1822.cv_arg") -> "NonSpare_1822":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1043(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "GSP"
    cv_title = "Ground Speed Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1043.cv_arg") -> "NonSpare_1043":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_2046(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "VUN"
    cv_title = "Velocity Uncertainty Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_2046.cv_arg") -> "NonSpare_2046":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1273(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MET"
    cv_title = "Meteorological Data Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1273.cv_arg") -> "NonSpare_1273":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_930(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "EMC"
    cv_title = "Emitter Category Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_930.cv_arg") -> "NonSpare_930":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1450(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "POS"
    cv_title = "Position Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1450.cv_arg") -> "NonSpare_1450":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1020(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "GAL"
    cv_title = "Geometric Altitude Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1020.cv_arg") -> "NonSpare_1020":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1486(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "PUN"
    cv_title = "Position Uncertainty Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1486.cv_arg") -> "NonSpare_1486":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1233(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MB"
    cv_title = "Mode S MB Data Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1233.cv_arg") -> "NonSpare_1233":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1101(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "IAR"
    cv_title = "Indicated Airspeed Data Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1101.cv_arg") -> "NonSpare_1101":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_1223(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "MAC"
    cv_title = "Mach Number Data Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_1223.cv_arg") -> "NonSpare_1223":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class NonSpare_695(NonSpare):
    cv_arg: TypeAlias = RuleVariation_229.cv_arg
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting Data Age"
    cv_rule: TypeAlias = RuleVariation_229

    @classmethod
    def create(cls, arg : "NonSpare_695.cv_arg") -> "NonSpare_695":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_236:
        return self.rule.variation

class Variation_1496(Compound):
    cv_arg = TypedDict('cv_arg', {
        "MFL": NonSpare_1276.cv_arg,
        "MD1": NonSpare_1242.cv_arg,
        "MD2": NonSpare_1245.cv_arg,
        "MDA": NonSpare_1254.cv_arg,
        "MD4": NonSpare_1247.cv_arg,
        "MD5": NonSpare_1249.cv_arg,
        "MHG": NonSpare_1281.cv_arg,
        "IAS": NonSpare_1103.cv_arg,
        "TAS": NonSpare_1832.cv_arg,
        "SAL": NonSpare_1660.cv_arg,
        "FSS": NonSpare_1003.cv_arg,
        "TID": NonSpare_1865.cv_arg,
        "COM": NonSpare_783.cv_arg,
        "SAB": NonSpare_1653.cv_arg,
        "ACS": NonSpare_565.cv_arg,
        "BVR": NonSpare_699.cv_arg,
        "GVR": NonSpare_1052.cv_arg,
        "RAN": NonSpare_1549.cv_arg,
        "TAR": NonSpare_1828.cv_arg,
        "TAN": NonSpare_1822.cv_arg,
        "GSP": NonSpare_1043.cv_arg,
        "VUN": NonSpare_2046.cv_arg,
        "MET": NonSpare_1273.cv_arg,
        "EMC": NonSpare_930.cv_arg,
        "POS": NonSpare_1450.cv_arg,
        "GAL": NonSpare_1020.cv_arg,
        "PUN": NonSpare_1486.cv_arg,
        "MB": NonSpare_1233.cv_arg,
        "IAR": NonSpare_1101.cv_arg,
        "MAC": NonSpare_1223.cv_arg,
        "BPS": NonSpare_695.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [NonSpare_1276, NonSpare_1242, NonSpare_1245, NonSpare_1254, NonSpare_1247, NonSpare_1249, NonSpare_1281, NonSpare_1103, NonSpare_1832, NonSpare_1660, NonSpare_1003, NonSpare_1865, NonSpare_783, NonSpare_1653, NonSpare_565, NonSpare_699, NonSpare_1052, NonSpare_1549, NonSpare_1828, NonSpare_1822, NonSpare_1043, NonSpare_2046, NonSpare_1273, NonSpare_930, NonSpare_1450, NonSpare_1020, NonSpare_1486, NonSpare_1233, NonSpare_1101, NonSpare_1223, NonSpare_695]
    cv_items_dict = {"MFL": NonSpare_1276, "MD1": NonSpare_1242, "MD2": NonSpare_1245, "MDA": NonSpare_1254, "MD4": NonSpare_1247, "MD5": NonSpare_1249, "MHG": NonSpare_1281, "IAS": NonSpare_1103, "TAS": NonSpare_1832, "SAL": NonSpare_1660, "FSS": NonSpare_1003, "TID": NonSpare_1865, "COM": NonSpare_783, "SAB": NonSpare_1653, "ACS": NonSpare_565, "BVR": NonSpare_699, "GVR": NonSpare_1052, "RAN": NonSpare_1549, "TAR": NonSpare_1828, "TAN": NonSpare_1822, "GSP": NonSpare_1043, "VUN": NonSpare_2046, "MET": NonSpare_1273, "EMC": NonSpare_930, "POS": NonSpare_1450, "GAL": NonSpare_1020, "PUN": NonSpare_1486, "MB": NonSpare_1233, "IAR": NonSpare_1101, "MAC": NonSpare_1223, "BPS": NonSpare_695}

    @overload
    @classmethod
    def spec(cls, key : Literal["MFL"]) -> NonSpare_1276:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD1"]) -> NonSpare_1242:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD2"]) -> NonSpare_1245:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1254:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD4"]) -> NonSpare_1247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MD5"]) -> NonSpare_1249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1281:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1103:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1832:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1660:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_1003:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1865:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_783:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1653:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_565:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_699:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1052:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1549:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1828:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1822:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GSP"]) -> NonSpare_1043:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2046:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1273:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_930:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1450:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1020:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1486:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1233:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1101:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1223:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_695:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["MFL"], Literal["MD1"], Literal["MD2"], Literal["MDA"], Literal["MD4"], Literal["MD5"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GSP"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["MFL"]) -> Optional[NonSpare_1276]:
        ...
    @overload
    def get_item(self, key : Literal["MD1"]) -> Optional[NonSpare_1242]:
        ...
    @overload
    def get_item(self, key : Literal["MD2"]) -> Optional[NonSpare_1245]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1254]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[NonSpare_1247]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[NonSpare_1249]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1281]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1103]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1832]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1660]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_1003]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1865]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_783]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1653]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_565]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_699]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1052]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1549]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1828]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1822]:
        ...
    @overload
    def get_item(self, key : Literal["GSP"]) -> Optional[NonSpare_1043]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2046]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1273]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_930]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1450]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1020]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1486]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1233]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1101]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1223]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_695]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["MFL"], val : NonSpare_1276.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MD1"], val : NonSpare_1242.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MD2"], val : NonSpare_1245.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1254.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MD4"], val : NonSpare_1247.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MD5"], val : NonSpare_1249.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1281.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1103.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1832.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1660.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_1003.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1865.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_783.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1653.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_565.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_699.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1052.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1549.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1828.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1822.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["GSP"], val : NonSpare_1043.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2046.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1273.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_930.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1450.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1020.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1486.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1233.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1101.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1223.cv_arg) -> "Variation_1496":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_695.cv_arg) -> "Variation_1496":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["MFL"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MD1"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MD2"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MD4"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MD5"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["GSP"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1496":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1496":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1496.cv_arg") -> 'Variation_1496':
        return cls._create(arg) # type: ignore

class RuleVariation_1417(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1496.cv_arg
    cv_variation: TypeAlias = Variation_1496

    @classmethod
    def create(cls, arg : "RuleVariation_1417.cv_arg") -> "RuleVariation_1417":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1496:
        return self.arg # type: ignore

class NonSpare_473(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1417.cv_arg
    cv_name = "295"
    cv_title = "Track Data Ages"
    cv_rule: TypeAlias = RuleVariation_1417

    @classmethod
    def create(cls, arg : "NonSpare_473.cv_arg") -> "NonSpare_473":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1417:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1496:
        return self.rule.variation

class UapItem_473(UapItem):
    cv_non_spare: TypeAlias = NonSpare_473

class Variation_273(Element):
    cv_arg: TypeAlias = RuleContent_655.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_655

    @classmethod
    def create(cls, arg: "Variation_273.cv_arg") -> "Variation_273":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_655:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_655:
        return self.rule.content

class RuleVariation_266(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_273.cv_arg
    cv_variation: TypeAlias = Variation_273

    @classmethod
    def create(cls, arg : "RuleVariation_266.cv_arg") -> "RuleVariation_266":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_273:
        return self.arg # type: ignore

class NonSpare_320(NonSpare):
    cv_arg: TypeAlias = RuleVariation_266.cv_arg
    cv_name = "136"
    cv_title = "Measured Flight Level"
    cv_rule: TypeAlias = RuleVariation_266

    @classmethod
    def create(cls, arg : "NonSpare_320.cv_arg") -> "NonSpare_320":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_266:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_273:
        return self.rule.variation

class UapItem_320(UapItem):
    cv_non_spare: TypeAlias = NonSpare_320

class NonSpare_306(NonSpare):
    cv_arg: TypeAlias = RuleVariation_285.cv_arg
    cv_name = "130"
    cv_title = "Calculated Track Geometric Altitude"
    cv_rule: TypeAlias = RuleVariation_285

    @classmethod
    def create(cls, arg : "NonSpare_306.cv_arg") -> "NonSpare_306":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_285:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_292:
        return self.rule.variation

class UapItem_306(UapItem):
    cv_non_spare: TypeAlias = NonSpare_306

class NonSpare_1528(NonSpare):
    cv_arg: TypeAlias = RuleVariation_59.cv_arg
    cv_name = "QNH"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_59

    @classmethod
    def create(cls, arg : "NonSpare_1528.cv_arg") -> "NonSpare_1528":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_59:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_59:
        return self.rule.variation

class Item_760(Item):
    cv_arg: TypeAlias = NonSpare_1528.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1528

    @classmethod
    def create(cls, arg : "Item_760.cv_arg") -> "Item_760":
        return cls._create(arg) # type: ignore

class NonSpare_847(NonSpare):
    cv_arg: TypeAlias = RuleVariation_489.cv_arg
    cv_name = "CTB"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_489

    @classmethod
    def create(cls, arg : "NonSpare_847.cv_arg") -> "NonSpare_847":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_489:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_500:
        return self.rule.variation

class Item_229(Item):
    cv_arg: TypeAlias = NonSpare_847.cv_arg
    cv_non_spare: TypeAlias = NonSpare_847

    @classmethod
    def create(cls, arg : "Item_229.cv_arg") -> "Item_229":
        return cls._create(arg) # type: ignore

class Variation_1166(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_59.cv_arg, Tuple[Literal["QNH"], RuleVariation_59.cv_arg]], Union[RuleVariation_489.cv_arg, Tuple[Literal["CTB"], RuleVariation_489.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1166.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_760, 1), (Item_229, 15)]
    cv_items_dict = {"QNH": RuleVariation_59, "CTB": RuleVariation_489}

    @overload
    @classmethod
    def spec(cls, key : Literal["QNH"]) -> RuleVariation_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTB"]) -> RuleVariation_489:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["QNH"], Literal["CTB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["QNH"]) -> RuleVariation_59:
        ...
    @overload
    def get_item(self, key : Literal["CTB"]) -> RuleVariation_489:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1166.cv_arg") -> 'Variation_1166':
        return cls._create(arg) # type: ignore

class RuleVariation_1117(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1166.cv_arg
    cv_variation: TypeAlias = Variation_1166

    @classmethod
    def create(cls, arg : "RuleVariation_1117.cv_arg") -> "RuleVariation_1117":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1166:
        return self.arg # type: ignore

class NonSpare_319(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1117.cv_arg
    cv_name = "135"
    cv_title = "Calculated Track Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_1117

    @classmethod
    def create(cls, arg : "NonSpare_319.cv_arg") -> "NonSpare_319":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1117:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1166:
        return self.rule.variation

class UapItem_319(UapItem):
    cv_non_spare: TypeAlias = NonSpare_319

class NonSpare_422(NonSpare):
    cv_arg: TypeAlias = RuleVariation_286.cv_arg
    cv_name = "220"
    cv_title = "Calculated Rate of Climb/Descent"
    cv_rule: TypeAlias = RuleVariation_286

    @classmethod
    def create(cls, arg : "NonSpare_422.cv_arg") -> "NonSpare_422":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_286:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_293:
        return self.rule.variation

class UapItem_422(UapItem):
    cv_non_spare: TypeAlias = NonSpare_422

class NonSpare_1820(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "TAG"
    cv_title = "FPPS Identification Tag"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_1820.cv_arg") -> "NonSpare_1820":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class NonSpare_832(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "CS"
    cv_title = "Callsign"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_832.cv_arg") -> "NonSpare_832":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1354(NonSpare):
    cv_arg: TypeAlias = RuleVariation_867.cv_arg
    cv_name = "NBR"
    cv_title = "Number from 0 to 99 999 999"
    cv_rule: TypeAlias = RuleVariation_867

    @classmethod
    def create(cls, arg : "NonSpare_1354.cv_arg") -> "NonSpare_1354":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_867:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_897:
        return self.rule.variation

class Item_614(Item):
    cv_arg: TypeAlias = NonSpare_1354.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1354

    @classmethod
    def create(cls, arg : "Item_614.cv_arg") -> "Item_614":
        return cls._create(arg) # type: ignore

class Variation_1234(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_111.cv_arg, Tuple[Literal["TYP"], RuleVariation_111.cv_arg]], int, Union[RuleVariation_867.cv_arg, Tuple[Literal["NBR"], RuleVariation_867.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1234.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1072, 2), (Item_13, 3), (Item_614, 27)]
    cv_items_dict = {"TYP": RuleVariation_111, "NBR": RuleVariation_867}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBR"]) -> RuleVariation_867:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["NBR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_111:
        ...
    @overload
    def get_item(self, key : Literal["NBR"]) -> RuleVariation_867:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1234.cv_arg") -> 'Variation_1234':
        return cls._create(arg) # type: ignore

class RuleVariation_1172(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1234.cv_arg
    cv_variation: TypeAlias = Variation_1234

    @classmethod
    def create(cls, arg : "RuleVariation_1172.cv_arg") -> "RuleVariation_1172":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1234:
        return self.arg # type: ignore

class NonSpare_1118(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1172.cv_arg
    cv_name = "IFI"
    cv_title = "IFPS_FLIGHT_ID"
    cv_rule: TypeAlias = RuleVariation_1172

    @classmethod
    def create(cls, arg : "NonSpare_1118.cv_arg") -> "NonSpare_1118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1172:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1234:
        return self.rule.variation

class NonSpare_992(NonSpare):
    cv_arg: TypeAlias = RuleVariation_580.cv_arg
    cv_name = "FR1FR2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_580

    @classmethod
    def create(cls, arg : "NonSpare_992.cv_arg") -> "NonSpare_992":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_580:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_591:
        return self.rule.variation

class Item_341(Item):
    cv_arg: TypeAlias = NonSpare_992.cv_arg
    cv_non_spare: TypeAlias = NonSpare_992

    @classmethod
    def create(cls, arg : "Item_341.cv_arg") -> "Item_341":
        return cls._create(arg) # type: ignore

class Variation_1109(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_116.cv_arg, Tuple[Literal["GATOAT"], RuleVariation_116.cv_arg]], Union[RuleVariation_580.cv_arg, Tuple[Literal["FR1FR2"], RuleVariation_580.cv_arg]], Union[RuleVariation_758.cv_arg, Tuple[Literal["RVSM"], RuleVariation_758.cv_arg]], Union[RuleVariation_912.cv_arg, Tuple[Literal["HPR"], RuleVariation_912.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1109.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_362, 2), (Item_341, 2), (Item_843, 2), (Item_401, 1), (Item_29, 1)]
    cv_items_dict = {"GATOAT": RuleVariation_116, "FR1FR2": RuleVariation_580, "RVSM": RuleVariation_758, "HPR": RuleVariation_912}

    @overload
    @classmethod
    def spec(cls, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FR1FR2"]) -> RuleVariation_580:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GATOAT"], Literal["FR1FR2"], Literal["RVSM"], Literal["HPR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GATOAT"]) -> RuleVariation_116:
        ...
    @overload
    def get_item(self, key : Literal["FR1FR2"]) -> RuleVariation_580:
        ...
    @overload
    def get_item(self, key : Literal["RVSM"]) -> RuleVariation_758:
        ...
    @overload
    def get_item(self, key : Literal["HPR"]) -> RuleVariation_912:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1109.cv_arg") -> 'Variation_1109':
        return cls._create(arg) # type: ignore

class RuleVariation_1067(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1109.cv_arg
    cv_variation: TypeAlias = Variation_1109

    @classmethod
    def create(cls, arg : "RuleVariation_1067.cv_arg") -> "RuleVariation_1067":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1109:
        return self.arg # type: ignore

class NonSpare_970(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1067.cv_arg
    cv_name = "FCT"
    cv_title = "Flight Category"
    cv_rule: TypeAlias = RuleVariation_1067

    @classmethod
    def create(cls, arg : "NonSpare_970.cv_arg") -> "NonSpare_970":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1067:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1109:
        return self.rule.variation

class NonSpare_1819(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "TAC"
    cv_title = "Type of Aircraft"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_1819.cv_arg") -> "NonSpare_1819":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class NonSpare_2070(NonSpare):
    cv_arg: TypeAlias = RuleVariation_196.cv_arg
    cv_name = "WTC"
    cv_title = "Wake Turbulence Category"
    cv_rule: TypeAlias = RuleVariation_196

    @classmethod
    def create(cls, arg : "NonSpare_2070.cv_arg") -> "NonSpare_2070":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

class NonSpare_879(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "DEP"
    cv_title = "Departure Airport"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_879.cv_arg") -> "NonSpare_879":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class NonSpare_904(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "DST"
    cv_title = "Destination Airport"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_904.cv_arg") -> "NonSpare_904":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class NonSpare_849(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1031.cv_arg
    cv_name = "CTL"
    cv_title = "Current Control Position"
    cv_rule: TypeAlias = RuleVariation_1031

    @classmethod
    def create(cls, arg : "NonSpare_849.cv_arg") -> "NonSpare_849":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1031:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1069:
        return self.rule.variation

class NonSpare_1962(NonSpare):
    cv_arg: TypeAlias = RuleVariation_145.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_145

    @classmethod
    def create(cls, arg : "NonSpare_1962.cv_arg") -> "NonSpare_1962":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_145:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_145:
        return self.rule.variation

class Item_1076(Item):
    cv_arg: TypeAlias = NonSpare_1962.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1962

    @classmethod
    def create(cls, arg : "Item_1076.cv_arg") -> "Item_1076":
        return cls._create(arg) # type: ignore

class NonSpare_1074(NonSpare):
    cv_arg: TypeAlias = RuleVariation_685.cv_arg
    cv_name = "HOR"
    cv_title = "Hours"
    cv_rule: TypeAlias = RuleVariation_685

    @classmethod
    def create(cls, arg : "NonSpare_1074.cv_arg") -> "NonSpare_1074":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_685:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_696:
        return self.rule.variation

class Item_399(Item):
    cv_arg: TypeAlias = NonSpare_1074.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1074

    @classmethod
    def create(cls, arg : "Item_399.cv_arg") -> "Item_399":
        return cls._create(arg) # type: ignore

class NonSpare_1288(NonSpare):
    cv_arg: TypeAlias = RuleVariation_592.cv_arg
    cv_name = "MIN"
    cv_title = "Minutes"
    cv_rule: TypeAlias = RuleVariation_592

    @classmethod
    def create(cls, arg : "NonSpare_1288.cv_arg") -> "NonSpare_1288":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

class Item_555(Item):
    cv_arg: TypeAlias = NonSpare_1288.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1288

    @classmethod
    def create(cls, arg : "Item_555.cv_arg") -> "Item_555":
        return cls._create(arg) # type: ignore

class NonSpare_653(NonSpare):
    cv_arg: TypeAlias = RuleVariation_75.cv_arg
    cv_name = "AVS"
    cv_title = "Seconds Available Flag"
    cv_rule: TypeAlias = RuleVariation_75

    @classmethod
    def create(cls, arg : "NonSpare_653.cv_arg") -> "NonSpare_653":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_75:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_75:
        return self.rule.variation

class Item_97(Item):
    cv_arg: TypeAlias = NonSpare_653.cv_arg
    cv_non_spare: TypeAlias = NonSpare_653

    @classmethod
    def create(cls, arg : "Item_97.cv_arg") -> "Item_97":
        return cls._create(arg) # type: ignore

class NonSpare_1700(NonSpare):
    cv_arg: TypeAlias = RuleVariation_592.cv_arg
    cv_name = "SEC"
    cv_title = "Seconds"
    cv_rule: TypeAlias = RuleVariation_592

    @classmethod
    def create(cls, arg : "NonSpare_1700.cv_arg") -> "NonSpare_1700":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_592:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_603:
        return self.rule.variation

class Item_879(Item):
    cv_arg: TypeAlias = NonSpare_1700.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1700

    @classmethod
    def create(cls, arg : "Item_879.cv_arg") -> "Item_879":
        return cls._create(arg) # type: ignore

class Variation_1236(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_145.cv_arg, Tuple[Literal["TYP"], RuleVariation_145.cv_arg]], Union[RuleVariation_855.cv_arg, Tuple[Literal["DAY"], RuleVariation_855.cv_arg]], int, Union[RuleVariation_685.cv_arg, Tuple[Literal["HOR"], RuleVariation_685.cv_arg]], int, Union[RuleVariation_592.cv_arg, Tuple[Literal["MIN"], RuleVariation_592.cv_arg]], Union[RuleVariation_75.cv_arg, Tuple[Literal["AVS"], RuleVariation_75.cv_arg]], int, Union[RuleVariation_592.cv_arg, Tuple[Literal["SEC"], RuleVariation_592.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1236.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1076, 5), (Item_241, 2), (Item_30, 4), (Item_399, 5), (Item_1, 2), (Item_555, 6), (Item_97, 1), (Item_7, 1), (Item_879, 6)]
    cv_items_dict = {"TYP": RuleVariation_145, "DAY": RuleVariation_855, "HOR": RuleVariation_685, "MIN": RuleVariation_592, "AVS": RuleVariation_75, "SEC": RuleVariation_592}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_145:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DAY"]) -> RuleVariation_855:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HOR"]) -> RuleVariation_685:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIN"]) -> RuleVariation_592:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AVS"]) -> RuleVariation_75:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SEC"]) -> RuleVariation_592:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["DAY"], Literal["HOR"], Literal["MIN"], Literal["AVS"], Literal["SEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_145:
        ...
    @overload
    def get_item(self, key : Literal["DAY"]) -> RuleVariation_855:
        ...
    @overload
    def get_item(self, key : Literal["HOR"]) -> RuleVariation_685:
        ...
    @overload
    def get_item(self, key : Literal["MIN"]) -> RuleVariation_592:
        ...
    @overload
    def get_item(self, key : Literal["AVS"]) -> RuleVariation_75:
        ...
    @overload
    def get_item(self, key : Literal["SEC"]) -> RuleVariation_592:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1236.cv_arg") -> 'Variation_1236':
        return cls._create(arg) # type: ignore

class Variation_1441(Repetitive):
    cv_arg: TypeAlias = List[Variation_1236.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1236

    @classmethod
    def create(cls, arg: "Variation_1441.cv_arg") -> 'Variation_1441':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1236]:
        return self._get_list() # type: ignore

class RuleVariation_1362(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1441.cv_arg
    cv_variation: TypeAlias = Variation_1441

    @classmethod
    def create(cls, arg : "RuleVariation_1362.cv_arg") -> "RuleVariation_1362":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1441:
        return self.arg # type: ignore

class NonSpare_1883(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1362.cv_arg
    cv_name = "TOD"
    cv_title = "Time of Departure / Arrival"
    cv_rule: TypeAlias = RuleVariation_1362

    @classmethod
    def create(cls, arg : "NonSpare_1883.cv_arg") -> "NonSpare_1883":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1362:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1441:
        return self.rule.variation

class NonSpare_1788(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "STD"
    cv_title = "Standard Instrument Departure"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1788.cv_arg") -> "NonSpare_1788":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class NonSpare_1771(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "STA"
    cv_title = "Standard Instrument Arrival"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1771.cv_arg") -> "NonSpare_1771":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class Content_376(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No valid Mode 3/A available", 1: "Valid Mode 3/A available"}

class RuleContent_376(RuleContentContextFree):
    cv_arg: TypeAlias = Content_376.cv_arg
    cv_content: TypeAlias = Content_376

    @property
    def content(self) -> Content_376:
        return self._get_content() # type: ignore

class Variation_655(Element):
    cv_arg: TypeAlias = RuleContent_376.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_376

    @classmethod
    def create(cls, arg: "Variation_655.cv_arg") -> "Variation_655":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_376:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_376:
        return self.rule.content

class RuleVariation_644(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_655.cv_arg
    cv_variation: TypeAlias = Variation_655

    @classmethod
    def create(cls, arg : "RuleVariation_644.cv_arg") -> "RuleVariation_644":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_655:
        return self.arg # type: ignore

class NonSpare_1993(NonSpare):
    cv_arg: TypeAlias = RuleVariation_644.cv_arg
    cv_name = "VA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_644

    @classmethod
    def create(cls, arg : "NonSpare_1993.cv_arg") -> "NonSpare_1993":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_644:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_655:
        return self.rule.variation

class Item_1104(Item):
    cv_arg: TypeAlias = NonSpare_1993.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1993

    @classmethod
    def create(cls, arg : "Item_1104.cv_arg") -> "Item_1104":
        return cls._create(arg) # type: ignore

class Variation_1017(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_644.cv_arg, Tuple[Literal["VA"], RuleVariation_644.cv_arg]], Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1017.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_2, 3), (Item_1104, 1), (Item_575, 12)]
    cv_items_dict = {"VA": RuleVariation_644, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["VA"]) -> RuleVariation_644:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["VA"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["VA"]) -> RuleVariation_644:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1017.cv_arg") -> 'Variation_1017':
        return cls._create(arg) # type: ignore

class RuleVariation_987(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1017.cv_arg
    cv_variation: TypeAlias = Variation_1017

    @classmethod
    def create(cls, arg : "RuleVariation_987.cv_arg") -> "RuleVariation_987":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1017:
        return self.arg # type: ignore

class NonSpare_1426(NonSpare):
    cv_arg: TypeAlias = RuleVariation_987.cv_arg
    cv_name = "PEM"
    cv_title = "Pre-Emergency Mode 3/A"
    cv_rule: TypeAlias = RuleVariation_987

    @classmethod
    def create(cls, arg : "NonSpare_1426.cv_arg") -> "NonSpare_1426":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_987:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1017:
        return self.rule.variation

class NonSpare_1425(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "PEC"
    cv_title = "Pre-Emergency Callsign"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_1425.cv_arg") -> "NonSpare_1425":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class Variation_1513(Compound):
    cv_arg = TypedDict('cv_arg', {
        "TAG": NonSpare_1820.cv_arg,
        "CS": NonSpare_832.cv_arg,
        "IFI": NonSpare_1118.cv_arg,
        "FCT": NonSpare_970.cv_arg,
        "TAC": NonSpare_1819.cv_arg,
        "WTC": NonSpare_2070.cv_arg,
        "DEP": NonSpare_879.cv_arg,
        "DST": NonSpare_904.cv_arg,
        "RDS": NonSpare_1564.cv_arg,
        "CFL": NonSpare_727.cv_arg,
        "CTL": NonSpare_849.cv_arg,
        "TOD": NonSpare_1883.cv_arg,
        "AST": NonSpare_639.cv_arg,
        "STS": NonSpare_1798.cv_arg,
        "STD": NonSpare_1788.cv_arg,
        "STA": NonSpare_1771.cv_arg,
        "PEM": NonSpare_1426.cv_arg,
        "PEC": NonSpare_1425.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 3
    cv_items_list = [NonSpare_1820, NonSpare_832, NonSpare_1118, NonSpare_970, NonSpare_1819, NonSpare_2070, NonSpare_879, NonSpare_904, NonSpare_1564, NonSpare_727, NonSpare_849, NonSpare_1883, NonSpare_639, NonSpare_1798, NonSpare_1788, NonSpare_1771, NonSpare_1426, NonSpare_1425]
    cv_items_dict = {"TAG": NonSpare_1820, "CS": NonSpare_832, "IFI": NonSpare_1118, "FCT": NonSpare_970, "TAC": NonSpare_1819, "WTC": NonSpare_2070, "DEP": NonSpare_879, "DST": NonSpare_904, "RDS": NonSpare_1564, "CFL": NonSpare_727, "CTL": NonSpare_849, "TOD": NonSpare_1883, "AST": NonSpare_639, "STS": NonSpare_1798, "STD": NonSpare_1788, "STA": NonSpare_1771, "PEM": NonSpare_1426, "PEC": NonSpare_1425}

    @overload
    @classmethod
    def spec(cls, key : Literal["TAG"]) -> NonSpare_1820:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> NonSpare_832:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFI"]) -> NonSpare_1118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FCT"]) -> NonSpare_970:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAC"]) -> NonSpare_1819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2070:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DEP"]) -> NonSpare_879:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DST"]) -> NonSpare_904:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_727:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTL"]) -> NonSpare_849:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1883:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_639:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1798:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STD"]) -> NonSpare_1788:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1771:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEM"]) -> NonSpare_1426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEC"]) -> NonSpare_1425:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TAG"], Literal["CS"], Literal["IFI"], Literal["FCT"], Literal["TAC"], Literal["WTC"], Literal["DEP"], Literal["DST"], Literal["RDS"], Literal["CFL"], Literal["CTL"], Literal["TOD"], Literal["AST"], Literal["STS"], Literal["STD"], Literal["STA"], Literal["PEM"], Literal["PEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TAG"]) -> Optional[NonSpare_1820]:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> Optional[NonSpare_832]:
        ...
    @overload
    def get_item(self, key : Literal["IFI"]) -> Optional[NonSpare_1118]:
        ...
    @overload
    def get_item(self, key : Literal["FCT"]) -> Optional[NonSpare_970]:
        ...
    @overload
    def get_item(self, key : Literal["TAC"]) -> Optional[NonSpare_1819]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2070]:
        ...
    @overload
    def get_item(self, key : Literal["DEP"]) -> Optional[NonSpare_879]:
        ...
    @overload
    def get_item(self, key : Literal["DST"]) -> Optional[NonSpare_904]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1564]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_727]:
        ...
    @overload
    def get_item(self, key : Literal["CTL"]) -> Optional[NonSpare_849]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1883]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_639]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1798]:
        ...
    @overload
    def get_item(self, key : Literal["STD"]) -> Optional[NonSpare_1788]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1771]:
        ...
    @overload
    def get_item(self, key : Literal["PEM"]) -> Optional[NonSpare_1426]:
        ...
    @overload
    def get_item(self, key : Literal["PEC"]) -> Optional[NonSpare_1425]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TAG"], val : NonSpare_1820.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["CS"], val : NonSpare_832.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["IFI"], val : NonSpare_1118.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["FCT"], val : NonSpare_970.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["TAC"], val : NonSpare_1819.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2070.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["DEP"], val : NonSpare_879.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["DST"], val : NonSpare_904.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1564.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_727.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["CTL"], val : NonSpare_849.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1883.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_639.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1798.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["STD"], val : NonSpare_1788.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1771.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["PEM"], val : NonSpare_1426.cv_arg) -> "Variation_1513":
        ...
    @overload
    def set_item(self, key : Literal["PEC"], val : NonSpare_1425.cv_arg) -> "Variation_1513":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TAG"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["CS"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["IFI"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["FCT"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["TAC"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["DEP"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["DST"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["CTL"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["STD"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["PEM"]) -> "Variation_1513":
        ...
    @overload
    def del_item(self, key : Literal["PEC"]) -> "Variation_1513":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1513.cv_arg") -> 'Variation_1513':
        return cls._create(arg) # type: ignore

class RuleVariation_1434(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1513.cv_arg
    cv_variation: TypeAlias = Variation_1513

    @classmethod
    def create(cls, arg : "RuleVariation_1434.cv_arg") -> "RuleVariation_1434":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1513:
        return self.arg # type: ignore

class NonSpare_493(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1434.cv_arg
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule: TypeAlias = RuleVariation_1434

    @classmethod
    def create(cls, arg : "NonSpare_493.cv_arg") -> "NonSpare_493":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1434:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1513:
        return self.rule.variation

class UapItem_493(UapItem):
    cv_non_spare: TypeAlias = NonSpare_493

class NonSpare_462(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1284.cv_arg
    cv_name = "270"
    cv_title = "Target Size and Orientation"
    cv_rule: TypeAlias = RuleVariation_1284

    @classmethod
    def create(cls, arg : "NonSpare_462.cv_arg") -> "NonSpare_462":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1284:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1363:
        return self.rule.variation

class UapItem_462(UapItem):
    cv_non_spare: TypeAlias = NonSpare_462

class Content_328(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No authenticated Mode 5 ID reply", 1: "Authenticated Mode 5 ID reply"}

class RuleContent_328(RuleContentContextFree):
    cv_arg: TypeAlias = Content_328.cv_arg
    cv_content: TypeAlias = Content_328

    @property
    def content(self) -> Content_328:
        return self._get_content() # type: ignore

class Variation_441(Element):
    cv_arg: TypeAlias = RuleContent_328.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_328

    @classmethod
    def create(cls, arg: "Variation_441.cv_arg") -> "Variation_441":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_328:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_328:
        return self.rule.content

class RuleVariation_430(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_441.cv_arg
    cv_variation: TypeAlias = Variation_441

    @classmethod
    def create(cls, arg : "RuleVariation_430.cv_arg") -> "RuleVariation_430":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_441:
        return self.arg # type: ignore

class NonSpare_1109(NonSpare):
    cv_arg: TypeAlias = RuleVariation_430.cv_arg
    cv_name = "ID"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_430

    @classmethod
    def create(cls, arg : "NonSpare_1109.cv_arg") -> "NonSpare_1109":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_430:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_441:
        return self.rule.variation

class Item_427(Item):
    cv_arg: TypeAlias = NonSpare_1109.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1109

    @classmethod
    def create(cls, arg : "Item_427.cv_arg") -> "Item_427":
        return cls._create(arg) # type: ignore

class Content_273(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 1 code not present or not from Mode 5 reply", 1: "Mode 1 code from Mode 5 reply"}

class RuleContent_273(RuleContentContextFree):
    cv_arg: TypeAlias = Content_273.cv_arg
    cv_content: TypeAlias = Content_273

    @property
    def content(self) -> Content_273:
        return self._get_content() # type: ignore

class Variation_646(Element):
    cv_arg: TypeAlias = RuleContent_273.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_273

    @classmethod
    def create(cls, arg: "Variation_646.cv_arg") -> "Variation_646":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_273:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_273:
        return self.rule.content

class RuleVariation_635(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_646.cv_arg
    cv_variation: TypeAlias = Variation_646

    @classmethod
    def create(cls, arg : "RuleVariation_635.cv_arg") -> "RuleVariation_635":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_646:
        return self.arg # type: ignore

class NonSpare_1206(NonSpare):
    cv_arg: TypeAlias = RuleVariation_635.cv_arg
    cv_name = "M1"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_635

    @classmethod
    def create(cls, arg : "NonSpare_1206.cv_arg") -> "NonSpare_1206":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_635:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_646:
        return self.rule.variation

class Item_514(Item):
    cv_arg: TypeAlias = NonSpare_1206.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1206

    @classmethod
    def create(cls, arg : "Item_514.cv_arg") -> "Item_514":
        return cls._create(arg) # type: ignore

class Content_275(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 2 code not present or not from Mode 5 reply", 1: "Mode 2 code from Mode 5 reply"}

class RuleContent_275(RuleContentContextFree):
    cv_arg: TypeAlias = Content_275.cv_arg
    cv_content: TypeAlias = Content_275

    @property
    def content(self) -> Content_275:
        return self._get_content() # type: ignore

class Variation_733(Element):
    cv_arg: TypeAlias = RuleContent_275.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_275

    @classmethod
    def create(cls, arg: "Variation_733.cv_arg") -> "Variation_733":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_275:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_275:
        return self.rule.content

class RuleVariation_722(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_733.cv_arg
    cv_variation: TypeAlias = Variation_733

    @classmethod
    def create(cls, arg : "RuleVariation_722.cv_arg") -> "RuleVariation_722":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_733:
        return self.arg # type: ignore

class NonSpare_1208(NonSpare):
    cv_arg: TypeAlias = RuleVariation_722.cv_arg
    cv_name = "M2"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_722

    @classmethod
    def create(cls, arg : "NonSpare_1208.cv_arg") -> "NonSpare_1208":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_722:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_733:
        return self.rule.variation

class Item_516(Item):
    cv_arg: TypeAlias = NonSpare_1208.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1208

    @classmethod
    def create(cls, arg : "Item_516.cv_arg") -> "Item_516":
        return cls._create(arg) # type: ignore

class Content_277(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 3 code not present or not from Mode 5 reply", 1: "Mode 3 code from Mode 5 reply"}

class RuleContent_277(RuleContentContextFree):
    cv_arg: TypeAlias = Content_277.cv_arg
    cv_content: TypeAlias = Content_277

    @property
    def content(self) -> Content_277:
        return self._get_content() # type: ignore

class Variation_860(Element):
    cv_arg: TypeAlias = RuleContent_277.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_277

    @classmethod
    def create(cls, arg: "Variation_860.cv_arg") -> "Variation_860":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_277:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_277:
        return self.rule.content

class RuleVariation_830(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_860.cv_arg
    cv_variation: TypeAlias = Variation_860

    @classmethod
    def create(cls, arg : "RuleVariation_830.cv_arg") -> "RuleVariation_830":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_860:
        return self.arg # type: ignore

class NonSpare_1212(NonSpare):
    cv_arg: TypeAlias = RuleVariation_830.cv_arg
    cv_name = "M3"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_830

    @classmethod
    def create(cls, arg : "NonSpare_1212.cv_arg") -> "NonSpare_1212":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_830:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_860:
        return self.rule.variation

class Item_519(Item):
    cv_arg: TypeAlias = NonSpare_1212.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1212

    @classmethod
    def create(cls, arg : "Item_519.cv_arg") -> "Item_519":
        return cls._create(arg) # type: ignore

class Content_280(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode C altitude code not present or not from Mode 5 reply", 1: "Mode C altitude from Mode 5 reply"}

class RuleContent_280(RuleContentContextFree):
    cv_arg: TypeAlias = Content_280.cv_arg
    cv_content: TypeAlias = Content_280

    @property
    def content(self) -> Content_280:
        return self._get_content() # type: ignore

class Variation_938(Element):
    cv_arg: TypeAlias = RuleContent_280.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_280

    @classmethod
    def create(cls, arg: "Variation_938.cv_arg") -> "Variation_938":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_280:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_280:
        return self.rule.content

class RuleVariation_908(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_938.cv_arg
    cv_variation: TypeAlias = Variation_938

    @classmethod
    def create(cls, arg : "RuleVariation_908.cv_arg") -> "RuleVariation_908":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_938:
        return self.arg # type: ignore

class NonSpare_1239(NonSpare):
    cv_arg: TypeAlias = RuleVariation_908.cv_arg
    cv_name = "MC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_908

    @classmethod
    def create(cls, arg : "NonSpare_1239.cv_arg") -> "NonSpare_1239":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_908:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_938:
        return self.rule.variation

class Item_535(Item):
    cv_arg: TypeAlias = NonSpare_1239.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1239

    @classmethod
    def create(cls, arg : "Item_535.cv_arg") -> "Item_535":
        return cls._create(arg) # type: ignore

class Content_569(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "X-pulse set to zero or no authenticated Data reply or Report received", 1: "X-pulse set to one"}

class RuleContent_569(RuleContentContextFree):
    cv_arg: TypeAlias = Content_569.cv_arg
    cv_content: TypeAlias = Content_569

    @property
    def content(self) -> Content_569:
        return self._get_content() # type: ignore

class Variation_991(Element):
    cv_arg: TypeAlias = RuleContent_569.cv_arg
    cv_bit_offset8 = 7
    cv_bit_size = 1
    cv_rule = RuleContent_569

    @classmethod
    def create(cls, arg: "Variation_991.cv_arg") -> "Variation_991":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_569:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_569:
        return self.rule.content

class RuleVariation_961(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_991.cv_arg
    cv_variation: TypeAlias = Variation_991

    @classmethod
    def create(cls, arg : "RuleVariation_961.cv_arg") -> "RuleVariation_961":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_991:
        return self.arg # type: ignore

class NonSpare_2103(NonSpare):
    cv_arg: TypeAlias = RuleVariation_961.cv_arg
    cv_name = "X"
    cv_title = "X-pulse from Mode 5 Data Reply or Report"
    cv_rule: TypeAlias = RuleVariation_961

    @classmethod
    def create(cls, arg : "NonSpare_2103.cv_arg") -> "NonSpare_2103":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_961:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_991:
        return self.rule.variation

class Item_1204(Item):
    cv_arg: TypeAlias = NonSpare_2103.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2103

    @classmethod
    def create(cls, arg : "Item_1204.cv_arg") -> "Item_1204":
        return cls._create(arg) # type: ignore

class Variation_1139(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_57.cv_arg, Tuple[Literal["M5"], RuleVariation_57.cv_arg]], Union[RuleVariation_430.cv_arg, Tuple[Literal["ID"], RuleVariation_430.cv_arg]], Union[RuleVariation_549.cv_arg, Tuple[Literal["DA"], RuleVariation_549.cv_arg]], Union[RuleVariation_635.cv_arg, Tuple[Literal["M1"], RuleVariation_635.cv_arg]], Union[RuleVariation_722.cv_arg, Tuple[Literal["M2"], RuleVariation_722.cv_arg]], Union[RuleVariation_830.cv_arg, Tuple[Literal["M3"], RuleVariation_830.cv_arg]], Union[RuleVariation_908.cv_arg, Tuple[Literal["MC"], RuleVariation_908.cv_arg]], Union[RuleVariation_961.cv_arg, Tuple[Literal["X"], RuleVariation_961.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1139.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_522, 1), (Item_427, 1), (Item_237, 1), (Item_514, 1), (Item_516, 1), (Item_519, 1), (Item_535, 1), (Item_1204, 1)]
    cv_items_dict = {"M5": RuleVariation_57, "ID": RuleVariation_430, "DA": RuleVariation_549, "M1": RuleVariation_635, "M2": RuleVariation_722, "M3": RuleVariation_830, "MC": RuleVariation_908, "X": RuleVariation_961}

    @overload
    @classmethod
    def spec(cls, key : Literal["M5"]) -> RuleVariation_57:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> RuleVariation_430:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DA"]) -> RuleVariation_549:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M1"]) -> RuleVariation_635:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M2"]) -> RuleVariation_722:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["M3"]) -> RuleVariation_830:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MC"]) -> RuleVariation_908:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_961:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["M5"], Literal["ID"], Literal["DA"], Literal["M1"], Literal["M2"], Literal["M3"], Literal["MC"], Literal["X"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["M5"]) -> RuleVariation_57:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> RuleVariation_430:
        ...
    @overload
    def get_item(self, key : Literal["DA"]) -> RuleVariation_549:
        ...
    @overload
    def get_item(self, key : Literal["M1"]) -> RuleVariation_635:
        ...
    @overload
    def get_item(self, key : Literal["M2"]) -> RuleVariation_722:
        ...
    @overload
    def get_item(self, key : Literal["M3"]) -> RuleVariation_830:
        ...
    @overload
    def get_item(self, key : Literal["MC"]) -> RuleVariation_908:
        ...
    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_961:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1139.cv_arg") -> 'Variation_1139':
        return cls._create(arg) # type: ignore

class RuleVariation_1095(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1139.cv_arg
    cv_variation: TypeAlias = Variation_1139

    @classmethod
    def create(cls, arg : "RuleVariation_1095.cv_arg") -> "RuleVariation_1095":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1139:
        return self.arg # type: ignore

class NonSpare_1808(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1095.cv_arg
    cv_name = "SUM"
    cv_title = "Mode 5 Summary"
    cv_rule: TypeAlias = RuleVariation_1095

    @classmethod
    def create(cls, arg : "NonSpare_1808.cv_arg") -> "NonSpare_1808":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1095:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1139:
        return self.rule.variation

class Variation_1006(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_593.cv_arg, Tuple[Literal["PIN"], RuleVariation_593.cv_arg]], int, Union[RuleVariation_684.cv_arg, Tuple[Literal["NAT"], RuleVariation_684.cv_arg]], int, Union[RuleVariation_591.cv_arg, Tuple[Literal["MIS"], RuleVariation_591.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1006.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1, 2), (Item_685, 14), (Item_2, 3), (Item_605, 5), (Item_1, 2), (Item_557, 6)]
    cv_items_dict = {"PIN": RuleVariation_593, "NAT": RuleVariation_684, "MIS": RuleVariation_591}

    @overload
    @classmethod
    def spec(cls, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NAT"]) -> RuleVariation_684:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MIS"]) -> RuleVariation_591:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PIN"], Literal["NAT"], Literal["MIS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PIN"]) -> RuleVariation_593:
        ...
    @overload
    def get_item(self, key : Literal["NAT"]) -> RuleVariation_684:
        ...
    @overload
    def get_item(self, key : Literal["MIS"]) -> RuleVariation_591:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1006.cv_arg") -> 'Variation_1006':
        return cls._create(arg) # type: ignore

class RuleVariation_976(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1006.cv_arg
    cv_variation: TypeAlias = Variation_1006

    @classmethod
    def create(cls, arg : "RuleVariation_976.cv_arg") -> "RuleVariation_976":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1006:
        return self.arg # type: ignore

class NonSpare_1434(NonSpare):
    cv_arg: TypeAlias = RuleVariation_976.cv_arg
    cv_name = "PMN"
    cv_title = "Mode 5 PIN/ National Origin/Mission Code"
    cv_rule: TypeAlias = RuleVariation_976

    @classmethod
    def create(cls, arg : "NonSpare_1434.cv_arg") -> "NonSpare_1434":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_976:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1006:
        return self.rule.variation

class NonSpare_1445(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1082.cv_arg
    cv_name = "POS"
    cv_title = "Mode 5 Reported Position"
    cv_rule: TypeAlias = RuleVariation_1082

    @classmethod
    def create(cls, arg : "NonSpare_1445.cv_arg") -> "NonSpare_1445":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1082:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1126:
        return self.rule.variation

class NonSpare_1585(NonSpare):
    cv_arg: TypeAlias = RuleVariation_416.cv_arg
    cv_name = "RES"
    cv_title = "Resolution with which the GNSS-derived Altitude (GA) is Reported"
    cv_rule: TypeAlias = RuleVariation_416

    @classmethod
    def create(cls, arg : "NonSpare_1585.cv_arg") -> "NonSpare_1585":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_416:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_427:
        return self.rule.variation

class Item_810(Item):
    cv_arg: TypeAlias = NonSpare_1585.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1585

    @classmethod
    def create(cls, arg : "Item_810.cv_arg") -> "Item_810":
        return cls._create(arg) # type: ignore

class NonSpare_1015(NonSpare):
    cv_arg: TypeAlias = RuleVariation_596.cv_arg
    cv_name = "GA"
    cv_title = "GNSS-derived Altitude of Target, Expressed as Height Above WGS 84 Ellipsoid"
    cv_rule: TypeAlias = RuleVariation_596

    @classmethod
    def create(cls, arg : "NonSpare_1015.cv_arg") -> "NonSpare_1015":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_596:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_607:
        return self.rule.variation

class Item_360(Item):
    cv_arg: TypeAlias = NonSpare_1015.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1015

    @classmethod
    def create(cls, arg : "Item_360.cv_arg") -> "Item_360":
        return cls._create(arg) # type: ignore

class Variation_1001(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_416.cv_arg, Tuple[Literal["RES"], RuleVariation_416.cv_arg]], Union[RuleVariation_596.cv_arg, Tuple[Literal["GA"], RuleVariation_596.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1001.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_0, 1), (Item_810, 1), (Item_360, 14)]
    cv_items_dict = {"RES": RuleVariation_416, "GA": RuleVariation_596}

    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_416:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> RuleVariation_596:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RES"], Literal["GA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_416:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> RuleVariation_596:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1001.cv_arg") -> 'Variation_1001':
        return cls._create(arg) # type: ignore

class RuleVariation_971(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1001.cv_arg
    cv_variation: TypeAlias = Variation_1001

    @classmethod
    def create(cls, arg : "RuleVariation_971.cv_arg") -> "RuleVariation_971":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1001:
        return self.arg # type: ignore

class NonSpare_1018(NonSpare):
    cv_arg: TypeAlias = RuleVariation_971.cv_arg
    cv_name = "GA"
    cv_title = "Mode 5 GNSS-derived Altitude"
    cv_rule: TypeAlias = RuleVariation_971

    @classmethod
    def create(cls, arg : "NonSpare_1018.cv_arg") -> "NonSpare_1018":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_971:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1001:
        return self.rule.variation

class NonSpare_928(NonSpare):
    cv_arg: TypeAlias = RuleVariation_779.cv_arg
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Reply in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_779

    @classmethod
    def create(cls, arg : "NonSpare_928.cv_arg") -> "NonSpare_928":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_779:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_809:
        return self.rule.variation

class Item_291(Item):
    cv_arg: TypeAlias = NonSpare_928.cv_arg
    cv_non_spare: TypeAlias = NonSpare_928

    @classmethod
    def create(cls, arg : "Item_291.cv_arg") -> "Item_291":
        return cls._create(arg) # type: ignore

class Variation_1021(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["EM1"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1021.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_291, 12)]
    cv_items_dict = {"EM1": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["EM1"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["EM1"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1021.cv_arg") -> 'Variation_1021':
        return cls._create(arg) # type: ignore

class RuleVariation_991(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1021.cv_arg
    cv_variation: TypeAlias = Variation_1021

    @classmethod
    def create(cls, arg : "RuleVariation_991.cv_arg") -> "RuleVariation_991":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1021:
        return self.arg # type: ignore

class NonSpare_925(NonSpare):
    cv_arg: TypeAlias = RuleVariation_991.cv_arg
    cv_name = "EM1"
    cv_title = "Extended Mode 1 Code in Octal Representation"
    cv_rule: TypeAlias = RuleVariation_991

    @classmethod
    def create(cls, arg : "NonSpare_925.cv_arg") -> "NonSpare_925":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_991:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1021:
        return self.rule.variation

class Content_679(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["s"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 7.8125e-3
    cv_unit = "s"

    def as_quantity(self, cv_unit : Optional[Literal["s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_679(RuleContentContextFree):
    cv_arg: TypeAlias = Content_679.cv_arg
    cv_content: TypeAlias = Content_679

    @property
    def content(self) -> Content_679:
        return self._get_content() # type: ignore

class Variation_216(Element):
    cv_arg: TypeAlias = RuleContent_679.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_679

    @classmethod
    def create(cls, arg: "Variation_216.cv_arg") -> "Variation_216":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_679:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_679:
        return self.rule.content

class RuleVariation_209(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_216.cv_arg
    cv_variation: TypeAlias = Variation_216

    @classmethod
    def create(cls, arg : "RuleVariation_209.cv_arg") -> "RuleVariation_209":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_216:
        return self.arg # type: ignore

class NonSpare_1886(NonSpare):
    cv_arg: TypeAlias = RuleVariation_209.cv_arg
    cv_name = "TOS"
    cv_title = "Time Offset for POS and GA"
    cv_rule: TypeAlias = RuleVariation_209

    @classmethod
    def create(cls, arg : "NonSpare_1886.cv_arg") -> "NonSpare_1886":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_209:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_216:
        return self.rule.variation

class Variation_1018(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_663.cv_arg, Tuple[Literal["X5"], RuleVariation_663.cv_arg]], Union[RuleVariation_751.cv_arg, Tuple[Literal["XC"], RuleVariation_751.cv_arg]], Union[RuleVariation_846.cv_arg, Tuple[Literal["X3"], RuleVariation_846.cv_arg]], Union[RuleVariation_929.cv_arg, Tuple[Literal["X2"], RuleVariation_929.cv_arg]], Union[RuleVariation_960.cv_arg, Tuple[Literal["X1"], RuleVariation_960.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1018.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_2, 3), (Item_1213, 1), (Item_1216, 1), (Item_1212, 1), (Item_1210, 1), (Item_1206, 1)]
    cv_items_dict = {"X5": RuleVariation_663, "XC": RuleVariation_751, "X3": RuleVariation_846, "X2": RuleVariation_929, "X1": RuleVariation_960}

    @overload
    @classmethod
    def spec(cls, key : Literal["X5"]) -> RuleVariation_663:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XC"]) -> RuleVariation_751:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X3"]) -> RuleVariation_846:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X2"]) -> RuleVariation_929:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["X1"]) -> RuleVariation_960:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X5"], Literal["XC"], Literal["X3"], Literal["X2"], Literal["X1"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X5"]) -> RuleVariation_663:
        ...
    @overload
    def get_item(self, key : Literal["XC"]) -> RuleVariation_751:
        ...
    @overload
    def get_item(self, key : Literal["X3"]) -> RuleVariation_846:
        ...
    @overload
    def get_item(self, key : Literal["X2"]) -> RuleVariation_929:
        ...
    @overload
    def get_item(self, key : Literal["X1"]) -> RuleVariation_960:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1018.cv_arg") -> 'Variation_1018':
        return cls._create(arg) # type: ignore

class RuleVariation_988(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1018.cv_arg
    cv_variation: TypeAlias = Variation_1018

    @classmethod
    def create(cls, arg : "RuleVariation_988.cv_arg") -> "RuleVariation_988":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1018:
        return self.arg # type: ignore

class NonSpare_2118(NonSpare):
    cv_arg: TypeAlias = RuleVariation_988.cv_arg
    cv_name = "XP"
    cv_title = "X Pulse Presence"
    cv_rule: TypeAlias = RuleVariation_988

    @classmethod
    def create(cls, arg : "NonSpare_2118.cv_arg") -> "NonSpare_2118":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_988:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1018:
        return self.rule.variation

class Variation_1509(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SUM": NonSpare_1808.cv_arg,
        "PMN": NonSpare_1434.cv_arg,
        "POS": NonSpare_1445.cv_arg,
        "GA": NonSpare_1018.cv_arg,
        "EM1": NonSpare_925.cv_arg,
        "TOS": NonSpare_1886.cv_arg,
        "XP": NonSpare_2118.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1808, NonSpare_1434, NonSpare_1445, NonSpare_1018, NonSpare_925, NonSpare_1886, NonSpare_2118]
    cv_items_dict = {"SUM": NonSpare_1808, "PMN": NonSpare_1434, "POS": NonSpare_1445, "GA": NonSpare_1018, "EM1": NonSpare_925, "TOS": NonSpare_1886, "XP": NonSpare_2118}

    @overload
    @classmethod
    def spec(cls, key : Literal["SUM"]) -> NonSpare_1808:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PMN"]) -> NonSpare_1434:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1445:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GA"]) -> NonSpare_1018:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EM1"]) -> NonSpare_925:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOS"]) -> NonSpare_1886:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["XP"]) -> NonSpare_2118:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SUM"], Literal["PMN"], Literal["POS"], Literal["GA"], Literal["EM1"], Literal["TOS"], Literal["XP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SUM"]) -> Optional[NonSpare_1808]:
        ...
    @overload
    def get_item(self, key : Literal["PMN"]) -> Optional[NonSpare_1434]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1445]:
        ...
    @overload
    def get_item(self, key : Literal["GA"]) -> Optional[NonSpare_1018]:
        ...
    @overload
    def get_item(self, key : Literal["EM1"]) -> Optional[NonSpare_925]:
        ...
    @overload
    def get_item(self, key : Literal["TOS"]) -> Optional[NonSpare_1886]:
        ...
    @overload
    def get_item(self, key : Literal["XP"]) -> Optional[NonSpare_2118]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SUM"], val : NonSpare_1808.cv_arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["PMN"], val : NonSpare_1434.cv_arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1445.cv_arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["GA"], val : NonSpare_1018.cv_arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["EM1"], val : NonSpare_925.cv_arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["TOS"], val : NonSpare_1886.cv_arg) -> "Variation_1509":
        ...
    @overload
    def set_item(self, key : Literal["XP"], val : NonSpare_2118.cv_arg) -> "Variation_1509":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SUM"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["PMN"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["GA"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["EM1"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["TOS"]) -> "Variation_1509":
        ...
    @overload
    def del_item(self, key : Literal["XP"]) -> "Variation_1509":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1509.cv_arg") -> 'Variation_1509':
        return cls._create(arg) # type: ignore

class RuleVariation_1430(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1509.cv_arg
    cv_variation: TypeAlias = Variation_1509

    @classmethod
    def create(cls, arg : "RuleVariation_1430.cv_arg") -> "RuleVariation_1430":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1509:
        return self.arg # type: ignore

class NonSpare_289(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1430.cv_arg
    cv_name = "110"
    cv_title = "Mode 5 Data Reports and Extended Mode 1 Code"
    cv_rule: TypeAlias = RuleVariation_1430

    @classmethod
    def create(cls, arg : "NonSpare_289.cv_arg") -> "NonSpare_289":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1430:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1509:
        return self.rule.variation

class UapItem_289(UapItem):
    cv_non_spare: TypeAlias = NonSpare_289

class Variation_1025(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE2"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1025.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_3, 4), (Item_569, 12)]
    cv_items_dict = {"MODE2": RuleVariation_779}

    @classmethod
    def spec(cls, key : Literal["MODE2"]) -> RuleVariation_779:
        return cls._spec(arg) # type: ignore

    def get_item(self, key : Literal["MODE2"]) -> RuleVariation_779:
        return self._get_item(key) # type: ignore

    @classmethod
    def create(cls, arg:"Variation_1025.cv_arg") -> 'Variation_1025':
        return cls._create(arg) # type: ignore

class RuleVariation_994(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1025.cv_arg
    cv_variation: TypeAlias = Variation_1025

    @classmethod
    def create(cls, arg : "RuleVariation_994.cv_arg") -> "RuleVariation_994":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1025:
        return self.arg # type: ignore

class NonSpare_305(NonSpare):
    cv_arg: TypeAlias = RuleVariation_994.cv_arg
    cv_name = "120"
    cv_title = "Track Mode 2 Code"
    cv_rule: TypeAlias = RuleVariation_994

    @classmethod
    def create(cls, arg : "NonSpare_305.cv_arg") -> "NonSpare_305":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_994:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1025:
        return self.rule.variation

class UapItem_305(UapItem):
    cv_non_spare: TypeAlias = NonSpare_305

class NonSpare_1115(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "IDENT"
    cv_title = "System Unit Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1115.cv_arg") -> "NonSpare_1115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_432(Item):
    cv_arg: TypeAlias = NonSpare_1115.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1115

    @classmethod
    def create(cls, arg : "Item_432.cv_arg") -> "Item_432":
        return cls._create(arg) # type: ignore

class NonSpare_1903(NonSpare):
    cv_arg: TypeAlias = RuleVariation_244.cv_arg
    cv_name = "TRACK"
    cv_title = "System Track Number"
    cv_rule: TypeAlias = RuleVariation_244

    @classmethod
    def create(cls, arg : "NonSpare_1903.cv_arg") -> "NonSpare_1903":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_244:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_251:
        return self.rule.variation

class Item_1026(Item):
    cv_arg: TypeAlias = NonSpare_1903.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1903

    @classmethod
    def create(cls, arg : "Item_1026.cv_arg") -> "Item_1026":
        return cls._create(arg) # type: ignore

class Variation_1120(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["IDENT"], RuleVariation_159.cv_arg]], Union[RuleVariation_244.cv_arg, Tuple[Literal["TRACK"], RuleVariation_244.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1120.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 23
    cv_items_list = [(Item_432, 8), (Item_1026, 15)]
    cv_items_dict = {"IDENT": RuleVariation_159, "TRACK": RuleVariation_244}

    @overload
    @classmethod
    def spec(cls, key : Literal["IDENT"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK"]) -> RuleVariation_244:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["IDENT"], Literal["TRACK"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["IDENT"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["TRACK"]) -> RuleVariation_244:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1120.cv_arg") -> 'Variation_1120':
        return cls._create(arg) # type: ignore

class Variation_1461(Repetitive):
    cv_arg: TypeAlias = List[Variation_1120.cv_arg]
    cv_rep_bytes = None
    cv_variation: TypeAlias = Variation_1120

    @classmethod
    def create(cls, arg: "Variation_1461.cv_arg") -> 'Variation_1461':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1120]:
        return self._get_list() # type: ignore

class RuleVariation_1382(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1461.cv_arg
    cv_variation: TypeAlias = Variation_1461

    @classmethod
    def create(cls, arg : "RuleVariation_1382.cv_arg") -> "RuleVariation_1382":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1461:
        return self.arg # type: ignore

class NonSpare_520(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1382.cv_arg
    cv_name = "510"
    cv_title = "Composed Track Number"
    cv_rule: TypeAlias = RuleVariation_1382

    @classmethod
    def create(cls, arg : "NonSpare_520.cv_arg") -> "NonSpare_520":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1382:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1461:
        return self.rule.variation

class UapItem_519(UapItem):
    cv_non_spare: TypeAlias = NonSpare_520

class NonSpare_2086(NonSpare):
    cv_arg: TypeAlias = RuleVariation_304.cv_arg
    cv_name = "X"
    cv_title = "APC (X-Component)"
    cv_rule: TypeAlias = RuleVariation_304

    @classmethod
    def create(cls, arg : "NonSpare_2086.cv_arg") -> "NonSpare_2086":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

class Item_1187(Item):
    cv_arg: TypeAlias = NonSpare_2086.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2086

    @classmethod
    def create(cls, arg : "Item_1187.cv_arg") -> "Item_1187":
        return cls._create(arg) # type: ignore

class NonSpare_2139(NonSpare):
    cv_arg: TypeAlias = RuleVariation_304.cv_arg
    cv_name = "Y"
    cv_title = "APC (Y-Component)"
    cv_rule: TypeAlias = RuleVariation_304

    @classmethod
    def create(cls, arg : "NonSpare_2139.cv_arg") -> "NonSpare_2139":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_304:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_311:
        return self.rule.variation

class Item_1237(Item):
    cv_arg: TypeAlias = NonSpare_2139.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2139

    @classmethod
    def create(cls, arg : "Item_1237.cv_arg") -> "Item_1237":
        return cls._create(arg) # type: ignore

class Variation_1300(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_304.cv_arg, Tuple[Literal["X"], RuleVariation_304.cv_arg]], Union[RuleVariation_304.cv_arg, Tuple[Literal["Y"], RuleVariation_304.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1300.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1187, 16), (Item_1237, 16)]
    cv_items_dict = {"X": RuleVariation_304, "Y": RuleVariation_304}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_304:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_304:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_304:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_304:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1300.cv_arg") -> 'Variation_1300':
        return cls._create(arg) # type: ignore

class RuleVariation_1229(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1300.cv_arg
    cv_variation: TypeAlias = Variation_1300

    @classmethod
    def create(cls, arg : "RuleVariation_1229.cv_arg") -> "RuleVariation_1229":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1300:
        return self.arg # type: ignore

class NonSpare_615(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1229.cv_arg
    cv_name = "APC"
    cv_title = "Estimated Accuracy Of Track Position (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1229

    @classmethod
    def create(cls, arg : "NonSpare_615.cv_arg") -> "NonSpare_615":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1229:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1300:
        return self.rule.variation

class NonSpare_802(NonSpare):
    cv_arg: TypeAlias = RuleVariation_258.cv_arg
    cv_name = "COV"
    cv_title = "XY Covariance Component"
    cv_rule: TypeAlias = RuleVariation_258

    @classmethod
    def create(cls, arg : "NonSpare_802.cv_arg") -> "NonSpare_802":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_258:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_265:
        return self.rule.variation

class Content_788(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 5.364418029785156e-6
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_787(RuleContentContextFree):
    cv_arg: TypeAlias = Content_788.cv_arg
    cv_content: TypeAlias = Content_788

    @property
    def content(self) -> Content_788:
        return self._get_content() # type: ignore

class Variation_342(Element):
    cv_arg: TypeAlias = RuleContent_787.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_787

    @classmethod
    def create(cls, arg: "Variation_342.cv_arg") -> "Variation_342":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_787:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_788:
        return self.rule.content

class RuleVariation_335(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_342.cv_arg
    cv_variation: TypeAlias = Variation_342

    @classmethod
    def create(cls, arg : "RuleVariation_335.cv_arg") -> "RuleVariation_335":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_342:
        return self.arg # type: ignore

class NonSpare_1147(NonSpare):
    cv_arg: TypeAlias = RuleVariation_335.cv_arg
    cv_name = "LAT"
    cv_title = "APW (Latitude Component)"
    cv_rule: TypeAlias = RuleVariation_335

    @classmethod
    def create(cls, arg : "NonSpare_1147.cv_arg") -> "NonSpare_1147":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_335:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_342:
        return self.rule.variation

class Item_459(Item):
    cv_arg: TypeAlias = NonSpare_1147.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1147

    @classmethod
    def create(cls, arg : "Item_459.cv_arg") -> "Item_459":
        return cls._create(arg) # type: ignore

class NonSpare_1176(NonSpare):
    cv_arg: TypeAlias = RuleVariation_335.cv_arg
    cv_name = "LON"
    cv_title = "APW (Longitude Component)"
    cv_rule: TypeAlias = RuleVariation_335

    @classmethod
    def create(cls, arg : "NonSpare_1176.cv_arg") -> "NonSpare_1176":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_335:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_342:
        return self.rule.variation

class Item_486(Item):
    cv_arg: TypeAlias = NonSpare_1176.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1176

    @classmethod
    def create(cls, arg : "Item_486.cv_arg") -> "Item_486":
        return cls._create(arg) # type: ignore

class Variation_1124(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_335.cv_arg, Tuple[Literal["LAT"], RuleVariation_335.cv_arg]], Union[RuleVariation_335.cv_arg, Tuple[Literal["LON"], RuleVariation_335.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1124.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_459, 16), (Item_486, 16)]
    cv_items_dict = {"LAT": RuleVariation_335, "LON": RuleVariation_335}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_335:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_335:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_335:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_335:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1124.cv_arg") -> 'Variation_1124':
        return cls._create(arg) # type: ignore

class RuleVariation_1080(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1124.cv_arg
    cv_variation: TypeAlias = Variation_1124

    @classmethod
    def create(cls, arg : "RuleVariation_1080.cv_arg") -> "RuleVariation_1080":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1124:
        return self.arg # type: ignore

class NonSpare_620(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1080.cv_arg
    cv_name = "APW"
    cv_title = "Estimated Accuracy Of Track Position (WGS-84)"
    cv_rule: TypeAlias = RuleVariation_1080

    @classmethod
    def create(cls, arg : "NonSpare_620.cv_arg") -> "NonSpare_620":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1080:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1124:
        return self.rule.variation

class Content_782(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.25
    cv_unit = "ft"

    def as_quantity(self, cv_unit : Optional[Literal["ft"]] = None) -> float:
        return self._as_quantity()

class RuleContent_781(RuleContentContextFree):
    cv_arg: TypeAlias = Content_782.cv_arg
    cv_content: TypeAlias = Content_782

    @property
    def content(self) -> Content_782:
        return self._get_content() # type: ignore

class Variation_241(Element):
    cv_arg: TypeAlias = RuleContent_781.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_781

    @classmethod
    def create(cls, arg: "Variation_241.cv_arg") -> "Variation_241":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_781:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_782:
        return self.rule.content

class RuleVariation_234(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_241.cv_arg
    cv_variation: TypeAlias = Variation_241

    @classmethod
    def create(cls, arg : "RuleVariation_234.cv_arg") -> "RuleVariation_234":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_241:
        return self.arg # type: ignore

class NonSpare_581(NonSpare):
    cv_arg: TypeAlias = RuleVariation_234.cv_arg
    cv_name = "AGA"
    cv_title = "Estimated Accuracy Of Calculated Track Geometric Altitude"
    cv_rule: TypeAlias = RuleVariation_234

    @classmethod
    def create(cls, arg : "NonSpare_581.cv_arg") -> "NonSpare_581":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_234:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_241:
        return self.rule.variation

class Variation_231(Element):
    cv_arg: TypeAlias = RuleContent_751.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_751

    @classmethod
    def create(cls, arg: "Variation_231.cv_arg") -> "Variation_231":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_751:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_752:
        return self.rule.content

class RuleVariation_224(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_231.cv_arg
    cv_variation: TypeAlias = Variation_231

    @classmethod
    def create(cls, arg : "RuleVariation_224.cv_arg") -> "RuleVariation_224":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_231:
        return self.arg # type: ignore

class NonSpare_553(NonSpare):
    cv_arg: TypeAlias = RuleVariation_224.cv_arg
    cv_name = "ABA"
    cv_title = "Estimated Accuracy Of Calculated Track Barometric Altitude"
    cv_rule: TypeAlias = RuleVariation_224

    @classmethod
    def create(cls, arg : "NonSpare_553.cv_arg") -> "NonSpare_553":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_224:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_231:
        return self.rule.variation

class Content_757(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "m/s"

    def as_quantity(self, cv_unit : Optional[Literal["m/s"]] = None) -> float:
        return self._as_quantity()

class RuleContent_756(RuleContentContextFree):
    cv_arg: TypeAlias = Content_757.cv_arg
    cv_content: TypeAlias = Content_757

    @property
    def content(self) -> Content_757:
        return self._get_content() # type: ignore

class Variation_233(Element):
    cv_arg: TypeAlias = RuleContent_756.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_756

    @classmethod
    def create(cls, arg: "Variation_233.cv_arg") -> "Variation_233":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_756:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_757:
        return self.rule.content

class RuleVariation_226(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_233.cv_arg
    cv_variation: TypeAlias = Variation_233

    @classmethod
    def create(cls, arg : "RuleVariation_226.cv_arg") -> "RuleVariation_226":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_233:
        return self.arg # type: ignore

class NonSpare_2087(NonSpare):
    cv_arg: TypeAlias = RuleVariation_226.cv_arg
    cv_name = "X"
    cv_title = "ATV (X-Component)"
    cv_rule: TypeAlias = RuleVariation_226

    @classmethod
    def create(cls, arg : "NonSpare_2087.cv_arg") -> "NonSpare_2087":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

class Item_1188(Item):
    cv_arg: TypeAlias = NonSpare_2087.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2087

    @classmethod
    def create(cls, arg : "Item_1188.cv_arg") -> "Item_1188":
        return cls._create(arg) # type: ignore

class NonSpare_2140(NonSpare):
    cv_arg: TypeAlias = RuleVariation_226.cv_arg
    cv_name = "Y"
    cv_title = "ATV (Y-Component)"
    cv_rule: TypeAlias = RuleVariation_226

    @classmethod
    def create(cls, arg : "NonSpare_2140.cv_arg") -> "NonSpare_2140":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_226:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_233:
        return self.rule.variation

class Item_1238(Item):
    cv_arg: TypeAlias = NonSpare_2140.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2140

    @classmethod
    def create(cls, arg : "Item_1238.cv_arg") -> "Item_1238":
        return cls._create(arg) # type: ignore

class Variation_1301(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_226.cv_arg, Tuple[Literal["X"], RuleVariation_226.cv_arg]], Union[RuleVariation_226.cv_arg, Tuple[Literal["Y"], RuleVariation_226.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1301.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1188, 8), (Item_1238, 8)]
    cv_items_dict = {"X": RuleVariation_226, "Y": RuleVariation_226}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_226:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_226:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_226:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_226:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1301.cv_arg") -> 'Variation_1301':
        return cls._create(arg) # type: ignore

class RuleVariation_1230(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1301.cv_arg
    cv_variation: TypeAlias = Variation_1301

    @classmethod
    def create(cls, arg : "RuleVariation_1230.cv_arg") -> "RuleVariation_1230":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1301:
        return self.arg # type: ignore

class NonSpare_646(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1230.cv_arg
    cv_name = "ATV"
    cv_title = "Estimated Accuracy Of Track Velocity (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1230

    @classmethod
    def create(cls, arg : "NonSpare_646.cv_arg") -> "NonSpare_646":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1230:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1301:
        return self.rule.variation

class Content_758(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m/s²"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "m/s²"

    def as_quantity(self, cv_unit : Optional[Literal["m/s²"]] = None) -> float:
        return self._as_quantity()

class RuleContent_757(RuleContentContextFree):
    cv_arg: TypeAlias = Content_758.cv_arg
    cv_content: TypeAlias = Content_758

    @property
    def content(self) -> Content_758:
        return self._get_content() # type: ignore

class Variation_234(Element):
    cv_arg: TypeAlias = RuleContent_757.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_757

    @classmethod
    def create(cls, arg: "Variation_234.cv_arg") -> "Variation_234":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_757:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_758:
        return self.rule.content

class RuleVariation_227(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_234.cv_arg
    cv_variation: TypeAlias = Variation_234

    @classmethod
    def create(cls, arg : "RuleVariation_227.cv_arg") -> "RuleVariation_227":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_234:
        return self.arg # type: ignore

class NonSpare_2085(NonSpare):
    cv_arg: TypeAlias = RuleVariation_227.cv_arg
    cv_name = "X"
    cv_title = "AA (X-Component)"
    cv_rule: TypeAlias = RuleVariation_227

    @classmethod
    def create(cls, arg : "NonSpare_2085.cv_arg") -> "NonSpare_2085":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

class Item_1186(Item):
    cv_arg: TypeAlias = NonSpare_2085.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2085

    @classmethod
    def create(cls, arg : "Item_1186.cv_arg") -> "Item_1186":
        return cls._create(arg) # type: ignore

class NonSpare_2138(NonSpare):
    cv_arg: TypeAlias = RuleVariation_227.cv_arg
    cv_name = "Y"
    cv_title = "AA (Y-Component)"
    cv_rule: TypeAlias = RuleVariation_227

    @classmethod
    def create(cls, arg : "NonSpare_2138.cv_arg") -> "NonSpare_2138":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_227:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_234:
        return self.rule.variation

class Item_1236(Item):
    cv_arg: TypeAlias = NonSpare_2138.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2138

    @classmethod
    def create(cls, arg : "Item_1236.cv_arg") -> "Item_1236":
        return cls._create(arg) # type: ignore

class Variation_1299(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_227.cv_arg, Tuple[Literal["X"], RuleVariation_227.cv_arg]], Union[RuleVariation_227.cv_arg, Tuple[Literal["Y"], RuleVariation_227.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1299.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1186, 8), (Item_1236, 8)]
    cv_items_dict = {"X": RuleVariation_227, "Y": RuleVariation_227}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_227:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_227:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_227:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_227:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1299.cv_arg") -> 'Variation_1299':
        return cls._create(arg) # type: ignore

class RuleVariation_1228(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1299.cv_arg
    cv_variation: TypeAlias = Variation_1299

    @classmethod
    def create(cls, arg : "RuleVariation_1228.cv_arg") -> "RuleVariation_1228":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1299:
        return self.arg # type: ignore

class NonSpare_549(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1228.cv_arg
    cv_name = "AA"
    cv_title = "Estimated Accuracy Of Acceleration (Cartesian)"
    cv_rule: TypeAlias = RuleVariation_1228

    @classmethod
    def create(cls, arg : "NonSpare_549.cv_arg") -> "NonSpare_549":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1228:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1299:
        return self.rule.variation

class Content_783(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ft/min"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 6.25
    cv_unit = "ft/min"

    def as_quantity(self, cv_unit : Optional[Literal["ft/min"]] = None) -> float:
        return self._as_quantity()

class RuleContent_782(RuleContentContextFree):
    cv_arg: TypeAlias = Content_783.cv_arg
    cv_content: TypeAlias = Content_783

    @property
    def content(self) -> Content_783:
        return self._get_content() # type: ignore

class Variation_242(Element):
    cv_arg: TypeAlias = RuleContent_782.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_782

    @classmethod
    def create(cls, arg: "Variation_242.cv_arg") -> "Variation_242":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_782:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_783:
        return self.rule.content

class RuleVariation_235(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_242.cv_arg
    cv_variation: TypeAlias = Variation_242

    @classmethod
    def create(cls, arg : "RuleVariation_235.cv_arg") -> "RuleVariation_235":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_242:
        return self.arg # type: ignore

class NonSpare_630(NonSpare):
    cv_arg: TypeAlias = RuleVariation_235.cv_arg
    cv_name = "ARC"
    cv_title = "Estimated Accuracy Of Rate Of Climb/Descent"
    cv_rule: TypeAlias = RuleVariation_235

    @classmethod
    def create(cls, arg : "NonSpare_630.cv_arg") -> "NonSpare_630":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_235:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_242:
        return self.rule.variation

class Variation_1475(Compound):
    cv_arg = TypedDict('cv_arg', {
        "APC": NonSpare_615.cv_arg,
        "COV": NonSpare_802.cv_arg,
        "APW": NonSpare_620.cv_arg,
        "AGA": NonSpare_581.cv_arg,
        "ABA": NonSpare_553.cv_arg,
        "ATV": NonSpare_646.cv_arg,
        "AA": NonSpare_549.cv_arg,
        "ARC": NonSpare_630.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [NonSpare_615, NonSpare_802, NonSpare_620, NonSpare_581, NonSpare_553, NonSpare_646, NonSpare_549, NonSpare_630]
    cv_items_dict = {"APC": NonSpare_615, "COV": NonSpare_802, "APW": NonSpare_620, "AGA": NonSpare_581, "ABA": NonSpare_553, "ATV": NonSpare_646, "AA": NonSpare_549, "ARC": NonSpare_630}

    @overload
    @classmethod
    def spec(cls, key : Literal["APC"]) -> NonSpare_615:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COV"]) -> NonSpare_802:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["APW"]) -> NonSpare_620:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AGA"]) -> NonSpare_581:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ABA"]) -> NonSpare_553:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ATV"]) -> NonSpare_646:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AA"]) -> NonSpare_549:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> NonSpare_630:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["APC"], Literal["COV"], Literal["APW"], Literal["AGA"], Literal["ABA"], Literal["ATV"], Literal["AA"], Literal["ARC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["APC"]) -> Optional[NonSpare_615]:
        ...
    @overload
    def get_item(self, key : Literal["COV"]) -> Optional[NonSpare_802]:
        ...
    @overload
    def get_item(self, key : Literal["APW"]) -> Optional[NonSpare_620]:
        ...
    @overload
    def get_item(self, key : Literal["AGA"]) -> Optional[NonSpare_581]:
        ...
    @overload
    def get_item(self, key : Literal["ABA"]) -> Optional[NonSpare_553]:
        ...
    @overload
    def get_item(self, key : Literal["ATV"]) -> Optional[NonSpare_646]:
        ...
    @overload
    def get_item(self, key : Literal["AA"]) -> Optional[NonSpare_549]:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> Optional[NonSpare_630]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["APC"], val : NonSpare_615.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["COV"], val : NonSpare_802.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["APW"], val : NonSpare_620.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["AGA"], val : NonSpare_581.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["ABA"], val : NonSpare_553.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["ATV"], val : NonSpare_646.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["AA"], val : NonSpare_549.cv_arg) -> "Variation_1475":
        ...
    @overload
    def set_item(self, key : Literal["ARC"], val : NonSpare_630.cv_arg) -> "Variation_1475":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["APC"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["COV"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["APW"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["AGA"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["ABA"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["ATV"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["AA"]) -> "Variation_1475":
        ...
    @overload
    def del_item(self, key : Literal["ARC"]) -> "Variation_1475":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1475.cv_arg") -> 'Variation_1475':
        return cls._create(arg) # type: ignore

class RuleVariation_1396(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1475.cv_arg
    cv_variation: TypeAlias = Variation_1475

    @classmethod
    def create(cls, arg : "RuleVariation_1396.cv_arg") -> "RuleVariation_1396":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1475:
        return self.arg # type: ignore

class NonSpare_515(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1396.cv_arg
    cv_name = "500"
    cv_title = "Estimated Accuracies"
    cv_rule: TypeAlias = RuleVariation_1396

    @classmethod
    def create(cls, arg : "NonSpare_515.cv_arg") -> "NonSpare_515":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1396:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1475:
        return self.rule.variation

class UapItem_514(UapItem):
    cv_non_spare: TypeAlias = NonSpare_515

class NonSpare_1713(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "SID"
    cv_title = "Sensor Identification"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_1713.cv_arg") -> "NonSpare_1713":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class NonSpare_1591(NonSpare):
    cv_arg: TypeAlias = RuleVariation_329.cv_arg
    cv_name = "RHO"
    cv_title = "Measured Distance"
    cv_rule: TypeAlias = RuleVariation_329

    @classmethod
    def create(cls, arg : "NonSpare_1591.cv_arg") -> "NonSpare_1591":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_329:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_336:
        return self.rule.variation

class Item_816(Item):
    cv_arg: TypeAlias = NonSpare_1591.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1591

    @classmethod
    def create(cls, arg : "Item_816.cv_arg") -> "Item_816":
        return cls._create(arg) # type: ignore

class NonSpare_1856(NonSpare):
    cv_arg: TypeAlias = RuleVariation_336.cv_arg
    cv_name = "THETA"
    cv_title = "Measured Azimuth"
    cv_rule: TypeAlias = RuleVariation_336

    @classmethod
    def create(cls, arg : "NonSpare_1856.cv_arg") -> "NonSpare_1856":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_336:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_343:
        return self.rule.variation

class Item_994(Item):
    cv_arg: TypeAlias = NonSpare_1856.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1856

    @classmethod
    def create(cls, arg : "Item_994.cv_arg") -> "Item_994":
        return cls._create(arg) # type: ignore

class Variation_1180(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_329.cv_arg, Tuple[Literal["RHO"], RuleVariation_329.cv_arg]], Union[RuleVariation_336.cv_arg, Tuple[Literal["THETA"], RuleVariation_336.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1180.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_816, 16), (Item_994, 16)]
    cv_items_dict = {"RHO": RuleVariation_329, "THETA": RuleVariation_336}

    @overload
    @classmethod
    def spec(cls, key : Literal["RHO"]) -> RuleVariation_329:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["THETA"]) -> RuleVariation_336:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["RHO"], Literal["THETA"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["RHO"]) -> RuleVariation_329:
        ...
    @overload
    def get_item(self, key : Literal["THETA"]) -> RuleVariation_336:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1180.cv_arg") -> 'Variation_1180':
        return cls._create(arg) # type: ignore

class RuleVariation_1131(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1180.cv_arg
    cv_variation: TypeAlias = Variation_1180

    @classmethod
    def create(cls, arg : "RuleVariation_1131.cv_arg") -> "RuleVariation_1131":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1180:
        return self.arg # type: ignore

class NonSpare_1444(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1131.cv_arg
    cv_name = "POS"
    cv_title = "Measured Position"
    cv_rule: TypeAlias = RuleVariation_1131

    @classmethod
    def create(cls, arg : "NonSpare_1444.cv_arg") -> "NonSpare_1444":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1131:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1180:
        return self.rule.variation

class NonSpare_1064(NonSpare):
    cv_arg: TypeAlias = RuleVariation_303.cv_arg
    cv_name = "HEIGHT"
    cv_title = "Measured 3-D Height"
    cv_rule: TypeAlias = RuleVariation_303

    @classmethod
    def create(cls, arg : "NonSpare_1064.cv_arg") -> "NonSpare_1064":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_303:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_310:
        return self.rule.variation

class Content_656(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_656(RuleContentContextFree):
    cv_arg: TypeAlias = Content_656.cv_arg
    cv_content: TypeAlias = Content_656

    @property
    def content(self) -> Content_656:
        return self._get_content() # type: ignore

class Variation_610(Element):
    cv_arg: TypeAlias = RuleContent_656.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 14
    cv_rule = RuleContent_656

    @classmethod
    def create(cls, arg: "Variation_610.cv_arg") -> "Variation_610":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_656:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_656:
        return self.rule.content

class RuleVariation_599(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_610.cv_arg
    cv_variation: TypeAlias = Variation_610

    @classmethod
    def create(cls, arg : "RuleVariation_599.cv_arg") -> "RuleVariation_599":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_610:
        return self.arg # type: ignore

class NonSpare_1172(NonSpare):
    cv_arg: TypeAlias = RuleVariation_599.cv_arg
    cv_name = "LMC"
    cv_title = "Last Measured Mode C Code"
    cv_rule: TypeAlias = RuleVariation_599

    @classmethod
    def create(cls, arg : "NonSpare_1172.cv_arg") -> "NonSpare_1172":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_599:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_610:
        return self.rule.variation

class Item_482(Item):
    cv_arg: TypeAlias = NonSpare_1172.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1172

    @classmethod
    def create(cls, arg : "Item_482.cv_arg") -> "Item_482":
        return cls._create(arg) # type: ignore

class Variation_1277(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_599.cv_arg, Tuple[Literal["LMC"], RuleVariation_599.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1277.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_482, 14)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "LMC": RuleVariation_599}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LMC"]) -> RuleVariation_599:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["LMC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["LMC"]) -> RuleVariation_599:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1277.cv_arg") -> 'Variation_1277':
        return cls._create(arg) # type: ignore

class RuleVariation_1206(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1277.cv_arg
    cv_variation: TypeAlias = Variation_1277

    @classmethod
    def create(cls, arg : "RuleVariation_1206.cv_arg") -> "RuleVariation_1206":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1277:
        return self.arg # type: ignore

class NonSpare_1255(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1206.cv_arg
    cv_name = "MDC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_1206

    @classmethod
    def create(cls, arg : "NonSpare_1255.cv_arg") -> "NonSpare_1255":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1206:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1277:
        return self.rule.variation

class Content_279(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Mode 3/A code as derived from the reply of the transponder", 1: "Mode 3/A code as provided by a sensor local tracker"}

class RuleContent_279(RuleContentContextFree):
    cv_arg: TypeAlias = Content_279.cv_arg
    cv_content: TypeAlias = Content_279

    @property
    def content(self) -> Content_279:
        return self._get_content() # type: ignore

class Variation_545(Element):
    cv_arg: TypeAlias = RuleContent_279.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_279

    @classmethod
    def create(cls, arg: "Variation_545.cv_arg") -> "Variation_545":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_279:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_279:
        return self.rule.content

class RuleVariation_534(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_545.cv_arg
    cv_variation: TypeAlias = Variation_545

    @classmethod
    def create(cls, arg : "RuleVariation_534.cv_arg") -> "RuleVariation_534":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_545:
        return self.arg # type: ignore

class NonSpare_1133(NonSpare):
    cv_arg: TypeAlias = RuleVariation_534.cv_arg
    cv_name = "L"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_534

    @classmethod
    def create(cls, arg : "NonSpare_1133.cv_arg") -> "NonSpare_1133":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_534:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_545:
        return self.rule.variation

class Item_445(Item):
    cv_arg: TypeAlias = NonSpare_1133.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1133

    @classmethod
    def create(cls, arg : "Item_445.cv_arg") -> "Item_445":
        return cls._create(arg) # type: ignore

class Variation_1272(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_15.cv_arg, Tuple[Literal["V"], RuleVariation_15.cv_arg]], Union[RuleVariation_396.cv_arg, Tuple[Literal["G"], RuleVariation_396.cv_arg]], Union[RuleVariation_534.cv_arg, Tuple[Literal["L"], RuleVariation_534.cv_arg]], int, Union[RuleVariation_779.cv_arg, Tuple[Literal["MODE3A"], RuleVariation_779.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1272.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_1103, 1), (Item_357, 1), (Item_445, 1), (Item_16, 1), (Item_575, 12)]
    cv_items_dict = {"V": RuleVariation_15, "G": RuleVariation_396, "L": RuleVariation_534, "MODE3A": RuleVariation_779}

    @overload
    @classmethod
    def spec(cls, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["L"]) -> RuleVariation_534:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["V"], Literal["G"], Literal["L"], Literal["MODE3A"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["V"]) -> RuleVariation_15:
        ...
    @overload
    def get_item(self, key : Literal["G"]) -> RuleVariation_396:
        ...
    @overload
    def get_item(self, key : Literal["L"]) -> RuleVariation_534:
        ...
    @overload
    def get_item(self, key : Literal["MODE3A"]) -> RuleVariation_779:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1272.cv_arg") -> 'Variation_1272':
        return cls._create(arg) # type: ignore

class RuleVariation_1201(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1272.cv_arg
    cv_variation: TypeAlias = Variation_1272

    @classmethod
    def create(cls, arg : "RuleVariation_1201.cv_arg") -> "RuleVariation_1201":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1272:
        return self.arg # type: ignore

class NonSpare_1251(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1201.cv_arg
    cv_name = "MDA"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_1201

    @classmethod
    def create(cls, arg : "NonSpare_1251.cv_arg") -> "NonSpare_1251":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1201:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1272:
        return self.rule.variation

class Content_345(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No detection", 1: "Single PSR detection", 2: "Single SSR detection", 3: "SSR + PSR detection", 4: "Single ModeS All-Call", 5: "Single ModeS Roll-Call", 6: "ModeS All-Call + PSR", 7: "ModeS Roll-Call + PSR"}

class RuleContent_345(RuleContentContextFree):
    cv_arg: TypeAlias = Content_345.cv_arg
    cv_content: TypeAlias = Content_345

    @property
    def content(self) -> Content_345:
        return self._get_content() # type: ignore

class Variation_126(Element):
    cv_arg: TypeAlias = RuleContent_345.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 3
    cv_rule = RuleContent_345

    @classmethod
    def create(cls, arg: "Variation_126.cv_arg") -> "Variation_126":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_345:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_345:
        return self.rule.content

class RuleVariation_126(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_126.cv_arg
    cv_variation: TypeAlias = Variation_126

    @classmethod
    def create(cls, arg : "RuleVariation_126.cv_arg") -> "RuleVariation_126":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_126:
        return self.arg # type: ignore

class NonSpare_1967(NonSpare):
    cv_arg: TypeAlias = RuleVariation_126.cv_arg
    cv_name = "TYP"
    cv_title = "Report Type"
    cv_rule: TypeAlias = RuleVariation_126

    @classmethod
    def create(cls, arg : "NonSpare_1967.cv_arg") -> "NonSpare_1967":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_126:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_126:
        return self.rule.variation

class Item_1080(Item):
    cv_arg: TypeAlias = NonSpare_1967.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1967

    @classmethod
    def create(cls, arg : "Item_1080.cv_arg") -> "Item_1080":
        return cls._create(arg) # type: ignore

class Content_443(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Report from target transponder", 1: "Report from field monitor (item transponder)"}

class RuleContent_443(RuleContentContextFree):
    cv_arg: TypeAlias = Content_443.cv_arg
    cv_content: TypeAlias = Content_443

    @property
    def content(self) -> Content_443:
        return self._get_content() # type: ignore

class Variation_750(Element):
    cv_arg: TypeAlias = RuleContent_443.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_443

    @classmethod
    def create(cls, arg: "Variation_750.cv_arg") -> "Variation_750":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_443:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_443:
        return self.rule.content

class RuleVariation_739(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_750.cv_arg
    cv_variation: TypeAlias = Variation_750

    @classmethod
    def create(cls, arg : "RuleVariation_739.cv_arg") -> "RuleVariation_739":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_750:
        return self.arg # type: ignore

class NonSpare_1538(NonSpare):
    cv_arg: TypeAlias = RuleVariation_739.cv_arg
    cv_name = "RAB"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_739

    @classmethod
    def create(cls, arg : "NonSpare_1538.cv_arg") -> "NonSpare_1538":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_739:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_750:
        return self.rule.variation

class Item_768(Item):
    cv_arg: TypeAlias = NonSpare_1538.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1538

    @classmethod
    def create(cls, arg : "Item_768.cv_arg") -> "Item_768":
        return cls._create(arg) # type: ignore

class Variation_870(Element):
    cv_arg: TypeAlias = RuleContent_437.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_437

    @classmethod
    def create(cls, arg: "Variation_870.cv_arg") -> "Variation_870":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_437:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_437:
        return self.rule.content

class RuleVariation_840(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_870.cv_arg
    cv_variation: TypeAlias = Variation_870

    @classmethod
    def create(cls, arg : "RuleVariation_840.cv_arg") -> "RuleVariation_840":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_870:
        return self.arg # type: ignore

class NonSpare_1937(NonSpare):
    cv_arg: TypeAlias = RuleVariation_840.cv_arg
    cv_name = "TST"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_840

    @classmethod
    def create(cls, arg : "NonSpare_1937.cv_arg") -> "NonSpare_1937":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_840:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_870:
        return self.rule.variation

class Item_1054(Item):
    cv_arg: TypeAlias = NonSpare_1937.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1937

    @classmethod
    def create(cls, arg : "Item_1054.cv_arg") -> "Item_1054":
        return cls._create(arg) # type: ignore

class Variation_1239(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_126.cv_arg, Tuple[Literal["TYP"], RuleVariation_126.cv_arg]], Union[RuleVariation_604.cv_arg, Tuple[Literal["SIM"], RuleVariation_604.cv_arg]], Union[RuleVariation_739.cv_arg, Tuple[Literal["RAB"], RuleVariation_739.cv_arg]], Union[RuleVariation_840.cv_arg, Tuple[Literal["TST"], RuleVariation_840.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1239.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_1080, 3), (Item_901, 1), (Item_768, 1), (Item_1054, 1), (Item_27, 2)]
    cv_items_dict = {"TYP": RuleVariation_126, "SIM": RuleVariation_604, "RAB": RuleVariation_739, "TST": RuleVariation_840}

    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> RuleVariation_126:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SIM"]) -> RuleVariation_604:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAB"]) -> RuleVariation_739:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TST"]) -> RuleVariation_840:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TYP"], Literal["SIM"], Literal["RAB"], Literal["TST"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TYP"]) -> RuleVariation_126:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> RuleVariation_604:
        ...
    @overload
    def get_item(self, key : Literal["RAB"]) -> RuleVariation_739:
        ...
    @overload
    def get_item(self, key : Literal["TST"]) -> RuleVariation_840:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1239.cv_arg") -> 'Variation_1239':
        return cls._create(arg) # type: ignore

class RuleVariation_1175(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1239.cv_arg
    cv_variation: TypeAlias = Variation_1239

    @classmethod
    def create(cls, arg : "RuleVariation_1175.cv_arg") -> "RuleVariation_1175":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1239:
        return self.arg # type: ignore

class NonSpare_1964(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1175.cv_arg
    cv_name = "TYP"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_1175

    @classmethod
    def create(cls, arg : "NonSpare_1964.cv_arg") -> "NonSpare_1964":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1175:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1239:
        return self.rule.variation

class Variation_1507(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SID": NonSpare_1713.cv_arg,
        "POS": NonSpare_1444.cv_arg,
        "HEIGHT": NonSpare_1064.cv_arg,
        "MDC": NonSpare_1255.cv_arg,
        "MDA": NonSpare_1251.cv_arg,
        "TYP": NonSpare_1964.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1713, NonSpare_1444, NonSpare_1064, NonSpare_1255, NonSpare_1251, NonSpare_1964]
    cv_items_dict = {"SID": NonSpare_1713, "POS": NonSpare_1444, "HEIGHT": NonSpare_1064, "MDC": NonSpare_1255, "MDA": NonSpare_1251, "TYP": NonSpare_1964}

    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> NonSpare_1713:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1444:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HEIGHT"]) -> NonSpare_1064:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDC"]) -> NonSpare_1255:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> NonSpare_1964:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SID"], Literal["POS"], Literal["HEIGHT"], Literal["MDC"], Literal["MDA"], Literal["TYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SID"]) -> Optional[NonSpare_1713]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1444]:
        ...
    @overload
    def get_item(self, key : Literal["HEIGHT"]) -> Optional[NonSpare_1064]:
        ...
    @overload
    def get_item(self, key : Literal["MDC"]) -> Optional[NonSpare_1255]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1251]:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> Optional[NonSpare_1964]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SID"], val : NonSpare_1713.cv_arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1444.cv_arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["HEIGHT"], val : NonSpare_1064.cv_arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["MDC"], val : NonSpare_1255.cv_arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1251.cv_arg) -> "Variation_1507":
        ...
    @overload
    def set_item(self, key : Literal["TYP"], val : NonSpare_1964.cv_arg) -> "Variation_1507":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SID"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["HEIGHT"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["MDC"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1507":
        ...
    @overload
    def del_item(self, key : Literal["TYP"]) -> "Variation_1507":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1507.cv_arg") -> 'Variation_1507':
        return cls._create(arg) # type: ignore

class RuleVariation_1428(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1507.cv_arg
    cv_variation: TypeAlias = Variation_1507

    @classmethod
    def create(cls, arg : "RuleVariation_1428.cv_arg") -> "RuleVariation_1428":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1507:
        return self.arg # type: ignore

class NonSpare_482(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1428.cv_arg
    cv_name = "340"
    cv_title = "Measured Information"
    cv_rule: TypeAlias = RuleVariation_1428

    @classmethod
    def create(cls, arg : "NonSpare_482.cv_arg") -> "NonSpare_482":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1428:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1507:
        return self.rule.variation

class UapItem_482(UapItem):
    cv_non_spare: TypeAlias = NonSpare_482

class Record_42(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_46.cv_arg,
        "015": NonSpare_59.cv_arg,
        "070": NonSpare_217.cv_arg,
        "105": NonSpare_281.cv_arg,
        "100": NonSpare_268.cv_arg,
        "185": NonSpare_386.cv_arg,
        "210": NonSpare_410.cv_arg,
        "060": NonSpare_202.cv_arg,
        "245": NonSpare_440.cv_arg,
        "380": NonSpare_485.cv_arg,
        "040": NonSpare_149.cv_arg,
        "080": NonSpare_239.cv_arg,
        "290": NonSpare_470.cv_arg,
        "200": NonSpare_394.cv_arg,
        "295": NonSpare_473.cv_arg,
        "136": NonSpare_320.cv_arg,
        "130": NonSpare_306.cv_arg,
        "135": NonSpare_319.cv_arg,
        "220": NonSpare_422.cv_arg,
        "390": NonSpare_493.cv_arg,
        "270": NonSpare_462.cv_arg,
        "300": NonSpare_477.cv_arg,
        "110": NonSpare_289.cv_arg,
        "120": NonSpare_305.cv_arg,
        "510": NonSpare_520.cv_arg,
        "500": NonSpare_515.cv_arg,
        "340": NonSpare_482.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_46, UapItem_549, UapItem_59, UapItem_217, UapItem_281, UapItem_268, UapItem_386, UapItem_410, UapItem_202, UapItem_440, UapItem_485, UapItem_149, UapItem_239, UapItem_470, UapItem_394, UapItem_473, UapItem_320, UapItem_306, UapItem_319, UapItem_422, UapItem_493, UapItem_462, UapItem_477, UapItem_289, UapItem_305, UapItem_519, UapItem_514, UapItem_482, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_46, "015": NonSpare_59, "070": NonSpare_217, "105": NonSpare_281, "100": NonSpare_268, "185": NonSpare_386, "210": NonSpare_410, "060": NonSpare_202, "245": NonSpare_440, "380": NonSpare_485, "040": NonSpare_149, "080": NonSpare_239, "290": NonSpare_470, "200": NonSpare_394, "295": NonSpare_473, "136": NonSpare_320, "130": NonSpare_306, "135": NonSpare_319, "220": NonSpare_422, "390": NonSpare_493, "270": NonSpare_462, "300": NonSpare_477, "110": NonSpare_289, "120": NonSpare_305, "510": NonSpare_520, "500": NonSpare_515, "340": NonSpare_482, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_281:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_386:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_410:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_202:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_485:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_149:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_239:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_470:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_320:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_493:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_462:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_520:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_482:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_46]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_59]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_217]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_281]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_268]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_386]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_410]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_202]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_485]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_149]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_239]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_470]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_394]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_473]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_320]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_422]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_493]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_462]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_520]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_482]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_46.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_59.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_217.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_281.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_268.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_386.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_410.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_202.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_440.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_485.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_149.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_239.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_470.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_394.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_473.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_320.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_319.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_422.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_493.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_462.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_305.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_520.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_515.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_482.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_42':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_42':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_42':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_42':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_42.cv_arg") -> 'Record_42':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_42", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_38(UapSingle):
    cv_arg: TypeAlias = Record_42
    cv_record: TypeAlias = Record_42

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_42]]:
        return cls._parse(bs)

class Asterix_53(AstCat):
    cv_category = 62
    cv_edition = (1, 17)
    cv_uap: TypeAlias = Uap_38
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_38.cv_arg]) -> "Asterix_53":
        return cls._create(records) # type: ignore

class Content_323(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No alert, no SPI, aircraft airborne", 1: "No alert, no SPI, aircraft on ground", 2: "Alert, no SPI, aircraft airborne", 3: "Alert, no SPI, aircraft on ground", 4: "Alert, SPI, aircraft airborne or on ground", 5: "No alert, SPI, aircraft airborne or on ground", 6: "Not defined", 7: "Unknown or not yet extracted"}

class RuleContent_323(RuleContentContextFree):
    cv_arg: TypeAlias = Content_323.cv_arg
    cv_content: TypeAlias = Content_323

    @property
    def content(self) -> Content_323:
        return self._get_content() # type: ignore

class Variation_686(Element):
    cv_arg: TypeAlias = RuleContent_323.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 3
    cv_rule = RuleContent_323

    @classmethod
    def create(cls, arg: "Variation_686.cv_arg") -> "Variation_686":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_323:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_323:
        return self.rule.content

class RuleVariation_675(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_686.cv_arg
    cv_variation: TypeAlias = Variation_686

    @classmethod
    def create(cls, arg : "RuleVariation_675.cv_arg") -> "RuleVariation_675":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_686:
        return self.arg # type: ignore

class NonSpare_1777(NonSpare):
    cv_arg: TypeAlias = RuleVariation_675.cv_arg
    cv_name = "STAT"
    cv_title = "Flight Status"
    cv_rule: TypeAlias = RuleVariation_675

    @classmethod
    def create(cls, arg : "NonSpare_1777.cv_arg") -> "NonSpare_1777":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_675:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_686:
        return self.rule.variation

class Item_938(Item):
    cv_arg: TypeAlias = NonSpare_1777.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1777

    @classmethod
    def create(cls, arg : "Item_938.cv_arg") -> "Item_938":
        return cls._create(arg) # type: ignore

class Variation_1078(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_124.cv_arg, Tuple[Literal["COM"], RuleVariation_124.cv_arg]], Union[RuleVariation_675.cv_arg, Tuple[Literal["STAT"], RuleVariation_675.cv_arg]], int, Union[RuleVariation_56.cv_arg, Tuple[Literal["SSC"], RuleVariation_56.cv_arg]], Union[RuleVariation_390.cv_arg, Tuple[Literal["ARC"], RuleVariation_390.cv_arg]], Union[RuleVariation_547.cv_arg, Tuple[Literal["AIC"], RuleVariation_547.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["B1A"], RuleVariation_603.cv_arg]], Union[RuleVariation_769.cv_arg, Tuple[Literal["B1B"], RuleVariation_769.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1078.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_188, 3), (Item_938, 3), (Item_27, 2), (Item_926, 1), (Item_81, 1), (Item_55, 1), (Item_109, 1), (Item_112, 4)]
    cv_items_dict = {"COM": RuleVariation_124, "STAT": RuleVariation_675, "SSC": RuleVariation_56, "ARC": RuleVariation_390, "AIC": RuleVariation_547, "B1A": RuleVariation_603, "B1B": RuleVariation_769}

    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STAT"]) -> RuleVariation_675:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["COM"], Literal["STAT"], Literal["SSC"], Literal["ARC"], Literal["AIC"], Literal["B1A"], Literal["B1B"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["COM"]) -> RuleVariation_124:
        ...
    @overload
    def get_item(self, key : Literal["STAT"]) -> RuleVariation_675:
        ...
    @overload
    def get_item(self, key : Literal["SSC"]) -> RuleVariation_56:
        ...
    @overload
    def get_item(self, key : Literal["ARC"]) -> RuleVariation_390:
        ...
    @overload
    def get_item(self, key : Literal["AIC"]) -> RuleVariation_547:
        ...
    @overload
    def get_item(self, key : Literal["B1A"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["B1B"]) -> RuleVariation_769:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1078.cv_arg") -> 'Variation_1078':
        return cls._create(arg) # type: ignore

class RuleVariation_1038(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1078.cv_arg
    cv_variation: TypeAlias = Variation_1078

    @classmethod
    def create(cls, arg : "RuleVariation_1038.cv_arg") -> "RuleVariation_1038":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1078:
        return self.arg # type: ignore

class NonSpare_788(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1038.cv_arg
    cv_name = "COM"
    cv_title = "Communications/ACAS Capability and Flight Status"
    cv_rule: TypeAlias = RuleVariation_1038

    @classmethod
    def create(cls, arg : "NonSpare_788.cv_arg") -> "NonSpare_788":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1038:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1078:
        return self.rule.variation

class Variation_1468(Compound):
    cv_arg = TypedDict('cv_arg', {
        "ADR": NonSpare_572.cv_arg,
        "ID": NonSpare_1111.cv_arg,
        "MHG": NonSpare_1280.cv_arg,
        "IAS": NonSpare_1104.cv_arg,
        "TAS": NonSpare_1831.cv_arg,
        "SAL": NonSpare_1658.cv_arg,
        "FSS": NonSpare_1002.cv_arg,
        "TIS": NonSpare_1872.cv_arg,
        "TID": NonSpare_1867.cv_arg,
        "COM": NonSpare_788.cv_arg,
        "SAB": NonSpare_1652.cv_arg,
        "ACS": NonSpare_564.cv_arg,
        "BVR": NonSpare_696.cv_arg,
        "GVR": NonSpare_1049.cv_arg,
        "RAN": NonSpare_1548.cv_arg,
        "TAR": NonSpare_1826.cv_arg,
        "TAN": NonSpare_1821.cv_arg,
        "GS": NonSpare_1038.cv_arg,
        "VUN": NonSpare_2045.cv_arg,
        "MET": NonSpare_1272.cv_arg,
        "EMC": NonSpare_929.cv_arg,
        "POS": NonSpare_1449.cv_arg,
        "GAL": NonSpare_1019.cv_arg,
        "PUN": NonSpare_1485.cv_arg,
        "MB": NonSpare_1232.cv_arg,
        "IAR": NonSpare_1100.cv_arg,
        "MAC": NonSpare_1222.cv_arg,
        "BPS": NonSpare_694.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_572, NonSpare_1111, NonSpare_1280, NonSpare_1104, NonSpare_1831, NonSpare_1658, NonSpare_1002, NonSpare_1872, NonSpare_1867, NonSpare_788, NonSpare_1652, NonSpare_564, NonSpare_696, NonSpare_1049, NonSpare_1548, NonSpare_1826, NonSpare_1821, NonSpare_1038, NonSpare_2045, NonSpare_1272, NonSpare_929, NonSpare_1449, NonSpare_1019, NonSpare_1485, NonSpare_1232, NonSpare_1100, NonSpare_1222, NonSpare_694]
    cv_items_dict = {"ADR": NonSpare_572, "ID": NonSpare_1111, "MHG": NonSpare_1280, "IAS": NonSpare_1104, "TAS": NonSpare_1831, "SAL": NonSpare_1658, "FSS": NonSpare_1002, "TIS": NonSpare_1872, "TID": NonSpare_1867, "COM": NonSpare_788, "SAB": NonSpare_1652, "ACS": NonSpare_564, "BVR": NonSpare_696, "GVR": NonSpare_1049, "RAN": NonSpare_1548, "TAR": NonSpare_1826, "TAN": NonSpare_1821, "GS": NonSpare_1038, "VUN": NonSpare_2045, "MET": NonSpare_1272, "EMC": NonSpare_929, "POS": NonSpare_1449, "GAL": NonSpare_1019, "PUN": NonSpare_1485, "MB": NonSpare_1232, "IAR": NonSpare_1100, "MAC": NonSpare_1222, "BPS": NonSpare_694}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1104:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1658:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_1002:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1872:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1867:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_788:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1652:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1049:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1548:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1826:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1821:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1038:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2045:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_929:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1019:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1485:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1232:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_694:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_572]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1111]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1280]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1104]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1831]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1658]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_1002]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1872]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1867]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_788]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1652]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_564]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_696]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1049]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1548]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1826]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1821]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1038]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2045]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1272]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_929]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1449]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1019]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1485]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1232]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1100]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_694]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_572.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1111.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1280.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1104.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1831.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1658.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_1002.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1872.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1867.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_788.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1652.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_564.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_696.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1049.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1548.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1826.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1821.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1038.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2045.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1272.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_929.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1449.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1019.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1485.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1232.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1100.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1222.cv_arg) -> "Variation_1468":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_694.cv_arg) -> "Variation_1468":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1468":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1468":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1468.cv_arg") -> 'Variation_1468':
        return cls._create(arg) # type: ignore

class RuleVariation_1389(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1468.cv_arg
    cv_variation: TypeAlias = Variation_1468

    @classmethod
    def create(cls, arg : "RuleVariation_1389.cv_arg") -> "RuleVariation_1389":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1468:
        return self.arg # type: ignore

class NonSpare_488(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1389.cv_arg
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule: TypeAlias = RuleVariation_1389

    @classmethod
    def create(cls, arg : "NonSpare_488.cv_arg") -> "NonSpare_488":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1389:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1468:
        return self.rule.variation

class UapItem_488(UapItem):
    cv_non_spare: TypeAlias = NonSpare_488

class Content_193(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Surface target"}

class RuleContent_193(RuleContentContextFree):
    cv_arg: TypeAlias = Content_193.cv_arg
    cv_content: TypeAlias = Content_193

    @property
    def content(self) -> Content_193:
        return self._get_content() # type: ignore

class Variation_637(Element):
    cv_arg: TypeAlias = RuleContent_193.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_193

    @classmethod
    def create(cls, arg: "Variation_637.cv_arg") -> "Variation_637":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_193:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_193:
        return self.rule.content

class RuleVariation_626(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_637.cv_arg
    cv_variation: TypeAlias = Variation_637

    @classmethod
    def create(cls, arg : "RuleVariation_626.cv_arg") -> "RuleVariation_626":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_637:
        return self.arg # type: ignore

class Content_363(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No indication", 1: "Duplicate Flight-ID"}

class RuleContent_363(RuleContentContextFree):
    cv_arg: TypeAlias = Content_363.cv_arg
    cv_content: TypeAlias = Content_363

    @property
    def content(self) -> Content_363:
        return self._get_content() # type: ignore

class Variation_740(Element):
    cv_arg: TypeAlias = RuleContent_363.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_363

    @classmethod
    def create(cls, arg: "Variation_740.cv_arg") -> "Variation_740":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_363:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_363:
        return self.rule.content

class RuleVariation_729(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_740.cv_arg
    cv_variation: TypeAlias = Variation_740

    @classmethod
    def create(cls, arg : "RuleVariation_729.cv_arg") -> "RuleVariation_729":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_740:
        return self.arg # type: ignore

class Content_186(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Inconsistent Emergency Code"}

class RuleContent_186(RuleContentContextFree):
    cv_arg: TypeAlias = Content_186.cv_arg
    cv_content: TypeAlias = Content_186

    @property
    def content(self) -> Content_186:
        return self._get_content() # type: ignore

class Variation_844(Element):
    cv_arg: TypeAlias = RuleContent_186.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_186

    @classmethod
    def create(cls, arg: "Variation_844.cv_arg") -> "Variation_844":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_186:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_186:
        return self.rule.content

class RuleVariation_814(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_844.cv_arg
    cv_variation: TypeAlias = Variation_844

    @classmethod
    def create(cls, arg : "RuleVariation_814.cv_arg") -> "RuleVariation_814":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_844:
        return self.arg # type: ignore

class NonSpare_1703(NonSpare):
    cv_arg: TypeAlias = RuleVariation_626.cv_arg
    cv_name = "SFC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_626

    @classmethod
    def create(cls, arg : "NonSpare_1703.cv_arg") -> "NonSpare_1703":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_626:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_637:
        return self.rule.variation

class Item_882(Item):
    cv_arg: TypeAlias = NonSpare_1703.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1703

    @classmethod
    def create(cls, arg : "Item_882.cv_arg") -> "Item_882":
        return cls._create(arg) # type: ignore

class NonSpare_1112(NonSpare):
    cv_arg: TypeAlias = RuleVariation_729.cv_arg
    cv_name = "IDD"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_729

    @classmethod
    def create(cls, arg : "NonSpare_1112.cv_arg") -> "NonSpare_1112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_729:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_740:
        return self.rule.variation

class Item_429(Item):
    cv_arg: TypeAlias = NonSpare_1112.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1112

    @classmethod
    def create(cls, arg : "Item_429.cv_arg") -> "Item_429":
        return cls._create(arg) # type: ignore

class NonSpare_1116(NonSpare):
    cv_arg: TypeAlias = RuleVariation_814.cv_arg
    cv_name = "IEC"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_814

    @classmethod
    def create(cls, arg : "NonSpare_1116.cv_arg") -> "NonSpare_1116":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_814:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_844:
        return self.rule.variation

class Item_433(Item):
    cv_arg: TypeAlias = NonSpare_1116.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1116

    @classmethod
    def create(cls, arg : "Item_433.cv_arg") -> "Item_433":
        return cls._create(arg) # type: ignore

class Variation_1369(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_55.cv_arg, Tuple[Literal["MON"], RuleVariation_55.cv_arg]], Union[RuleVariation_412.cv_arg, Tuple[Literal["SPI"], RuleVariation_412.cv_arg]], Union[RuleVariation_500.cv_arg, Tuple[Literal["MRH"], RuleVariation_500.cv_arg]], Union[RuleVariation_678.cv_arg, Tuple[Literal["SRC"], RuleVariation_678.cv_arg]], Union[RuleVariation_877.cv_arg, Tuple[Literal["CNF"], RuleVariation_877.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_6.cv_arg, Tuple[Literal["SIM"], RuleVariation_6.cv_arg]], Union[RuleVariation_411.cv_arg, Tuple[Literal["TSE"], RuleVariation_411.cv_arg]], Union[RuleVariation_520.cv_arg, Tuple[Literal["TSB"], RuleVariation_520.cv_arg]], Union[RuleVariation_647.cv_arg, Tuple[Literal["FPC"], RuleVariation_647.cv_arg]], Union[RuleVariation_705.cv_arg, Tuple[Literal["AFF"], RuleVariation_705.cv_arg]], Union[RuleVariation_816.cv_arg, Tuple[Literal["STP"], RuleVariation_816.cv_arg]], Union[RuleVariation_875.cv_arg, Tuple[Literal["KOS"], RuleVariation_875.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_90.cv_arg, Tuple[Literal["AMA"], RuleVariation_90.cv_arg]], Union[RuleVariation_458.cv_arg, Tuple[Literal["MD4"], RuleVariation_458.cv_arg]], Union[RuleVariation_625.cv_arg, Tuple[Literal["ME"], RuleVariation_625.cv_arg]], Union[RuleVariation_708.cv_arg, Tuple[Literal["MI"], RuleVariation_708.cv_arg]], Union[RuleVariation_852.cv_arg, Tuple[Literal["MD5"], RuleVariation_852.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_38.cv_arg, Tuple[Literal["CST"], RuleVariation_38.cv_arg]], Union[RuleVariation_409.cv_arg, Tuple[Literal["PSR"], RuleVariation_409.cv_arg]], Union[RuleVariation_517.cv_arg, Tuple[Literal["SSR"], RuleVariation_517.cv_arg]], Union[RuleVariation_624.cv_arg, Tuple[Literal["MDS"], RuleVariation_624.cv_arg]], Union[RuleVariation_707.cv_arg, Tuple[Literal["ADS"], RuleVariation_707.cv_arg]], Union[RuleVariation_817.cv_arg, Tuple[Literal["SUC"], RuleVariation_817.cv_arg]], Union[RuleVariation_893.cv_arg, Tuple[Literal["AAC"], RuleVariation_893.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_100.cv_arg, Tuple[Literal["SDS"], RuleVariation_100.cv_arg]], Union[RuleVariation_590.cv_arg, Tuple[Literal["EMS"], RuleVariation_590.cv_arg]], Union[RuleVariation_833.cv_arg, Tuple[Literal["PFT"], RuleVariation_833.cv_arg]], Union[RuleVariation_895.cv_arg, Tuple[Literal["FPLT"], RuleVariation_895.cv_arg]], None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_39.cv_arg, Tuple[Literal["DUPT"], RuleVariation_39.cv_arg]], Union[RuleVariation_410.cv_arg, Tuple[Literal["DUPF"], RuleVariation_410.cv_arg]], Union[RuleVariation_519.cv_arg, Tuple[Literal["DUPM"], RuleVariation_519.cv_arg]], Union[RuleVariation_626.cv_arg, Tuple[Literal["SFC"], RuleVariation_626.cv_arg]], Union[RuleVariation_729.cv_arg, Tuple[Literal["IDD"], RuleVariation_729.cv_arg]], Union[RuleVariation_814.cv_arg, Tuple[Literal["IEC"], RuleVariation_814.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1369.cv_arg_group_1"],
        Tuple["Variation_1369.cv_arg_group_1", "Variation_1369.cv_arg_group_2"],
        Tuple["Variation_1369.cv_arg_group_1", "Variation_1369.cv_arg_group_2", "Variation_1369.cv_arg_group_3"],
        Tuple["Variation_1369.cv_arg_group_1", "Variation_1369.cv_arg_group_2", "Variation_1369.cv_arg_group_3", "Variation_1369.cv_arg_group_4"],
        Tuple["Variation_1369.cv_arg_group_1", "Variation_1369.cv_arg_group_2", "Variation_1369.cv_arg_group_3", "Variation_1369.cv_arg_group_4", "Variation_1369.cv_arg_group_5"],
        Tuple["Variation_1369.cv_arg_group_1", "Variation_1369.cv_arg_group_2", "Variation_1369.cv_arg_group_3", "Variation_1369.cv_arg_group_4", "Variation_1369.cv_arg_group_5", "Variation_1369.cv_arg_group_6"],
    ]
    cv_items_list = [[(Item_579, 1), (Item_911, 1), (Item_582, 1), (Item_923, 3), (Item_167, 1), None], [(Item_899, 1), (Item_1046, 1), (Item_1044, 1), (Item_338, 1), (Item_50, 1), (Item_956, 1), (Item_442, 1), None], [(Item_71, 1), (Item_537, 2), (Item_544, 1), (Item_551, 1), (Item_538, 2), None], [(Item_221, 1), (Item_713, 1), (Item_928, 1), (Item_539, 1), (Item_46, 1), (Item_962, 1), (Item_34, 1), None], [(Item_875, 2), (Item_294, 3), (Item_681, 1), (Item_339, 1), None], [(Item_283, 1), (Item_281, 1), (Item_282, 1), (Item_882, 1), (Item_429, 1), (Item_433, 1), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1369.cv_arg") -> 'Variation_1369':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_412:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_500:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_678:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_877:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_6]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_411]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_520]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_647]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["STP"]) -> Optional[RuleVariation_816]:
        ...
    @overload
    def get_item(self, key : Literal["KOS"]) -> Optional[RuleVariation_875]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_90]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[RuleVariation_458]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_625]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_708]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[RuleVariation_852]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_38]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_624]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_707]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_817]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_893]:
        ...
    @overload
    def get_item(self, key : Literal["SDS"]) -> Optional[RuleVariation_100]:
        ...
    @overload
    def get_item(self, key : Literal["EMS"]) -> Optional[RuleVariation_590]:
        ...
    @overload
    def get_item(self, key : Literal["PFT"]) -> Optional[RuleVariation_833]:
        ...
    @overload
    def get_item(self, key : Literal["FPLT"]) -> Optional[RuleVariation_895]:
        ...
    @overload
    def get_item(self, key : Literal["DUPT"]) -> Optional[RuleVariation_39]:
        ...
    @overload
    def get_item(self, key : Literal["DUPF"]) -> Optional[RuleVariation_410]:
        ...
    @overload
    def get_item(self, key : Literal["DUPM"]) -> Optional[RuleVariation_519]:
        ...
    @overload
    def get_item(self, key : Literal["SFC"]) -> Optional[RuleVariation_626]:
        ...
    @overload
    def get_item(self, key : Literal["IDD"]) -> Optional[RuleVariation_729]:
        ...
    @overload
    def get_item(self, key : Literal["IEC"]) -> Optional[RuleVariation_814]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1290(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1369.cv_arg
    cv_variation: TypeAlias = Variation_1369

    @classmethod
    def create(cls, arg : "RuleVariation_1290.cv_arg") -> "RuleVariation_1290":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1369:
        return self.arg # type: ignore

class NonSpare_240(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1290.cv_arg
    cv_name = "080"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1290

    @classmethod
    def create(cls, arg : "NonSpare_240.cv_arg") -> "NonSpare_240":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1290:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1369:
        return self.rule.variation

class UapItem_240(UapItem):
    cv_non_spare: TypeAlias = NonSpare_240

class Record_45(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_46.cv_arg,
        "015": NonSpare_59.cv_arg,
        "070": NonSpare_217.cv_arg,
        "105": NonSpare_281.cv_arg,
        "100": NonSpare_268.cv_arg,
        "185": NonSpare_386.cv_arg,
        "210": NonSpare_410.cv_arg,
        "060": NonSpare_202.cv_arg,
        "245": NonSpare_440.cv_arg,
        "380": NonSpare_488.cv_arg,
        "040": NonSpare_149.cv_arg,
        "080": NonSpare_240.cv_arg,
        "290": NonSpare_470.cv_arg,
        "200": NonSpare_394.cv_arg,
        "295": NonSpare_473.cv_arg,
        "136": NonSpare_320.cv_arg,
        "130": NonSpare_306.cv_arg,
        "135": NonSpare_319.cv_arg,
        "220": NonSpare_422.cv_arg,
        "390": NonSpare_493.cv_arg,
        "270": NonSpare_462.cv_arg,
        "300": NonSpare_477.cv_arg,
        "110": NonSpare_289.cv_arg,
        "120": NonSpare_305.cv_arg,
        "510": NonSpare_520.cv_arg,
        "500": NonSpare_515.cv_arg,
        "340": NonSpare_482.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_46, UapItem_549, UapItem_59, UapItem_217, UapItem_281, UapItem_268, UapItem_386, UapItem_410, UapItem_202, UapItem_440, UapItem_488, UapItem_149, UapItem_240, UapItem_470, UapItem_394, UapItem_473, UapItem_320, UapItem_306, UapItem_319, UapItem_422, UapItem_493, UapItem_462, UapItem_477, UapItem_289, UapItem_305, UapItem_519, UapItem_514, UapItem_482, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_46, "015": NonSpare_59, "070": NonSpare_217, "105": NonSpare_281, "100": NonSpare_268, "185": NonSpare_386, "210": NonSpare_410, "060": NonSpare_202, "245": NonSpare_440, "380": NonSpare_488, "040": NonSpare_149, "080": NonSpare_240, "290": NonSpare_470, "200": NonSpare_394, "295": NonSpare_473, "136": NonSpare_320, "130": NonSpare_306, "135": NonSpare_319, "220": NonSpare_422, "390": NonSpare_493, "270": NonSpare_462, "300": NonSpare_477, "110": NonSpare_289, "120": NonSpare_305, "510": NonSpare_520, "500": NonSpare_515, "340": NonSpare_482, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_281:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_386:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_410:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_202:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_488:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_149:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_470:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_320:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_493:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_462:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_520:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_482:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_46]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_59]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_217]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_281]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_268]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_386]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_410]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_202]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_488]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_149]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_240]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_470]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_394]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_473]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_320]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_422]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_493]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_462]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_520]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_482]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_46.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_59.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_217.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_281.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_268.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_386.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_410.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_202.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_440.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_488.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_149.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_240.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_470.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_394.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_473.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_320.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_319.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_422.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_493.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_462.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_305.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_520.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_515.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_482.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_45':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_45':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_45':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_45':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_45.cv_arg") -> 'Record_45':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_45", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_41(UapSingle):
    cv_arg: TypeAlias = Record_45
    cv_record: TypeAlias = Record_45

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_45]]:
        return cls._parse(bs)

class Asterix_54(AstCat):
    cv_category = 62
    cv_edition = (1, 18)
    cv_uap: TypeAlias = Uap_41
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_41.cv_arg]) -> "Asterix_54":
        return cls._create(records) # type: ignore

class NonSpare_692(NonSpare):
    cv_arg: TypeAlias = RuleVariation_989.cv_arg
    cv_name = "BPS"
    cv_title = "Barometric Pressure Setting"
    cv_rule: TypeAlias = RuleVariation_989

    @classmethod
    def create(cls, arg : "NonSpare_692.cv_arg") -> "NonSpare_692":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_989:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1019:
        return self.rule.variation

class Variation_1467(Compound):
    cv_arg = TypedDict('cv_arg', {
        "ADR": NonSpare_572.cv_arg,
        "ID": NonSpare_1111.cv_arg,
        "MHG": NonSpare_1280.cv_arg,
        "IAS": NonSpare_1104.cv_arg,
        "TAS": NonSpare_1831.cv_arg,
        "SAL": NonSpare_1658.cv_arg,
        "FSS": NonSpare_1002.cv_arg,
        "TIS": NonSpare_1872.cv_arg,
        "TID": NonSpare_1867.cv_arg,
        "COM": NonSpare_788.cv_arg,
        "SAB": NonSpare_1652.cv_arg,
        "ACS": NonSpare_564.cv_arg,
        "BVR": NonSpare_696.cv_arg,
        "GVR": NonSpare_1049.cv_arg,
        "RAN": NonSpare_1548.cv_arg,
        "TAR": NonSpare_1826.cv_arg,
        "TAN": NonSpare_1821.cv_arg,
        "GS": NonSpare_1038.cv_arg,
        "VUN": NonSpare_2045.cv_arg,
        "MET": NonSpare_1272.cv_arg,
        "EMC": NonSpare_929.cv_arg,
        "POS": NonSpare_1449.cv_arg,
        "GAL": NonSpare_1019.cv_arg,
        "PUN": NonSpare_1485.cv_arg,
        "MB": NonSpare_1232.cv_arg,
        "IAR": NonSpare_1100.cv_arg,
        "MAC": NonSpare_1222.cv_arg,
        "BPS": NonSpare_692.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_572, NonSpare_1111, NonSpare_1280, NonSpare_1104, NonSpare_1831, NonSpare_1658, NonSpare_1002, NonSpare_1872, NonSpare_1867, NonSpare_788, NonSpare_1652, NonSpare_564, NonSpare_696, NonSpare_1049, NonSpare_1548, NonSpare_1826, NonSpare_1821, NonSpare_1038, NonSpare_2045, NonSpare_1272, NonSpare_929, NonSpare_1449, NonSpare_1019, NonSpare_1485, NonSpare_1232, NonSpare_1100, NonSpare_1222, NonSpare_692]
    cv_items_dict = {"ADR": NonSpare_572, "ID": NonSpare_1111, "MHG": NonSpare_1280, "IAS": NonSpare_1104, "TAS": NonSpare_1831, "SAL": NonSpare_1658, "FSS": NonSpare_1002, "TIS": NonSpare_1872, "TID": NonSpare_1867, "COM": NonSpare_788, "SAB": NonSpare_1652, "ACS": NonSpare_564, "BVR": NonSpare_696, "GVR": NonSpare_1049, "RAN": NonSpare_1548, "TAR": NonSpare_1826, "TAN": NonSpare_1821, "GS": NonSpare_1038, "VUN": NonSpare_2045, "MET": NonSpare_1272, "EMC": NonSpare_929, "POS": NonSpare_1449, "GAL": NonSpare_1019, "PUN": NonSpare_1485, "MB": NonSpare_1232, "IAR": NonSpare_1100, "MAC": NonSpare_1222, "BPS": NonSpare_692}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1104:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1658:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_1002:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1872:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1867:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_788:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1652:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1049:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1548:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1826:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1821:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1038:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2045:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_929:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1019:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1485:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MB"]) -> NonSpare_1232:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_692:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["MB"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_572]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1111]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1280]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1104]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1831]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1658]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_1002]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1872]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1867]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_788]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1652]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_564]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_696]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1049]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1548]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1826]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1821]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1038]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2045]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1272]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_929]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1449]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1019]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1485]:
        ...
    @overload
    def get_item(self, key : Literal["MB"]) -> Optional[NonSpare_1232]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1100]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_692]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_572.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1111.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1280.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1104.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1831.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1658.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_1002.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1872.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1867.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_788.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1652.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_564.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_696.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1049.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1548.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1826.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1821.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1038.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2045.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1272.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_929.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1449.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1019.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1485.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["MB"], val : NonSpare_1232.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1100.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1222.cv_arg) -> "Variation_1467":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_692.cv_arg) -> "Variation_1467":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["MB"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1467":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1467":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1467.cv_arg") -> 'Variation_1467':
        return cls._create(arg) # type: ignore

class RuleVariation_1388(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1467.cv_arg
    cv_variation: TypeAlias = Variation_1467

    @classmethod
    def create(cls, arg : "RuleVariation_1388.cv_arg") -> "RuleVariation_1388":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1467:
        return self.arg # type: ignore

class NonSpare_487(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1388.cv_arg
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule: TypeAlias = RuleVariation_1388

    @classmethod
    def create(cls, arg : "NonSpare_487.cv_arg") -> "NonSpare_487":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1388:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1467:
        return self.rule.variation

class UapItem_487(UapItem):
    cv_non_spare: TypeAlias = NonSpare_487

class Content_754(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["FL"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 0.25
    cv_unit = "FL"

    def as_quantity(self, cv_unit : Optional[Literal["FL"]] = None) -> float:
        return self._as_quantity()

class RuleContent_753(RuleContentContextFree):
    cv_arg: TypeAlias = Content_754.cv_arg
    cv_content: TypeAlias = Content_754

    @property
    def content(self) -> Content_754:
        return self._get_content() # type: ignore

class Variation_323(Element):
    cv_arg: TypeAlias = RuleContent_753.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_753

    @classmethod
    def create(cls, arg: "Variation_323.cv_arg") -> "Variation_323":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_753:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_754:
        return self.rule.content

class RuleVariation_316(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_323.cv_arg
    cv_variation: TypeAlias = Variation_323

    @classmethod
    def create(cls, arg : "RuleVariation_316.cv_arg") -> "RuleVariation_316":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_323:
        return self.arg # type: ignore

class NonSpare_728(NonSpare):
    cv_arg: TypeAlias = RuleVariation_316.cv_arg
    cv_name = "CFL"
    cv_title = "Current Cleared Flight Level"
    cv_rule: TypeAlias = RuleVariation_316

    @classmethod
    def create(cls, arg : "NonSpare_728.cv_arg") -> "NonSpare_728":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_316:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_323:
        return self.rule.variation

class Variation_1514(Compound):
    cv_arg = TypedDict('cv_arg', {
        "TAG": NonSpare_1820.cv_arg,
        "CS": NonSpare_832.cv_arg,
        "IFI": NonSpare_1118.cv_arg,
        "FCT": NonSpare_970.cv_arg,
        "TAC": NonSpare_1819.cv_arg,
        "WTC": NonSpare_2070.cv_arg,
        "DEP": NonSpare_879.cv_arg,
        "DST": NonSpare_904.cv_arg,
        "RDS": NonSpare_1564.cv_arg,
        "CFL": NonSpare_728.cv_arg,
        "CTL": NonSpare_849.cv_arg,
        "TOD": NonSpare_1883.cv_arg,
        "AST": NonSpare_639.cv_arg,
        "STS": NonSpare_1798.cv_arg,
        "STD": NonSpare_1788.cv_arg,
        "STA": NonSpare_1771.cv_arg,
        "PEM": NonSpare_1426.cv_arg,
        "PEC": NonSpare_1425.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 3
    cv_items_list = [NonSpare_1820, NonSpare_832, NonSpare_1118, NonSpare_970, NonSpare_1819, NonSpare_2070, NonSpare_879, NonSpare_904, NonSpare_1564, NonSpare_728, NonSpare_849, NonSpare_1883, NonSpare_639, NonSpare_1798, NonSpare_1788, NonSpare_1771, NonSpare_1426, NonSpare_1425]
    cv_items_dict = {"TAG": NonSpare_1820, "CS": NonSpare_832, "IFI": NonSpare_1118, "FCT": NonSpare_970, "TAC": NonSpare_1819, "WTC": NonSpare_2070, "DEP": NonSpare_879, "DST": NonSpare_904, "RDS": NonSpare_1564, "CFL": NonSpare_728, "CTL": NonSpare_849, "TOD": NonSpare_1883, "AST": NonSpare_639, "STS": NonSpare_1798, "STD": NonSpare_1788, "STA": NonSpare_1771, "PEM": NonSpare_1426, "PEC": NonSpare_1425}

    @overload
    @classmethod
    def spec(cls, key : Literal["TAG"]) -> NonSpare_1820:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CS"]) -> NonSpare_832:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IFI"]) -> NonSpare_1118:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FCT"]) -> NonSpare_970:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAC"]) -> NonSpare_1819:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WTC"]) -> NonSpare_2070:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DEP"]) -> NonSpare_879:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["DST"]) -> NonSpare_904:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RDS"]) -> NonSpare_1564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CFL"]) -> NonSpare_728:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CTL"]) -> NonSpare_849:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOD"]) -> NonSpare_1883:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["AST"]) -> NonSpare_639:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STS"]) -> NonSpare_1798:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STD"]) -> NonSpare_1788:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STA"]) -> NonSpare_1771:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEM"]) -> NonSpare_1426:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PEC"]) -> NonSpare_1425:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TAG"], Literal["CS"], Literal["IFI"], Literal["FCT"], Literal["TAC"], Literal["WTC"], Literal["DEP"], Literal["DST"], Literal["RDS"], Literal["CFL"], Literal["CTL"], Literal["TOD"], Literal["AST"], Literal["STS"], Literal["STD"], Literal["STA"], Literal["PEM"], Literal["PEC"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TAG"]) -> Optional[NonSpare_1820]:
        ...
    @overload
    def get_item(self, key : Literal["CS"]) -> Optional[NonSpare_832]:
        ...
    @overload
    def get_item(self, key : Literal["IFI"]) -> Optional[NonSpare_1118]:
        ...
    @overload
    def get_item(self, key : Literal["FCT"]) -> Optional[NonSpare_970]:
        ...
    @overload
    def get_item(self, key : Literal["TAC"]) -> Optional[NonSpare_1819]:
        ...
    @overload
    def get_item(self, key : Literal["WTC"]) -> Optional[NonSpare_2070]:
        ...
    @overload
    def get_item(self, key : Literal["DEP"]) -> Optional[NonSpare_879]:
        ...
    @overload
    def get_item(self, key : Literal["DST"]) -> Optional[NonSpare_904]:
        ...
    @overload
    def get_item(self, key : Literal["RDS"]) -> Optional[NonSpare_1564]:
        ...
    @overload
    def get_item(self, key : Literal["CFL"]) -> Optional[NonSpare_728]:
        ...
    @overload
    def get_item(self, key : Literal["CTL"]) -> Optional[NonSpare_849]:
        ...
    @overload
    def get_item(self, key : Literal["TOD"]) -> Optional[NonSpare_1883]:
        ...
    @overload
    def get_item(self, key : Literal["AST"]) -> Optional[NonSpare_639]:
        ...
    @overload
    def get_item(self, key : Literal["STS"]) -> Optional[NonSpare_1798]:
        ...
    @overload
    def get_item(self, key : Literal["STD"]) -> Optional[NonSpare_1788]:
        ...
    @overload
    def get_item(self, key : Literal["STA"]) -> Optional[NonSpare_1771]:
        ...
    @overload
    def get_item(self, key : Literal["PEM"]) -> Optional[NonSpare_1426]:
        ...
    @overload
    def get_item(self, key : Literal["PEC"]) -> Optional[NonSpare_1425]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["TAG"], val : NonSpare_1820.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["CS"], val : NonSpare_832.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["IFI"], val : NonSpare_1118.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["FCT"], val : NonSpare_970.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["TAC"], val : NonSpare_1819.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["WTC"], val : NonSpare_2070.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["DEP"], val : NonSpare_879.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["DST"], val : NonSpare_904.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["RDS"], val : NonSpare_1564.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["CFL"], val : NonSpare_728.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["CTL"], val : NonSpare_849.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["TOD"], val : NonSpare_1883.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["AST"], val : NonSpare_639.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["STS"], val : NonSpare_1798.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["STD"], val : NonSpare_1788.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["STA"], val : NonSpare_1771.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["PEM"], val : NonSpare_1426.cv_arg) -> "Variation_1514":
        ...
    @overload
    def set_item(self, key : Literal["PEC"], val : NonSpare_1425.cv_arg) -> "Variation_1514":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["TAG"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["CS"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["IFI"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["FCT"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["TAC"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["WTC"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["DEP"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["DST"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["RDS"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["CFL"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["CTL"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["TOD"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["AST"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["STS"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["STD"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["STA"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["PEM"]) -> "Variation_1514":
        ...
    @overload
    def del_item(self, key : Literal["PEC"]) -> "Variation_1514":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1514.cv_arg") -> 'Variation_1514':
        return cls._create(arg) # type: ignore

class RuleVariation_1435(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1514.cv_arg
    cv_variation: TypeAlias = Variation_1514

    @classmethod
    def create(cls, arg : "RuleVariation_1435.cv_arg") -> "RuleVariation_1435":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1514:
        return self.arg # type: ignore

class NonSpare_494(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1435.cv_arg
    cv_name = "390"
    cv_title = "Flight Plan Related Data"
    cv_rule: TypeAlias = RuleVariation_1435

    @classmethod
    def create(cls, arg : "NonSpare_494.cv_arg") -> "NonSpare_494":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1435:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1514:
        return self.rule.variation

class UapItem_494(UapItem):
    cv_non_spare: TypeAlias = NonSpare_494

class NonSpare_1063(NonSpare):
    cv_arg: TypeAlias = RuleVariation_255.cv_arg
    cv_name = "HEIGHT"
    cv_title = "Measured 3-D Height"
    cv_rule: TypeAlias = RuleVariation_255

    @classmethod
    def create(cls, arg : "NonSpare_1063.cv_arg") -> "NonSpare_1063":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_255:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_262:
        return self.rule.variation

class Variation_1506(Compound):
    cv_arg = TypedDict('cv_arg', {
        "SID": NonSpare_1713.cv_arg,
        "POS": NonSpare_1444.cv_arg,
        "HEIGHT": NonSpare_1063.cv_arg,
        "MDC": NonSpare_1255.cv_arg,
        "MDA": NonSpare_1251.cv_arg,
        "TYP": NonSpare_1964.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [NonSpare_1713, NonSpare_1444, NonSpare_1063, NonSpare_1255, NonSpare_1251, NonSpare_1964]
    cv_items_dict = {"SID": NonSpare_1713, "POS": NonSpare_1444, "HEIGHT": NonSpare_1063, "MDC": NonSpare_1255, "MDA": NonSpare_1251, "TYP": NonSpare_1964}

    @overload
    @classmethod
    def spec(cls, key : Literal["SID"]) -> NonSpare_1713:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1444:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["HEIGHT"]) -> NonSpare_1063:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDC"]) -> NonSpare_1255:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MDA"]) -> NonSpare_1251:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TYP"]) -> NonSpare_1964:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SID"], Literal["POS"], Literal["HEIGHT"], Literal["MDC"], Literal["MDA"], Literal["TYP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SID"]) -> Optional[NonSpare_1713]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1444]:
        ...
    @overload
    def get_item(self, key : Literal["HEIGHT"]) -> Optional[NonSpare_1063]:
        ...
    @overload
    def get_item(self, key : Literal["MDC"]) -> Optional[NonSpare_1255]:
        ...
    @overload
    def get_item(self, key : Literal["MDA"]) -> Optional[NonSpare_1251]:
        ...
    @overload
    def get_item(self, key : Literal["TYP"]) -> Optional[NonSpare_1964]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["SID"], val : NonSpare_1713.cv_arg) -> "Variation_1506":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1444.cv_arg) -> "Variation_1506":
        ...
    @overload
    def set_item(self, key : Literal["HEIGHT"], val : NonSpare_1063.cv_arg) -> "Variation_1506":
        ...
    @overload
    def set_item(self, key : Literal["MDC"], val : NonSpare_1255.cv_arg) -> "Variation_1506":
        ...
    @overload
    def set_item(self, key : Literal["MDA"], val : NonSpare_1251.cv_arg) -> "Variation_1506":
        ...
    @overload
    def set_item(self, key : Literal["TYP"], val : NonSpare_1964.cv_arg) -> "Variation_1506":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["SID"]) -> "Variation_1506":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1506":
        ...
    @overload
    def del_item(self, key : Literal["HEIGHT"]) -> "Variation_1506":
        ...
    @overload
    def del_item(self, key : Literal["MDC"]) -> "Variation_1506":
        ...
    @overload
    def del_item(self, key : Literal["MDA"]) -> "Variation_1506":
        ...
    @overload
    def del_item(self, key : Literal["TYP"]) -> "Variation_1506":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1506.cv_arg") -> 'Variation_1506':
        return cls._create(arg) # type: ignore

class RuleVariation_1427(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1506.cv_arg
    cv_variation: TypeAlias = Variation_1506

    @classmethod
    def create(cls, arg : "RuleVariation_1427.cv_arg") -> "RuleVariation_1427":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1506:
        return self.arg # type: ignore

class NonSpare_481(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1427.cv_arg
    cv_name = "340"
    cv_title = "Measured Information"
    cv_rule: TypeAlias = RuleVariation_1427

    @classmethod
    def create(cls, arg : "NonSpare_481.cv_arg") -> "NonSpare_481":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1427:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1506:
        return self.rule.variation

class UapItem_481(UapItem):
    cv_non_spare: TypeAlias = NonSpare_481

class Record_44(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_46.cv_arg,
        "015": NonSpare_59.cv_arg,
        "070": NonSpare_217.cv_arg,
        "105": NonSpare_281.cv_arg,
        "100": NonSpare_268.cv_arg,
        "185": NonSpare_386.cv_arg,
        "210": NonSpare_410.cv_arg,
        "060": NonSpare_202.cv_arg,
        "245": NonSpare_440.cv_arg,
        "380": NonSpare_487.cv_arg,
        "040": NonSpare_149.cv_arg,
        "080": NonSpare_240.cv_arg,
        "290": NonSpare_470.cv_arg,
        "200": NonSpare_394.cv_arg,
        "295": NonSpare_473.cv_arg,
        "136": NonSpare_320.cv_arg,
        "130": NonSpare_306.cv_arg,
        "135": NonSpare_319.cv_arg,
        "220": NonSpare_422.cv_arg,
        "390": NonSpare_494.cv_arg,
        "270": NonSpare_462.cv_arg,
        "300": NonSpare_477.cv_arg,
        "110": NonSpare_289.cv_arg,
        "120": NonSpare_305.cv_arg,
        "510": NonSpare_520.cv_arg,
        "500": NonSpare_515.cv_arg,
        "340": NonSpare_481.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_46, UapItem_549, UapItem_59, UapItem_217, UapItem_281, UapItem_268, UapItem_386, UapItem_410, UapItem_202, UapItem_440, UapItem_487, UapItem_149, UapItem_240, UapItem_470, UapItem_394, UapItem_473, UapItem_320, UapItem_306, UapItem_319, UapItem_422, UapItem_494, UapItem_462, UapItem_477, UapItem_289, UapItem_305, UapItem_519, UapItem_514, UapItem_481, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_46, "015": NonSpare_59, "070": NonSpare_217, "105": NonSpare_281, "100": NonSpare_268, "185": NonSpare_386, "210": NonSpare_410, "060": NonSpare_202, "245": NonSpare_440, "380": NonSpare_487, "040": NonSpare_149, "080": NonSpare_240, "290": NonSpare_470, "200": NonSpare_394, "295": NonSpare_473, "136": NonSpare_320, "130": NonSpare_306, "135": NonSpare_319, "220": NonSpare_422, "390": NonSpare_494, "270": NonSpare_462, "300": NonSpare_477, "110": NonSpare_289, "120": NonSpare_305, "510": NonSpare_520, "500": NonSpare_515, "340": NonSpare_481, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_281:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_386:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_410:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_202:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_487:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_149:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_240:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_470:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_320:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_494:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_462:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_520:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_481:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_46]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_59]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_217]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_281]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_268]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_386]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_410]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_202]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_487]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_149]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_240]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_470]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_394]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_473]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_320]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_422]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_494]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_462]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_520]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_481]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_46.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_59.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_217.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_281.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_268.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_386.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_410.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_202.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_440.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_487.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_149.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_240.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_470.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_394.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_473.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_320.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_319.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_422.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_494.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_462.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_305.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_520.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_515.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_481.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_44':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_44':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_44':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_44':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_44.cv_arg") -> 'Record_44':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_44", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_40(UapSingle):
    cv_arg: TypeAlias = Record_44
    cv_record: TypeAlias = Record_44

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_44]]:
        return cls._parse(bs)

class Asterix_55(AstCat):
    cv_category = 62
    cv_edition = (1, 19)
    cv_uap: TypeAlias = Uap_40
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_40.cv_arg]) -> "Asterix_55":
        return cls._create(records) # type: ignore

class NonSpare_679(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1325.cv_arg
    cv_name = "BDSDATA"
    cv_title = "BDS Register DATA"
    cv_rule: TypeAlias = RuleVariation_1325

    @classmethod
    def create(cls, arg : "NonSpare_679.cv_arg") -> "NonSpare_679":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1325:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1404:
        return self.rule.variation

class Variation_1466(Compound):
    cv_arg = TypedDict('cv_arg', {
        "ADR": NonSpare_572.cv_arg,
        "ID": NonSpare_1111.cv_arg,
        "MHG": NonSpare_1280.cv_arg,
        "IAS": NonSpare_1104.cv_arg,
        "TAS": NonSpare_1831.cv_arg,
        "SAL": NonSpare_1658.cv_arg,
        "FSS": NonSpare_1002.cv_arg,
        "TIS": NonSpare_1872.cv_arg,
        "TID": NonSpare_1867.cv_arg,
        "COM": NonSpare_788.cv_arg,
        "SAB": NonSpare_1652.cv_arg,
        "ACS": NonSpare_564.cv_arg,
        "BVR": NonSpare_696.cv_arg,
        "GVR": NonSpare_1049.cv_arg,
        "RAN": NonSpare_1548.cv_arg,
        "TAR": NonSpare_1826.cv_arg,
        "TAN": NonSpare_1821.cv_arg,
        "GS": NonSpare_1038.cv_arg,
        "VUN": NonSpare_2045.cv_arg,
        "MET": NonSpare_1272.cv_arg,
        "EMC": NonSpare_929.cv_arg,
        "POS": NonSpare_1449.cv_arg,
        "GAL": NonSpare_1019.cv_arg,
        "PUN": NonSpare_1485.cv_arg,
        "BDSDATA": NonSpare_679.cv_arg,
        "IAR": NonSpare_1100.cv_arg,
        "MAC": NonSpare_1222.cv_arg,
        "BPS": NonSpare_692.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [NonSpare_572, NonSpare_1111, NonSpare_1280, NonSpare_1104, NonSpare_1831, NonSpare_1658, NonSpare_1002, NonSpare_1872, NonSpare_1867, NonSpare_788, NonSpare_1652, NonSpare_564, NonSpare_696, NonSpare_1049, NonSpare_1548, NonSpare_1826, NonSpare_1821, NonSpare_1038, NonSpare_2045, NonSpare_1272, NonSpare_929, NonSpare_1449, NonSpare_1019, NonSpare_1485, NonSpare_679, NonSpare_1100, NonSpare_1222, NonSpare_692]
    cv_items_dict = {"ADR": NonSpare_572, "ID": NonSpare_1111, "MHG": NonSpare_1280, "IAS": NonSpare_1104, "TAS": NonSpare_1831, "SAL": NonSpare_1658, "FSS": NonSpare_1002, "TIS": NonSpare_1872, "TID": NonSpare_1867, "COM": NonSpare_788, "SAB": NonSpare_1652, "ACS": NonSpare_564, "BVR": NonSpare_696, "GVR": NonSpare_1049, "RAN": NonSpare_1548, "TAR": NonSpare_1826, "TAN": NonSpare_1821, "GS": NonSpare_1038, "VUN": NonSpare_2045, "MET": NonSpare_1272, "EMC": NonSpare_929, "POS": NonSpare_1449, "GAL": NonSpare_1019, "PUN": NonSpare_1485, "BDSDATA": NonSpare_679, "IAR": NonSpare_1100, "MAC": NonSpare_1222, "BPS": NonSpare_692}

    @overload
    @classmethod
    def spec(cls, key : Literal["ADR"]) -> NonSpare_572:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ID"]) -> NonSpare_1111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MHG"]) -> NonSpare_1280:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAS"]) -> NonSpare_1104:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAS"]) -> NonSpare_1831:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAL"]) -> NonSpare_1658:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["FSS"]) -> NonSpare_1002:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TIS"]) -> NonSpare_1872:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TID"]) -> NonSpare_1867:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["COM"]) -> NonSpare_788:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SAB"]) -> NonSpare_1652:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ACS"]) -> NonSpare_564:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BVR"]) -> NonSpare_696:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GVR"]) -> NonSpare_1049:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RAN"]) -> NonSpare_1548:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAR"]) -> NonSpare_1826:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TAN"]) -> NonSpare_1821:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GS"]) -> NonSpare_1038:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["VUN"]) -> NonSpare_2045:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MET"]) -> NonSpare_1272:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["EMC"]) -> NonSpare_929:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> NonSpare_1449:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["GAL"]) -> NonSpare_1019:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PUN"]) -> NonSpare_1485:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BDSDATA"]) -> NonSpare_679:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["IAR"]) -> NonSpare_1100:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAC"]) -> NonSpare_1222:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["BPS"]) -> NonSpare_692:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["ADR"], Literal["ID"], Literal["MHG"], Literal["IAS"], Literal["TAS"], Literal["SAL"], Literal["FSS"], Literal["TIS"], Literal["TID"], Literal["COM"], Literal["SAB"], Literal["ACS"], Literal["BVR"], Literal["GVR"], Literal["RAN"], Literal["TAR"], Literal["TAN"], Literal["GS"], Literal["VUN"], Literal["MET"], Literal["EMC"], Literal["POS"], Literal["GAL"], Literal["PUN"], Literal["BDSDATA"], Literal["IAR"], Literal["MAC"], Literal["BPS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["ADR"]) -> Optional[NonSpare_572]:
        ...
    @overload
    def get_item(self, key : Literal["ID"]) -> Optional[NonSpare_1111]:
        ...
    @overload
    def get_item(self, key : Literal["MHG"]) -> Optional[NonSpare_1280]:
        ...
    @overload
    def get_item(self, key : Literal["IAS"]) -> Optional[NonSpare_1104]:
        ...
    @overload
    def get_item(self, key : Literal["TAS"]) -> Optional[NonSpare_1831]:
        ...
    @overload
    def get_item(self, key : Literal["SAL"]) -> Optional[NonSpare_1658]:
        ...
    @overload
    def get_item(self, key : Literal["FSS"]) -> Optional[NonSpare_1002]:
        ...
    @overload
    def get_item(self, key : Literal["TIS"]) -> Optional[NonSpare_1872]:
        ...
    @overload
    def get_item(self, key : Literal["TID"]) -> Optional[NonSpare_1867]:
        ...
    @overload
    def get_item(self, key : Literal["COM"]) -> Optional[NonSpare_788]:
        ...
    @overload
    def get_item(self, key : Literal["SAB"]) -> Optional[NonSpare_1652]:
        ...
    @overload
    def get_item(self, key : Literal["ACS"]) -> Optional[NonSpare_564]:
        ...
    @overload
    def get_item(self, key : Literal["BVR"]) -> Optional[NonSpare_696]:
        ...
    @overload
    def get_item(self, key : Literal["GVR"]) -> Optional[NonSpare_1049]:
        ...
    @overload
    def get_item(self, key : Literal["RAN"]) -> Optional[NonSpare_1548]:
        ...
    @overload
    def get_item(self, key : Literal["TAR"]) -> Optional[NonSpare_1826]:
        ...
    @overload
    def get_item(self, key : Literal["TAN"]) -> Optional[NonSpare_1821]:
        ...
    @overload
    def get_item(self, key : Literal["GS"]) -> Optional[NonSpare_1038]:
        ...
    @overload
    def get_item(self, key : Literal["VUN"]) -> Optional[NonSpare_2045]:
        ...
    @overload
    def get_item(self, key : Literal["MET"]) -> Optional[NonSpare_1272]:
        ...
    @overload
    def get_item(self, key : Literal["EMC"]) -> Optional[NonSpare_929]:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> Optional[NonSpare_1449]:
        ...
    @overload
    def get_item(self, key : Literal["GAL"]) -> Optional[NonSpare_1019]:
        ...
    @overload
    def get_item(self, key : Literal["PUN"]) -> Optional[NonSpare_1485]:
        ...
    @overload
    def get_item(self, key : Literal["BDSDATA"]) -> Optional[NonSpare_679]:
        ...
    @overload
    def get_item(self, key : Literal["IAR"]) -> Optional[NonSpare_1100]:
        ...
    @overload
    def get_item(self, key : Literal["MAC"]) -> Optional[NonSpare_1222]:
        ...
    @overload
    def get_item(self, key : Literal["BPS"]) -> Optional[NonSpare_692]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["ADR"], val : NonSpare_572.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["ID"], val : NonSpare_1111.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["MHG"], val : NonSpare_1280.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["IAS"], val : NonSpare_1104.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["TAS"], val : NonSpare_1831.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["SAL"], val : NonSpare_1658.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["FSS"], val : NonSpare_1002.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["TIS"], val : NonSpare_1872.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["TID"], val : NonSpare_1867.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["COM"], val : NonSpare_788.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["SAB"], val : NonSpare_1652.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["ACS"], val : NonSpare_564.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["BVR"], val : NonSpare_696.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["GVR"], val : NonSpare_1049.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["RAN"], val : NonSpare_1548.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["TAR"], val : NonSpare_1826.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["TAN"], val : NonSpare_1821.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["GS"], val : NonSpare_1038.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["VUN"], val : NonSpare_2045.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["MET"], val : NonSpare_1272.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["EMC"], val : NonSpare_929.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["POS"], val : NonSpare_1449.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["GAL"], val : NonSpare_1019.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["PUN"], val : NonSpare_1485.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["BDSDATA"], val : NonSpare_679.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["IAR"], val : NonSpare_1100.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["MAC"], val : NonSpare_1222.cv_arg) -> "Variation_1466":
        ...
    @overload
    def set_item(self, key : Literal["BPS"], val : NonSpare_692.cv_arg) -> "Variation_1466":
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["ADR"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["ID"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["MHG"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["IAS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["TAS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["SAL"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["FSS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["TIS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["TID"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["COM"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["SAB"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["ACS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["BVR"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["GVR"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["RAN"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["TAR"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["TAN"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["GS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["VUN"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["MET"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["EMC"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["POS"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["GAL"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["PUN"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["BDSDATA"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["IAR"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["MAC"]) -> "Variation_1466":
        ...
    @overload
    def del_item(self, key : Literal["BPS"]) -> "Variation_1466":
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Variation_1466.cv_arg") -> 'Variation_1466':
        return cls._create(arg) # type: ignore

class RuleVariation_1387(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1466.cv_arg
    cv_variation: TypeAlias = Variation_1466

    @classmethod
    def create(cls, arg : "RuleVariation_1387.cv_arg") -> "RuleVariation_1387":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1466:
        return self.arg # type: ignore

class NonSpare_486(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1387.cv_arg
    cv_name = "380"
    cv_title = "Aircraft Derived Data"
    cv_rule: TypeAlias = RuleVariation_1387

    @classmethod
    def create(cls, arg : "NonSpare_486.cv_arg") -> "NonSpare_486":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1387:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1466:
        return self.rule.variation

class UapItem_486(UapItem):
    cv_non_spare: TypeAlias = NonSpare_486

class Content_175(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default value", 1: "Age of the last received MLAT track updateis higher than system dependent threshold"}

class RuleContent_175(RuleContentContextFree):
    cv_arg: TypeAlias = Content_175.cv_arg
    cv_content: TypeAlias = Content_175

    @property
    def content(self) -> Content_175:
        return self._get_content() # type: ignore

class Variation_922(Element):
    cv_arg: TypeAlias = RuleContent_175.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_175

    @classmethod
    def create(cls, arg: "Variation_922.cv_arg") -> "Variation_922":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_175:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_175:
        return self.rule.content

class RuleVariation_892(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_922.cv_arg
    cv_variation: TypeAlias = Variation_922

    @classmethod
    def create(cls, arg : "RuleVariation_892.cv_arg") -> "RuleVariation_892":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_922:
        return self.arg # type: ignore

class NonSpare_1291(NonSpare):
    cv_arg: TypeAlias = RuleVariation_892.cv_arg
    cv_name = "MLAT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_892

    @classmethod
    def create(cls, arg : "NonSpare_1291.cv_arg") -> "NonSpare_1291":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_892:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_922:
        return self.rule.variation

class Item_558(Item):
    cv_arg: TypeAlias = NonSpare_1291.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1291

    @classmethod
    def create(cls, arg : "Item_558.cv_arg") -> "Item_558":
        return cls._create(arg) # type: ignore

class Variation_1370(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_55.cv_arg, Tuple[Literal["MON"], RuleVariation_55.cv_arg]], Union[RuleVariation_412.cv_arg, Tuple[Literal["SPI"], RuleVariation_412.cv_arg]], Union[RuleVariation_500.cv_arg, Tuple[Literal["MRH"], RuleVariation_500.cv_arg]], Union[RuleVariation_678.cv_arg, Tuple[Literal["SRC"], RuleVariation_678.cv_arg]], Union[RuleVariation_877.cv_arg, Tuple[Literal["CNF"], RuleVariation_877.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_6.cv_arg, Tuple[Literal["SIM"], RuleVariation_6.cv_arg]], Union[RuleVariation_411.cv_arg, Tuple[Literal["TSE"], RuleVariation_411.cv_arg]], Union[RuleVariation_520.cv_arg, Tuple[Literal["TSB"], RuleVariation_520.cv_arg]], Union[RuleVariation_647.cv_arg, Tuple[Literal["FPC"], RuleVariation_647.cv_arg]], Union[RuleVariation_705.cv_arg, Tuple[Literal["AFF"], RuleVariation_705.cv_arg]], Union[RuleVariation_816.cv_arg, Tuple[Literal["STP"], RuleVariation_816.cv_arg]], Union[RuleVariation_875.cv_arg, Tuple[Literal["KOS"], RuleVariation_875.cv_arg]], None]]
    cv_arg_group_3: TypeAlias = Union[int, Tuple[Union[RuleVariation_90.cv_arg, Tuple[Literal["AMA"], RuleVariation_90.cv_arg]], Union[RuleVariation_458.cv_arg, Tuple[Literal["MD4"], RuleVariation_458.cv_arg]], Union[RuleVariation_625.cv_arg, Tuple[Literal["ME"], RuleVariation_625.cv_arg]], Union[RuleVariation_708.cv_arg, Tuple[Literal["MI"], RuleVariation_708.cv_arg]], Union[RuleVariation_852.cv_arg, Tuple[Literal["MD5"], RuleVariation_852.cv_arg]], None]]
    cv_arg_group_4: TypeAlias = Union[int, Tuple[Union[RuleVariation_38.cv_arg, Tuple[Literal["CST"], RuleVariation_38.cv_arg]], Union[RuleVariation_409.cv_arg, Tuple[Literal["PSR"], RuleVariation_409.cv_arg]], Union[RuleVariation_517.cv_arg, Tuple[Literal["SSR"], RuleVariation_517.cv_arg]], Union[RuleVariation_624.cv_arg, Tuple[Literal["MDS"], RuleVariation_624.cv_arg]], Union[RuleVariation_707.cv_arg, Tuple[Literal["ADS"], RuleVariation_707.cv_arg]], Union[RuleVariation_817.cv_arg, Tuple[Literal["SUC"], RuleVariation_817.cv_arg]], Union[RuleVariation_893.cv_arg, Tuple[Literal["AAC"], RuleVariation_893.cv_arg]], None]]
    cv_arg_group_5: TypeAlias = Union[int, Tuple[Union[RuleVariation_100.cv_arg, Tuple[Literal["SDS"], RuleVariation_100.cv_arg]], Union[RuleVariation_590.cv_arg, Tuple[Literal["EMS"], RuleVariation_590.cv_arg]], Union[RuleVariation_833.cv_arg, Tuple[Literal["PFT"], RuleVariation_833.cv_arg]], Union[RuleVariation_895.cv_arg, Tuple[Literal["FPLT"], RuleVariation_895.cv_arg]], None]]
    cv_arg_group_6: TypeAlias = Union[int, Tuple[Union[RuleVariation_39.cv_arg, Tuple[Literal["DUPT"], RuleVariation_39.cv_arg]], Union[RuleVariation_410.cv_arg, Tuple[Literal["DUPF"], RuleVariation_410.cv_arg]], Union[RuleVariation_519.cv_arg, Tuple[Literal["DUPM"], RuleVariation_519.cv_arg]], Union[RuleVariation_626.cv_arg, Tuple[Literal["SFC"], RuleVariation_626.cv_arg]], Union[RuleVariation_729.cv_arg, Tuple[Literal["IDD"], RuleVariation_729.cv_arg]], Union[RuleVariation_814.cv_arg, Tuple[Literal["IEC"], RuleVariation_814.cv_arg]], Union[RuleVariation_892.cv_arg, Tuple[Literal["MLAT"], RuleVariation_892.cv_arg]], None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1370.cv_arg_group_1"],
        Tuple["Variation_1370.cv_arg_group_1", "Variation_1370.cv_arg_group_2"],
        Tuple["Variation_1370.cv_arg_group_1", "Variation_1370.cv_arg_group_2", "Variation_1370.cv_arg_group_3"],
        Tuple["Variation_1370.cv_arg_group_1", "Variation_1370.cv_arg_group_2", "Variation_1370.cv_arg_group_3", "Variation_1370.cv_arg_group_4"],
        Tuple["Variation_1370.cv_arg_group_1", "Variation_1370.cv_arg_group_2", "Variation_1370.cv_arg_group_3", "Variation_1370.cv_arg_group_4", "Variation_1370.cv_arg_group_5"],
        Tuple["Variation_1370.cv_arg_group_1", "Variation_1370.cv_arg_group_2", "Variation_1370.cv_arg_group_3", "Variation_1370.cv_arg_group_4", "Variation_1370.cv_arg_group_5", "Variation_1370.cv_arg_group_6"],
    ]
    cv_items_list = [[(Item_579, 1), (Item_911, 1), (Item_582, 1), (Item_923, 3), (Item_167, 1), None], [(Item_899, 1), (Item_1046, 1), (Item_1044, 1), (Item_338, 1), (Item_50, 1), (Item_956, 1), (Item_442, 1), None], [(Item_71, 1), (Item_537, 2), (Item_544, 1), (Item_551, 1), (Item_538, 2), None], [(Item_221, 1), (Item_713, 1), (Item_928, 1), (Item_539, 1), (Item_46, 1), (Item_962, 1), (Item_34, 1), None], [(Item_875, 2), (Item_294, 3), (Item_681, 1), (Item_339, 1), None], [(Item_283, 1), (Item_281, 1), (Item_282, 1), (Item_882, 1), (Item_429, 1), (Item_433, 1), (Item_558, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1370.cv_arg") -> 'Variation_1370':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["MON"]) -> RuleVariation_55:
        ...
    @overload
    def get_item(self, key : Literal["SPI"]) -> RuleVariation_412:
        ...
    @overload
    def get_item(self, key : Literal["MRH"]) -> RuleVariation_500:
        ...
    @overload
    def get_item(self, key : Literal["SRC"]) -> RuleVariation_678:
        ...
    @overload
    def get_item(self, key : Literal["CNF"]) -> RuleVariation_877:
        ...
    @overload
    def get_item(self, key : Literal["SIM"]) -> Optional[RuleVariation_6]:
        ...
    @overload
    def get_item(self, key : Literal["TSE"]) -> Optional[RuleVariation_411]:
        ...
    @overload
    def get_item(self, key : Literal["TSB"]) -> Optional[RuleVariation_520]:
        ...
    @overload
    def get_item(self, key : Literal["FPC"]) -> Optional[RuleVariation_647]:
        ...
    @overload
    def get_item(self, key : Literal["AFF"]) -> Optional[RuleVariation_705]:
        ...
    @overload
    def get_item(self, key : Literal["STP"]) -> Optional[RuleVariation_816]:
        ...
    @overload
    def get_item(self, key : Literal["KOS"]) -> Optional[RuleVariation_875]:
        ...
    @overload
    def get_item(self, key : Literal["AMA"]) -> Optional[RuleVariation_90]:
        ...
    @overload
    def get_item(self, key : Literal["MD4"]) -> Optional[RuleVariation_458]:
        ...
    @overload
    def get_item(self, key : Literal["ME"]) -> Optional[RuleVariation_625]:
        ...
    @overload
    def get_item(self, key : Literal["MI"]) -> Optional[RuleVariation_708]:
        ...
    @overload
    def get_item(self, key : Literal["MD5"]) -> Optional[RuleVariation_852]:
        ...
    @overload
    def get_item(self, key : Literal["CST"]) -> Optional[RuleVariation_38]:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> Optional[RuleVariation_409]:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> Optional[RuleVariation_517]:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> Optional[RuleVariation_624]:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> Optional[RuleVariation_707]:
        ...
    @overload
    def get_item(self, key : Literal["SUC"]) -> Optional[RuleVariation_817]:
        ...
    @overload
    def get_item(self, key : Literal["AAC"]) -> Optional[RuleVariation_893]:
        ...
    @overload
    def get_item(self, key : Literal["SDS"]) -> Optional[RuleVariation_100]:
        ...
    @overload
    def get_item(self, key : Literal["EMS"]) -> Optional[RuleVariation_590]:
        ...
    @overload
    def get_item(self, key : Literal["PFT"]) -> Optional[RuleVariation_833]:
        ...
    @overload
    def get_item(self, key : Literal["FPLT"]) -> Optional[RuleVariation_895]:
        ...
    @overload
    def get_item(self, key : Literal["DUPT"]) -> Optional[RuleVariation_39]:
        ...
    @overload
    def get_item(self, key : Literal["DUPF"]) -> Optional[RuleVariation_410]:
        ...
    @overload
    def get_item(self, key : Literal["DUPM"]) -> Optional[RuleVariation_519]:
        ...
    @overload
    def get_item(self, key : Literal["SFC"]) -> Optional[RuleVariation_626]:
        ...
    @overload
    def get_item(self, key : Literal["IDD"]) -> Optional[RuleVariation_729]:
        ...
    @overload
    def get_item(self, key : Literal["IEC"]) -> Optional[RuleVariation_814]:
        ...
    @overload
    def get_item(self, key : Literal["MLAT"]) -> Optional[RuleVariation_892]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1291(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1370.cv_arg
    cv_variation: TypeAlias = Variation_1370

    @classmethod
    def create(cls, arg : "RuleVariation_1291.cv_arg") -> "RuleVariation_1291":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1370:
        return self.arg # type: ignore

class NonSpare_241(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1291.cv_arg
    cv_name = "080"
    cv_title = "Track Status"
    cv_rule: TypeAlias = RuleVariation_1291

    @classmethod
    def create(cls, arg : "NonSpare_241.cv_arg") -> "NonSpare_241":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1291:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1370:
        return self.rule.variation

class UapItem_241(UapItem):
    cv_non_spare: TypeAlias = NonSpare_241

class Record_43(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_46.cv_arg,
        "015": NonSpare_59.cv_arg,
        "070": NonSpare_217.cv_arg,
        "105": NonSpare_281.cv_arg,
        "100": NonSpare_268.cv_arg,
        "185": NonSpare_386.cv_arg,
        "210": NonSpare_410.cv_arg,
        "060": NonSpare_202.cv_arg,
        "245": NonSpare_440.cv_arg,
        "380": NonSpare_486.cv_arg,
        "040": NonSpare_149.cv_arg,
        "080": NonSpare_241.cv_arg,
        "290": NonSpare_470.cv_arg,
        "200": NonSpare_394.cv_arg,
        "295": NonSpare_473.cv_arg,
        "136": NonSpare_320.cv_arg,
        "130": NonSpare_306.cv_arg,
        "135": NonSpare_319.cv_arg,
        "220": NonSpare_422.cv_arg,
        "390": NonSpare_494.cv_arg,
        "270": NonSpare_462.cv_arg,
        "300": NonSpare_477.cv_arg,
        "110": NonSpare_289.cv_arg,
        "120": NonSpare_305.cv_arg,
        "510": NonSpare_520.cv_arg,
        "500": NonSpare_515.cv_arg,
        "340": NonSpare_481.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 5
    cv_items_list = [UapItem_46, UapItem_549, UapItem_59, UapItem_217, UapItem_281, UapItem_268, UapItem_386, UapItem_410, UapItem_202, UapItem_440, UapItem_486, UapItem_149, UapItem_241, UapItem_470, UapItem_394, UapItem_473, UapItem_320, UapItem_306, UapItem_319, UapItem_422, UapItem_494, UapItem_462, UapItem_477, UapItem_289, UapItem_305, UapItem_519, UapItem_514, UapItem_481, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_46, "015": NonSpare_59, "070": NonSpare_217, "105": NonSpare_281, "100": NonSpare_268, "185": NonSpare_386, "210": NonSpare_410, "060": NonSpare_202, "245": NonSpare_440, "380": NonSpare_486, "040": NonSpare_149, "080": NonSpare_241, "290": NonSpare_470, "200": NonSpare_394, "295": NonSpare_473, "136": NonSpare_320, "130": NonSpare_306, "135": NonSpare_319, "220": NonSpare_422, "390": NonSpare_494, "270": NonSpare_462, "300": NonSpare_477, "110": NonSpare_289, "120": NonSpare_305, "510": NonSpare_520, "500": NonSpare_515, "340": NonSpare_481, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_59:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_217:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["105"]) -> NonSpare_281:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_268:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["185"]) -> NonSpare_386:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_410:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_202:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["245"]) -> NonSpare_440:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["380"]) -> NonSpare_486:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_149:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_241:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["290"]) -> NonSpare_470:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_394:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["295"]) -> NonSpare_473:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["136"]) -> NonSpare_320:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_306:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["135"]) -> NonSpare_319:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_422:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["390"]) -> NonSpare_494:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["270"]) -> NonSpare_462:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["300"]) -> NonSpare_477:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_289:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_305:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["510"]) -> NonSpare_520:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["500"]) -> NonSpare_515:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["340"]) -> NonSpare_481:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["070"], Literal["105"], Literal["100"], Literal["185"], Literal["210"], Literal["060"], Literal["245"], Literal["380"], Literal["040"], Literal["080"], Literal["290"], Literal["200"], Literal["295"], Literal["136"], Literal["130"], Literal["135"], Literal["220"], Literal["390"], Literal["270"], Literal["300"], Literal["110"], Literal["120"], Literal["510"], Literal["500"], Literal["340"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_46]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_59]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_217]:
        ...
    @overload
    def get_item(self, key : Literal["105"]) -> Optional[NonSpare_281]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_268]:
        ...
    @overload
    def get_item(self, key : Literal["185"]) -> Optional[NonSpare_386]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_410]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_202]:
        ...
    @overload
    def get_item(self, key : Literal["245"]) -> Optional[NonSpare_440]:
        ...
    @overload
    def get_item(self, key : Literal["380"]) -> Optional[NonSpare_486]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_149]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_241]:
        ...
    @overload
    def get_item(self, key : Literal["290"]) -> Optional[NonSpare_470]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_394]:
        ...
    @overload
    def get_item(self, key : Literal["295"]) -> Optional[NonSpare_473]:
        ...
    @overload
    def get_item(self, key : Literal["136"]) -> Optional[NonSpare_320]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_306]:
        ...
    @overload
    def get_item(self, key : Literal["135"]) -> Optional[NonSpare_319]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_422]:
        ...
    @overload
    def get_item(self, key : Literal["390"]) -> Optional[NonSpare_494]:
        ...
    @overload
    def get_item(self, key : Literal["270"]) -> Optional[NonSpare_462]:
        ...
    @overload
    def get_item(self, key : Literal["300"]) -> Optional[NonSpare_477]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_289]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_305]:
        ...
    @overload
    def get_item(self, key : Literal["510"]) -> Optional[NonSpare_520]:
        ...
    @overload
    def get_item(self, key : Literal["500"]) -> Optional[NonSpare_515]:
        ...
    @overload
    def get_item(self, key : Literal["340"]) -> Optional[NonSpare_481]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_46.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_59.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_217.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["105"], val : NonSpare_281.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_268.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["185"], val : NonSpare_386.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_410.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_202.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["245"], val : NonSpare_440.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["380"], val : NonSpare_486.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_149.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_241.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["290"], val : NonSpare_470.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_394.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["295"], val : NonSpare_473.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["136"], val : NonSpare_320.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_306.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["135"], val : NonSpare_319.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_422.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["390"], val : NonSpare_494.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["270"], val : NonSpare_462.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["300"], val : NonSpare_477.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_289.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_305.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["510"], val : NonSpare_520.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["500"], val : NonSpare_515.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["340"], val : NonSpare_481.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_43':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_43':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["105"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["185"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["245"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["380"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["290"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["295"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["136"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["135"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["390"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["270"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["300"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["510"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["500"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["340"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_43':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_43':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_43.cv_arg") -> 'Record_43':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_43", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_39(UapSingle):
    cv_arg: TypeAlias = Record_43
    cv_record: TypeAlias = Record_43

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_43]]:
        return cls._parse(bs)

class Asterix_56(AstCat):
    cv_category = 62
    cv_edition = (1, 20)
    cv_uap: TypeAlias = Uap_39
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_39.cv_arg]) -> "Asterix_56":
        return cls._create(records) # type: ignore

class NonSpare_65(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_65.cv_arg") -> "NonSpare_65":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_65(UapItem):
    cv_non_spare: TypeAlias = NonSpare_65

class NonSpare_113(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "030"
    cv_title = "Time of Message"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_113.cv_arg") -> "NonSpare_113":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_113(UapItem):
    cv_non_spare: TypeAlias = NonSpare_113

class NonSpare_177(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "050"
    cv_title = "Sensor Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_177.cv_arg") -> "NonSpare_177":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_177(UapItem):
    cv_non_spare: TypeAlias = NonSpare_177

class Content_410(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Operational", 1: "Degraded", 2: "Initialization", 3: "Not currently connected"}

class RuleContent_410(RuleContentContextFree):
    cv_arg: TypeAlias = Content_410.cv_arg
    cv_content: TypeAlias = Content_410

    @property
    def content(self) -> Content_410:
        return self._get_content() # type: ignore

class Variation_107(Element):
    cv_arg: TypeAlias = RuleContent_410.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_410

    @classmethod
    def create(cls, arg: "Variation_107.cv_arg") -> "Variation_107":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_410:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_410:
        return self.rule.content

class RuleVariation_107(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_107.cv_arg
    cv_variation: TypeAlias = Variation_107

    @classmethod
    def create(cls, arg : "RuleVariation_107.cv_arg") -> "RuleVariation_107":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_107:
        return self.arg # type: ignore

class Content_424(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "PSR GO", 1: "PSR NOGO"}

class RuleContent_424(RuleContentContextFree):
    cv_arg: TypeAlias = Content_424.cv_arg
    cv_content: TypeAlias = Content_424

    @property
    def content(self) -> Content_424:
        return self._get_content() # type: ignore

class Variation_572(Element):
    cv_arg: TypeAlias = RuleContent_424.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_424

    @classmethod
    def create(cls, arg: "Variation_572.cv_arg") -> "Variation_572":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_424:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_424:
        return self.rule.content

class RuleVariation_561(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_572.cv_arg
    cv_variation: TypeAlias = Variation_572

    @classmethod
    def create(cls, arg : "RuleVariation_561.cv_arg") -> "RuleVariation_561":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_572:
        return self.arg # type: ignore

class Content_450(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "SSR GO", 1: "SSR NOGO"}

class RuleContent_450(RuleContentContextFree):
    cv_arg: TypeAlias = Content_450.cv_arg
    cv_content: TypeAlias = Content_450

    @property
    def content(self) -> Content_450:
        return self._get_content() # type: ignore

class Variation_661(Element):
    cv_arg: TypeAlias = RuleContent_450.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_450

    @classmethod
    def create(cls, arg: "Variation_661.cv_arg") -> "Variation_661":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_450:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_450:
        return self.rule.content

class RuleVariation_650(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_661.cv_arg
    cv_variation: TypeAlias = Variation_661

    @classmethod
    def create(cls, arg : "RuleVariation_650.cv_arg") -> "RuleVariation_650":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_661:
        return self.arg # type: ignore

class Content_261(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "MDS GO", 1: "MDS NOGO"}

class RuleContent_261(RuleContentContextFree):
    cv_arg: TypeAlias = Content_261.cv_arg
    cv_content: TypeAlias = Content_261

    @property
    def content(self) -> Content_261:
        return self._get_content() # type: ignore

class Variation_730(Element):
    cv_arg: TypeAlias = RuleContent_261.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 1
    cv_rule = RuleContent_261

    @classmethod
    def create(cls, arg: "Variation_730.cv_arg") -> "Variation_730":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_261:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_261:
        return self.rule.content

class RuleVariation_719(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_730.cv_arg
    cv_variation: TypeAlias = Variation_730

    @classmethod
    def create(cls, arg : "RuleVariation_719.cv_arg") -> "RuleVariation_719":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_730:
        return self.arg # type: ignore

class Content_9(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "ADS GO", 1: "ADS NOGO"}

class RuleContent_9(RuleContentContextFree):
    cv_arg: TypeAlias = Content_9.cv_arg
    cv_content: TypeAlias = Content_9

    @property
    def content(self) -> Content_9:
        return self._get_content() # type: ignore

class Variation_818(Element):
    cv_arg: TypeAlias = RuleContent_9.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_9

    @classmethod
    def create(cls, arg: "Variation_818.cv_arg") -> "Variation_818":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_9:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_9:
        return self.rule.content

class RuleVariation_788(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_818.cv_arg
    cv_variation: TypeAlias = Variation_818

    @classmethod
    def create(cls, arg : "RuleVariation_788.cv_arg") -> "RuleVariation_788":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_818:
        return self.arg # type: ignore

class Content_262(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "MLT GO", 1: "MLT NOGO"}

class RuleContent_262(RuleContentContextFree):
    cv_arg: TypeAlias = Content_262.cv_arg
    cv_content: TypeAlias = Content_262

    @property
    def content(self) -> Content_262:
        return self._get_content() # type: ignore

class Variation_936(Element):
    cv_arg: TypeAlias = RuleContent_262.cv_arg
    cv_bit_offset8 = 6
    cv_bit_size = 1
    cv_rule = RuleContent_262

    @classmethod
    def create(cls, arg: "Variation_936.cv_arg") -> "Variation_936":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_262:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_262:
        return self.rule.content

class RuleVariation_906(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_936.cv_arg
    cv_variation: TypeAlias = Variation_936

    @classmethod
    def create(cls, arg : "RuleVariation_906.cv_arg") -> "RuleVariation_906":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_936:
        return self.arg # type: ignore

class Content_461(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "System is released for operational use", 1: "Operational use of System is inhibited"}

class RuleContent_461(RuleContentContextFree):
    cv_arg: TypeAlias = Content_461.cv_arg
    cv_content: TypeAlias = Content_461

    @property
    def content(self) -> Content_461:
        return self._get_content() # type: ignore

class Variation_77(Element):
    cv_arg: TypeAlias = RuleContent_461.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_461

    @classmethod
    def create(cls, arg: "Variation_77.cv_arg") -> "Variation_77":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_461:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_461:
        return self.rule.content

class RuleVariation_77(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_77.cv_arg
    cv_variation: TypeAlias = Variation_77

    @classmethod
    def create(cls, arg : "RuleVariation_77.cv_arg") -> "RuleVariation_77":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_77:
        return self.arg # type: ignore

class Variation_648(Element):
    cv_arg: TypeAlias = RuleContent_295.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_295

    @classmethod
    def create(cls, arg: "Variation_648.cv_arg") -> "Variation_648":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_295:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_295:
        return self.rule.content

class RuleVariation_637(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_648.cv_arg
    cv_variation: TypeAlias = Variation_648

    @classmethod
    def create(cls, arg : "RuleVariation_637.cv_arg") -> "RuleVariation_637":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_648:
        return self.arg # type: ignore

class Content_169(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default (no meaning)", 1: "No plots being received"}

class RuleContent_169(RuleContentContextFree):
    cv_arg: TypeAlias = Content_169.cv_arg
    cv_content: TypeAlias = Content_169

    @property
    def content(self) -> Content_169:
        return self._get_content() # type: ignore

class Variation_843(Element):
    cv_arg: TypeAlias = RuleContent_169.cv_arg
    cv_bit_offset8 = 5
    cv_bit_size = 1
    cv_rule = RuleContent_169

    @classmethod
    def create(cls, arg: "Variation_843.cv_arg") -> "Variation_843":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_169:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_169:
        return self.rule.content

class RuleVariation_813(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_843.cv_arg
    cv_variation: TypeAlias = Variation_843

    @classmethod
    def create(cls, arg : "RuleVariation_813.cv_arg") -> "RuleVariation_813":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_843:
        return self.arg # type: ignore

class NonSpare_792(NonSpare):
    cv_arg: TypeAlias = RuleVariation_107.cv_arg
    cv_name = "CON"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_107

    @classmethod
    def create(cls, arg : "NonSpare_792.cv_arg") -> "NonSpare_792":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_107:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_107:
        return self.rule.variation

class Item_191(Item):
    cv_arg: TypeAlias = NonSpare_792.cv_arg
    cv_non_spare: TypeAlias = NonSpare_792

    @classmethod
    def create(cls, arg : "Item_191.cv_arg") -> "Item_191":
        return cls._create(arg) # type: ignore

class NonSpare_1473(NonSpare):
    cv_arg: TypeAlias = RuleVariation_561.cv_arg
    cv_name = "PSR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_561

    @classmethod
    def create(cls, arg : "NonSpare_1473.cv_arg") -> "NonSpare_1473":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_561:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_572:
        return self.rule.variation

class Item_714(Item):
    cv_arg: TypeAlias = NonSpare_1473.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1473

    @classmethod
    def create(cls, arg : "Item_714.cv_arg") -> "Item_714":
        return cls._create(arg) # type: ignore

class NonSpare_1759(NonSpare):
    cv_arg: TypeAlias = RuleVariation_650.cv_arg
    cv_name = "SSR"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_650

    @classmethod
    def create(cls, arg : "NonSpare_1759.cv_arg") -> "NonSpare_1759":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_650:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_661:
        return self.rule.variation

class Item_929(Item):
    cv_arg: TypeAlias = NonSpare_1759.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1759

    @classmethod
    def create(cls, arg : "Item_929.cv_arg") -> "Item_929":
        return cls._create(arg) # type: ignore

class NonSpare_1257(NonSpare):
    cv_arg: TypeAlias = RuleVariation_719.cv_arg
    cv_name = "MDS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_719

    @classmethod
    def create(cls, arg : "NonSpare_1257.cv_arg") -> "NonSpare_1257":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_719:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_730:
        return self.rule.variation

class Item_540(Item):
    cv_arg: TypeAlias = NonSpare_1257.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1257

    @classmethod
    def create(cls, arg : "Item_540.cv_arg") -> "Item_540":
        return cls._create(arg) # type: ignore

class NonSpare_575(NonSpare):
    cv_arg: TypeAlias = RuleVariation_788.cv_arg
    cv_name = "ADS"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_788

    @classmethod
    def create(cls, arg : "NonSpare_575.cv_arg") -> "NonSpare_575":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_788:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_818:
        return self.rule.variation

class Item_47(Item):
    cv_arg: TypeAlias = NonSpare_575.cv_arg
    cv_non_spare: TypeAlias = NonSpare_575

    @classmethod
    def create(cls, arg : "Item_47.cv_arg") -> "Item_47":
        return cls._create(arg) # type: ignore

class NonSpare_1292(NonSpare):
    cv_arg: TypeAlias = RuleVariation_906.cv_arg
    cv_name = "MLT"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_906

    @classmethod
    def create(cls, arg : "NonSpare_1292.cv_arg") -> "NonSpare_1292":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_906:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_936:
        return self.rule.variation

class Item_559(Item):
    cv_arg: TypeAlias = NonSpare_1292.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1292

    @classmethod
    def create(cls, arg : "Item_559.cv_arg") -> "Item_559":
        return cls._create(arg) # type: ignore

class NonSpare_1401(NonSpare):
    cv_arg: TypeAlias = RuleVariation_77.cv_arg
    cv_name = "OPS"
    cv_title = "Operational Release Status of the System"
    cv_rule: TypeAlias = RuleVariation_77

    @classmethod
    def create(cls, arg : "NonSpare_1401.cv_arg") -> "NonSpare_1401":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_77:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_77:
        return self.rule.variation

class Item_660(Item):
    cv_arg: TypeAlias = NonSpare_1401.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1401

    @classmethod
    def create(cls, arg : "Item_660.cv_arg") -> "Item_660":
        return cls._create(arg) # type: ignore

class NonSpare_1417(NonSpare):
    cv_arg: TypeAlias = RuleVariation_522.cv_arg
    cv_name = "OXT"
    cv_title = "Transmission Subsystem Overload Status"
    cv_rule: TypeAlias = RuleVariation_522

    @classmethod
    def create(cls, arg : "NonSpare_1417.cv_arg") -> "NonSpare_1417":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_522:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_533:
        return self.rule.variation

class Item_675(Item):
    cv_arg: TypeAlias = NonSpare_1417.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1417

    @classmethod
    def create(cls, arg : "Item_675.cv_arg") -> "Item_675":
        return cls._create(arg) # type: ignore

class NonSpare_1324(NonSpare):
    cv_arg: TypeAlias = RuleVariation_637.cv_arg
    cv_name = "MSC"
    cv_title = "Monitoring System Connected Status"
    cv_rule: TypeAlias = RuleVariation_637

    @classmethod
    def create(cls, arg : "NonSpare_1324.cv_arg") -> "NonSpare_1324":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_637:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_648:
        return self.rule.variation

class Item_588(Item):
    cv_arg: TypeAlias = NonSpare_1324.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1324

    @classmethod
    def create(cls, arg : "Item_588.cv_arg") -> "Item_588":
        return cls._create(arg) # type: ignore

class NonSpare_1380(NonSpare):
    cv_arg: TypeAlias = RuleVariation_813.cv_arg
    cv_name = "NPW"
    cv_title = "No Plot Warning"
    cv_rule: TypeAlias = RuleVariation_813

    @classmethod
    def create(cls, arg : "NonSpare_1380.cv_arg") -> "NonSpare_1380":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_813:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_843:
        return self.rule.variation

class Item_639(Item):
    cv_arg: TypeAlias = NonSpare_1380.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1380

    @classmethod
    def create(cls, arg : "Item_639.cv_arg") -> "Item_639":
        return cls._create(arg) # type: ignore

class Variation_1356(Extended):
    cv_arg_group_1: TypeAlias = Union[int, Tuple[Union[RuleVariation_107.cv_arg, Tuple[Literal["CON"], RuleVariation_107.cv_arg]], Union[RuleVariation_561.cv_arg, Tuple[Literal["PSR"], RuleVariation_561.cv_arg]], Union[RuleVariation_650.cv_arg, Tuple[Literal["SSR"], RuleVariation_650.cv_arg]], Union[RuleVariation_719.cv_arg, Tuple[Literal["MDS"], RuleVariation_719.cv_arg]], Union[RuleVariation_788.cv_arg, Tuple[Literal["ADS"], RuleVariation_788.cv_arg]], Union[RuleVariation_906.cv_arg, Tuple[Literal["MLT"], RuleVariation_906.cv_arg]], None]]
    cv_arg_group_2: TypeAlias = Union[int, Tuple[Union[RuleVariation_77.cv_arg, Tuple[Literal["OPS"], RuleVariation_77.cv_arg]], Union[RuleVariation_414.cv_arg, Tuple[Literal["ODP"], RuleVariation_414.cv_arg]], Union[RuleVariation_522.cv_arg, Tuple[Literal["OXT"], RuleVariation_522.cv_arg]], Union[RuleVariation_637.cv_arg, Tuple[Literal["MSC"], RuleVariation_637.cv_arg]], Union[RuleVariation_749.cv_arg, Tuple[Literal["TSV"], RuleVariation_749.cv_arg]], Union[RuleVariation_813.cv_arg, Tuple[Literal["NPW"], RuleVariation_813.cv_arg]], int, None]]
    cv_arg: TypeAlias = Union[
        Tuple["Variation_1356.cv_arg_group_1"],
        Tuple["Variation_1356.cv_arg_group_1", "Variation_1356.cv_arg_group_2"],
    ]
    cv_items_list = [[(Item_191, 2), (Item_714, 1), (Item_929, 1), (Item_540, 1), (Item_47, 1), (Item_559, 1), None], [(Item_660, 1), (Item_654, 1), (Item_675, 1), (Item_588, 1), (Item_1059, 1), (Item_639, 1), (Item_26, 1), None]]

    @classmethod
    def create(cls, arg: "Variation_1356.cv_arg") -> 'Variation_1356':
        return cls._create(arg) # type: ignore

    @overload
    def get_item(self, key : Literal["CON"]) -> RuleVariation_107:
        ...
    @overload
    def get_item(self, key : Literal["PSR"]) -> RuleVariation_561:
        ...
    @overload
    def get_item(self, key : Literal["SSR"]) -> RuleVariation_650:
        ...
    @overload
    def get_item(self, key : Literal["MDS"]) -> RuleVariation_719:
        ...
    @overload
    def get_item(self, key : Literal["ADS"]) -> RuleVariation_788:
        ...
    @overload
    def get_item(self, key : Literal["MLT"]) -> RuleVariation_906:
        ...
    @overload
    def get_item(self, key : Literal["OPS"]) -> Optional[RuleVariation_77]:
        ...
    @overload
    def get_item(self, key : Literal["ODP"]) -> Optional[RuleVariation_414]:
        ...
    @overload
    def get_item(self, key : Literal["OXT"]) -> Optional[RuleVariation_522]:
        ...
    @overload
    def get_item(self, key : Literal["MSC"]) -> Optional[RuleVariation_637]:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> Optional[RuleVariation_749]:
        ...
    @overload
    def get_item(self, key : Literal["NPW"]) -> Optional[RuleVariation_813]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

class RuleVariation_1277(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1356.cv_arg
    cv_variation: TypeAlias = Variation_1356

    @classmethod
    def create(cls, arg : "RuleVariation_1277.cv_arg") -> "RuleVariation_1277":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1356:
        return self.arg # type: ignore

class NonSpare_197(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1277.cv_arg
    cv_name = "060"
    cv_title = "Sensor Configuration and Status"
    cv_rule: TypeAlias = RuleVariation_1277

    @classmethod
    def create(cls, arg : "NonSpare_197.cv_arg") -> "NonSpare_197":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1277:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1356:
        return self.rule.variation

class UapItem_197(UapItem):
    cv_non_spare: TypeAlias = NonSpare_197

class Content_630(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["ms"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0
    cv_unit = "ms"

    def as_quantity(self, cv_unit : Optional[Literal["ms"]] = None) -> float:
        return self._as_quantity()

class RuleContent_630(RuleContentContextFree):
    cv_arg: TypeAlias = Content_630.cv_arg
    cv_content: TypeAlias = Content_630

    @property
    def content(self) -> Content_630:
        return self._get_content() # type: ignore

class Variation_260(Element):
    cv_arg: TypeAlias = RuleContent_630.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_630

    @classmethod
    def create(cls, arg: "Variation_260.cv_arg") -> "Variation_260":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_630:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_630:
        return self.rule.content

class RuleVariation_253(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_260.cv_arg
    cv_variation: TypeAlias = Variation_260

    @classmethod
    def create(cls, arg : "RuleVariation_253.cv_arg") -> "RuleVariation_253":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_260:
        return self.arg # type: ignore

class NonSpare_218(NonSpare):
    cv_arg: TypeAlias = RuleVariation_253.cv_arg
    cv_name = "070"
    cv_title = "Time Stamping Bias"
    cv_rule: TypeAlias = RuleVariation_253

    @classmethod
    def create(cls, arg : "NonSpare_218.cv_arg") -> "NonSpare_218":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_253:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_260:
        return self.rule.variation

class UapItem_218(UapItem):
    cv_non_spare: TypeAlias = NonSpare_218

class Content_651(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal[""]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-5
    cv_unit = ""

    def as_quantity(self, cv_unit : Optional[Literal[""]] = None) -> float:
        return self._as_quantity()

class RuleContent_651(RuleContentContextFree):
    cv_arg: TypeAlias = Content_651.cv_arg
    cv_content: TypeAlias = Content_651

    @property
    def content(self) -> Content_651:
        return self._get_content() # type: ignore

class Variation_271(Element):
    cv_arg: TypeAlias = RuleContent_651.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_651

    @classmethod
    def create(cls, arg: "Variation_271.cv_arg") -> "Variation_271":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_651:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_651:
        return self.rule.content

class RuleVariation_264(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_271.cv_arg
    cv_variation: TypeAlias = Variation_271

    @classmethod
    def create(cls, arg : "RuleVariation_264.cv_arg") -> "RuleVariation_264":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_271:
        return self.arg # type: ignore

class NonSpare_1752(NonSpare):
    cv_arg: TypeAlias = RuleVariation_264.cv_arg
    cv_name = "SRG"
    cv_title = "Mode S Range Gain"
    cv_rule: TypeAlias = RuleVariation_264

    @classmethod
    def create(cls, arg : "NonSpare_1752.cv_arg") -> "NonSpare_1752":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_264:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_271:
        return self.rule.variation

class Item_924(Item):
    cv_arg: TypeAlias = NonSpare_1752.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1752

    @classmethod
    def create(cls, arg : "Item_924.cv_arg") -> "Item_924":
        return cls._create(arg) # type: ignore

class Variation_286(Element):
    cv_arg: TypeAlias = RuleContent_677.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_677

    @classmethod
    def create(cls, arg: "Variation_286.cv_arg") -> "Variation_286":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_677:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_677:
        return self.rule.content

class RuleVariation_279(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_286.cv_arg
    cv_variation: TypeAlias = Variation_286

    @classmethod
    def create(cls, arg : "RuleVariation_279.cv_arg") -> "RuleVariation_279":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_286:
        return self.arg # type: ignore

class NonSpare_1746(NonSpare):
    cv_arg: TypeAlias = RuleVariation_279.cv_arg
    cv_name = "SRB"
    cv_title = "Mode S Range Bias"
    cv_rule: TypeAlias = RuleVariation_279

    @classmethod
    def create(cls, arg : "NonSpare_1746.cv_arg") -> "NonSpare_1746":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_279:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_286:
        return self.rule.variation

class Item_919(Item):
    cv_arg: TypeAlias = NonSpare_1746.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1746

    @classmethod
    def create(cls, arg : "Item_919.cv_arg") -> "Item_919":
        return cls._create(arg) # type: ignore

class Variation_1212(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_264.cv_arg, Tuple[Literal["SRG"], RuleVariation_264.cv_arg]], Union[RuleVariation_279.cv_arg, Tuple[Literal["SRB"], RuleVariation_279.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1212.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_924, 16), (Item_919, 16)]
    cv_items_dict = {"SRG": RuleVariation_264, "SRB": RuleVariation_279}

    @overload
    @classmethod
    def spec(cls, key : Literal["SRG"]) -> RuleVariation_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SRB"]) -> RuleVariation_279:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["SRG"], Literal["SRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["SRG"]) -> RuleVariation_264:
        ...
    @overload
    def get_item(self, key : Literal["SRB"]) -> RuleVariation_279:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1212.cv_arg") -> 'Variation_1212':
        return cls._create(arg) # type: ignore

class RuleVariation_1156(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1212.cv_arg
    cv_variation: TypeAlias = Variation_1212

    @classmethod
    def create(cls, arg : "RuleVariation_1156.cv_arg") -> "RuleVariation_1156":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1212:
        return self.arg # type: ignore

class NonSpare_235(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1156.cv_arg
    cv_name = "080"
    cv_title = "SSR / Mode S Range Gain and Bias"
    cv_rule: TypeAlias = RuleVariation_1156

    @classmethod
    def create(cls, arg : "NonSpare_235.cv_arg") -> "NonSpare_235":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1156:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1212:
        return self.rule.variation

class UapItem_235(UapItem):
    cv_non_spare: TypeAlias = NonSpare_235

class Content_709(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_709(RuleContentContextFree):
    cv_arg: TypeAlias = Content_709.cv_arg
    cv_content: TypeAlias = Content_709

    @property
    def content(self) -> Content_709:
        return self._get_content() # type: ignore

class Variation_299(Element):
    cv_arg: TypeAlias = RuleContent_709.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_709

    @classmethod
    def create(cls, arg: "Variation_299.cv_arg") -> "Variation_299":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_709:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_709:
        return self.rule.content

class RuleVariation_292(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_299.cv_arg
    cv_variation: TypeAlias = Variation_299

    @classmethod
    def create(cls, arg : "RuleVariation_292.cv_arg") -> "RuleVariation_292":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_299:
        return self.arg # type: ignore

class NonSpare_243(NonSpare):
    cv_arg: TypeAlias = RuleVariation_292.cv_arg
    cv_name = "081"
    cv_title = "SSR Mode S Azimuth Bias"
    cv_rule: TypeAlias = RuleVariation_292

    @classmethod
    def create(cls, arg : "NonSpare_243.cv_arg") -> "NonSpare_243":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_299:
        return self.rule.variation

class UapItem_243(UapItem):
    cv_non_spare: TypeAlias = NonSpare_243

class NonSpare_1464(NonSpare):
    cv_arg: TypeAlias = RuleVariation_264.cv_arg
    cv_name = "PRG"
    cv_title = "PSR Range Gain"
    cv_rule: TypeAlias = RuleVariation_264

    @classmethod
    def create(cls, arg : "NonSpare_1464.cv_arg") -> "NonSpare_1464":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_264:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_271:
        return self.rule.variation

class Item_707(Item):
    cv_arg: TypeAlias = NonSpare_1464.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1464

    @classmethod
    def create(cls, arg : "Item_707.cv_arg") -> "Item_707":
        return cls._create(arg) # type: ignore

class NonSpare_1457(NonSpare):
    cv_arg: TypeAlias = RuleVariation_279.cv_arg
    cv_name = "PRB"
    cv_title = "PSR Range Bias"
    cv_rule: TypeAlias = RuleVariation_279

    @classmethod
    def create(cls, arg : "NonSpare_1457.cv_arg") -> "NonSpare_1457":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_279:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_286:
        return self.rule.variation

class Item_700(Item):
    cv_arg: TypeAlias = NonSpare_1457.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1457

    @classmethod
    def create(cls, arg : "Item_700.cv_arg") -> "Item_700":
        return cls._create(arg) # type: ignore

class Variation_1163(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_264.cv_arg, Tuple[Literal["PRG"], RuleVariation_264.cv_arg]], Union[RuleVariation_279.cv_arg, Tuple[Literal["PRB"], RuleVariation_279.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1163.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_707, 16), (Item_700, 16)]
    cv_items_dict = {"PRG": RuleVariation_264, "PRB": RuleVariation_279}

    @overload
    @classmethod
    def spec(cls, key : Literal["PRG"]) -> RuleVariation_264:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PRB"]) -> RuleVariation_279:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PRG"], Literal["PRB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PRG"]) -> RuleVariation_264:
        ...
    @overload
    def get_item(self, key : Literal["PRB"]) -> RuleVariation_279:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1163.cv_arg") -> 'Variation_1163':
        return cls._create(arg) # type: ignore

class RuleVariation_1114(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1163.cv_arg
    cv_variation: TypeAlias = Variation_1163

    @classmethod
    def create(cls, arg : "RuleVariation_1114.cv_arg") -> "RuleVariation_1114":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1163:
        return self.arg # type: ignore

class NonSpare_254(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1114.cv_arg
    cv_name = "090"
    cv_title = "PSR Range Gain and Bias"
    cv_rule: TypeAlias = RuleVariation_1114

    @classmethod
    def create(cls, arg : "NonSpare_254.cv_arg") -> "NonSpare_254":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1114:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1163:
        return self.rule.variation

class UapItem_254(UapItem):
    cv_non_spare: TypeAlias = NonSpare_254

class NonSpare_261(NonSpare):
    cv_arg: TypeAlias = RuleVariation_292.cv_arg
    cv_name = "091"
    cv_title = "PSR Azimuth Bias"
    cv_rule: TypeAlias = RuleVariation_292

    @classmethod
    def create(cls, arg : "NonSpare_261.cv_arg") -> "NonSpare_261":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_299:
        return self.rule.variation

class UapItem_261(UapItem):
    cv_non_spare: TypeAlias = NonSpare_261

class NonSpare_263(NonSpare):
    cv_arg: TypeAlias = RuleVariation_292.cv_arg
    cv_name = "092"
    cv_title = "PSR Elevation Bias"
    cv_rule: TypeAlias = RuleVariation_292

    @classmethod
    def create(cls, arg : "NonSpare_263.cv_arg") -> "NonSpare_263":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_292:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_299:
        return self.rule.variation

class UapItem_263(UapItem):
    cv_non_spare: TypeAlias = NonSpare_263

class Record_22(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "015": NonSpare_65.cv_arg,
        "030": NonSpare_113.cv_arg,
        "050": NonSpare_177.cv_arg,
        "060": NonSpare_197.cv_arg,
        "070": NonSpare_218.cv_arg,
        "080": NonSpare_235.cv_arg,
        "081": NonSpare_243.cv_arg,
        "090": NonSpare_254.cv_arg,
        "091": NonSpare_261.cv_arg,
        "092": NonSpare_263.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_37, UapItem_65, UapItem_113, UapItem_177, UapItem_197, UapItem_218, UapItem_235, UapItem_243, UapItem_254, UapItem_261, UapItem_263, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_37, "015": NonSpare_65, "030": NonSpare_113, "050": NonSpare_177, "060": NonSpare_197, "070": NonSpare_218, "080": NonSpare_235, "081": NonSpare_243, "090": NonSpare_254, "091": NonSpare_261, "092": NonSpare_263, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_65:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_113:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_177:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_197:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_218:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_235:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["081"]) -> NonSpare_243:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_254:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["091"]) -> NonSpare_261:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["092"]) -> NonSpare_263:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["030"], Literal["050"], Literal["060"], Literal["070"], Literal["080"], Literal["081"], Literal["090"], Literal["091"], Literal["092"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_65]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_113]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_177]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_197]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_218]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_235]:
        ...
    @overload
    def get_item(self, key : Literal["081"]) -> Optional[NonSpare_243]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_254]:
        ...
    @overload
    def get_item(self, key : Literal["091"]) -> Optional[NonSpare_261]:
        ...
    @overload
    def get_item(self, key : Literal["092"]) -> Optional[NonSpare_263]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_65.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_113.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_177.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_197.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_218.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_235.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["081"], val : NonSpare_243.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_254.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["091"], val : NonSpare_261.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["092"], val : NonSpare_263.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_22':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_22':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["081"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["091"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["092"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_22':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_22':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_22.cv_arg") -> 'Record_22':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_22", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_20(UapSingle):
    cv_arg: TypeAlias = Record_22
    cv_record: TypeAlias = Record_22

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_22]]:
        return cls._parse(bs)

class Asterix_57(AstCat):
    cv_category = 63
    cv_edition = (1, 6)
    cv_uap: TypeAlias = Uap_20
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_20.cv_arg]) -> "Asterix_57":
        return cls._create(records) # type: ignore

class Content_593(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "SDPS Status", 2: "End of Batch", 3: "Service Status Report"}

class RuleContent_593(RuleContentContextFree):
    cv_arg: TypeAlias = Content_593.cv_arg
    cv_content: TypeAlias = Content_593

    @property
    def content(self) -> Content_593:
        return self._get_content() # type: ignore

class Variation_193(Element):
    cv_arg: TypeAlias = RuleContent_593.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_593

    @classmethod
    def create(cls, arg: "Variation_193.cv_arg") -> "Variation_193":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_593:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_593:
        return self.rule.content

class RuleVariation_186(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_193.cv_arg
    cv_variation: TypeAlias = Variation_193

    @classmethod
    def create(cls, arg : "RuleVariation_186.cv_arg") -> "RuleVariation_186":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_193:
        return self.arg # type: ignore

class NonSpare_9(NonSpare):
    cv_arg: TypeAlias = RuleVariation_186.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_186

    @classmethod
    def create(cls, arg : "NonSpare_9.cv_arg") -> "NonSpare_9":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_186:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_193:
        return self.rule.variation

class UapItem_9(UapItem):
    cv_non_spare: TypeAlias = NonSpare_9

class NonSpare_61(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_61.cv_arg") -> "NonSpare_61":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_61(UapItem):
    cv_non_spare: TypeAlias = NonSpare_61

class NonSpare_112(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "030"
    cv_title = "Time of Message"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_112.cv_arg") -> "NonSpare_112":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_112(UapItem):
    cv_non_spare: TypeAlias = NonSpare_112

class NonSpare_77(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "020"
    cv_title = "Batch Number"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_77.cv_arg") -> "NonSpare_77":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class UapItem_77(UapItem):
    cv_non_spare: TypeAlias = NonSpare_77

class Content_413(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Operational", 1: "Degraded", 2: "Not currently connected", 3: "Unknown"}

class RuleContent_413(RuleContentContextFree):
    cv_arg: TypeAlias = Content_413.cv_arg
    cv_content: TypeAlias = Content_413

    @property
    def content(self) -> Content_413:
        return self._get_content() # type: ignore

class Variation_110(Element):
    cv_arg: TypeAlias = RuleContent_413.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2
    cv_rule = RuleContent_413

    @classmethod
    def create(cls, arg: "Variation_110.cv_arg") -> "Variation_110":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_413:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_413:
        return self.rule.content

class RuleVariation_110(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_110.cv_arg
    cv_variation: TypeAlias = Variation_110

    @classmethod
    def create(cls, arg : "RuleVariation_110.cv_arg") -> "RuleVariation_110":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_110:
        return self.arg # type: ignore

class NonSpare_1365(NonSpare):
    cv_arg: TypeAlias = RuleVariation_110.cv_arg
    cv_name = "NOGO"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_110

    @classmethod
    def create(cls, arg : "NonSpare_1365.cv_arg") -> "NonSpare_1365":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_110:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_110:
        return self.rule.variation

class Item_625(Item):
    cv_arg: TypeAlias = NonSpare_1365.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1365

    @classmethod
    def create(cls, arg : "Item_625.cv_arg") -> "Item_625":
        return cls._create(arg) # type: ignore

class Content_137(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Overload"}

class RuleContent_137(RuleContentContextFree):
    cv_arg: TypeAlias = Content_137.cv_arg
    cv_content: TypeAlias = Content_137

    @property
    def content(self) -> Content_137:
        return self._get_content() # type: ignore

class Variation_523(Element):
    cv_arg: TypeAlias = RuleContent_137.cv_arg
    cv_bit_offset8 = 2
    cv_bit_size = 1
    cv_rule = RuleContent_137

    @classmethod
    def create(cls, arg: "Variation_523.cv_arg") -> "Variation_523":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_137:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_137:
        return self.rule.content

class RuleVariation_512(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_523.cv_arg
    cv_variation: TypeAlias = Variation_523

    @classmethod
    def create(cls, arg : "RuleVariation_512.cv_arg") -> "RuleVariation_512":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_523:
        return self.arg # type: ignore

class NonSpare_1408(NonSpare):
    cv_arg: TypeAlias = RuleVariation_512.cv_arg
    cv_name = "OVL"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_512

    @classmethod
    def create(cls, arg : "NonSpare_1408.cv_arg") -> "NonSpare_1408":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_512:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_523:
        return self.rule.variation

class Item_666(Item):
    cv_arg: TypeAlias = NonSpare_1408.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1408

    @classmethod
    def create(cls, arg : "Item_666.cv_arg") -> "Item_666":
        return cls._create(arg) # type: ignore

class Content_110(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Default", 1: "Invalid Time Source"}

class RuleContent_110(RuleContentContextFree):
    cv_arg: TypeAlias = Content_110.cv_arg
    cv_content: TypeAlias = Content_110

    @property
    def content(self) -> Content_110:
        return self._get_content() # type: ignore

class Variation_624(Element):
    cv_arg: TypeAlias = RuleContent_110.cv_arg
    cv_bit_offset8 = 3
    cv_bit_size = 1
    cv_rule = RuleContent_110

    @classmethod
    def create(cls, arg: "Variation_624.cv_arg") -> "Variation_624":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_110:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_110:
        return self.rule.content

class RuleVariation_613(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_624.cv_arg
    cv_variation: TypeAlias = Variation_624

    @classmethod
    def create(cls, arg : "RuleVariation_613.cv_arg") -> "RuleVariation_613":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_624:
        return self.arg # type: ignore

class NonSpare_1940(NonSpare):
    cv_arg: TypeAlias = RuleVariation_613.cv_arg
    cv_name = "TSV"
    cv_title = ""
    cv_rule: TypeAlias = RuleVariation_613

    @classmethod
    def create(cls, arg : "NonSpare_1940.cv_arg") -> "NonSpare_1940":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_613:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_624:
        return self.rule.variation

class Item_1057(Item):
    cv_arg: TypeAlias = NonSpare_1940.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1940

    @classmethod
    def create(cls, arg : "Item_1057.cv_arg") -> "Item_1057":
        return cls._create(arg) # type: ignore

class Content_390(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "Not applicable", 1: "SDPS-1 selected", 2: "SDPS-2 selected", 3: "SDPS-3 selected"}

class RuleContent_390(RuleContentContextFree):
    cv_arg: TypeAlias = Content_390.cv_arg
    cv_content: TypeAlias = Content_390

    @property
    def content(self) -> Content_390:
        return self._get_content() # type: ignore

class Variation_767(Element):
    cv_arg: TypeAlias = RuleContent_390.cv_arg
    cv_bit_offset8 = 4
    cv_bit_size = 2
    cv_rule = RuleContent_390

    @classmethod
    def create(cls, arg: "Variation_767.cv_arg") -> "Variation_767":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_390:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_390:
        return self.rule.content

class RuleVariation_756(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_767.cv_arg
    cv_variation: TypeAlias = Variation_767

    @classmethod
    def create(cls, arg : "RuleVariation_756.cv_arg") -> "RuleVariation_756":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_767:
        return self.arg # type: ignore

class NonSpare_1480(NonSpare):
    cv_arg: TypeAlias = RuleVariation_756.cv_arg
    cv_name = "PSS"
    cv_title = "Processing System Status"
    cv_rule: TypeAlias = RuleVariation_756

    @classmethod
    def create(cls, arg : "NonSpare_1480.cv_arg") -> "NonSpare_1480":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_756:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_767:
        return self.rule.variation

class Item_716(Item):
    cv_arg: TypeAlias = NonSpare_1480.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1480

    @classmethod
    def create(cls, arg : "Item_716.cv_arg") -> "Item_716":
        return cls._create(arg) # type: ignore

class NonSpare_1802(NonSpare):
    cv_arg: TypeAlias = RuleVariation_869.cv_arg
    cv_name = "STTN"
    cv_title = "Track Re-numbering Indication"
    cv_rule: TypeAlias = RuleVariation_869

    @classmethod
    def create(cls, arg : "NonSpare_1802.cv_arg") -> "NonSpare_1802":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_869:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_899:
        return self.rule.variation

class Item_958(Item):
    cv_arg: TypeAlias = NonSpare_1802.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1802

    @classmethod
    def create(cls, arg : "Item_958.cv_arg") -> "Item_958":
        return cls._create(arg) # type: ignore

class Variation_1151(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_110.cv_arg, Tuple[Literal["NOGO"], RuleVariation_110.cv_arg]], Union[RuleVariation_512.cv_arg, Tuple[Literal["OVL"], RuleVariation_512.cv_arg]], Union[RuleVariation_613.cv_arg, Tuple[Literal["TSV"], RuleVariation_613.cv_arg]], Union[RuleVariation_756.cv_arg, Tuple[Literal["PSS"], RuleVariation_756.cv_arg]], Union[RuleVariation_869.cv_arg, Tuple[Literal["STTN"], RuleVariation_869.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1151.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_625, 2), (Item_666, 1), (Item_1057, 1), (Item_716, 2), (Item_958, 1), (Item_29, 1)]
    cv_items_dict = {"NOGO": RuleVariation_110, "OVL": RuleVariation_512, "TSV": RuleVariation_613, "PSS": RuleVariation_756, "STTN": RuleVariation_869}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOGO"]) -> RuleVariation_110:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OVL"]) -> RuleVariation_512:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TSV"]) -> RuleVariation_613:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["PSS"]) -> RuleVariation_756:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STTN"]) -> RuleVariation_869:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOGO"], Literal["OVL"], Literal["TSV"], Literal["PSS"], Literal["STTN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOGO"]) -> RuleVariation_110:
        ...
    @overload
    def get_item(self, key : Literal["OVL"]) -> RuleVariation_512:
        ...
    @overload
    def get_item(self, key : Literal["TSV"]) -> RuleVariation_613:
        ...
    @overload
    def get_item(self, key : Literal["PSS"]) -> RuleVariation_756:
        ...
    @overload
    def get_item(self, key : Literal["STTN"]) -> RuleVariation_869:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1151.cv_arg") -> 'Variation_1151':
        return cls._create(arg) # type: ignore

class RuleVariation_1104(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1151.cv_arg
    cv_variation: TypeAlias = Variation_1151

    @classmethod
    def create(cls, arg : "RuleVariation_1104.cv_arg") -> "RuleVariation_1104":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1151:
        return self.arg # type: ignore

class NonSpare_143(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1104.cv_arg
    cv_name = "040"
    cv_title = "SDPS Configuration and Status"
    cv_rule: TypeAlias = RuleVariation_1104

    @classmethod
    def create(cls, arg : "NonSpare_143.cv_arg") -> "NonSpare_143":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1104:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1151:
        return self.rule.variation

class UapItem_143(UapItem):
    cv_non_spare: TypeAlias = NonSpare_143

class Content_594(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Service degradation", 2: "Service degradation ended", 3: "Main radar out of service", 4: "Service interrupted by the operator", 5: "Service interrupted due to contingency", 6: "Ready for service restart after contingency", 7: "Service ended by the operator", 8: "Failure of user main radar", 9: "Service restarted by the operator", 10: "Main radar becoming operational", 11: "Main radar becoming degraded", 12: "Service continuity interrupted due to disconnection with adjacent unit", 13: "Service continuity restarted", 14: "Service synchronised on backup radar", 15: "Service synchronised on main radar", 16: "Main and backup radar, if any, failed"}

class RuleContent_594(RuleContentContextFree):
    cv_arg: TypeAlias = Content_594.cv_arg
    cv_content: TypeAlias = Content_594

    @property
    def content(self) -> Content_594:
        return self._get_content() # type: ignore

class Variation_194(Element):
    cv_arg: TypeAlias = RuleContent_594.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_594

    @classmethod
    def create(cls, arg: "Variation_194.cv_arg") -> "Variation_194":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_594:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_594:
        return self.rule.content

class RuleVariation_187(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_194.cv_arg
    cv_variation: TypeAlias = Variation_194

    @classmethod
    def create(cls, arg : "RuleVariation_187.cv_arg") -> "RuleVariation_187":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_194:
        return self.arg # type: ignore

class NonSpare_179(NonSpare):
    cv_arg: TypeAlias = RuleVariation_187.cv_arg
    cv_name = "050"
    cv_title = "Service Status Report"
    cv_rule: TypeAlias = RuleVariation_187

    @classmethod
    def create(cls, arg : "NonSpare_179.cv_arg") -> "NonSpare_179":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_187:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_194:
        return self.rule.variation

class UapItem_179(UapItem):
    cv_non_spare: TypeAlias = NonSpare_179

class Record_41(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_46.cv_arg,
        "000": NonSpare_9.cv_arg,
        "015": NonSpare_61.cv_arg,
        "030": NonSpare_112.cv_arg,
        "020": NonSpare_77.cv_arg,
        "040": NonSpare_143.cv_arg,
        "050": NonSpare_179.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_46, UapItem_9, UapItem_61, UapItem_112, UapItem_77, UapItem_143, UapItem_179, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_549, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_46, "000": NonSpare_9, "015": NonSpare_61, "030": NonSpare_112, "020": NonSpare_77, "040": NonSpare_143, "050": NonSpare_179, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_46:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_9:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_61:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_112:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_77:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_143:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_179:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["015"], Literal["030"], Literal["020"], Literal["040"], Literal["050"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_46]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_9]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_61]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_112]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_77]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_143]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_179]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_46.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_9.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_61.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_112.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_77.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_143.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_179.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_41':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_41':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_41':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_41':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_41.cv_arg") -> 'Record_41':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_41", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_37(UapSingle):
    cv_arg: TypeAlias = Record_41
    cv_record: TypeAlias = Record_41

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_41]]:
        return cls._parse(bs)

class Asterix_58(AstCat):
    cv_category = 65
    cv_edition = (1, 4)
    cv_uap: TypeAlias = Uap_37
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_37.cv_arg]) -> "Asterix_58":
        return cls._create(records) # type: ignore

class Asterix_59(AstCat):
    cv_category = 65
    cv_edition = (1, 5)
    cv_uap: TypeAlias = Uap_37
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_37.cv_arg]) -> "Asterix_59":
        return cls._create(records) # type: ignore

class Asterix_60(AstCat):
    cv_category = 65
    cv_edition = (1, 6)
    cv_uap: TypeAlias = Uap_37
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_37.cv_arg]) -> "Asterix_60":
        return cls._create(records) # type: ignore

class NonSpare_723(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "CEN"
    cv_title = "Centre Identifier"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_723.cv_arg") -> "NonSpare_723":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_149(Item):
    cv_arg: TypeAlias = NonSpare_723.cv_arg
    cv_non_spare: TypeAlias = NonSpare_723

    @classmethod
    def create(cls, arg : "Item_149.cv_arg") -> "Item_149":
        return cls._create(arg) # type: ignore

class NonSpare_1451(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "POS"
    cv_title = "Workstation Identifier"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_1451.cv_arg") -> "NonSpare_1451":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class Item_694(Item):
    cv_arg: TypeAlias = NonSpare_1451.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1451

    @classmethod
    def create(cls, arg : "Item_694.cv_arg") -> "Item_694":
        return cls._create(arg) # type: ignore

class Variation_1068(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_159.cv_arg, Tuple[Literal["CEN"], RuleVariation_159.cv_arg]], Union[RuleVariation_159.cv_arg, Tuple[Literal["POS"], RuleVariation_159.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1068.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_149, 8), (Item_694, 8)]
    cv_items_dict = {"CEN": RuleVariation_159, "POS": RuleVariation_159}

    @overload
    @classmethod
    def spec(cls, key : Literal["CEN"]) -> RuleVariation_159:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["POS"]) -> RuleVariation_159:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CEN"], Literal["POS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CEN"]) -> RuleVariation_159:
        ...
    @overload
    def get_item(self, key : Literal["POS"]) -> RuleVariation_159:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1068.cv_arg") -> 'Variation_1068':
        return cls._create(arg) # type: ignore

class RuleVariation_1030(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1068.cv_arg
    cv_variation: TypeAlias = Variation_1068

    @classmethod
    def create(cls, arg : "RuleVariation_1030.cv_arg") -> "RuleVariation_1030":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1068:
        return self.arg # type: ignore

class NonSpare_49(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1030.cv_arg
    cv_name = "010"
    cv_title = "Destination ID"
    cv_rule: TypeAlias = RuleVariation_1030

    @classmethod
    def create(cls, arg : "NonSpare_49.cv_arg") -> "NonSpare_49":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1030:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1068:
        return self.rule.variation

class UapItem_49(UapItem):
    cv_non_spare: TypeAlias = NonSpare_49

class NonSpare_84(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1030.cv_arg
    cv_name = "020"
    cv_title = "Source ID"
    cv_rule: TypeAlias = RuleVariation_1030

    @classmethod
    def create(cls, arg : "NonSpare_84.cv_arg") -> "NonSpare_84":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1030:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1068:
        return self.rule.variation

class UapItem_84(UapItem):
    cv_non_spare: TypeAlias = NonSpare_84

class Content_578(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Flight plan creation", 2: "Flight plan modification", 3: "Flight plan repetition", 4: "Manual flight plan deletion", 5: "Automatic flight plan deletion", 6: "Flight is beyond extraction area boundary", 251: "Short term conflict alert", 252: "Correlations", 253: "Decorrelations", 254: "Start of background loop", 255: "End of background loop"}

class RuleContent_578(RuleContentContextFree):
    cv_arg: TypeAlias = Content_578.cv_arg
    cv_content: TypeAlias = Content_578

    @property
    def content(self) -> Content_578:
        return self._get_content() # type: ignore

class Variation_181(Element):
    cv_arg: TypeAlias = RuleContent_578.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_578

    @classmethod
    def create(cls, arg: "Variation_181.cv_arg") -> "Variation_181":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_578:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_578:
        return self.rule.content

class RuleVariation_174(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_181.cv_arg
    cv_variation: TypeAlias = Variation_181

    @classmethod
    def create(cls, arg : "RuleVariation_174.cv_arg") -> "RuleVariation_174":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_181:
        return self.arg # type: ignore

class NonSpare_106(NonSpare):
    cv_arg: TypeAlias = RuleVariation_174.cv_arg
    cv_name = "030"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_174

    @classmethod
    def create(cls, arg : "NonSpare_106.cv_arg") -> "NonSpare_106":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_174:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_181:
        return self.rule.variation

class UapItem_106(UapItem):
    cv_non_spare: TypeAlias = NonSpare_106

class NonSpare_141(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "040"
    cv_title = "Plan Reference Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_141.cv_arg") -> "NonSpare_141":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_141(UapItem):
    cv_non_spare: TypeAlias = NonSpare_141

class NonSpare_168(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "050"
    cv_title = "Callsign"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_168.cv_arg") -> "NonSpare_168":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class UapItem_168(UapItem):
    cv_non_spare: TypeAlias = NonSpare_168

class NonSpare_194(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "060"
    cv_title = "Present Mode 3A"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_194.cv_arg") -> "NonSpare_194":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_194(UapItem):
    cv_non_spare: TypeAlias = NonSpare_194

class NonSpare_215(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "070"
    cv_title = "Next Mode 3A"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_215.cv_arg") -> "NonSpare_215":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_215(UapItem):
    cv_non_spare: TypeAlias = NonSpare_215

class NonSpare_232(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "080"
    cv_title = "Departure Aerodrome"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_232.cv_arg") -> "NonSpare_232":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_232(UapItem):
    cv_non_spare: TypeAlias = NonSpare_232

class NonSpare_246(NonSpare):
    cv_arg: TypeAlias = RuleVariation_367.cv_arg
    cv_name = "090"
    cv_title = "Destination Aerodrome"
    cv_rule: TypeAlias = RuleVariation_367

    @classmethod
    def create(cls, arg : "NonSpare_246.cv_arg") -> "NonSpare_246":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_367:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_374:
        return self.rule.variation

class UapItem_246(UapItem):
    cv_non_spare: TypeAlias = NonSpare_246

class NonSpare_1023(NonSpare):
    cv_arg: TypeAlias = RuleVariation_0.cv_arg
    cv_name = "GAT"
    cv_title = "General Air Traffic"
    cv_rule: TypeAlias = RuleVariation_0

    @classmethod
    def create(cls, arg : "NonSpare_1023.cv_arg") -> "NonSpare_1023":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_0:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_0:
        return self.rule.variation

class Item_361(Item):
    cv_arg: TypeAlias = NonSpare_1023.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1023

    @classmethod
    def create(cls, arg : "Item_361.cv_arg") -> "Item_361":
        return cls._create(arg) # type: ignore

class Variation_400(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 1
    cv_bit_size = 1
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_400.cv_arg") -> "Variation_400":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class RuleVariation_389(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_400.cv_arg
    cv_variation: TypeAlias = Variation_400

    @classmethod
    def create(cls, arg : "RuleVariation_389.cv_arg") -> "RuleVariation_389":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_400:
        return self.arg # type: ignore

class NonSpare_1389(NonSpare):
    cv_arg: TypeAlias = RuleVariation_389.cv_arg
    cv_name = "OAT"
    cv_title = "Operational Air Traffic"
    cv_rule: TypeAlias = RuleVariation_389

    @classmethod
    def create(cls, arg : "NonSpare_1389.cv_arg") -> "NonSpare_1389":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_389:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_400:
        return self.rule.variation

class Item_648(Item):
    cv_arg: TypeAlias = NonSpare_1389.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1389

    @classmethod
    def create(cls, arg : "Item_648.cv_arg") -> "Item_648":
        return cls._create(arg) # type: ignore

class NonSpare_821(NonSpare):
    cv_arg: TypeAlias = RuleVariation_787.cv_arg
    cv_name = "CPL"
    cv_title = "Complete Flight Plan"
    cv_rule: TypeAlias = RuleVariation_787

    @classmethod
    def create(cls, arg : "NonSpare_821.cv_arg") -> "NonSpare_821":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_787:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_817:
        return self.rule.variation

class Item_210(Item):
    cv_arg: TypeAlias = NonSpare_821.cv_arg
    cv_non_spare: TypeAlias = NonSpare_821

    @classmethod
    def create(cls, arg : "Item_210.cv_arg") -> "Item_210":
        return cls._create(arg) # type: ignore

class NonSpare_1742(NonSpare):
    cv_arg: TypeAlias = RuleVariation_869.cv_arg
    cv_name = "SPN"
    cv_title = "Short Flight Plan"
    cv_rule: TypeAlias = RuleVariation_869

    @classmethod
    def create(cls, arg : "NonSpare_1742.cv_arg") -> "NonSpare_1742":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_869:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_899:
        return self.rule.variation

class Item_915(Item):
    cv_arg: TypeAlias = NonSpare_1742.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1742

    @classmethod
    def create(cls, arg : "Item_915.cv_arg") -> "Item_915":
        return cls._create(arg) # type: ignore

class Variation_1108(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_0.cv_arg, Tuple[Literal["GAT"], RuleVariation_0.cv_arg]], Union[RuleVariation_389.cv_arg, Tuple[Literal["OAT"], RuleVariation_389.cv_arg]], int, Union[RuleVariation_787.cv_arg, Tuple[Literal["CPL"], RuleVariation_787.cv_arg]], Union[RuleVariation_869.cv_arg, Tuple[Literal["SPN"], RuleVariation_869.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_1108.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_361, 1), (Item_648, 1), (Item_13, 3), (Item_210, 1), (Item_915, 1), (Item_29, 1)]
    cv_items_dict = {"GAT": RuleVariation_0, "OAT": RuleVariation_389, "CPL": RuleVariation_787, "SPN": RuleVariation_869}

    @overload
    @classmethod
    def spec(cls, key : Literal["GAT"]) -> RuleVariation_0:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["OAT"]) -> RuleVariation_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CPL"]) -> RuleVariation_787:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SPN"]) -> RuleVariation_869:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["GAT"], Literal["OAT"], Literal["CPL"], Literal["SPN"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["GAT"]) -> RuleVariation_0:
        ...
    @overload
    def get_item(self, key : Literal["OAT"]) -> RuleVariation_389:
        ...
    @overload
    def get_item(self, key : Literal["CPL"]) -> RuleVariation_787:
        ...
    @overload
    def get_item(self, key : Literal["SPN"]) -> RuleVariation_869:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1108.cv_arg") -> 'Variation_1108':
        return cls._create(arg) # type: ignore

class RuleVariation_1066(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1108.cv_arg
    cv_variation: TypeAlias = Variation_1108

    @classmethod
    def create(cls, arg : "RuleVariation_1066.cv_arg") -> "RuleVariation_1066":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1108:
        return self.arg # type: ignore

class NonSpare_278(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1066.cv_arg
    cv_name = "100"
    cv_title = "Type Flags"
    cv_rule: TypeAlias = RuleVariation_1066

    @classmethod
    def create(cls, arg : "NonSpare_278.cv_arg") -> "NonSpare_278":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1066:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1108:
        return self.rule.variation

class UapItem_278(UapItem):
    cv_non_spare: TypeAlias = NonSpare_278

class NonSpare_1072(NonSpare):
    cv_arg: TypeAlias = RuleVariation_389.cv_arg
    cv_name = "HLD"
    cv_title = "Aircraft is in Hold State"
    cv_rule: TypeAlias = RuleVariation_389

    @classmethod
    def create(cls, arg : "NonSpare_1072.cv_arg") -> "NonSpare_1072":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_389:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_400:
        return self.rule.variation

class Item_397(Item):
    cv_arg: TypeAlias = NonSpare_1072.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1072

    @classmethod
    def create(cls, arg : "Item_397.cv_arg") -> "Item_397":
        return cls._create(arg) # type: ignore

class NonSpare_1637(NonSpare):
    cv_arg: TypeAlias = RuleVariation_496.cv_arg
    cv_name = "RVQ"
    cv_title = "Aircraft is RVSM Equipped"
    cv_rule: TypeAlias = RuleVariation_496

    @classmethod
    def create(cls, arg : "NonSpare_1637.cv_arg") -> "NonSpare_1637":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_496:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_507:
        return self.rule.variation

class Item_842(Item):
    cv_arg: TypeAlias = NonSpare_1637.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1637

    @classmethod
    def create(cls, arg : "Item_842.cv_arg") -> "Item_842":
        return cls._create(arg) # type: ignore

class NonSpare_1635(NonSpare):
    cv_arg: TypeAlias = RuleVariation_603.cv_arg
    cv_name = "RVC"
    cv_title = "Aircraft is RVSM Capable"
    cv_rule: TypeAlias = RuleVariation_603

    @classmethod
    def create(cls, arg : "NonSpare_1635.cv_arg") -> "NonSpare_1635":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_603:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_614:
        return self.rule.variation

class Item_841(Item):
    cv_arg: TypeAlias = NonSpare_1635.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1635

    @classmethod
    def create(cls, arg : "Item_841.cv_arg") -> "Item_841":
        return cls._create(arg) # type: ignore

class NonSpare_1641(NonSpare):
    cv_arg: TypeAlias = RuleVariation_688.cv_arg
    cv_name = "RVX"
    cv_title = "Aircraft is RVSM Exempted"
    cv_rule: TypeAlias = RuleVariation_688

    @classmethod
    def create(cls, arg : "NonSpare_1641.cv_arg") -> "NonSpare_1641":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_688:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_699:
        return self.rule.variation

class Item_846(Item):
    cv_arg: TypeAlias = NonSpare_1641.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1641

    @classmethod
    def create(cls, arg : "Item_846.cv_arg") -> "Item_846":
        return cls._create(arg) # type: ignore

class Variation_996(Group):
    cv_arg_group: TypeAlias = Tuple[int, Union[RuleVariation_389.cv_arg, Tuple[Literal["HLD"], RuleVariation_389.cv_arg]], Union[RuleVariation_496.cv_arg, Tuple[Literal["RVQ"], RuleVariation_496.cv_arg]], Union[RuleVariation_603.cv_arg, Tuple[Literal["RVC"], RuleVariation_603.cv_arg]], Union[RuleVariation_688.cv_arg, Tuple[Literal["RVX"], RuleVariation_688.cv_arg]], int]
    cv_arg: TypeAlias = Union[int, "Variation_996.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_items_list = [(Item_0, 1), (Item_397, 1), (Item_842, 1), (Item_841, 1), (Item_846, 1), (Item_25, 3)]
    cv_items_dict = {"HLD": RuleVariation_389, "RVQ": RuleVariation_496, "RVC": RuleVariation_603, "RVX": RuleVariation_688}

    @overload
    @classmethod
    def spec(cls, key : Literal["HLD"]) -> RuleVariation_389:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVQ"]) -> RuleVariation_496:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVC"]) -> RuleVariation_603:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RVX"]) -> RuleVariation_688:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HLD"], Literal["RVQ"], Literal["RVC"], Literal["RVX"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HLD"]) -> RuleVariation_389:
        ...
    @overload
    def get_item(self, key : Literal["RVQ"]) -> RuleVariation_496:
        ...
    @overload
    def get_item(self, key : Literal["RVC"]) -> RuleVariation_603:
        ...
    @overload
    def get_item(self, key : Literal["RVX"]) -> RuleVariation_688:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_996.cv_arg") -> 'Variation_996':
        return cls._create(arg) # type: ignore

class RuleVariation_966(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_996.cv_arg
    cv_variation: TypeAlias = Variation_996

    @classmethod
    def create(cls, arg : "RuleVariation_966.cv_arg") -> "RuleVariation_966":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_996:
        return self.arg # type: ignore

class NonSpare_292(NonSpare):
    cv_arg: TypeAlias = RuleVariation_966.cv_arg
    cv_name = "110"
    cv_title = "Status Flags"
    cv_rule: TypeAlias = RuleVariation_966

    @classmethod
    def create(cls, arg : "NonSpare_292.cv_arg") -> "NonSpare_292":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_966:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_996:
        return self.rule.variation

class UapItem_292(UapItem):
    cv_non_spare: TypeAlias = NonSpare_292

class Variation_254(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_254.cv_arg") -> "Variation_254":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_247(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_254.cv_arg
    cv_variation: TypeAlias = Variation_254

    @classmethod
    def create(cls, arg : "RuleVariation_247.cv_arg") -> "RuleVariation_247":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_254:
        return self.arg # type: ignore

class NonSpare_1362(NonSpare):
    cv_arg: TypeAlias = RuleVariation_247.cv_arg
    cv_name = "NOA"
    cv_title = "Number of Aircraft"
    cv_rule: TypeAlias = RuleVariation_247

    @classmethod
    def create(cls, arg : "NonSpare_1362.cv_arg") -> "NonSpare_1362":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class Item_622(Item):
    cv_arg: TypeAlias = NonSpare_1362.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1362

    @classmethod
    def create(cls, arg : "Item_622.cv_arg") -> "Item_622":
        return cls._create(arg) # type: ignore

class Item_1008(Item):
    cv_arg: TypeAlias = NonSpare_1880.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1880

    @classmethod
    def create(cls, arg : "Item_1008.cv_arg") -> "Item_1008":
        return cls._create(arg) # type: ignore

class NonSpare_2068(NonSpare):
    cv_arg: TypeAlias = RuleVariation_196.cv_arg
    cv_name = "WT"
    cv_title = "Wake Turbulence"
    cv_rule: TypeAlias = RuleVariation_196

    @classmethod
    def create(cls, arg : "NonSpare_2068.cv_arg") -> "NonSpare_2068":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_196:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_203:
        return self.rule.variation

class Item_1171(Item):
    cv_arg: TypeAlias = NonSpare_2068.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2068

    @classmethod
    def create(cls, arg : "Item_1171.cv_arg") -> "Item_1171":
        return cls._create(arg) # type: ignore

class Variation_1150(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_247.cv_arg, Tuple[Literal["NOA"], RuleVariation_247.cv_arg]], Union[RuleVariation_367.cv_arg, Tuple[Literal["TOA"], RuleVariation_367.cv_arg]], Union[RuleVariation_196.cv_arg, Tuple[Literal["WT"], RuleVariation_196.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1150.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 56
    cv_items_list = [(Item_622, 16), (Item_1008, 32), (Item_1171, 8)]
    cv_items_dict = {"NOA": RuleVariation_247, "TOA": RuleVariation_367, "WT": RuleVariation_196}

    @overload
    @classmethod
    def spec(cls, key : Literal["NOA"]) -> RuleVariation_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TOA"]) -> RuleVariation_367:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["WT"]) -> RuleVariation_196:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NOA"], Literal["TOA"], Literal["WT"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NOA"]) -> RuleVariation_247:
        ...
    @overload
    def get_item(self, key : Literal["TOA"]) -> RuleVariation_367:
        ...
    @overload
    def get_item(self, key : Literal["WT"]) -> RuleVariation_196:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1150.cv_arg") -> 'Variation_1150':
        return cls._create(arg) # type: ignore

class RuleVariation_1103(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1150.cv_arg
    cv_variation: TypeAlias = Variation_1150

    @classmethod
    def create(cls, arg : "RuleVariation_1103.cv_arg") -> "RuleVariation_1103":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1150:
        return self.arg # type: ignore

class NonSpare_295(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1103.cv_arg
    cv_name = "120"
    cv_title = "Aircraft Type"
    cv_rule: TypeAlias = RuleVariation_1103

    @classmethod
    def create(cls, arg : "NonSpare_295.cv_arg") -> "NonSpare_295":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1103:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1150:
        return self.rule.variation

class UapItem_295(UapItem):
    cv_non_spare: TypeAlias = NonSpare_295

class NonSpare_307(NonSpare):
    cv_arg: TypeAlias = RuleVariation_343.cv_arg
    cv_name = "130"
    cv_title = "Cleared Flight Level"
    cv_rule: TypeAlias = RuleVariation_343

    @classmethod
    def create(cls, arg : "NonSpare_307.cv_arg") -> "NonSpare_307":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_343:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_350:
        return self.rule.variation

class UapItem_307(UapItem):
    cv_non_spare: TypeAlias = NonSpare_307

class Content_591(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "P, point", 2: "B, point with bearing and distance", 3: "LS, latitude/longitude position short format", 4: "LL, latitude/longitude position long format", 5: "X, x/y co-ordinate position", 6: "G, georeference position", 14: "E, airport"}

class RuleContent_591(RuleContentContextFree):
    cv_arg: TypeAlias = Content_591.cv_arg
    cv_content: TypeAlias = Content_591

    @property
    def content(self) -> Content_591:
        return self._get_content() # type: ignore

class Variation_191(Element):
    cv_arg: TypeAlias = RuleContent_591.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_591

    @classmethod
    def create(cls, arg: "Variation_191.cv_arg") -> "Variation_191":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_591:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_591:
        return self.rule.content

class RuleVariation_184(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_191.cv_arg
    cv_variation: TypeAlias = Variation_191

    @classmethod
    def create(cls, arg : "RuleVariation_184.cv_arg") -> "RuleVariation_184":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_191:
        return self.arg # type: ignore

class NonSpare_1816(NonSpare):
    cv_arg: TypeAlias = RuleVariation_184.cv_arg
    cv_name = "T"
    cv_title = "Route Point Type"
    cv_rule: TypeAlias = RuleVariation_184

    @classmethod
    def create(cls, arg : "NonSpare_1816.cv_arg") -> "NonSpare_1816":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_184:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_191:
        return self.rule.variation

class Item_968(Item):
    cv_arg: TypeAlias = NonSpare_1816.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1816

    @classmethod
    def create(cls, arg : "Item_968.cv_arg") -> "Item_968":
        return cls._create(arg) # type: ignore

class Variation_397(Element):
    cv_arg: TypeAlias = RuleContent_609.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 88
    cv_rule = RuleContent_609

    @classmethod
    def create(cls, arg: "Variation_397.cv_arg") -> "Variation_397":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_609:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_609:
        return self.rule.content

class RuleVariation_388(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_397.cv_arg
    cv_variation: TypeAlias = Variation_397

    @classmethod
    def create(cls, arg : "RuleVariation_388.cv_arg") -> "RuleVariation_388":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_397:
        return self.arg # type: ignore

class NonSpare_918(NonSpare):
    cv_arg: TypeAlias = RuleVariation_388.cv_arg
    cv_name = "E"
    cv_title = "Route Point Description Element"
    cv_rule: TypeAlias = RuleVariation_388

    @classmethod
    def create(cls, arg : "NonSpare_918.cv_arg") -> "NonSpare_918":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_388:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_397:
        return self.rule.variation

class Item_287(Item):
    cv_arg: TypeAlias = NonSpare_918.cv_arg
    cv_non_spare: TypeAlias = NonSpare_918

    @classmethod
    def create(cls, arg : "Item_287.cv_arg") -> "Item_287":
        return cls._create(arg) # type: ignore

class Variation_1220(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_184.cv_arg, Tuple[Literal["T"], RuleVariation_184.cv_arg]], Union[RuleVariation_388.cv_arg, Tuple[Literal["E"], RuleVariation_388.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1220.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_968, 8), (Item_287, 88)]
    cv_items_dict = {"T": RuleVariation_184, "E": RuleVariation_388}

    @overload
    @classmethod
    def spec(cls, key : Literal["T"]) -> RuleVariation_184:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["E"]) -> RuleVariation_388:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["T"], Literal["E"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["T"]) -> RuleVariation_184:
        ...
    @overload
    def get_item(self, key : Literal["E"]) -> RuleVariation_388:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1220.cv_arg") -> 'Variation_1220':
        return cls._create(arg) # type: ignore

class Variation_1435(Repetitive):
    cv_arg: TypeAlias = List[Variation_1220.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1220

    @classmethod
    def create(cls, arg: "Variation_1435.cv_arg") -> 'Variation_1435':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1220]:
        return self._get_list() # type: ignore

class RuleVariation_1356(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1435.cv_arg
    cv_variation: TypeAlias = Variation_1435

    @classmethod
    def create(cls, arg : "RuleVariation_1356.cv_arg") -> "RuleVariation_1356":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1435:
        return self.arg # type: ignore

class NonSpare_325(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1356.cv_arg
    cv_name = "140"
    cv_title = "Route Points, Description"
    cv_rule: TypeAlias = RuleVariation_1356

    @classmethod
    def create(cls, arg : "NonSpare_325.cv_arg") -> "NonSpare_325":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1356:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1435:
        return self.rule.variation

class UapItem_325(UapItem):
    cv_non_spare: TypeAlias = NonSpare_325

class Content_673(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["NM"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.5625e-2
    cv_unit = "NM"

    def as_quantity(self, cv_unit : Optional[Literal["NM"]] = None) -> float:
        return self._as_quantity()

class RuleContent_673(RuleContentContextFree):
    cv_arg: TypeAlias = Content_673.cv_arg
    cv_content: TypeAlias = Content_673

    @property
    def content(self) -> Content_673:
        return self._get_content() # type: ignore

class Variation_283(Element):
    cv_arg: TypeAlias = RuleContent_673.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_673

    @classmethod
    def create(cls, arg: "Variation_283.cv_arg") -> "Variation_283":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_673:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_673:
        return self.rule.content

class RuleVariation_276(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_283.cv_arg
    cv_variation: TypeAlias = Variation_283

    @classmethod
    def create(cls, arg : "RuleVariation_276.cv_arg") -> "RuleVariation_276":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_283:
        return self.arg # type: ignore

class NonSpare_2094(NonSpare):
    cv_arg: TypeAlias = RuleVariation_276.cv_arg
    cv_name = "X"
    cv_title = "X Co-ordinate"
    cv_rule: TypeAlias = RuleVariation_276

    @classmethod
    def create(cls, arg : "NonSpare_2094.cv_arg") -> "NonSpare_2094":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_276:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_283:
        return self.rule.variation

class Item_1195(Item):
    cv_arg: TypeAlias = NonSpare_2094.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2094

    @classmethod
    def create(cls, arg : "Item_1195.cv_arg") -> "Item_1195":
        return cls._create(arg) # type: ignore

class NonSpare_2148(NonSpare):
    cv_arg: TypeAlias = RuleVariation_276.cv_arg
    cv_name = "Y"
    cv_title = "Y Co-ordinate"
    cv_rule: TypeAlias = RuleVariation_276

    @classmethod
    def create(cls, arg : "NonSpare_2148.cv_arg") -> "NonSpare_2148":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_276:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_283:
        return self.rule.variation

class Item_1246(Item):
    cv_arg: TypeAlias = NonSpare_2148.cv_arg
    cv_non_spare: TypeAlias = NonSpare_2148

    @classmethod
    def create(cls, arg : "Item_1246.cv_arg") -> "Item_1246":
        return cls._create(arg) # type: ignore

class Variation_1308(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_276.cv_arg, Tuple[Literal["X"], RuleVariation_276.cv_arg]], Union[RuleVariation_276.cv_arg, Tuple[Literal["Y"], RuleVariation_276.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1308.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1195, 16), (Item_1246, 16)]
    cv_items_dict = {"X": RuleVariation_276, "Y": RuleVariation_276}

    @overload
    @classmethod
    def spec(cls, key : Literal["X"]) -> RuleVariation_276:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["Y"]) -> RuleVariation_276:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["X"], Literal["Y"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["X"]) -> RuleVariation_276:
        ...
    @overload
    def get_item(self, key : Literal["Y"]) -> RuleVariation_276:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1308.cv_arg") -> 'Variation_1308':
        return cls._create(arg) # type: ignore

class Variation_1449(Repetitive):
    cv_arg: TypeAlias = List[Variation_1308.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1308

    @classmethod
    def create(cls, arg: "Variation_1449.cv_arg") -> 'Variation_1449':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1308]:
        return self._get_list() # type: ignore

class RuleVariation_1370(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1449.cv_arg
    cv_variation: TypeAlias = Variation_1449

    @classmethod
    def create(cls, arg : "RuleVariation_1370.cv_arg") -> "RuleVariation_1370":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1449:
        return self.arg # type: ignore

class NonSpare_347(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1370.cv_arg
    cv_name = "150"
    cv_title = "Route Points, Coordinates"
    cv_rule: TypeAlias = RuleVariation_1370

    @classmethod
    def create(cls, arg : "NonSpare_347.cv_arg") -> "NonSpare_347":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1370:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1449:
        return self.rule.variation

class UapItem_347(UapItem):
    cv_non_spare: TypeAlias = NonSpare_347

class NonSpare_1071(NonSpare):
    cv_arg: TypeAlias = RuleVariation_247.cv_arg
    cv_name = "HH"
    cv_title = "Hours"
    cv_rule: TypeAlias = RuleVariation_247

    @classmethod
    def create(cls, arg : "NonSpare_1071.cv_arg") -> "NonSpare_1071":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class Item_396(Item):
    cv_arg: TypeAlias = NonSpare_1071.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1071

    @classmethod
    def create(cls, arg : "Item_396.cv_arg") -> "Item_396":
        return cls._create(arg) # type: ignore

class NonSpare_1294(NonSpare):
    cv_arg: TypeAlias = RuleVariation_247.cv_arg
    cv_name = "MM"
    cv_title = "Minutes"
    cv_rule: TypeAlias = RuleVariation_247

    @classmethod
    def create(cls, arg : "NonSpare_1294.cv_arg") -> "NonSpare_1294":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class Item_560(Item):
    cv_arg: TypeAlias = NonSpare_1294.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1294

    @classmethod
    def create(cls, arg : "Item_560.cv_arg") -> "Item_560":
        return cls._create(arg) # type: ignore

class Variation_1117(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_247.cv_arg, Tuple[Literal["HH"], RuleVariation_247.cv_arg]], Union[RuleVariation_247.cv_arg, Tuple[Literal["MM"], RuleVariation_247.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1117.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_396, 16), (Item_560, 16)]
    cv_items_dict = {"HH": RuleVariation_247, "MM": RuleVariation_247}

    @overload
    @classmethod
    def spec(cls, key : Literal["HH"]) -> RuleVariation_247:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MM"]) -> RuleVariation_247:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["HH"], Literal["MM"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["HH"]) -> RuleVariation_247:
        ...
    @overload
    def get_item(self, key : Literal["MM"]) -> RuleVariation_247:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1117.cv_arg") -> 'Variation_1117':
        return cls._create(arg) # type: ignore

class Variation_1419(Repetitive):
    cv_arg: TypeAlias = List[Variation_1117.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1117

    @classmethod
    def create(cls, arg: "Variation_1419.cv_arg") -> 'Variation_1419':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1117]:
        return self._get_list() # type: ignore

class RuleVariation_1340(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1419.cv_arg
    cv_variation: TypeAlias = Variation_1419

    @classmethod
    def create(cls, arg : "RuleVariation_1340.cv_arg") -> "RuleVariation_1340":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1419:
        return self.arg # type: ignore

class NonSpare_359(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1340.cv_arg
    cv_name = "160"
    cv_title = "Route Points, Time"
    cv_rule: TypeAlias = RuleVariation_1340

    @classmethod
    def create(cls, arg : "NonSpare_359.cv_arg") -> "NonSpare_359":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1340:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1419:
        return self.rule.variation

class UapItem_359(UapItem):
    cv_non_spare: TypeAlias = NonSpare_359

class Variation_1399(Repetitive):
    cv_arg: TypeAlias = List[Variation_350.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_350

    @classmethod
    def create(cls, arg: "Variation_1399.cv_arg") -> 'Variation_1399':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_350]:
        return self._get_list() # type: ignore

class RuleVariation_1320(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1399.cv_arg
    cv_variation: TypeAlias = Variation_1399

    @classmethod
    def create(cls, arg : "RuleVariation_1320.cv_arg") -> "RuleVariation_1320":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1399:
        return self.arg # type: ignore

class NonSpare_371(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1320.cv_arg
    cv_name = "170"
    cv_title = "Route Points, Flight Level"
    cv_rule: TypeAlias = RuleVariation_1320

    @classmethod
    def create(cls, arg : "NonSpare_371.cv_arg") -> "NonSpare_371":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1320:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1399:
        return self.rule.variation

class UapItem_371(UapItem):
    cv_non_spare: TypeAlias = NonSpare_371

class Variation_1401(Repetitive):
    cv_arg: TypeAlias = List[Variation_374.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_374

    @classmethod
    def create(cls, arg: "Variation_1401.cv_arg") -> 'Variation_1401':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_374]:
        return self._get_list() # type: ignore

class RuleVariation_1322(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1401.cv_arg
    cv_variation: TypeAlias = Variation_1401

    @classmethod
    def create(cls, arg : "RuleVariation_1322.cv_arg") -> "RuleVariation_1322":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1401:
        return self.arg # type: ignore

class NonSpare_384(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1322.cv_arg
    cv_name = "180"
    cv_title = "Route Points, Speed"
    cv_rule: TypeAlias = RuleVariation_1322

    @classmethod
    def create(cls, arg : "NonSpare_384.cv_arg") -> "NonSpare_384":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1322:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1401:
        return self.rule.variation

class UapItem_384(UapItem):
    cv_non_spare: TypeAlias = NonSpare_384

class NonSpare_387(NonSpare):
    cv_arg: TypeAlias = RuleVariation_247.cv_arg
    cv_name = "190"
    cv_title = "Controller ID"
    cv_rule: TypeAlias = RuleVariation_247

    @classmethod
    def create(cls, arg : "NonSpare_387.cv_arg") -> "NonSpare_387":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_247:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_254:
        return self.rule.variation

class UapItem_387(UapItem):
    cv_non_spare: TypeAlias = NonSpare_387

class Variation_1396(Repetitive):
    cv_arg: TypeAlias = List[Variation_203.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_203

    @classmethod
    def create(cls, arg: "Variation_1396.cv_arg") -> 'Variation_1396':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_203]:
        return self._get_list() # type: ignore

class RuleVariation_1317(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1396.cv_arg
    cv_variation: TypeAlias = Variation_1396

    @classmethod
    def create(cls, arg : "RuleVariation_1317.cv_arg") -> "RuleVariation_1317":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1396:
        return self.arg # type: ignore

class NonSpare_392(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1317.cv_arg
    cv_name = "200"
    cv_title = "Field 18"
    cv_rule: TypeAlias = RuleVariation_1317

    @classmethod
    def create(cls, arg : "NonSpare_392.cv_arg") -> "NonSpare_392":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1317:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1396:
        return self.rule.variation

class UapItem_392(UapItem):
    cv_non_spare: TypeAlias = NonSpare_392

class NonSpare_411(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "210"
    cv_title = "Correlated Track Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_411.cv_arg") -> "NonSpare_411":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_411(UapItem):
    cv_non_spare: TypeAlias = NonSpare_411

class NonSpare_423(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "220"
    cv_title = "Maximum Plan Count"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_423.cv_arg") -> "NonSpare_423":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_423(UapItem):
    cv_non_spare: TypeAlias = NonSpare_423

class NonSpare_432(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "230"
    cv_title = "Number of Plans"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_432.cv_arg") -> "NonSpare_432":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class UapItem_432(UapItem):
    cv_non_spare: TypeAlias = NonSpare_432

class NonSpare_1432(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "PLAN"
    cv_title = "Plan Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1432.cv_arg") -> "NonSpare_1432":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_686(Item):
    cv_arg: TypeAlias = NonSpare_1432.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1432

    @classmethod
    def create(cls, arg : "Item_686.cv_arg") -> "Item_686":
        return cls._create(arg) # type: ignore

class NonSpare_1904(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "TRACK"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1904.cv_arg") -> "NonSpare_1904":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_1027(Item):
    cv_arg: TypeAlias = NonSpare_1904.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1904

    @classmethod
    def create(cls, arg : "Item_1027.cv_arg") -> "Item_1027":
        return cls._create(arg) # type: ignore

class Variation_1159(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_246.cv_arg, Tuple[Literal["PLAN"], RuleVariation_246.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["TRACK"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1159.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_686, 16), (Item_1027, 16)]
    cv_items_dict = {"PLAN": RuleVariation_246, "TRACK": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["PLAN"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["PLAN"], Literal["TRACK"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["PLAN"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["TRACK"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1159.cv_arg") -> 'Variation_1159':
        return cls._create(arg) # type: ignore

class Variation_1425(Repetitive):
    cv_arg: TypeAlias = List[Variation_1159.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1159

    @classmethod
    def create(cls, arg: "Variation_1425.cv_arg") -> 'Variation_1425':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1159]:
        return self._get_list() # type: ignore

class RuleVariation_1346(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1425.cv_arg
    cv_variation: TypeAlias = Variation_1425

    @classmethod
    def create(cls, arg : "RuleVariation_1346.cv_arg") -> "RuleVariation_1346":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1425:
        return self.arg # type: ignore

class NonSpare_438(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1346.cv_arg
    cv_name = "240"
    cv_title = "Newly Correlated Plans"
    cv_rule: TypeAlias = RuleVariation_1346

    @classmethod
    def create(cls, arg : "NonSpare_438.cv_arg") -> "NonSpare_438":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1346:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1425:
        return self.rule.variation

class UapItem_438(UapItem):
    cv_non_spare: TypeAlias = NonSpare_438

class NonSpare_451(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1318.cv_arg
    cv_name = "250"
    cv_title = "Newly De-correlated Plans"
    cv_rule: TypeAlias = RuleVariation_1318

    @classmethod
    def create(cls, arg : "NonSpare_451.cv_arg") -> "NonSpare_451":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1318:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1397:
        return self.rule.variation

class UapItem_451(UapItem):
    cv_non_spare: TypeAlias = NonSpare_451

class NonSpare_1905(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "TRACK1"
    cv_title = "Track Number 1"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1905.cv_arg") -> "NonSpare_1905":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_1028(Item):
    cv_arg: TypeAlias = NonSpare_1905.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1905

    @classmethod
    def create(cls, arg : "Item_1028.cv_arg") -> "Item_1028":
        return cls._create(arg) # type: ignore

class NonSpare_1906(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "TRACK2"
    cv_title = "Track Number 2"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_1906.cv_arg") -> "NonSpare_1906":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class Item_1029(Item):
    cv_arg: TypeAlias = NonSpare_1906.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1906

    @classmethod
    def create(cls, arg : "Item_1029.cv_arg") -> "Item_1029":
        return cls._create(arg) # type: ignore

class Variation_1228(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_246.cv_arg, Tuple[Literal["TRACK1"], RuleVariation_246.cv_arg]], Union[RuleVariation_246.cv_arg, Tuple[Literal["TRACK2"], RuleVariation_246.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1228.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_items_list = [(Item_1028, 16), (Item_1029, 16)]
    cv_items_dict = {"TRACK1": RuleVariation_246, "TRACK2": RuleVariation_246}

    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK1"]) -> RuleVariation_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["TRACK2"]) -> RuleVariation_246:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["TRACK1"], Literal["TRACK2"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["TRACK1"]) -> RuleVariation_246:
        ...
    @overload
    def get_item(self, key : Literal["TRACK2"]) -> RuleVariation_246:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1228.cv_arg") -> 'Variation_1228':
        return cls._create(arg) # type: ignore

class Variation_1439(Repetitive):
    cv_arg: TypeAlias = List[Variation_1228.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1228

    @classmethod
    def create(cls, arg: "Variation_1439.cv_arg") -> 'Variation_1439':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1228]:
        return self._get_list() # type: ignore

class RuleVariation_1360(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1439.cv_arg
    cv_variation: TypeAlias = Variation_1439

    @classmethod
    def create(cls, arg : "RuleVariation_1360.cv_arg") -> "RuleVariation_1360":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1439:
        return self.arg # type: ignore

class NonSpare_452(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1360.cv_arg
    cv_name = "251"
    cv_title = "Tracks in Conflict"
    cv_rule: TypeAlias = RuleVariation_1360

    @classmethod
    def create(cls, arg : "NonSpare_452.cv_arg") -> "NonSpare_452":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1360:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1439:
        return self.rule.variation

class UapItem_452(UapItem):
    cv_non_spare: TypeAlias = NonSpare_452

class NonSpare_383(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1320.cv_arg
    cv_name = "171"
    cv_title = "Route Points, Requested Flight Level"
    cv_rule: TypeAlias = RuleVariation_1320

    @classmethod
    def create(cls, arg : "NonSpare_383.cv_arg") -> "NonSpare_383":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1320:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1399:
        return self.rule.variation

class UapItem_383(UapItem):
    cv_non_spare: TypeAlias = NonSpare_383

class Variation_1420(Repetitive):
    cv_arg: TypeAlias = List[Variation_1136.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1136

    @classmethod
    def create(cls, arg: "Variation_1420.cv_arg") -> 'Variation_1420':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1136]:
        return self._get_list() # type: ignore

class RuleVariation_1341(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1420.cv_arg
    cv_variation: TypeAlias = Variation_1420

    @classmethod
    def create(cls, arg : "RuleVariation_1341.cv_arg") -> "RuleVariation_1341":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1420:
        return self.arg # type: ignore

class NonSpare_348(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1341.cv_arg
    cv_name = "151"
    cv_title = "Route Points, Geographic Position"
    cv_rule: TypeAlias = RuleVariation_1341

    @classmethod
    def create(cls, arg : "NonSpare_348.cv_arg") -> "NonSpare_348":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1341:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1420:
        return self.rule.variation

class UapItem_348(UapItem):
    cv_non_spare: TypeAlias = NonSpare_348

class Record_49(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_49.cv_arg,
        "020": NonSpare_84.cv_arg,
        "030": NonSpare_106.cv_arg,
        "040": NonSpare_141.cv_arg,
        "050": NonSpare_168.cv_arg,
        "060": NonSpare_194.cv_arg,
        "070": NonSpare_215.cv_arg,
        "080": NonSpare_232.cv_arg,
        "090": NonSpare_246.cv_arg,
        "100": NonSpare_278.cv_arg,
        "110": NonSpare_292.cv_arg,
        "120": NonSpare_295.cv_arg,
        "130": NonSpare_307.cv_arg,
        "140": NonSpare_325.cv_arg,
        "150": NonSpare_347.cv_arg,
        "160": NonSpare_359.cv_arg,
        "170": NonSpare_371.cv_arg,
        "180": NonSpare_384.cv_arg,
        "190": NonSpare_387.cv_arg,
        "200": NonSpare_392.cv_arg,
        "210": NonSpare_411.cv_arg,
        "220": NonSpare_423.cv_arg,
        "230": NonSpare_432.cv_arg,
        "240": NonSpare_438.cv_arg,
        "250": NonSpare_451.cv_arg,
        "251": NonSpare_452.cv_arg,
        "171": NonSpare_383.cv_arg,
        "151": NonSpare_348.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_49, UapItem_84, UapItem_106, UapItem_141, UapItem_168, UapItem_194, UapItem_215, UapItem_232, UapItem_246, UapItem_278, UapItem_292, UapItem_295, UapItem_307, UapItem_325, UapItem_347, UapItem_359, UapItem_371, UapItem_384, UapItem_387, UapItem_392, UapItem_411, UapItem_423, UapItem_432, UapItem_438, UapItem_451, UapItem_452, UapItem_383, UapItem_348]
    cv_items_dict = {"010": NonSpare_49, "020": NonSpare_84, "030": NonSpare_106, "040": NonSpare_141, "050": NonSpare_168, "060": NonSpare_194, "070": NonSpare_215, "080": NonSpare_232, "090": NonSpare_246, "100": NonSpare_278, "110": NonSpare_292, "120": NonSpare_295, "130": NonSpare_307, "140": NonSpare_325, "150": NonSpare_347, "160": NonSpare_359, "170": NonSpare_371, "180": NonSpare_384, "190": NonSpare_387, "200": NonSpare_392, "210": NonSpare_411, "220": NonSpare_423, "230": NonSpare_432, "240": NonSpare_438, "250": NonSpare_451, "251": NonSpare_452, "171": NonSpare_383, "151": NonSpare_348}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_49:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_84:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_106:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_141:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_168:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_194:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_215:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_232:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_246:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_278:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_292:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_295:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_307:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_325:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_347:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_359:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_371:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["180"]) -> NonSpare_384:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["190"]) -> NonSpare_387:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_392:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["210"]) -> NonSpare_411:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["220"]) -> NonSpare_423:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["230"]) -> NonSpare_432:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["240"]) -> NonSpare_438:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["250"]) -> NonSpare_451:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["251"]) -> NonSpare_452:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["171"]) -> NonSpare_383:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["151"]) -> NonSpare_348:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["020"], Literal["030"], Literal["040"], Literal["050"], Literal["060"], Literal["070"], Literal["080"], Literal["090"], Literal["100"], Literal["110"], Literal["120"], Literal["130"], Literal["140"], Literal["150"], Literal["160"], Literal["170"], Literal["180"], Literal["190"], Literal["200"], Literal["210"], Literal["220"], Literal["230"], Literal["240"], Literal["250"], Literal["251"], Literal["171"], Literal["151"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_49]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_84]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_106]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_141]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_168]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_194]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_215]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_232]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_246]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_278]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_292]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_295]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_307]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_325]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_347]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_359]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_371]:
        ...
    @overload
    def get_item(self, key : Literal["180"]) -> Optional[NonSpare_384]:
        ...
    @overload
    def get_item(self, key : Literal["190"]) -> Optional[NonSpare_387]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_392]:
        ...
    @overload
    def get_item(self, key : Literal["210"]) -> Optional[NonSpare_411]:
        ...
    @overload
    def get_item(self, key : Literal["220"]) -> Optional[NonSpare_423]:
        ...
    @overload
    def get_item(self, key : Literal["230"]) -> Optional[NonSpare_432]:
        ...
    @overload
    def get_item(self, key : Literal["240"]) -> Optional[NonSpare_438]:
        ...
    @overload
    def get_item(self, key : Literal["250"]) -> Optional[NonSpare_451]:
        ...
    @overload
    def get_item(self, key : Literal["251"]) -> Optional[NonSpare_452]:
        ...
    @overload
    def get_item(self, key : Literal["171"]) -> Optional[NonSpare_383]:
        ...
    @overload
    def get_item(self, key : Literal["151"]) -> Optional[NonSpare_348]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_49.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_84.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_106.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_141.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_168.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_194.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_215.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_232.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_246.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_278.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_292.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_295.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_307.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_325.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_347.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_359.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_371.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["180"], val : NonSpare_384.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["190"], val : NonSpare_387.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_392.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["210"], val : NonSpare_411.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["220"], val : NonSpare_423.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["230"], val : NonSpare_432.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["240"], val : NonSpare_438.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["250"], val : NonSpare_451.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["251"], val : NonSpare_452.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["171"], val : NonSpare_383.cv_arg) -> 'Record_49':
        ...
    @overload
    def set_item(self, key : Literal["151"], val : NonSpare_348.cv_arg) -> 'Record_49':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["180"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["190"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["210"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["220"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["230"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["240"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["250"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["251"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["171"]) -> 'Record_49':
        ...
    @overload
    def del_item(self, key : Literal["151"]) -> 'Record_49':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_49.cv_arg") -> 'Record_49':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_49", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_45(UapSingle):
    cv_arg: TypeAlias = Record_49
    cv_record: TypeAlias = Record_49

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_49]]:
        return cls._parse(bs)

class Asterix_61(AstCat):
    cv_category = 150
    cv_edition = (3, 0)
    cv_uap: TypeAlias = Uap_45
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_45.cv_arg]) -> "Asterix_61":
        return cls._create(records) # type: ignore

class NonSpare_33(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_33.cv_arg") -> "NonSpare_33":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_33(UapItem):
    cv_non_spare: TypeAlias = NonSpare_33

class NonSpare_63(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_63.cv_arg") -> "NonSpare_63":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_63(UapItem):
    cv_non_spare: TypeAlias = NonSpare_63

class Content_598(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "System Position Report", 2: "System Bearing Report", 3: "System Position Report of conflicting transmission", 4: "System Detection End Report", 5: "Sensor Data Report"}

class RuleContent_598(RuleContentContextFree):
    cv_arg: TypeAlias = Content_598.cv_arg
    cv_content: TypeAlias = Content_598

    @property
    def content(self) -> Content_598:
        return self._get_content() # type: ignore

class Variation_197(Element):
    cv_arg: TypeAlias = RuleContent_598.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_598

    @classmethod
    def create(cls, arg: "Variation_197.cv_arg") -> "Variation_197":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_598:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_598:
        return self.rule.content

class RuleVariation_190(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_197.cv_arg
    cv_variation: TypeAlias = Variation_197

    @classmethod
    def create(cls, arg : "RuleVariation_190.cv_arg") -> "RuleVariation_190":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_197:
        return self.arg # type: ignore

class NonSpare_12(NonSpare):
    cv_arg: TypeAlias = RuleVariation_190.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_190

    @classmethod
    def create(cls, arg : "NonSpare_12.cv_arg") -> "NonSpare_12":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_190:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_197:
        return self.rule.variation

class UapItem_12(UapItem):
    cv_non_spare: TypeAlias = NonSpare_12

class NonSpare_111(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "030"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_111.cv_arg") -> "NonSpare_111":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_111(UapItem):
    cv_non_spare: TypeAlias = NonSpare_111

class NonSpare_142(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "040"
    cv_title = "Report Number"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_142.cv_arg") -> "NonSpare_142":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_142(UapItem):
    cv_non_spare: TypeAlias = NonSpare_142

class NonSpare_258(NonSpare):
    cv_arg: TypeAlias = RuleVariation_385.cv_arg
    cv_name = "090"
    cv_title = "Radio Channel Name"
    cv_rule: TypeAlias = RuleVariation_385

    @classmethod
    def create(cls, arg : "NonSpare_258.cv_arg") -> "NonSpare_258":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_385:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_393:
        return self.rule.variation

class UapItem_258(UapItem):
    cv_non_spare: TypeAlias = NonSpare_258

class NonSpare_1157(NonSpare):
    cv_arg: TypeAlias = RuleVariation_371.cv_arg
    cv_name = "LAT"
    cv_title = "Latitude in WGS-84"
    cv_rule: TypeAlias = RuleVariation_371

    @classmethod
    def create(cls, arg : "NonSpare_1157.cv_arg") -> "NonSpare_1157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_371:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_378:
        return self.rule.variation

class Item_469(Item):
    cv_arg: TypeAlias = NonSpare_1157.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1157

    @classmethod
    def create(cls, arg : "Item_469.cv_arg") -> "Item_469":
        return cls._create(arg) # type: ignore

class NonSpare_1187(NonSpare):
    cv_arg: TypeAlias = RuleVariation_370.cv_arg
    cv_name = "LON"
    cv_title = "Longitude in WGS-84"
    cv_rule: TypeAlias = RuleVariation_370

    @classmethod
    def create(cls, arg : "NonSpare_1187.cv_arg") -> "NonSpare_1187":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_370:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_377:
        return self.rule.variation

class Item_497(Item):
    cv_arg: TypeAlias = NonSpare_1187.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1187

    @classmethod
    def create(cls, arg : "Item_497.cv_arg") -> "Item_497":
        return cls._create(arg) # type: ignore

class Variation_1133(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_371.cv_arg, Tuple[Literal["LAT"], RuleVariation_371.cv_arg]], Union[RuleVariation_370.cv_arg, Tuple[Literal["LON"], RuleVariation_370.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1133.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 64
    cv_items_list = [(Item_469, 32), (Item_497, 32)]
    cv_items_dict = {"LAT": RuleVariation_371, "LON": RuleVariation_370}

    @overload
    @classmethod
    def spec(cls, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["LON"]) -> RuleVariation_370:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["LAT"], Literal["LON"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["LAT"]) -> RuleVariation_371:
        ...
    @overload
    def get_item(self, key : Literal["LON"]) -> RuleVariation_370:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1133.cv_arg") -> 'Variation_1133':
        return cls._create(arg) # type: ignore

class RuleVariation_1089(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1133.cv_arg
    cv_variation: TypeAlias = Variation_1133

    @classmethod
    def create(cls, arg : "RuleVariation_1089.cv_arg") -> "RuleVariation_1089":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1133:
        return self.arg # type: ignore

class NonSpare_176(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1089.cv_arg
    cv_name = "050"
    cv_title = "Position in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1089

    @classmethod
    def create(cls, arg : "NonSpare_176.cv_arg") -> "NonSpare_176":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1089:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1133:
        return self.rule.variation

class UapItem_176(UapItem):
    cv_non_spare: TypeAlias = NonSpare_176

class NonSpare_193(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1243.cv_arg
    cv_name = "060"
    cv_title = "Position in Cartesian Coordinates"
    cv_rule: TypeAlias = RuleVariation_1243

    @classmethod
    def create(cls, arg : "NonSpare_193.cv_arg") -> "NonSpare_193":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1243:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1317:
        return self.rule.variation

class UapItem_193(UapItem):
    cv_non_spare: TypeAlias = NonSpare_193

class Content_748(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_748(RuleContentContextFree):
    cv_arg: TypeAlias = Content_748.cv_arg
    cv_content: TypeAlias = Content_748

    @property
    def content(self) -> Content_748:
        return self._get_content() # type: ignore

class Variation_318(Element):
    cv_arg: TypeAlias = RuleContent_748.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_748

    @classmethod
    def create(cls, arg: "Variation_318.cv_arg") -> "Variation_318":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_748:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_748:
        return self.rule.content

class RuleVariation_311(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_318.cv_arg
    cv_variation: TypeAlias = Variation_318

    @classmethod
    def create(cls, arg : "RuleVariation_311.cv_arg") -> "RuleVariation_311":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_318:
        return self.arg # type: ignore

class NonSpare_205(NonSpare):
    cv_arg: TypeAlias = RuleVariation_311.cv_arg
    cv_name = "070"
    cv_title = "Local Bearing"
    cv_rule: TypeAlias = RuleVariation_311

    @classmethod
    def create(cls, arg : "NonSpare_205.cv_arg") -> "NonSpare_205":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_318:
        return self.rule.variation

class UapItem_205(UapItem):
    cv_non_spare: TypeAlias = NonSpare_205

class NonSpare_236(NonSpare):
    cv_arg: TypeAlias = RuleVariation_311.cv_arg
    cv_name = "080"
    cv_title = "System Bearing"
    cv_rule: TypeAlias = RuleVariation_311

    @classmethod
    def create(cls, arg : "NonSpare_236.cv_arg") -> "NonSpare_236":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_311:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_318:
        return self.rule.variation

class UapItem_236(UapItem):
    cv_non_spare: TypeAlias = NonSpare_236

class NonSpare_276(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "100"
    cv_title = "Quality of Measurement"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_276.cv_arg") -> "NonSpare_276":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_276(UapItem):
    cv_non_spare: TypeAlias = NonSpare_276

class Content_730(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["m"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 100.0
    cv_unit = "m"

    def as_quantity(self, cv_unit : Optional[Literal["m"]] = None) -> float:
        return self._as_quantity()

class RuleContent_730(RuleContentContextFree):
    cv_arg: TypeAlias = Content_730.cv_arg
    cv_content: TypeAlias = Content_730

    @property
    def content(self) -> Content_730:
        return self._get_content() # type: ignore

class Variation_225(Element):
    cv_arg: TypeAlias = RuleContent_730.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_730

    @classmethod
    def create(cls, arg: "Variation_225.cv_arg") -> "Variation_225":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_730:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_730:
        return self.rule.content

class RuleVariation_218(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_225.cv_arg
    cv_variation: TypeAlias = Variation_225

    @classmethod
    def create(cls, arg : "RuleVariation_218.cv_arg") -> "RuleVariation_218":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_225:
        return self.arg # type: ignore

class NonSpare_285(NonSpare):
    cv_arg: TypeAlias = RuleVariation_218.cv_arg
    cv_name = "110"
    cv_title = "Estimated Uncertainty"
    cv_rule: TypeAlias = RuleVariation_218

    @classmethod
    def create(cls, arg : "NonSpare_285.cv_arg") -> "NonSpare_285":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_218:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_225:
        return self.rule.variation

class UapItem_285(UapItem):
    cv_non_spare: TypeAlias = NonSpare_285

class Variation_1394(Repetitive):
    cv_arg: TypeAlias = List[Variation_165.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_165

    @classmethod
    def create(cls, arg: "Variation_1394.cv_arg") -> 'Variation_1394':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_165]:
        return self._get_list() # type: ignore

class RuleVariation_1315(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1394.cv_arg
    cv_variation: TypeAlias = Variation_1394

    @classmethod
    def create(cls, arg : "RuleVariation_1315.cv_arg") -> "RuleVariation_1315":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1394:
        return self.arg # type: ignore

class NonSpare_299(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1315.cv_arg
    cv_name = "120"
    cv_title = "Contributing Sensors"
    cv_rule: TypeAlias = RuleVariation_1315

    @classmethod
    def create(cls, arg : "NonSpare_299.cv_arg") -> "NonSpare_299":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1315:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1394:
        return self.rule.variation

class UapItem_299(UapItem):
    cv_non_spare: TypeAlias = NonSpare_299

class NonSpare_308(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1089.cv_arg
    cv_name = "130"
    cv_title = "Conflicting Transmitter Position in WGS-84 Coordinates"
    cv_rule: TypeAlias = RuleVariation_1089

    @classmethod
    def create(cls, arg : "NonSpare_308.cv_arg") -> "NonSpare_308":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1089:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1133:
        return self.rule.variation

class UapItem_308(UapItem):
    cv_non_spare: TypeAlias = NonSpare_308

class NonSpare_321(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1243.cv_arg
    cv_name = "140"
    cv_title = "Conflicting Transmitter Position in Cartesian Coordinates"
    cv_rule: TypeAlias = RuleVariation_1243

    @classmethod
    def create(cls, arg : "NonSpare_321.cv_arg") -> "NonSpare_321":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1243:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1317:
        return self.rule.variation

class UapItem_321(UapItem):
    cv_non_spare: TypeAlias = NonSpare_321

class NonSpare_345(NonSpare):
    cv_arg: TypeAlias = RuleVariation_218.cv_arg
    cv_name = "150"
    cv_title = "Conflicting Transmitter Estimated Uncertainty"
    cv_rule: TypeAlias = RuleVariation_218

    @classmethod
    def create(cls, arg : "NonSpare_345.cv_arg") -> "NonSpare_345":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_218:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_225:
        return self.rule.variation

class UapItem_345(UapItem):
    cv_non_spare: TypeAlias = NonSpare_345

class NonSpare_360(NonSpare):
    cv_arg: TypeAlias = RuleVariation_246.cv_arg
    cv_name = "160"
    cv_title = "Track Number"
    cv_rule: TypeAlias = RuleVariation_246

    @classmethod
    def create(cls, arg : "NonSpare_360.cv_arg") -> "NonSpare_360":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_246:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_253:
        return self.rule.variation

class UapItem_360(UapItem):
    cv_non_spare: TypeAlias = NonSpare_360

class NonSpare_372(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "170"
    cv_title = "Sensor Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_372.cv_arg") -> "NonSpare_372":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_372(UapItem):
    cv_non_spare: TypeAlias = NonSpare_372

class Content_644(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["dBµV"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "dBµV"

    def as_quantity(self, cv_unit : Optional[Literal["dBµV"]] = None) -> float:
        return self._as_quantity()

class RuleContent_644(RuleContentContextFree):
    cv_arg: TypeAlias = Content_644.cv_arg
    cv_content: TypeAlias = Content_644

    @property
    def content(self) -> Content_644:
        return self._get_content() # type: ignore

class Variation_267(Element):
    cv_arg: TypeAlias = RuleContent_644.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_644

    @classmethod
    def create(cls, arg: "Variation_267.cv_arg") -> "Variation_267":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_644:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_644:
        return self.rule.content

class RuleVariation_260(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_267.cv_arg
    cv_variation: TypeAlias = Variation_267

    @classmethod
    def create(cls, arg : "RuleVariation_260.cv_arg") -> "RuleVariation_260":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_267:
        return self.arg # type: ignore

class NonSpare_385(NonSpare):
    cv_arg: TypeAlias = RuleVariation_260.cv_arg
    cv_name = "180"
    cv_title = "Signal Level"
    cv_rule: TypeAlias = RuleVariation_260

    @classmethod
    def create(cls, arg : "NonSpare_385.cv_arg") -> "NonSpare_385":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_260:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_267:
        return self.rule.variation

class UapItem_385(UapItem):
    cv_non_spare: TypeAlias = NonSpare_385

class NonSpare_388(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "190"
    cv_title = "Signal Quality"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_388.cv_arg") -> "NonSpare_388":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_388(UapItem):
    cv_non_spare: TypeAlias = NonSpare_388

class Content_650(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Signed
    cv_lsb = 1.0e-2
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_650(RuleContentContextFree):
    cv_arg: TypeAlias = Content_650.cv_arg
    cv_content: TypeAlias = Content_650

    @property
    def content(self) -> Content_650:
        return self._get_content() # type: ignore

class Variation_270(Element):
    cv_arg: TypeAlias = RuleContent_650.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_650

    @classmethod
    def create(cls, arg: "Variation_270.cv_arg") -> "Variation_270":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_650:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_650:
        return self.rule.content

class RuleVariation_263(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_270.cv_arg
    cv_variation: TypeAlias = Variation_270

    @classmethod
    def create(cls, arg : "RuleVariation_263.cv_arg") -> "RuleVariation_263":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_270:
        return self.arg # type: ignore

class NonSpare_396(NonSpare):
    cv_arg: TypeAlias = RuleVariation_263.cv_arg
    cv_name = "200"
    cv_title = "Signal Elevation"
    cv_rule: TypeAlias = RuleVariation_263

    @classmethod
    def create(cls, arg : "NonSpare_396.cv_arg") -> "NonSpare_396":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_263:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_270:
        return self.rule.variation

class UapItem_396(UapItem):
    cv_non_spare: TypeAlias = NonSpare_396

class Record_12(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_33.cv_arg,
        "015": NonSpare_63.cv_arg,
        "000": NonSpare_12.cv_arg,
        "030": NonSpare_111.cv_arg,
        "040": NonSpare_142.cv_arg,
        "090": NonSpare_258.cv_arg,
        "050": NonSpare_176.cv_arg,
        "060": NonSpare_193.cv_arg,
        "070": NonSpare_205.cv_arg,
        "080": NonSpare_236.cv_arg,
        "100": NonSpare_276.cv_arg,
        "110": NonSpare_285.cv_arg,
        "120": NonSpare_299.cv_arg,
        "130": NonSpare_308.cv_arg,
        "140": NonSpare_321.cv_arg,
        "150": NonSpare_345.cv_arg,
        "160": NonSpare_360.cv_arg,
        "170": NonSpare_372.cv_arg,
        "180": NonSpare_385.cv_arg,
        "190": NonSpare_388.cv_arg,
        "200": NonSpare_396.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 4
    cv_items_list = [UapItem_33, UapItem_63, UapItem_12, UapItem_111, UapItem_142, UapItem_258, UapItem_176, UapItem_193, UapItem_205, UapItem_236, UapItem_276, UapItem_285, UapItem_299, UapItem_308, UapItem_321, UapItem_345, UapItem_360, UapItem_372, UapItem_385, UapItem_388, UapItem_396, UapItem_548]
    cv_items_dict = {"010": NonSpare_33, "015": NonSpare_63, "000": NonSpare_12, "030": NonSpare_111, "040": NonSpare_142, "090": NonSpare_258, "050": NonSpare_176, "060": NonSpare_193, "070": NonSpare_205, "080": NonSpare_236, "100": NonSpare_276, "110": NonSpare_285, "120": NonSpare_299, "130": NonSpare_308, "140": NonSpare_321, "150": NonSpare_345, "160": NonSpare_360, "170": NonSpare_372, "180": NonSpare_385, "190": NonSpare_388, "200": NonSpare_396, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_33:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_63:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_12:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_111:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_142:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["090"]) -> NonSpare_258:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_176:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["060"]) -> NonSpare_193:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["070"]) -> NonSpare_205:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["080"]) -> NonSpare_236:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["100"]) -> NonSpare_276:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["110"]) -> NonSpare_285:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["120"]) -> NonSpare_299:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["130"]) -> NonSpare_308:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_321:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["150"]) -> NonSpare_345:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["160"]) -> NonSpare_360:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["170"]) -> NonSpare_372:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["180"]) -> NonSpare_385:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["190"]) -> NonSpare_388:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["200"]) -> NonSpare_396:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["000"], Literal["030"], Literal["040"], Literal["090"], Literal["050"], Literal["060"], Literal["070"], Literal["080"], Literal["100"], Literal["110"], Literal["120"], Literal["130"], Literal["140"], Literal["150"], Literal["160"], Literal["170"], Literal["180"], Literal["190"], Literal["200"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_33]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_63]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_12]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_111]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_142]:
        ...
    @overload
    def get_item(self, key : Literal["090"]) -> Optional[NonSpare_258]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_176]:
        ...
    @overload
    def get_item(self, key : Literal["060"]) -> Optional[NonSpare_193]:
        ...
    @overload
    def get_item(self, key : Literal["070"]) -> Optional[NonSpare_205]:
        ...
    @overload
    def get_item(self, key : Literal["080"]) -> Optional[NonSpare_236]:
        ...
    @overload
    def get_item(self, key : Literal["100"]) -> Optional[NonSpare_276]:
        ...
    @overload
    def get_item(self, key : Literal["110"]) -> Optional[NonSpare_285]:
        ...
    @overload
    def get_item(self, key : Literal["120"]) -> Optional[NonSpare_299]:
        ...
    @overload
    def get_item(self, key : Literal["130"]) -> Optional[NonSpare_308]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_321]:
        ...
    @overload
    def get_item(self, key : Literal["150"]) -> Optional[NonSpare_345]:
        ...
    @overload
    def get_item(self, key : Literal["160"]) -> Optional[NonSpare_360]:
        ...
    @overload
    def get_item(self, key : Literal["170"]) -> Optional[NonSpare_372]:
        ...
    @overload
    def get_item(self, key : Literal["180"]) -> Optional[NonSpare_385]:
        ...
    @overload
    def get_item(self, key : Literal["190"]) -> Optional[NonSpare_388]:
        ...
    @overload
    def get_item(self, key : Literal["200"]) -> Optional[NonSpare_396]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_33.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_63.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_12.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_111.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_142.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["090"], val : NonSpare_258.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_176.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["060"], val : NonSpare_193.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["070"], val : NonSpare_205.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["080"], val : NonSpare_236.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["100"], val : NonSpare_276.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["110"], val : NonSpare_285.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["120"], val : NonSpare_299.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["130"], val : NonSpare_308.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_321.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["150"], val : NonSpare_345.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["160"], val : NonSpare_360.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["170"], val : NonSpare_372.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["180"], val : NonSpare_385.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["190"], val : NonSpare_388.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["200"], val : NonSpare_396.cv_arg) -> 'Record_12':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_12':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["090"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["060"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["070"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["080"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["100"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["110"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["120"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["130"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["150"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["160"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["170"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["180"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["190"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["200"]) -> 'Record_12':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_12':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_12.cv_arg") -> 'Record_12':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_12", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_12(UapSingle):
    cv_arg: TypeAlias = Record_12
    cv_record: TypeAlias = Record_12

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_12]]:
        return cls._parse(bs)

class Asterix_62(AstCat):
    cv_category = 205
    cv_edition = (1, 0)
    cv_uap: TypeAlias = Uap_12
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_12.cv_arg]) -> "Asterix_62":
        return cls._create(records) # type: ignore

class NonSpare_44(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1140.cv_arg
    cv_name = "010"
    cv_title = "Data Source Identifier"
    cv_rule: TypeAlias = RuleVariation_1140

    @classmethod
    def create(cls, arg : "NonSpare_44.cv_arg") -> "NonSpare_44":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1140:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1192:
        return self.rule.variation

class UapItem_44(UapItem):
    cv_non_spare: TypeAlias = NonSpare_44

class Content_603(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Video Summary message", 2: "Video message"}

class RuleContent_603(RuleContentContextFree):
    cv_arg: TypeAlias = Content_603.cv_arg
    cv_content: TypeAlias = Content_603

    @property
    def content(self) -> Content_603:
        return self._get_content() # type: ignore

class Variation_200(Element):
    cv_arg: TypeAlias = RuleContent_603.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_603

    @classmethod
    def create(cls, arg: "Variation_200.cv_arg") -> "Variation_200":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_603:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_603:
        return self.rule.content

class RuleVariation_193(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_200.cv_arg
    cv_variation: TypeAlias = Variation_200

    @classmethod
    def create(cls, arg : "RuleVariation_193.cv_arg") -> "RuleVariation_193":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_200:
        return self.arg # type: ignore

class NonSpare_15(NonSpare):
    cv_arg: TypeAlias = RuleVariation_193.cv_arg
    cv_name = "000"
    cv_title = "Message Type"
    cv_rule: TypeAlias = RuleVariation_193

    @classmethod
    def create(cls, arg : "NonSpare_15.cv_arg") -> "NonSpare_15":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_193:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_200:
        return self.rule.variation

class UapItem_15(UapItem):
    cv_non_spare: TypeAlias = NonSpare_15

class NonSpare_97(NonSpare):
    cv_arg: TypeAlias = RuleVariation_368.cv_arg
    cv_name = "020"
    cv_title = "Video Record Header"
    cv_rule: TypeAlias = RuleVariation_368

    @classmethod
    def create(cls, arg : "NonSpare_97.cv_arg") -> "NonSpare_97":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

class UapItem_97(UapItem):
    cv_non_spare: TypeAlias = NonSpare_97

class NonSpare_115(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1317.cv_arg
    cv_name = "030"
    cv_title = "Video Summary"
    cv_rule: TypeAlias = RuleVariation_1317

    @classmethod
    def create(cls, arg : "NonSpare_115.cv_arg") -> "NonSpare_115":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1317:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1396:
        return self.rule.variation

class UapItem_115(UapItem):
    cv_non_spare: TypeAlias = NonSpare_115

class Content_794(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["°"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 5.4931640625e-3
    cv_unit = "°"

    def as_quantity(self, cv_unit : Optional[Literal["°"]] = None) -> float:
        return self._as_quantity()

class RuleContent_793(RuleContentContextFree):
    cv_arg: TypeAlias = Content_794.cv_arg
    cv_content: TypeAlias = Content_794

    @property
    def content(self) -> Content_794:
        return self._get_content() # type: ignore

class Variation_344(Element):
    cv_arg: TypeAlias = RuleContent_793.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_rule = RuleContent_793

    @classmethod
    def create(cls, arg: "Variation_344.cv_arg") -> "Variation_344":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_793:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_794:
        return self.rule.content

class RuleVariation_337(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_344.cv_arg
    cv_variation: TypeAlias = Variation_344

    @classmethod
    def create(cls, arg : "RuleVariation_337.cv_arg") -> "RuleVariation_337":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_344:
        return self.arg # type: ignore

class NonSpare_1773(NonSpare):
    cv_arg: TypeAlias = RuleVariation_337.cv_arg
    cv_name = "STARTAZ"
    cv_title = "Start Azimuth of the Cells Group"
    cv_rule: TypeAlias = RuleVariation_337

    @classmethod
    def create(cls, arg : "NonSpare_1773.cv_arg") -> "NonSpare_1773":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_344:
        return self.rule.variation

class Item_934(Item):
    cv_arg: TypeAlias = NonSpare_1773.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1773

    @classmethod
    def create(cls, arg : "Item_934.cv_arg") -> "Item_934":
        return cls._create(arg) # type: ignore

class NonSpare_934(NonSpare):
    cv_arg: TypeAlias = RuleVariation_337.cv_arg
    cv_name = "ENDAZ"
    cv_title = "End Azimuth of the Cells Group"
    cv_rule: TypeAlias = RuleVariation_337

    @classmethod
    def create(cls, arg : "NonSpare_934.cv_arg") -> "NonSpare_934":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_337:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_344:
        return self.rule.variation

class Item_295(Item):
    cv_arg: TypeAlias = NonSpare_934.cv_arg
    cv_non_spare: TypeAlias = NonSpare_934

    @classmethod
    def create(cls, arg : "Item_295.cv_arg") -> "Item_295":
        return cls._create(arg) # type: ignore

class NonSpare_1774(NonSpare):
    cv_arg: TypeAlias = RuleVariation_368.cv_arg
    cv_name = "STARTRG"
    cv_title = "Starting Range of the Cells Group, Expressed in Number of Cells"
    cv_rule: TypeAlias = RuleVariation_368

    @classmethod
    def create(cls, arg : "NonSpare_1774.cv_arg") -> "NonSpare_1774":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_368:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_375:
        return self.rule.variation

class Item_935(Item):
    cv_arg: TypeAlias = NonSpare_1774.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1774

    @classmethod
    def create(cls, arg : "Item_935.cv_arg") -> "Item_935":
        return cls._create(arg) # type: ignore

class Variation_387(Element):
    cv_arg: TypeAlias = RuleContent_723.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_723

    @classmethod
    def create(cls, arg: "Variation_387.cv_arg") -> "Variation_387":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_723:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_723:
        return self.rule.content

class RuleVariation_380(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_387.cv_arg
    cv_variation: TypeAlias = Variation_387

    @classmethod
    def create(cls, arg : "RuleVariation_380.cv_arg") -> "RuleVariation_380":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_387:
        return self.arg # type: ignore

class NonSpare_720(NonSpare):
    cv_arg: TypeAlias = RuleVariation_380.cv_arg
    cv_name = "CELLDUR"
    cv_title = "Video Cell Duration in Nano-seconds"
    cv_rule: TypeAlias = RuleVariation_380

    @classmethod
    def create(cls, arg : "NonSpare_720.cv_arg") -> "NonSpare_720":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_380:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_387:
        return self.rule.variation

class Item_146(Item):
    cv_arg: TypeAlias = NonSpare_720.cv_arg
    cv_non_spare: TypeAlias = NonSpare_720

    @classmethod
    def create(cls, arg : "Item_146.cv_arg") -> "Item_146":
        return cls._create(arg) # type: ignore

class Variation_1214(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_337.cv_arg, Tuple[Literal["STARTAZ"], RuleVariation_337.cv_arg]], Union[RuleVariation_337.cv_arg, Tuple[Literal["ENDAZ"], RuleVariation_337.cv_arg]], Union[RuleVariation_368.cv_arg, Tuple[Literal["STARTRG"], RuleVariation_368.cv_arg]], Union[RuleVariation_380.cv_arg, Tuple[Literal["CELLDUR"], RuleVariation_380.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1214.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_934, 16), (Item_295, 16), (Item_935, 32), (Item_146, 32)]
    cv_items_dict = {"STARTAZ": RuleVariation_337, "ENDAZ": RuleVariation_337, "STARTRG": RuleVariation_368, "CELLDUR": RuleVariation_380}

    @overload
    @classmethod
    def spec(cls, key : Literal["STARTAZ"]) -> RuleVariation_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ENDAZ"]) -> RuleVariation_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STARTRG"]) -> RuleVariation_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CELLDUR"]) -> RuleVariation_380:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STARTAZ"], Literal["ENDAZ"], Literal["STARTRG"], Literal["CELLDUR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STARTAZ"]) -> RuleVariation_337:
        ...
    @overload
    def get_item(self, key : Literal["ENDAZ"]) -> RuleVariation_337:
        ...
    @overload
    def get_item(self, key : Literal["STARTRG"]) -> RuleVariation_368:
        ...
    @overload
    def get_item(self, key : Literal["CELLDUR"]) -> RuleVariation_380:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1214.cv_arg") -> 'Variation_1214':
        return cls._create(arg) # type: ignore

class RuleVariation_1158(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1214.cv_arg
    cv_variation: TypeAlias = Variation_1214

    @classmethod
    def create(cls, arg : "RuleVariation_1158.cv_arg") -> "RuleVariation_1158":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1214:
        return self.arg # type: ignore

class NonSpare_151(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1158.cv_arg
    cv_name = "040"
    cv_title = "Video Header Nano"
    cv_rule: TypeAlias = RuleVariation_1158

    @classmethod
    def create(cls, arg : "NonSpare_151.cv_arg") -> "NonSpare_151":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1158:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1214:
        return self.rule.variation

class UapItem_151(UapItem):
    cv_non_spare: TypeAlias = NonSpare_151

class Content_714(ContentQuantity):
    cv_arg: TypeAlias = Union[int, float, Tuple[float, Literal["fs"]]]
    cv_signedness: TypeAlias = Unsigned
    cv_lsb = 1.0
    cv_unit = "fs"

    def as_quantity(self, cv_unit : Optional[Literal["fs"]] = None) -> float:
        return self._as_quantity()

class RuleContent_714(RuleContentContextFree):
    cv_arg: TypeAlias = Content_714.cv_arg
    cv_content: TypeAlias = Content_714

    @property
    def content(self) -> Content_714:
        return self._get_content() # type: ignore

class Variation_386(Element):
    cv_arg: TypeAlias = RuleContent_714.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 32
    cv_rule = RuleContent_714

    @classmethod
    def create(cls, arg: "Variation_386.cv_arg") -> "Variation_386":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_714:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_714:
        return self.rule.content

class RuleVariation_379(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_386.cv_arg
    cv_variation: TypeAlias = Variation_386

    @classmethod
    def create(cls, arg : "RuleVariation_379.cv_arg") -> "RuleVariation_379":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_386:
        return self.arg # type: ignore

class NonSpare_719(NonSpare):
    cv_arg: TypeAlias = RuleVariation_379.cv_arg
    cv_name = "CELLDUR"
    cv_title = "Video Cell Duration in Femto-seconds"
    cv_rule: TypeAlias = RuleVariation_379

    @classmethod
    def create(cls, arg : "NonSpare_719.cv_arg") -> "NonSpare_719":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_379:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_386:
        return self.rule.variation

class Item_145(Item):
    cv_arg: TypeAlias = NonSpare_719.cv_arg
    cv_non_spare: TypeAlias = NonSpare_719

    @classmethod
    def create(cls, arg : "Item_145.cv_arg") -> "Item_145":
        return cls._create(arg) # type: ignore

class Variation_1213(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_337.cv_arg, Tuple[Literal["STARTAZ"], RuleVariation_337.cv_arg]], Union[RuleVariation_337.cv_arg, Tuple[Literal["ENDAZ"], RuleVariation_337.cv_arg]], Union[RuleVariation_368.cv_arg, Tuple[Literal["STARTRG"], RuleVariation_368.cv_arg]], Union[RuleVariation_379.cv_arg, Tuple[Literal["CELLDUR"], RuleVariation_379.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1213.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 96
    cv_items_list = [(Item_934, 16), (Item_295, 16), (Item_935, 32), (Item_145, 32)]
    cv_items_dict = {"STARTAZ": RuleVariation_337, "ENDAZ": RuleVariation_337, "STARTRG": RuleVariation_368, "CELLDUR": RuleVariation_379}

    @overload
    @classmethod
    def spec(cls, key : Literal["STARTAZ"]) -> RuleVariation_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["ENDAZ"]) -> RuleVariation_337:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["STARTRG"]) -> RuleVariation_368:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["CELLDUR"]) -> RuleVariation_379:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["STARTAZ"], Literal["ENDAZ"], Literal["STARTRG"], Literal["CELLDUR"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["STARTAZ"]) -> RuleVariation_337:
        ...
    @overload
    def get_item(self, key : Literal["ENDAZ"]) -> RuleVariation_337:
        ...
    @overload
    def get_item(self, key : Literal["STARTRG"]) -> RuleVariation_368:
        ...
    @overload
    def get_item(self, key : Literal["CELLDUR"]) -> RuleVariation_379:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1213.cv_arg") -> 'Variation_1213':
        return cls._create(arg) # type: ignore

class RuleVariation_1157(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1213.cv_arg
    cv_variation: TypeAlias = Variation_1213

    @classmethod
    def create(cls, arg : "RuleVariation_1157.cv_arg") -> "RuleVariation_1157":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1213:
        return self.arg # type: ignore

class NonSpare_157(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1157.cv_arg
    cv_name = "041"
    cv_title = "Video Header Femto"
    cv_rule: TypeAlias = RuleVariation_1157

    @classmethod
    def create(cls, arg : "NonSpare_157.cv_arg") -> "NonSpare_157":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1157:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1213:
        return self.rule.variation

class UapItem_157(UapItem):
    cv_non_spare: TypeAlias = NonSpare_157

class Content_341(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {0: "No compression applied", 1: "Compression applied"}

class RuleContent_341(RuleContentContextFree):
    cv_arg: TypeAlias = Content_341.cv_arg
    cv_content: TypeAlias = Content_341

    @property
    def content(self) -> Content_341:
        return self._get_content() # type: ignore

class Variation_60(Element):
    cv_arg: TypeAlias = RuleContent_341.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 1
    cv_rule = RuleContent_341

    @classmethod
    def create(cls, arg: "Variation_60.cv_arg") -> "Variation_60":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_341:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_341:
        return self.rule.content

class RuleVariation_60(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_60.cv_arg
    cv_variation: TypeAlias = Variation_60

    @classmethod
    def create(cls, arg : "RuleVariation_60.cv_arg") -> "RuleVariation_60":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_60:
        return self.arg # type: ignore

class NonSpare_700(NonSpare):
    cv_arg: TypeAlias = RuleVariation_60.cv_arg
    cv_name = "C"
    cv_title = "Data Compression Indicator"
    cv_rule: TypeAlias = RuleVariation_60

    @classmethod
    def create(cls, arg : "NonSpare_700.cv_arg") -> "NonSpare_700":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_60:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_60:
        return self.rule.variation

class Item_132(Item):
    cv_arg: TypeAlias = NonSpare_700.cv_arg
    cv_non_spare: TypeAlias = NonSpare_700

    @classmethod
    def create(cls, arg : "Item_132.cv_arg") -> "Item_132":
        return cls._create(arg) # type: ignore

class Content_586(ContentTable):
    cv_arg: TypeAlias = int
    cv_values = {1: "Monobit Resolution (1 bit)", 2: "Low Resolution (2 bits)", 3: "Medium Resolution (4 bits)", 4: "High Resolution (8 bits)", 5: "Very High Resolution (16 bits)", 6: "Ultra High Resolution (32 bits)"}

class RuleContent_586(RuleContentContextFree):
    cv_arg: TypeAlias = Content_586.cv_arg
    cv_content: TypeAlias = Content_586

    @property
    def content(self) -> Content_586:
        return self._get_content() # type: ignore

class Variation_186(Element):
    cv_arg: TypeAlias = RuleContent_586.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 8
    cv_rule = RuleContent_586

    @classmethod
    def create(cls, arg: "Variation_186.cv_arg") -> "Variation_186":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_586:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_586:
        return self.rule.content

class RuleVariation_179(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_186.cv_arg
    cv_variation: TypeAlias = Variation_186

    @classmethod
    def create(cls, arg : "RuleVariation_179.cv_arg") -> "RuleVariation_179":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_186:
        return self.arg # type: ignore

class NonSpare_1584(NonSpare):
    cv_arg: TypeAlias = RuleVariation_179.cv_arg
    cv_name = "RES"
    cv_title = "Bit Resolution"
    cv_rule: TypeAlias = RuleVariation_179

    @classmethod
    def create(cls, arg : "NonSpare_1584.cv_arg") -> "NonSpare_1584":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_179:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_186:
        return self.rule.variation

class Item_809(Item):
    cv_arg: TypeAlias = NonSpare_1584.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1584

    @classmethod
    def create(cls, arg : "Item_809.cv_arg") -> "Item_809":
        return cls._create(arg) # type: ignore

class Variation_1062(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_60.cv_arg, Tuple[Literal["C"], RuleVariation_60.cv_arg]], int, Union[RuleVariation_179.cv_arg, Tuple[Literal["RES"], RuleVariation_179.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1062.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 16
    cv_items_list = [(Item_132, 1), (Item_10, 7), (Item_809, 8)]
    cv_items_dict = {"C": RuleVariation_60, "RES": RuleVariation_179}

    @overload
    @classmethod
    def spec(cls, key : Literal["C"]) -> RuleVariation_60:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RES"]) -> RuleVariation_179:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["C"], Literal["RES"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["C"]) -> RuleVariation_60:
        ...
    @overload
    def get_item(self, key : Literal["RES"]) -> RuleVariation_179:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1062.cv_arg") -> 'Variation_1062':
        return cls._create(arg) # type: ignore

class RuleVariation_1026(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1062.cv_arg
    cv_variation: TypeAlias = Variation_1062

    @classmethod
    def create(cls, arg : "RuleVariation_1026.cv_arg") -> "RuleVariation_1026":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1062:
        return self.arg # type: ignore

class NonSpare_166(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1026.cv_arg
    cv_name = "048"
    cv_title = "Video Cells Resolution & Data Compression Indicator"
    cv_rule: TypeAlias = RuleVariation_1026

    @classmethod
    def create(cls, arg : "NonSpare_166.cv_arg") -> "NonSpare_166":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1026:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1062:
        return self.rule.variation

class UapItem_166(UapItem):
    cv_non_spare: TypeAlias = NonSpare_166

class NonSpare_1355(NonSpare):
    cv_arg: TypeAlias = RuleVariation_249.cv_arg
    cv_name = "NBVB"
    cv_title = "Number of 'valid' Octets"
    cv_rule: TypeAlias = RuleVariation_249

    @classmethod
    def create(cls, arg : "NonSpare_1355.cv_arg") -> "NonSpare_1355":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_249:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_256:
        return self.rule.variation

class Item_615(Item):
    cv_arg: TypeAlias = NonSpare_1355.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1355

    @classmethod
    def create(cls, arg : "Item_615.cv_arg") -> "Item_615":
        return cls._create(arg) # type: ignore

class NonSpare_1350(NonSpare):
    cv_arg: TypeAlias = RuleVariation_344.cv_arg
    cv_name = "NBCELLS"
    cv_title = "Number of 'valid' Cells"
    cv_rule: TypeAlias = RuleVariation_344

    @classmethod
    def create(cls, arg : "NonSpare_1350.cv_arg") -> "NonSpare_1350":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_344:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_351:
        return self.rule.variation

class Item_610(Item):
    cv_arg: TypeAlias = NonSpare_1350.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1350

    @classmethod
    def create(cls, arg : "Item_610.cv_arg") -> "Item_610":
        return cls._create(arg) # type: ignore

class Variation_1149(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_249.cv_arg, Tuple[Literal["NBVB"], RuleVariation_249.cv_arg]], Union[RuleVariation_344.cv_arg, Tuple[Literal["NBCELLS"], RuleVariation_344.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1149.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 40
    cv_items_list = [(Item_615, 16), (Item_610, 24)]
    cv_items_dict = {"NBVB": RuleVariation_249, "NBCELLS": RuleVariation_344}

    @overload
    @classmethod
    def spec(cls, key : Literal["NBVB"]) -> RuleVariation_249:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["NBCELLS"]) -> RuleVariation_344:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["NBVB"], Literal["NBCELLS"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["NBVB"]) -> RuleVariation_249:
        ...
    @overload
    def get_item(self, key : Literal["NBCELLS"]) -> RuleVariation_344:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1149.cv_arg") -> 'Variation_1149':
        return cls._create(arg) # type: ignore

class RuleVariation_1102(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1149.cv_arg
    cv_variation: TypeAlias = Variation_1149

    @classmethod
    def create(cls, arg : "RuleVariation_1102.cv_arg") -> "RuleVariation_1102":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1149:
        return self.arg # type: ignore

class NonSpare_167(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1102.cv_arg
    cv_name = "049"
    cv_title = "Video Octets & Video Cells Counters"
    cv_rule: TypeAlias = RuleVariation_1102

    @classmethod
    def create(cls, arg : "NonSpare_167.cv_arg") -> "NonSpare_167":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1102:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1149:
        return self.rule.variation

class UapItem_167(UapItem):
    cv_non_spare: TypeAlias = NonSpare_167

class Variation_1400(Repetitive):
    cv_arg: TypeAlias = List[Variation_373.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_373

    @classmethod
    def create(cls, arg: "Variation_1400.cv_arg") -> 'Variation_1400':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_373]:
        return self._get_list() # type: ignore

class RuleVariation_1321(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1400.cv_arg
    cv_variation: TypeAlias = Variation_1400

    @classmethod
    def create(cls, arg : "RuleVariation_1321.cv_arg") -> "RuleVariation_1321":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1400:
        return self.arg # type: ignore

class NonSpare_183(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1321.cv_arg
    cv_name = "050"
    cv_title = "Video Block Low Data Volume"
    cv_rule: TypeAlias = RuleVariation_1321

    @classmethod
    def create(cls, arg : "NonSpare_183.cv_arg") -> "NonSpare_183":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1321:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1400:
        return self.rule.variation

class UapItem_183(UapItem):
    cv_non_spare: TypeAlias = NonSpare_183

class Variation_398(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 512
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_398.cv_arg") -> "Variation_398":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class Variation_1405(Repetitive):
    cv_arg: TypeAlias = List[Variation_398.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_398

    @classmethod
    def create(cls, arg: "Variation_1405.cv_arg") -> 'Variation_1405':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_398]:
        return self._get_list() # type: ignore

class RuleVariation_1326(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1405.cv_arg
    cv_variation: TypeAlias = Variation_1405

    @classmethod
    def create(cls, arg : "RuleVariation_1326.cv_arg") -> "RuleVariation_1326":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1405:
        return self.arg # type: ignore

class NonSpare_184(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1326.cv_arg
    cv_name = "051"
    cv_title = "Video Block Medium Data Volume"
    cv_rule: TypeAlias = RuleVariation_1326

    @classmethod
    def create(cls, arg : "NonSpare_184.cv_arg") -> "NonSpare_184":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1326:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1405:
        return self.rule.variation

class UapItem_184(UapItem):
    cv_non_spare: TypeAlias = NonSpare_184

class Variation_399(Element):
    cv_arg: TypeAlias = RuleContent_0.cv_arg
    cv_bit_offset8 = 0
    cv_bit_size = 2048
    cv_rule = RuleContent_0

    @classmethod
    def create(cls, arg: "Variation_399.cv_arg") -> "Variation_399":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleContent_0:
        return self._get_rule() # type: ignore

    # shortcut
    @property
    def content(self) -> Content_0:
        return self.rule.content

class Variation_1406(Repetitive):
    cv_arg: TypeAlias = List[Variation_399.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_399

    @classmethod
    def create(cls, arg: "Variation_1406.cv_arg") -> 'Variation_1406':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_399]:
        return self._get_list() # type: ignore

class RuleVariation_1327(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1406.cv_arg
    cv_variation: TypeAlias = Variation_1406

    @classmethod
    def create(cls, arg : "RuleVariation_1327.cv_arg") -> "RuleVariation_1327":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1406:
        return self.arg # type: ignore

class NonSpare_185(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1327.cv_arg
    cv_name = "052"
    cv_title = "Video Block High Data Volume"
    cv_rule: TypeAlias = RuleVariation_1327

    @classmethod
    def create(cls, arg : "NonSpare_185.cv_arg") -> "NonSpare_185":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1327:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1406:
        return self.rule.variation

class UapItem_185(UapItem):
    cv_non_spare: TypeAlias = NonSpare_185

class NonSpare_330(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_330.cv_arg") -> "NonSpare_330":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_330(UapItem):
    cv_non_spare: TypeAlias = NonSpare_330

class Record_39(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_44.cv_arg,
        "000": NonSpare_15.cv_arg,
        "020": NonSpare_97.cv_arg,
        "030": NonSpare_115.cv_arg,
        "040": NonSpare_151.cv_arg,
        "041": NonSpare_157.cv_arg,
        "048": NonSpare_166.cv_arg,
        "049": NonSpare_167.cv_arg,
        "050": NonSpare_183.cv_arg,
        "051": NonSpare_184.cv_arg,
        "052": NonSpare_185.cv_arg,
        "140": NonSpare_330.cv_arg,
        "RE": NonSpare_1568.cv_arg,
        "SP": NonSpare_1732.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 2
    cv_items_list = [UapItem_44, UapItem_15, UapItem_97, UapItem_115, UapItem_151, UapItem_157, UapItem_166, UapItem_167, UapItem_183, UapItem_184, UapItem_185, UapItem_330, UapItem_547, UapItem_548]
    cv_items_dict = {"010": NonSpare_44, "000": NonSpare_15, "020": NonSpare_97, "030": NonSpare_115, "040": NonSpare_151, "041": NonSpare_157, "048": NonSpare_166, "049": NonSpare_167, "050": NonSpare_183, "051": NonSpare_184, "052": NonSpare_185, "140": NonSpare_330, "RE": NonSpare_1568, "SP": NonSpare_1732}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_44:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["000"]) -> NonSpare_15:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["020"]) -> NonSpare_97:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["030"]) -> NonSpare_115:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["040"]) -> NonSpare_151:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["041"]) -> NonSpare_157:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["048"]) -> NonSpare_166:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["049"]) -> NonSpare_167:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["050"]) -> NonSpare_183:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["051"]) -> NonSpare_184:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["052"]) -> NonSpare_185:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_330:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["000"], Literal["020"], Literal["030"], Literal["040"], Literal["041"], Literal["048"], Literal["049"], Literal["050"], Literal["051"], Literal["052"], Literal["140"], Literal["RE"], Literal["SP"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_44]:
        ...
    @overload
    def get_item(self, key : Literal["000"]) -> Optional[NonSpare_15]:
        ...
    @overload
    def get_item(self, key : Literal["020"]) -> Optional[NonSpare_97]:
        ...
    @overload
    def get_item(self, key : Literal["030"]) -> Optional[NonSpare_115]:
        ...
    @overload
    def get_item(self, key : Literal["040"]) -> Optional[NonSpare_151]:
        ...
    @overload
    def get_item(self, key : Literal["041"]) -> Optional[NonSpare_157]:
        ...
    @overload
    def get_item(self, key : Literal["048"]) -> Optional[NonSpare_166]:
        ...
    @overload
    def get_item(self, key : Literal["049"]) -> Optional[NonSpare_167]:
        ...
    @overload
    def get_item(self, key : Literal["050"]) -> Optional[NonSpare_183]:
        ...
    @overload
    def get_item(self, key : Literal["051"]) -> Optional[NonSpare_184]:
        ...
    @overload
    def get_item(self, key : Literal["052"]) -> Optional[NonSpare_185]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_330]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_44.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["000"], val : NonSpare_15.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["020"], val : NonSpare_97.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["030"], val : NonSpare_115.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["040"], val : NonSpare_151.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["041"], val : NonSpare_157.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["048"], val : NonSpare_166.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["049"], val : NonSpare_167.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["050"], val : NonSpare_183.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["051"], val : NonSpare_184.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["052"], val : NonSpare_185.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_330.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_39':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_39':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["000"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["020"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["030"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["040"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["041"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["048"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["049"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["050"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["051"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["052"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_39':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_39':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_39.cv_arg") -> 'Record_39':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_39", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_35(UapSingle):
    cv_arg: TypeAlias = Record_39
    cv_record: TypeAlias = Record_39

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_39]]:
        return cls._parse(bs)

class Asterix_63(AstCat):
    cv_category = 240
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_35
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_35.cv_arg]) -> "Asterix_63":
        return cls._create(records) # type: ignore

class NonSpare_66(NonSpare):
    cv_arg: TypeAlias = RuleVariation_159.cv_arg
    cv_name = "015"
    cv_title = "Service Identification"
    cv_rule: TypeAlias = RuleVariation_159

    @classmethod
    def create(cls, arg : "NonSpare_66.cv_arg") -> "NonSpare_66":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_159:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_165:
        return self.rule.variation

class UapItem_66(UapItem):
    cv_non_spare: TypeAlias = NonSpare_66

class NonSpare_332(NonSpare):
    cv_arg: TypeAlias = RuleVariation_363.cv_arg
    cv_name = "140"
    cv_title = "Time of Day"
    cv_rule: TypeAlias = RuleVariation_363

    @classmethod
    def create(cls, arg : "NonSpare_332.cv_arg") -> "NonSpare_332":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_363:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_370:
        return self.rule.variation

class UapItem_332(UapItem):
    cv_non_spare: TypeAlias = NonSpare_332

class NonSpare_706(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "CAT"
    cv_title = "Category"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_706.cv_arg") -> "NonSpare_706":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_136(Item):
    cv_arg: TypeAlias = NonSpare_706.cv_arg
    cv_non_spare: TypeAlias = NonSpare_706

    @classmethod
    def create(cls, arg : "Item_136.cv_arg") -> "Item_136":
        return cls._create(arg) # type: ignore

class NonSpare_1227(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "MAIN"
    cv_title = "Main Version Number"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1227.cv_arg") -> "NonSpare_1227":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_527(Item):
    cv_arg: TypeAlias = NonSpare_1227.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1227

    @classmethod
    def create(cls, arg : "Item_527.cv_arg") -> "Item_527":
        return cls._create(arg) # type: ignore

class NonSpare_1805(NonSpare):
    cv_arg: TypeAlias = RuleVariation_198.cv_arg
    cv_name = "SUB"
    cv_title = "Sub Version Number"
    cv_rule: TypeAlias = RuleVariation_198

    @classmethod
    def create(cls, arg : "NonSpare_1805.cv_arg") -> "NonSpare_1805":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_198:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_205:
        return self.rule.variation

class Item_961(Item):
    cv_arg: TypeAlias = NonSpare_1805.cv_arg
    cv_non_spare: TypeAlias = NonSpare_1805

    @classmethod
    def create(cls, arg : "Item_961.cv_arg") -> "Item_961":
        return cls._create(arg) # type: ignore

class Variation_1064(Group):
    cv_arg_group: TypeAlias = Tuple[Union[RuleVariation_198.cv_arg, Tuple[Literal["CAT"], RuleVariation_198.cv_arg]], Union[RuleVariation_198.cv_arg, Tuple[Literal["MAIN"], RuleVariation_198.cv_arg]], Union[RuleVariation_198.cv_arg, Tuple[Literal["SUB"], RuleVariation_198.cv_arg]]]
    cv_arg: TypeAlias = Union[int, "Variation_1064.cv_arg_group"]
    cv_bit_offset8 = 0
    cv_bit_size = 24
    cv_items_list = [(Item_136, 8), (Item_527, 8), (Item_961, 8)]
    cv_items_dict = {"CAT": RuleVariation_198, "MAIN": RuleVariation_198, "SUB": RuleVariation_198}

    @overload
    @classmethod
    def spec(cls, key : Literal["CAT"]) -> RuleVariation_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["MAIN"]) -> RuleVariation_198:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SUB"]) -> RuleVariation_198:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["CAT"], Literal["MAIN"], Literal["SUB"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["CAT"]) -> RuleVariation_198:
        ...
    @overload
    def get_item(self, key : Literal["MAIN"]) -> RuleVariation_198:
        ...
    @overload
    def get_item(self, key : Literal["SUB"]) -> RuleVariation_198:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @classmethod
    def create(cls, arg: "Variation_1064.cv_arg") -> 'Variation_1064':
        return cls._create(arg) # type: ignore

class Variation_1413(Repetitive):
    cv_arg: TypeAlias = List[Variation_1064.cv_arg]
    cv_rep_bytes = 1
    cv_variation: TypeAlias = Variation_1064

    @classmethod
    def create(cls, arg: "Variation_1413.cv_arg") -> 'Variation_1413':
        return cls._create(arg) # type: ignore

    def get_list(self) -> List[Variation_1064]:
        return self._get_list() # type: ignore

class RuleVariation_1334(RuleVariationContextFree):
    cv_arg: TypeAlias = Variation_1413.cv_arg
    cv_variation: TypeAlias = Variation_1413

    @classmethod
    def create(cls, arg : "RuleVariation_1334.cv_arg") -> "RuleVariation_1334":
        return cls._create(arg) # type: ignore

    @property
    def variation(self) -> Variation_1413:
        return self.arg # type: ignore

class NonSpare_521(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1334.cv_arg
    cv_name = "550"
    cv_title = "Category Version Number Report"
    cv_rule: TypeAlias = RuleVariation_1334

    @classmethod
    def create(cls, arg : "NonSpare_521.cv_arg") -> "NonSpare_521":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1413:
        return self.rule.variation

class UapItem_520(UapItem):
    cv_non_spare: TypeAlias = NonSpare_521

class Record_23(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "015": NonSpare_66.cv_arg,
        "140": NonSpare_332.cv_arg,
        "550": NonSpare_521.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [UapItem_37, UapItem_66, UapItem_332, UapItem_520, UapItem_549, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_37, "015": NonSpare_66, "140": NonSpare_332, "550": NonSpare_521, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_66:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_521:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["140"], Literal["550"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_66]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_332]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_521]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_66.cv_arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_332.cv_arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_521.cv_arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_23':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_23':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_23':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_23':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_23.cv_arg") -> 'Record_23':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_23", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_21(UapSingle):
    cv_arg: TypeAlias = Record_23
    cv_record: TypeAlias = Record_23

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_23]]:
        return cls._parse(bs)

class Asterix_64(AstCat):
    cv_category = 247
    cv_edition = (1, 2)
    cv_uap: TypeAlias = Uap_21
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_21.cv_arg]) -> "Asterix_64":
        return cls._create(records) # type: ignore

class NonSpare_522(NonSpare):
    cv_arg: TypeAlias = RuleVariation_1334.cv_arg
    cv_name = "550"
    cv_title = "Category Version Number Report"
    cv_rule: TypeAlias = RuleVariation_1334

    @classmethod
    def create(cls, arg : "NonSpare_522.cv_arg") -> "NonSpare_522":
        return cls._create(arg) # type: ignore

    @property
    def rule(self) -> RuleVariation_1334:
        return self.arg # type: ignore

    # shortcut to variation
    @property
    def variation(self) -> Variation_1413:
        return self.rule.variation

class UapItem_521(UapItem):
    cv_non_spare: TypeAlias = NonSpare_522

class Record_24(Record):
    cv_arg = TypedDict('cv_arg', {
        "010": NonSpare_37.cv_arg,
        "015": NonSpare_66.cv_arg,
        "140": NonSpare_332.cv_arg,
        "550": NonSpare_522.cv_arg,
        "SP": NonSpare_1732.cv_arg,
        "RE": NonSpare_1568.cv_arg,
    }, total=False)
    cv_fspec_max_bytes = 1
    cv_items_list = [UapItem_37, UapItem_66, UapItem_332, UapItem_521, UapItem_549, UapItem_548, UapItem_547]
    cv_items_dict = {"010": NonSpare_37, "015": NonSpare_66, "140": NonSpare_332, "550": NonSpare_522, "SP": NonSpare_1732, "RE": NonSpare_1568}

    @overload
    @classmethod
    def spec(cls, key : Literal["010"]) -> NonSpare_37:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["015"]) -> NonSpare_66:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["140"]) -> NonSpare_332:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["550"]) -> NonSpare_522:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["SP"]) -> NonSpare_1732:
        ...
    @overload
    @classmethod
    def spec(cls, key : Literal["RE"]) -> NonSpare_1568:
        ...
    @classmethod
    def spec(cls, key : Union[Literal["010"], Literal["015"], Literal["140"], Literal["550"], Literal["SP"], Literal["RE"]]) -> Any:
        return cls._spec(key)

    @overload
    def get_item(self, key : Literal["010"]) -> Optional[NonSpare_37]:
        ...
    @overload
    def get_item(self, key : Literal["015"]) -> Optional[NonSpare_66]:
        ...
    @overload
    def get_item(self, key : Literal["140"]) -> Optional[NonSpare_332]:
        ...
    @overload
    def get_item(self, key : Literal["550"]) -> Optional[NonSpare_522]:
        ...
    @overload
    def get_item(self, key : Literal["SP"]) -> Optional[NonSpare_1732]:
        ...
    @overload
    def get_item(self, key : Literal["RE"]) -> Optional[NonSpare_1568]:
        ...
    def get_item(self, key : Any) -> Any:
        return self._get_item(key)

    @overload
    def set_item(self, key : Literal["010"], val : NonSpare_37.cv_arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["015"], val : NonSpare_66.cv_arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["140"], val : NonSpare_332.cv_arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["550"], val : NonSpare_522.cv_arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["SP"], val : NonSpare_1732.cv_arg) -> 'Record_24':
        ...
    @overload
    def set_item(self, key : Literal["RE"], val : NonSpare_1568.cv_arg) -> 'Record_24':
        ...
    def set_item(self, key : Any, val : Any) -> Any:
        return self._set_item(key, val)

    @overload
    def del_item(self, key : Literal["010"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["015"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["140"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["550"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["SP"]) -> 'Record_24':
        ...
    @overload
    def del_item(self, key : Literal["RE"]) -> 'Record_24':
        ...
    def del_item(self, key : Any) -> Any:
        return self._del_item(key)

    @classmethod
    def create(cls, arg: "Record_24.cv_arg") -> 'Record_24':
        return cls._create(arg) # type: ignore

    @classmethod
    def parse(cls, pm: ParsingMode, bs : Bits) -> Union[ValueError, Tuple["Record_24", Bits]]:
        return cls._parse(pm, bs) # type: ignore

class Uap_22(UapSingle):
    cv_arg: TypeAlias = Record_24
    cv_record: TypeAlias = Record_24

    @classmethod
    def parse(cls, bs : Bits) -> Union[ValueError, List[Record_24]]:
        return cls._parse(bs)

class Asterix_65(AstCat):
    cv_category = 247
    cv_edition = (1, 3)
    cv_uap: TypeAlias = Uap_22
    cv_record: TypeAlias = cv_uap.cv_record # shortcut

    @classmethod
    def create(cls, records : List[Uap_22.cv_arg]) -> "Asterix_65":
        return cls._create(records) # type: ignore

# Aliases

Cat_001_1_2: TypeAlias = Asterix_0
Cat_001_1_3: TypeAlias = Asterix_1
Cat_001_1_4: TypeAlias = Asterix_2
Cat_002_1_0: TypeAlias = Asterix_3
Cat_002_1_1: TypeAlias = Asterix_4
Cat_002_1_2: TypeAlias = Asterix_5
Cat_004_1_12: TypeAlias = Asterix_6
Cat_004_1_13: TypeAlias = Asterix_7
Cat_008_1_2: TypeAlias = Asterix_8
Cat_008_1_3: TypeAlias = Asterix_9
Cat_009_2_1: TypeAlias = Asterix_10
Cat_010_1_1: TypeAlias = Asterix_11
Cat_011_1_2: TypeAlias = Asterix_12
Cat_011_1_3: TypeAlias = Asterix_13
Cat_015_1_0: TypeAlias = Asterix_14
Cat_015_1_1: TypeAlias = Asterix_15
Cat_015_1_2: TypeAlias = Asterix_16
Cat_016_1_0: TypeAlias = Asterix_17
Cat_017_1_3: TypeAlias = Asterix_18
Cat_018_1_7: TypeAlias = Asterix_19
Cat_018_1_8: TypeAlias = Asterix_20
Cat_019_1_3: TypeAlias = Asterix_21
Cat_020_1_9: TypeAlias = Asterix_22
Cat_020_1_10: TypeAlias = Asterix_23
Cat_021_0_23: TypeAlias = Asterix_24
Cat_021_0_24: TypeAlias = Asterix_25
Cat_021_0_25: TypeAlias = Asterix_26
Cat_021_0_26: TypeAlias = Asterix_27
Ref_021_1_4: TypeAlias = Asterix_28
Ref_021_1_5: TypeAlias = Asterix_29
Cat_021_2_1: TypeAlias = Asterix_30
Cat_021_2_2: TypeAlias = Asterix_31
Cat_021_2_3: TypeAlias = Asterix_32
Cat_021_2_4: TypeAlias = Asterix_33
Cat_021_2_5: TypeAlias = Asterix_34
Cat_021_2_6: TypeAlias = Asterix_35
Cat_023_1_2: TypeAlias = Asterix_36
Cat_023_1_3: TypeAlias = Asterix_37
Cat_025_1_5: TypeAlias = Asterix_38
Cat_032_1_1: TypeAlias = Asterix_39
Cat_034_1_27: TypeAlias = Asterix_40
Cat_034_1_28: TypeAlias = Asterix_41
Cat_034_1_29: TypeAlias = Asterix_42
Ref_048_1_11: TypeAlias = Asterix_43
Ref_048_1_12: TypeAlias = Asterix_44
Cat_048_1_27: TypeAlias = Asterix_45
Cat_048_1_28: TypeAlias = Asterix_46
Cat_048_1_29: TypeAlias = Asterix_47
Cat_048_1_30: TypeAlias = Asterix_48
Cat_048_1_31: TypeAlias = Asterix_49
Cat_048_1_32: TypeAlias = Asterix_50
Ref_062_1_2: TypeAlias = Asterix_51
Ref_062_1_3: TypeAlias = Asterix_52
Cat_062_1_17: TypeAlias = Asterix_53
Cat_062_1_18: TypeAlias = Asterix_54
Cat_062_1_19: TypeAlias = Asterix_55
Cat_062_1_20: TypeAlias = Asterix_56
Cat_063_1_6: TypeAlias = Asterix_57
Cat_065_1_4: TypeAlias = Asterix_58
Cat_065_1_5: TypeAlias = Asterix_59
Cat_065_1_6: TypeAlias = Asterix_60
Cat_150_3_0: TypeAlias = Asterix_61
Cat_205_1_0: TypeAlias = Asterix_62
Cat_240_1_3: TypeAlias = Asterix_63
Cat_247_1_2: TypeAlias = Asterix_64
Cat_247_1_3: TypeAlias = Asterix_65

# Manifest

manifest = {
    'CATS': {
        1: [
            Cat_001_1_2,
            Cat_001_1_3,
            Cat_001_1_4,
        ],
        2: [
            Cat_002_1_0,
            Cat_002_1_1,
            Cat_002_1_2,
        ],
        4: [
            Cat_004_1_12,
            Cat_004_1_13,
        ],
        8: [
            Cat_008_1_2,
            Cat_008_1_3,
        ],
        9: [
            Cat_009_2_1,
        ],
        10: [
            Cat_010_1_1,
        ],
        11: [
            Cat_011_1_2,
            Cat_011_1_3,
        ],
        15: [
            Cat_015_1_0,
            Cat_015_1_1,
            Cat_015_1_2,
        ],
        16: [
            Cat_016_1_0,
        ],
        17: [
            Cat_017_1_3,
        ],
        18: [
            Cat_018_1_7,
            Cat_018_1_8,
        ],
        19: [
            Cat_019_1_3,
        ],
        20: [
            Cat_020_1_9,
            Cat_020_1_10,
        ],
        21: [
            Cat_021_0_23,
            Cat_021_0_24,
            Cat_021_0_25,
            Cat_021_0_26,
            Cat_021_2_1,
            Cat_021_2_2,
            Cat_021_2_3,
            Cat_021_2_4,
            Cat_021_2_5,
            Cat_021_2_6,
        ],
        23: [
            Cat_023_1_2,
            Cat_023_1_3,
        ],
        25: [
            Cat_025_1_5,
        ],
        32: [
            Cat_032_1_1,
        ],
        34: [
            Cat_034_1_27,
            Cat_034_1_28,
            Cat_034_1_29,
        ],
        48: [
            Cat_048_1_27,
            Cat_048_1_28,
            Cat_048_1_29,
            Cat_048_1_30,
            Cat_048_1_31,
            Cat_048_1_32,
        ],
        62: [
            Cat_062_1_17,
            Cat_062_1_18,
            Cat_062_1_19,
            Cat_062_1_20,
        ],
        63: [
            Cat_063_1_6,
        ],
        65: [
            Cat_065_1_4,
            Cat_065_1_5,
            Cat_065_1_6,
        ],
        150: [
            Cat_150_3_0,
        ],
        205: [
            Cat_205_1_0,
        ],
        240: [
            Cat_240_1_3,
        ],
        247: [
            Cat_247_1_2,
            Cat_247_1_3,
        ],
    },
    'REFS': {
        21: [
            Ref_021_1_4,
            Ref_021_1_5,
        ],
        48: [
            Ref_048_1_11,
            Ref_048_1_12,
        ],
        62: [
            Ref_062_1_2,
            Ref_062_1_3,
        ],
    },
}
